#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 2199
#define LARGE_STATE_COUNT 1003
#define SYMBOL_COUNT 134
#define ALIAS_COUNT 1
#define TOKEN_COUNT 80
#define EXTERNAL_TOKEN_COUNT 13
#define FIELD_COUNT 20
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 49

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_BSLASH = 2,
  anon_sym_function = 3,
  anon_sym_EQ = 4,
  anon_sym_if = 5,
  anon_sym_for = 6,
  anon_sym_in = 7,
  anon_sym_while = 8,
  anon_sym_repeat = 9,
  anon_sym_QMARK = 10,
  anon_sym_TILDE = 11,
  anon_sym_BANG = 12,
  anon_sym_PLUS = 13,
  anon_sym_DASH = 14,
  anon_sym_LT_DASH = 15,
  anon_sym_LT_LT_DASH = 16,
  anon_sym_COLON_EQ = 17,
  anon_sym_DASH_GT = 18,
  anon_sym_DASH_GT_GT = 19,
  anon_sym_PIPE = 20,
  anon_sym_AMP = 21,
  anon_sym_PIPE_PIPE = 22,
  anon_sym_AMP_AMP = 23,
  anon_sym_LT = 24,
  anon_sym_LT_EQ = 25,
  anon_sym_GT = 26,
  anon_sym_GT_EQ = 27,
  anon_sym_EQ_EQ = 28,
  anon_sym_BANG_EQ = 29,
  anon_sym_STAR = 30,
  anon_sym_SLASH = 31,
  anon_sym_STAR_STAR = 32,
  anon_sym_CARET = 33,
  aux_sym_binary_operator_token1 = 34,
  anon_sym_PIPE_GT = 35,
  anon_sym_COLON = 36,
  anon_sym_DOLLAR = 37,
  anon_sym_AT = 38,
  anon_sym_COLON_COLON = 39,
  anon_sym_COLON_COLON_COLON = 40,
  anon_sym_L = 41,
  anon_sym_i = 42,
  sym__hex_literal = 43,
  sym__number_literal = 44,
  anon_sym_SQUOTE = 45,
  anon_sym_DQUOTE = 46,
  aux_sym__single_quoted_string_content_token1 = 47,
  aux_sym__double_quoted_string_content_token1 = 48,
  sym_escape_sequence = 49,
  sym_return = 50,
  sym_next = 51,
  sym_break = 52,
  sym_true = 53,
  sym_false = 54,
  sym_null = 55,
  sym_inf = 56,
  sym_nan = 57,
  anon_sym_NA = 58,
  anon_sym_NA_integer_ = 59,
  anon_sym_NA_real_ = 60,
  anon_sym_NA_complex_ = 61,
  anon_sym_NA_character_ = 62,
  sym_dots = 63,
  sym_dot_dot_i = 64,
  sym_comment = 65,
  sym_comma = 66,
  sym__newline = 67,
  sym__semicolon = 68,
  sym__raw_string_literal = 69,
  sym__external_else = 70,
  sym__external_open_parenthesis = 71,
  sym__external_close_parenthesis = 72,
  sym__external_open_brace = 73,
  sym__external_close_brace = 74,
  sym__external_open_bracket = 75,
  sym__external_close_bracket = 76,
  sym__external_open_bracket2 = 77,
  sym__external_close_bracket2 = 78,
  sym__error_sentinel = 79,
  sym_program = 80,
  sym_function_definition = 81,
  sym_parameters = 82,
  sym_parameter = 83,
  sym__parameter_with_default = 84,
  sym__parameter_without_default = 85,
  sym_if_statement = 86,
  sym_for_statement = 87,
  sym_while_statement = 88,
  sym_repeat_statement = 89,
  sym_braced_expression = 90,
  sym_parenthesized_expression = 91,
  sym_call = 92,
  sym_subset = 93,
  sym_subset2 = 94,
  sym_call_arguments = 95,
  sym_subset_arguments = 96,
  sym_subset2_arguments = 97,
  sym__argument = 98,
  sym_argument = 99,
  sym__argument_named = 100,
  sym__argument_unnamed = 101,
  sym__argument_value = 102,
  sym_unary_operator = 103,
  sym_binary_operator = 104,
  sym_extract_operator = 105,
  sym_namespace_operator = 106,
  sym_integer = 107,
  sym_complex = 108,
  sym_float = 109,
  sym__float_literal = 110,
  sym_string = 111,
  sym__single_quoted_string = 112,
  sym__double_quoted_string = 113,
  aux_sym__single_quoted_string_content = 114,
  aux_sym__double_quoted_string_content = 115,
  sym_na = 116,
  sym__expression = 117,
  sym__string_or_identifier = 118,
  sym__else = 119,
  sym__open_parenthesis = 120,
  sym__close_parenthesis = 121,
  sym__open_brace = 122,
  sym__close_brace = 123,
  sym__open_bracket = 124,
  sym__close_bracket = 125,
  sym__open_bracket2 = 126,
  sym__close_bracket2 = 127,
  aux_sym_program_repeat1 = 128,
  aux_sym_function_definition_repeat1 = 129,
  aux_sym_parameters_repeat1 = 130,
  aux_sym_braced_expression_repeat1 = 131,
  aux_sym_parenthesized_expression_repeat1 = 132,
  aux_sym_call_arguments_repeat1 = 133,
  alias_sym_string_content = 134,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_BSLASH] = "\\",
  [anon_sym_function] = "function",
  [anon_sym_EQ] = "=",
  [anon_sym_if] = "if",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_while] = "while",
  [anon_sym_repeat] = "repeat",
  [anon_sym_QMARK] = "\?",
  [anon_sym_TILDE] = "~",
  [anon_sym_BANG] = "!",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_LT_DASH] = "<-",
  [anon_sym_LT_LT_DASH] = "<<-",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_DASH_GT_GT] = "->>",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP] = "&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_CARET] = "^",
  [aux_sym_binary_operator_token1] = "special",
  [anon_sym_PIPE_GT] = "|>",
  [anon_sym_COLON] = ":",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_AT] = "@",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_COLON_COLON_COLON] = ":::",
  [anon_sym_L] = "L",
  [anon_sym_i] = "i",
  [sym__hex_literal] = "_hex_literal",
  [sym__number_literal] = "_number_literal",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym__single_quoted_string_content_token1] = "_single_quoted_string_content_token1",
  [aux_sym__double_quoted_string_content_token1] = "_double_quoted_string_content_token1",
  [sym_escape_sequence] = "escape_sequence",
  [sym_return] = "return",
  [sym_next] = "next",
  [sym_break] = "break",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_inf] = "inf",
  [sym_nan] = "nan",
  [anon_sym_NA] = "NA",
  [anon_sym_NA_integer_] = "NA_integer_",
  [anon_sym_NA_real_] = "NA_real_",
  [anon_sym_NA_complex_] = "NA_complex_",
  [anon_sym_NA_character_] = "NA_character_",
  [sym_dots] = "dots",
  [sym_dot_dot_i] = "dot_dot_i",
  [sym_comment] = "comment",
  [sym_comma] = "comma",
  [sym__newline] = "_newline",
  [sym__semicolon] = "_semicolon",
  [sym__raw_string_literal] = "_raw_string_literal",
  [sym__external_else] = "else",
  [sym__external_open_parenthesis] = "(",
  [sym__external_close_parenthesis] = ")",
  [sym__external_open_brace] = "{",
  [sym__external_close_brace] = "}",
  [sym__external_open_bracket] = "[",
  [sym__external_close_bracket] = "]",
  [sym__external_open_bracket2] = "[[",
  [sym__external_close_bracket2] = "]]",
  [sym__error_sentinel] = "_error_sentinel",
  [sym_program] = "program",
  [sym_function_definition] = "function_definition",
  [sym_parameters] = "parameters",
  [sym_parameter] = "parameter",
  [sym__parameter_with_default] = "_parameter_with_default",
  [sym__parameter_without_default] = "_parameter_without_default",
  [sym_if_statement] = "if_statement",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_repeat_statement] = "repeat_statement",
  [sym_braced_expression] = "braced_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_call] = "call",
  [sym_subset] = "subset",
  [sym_subset2] = "subset2",
  [sym_call_arguments] = "arguments",
  [sym_subset_arguments] = "arguments",
  [sym_subset2_arguments] = "arguments",
  [sym__argument] = "_argument",
  [sym_argument] = "argument",
  [sym__argument_named] = "_argument_named",
  [sym__argument_unnamed] = "_argument_unnamed",
  [sym__argument_value] = "_argument_value",
  [sym_unary_operator] = "unary_operator",
  [sym_binary_operator] = "binary_operator",
  [sym_extract_operator] = "extract_operator",
  [sym_namespace_operator] = "namespace_operator",
  [sym_integer] = "integer",
  [sym_complex] = "complex",
  [sym_float] = "float",
  [sym__float_literal] = "_float_literal",
  [sym_string] = "string",
  [sym__single_quoted_string] = "_single_quoted_string",
  [sym__double_quoted_string] = "_double_quoted_string",
  [aux_sym__single_quoted_string_content] = "_single_quoted_string_content",
  [aux_sym__double_quoted_string_content] = "_double_quoted_string_content",
  [sym_na] = "na",
  [sym__expression] = "_expression",
  [sym__string_or_identifier] = "_string_or_identifier",
  [sym__else] = "_else",
  [sym__open_parenthesis] = "_open_parenthesis",
  [sym__close_parenthesis] = "_close_parenthesis",
  [sym__open_brace] = "_open_brace",
  [sym__close_brace] = "_close_brace",
  [sym__open_bracket] = "_open_bracket",
  [sym__close_bracket] = "_close_bracket",
  [sym__open_bracket2] = "_open_bracket2",
  [sym__close_bracket2] = "_close_bracket2",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_function_definition_repeat1] = "function_definition_repeat1",
  [aux_sym_parameters_repeat1] = "parameters_repeat1",
  [aux_sym_braced_expression_repeat1] = "braced_expression_repeat1",
  [aux_sym_parenthesized_expression_repeat1] = "parenthesized_expression_repeat1",
  [aux_sym_call_arguments_repeat1] = "call_arguments_repeat1",
  [alias_sym_string_content] = "string_content",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_BSLASH] = anon_sym_BSLASH,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_repeat] = anon_sym_repeat,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_LT_DASH] = anon_sym_LT_DASH,
  [anon_sym_LT_LT_DASH] = anon_sym_LT_LT_DASH,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_DASH_GT_GT] = anon_sym_DASH_GT_GT,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_CARET] = anon_sym_CARET,
  [aux_sym_binary_operator_token1] = aux_sym_binary_operator_token1,
  [anon_sym_PIPE_GT] = anon_sym_PIPE_GT,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_COLON_COLON_COLON] = anon_sym_COLON_COLON_COLON,
  [anon_sym_L] = anon_sym_L,
  [anon_sym_i] = anon_sym_i,
  [sym__hex_literal] = sym__hex_literal,
  [sym__number_literal] = sym__number_literal,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym__single_quoted_string_content_token1] = aux_sym__single_quoted_string_content_token1,
  [aux_sym__double_quoted_string_content_token1] = aux_sym__double_quoted_string_content_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_return] = sym_return,
  [sym_next] = sym_next,
  [sym_break] = sym_break,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [sym_inf] = sym_inf,
  [sym_nan] = sym_nan,
  [anon_sym_NA] = anon_sym_NA,
  [anon_sym_NA_integer_] = anon_sym_NA_integer_,
  [anon_sym_NA_real_] = anon_sym_NA_real_,
  [anon_sym_NA_complex_] = anon_sym_NA_complex_,
  [anon_sym_NA_character_] = anon_sym_NA_character_,
  [sym_dots] = sym_dots,
  [sym_dot_dot_i] = sym_dot_dot_i,
  [sym_comment] = sym_comment,
  [sym_comma] = sym_comma,
  [sym__newline] = sym__newline,
  [sym__semicolon] = sym__semicolon,
  [sym__raw_string_literal] = sym__raw_string_literal,
  [sym__external_else] = sym__external_else,
  [sym__external_open_parenthesis] = sym__external_open_parenthesis,
  [sym__external_close_parenthesis] = sym__external_close_parenthesis,
  [sym__external_open_brace] = sym__external_open_brace,
  [sym__external_close_brace] = sym__external_close_brace,
  [sym__external_open_bracket] = sym__external_open_bracket,
  [sym__external_close_bracket] = sym__external_close_bracket,
  [sym__external_open_bracket2] = sym__external_open_bracket2,
  [sym__external_close_bracket2] = sym__external_close_bracket2,
  [sym__error_sentinel] = sym__error_sentinel,
  [sym_program] = sym_program,
  [sym_function_definition] = sym_function_definition,
  [sym_parameters] = sym_parameters,
  [sym_parameter] = sym_parameter,
  [sym__parameter_with_default] = sym__parameter_with_default,
  [sym__parameter_without_default] = sym__parameter_without_default,
  [sym_if_statement] = sym_if_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_repeat_statement] = sym_repeat_statement,
  [sym_braced_expression] = sym_braced_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_call] = sym_call,
  [sym_subset] = sym_subset,
  [sym_subset2] = sym_subset2,
  [sym_call_arguments] = sym_call_arguments,
  [sym_subset_arguments] = sym_call_arguments,
  [sym_subset2_arguments] = sym_call_arguments,
  [sym__argument] = sym__argument,
  [sym_argument] = sym_argument,
  [sym__argument_named] = sym__argument_named,
  [sym__argument_unnamed] = sym__argument_unnamed,
  [sym__argument_value] = sym__argument_value,
  [sym_unary_operator] = sym_unary_operator,
  [sym_binary_operator] = sym_binary_operator,
  [sym_extract_operator] = sym_extract_operator,
  [sym_namespace_operator] = sym_namespace_operator,
  [sym_integer] = sym_integer,
  [sym_complex] = sym_complex,
  [sym_float] = sym_float,
  [sym__float_literal] = sym__float_literal,
  [sym_string] = sym_string,
  [sym__single_quoted_string] = sym__single_quoted_string,
  [sym__double_quoted_string] = sym__double_quoted_string,
  [aux_sym__single_quoted_string_content] = aux_sym__single_quoted_string_content,
  [aux_sym__double_quoted_string_content] = aux_sym__double_quoted_string_content,
  [sym_na] = sym_na,
  [sym__expression] = sym__expression,
  [sym__string_or_identifier] = sym__string_or_identifier,
  [sym__else] = sym__else,
  [sym__open_parenthesis] = sym__open_parenthesis,
  [sym__close_parenthesis] = sym__close_parenthesis,
  [sym__open_brace] = sym__open_brace,
  [sym__close_brace] = sym__close_brace,
  [sym__open_bracket] = sym__open_bracket,
  [sym__close_bracket] = sym__close_bracket,
  [sym__open_bracket2] = sym__open_bracket2,
  [sym__close_bracket2] = sym__close_bracket2,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_function_definition_repeat1] = aux_sym_function_definition_repeat1,
  [aux_sym_parameters_repeat1] = aux_sym_parameters_repeat1,
  [aux_sym_braced_expression_repeat1] = aux_sym_braced_expression_repeat1,
  [aux_sym_parenthesized_expression_repeat1] = aux_sym_parenthesized_expression_repeat1,
  [aux_sym_call_arguments_repeat1] = aux_sym_call_arguments_repeat1,
  [alias_sym_string_content] = alias_sym_string_content,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_repeat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_binary_operator_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_L] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_i] = {
    .visible = true,
    .named = false,
  },
  [sym__hex_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__number_literal] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__single_quoted_string_content_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__double_quoted_string_content_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_return] = {
    .visible = true,
    .named = true,
  },
  [sym_next] = {
    .visible = true,
    .named = true,
  },
  [sym_break] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_inf] = {
    .visible = true,
    .named = true,
  },
  [sym_nan] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_NA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_NA_integer_] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_NA_real_] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_NA_complex_] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_NA_character_] = {
    .visible = true,
    .named = false,
  },
  [sym_dots] = {
    .visible = true,
    .named = true,
  },
  [sym_dot_dot_i] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_comma] = {
    .visible = true,
    .named = true,
  },
  [sym__newline] = {
    .visible = false,
    .named = true,
  },
  [sym__semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__raw_string_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__external_else] = {
    .visible = true,
    .named = false,
  },
  [sym__external_open_parenthesis] = {
    .visible = true,
    .named = false,
  },
  [sym__external_close_parenthesis] = {
    .visible = true,
    .named = false,
  },
  [sym__external_open_brace] = {
    .visible = true,
    .named = false,
  },
  [sym__external_close_brace] = {
    .visible = true,
    .named = false,
  },
  [sym__external_open_bracket] = {
    .visible = true,
    .named = false,
  },
  [sym__external_close_bracket] = {
    .visible = true,
    .named = false,
  },
  [sym__external_open_bracket2] = {
    .visible = true,
    .named = false,
  },
  [sym__external_close_bracket2] = {
    .visible = true,
    .named = false,
  },
  [sym__error_sentinel] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_with_default] = {
    .visible = false,
    .named = true,
  },
  [sym__parameter_without_default] = {
    .visible = false,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_repeat_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_braced_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [sym_subset] = {
    .visible = true,
    .named = true,
  },
  [sym_subset2] = {
    .visible = true,
    .named = true,
  },
  [sym_call_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_subset_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_subset2_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym__argument] = {
    .visible = false,
    .named = true,
  },
  [sym_argument] = {
    .visible = true,
    .named = true,
  },
  [sym__argument_named] = {
    .visible = false,
    .named = true,
  },
  [sym__argument_unnamed] = {
    .visible = false,
    .named = true,
  },
  [sym__argument_value] = {
    .visible = false,
    .named = true,
  },
  [sym_unary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_extract_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_complex] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym__float_literal] = {
    .visible = false,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym__single_quoted_string] = {
    .visible = false,
    .named = true,
  },
  [sym__double_quoted_string] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__single_quoted_string_content] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__double_quoted_string_content] = {
    .visible = false,
    .named = false,
  },
  [sym_na] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym__string_or_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym__else] = {
    .visible = false,
    .named = true,
  },
  [sym__open_parenthesis] = {
    .visible = false,
    .named = true,
  },
  [sym__close_parenthesis] = {
    .visible = false,
    .named = true,
  },
  [sym__open_brace] = {
    .visible = false,
    .named = true,
  },
  [sym__close_brace] = {
    .visible = false,
    .named = true,
  },
  [sym__open_bracket] = {
    .visible = false,
    .named = true,
  },
  [sym__close_bracket] = {
    .visible = false,
    .named = true,
  },
  [sym__open_bracket2] = {
    .visible = false,
    .named = true,
  },
  [sym__close_bracket2] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_braced_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parenthesized_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_call_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_string_content] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_argument = 2,
  field_arguments = 3,
  field_body = 4,
  field_close = 5,
  field_condition = 6,
  field_consequence = 7,
  field_content = 8,
  field_default = 9,
  field_function = 10,
  field_lhs = 11,
  field_name = 12,
  field_open = 13,
  field_operator = 14,
  field_parameter = 15,
  field_parameters = 16,
  field_rhs = 17,
  field_sequence = 18,
  field_value = 19,
  field_variable = 20,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_close] = "close",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_content] = "content",
  [field_default] = "default",
  [field_function] = "function",
  [field_lhs] = "lhs",
  [field_name] = "name",
  [field_open] = "open",
  [field_operator] = "operator",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_rhs] = "rhs",
  [field_sequence] = "sequence",
  [field_value] = "value",
  [field_variable] = "variable",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [3] = {.index = 2, .length = 2},
  [4] = {.index = 4, .length = 2},
  [5] = {.index = 6, .length = 2},
  [6] = {.index = 8, .length = 1},
  [7] = {.index = 9, .length = 2},
  [8] = {.index = 11, .length = 3},
  [9] = {.index = 14, .length = 1},
  [10] = {.index = 15, .length = 2},
  [11] = {.index = 17, .length = 1},
  [12] = {.index = 18, .length = 1},
  [13] = {.index = 19, .length = 2},
  [14] = {.index = 21, .length = 1},
  [15] = {.index = 22, .length = 3},
  [16] = {.index = 25, .length = 1},
  [17] = {.index = 26, .length = 1},
  [18] = {.index = 27, .length = 1},
  [19] = {.index = 28, .length = 2},
  [20] = {.index = 30, .length = 1},
  [21] = {.index = 31, .length = 3},
  [22] = {.index = 34, .length = 2},
  [23] = {.index = 36, .length = 3},
  [24] = {.index = 39, .length = 3},
  [25] = {.index = 42, .length = 3},
  [26] = {.index = 45, .length = 3},
  [27] = {.index = 48, .length = 2},
  [28] = {.index = 50, .length = 2},
  [29] = {.index = 52, .length = 1},
  [30] = {.index = 53, .length = 4},
  [31] = {.index = 57, .length = 2},
  [32] = {.index = 59, .length = 4},
  [33] = {.index = 63, .length = 4},
  [34] = {.index = 67, .length = 2},
  [35] = {.index = 69, .length = 4},
  [36] = {.index = 73, .length = 4},
  [37] = {.index = 77, .length = 4},
  [38] = {.index = 81, .length = 4},
  [39] = {.index = 85, .length = 5},
  [40] = {.index = 90, .length = 4},
  [41] = {.index = 94, .length = 5},
  [42] = {.index = 99, .length = 4},
  [43] = {.index = 103, .length = 5},
  [44] = {.index = 108, .length = 5},
  [45] = {.index = 113, .length = 5},
  [46] = {.index = 118, .length = 5},
  [47] = {.index = 123, .length = 5},
  [48] = {.index = 128, .length = 5},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_content, 0, .inherited = true},
  [1] =
    {field_body, 1},
  [2] =
    {field_operator, 0},
    {field_rhs, 1},
  [4] =
    {field_lhs, 0},
    {field_operator, 1},
  [6] =
    {field_arguments, 1},
    {field_function, 0},
  [8] =
    {field_body, 0},
  [9] =
    {field_close, 1},
    {field_open, 0},
  [11] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1},
  [14] =
    {field_name, 0},
  [15] =
    {field_default, 0, .inherited = true},
    {field_name, 0, .inherited = true},
  [17] =
    {field_name, 0, .inherited = true},
  [18] =
    {field_body, 2},
  [19] =
    {field_operator, 0},
    {field_rhs, 2},
  [21] =
    {field_content, 1},
  [22] =
    {field_lhs, 0},
    {field_operator, 1},
    {field_rhs, 2},
  [25] =
    {field_value, 0},
  [26] =
    {field_argument, 0, .inherited = true},
  [27] =
    {field_argument, 0},
  [28] =
    {field_name, 0, .inherited = true},
    {field_value, 0, .inherited = true},
  [30] =
    {field_value, 0, .inherited = true},
  [31] =
    {field_body, 1, .inherited = true},
    {field_close, 2},
    {field_open, 0},
  [34] =
    {field_body, 0, .inherited = true},
    {field_body, 1, .inherited = true},
  [36] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 1},
  [39] =
    {field_close, 2},
    {field_open, 0},
    {field_parameter, 1},
  [42] =
    {field_lhs, 0},
    {field_operator, 1},
    {field_rhs, 3},
  [45] =
    {field_argument, 1, .inherited = true},
    {field_close, 2},
    {field_open, 0},
  [48] =
    {field_argument, 0, .inherited = true},
    {field_argument, 1, .inherited = true},
  [50] =
    {field_default, 2},
    {field_name, 0},
  [52] =
    {field_parameter, 1},
  [53] =
    {field_close, 3},
    {field_open, 0},
    {field_parameter, 1},
    {field_parameter, 2, .inherited = true},
  [57] =
    {field_parameter, 0, .inherited = true},
    {field_parameter, 1, .inherited = true},
  [59] =
    {field_close, 3},
    {field_condition, 2},
    {field_consequence, 4},
    {field_open, 1},
  [63] =
    {field_body, 4},
    {field_close, 3},
    {field_condition, 2},
    {field_open, 1},
  [67] =
    {field_name, 0},
    {field_value, 2, .inherited = true},
  [69] =
    {field_close, 3},
    {field_condition, 2},
    {field_consequence, 5},
    {field_open, 1},
  [73] =
    {field_close, 4},
    {field_condition, 3},
    {field_consequence, 5},
    {field_open, 2},
  [77] =
    {field_body, 5},
    {field_close, 3},
    {field_condition, 2},
    {field_open, 1},
  [81] =
    {field_body, 5},
    {field_close, 4},
    {field_condition, 3},
    {field_open, 2},
  [85] =
    {field_alternative, 6},
    {field_close, 3},
    {field_condition, 2},
    {field_consequence, 4},
    {field_open, 1},
  [90] =
    {field_close, 4},
    {field_condition, 3},
    {field_consequence, 6},
    {field_open, 2},
  [94] =
    {field_body, 6},
    {field_close, 5},
    {field_open, 1},
    {field_sequence, 4},
    {field_variable, 2},
  [99] =
    {field_body, 6},
    {field_close, 4},
    {field_condition, 3},
    {field_open, 2},
  [103] =
    {field_alternative, 7},
    {field_close, 3},
    {field_condition, 2},
    {field_consequence, 5},
    {field_open, 1},
  [108] =
    {field_alternative, 7},
    {field_close, 4},
    {field_condition, 3},
    {field_consequence, 5},
    {field_open, 2},
  [113] =
    {field_body, 7},
    {field_close, 5},
    {field_open, 1},
    {field_sequence, 4},
    {field_variable, 2},
  [118] =
    {field_body, 7},
    {field_close, 6},
    {field_open, 2},
    {field_sequence, 5},
    {field_variable, 3},
  [123] =
    {field_alternative, 8},
    {field_close, 4},
    {field_condition, 3},
    {field_consequence, 6},
    {field_open, 2},
  [128] =
    {field_body, 8},
    {field_close, 6},
    {field_open, 2},
    {field_sequence, 5},
    {field_variable, 3},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [14] = {
    [1] = alias_sym_string_content,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  aux_sym__single_quoted_string_content, 2,
    aux_sym__single_quoted_string_content,
    alias_sym_string_content,
  aux_sym__double_quoted_string_content, 2,
    aux_sym__double_quoted_string_content,
    alias_sym_string_content,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 2,
  [6] = 4,
  [7] = 7,
  [8] = 3,
  [9] = 2,
  [10] = 4,
  [11] = 7,
  [12] = 3,
  [13] = 2,
  [14] = 4,
  [15] = 7,
  [16] = 3,
  [17] = 2,
  [18] = 2,
  [19] = 7,
  [20] = 3,
  [21] = 3,
  [22] = 2,
  [23] = 4,
  [24] = 7,
  [25] = 3,
  [26] = 2,
  [27] = 4,
  [28] = 7,
  [29] = 3,
  [30] = 2,
  [31] = 4,
  [32] = 7,
  [33] = 3,
  [34] = 7,
  [35] = 4,
  [36] = 7,
  [37] = 3,
  [38] = 2,
  [39] = 4,
  [40] = 7,
  [41] = 4,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 42,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 43,
  [94] = 44,
  [95] = 45,
  [96] = 46,
  [97] = 47,
  [98] = 48,
  [99] = 49,
  [100] = 50,
  [101] = 51,
  [102] = 52,
  [103] = 53,
  [104] = 54,
  [105] = 55,
  [106] = 56,
  [107] = 57,
  [108] = 58,
  [109] = 59,
  [110] = 60,
  [111] = 61,
  [112] = 62,
  [113] = 63,
  [114] = 64,
  [115] = 65,
  [116] = 66,
  [117] = 42,
  [118] = 68,
  [119] = 69,
  [120] = 70,
  [121] = 71,
  [122] = 72,
  [123] = 73,
  [124] = 74,
  [125] = 75,
  [126] = 76,
  [127] = 77,
  [128] = 78,
  [129] = 79,
  [130] = 80,
  [131] = 81,
  [132] = 82,
  [133] = 83,
  [134] = 84,
  [135] = 85,
  [136] = 86,
  [137] = 87,
  [138] = 88,
  [139] = 89,
  [140] = 90,
  [141] = 91,
  [142] = 92,
  [143] = 43,
  [144] = 44,
  [145] = 45,
  [146] = 46,
  [147] = 47,
  [148] = 48,
  [149] = 49,
  [150] = 50,
  [151] = 51,
  [152] = 52,
  [153] = 53,
  [154] = 54,
  [155] = 55,
  [156] = 56,
  [157] = 57,
  [158] = 58,
  [159] = 59,
  [160] = 60,
  [161] = 61,
  [162] = 62,
  [163] = 63,
  [164] = 64,
  [165] = 65,
  [166] = 66,
  [167] = 42,
  [168] = 68,
  [169] = 69,
  [170] = 70,
  [171] = 71,
  [172] = 72,
  [173] = 73,
  [174] = 74,
  [175] = 75,
  [176] = 76,
  [177] = 77,
  [178] = 92,
  [179] = 79,
  [180] = 80,
  [181] = 81,
  [182] = 82,
  [183] = 83,
  [184] = 84,
  [185] = 85,
  [186] = 86,
  [187] = 87,
  [188] = 88,
  [189] = 89,
  [190] = 90,
  [191] = 91,
  [192] = 92,
  [193] = 43,
  [194] = 44,
  [195] = 45,
  [196] = 46,
  [197] = 47,
  [198] = 48,
  [199] = 49,
  [200] = 50,
  [201] = 51,
  [202] = 52,
  [203] = 53,
  [204] = 54,
  [205] = 55,
  [206] = 56,
  [207] = 57,
  [208] = 58,
  [209] = 59,
  [210] = 60,
  [211] = 61,
  [212] = 62,
  [213] = 63,
  [214] = 64,
  [215] = 65,
  [216] = 66,
  [217] = 42,
  [218] = 68,
  [219] = 69,
  [220] = 70,
  [221] = 71,
  [222] = 72,
  [223] = 73,
  [224] = 74,
  [225] = 75,
  [226] = 76,
  [227] = 77,
  [228] = 78,
  [229] = 79,
  [230] = 80,
  [231] = 81,
  [232] = 82,
  [233] = 83,
  [234] = 84,
  [235] = 85,
  [236] = 86,
  [237] = 87,
  [238] = 88,
  [239] = 89,
  [240] = 90,
  [241] = 91,
  [242] = 92,
  [243] = 43,
  [244] = 44,
  [245] = 45,
  [246] = 46,
  [247] = 47,
  [248] = 48,
  [249] = 49,
  [250] = 50,
  [251] = 51,
  [252] = 52,
  [253] = 53,
  [254] = 54,
  [255] = 55,
  [256] = 56,
  [257] = 57,
  [258] = 58,
  [259] = 59,
  [260] = 60,
  [261] = 61,
  [262] = 62,
  [263] = 63,
  [264] = 64,
  [265] = 65,
  [266] = 66,
  [267] = 72,
  [268] = 68,
  [269] = 69,
  [270] = 70,
  [271] = 71,
  [272] = 73,
  [273] = 74,
  [274] = 75,
  [275] = 76,
  [276] = 77,
  [277] = 78,
  [278] = 79,
  [279] = 80,
  [280] = 81,
  [281] = 82,
  [282] = 83,
  [283] = 84,
  [284] = 85,
  [285] = 86,
  [286] = 87,
  [287] = 88,
  [288] = 89,
  [289] = 90,
  [290] = 91,
  [291] = 78,
  [292] = 292,
  [293] = 68,
  [294] = 69,
  [295] = 70,
  [296] = 296,
  [297] = 297,
  [298] = 72,
  [299] = 73,
  [300] = 74,
  [301] = 75,
  [302] = 76,
  [303] = 77,
  [304] = 78,
  [305] = 79,
  [306] = 80,
  [307] = 81,
  [308] = 82,
  [309] = 83,
  [310] = 84,
  [311] = 85,
  [312] = 86,
  [313] = 87,
  [314] = 88,
  [315] = 89,
  [316] = 90,
  [317] = 91,
  [318] = 92,
  [319] = 43,
  [320] = 44,
  [321] = 45,
  [322] = 296,
  [323] = 297,
  [324] = 46,
  [325] = 47,
  [326] = 48,
  [327] = 49,
  [328] = 50,
  [329] = 51,
  [330] = 52,
  [331] = 53,
  [332] = 54,
  [333] = 55,
  [334] = 56,
  [335] = 57,
  [336] = 58,
  [337] = 59,
  [338] = 60,
  [339] = 61,
  [340] = 62,
  [341] = 63,
  [342] = 64,
  [343] = 65,
  [344] = 66,
  [345] = 42,
  [346] = 68,
  [347] = 69,
  [348] = 70,
  [349] = 71,
  [350] = 72,
  [351] = 73,
  [352] = 74,
  [353] = 75,
  [354] = 76,
  [355] = 77,
  [356] = 78,
  [357] = 79,
  [358] = 80,
  [359] = 81,
  [360] = 82,
  [361] = 83,
  [362] = 84,
  [363] = 85,
  [364] = 86,
  [365] = 87,
  [366] = 88,
  [367] = 89,
  [368] = 90,
  [369] = 91,
  [370] = 92,
  [371] = 43,
  [372] = 44,
  [373] = 45,
  [374] = 296,
  [375] = 297,
  [376] = 46,
  [377] = 47,
  [378] = 48,
  [379] = 49,
  [380] = 50,
  [381] = 51,
  [382] = 52,
  [383] = 53,
  [384] = 54,
  [385] = 55,
  [386] = 56,
  [387] = 57,
  [388] = 58,
  [389] = 59,
  [390] = 60,
  [391] = 61,
  [392] = 62,
  [393] = 63,
  [394] = 64,
  [395] = 65,
  [396] = 66,
  [397] = 42,
  [398] = 68,
  [399] = 69,
  [400] = 70,
  [401] = 71,
  [402] = 402,
  [403] = 403,
  [404] = 404,
  [405] = 405,
  [406] = 406,
  [407] = 77,
  [408] = 78,
  [409] = 79,
  [410] = 80,
  [411] = 81,
  [412] = 82,
  [413] = 83,
  [414] = 84,
  [415] = 85,
  [416] = 86,
  [417] = 87,
  [418] = 418,
  [419] = 296,
  [420] = 297,
  [421] = 88,
  [422] = 89,
  [423] = 90,
  [424] = 91,
  [425] = 92,
  [426] = 43,
  [427] = 44,
  [428] = 45,
  [429] = 429,
  [430] = 430,
  [431] = 296,
  [432] = 297,
  [433] = 46,
  [434] = 47,
  [435] = 48,
  [436] = 49,
  [437] = 50,
  [438] = 51,
  [439] = 52,
  [440] = 405,
  [441] = 53,
  [442] = 54,
  [443] = 55,
  [444] = 56,
  [445] = 57,
  [446] = 58,
  [447] = 59,
  [448] = 60,
  [449] = 61,
  [450] = 62,
  [451] = 418,
  [452] = 296,
  [453] = 297,
  [454] = 63,
  [455] = 64,
  [456] = 65,
  [457] = 66,
  [458] = 42,
  [459] = 68,
  [460] = 69,
  [461] = 70,
  [462] = 71,
  [463] = 72,
  [464] = 73,
  [465] = 74,
  [466] = 75,
  [467] = 76,
  [468] = 405,
  [469] = 77,
  [470] = 78,
  [471] = 79,
  [472] = 80,
  [473] = 81,
  [474] = 82,
  [475] = 83,
  [476] = 84,
  [477] = 85,
  [478] = 86,
  [479] = 87,
  [480] = 88,
  [481] = 89,
  [482] = 418,
  [483] = 296,
  [484] = 297,
  [485] = 90,
  [486] = 91,
  [487] = 92,
  [488] = 43,
  [489] = 44,
  [490] = 45,
  [491] = 429,
  [492] = 430,
  [493] = 296,
  [494] = 297,
  [495] = 46,
  [496] = 47,
  [497] = 48,
  [498] = 49,
  [499] = 50,
  [500] = 51,
  [501] = 296,
  [502] = 297,
  [503] = 52,
  [504] = 53,
  [505] = 54,
  [506] = 55,
  [507] = 56,
  [508] = 405,
  [509] = 57,
  [510] = 58,
  [511] = 59,
  [512] = 60,
  [513] = 61,
  [514] = 62,
  [515] = 63,
  [516] = 72,
  [517] = 64,
  [518] = 65,
  [519] = 418,
  [520] = 296,
  [521] = 297,
  [522] = 66,
  [523] = 42,
  [524] = 68,
  [525] = 69,
  [526] = 70,
  [527] = 71,
  [528] = 72,
  [529] = 73,
  [530] = 74,
  [531] = 75,
  [532] = 76,
  [533] = 77,
  [534] = 405,
  [535] = 78,
  [536] = 79,
  [537] = 80,
  [538] = 81,
  [539] = 82,
  [540] = 83,
  [541] = 84,
  [542] = 85,
  [543] = 86,
  [544] = 87,
  [545] = 88,
  [546] = 89,
  [547] = 90,
  [548] = 91,
  [549] = 92,
  [550] = 43,
  [551] = 44,
  [552] = 418,
  [553] = 296,
  [554] = 297,
  [555] = 45,
  [556] = 429,
  [557] = 296,
  [558] = 297,
  [559] = 46,
  [560] = 47,
  [561] = 48,
  [562] = 49,
  [563] = 50,
  [564] = 51,
  [565] = 52,
  [566] = 53,
  [567] = 54,
  [568] = 55,
  [569] = 56,
  [570] = 57,
  [571] = 402,
  [572] = 403,
  [573] = 404,
  [574] = 58,
  [575] = 59,
  [576] = 430,
  [577] = 73,
  [578] = 60,
  [579] = 74,
  [580] = 75,
  [581] = 61,
  [582] = 62,
  [583] = 63,
  [584] = 76,
  [585] = 64,
  [586] = 65,
  [587] = 66,
  [588] = 42,
  [589] = 402,
  [590] = 403,
  [591] = 404,
  [592] = 430,
  [593] = 402,
  [594] = 403,
  [595] = 404,
  [596] = 430,
  [597] = 402,
  [598] = 403,
  [599] = 404,
  [600] = 430,
  [601] = 402,
  [602] = 403,
  [603] = 404,
  [604] = 430,
  [605] = 402,
  [606] = 403,
  [607] = 404,
  [608] = 430,
  [609] = 402,
  [610] = 403,
  [611] = 404,
  [612] = 430,
  [613] = 402,
  [614] = 403,
  [615] = 404,
  [616] = 430,
  [617] = 402,
  [618] = 403,
  [619] = 404,
  [620] = 430,
  [621] = 402,
  [622] = 403,
  [623] = 404,
  [624] = 430,
  [625] = 402,
  [626] = 403,
  [627] = 404,
  [628] = 71,
  [629] = 418,
  [630] = 405,
  [631] = 631,
  [632] = 632,
  [633] = 632,
  [634] = 418,
  [635] = 405,
  [636] = 632,
  [637] = 637,
  [638] = 405,
  [639] = 637,
  [640] = 632,
  [641] = 418,
  [642] = 418,
  [643] = 418,
  [644] = 405,
  [645] = 632,
  [646] = 405,
  [647] = 637,
  [648] = 632,
  [649] = 632,
  [650] = 632,
  [651] = 632,
  [652] = 632,
  [653] = 653,
  [654] = 654,
  [655] = 655,
  [656] = 656,
  [657] = 657,
  [658] = 658,
  [659] = 653,
  [660] = 660,
  [661] = 656,
  [662] = 662,
  [663] = 660,
  [664] = 662,
  [665] = 660,
  [666] = 662,
  [667] = 667,
  [668] = 654,
  [669] = 667,
  [670] = 654,
  [671] = 655,
  [672] = 656,
  [673] = 667,
  [674] = 658,
  [675] = 653,
  [676] = 655,
  [677] = 660,
  [678] = 662,
  [679] = 656,
  [680] = 657,
  [681] = 667,
  [682] = 654,
  [683] = 655,
  [684] = 656,
  [685] = 657,
  [686] = 657,
  [687] = 658,
  [688] = 654,
  [689] = 658,
  [690] = 653,
  [691] = 660,
  [692] = 662,
  [693] = 655,
  [694] = 658,
  [695] = 653,
  [696] = 667,
  [697] = 657,
  [698] = 667,
  [699] = 653,
  [700] = 657,
  [701] = 660,
  [702] = 702,
  [703] = 662,
  [704] = 658,
  [705] = 653,
  [706] = 654,
  [707] = 656,
  [708] = 657,
  [709] = 667,
  [710] = 655,
  [711] = 660,
  [712] = 662,
  [713] = 667,
  [714] = 654,
  [715] = 660,
  [716] = 653,
  [717] = 667,
  [718] = 662,
  [719] = 658,
  [720] = 702,
  [721] = 721,
  [722] = 655,
  [723] = 702,
  [724] = 721,
  [725] = 656,
  [726] = 654,
  [727] = 658,
  [728] = 721,
  [729] = 660,
  [730] = 662,
  [731] = 702,
  [732] = 702,
  [733] = 658,
  [734] = 655,
  [735] = 656,
  [736] = 657,
  [737] = 660,
  [738] = 653,
  [739] = 654,
  [740] = 654,
  [741] = 655,
  [742] = 667,
  [743] = 656,
  [744] = 655,
  [745] = 656,
  [746] = 657,
  [747] = 657,
  [748] = 662,
  [749] = 658,
  [750] = 653,
  [751] = 751,
  [752] = 752,
  [753] = 753,
  [754] = 754,
  [755] = 755,
  [756] = 756,
  [757] = 757,
  [758] = 757,
  [759] = 759,
  [760] = 751,
  [761] = 757,
  [762] = 762,
  [763] = 763,
  [764] = 764,
  [765] = 702,
  [766] = 766,
  [767] = 767,
  [768] = 768,
  [769] = 769,
  [770] = 762,
  [771] = 771,
  [772] = 763,
  [773] = 764,
  [774] = 762,
  [775] = 763,
  [776] = 764,
  [777] = 777,
  [778] = 766,
  [779] = 766,
  [780] = 780,
  [781] = 781,
  [782] = 782,
  [783] = 759,
  [784] = 767,
  [785] = 768,
  [786] = 769,
  [787] = 787,
  [788] = 767,
  [789] = 768,
  [790] = 769,
  [791] = 771,
  [792] = 780,
  [793] = 752,
  [794] = 753,
  [795] = 757,
  [796] = 702,
  [797] = 702,
  [798] = 754,
  [799] = 777,
  [800] = 787,
  [801] = 781,
  [802] = 752,
  [803] = 753,
  [804] = 754,
  [805] = 755,
  [806] = 755,
  [807] = 756,
  [808] = 757,
  [809] = 777,
  [810] = 757,
  [811] = 787,
  [812] = 780,
  [813] = 781,
  [814] = 782,
  [815] = 782,
  [816] = 756,
  [817] = 752,
  [818] = 780,
  [819] = 781,
  [820] = 782,
  [821] = 759,
  [822] = 762,
  [823] = 763,
  [824] = 764,
  [825] = 766,
  [826] = 767,
  [827] = 768,
  [828] = 769,
  [829] = 780,
  [830] = 781,
  [831] = 782,
  [832] = 759,
  [833] = 787,
  [834] = 753,
  [835] = 771,
  [836] = 754,
  [837] = 757,
  [838] = 755,
  [839] = 756,
  [840] = 757,
  [841] = 757,
  [842] = 751,
  [843] = 702,
  [844] = 777,
  [845] = 787,
  [846] = 752,
  [847] = 753,
  [848] = 754,
  [849] = 755,
  [850] = 756,
  [851] = 757,
  [852] = 702,
  [853] = 751,
  [854] = 771,
  [855] = 751,
  [856] = 757,
  [857] = 751,
  [858] = 751,
  [859] = 757,
  [860] = 762,
  [861] = 751,
  [862] = 763,
  [863] = 764,
  [864] = 751,
  [865] = 766,
  [866] = 767,
  [867] = 768,
  [868] = 751,
  [869] = 769,
  [870] = 771,
  [871] = 751,
  [872] = 751,
  [873] = 777,
  [874] = 759,
  [875] = 759,
  [876] = 782,
  [877] = 762,
  [878] = 767,
  [879] = 768,
  [880] = 880,
  [881] = 767,
  [882] = 763,
  [883] = 764,
  [884] = 768,
  [885] = 766,
  [886] = 767,
  [887] = 768,
  [888] = 769,
  [889] = 766,
  [890] = 777,
  [891] = 891,
  [892] = 787,
  [893] = 769,
  [894] = 894,
  [895] = 762,
  [896] = 762,
  [897] = 769,
  [898] = 771,
  [899] = 755,
  [900] = 756,
  [901] = 753,
  [902] = 768,
  [903] = 753,
  [904] = 763,
  [905] = 769,
  [906] = 754,
  [907] = 907,
  [908] = 771,
  [909] = 764,
  [910] = 755,
  [911] = 766,
  [912] = 755,
  [913] = 780,
  [914] = 780,
  [915] = 915,
  [916] = 916,
  [917] = 880,
  [918] = 781,
  [919] = 752,
  [920] = 782,
  [921] = 759,
  [922] = 915,
  [923] = 777,
  [924] = 781,
  [925] = 763,
  [926] = 771,
  [927] = 916,
  [928] = 764,
  [929] = 754,
  [930] = 756,
  [931] = 767,
  [932] = 777,
  [933] = 768,
  [934] = 907,
  [935] = 787,
  [936] = 769,
  [937] = 762,
  [938] = 777,
  [939] = 916,
  [940] = 787,
  [941] = 907,
  [942] = 752,
  [943] = 756,
  [944] = 766,
  [945] = 754,
  [946] = 756,
  [947] = 780,
  [948] = 907,
  [949] = 916,
  [950] = 915,
  [951] = 781,
  [952] = 752,
  [953] = 916,
  [954] = 782,
  [955] = 907,
  [956] = 880,
  [957] = 759,
  [958] = 771,
  [959] = 752,
  [960] = 916,
  [961] = 756,
  [962] = 907,
  [963] = 752,
  [964] = 763,
  [965] = 787,
  [966] = 753,
  [967] = 916,
  [968] = 753,
  [969] = 907,
  [970] = 754,
  [971] = 754,
  [972] = 782,
  [973] = 777,
  [974] = 916,
  [975] = 975,
  [976] = 907,
  [977] = 780,
  [978] = 787,
  [979] = 755,
  [980] = 764,
  [981] = 916,
  [982] = 771,
  [983] = 907,
  [984] = 759,
  [985] = 781,
  [986] = 762,
  [987] = 907,
  [988] = 916,
  [989] = 753,
  [990] = 907,
  [991] = 766,
  [992] = 763,
  [993] = 764,
  [994] = 780,
  [995] = 916,
  [996] = 781,
  [997] = 907,
  [998] = 767,
  [999] = 782,
  [1000] = 759,
  [1001] = 755,
  [1002] = 916,
  [1003] = 1003,
  [1004] = 1004,
  [1005] = 1005,
  [1006] = 1006,
  [1007] = 1007,
  [1008] = 1008,
  [1009] = 1005,
  [1010] = 1008,
  [1011] = 1011,
  [1012] = 1011,
  [1013] = 1013,
  [1014] = 1014,
  [1015] = 1015,
  [1016] = 1016,
  [1017] = 1013,
  [1018] = 1018,
  [1019] = 1019,
  [1020] = 1020,
  [1021] = 1021,
  [1022] = 1022,
  [1023] = 1023,
  [1024] = 1024,
  [1025] = 1025,
  [1026] = 1026,
  [1027] = 1027,
  [1028] = 1028,
  [1029] = 1029,
  [1030] = 1030,
  [1031] = 1031,
  [1032] = 1032,
  [1033] = 1033,
  [1034] = 1034,
  [1035] = 1035,
  [1036] = 1036,
  [1037] = 1037,
  [1038] = 1038,
  [1039] = 1039,
  [1040] = 1040,
  [1041] = 1041,
  [1042] = 1042,
  [1043] = 1043,
  [1044] = 1004,
  [1045] = 1045,
  [1046] = 1046,
  [1047] = 1047,
  [1048] = 1048,
  [1049] = 1014,
  [1050] = 1050,
  [1051] = 1051,
  [1052] = 1020,
  [1053] = 1021,
  [1054] = 1022,
  [1055] = 1023,
  [1056] = 1025,
  [1057] = 1026,
  [1058] = 1027,
  [1059] = 1059,
  [1060] = 1028,
  [1061] = 1015,
  [1062] = 1029,
  [1063] = 1030,
  [1064] = 1031,
  [1065] = 1033,
  [1066] = 1037,
  [1067] = 1038,
  [1068] = 1040,
  [1069] = 1041,
  [1070] = 1004,
  [1071] = 1045,
  [1072] = 1046,
  [1073] = 1047,
  [1074] = 1048,
  [1075] = 1050,
  [1076] = 1076,
  [1077] = 1077,
  [1078] = 1078,
  [1079] = 1059,
  [1080] = 1051,
  [1081] = 1006,
  [1082] = 1007,
  [1083] = 1005,
  [1084] = 1008,
  [1085] = 1076,
  [1086] = 1077,
  [1087] = 1011,
  [1088] = 1078,
  [1089] = 1051,
  [1090] = 1013,
  [1091] = 1006,
  [1092] = 1007,
  [1093] = 1015,
  [1094] = 1005,
  [1095] = 1008,
  [1096] = 1016,
  [1097] = 1011,
  [1098] = 1013,
  [1099] = 1018,
  [1100] = 1015,
  [1101] = 1016,
  [1102] = 1018,
  [1103] = 1016,
  [1104] = 1024,
  [1105] = 1024,
  [1106] = 1034,
  [1107] = 1035,
  [1108] = 1036,
  [1109] = 1034,
  [1110] = 1035,
  [1111] = 1039,
  [1112] = 1042,
  [1113] = 1043,
  [1114] = 1036,
  [1115] = 1039,
  [1116] = 1014,
  [1117] = 1019,
  [1118] = 1020,
  [1119] = 1021,
  [1120] = 1022,
  [1121] = 1023,
  [1122] = 1042,
  [1123] = 1043,
  [1124] = 1025,
  [1125] = 1026,
  [1126] = 1027,
  [1127] = 1028,
  [1128] = 1029,
  [1129] = 1030,
  [1130] = 1014,
  [1131] = 1131,
  [1132] = 1031,
  [1133] = 1033,
  [1134] = 1037,
  [1135] = 1038,
  [1136] = 1040,
  [1137] = 1041,
  [1138] = 1004,
  [1139] = 1045,
  [1140] = 1046,
  [1141] = 1047,
  [1142] = 1048,
  [1143] = 1050,
  [1144] = 1019,
  [1145] = 1020,
  [1146] = 1021,
  [1147] = 1022,
  [1148] = 1023,
  [1149] = 1018,
  [1150] = 1059,
  [1151] = 1025,
  [1152] = 1152,
  [1153] = 1026,
  [1154] = 1027,
  [1155] = 1028,
  [1156] = 1076,
  [1157] = 1029,
  [1158] = 1077,
  [1159] = 1078,
  [1160] = 1030,
  [1161] = 1051,
  [1162] = 1006,
  [1163] = 1007,
  [1164] = 1005,
  [1165] = 1008,
  [1166] = 1031,
  [1167] = 1011,
  [1168] = 1032,
  [1169] = 1013,
  [1170] = 1033,
  [1171] = 1015,
  [1172] = 1037,
  [1173] = 1016,
  [1174] = 1038,
  [1175] = 1018,
  [1176] = 1040,
  [1177] = 1041,
  [1178] = 1004,
  [1179] = 1045,
  [1180] = 1046,
  [1181] = 1047,
  [1182] = 1048,
  [1183] = 1050,
  [1184] = 1024,
  [1185] = 1024,
  [1186] = 1026,
  [1187] = 1024,
  [1188] = 1059,
  [1189] = 1027,
  [1190] = 1059,
  [1191] = 1076,
  [1192] = 1034,
  [1193] = 1035,
  [1194] = 1036,
  [1195] = 1077,
  [1196] = 1039,
  [1197] = 1078,
  [1198] = 1042,
  [1199] = 1043,
  [1200] = 1051,
  [1201] = 1006,
  [1202] = 1007,
  [1203] = 1014,
  [1204] = 1005,
  [1205] = 1019,
  [1206] = 1020,
  [1207] = 1021,
  [1208] = 1022,
  [1209] = 1023,
  [1210] = 1025,
  [1211] = 1026,
  [1212] = 1027,
  [1213] = 1028,
  [1214] = 1029,
  [1215] = 1030,
  [1216] = 1031,
  [1217] = 1033,
  [1218] = 1037,
  [1219] = 1038,
  [1220] = 1040,
  [1221] = 1041,
  [1222] = 1004,
  [1223] = 1045,
  [1224] = 1046,
  [1225] = 1047,
  [1226] = 1048,
  [1227] = 1050,
  [1228] = 1059,
  [1229] = 1008,
  [1230] = 1076,
  [1231] = 1077,
  [1232] = 1078,
  [1233] = 1051,
  [1234] = 1006,
  [1235] = 1007,
  [1236] = 1005,
  [1237] = 1008,
  [1238] = 1011,
  [1239] = 1013,
  [1240] = 1015,
  [1241] = 1016,
  [1242] = 1018,
  [1243] = 1011,
  [1244] = 1024,
  [1245] = 1034,
  [1246] = 1035,
  [1247] = 1036,
  [1248] = 1039,
  [1249] = 1042,
  [1250] = 1043,
  [1251] = 1014,
  [1252] = 1019,
  [1253] = 1020,
  [1254] = 1021,
  [1255] = 1022,
  [1256] = 1023,
  [1257] = 1013,
  [1258] = 1258,
  [1259] = 1015,
  [1260] = 1260,
  [1261] = 1016,
  [1262] = 1025,
  [1263] = 1026,
  [1264] = 1018,
  [1265] = 1027,
  [1266] = 1034,
  [1267] = 1028,
  [1268] = 1035,
  [1269] = 1029,
  [1270] = 1030,
  [1271] = 1036,
  [1272] = 1031,
  [1273] = 1033,
  [1274] = 1037,
  [1275] = 1038,
  [1276] = 1040,
  [1277] = 1041,
  [1278] = 1004,
  [1279] = 1045,
  [1280] = 1046,
  [1281] = 1047,
  [1282] = 1048,
  [1283] = 1050,
  [1284] = 1034,
  [1285] = 1035,
  [1286] = 1039,
  [1287] = 1024,
  [1288] = 1059,
  [1289] = 1042,
  [1290] = 1043,
  [1291] = 1291,
  [1292] = 1036,
  [1293] = 1028,
  [1294] = 1014,
  [1295] = 1076,
  [1296] = 1077,
  [1297] = 1039,
  [1298] = 1078,
  [1299] = 1029,
  [1300] = 1051,
  [1301] = 1019,
  [1302] = 1006,
  [1303] = 1020,
  [1304] = 1007,
  [1305] = 1021,
  [1306] = 1005,
  [1307] = 1034,
  [1308] = 1008,
  [1309] = 1035,
  [1310] = 1011,
  [1311] = 1013,
  [1312] = 1022,
  [1313] = 1015,
  [1314] = 1023,
  [1315] = 1016,
  [1316] = 1036,
  [1317] = 1018,
  [1318] = 1039,
  [1319] = 1030,
  [1320] = 1042,
  [1321] = 1042,
  [1322] = 1043,
  [1323] = 1025,
  [1324] = 1024,
  [1325] = 1043,
  [1326] = 1026,
  [1327] = 1027,
  [1328] = 1014,
  [1329] = 1028,
  [1330] = 1019,
  [1331] = 1020,
  [1332] = 1021,
  [1333] = 1022,
  [1334] = 1023,
  [1335] = 1029,
  [1336] = 1030,
  [1337] = 1034,
  [1338] = 1035,
  [1339] = 1036,
  [1340] = 1076,
  [1341] = 1025,
  [1342] = 1039,
  [1343] = 1014,
  [1344] = 1026,
  [1345] = 1042,
  [1346] = 1043,
  [1347] = 1027,
  [1348] = 1031,
  [1349] = 1028,
  [1350] = 1032,
  [1351] = 1014,
  [1352] = 1029,
  [1353] = 1033,
  [1354] = 1030,
  [1355] = 1019,
  [1356] = 1020,
  [1357] = 1021,
  [1358] = 1022,
  [1359] = 1023,
  [1360] = 1037,
  [1361] = 1038,
  [1362] = 1040,
  [1363] = 1041,
  [1364] = 1031,
  [1365] = 1025,
  [1366] = 1032,
  [1367] = 1026,
  [1368] = 1033,
  [1369] = 1027,
  [1370] = 1037,
  [1371] = 1028,
  [1372] = 1038,
  [1373] = 1029,
  [1374] = 1040,
  [1375] = 1030,
  [1376] = 1041,
  [1377] = 1004,
  [1378] = 1045,
  [1379] = 1046,
  [1380] = 1031,
  [1381] = 1033,
  [1382] = 1037,
  [1383] = 1038,
  [1384] = 1040,
  [1385] = 1041,
  [1386] = 1004,
  [1387] = 1045,
  [1388] = 1046,
  [1389] = 1047,
  [1390] = 1048,
  [1391] = 1050,
  [1392] = 1047,
  [1393] = 1048,
  [1394] = 1050,
  [1395] = 1004,
  [1396] = 1045,
  [1397] = 1046,
  [1398] = 1047,
  [1399] = 1048,
  [1400] = 1050,
  [1401] = 1059,
  [1402] = 1077,
  [1403] = 1019,
  [1404] = 1059,
  [1405] = 1020,
  [1406] = 1021,
  [1407] = 1022,
  [1408] = 1076,
  [1409] = 1023,
  [1410] = 1077,
  [1411] = 1078,
  [1412] = 1078,
  [1413] = 1051,
  [1414] = 1059,
  [1415] = 1006,
  [1416] = 1051,
  [1417] = 1007,
  [1418] = 1076,
  [1419] = 1005,
  [1420] = 1008,
  [1421] = 1077,
  [1422] = 1011,
  [1423] = 1006,
  [1424] = 1013,
  [1425] = 1078,
  [1426] = 1015,
  [1427] = 1025,
  [1428] = 1016,
  [1429] = 1051,
  [1430] = 1018,
  [1431] = 1019,
  [1432] = 1006,
  [1433] = 1026,
  [1434] = 1007,
  [1435] = 1007,
  [1436] = 1005,
  [1437] = 1027,
  [1438] = 1008,
  [1439] = 1020,
  [1440] = 1011,
  [1441] = 1076,
  [1442] = 1024,
  [1443] = 1013,
  [1444] = 1028,
  [1445] = 1015,
  [1446] = 1077,
  [1447] = 1016,
  [1448] = 1005,
  [1449] = 1018,
  [1450] = 1078,
  [1451] = 1029,
  [1452] = 1051,
  [1453] = 1031,
  [1454] = 1006,
  [1455] = 1030,
  [1456] = 1007,
  [1457] = 1008,
  [1458] = 1005,
  [1459] = 1032,
  [1460] = 1008,
  [1461] = 1034,
  [1462] = 1035,
  [1463] = 1036,
  [1464] = 1024,
  [1465] = 1011,
  [1466] = 1039,
  [1467] = 1011,
  [1468] = 1033,
  [1469] = 1042,
  [1470] = 1043,
  [1471] = 1013,
  [1472] = 1031,
  [1473] = 1015,
  [1474] = 1032,
  [1475] = 1016,
  [1476] = 1014,
  [1477] = 1033,
  [1478] = 1018,
  [1479] = 1037,
  [1480] = 1038,
  [1481] = 1040,
  [1482] = 1041,
  [1483] = 1152,
  [1484] = 1258,
  [1485] = 1260,
  [1486] = 1034,
  [1487] = 1291,
  [1488] = 1035,
  [1489] = 1013,
  [1490] = 1036,
  [1491] = 1045,
  [1492] = 1046,
  [1493] = 1039,
  [1494] = 1047,
  [1495] = 1048,
  [1496] = 1050,
  [1497] = 1042,
  [1498] = 1043,
  [1499] = 1037,
  [1500] = 1015,
  [1501] = 1038,
  [1502] = 1016,
  [1503] = 1024,
  [1504] = 1014,
  [1505] = 1040,
  [1506] = 1018,
  [1507] = 1152,
  [1508] = 1258,
  [1509] = 1260,
  [1510] = 1291,
  [1511] = 1041,
  [1512] = 1019,
  [1513] = 1020,
  [1514] = 1021,
  [1515] = 1022,
  [1516] = 1023,
  [1517] = 1004,
  [1518] = 1152,
  [1519] = 1258,
  [1520] = 1260,
  [1521] = 1291,
  [1522] = 1045,
  [1523] = 1059,
  [1524] = 1025,
  [1525] = 1046,
  [1526] = 1026,
  [1527] = 1152,
  [1528] = 1258,
  [1529] = 1260,
  [1530] = 1291,
  [1531] = 1027,
  [1532] = 1028,
  [1533] = 1029,
  [1534] = 1152,
  [1535] = 1258,
  [1536] = 1260,
  [1537] = 1291,
  [1538] = 1030,
  [1539] = 1047,
  [1540] = 1048,
  [1541] = 1076,
  [1542] = 1031,
  [1543] = 1033,
  [1544] = 1152,
  [1545] = 1258,
  [1546] = 1260,
  [1547] = 1291,
  [1548] = 1037,
  [1549] = 1038,
  [1550] = 1040,
  [1551] = 1041,
  [1552] = 1004,
  [1553] = 1045,
  [1554] = 1046,
  [1555] = 1152,
  [1556] = 1258,
  [1557] = 1260,
  [1558] = 1291,
  [1559] = 1047,
  [1560] = 1048,
  [1561] = 1050,
  [1562] = 1050,
  [1563] = 1077,
  [1564] = 1078,
  [1565] = 1152,
  [1566] = 1258,
  [1567] = 1260,
  [1568] = 1291,
  [1569] = 1034,
  [1570] = 1035,
  [1571] = 1021,
  [1572] = 1059,
  [1573] = 1051,
  [1574] = 1152,
  [1575] = 1258,
  [1576] = 1260,
  [1577] = 1291,
  [1578] = 1036,
  [1579] = 1022,
  [1580] = 1006,
  [1581] = 1039,
  [1582] = 1023,
  [1583] = 1152,
  [1584] = 1258,
  [1585] = 1260,
  [1586] = 1291,
  [1587] = 1007,
  [1588] = 1076,
  [1589] = 1025,
  [1590] = 1077,
  [1591] = 1042,
  [1592] = 1078,
  [1593] = 1043,
  [1594] = 1152,
  [1595] = 1258,
  [1596] = 1260,
  [1597] = 1291,
  [1598] = 1019,
  [1599] = 1599,
  [1600] = 1599,
  [1601] = 1601,
  [1602] = 1602,
  [1603] = 1603,
  [1604] = 1599,
  [1605] = 1601,
  [1606] = 1601,
  [1607] = 1607,
  [1608] = 1603,
  [1609] = 1599,
  [1610] = 1603,
  [1611] = 1607,
  [1612] = 1599,
  [1613] = 1607,
  [1614] = 1599,
  [1615] = 1601,
  [1616] = 1601,
  [1617] = 1603,
  [1618] = 1607,
  [1619] = 1599,
  [1620] = 1603,
  [1621] = 1621,
  [1622] = 1601,
  [1623] = 1623,
  [1624] = 1607,
  [1625] = 1599,
  [1626] = 1603,
  [1627] = 1627,
  [1628] = 1601,
  [1629] = 1607,
  [1630] = 1601,
  [1631] = 1603,
  [1632] = 1603,
  [1633] = 1607,
  [1634] = 1599,
  [1635] = 1607,
  [1636] = 1636,
  [1637] = 1603,
  [1638] = 1603,
  [1639] = 1603,
  [1640] = 1607,
  [1641] = 1636,
  [1642] = 1601,
  [1643] = 1599,
  [1644] = 1607,
  [1645] = 1599,
  [1646] = 1607,
  [1647] = 1599,
  [1648] = 1601,
  [1649] = 1601,
  [1650] = 1603,
  [1651] = 1601,
  [1652] = 1652,
  [1653] = 1627,
  [1654] = 1623,
  [1655] = 1621,
  [1656] = 1607,
  [1657] = 1652,
  [1658] = 1627,
  [1659] = 1623,
  [1660] = 1621,
  [1661] = 1652,
  [1662] = 1627,
  [1663] = 1623,
  [1664] = 1621,
  [1665] = 1652,
  [1666] = 1627,
  [1667] = 1623,
  [1668] = 1621,
  [1669] = 1652,
  [1670] = 1627,
  [1671] = 1623,
  [1672] = 1621,
  [1673] = 1652,
  [1674] = 1627,
  [1675] = 1623,
  [1676] = 1621,
  [1677] = 1652,
  [1678] = 1627,
  [1679] = 1623,
  [1680] = 1621,
  [1681] = 1652,
  [1682] = 1627,
  [1683] = 1623,
  [1684] = 1621,
  [1685] = 1652,
  [1686] = 1627,
  [1687] = 1623,
  [1688] = 1621,
  [1689] = 1652,
  [1690] = 1627,
  [1691] = 1623,
  [1692] = 1621,
  [1693] = 1652,
  [1694] = 1627,
  [1695] = 1623,
  [1696] = 1621,
  [1697] = 1602,
  [1698] = 1636,
  [1699] = 1602,
  [1700] = 1636,
  [1701] = 1602,
  [1702] = 1636,
  [1703] = 1602,
  [1704] = 1636,
  [1705] = 1602,
  [1706] = 1636,
  [1707] = 1602,
  [1708] = 1636,
  [1709] = 1602,
  [1710] = 1636,
  [1711] = 1602,
  [1712] = 1636,
  [1713] = 1602,
  [1714] = 1636,
  [1715] = 1602,
  [1716] = 1636,
  [1717] = 1602,
  [1718] = 1652,
  [1719] = 405,
  [1720] = 418,
  [1721] = 405,
  [1722] = 418,
  [1723] = 632,
  [1724] = 3,
  [1725] = 7,
  [1726] = 2,
  [1727] = 3,
  [1728] = 2,
  [1729] = 632,
  [1730] = 4,
  [1731] = 4,
  [1732] = 7,
  [1733] = 89,
  [1734] = 69,
  [1735] = 79,
  [1736] = 70,
  [1737] = 71,
  [1738] = 80,
  [1739] = 63,
  [1740] = 81,
  [1741] = 82,
  [1742] = 74,
  [1743] = 75,
  [1744] = 61,
  [1745] = 64,
  [1746] = 83,
  [1747] = 62,
  [1748] = 84,
  [1749] = 702,
  [1750] = 85,
  [1751] = 86,
  [1752] = 87,
  [1753] = 88,
  [1754] = 72,
  [1755] = 77,
  [1756] = 90,
  [1757] = 73,
  [1758] = 92,
  [1759] = 76,
  [1760] = 43,
  [1761] = 44,
  [1762] = 45,
  [1763] = 65,
  [1764] = 66,
  [1765] = 46,
  [1766] = 47,
  [1767] = 48,
  [1768] = 49,
  [1769] = 50,
  [1770] = 51,
  [1771] = 52,
  [1772] = 42,
  [1773] = 53,
  [1774] = 54,
  [1775] = 55,
  [1776] = 56,
  [1777] = 78,
  [1778] = 57,
  [1779] = 58,
  [1780] = 59,
  [1781] = 60,
  [1782] = 68,
  [1783] = 91,
  [1784] = 88,
  [1785] = 92,
  [1786] = 1786,
  [1787] = 77,
  [1788] = 76,
  [1789] = 1789,
  [1790] = 1786,
  [1791] = 1791,
  [1792] = 1792,
  [1793] = 1793,
  [1794] = 46,
  [1795] = 47,
  [1796] = 48,
  [1797] = 49,
  [1798] = 50,
  [1799] = 1786,
  [1800] = 1791,
  [1801] = 51,
  [1802] = 73,
  [1803] = 1792,
  [1804] = 1793,
  [1805] = 68,
  [1806] = 52,
  [1807] = 53,
  [1808] = 54,
  [1809] = 1786,
  [1810] = 1791,
  [1811] = 55,
  [1812] = 56,
  [1813] = 1792,
  [1814] = 1793,
  [1815] = 1793,
  [1816] = 57,
  [1817] = 58,
  [1818] = 1786,
  [1819] = 59,
  [1820] = 1791,
  [1821] = 1792,
  [1822] = 1793,
  [1823] = 1791,
  [1824] = 1786,
  [1825] = 1791,
  [1826] = 1792,
  [1827] = 60,
  [1828] = 1793,
  [1829] = 1786,
  [1830] = 1791,
  [1831] = 1792,
  [1832] = 1793,
  [1833] = 43,
  [1834] = 1786,
  [1835] = 1791,
  [1836] = 1836,
  [1837] = 1792,
  [1838] = 1793,
  [1839] = 63,
  [1840] = 85,
  [1841] = 1786,
  [1842] = 1791,
  [1843] = 89,
  [1844] = 69,
  [1845] = 1792,
  [1846] = 1793,
  [1847] = 1786,
  [1848] = 83,
  [1849] = 1792,
  [1850] = 1793,
  [1851] = 1851,
  [1852] = 86,
  [1853] = 61,
  [1854] = 74,
  [1855] = 1786,
  [1856] = 1791,
  [1857] = 1792,
  [1858] = 1793,
  [1859] = 1836,
  [1860] = 1789,
  [1861] = 62,
  [1862] = 44,
  [1863] = 1836,
  [1864] = 1789,
  [1865] = 90,
  [1866] = 1836,
  [1867] = 1789,
  [1868] = 78,
  [1869] = 70,
  [1870] = 1836,
  [1871] = 702,
  [1872] = 1789,
  [1873] = 64,
  [1874] = 71,
  [1875] = 1836,
  [1876] = 1789,
  [1877] = 65,
  [1878] = 1836,
  [1879] = 79,
  [1880] = 1789,
  [1881] = 91,
  [1882] = 1836,
  [1883] = 45,
  [1884] = 1789,
  [1885] = 1836,
  [1886] = 1789,
  [1887] = 1836,
  [1888] = 1789,
  [1889] = 80,
  [1890] = 1836,
  [1891] = 1789,
  [1892] = 1786,
  [1893] = 1791,
  [1894] = 81,
  [1895] = 82,
  [1896] = 1836,
  [1897] = 1792,
  [1898] = 1789,
  [1899] = 1793,
  [1900] = 75,
  [1901] = 87,
  [1902] = 1792,
  [1903] = 72,
  [1904] = 66,
  [1905] = 42,
  [1906] = 84,
  [1907] = 1791,
  [1908] = 1908,
  [1909] = 1908,
  [1910] = 660,
  [1911] = 662,
  [1912] = 1912,
  [1913] = 667,
  [1914] = 655,
  [1915] = 658,
  [1916] = 1916,
  [1917] = 653,
  [1918] = 1918,
  [1919] = 1908,
  [1920] = 1920,
  [1921] = 1921,
  [1922] = 656,
  [1923] = 657,
  [1924] = 1924,
  [1925] = 1918,
  [1926] = 1918,
  [1927] = 1920,
  [1928] = 1912,
  [1929] = 654,
  [1930] = 1916,
  [1931] = 1924,
  [1932] = 1921,
  [1933] = 1921,
  [1934] = 1912,
  [1935] = 1935,
  [1936] = 1920,
  [1937] = 1916,
  [1938] = 1924,
  [1939] = 653,
  [1940] = 702,
  [1941] = 657,
  [1942] = 667,
  [1943] = 660,
  [1944] = 658,
  [1945] = 655,
  [1946] = 662,
  [1947] = 656,
  [1948] = 654,
  [1949] = 1949,
  [1950] = 752,
  [1951] = 764,
  [1952] = 1952,
  [1953] = 769,
  [1954] = 1954,
  [1955] = 787,
  [1956] = 762,
  [1957] = 767,
  [1958] = 780,
  [1959] = 771,
  [1960] = 754,
  [1961] = 766,
  [1962] = 781,
  [1963] = 782,
  [1964] = 777,
  [1965] = 755,
  [1966] = 759,
  [1967] = 763,
  [1968] = 756,
  [1969] = 768,
  [1970] = 753,
  [1971] = 1971,
  [1972] = 766,
  [1973] = 781,
  [1974] = 762,
  [1975] = 777,
  [1976] = 767,
  [1977] = 759,
  [1978] = 787,
  [1979] = 752,
  [1980] = 782,
  [1981] = 771,
  [1982] = 755,
  [1983] = 756,
  [1984] = 763,
  [1985] = 768,
  [1986] = 780,
  [1987] = 753,
  [1988] = 754,
  [1989] = 764,
  [1990] = 769,
  [1991] = 1991,
  [1992] = 1992,
  [1993] = 1993,
  [1994] = 1994,
  [1995] = 1995,
  [1996] = 1996,
  [1997] = 1997,
  [1998] = 1998,
  [1999] = 1997,
  [2000] = 1996,
  [2001] = 1998,
  [2002] = 1996,
  [2003] = 2003,
  [2004] = 2004,
  [2005] = 1994,
  [2006] = 1997,
  [2007] = 1994,
  [2008] = 1997,
  [2009] = 1994,
  [2010] = 1997,
  [2011] = 1998,
  [2012] = 1998,
  [2013] = 1996,
  [2014] = 1996,
  [2015] = 2015,
  [2016] = 1994,
  [2017] = 2017,
  [2018] = 1998,
  [2019] = 1996,
  [2020] = 1997,
  [2021] = 2021,
  [2022] = 1994,
  [2023] = 2023,
  [2024] = 1997,
  [2025] = 1998,
  [2026] = 2026,
  [2027] = 1998,
  [2028] = 1996,
  [2029] = 1997,
  [2030] = 1994,
  [2031] = 1993,
  [2032] = 2032,
  [2033] = 1998,
  [2034] = 1996,
  [2035] = 1998,
  [2036] = 2004,
  [2037] = 2021,
  [2038] = 1997,
  [2039] = 1994,
  [2040] = 2004,
  [2041] = 2021,
  [2042] = 1997,
  [2043] = 2004,
  [2044] = 2021,
  [2045] = 1994,
  [2046] = 2004,
  [2047] = 2021,
  [2048] = 1994,
  [2049] = 2004,
  [2050] = 2021,
  [2051] = 2004,
  [2052] = 2021,
  [2053] = 1997,
  [2054] = 2004,
  [2055] = 1994,
  [2056] = 2021,
  [2057] = 2004,
  [2058] = 1998,
  [2059] = 2021,
  [2060] = 1996,
  [2061] = 2004,
  [2062] = 1998,
  [2063] = 2021,
  [2064] = 1996,
  [2065] = 2004,
  [2066] = 1997,
  [2067] = 2021,
  [2068] = 1998,
  [2069] = 2004,
  [2070] = 2021,
  [2071] = 2003,
  [2072] = 1996,
  [2073] = 1993,
  [2074] = 2003,
  [2075] = 1993,
  [2076] = 2003,
  [2077] = 1993,
  [2078] = 2003,
  [2079] = 1993,
  [2080] = 2003,
  [2081] = 1993,
  [2082] = 2003,
  [2083] = 1993,
  [2084] = 2003,
  [2085] = 1993,
  [2086] = 2003,
  [2087] = 1993,
  [2088] = 2003,
  [2089] = 1996,
  [2090] = 2003,
  [2091] = 1993,
  [2092] = 2003,
  [2093] = 2023,
  [2094] = 1993,
  [2095] = 2015,
  [2096] = 2023,
  [2097] = 2015,
  [2098] = 2023,
  [2099] = 2015,
  [2100] = 2023,
  [2101] = 2015,
  [2102] = 2023,
  [2103] = 2015,
  [2104] = 2023,
  [2105] = 2015,
  [2106] = 2023,
  [2107] = 2015,
  [2108] = 2023,
  [2109] = 2015,
  [2110] = 2023,
  [2111] = 2015,
  [2112] = 2023,
  [2113] = 2015,
  [2114] = 2023,
  [2115] = 2015,
  [2116] = 1994,
  [2117] = 2117,
  [2118] = 2118,
  [2119] = 2119,
  [2120] = 2118,
  [2121] = 2121,
  [2122] = 2118,
  [2123] = 2118,
  [2124] = 2118,
  [2125] = 2118,
  [2126] = 2118,
  [2127] = 2118,
  [2128] = 2118,
  [2129] = 2129,
  [2130] = 2118,
  [2131] = 2118,
  [2132] = 2118,
  [2133] = 702,
  [2134] = 2134,
  [2135] = 2135,
  [2136] = 2134,
  [2137] = 2134,
  [2138] = 2138,
  [2139] = 2134,
  [2140] = 2134,
  [2141] = 2134,
  [2142] = 2134,
  [2143] = 2134,
  [2144] = 2134,
  [2145] = 2134,
  [2146] = 2146,
  [2147] = 2134,
  [2148] = 2134,
  [2149] = 2149,
  [2150] = 2150,
  [2151] = 2151,
  [2152] = 2152,
  [2153] = 2153,
  [2154] = 2150,
  [2155] = 2151,
  [2156] = 2150,
  [2157] = 2151,
  [2158] = 2150,
  [2159] = 2151,
  [2160] = 2152,
  [2161] = 2153,
  [2162] = 2150,
  [2163] = 2151,
  [2164] = 2152,
  [2165] = 2153,
  [2166] = 2150,
  [2167] = 2151,
  [2168] = 2152,
  [2169] = 2150,
  [2170] = 2151,
  [2171] = 2151,
  [2172] = 2150,
  [2173] = 2151,
  [2174] = 2151,
  [2175] = 2153,
  [2176] = 2152,
  [2177] = 2153,
  [2178] = 2178,
  [2179] = 2153,
  [2180] = 2151,
  [2181] = 2152,
  [2182] = 2152,
  [2183] = 2153,
  [2184] = 2152,
  [2185] = 2150,
  [2186] = 2152,
  [2187] = 2151,
  [2188] = 2152,
  [2189] = 2153,
  [2190] = 2153,
  [2191] = 2150,
  [2192] = 2150,
  [2193] = 2153,
  [2194] = 2152,
  [2195] = 2153,
  [2196] = 2150,
  [2197] = 2153,
  [2198] = 2152,
};

static TSCharacterRange sym_identifier_character_set_1[] = {
  {'.', '.'}, {'A', 'Z'}, {'_', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6},
  {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x370, 0x374}, {0x376, 0x377}, {0x37b, 0x37d},
  {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481}, {0x48a, 0x52f},
  {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x620, 0x64a}, {0x66e, 0x66f}, {0x671, 0x6d3},
  {0x6d5, 0x6d5}, {0x6e5, 0x6e6}, {0x6ee, 0x6ef}, {0x6fa, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x710}, {0x712, 0x72f}, {0x74d, 0x7a5},
  {0x7b1, 0x7b1}, {0x7ca, 0x7ea}, {0x7f4, 0x7f5}, {0x7fa, 0x7fa}, {0x800, 0x815}, {0x81a, 0x81a}, {0x824, 0x824}, {0x828, 0x828},
  {0x840, 0x858}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x8a0, 0x8c9}, {0x904, 0x939}, {0x93d, 0x93d}, {0x950, 0x950},
  {0x958, 0x961}, {0x971, 0x980}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9},
  {0x9bd, 0x9bd}, {0x9ce, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e1}, {0x9f0, 0x9f1}, {0x9fc, 0x9fc}, {0xa05, 0xa0a}, {0xa0f, 0xa10},
  {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa59, 0xa5c}, {0xa5e, 0xa5e}, {0xa72, 0xa74},
  {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabd, 0xabd}, {0xad0, 0xad0},
  {0xae0, 0xae1}, {0xaf9, 0xaf9}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39},
  {0xb3d, 0xb3d}, {0xb5c, 0xb5d}, {0xb5f, 0xb61}, {0xb71, 0xb71}, {0xb83, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90}, {0xb92, 0xb95},
  {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbd0, 0xbd0}, {0xc05, 0xc0c},
  {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3d, 0xc3d}, {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc61}, {0xc80, 0xc80},
  {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbd, 0xcbd}, {0xcdd, 0xcde}, {0xce0, 0xce1},
  {0xcf1, 0xcf2}, {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3a}, {0xd3d, 0xd3d}, {0xd4e, 0xd4e}, {0xd54, 0xd56}, {0xd5f, 0xd61},
  {0xd7a, 0xd7f}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xe01, 0xe30}, {0xe32, 0xe32},
  {0xe40, 0xe46}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xeb0}, {0xeb2, 0xeb2},
  {0xebd, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf40, 0xf47}, {0xf49, 0xf6c}, {0xf88, 0xf8c},
  {0x1000, 0x102a}, {0x103f, 0x103f}, {0x1050, 0x1055}, {0x105a, 0x105d}, {0x1061, 0x1061}, {0x1065, 0x1066}, {0x106e, 0x1070}, {0x1075, 0x1081},
  {0x108e, 0x108e}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256},
  {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0},
  {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x1380, 0x138f}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd},
  {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1711}, {0x171f, 0x1731}, {0x1740, 0x1751},
  {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1780, 0x17b3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dc}, {0x1820, 0x1878}, {0x1880, 0x18a8}, {0x18aa, 0x18aa},
  {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1950, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x1a00, 0x1a16}, {0x1a20, 0x1a54},
  {0x1aa7, 0x1aa7}, {0x1b05, 0x1b33}, {0x1b45, 0x1b4c}, {0x1b83, 0x1ba0}, {0x1bae, 0x1baf}, {0x1bba, 0x1be5}, {0x1c00, 0x1c23}, {0x1c4d, 0x1c4f},
  {0x1c5a, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1ce9, 0x1cec}, {0x1cee, 0x1cf3}, {0x1cf5, 0x1cf6}, {0x1cfa, 0x1cfa},
  {0x1d00, 0x1dbf}, {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b},
  {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3},
  {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x2102, 0x2102},
  {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139},
  {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cee}, {0x2cf2, 0x2cf3}, {0x2d00, 0x2d25},
  {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d80, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6},
  {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x3005, 0x3007}, {0x3021, 0x3029}, {0x3031, 0x3035},
  {0x3038, 0x303c}, {0x3041, 0x3096}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf},
  {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa61f}, {0xa62a, 0xa62b}, {0xa640, 0xa66e},
  {0xa67f, 0xa69d}, {0xa6a0, 0xa6ef}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9},
  {0xa7f2, 0xa801}, {0xa803, 0xa805}, {0xa807, 0xa80a}, {0xa80c, 0xa822}, {0xa840, 0xa873}, {0xa882, 0xa8b3}, {0xa8f2, 0xa8f7}, {0xa8fb, 0xa8fb},
  {0xa8fd, 0xa8fe}, {0xa90a, 0xa925}, {0xa930, 0xa946}, {0xa960, 0xa97c}, {0xa984, 0xa9b2}, {0xa9cf, 0xa9cf}, {0xa9e0, 0xa9e4}, {0xa9e6, 0xa9ef},
  {0xa9fa, 0xa9fe}, {0xaa00, 0xaa28}, {0xaa40, 0xaa42}, {0xaa44, 0xaa4b}, {0xaa60, 0xaa76}, {0xaa7a, 0xaa7a}, {0xaa7e, 0xaaaf}, {0xaab1, 0xaab1},
  {0xaab5, 0xaab6}, {0xaab9, 0xaabd}, {0xaac0, 0xaac0}, {0xaac2, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaea}, {0xaaf2, 0xaaf4}, {0xab01, 0xab06},
  {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabe2}, {0xac00, 0xd7a3},
  {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb1d}, {0xfb1f, 0xfb28},
  {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d},
  {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b},
  {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0xff66, 0xff9d}, {0xffa0, 0xffbe}, {0xffc2, 0xffc7}, {0xffca, 0xffcf},
  {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d}, {0x10050, 0x1005d},
  {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x10375}, {0x10380, 0x1039d},
  {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563},
  {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc},
  {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808},
  {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5},
  {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a00}, {0x10a10, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35},
  {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae4}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91},
  {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d23}, {0x10e80, 0x10ea9}, {0x10eb0, 0x10eb1}, {0x10f00, 0x10f1c}, {0x10f27, 0x10f27},
  {0x10f30, 0x10f45}, {0x10f70, 0x10f81}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11003, 0x11037}, {0x11071, 0x11072}, {0x11075, 0x11075}, {0x11083, 0x110af},
  {0x110d0, 0x110e8}, {0x11103, 0x11126}, {0x11144, 0x11144}, {0x11147, 0x11147}, {0x11150, 0x11172}, {0x11176, 0x11176}, {0x11183, 0x111b2}, {0x111c1, 0x111c4},
  {0x111da, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x1122b}, {0x1123f, 0x11240}, {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d},
  {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112de}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333},
  {0x11335, 0x11339}, {0x1133d, 0x1133d}, {0x11350, 0x11350}, {0x1135d, 0x11361}, {0x11400, 0x11434}, {0x11447, 0x1144a}, {0x1145f, 0x11461}, {0x11480, 0x114af},
  {0x114c4, 0x114c5}, {0x114c7, 0x114c7}, {0x11580, 0x115ae}, {0x115d8, 0x115db}, {0x11600, 0x1162f}, {0x11644, 0x11644}, {0x11680, 0x116aa}, {0x116b8, 0x116b8},
  {0x11700, 0x1171a}, {0x11740, 0x11746}, {0x11800, 0x1182b}, {0x118a0, 0x118df}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916},
  {0x11918, 0x1192f}, {0x1193f, 0x1193f}, {0x11941, 0x11941}, {0x119a0, 0x119a7}, {0x119aa, 0x119d0}, {0x119e1, 0x119e1}, {0x119e3, 0x119e3}, {0x11a00, 0x11a00},
  {0x11a0b, 0x11a32}, {0x11a3a, 0x11a3a}, {0x11a50, 0x11a50}, {0x11a5c, 0x11a89}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c2e},
  {0x11c40, 0x11c40}, {0x11c72, 0x11c8f}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d30}, {0x11d46, 0x11d46}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68},
  {0x11d6a, 0x11d89}, {0x11d98, 0x11d98}, {0x11ee0, 0x11ef2}, {0x11f02, 0x11f02}, {0x11f04, 0x11f10}, {0x11f12, 0x11f33}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399},
  {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342f}, {0x13441, 0x13446}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e},
  {0x16a70, 0x16abe}, {0x16ad0, 0x16aed}, {0x16b00, 0x16b2f}, {0x16b40, 0x16b43}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a},
  {0x16f50, 0x16f50}, {0x16f93, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe3}, {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3},
  {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132}, {0x1b150, 0x1b152}, {0x1b155, 0x1b155}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb},
  {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2},
  {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514},
  {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0},
  {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8},
  {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a}, {0x1e030, 0x1e06d}, {0x1e100, 0x1e12c}, {0x1e137, 0x1e13d}, {0x1e14e, 0x1e14e},
  {0x1e290, 0x1e2ad}, {0x1e2c0, 0x1e2eb}, {0x1e4d0, 0x1e4eb}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4},
  {0x1e900, 0x1e943}, {0x1e94b, 0x1e94b}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32},
  {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f},
  {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62},
  {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b},
  {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x20000, 0x2a6df}, {0x2a700, 0x2b739}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0},
  {0x2ebf0, 0x2ee5d}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0x31350, 0x323af},
};

static TSCharacterRange sym_identifier_character_set_2[] = {
  {'.', '.'}, {'0', '9'}, {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xb7, 0xb7},
  {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee},
  {0x300, 0x374}, {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5},
  {0x3f7, 0x481}, {0x483, 0x487}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x591, 0x5bd}, {0x5bf, 0x5bf},
  {0x5c1, 0x5c2}, {0x5c4, 0x5c5}, {0x5c7, 0x5c7}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x610, 0x61a}, {0x620, 0x669}, {0x66e, 0x6d3},
  {0x6d5, 0x6dc}, {0x6df, 0x6e8}, {0x6ea, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x74a}, {0x74d, 0x7b1}, {0x7c0, 0x7f5}, {0x7fa, 0x7fa},
  {0x7fd, 0x7fd}, {0x800, 0x82d}, {0x840, 0x85b}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x898, 0x8e1}, {0x8e3, 0x963},
  {0x966, 0x96f}, {0x971, 0x983}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9},
  {0x9bc, 0x9c4}, {0x9c7, 0x9c8}, {0x9cb, 0x9ce}, {0x9d7, 0x9d7}, {0x9dc, 0x9dd}, {0x9df, 0x9e3}, {0x9e6, 0x9f1}, {0x9fc, 0x9fc},
  {0x9fe, 0x9fe}, {0xa01, 0xa03}, {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36},
  {0xa38, 0xa39}, {0xa3c, 0xa3c}, {0xa3e, 0xa42}, {0xa47, 0xa48}, {0xa4b, 0xa4d}, {0xa51, 0xa51}, {0xa59, 0xa5c}, {0xa5e, 0xa5e},
  {0xa66, 0xa75}, {0xa81, 0xa83}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9},
  {0xabc, 0xac5}, {0xac7, 0xac9}, {0xacb, 0xacd}, {0xad0, 0xad0}, {0xae0, 0xae3}, {0xae6, 0xaef}, {0xaf9, 0xaff}, {0xb01, 0xb03},
  {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3c, 0xb44}, {0xb47, 0xb48},
  {0xb4b, 0xb4d}, {0xb55, 0xb57}, {0xb5c, 0xb5d}, {0xb5f, 0xb63}, {0xb66, 0xb6f}, {0xb71, 0xb71}, {0xb82, 0xb83}, {0xb85, 0xb8a},
  {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9},
  {0xbbe, 0xbc2}, {0xbc6, 0xbc8}, {0xbca, 0xbcd}, {0xbd0, 0xbd0}, {0xbd7, 0xbd7}, {0xbe6, 0xbef}, {0xc00, 0xc0c}, {0xc0e, 0xc10},
  {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3c, 0xc44}, {0xc46, 0xc48}, {0xc4a, 0xc4d}, {0xc55, 0xc56}, {0xc58, 0xc5a}, {0xc5d, 0xc5d},
  {0xc60, 0xc63}, {0xc66, 0xc6f}, {0xc80, 0xc83}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9},
  {0xcbc, 0xcc4}, {0xcc6, 0xcc8}, {0xcca, 0xccd}, {0xcd5, 0xcd6}, {0xcdd, 0xcde}, {0xce0, 0xce3}, {0xce6, 0xcef}, {0xcf1, 0xcf3},
  {0xd00, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd44}, {0xd46, 0xd48}, {0xd4a, 0xd4e}, {0xd54, 0xd57}, {0xd5f, 0xd63}, {0xd66, 0xd6f},
  {0xd7a, 0xd7f}, {0xd81, 0xd83}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xdca, 0xdca},
  {0xdcf, 0xdd4}, {0xdd6, 0xdd6}, {0xdd8, 0xddf}, {0xde6, 0xdef}, {0xdf2, 0xdf3}, {0xe01, 0xe3a}, {0xe40, 0xe4e}, {0xe50, 0xe59},
  {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6},
  {0xec8, 0xece}, {0xed0, 0xed9}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf18, 0xf19}, {0xf20, 0xf29}, {0xf35, 0xf35}, {0xf37, 0xf37},
  {0xf39, 0xf39}, {0xf3e, 0xf47}, {0xf49, 0xf6c}, {0xf71, 0xf84}, {0xf86, 0xf97}, {0xf99, 0xfbc}, {0xfc6, 0xfc6}, {0x1000, 0x1049},
  {0x1050, 0x109d}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256},
  {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0},
  {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x135d, 0x135f}, {0x1369, 0x1371}, {0x1380, 0x138f},
  {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1715},
  {0x171f, 0x1734}, {0x1740, 0x1753}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1772, 0x1773}, {0x1780, 0x17d3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dd},
  {0x17e0, 0x17e9}, {0x180b, 0x180d}, {0x180f, 0x1819}, {0x1820, 0x1878}, {0x1880, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1920, 0x192b},
  {0x1930, 0x193b}, {0x1946, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x19d0, 0x19da}, {0x1a00, 0x1a1b}, {0x1a20, 0x1a5e},
  {0x1a60, 0x1a7c}, {0x1a7f, 0x1a89}, {0x1a90, 0x1a99}, {0x1aa7, 0x1aa7}, {0x1ab0, 0x1abd}, {0x1abf, 0x1ace}, {0x1b00, 0x1b4c}, {0x1b50, 0x1b59},
  {0x1b6b, 0x1b73}, {0x1b80, 0x1bf3}, {0x1c00, 0x1c37}, {0x1c40, 0x1c49}, {0x1c4d, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf},
  {0x1cd0, 0x1cd2}, {0x1cd4, 0x1cfa}, {0x1d00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59},
  {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc},
  {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x200c, 0x200d}, {0x203f, 0x2040}, {0x2054, 0x2054},
  {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x20d0, 0x20dc}, {0x20e1, 0x20e1}, {0x20e5, 0x20f0}, {0x2102, 0x2102}, {0x2107, 0x2107},
  {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f},
  {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d},
  {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d7f, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6},
  {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x2de0, 0x2dff}, {0x3005, 0x3007}, {0x3021, 0x302f}, {0x3031, 0x3035}, {0x3038, 0x303c},
  {0x3041, 0x3096}, {0x3099, 0x309a}, {0x309d, 0x309f}, {0x30a1, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff},
  {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa62b}, {0xa640, 0xa66f}, {0xa674, 0xa67d}, {0xa67f, 0xa6f1},
  {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa827}, {0xa82c, 0xa82c},
  {0xa840, 0xa873}, {0xa880, 0xa8c5}, {0xa8d0, 0xa8d9}, {0xa8e0, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa92d}, {0xa930, 0xa953}, {0xa960, 0xa97c},
  {0xa980, 0xa9c0}, {0xa9cf, 0xa9d9}, {0xa9e0, 0xa9fe}, {0xaa00, 0xaa36}, {0xaa40, 0xaa4d}, {0xaa50, 0xaa59}, {0xaa60, 0xaa76}, {0xaa7a, 0xaac2},
  {0xaadb, 0xaadd}, {0xaae0, 0xaaef}, {0xaaf2, 0xaaf6}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e},
  {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabea}, {0xabec, 0xabed}, {0xabf0, 0xabf9}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb},
  {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e},
  {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9},
  {0xfe00, 0xfe0f}, {0xfe20, 0xfe2f}, {0xfe33, 0xfe34}, {0xfe4d, 0xfe4f}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79},
  {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff10, 0xff19}, {0xff21, 0xff3a}, {0xff3f, 0xff3f}, {0xff41, 0xff5a}, {0xff65, 0xffbe},
  {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d},
  {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x101fd, 0x101fd}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x102e0, 0x102e0},
  {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x1037a}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d},
  {0x104a0, 0x104a9}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592},
  {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767},
  {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c},
  {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7},
  {0x109be, 0x109bf}, {0x10a00, 0x10a03}, {0x10a05, 0x10a06}, {0x10a0c, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a38, 0x10a3a}, {0x10a3f, 0x10a3f},
  {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae6}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91},
  {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d27}, {0x10d30, 0x10d39}, {0x10e80, 0x10ea9}, {0x10eab, 0x10eac}, {0x10eb0, 0x10eb1},
  {0x10efd, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f50}, {0x10f70, 0x10f85}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11000, 0x11046}, {0x11066, 0x11075},
  {0x1107f, 0x110ba}, {0x110c2, 0x110c2}, {0x110d0, 0x110e8}, {0x110f0, 0x110f9}, {0x11100, 0x11134}, {0x11136, 0x1113f}, {0x11144, 0x11147}, {0x11150, 0x11173},
  {0x11176, 0x11176}, {0x11180, 0x111c4}, {0x111c9, 0x111cc}, {0x111ce, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x11237}, {0x1123e, 0x11241},
  {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112ea}, {0x112f0, 0x112f9}, {0x11300, 0x11303},
  {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133b, 0x11344}, {0x11347, 0x11348},
  {0x1134b, 0x1134d}, {0x11350, 0x11350}, {0x11357, 0x11357}, {0x1135d, 0x11363}, {0x11366, 0x1136c}, {0x11370, 0x11374}, {0x11400, 0x1144a}, {0x11450, 0x11459},
  {0x1145e, 0x11461}, {0x11480, 0x114c5}, {0x114c7, 0x114c7}, {0x114d0, 0x114d9}, {0x11580, 0x115b5}, {0x115b8, 0x115c0}, {0x115d8, 0x115dd}, {0x11600, 0x11640},
  {0x11644, 0x11644}, {0x11650, 0x11659}, {0x11680, 0x116b8}, {0x116c0, 0x116c9}, {0x11700, 0x1171a}, {0x1171d, 0x1172b}, {0x11730, 0x11739}, {0x11740, 0x11746},
  {0x11800, 0x1183a}, {0x118a0, 0x118e9}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x11935}, {0x11937, 0x11938},
  {0x1193b, 0x11943}, {0x11950, 0x11959}, {0x119a0, 0x119a7}, {0x119aa, 0x119d7}, {0x119da, 0x119e1}, {0x119e3, 0x119e4}, {0x11a00, 0x11a3e}, {0x11a47, 0x11a47},
  {0x11a50, 0x11a99}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c36}, {0x11c38, 0x11c40}, {0x11c50, 0x11c59}, {0x11c72, 0x11c8f},
  {0x11c92, 0x11ca7}, {0x11ca9, 0x11cb6}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d36}, {0x11d3a, 0x11d3a}, {0x11d3c, 0x11d3d}, {0x11d3f, 0x11d47},
  {0x11d50, 0x11d59}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d8e}, {0x11d90, 0x11d91}, {0x11d93, 0x11d98}, {0x11da0, 0x11da9}, {0x11ee0, 0x11ef6},
  {0x11f00, 0x11f10}, {0x11f12, 0x11f3a}, {0x11f3e, 0x11f42}, {0x11f50, 0x11f59}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543},
  {0x12f90, 0x12ff0}, {0x13000, 0x1342f}, {0x13440, 0x13455}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a60, 0x16a69}, {0x16a70, 0x16abe},
  {0x16ac0, 0x16ac9}, {0x16ad0, 0x16aed}, {0x16af0, 0x16af4}, {0x16b00, 0x16b36}, {0x16b40, 0x16b43}, {0x16b50, 0x16b59}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f},
  {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f4f, 0x16f87}, {0x16f8f, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe4}, {0x16ff0, 0x16ff1}, {0x17000, 0x187f7},
  {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132}, {0x1b150, 0x1b152},
  {0x1b155, 0x1b155}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1bc9d, 0x1bc9e},
  {0x1cf00, 0x1cf2d}, {0x1cf30, 0x1cf46}, {0x1d165, 0x1d169}, {0x1d16d, 0x1d172}, {0x1d17b, 0x1d182}, {0x1d185, 0x1d18b}, {0x1d1aa, 0x1d1ad}, {0x1d242, 0x1d244},
  {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb},
  {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544},
  {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734},
  {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1d7ce, 0x1d7ff}, {0x1da00, 0x1da36},
  {0x1da3b, 0x1da6c}, {0x1da75, 0x1da75}, {0x1da84, 0x1da84}, {0x1da9b, 0x1da9f}, {0x1daa1, 0x1daaf}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a}, {0x1e000, 0x1e006},
  {0x1e008, 0x1e018}, {0x1e01b, 0x1e021}, {0x1e023, 0x1e024}, {0x1e026, 0x1e02a}, {0x1e030, 0x1e06d}, {0x1e08f, 0x1e08f}, {0x1e100, 0x1e12c}, {0x1e130, 0x1e13d},
  {0x1e140, 0x1e149}, {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ae}, {0x1e2c0, 0x1e2f9}, {0x1e4d0, 0x1e4f9}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee},
  {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4}, {0x1e8d0, 0x1e8d6}, {0x1e900, 0x1e94b}, {0x1e950, 0x1e959}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22},
  {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47},
  {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b},
  {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c},
  {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x1fbf0, 0x1fbf9}, {0x20000, 0x2a6df},
  {0x2a700, 0x2b739}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2ebf0, 0x2ee5d}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0x31350, 0x323af},
  {0xe0100, 0xe01ef},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(25);
      ADVANCE_MAP(
        '!', 30,
        '"', 70,
        '#', 95,
        '$', 56,
        '%', 5,
        '&', 39,
        '\'', 69,
        '*', 48,
        '+', 31,
        ',', 96,
        '-', 32,
        '.', 90,
        '/', 49,
        '0', 61,
        ':', 54,
        '<', 42,
        '=', 27,
        '>', 44,
        '?', 28,
        '@', 57,
        '\\', 26,
        '^', 51,
        '`', 9,
        '|', 38,
        '~', 29,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(62);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(92);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        '!', 7,
        '"', 70,
        '#', 95,
        '$', 56,
        '%', 5,
        '&', 39,
        '\'', 69,
        '*', 48,
        '+', 31,
        ',', 96,
        '-', 32,
        '/', 49,
        ':', 55,
        '<', 42,
        '=', 27,
        '>', 44,
        '?', 28,
        '@', 57,
        '^', 51,
        '`', 9,
        '|', 38,
        '~', 29,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(1);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(92);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(70);
      if (lookahead == '#') ADVANCE(74);
      if (lookahead == '\\') ADVANCE(8);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(75);
      if (lookahead != 0) ADVANCE(76);
      END_STATE();
    case 3:
      if (lookahead == '#') ADVANCE(95);
      if (lookahead == '.') ADVANCE(91);
      if (lookahead == '`') ADVANCE(9);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(92);
      END_STATE();
    case 4:
      if (lookahead == '#') ADVANCE(71);
      if (lookahead == '\'') ADVANCE(69);
      if (lookahead == '\\') ADVANCE(8);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(72);
      if (lookahead != 0) ADVANCE(73);
      END_STATE();
    case 5:
      if (lookahead == '%') ADVANCE(52);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\\') ADVANCE(5);
      END_STATE();
    case 6:
      if (lookahead == '-') ADVANCE(34);
      END_STATE();
    case 7:
      if (lookahead == '=') ADVANCE(47);
      END_STATE();
    case 8:
      if (lookahead == 'U') ADVANCE(10);
      if (lookahead == 'u') ADVANCE(11);
      if (lookahead == 'x') ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(79);
      if (lookahead != 0 &&
          (lookahead < '0' || '9' < lookahead)) ADVANCE(77);
      END_STATE();
    case 9:
      if (lookahead == '\\') ADVANCE(24);
      if (lookahead == '`') ADVANCE(87);
      if (lookahead != 0) ADVANCE(9);
      END_STATE();
    case 10:
      if (lookahead == '{') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(86);
      END_STATE();
    case 11:
      if (lookahead == '{') ADVANCE(23);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(82);
      END_STATE();
    case 12:
      if (lookahead == '}') ADVANCE(77);
      END_STATE();
    case 13:
      if (lookahead == '}') ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(12);
      END_STATE();
    case 14:
      if (lookahead == '}') ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(13);
      END_STATE();
    case 15:
      if (lookahead == '}') ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(14);
      END_STATE();
    case 16:
      if (lookahead == '}') ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(15);
      END_STATE();
    case 17:
      if (lookahead == '}') ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(16);
      END_STATE();
    case 18:
      if (lookahead == '}') ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(17);
      END_STATE();
    case 19:
      if (lookahead == '}') ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(18);
      END_STATE();
    case 20:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(60);
      END_STATE();
    case 21:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(19);
      END_STATE();
    case 22:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(80);
      END_STATE();
    case 23:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(15);
      END_STATE();
    case 24:
      if (lookahead != 0) ADVANCE(9);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(46);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(47);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(36);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_LT_DASH);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_LT_LT_DASH);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      if (lookahead == '>') ADVANCE(37);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_DASH_GT_GT);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '>') ADVANCE(53);
      if (lookahead == '|') ADVANCE(40);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(41);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '-') ADVANCE(33);
      if (lookahead == '<') ADVANCE(6);
      if (lookahead == '=') ADVANCE(43);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(45);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(50);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(aux_sym_binary_operator_token1);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_PIPE_GT);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(58);
      if (lookahead == '=') ADVANCE(35);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '=') ADVANCE(35);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      if (lookahead == ':') ADVANCE(59);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_COLON_COLON_COLON);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(sym__hex_literal);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(60);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(sym__number_literal);
      if (lookahead == '.') ADVANCE(65);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(63);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(20);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(62);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym__number_literal);
      if (lookahead == '.') ADVANCE(65);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(63);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(62);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym__number_literal);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(67);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym__number_literal);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(68);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(92);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym__number_literal);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(63);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(65);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym__number_literal);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(66);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(92);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym__number_literal);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(67);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym__number_literal);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(68);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(92);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(aux_sym__single_quoted_string_content_token1);
      if (lookahead == '\n') ADVANCE(73);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(71);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(aux_sym__single_quoted_string_content_token1);
      if (lookahead == '#') ADVANCE(71);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(72);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(73);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(aux_sym__single_quoted_string_content_token1);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(73);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(aux_sym__double_quoted_string_content_token1);
      if (lookahead == '\n') ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(74);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(aux_sym__double_quoted_string_content_token1);
      if (lookahead == '#') ADVANCE(74);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(75);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          lookahead != '\\') ADVANCE(76);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(aux_sym__double_quoted_string_content_token1);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(76);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(77);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(78);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(77);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(80);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(81);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(82);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(83);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(84);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(85);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_identifier);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(93);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(94);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(92);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(93);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(92);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(88);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(66);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(92);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(89);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(92);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_identifier);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(92);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_dots);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(92);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_dot_dot_i);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(94);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(95);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_comma);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'F', 1,
        'I', 2,
        'L', 3,
        'N', 4,
        'T', 5,
        'b', 6,
        'f', 7,
        'i', 8,
        'n', 9,
        'r', 10,
        'w', 11,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'A') ADVANCE(12);
      END_STATE();
    case 2:
      if (lookahead == 'n') ADVANCE(13);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_L);
      END_STATE();
    case 4:
      if (lookahead == 'A') ADVANCE(14);
      if (lookahead == 'U') ADVANCE(15);
      if (lookahead == 'a') ADVANCE(16);
      END_STATE();
    case 5:
      if (lookahead == 'R') ADVANCE(17);
      END_STATE();
    case 6:
      if (lookahead == 'r') ADVANCE(18);
      END_STATE();
    case 7:
      if (lookahead == 'o') ADVANCE(19);
      if (lookahead == 'u') ADVANCE(20);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_i);
      if (lookahead == 'f') ADVANCE(21);
      if (lookahead == 'n') ADVANCE(22);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(23);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(24);
      END_STATE();
    case 11:
      if (lookahead == 'h') ADVANCE(25);
      END_STATE();
    case 12:
      if (lookahead == 'L') ADVANCE(26);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(27);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_NA);
      if (lookahead == '_') ADVANCE(28);
      END_STATE();
    case 15:
      if (lookahead == 'L') ADVANCE(29);
      END_STATE();
    case 16:
      if (lookahead == 'N') ADVANCE(30);
      END_STATE();
    case 17:
      if (lookahead == 'U') ADVANCE(31);
      END_STATE();
    case 18:
      if (lookahead == 'e') ADVANCE(32);
      END_STATE();
    case 19:
      if (lookahead == 'r') ADVANCE(33);
      END_STATE();
    case 20:
      if (lookahead == 'n') ADVANCE(34);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 23:
      if (lookahead == 'x') ADVANCE(35);
      END_STATE();
    case 24:
      if (lookahead == 'p') ADVANCE(36);
      if (lookahead == 't') ADVANCE(37);
      END_STATE();
    case 25:
      if (lookahead == 'i') ADVANCE(38);
      END_STATE();
    case 26:
      if (lookahead == 'S') ADVANCE(39);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(sym_inf);
      END_STATE();
    case 28:
      if (lookahead == 'c') ADVANCE(40);
      if (lookahead == 'i') ADVANCE(41);
      if (lookahead == 'r') ADVANCE(42);
      END_STATE();
    case 29:
      if (lookahead == 'L') ADVANCE(43);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(sym_nan);
      END_STATE();
    case 31:
      if (lookahead == 'E') ADVANCE(44);
      END_STATE();
    case 32:
      if (lookahead == 'a') ADVANCE(45);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 34:
      if (lookahead == 'c') ADVANCE(46);
      END_STATE();
    case 35:
      if (lookahead == 't') ADVANCE(47);
      END_STATE();
    case 36:
      if (lookahead == 'e') ADVANCE(48);
      END_STATE();
    case 37:
      if (lookahead == 'u') ADVANCE(49);
      END_STATE();
    case 38:
      if (lookahead == 'l') ADVANCE(50);
      END_STATE();
    case 39:
      if (lookahead == 'E') ADVANCE(51);
      END_STATE();
    case 40:
      if (lookahead == 'h') ADVANCE(52);
      if (lookahead == 'o') ADVANCE(53);
      END_STATE();
    case 41:
      if (lookahead == 'n') ADVANCE(54);
      END_STATE();
    case 42:
      if (lookahead == 'e') ADVANCE(55);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 45:
      if (lookahead == 'k') ADVANCE(56);
      END_STATE();
    case 46:
      if (lookahead == 't') ADVANCE(57);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(sym_next);
      END_STATE();
    case 48:
      if (lookahead == 'a') ADVANCE(58);
      END_STATE();
    case 49:
      if (lookahead == 'r') ADVANCE(59);
      END_STATE();
    case 50:
      if (lookahead == 'e') ADVANCE(60);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 52:
      if (lookahead == 'a') ADVANCE(61);
      END_STATE();
    case 53:
      if (lookahead == 'm') ADVANCE(62);
      END_STATE();
    case 54:
      if (lookahead == 't') ADVANCE(63);
      END_STATE();
    case 55:
      if (lookahead == 'a') ADVANCE(64);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(sym_break);
      END_STATE();
    case 57:
      if (lookahead == 'i') ADVANCE(65);
      END_STATE();
    case 58:
      if (lookahead == 't') ADVANCE(66);
      END_STATE();
    case 59:
      if (lookahead == 'n') ADVANCE(67);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 61:
      if (lookahead == 'r') ADVANCE(68);
      END_STATE();
    case 62:
      if (lookahead == 'p') ADVANCE(69);
      END_STATE();
    case 63:
      if (lookahead == 'e') ADVANCE(70);
      END_STATE();
    case 64:
      if (lookahead == 'l') ADVANCE(71);
      END_STATE();
    case 65:
      if (lookahead == 'o') ADVANCE(72);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_repeat);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_return);
      END_STATE();
    case 68:
      if (lookahead == 'a') ADVANCE(73);
      END_STATE();
    case 69:
      if (lookahead == 'l') ADVANCE(74);
      END_STATE();
    case 70:
      if (lookahead == 'g') ADVANCE(75);
      END_STATE();
    case 71:
      if (lookahead == '_') ADVANCE(76);
      END_STATE();
    case 72:
      if (lookahead == 'n') ADVANCE(77);
      END_STATE();
    case 73:
      if (lookahead == 'c') ADVANCE(78);
      END_STATE();
    case 74:
      if (lookahead == 'e') ADVANCE(79);
      END_STATE();
    case 75:
      if (lookahead == 'e') ADVANCE(80);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_NA_real_);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 78:
      if (lookahead == 't') ADVANCE(81);
      END_STATE();
    case 79:
      if (lookahead == 'x') ADVANCE(82);
      END_STATE();
    case 80:
      if (lookahead == 'r') ADVANCE(83);
      END_STATE();
    case 81:
      if (lookahead == 'e') ADVANCE(84);
      END_STATE();
    case 82:
      if (lookahead == '_') ADVANCE(85);
      END_STATE();
    case 83:
      if (lookahead == '_') ADVANCE(86);
      END_STATE();
    case 84:
      if (lookahead == 'r') ADVANCE(87);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_NA_complex_);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_NA_integer_);
      END_STATE();
    case 87:
      if (lookahead == '_') ADVANCE(88);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_NA_character_);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 0, .external_lex_state = 2},
  [2] = {.lex_state = 0, .external_lex_state = 3},
  [3] = {.lex_state = 0, .external_lex_state = 4},
  [4] = {.lex_state = 0, .external_lex_state = 4},
  [5] = {.lex_state = 0, .external_lex_state = 5},
  [6] = {.lex_state = 0, .external_lex_state = 5},
  [7] = {.lex_state = 0, .external_lex_state = 5},
  [8] = {.lex_state = 0, .external_lex_state = 5},
  [9] = {.lex_state = 0, .external_lex_state = 6},
  [10] = {.lex_state = 0, .external_lex_state = 6},
  [11] = {.lex_state = 0, .external_lex_state = 6},
  [12] = {.lex_state = 0, .external_lex_state = 6},
  [13] = {.lex_state = 0, .external_lex_state = 3},
  [14] = {.lex_state = 0, .external_lex_state = 3},
  [15] = {.lex_state = 0, .external_lex_state = 3},
  [16] = {.lex_state = 0, .external_lex_state = 3},
  [17] = {.lex_state = 0, .external_lex_state = 7},
  [18] = {.lex_state = 0, .external_lex_state = 4},
  [19] = {.lex_state = 0, .external_lex_state = 7},
  [20] = {.lex_state = 0, .external_lex_state = 7},
  [21] = {.lex_state = 0, .external_lex_state = 7},
  [22] = {.lex_state = 0, .external_lex_state = 4},
  [23] = {.lex_state = 0, .external_lex_state = 4},
  [24] = {.lex_state = 0, .external_lex_state = 4},
  [25] = {.lex_state = 0, .external_lex_state = 4},
  [26] = {.lex_state = 0, .external_lex_state = 5},
  [27] = {.lex_state = 0, .external_lex_state = 5},
  [28] = {.lex_state = 0, .external_lex_state = 5},
  [29] = {.lex_state = 0, .external_lex_state = 5},
  [30] = {.lex_state = 0, .external_lex_state = 6},
  [31] = {.lex_state = 0, .external_lex_state = 6},
  [32] = {.lex_state = 0, .external_lex_state = 6},
  [33] = {.lex_state = 0, .external_lex_state = 6},
  [34] = {.lex_state = 0, .external_lex_state = 4},
  [35] = {.lex_state = 0, .external_lex_state = 3},
  [36] = {.lex_state = 0, .external_lex_state = 3},
  [37] = {.lex_state = 0, .external_lex_state = 3},
  [38] = {.lex_state = 0, .external_lex_state = 7},
  [39] = {.lex_state = 0, .external_lex_state = 7},
  [40] = {.lex_state = 0, .external_lex_state = 7},
  [41] = {.lex_state = 0, .external_lex_state = 7},
  [42] = {.lex_state = 0, .external_lex_state = 7},
  [43] = {.lex_state = 0, .external_lex_state = 4},
  [44] = {.lex_state = 0, .external_lex_state = 4},
  [45] = {.lex_state = 0, .external_lex_state = 4},
  [46] = {.lex_state = 0, .external_lex_state = 4},
  [47] = {.lex_state = 0, .external_lex_state = 4},
  [48] = {.lex_state = 0, .external_lex_state = 4},
  [49] = {.lex_state = 0, .external_lex_state = 4},
  [50] = {.lex_state = 0, .external_lex_state = 4},
  [51] = {.lex_state = 0, .external_lex_state = 4},
  [52] = {.lex_state = 0, .external_lex_state = 4},
  [53] = {.lex_state = 0, .external_lex_state = 4},
  [54] = {.lex_state = 0, .external_lex_state = 4},
  [55] = {.lex_state = 0, .external_lex_state = 4},
  [56] = {.lex_state = 0, .external_lex_state = 4},
  [57] = {.lex_state = 0, .external_lex_state = 4},
  [58] = {.lex_state = 0, .external_lex_state = 4},
  [59] = {.lex_state = 0, .external_lex_state = 4},
  [60] = {.lex_state = 0, .external_lex_state = 4},
  [61] = {.lex_state = 0, .external_lex_state = 4},
  [62] = {.lex_state = 0, .external_lex_state = 4},
  [63] = {.lex_state = 0, .external_lex_state = 4},
  [64] = {.lex_state = 0, .external_lex_state = 4},
  [65] = {.lex_state = 0, .external_lex_state = 4},
  [66] = {.lex_state = 0, .external_lex_state = 4},
  [67] = {.lex_state = 0, .external_lex_state = 4},
  [68] = {.lex_state = 0, .external_lex_state = 4},
  [69] = {.lex_state = 0, .external_lex_state = 4},
  [70] = {.lex_state = 0, .external_lex_state = 4},
  [71] = {.lex_state = 0, .external_lex_state = 4},
  [72] = {.lex_state = 0, .external_lex_state = 5},
  [73] = {.lex_state = 0, .external_lex_state = 5},
  [74] = {.lex_state = 0, .external_lex_state = 5},
  [75] = {.lex_state = 0, .external_lex_state = 5},
  [76] = {.lex_state = 0, .external_lex_state = 5},
  [77] = {.lex_state = 0, .external_lex_state = 5},
  [78] = {.lex_state = 0, .external_lex_state = 5},
  [79] = {.lex_state = 0, .external_lex_state = 5},
  [80] = {.lex_state = 0, .external_lex_state = 5},
  [81] = {.lex_state = 0, .external_lex_state = 5},
  [82] = {.lex_state = 0, .external_lex_state = 5},
  [83] = {.lex_state = 0, .external_lex_state = 5},
  [84] = {.lex_state = 0, .external_lex_state = 5},
  [85] = {.lex_state = 0, .external_lex_state = 5},
  [86] = {.lex_state = 0, .external_lex_state = 5},
  [87] = {.lex_state = 0, .external_lex_state = 5},
  [88] = {.lex_state = 0, .external_lex_state = 5},
  [89] = {.lex_state = 0, .external_lex_state = 5},
  [90] = {.lex_state = 0, .external_lex_state = 5},
  [91] = {.lex_state = 0, .external_lex_state = 5},
  [92] = {.lex_state = 0, .external_lex_state = 5},
  [93] = {.lex_state = 0, .external_lex_state = 5},
  [94] = {.lex_state = 0, .external_lex_state = 5},
  [95] = {.lex_state = 0, .external_lex_state = 5},
  [96] = {.lex_state = 0, .external_lex_state = 5},
  [97] = {.lex_state = 0, .external_lex_state = 5},
  [98] = {.lex_state = 0, .external_lex_state = 5},
  [99] = {.lex_state = 0, .external_lex_state = 5},
  [100] = {.lex_state = 0, .external_lex_state = 5},
  [101] = {.lex_state = 0, .external_lex_state = 5},
  [102] = {.lex_state = 0, .external_lex_state = 5},
  [103] = {.lex_state = 0, .external_lex_state = 5},
  [104] = {.lex_state = 0, .external_lex_state = 5},
  [105] = {.lex_state = 0, .external_lex_state = 5},
  [106] = {.lex_state = 0, .external_lex_state = 5},
  [107] = {.lex_state = 0, .external_lex_state = 5},
  [108] = {.lex_state = 0, .external_lex_state = 5},
  [109] = {.lex_state = 0, .external_lex_state = 5},
  [110] = {.lex_state = 0, .external_lex_state = 5},
  [111] = {.lex_state = 0, .external_lex_state = 5},
  [112] = {.lex_state = 0, .external_lex_state = 5},
  [113] = {.lex_state = 0, .external_lex_state = 5},
  [114] = {.lex_state = 0, .external_lex_state = 5},
  [115] = {.lex_state = 0, .external_lex_state = 5},
  [116] = {.lex_state = 0, .external_lex_state = 5},
  [117] = {.lex_state = 0, .external_lex_state = 5},
  [118] = {.lex_state = 0, .external_lex_state = 5},
  [119] = {.lex_state = 0, .external_lex_state = 5},
  [120] = {.lex_state = 0, .external_lex_state = 5},
  [121] = {.lex_state = 0, .external_lex_state = 5},
  [122] = {.lex_state = 0, .external_lex_state = 6},
  [123] = {.lex_state = 0, .external_lex_state = 6},
  [124] = {.lex_state = 0, .external_lex_state = 6},
  [125] = {.lex_state = 0, .external_lex_state = 6},
  [126] = {.lex_state = 0, .external_lex_state = 6},
  [127] = {.lex_state = 0, .external_lex_state = 6},
  [128] = {.lex_state = 0, .external_lex_state = 6},
  [129] = {.lex_state = 0, .external_lex_state = 6},
  [130] = {.lex_state = 0, .external_lex_state = 6},
  [131] = {.lex_state = 0, .external_lex_state = 6},
  [132] = {.lex_state = 0, .external_lex_state = 6},
  [133] = {.lex_state = 0, .external_lex_state = 6},
  [134] = {.lex_state = 0, .external_lex_state = 6},
  [135] = {.lex_state = 0, .external_lex_state = 6},
  [136] = {.lex_state = 0, .external_lex_state = 6},
  [137] = {.lex_state = 0, .external_lex_state = 6},
  [138] = {.lex_state = 0, .external_lex_state = 6},
  [139] = {.lex_state = 0, .external_lex_state = 6},
  [140] = {.lex_state = 0, .external_lex_state = 6},
  [141] = {.lex_state = 0, .external_lex_state = 6},
  [142] = {.lex_state = 0, .external_lex_state = 6},
  [143] = {.lex_state = 0, .external_lex_state = 6},
  [144] = {.lex_state = 0, .external_lex_state = 6},
  [145] = {.lex_state = 0, .external_lex_state = 6},
  [146] = {.lex_state = 0, .external_lex_state = 6},
  [147] = {.lex_state = 0, .external_lex_state = 6},
  [148] = {.lex_state = 0, .external_lex_state = 6},
  [149] = {.lex_state = 0, .external_lex_state = 6},
  [150] = {.lex_state = 0, .external_lex_state = 6},
  [151] = {.lex_state = 0, .external_lex_state = 6},
  [152] = {.lex_state = 0, .external_lex_state = 6},
  [153] = {.lex_state = 0, .external_lex_state = 6},
  [154] = {.lex_state = 0, .external_lex_state = 6},
  [155] = {.lex_state = 0, .external_lex_state = 6},
  [156] = {.lex_state = 0, .external_lex_state = 6},
  [157] = {.lex_state = 0, .external_lex_state = 6},
  [158] = {.lex_state = 0, .external_lex_state = 6},
  [159] = {.lex_state = 0, .external_lex_state = 6},
  [160] = {.lex_state = 0, .external_lex_state = 6},
  [161] = {.lex_state = 0, .external_lex_state = 6},
  [162] = {.lex_state = 0, .external_lex_state = 6},
  [163] = {.lex_state = 0, .external_lex_state = 6},
  [164] = {.lex_state = 0, .external_lex_state = 6},
  [165] = {.lex_state = 0, .external_lex_state = 6},
  [166] = {.lex_state = 0, .external_lex_state = 6},
  [167] = {.lex_state = 0, .external_lex_state = 6},
  [168] = {.lex_state = 0, .external_lex_state = 6},
  [169] = {.lex_state = 0, .external_lex_state = 6},
  [170] = {.lex_state = 0, .external_lex_state = 6},
  [171] = {.lex_state = 0, .external_lex_state = 6},
  [172] = {.lex_state = 0, .external_lex_state = 3},
  [173] = {.lex_state = 0, .external_lex_state = 3},
  [174] = {.lex_state = 0, .external_lex_state = 3},
  [175] = {.lex_state = 0, .external_lex_state = 3},
  [176] = {.lex_state = 0, .external_lex_state = 3},
  [177] = {.lex_state = 0, .external_lex_state = 3},
  [178] = {.lex_state = 0, .external_lex_state = 4},
  [179] = {.lex_state = 0, .external_lex_state = 3},
  [180] = {.lex_state = 0, .external_lex_state = 3},
  [181] = {.lex_state = 0, .external_lex_state = 3},
  [182] = {.lex_state = 0, .external_lex_state = 3},
  [183] = {.lex_state = 0, .external_lex_state = 3},
  [184] = {.lex_state = 0, .external_lex_state = 3},
  [185] = {.lex_state = 0, .external_lex_state = 3},
  [186] = {.lex_state = 0, .external_lex_state = 3},
  [187] = {.lex_state = 0, .external_lex_state = 3},
  [188] = {.lex_state = 0, .external_lex_state = 3},
  [189] = {.lex_state = 0, .external_lex_state = 3},
  [190] = {.lex_state = 0, .external_lex_state = 3},
  [191] = {.lex_state = 0, .external_lex_state = 3},
  [192] = {.lex_state = 0, .external_lex_state = 3},
  [193] = {.lex_state = 0, .external_lex_state = 3},
  [194] = {.lex_state = 0, .external_lex_state = 3},
  [195] = {.lex_state = 0, .external_lex_state = 3},
  [196] = {.lex_state = 0, .external_lex_state = 3},
  [197] = {.lex_state = 0, .external_lex_state = 3},
  [198] = {.lex_state = 0, .external_lex_state = 3},
  [199] = {.lex_state = 0, .external_lex_state = 3},
  [200] = {.lex_state = 0, .external_lex_state = 3},
  [201] = {.lex_state = 0, .external_lex_state = 3},
  [202] = {.lex_state = 0, .external_lex_state = 3},
  [203] = {.lex_state = 0, .external_lex_state = 3},
  [204] = {.lex_state = 0, .external_lex_state = 3},
  [205] = {.lex_state = 0, .external_lex_state = 3},
  [206] = {.lex_state = 0, .external_lex_state = 3},
  [207] = {.lex_state = 0, .external_lex_state = 3},
  [208] = {.lex_state = 0, .external_lex_state = 3},
  [209] = {.lex_state = 0, .external_lex_state = 3},
  [210] = {.lex_state = 0, .external_lex_state = 3},
  [211] = {.lex_state = 0, .external_lex_state = 3},
  [212] = {.lex_state = 0, .external_lex_state = 3},
  [213] = {.lex_state = 0, .external_lex_state = 3},
  [214] = {.lex_state = 0, .external_lex_state = 3},
  [215] = {.lex_state = 0, .external_lex_state = 3},
  [216] = {.lex_state = 0, .external_lex_state = 3},
  [217] = {.lex_state = 0, .external_lex_state = 3},
  [218] = {.lex_state = 0, .external_lex_state = 3},
  [219] = {.lex_state = 0, .external_lex_state = 3},
  [220] = {.lex_state = 0, .external_lex_state = 3},
  [221] = {.lex_state = 0, .external_lex_state = 3},
  [222] = {.lex_state = 0, .external_lex_state = 7},
  [223] = {.lex_state = 0, .external_lex_state = 7},
  [224] = {.lex_state = 0, .external_lex_state = 7},
  [225] = {.lex_state = 0, .external_lex_state = 7},
  [226] = {.lex_state = 0, .external_lex_state = 7},
  [227] = {.lex_state = 0, .external_lex_state = 7},
  [228] = {.lex_state = 0, .external_lex_state = 7},
  [229] = {.lex_state = 0, .external_lex_state = 7},
  [230] = {.lex_state = 0, .external_lex_state = 7},
  [231] = {.lex_state = 0, .external_lex_state = 7},
  [232] = {.lex_state = 0, .external_lex_state = 7},
  [233] = {.lex_state = 0, .external_lex_state = 7},
  [234] = {.lex_state = 0, .external_lex_state = 7},
  [235] = {.lex_state = 0, .external_lex_state = 7},
  [236] = {.lex_state = 0, .external_lex_state = 7},
  [237] = {.lex_state = 0, .external_lex_state = 7},
  [238] = {.lex_state = 0, .external_lex_state = 7},
  [239] = {.lex_state = 0, .external_lex_state = 7},
  [240] = {.lex_state = 0, .external_lex_state = 7},
  [241] = {.lex_state = 0, .external_lex_state = 7},
  [242] = {.lex_state = 0, .external_lex_state = 7},
  [243] = {.lex_state = 0, .external_lex_state = 7},
  [244] = {.lex_state = 0, .external_lex_state = 7},
  [245] = {.lex_state = 0, .external_lex_state = 7},
  [246] = {.lex_state = 0, .external_lex_state = 7},
  [247] = {.lex_state = 0, .external_lex_state = 7},
  [248] = {.lex_state = 0, .external_lex_state = 7},
  [249] = {.lex_state = 0, .external_lex_state = 7},
  [250] = {.lex_state = 0, .external_lex_state = 7},
  [251] = {.lex_state = 0, .external_lex_state = 7},
  [252] = {.lex_state = 0, .external_lex_state = 7},
  [253] = {.lex_state = 0, .external_lex_state = 7},
  [254] = {.lex_state = 0, .external_lex_state = 7},
  [255] = {.lex_state = 0, .external_lex_state = 7},
  [256] = {.lex_state = 0, .external_lex_state = 7},
  [257] = {.lex_state = 0, .external_lex_state = 7},
  [258] = {.lex_state = 0, .external_lex_state = 7},
  [259] = {.lex_state = 0, .external_lex_state = 7},
  [260] = {.lex_state = 0, .external_lex_state = 7},
  [261] = {.lex_state = 0, .external_lex_state = 7},
  [262] = {.lex_state = 0, .external_lex_state = 7},
  [263] = {.lex_state = 0, .external_lex_state = 7},
  [264] = {.lex_state = 0, .external_lex_state = 7},
  [265] = {.lex_state = 0, .external_lex_state = 7},
  [266] = {.lex_state = 0, .external_lex_state = 7},
  [267] = {.lex_state = 0, .external_lex_state = 4},
  [268] = {.lex_state = 0, .external_lex_state = 7},
  [269] = {.lex_state = 0, .external_lex_state = 7},
  [270] = {.lex_state = 0, .external_lex_state = 7},
  [271] = {.lex_state = 0, .external_lex_state = 7},
  [272] = {.lex_state = 0, .external_lex_state = 4},
  [273] = {.lex_state = 0, .external_lex_state = 4},
  [274] = {.lex_state = 0, .external_lex_state = 4},
  [275] = {.lex_state = 0, .external_lex_state = 4},
  [276] = {.lex_state = 0, .external_lex_state = 4},
  [277] = {.lex_state = 0, .external_lex_state = 4},
  [278] = {.lex_state = 0, .external_lex_state = 4},
  [279] = {.lex_state = 0, .external_lex_state = 4},
  [280] = {.lex_state = 0, .external_lex_state = 4},
  [281] = {.lex_state = 0, .external_lex_state = 4},
  [282] = {.lex_state = 0, .external_lex_state = 4},
  [283] = {.lex_state = 0, .external_lex_state = 4},
  [284] = {.lex_state = 0, .external_lex_state = 4},
  [285] = {.lex_state = 0, .external_lex_state = 4},
  [286] = {.lex_state = 0, .external_lex_state = 4},
  [287] = {.lex_state = 0, .external_lex_state = 4},
  [288] = {.lex_state = 0, .external_lex_state = 4},
  [289] = {.lex_state = 0, .external_lex_state = 4},
  [290] = {.lex_state = 0, .external_lex_state = 4},
  [291] = {.lex_state = 0, .external_lex_state = 3},
  [292] = {.lex_state = 0, .external_lex_state = 8},
  [293] = {.lex_state = 0, .external_lex_state = 9},
  [294] = {.lex_state = 0, .external_lex_state = 9},
  [295] = {.lex_state = 0, .external_lex_state = 9},
  [296] = {.lex_state = 0, .external_lex_state = 10},
  [297] = {.lex_state = 0, .external_lex_state = 11},
  [298] = {.lex_state = 0, .external_lex_state = 12},
  [299] = {.lex_state = 0, .external_lex_state = 12},
  [300] = {.lex_state = 0, .external_lex_state = 12},
  [301] = {.lex_state = 0, .external_lex_state = 12},
  [302] = {.lex_state = 0, .external_lex_state = 12},
  [303] = {.lex_state = 0, .external_lex_state = 12},
  [304] = {.lex_state = 0, .external_lex_state = 12},
  [305] = {.lex_state = 0, .external_lex_state = 12},
  [306] = {.lex_state = 0, .external_lex_state = 12},
  [307] = {.lex_state = 0, .external_lex_state = 12},
  [308] = {.lex_state = 0, .external_lex_state = 12},
  [309] = {.lex_state = 0, .external_lex_state = 12},
  [310] = {.lex_state = 0, .external_lex_state = 12},
  [311] = {.lex_state = 0, .external_lex_state = 12},
  [312] = {.lex_state = 0, .external_lex_state = 12},
  [313] = {.lex_state = 0, .external_lex_state = 12},
  [314] = {.lex_state = 0, .external_lex_state = 12},
  [315] = {.lex_state = 0, .external_lex_state = 12},
  [316] = {.lex_state = 0, .external_lex_state = 12},
  [317] = {.lex_state = 0, .external_lex_state = 12},
  [318] = {.lex_state = 0, .external_lex_state = 12},
  [319] = {.lex_state = 0, .external_lex_state = 12},
  [320] = {.lex_state = 0, .external_lex_state = 12},
  [321] = {.lex_state = 0, .external_lex_state = 12},
  [322] = {.lex_state = 0, .external_lex_state = 10},
  [323] = {.lex_state = 0, .external_lex_state = 11},
  [324] = {.lex_state = 0, .external_lex_state = 12},
  [325] = {.lex_state = 0, .external_lex_state = 12},
  [326] = {.lex_state = 0, .external_lex_state = 12},
  [327] = {.lex_state = 0, .external_lex_state = 12},
  [328] = {.lex_state = 0, .external_lex_state = 12},
  [329] = {.lex_state = 0, .external_lex_state = 12},
  [330] = {.lex_state = 0, .external_lex_state = 12},
  [331] = {.lex_state = 0, .external_lex_state = 12},
  [332] = {.lex_state = 0, .external_lex_state = 12},
  [333] = {.lex_state = 0, .external_lex_state = 12},
  [334] = {.lex_state = 0, .external_lex_state = 12},
  [335] = {.lex_state = 0, .external_lex_state = 12},
  [336] = {.lex_state = 0, .external_lex_state = 12},
  [337] = {.lex_state = 0, .external_lex_state = 12},
  [338] = {.lex_state = 0, .external_lex_state = 12},
  [339] = {.lex_state = 0, .external_lex_state = 12},
  [340] = {.lex_state = 0, .external_lex_state = 12},
  [341] = {.lex_state = 0, .external_lex_state = 12},
  [342] = {.lex_state = 0, .external_lex_state = 12},
  [343] = {.lex_state = 0, .external_lex_state = 12},
  [344] = {.lex_state = 0, .external_lex_state = 12},
  [345] = {.lex_state = 0, .external_lex_state = 12},
  [346] = {.lex_state = 0, .external_lex_state = 12},
  [347] = {.lex_state = 0, .external_lex_state = 12},
  [348] = {.lex_state = 0, .external_lex_state = 12},
  [349] = {.lex_state = 0, .external_lex_state = 12},
  [350] = {.lex_state = 0, .external_lex_state = 13},
  [351] = {.lex_state = 0, .external_lex_state = 13},
  [352] = {.lex_state = 0, .external_lex_state = 13},
  [353] = {.lex_state = 0, .external_lex_state = 13},
  [354] = {.lex_state = 0, .external_lex_state = 13},
  [355] = {.lex_state = 0, .external_lex_state = 13},
  [356] = {.lex_state = 0, .external_lex_state = 13},
  [357] = {.lex_state = 0, .external_lex_state = 13},
  [358] = {.lex_state = 0, .external_lex_state = 13},
  [359] = {.lex_state = 0, .external_lex_state = 13},
  [360] = {.lex_state = 0, .external_lex_state = 13},
  [361] = {.lex_state = 0, .external_lex_state = 13},
  [362] = {.lex_state = 0, .external_lex_state = 13},
  [363] = {.lex_state = 0, .external_lex_state = 13},
  [364] = {.lex_state = 0, .external_lex_state = 13},
  [365] = {.lex_state = 0, .external_lex_state = 13},
  [366] = {.lex_state = 0, .external_lex_state = 13},
  [367] = {.lex_state = 0, .external_lex_state = 13},
  [368] = {.lex_state = 0, .external_lex_state = 13},
  [369] = {.lex_state = 0, .external_lex_state = 13},
  [370] = {.lex_state = 0, .external_lex_state = 13},
  [371] = {.lex_state = 0, .external_lex_state = 13},
  [372] = {.lex_state = 0, .external_lex_state = 13},
  [373] = {.lex_state = 0, .external_lex_state = 13},
  [374] = {.lex_state = 0, .external_lex_state = 10},
  [375] = {.lex_state = 0, .external_lex_state = 11},
  [376] = {.lex_state = 0, .external_lex_state = 13},
  [377] = {.lex_state = 0, .external_lex_state = 13},
  [378] = {.lex_state = 0, .external_lex_state = 13},
  [379] = {.lex_state = 0, .external_lex_state = 13},
  [380] = {.lex_state = 0, .external_lex_state = 13},
  [381] = {.lex_state = 0, .external_lex_state = 13},
  [382] = {.lex_state = 0, .external_lex_state = 13},
  [383] = {.lex_state = 0, .external_lex_state = 13},
  [384] = {.lex_state = 0, .external_lex_state = 13},
  [385] = {.lex_state = 0, .external_lex_state = 13},
  [386] = {.lex_state = 0, .external_lex_state = 13},
  [387] = {.lex_state = 0, .external_lex_state = 13},
  [388] = {.lex_state = 0, .external_lex_state = 13},
  [389] = {.lex_state = 0, .external_lex_state = 13},
  [390] = {.lex_state = 0, .external_lex_state = 13},
  [391] = {.lex_state = 0, .external_lex_state = 13},
  [392] = {.lex_state = 0, .external_lex_state = 13},
  [393] = {.lex_state = 0, .external_lex_state = 13},
  [394] = {.lex_state = 0, .external_lex_state = 13},
  [395] = {.lex_state = 0, .external_lex_state = 13},
  [396] = {.lex_state = 0, .external_lex_state = 13},
  [397] = {.lex_state = 0, .external_lex_state = 13},
  [398] = {.lex_state = 0, .external_lex_state = 13},
  [399] = {.lex_state = 0, .external_lex_state = 13},
  [400] = {.lex_state = 0, .external_lex_state = 13},
  [401] = {.lex_state = 0, .external_lex_state = 13},
  [402] = {.lex_state = 0, .external_lex_state = 14},
  [403] = {.lex_state = 0, .external_lex_state = 10},
  [404] = {.lex_state = 0, .external_lex_state = 11},
  [405] = {.lex_state = 0, .external_lex_state = 4},
  [406] = {.lex_state = 0, .external_lex_state = 9},
  [407] = {.lex_state = 0, .external_lex_state = 8},
  [408] = {.lex_state = 0, .external_lex_state = 8},
  [409] = {.lex_state = 0, .external_lex_state = 8},
  [410] = {.lex_state = 0, .external_lex_state = 8},
  [411] = {.lex_state = 0, .external_lex_state = 8},
  [412] = {.lex_state = 0, .external_lex_state = 8},
  [413] = {.lex_state = 0, .external_lex_state = 8},
  [414] = {.lex_state = 0, .external_lex_state = 8},
  [415] = {.lex_state = 0, .external_lex_state = 8},
  [416] = {.lex_state = 0, .external_lex_state = 8},
  [417] = {.lex_state = 0, .external_lex_state = 8},
  [418] = {.lex_state = 0, .external_lex_state = 4},
  [419] = {.lex_state = 0, .external_lex_state = 10},
  [420] = {.lex_state = 0, .external_lex_state = 11},
  [421] = {.lex_state = 0, .external_lex_state = 8},
  [422] = {.lex_state = 0, .external_lex_state = 8},
  [423] = {.lex_state = 0, .external_lex_state = 8},
  [424] = {.lex_state = 0, .external_lex_state = 8},
  [425] = {.lex_state = 0, .external_lex_state = 8},
  [426] = {.lex_state = 0, .external_lex_state = 8},
  [427] = {.lex_state = 0, .external_lex_state = 8},
  [428] = {.lex_state = 0, .external_lex_state = 8},
  [429] = {.lex_state = 0, .external_lex_state = 15},
  [430] = {.lex_state = 0, .external_lex_state = 14},
  [431] = {.lex_state = 0, .external_lex_state = 10},
  [432] = {.lex_state = 0, .external_lex_state = 11},
  [433] = {.lex_state = 0, .external_lex_state = 8},
  [434] = {.lex_state = 0, .external_lex_state = 8},
  [435] = {.lex_state = 0, .external_lex_state = 8},
  [436] = {.lex_state = 0, .external_lex_state = 8},
  [437] = {.lex_state = 0, .external_lex_state = 8},
  [438] = {.lex_state = 0, .external_lex_state = 8},
  [439] = {.lex_state = 0, .external_lex_state = 8},
  [440] = {.lex_state = 0, .external_lex_state = 5},
  [441] = {.lex_state = 0, .external_lex_state = 8},
  [442] = {.lex_state = 0, .external_lex_state = 8},
  [443] = {.lex_state = 0, .external_lex_state = 8},
  [444] = {.lex_state = 0, .external_lex_state = 8},
  [445] = {.lex_state = 0, .external_lex_state = 8},
  [446] = {.lex_state = 0, .external_lex_state = 8},
  [447] = {.lex_state = 0, .external_lex_state = 8},
  [448] = {.lex_state = 0, .external_lex_state = 8},
  [449] = {.lex_state = 0, .external_lex_state = 8},
  [450] = {.lex_state = 0, .external_lex_state = 8},
  [451] = {.lex_state = 0, .external_lex_state = 5},
  [452] = {.lex_state = 0, .external_lex_state = 10},
  [453] = {.lex_state = 0, .external_lex_state = 11},
  [454] = {.lex_state = 0, .external_lex_state = 8},
  [455] = {.lex_state = 0, .external_lex_state = 8},
  [456] = {.lex_state = 0, .external_lex_state = 8},
  [457] = {.lex_state = 0, .external_lex_state = 8},
  [458] = {.lex_state = 0, .external_lex_state = 8},
  [459] = {.lex_state = 0, .external_lex_state = 8},
  [460] = {.lex_state = 0, .external_lex_state = 8},
  [461] = {.lex_state = 0, .external_lex_state = 8},
  [462] = {.lex_state = 0, .external_lex_state = 8},
  [463] = {.lex_state = 0, .external_lex_state = 15},
  [464] = {.lex_state = 0, .external_lex_state = 15},
  [465] = {.lex_state = 0, .external_lex_state = 15},
  [466] = {.lex_state = 0, .external_lex_state = 15},
  [467] = {.lex_state = 0, .external_lex_state = 15},
  [468] = {.lex_state = 0, .external_lex_state = 6},
  [469] = {.lex_state = 0, .external_lex_state = 15},
  [470] = {.lex_state = 0, .external_lex_state = 15},
  [471] = {.lex_state = 0, .external_lex_state = 15},
  [472] = {.lex_state = 0, .external_lex_state = 15},
  [473] = {.lex_state = 0, .external_lex_state = 15},
  [474] = {.lex_state = 0, .external_lex_state = 15},
  [475] = {.lex_state = 0, .external_lex_state = 15},
  [476] = {.lex_state = 0, .external_lex_state = 15},
  [477] = {.lex_state = 0, .external_lex_state = 15},
  [478] = {.lex_state = 0, .external_lex_state = 15},
  [479] = {.lex_state = 0, .external_lex_state = 15},
  [480] = {.lex_state = 0, .external_lex_state = 15},
  [481] = {.lex_state = 0, .external_lex_state = 15},
  [482] = {.lex_state = 0, .external_lex_state = 6},
  [483] = {.lex_state = 0, .external_lex_state = 10},
  [484] = {.lex_state = 0, .external_lex_state = 11},
  [485] = {.lex_state = 0, .external_lex_state = 15},
  [486] = {.lex_state = 0, .external_lex_state = 15},
  [487] = {.lex_state = 0, .external_lex_state = 15},
  [488] = {.lex_state = 0, .external_lex_state = 15},
  [489] = {.lex_state = 0, .external_lex_state = 15},
  [490] = {.lex_state = 0, .external_lex_state = 15},
  [491] = {.lex_state = 0, .external_lex_state = 12},
  [492] = {.lex_state = 0, .external_lex_state = 14},
  [493] = {.lex_state = 0, .external_lex_state = 10},
  [494] = {.lex_state = 0, .external_lex_state = 11},
  [495] = {.lex_state = 0, .external_lex_state = 15},
  [496] = {.lex_state = 0, .external_lex_state = 15},
  [497] = {.lex_state = 0, .external_lex_state = 15},
  [498] = {.lex_state = 0, .external_lex_state = 15},
  [499] = {.lex_state = 0, .external_lex_state = 15},
  [500] = {.lex_state = 0, .external_lex_state = 15},
  [501] = {.lex_state = 0, .external_lex_state = 10},
  [502] = {.lex_state = 0, .external_lex_state = 11},
  [503] = {.lex_state = 0, .external_lex_state = 15},
  [504] = {.lex_state = 0, .external_lex_state = 15},
  [505] = {.lex_state = 0, .external_lex_state = 15},
  [506] = {.lex_state = 0, .external_lex_state = 15},
  [507] = {.lex_state = 0, .external_lex_state = 15},
  [508] = {.lex_state = 0, .external_lex_state = 3},
  [509] = {.lex_state = 0, .external_lex_state = 15},
  [510] = {.lex_state = 0, .external_lex_state = 15},
  [511] = {.lex_state = 0, .external_lex_state = 15},
  [512] = {.lex_state = 0, .external_lex_state = 15},
  [513] = {.lex_state = 0, .external_lex_state = 15},
  [514] = {.lex_state = 0, .external_lex_state = 15},
  [515] = {.lex_state = 0, .external_lex_state = 15},
  [516] = {.lex_state = 0, .external_lex_state = 8},
  [517] = {.lex_state = 0, .external_lex_state = 15},
  [518] = {.lex_state = 0, .external_lex_state = 15},
  [519] = {.lex_state = 0, .external_lex_state = 3},
  [520] = {.lex_state = 0, .external_lex_state = 10},
  [521] = {.lex_state = 0, .external_lex_state = 11},
  [522] = {.lex_state = 0, .external_lex_state = 15},
  [523] = {.lex_state = 0, .external_lex_state = 15},
  [524] = {.lex_state = 0, .external_lex_state = 15},
  [525] = {.lex_state = 0, .external_lex_state = 15},
  [526] = {.lex_state = 0, .external_lex_state = 15},
  [527] = {.lex_state = 0, .external_lex_state = 15},
  [528] = {.lex_state = 0, .external_lex_state = 9},
  [529] = {.lex_state = 0, .external_lex_state = 9},
  [530] = {.lex_state = 0, .external_lex_state = 9},
  [531] = {.lex_state = 0, .external_lex_state = 9},
  [532] = {.lex_state = 0, .external_lex_state = 9},
  [533] = {.lex_state = 0, .external_lex_state = 9},
  [534] = {.lex_state = 0, .external_lex_state = 7},
  [535] = {.lex_state = 0, .external_lex_state = 9},
  [536] = {.lex_state = 0, .external_lex_state = 9},
  [537] = {.lex_state = 0, .external_lex_state = 9},
  [538] = {.lex_state = 0, .external_lex_state = 9},
  [539] = {.lex_state = 0, .external_lex_state = 9},
  [540] = {.lex_state = 0, .external_lex_state = 9},
  [541] = {.lex_state = 0, .external_lex_state = 9},
  [542] = {.lex_state = 0, .external_lex_state = 9},
  [543] = {.lex_state = 0, .external_lex_state = 9},
  [544] = {.lex_state = 0, .external_lex_state = 9},
  [545] = {.lex_state = 0, .external_lex_state = 9},
  [546] = {.lex_state = 0, .external_lex_state = 9},
  [547] = {.lex_state = 0, .external_lex_state = 9},
  [548] = {.lex_state = 0, .external_lex_state = 9},
  [549] = {.lex_state = 0, .external_lex_state = 9},
  [550] = {.lex_state = 0, .external_lex_state = 9},
  [551] = {.lex_state = 0, .external_lex_state = 9},
  [552] = {.lex_state = 0, .external_lex_state = 7},
  [553] = {.lex_state = 0, .external_lex_state = 10},
  [554] = {.lex_state = 0, .external_lex_state = 11},
  [555] = {.lex_state = 0, .external_lex_state = 9},
  [556] = {.lex_state = 0, .external_lex_state = 13},
  [557] = {.lex_state = 0, .external_lex_state = 10},
  [558] = {.lex_state = 0, .external_lex_state = 11},
  [559] = {.lex_state = 0, .external_lex_state = 9},
  [560] = {.lex_state = 0, .external_lex_state = 9},
  [561] = {.lex_state = 0, .external_lex_state = 9},
  [562] = {.lex_state = 0, .external_lex_state = 9},
  [563] = {.lex_state = 0, .external_lex_state = 9},
  [564] = {.lex_state = 0, .external_lex_state = 9},
  [565] = {.lex_state = 0, .external_lex_state = 9},
  [566] = {.lex_state = 0, .external_lex_state = 9},
  [567] = {.lex_state = 0, .external_lex_state = 9},
  [568] = {.lex_state = 0, .external_lex_state = 9},
  [569] = {.lex_state = 0, .external_lex_state = 9},
  [570] = {.lex_state = 0, .external_lex_state = 9},
  [571] = {.lex_state = 0, .external_lex_state = 14},
  [572] = {.lex_state = 0, .external_lex_state = 10},
  [573] = {.lex_state = 0, .external_lex_state = 11},
  [574] = {.lex_state = 0, .external_lex_state = 9},
  [575] = {.lex_state = 0, .external_lex_state = 9},
  [576] = {.lex_state = 0, .external_lex_state = 14},
  [577] = {.lex_state = 0, .external_lex_state = 8},
  [578] = {.lex_state = 0, .external_lex_state = 9},
  [579] = {.lex_state = 0, .external_lex_state = 8},
  [580] = {.lex_state = 0, .external_lex_state = 8},
  [581] = {.lex_state = 0, .external_lex_state = 9},
  [582] = {.lex_state = 0, .external_lex_state = 9},
  [583] = {.lex_state = 0, .external_lex_state = 9},
  [584] = {.lex_state = 0, .external_lex_state = 8},
  [585] = {.lex_state = 0, .external_lex_state = 9},
  [586] = {.lex_state = 0, .external_lex_state = 9},
  [587] = {.lex_state = 0, .external_lex_state = 9},
  [588] = {.lex_state = 0, .external_lex_state = 9},
  [589] = {.lex_state = 0, .external_lex_state = 14},
  [590] = {.lex_state = 0, .external_lex_state = 10},
  [591] = {.lex_state = 0, .external_lex_state = 11},
  [592] = {.lex_state = 0, .external_lex_state = 14},
  [593] = {.lex_state = 0, .external_lex_state = 14},
  [594] = {.lex_state = 0, .external_lex_state = 10},
  [595] = {.lex_state = 0, .external_lex_state = 11},
  [596] = {.lex_state = 0, .external_lex_state = 14},
  [597] = {.lex_state = 0, .external_lex_state = 14},
  [598] = {.lex_state = 0, .external_lex_state = 10},
  [599] = {.lex_state = 0, .external_lex_state = 11},
  [600] = {.lex_state = 0, .external_lex_state = 14},
  [601] = {.lex_state = 0, .external_lex_state = 14},
  [602] = {.lex_state = 0, .external_lex_state = 10},
  [603] = {.lex_state = 0, .external_lex_state = 11},
  [604] = {.lex_state = 0, .external_lex_state = 14},
  [605] = {.lex_state = 0, .external_lex_state = 14},
  [606] = {.lex_state = 0, .external_lex_state = 10},
  [607] = {.lex_state = 0, .external_lex_state = 11},
  [608] = {.lex_state = 0, .external_lex_state = 14},
  [609] = {.lex_state = 0, .external_lex_state = 14},
  [610] = {.lex_state = 0, .external_lex_state = 10},
  [611] = {.lex_state = 0, .external_lex_state = 11},
  [612] = {.lex_state = 0, .external_lex_state = 14},
  [613] = {.lex_state = 0, .external_lex_state = 14},
  [614] = {.lex_state = 0, .external_lex_state = 10},
  [615] = {.lex_state = 0, .external_lex_state = 11},
  [616] = {.lex_state = 0, .external_lex_state = 14},
  [617] = {.lex_state = 0, .external_lex_state = 14},
  [618] = {.lex_state = 0, .external_lex_state = 10},
  [619] = {.lex_state = 0, .external_lex_state = 11},
  [620] = {.lex_state = 0, .external_lex_state = 14},
  [621] = {.lex_state = 0, .external_lex_state = 14},
  [622] = {.lex_state = 0, .external_lex_state = 10},
  [623] = {.lex_state = 0, .external_lex_state = 11},
  [624] = {.lex_state = 0, .external_lex_state = 14},
  [625] = {.lex_state = 0, .external_lex_state = 14},
  [626] = {.lex_state = 0, .external_lex_state = 10},
  [627] = {.lex_state = 0, .external_lex_state = 11},
  [628] = {.lex_state = 0, .external_lex_state = 9},
  [629] = {.lex_state = 0, .external_lex_state = 12},
  [630] = {.lex_state = 0, .external_lex_state = 15},
  [631] = {.lex_state = 0, .external_lex_state = 15},
  [632] = {.lex_state = 0, .external_lex_state = 6},
  [633] = {.lex_state = 0, .external_lex_state = 4},
  [634] = {.lex_state = 0, .external_lex_state = 15},
  [635] = {.lex_state = 0, .external_lex_state = 13},
  [636] = {.lex_state = 0, .external_lex_state = 3},
  [637] = {.lex_state = 0, .external_lex_state = 10},
  [638] = {.lex_state = 0, .external_lex_state = 9},
  [639] = {.lex_state = 0, .external_lex_state = 11},
  [640] = {.lex_state = 0, .external_lex_state = 7},
  [641] = {.lex_state = 0, .external_lex_state = 8},
  [642] = {.lex_state = 0, .external_lex_state = 9},
  [643] = {.lex_state = 0, .external_lex_state = 13},
  [644] = {.lex_state = 0, .external_lex_state = 8},
  [645] = {.lex_state = 0, .external_lex_state = 5},
  [646] = {.lex_state = 0, .external_lex_state = 12},
  [647] = {.lex_state = 0, .external_lex_state = 14},
  [648] = {.lex_state = 0, .external_lex_state = 15},
  [649] = {.lex_state = 0, .external_lex_state = 8},
  [650] = {.lex_state = 0, .external_lex_state = 13},
  [651] = {.lex_state = 0, .external_lex_state = 9},
  [652] = {.lex_state = 0, .external_lex_state = 12},
  [653] = {.lex_state = 0, .external_lex_state = 5},
  [654] = {.lex_state = 0, .external_lex_state = 3},
  [655] = {.lex_state = 0, .external_lex_state = 3},
  [656] = {.lex_state = 0, .external_lex_state = 3},
  [657] = {.lex_state = 0, .external_lex_state = 3},
  [658] = {.lex_state = 0, .external_lex_state = 3},
  [659] = {.lex_state = 0, .external_lex_state = 3},
  [660] = {.lex_state = 0, .external_lex_state = 4},
  [661] = {.lex_state = 0, .external_lex_state = 6},
  [662] = {.lex_state = 0, .external_lex_state = 4},
  [663] = {.lex_state = 0, .external_lex_state = 3},
  [664] = {.lex_state = 0, .external_lex_state = 3},
  [665] = {.lex_state = 0, .external_lex_state = 6},
  [666] = {.lex_state = 0, .external_lex_state = 6},
  [667] = {.lex_state = 0, .external_lex_state = 4},
  [668] = {.lex_state = 0, .external_lex_state = 4},
  [669] = {.lex_state = 0, .external_lex_state = 7},
  [670] = {.lex_state = 0, .external_lex_state = 7},
  [671] = {.lex_state = 0, .external_lex_state = 7},
  [672] = {.lex_state = 0, .external_lex_state = 7},
  [673] = {.lex_state = 0, .external_lex_state = 6},
  [674] = {.lex_state = 0, .external_lex_state = 7},
  [675] = {.lex_state = 0, .external_lex_state = 7},
  [676] = {.lex_state = 0, .external_lex_state = 4},
  [677] = {.lex_state = 0, .external_lex_state = 7},
  [678] = {.lex_state = 0, .external_lex_state = 7},
  [679] = {.lex_state = 0, .external_lex_state = 4},
  [680] = {.lex_state = 0, .external_lex_state = 4},
  [681] = {.lex_state = 0, .external_lex_state = 5},
  [682] = {.lex_state = 0, .external_lex_state = 5},
  [683] = {.lex_state = 0, .external_lex_state = 5},
  [684] = {.lex_state = 0, .external_lex_state = 5},
  [685] = {.lex_state = 0, .external_lex_state = 5},
  [686] = {.lex_state = 0, .external_lex_state = 6},
  [687] = {.lex_state = 0, .external_lex_state = 5},
  [688] = {.lex_state = 0, .external_lex_state = 6},
  [689] = {.lex_state = 0, .external_lex_state = 4},
  [690] = {.lex_state = 0, .external_lex_state = 4},
  [691] = {.lex_state = 0, .external_lex_state = 5},
  [692] = {.lex_state = 0, .external_lex_state = 5},
  [693] = {.lex_state = 0, .external_lex_state = 6},
  [694] = {.lex_state = 0, .external_lex_state = 6},
  [695] = {.lex_state = 0, .external_lex_state = 6},
  [696] = {.lex_state = 0, .external_lex_state = 3},
  [697] = {.lex_state = 0, .external_lex_state = 7},
  [698] = {.lex_state = 0, .external_lex_state = 9},
  [699] = {.lex_state = 0, .external_lex_state = 9},
  [700] = {.lex_state = 0, .external_lex_state = 13},
  [701] = {.lex_state = 0, .external_lex_state = 15},
  [702] = {.lex_state = 0, .external_lex_state = 5},
  [703] = {.lex_state = 0, .external_lex_state = 15},
  [704] = {.lex_state = 0, .external_lex_state = 13},
  [705] = {.lex_state = 0, .external_lex_state = 15},
  [706] = {.lex_state = 0, .external_lex_state = 8},
  [707] = {.lex_state = 0, .external_lex_state = 15},
  [708] = {.lex_state = 0, .external_lex_state = 15},
  [709] = {.lex_state = 0, .external_lex_state = 8},
  [710] = {.lex_state = 0, .external_lex_state = 13},
  [711] = {.lex_state = 0, .external_lex_state = 12},
  [712] = {.lex_state = 0, .external_lex_state = 12},
  [713] = {.lex_state = 0, .external_lex_state = 12},
  [714] = {.lex_state = 0, .external_lex_state = 12},
  [715] = {.lex_state = 0, .external_lex_state = 9},
  [716] = {.lex_state = 0, .external_lex_state = 13},
  [717] = {.lex_state = 0, .external_lex_state = 13},
  [718] = {.lex_state = 0, .external_lex_state = 9},
  [719] = {.lex_state = 0, .external_lex_state = 12},
  [720] = {.lex_state = 0, .external_lex_state = 4},
  [721] = {.lex_state = 0, .external_lex_state = 15},
  [722] = {.lex_state = 0, .external_lex_state = 15},
  [723] = {.lex_state = 0, .external_lex_state = 6},
  [724] = {.lex_state = 0, .external_lex_state = 13},
  [725] = {.lex_state = 0, .external_lex_state = 13},
  [726] = {.lex_state = 0, .external_lex_state = 13},
  [727] = {.lex_state = 0, .external_lex_state = 15},
  [728] = {.lex_state = 0, .external_lex_state = 12},
  [729] = {.lex_state = 0, .external_lex_state = 8},
  [730] = {.lex_state = 0, .external_lex_state = 8},
  [731] = {.lex_state = 0, .external_lex_state = 3},
  [732] = {.lex_state = 0, .external_lex_state = 7},
  [733] = {.lex_state = 0, .external_lex_state = 8},
  [734] = {.lex_state = 0, .external_lex_state = 12},
  [735] = {.lex_state = 0, .external_lex_state = 12},
  [736] = {.lex_state = 0, .external_lex_state = 12},
  [737] = {.lex_state = 0, .external_lex_state = 13},
  [738] = {.lex_state = 0, .external_lex_state = 8},
  [739] = {.lex_state = 0, .external_lex_state = 15},
  [740] = {.lex_state = 0, .external_lex_state = 9},
  [741] = {.lex_state = 0, .external_lex_state = 9},
  [742] = {.lex_state = 0, .external_lex_state = 15},
  [743] = {.lex_state = 0, .external_lex_state = 9},
  [744] = {.lex_state = 0, .external_lex_state = 8},
  [745] = {.lex_state = 0, .external_lex_state = 8},
  [746] = {.lex_state = 0, .external_lex_state = 9},
  [747] = {.lex_state = 0, .external_lex_state = 8},
  [748] = {.lex_state = 0, .external_lex_state = 13},
  [749] = {.lex_state = 0, .external_lex_state = 9},
  [750] = {.lex_state = 0, .external_lex_state = 12},
  [751] = {.lex_state = 0, .external_lex_state = 16},
  [752] = {.lex_state = 0, .external_lex_state = 3},
  [753] = {.lex_state = 0, .external_lex_state = 3},
  [754] = {.lex_state = 0, .external_lex_state = 3},
  [755] = {.lex_state = 0, .external_lex_state = 3},
  [756] = {.lex_state = 0, .external_lex_state = 3},
  [757] = {.lex_state = 0, .external_lex_state = 16},
  [758] = {.lex_state = 0, .external_lex_state = 16},
  [759] = {.lex_state = 0, .external_lex_state = 5},
  [760] = {.lex_state = 0, .external_lex_state = 16},
  [761] = {.lex_state = 0, .external_lex_state = 16},
  [762] = {.lex_state = 0, .external_lex_state = 3},
  [763] = {.lex_state = 0, .external_lex_state = 3},
  [764] = {.lex_state = 0, .external_lex_state = 3},
  [765] = {.lex_state = 0, .external_lex_state = 9},
  [766] = {.lex_state = 0, .external_lex_state = 3},
  [767] = {.lex_state = 0, .external_lex_state = 3},
  [768] = {.lex_state = 0, .external_lex_state = 3},
  [769] = {.lex_state = 0, .external_lex_state = 3},
  [770] = {.lex_state = 0, .external_lex_state = 4},
  [771] = {.lex_state = 0, .external_lex_state = 4},
  [772] = {.lex_state = 0, .external_lex_state = 4},
  [773] = {.lex_state = 0, .external_lex_state = 4},
  [774] = {.lex_state = 0, .external_lex_state = 6},
  [775] = {.lex_state = 0, .external_lex_state = 6},
  [776] = {.lex_state = 0, .external_lex_state = 6},
  [777] = {.lex_state = 0, .external_lex_state = 6},
  [778] = {.lex_state = 0, .external_lex_state = 4},
  [779] = {.lex_state = 0, .external_lex_state = 6},
  [780] = {.lex_state = 0, .external_lex_state = 3},
  [781] = {.lex_state = 0, .external_lex_state = 3},
  [782] = {.lex_state = 0, .external_lex_state = 3},
  [783] = {.lex_state = 0, .external_lex_state = 3},
  [784] = {.lex_state = 0, .external_lex_state = 4},
  [785] = {.lex_state = 0, .external_lex_state = 4},
  [786] = {.lex_state = 0, .external_lex_state = 4},
  [787] = {.lex_state = 0, .external_lex_state = 6},
  [788] = {.lex_state = 0, .external_lex_state = 6},
  [789] = {.lex_state = 0, .external_lex_state = 6},
  [790] = {.lex_state = 0, .external_lex_state = 6},
  [791] = {.lex_state = 0, .external_lex_state = 7},
  [792] = {.lex_state = 0, .external_lex_state = 5},
  [793] = {.lex_state = 0, .external_lex_state = 6},
  [794] = {.lex_state = 0, .external_lex_state = 6},
  [795] = {.lex_state = 0, .external_lex_state = 16},
  [796] = {.lex_state = 0, .external_lex_state = 15},
  [797] = {.lex_state = 0, .external_lex_state = 8},
  [798] = {.lex_state = 0, .external_lex_state = 6},
  [799] = {.lex_state = 0, .external_lex_state = 7},
  [800] = {.lex_state = 0, .external_lex_state = 7},
  [801] = {.lex_state = 0, .external_lex_state = 5},
  [802] = {.lex_state = 0, .external_lex_state = 7},
  [803] = {.lex_state = 0, .external_lex_state = 7},
  [804] = {.lex_state = 0, .external_lex_state = 7},
  [805] = {.lex_state = 0, .external_lex_state = 6},
  [806] = {.lex_state = 0, .external_lex_state = 7},
  [807] = {.lex_state = 0, .external_lex_state = 7},
  [808] = {.lex_state = 0, .external_lex_state = 16},
  [809] = {.lex_state = 0, .external_lex_state = 4},
  [810] = {.lex_state = 0, .external_lex_state = 16},
  [811] = {.lex_state = 0, .external_lex_state = 4},
  [812] = {.lex_state = 0, .external_lex_state = 6},
  [813] = {.lex_state = 0, .external_lex_state = 6},
  [814] = {.lex_state = 0, .external_lex_state = 6},
  [815] = {.lex_state = 0, .external_lex_state = 5},
  [816] = {.lex_state = 0, .external_lex_state = 6},
  [817] = {.lex_state = 0, .external_lex_state = 4},
  [818] = {.lex_state = 0, .external_lex_state = 4},
  [819] = {.lex_state = 0, .external_lex_state = 4},
  [820] = {.lex_state = 0, .external_lex_state = 4},
  [821] = {.lex_state = 0, .external_lex_state = 4},
  [822] = {.lex_state = 0, .external_lex_state = 7},
  [823] = {.lex_state = 0, .external_lex_state = 7},
  [824] = {.lex_state = 0, .external_lex_state = 7},
  [825] = {.lex_state = 0, .external_lex_state = 7},
  [826] = {.lex_state = 0, .external_lex_state = 7},
  [827] = {.lex_state = 0, .external_lex_state = 7},
  [828] = {.lex_state = 0, .external_lex_state = 7},
  [829] = {.lex_state = 0, .external_lex_state = 7},
  [830] = {.lex_state = 0, .external_lex_state = 7},
  [831] = {.lex_state = 0, .external_lex_state = 7},
  [832] = {.lex_state = 0, .external_lex_state = 7},
  [833] = {.lex_state = 0, .external_lex_state = 3},
  [834] = {.lex_state = 0, .external_lex_state = 4},
  [835] = {.lex_state = 0, .external_lex_state = 5},
  [836] = {.lex_state = 0, .external_lex_state = 4},
  [837] = {.lex_state = 0, .external_lex_state = 16},
  [838] = {.lex_state = 0, .external_lex_state = 4},
  [839] = {.lex_state = 0, .external_lex_state = 4},
  [840] = {.lex_state = 0, .external_lex_state = 16},
  [841] = {.lex_state = 0, .external_lex_state = 16},
  [842] = {.lex_state = 0, .external_lex_state = 16},
  [843] = {.lex_state = 0, .external_lex_state = 12},
  [844] = {.lex_state = 0, .external_lex_state = 5},
  [845] = {.lex_state = 0, .external_lex_state = 5},
  [846] = {.lex_state = 0, .external_lex_state = 5},
  [847] = {.lex_state = 0, .external_lex_state = 5},
  [848] = {.lex_state = 0, .external_lex_state = 5},
  [849] = {.lex_state = 0, .external_lex_state = 5},
  [850] = {.lex_state = 0, .external_lex_state = 5},
  [851] = {.lex_state = 0, .external_lex_state = 16},
  [852] = {.lex_state = 0, .external_lex_state = 13},
  [853] = {.lex_state = 0, .external_lex_state = 16},
  [854] = {.lex_state = 0, .external_lex_state = 3},
  [855] = {.lex_state = 0, .external_lex_state = 16},
  [856] = {.lex_state = 0, .external_lex_state = 16},
  [857] = {.lex_state = 0, .external_lex_state = 16},
  [858] = {.lex_state = 0, .external_lex_state = 16},
  [859] = {.lex_state = 0, .external_lex_state = 16},
  [860] = {.lex_state = 0, .external_lex_state = 5},
  [861] = {.lex_state = 0, .external_lex_state = 16},
  [862] = {.lex_state = 0, .external_lex_state = 5},
  [863] = {.lex_state = 0, .external_lex_state = 5},
  [864] = {.lex_state = 0, .external_lex_state = 16},
  [865] = {.lex_state = 0, .external_lex_state = 5},
  [866] = {.lex_state = 0, .external_lex_state = 5},
  [867] = {.lex_state = 0, .external_lex_state = 5},
  [868] = {.lex_state = 0, .external_lex_state = 16},
  [869] = {.lex_state = 0, .external_lex_state = 5},
  [870] = {.lex_state = 0, .external_lex_state = 6},
  [871] = {.lex_state = 0, .external_lex_state = 16},
  [872] = {.lex_state = 0, .external_lex_state = 16},
  [873] = {.lex_state = 0, .external_lex_state = 3},
  [874] = {.lex_state = 0, .external_lex_state = 6},
  [875] = {.lex_state = 0, .external_lex_state = 12},
  [876] = {.lex_state = 0, .external_lex_state = 12},
  [877] = {.lex_state = 0, .external_lex_state = 9},
  [878] = {.lex_state = 0, .external_lex_state = 15},
  [879] = {.lex_state = 0, .external_lex_state = 15},
  [880] = {.lex_state = 0, .external_lex_state = 13},
  [881] = {.lex_state = 0, .external_lex_state = 8},
  [882] = {.lex_state = 0, .external_lex_state = 9},
  [883] = {.lex_state = 0, .external_lex_state = 9},
  [884] = {.lex_state = 0, .external_lex_state = 8},
  [885] = {.lex_state = 0, .external_lex_state = 9},
  [886] = {.lex_state = 0, .external_lex_state = 9},
  [887] = {.lex_state = 0, .external_lex_state = 9},
  [888] = {.lex_state = 0, .external_lex_state = 9},
  [889] = {.lex_state = 0, .external_lex_state = 12},
  [890] = {.lex_state = 0, .external_lex_state = 15},
  [891] = {.lex_state = 0, .external_lex_state = 2},
  [892] = {.lex_state = 0, .external_lex_state = 15},
  [893] = {.lex_state = 0, .external_lex_state = 8},
  [894] = {.lex_state = 0, .external_lex_state = 16},
  [895] = {.lex_state = 0, .external_lex_state = 15},
  [896] = {.lex_state = 0, .external_lex_state = 13},
  [897] = {.lex_state = 0, .external_lex_state = 15},
  [898] = {.lex_state = 0, .external_lex_state = 9},
  [899] = {.lex_state = 0, .external_lex_state = 13},
  [900] = {.lex_state = 0, .external_lex_state = 13},
  [901] = {.lex_state = 0, .external_lex_state = 13},
  [902] = {.lex_state = 0, .external_lex_state = 12},
  [903] = {.lex_state = 0, .external_lex_state = 15},
  [904] = {.lex_state = 0, .external_lex_state = 13},
  [905] = {.lex_state = 0, .external_lex_state = 12},
  [906] = {.lex_state = 0, .external_lex_state = 13},
  [907] = {.lex_state = 0, .external_lex_state = 14},
  [908] = {.lex_state = 0, .external_lex_state = 12},
  [909] = {.lex_state = 0, .external_lex_state = 13},
  [910] = {.lex_state = 0, .external_lex_state = 15},
  [911] = {.lex_state = 0, .external_lex_state = 13},
  [912] = {.lex_state = 0, .external_lex_state = 8},
  [913] = {.lex_state = 0, .external_lex_state = 15},
  [914] = {.lex_state = 0, .external_lex_state = 9},
  [915] = {.lex_state = 0, .external_lex_state = 11},
  [916] = {.lex_state = 0, .external_lex_state = 14},
  [917] = {.lex_state = 0, .external_lex_state = 12},
  [918] = {.lex_state = 0, .external_lex_state = 9},
  [919] = {.lex_state = 0, .external_lex_state = 8},
  [920] = {.lex_state = 0, .external_lex_state = 9},
  [921] = {.lex_state = 0, .external_lex_state = 9},
  [922] = {.lex_state = 0, .external_lex_state = 10},
  [923] = {.lex_state = 0, .external_lex_state = 12},
  [924] = {.lex_state = 0, .external_lex_state = 15},
  [925] = {.lex_state = 0, .external_lex_state = 15},
  [926] = {.lex_state = 0, .external_lex_state = 13},
  [927] = {.lex_state = 0, .external_lex_state = 14},
  [928] = {.lex_state = 0, .external_lex_state = 15},
  [929] = {.lex_state = 0, .external_lex_state = 15},
  [930] = {.lex_state = 0, .external_lex_state = 12},
  [931] = {.lex_state = 0, .external_lex_state = 13},
  [932] = {.lex_state = 0, .external_lex_state = 9},
  [933] = {.lex_state = 0, .external_lex_state = 13},
  [934] = {.lex_state = 0, .external_lex_state = 14},
  [935] = {.lex_state = 0, .external_lex_state = 9},
  [936] = {.lex_state = 0, .external_lex_state = 13},
  [937] = {.lex_state = 0, .external_lex_state = 8},
  [938] = {.lex_state = 0, .external_lex_state = 8},
  [939] = {.lex_state = 0, .external_lex_state = 14},
  [940] = {.lex_state = 0, .external_lex_state = 12},
  [941] = {.lex_state = 0, .external_lex_state = 14},
  [942] = {.lex_state = 0, .external_lex_state = 15},
  [943] = {.lex_state = 0, .external_lex_state = 15},
  [944] = {.lex_state = 0, .external_lex_state = 15},
  [945] = {.lex_state = 0, .external_lex_state = 8},
  [946] = {.lex_state = 0, .external_lex_state = 9},
  [947] = {.lex_state = 0, .external_lex_state = 8},
  [948] = {.lex_state = 0, .external_lex_state = 14},
  [949] = {.lex_state = 0, .external_lex_state = 14},
  [950] = {.lex_state = 0, .external_lex_state = 14},
  [951] = {.lex_state = 0, .external_lex_state = 8},
  [952] = {.lex_state = 0, .external_lex_state = 13},
  [953] = {.lex_state = 0, .external_lex_state = 14},
  [954] = {.lex_state = 0, .external_lex_state = 8},
  [955] = {.lex_state = 0, .external_lex_state = 14},
  [956] = {.lex_state = 0, .external_lex_state = 15},
  [957] = {.lex_state = 0, .external_lex_state = 8},
  [958] = {.lex_state = 0, .external_lex_state = 8},
  [959] = {.lex_state = 0, .external_lex_state = 12},
  [960] = {.lex_state = 0, .external_lex_state = 14},
  [961] = {.lex_state = 0, .external_lex_state = 8},
  [962] = {.lex_state = 0, .external_lex_state = 14},
  [963] = {.lex_state = 0, .external_lex_state = 9},
  [964] = {.lex_state = 0, .external_lex_state = 8},
  [965] = {.lex_state = 0, .external_lex_state = 8},
  [966] = {.lex_state = 0, .external_lex_state = 12},
  [967] = {.lex_state = 0, .external_lex_state = 14},
  [968] = {.lex_state = 0, .external_lex_state = 9},
  [969] = {.lex_state = 0, .external_lex_state = 14},
  [970] = {.lex_state = 0, .external_lex_state = 9},
  [971] = {.lex_state = 0, .external_lex_state = 12},
  [972] = {.lex_state = 0, .external_lex_state = 15},
  [973] = {.lex_state = 0, .external_lex_state = 13},
  [974] = {.lex_state = 0, .external_lex_state = 14},
  [975] = {.lex_state = 0, .external_lex_state = 2},
  [976] = {.lex_state = 0, .external_lex_state = 14},
  [977] = {.lex_state = 0, .external_lex_state = 12},
  [978] = {.lex_state = 0, .external_lex_state = 13},
  [979] = {.lex_state = 0, .external_lex_state = 12},
  [980] = {.lex_state = 0, .external_lex_state = 8},
  [981] = {.lex_state = 0, .external_lex_state = 14},
  [982] = {.lex_state = 0, .external_lex_state = 15},
  [983] = {.lex_state = 0, .external_lex_state = 14},
  [984] = {.lex_state = 0, .external_lex_state = 15},
  [985] = {.lex_state = 0, .external_lex_state = 12},
  [986] = {.lex_state = 0, .external_lex_state = 12},
  [987] = {.lex_state = 0, .external_lex_state = 14},
  [988] = {.lex_state = 0, .external_lex_state = 14},
  [989] = {.lex_state = 0, .external_lex_state = 8},
  [990] = {.lex_state = 0, .external_lex_state = 14},
  [991] = {.lex_state = 0, .external_lex_state = 8},
  [992] = {.lex_state = 0, .external_lex_state = 12},
  [993] = {.lex_state = 0, .external_lex_state = 12},
  [994] = {.lex_state = 0, .external_lex_state = 13},
  [995] = {.lex_state = 0, .external_lex_state = 14},
  [996] = {.lex_state = 0, .external_lex_state = 13},
  [997] = {.lex_state = 0, .external_lex_state = 14},
  [998] = {.lex_state = 0, .external_lex_state = 12},
  [999] = {.lex_state = 0, .external_lex_state = 13},
  [1000] = {.lex_state = 0, .external_lex_state = 13},
  [1001] = {.lex_state = 0, .external_lex_state = 9},
  [1002] = {.lex_state = 0, .external_lex_state = 14},
  [1003] = {.lex_state = 0, .external_lex_state = 14},
  [1004] = {.lex_state = 0, .external_lex_state = 17},
  [1005] = {.lex_state = 0, .external_lex_state = 17},
  [1006] = {.lex_state = 0, .external_lex_state = 17},
  [1007] = {.lex_state = 0, .external_lex_state = 17},
  [1008] = {.lex_state = 0, .external_lex_state = 17},
  [1009] = {.lex_state = 0, .external_lex_state = 17},
  [1010] = {.lex_state = 0, .external_lex_state = 17},
  [1011] = {.lex_state = 0, .external_lex_state = 17},
  [1012] = {.lex_state = 0, .external_lex_state = 17},
  [1013] = {.lex_state = 0, .external_lex_state = 17},
  [1014] = {.lex_state = 0, .external_lex_state = 17},
  [1015] = {.lex_state = 0, .external_lex_state = 17},
  [1016] = {.lex_state = 0, .external_lex_state = 17},
  [1017] = {.lex_state = 0, .external_lex_state = 17},
  [1018] = {.lex_state = 0, .external_lex_state = 17},
  [1019] = {.lex_state = 0, .external_lex_state = 17},
  [1020] = {.lex_state = 0, .external_lex_state = 17},
  [1021] = {.lex_state = 0, .external_lex_state = 17},
  [1022] = {.lex_state = 0, .external_lex_state = 17},
  [1023] = {.lex_state = 0, .external_lex_state = 17},
  [1024] = {.lex_state = 0, .external_lex_state = 17},
  [1025] = {.lex_state = 0, .external_lex_state = 17},
  [1026] = {.lex_state = 0, .external_lex_state = 17},
  [1027] = {.lex_state = 0, .external_lex_state = 17},
  [1028] = {.lex_state = 0, .external_lex_state = 17},
  [1029] = {.lex_state = 0, .external_lex_state = 17},
  [1030] = {.lex_state = 0, .external_lex_state = 17},
  [1031] = {.lex_state = 0, .external_lex_state = 17},
  [1032] = {.lex_state = 0, .external_lex_state = 17},
  [1033] = {.lex_state = 0, .external_lex_state = 17},
  [1034] = {.lex_state = 0, .external_lex_state = 17},
  [1035] = {.lex_state = 0, .external_lex_state = 17},
  [1036] = {.lex_state = 0, .external_lex_state = 17},
  [1037] = {.lex_state = 0, .external_lex_state = 17},
  [1038] = {.lex_state = 0, .external_lex_state = 17},
  [1039] = {.lex_state = 0, .external_lex_state = 17},
  [1040] = {.lex_state = 0, .external_lex_state = 17},
  [1041] = {.lex_state = 0, .external_lex_state = 17},
  [1042] = {.lex_state = 0, .external_lex_state = 17},
  [1043] = {.lex_state = 0, .external_lex_state = 17},
  [1044] = {.lex_state = 0, .external_lex_state = 17},
  [1045] = {.lex_state = 0, .external_lex_state = 17},
  [1046] = {.lex_state = 0, .external_lex_state = 17},
  [1047] = {.lex_state = 0, .external_lex_state = 17},
  [1048] = {.lex_state = 0, .external_lex_state = 17},
  [1049] = {.lex_state = 0, .external_lex_state = 17},
  [1050] = {.lex_state = 0, .external_lex_state = 17},
  [1051] = {.lex_state = 0, .external_lex_state = 17},
  [1052] = {.lex_state = 0, .external_lex_state = 17},
  [1053] = {.lex_state = 0, .external_lex_state = 17},
  [1054] = {.lex_state = 0, .external_lex_state = 17},
  [1055] = {.lex_state = 0, .external_lex_state = 17},
  [1056] = {.lex_state = 0, .external_lex_state = 17},
  [1057] = {.lex_state = 0, .external_lex_state = 17},
  [1058] = {.lex_state = 0, .external_lex_state = 17},
  [1059] = {.lex_state = 0, .external_lex_state = 17},
  [1060] = {.lex_state = 0, .external_lex_state = 17},
  [1061] = {.lex_state = 0, .external_lex_state = 17},
  [1062] = {.lex_state = 0, .external_lex_state = 17},
  [1063] = {.lex_state = 0, .external_lex_state = 17},
  [1064] = {.lex_state = 0, .external_lex_state = 17},
  [1065] = {.lex_state = 0, .external_lex_state = 17},
  [1066] = {.lex_state = 0, .external_lex_state = 17},
  [1067] = {.lex_state = 0, .external_lex_state = 17},
  [1068] = {.lex_state = 0, .external_lex_state = 17},
  [1069] = {.lex_state = 0, .external_lex_state = 17},
  [1070] = {.lex_state = 0, .external_lex_state = 17},
  [1071] = {.lex_state = 0, .external_lex_state = 17},
  [1072] = {.lex_state = 0, .external_lex_state = 17},
  [1073] = {.lex_state = 0, .external_lex_state = 17},
  [1074] = {.lex_state = 0, .external_lex_state = 17},
  [1075] = {.lex_state = 0, .external_lex_state = 17},
  [1076] = {.lex_state = 0, .external_lex_state = 17},
  [1077] = {.lex_state = 0, .external_lex_state = 17},
  [1078] = {.lex_state = 0, .external_lex_state = 17},
  [1079] = {.lex_state = 0, .external_lex_state = 17},
  [1080] = {.lex_state = 0, .external_lex_state = 17},
  [1081] = {.lex_state = 0, .external_lex_state = 17},
  [1082] = {.lex_state = 0, .external_lex_state = 17},
  [1083] = {.lex_state = 0, .external_lex_state = 17},
  [1084] = {.lex_state = 0, .external_lex_state = 17},
  [1085] = {.lex_state = 0, .external_lex_state = 17},
  [1086] = {.lex_state = 0, .external_lex_state = 17},
  [1087] = {.lex_state = 0, .external_lex_state = 17},
  [1088] = {.lex_state = 0, .external_lex_state = 17},
  [1089] = {.lex_state = 0, .external_lex_state = 17},
  [1090] = {.lex_state = 0, .external_lex_state = 17},
  [1091] = {.lex_state = 0, .external_lex_state = 17},
  [1092] = {.lex_state = 0, .external_lex_state = 17},
  [1093] = {.lex_state = 0, .external_lex_state = 17},
  [1094] = {.lex_state = 0, .external_lex_state = 17},
  [1095] = {.lex_state = 0, .external_lex_state = 17},
  [1096] = {.lex_state = 0, .external_lex_state = 17},
  [1097] = {.lex_state = 0, .external_lex_state = 17},
  [1098] = {.lex_state = 0, .external_lex_state = 17},
  [1099] = {.lex_state = 0, .external_lex_state = 17},
  [1100] = {.lex_state = 0, .external_lex_state = 17},
  [1101] = {.lex_state = 0, .external_lex_state = 17},
  [1102] = {.lex_state = 0, .external_lex_state = 17},
  [1103] = {.lex_state = 0, .external_lex_state = 17},
  [1104] = {.lex_state = 0, .external_lex_state = 17},
  [1105] = {.lex_state = 0, .external_lex_state = 17},
  [1106] = {.lex_state = 0, .external_lex_state = 17},
  [1107] = {.lex_state = 0, .external_lex_state = 17},
  [1108] = {.lex_state = 0, .external_lex_state = 17},
  [1109] = {.lex_state = 0, .external_lex_state = 17},
  [1110] = {.lex_state = 0, .external_lex_state = 17},
  [1111] = {.lex_state = 0, .external_lex_state = 17},
  [1112] = {.lex_state = 0, .external_lex_state = 17},
  [1113] = {.lex_state = 0, .external_lex_state = 17},
  [1114] = {.lex_state = 0, .external_lex_state = 17},
  [1115] = {.lex_state = 0, .external_lex_state = 17},
  [1116] = {.lex_state = 0, .external_lex_state = 17},
  [1117] = {.lex_state = 0, .external_lex_state = 17},
  [1118] = {.lex_state = 0, .external_lex_state = 17},
  [1119] = {.lex_state = 0, .external_lex_state = 17},
  [1120] = {.lex_state = 0, .external_lex_state = 17},
  [1121] = {.lex_state = 0, .external_lex_state = 17},
  [1122] = {.lex_state = 0, .external_lex_state = 17},
  [1123] = {.lex_state = 0, .external_lex_state = 17},
  [1124] = {.lex_state = 0, .external_lex_state = 17},
  [1125] = {.lex_state = 0, .external_lex_state = 17},
  [1126] = {.lex_state = 0, .external_lex_state = 17},
  [1127] = {.lex_state = 0, .external_lex_state = 17},
  [1128] = {.lex_state = 0, .external_lex_state = 17},
  [1129] = {.lex_state = 0, .external_lex_state = 17},
  [1130] = {.lex_state = 0, .external_lex_state = 17},
  [1131] = {.lex_state = 0, .external_lex_state = 18},
  [1132] = {.lex_state = 0, .external_lex_state = 17},
  [1133] = {.lex_state = 0, .external_lex_state = 17},
  [1134] = {.lex_state = 0, .external_lex_state = 17},
  [1135] = {.lex_state = 0, .external_lex_state = 17},
  [1136] = {.lex_state = 0, .external_lex_state = 17},
  [1137] = {.lex_state = 0, .external_lex_state = 17},
  [1138] = {.lex_state = 0, .external_lex_state = 17},
  [1139] = {.lex_state = 0, .external_lex_state = 17},
  [1140] = {.lex_state = 0, .external_lex_state = 17},
  [1141] = {.lex_state = 0, .external_lex_state = 17},
  [1142] = {.lex_state = 0, .external_lex_state = 17},
  [1143] = {.lex_state = 0, .external_lex_state = 17},
  [1144] = {.lex_state = 0, .external_lex_state = 17},
  [1145] = {.lex_state = 0, .external_lex_state = 17},
  [1146] = {.lex_state = 0, .external_lex_state = 17},
  [1147] = {.lex_state = 0, .external_lex_state = 17},
  [1148] = {.lex_state = 0, .external_lex_state = 17},
  [1149] = {.lex_state = 0, .external_lex_state = 17},
  [1150] = {.lex_state = 0, .external_lex_state = 17},
  [1151] = {.lex_state = 0, .external_lex_state = 17},
  [1152] = {.lex_state = 0, .external_lex_state = 17},
  [1153] = {.lex_state = 0, .external_lex_state = 17},
  [1154] = {.lex_state = 0, .external_lex_state = 17},
  [1155] = {.lex_state = 0, .external_lex_state = 17},
  [1156] = {.lex_state = 0, .external_lex_state = 17},
  [1157] = {.lex_state = 0, .external_lex_state = 17},
  [1158] = {.lex_state = 0, .external_lex_state = 17},
  [1159] = {.lex_state = 0, .external_lex_state = 17},
  [1160] = {.lex_state = 0, .external_lex_state = 17},
  [1161] = {.lex_state = 0, .external_lex_state = 17},
  [1162] = {.lex_state = 0, .external_lex_state = 17},
  [1163] = {.lex_state = 0, .external_lex_state = 17},
  [1164] = {.lex_state = 0, .external_lex_state = 17},
  [1165] = {.lex_state = 0, .external_lex_state = 17},
  [1166] = {.lex_state = 0, .external_lex_state = 17},
  [1167] = {.lex_state = 0, .external_lex_state = 17},
  [1168] = {.lex_state = 0, .external_lex_state = 17},
  [1169] = {.lex_state = 0, .external_lex_state = 17},
  [1170] = {.lex_state = 0, .external_lex_state = 17},
  [1171] = {.lex_state = 0, .external_lex_state = 17},
  [1172] = {.lex_state = 0, .external_lex_state = 17},
  [1173] = {.lex_state = 0, .external_lex_state = 17},
  [1174] = {.lex_state = 0, .external_lex_state = 17},
  [1175] = {.lex_state = 0, .external_lex_state = 17},
  [1176] = {.lex_state = 0, .external_lex_state = 17},
  [1177] = {.lex_state = 0, .external_lex_state = 17},
  [1178] = {.lex_state = 0, .external_lex_state = 17},
  [1179] = {.lex_state = 0, .external_lex_state = 17},
  [1180] = {.lex_state = 0, .external_lex_state = 17},
  [1181] = {.lex_state = 0, .external_lex_state = 17},
  [1182] = {.lex_state = 0, .external_lex_state = 17},
  [1183] = {.lex_state = 0, .external_lex_state = 17},
  [1184] = {.lex_state = 0, .external_lex_state = 17},
  [1185] = {.lex_state = 0, .external_lex_state = 17},
  [1186] = {.lex_state = 0, .external_lex_state = 17},
  [1187] = {.lex_state = 0, .external_lex_state = 17},
  [1188] = {.lex_state = 0, .external_lex_state = 17},
  [1189] = {.lex_state = 0, .external_lex_state = 17},
  [1190] = {.lex_state = 0, .external_lex_state = 17},
  [1191] = {.lex_state = 0, .external_lex_state = 17},
  [1192] = {.lex_state = 0, .external_lex_state = 17},
  [1193] = {.lex_state = 0, .external_lex_state = 17},
  [1194] = {.lex_state = 0, .external_lex_state = 17},
  [1195] = {.lex_state = 0, .external_lex_state = 17},
  [1196] = {.lex_state = 0, .external_lex_state = 17},
  [1197] = {.lex_state = 0, .external_lex_state = 17},
  [1198] = {.lex_state = 0, .external_lex_state = 17},
  [1199] = {.lex_state = 0, .external_lex_state = 17},
  [1200] = {.lex_state = 0, .external_lex_state = 17},
  [1201] = {.lex_state = 0, .external_lex_state = 17},
  [1202] = {.lex_state = 0, .external_lex_state = 17},
  [1203] = {.lex_state = 0, .external_lex_state = 17},
  [1204] = {.lex_state = 0, .external_lex_state = 17},
  [1205] = {.lex_state = 0, .external_lex_state = 17},
  [1206] = {.lex_state = 0, .external_lex_state = 17},
  [1207] = {.lex_state = 0, .external_lex_state = 17},
  [1208] = {.lex_state = 0, .external_lex_state = 17},
  [1209] = {.lex_state = 0, .external_lex_state = 17},
  [1210] = {.lex_state = 0, .external_lex_state = 17},
  [1211] = {.lex_state = 0, .external_lex_state = 17},
  [1212] = {.lex_state = 0, .external_lex_state = 17},
  [1213] = {.lex_state = 0, .external_lex_state = 17},
  [1214] = {.lex_state = 0, .external_lex_state = 17},
  [1215] = {.lex_state = 0, .external_lex_state = 17},
  [1216] = {.lex_state = 0, .external_lex_state = 17},
  [1217] = {.lex_state = 0, .external_lex_state = 17},
  [1218] = {.lex_state = 0, .external_lex_state = 17},
  [1219] = {.lex_state = 0, .external_lex_state = 17},
  [1220] = {.lex_state = 0, .external_lex_state = 17},
  [1221] = {.lex_state = 0, .external_lex_state = 17},
  [1222] = {.lex_state = 0, .external_lex_state = 17},
  [1223] = {.lex_state = 0, .external_lex_state = 17},
  [1224] = {.lex_state = 0, .external_lex_state = 17},
  [1225] = {.lex_state = 0, .external_lex_state = 17},
  [1226] = {.lex_state = 0, .external_lex_state = 17},
  [1227] = {.lex_state = 0, .external_lex_state = 17},
  [1228] = {.lex_state = 0, .external_lex_state = 17},
  [1229] = {.lex_state = 0, .external_lex_state = 17},
  [1230] = {.lex_state = 0, .external_lex_state = 17},
  [1231] = {.lex_state = 0, .external_lex_state = 17},
  [1232] = {.lex_state = 0, .external_lex_state = 17},
  [1233] = {.lex_state = 0, .external_lex_state = 17},
  [1234] = {.lex_state = 0, .external_lex_state = 17},
  [1235] = {.lex_state = 0, .external_lex_state = 17},
  [1236] = {.lex_state = 0, .external_lex_state = 17},
  [1237] = {.lex_state = 0, .external_lex_state = 17},
  [1238] = {.lex_state = 0, .external_lex_state = 17},
  [1239] = {.lex_state = 0, .external_lex_state = 17},
  [1240] = {.lex_state = 0, .external_lex_state = 17},
  [1241] = {.lex_state = 0, .external_lex_state = 17},
  [1242] = {.lex_state = 0, .external_lex_state = 17},
  [1243] = {.lex_state = 0, .external_lex_state = 17},
  [1244] = {.lex_state = 0, .external_lex_state = 17},
  [1245] = {.lex_state = 0, .external_lex_state = 17},
  [1246] = {.lex_state = 0, .external_lex_state = 17},
  [1247] = {.lex_state = 0, .external_lex_state = 17},
  [1248] = {.lex_state = 0, .external_lex_state = 17},
  [1249] = {.lex_state = 0, .external_lex_state = 17},
  [1250] = {.lex_state = 0, .external_lex_state = 17},
  [1251] = {.lex_state = 0, .external_lex_state = 17},
  [1252] = {.lex_state = 0, .external_lex_state = 17},
  [1253] = {.lex_state = 0, .external_lex_state = 17},
  [1254] = {.lex_state = 0, .external_lex_state = 17},
  [1255] = {.lex_state = 0, .external_lex_state = 17},
  [1256] = {.lex_state = 0, .external_lex_state = 17},
  [1257] = {.lex_state = 0, .external_lex_state = 17},
  [1258] = {.lex_state = 0, .external_lex_state = 17},
  [1259] = {.lex_state = 0, .external_lex_state = 17},
  [1260] = {.lex_state = 0, .external_lex_state = 17},
  [1261] = {.lex_state = 0, .external_lex_state = 17},
  [1262] = {.lex_state = 0, .external_lex_state = 17},
  [1263] = {.lex_state = 0, .external_lex_state = 17},
  [1264] = {.lex_state = 0, .external_lex_state = 17},
  [1265] = {.lex_state = 0, .external_lex_state = 17},
  [1266] = {.lex_state = 0, .external_lex_state = 17},
  [1267] = {.lex_state = 0, .external_lex_state = 17},
  [1268] = {.lex_state = 0, .external_lex_state = 17},
  [1269] = {.lex_state = 0, .external_lex_state = 17},
  [1270] = {.lex_state = 0, .external_lex_state = 17},
  [1271] = {.lex_state = 0, .external_lex_state = 17},
  [1272] = {.lex_state = 0, .external_lex_state = 17},
  [1273] = {.lex_state = 0, .external_lex_state = 17},
  [1274] = {.lex_state = 0, .external_lex_state = 17},
  [1275] = {.lex_state = 0, .external_lex_state = 17},
  [1276] = {.lex_state = 0, .external_lex_state = 17},
  [1277] = {.lex_state = 0, .external_lex_state = 17},
  [1278] = {.lex_state = 0, .external_lex_state = 17},
  [1279] = {.lex_state = 0, .external_lex_state = 17},
  [1280] = {.lex_state = 0, .external_lex_state = 17},
  [1281] = {.lex_state = 0, .external_lex_state = 17},
  [1282] = {.lex_state = 0, .external_lex_state = 17},
  [1283] = {.lex_state = 0, .external_lex_state = 17},
  [1284] = {.lex_state = 0, .external_lex_state = 17},
  [1285] = {.lex_state = 0, .external_lex_state = 17},
  [1286] = {.lex_state = 0, .external_lex_state = 17},
  [1287] = {.lex_state = 0, .external_lex_state = 17},
  [1288] = {.lex_state = 0, .external_lex_state = 17},
  [1289] = {.lex_state = 0, .external_lex_state = 17},
  [1290] = {.lex_state = 0, .external_lex_state = 17},
  [1291] = {.lex_state = 0, .external_lex_state = 17},
  [1292] = {.lex_state = 0, .external_lex_state = 17},
  [1293] = {.lex_state = 0, .external_lex_state = 17},
  [1294] = {.lex_state = 0, .external_lex_state = 17},
  [1295] = {.lex_state = 0, .external_lex_state = 17},
  [1296] = {.lex_state = 0, .external_lex_state = 17},
  [1297] = {.lex_state = 0, .external_lex_state = 17},
  [1298] = {.lex_state = 0, .external_lex_state = 17},
  [1299] = {.lex_state = 0, .external_lex_state = 17},
  [1300] = {.lex_state = 0, .external_lex_state = 17},
  [1301] = {.lex_state = 0, .external_lex_state = 17},
  [1302] = {.lex_state = 0, .external_lex_state = 17},
  [1303] = {.lex_state = 0, .external_lex_state = 17},
  [1304] = {.lex_state = 0, .external_lex_state = 17},
  [1305] = {.lex_state = 0, .external_lex_state = 17},
  [1306] = {.lex_state = 0, .external_lex_state = 17},
  [1307] = {.lex_state = 0, .external_lex_state = 17},
  [1308] = {.lex_state = 0, .external_lex_state = 17},
  [1309] = {.lex_state = 0, .external_lex_state = 17},
  [1310] = {.lex_state = 0, .external_lex_state = 17},
  [1311] = {.lex_state = 0, .external_lex_state = 17},
  [1312] = {.lex_state = 0, .external_lex_state = 17},
  [1313] = {.lex_state = 0, .external_lex_state = 17},
  [1314] = {.lex_state = 0, .external_lex_state = 17},
  [1315] = {.lex_state = 0, .external_lex_state = 17},
  [1316] = {.lex_state = 0, .external_lex_state = 17},
  [1317] = {.lex_state = 0, .external_lex_state = 17},
  [1318] = {.lex_state = 0, .external_lex_state = 17},
  [1319] = {.lex_state = 0, .external_lex_state = 17},
  [1320] = {.lex_state = 0, .external_lex_state = 17},
  [1321] = {.lex_state = 0, .external_lex_state = 17},
  [1322] = {.lex_state = 0, .external_lex_state = 17},
  [1323] = {.lex_state = 0, .external_lex_state = 17},
  [1324] = {.lex_state = 0, .external_lex_state = 17},
  [1325] = {.lex_state = 0, .external_lex_state = 17},
  [1326] = {.lex_state = 0, .external_lex_state = 17},
  [1327] = {.lex_state = 0, .external_lex_state = 17},
  [1328] = {.lex_state = 0, .external_lex_state = 17},
  [1329] = {.lex_state = 0, .external_lex_state = 17},
  [1330] = {.lex_state = 0, .external_lex_state = 17},
  [1331] = {.lex_state = 0, .external_lex_state = 17},
  [1332] = {.lex_state = 0, .external_lex_state = 17},
  [1333] = {.lex_state = 0, .external_lex_state = 17},
  [1334] = {.lex_state = 0, .external_lex_state = 17},
  [1335] = {.lex_state = 0, .external_lex_state = 17},
  [1336] = {.lex_state = 0, .external_lex_state = 17},
  [1337] = {.lex_state = 0, .external_lex_state = 17},
  [1338] = {.lex_state = 0, .external_lex_state = 17},
  [1339] = {.lex_state = 0, .external_lex_state = 17},
  [1340] = {.lex_state = 0, .external_lex_state = 17},
  [1341] = {.lex_state = 0, .external_lex_state = 17},
  [1342] = {.lex_state = 0, .external_lex_state = 17},
  [1343] = {.lex_state = 0, .external_lex_state = 17},
  [1344] = {.lex_state = 0, .external_lex_state = 17},
  [1345] = {.lex_state = 0, .external_lex_state = 17},
  [1346] = {.lex_state = 0, .external_lex_state = 17},
  [1347] = {.lex_state = 0, .external_lex_state = 17},
  [1348] = {.lex_state = 0, .external_lex_state = 17},
  [1349] = {.lex_state = 0, .external_lex_state = 17},
  [1350] = {.lex_state = 0, .external_lex_state = 17},
  [1351] = {.lex_state = 0, .external_lex_state = 17},
  [1352] = {.lex_state = 0, .external_lex_state = 17},
  [1353] = {.lex_state = 0, .external_lex_state = 17},
  [1354] = {.lex_state = 0, .external_lex_state = 17},
  [1355] = {.lex_state = 0, .external_lex_state = 17},
  [1356] = {.lex_state = 0, .external_lex_state = 17},
  [1357] = {.lex_state = 0, .external_lex_state = 17},
  [1358] = {.lex_state = 0, .external_lex_state = 17},
  [1359] = {.lex_state = 0, .external_lex_state = 17},
  [1360] = {.lex_state = 0, .external_lex_state = 17},
  [1361] = {.lex_state = 0, .external_lex_state = 17},
  [1362] = {.lex_state = 0, .external_lex_state = 17},
  [1363] = {.lex_state = 0, .external_lex_state = 17},
  [1364] = {.lex_state = 0, .external_lex_state = 17},
  [1365] = {.lex_state = 0, .external_lex_state = 17},
  [1366] = {.lex_state = 0, .external_lex_state = 17},
  [1367] = {.lex_state = 0, .external_lex_state = 17},
  [1368] = {.lex_state = 0, .external_lex_state = 17},
  [1369] = {.lex_state = 0, .external_lex_state = 17},
  [1370] = {.lex_state = 0, .external_lex_state = 17},
  [1371] = {.lex_state = 0, .external_lex_state = 17},
  [1372] = {.lex_state = 0, .external_lex_state = 17},
  [1373] = {.lex_state = 0, .external_lex_state = 17},
  [1374] = {.lex_state = 0, .external_lex_state = 17},
  [1375] = {.lex_state = 0, .external_lex_state = 17},
  [1376] = {.lex_state = 0, .external_lex_state = 17},
  [1377] = {.lex_state = 0, .external_lex_state = 17},
  [1378] = {.lex_state = 0, .external_lex_state = 17},
  [1379] = {.lex_state = 0, .external_lex_state = 17},
  [1380] = {.lex_state = 0, .external_lex_state = 17},
  [1381] = {.lex_state = 0, .external_lex_state = 17},
  [1382] = {.lex_state = 0, .external_lex_state = 17},
  [1383] = {.lex_state = 0, .external_lex_state = 17},
  [1384] = {.lex_state = 0, .external_lex_state = 17},
  [1385] = {.lex_state = 0, .external_lex_state = 17},
  [1386] = {.lex_state = 0, .external_lex_state = 17},
  [1387] = {.lex_state = 0, .external_lex_state = 17},
  [1388] = {.lex_state = 0, .external_lex_state = 17},
  [1389] = {.lex_state = 0, .external_lex_state = 17},
  [1390] = {.lex_state = 0, .external_lex_state = 17},
  [1391] = {.lex_state = 0, .external_lex_state = 17},
  [1392] = {.lex_state = 0, .external_lex_state = 17},
  [1393] = {.lex_state = 0, .external_lex_state = 17},
  [1394] = {.lex_state = 0, .external_lex_state = 17},
  [1395] = {.lex_state = 0, .external_lex_state = 17},
  [1396] = {.lex_state = 0, .external_lex_state = 17},
  [1397] = {.lex_state = 0, .external_lex_state = 17},
  [1398] = {.lex_state = 0, .external_lex_state = 17},
  [1399] = {.lex_state = 0, .external_lex_state = 17},
  [1400] = {.lex_state = 0, .external_lex_state = 17},
  [1401] = {.lex_state = 0, .external_lex_state = 17},
  [1402] = {.lex_state = 0, .external_lex_state = 17},
  [1403] = {.lex_state = 0, .external_lex_state = 17},
  [1404] = {.lex_state = 0, .external_lex_state = 17},
  [1405] = {.lex_state = 0, .external_lex_state = 17},
  [1406] = {.lex_state = 0, .external_lex_state = 17},
  [1407] = {.lex_state = 0, .external_lex_state = 17},
  [1408] = {.lex_state = 0, .external_lex_state = 17},
  [1409] = {.lex_state = 0, .external_lex_state = 17},
  [1410] = {.lex_state = 0, .external_lex_state = 17},
  [1411] = {.lex_state = 0, .external_lex_state = 17},
  [1412] = {.lex_state = 0, .external_lex_state = 17},
  [1413] = {.lex_state = 0, .external_lex_state = 17},
  [1414] = {.lex_state = 0, .external_lex_state = 17},
  [1415] = {.lex_state = 0, .external_lex_state = 17},
  [1416] = {.lex_state = 0, .external_lex_state = 17},
  [1417] = {.lex_state = 0, .external_lex_state = 17},
  [1418] = {.lex_state = 0, .external_lex_state = 17},
  [1419] = {.lex_state = 0, .external_lex_state = 17},
  [1420] = {.lex_state = 0, .external_lex_state = 17},
  [1421] = {.lex_state = 0, .external_lex_state = 17},
  [1422] = {.lex_state = 0, .external_lex_state = 17},
  [1423] = {.lex_state = 0, .external_lex_state = 17},
  [1424] = {.lex_state = 0, .external_lex_state = 17},
  [1425] = {.lex_state = 0, .external_lex_state = 17},
  [1426] = {.lex_state = 0, .external_lex_state = 17},
  [1427] = {.lex_state = 0, .external_lex_state = 17},
  [1428] = {.lex_state = 0, .external_lex_state = 17},
  [1429] = {.lex_state = 0, .external_lex_state = 17},
  [1430] = {.lex_state = 0, .external_lex_state = 17},
  [1431] = {.lex_state = 0, .external_lex_state = 17},
  [1432] = {.lex_state = 0, .external_lex_state = 17},
  [1433] = {.lex_state = 0, .external_lex_state = 17},
  [1434] = {.lex_state = 0, .external_lex_state = 17},
  [1435] = {.lex_state = 0, .external_lex_state = 17},
  [1436] = {.lex_state = 0, .external_lex_state = 17},
  [1437] = {.lex_state = 0, .external_lex_state = 17},
  [1438] = {.lex_state = 0, .external_lex_state = 17},
  [1439] = {.lex_state = 0, .external_lex_state = 17},
  [1440] = {.lex_state = 0, .external_lex_state = 17},
  [1441] = {.lex_state = 0, .external_lex_state = 17},
  [1442] = {.lex_state = 0, .external_lex_state = 17},
  [1443] = {.lex_state = 0, .external_lex_state = 17},
  [1444] = {.lex_state = 0, .external_lex_state = 17},
  [1445] = {.lex_state = 0, .external_lex_state = 17},
  [1446] = {.lex_state = 0, .external_lex_state = 17},
  [1447] = {.lex_state = 0, .external_lex_state = 17},
  [1448] = {.lex_state = 0, .external_lex_state = 17},
  [1449] = {.lex_state = 0, .external_lex_state = 17},
  [1450] = {.lex_state = 0, .external_lex_state = 17},
  [1451] = {.lex_state = 0, .external_lex_state = 17},
  [1452] = {.lex_state = 0, .external_lex_state = 17},
  [1453] = {.lex_state = 0, .external_lex_state = 17},
  [1454] = {.lex_state = 0, .external_lex_state = 17},
  [1455] = {.lex_state = 0, .external_lex_state = 17},
  [1456] = {.lex_state = 0, .external_lex_state = 17},
  [1457] = {.lex_state = 0, .external_lex_state = 17},
  [1458] = {.lex_state = 0, .external_lex_state = 17},
  [1459] = {.lex_state = 0, .external_lex_state = 17},
  [1460] = {.lex_state = 0, .external_lex_state = 17},
  [1461] = {.lex_state = 0, .external_lex_state = 17},
  [1462] = {.lex_state = 0, .external_lex_state = 17},
  [1463] = {.lex_state = 0, .external_lex_state = 17},
  [1464] = {.lex_state = 0, .external_lex_state = 17},
  [1465] = {.lex_state = 0, .external_lex_state = 17},
  [1466] = {.lex_state = 0, .external_lex_state = 17},
  [1467] = {.lex_state = 0, .external_lex_state = 17},
  [1468] = {.lex_state = 0, .external_lex_state = 17},
  [1469] = {.lex_state = 0, .external_lex_state = 17},
  [1470] = {.lex_state = 0, .external_lex_state = 17},
  [1471] = {.lex_state = 0, .external_lex_state = 17},
  [1472] = {.lex_state = 0, .external_lex_state = 17},
  [1473] = {.lex_state = 0, .external_lex_state = 17},
  [1474] = {.lex_state = 0, .external_lex_state = 17},
  [1475] = {.lex_state = 0, .external_lex_state = 17},
  [1476] = {.lex_state = 0, .external_lex_state = 17},
  [1477] = {.lex_state = 0, .external_lex_state = 17},
  [1478] = {.lex_state = 0, .external_lex_state = 17},
  [1479] = {.lex_state = 0, .external_lex_state = 17},
  [1480] = {.lex_state = 0, .external_lex_state = 17},
  [1481] = {.lex_state = 0, .external_lex_state = 17},
  [1482] = {.lex_state = 0, .external_lex_state = 17},
  [1483] = {.lex_state = 0, .external_lex_state = 17},
  [1484] = {.lex_state = 0, .external_lex_state = 17},
  [1485] = {.lex_state = 0, .external_lex_state = 17},
  [1486] = {.lex_state = 0, .external_lex_state = 17},
  [1487] = {.lex_state = 0, .external_lex_state = 17},
  [1488] = {.lex_state = 0, .external_lex_state = 17},
  [1489] = {.lex_state = 0, .external_lex_state = 17},
  [1490] = {.lex_state = 0, .external_lex_state = 17},
  [1491] = {.lex_state = 0, .external_lex_state = 17},
  [1492] = {.lex_state = 0, .external_lex_state = 17},
  [1493] = {.lex_state = 0, .external_lex_state = 17},
  [1494] = {.lex_state = 0, .external_lex_state = 17},
  [1495] = {.lex_state = 0, .external_lex_state = 17},
  [1496] = {.lex_state = 0, .external_lex_state = 17},
  [1497] = {.lex_state = 0, .external_lex_state = 17},
  [1498] = {.lex_state = 0, .external_lex_state = 17},
  [1499] = {.lex_state = 0, .external_lex_state = 17},
  [1500] = {.lex_state = 0, .external_lex_state = 17},
  [1501] = {.lex_state = 0, .external_lex_state = 17},
  [1502] = {.lex_state = 0, .external_lex_state = 17},
  [1503] = {.lex_state = 0, .external_lex_state = 17},
  [1504] = {.lex_state = 0, .external_lex_state = 17},
  [1505] = {.lex_state = 0, .external_lex_state = 17},
  [1506] = {.lex_state = 0, .external_lex_state = 17},
  [1507] = {.lex_state = 0, .external_lex_state = 17},
  [1508] = {.lex_state = 0, .external_lex_state = 17},
  [1509] = {.lex_state = 0, .external_lex_state = 17},
  [1510] = {.lex_state = 0, .external_lex_state = 17},
  [1511] = {.lex_state = 0, .external_lex_state = 17},
  [1512] = {.lex_state = 0, .external_lex_state = 17},
  [1513] = {.lex_state = 0, .external_lex_state = 17},
  [1514] = {.lex_state = 0, .external_lex_state = 17},
  [1515] = {.lex_state = 0, .external_lex_state = 17},
  [1516] = {.lex_state = 0, .external_lex_state = 17},
  [1517] = {.lex_state = 0, .external_lex_state = 17},
  [1518] = {.lex_state = 0, .external_lex_state = 17},
  [1519] = {.lex_state = 0, .external_lex_state = 17},
  [1520] = {.lex_state = 0, .external_lex_state = 17},
  [1521] = {.lex_state = 0, .external_lex_state = 17},
  [1522] = {.lex_state = 0, .external_lex_state = 17},
  [1523] = {.lex_state = 0, .external_lex_state = 17},
  [1524] = {.lex_state = 0, .external_lex_state = 17},
  [1525] = {.lex_state = 0, .external_lex_state = 17},
  [1526] = {.lex_state = 0, .external_lex_state = 17},
  [1527] = {.lex_state = 0, .external_lex_state = 17},
  [1528] = {.lex_state = 0, .external_lex_state = 17},
  [1529] = {.lex_state = 0, .external_lex_state = 17},
  [1530] = {.lex_state = 0, .external_lex_state = 17},
  [1531] = {.lex_state = 0, .external_lex_state = 17},
  [1532] = {.lex_state = 0, .external_lex_state = 17},
  [1533] = {.lex_state = 0, .external_lex_state = 17},
  [1534] = {.lex_state = 0, .external_lex_state = 17},
  [1535] = {.lex_state = 0, .external_lex_state = 17},
  [1536] = {.lex_state = 0, .external_lex_state = 17},
  [1537] = {.lex_state = 0, .external_lex_state = 17},
  [1538] = {.lex_state = 0, .external_lex_state = 17},
  [1539] = {.lex_state = 0, .external_lex_state = 17},
  [1540] = {.lex_state = 0, .external_lex_state = 17},
  [1541] = {.lex_state = 0, .external_lex_state = 17},
  [1542] = {.lex_state = 0, .external_lex_state = 17},
  [1543] = {.lex_state = 0, .external_lex_state = 17},
  [1544] = {.lex_state = 0, .external_lex_state = 17},
  [1545] = {.lex_state = 0, .external_lex_state = 17},
  [1546] = {.lex_state = 0, .external_lex_state = 17},
  [1547] = {.lex_state = 0, .external_lex_state = 17},
  [1548] = {.lex_state = 0, .external_lex_state = 17},
  [1549] = {.lex_state = 0, .external_lex_state = 17},
  [1550] = {.lex_state = 0, .external_lex_state = 17},
  [1551] = {.lex_state = 0, .external_lex_state = 17},
  [1552] = {.lex_state = 0, .external_lex_state = 17},
  [1553] = {.lex_state = 0, .external_lex_state = 17},
  [1554] = {.lex_state = 0, .external_lex_state = 17},
  [1555] = {.lex_state = 0, .external_lex_state = 17},
  [1556] = {.lex_state = 0, .external_lex_state = 17},
  [1557] = {.lex_state = 0, .external_lex_state = 17},
  [1558] = {.lex_state = 0, .external_lex_state = 17},
  [1559] = {.lex_state = 0, .external_lex_state = 17},
  [1560] = {.lex_state = 0, .external_lex_state = 17},
  [1561] = {.lex_state = 0, .external_lex_state = 17},
  [1562] = {.lex_state = 0, .external_lex_state = 17},
  [1563] = {.lex_state = 0, .external_lex_state = 17},
  [1564] = {.lex_state = 0, .external_lex_state = 17},
  [1565] = {.lex_state = 0, .external_lex_state = 17},
  [1566] = {.lex_state = 0, .external_lex_state = 17},
  [1567] = {.lex_state = 0, .external_lex_state = 17},
  [1568] = {.lex_state = 0, .external_lex_state = 17},
  [1569] = {.lex_state = 0, .external_lex_state = 17},
  [1570] = {.lex_state = 0, .external_lex_state = 17},
  [1571] = {.lex_state = 0, .external_lex_state = 17},
  [1572] = {.lex_state = 0, .external_lex_state = 17},
  [1573] = {.lex_state = 0, .external_lex_state = 17},
  [1574] = {.lex_state = 0, .external_lex_state = 17},
  [1575] = {.lex_state = 0, .external_lex_state = 17},
  [1576] = {.lex_state = 0, .external_lex_state = 17},
  [1577] = {.lex_state = 0, .external_lex_state = 17},
  [1578] = {.lex_state = 0, .external_lex_state = 17},
  [1579] = {.lex_state = 0, .external_lex_state = 17},
  [1580] = {.lex_state = 0, .external_lex_state = 17},
  [1581] = {.lex_state = 0, .external_lex_state = 17},
  [1582] = {.lex_state = 0, .external_lex_state = 17},
  [1583] = {.lex_state = 0, .external_lex_state = 17},
  [1584] = {.lex_state = 0, .external_lex_state = 17},
  [1585] = {.lex_state = 0, .external_lex_state = 17},
  [1586] = {.lex_state = 0, .external_lex_state = 17},
  [1587] = {.lex_state = 0, .external_lex_state = 17},
  [1588] = {.lex_state = 0, .external_lex_state = 17},
  [1589] = {.lex_state = 0, .external_lex_state = 17},
  [1590] = {.lex_state = 0, .external_lex_state = 17},
  [1591] = {.lex_state = 0, .external_lex_state = 17},
  [1592] = {.lex_state = 0, .external_lex_state = 17},
  [1593] = {.lex_state = 0, .external_lex_state = 17},
  [1594] = {.lex_state = 0, .external_lex_state = 17},
  [1595] = {.lex_state = 0, .external_lex_state = 17},
  [1596] = {.lex_state = 0, .external_lex_state = 17},
  [1597] = {.lex_state = 0, .external_lex_state = 17},
  [1598] = {.lex_state = 0, .external_lex_state = 17},
  [1599] = {.lex_state = 0, .external_lex_state = 19},
  [1600] = {.lex_state = 0, .external_lex_state = 19},
  [1601] = {.lex_state = 0, .external_lex_state = 19},
  [1602] = {.lex_state = 0, .external_lex_state = 19},
  [1603] = {.lex_state = 0, .external_lex_state = 19},
  [1604] = {.lex_state = 0, .external_lex_state = 19},
  [1605] = {.lex_state = 0, .external_lex_state = 19},
  [1606] = {.lex_state = 0, .external_lex_state = 19},
  [1607] = {.lex_state = 0, .external_lex_state = 19},
  [1608] = {.lex_state = 0, .external_lex_state = 19},
  [1609] = {.lex_state = 0, .external_lex_state = 19},
  [1610] = {.lex_state = 0, .external_lex_state = 19},
  [1611] = {.lex_state = 0, .external_lex_state = 19},
  [1612] = {.lex_state = 0, .external_lex_state = 19},
  [1613] = {.lex_state = 0, .external_lex_state = 19},
  [1614] = {.lex_state = 0, .external_lex_state = 19},
  [1615] = {.lex_state = 0, .external_lex_state = 19},
  [1616] = {.lex_state = 0, .external_lex_state = 19},
  [1617] = {.lex_state = 0, .external_lex_state = 19},
  [1618] = {.lex_state = 0, .external_lex_state = 19},
  [1619] = {.lex_state = 0, .external_lex_state = 19},
  [1620] = {.lex_state = 0, .external_lex_state = 19},
  [1621] = {.lex_state = 0, .external_lex_state = 19},
  [1622] = {.lex_state = 0, .external_lex_state = 19},
  [1623] = {.lex_state = 0, .external_lex_state = 19},
  [1624] = {.lex_state = 0, .external_lex_state = 19},
  [1625] = {.lex_state = 0, .external_lex_state = 19},
  [1626] = {.lex_state = 0, .external_lex_state = 19},
  [1627] = {.lex_state = 0, .external_lex_state = 19},
  [1628] = {.lex_state = 0, .external_lex_state = 19},
  [1629] = {.lex_state = 0, .external_lex_state = 19},
  [1630] = {.lex_state = 0, .external_lex_state = 19},
  [1631] = {.lex_state = 0, .external_lex_state = 19},
  [1632] = {.lex_state = 0, .external_lex_state = 19},
  [1633] = {.lex_state = 0, .external_lex_state = 19},
  [1634] = {.lex_state = 0, .external_lex_state = 19},
  [1635] = {.lex_state = 0, .external_lex_state = 19},
  [1636] = {.lex_state = 0, .external_lex_state = 19},
  [1637] = {.lex_state = 0, .external_lex_state = 19},
  [1638] = {.lex_state = 0, .external_lex_state = 19},
  [1639] = {.lex_state = 0, .external_lex_state = 19},
  [1640] = {.lex_state = 0, .external_lex_state = 19},
  [1641] = {.lex_state = 0, .external_lex_state = 19},
  [1642] = {.lex_state = 0, .external_lex_state = 19},
  [1643] = {.lex_state = 0, .external_lex_state = 19},
  [1644] = {.lex_state = 0, .external_lex_state = 19},
  [1645] = {.lex_state = 0, .external_lex_state = 19},
  [1646] = {.lex_state = 0, .external_lex_state = 19},
  [1647] = {.lex_state = 0, .external_lex_state = 19},
  [1648] = {.lex_state = 0, .external_lex_state = 19},
  [1649] = {.lex_state = 0, .external_lex_state = 19},
  [1650] = {.lex_state = 0, .external_lex_state = 19},
  [1651] = {.lex_state = 0, .external_lex_state = 19},
  [1652] = {.lex_state = 0, .external_lex_state = 19},
  [1653] = {.lex_state = 0, .external_lex_state = 19},
  [1654] = {.lex_state = 0, .external_lex_state = 19},
  [1655] = {.lex_state = 0, .external_lex_state = 19},
  [1656] = {.lex_state = 0, .external_lex_state = 19},
  [1657] = {.lex_state = 0, .external_lex_state = 19},
  [1658] = {.lex_state = 0, .external_lex_state = 19},
  [1659] = {.lex_state = 0, .external_lex_state = 19},
  [1660] = {.lex_state = 0, .external_lex_state = 19},
  [1661] = {.lex_state = 0, .external_lex_state = 19},
  [1662] = {.lex_state = 0, .external_lex_state = 19},
  [1663] = {.lex_state = 0, .external_lex_state = 19},
  [1664] = {.lex_state = 0, .external_lex_state = 19},
  [1665] = {.lex_state = 0, .external_lex_state = 19},
  [1666] = {.lex_state = 0, .external_lex_state = 19},
  [1667] = {.lex_state = 0, .external_lex_state = 19},
  [1668] = {.lex_state = 0, .external_lex_state = 19},
  [1669] = {.lex_state = 0, .external_lex_state = 19},
  [1670] = {.lex_state = 0, .external_lex_state = 19},
  [1671] = {.lex_state = 0, .external_lex_state = 19},
  [1672] = {.lex_state = 0, .external_lex_state = 19},
  [1673] = {.lex_state = 0, .external_lex_state = 19},
  [1674] = {.lex_state = 0, .external_lex_state = 19},
  [1675] = {.lex_state = 0, .external_lex_state = 19},
  [1676] = {.lex_state = 0, .external_lex_state = 19},
  [1677] = {.lex_state = 0, .external_lex_state = 19},
  [1678] = {.lex_state = 0, .external_lex_state = 19},
  [1679] = {.lex_state = 0, .external_lex_state = 19},
  [1680] = {.lex_state = 0, .external_lex_state = 19},
  [1681] = {.lex_state = 0, .external_lex_state = 19},
  [1682] = {.lex_state = 0, .external_lex_state = 19},
  [1683] = {.lex_state = 0, .external_lex_state = 19},
  [1684] = {.lex_state = 0, .external_lex_state = 19},
  [1685] = {.lex_state = 0, .external_lex_state = 19},
  [1686] = {.lex_state = 0, .external_lex_state = 19},
  [1687] = {.lex_state = 0, .external_lex_state = 19},
  [1688] = {.lex_state = 0, .external_lex_state = 19},
  [1689] = {.lex_state = 0, .external_lex_state = 19},
  [1690] = {.lex_state = 0, .external_lex_state = 19},
  [1691] = {.lex_state = 0, .external_lex_state = 19},
  [1692] = {.lex_state = 0, .external_lex_state = 19},
  [1693] = {.lex_state = 0, .external_lex_state = 19},
  [1694] = {.lex_state = 0, .external_lex_state = 19},
  [1695] = {.lex_state = 0, .external_lex_state = 19},
  [1696] = {.lex_state = 0, .external_lex_state = 19},
  [1697] = {.lex_state = 0, .external_lex_state = 19},
  [1698] = {.lex_state = 0, .external_lex_state = 19},
  [1699] = {.lex_state = 0, .external_lex_state = 19},
  [1700] = {.lex_state = 0, .external_lex_state = 19},
  [1701] = {.lex_state = 0, .external_lex_state = 19},
  [1702] = {.lex_state = 0, .external_lex_state = 19},
  [1703] = {.lex_state = 0, .external_lex_state = 19},
  [1704] = {.lex_state = 0, .external_lex_state = 19},
  [1705] = {.lex_state = 0, .external_lex_state = 19},
  [1706] = {.lex_state = 0, .external_lex_state = 19},
  [1707] = {.lex_state = 0, .external_lex_state = 19},
  [1708] = {.lex_state = 0, .external_lex_state = 19},
  [1709] = {.lex_state = 0, .external_lex_state = 19},
  [1710] = {.lex_state = 0, .external_lex_state = 19},
  [1711] = {.lex_state = 0, .external_lex_state = 19},
  [1712] = {.lex_state = 0, .external_lex_state = 19},
  [1713] = {.lex_state = 0, .external_lex_state = 19},
  [1714] = {.lex_state = 0, .external_lex_state = 19},
  [1715] = {.lex_state = 0, .external_lex_state = 19},
  [1716] = {.lex_state = 0, .external_lex_state = 19},
  [1717] = {.lex_state = 0, .external_lex_state = 19},
  [1718] = {.lex_state = 0, .external_lex_state = 19},
  [1719] = {.lex_state = 1, .external_lex_state = 20},
  [1720] = {.lex_state = 1, .external_lex_state = 20},
  [1721] = {.lex_state = 1, .external_lex_state = 21},
  [1722] = {.lex_state = 1, .external_lex_state = 21},
  [1723] = {.lex_state = 1, .external_lex_state = 22},
  [1724] = {.lex_state = 0, .external_lex_state = 23},
  [1725] = {.lex_state = 0, .external_lex_state = 23},
  [1726] = {.lex_state = 0, .external_lex_state = 23},
  [1727] = {.lex_state = 0, .external_lex_state = 23},
  [1728] = {.lex_state = 0, .external_lex_state = 23},
  [1729] = {.lex_state = 1, .external_lex_state = 24},
  [1730] = {.lex_state = 0, .external_lex_state = 23},
  [1731] = {.lex_state = 0, .external_lex_state = 23},
  [1732] = {.lex_state = 0, .external_lex_state = 23},
  [1733] = {.lex_state = 0, .external_lex_state = 23},
  [1734] = {.lex_state = 0, .external_lex_state = 23},
  [1735] = {.lex_state = 0, .external_lex_state = 23},
  [1736] = {.lex_state = 0, .external_lex_state = 23},
  [1737] = {.lex_state = 0, .external_lex_state = 23},
  [1738] = {.lex_state = 0, .external_lex_state = 23},
  [1739] = {.lex_state = 0, .external_lex_state = 23},
  [1740] = {.lex_state = 0, .external_lex_state = 23},
  [1741] = {.lex_state = 0, .external_lex_state = 23},
  [1742] = {.lex_state = 0, .external_lex_state = 23},
  [1743] = {.lex_state = 0, .external_lex_state = 23},
  [1744] = {.lex_state = 0, .external_lex_state = 23},
  [1745] = {.lex_state = 0, .external_lex_state = 23},
  [1746] = {.lex_state = 0, .external_lex_state = 23},
  [1747] = {.lex_state = 0, .external_lex_state = 23},
  [1748] = {.lex_state = 0, .external_lex_state = 23},
  [1749] = {.lex_state = 1, .external_lex_state = 20},
  [1750] = {.lex_state = 0, .external_lex_state = 23},
  [1751] = {.lex_state = 0, .external_lex_state = 23},
  [1752] = {.lex_state = 0, .external_lex_state = 23},
  [1753] = {.lex_state = 0, .external_lex_state = 23},
  [1754] = {.lex_state = 0, .external_lex_state = 23},
  [1755] = {.lex_state = 0, .external_lex_state = 23},
  [1756] = {.lex_state = 0, .external_lex_state = 23},
  [1757] = {.lex_state = 0, .external_lex_state = 23},
  [1758] = {.lex_state = 0, .external_lex_state = 23},
  [1759] = {.lex_state = 0, .external_lex_state = 23},
  [1760] = {.lex_state = 0, .external_lex_state = 23},
  [1761] = {.lex_state = 0, .external_lex_state = 23},
  [1762] = {.lex_state = 0, .external_lex_state = 23},
  [1763] = {.lex_state = 0, .external_lex_state = 23},
  [1764] = {.lex_state = 0, .external_lex_state = 23},
  [1765] = {.lex_state = 0, .external_lex_state = 23},
  [1766] = {.lex_state = 0, .external_lex_state = 23},
  [1767] = {.lex_state = 0, .external_lex_state = 23},
  [1768] = {.lex_state = 0, .external_lex_state = 23},
  [1769] = {.lex_state = 0, .external_lex_state = 23},
  [1770] = {.lex_state = 0, .external_lex_state = 23},
  [1771] = {.lex_state = 0, .external_lex_state = 23},
  [1772] = {.lex_state = 0, .external_lex_state = 23},
  [1773] = {.lex_state = 0, .external_lex_state = 23},
  [1774] = {.lex_state = 0, .external_lex_state = 23},
  [1775] = {.lex_state = 0, .external_lex_state = 23},
  [1776] = {.lex_state = 0, .external_lex_state = 23},
  [1777] = {.lex_state = 0, .external_lex_state = 23},
  [1778] = {.lex_state = 0, .external_lex_state = 23},
  [1779] = {.lex_state = 0, .external_lex_state = 23},
  [1780] = {.lex_state = 0, .external_lex_state = 23},
  [1781] = {.lex_state = 0, .external_lex_state = 23},
  [1782] = {.lex_state = 0, .external_lex_state = 23},
  [1783] = {.lex_state = 0, .external_lex_state = 23},
  [1784] = {.lex_state = 0, .external_lex_state = 25},
  [1785] = {.lex_state = 0, .external_lex_state = 25},
  [1786] = {.lex_state = 0, .external_lex_state = 25},
  [1787] = {.lex_state = 0, .external_lex_state = 25},
  [1788] = {.lex_state = 0, .external_lex_state = 25},
  [1789] = {.lex_state = 0, .external_lex_state = 25},
  [1790] = {.lex_state = 0, .external_lex_state = 25},
  [1791] = {.lex_state = 0, .external_lex_state = 25},
  [1792] = {.lex_state = 0, .external_lex_state = 25},
  [1793] = {.lex_state = 0, .external_lex_state = 25},
  [1794] = {.lex_state = 0, .external_lex_state = 25},
  [1795] = {.lex_state = 0, .external_lex_state = 25},
  [1796] = {.lex_state = 0, .external_lex_state = 25},
  [1797] = {.lex_state = 0, .external_lex_state = 25},
  [1798] = {.lex_state = 0, .external_lex_state = 25},
  [1799] = {.lex_state = 0, .external_lex_state = 25},
  [1800] = {.lex_state = 0, .external_lex_state = 25},
  [1801] = {.lex_state = 0, .external_lex_state = 25},
  [1802] = {.lex_state = 0, .external_lex_state = 25},
  [1803] = {.lex_state = 0, .external_lex_state = 25},
  [1804] = {.lex_state = 0, .external_lex_state = 25},
  [1805] = {.lex_state = 0, .external_lex_state = 25},
  [1806] = {.lex_state = 0, .external_lex_state = 25},
  [1807] = {.lex_state = 0, .external_lex_state = 25},
  [1808] = {.lex_state = 0, .external_lex_state = 25},
  [1809] = {.lex_state = 0, .external_lex_state = 25},
  [1810] = {.lex_state = 0, .external_lex_state = 25},
  [1811] = {.lex_state = 0, .external_lex_state = 25},
  [1812] = {.lex_state = 0, .external_lex_state = 25},
  [1813] = {.lex_state = 0, .external_lex_state = 25},
  [1814] = {.lex_state = 0, .external_lex_state = 25},
  [1815] = {.lex_state = 0, .external_lex_state = 25},
  [1816] = {.lex_state = 0, .external_lex_state = 25},
  [1817] = {.lex_state = 0, .external_lex_state = 25},
  [1818] = {.lex_state = 0, .external_lex_state = 25},
  [1819] = {.lex_state = 0, .external_lex_state = 25},
  [1820] = {.lex_state = 0, .external_lex_state = 25},
  [1821] = {.lex_state = 0, .external_lex_state = 25},
  [1822] = {.lex_state = 0, .external_lex_state = 25},
  [1823] = {.lex_state = 0, .external_lex_state = 25},
  [1824] = {.lex_state = 0, .external_lex_state = 25},
  [1825] = {.lex_state = 0, .external_lex_state = 25},
  [1826] = {.lex_state = 0, .external_lex_state = 25},
  [1827] = {.lex_state = 0, .external_lex_state = 25},
  [1828] = {.lex_state = 0, .external_lex_state = 25},
  [1829] = {.lex_state = 0, .external_lex_state = 25},
  [1830] = {.lex_state = 0, .external_lex_state = 25},
  [1831] = {.lex_state = 0, .external_lex_state = 25},
  [1832] = {.lex_state = 0, .external_lex_state = 25},
  [1833] = {.lex_state = 0, .external_lex_state = 25},
  [1834] = {.lex_state = 0, .external_lex_state = 25},
  [1835] = {.lex_state = 0, .external_lex_state = 25},
  [1836] = {.lex_state = 0, .external_lex_state = 25},
  [1837] = {.lex_state = 0, .external_lex_state = 25},
  [1838] = {.lex_state = 0, .external_lex_state = 25},
  [1839] = {.lex_state = 0, .external_lex_state = 25},
  [1840] = {.lex_state = 0, .external_lex_state = 25},
  [1841] = {.lex_state = 0, .external_lex_state = 25},
  [1842] = {.lex_state = 0, .external_lex_state = 25},
  [1843] = {.lex_state = 0, .external_lex_state = 25},
  [1844] = {.lex_state = 0, .external_lex_state = 25},
  [1845] = {.lex_state = 0, .external_lex_state = 25},
  [1846] = {.lex_state = 0, .external_lex_state = 25},
  [1847] = {.lex_state = 0, .external_lex_state = 25},
  [1848] = {.lex_state = 0, .external_lex_state = 25},
  [1849] = {.lex_state = 0, .external_lex_state = 25},
  [1850] = {.lex_state = 0, .external_lex_state = 25},
  [1851] = {.lex_state = 0, .external_lex_state = 25},
  [1852] = {.lex_state = 0, .external_lex_state = 25},
  [1853] = {.lex_state = 0, .external_lex_state = 25},
  [1854] = {.lex_state = 0, .external_lex_state = 25},
  [1855] = {.lex_state = 0, .external_lex_state = 25},
  [1856] = {.lex_state = 0, .external_lex_state = 25},
  [1857] = {.lex_state = 0, .external_lex_state = 25},
  [1858] = {.lex_state = 0, .external_lex_state = 25},
  [1859] = {.lex_state = 0, .external_lex_state = 25},
  [1860] = {.lex_state = 0, .external_lex_state = 25},
  [1861] = {.lex_state = 0, .external_lex_state = 25},
  [1862] = {.lex_state = 0, .external_lex_state = 25},
  [1863] = {.lex_state = 0, .external_lex_state = 25},
  [1864] = {.lex_state = 0, .external_lex_state = 25},
  [1865] = {.lex_state = 0, .external_lex_state = 25},
  [1866] = {.lex_state = 0, .external_lex_state = 25},
  [1867] = {.lex_state = 0, .external_lex_state = 25},
  [1868] = {.lex_state = 0, .external_lex_state = 25},
  [1869] = {.lex_state = 0, .external_lex_state = 25},
  [1870] = {.lex_state = 0, .external_lex_state = 25},
  [1871] = {.lex_state = 1, .external_lex_state = 21},
  [1872] = {.lex_state = 0, .external_lex_state = 25},
  [1873] = {.lex_state = 0, .external_lex_state = 25},
  [1874] = {.lex_state = 0, .external_lex_state = 25},
  [1875] = {.lex_state = 0, .external_lex_state = 25},
  [1876] = {.lex_state = 0, .external_lex_state = 25},
  [1877] = {.lex_state = 0, .external_lex_state = 25},
  [1878] = {.lex_state = 0, .external_lex_state = 25},
  [1879] = {.lex_state = 0, .external_lex_state = 25},
  [1880] = {.lex_state = 0, .external_lex_state = 25},
  [1881] = {.lex_state = 0, .external_lex_state = 25},
  [1882] = {.lex_state = 0, .external_lex_state = 25},
  [1883] = {.lex_state = 0, .external_lex_state = 25},
  [1884] = {.lex_state = 0, .external_lex_state = 25},
  [1885] = {.lex_state = 0, .external_lex_state = 25},
  [1886] = {.lex_state = 0, .external_lex_state = 25},
  [1887] = {.lex_state = 0, .external_lex_state = 25},
  [1888] = {.lex_state = 0, .external_lex_state = 25},
  [1889] = {.lex_state = 0, .external_lex_state = 25},
  [1890] = {.lex_state = 0, .external_lex_state = 25},
  [1891] = {.lex_state = 0, .external_lex_state = 25},
  [1892] = {.lex_state = 0, .external_lex_state = 25},
  [1893] = {.lex_state = 0, .external_lex_state = 25},
  [1894] = {.lex_state = 0, .external_lex_state = 25},
  [1895] = {.lex_state = 0, .external_lex_state = 25},
  [1896] = {.lex_state = 0, .external_lex_state = 25},
  [1897] = {.lex_state = 0, .external_lex_state = 25},
  [1898] = {.lex_state = 0, .external_lex_state = 25},
  [1899] = {.lex_state = 0, .external_lex_state = 25},
  [1900] = {.lex_state = 0, .external_lex_state = 25},
  [1901] = {.lex_state = 0, .external_lex_state = 25},
  [1902] = {.lex_state = 0, .external_lex_state = 25},
  [1903] = {.lex_state = 0, .external_lex_state = 25},
  [1904] = {.lex_state = 0, .external_lex_state = 25},
  [1905] = {.lex_state = 0, .external_lex_state = 25},
  [1906] = {.lex_state = 0, .external_lex_state = 25},
  [1907] = {.lex_state = 0, .external_lex_state = 25},
  [1908] = {.lex_state = 0, .external_lex_state = 11},
  [1909] = {.lex_state = 0, .external_lex_state = 10},
  [1910] = {.lex_state = 0, .external_lex_state = 23},
  [1911] = {.lex_state = 0, .external_lex_state = 23},
  [1912] = {.lex_state = 0, .external_lex_state = 14},
  [1913] = {.lex_state = 0, .external_lex_state = 23},
  [1914] = {.lex_state = 1, .external_lex_state = 23},
  [1915] = {.lex_state = 0, .external_lex_state = 23},
  [1916] = {.lex_state = 0, .external_lex_state = 14},
  [1917] = {.lex_state = 0, .external_lex_state = 23},
  [1918] = {.lex_state = 0, .external_lex_state = 14},
  [1919] = {.lex_state = 0, .external_lex_state = 14},
  [1920] = {.lex_state = 0, .external_lex_state = 10},
  [1921] = {.lex_state = 0, .external_lex_state = 14},
  [1922] = {.lex_state = 0, .external_lex_state = 23},
  [1923] = {.lex_state = 0, .external_lex_state = 23},
  [1924] = {.lex_state = 0, .external_lex_state = 11},
  [1925] = {.lex_state = 0, .external_lex_state = 11},
  [1926] = {.lex_state = 0, .external_lex_state = 10},
  [1927] = {.lex_state = 0, .external_lex_state = 14},
  [1928] = {.lex_state = 0, .external_lex_state = 11},
  [1929] = {.lex_state = 0, .external_lex_state = 23},
  [1930] = {.lex_state = 0, .external_lex_state = 11},
  [1931] = {.lex_state = 0, .external_lex_state = 14},
  [1932] = {.lex_state = 0, .external_lex_state = 10},
  [1933] = {.lex_state = 0, .external_lex_state = 11},
  [1934] = {.lex_state = 0, .external_lex_state = 10},
  [1935] = {.lex_state = 0, .external_lex_state = 16},
  [1936] = {.lex_state = 0, .external_lex_state = 11},
  [1937] = {.lex_state = 0, .external_lex_state = 10},
  [1938] = {.lex_state = 0, .external_lex_state = 10},
  [1939] = {.lex_state = 0, .external_lex_state = 25},
  [1940] = {.lex_state = 0, .external_lex_state = 17},
  [1941] = {.lex_state = 0, .external_lex_state = 25},
  [1942] = {.lex_state = 0, .external_lex_state = 25},
  [1943] = {.lex_state = 0, .external_lex_state = 25},
  [1944] = {.lex_state = 0, .external_lex_state = 25},
  [1945] = {.lex_state = 1, .external_lex_state = 25},
  [1946] = {.lex_state = 0, .external_lex_state = 25},
  [1947] = {.lex_state = 0, .external_lex_state = 25},
  [1948] = {.lex_state = 0, .external_lex_state = 25},
  [1949] = {.lex_state = 0, .external_lex_state = 14},
  [1950] = {.lex_state = 0, .external_lex_state = 23},
  [1951] = {.lex_state = 0, .external_lex_state = 23},
  [1952] = {.lex_state = 0, .external_lex_state = 17},
  [1953] = {.lex_state = 0, .external_lex_state = 23},
  [1954] = {.lex_state = 0, .external_lex_state = 17},
  [1955] = {.lex_state = 0, .external_lex_state = 23},
  [1956] = {.lex_state = 0, .external_lex_state = 23},
  [1957] = {.lex_state = 0, .external_lex_state = 23},
  [1958] = {.lex_state = 0, .external_lex_state = 23},
  [1959] = {.lex_state = 0, .external_lex_state = 23},
  [1960] = {.lex_state = 0, .external_lex_state = 23},
  [1961] = {.lex_state = 0, .external_lex_state = 23},
  [1962] = {.lex_state = 0, .external_lex_state = 23},
  [1963] = {.lex_state = 0, .external_lex_state = 23},
  [1964] = {.lex_state = 0, .external_lex_state = 23},
  [1965] = {.lex_state = 0, .external_lex_state = 23},
  [1966] = {.lex_state = 0, .external_lex_state = 23},
  [1967] = {.lex_state = 0, .external_lex_state = 23},
  [1968] = {.lex_state = 0, .external_lex_state = 23},
  [1969] = {.lex_state = 0, .external_lex_state = 23},
  [1970] = {.lex_state = 0, .external_lex_state = 23},
  [1971] = {.lex_state = 0, .external_lex_state = 17},
  [1972] = {.lex_state = 0, .external_lex_state = 25},
  [1973] = {.lex_state = 0, .external_lex_state = 25},
  [1974] = {.lex_state = 0, .external_lex_state = 25},
  [1975] = {.lex_state = 0, .external_lex_state = 25},
  [1976] = {.lex_state = 0, .external_lex_state = 25},
  [1977] = {.lex_state = 0, .external_lex_state = 25},
  [1978] = {.lex_state = 0, .external_lex_state = 25},
  [1979] = {.lex_state = 0, .external_lex_state = 25},
  [1980] = {.lex_state = 0, .external_lex_state = 25},
  [1981] = {.lex_state = 0, .external_lex_state = 25},
  [1982] = {.lex_state = 0, .external_lex_state = 25},
  [1983] = {.lex_state = 0, .external_lex_state = 25},
  [1984] = {.lex_state = 0, .external_lex_state = 25},
  [1985] = {.lex_state = 0, .external_lex_state = 25},
  [1986] = {.lex_state = 0, .external_lex_state = 25},
  [1987] = {.lex_state = 0, .external_lex_state = 25},
  [1988] = {.lex_state = 0, .external_lex_state = 25},
  [1989] = {.lex_state = 0, .external_lex_state = 25},
  [1990] = {.lex_state = 0, .external_lex_state = 25},
  [1991] = {.lex_state = 3, .external_lex_state = 26},
  [1992] = {.lex_state = 3},
  [1993] = {.lex_state = 0, .external_lex_state = 27},
  [1994] = {.lex_state = 2},
  [1995] = {.lex_state = 0, .external_lex_state = 26},
  [1996] = {.lex_state = 2},
  [1997] = {.lex_state = 4},
  [1998] = {.lex_state = 4},
  [1999] = {.lex_state = 4},
  [2000] = {.lex_state = 2},
  [2001] = {.lex_state = 4},
  [2002] = {.lex_state = 2},
  [2003] = {.lex_state = 0, .external_lex_state = 27},
  [2004] = {.lex_state = 0, .external_lex_state = 27},
  [2005] = {.lex_state = 2},
  [2006] = {.lex_state = 4},
  [2007] = {.lex_state = 2},
  [2008] = {.lex_state = 4},
  [2009] = {.lex_state = 2},
  [2010] = {.lex_state = 4},
  [2011] = {.lex_state = 4},
  [2012] = {.lex_state = 4},
  [2013] = {.lex_state = 2},
  [2014] = {.lex_state = 2},
  [2015] = {.lex_state = 0, .external_lex_state = 27},
  [2016] = {.lex_state = 2},
  [2017] = {.lex_state = 4},
  [2018] = {.lex_state = 4},
  [2019] = {.lex_state = 2},
  [2020] = {.lex_state = 4},
  [2021] = {.lex_state = 0, .external_lex_state = 27},
  [2022] = {.lex_state = 2},
  [2023] = {.lex_state = 0, .external_lex_state = 27},
  [2024] = {.lex_state = 4},
  [2025] = {.lex_state = 4},
  [2026] = {.lex_state = 2},
  [2027] = {.lex_state = 4},
  [2028] = {.lex_state = 2},
  [2029] = {.lex_state = 4},
  [2030] = {.lex_state = 2},
  [2031] = {.lex_state = 0, .external_lex_state = 27},
  [2032] = {.lex_state = 0, .external_lex_state = 26},
  [2033] = {.lex_state = 4},
  [2034] = {.lex_state = 2},
  [2035] = {.lex_state = 4},
  [2036] = {.lex_state = 0, .external_lex_state = 27},
  [2037] = {.lex_state = 0, .external_lex_state = 27},
  [2038] = {.lex_state = 4},
  [2039] = {.lex_state = 2},
  [2040] = {.lex_state = 0, .external_lex_state = 27},
  [2041] = {.lex_state = 0, .external_lex_state = 27},
  [2042] = {.lex_state = 4},
  [2043] = {.lex_state = 0, .external_lex_state = 27},
  [2044] = {.lex_state = 0, .external_lex_state = 27},
  [2045] = {.lex_state = 2},
  [2046] = {.lex_state = 0, .external_lex_state = 27},
  [2047] = {.lex_state = 0, .external_lex_state = 27},
  [2048] = {.lex_state = 2},
  [2049] = {.lex_state = 0, .external_lex_state = 27},
  [2050] = {.lex_state = 0, .external_lex_state = 27},
  [2051] = {.lex_state = 0, .external_lex_state = 27},
  [2052] = {.lex_state = 0, .external_lex_state = 27},
  [2053] = {.lex_state = 4},
  [2054] = {.lex_state = 0, .external_lex_state = 27},
  [2055] = {.lex_state = 2},
  [2056] = {.lex_state = 0, .external_lex_state = 27},
  [2057] = {.lex_state = 0, .external_lex_state = 27},
  [2058] = {.lex_state = 4},
  [2059] = {.lex_state = 0, .external_lex_state = 27},
  [2060] = {.lex_state = 2},
  [2061] = {.lex_state = 0, .external_lex_state = 27},
  [2062] = {.lex_state = 4},
  [2063] = {.lex_state = 0, .external_lex_state = 27},
  [2064] = {.lex_state = 2},
  [2065] = {.lex_state = 0, .external_lex_state = 27},
  [2066] = {.lex_state = 4},
  [2067] = {.lex_state = 0, .external_lex_state = 27},
  [2068] = {.lex_state = 4},
  [2069] = {.lex_state = 0, .external_lex_state = 27},
  [2070] = {.lex_state = 0, .external_lex_state = 27},
  [2071] = {.lex_state = 0, .external_lex_state = 27},
  [2072] = {.lex_state = 2},
  [2073] = {.lex_state = 0, .external_lex_state = 27},
  [2074] = {.lex_state = 0, .external_lex_state = 27},
  [2075] = {.lex_state = 0, .external_lex_state = 27},
  [2076] = {.lex_state = 0, .external_lex_state = 27},
  [2077] = {.lex_state = 0, .external_lex_state = 27},
  [2078] = {.lex_state = 0, .external_lex_state = 27},
  [2079] = {.lex_state = 0, .external_lex_state = 27},
  [2080] = {.lex_state = 0, .external_lex_state = 27},
  [2081] = {.lex_state = 0, .external_lex_state = 27},
  [2082] = {.lex_state = 0, .external_lex_state = 27},
  [2083] = {.lex_state = 0, .external_lex_state = 27},
  [2084] = {.lex_state = 0, .external_lex_state = 27},
  [2085] = {.lex_state = 0, .external_lex_state = 27},
  [2086] = {.lex_state = 0, .external_lex_state = 27},
  [2087] = {.lex_state = 0, .external_lex_state = 27},
  [2088] = {.lex_state = 0, .external_lex_state = 27},
  [2089] = {.lex_state = 2},
  [2090] = {.lex_state = 0, .external_lex_state = 27},
  [2091] = {.lex_state = 0, .external_lex_state = 27},
  [2092] = {.lex_state = 0, .external_lex_state = 27},
  [2093] = {.lex_state = 0, .external_lex_state = 27},
  [2094] = {.lex_state = 0, .external_lex_state = 27},
  [2095] = {.lex_state = 0, .external_lex_state = 27},
  [2096] = {.lex_state = 0, .external_lex_state = 27},
  [2097] = {.lex_state = 0, .external_lex_state = 27},
  [2098] = {.lex_state = 0, .external_lex_state = 27},
  [2099] = {.lex_state = 0, .external_lex_state = 27},
  [2100] = {.lex_state = 0, .external_lex_state = 27},
  [2101] = {.lex_state = 0, .external_lex_state = 27},
  [2102] = {.lex_state = 0, .external_lex_state = 27},
  [2103] = {.lex_state = 0, .external_lex_state = 27},
  [2104] = {.lex_state = 0, .external_lex_state = 27},
  [2105] = {.lex_state = 0, .external_lex_state = 27},
  [2106] = {.lex_state = 0, .external_lex_state = 27},
  [2107] = {.lex_state = 0, .external_lex_state = 27},
  [2108] = {.lex_state = 0, .external_lex_state = 27},
  [2109] = {.lex_state = 0, .external_lex_state = 27},
  [2110] = {.lex_state = 0, .external_lex_state = 27},
  [2111] = {.lex_state = 0, .external_lex_state = 27},
  [2112] = {.lex_state = 0, .external_lex_state = 27},
  [2113] = {.lex_state = 0, .external_lex_state = 27},
  [2114] = {.lex_state = 0, .external_lex_state = 27},
  [2115] = {.lex_state = 0, .external_lex_state = 27},
  [2116] = {.lex_state = 2},
  [2117] = {.lex_state = 2},
  [2118] = {.lex_state = 0, .external_lex_state = 28},
  [2119] = {.lex_state = 0, .external_lex_state = 26},
  [2120] = {.lex_state = 0, .external_lex_state = 28},
  [2121] = {.lex_state = 0, .external_lex_state = 26},
  [2122] = {.lex_state = 0, .external_lex_state = 28},
  [2123] = {.lex_state = 0, .external_lex_state = 28},
  [2124] = {.lex_state = 0, .external_lex_state = 28},
  [2125] = {.lex_state = 0, .external_lex_state = 28},
  [2126] = {.lex_state = 0, .external_lex_state = 28},
  [2127] = {.lex_state = 0, .external_lex_state = 28},
  [2128] = {.lex_state = 0, .external_lex_state = 28},
  [2129] = {.lex_state = 4},
  [2130] = {.lex_state = 0, .external_lex_state = 28},
  [2131] = {.lex_state = 0, .external_lex_state = 28},
  [2132] = {.lex_state = 0, .external_lex_state = 28},
  [2133] = {.lex_state = 0, .external_lex_state = 27},
  [2134] = {.lex_state = 0},
  [2135] = {.lex_state = 0, .external_lex_state = 26},
  [2136] = {.lex_state = 0},
  [2137] = {.lex_state = 0},
  [2138] = {.lex_state = 0, .external_lex_state = 26},
  [2139] = {.lex_state = 0},
  [2140] = {.lex_state = 0},
  [2141] = {.lex_state = 0},
  [2142] = {.lex_state = 0},
  [2143] = {.lex_state = 0},
  [2144] = {.lex_state = 0},
  [2145] = {.lex_state = 0},
  [2146] = {.lex_state = 0, .external_lex_state = 26},
  [2147] = {.lex_state = 0},
  [2148] = {.lex_state = 0},
  [2149] = {.lex_state = 0, .external_lex_state = 26},
  [2150] = {.lex_state = 1},
  [2151] = {.lex_state = 1},
  [2152] = {.lex_state = 1},
  [2153] = {.lex_state = 1},
  [2154] = {.lex_state = 1},
  [2155] = {.lex_state = 1},
  [2156] = {.lex_state = 1},
  [2157] = {.lex_state = 1},
  [2158] = {.lex_state = 1},
  [2159] = {.lex_state = 1},
  [2160] = {.lex_state = 1},
  [2161] = {.lex_state = 1},
  [2162] = {.lex_state = 1},
  [2163] = {.lex_state = 1},
  [2164] = {.lex_state = 1},
  [2165] = {.lex_state = 1},
  [2166] = {.lex_state = 1},
  [2167] = {.lex_state = 1},
  [2168] = {.lex_state = 1},
  [2169] = {.lex_state = 1},
  [2170] = {.lex_state = 1},
  [2171] = {.lex_state = 1},
  [2172] = {.lex_state = 1},
  [2173] = {.lex_state = 1},
  [2174] = {.lex_state = 1},
  [2175] = {.lex_state = 1},
  [2176] = {.lex_state = 1},
  [2177] = {.lex_state = 1},
  [2178] = {.lex_state = 0},
  [2179] = {.lex_state = 1},
  [2180] = {.lex_state = 1},
  [2181] = {.lex_state = 1},
  [2182] = {.lex_state = 1},
  [2183] = {.lex_state = 1},
  [2184] = {.lex_state = 1},
  [2185] = {.lex_state = 1},
  [2186] = {.lex_state = 1},
  [2187] = {.lex_state = 1},
  [2188] = {.lex_state = 1},
  [2189] = {.lex_state = 1},
  [2190] = {.lex_state = 1},
  [2191] = {.lex_state = 1},
  [2192] = {.lex_state = 1},
  [2193] = {.lex_state = 1},
  [2194] = {.lex_state = 1},
  [2195] = {.lex_state = 1},
  [2196] = {.lex_state = 1},
  [2197] = {.lex_state = 1},
  [2198] = {.lex_state = 1},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_BSLASH] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_repeat] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_LT_DASH] = ACTIONS(1),
    [anon_sym_LT_LT_DASH] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_DASH_GT_GT] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [aux_sym_binary_operator_token1] = ACTIONS(1),
    [anon_sym_PIPE_GT] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1),
    [anon_sym_L] = ACTIONS(1),
    [anon_sym_i] = ACTIONS(1),
    [sym__hex_literal] = ACTIONS(1),
    [sym__number_literal] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_return] = ACTIONS(1),
    [sym_next] = ACTIONS(1),
    [sym_break] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_inf] = ACTIONS(1),
    [sym_nan] = ACTIONS(1),
    [anon_sym_NA] = ACTIONS(1),
    [anon_sym_NA_integer_] = ACTIONS(1),
    [anon_sym_NA_real_] = ACTIONS(1),
    [anon_sym_NA_complex_] = ACTIONS(1),
    [anon_sym_NA_character_] = ACTIONS(1),
    [sym_dots] = ACTIONS(1),
    [sym_dot_dot_i] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1),
    [sym__newline] = ACTIONS(1),
    [sym__semicolon] = ACTIONS(1),
    [sym__raw_string_literal] = ACTIONS(1),
    [sym__external_else] = ACTIONS(1),
    [sym__external_open_parenthesis] = ACTIONS(1),
    [sym__external_close_parenthesis] = ACTIONS(1),
    [sym__external_open_brace] = ACTIONS(1),
    [sym__external_close_brace] = ACTIONS(1),
    [sym__external_open_bracket] = ACTIONS(1),
    [sym__external_close_bracket] = ACTIONS(1),
    [sym__external_open_bracket2] = ACTIONS(1),
    [sym__external_close_bracket2] = ACTIONS(1),
    [sym__error_sentinel] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(2178),
    [sym_function_definition] = STATE(292),
    [sym_if_statement] = STATE(292),
    [sym_for_statement] = STATE(292),
    [sym_while_statement] = STATE(292),
    [sym_repeat_statement] = STATE(292),
    [sym_braced_expression] = STATE(292),
    [sym_parenthesized_expression] = STATE(292),
    [sym_call] = STATE(292),
    [sym_subset] = STATE(292),
    [sym_subset2] = STATE(292),
    [sym_unary_operator] = STATE(292),
    [sym_binary_operator] = STATE(292),
    [sym_extract_operator] = STATE(292),
    [sym_namespace_operator] = STATE(292),
    [sym_integer] = STATE(292),
    [sym_complex] = STATE(292),
    [sym_float] = STATE(292),
    [sym__float_literal] = STATE(744),
    [sym_string] = STATE(706),
    [sym__single_quoted_string] = STATE(745),
    [sym__double_quoted_string] = STATE(747),
    [sym_na] = STATE(292),
    [sym__expression] = STATE(292),
    [sym__string_or_identifier] = STATE(2134),
    [sym__open_parenthesis] = STATE(987),
    [sym__open_brace] = STATE(760),
    [aux_sym_program_repeat1] = STATE(891),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(9),
    [anon_sym_function] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_for] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(27),
    [sym__hex_literal] = ACTIONS(29),
    [sym__number_literal] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_return] = ACTIONS(37),
    [sym_next] = ACTIONS(37),
    [sym_break] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_null] = ACTIONS(37),
    [sym_inf] = ACTIONS(37),
    [sym_nan] = ACTIONS(37),
    [anon_sym_NA] = ACTIONS(39),
    [anon_sym_NA_integer_] = ACTIONS(39),
    [anon_sym_NA_real_] = ACTIONS(39),
    [anon_sym_NA_complex_] = ACTIONS(39),
    [anon_sym_NA_character_] = ACTIONS(39),
    [sym_dots] = ACTIONS(37),
    [sym_dot_dot_i] = ACTIONS(41),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(43),
    [sym__semicolon] = ACTIONS(43),
    [sym__raw_string_literal] = ACTIONS(45),
    [sym__external_open_parenthesis] = ACTIONS(47),
    [sym__external_open_brace] = ACTIONS(49),
  },
  [2] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__else] = STATE(1650),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(51),
    [anon_sym_BSLASH] = ACTIONS(53),
    [anon_sym_function] = ACTIONS(51),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_repeat] = ACTIONS(51),
    [anon_sym_QMARK] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LT_LT_DASH] = ACTIONS(63),
    [anon_sym_COLON_EQ] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(53),
    [sym__number_literal] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [sym_return] = ACTIONS(51),
    [sym_next] = ACTIONS(51),
    [sym_break] = ACTIONS(51),
    [sym_true] = ACTIONS(51),
    [sym_false] = ACTIONS(51),
    [sym_null] = ACTIONS(51),
    [sym_inf] = ACTIONS(51),
    [sym_nan] = ACTIONS(51),
    [anon_sym_NA] = ACTIONS(51),
    [anon_sym_NA_integer_] = ACTIONS(51),
    [anon_sym_NA_real_] = ACTIONS(51),
    [anon_sym_NA_complex_] = ACTIONS(51),
    [anon_sym_NA_character_] = ACTIONS(51),
    [sym_dots] = ACTIONS(51),
    [sym_dot_dot_i] = ACTIONS(53),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(53),
    [sym__newline] = ACTIONS(53),
    [sym__raw_string_literal] = ACTIONS(53),
    [sym__external_else] = ACTIONS(93),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(53),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [3] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__else] = STATE(1648),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(101),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_BSLASH] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(103),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(103),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_repeat] = ACTIONS(103),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LT_LT_DASH] = ACTIONS(113),
    [anon_sym_COLON_EQ] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(101),
    [sym__number_literal] = ACTIONS(103),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [sym_return] = ACTIONS(103),
    [sym_next] = ACTIONS(103),
    [sym_break] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [sym_inf] = ACTIONS(103),
    [sym_nan] = ACTIONS(103),
    [anon_sym_NA] = ACTIONS(103),
    [anon_sym_NA_integer_] = ACTIONS(103),
    [anon_sym_NA_real_] = ACTIONS(103),
    [anon_sym_NA_complex_] = ACTIONS(103),
    [anon_sym_NA_character_] = ACTIONS(103),
    [sym_dots] = ACTIONS(103),
    [sym_dot_dot_i] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(101),
    [sym__semicolon] = ACTIONS(101),
    [sym__raw_string_literal] = ACTIONS(101),
    [sym__external_else] = ACTIONS(143),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(101),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [4] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__else] = STATE(1633),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LT_LT_DASH] = ACTIONS(113),
    [anon_sym_COLON_EQ] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(155),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [5] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__else] = STATE(1620),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(51),
    [anon_sym_BSLASH] = ACTIONS(53),
    [anon_sym_function] = ACTIONS(51),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_repeat] = ACTIONS(51),
    [anon_sym_QMARK] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_COLON_EQ] = ACTIONS(165),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(53),
    [sym__number_literal] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [sym_return] = ACTIONS(51),
    [sym_next] = ACTIONS(51),
    [sym_break] = ACTIONS(51),
    [sym_true] = ACTIONS(51),
    [sym_false] = ACTIONS(51),
    [sym_null] = ACTIONS(51),
    [sym_inf] = ACTIONS(51),
    [sym_nan] = ACTIONS(51),
    [anon_sym_NA] = ACTIONS(51),
    [anon_sym_NA_integer_] = ACTIONS(51),
    [anon_sym_NA_real_] = ACTIONS(51),
    [anon_sym_NA_complex_] = ACTIONS(51),
    [anon_sym_NA_character_] = ACTIONS(51),
    [sym_dots] = ACTIONS(51),
    [sym_dot_dot_i] = ACTIONS(53),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(53),
    [sym__newline] = ACTIONS(53),
    [sym__raw_string_literal] = ACTIONS(53),
    [sym__external_else] = ACTIONS(195),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(53),
    [sym__external_open_brace] = ACTIONS(53),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [6] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__else] = STATE(1624),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_COLON_EQ] = ACTIONS(165),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(151),
    [sym__newline] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(203),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(151),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [7] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__else] = STATE(1625),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(205),
    [anon_sym_BSLASH] = ACTIONS(207),
    [anon_sym_function] = ACTIONS(205),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_for] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(205),
    [anon_sym_repeat] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_COLON_EQ] = ACTIONS(165),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(207),
    [sym__number_literal] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [sym_return] = ACTIONS(205),
    [sym_next] = ACTIONS(205),
    [sym_break] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_null] = ACTIONS(205),
    [sym_inf] = ACTIONS(205),
    [sym_nan] = ACTIONS(205),
    [anon_sym_NA] = ACTIONS(205),
    [anon_sym_NA_integer_] = ACTIONS(205),
    [anon_sym_NA_real_] = ACTIONS(205),
    [anon_sym_NA_complex_] = ACTIONS(205),
    [anon_sym_NA_character_] = ACTIONS(205),
    [sym_dots] = ACTIONS(205),
    [sym_dot_dot_i] = ACTIONS(207),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(207),
    [sym__newline] = ACTIONS(207),
    [sym__raw_string_literal] = ACTIONS(207),
    [sym__external_else] = ACTIONS(209),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(207),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [8] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__else] = STATE(1628),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_BSLASH] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(103),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(103),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_repeat] = ACTIONS(103),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_COLON_EQ] = ACTIONS(165),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(101),
    [sym__number_literal] = ACTIONS(103),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [sym_return] = ACTIONS(103),
    [sym_next] = ACTIONS(103),
    [sym_break] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [sym_inf] = ACTIONS(103),
    [sym_nan] = ACTIONS(103),
    [anon_sym_NA] = ACTIONS(103),
    [anon_sym_NA_integer_] = ACTIONS(103),
    [anon_sym_NA_real_] = ACTIONS(103),
    [anon_sym_NA_complex_] = ACTIONS(103),
    [anon_sym_NA_character_] = ACTIONS(103),
    [sym_dots] = ACTIONS(103),
    [sym_dot_dot_i] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(101),
    [sym__newline] = ACTIONS(101),
    [sym__raw_string_literal] = ACTIONS(101),
    [sym__external_else] = ACTIONS(211),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(101),
    [sym__external_open_brace] = ACTIONS(101),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [9] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__else] = STATE(1639),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(51),
    [anon_sym_BSLASH] = ACTIONS(53),
    [anon_sym_function] = ACTIONS(51),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_repeat] = ACTIONS(51),
    [anon_sym_QMARK] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(53),
    [sym__number_literal] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [sym_return] = ACTIONS(51),
    [sym_next] = ACTIONS(51),
    [sym_break] = ACTIONS(51),
    [sym_true] = ACTIONS(51),
    [sym_false] = ACTIONS(51),
    [sym_null] = ACTIONS(51),
    [sym_inf] = ACTIONS(51),
    [sym_nan] = ACTIONS(51),
    [anon_sym_NA] = ACTIONS(51),
    [anon_sym_NA_integer_] = ACTIONS(51),
    [anon_sym_NA_real_] = ACTIONS(51),
    [anon_sym_NA_complex_] = ACTIONS(51),
    [anon_sym_NA_character_] = ACTIONS(51),
    [sym_dots] = ACTIONS(51),
    [sym_dot_dot_i] = ACTIONS(53),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(53),
    [sym__semicolon] = ACTIONS(53),
    [sym__raw_string_literal] = ACTIONS(53),
    [sym__external_else] = ACTIONS(251),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(53),
    [sym__external_close_brace] = ACTIONS(53),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [10] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__else] = STATE(1646),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(259),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_close_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [11] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__else] = STATE(1647),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(205),
    [anon_sym_BSLASH] = ACTIONS(207),
    [anon_sym_function] = ACTIONS(205),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_for] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(205),
    [anon_sym_repeat] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(207),
    [sym__number_literal] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [sym_return] = ACTIONS(205),
    [sym_next] = ACTIONS(205),
    [sym_break] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_null] = ACTIONS(205),
    [sym_inf] = ACTIONS(205),
    [sym_nan] = ACTIONS(205),
    [anon_sym_NA] = ACTIONS(205),
    [anon_sym_NA_integer_] = ACTIONS(205),
    [anon_sym_NA_real_] = ACTIONS(205),
    [anon_sym_NA_complex_] = ACTIONS(205),
    [anon_sym_NA_character_] = ACTIONS(205),
    [sym_dots] = ACTIONS(205),
    [sym_dot_dot_i] = ACTIONS(207),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(207),
    [sym__semicolon] = ACTIONS(207),
    [sym__raw_string_literal] = ACTIONS(207),
    [sym__external_else] = ACTIONS(261),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_close_brace] = ACTIONS(207),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [12] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__else] = STATE(1606),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_BSLASH] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(103),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(103),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_repeat] = ACTIONS(103),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(101),
    [sym__number_literal] = ACTIONS(103),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [sym_return] = ACTIONS(103),
    [sym_next] = ACTIONS(103),
    [sym_break] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [sym_inf] = ACTIONS(103),
    [sym_nan] = ACTIONS(103),
    [anon_sym_NA] = ACTIONS(103),
    [anon_sym_NA_integer_] = ACTIONS(103),
    [anon_sym_NA_real_] = ACTIONS(103),
    [anon_sym_NA_complex_] = ACTIONS(103),
    [anon_sym_NA_character_] = ACTIONS(103),
    [sym_dots] = ACTIONS(103),
    [sym_dot_dot_i] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(101),
    [sym__semicolon] = ACTIONS(101),
    [sym__raw_string_literal] = ACTIONS(101),
    [sym__external_else] = ACTIONS(263),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(101),
    [sym__external_close_brace] = ACTIONS(101),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [13] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__else] = STATE(1631),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(51),
    [anon_sym_BSLASH] = ACTIONS(53),
    [anon_sym_function] = ACTIONS(51),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_repeat] = ACTIONS(51),
    [anon_sym_QMARK] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LT_LT_DASH] = ACTIONS(63),
    [anon_sym_COLON_EQ] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(53),
    [sym__number_literal] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [sym_return] = ACTIONS(51),
    [sym_next] = ACTIONS(51),
    [sym_break] = ACTIONS(51),
    [sym_true] = ACTIONS(51),
    [sym_false] = ACTIONS(51),
    [sym_null] = ACTIONS(51),
    [sym_inf] = ACTIONS(51),
    [sym_nan] = ACTIONS(51),
    [anon_sym_NA] = ACTIONS(51),
    [anon_sym_NA_integer_] = ACTIONS(51),
    [anon_sym_NA_real_] = ACTIONS(51),
    [anon_sym_NA_complex_] = ACTIONS(51),
    [anon_sym_NA_character_] = ACTIONS(51),
    [sym_dots] = ACTIONS(51),
    [sym_dot_dot_i] = ACTIONS(53),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(53),
    [sym__newline] = ACTIONS(53),
    [sym__raw_string_literal] = ACTIONS(53),
    [sym__external_else] = ACTIONS(265),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(53),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(53),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [14] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__else] = STATE(1635),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LT_LT_DASH] = ACTIONS(63),
    [anon_sym_COLON_EQ] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(151),
    [sym__newline] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(267),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(151),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [15] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__else] = STATE(1599),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(205),
    [anon_sym_BSLASH] = ACTIONS(207),
    [anon_sym_function] = ACTIONS(205),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_for] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(205),
    [anon_sym_repeat] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LT_LT_DASH] = ACTIONS(63),
    [anon_sym_COLON_EQ] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(207),
    [sym__number_literal] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [sym_return] = ACTIONS(205),
    [sym_next] = ACTIONS(205),
    [sym_break] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_null] = ACTIONS(205),
    [sym_inf] = ACTIONS(205),
    [sym_nan] = ACTIONS(205),
    [anon_sym_NA] = ACTIONS(205),
    [anon_sym_NA_integer_] = ACTIONS(205),
    [anon_sym_NA_real_] = ACTIONS(205),
    [anon_sym_NA_complex_] = ACTIONS(205),
    [anon_sym_NA_character_] = ACTIONS(205),
    [sym_dots] = ACTIONS(205),
    [sym_dot_dot_i] = ACTIONS(207),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(207),
    [sym__newline] = ACTIONS(207),
    [sym__raw_string_literal] = ACTIONS(207),
    [sym__external_else] = ACTIONS(269),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(207),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [16] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__else] = STATE(1642),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_BSLASH] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(103),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(103),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_repeat] = ACTIONS(103),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LT_LT_DASH] = ACTIONS(63),
    [anon_sym_COLON_EQ] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(101),
    [sym__number_literal] = ACTIONS(103),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [sym_return] = ACTIONS(103),
    [sym_next] = ACTIONS(103),
    [sym_break] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [sym_inf] = ACTIONS(103),
    [sym_nan] = ACTIONS(103),
    [anon_sym_NA] = ACTIONS(103),
    [anon_sym_NA_integer_] = ACTIONS(103),
    [anon_sym_NA_real_] = ACTIONS(103),
    [anon_sym_NA_complex_] = ACTIONS(103),
    [anon_sym_NA_character_] = ACTIONS(103),
    [sym_dots] = ACTIONS(103),
    [sym_dot_dot_i] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(101),
    [sym__newline] = ACTIONS(101),
    [sym__raw_string_literal] = ACTIONS(101),
    [sym__external_else] = ACTIONS(271),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(101),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(101),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [17] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__else] = STATE(1617),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(51),
    [anon_sym_BSLASH] = ACTIONS(53),
    [anon_sym_function] = ACTIONS(51),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_repeat] = ACTIONS(51),
    [anon_sym_QMARK] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(281),
    [anon_sym_LT_LT_DASH] = ACTIONS(281),
    [anon_sym_COLON_EQ] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(53),
    [sym__number_literal] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [sym_return] = ACTIONS(51),
    [sym_next] = ACTIONS(51),
    [sym_break] = ACTIONS(51),
    [sym_true] = ACTIONS(51),
    [sym_false] = ACTIONS(51),
    [sym_null] = ACTIONS(51),
    [sym_inf] = ACTIONS(51),
    [sym_nan] = ACTIONS(51),
    [anon_sym_NA] = ACTIONS(51),
    [anon_sym_NA_integer_] = ACTIONS(51),
    [anon_sym_NA_real_] = ACTIONS(51),
    [anon_sym_NA_complex_] = ACTIONS(51),
    [anon_sym_NA_character_] = ACTIONS(51),
    [sym_dots] = ACTIONS(51),
    [sym_dot_dot_i] = ACTIONS(53),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(53),
    [sym__newline] = ACTIONS(53),
    [sym__raw_string_literal] = ACTIONS(53),
    [sym__external_else] = ACTIONS(311),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(53),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(53),
  },
  [18] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__else] = STATE(1626),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(53),
    [sym_identifier] = ACTIONS(51),
    [anon_sym_BSLASH] = ACTIONS(53),
    [anon_sym_function] = ACTIONS(51),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_repeat] = ACTIONS(51),
    [anon_sym_QMARK] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LT_LT_DASH] = ACTIONS(113),
    [anon_sym_COLON_EQ] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(53),
    [sym__number_literal] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [sym_return] = ACTIONS(51),
    [sym_next] = ACTIONS(51),
    [sym_break] = ACTIONS(51),
    [sym_true] = ACTIONS(51),
    [sym_false] = ACTIONS(51),
    [sym_null] = ACTIONS(51),
    [sym_inf] = ACTIONS(51),
    [sym_nan] = ACTIONS(51),
    [anon_sym_NA] = ACTIONS(51),
    [anon_sym_NA_integer_] = ACTIONS(51),
    [anon_sym_NA_real_] = ACTIONS(51),
    [anon_sym_NA_complex_] = ACTIONS(51),
    [anon_sym_NA_character_] = ACTIONS(51),
    [sym_dots] = ACTIONS(51),
    [sym_dot_dot_i] = ACTIONS(53),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(53),
    [sym__semicolon] = ACTIONS(53),
    [sym__raw_string_literal] = ACTIONS(53),
    [sym__external_else] = ACTIONS(319),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(53),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [19] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__else] = STATE(1619),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(205),
    [anon_sym_BSLASH] = ACTIONS(207),
    [anon_sym_function] = ACTIONS(205),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_for] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(205),
    [anon_sym_repeat] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(281),
    [anon_sym_LT_LT_DASH] = ACTIONS(281),
    [anon_sym_COLON_EQ] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(207),
    [sym__number_literal] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [sym_return] = ACTIONS(205),
    [sym_next] = ACTIONS(205),
    [sym_break] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_null] = ACTIONS(205),
    [sym_inf] = ACTIONS(205),
    [sym_nan] = ACTIONS(205),
    [anon_sym_NA] = ACTIONS(205),
    [anon_sym_NA_integer_] = ACTIONS(205),
    [anon_sym_NA_real_] = ACTIONS(205),
    [anon_sym_NA_complex_] = ACTIONS(205),
    [anon_sym_NA_character_] = ACTIONS(205),
    [sym_dots] = ACTIONS(205),
    [sym_dot_dot_i] = ACTIONS(207),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(207),
    [sym__newline] = ACTIONS(207),
    [sym__raw_string_literal] = ACTIONS(207),
    [sym__external_else] = ACTIONS(321),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(207),
  },
  [20] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__else] = STATE(1622),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_BSLASH] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(103),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(103),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_repeat] = ACTIONS(103),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(281),
    [anon_sym_LT_LT_DASH] = ACTIONS(281),
    [anon_sym_COLON_EQ] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(101),
    [sym__number_literal] = ACTIONS(103),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [sym_return] = ACTIONS(103),
    [sym_next] = ACTIONS(103),
    [sym_break] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [sym_inf] = ACTIONS(103),
    [sym_nan] = ACTIONS(103),
    [anon_sym_NA] = ACTIONS(103),
    [anon_sym_NA_integer_] = ACTIONS(103),
    [anon_sym_NA_real_] = ACTIONS(103),
    [anon_sym_NA_complex_] = ACTIONS(103),
    [anon_sym_NA_character_] = ACTIONS(103),
    [sym_dots] = ACTIONS(103),
    [sym_dot_dot_i] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(101),
    [sym__newline] = ACTIONS(101),
    [sym__raw_string_literal] = ACTIONS(101),
    [sym__external_else] = ACTIONS(323),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(101),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(101),
  },
  [21] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__else] = STATE(1616),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_BSLASH] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(103),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(103),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_repeat] = ACTIONS(103),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(281),
    [anon_sym_LT_LT_DASH] = ACTIONS(281),
    [anon_sym_COLON_EQ] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(101),
    [sym__number_literal] = ACTIONS(103),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [sym_return] = ACTIONS(103),
    [sym_next] = ACTIONS(103),
    [sym_break] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [sym_inf] = ACTIONS(103),
    [sym_nan] = ACTIONS(103),
    [anon_sym_NA] = ACTIONS(103),
    [anon_sym_NA_integer_] = ACTIONS(103),
    [anon_sym_NA_real_] = ACTIONS(103),
    [anon_sym_NA_complex_] = ACTIONS(103),
    [anon_sym_NA_character_] = ACTIONS(103),
    [sym_dots] = ACTIONS(103),
    [sym_dot_dot_i] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(101),
    [sym__newline] = ACTIONS(101),
    [sym__raw_string_literal] = ACTIONS(101),
    [sym__external_else] = ACTIONS(325),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(101),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(101),
  },
  [22] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__else] = STATE(1603),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(53),
    [sym_identifier] = ACTIONS(51),
    [anon_sym_BSLASH] = ACTIONS(53),
    [anon_sym_function] = ACTIONS(51),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_repeat] = ACTIONS(51),
    [anon_sym_QMARK] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LT_LT_DASH] = ACTIONS(113),
    [anon_sym_COLON_EQ] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(53),
    [sym__number_literal] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [sym_return] = ACTIONS(51),
    [sym_next] = ACTIONS(51),
    [sym_break] = ACTIONS(51),
    [sym_true] = ACTIONS(51),
    [sym_false] = ACTIONS(51),
    [sym_null] = ACTIONS(51),
    [sym_inf] = ACTIONS(51),
    [sym_nan] = ACTIONS(51),
    [anon_sym_NA] = ACTIONS(51),
    [anon_sym_NA_integer_] = ACTIONS(51),
    [anon_sym_NA_real_] = ACTIONS(51),
    [anon_sym_NA_complex_] = ACTIONS(51),
    [anon_sym_NA_character_] = ACTIONS(51),
    [sym_dots] = ACTIONS(51),
    [sym_dot_dot_i] = ACTIONS(53),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(53),
    [sym__semicolon] = ACTIONS(53),
    [sym__raw_string_literal] = ACTIONS(53),
    [sym__external_else] = ACTIONS(327),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(53),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [23] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__else] = STATE(1607),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LT_LT_DASH] = ACTIONS(113),
    [anon_sym_COLON_EQ] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(329),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [24] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__else] = STATE(1609),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(207),
    [sym_identifier] = ACTIONS(205),
    [anon_sym_BSLASH] = ACTIONS(207),
    [anon_sym_function] = ACTIONS(205),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_for] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(205),
    [anon_sym_repeat] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LT_LT_DASH] = ACTIONS(113),
    [anon_sym_COLON_EQ] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(207),
    [sym__number_literal] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [sym_return] = ACTIONS(205),
    [sym_next] = ACTIONS(205),
    [sym_break] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_null] = ACTIONS(205),
    [sym_inf] = ACTIONS(205),
    [sym_nan] = ACTIONS(205),
    [anon_sym_NA] = ACTIONS(205),
    [anon_sym_NA_integer_] = ACTIONS(205),
    [anon_sym_NA_real_] = ACTIONS(205),
    [anon_sym_NA_complex_] = ACTIONS(205),
    [anon_sym_NA_character_] = ACTIONS(205),
    [sym_dots] = ACTIONS(205),
    [sym_dot_dot_i] = ACTIONS(207),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(207),
    [sym__semicolon] = ACTIONS(207),
    [sym__raw_string_literal] = ACTIONS(207),
    [sym__external_else] = ACTIONS(331),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [25] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__else] = STATE(1630),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(101),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_BSLASH] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(103),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(103),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_repeat] = ACTIONS(103),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LT_LT_DASH] = ACTIONS(113),
    [anon_sym_COLON_EQ] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(101),
    [sym__number_literal] = ACTIONS(103),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [sym_return] = ACTIONS(103),
    [sym_next] = ACTIONS(103),
    [sym_break] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [sym_inf] = ACTIONS(103),
    [sym_nan] = ACTIONS(103),
    [anon_sym_NA] = ACTIONS(103),
    [anon_sym_NA_integer_] = ACTIONS(103),
    [anon_sym_NA_real_] = ACTIONS(103),
    [anon_sym_NA_complex_] = ACTIONS(103),
    [anon_sym_NA_character_] = ACTIONS(103),
    [sym_dots] = ACTIONS(103),
    [sym_dot_dot_i] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(101),
    [sym__semicolon] = ACTIONS(101),
    [sym__raw_string_literal] = ACTIONS(101),
    [sym__external_else] = ACTIONS(333),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(101),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [26] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__else] = STATE(1632),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(51),
    [anon_sym_BSLASH] = ACTIONS(53),
    [anon_sym_function] = ACTIONS(51),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_repeat] = ACTIONS(51),
    [anon_sym_QMARK] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_COLON_EQ] = ACTIONS(165),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(53),
    [sym__number_literal] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [sym_return] = ACTIONS(51),
    [sym_next] = ACTIONS(51),
    [sym_break] = ACTIONS(51),
    [sym_true] = ACTIONS(51),
    [sym_false] = ACTIONS(51),
    [sym_null] = ACTIONS(51),
    [sym_inf] = ACTIONS(51),
    [sym_nan] = ACTIONS(51),
    [anon_sym_NA] = ACTIONS(51),
    [anon_sym_NA_integer_] = ACTIONS(51),
    [anon_sym_NA_real_] = ACTIONS(51),
    [anon_sym_NA_complex_] = ACTIONS(51),
    [anon_sym_NA_character_] = ACTIONS(51),
    [sym_dots] = ACTIONS(51),
    [sym_dot_dot_i] = ACTIONS(53),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(53),
    [sym__newline] = ACTIONS(53),
    [sym__raw_string_literal] = ACTIONS(53),
    [sym__external_else] = ACTIONS(335),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(53),
    [sym__external_open_brace] = ACTIONS(53),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [27] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__else] = STATE(1640),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_COLON_EQ] = ACTIONS(165),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(151),
    [sym__newline] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(337),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(151),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [28] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__else] = STATE(1643),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(205),
    [anon_sym_BSLASH] = ACTIONS(207),
    [anon_sym_function] = ACTIONS(205),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_for] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(205),
    [anon_sym_repeat] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_COLON_EQ] = ACTIONS(165),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(207),
    [sym__number_literal] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [sym_return] = ACTIONS(205),
    [sym_next] = ACTIONS(205),
    [sym_break] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_null] = ACTIONS(205),
    [sym_inf] = ACTIONS(205),
    [sym_nan] = ACTIONS(205),
    [anon_sym_NA] = ACTIONS(205),
    [anon_sym_NA_integer_] = ACTIONS(205),
    [anon_sym_NA_real_] = ACTIONS(205),
    [anon_sym_NA_complex_] = ACTIONS(205),
    [anon_sym_NA_character_] = ACTIONS(205),
    [sym_dots] = ACTIONS(205),
    [sym_dot_dot_i] = ACTIONS(207),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(207),
    [sym__newline] = ACTIONS(207),
    [sym__raw_string_literal] = ACTIONS(207),
    [sym__external_else] = ACTIONS(339),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(207),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [29] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__else] = STATE(1651),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_BSLASH] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(103),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(103),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_repeat] = ACTIONS(103),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_COLON_EQ] = ACTIONS(165),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(101),
    [sym__number_literal] = ACTIONS(103),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [sym_return] = ACTIONS(103),
    [sym_next] = ACTIONS(103),
    [sym_break] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [sym_inf] = ACTIONS(103),
    [sym_nan] = ACTIONS(103),
    [anon_sym_NA] = ACTIONS(103),
    [anon_sym_NA_integer_] = ACTIONS(103),
    [anon_sym_NA_real_] = ACTIONS(103),
    [anon_sym_NA_complex_] = ACTIONS(103),
    [anon_sym_NA_character_] = ACTIONS(103),
    [sym_dots] = ACTIONS(103),
    [sym_dot_dot_i] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(101),
    [sym__newline] = ACTIONS(101),
    [sym__raw_string_literal] = ACTIONS(101),
    [sym__external_else] = ACTIONS(341),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(101),
    [sym__external_open_brace] = ACTIONS(101),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [30] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__else] = STATE(1637),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(51),
    [anon_sym_BSLASH] = ACTIONS(53),
    [anon_sym_function] = ACTIONS(51),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_repeat] = ACTIONS(51),
    [anon_sym_QMARK] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(53),
    [sym__number_literal] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [sym_return] = ACTIONS(51),
    [sym_next] = ACTIONS(51),
    [sym_break] = ACTIONS(51),
    [sym_true] = ACTIONS(51),
    [sym_false] = ACTIONS(51),
    [sym_null] = ACTIONS(51),
    [sym_inf] = ACTIONS(51),
    [sym_nan] = ACTIONS(51),
    [anon_sym_NA] = ACTIONS(51),
    [anon_sym_NA_integer_] = ACTIONS(51),
    [anon_sym_NA_real_] = ACTIONS(51),
    [anon_sym_NA_complex_] = ACTIONS(51),
    [anon_sym_NA_character_] = ACTIONS(51),
    [sym_dots] = ACTIONS(51),
    [sym_dot_dot_i] = ACTIONS(53),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(53),
    [sym__semicolon] = ACTIONS(53),
    [sym__raw_string_literal] = ACTIONS(53),
    [sym__external_else] = ACTIONS(343),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(53),
    [sym__external_close_brace] = ACTIONS(53),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [31] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__else] = STATE(1644),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(151),
    [sym__semicolon] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(345),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_close_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [32] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__else] = STATE(1645),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(205),
    [anon_sym_BSLASH] = ACTIONS(207),
    [anon_sym_function] = ACTIONS(205),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_for] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(205),
    [anon_sym_repeat] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(207),
    [sym__number_literal] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [sym_return] = ACTIONS(205),
    [sym_next] = ACTIONS(205),
    [sym_break] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_null] = ACTIONS(205),
    [sym_inf] = ACTIONS(205),
    [sym_nan] = ACTIONS(205),
    [anon_sym_NA] = ACTIONS(205),
    [anon_sym_NA_integer_] = ACTIONS(205),
    [anon_sym_NA_real_] = ACTIONS(205),
    [anon_sym_NA_complex_] = ACTIONS(205),
    [anon_sym_NA_character_] = ACTIONS(205),
    [sym_dots] = ACTIONS(205),
    [sym_dot_dot_i] = ACTIONS(207),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(207),
    [sym__semicolon] = ACTIONS(207),
    [sym__raw_string_literal] = ACTIONS(207),
    [sym__external_else] = ACTIONS(347),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_close_brace] = ACTIONS(207),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [33] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__else] = STATE(1649),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_BSLASH] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(103),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(103),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_repeat] = ACTIONS(103),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(101),
    [sym__number_literal] = ACTIONS(103),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [sym_return] = ACTIONS(103),
    [sym_next] = ACTIONS(103),
    [sym_break] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [sym_inf] = ACTIONS(103),
    [sym_nan] = ACTIONS(103),
    [anon_sym_NA] = ACTIONS(103),
    [anon_sym_NA_integer_] = ACTIONS(103),
    [anon_sym_NA_real_] = ACTIONS(103),
    [anon_sym_NA_complex_] = ACTIONS(103),
    [anon_sym_NA_character_] = ACTIONS(103),
    [sym_dots] = ACTIONS(103),
    [sym_dot_dot_i] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(101),
    [sym__semicolon] = ACTIONS(101),
    [sym__raw_string_literal] = ACTIONS(101),
    [sym__external_else] = ACTIONS(349),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(101),
    [sym__external_close_brace] = ACTIONS(101),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [34] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__else] = STATE(1634),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(207),
    [sym_identifier] = ACTIONS(205),
    [anon_sym_BSLASH] = ACTIONS(207),
    [anon_sym_function] = ACTIONS(205),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_for] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(205),
    [anon_sym_repeat] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LT_LT_DASH] = ACTIONS(113),
    [anon_sym_COLON_EQ] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(207),
    [sym__number_literal] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [sym_return] = ACTIONS(205),
    [sym_next] = ACTIONS(205),
    [sym_break] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_null] = ACTIONS(205),
    [sym_inf] = ACTIONS(205),
    [sym_nan] = ACTIONS(205),
    [anon_sym_NA] = ACTIONS(205),
    [anon_sym_NA_integer_] = ACTIONS(205),
    [anon_sym_NA_real_] = ACTIONS(205),
    [anon_sym_NA_complex_] = ACTIONS(205),
    [anon_sym_NA_character_] = ACTIONS(205),
    [sym_dots] = ACTIONS(205),
    [sym_dot_dot_i] = ACTIONS(207),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(207),
    [sym__semicolon] = ACTIONS(207),
    [sym__raw_string_literal] = ACTIONS(207),
    [sym__external_else] = ACTIONS(351),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [35] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__else] = STATE(1656),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LT_LT_DASH] = ACTIONS(63),
    [anon_sym_COLON_EQ] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(151),
    [sym__newline] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(353),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(151),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [36] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__else] = STATE(1604),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(205),
    [anon_sym_BSLASH] = ACTIONS(207),
    [anon_sym_function] = ACTIONS(205),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_for] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(205),
    [anon_sym_repeat] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LT_LT_DASH] = ACTIONS(63),
    [anon_sym_COLON_EQ] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(207),
    [sym__number_literal] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [sym_return] = ACTIONS(205),
    [sym_next] = ACTIONS(205),
    [sym_break] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_null] = ACTIONS(205),
    [sym_inf] = ACTIONS(205),
    [sym_nan] = ACTIONS(205),
    [anon_sym_NA] = ACTIONS(205),
    [anon_sym_NA_integer_] = ACTIONS(205),
    [anon_sym_NA_real_] = ACTIONS(205),
    [anon_sym_NA_complex_] = ACTIONS(205),
    [anon_sym_NA_character_] = ACTIONS(205),
    [sym_dots] = ACTIONS(205),
    [sym_dot_dot_i] = ACTIONS(207),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(207),
    [sym__newline] = ACTIONS(207),
    [sym__raw_string_literal] = ACTIONS(207),
    [sym__external_else] = ACTIONS(355),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(207),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [37] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__else] = STATE(1601),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(103),
    [anon_sym_BSLASH] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(103),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(103),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_repeat] = ACTIONS(103),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LT_LT_DASH] = ACTIONS(63),
    [anon_sym_COLON_EQ] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(101),
    [sym__number_literal] = ACTIONS(103),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [sym_return] = ACTIONS(103),
    [sym_next] = ACTIONS(103),
    [sym_break] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [sym_inf] = ACTIONS(103),
    [sym_nan] = ACTIONS(103),
    [anon_sym_NA] = ACTIONS(103),
    [anon_sym_NA_integer_] = ACTIONS(103),
    [anon_sym_NA_real_] = ACTIONS(103),
    [anon_sym_NA_complex_] = ACTIONS(103),
    [anon_sym_NA_character_] = ACTIONS(103),
    [sym_dots] = ACTIONS(103),
    [sym_dot_dot_i] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(101),
    [sym__newline] = ACTIONS(101),
    [sym__raw_string_literal] = ACTIONS(101),
    [sym__external_else] = ACTIONS(357),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(101),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(101),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [38] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__else] = STATE(1610),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(51),
    [anon_sym_BSLASH] = ACTIONS(53),
    [anon_sym_function] = ACTIONS(51),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_repeat] = ACTIONS(51),
    [anon_sym_QMARK] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(281),
    [anon_sym_LT_LT_DASH] = ACTIONS(281),
    [anon_sym_COLON_EQ] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(53),
    [sym__number_literal] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [sym_return] = ACTIONS(51),
    [sym_next] = ACTIONS(51),
    [sym_break] = ACTIONS(51),
    [sym_true] = ACTIONS(51),
    [sym_false] = ACTIONS(51),
    [sym_null] = ACTIONS(51),
    [sym_inf] = ACTIONS(51),
    [sym_nan] = ACTIONS(51),
    [anon_sym_NA] = ACTIONS(51),
    [anon_sym_NA_integer_] = ACTIONS(51),
    [anon_sym_NA_real_] = ACTIONS(51),
    [anon_sym_NA_complex_] = ACTIONS(51),
    [anon_sym_NA_character_] = ACTIONS(51),
    [sym_dots] = ACTIONS(51),
    [sym_dot_dot_i] = ACTIONS(53),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(53),
    [sym__newline] = ACTIONS(53),
    [sym__raw_string_literal] = ACTIONS(53),
    [sym__external_else] = ACTIONS(359),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(53),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(53),
  },
  [39] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__else] = STATE(1613),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(281),
    [anon_sym_LT_LT_DASH] = ACTIONS(281),
    [anon_sym_COLON_EQ] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(151),
    [sym__newline] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(361),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(151),
  },
  [40] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__else] = STATE(1614),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(205),
    [anon_sym_BSLASH] = ACTIONS(207),
    [anon_sym_function] = ACTIONS(205),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(205),
    [anon_sym_for] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(205),
    [anon_sym_repeat] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(281),
    [anon_sym_LT_LT_DASH] = ACTIONS(281),
    [anon_sym_COLON_EQ] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(207),
    [sym__number_literal] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [sym_return] = ACTIONS(205),
    [sym_next] = ACTIONS(205),
    [sym_break] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_null] = ACTIONS(205),
    [sym_inf] = ACTIONS(205),
    [sym_nan] = ACTIONS(205),
    [anon_sym_NA] = ACTIONS(205),
    [anon_sym_NA_integer_] = ACTIONS(205),
    [anon_sym_NA_real_] = ACTIONS(205),
    [anon_sym_NA_complex_] = ACTIONS(205),
    [anon_sym_NA_character_] = ACTIONS(205),
    [sym_dots] = ACTIONS(205),
    [sym_dot_dot_i] = ACTIONS(207),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(207),
    [sym__newline] = ACTIONS(207),
    [sym__raw_string_literal] = ACTIONS(207),
    [sym__external_else] = ACTIONS(363),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(207),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(207),
  },
  [41] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__else] = STATE(1618),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_BSLASH] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_repeat] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(281),
    [anon_sym_LT_LT_DASH] = ACTIONS(281),
    [anon_sym_COLON_EQ] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(151),
    [sym__number_literal] = ACTIONS(153),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(151),
    [sym_return] = ACTIONS(153),
    [sym_next] = ACTIONS(153),
    [sym_break] = ACTIONS(153),
    [sym_true] = ACTIONS(153),
    [sym_false] = ACTIONS(153),
    [sym_null] = ACTIONS(153),
    [sym_inf] = ACTIONS(153),
    [sym_nan] = ACTIONS(153),
    [anon_sym_NA] = ACTIONS(153),
    [anon_sym_NA_integer_] = ACTIONS(153),
    [anon_sym_NA_real_] = ACTIONS(153),
    [anon_sym_NA_complex_] = ACTIONS(153),
    [anon_sym_NA_character_] = ACTIONS(153),
    [sym_dots] = ACTIONS(153),
    [sym_dot_dot_i] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(151),
    [sym__newline] = ACTIONS(151),
    [sym__raw_string_literal] = ACTIONS(151),
    [sym__external_else] = ACTIONS(365),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(151),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(151),
  },
  [42] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(367),
    [anon_sym_BSLASH] = ACTIONS(369),
    [anon_sym_function] = ACTIONS(367),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(367),
    [anon_sym_for] = ACTIONS(367),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_repeat] = ACTIONS(367),
    [anon_sym_QMARK] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(281),
    [anon_sym_LT_LT_DASH] = ACTIONS(281),
    [anon_sym_COLON_EQ] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(369),
    [sym__number_literal] = ACTIONS(367),
    [anon_sym_SQUOTE] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [sym_return] = ACTIONS(367),
    [sym_next] = ACTIONS(367),
    [sym_break] = ACTIONS(367),
    [sym_true] = ACTIONS(367),
    [sym_false] = ACTIONS(367),
    [sym_null] = ACTIONS(367),
    [sym_inf] = ACTIONS(367),
    [sym_nan] = ACTIONS(367),
    [anon_sym_NA] = ACTIONS(367),
    [anon_sym_NA_integer_] = ACTIONS(367),
    [anon_sym_NA_real_] = ACTIONS(367),
    [anon_sym_NA_complex_] = ACTIONS(367),
    [anon_sym_NA_character_] = ACTIONS(367),
    [sym_dots] = ACTIONS(367),
    [sym_dot_dot_i] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(369),
    [sym__newline] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(369),
    [sym__external_else] = ACTIONS(369),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(369),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(369),
  },
  [43] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(371),
    [anon_sym_PIPE_GT] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(373),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [44] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(371),
    [anon_sym_PIPE_GT] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [45] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(371),
    [anon_sym_PIPE_GT] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(373),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [46] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(375),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(375),
    [anon_sym_function] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_repeat] = ACTIONS(377),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LT_LT_DASH] = ACTIONS(113),
    [anon_sym_COLON_EQ] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(375),
    [sym__number_literal] = ACTIONS(377),
    [anon_sym_SQUOTE] = ACTIONS(375),
    [anon_sym_DQUOTE] = ACTIONS(375),
    [sym_return] = ACTIONS(377),
    [sym_next] = ACTIONS(377),
    [sym_break] = ACTIONS(377),
    [sym_true] = ACTIONS(377),
    [sym_false] = ACTIONS(377),
    [sym_null] = ACTIONS(377),
    [sym_inf] = ACTIONS(377),
    [sym_nan] = ACTIONS(377),
    [anon_sym_NA] = ACTIONS(377),
    [anon_sym_NA_integer_] = ACTIONS(377),
    [anon_sym_NA_real_] = ACTIONS(377),
    [anon_sym_NA_complex_] = ACTIONS(377),
    [anon_sym_NA_character_] = ACTIONS(377),
    [sym_dots] = ACTIONS(377),
    [sym_dot_dot_i] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(375),
    [sym__semicolon] = ACTIONS(375),
    [sym__raw_string_literal] = ACTIONS(375),
    [sym__external_else] = ACTIONS(375),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(375),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [47] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(379),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [48] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(379),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LT_LT_DASH] = ACTIONS(113),
    [anon_sym_COLON_EQ] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [49] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(379),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [50] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(379),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [51] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(379),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LT_LT_DASH] = ACTIONS(113),
    [anon_sym_COLON_EQ] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [52] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(379),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [53] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(379),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [54] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(379),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [55] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(379),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [56] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(379),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [57] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(379),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(379),
    [anon_sym_PIPE_GT] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(381),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [58] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(379),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(379),
    [anon_sym_PIPE_GT] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [59] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(379),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(379),
    [anon_sym_PIPE_GT] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(381),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [60] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(383),
    [sym_identifier] = ACTIONS(385),
    [anon_sym_BSLASH] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_for] = ACTIONS(385),
    [anon_sym_while] = ACTIONS(385),
    [anon_sym_repeat] = ACTIONS(385),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LT_LT_DASH] = ACTIONS(113),
    [anon_sym_COLON_EQ] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(383),
    [sym__number_literal] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [sym_return] = ACTIONS(385),
    [sym_next] = ACTIONS(385),
    [sym_break] = ACTIONS(385),
    [sym_true] = ACTIONS(385),
    [sym_false] = ACTIONS(385),
    [sym_null] = ACTIONS(385),
    [sym_inf] = ACTIONS(385),
    [sym_nan] = ACTIONS(385),
    [anon_sym_NA] = ACTIONS(385),
    [anon_sym_NA_integer_] = ACTIONS(385),
    [anon_sym_NA_real_] = ACTIONS(385),
    [anon_sym_NA_complex_] = ACTIONS(385),
    [anon_sym_NA_character_] = ACTIONS(385),
    [sym_dots] = ACTIONS(385),
    [sym_dot_dot_i] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(383),
    [sym__semicolon] = ACTIONS(383),
    [sym__raw_string_literal] = ACTIONS(383),
    [sym__external_else] = ACTIONS(383),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(383),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [61] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(387),
    [sym_identifier] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(389),
    [anon_sym_for] = ACTIONS(389),
    [anon_sym_while] = ACTIONS(389),
    [anon_sym_repeat] = ACTIONS(389),
    [anon_sym_QMARK] = ACTIONS(387),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(389),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LT_LT_DASH] = ACTIONS(113),
    [anon_sym_COLON_EQ] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(387),
    [sym__number_literal] = ACTIONS(389),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_return] = ACTIONS(389),
    [sym_next] = ACTIONS(389),
    [sym_break] = ACTIONS(389),
    [sym_true] = ACTIONS(389),
    [sym_false] = ACTIONS(389),
    [sym_null] = ACTIONS(389),
    [sym_inf] = ACTIONS(389),
    [sym_nan] = ACTIONS(389),
    [anon_sym_NA] = ACTIONS(389),
    [anon_sym_NA_integer_] = ACTIONS(389),
    [anon_sym_NA_real_] = ACTIONS(389),
    [anon_sym_NA_complex_] = ACTIONS(389),
    [anon_sym_NA_character_] = ACTIONS(389),
    [sym_dots] = ACTIONS(389),
    [sym_dot_dot_i] = ACTIONS(387),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(387),
    [sym__semicolon] = ACTIONS(387),
    [sym__raw_string_literal] = ACTIONS(387),
    [sym__external_else] = ACTIONS(387),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(387),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [62] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(391),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_BSLASH] = ACTIONS(391),
    [anon_sym_function] = ACTIONS(393),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(393),
    [anon_sym_for] = ACTIONS(393),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_repeat] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LT_LT_DASH] = ACTIONS(113),
    [anon_sym_COLON_EQ] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(391),
    [sym__number_literal] = ACTIONS(393),
    [anon_sym_SQUOTE] = ACTIONS(391),
    [anon_sym_DQUOTE] = ACTIONS(391),
    [sym_return] = ACTIONS(393),
    [sym_next] = ACTIONS(393),
    [sym_break] = ACTIONS(393),
    [sym_true] = ACTIONS(393),
    [sym_false] = ACTIONS(393),
    [sym_null] = ACTIONS(393),
    [sym_inf] = ACTIONS(393),
    [sym_nan] = ACTIONS(393),
    [anon_sym_NA] = ACTIONS(393),
    [anon_sym_NA_integer_] = ACTIONS(393),
    [anon_sym_NA_real_] = ACTIONS(393),
    [anon_sym_NA_complex_] = ACTIONS(393),
    [anon_sym_NA_character_] = ACTIONS(393),
    [sym_dots] = ACTIONS(393),
    [sym_dot_dot_i] = ACTIONS(391),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(391),
    [sym__semicolon] = ACTIONS(391),
    [sym__raw_string_literal] = ACTIONS(391),
    [sym__external_else] = ACTIONS(391),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(391),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [63] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(395),
    [sym_identifier] = ACTIONS(397),
    [anon_sym_BSLASH] = ACTIONS(395),
    [anon_sym_function] = ACTIONS(397),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_while] = ACTIONS(397),
    [anon_sym_repeat] = ACTIONS(397),
    [anon_sym_QMARK] = ACTIONS(395),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LT_LT_DASH] = ACTIONS(113),
    [anon_sym_COLON_EQ] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(395),
    [sym__number_literal] = ACTIONS(397),
    [anon_sym_SQUOTE] = ACTIONS(395),
    [anon_sym_DQUOTE] = ACTIONS(395),
    [sym_return] = ACTIONS(397),
    [sym_next] = ACTIONS(397),
    [sym_break] = ACTIONS(397),
    [sym_true] = ACTIONS(397),
    [sym_false] = ACTIONS(397),
    [sym_null] = ACTIONS(397),
    [sym_inf] = ACTIONS(397),
    [sym_nan] = ACTIONS(397),
    [anon_sym_NA] = ACTIONS(397),
    [anon_sym_NA_integer_] = ACTIONS(397),
    [anon_sym_NA_real_] = ACTIONS(397),
    [anon_sym_NA_complex_] = ACTIONS(397),
    [anon_sym_NA_character_] = ACTIONS(397),
    [sym_dots] = ACTIONS(397),
    [sym_dot_dot_i] = ACTIONS(395),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(395),
    [sym__semicolon] = ACTIONS(395),
    [sym__raw_string_literal] = ACTIONS(395),
    [sym__external_else] = ACTIONS(395),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(395),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [64] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(399),
    [sym_identifier] = ACTIONS(401),
    [anon_sym_BSLASH] = ACTIONS(399),
    [anon_sym_function] = ACTIONS(401),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(401),
    [anon_sym_for] = ACTIONS(401),
    [anon_sym_while] = ACTIONS(401),
    [anon_sym_repeat] = ACTIONS(401),
    [anon_sym_QMARK] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LT_LT_DASH] = ACTIONS(113),
    [anon_sym_COLON_EQ] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(399),
    [sym__number_literal] = ACTIONS(401),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [sym_return] = ACTIONS(401),
    [sym_next] = ACTIONS(401),
    [sym_break] = ACTIONS(401),
    [sym_true] = ACTIONS(401),
    [sym_false] = ACTIONS(401),
    [sym_null] = ACTIONS(401),
    [sym_inf] = ACTIONS(401),
    [sym_nan] = ACTIONS(401),
    [anon_sym_NA] = ACTIONS(401),
    [anon_sym_NA_integer_] = ACTIONS(401),
    [anon_sym_NA_real_] = ACTIONS(401),
    [anon_sym_NA_complex_] = ACTIONS(401),
    [anon_sym_NA_character_] = ACTIONS(401),
    [sym_dots] = ACTIONS(401),
    [sym_dot_dot_i] = ACTIONS(399),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(399),
    [sym__semicolon] = ACTIONS(399),
    [sym__raw_string_literal] = ACTIONS(399),
    [sym__external_else] = ACTIONS(399),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(399),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [65] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(403),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_BSLASH] = ACTIONS(403),
    [anon_sym_function] = ACTIONS(405),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(405),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_while] = ACTIONS(405),
    [anon_sym_repeat] = ACTIONS(405),
    [anon_sym_QMARK] = ACTIONS(403),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(405),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LT_LT_DASH] = ACTIONS(113),
    [anon_sym_COLON_EQ] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(403),
    [sym__number_literal] = ACTIONS(405),
    [anon_sym_SQUOTE] = ACTIONS(403),
    [anon_sym_DQUOTE] = ACTIONS(403),
    [sym_return] = ACTIONS(405),
    [sym_next] = ACTIONS(405),
    [sym_break] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_null] = ACTIONS(405),
    [sym_inf] = ACTIONS(405),
    [sym_nan] = ACTIONS(405),
    [anon_sym_NA] = ACTIONS(405),
    [anon_sym_NA_integer_] = ACTIONS(405),
    [anon_sym_NA_real_] = ACTIONS(405),
    [anon_sym_NA_complex_] = ACTIONS(405),
    [anon_sym_NA_character_] = ACTIONS(405),
    [sym_dots] = ACTIONS(405),
    [sym_dot_dot_i] = ACTIONS(403),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(403),
    [sym__semicolon] = ACTIONS(403),
    [sym__raw_string_literal] = ACTIONS(403),
    [sym__external_else] = ACTIONS(403),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(403),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [66] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(407),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_BSLASH] = ACTIONS(407),
    [anon_sym_function] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(409),
    [anon_sym_while] = ACTIONS(409),
    [anon_sym_repeat] = ACTIONS(409),
    [anon_sym_QMARK] = ACTIONS(407),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(409),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LT_LT_DASH] = ACTIONS(113),
    [anon_sym_COLON_EQ] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(407),
    [sym__number_literal] = ACTIONS(409),
    [anon_sym_SQUOTE] = ACTIONS(407),
    [anon_sym_DQUOTE] = ACTIONS(407),
    [sym_return] = ACTIONS(409),
    [sym_next] = ACTIONS(409),
    [sym_break] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_null] = ACTIONS(409),
    [sym_inf] = ACTIONS(409),
    [sym_nan] = ACTIONS(409),
    [anon_sym_NA] = ACTIONS(409),
    [anon_sym_NA_integer_] = ACTIONS(409),
    [anon_sym_NA_real_] = ACTIONS(409),
    [anon_sym_NA_complex_] = ACTIONS(409),
    [anon_sym_NA_character_] = ACTIONS(409),
    [sym_dots] = ACTIONS(409),
    [sym_dot_dot_i] = ACTIONS(407),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(407),
    [sym__semicolon] = ACTIONS(407),
    [sym__raw_string_literal] = ACTIONS(407),
    [sym__external_else] = ACTIONS(407),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(407),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [67] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(369),
    [sym_identifier] = ACTIONS(367),
    [anon_sym_BSLASH] = ACTIONS(369),
    [anon_sym_function] = ACTIONS(367),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(367),
    [anon_sym_for] = ACTIONS(367),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_repeat] = ACTIONS(367),
    [anon_sym_QMARK] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LT_LT_DASH] = ACTIONS(113),
    [anon_sym_COLON_EQ] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(369),
    [sym__number_literal] = ACTIONS(367),
    [anon_sym_SQUOTE] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [sym_return] = ACTIONS(367),
    [sym_next] = ACTIONS(367),
    [sym_break] = ACTIONS(367),
    [sym_true] = ACTIONS(367),
    [sym_false] = ACTIONS(367),
    [sym_null] = ACTIONS(367),
    [sym_inf] = ACTIONS(367),
    [sym_nan] = ACTIONS(367),
    [anon_sym_NA] = ACTIONS(367),
    [anon_sym_NA_integer_] = ACTIONS(367),
    [anon_sym_NA_real_] = ACTIONS(367),
    [anon_sym_NA_complex_] = ACTIONS(367),
    [anon_sym_NA_character_] = ACTIONS(367),
    [sym_dots] = ACTIONS(367),
    [sym_dot_dot_i] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(369),
    [sym__semicolon] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(369),
    [sym__external_else] = ACTIONS(369),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(369),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [68] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(411),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_BSLASH] = ACTIONS(411),
    [anon_sym_function] = ACTIONS(413),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_repeat] = ACTIONS(413),
    [anon_sym_QMARK] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(413),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LT_LT_DASH] = ACTIONS(113),
    [anon_sym_COLON_EQ] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(411),
    [sym__number_literal] = ACTIONS(413),
    [anon_sym_SQUOTE] = ACTIONS(411),
    [anon_sym_DQUOTE] = ACTIONS(411),
    [sym_return] = ACTIONS(413),
    [sym_next] = ACTIONS(413),
    [sym_break] = ACTIONS(413),
    [sym_true] = ACTIONS(413),
    [sym_false] = ACTIONS(413),
    [sym_null] = ACTIONS(413),
    [sym_inf] = ACTIONS(413),
    [sym_nan] = ACTIONS(413),
    [anon_sym_NA] = ACTIONS(413),
    [anon_sym_NA_integer_] = ACTIONS(413),
    [anon_sym_NA_real_] = ACTIONS(413),
    [anon_sym_NA_complex_] = ACTIONS(413),
    [anon_sym_NA_character_] = ACTIONS(413),
    [sym_dots] = ACTIONS(413),
    [sym_dot_dot_i] = ACTIONS(411),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(411),
    [sym__semicolon] = ACTIONS(411),
    [sym__raw_string_literal] = ACTIONS(411),
    [sym__external_else] = ACTIONS(411),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(411),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [69] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(415),
    [sym_identifier] = ACTIONS(417),
    [anon_sym_BSLASH] = ACTIONS(415),
    [anon_sym_function] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_repeat] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(415),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LT_LT_DASH] = ACTIONS(113),
    [anon_sym_COLON_EQ] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(415),
    [sym__number_literal] = ACTIONS(417),
    [anon_sym_SQUOTE] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(415),
    [sym_return] = ACTIONS(417),
    [sym_next] = ACTIONS(417),
    [sym_break] = ACTIONS(417),
    [sym_true] = ACTIONS(417),
    [sym_false] = ACTIONS(417),
    [sym_null] = ACTIONS(417),
    [sym_inf] = ACTIONS(417),
    [sym_nan] = ACTIONS(417),
    [anon_sym_NA] = ACTIONS(417),
    [anon_sym_NA_integer_] = ACTIONS(417),
    [anon_sym_NA_real_] = ACTIONS(417),
    [anon_sym_NA_complex_] = ACTIONS(417),
    [anon_sym_NA_character_] = ACTIONS(417),
    [sym_dots] = ACTIONS(417),
    [sym_dot_dot_i] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(415),
    [sym__semicolon] = ACTIONS(415),
    [sym__raw_string_literal] = ACTIONS(415),
    [sym__external_else] = ACTIONS(415),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(415),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [70] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(419),
    [sym_identifier] = ACTIONS(421),
    [anon_sym_BSLASH] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_repeat] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LT_LT_DASH] = ACTIONS(113),
    [anon_sym_COLON_EQ] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(419),
    [sym__number_literal] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(419),
    [anon_sym_DQUOTE] = ACTIONS(419),
    [sym_return] = ACTIONS(421),
    [sym_next] = ACTIONS(421),
    [sym_break] = ACTIONS(421),
    [sym_true] = ACTIONS(421),
    [sym_false] = ACTIONS(421),
    [sym_null] = ACTIONS(421),
    [sym_inf] = ACTIONS(421),
    [sym_nan] = ACTIONS(421),
    [anon_sym_NA] = ACTIONS(421),
    [anon_sym_NA_integer_] = ACTIONS(421),
    [anon_sym_NA_real_] = ACTIONS(421),
    [anon_sym_NA_complex_] = ACTIONS(421),
    [anon_sym_NA_character_] = ACTIONS(421),
    [sym_dots] = ACTIONS(421),
    [sym_dot_dot_i] = ACTIONS(419),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(419),
    [sym__semicolon] = ACTIONS(419),
    [sym__raw_string_literal] = ACTIONS(419),
    [sym__external_else] = ACTIONS(419),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(419),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [71] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(423),
    [sym_identifier] = ACTIONS(425),
    [anon_sym_BSLASH] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_repeat] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LT_LT_DASH] = ACTIONS(113),
    [anon_sym_COLON_EQ] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(423),
    [sym__number_literal] = ACTIONS(425),
    [anon_sym_SQUOTE] = ACTIONS(423),
    [anon_sym_DQUOTE] = ACTIONS(423),
    [sym_return] = ACTIONS(425),
    [sym_next] = ACTIONS(425),
    [sym_break] = ACTIONS(425),
    [sym_true] = ACTIONS(425),
    [sym_false] = ACTIONS(425),
    [sym_null] = ACTIONS(425),
    [sym_inf] = ACTIONS(425),
    [sym_nan] = ACTIONS(425),
    [anon_sym_NA] = ACTIONS(425),
    [anon_sym_NA_integer_] = ACTIONS(425),
    [anon_sym_NA_real_] = ACTIONS(425),
    [anon_sym_NA_complex_] = ACTIONS(425),
    [anon_sym_NA_character_] = ACTIONS(425),
    [sym_dots] = ACTIONS(425),
    [sym_dot_dot_i] = ACTIONS(423),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(423),
    [sym__semicolon] = ACTIONS(423),
    [sym__raw_string_literal] = ACTIONS(423),
    [sym__external_else] = ACTIONS(423),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(423),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [72] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(427),
    [anon_sym_BSLASH] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_repeat] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_COLON_EQ] = ACTIONS(165),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(429),
    [sym__number_literal] = ACTIONS(427),
    [anon_sym_SQUOTE] = ACTIONS(429),
    [anon_sym_DQUOTE] = ACTIONS(429),
    [sym_return] = ACTIONS(427),
    [sym_next] = ACTIONS(427),
    [sym_break] = ACTIONS(427),
    [sym_true] = ACTIONS(427),
    [sym_false] = ACTIONS(427),
    [sym_null] = ACTIONS(427),
    [sym_inf] = ACTIONS(427),
    [sym_nan] = ACTIONS(427),
    [anon_sym_NA] = ACTIONS(427),
    [anon_sym_NA_integer_] = ACTIONS(427),
    [anon_sym_NA_real_] = ACTIONS(427),
    [anon_sym_NA_complex_] = ACTIONS(427),
    [anon_sym_NA_character_] = ACTIONS(427),
    [sym_dots] = ACTIONS(427),
    [sym_dot_dot_i] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(429),
    [sym__newline] = ACTIONS(429),
    [sym__raw_string_literal] = ACTIONS(429),
    [sym__external_else] = ACTIONS(429),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(429),
    [sym__external_open_brace] = ACTIONS(429),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [73] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_COLON_EQ] = ACTIONS(165),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym__newline] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_else] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(433),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [74] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(433),
    [anon_sym_LT_LT_DASH] = ACTIONS(433),
    [anon_sym_COLON_EQ] = ACTIONS(433),
    [anon_sym_DASH_GT] = ACTIONS(431),
    [anon_sym_DASH_GT_GT] = ACTIONS(433),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym__newline] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_else] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(433),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [75] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(433),
    [anon_sym_LT_LT_DASH] = ACTIONS(433),
    [anon_sym_COLON_EQ] = ACTIONS(433),
    [anon_sym_DASH_GT] = ACTIONS(431),
    [anon_sym_DASH_GT_GT] = ACTIONS(433),
    [anon_sym_PIPE] = ACTIONS(431),
    [anon_sym_AMP] = ACTIONS(431),
    [anon_sym_PIPE_PIPE] = ACTIONS(433),
    [anon_sym_AMP_AMP] = ACTIONS(433),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym__newline] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_else] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(433),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [76] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(433),
    [anon_sym_DASH] = ACTIONS(431),
    [anon_sym_LT_DASH] = ACTIONS(433),
    [anon_sym_LT_LT_DASH] = ACTIONS(433),
    [anon_sym_COLON_EQ] = ACTIONS(433),
    [anon_sym_DASH_GT] = ACTIONS(431),
    [anon_sym_DASH_GT_GT] = ACTIONS(433),
    [anon_sym_PIPE] = ACTIONS(431),
    [anon_sym_AMP] = ACTIONS(431),
    [anon_sym_PIPE_PIPE] = ACTIONS(433),
    [anon_sym_AMP_AMP] = ACTIONS(433),
    [anon_sym_LT] = ACTIONS(431),
    [anon_sym_LT_EQ] = ACTIONS(433),
    [anon_sym_GT] = ACTIONS(431),
    [anon_sym_GT_EQ] = ACTIONS(433),
    [anon_sym_EQ_EQ] = ACTIONS(433),
    [anon_sym_BANG_EQ] = ACTIONS(433),
    [anon_sym_STAR] = ACTIONS(431),
    [anon_sym_SLASH] = ACTIONS(433),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(433),
    [anon_sym_PIPE_GT] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(431),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym__newline] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_else] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(433),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [77] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(435),
    [anon_sym_BSLASH] = ACTIONS(437),
    [anon_sym_function] = ACTIONS(435),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(435),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_repeat] = ACTIONS(435),
    [anon_sym_QMARK] = ACTIONS(437),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(435),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_COLON_EQ] = ACTIONS(165),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(437),
    [sym__number_literal] = ACTIONS(435),
    [anon_sym_SQUOTE] = ACTIONS(437),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [sym_return] = ACTIONS(435),
    [sym_next] = ACTIONS(435),
    [sym_break] = ACTIONS(435),
    [sym_true] = ACTIONS(435),
    [sym_false] = ACTIONS(435),
    [sym_null] = ACTIONS(435),
    [sym_inf] = ACTIONS(435),
    [sym_nan] = ACTIONS(435),
    [anon_sym_NA] = ACTIONS(435),
    [anon_sym_NA_integer_] = ACTIONS(435),
    [anon_sym_NA_real_] = ACTIONS(435),
    [anon_sym_NA_complex_] = ACTIONS(435),
    [anon_sym_NA_character_] = ACTIONS(435),
    [sym_dots] = ACTIONS(435),
    [sym_dot_dot_i] = ACTIONS(437),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(437),
    [sym__newline] = ACTIONS(437),
    [sym__raw_string_literal] = ACTIONS(437),
    [sym__external_else] = ACTIONS(437),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(437),
    [sym__external_open_brace] = ACTIONS(437),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [78] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(439),
    [anon_sym_BSLASH] = ACTIONS(441),
    [anon_sym_function] = ACTIONS(439),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(439),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(439),
    [anon_sym_repeat] = ACTIONS(439),
    [anon_sym_QMARK] = ACTIONS(441),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(439),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_COLON_EQ] = ACTIONS(165),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(441),
    [sym__number_literal] = ACTIONS(439),
    [anon_sym_SQUOTE] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(441),
    [sym_return] = ACTIONS(439),
    [sym_next] = ACTIONS(439),
    [sym_break] = ACTIONS(439),
    [sym_true] = ACTIONS(439),
    [sym_false] = ACTIONS(439),
    [sym_null] = ACTIONS(439),
    [sym_inf] = ACTIONS(439),
    [sym_nan] = ACTIONS(439),
    [anon_sym_NA] = ACTIONS(439),
    [anon_sym_NA_integer_] = ACTIONS(439),
    [anon_sym_NA_real_] = ACTIONS(439),
    [anon_sym_NA_complex_] = ACTIONS(439),
    [anon_sym_NA_character_] = ACTIONS(439),
    [sym_dots] = ACTIONS(439),
    [sym_dot_dot_i] = ACTIONS(441),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(441),
    [sym__newline] = ACTIONS(441),
    [sym__raw_string_literal] = ACTIONS(441),
    [sym__external_else] = ACTIONS(441),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(441),
    [sym__external_open_brace] = ACTIONS(441),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [79] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_COLON_EQ] = ACTIONS(165),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym__newline] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(445),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [80] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(445),
    [anon_sym_LT_LT_DASH] = ACTIONS(445),
    [anon_sym_COLON_EQ] = ACTIONS(445),
    [anon_sym_DASH_GT] = ACTIONS(443),
    [anon_sym_DASH_GT_GT] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym__newline] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(445),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [81] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(445),
    [anon_sym_LT_LT_DASH] = ACTIONS(445),
    [anon_sym_COLON_EQ] = ACTIONS(445),
    [anon_sym_DASH_GT] = ACTIONS(443),
    [anon_sym_DASH_GT_GT] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(443),
    [anon_sym_AMP] = ACTIONS(443),
    [anon_sym_PIPE_PIPE] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(445),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym__newline] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(445),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [82] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(443),
    [anon_sym_LT_DASH] = ACTIONS(445),
    [anon_sym_LT_LT_DASH] = ACTIONS(445),
    [anon_sym_COLON_EQ] = ACTIONS(445),
    [anon_sym_DASH_GT] = ACTIONS(443),
    [anon_sym_DASH_GT_GT] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(443),
    [anon_sym_AMP] = ACTIONS(443),
    [anon_sym_PIPE_PIPE] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(445),
    [anon_sym_LT] = ACTIONS(443),
    [anon_sym_LT_EQ] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(443),
    [anon_sym_GT_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(445),
    [anon_sym_PIPE_GT] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(443),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym__newline] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(445),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [83] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(371),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [84] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_COLON_EQ] = ACTIONS(165),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(371),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [85] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(371),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [86] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(371),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [87] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_COLON_EQ] = ACTIONS(165),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(371),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [88] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(371),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [89] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(371),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [90] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(371),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [91] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(371),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [92] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(371),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [93] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(371),
    [anon_sym_PIPE_GT] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(373),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(371),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [94] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(371),
    [anon_sym_PIPE_GT] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(371),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [95] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(371),
    [anon_sym_PIPE_GT] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(373),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(371),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [96] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(375),
    [anon_sym_function] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_repeat] = ACTIONS(377),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_COLON_EQ] = ACTIONS(165),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(375),
    [sym__number_literal] = ACTIONS(377),
    [anon_sym_SQUOTE] = ACTIONS(375),
    [anon_sym_DQUOTE] = ACTIONS(375),
    [sym_return] = ACTIONS(377),
    [sym_next] = ACTIONS(377),
    [sym_break] = ACTIONS(377),
    [sym_true] = ACTIONS(377),
    [sym_false] = ACTIONS(377),
    [sym_null] = ACTIONS(377),
    [sym_inf] = ACTIONS(377),
    [sym_nan] = ACTIONS(377),
    [anon_sym_NA] = ACTIONS(377),
    [anon_sym_NA_integer_] = ACTIONS(377),
    [anon_sym_NA_real_] = ACTIONS(377),
    [anon_sym_NA_complex_] = ACTIONS(377),
    [anon_sym_NA_character_] = ACTIONS(377),
    [sym_dots] = ACTIONS(377),
    [sym_dot_dot_i] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(375),
    [sym__newline] = ACTIONS(375),
    [sym__raw_string_literal] = ACTIONS(375),
    [sym__external_else] = ACTIONS(375),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(375),
    [sym__external_open_brace] = ACTIONS(375),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [97] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(379),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [98] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_COLON_EQ] = ACTIONS(165),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(379),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [99] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(379),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [100] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(379),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [101] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_COLON_EQ] = ACTIONS(165),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(379),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [102] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(379),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [103] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(379),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [104] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(379),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [105] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(379),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [106] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(379),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [107] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(379),
    [anon_sym_PIPE_GT] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(381),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(379),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [108] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(379),
    [anon_sym_PIPE_GT] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(379),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [109] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(379),
    [anon_sym_PIPE_GT] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(381),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(379),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [110] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(385),
    [anon_sym_BSLASH] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_for] = ACTIONS(385),
    [anon_sym_while] = ACTIONS(385),
    [anon_sym_repeat] = ACTIONS(385),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_COLON_EQ] = ACTIONS(165),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(383),
    [sym__number_literal] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [sym_return] = ACTIONS(385),
    [sym_next] = ACTIONS(385),
    [sym_break] = ACTIONS(385),
    [sym_true] = ACTIONS(385),
    [sym_false] = ACTIONS(385),
    [sym_null] = ACTIONS(385),
    [sym_inf] = ACTIONS(385),
    [sym_nan] = ACTIONS(385),
    [anon_sym_NA] = ACTIONS(385),
    [anon_sym_NA_integer_] = ACTIONS(385),
    [anon_sym_NA_real_] = ACTIONS(385),
    [anon_sym_NA_complex_] = ACTIONS(385),
    [anon_sym_NA_character_] = ACTIONS(385),
    [sym_dots] = ACTIONS(385),
    [sym_dot_dot_i] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(383),
    [sym__newline] = ACTIONS(383),
    [sym__raw_string_literal] = ACTIONS(383),
    [sym__external_else] = ACTIONS(383),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(383),
    [sym__external_open_brace] = ACTIONS(383),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [111] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(389),
    [anon_sym_for] = ACTIONS(389),
    [anon_sym_while] = ACTIONS(389),
    [anon_sym_repeat] = ACTIONS(389),
    [anon_sym_QMARK] = ACTIONS(387),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(389),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_COLON_EQ] = ACTIONS(165),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(387),
    [sym__number_literal] = ACTIONS(389),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_return] = ACTIONS(389),
    [sym_next] = ACTIONS(389),
    [sym_break] = ACTIONS(389),
    [sym_true] = ACTIONS(389),
    [sym_false] = ACTIONS(389),
    [sym_null] = ACTIONS(389),
    [sym_inf] = ACTIONS(389),
    [sym_nan] = ACTIONS(389),
    [anon_sym_NA] = ACTIONS(389),
    [anon_sym_NA_integer_] = ACTIONS(389),
    [anon_sym_NA_real_] = ACTIONS(389),
    [anon_sym_NA_complex_] = ACTIONS(389),
    [anon_sym_NA_character_] = ACTIONS(389),
    [sym_dots] = ACTIONS(389),
    [sym_dot_dot_i] = ACTIONS(387),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym__newline] = ACTIONS(387),
    [sym__raw_string_literal] = ACTIONS(387),
    [sym__external_else] = ACTIONS(387),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(387),
    [sym__external_open_brace] = ACTIONS(387),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [112] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_BSLASH] = ACTIONS(391),
    [anon_sym_function] = ACTIONS(393),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(393),
    [anon_sym_for] = ACTIONS(393),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_repeat] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_COLON_EQ] = ACTIONS(165),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(391),
    [sym__number_literal] = ACTIONS(393),
    [anon_sym_SQUOTE] = ACTIONS(391),
    [anon_sym_DQUOTE] = ACTIONS(391),
    [sym_return] = ACTIONS(393),
    [sym_next] = ACTIONS(393),
    [sym_break] = ACTIONS(393),
    [sym_true] = ACTIONS(393),
    [sym_false] = ACTIONS(393),
    [sym_null] = ACTIONS(393),
    [sym_inf] = ACTIONS(393),
    [sym_nan] = ACTIONS(393),
    [anon_sym_NA] = ACTIONS(393),
    [anon_sym_NA_integer_] = ACTIONS(393),
    [anon_sym_NA_real_] = ACTIONS(393),
    [anon_sym_NA_complex_] = ACTIONS(393),
    [anon_sym_NA_character_] = ACTIONS(393),
    [sym_dots] = ACTIONS(393),
    [sym_dot_dot_i] = ACTIONS(391),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(391),
    [sym__newline] = ACTIONS(391),
    [sym__raw_string_literal] = ACTIONS(391),
    [sym__external_else] = ACTIONS(391),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(391),
    [sym__external_open_brace] = ACTIONS(391),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [113] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(397),
    [anon_sym_BSLASH] = ACTIONS(395),
    [anon_sym_function] = ACTIONS(397),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_while] = ACTIONS(397),
    [anon_sym_repeat] = ACTIONS(397),
    [anon_sym_QMARK] = ACTIONS(395),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_COLON_EQ] = ACTIONS(165),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(395),
    [sym__number_literal] = ACTIONS(397),
    [anon_sym_SQUOTE] = ACTIONS(395),
    [anon_sym_DQUOTE] = ACTIONS(395),
    [sym_return] = ACTIONS(397),
    [sym_next] = ACTIONS(397),
    [sym_break] = ACTIONS(397),
    [sym_true] = ACTIONS(397),
    [sym_false] = ACTIONS(397),
    [sym_null] = ACTIONS(397),
    [sym_inf] = ACTIONS(397),
    [sym_nan] = ACTIONS(397),
    [anon_sym_NA] = ACTIONS(397),
    [anon_sym_NA_integer_] = ACTIONS(397),
    [anon_sym_NA_real_] = ACTIONS(397),
    [anon_sym_NA_complex_] = ACTIONS(397),
    [anon_sym_NA_character_] = ACTIONS(397),
    [sym_dots] = ACTIONS(397),
    [sym_dot_dot_i] = ACTIONS(395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(395),
    [sym__newline] = ACTIONS(395),
    [sym__raw_string_literal] = ACTIONS(395),
    [sym__external_else] = ACTIONS(395),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(395),
    [sym__external_open_brace] = ACTIONS(395),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [114] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(401),
    [anon_sym_BSLASH] = ACTIONS(399),
    [anon_sym_function] = ACTIONS(401),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(401),
    [anon_sym_for] = ACTIONS(401),
    [anon_sym_while] = ACTIONS(401),
    [anon_sym_repeat] = ACTIONS(401),
    [anon_sym_QMARK] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_COLON_EQ] = ACTIONS(165),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(399),
    [sym__number_literal] = ACTIONS(401),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [sym_return] = ACTIONS(401),
    [sym_next] = ACTIONS(401),
    [sym_break] = ACTIONS(401),
    [sym_true] = ACTIONS(401),
    [sym_false] = ACTIONS(401),
    [sym_null] = ACTIONS(401),
    [sym_inf] = ACTIONS(401),
    [sym_nan] = ACTIONS(401),
    [anon_sym_NA] = ACTIONS(401),
    [anon_sym_NA_integer_] = ACTIONS(401),
    [anon_sym_NA_real_] = ACTIONS(401),
    [anon_sym_NA_complex_] = ACTIONS(401),
    [anon_sym_NA_character_] = ACTIONS(401),
    [sym_dots] = ACTIONS(401),
    [sym_dot_dot_i] = ACTIONS(399),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(399),
    [sym__newline] = ACTIONS(399),
    [sym__raw_string_literal] = ACTIONS(399),
    [sym__external_else] = ACTIONS(399),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(399),
    [sym__external_open_brace] = ACTIONS(399),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [115] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_BSLASH] = ACTIONS(403),
    [anon_sym_function] = ACTIONS(405),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(405),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_while] = ACTIONS(405),
    [anon_sym_repeat] = ACTIONS(405),
    [anon_sym_QMARK] = ACTIONS(403),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(405),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_COLON_EQ] = ACTIONS(165),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(403),
    [sym__number_literal] = ACTIONS(405),
    [anon_sym_SQUOTE] = ACTIONS(403),
    [anon_sym_DQUOTE] = ACTIONS(403),
    [sym_return] = ACTIONS(405),
    [sym_next] = ACTIONS(405),
    [sym_break] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_null] = ACTIONS(405),
    [sym_inf] = ACTIONS(405),
    [sym_nan] = ACTIONS(405),
    [anon_sym_NA] = ACTIONS(405),
    [anon_sym_NA_integer_] = ACTIONS(405),
    [anon_sym_NA_real_] = ACTIONS(405),
    [anon_sym_NA_complex_] = ACTIONS(405),
    [anon_sym_NA_character_] = ACTIONS(405),
    [sym_dots] = ACTIONS(405),
    [sym_dot_dot_i] = ACTIONS(403),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(403),
    [sym__newline] = ACTIONS(403),
    [sym__raw_string_literal] = ACTIONS(403),
    [sym__external_else] = ACTIONS(403),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(403),
    [sym__external_open_brace] = ACTIONS(403),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [116] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_BSLASH] = ACTIONS(407),
    [anon_sym_function] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(409),
    [anon_sym_while] = ACTIONS(409),
    [anon_sym_repeat] = ACTIONS(409),
    [anon_sym_QMARK] = ACTIONS(407),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(409),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_COLON_EQ] = ACTIONS(165),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(407),
    [sym__number_literal] = ACTIONS(409),
    [anon_sym_SQUOTE] = ACTIONS(407),
    [anon_sym_DQUOTE] = ACTIONS(407),
    [sym_return] = ACTIONS(409),
    [sym_next] = ACTIONS(409),
    [sym_break] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_null] = ACTIONS(409),
    [sym_inf] = ACTIONS(409),
    [sym_nan] = ACTIONS(409),
    [anon_sym_NA] = ACTIONS(409),
    [anon_sym_NA_integer_] = ACTIONS(409),
    [anon_sym_NA_real_] = ACTIONS(409),
    [anon_sym_NA_complex_] = ACTIONS(409),
    [anon_sym_NA_character_] = ACTIONS(409),
    [sym_dots] = ACTIONS(409),
    [sym_dot_dot_i] = ACTIONS(407),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(407),
    [sym__newline] = ACTIONS(407),
    [sym__raw_string_literal] = ACTIONS(407),
    [sym__external_else] = ACTIONS(407),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(407),
    [sym__external_open_brace] = ACTIONS(407),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [117] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(367),
    [anon_sym_BSLASH] = ACTIONS(369),
    [anon_sym_function] = ACTIONS(367),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(367),
    [anon_sym_for] = ACTIONS(367),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_repeat] = ACTIONS(367),
    [anon_sym_QMARK] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_COLON_EQ] = ACTIONS(165),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(369),
    [sym__number_literal] = ACTIONS(367),
    [anon_sym_SQUOTE] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [sym_return] = ACTIONS(367),
    [sym_next] = ACTIONS(367),
    [sym_break] = ACTIONS(367),
    [sym_true] = ACTIONS(367),
    [sym_false] = ACTIONS(367),
    [sym_null] = ACTIONS(367),
    [sym_inf] = ACTIONS(367),
    [sym_nan] = ACTIONS(367),
    [anon_sym_NA] = ACTIONS(367),
    [anon_sym_NA_integer_] = ACTIONS(367),
    [anon_sym_NA_real_] = ACTIONS(367),
    [anon_sym_NA_complex_] = ACTIONS(367),
    [anon_sym_NA_character_] = ACTIONS(367),
    [sym_dots] = ACTIONS(367),
    [sym_dot_dot_i] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(369),
    [sym__newline] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(369),
    [sym__external_else] = ACTIONS(369),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(369),
    [sym__external_open_brace] = ACTIONS(369),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [118] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_BSLASH] = ACTIONS(411),
    [anon_sym_function] = ACTIONS(413),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_repeat] = ACTIONS(413),
    [anon_sym_QMARK] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(413),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_COLON_EQ] = ACTIONS(165),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(411),
    [sym__number_literal] = ACTIONS(413),
    [anon_sym_SQUOTE] = ACTIONS(411),
    [anon_sym_DQUOTE] = ACTIONS(411),
    [sym_return] = ACTIONS(413),
    [sym_next] = ACTIONS(413),
    [sym_break] = ACTIONS(413),
    [sym_true] = ACTIONS(413),
    [sym_false] = ACTIONS(413),
    [sym_null] = ACTIONS(413),
    [sym_inf] = ACTIONS(413),
    [sym_nan] = ACTIONS(413),
    [anon_sym_NA] = ACTIONS(413),
    [anon_sym_NA_integer_] = ACTIONS(413),
    [anon_sym_NA_real_] = ACTIONS(413),
    [anon_sym_NA_complex_] = ACTIONS(413),
    [anon_sym_NA_character_] = ACTIONS(413),
    [sym_dots] = ACTIONS(413),
    [sym_dot_dot_i] = ACTIONS(411),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(411),
    [sym__newline] = ACTIONS(411),
    [sym__raw_string_literal] = ACTIONS(411),
    [sym__external_else] = ACTIONS(411),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(411),
    [sym__external_open_brace] = ACTIONS(411),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [119] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(417),
    [anon_sym_BSLASH] = ACTIONS(415),
    [anon_sym_function] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_repeat] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(415),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_COLON_EQ] = ACTIONS(165),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(415),
    [sym__number_literal] = ACTIONS(417),
    [anon_sym_SQUOTE] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(415),
    [sym_return] = ACTIONS(417),
    [sym_next] = ACTIONS(417),
    [sym_break] = ACTIONS(417),
    [sym_true] = ACTIONS(417),
    [sym_false] = ACTIONS(417),
    [sym_null] = ACTIONS(417),
    [sym_inf] = ACTIONS(417),
    [sym_nan] = ACTIONS(417),
    [anon_sym_NA] = ACTIONS(417),
    [anon_sym_NA_integer_] = ACTIONS(417),
    [anon_sym_NA_real_] = ACTIONS(417),
    [anon_sym_NA_complex_] = ACTIONS(417),
    [anon_sym_NA_character_] = ACTIONS(417),
    [sym_dots] = ACTIONS(417),
    [sym_dot_dot_i] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(415),
    [sym__newline] = ACTIONS(415),
    [sym__raw_string_literal] = ACTIONS(415),
    [sym__external_else] = ACTIONS(415),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(415),
    [sym__external_open_brace] = ACTIONS(415),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [120] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(421),
    [anon_sym_BSLASH] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_repeat] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_COLON_EQ] = ACTIONS(165),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(419),
    [sym__number_literal] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(419),
    [anon_sym_DQUOTE] = ACTIONS(419),
    [sym_return] = ACTIONS(421),
    [sym_next] = ACTIONS(421),
    [sym_break] = ACTIONS(421),
    [sym_true] = ACTIONS(421),
    [sym_false] = ACTIONS(421),
    [sym_null] = ACTIONS(421),
    [sym_inf] = ACTIONS(421),
    [sym_nan] = ACTIONS(421),
    [anon_sym_NA] = ACTIONS(421),
    [anon_sym_NA_integer_] = ACTIONS(421),
    [anon_sym_NA_real_] = ACTIONS(421),
    [anon_sym_NA_complex_] = ACTIONS(421),
    [anon_sym_NA_character_] = ACTIONS(421),
    [sym_dots] = ACTIONS(421),
    [sym_dot_dot_i] = ACTIONS(419),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(419),
    [sym__newline] = ACTIONS(419),
    [sym__raw_string_literal] = ACTIONS(419),
    [sym__external_else] = ACTIONS(419),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(419),
    [sym__external_open_brace] = ACTIONS(419),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [121] = {
    [sym_call_arguments] = STATE(846),
    [sym_subset_arguments] = STATE(847),
    [sym_subset2_arguments] = STATE(848),
    [sym__open_parenthesis] = STATE(609),
    [sym__open_bracket] = STATE(610),
    [sym__open_bracket2] = STATE(611),
    [sym_identifier] = ACTIONS(425),
    [anon_sym_BSLASH] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_repeat] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_BANG] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_LT_DASH] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_COLON_EQ] = ACTIONS(165),
    [anon_sym_DASH_GT] = ACTIONS(167),
    [anon_sym_DASH_GT_GT] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_PIPE_PIPE] = ACTIONS(175),
    [anon_sym_AMP_AMP] = ACTIONS(177),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(181),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(181),
    [anon_sym_EQ_EQ] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(183),
    [anon_sym_SLASH] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(187),
    [anon_sym_CARET] = ACTIONS(187),
    [aux_sym_binary_operator_token1] = ACTIONS(189),
    [anon_sym_PIPE_GT] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(193),
    [anon_sym_AT] = ACTIONS(193),
    [sym__hex_literal] = ACTIONS(423),
    [sym__number_literal] = ACTIONS(425),
    [anon_sym_SQUOTE] = ACTIONS(423),
    [anon_sym_DQUOTE] = ACTIONS(423),
    [sym_return] = ACTIONS(425),
    [sym_next] = ACTIONS(425),
    [sym_break] = ACTIONS(425),
    [sym_true] = ACTIONS(425),
    [sym_false] = ACTIONS(425),
    [sym_null] = ACTIONS(425),
    [sym_inf] = ACTIONS(425),
    [sym_nan] = ACTIONS(425),
    [anon_sym_NA] = ACTIONS(425),
    [anon_sym_NA_integer_] = ACTIONS(425),
    [anon_sym_NA_real_] = ACTIONS(425),
    [anon_sym_NA_complex_] = ACTIONS(425),
    [anon_sym_NA_character_] = ACTIONS(425),
    [sym_dots] = ACTIONS(425),
    [sym_dot_dot_i] = ACTIONS(423),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(423),
    [sym__newline] = ACTIONS(423),
    [sym__raw_string_literal] = ACTIONS(423),
    [sym__external_else] = ACTIONS(423),
    [sym__external_open_parenthesis] = ACTIONS(197),
    [sym__external_close_parenthesis] = ACTIONS(423),
    [sym__external_open_brace] = ACTIONS(423),
    [sym__external_open_bracket] = ACTIONS(199),
    [sym__external_open_bracket2] = ACTIONS(201),
  },
  [122] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(427),
    [anon_sym_BSLASH] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_repeat] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(429),
    [sym__number_literal] = ACTIONS(427),
    [anon_sym_SQUOTE] = ACTIONS(429),
    [anon_sym_DQUOTE] = ACTIONS(429),
    [sym_return] = ACTIONS(427),
    [sym_next] = ACTIONS(427),
    [sym_break] = ACTIONS(427),
    [sym_true] = ACTIONS(427),
    [sym_false] = ACTIONS(427),
    [sym_null] = ACTIONS(427),
    [sym_inf] = ACTIONS(427),
    [sym_nan] = ACTIONS(427),
    [anon_sym_NA] = ACTIONS(427),
    [anon_sym_NA_integer_] = ACTIONS(427),
    [anon_sym_NA_real_] = ACTIONS(427),
    [anon_sym_NA_complex_] = ACTIONS(427),
    [anon_sym_NA_character_] = ACTIONS(427),
    [sym_dots] = ACTIONS(427),
    [sym_dot_dot_i] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(429),
    [sym__semicolon] = ACTIONS(429),
    [sym__raw_string_literal] = ACTIONS(429),
    [sym__external_else] = ACTIONS(429),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(429),
    [sym__external_close_brace] = ACTIONS(429),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [123] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(433),
    [sym__semicolon] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_else] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_close_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [124] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(433),
    [anon_sym_LT_LT_DASH] = ACTIONS(433),
    [anon_sym_COLON_EQ] = ACTIONS(433),
    [anon_sym_DASH_GT] = ACTIONS(431),
    [anon_sym_DASH_GT_GT] = ACTIONS(433),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(433),
    [sym__semicolon] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_else] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_close_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [125] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(433),
    [anon_sym_LT_LT_DASH] = ACTIONS(433),
    [anon_sym_COLON_EQ] = ACTIONS(433),
    [anon_sym_DASH_GT] = ACTIONS(431),
    [anon_sym_DASH_GT_GT] = ACTIONS(433),
    [anon_sym_PIPE] = ACTIONS(431),
    [anon_sym_AMP] = ACTIONS(431),
    [anon_sym_PIPE_PIPE] = ACTIONS(433),
    [anon_sym_AMP_AMP] = ACTIONS(433),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(433),
    [sym__semicolon] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_else] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_close_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [126] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(433),
    [anon_sym_DASH] = ACTIONS(431),
    [anon_sym_LT_DASH] = ACTIONS(433),
    [anon_sym_LT_LT_DASH] = ACTIONS(433),
    [anon_sym_COLON_EQ] = ACTIONS(433),
    [anon_sym_DASH_GT] = ACTIONS(431),
    [anon_sym_DASH_GT_GT] = ACTIONS(433),
    [anon_sym_PIPE] = ACTIONS(431),
    [anon_sym_AMP] = ACTIONS(431),
    [anon_sym_PIPE_PIPE] = ACTIONS(433),
    [anon_sym_AMP_AMP] = ACTIONS(433),
    [anon_sym_LT] = ACTIONS(431),
    [anon_sym_LT_EQ] = ACTIONS(433),
    [anon_sym_GT] = ACTIONS(431),
    [anon_sym_GT_EQ] = ACTIONS(433),
    [anon_sym_EQ_EQ] = ACTIONS(433),
    [anon_sym_BANG_EQ] = ACTIONS(433),
    [anon_sym_STAR] = ACTIONS(431),
    [anon_sym_SLASH] = ACTIONS(433),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(433),
    [anon_sym_PIPE_GT] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(431),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(433),
    [sym__semicolon] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_else] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_close_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [127] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(435),
    [anon_sym_BSLASH] = ACTIONS(437),
    [anon_sym_function] = ACTIONS(435),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(435),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_repeat] = ACTIONS(435),
    [anon_sym_QMARK] = ACTIONS(437),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(435),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(437),
    [sym__number_literal] = ACTIONS(435),
    [anon_sym_SQUOTE] = ACTIONS(437),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [sym_return] = ACTIONS(435),
    [sym_next] = ACTIONS(435),
    [sym_break] = ACTIONS(435),
    [sym_true] = ACTIONS(435),
    [sym_false] = ACTIONS(435),
    [sym_null] = ACTIONS(435),
    [sym_inf] = ACTIONS(435),
    [sym_nan] = ACTIONS(435),
    [anon_sym_NA] = ACTIONS(435),
    [anon_sym_NA_integer_] = ACTIONS(435),
    [anon_sym_NA_real_] = ACTIONS(435),
    [anon_sym_NA_complex_] = ACTIONS(435),
    [anon_sym_NA_character_] = ACTIONS(435),
    [sym_dots] = ACTIONS(435),
    [sym_dot_dot_i] = ACTIONS(437),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(437),
    [sym__semicolon] = ACTIONS(437),
    [sym__raw_string_literal] = ACTIONS(437),
    [sym__external_else] = ACTIONS(437),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(437),
    [sym__external_close_brace] = ACTIONS(437),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [128] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(439),
    [anon_sym_BSLASH] = ACTIONS(441),
    [anon_sym_function] = ACTIONS(439),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(439),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(439),
    [anon_sym_repeat] = ACTIONS(439),
    [anon_sym_QMARK] = ACTIONS(441),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(439),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(441),
    [sym__number_literal] = ACTIONS(439),
    [anon_sym_SQUOTE] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(441),
    [sym_return] = ACTIONS(439),
    [sym_next] = ACTIONS(439),
    [sym_break] = ACTIONS(439),
    [sym_true] = ACTIONS(439),
    [sym_false] = ACTIONS(439),
    [sym_null] = ACTIONS(439),
    [sym_inf] = ACTIONS(439),
    [sym_nan] = ACTIONS(439),
    [anon_sym_NA] = ACTIONS(439),
    [anon_sym_NA_integer_] = ACTIONS(439),
    [anon_sym_NA_real_] = ACTIONS(439),
    [anon_sym_NA_complex_] = ACTIONS(439),
    [anon_sym_NA_character_] = ACTIONS(439),
    [sym_dots] = ACTIONS(439),
    [sym_dot_dot_i] = ACTIONS(441),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(441),
    [sym__semicolon] = ACTIONS(441),
    [sym__raw_string_literal] = ACTIONS(441),
    [sym__external_else] = ACTIONS(441),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(441),
    [sym__external_close_brace] = ACTIONS(441),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [129] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(445),
    [sym__semicolon] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_close_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [130] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(445),
    [anon_sym_LT_LT_DASH] = ACTIONS(445),
    [anon_sym_COLON_EQ] = ACTIONS(445),
    [anon_sym_DASH_GT] = ACTIONS(443),
    [anon_sym_DASH_GT_GT] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(445),
    [sym__semicolon] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_close_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [131] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(445),
    [anon_sym_LT_LT_DASH] = ACTIONS(445),
    [anon_sym_COLON_EQ] = ACTIONS(445),
    [anon_sym_DASH_GT] = ACTIONS(443),
    [anon_sym_DASH_GT_GT] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(443),
    [anon_sym_AMP] = ACTIONS(443),
    [anon_sym_PIPE_PIPE] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(445),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(445),
    [sym__semicolon] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_close_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [132] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(443),
    [anon_sym_LT_DASH] = ACTIONS(445),
    [anon_sym_LT_LT_DASH] = ACTIONS(445),
    [anon_sym_COLON_EQ] = ACTIONS(445),
    [anon_sym_DASH_GT] = ACTIONS(443),
    [anon_sym_DASH_GT_GT] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(443),
    [anon_sym_AMP] = ACTIONS(443),
    [anon_sym_PIPE_PIPE] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(445),
    [anon_sym_LT] = ACTIONS(443),
    [anon_sym_LT_EQ] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(443),
    [anon_sym_GT_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(445),
    [anon_sym_PIPE_GT] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(443),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(445),
    [sym__semicolon] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_close_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [133] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_close_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [134] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_close_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [135] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_close_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [136] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_close_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [137] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_close_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [138] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_close_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [139] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_close_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [140] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_close_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [141] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_close_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [142] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_close_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [143] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(371),
    [anon_sym_PIPE_GT] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(373),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_close_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [144] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(371),
    [anon_sym_PIPE_GT] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_close_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [145] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(371),
    [anon_sym_PIPE_GT] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(373),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_close_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [146] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(375),
    [anon_sym_function] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_repeat] = ACTIONS(377),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(375),
    [sym__number_literal] = ACTIONS(377),
    [anon_sym_SQUOTE] = ACTIONS(375),
    [anon_sym_DQUOTE] = ACTIONS(375),
    [sym_return] = ACTIONS(377),
    [sym_next] = ACTIONS(377),
    [sym_break] = ACTIONS(377),
    [sym_true] = ACTIONS(377),
    [sym_false] = ACTIONS(377),
    [sym_null] = ACTIONS(377),
    [sym_inf] = ACTIONS(377),
    [sym_nan] = ACTIONS(377),
    [anon_sym_NA] = ACTIONS(377),
    [anon_sym_NA_integer_] = ACTIONS(377),
    [anon_sym_NA_real_] = ACTIONS(377),
    [anon_sym_NA_complex_] = ACTIONS(377),
    [anon_sym_NA_character_] = ACTIONS(377),
    [sym_dots] = ACTIONS(377),
    [sym_dot_dot_i] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(375),
    [sym__semicolon] = ACTIONS(375),
    [sym__raw_string_literal] = ACTIONS(375),
    [sym__external_else] = ACTIONS(375),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(375),
    [sym__external_close_brace] = ACTIONS(375),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [147] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_close_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [148] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_close_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [149] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_close_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [150] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_close_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [151] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_close_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [152] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_close_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [153] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_close_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [154] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_close_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [155] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_close_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [156] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_close_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [157] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(379),
    [anon_sym_PIPE_GT] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(381),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_close_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [158] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(379),
    [anon_sym_PIPE_GT] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_close_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [159] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(379),
    [anon_sym_PIPE_GT] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(381),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_close_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [160] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(385),
    [anon_sym_BSLASH] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_for] = ACTIONS(385),
    [anon_sym_while] = ACTIONS(385),
    [anon_sym_repeat] = ACTIONS(385),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(383),
    [sym__number_literal] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [sym_return] = ACTIONS(385),
    [sym_next] = ACTIONS(385),
    [sym_break] = ACTIONS(385),
    [sym_true] = ACTIONS(385),
    [sym_false] = ACTIONS(385),
    [sym_null] = ACTIONS(385),
    [sym_inf] = ACTIONS(385),
    [sym_nan] = ACTIONS(385),
    [anon_sym_NA] = ACTIONS(385),
    [anon_sym_NA_integer_] = ACTIONS(385),
    [anon_sym_NA_real_] = ACTIONS(385),
    [anon_sym_NA_complex_] = ACTIONS(385),
    [anon_sym_NA_character_] = ACTIONS(385),
    [sym_dots] = ACTIONS(385),
    [sym_dot_dot_i] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(383),
    [sym__semicolon] = ACTIONS(383),
    [sym__raw_string_literal] = ACTIONS(383),
    [sym__external_else] = ACTIONS(383),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(383),
    [sym__external_close_brace] = ACTIONS(383),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [161] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(389),
    [anon_sym_for] = ACTIONS(389),
    [anon_sym_while] = ACTIONS(389),
    [anon_sym_repeat] = ACTIONS(389),
    [anon_sym_QMARK] = ACTIONS(387),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(389),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(387),
    [sym__number_literal] = ACTIONS(389),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_return] = ACTIONS(389),
    [sym_next] = ACTIONS(389),
    [sym_break] = ACTIONS(389),
    [sym_true] = ACTIONS(389),
    [sym_false] = ACTIONS(389),
    [sym_null] = ACTIONS(389),
    [sym_inf] = ACTIONS(389),
    [sym_nan] = ACTIONS(389),
    [anon_sym_NA] = ACTIONS(389),
    [anon_sym_NA_integer_] = ACTIONS(389),
    [anon_sym_NA_real_] = ACTIONS(389),
    [anon_sym_NA_complex_] = ACTIONS(389),
    [anon_sym_NA_character_] = ACTIONS(389),
    [sym_dots] = ACTIONS(389),
    [sym_dot_dot_i] = ACTIONS(387),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(387),
    [sym__semicolon] = ACTIONS(387),
    [sym__raw_string_literal] = ACTIONS(387),
    [sym__external_else] = ACTIONS(387),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(387),
    [sym__external_close_brace] = ACTIONS(387),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [162] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_BSLASH] = ACTIONS(391),
    [anon_sym_function] = ACTIONS(393),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(393),
    [anon_sym_for] = ACTIONS(393),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_repeat] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(391),
    [sym__number_literal] = ACTIONS(393),
    [anon_sym_SQUOTE] = ACTIONS(391),
    [anon_sym_DQUOTE] = ACTIONS(391),
    [sym_return] = ACTIONS(393),
    [sym_next] = ACTIONS(393),
    [sym_break] = ACTIONS(393),
    [sym_true] = ACTIONS(393),
    [sym_false] = ACTIONS(393),
    [sym_null] = ACTIONS(393),
    [sym_inf] = ACTIONS(393),
    [sym_nan] = ACTIONS(393),
    [anon_sym_NA] = ACTIONS(393),
    [anon_sym_NA_integer_] = ACTIONS(393),
    [anon_sym_NA_real_] = ACTIONS(393),
    [anon_sym_NA_complex_] = ACTIONS(393),
    [anon_sym_NA_character_] = ACTIONS(393),
    [sym_dots] = ACTIONS(393),
    [sym_dot_dot_i] = ACTIONS(391),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(391),
    [sym__semicolon] = ACTIONS(391),
    [sym__raw_string_literal] = ACTIONS(391),
    [sym__external_else] = ACTIONS(391),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(391),
    [sym__external_close_brace] = ACTIONS(391),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [163] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(397),
    [anon_sym_BSLASH] = ACTIONS(395),
    [anon_sym_function] = ACTIONS(397),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_while] = ACTIONS(397),
    [anon_sym_repeat] = ACTIONS(397),
    [anon_sym_QMARK] = ACTIONS(395),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(395),
    [sym__number_literal] = ACTIONS(397),
    [anon_sym_SQUOTE] = ACTIONS(395),
    [anon_sym_DQUOTE] = ACTIONS(395),
    [sym_return] = ACTIONS(397),
    [sym_next] = ACTIONS(397),
    [sym_break] = ACTIONS(397),
    [sym_true] = ACTIONS(397),
    [sym_false] = ACTIONS(397),
    [sym_null] = ACTIONS(397),
    [sym_inf] = ACTIONS(397),
    [sym_nan] = ACTIONS(397),
    [anon_sym_NA] = ACTIONS(397),
    [anon_sym_NA_integer_] = ACTIONS(397),
    [anon_sym_NA_real_] = ACTIONS(397),
    [anon_sym_NA_complex_] = ACTIONS(397),
    [anon_sym_NA_character_] = ACTIONS(397),
    [sym_dots] = ACTIONS(397),
    [sym_dot_dot_i] = ACTIONS(395),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(395),
    [sym__semicolon] = ACTIONS(395),
    [sym__raw_string_literal] = ACTIONS(395),
    [sym__external_else] = ACTIONS(395),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(395),
    [sym__external_close_brace] = ACTIONS(395),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [164] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(401),
    [anon_sym_BSLASH] = ACTIONS(399),
    [anon_sym_function] = ACTIONS(401),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(401),
    [anon_sym_for] = ACTIONS(401),
    [anon_sym_while] = ACTIONS(401),
    [anon_sym_repeat] = ACTIONS(401),
    [anon_sym_QMARK] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(399),
    [sym__number_literal] = ACTIONS(401),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [sym_return] = ACTIONS(401),
    [sym_next] = ACTIONS(401),
    [sym_break] = ACTIONS(401),
    [sym_true] = ACTIONS(401),
    [sym_false] = ACTIONS(401),
    [sym_null] = ACTIONS(401),
    [sym_inf] = ACTIONS(401),
    [sym_nan] = ACTIONS(401),
    [anon_sym_NA] = ACTIONS(401),
    [anon_sym_NA_integer_] = ACTIONS(401),
    [anon_sym_NA_real_] = ACTIONS(401),
    [anon_sym_NA_complex_] = ACTIONS(401),
    [anon_sym_NA_character_] = ACTIONS(401),
    [sym_dots] = ACTIONS(401),
    [sym_dot_dot_i] = ACTIONS(399),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(399),
    [sym__semicolon] = ACTIONS(399),
    [sym__raw_string_literal] = ACTIONS(399),
    [sym__external_else] = ACTIONS(399),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(399),
    [sym__external_close_brace] = ACTIONS(399),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [165] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_BSLASH] = ACTIONS(403),
    [anon_sym_function] = ACTIONS(405),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(405),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_while] = ACTIONS(405),
    [anon_sym_repeat] = ACTIONS(405),
    [anon_sym_QMARK] = ACTIONS(403),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(405),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(403),
    [sym__number_literal] = ACTIONS(405),
    [anon_sym_SQUOTE] = ACTIONS(403),
    [anon_sym_DQUOTE] = ACTIONS(403),
    [sym_return] = ACTIONS(405),
    [sym_next] = ACTIONS(405),
    [sym_break] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_null] = ACTIONS(405),
    [sym_inf] = ACTIONS(405),
    [sym_nan] = ACTIONS(405),
    [anon_sym_NA] = ACTIONS(405),
    [anon_sym_NA_integer_] = ACTIONS(405),
    [anon_sym_NA_real_] = ACTIONS(405),
    [anon_sym_NA_complex_] = ACTIONS(405),
    [anon_sym_NA_character_] = ACTIONS(405),
    [sym_dots] = ACTIONS(405),
    [sym_dot_dot_i] = ACTIONS(403),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(403),
    [sym__semicolon] = ACTIONS(403),
    [sym__raw_string_literal] = ACTIONS(403),
    [sym__external_else] = ACTIONS(403),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(403),
    [sym__external_close_brace] = ACTIONS(403),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [166] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_BSLASH] = ACTIONS(407),
    [anon_sym_function] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(409),
    [anon_sym_while] = ACTIONS(409),
    [anon_sym_repeat] = ACTIONS(409),
    [anon_sym_QMARK] = ACTIONS(407),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(409),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(407),
    [sym__number_literal] = ACTIONS(409),
    [anon_sym_SQUOTE] = ACTIONS(407),
    [anon_sym_DQUOTE] = ACTIONS(407),
    [sym_return] = ACTIONS(409),
    [sym_next] = ACTIONS(409),
    [sym_break] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_null] = ACTIONS(409),
    [sym_inf] = ACTIONS(409),
    [sym_nan] = ACTIONS(409),
    [anon_sym_NA] = ACTIONS(409),
    [anon_sym_NA_integer_] = ACTIONS(409),
    [anon_sym_NA_real_] = ACTIONS(409),
    [anon_sym_NA_complex_] = ACTIONS(409),
    [anon_sym_NA_character_] = ACTIONS(409),
    [sym_dots] = ACTIONS(409),
    [sym_dot_dot_i] = ACTIONS(407),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(407),
    [sym__semicolon] = ACTIONS(407),
    [sym__raw_string_literal] = ACTIONS(407),
    [sym__external_else] = ACTIONS(407),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(407),
    [sym__external_close_brace] = ACTIONS(407),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [167] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(367),
    [anon_sym_BSLASH] = ACTIONS(369),
    [anon_sym_function] = ACTIONS(367),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(367),
    [anon_sym_for] = ACTIONS(367),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_repeat] = ACTIONS(367),
    [anon_sym_QMARK] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(369),
    [sym__number_literal] = ACTIONS(367),
    [anon_sym_SQUOTE] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [sym_return] = ACTIONS(367),
    [sym_next] = ACTIONS(367),
    [sym_break] = ACTIONS(367),
    [sym_true] = ACTIONS(367),
    [sym_false] = ACTIONS(367),
    [sym_null] = ACTIONS(367),
    [sym_inf] = ACTIONS(367),
    [sym_nan] = ACTIONS(367),
    [anon_sym_NA] = ACTIONS(367),
    [anon_sym_NA_integer_] = ACTIONS(367),
    [anon_sym_NA_real_] = ACTIONS(367),
    [anon_sym_NA_complex_] = ACTIONS(367),
    [anon_sym_NA_character_] = ACTIONS(367),
    [sym_dots] = ACTIONS(367),
    [sym_dot_dot_i] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(369),
    [sym__semicolon] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(369),
    [sym__external_else] = ACTIONS(369),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(369),
    [sym__external_close_brace] = ACTIONS(369),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [168] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_BSLASH] = ACTIONS(411),
    [anon_sym_function] = ACTIONS(413),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_repeat] = ACTIONS(413),
    [anon_sym_QMARK] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(413),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(411),
    [sym__number_literal] = ACTIONS(413),
    [anon_sym_SQUOTE] = ACTIONS(411),
    [anon_sym_DQUOTE] = ACTIONS(411),
    [sym_return] = ACTIONS(413),
    [sym_next] = ACTIONS(413),
    [sym_break] = ACTIONS(413),
    [sym_true] = ACTIONS(413),
    [sym_false] = ACTIONS(413),
    [sym_null] = ACTIONS(413),
    [sym_inf] = ACTIONS(413),
    [sym_nan] = ACTIONS(413),
    [anon_sym_NA] = ACTIONS(413),
    [anon_sym_NA_integer_] = ACTIONS(413),
    [anon_sym_NA_real_] = ACTIONS(413),
    [anon_sym_NA_complex_] = ACTIONS(413),
    [anon_sym_NA_character_] = ACTIONS(413),
    [sym_dots] = ACTIONS(413),
    [sym_dot_dot_i] = ACTIONS(411),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(411),
    [sym__semicolon] = ACTIONS(411),
    [sym__raw_string_literal] = ACTIONS(411),
    [sym__external_else] = ACTIONS(411),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(411),
    [sym__external_close_brace] = ACTIONS(411),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [169] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(417),
    [anon_sym_BSLASH] = ACTIONS(415),
    [anon_sym_function] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_repeat] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(415),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(415),
    [sym__number_literal] = ACTIONS(417),
    [anon_sym_SQUOTE] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(415),
    [sym_return] = ACTIONS(417),
    [sym_next] = ACTIONS(417),
    [sym_break] = ACTIONS(417),
    [sym_true] = ACTIONS(417),
    [sym_false] = ACTIONS(417),
    [sym_null] = ACTIONS(417),
    [sym_inf] = ACTIONS(417),
    [sym_nan] = ACTIONS(417),
    [anon_sym_NA] = ACTIONS(417),
    [anon_sym_NA_integer_] = ACTIONS(417),
    [anon_sym_NA_real_] = ACTIONS(417),
    [anon_sym_NA_complex_] = ACTIONS(417),
    [anon_sym_NA_character_] = ACTIONS(417),
    [sym_dots] = ACTIONS(417),
    [sym_dot_dot_i] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(415),
    [sym__semicolon] = ACTIONS(415),
    [sym__raw_string_literal] = ACTIONS(415),
    [sym__external_else] = ACTIONS(415),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(415),
    [sym__external_close_brace] = ACTIONS(415),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [170] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(421),
    [anon_sym_BSLASH] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_repeat] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(419),
    [sym__number_literal] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(419),
    [anon_sym_DQUOTE] = ACTIONS(419),
    [sym_return] = ACTIONS(421),
    [sym_next] = ACTIONS(421),
    [sym_break] = ACTIONS(421),
    [sym_true] = ACTIONS(421),
    [sym_false] = ACTIONS(421),
    [sym_null] = ACTIONS(421),
    [sym_inf] = ACTIONS(421),
    [sym_nan] = ACTIONS(421),
    [anon_sym_NA] = ACTIONS(421),
    [anon_sym_NA_integer_] = ACTIONS(421),
    [anon_sym_NA_real_] = ACTIONS(421),
    [anon_sym_NA_complex_] = ACTIONS(421),
    [anon_sym_NA_character_] = ACTIONS(421),
    [sym_dots] = ACTIONS(421),
    [sym_dot_dot_i] = ACTIONS(419),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(419),
    [sym__semicolon] = ACTIONS(419),
    [sym__raw_string_literal] = ACTIONS(419),
    [sym__external_else] = ACTIONS(419),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(419),
    [sym__external_close_brace] = ACTIONS(419),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [171] = {
    [sym_call_arguments] = STATE(793),
    [sym_subset_arguments] = STATE(794),
    [sym_subset2_arguments] = STATE(798),
    [sym__open_parenthesis] = STATE(613),
    [sym__open_bracket] = STATE(614),
    [sym__open_bracket2] = STATE(615),
    [sym_identifier] = ACTIONS(425),
    [anon_sym_BSLASH] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_repeat] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_TILDE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_LT_DASH] = ACTIONS(221),
    [anon_sym_LT_LT_DASH] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_DASH_GT_GT] = ACTIONS(225),
    [anon_sym_PIPE] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_BANG_EQ] = ACTIONS(237),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_SLASH] = ACTIONS(241),
    [anon_sym_STAR_STAR] = ACTIONS(243),
    [anon_sym_CARET] = ACTIONS(243),
    [aux_sym_binary_operator_token1] = ACTIONS(245),
    [anon_sym_PIPE_GT] = ACTIONS(245),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(249),
    [sym__hex_literal] = ACTIONS(423),
    [sym__number_literal] = ACTIONS(425),
    [anon_sym_SQUOTE] = ACTIONS(423),
    [anon_sym_DQUOTE] = ACTIONS(423),
    [sym_return] = ACTIONS(425),
    [sym_next] = ACTIONS(425),
    [sym_break] = ACTIONS(425),
    [sym_true] = ACTIONS(425),
    [sym_false] = ACTIONS(425),
    [sym_null] = ACTIONS(425),
    [sym_inf] = ACTIONS(425),
    [sym_nan] = ACTIONS(425),
    [anon_sym_NA] = ACTIONS(425),
    [anon_sym_NA_integer_] = ACTIONS(425),
    [anon_sym_NA_real_] = ACTIONS(425),
    [anon_sym_NA_complex_] = ACTIONS(425),
    [anon_sym_NA_character_] = ACTIONS(425),
    [sym_dots] = ACTIONS(425),
    [sym_dot_dot_i] = ACTIONS(423),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(423),
    [sym__semicolon] = ACTIONS(423),
    [sym__raw_string_literal] = ACTIONS(423),
    [sym__external_else] = ACTIONS(423),
    [sym__external_open_parenthesis] = ACTIONS(253),
    [sym__external_open_brace] = ACTIONS(423),
    [sym__external_close_brace] = ACTIONS(423),
    [sym__external_open_bracket] = ACTIONS(255),
    [sym__external_open_bracket2] = ACTIONS(257),
  },
  [172] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(427),
    [anon_sym_BSLASH] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_repeat] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LT_LT_DASH] = ACTIONS(63),
    [anon_sym_COLON_EQ] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(429),
    [sym__number_literal] = ACTIONS(427),
    [anon_sym_SQUOTE] = ACTIONS(429),
    [anon_sym_DQUOTE] = ACTIONS(429),
    [sym_return] = ACTIONS(427),
    [sym_next] = ACTIONS(427),
    [sym_break] = ACTIONS(427),
    [sym_true] = ACTIONS(427),
    [sym_false] = ACTIONS(427),
    [sym_null] = ACTIONS(427),
    [sym_inf] = ACTIONS(427),
    [sym_nan] = ACTIONS(427),
    [anon_sym_NA] = ACTIONS(427),
    [anon_sym_NA_integer_] = ACTIONS(427),
    [anon_sym_NA_real_] = ACTIONS(427),
    [anon_sym_NA_complex_] = ACTIONS(427),
    [anon_sym_NA_character_] = ACTIONS(427),
    [sym_dots] = ACTIONS(427),
    [sym_dot_dot_i] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(429),
    [sym__newline] = ACTIONS(429),
    [sym__raw_string_literal] = ACTIONS(429),
    [sym__external_else] = ACTIONS(429),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(429),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(429),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [173] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LT_LT_DASH] = ACTIONS(63),
    [anon_sym_COLON_EQ] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym__newline] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_else] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(433),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [174] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(433),
    [anon_sym_LT_LT_DASH] = ACTIONS(433),
    [anon_sym_COLON_EQ] = ACTIONS(433),
    [anon_sym_DASH_GT] = ACTIONS(431),
    [anon_sym_DASH_GT_GT] = ACTIONS(433),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym__newline] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_else] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(433),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [175] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(433),
    [anon_sym_LT_LT_DASH] = ACTIONS(433),
    [anon_sym_COLON_EQ] = ACTIONS(433),
    [anon_sym_DASH_GT] = ACTIONS(431),
    [anon_sym_DASH_GT_GT] = ACTIONS(433),
    [anon_sym_PIPE] = ACTIONS(431),
    [anon_sym_AMP] = ACTIONS(431),
    [anon_sym_PIPE_PIPE] = ACTIONS(433),
    [anon_sym_AMP_AMP] = ACTIONS(433),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym__newline] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_else] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(433),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [176] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(433),
    [anon_sym_DASH] = ACTIONS(431),
    [anon_sym_LT_DASH] = ACTIONS(433),
    [anon_sym_LT_LT_DASH] = ACTIONS(433),
    [anon_sym_COLON_EQ] = ACTIONS(433),
    [anon_sym_DASH_GT] = ACTIONS(431),
    [anon_sym_DASH_GT_GT] = ACTIONS(433),
    [anon_sym_PIPE] = ACTIONS(431),
    [anon_sym_AMP] = ACTIONS(431),
    [anon_sym_PIPE_PIPE] = ACTIONS(433),
    [anon_sym_AMP_AMP] = ACTIONS(433),
    [anon_sym_LT] = ACTIONS(431),
    [anon_sym_LT_EQ] = ACTIONS(433),
    [anon_sym_GT] = ACTIONS(431),
    [anon_sym_GT_EQ] = ACTIONS(433),
    [anon_sym_EQ_EQ] = ACTIONS(433),
    [anon_sym_BANG_EQ] = ACTIONS(433),
    [anon_sym_STAR] = ACTIONS(431),
    [anon_sym_SLASH] = ACTIONS(433),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(433),
    [anon_sym_PIPE_GT] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(431),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym__newline] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_else] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(433),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [177] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(435),
    [anon_sym_BSLASH] = ACTIONS(437),
    [anon_sym_function] = ACTIONS(435),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(435),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_repeat] = ACTIONS(435),
    [anon_sym_QMARK] = ACTIONS(437),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(435),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LT_LT_DASH] = ACTIONS(63),
    [anon_sym_COLON_EQ] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(437),
    [sym__number_literal] = ACTIONS(435),
    [anon_sym_SQUOTE] = ACTIONS(437),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [sym_return] = ACTIONS(435),
    [sym_next] = ACTIONS(435),
    [sym_break] = ACTIONS(435),
    [sym_true] = ACTIONS(435),
    [sym_false] = ACTIONS(435),
    [sym_null] = ACTIONS(435),
    [sym_inf] = ACTIONS(435),
    [sym_nan] = ACTIONS(435),
    [anon_sym_NA] = ACTIONS(435),
    [anon_sym_NA_integer_] = ACTIONS(435),
    [anon_sym_NA_real_] = ACTIONS(435),
    [anon_sym_NA_complex_] = ACTIONS(435),
    [anon_sym_NA_character_] = ACTIONS(435),
    [sym_dots] = ACTIONS(435),
    [sym_dot_dot_i] = ACTIONS(437),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(437),
    [sym__newline] = ACTIONS(437),
    [sym__raw_string_literal] = ACTIONS(437),
    [sym__external_else] = ACTIONS(437),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(437),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(437),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [178] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [179] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LT_LT_DASH] = ACTIONS(63),
    [anon_sym_COLON_EQ] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym__newline] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(445),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [180] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(445),
    [anon_sym_LT_LT_DASH] = ACTIONS(445),
    [anon_sym_COLON_EQ] = ACTIONS(445),
    [anon_sym_DASH_GT] = ACTIONS(443),
    [anon_sym_DASH_GT_GT] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym__newline] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(445),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [181] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(445),
    [anon_sym_LT_LT_DASH] = ACTIONS(445),
    [anon_sym_COLON_EQ] = ACTIONS(445),
    [anon_sym_DASH_GT] = ACTIONS(443),
    [anon_sym_DASH_GT_GT] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(443),
    [anon_sym_AMP] = ACTIONS(443),
    [anon_sym_PIPE_PIPE] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(445),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym__newline] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(445),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [182] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(443),
    [anon_sym_LT_DASH] = ACTIONS(445),
    [anon_sym_LT_LT_DASH] = ACTIONS(445),
    [anon_sym_COLON_EQ] = ACTIONS(445),
    [anon_sym_DASH_GT] = ACTIONS(443),
    [anon_sym_DASH_GT_GT] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(443),
    [anon_sym_AMP] = ACTIONS(443),
    [anon_sym_PIPE_PIPE] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(445),
    [anon_sym_LT] = ACTIONS(443),
    [anon_sym_LT_EQ] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(443),
    [anon_sym_GT_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(445),
    [anon_sym_PIPE_GT] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(443),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym__newline] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(445),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [183] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(371),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [184] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LT_LT_DASH] = ACTIONS(63),
    [anon_sym_COLON_EQ] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(371),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [185] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(371),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [186] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(371),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [187] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LT_LT_DASH] = ACTIONS(63),
    [anon_sym_COLON_EQ] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(371),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [188] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(371),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [189] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(371),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [190] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(371),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [191] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(371),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [192] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(371),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [193] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(371),
    [anon_sym_PIPE_GT] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(373),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(371),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [194] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(371),
    [anon_sym_PIPE_GT] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(371),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [195] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(371),
    [anon_sym_PIPE_GT] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(373),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(371),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [196] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(375),
    [anon_sym_function] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_repeat] = ACTIONS(377),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LT_LT_DASH] = ACTIONS(63),
    [anon_sym_COLON_EQ] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(375),
    [sym__number_literal] = ACTIONS(377),
    [anon_sym_SQUOTE] = ACTIONS(375),
    [anon_sym_DQUOTE] = ACTIONS(375),
    [sym_return] = ACTIONS(377),
    [sym_next] = ACTIONS(377),
    [sym_break] = ACTIONS(377),
    [sym_true] = ACTIONS(377),
    [sym_false] = ACTIONS(377),
    [sym_null] = ACTIONS(377),
    [sym_inf] = ACTIONS(377),
    [sym_nan] = ACTIONS(377),
    [anon_sym_NA] = ACTIONS(377),
    [anon_sym_NA_integer_] = ACTIONS(377),
    [anon_sym_NA_real_] = ACTIONS(377),
    [anon_sym_NA_complex_] = ACTIONS(377),
    [anon_sym_NA_character_] = ACTIONS(377),
    [sym_dots] = ACTIONS(377),
    [sym_dot_dot_i] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(375),
    [sym__newline] = ACTIONS(375),
    [sym__raw_string_literal] = ACTIONS(375),
    [sym__external_else] = ACTIONS(375),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(375),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(375),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [197] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(379),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [198] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LT_LT_DASH] = ACTIONS(63),
    [anon_sym_COLON_EQ] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(379),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [199] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(379),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [200] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(379),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [201] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LT_LT_DASH] = ACTIONS(63),
    [anon_sym_COLON_EQ] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(379),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [202] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(379),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [203] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(379),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [204] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(379),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [205] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(379),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [206] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(379),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [207] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(379),
    [anon_sym_PIPE_GT] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(381),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(379),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [208] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(379),
    [anon_sym_PIPE_GT] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(379),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [209] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(379),
    [anon_sym_PIPE_GT] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(381),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(379),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [210] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(385),
    [anon_sym_BSLASH] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_for] = ACTIONS(385),
    [anon_sym_while] = ACTIONS(385),
    [anon_sym_repeat] = ACTIONS(385),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LT_LT_DASH] = ACTIONS(63),
    [anon_sym_COLON_EQ] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(383),
    [sym__number_literal] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [sym_return] = ACTIONS(385),
    [sym_next] = ACTIONS(385),
    [sym_break] = ACTIONS(385),
    [sym_true] = ACTIONS(385),
    [sym_false] = ACTIONS(385),
    [sym_null] = ACTIONS(385),
    [sym_inf] = ACTIONS(385),
    [sym_nan] = ACTIONS(385),
    [anon_sym_NA] = ACTIONS(385),
    [anon_sym_NA_integer_] = ACTIONS(385),
    [anon_sym_NA_real_] = ACTIONS(385),
    [anon_sym_NA_complex_] = ACTIONS(385),
    [anon_sym_NA_character_] = ACTIONS(385),
    [sym_dots] = ACTIONS(385),
    [sym_dot_dot_i] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(383),
    [sym__newline] = ACTIONS(383),
    [sym__raw_string_literal] = ACTIONS(383),
    [sym__external_else] = ACTIONS(383),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(383),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(383),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [211] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(389),
    [anon_sym_for] = ACTIONS(389),
    [anon_sym_while] = ACTIONS(389),
    [anon_sym_repeat] = ACTIONS(389),
    [anon_sym_QMARK] = ACTIONS(387),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(389),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LT_LT_DASH] = ACTIONS(63),
    [anon_sym_COLON_EQ] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(387),
    [sym__number_literal] = ACTIONS(389),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_return] = ACTIONS(389),
    [sym_next] = ACTIONS(389),
    [sym_break] = ACTIONS(389),
    [sym_true] = ACTIONS(389),
    [sym_false] = ACTIONS(389),
    [sym_null] = ACTIONS(389),
    [sym_inf] = ACTIONS(389),
    [sym_nan] = ACTIONS(389),
    [anon_sym_NA] = ACTIONS(389),
    [anon_sym_NA_integer_] = ACTIONS(389),
    [anon_sym_NA_real_] = ACTIONS(389),
    [anon_sym_NA_complex_] = ACTIONS(389),
    [anon_sym_NA_character_] = ACTIONS(389),
    [sym_dots] = ACTIONS(389),
    [sym_dot_dot_i] = ACTIONS(387),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym__newline] = ACTIONS(387),
    [sym__raw_string_literal] = ACTIONS(387),
    [sym__external_else] = ACTIONS(387),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(387),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(387),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [212] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_BSLASH] = ACTIONS(391),
    [anon_sym_function] = ACTIONS(393),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(393),
    [anon_sym_for] = ACTIONS(393),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_repeat] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LT_LT_DASH] = ACTIONS(63),
    [anon_sym_COLON_EQ] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(391),
    [sym__number_literal] = ACTIONS(393),
    [anon_sym_SQUOTE] = ACTIONS(391),
    [anon_sym_DQUOTE] = ACTIONS(391),
    [sym_return] = ACTIONS(393),
    [sym_next] = ACTIONS(393),
    [sym_break] = ACTIONS(393),
    [sym_true] = ACTIONS(393),
    [sym_false] = ACTIONS(393),
    [sym_null] = ACTIONS(393),
    [sym_inf] = ACTIONS(393),
    [sym_nan] = ACTIONS(393),
    [anon_sym_NA] = ACTIONS(393),
    [anon_sym_NA_integer_] = ACTIONS(393),
    [anon_sym_NA_real_] = ACTIONS(393),
    [anon_sym_NA_complex_] = ACTIONS(393),
    [anon_sym_NA_character_] = ACTIONS(393),
    [sym_dots] = ACTIONS(393),
    [sym_dot_dot_i] = ACTIONS(391),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(391),
    [sym__newline] = ACTIONS(391),
    [sym__raw_string_literal] = ACTIONS(391),
    [sym__external_else] = ACTIONS(391),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(391),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(391),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [213] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(397),
    [anon_sym_BSLASH] = ACTIONS(395),
    [anon_sym_function] = ACTIONS(397),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_while] = ACTIONS(397),
    [anon_sym_repeat] = ACTIONS(397),
    [anon_sym_QMARK] = ACTIONS(395),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LT_LT_DASH] = ACTIONS(63),
    [anon_sym_COLON_EQ] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(395),
    [sym__number_literal] = ACTIONS(397),
    [anon_sym_SQUOTE] = ACTIONS(395),
    [anon_sym_DQUOTE] = ACTIONS(395),
    [sym_return] = ACTIONS(397),
    [sym_next] = ACTIONS(397),
    [sym_break] = ACTIONS(397),
    [sym_true] = ACTIONS(397),
    [sym_false] = ACTIONS(397),
    [sym_null] = ACTIONS(397),
    [sym_inf] = ACTIONS(397),
    [sym_nan] = ACTIONS(397),
    [anon_sym_NA] = ACTIONS(397),
    [anon_sym_NA_integer_] = ACTIONS(397),
    [anon_sym_NA_real_] = ACTIONS(397),
    [anon_sym_NA_complex_] = ACTIONS(397),
    [anon_sym_NA_character_] = ACTIONS(397),
    [sym_dots] = ACTIONS(397),
    [sym_dot_dot_i] = ACTIONS(395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(395),
    [sym__newline] = ACTIONS(395),
    [sym__raw_string_literal] = ACTIONS(395),
    [sym__external_else] = ACTIONS(395),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(395),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(395),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [214] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(401),
    [anon_sym_BSLASH] = ACTIONS(399),
    [anon_sym_function] = ACTIONS(401),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(401),
    [anon_sym_for] = ACTIONS(401),
    [anon_sym_while] = ACTIONS(401),
    [anon_sym_repeat] = ACTIONS(401),
    [anon_sym_QMARK] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LT_LT_DASH] = ACTIONS(63),
    [anon_sym_COLON_EQ] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(399),
    [sym__number_literal] = ACTIONS(401),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [sym_return] = ACTIONS(401),
    [sym_next] = ACTIONS(401),
    [sym_break] = ACTIONS(401),
    [sym_true] = ACTIONS(401),
    [sym_false] = ACTIONS(401),
    [sym_null] = ACTIONS(401),
    [sym_inf] = ACTIONS(401),
    [sym_nan] = ACTIONS(401),
    [anon_sym_NA] = ACTIONS(401),
    [anon_sym_NA_integer_] = ACTIONS(401),
    [anon_sym_NA_real_] = ACTIONS(401),
    [anon_sym_NA_complex_] = ACTIONS(401),
    [anon_sym_NA_character_] = ACTIONS(401),
    [sym_dots] = ACTIONS(401),
    [sym_dot_dot_i] = ACTIONS(399),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(399),
    [sym__newline] = ACTIONS(399),
    [sym__raw_string_literal] = ACTIONS(399),
    [sym__external_else] = ACTIONS(399),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(399),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(399),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [215] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_BSLASH] = ACTIONS(403),
    [anon_sym_function] = ACTIONS(405),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(405),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_while] = ACTIONS(405),
    [anon_sym_repeat] = ACTIONS(405),
    [anon_sym_QMARK] = ACTIONS(403),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(405),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LT_LT_DASH] = ACTIONS(63),
    [anon_sym_COLON_EQ] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(403),
    [sym__number_literal] = ACTIONS(405),
    [anon_sym_SQUOTE] = ACTIONS(403),
    [anon_sym_DQUOTE] = ACTIONS(403),
    [sym_return] = ACTIONS(405),
    [sym_next] = ACTIONS(405),
    [sym_break] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_null] = ACTIONS(405),
    [sym_inf] = ACTIONS(405),
    [sym_nan] = ACTIONS(405),
    [anon_sym_NA] = ACTIONS(405),
    [anon_sym_NA_integer_] = ACTIONS(405),
    [anon_sym_NA_real_] = ACTIONS(405),
    [anon_sym_NA_complex_] = ACTIONS(405),
    [anon_sym_NA_character_] = ACTIONS(405),
    [sym_dots] = ACTIONS(405),
    [sym_dot_dot_i] = ACTIONS(403),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(403),
    [sym__newline] = ACTIONS(403),
    [sym__raw_string_literal] = ACTIONS(403),
    [sym__external_else] = ACTIONS(403),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(403),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(403),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [216] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_BSLASH] = ACTIONS(407),
    [anon_sym_function] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(409),
    [anon_sym_while] = ACTIONS(409),
    [anon_sym_repeat] = ACTIONS(409),
    [anon_sym_QMARK] = ACTIONS(407),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(409),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LT_LT_DASH] = ACTIONS(63),
    [anon_sym_COLON_EQ] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(407),
    [sym__number_literal] = ACTIONS(409),
    [anon_sym_SQUOTE] = ACTIONS(407),
    [anon_sym_DQUOTE] = ACTIONS(407),
    [sym_return] = ACTIONS(409),
    [sym_next] = ACTIONS(409),
    [sym_break] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_null] = ACTIONS(409),
    [sym_inf] = ACTIONS(409),
    [sym_nan] = ACTIONS(409),
    [anon_sym_NA] = ACTIONS(409),
    [anon_sym_NA_integer_] = ACTIONS(409),
    [anon_sym_NA_real_] = ACTIONS(409),
    [anon_sym_NA_complex_] = ACTIONS(409),
    [anon_sym_NA_character_] = ACTIONS(409),
    [sym_dots] = ACTIONS(409),
    [sym_dot_dot_i] = ACTIONS(407),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(407),
    [sym__newline] = ACTIONS(407),
    [sym__raw_string_literal] = ACTIONS(407),
    [sym__external_else] = ACTIONS(407),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(407),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(407),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [217] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(367),
    [anon_sym_BSLASH] = ACTIONS(369),
    [anon_sym_function] = ACTIONS(367),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(367),
    [anon_sym_for] = ACTIONS(367),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_repeat] = ACTIONS(367),
    [anon_sym_QMARK] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LT_LT_DASH] = ACTIONS(63),
    [anon_sym_COLON_EQ] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(369),
    [sym__number_literal] = ACTIONS(367),
    [anon_sym_SQUOTE] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [sym_return] = ACTIONS(367),
    [sym_next] = ACTIONS(367),
    [sym_break] = ACTIONS(367),
    [sym_true] = ACTIONS(367),
    [sym_false] = ACTIONS(367),
    [sym_null] = ACTIONS(367),
    [sym_inf] = ACTIONS(367),
    [sym_nan] = ACTIONS(367),
    [anon_sym_NA] = ACTIONS(367),
    [anon_sym_NA_integer_] = ACTIONS(367),
    [anon_sym_NA_real_] = ACTIONS(367),
    [anon_sym_NA_complex_] = ACTIONS(367),
    [anon_sym_NA_character_] = ACTIONS(367),
    [sym_dots] = ACTIONS(367),
    [sym_dot_dot_i] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(369),
    [sym__newline] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(369),
    [sym__external_else] = ACTIONS(369),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(369),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [218] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_BSLASH] = ACTIONS(411),
    [anon_sym_function] = ACTIONS(413),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_repeat] = ACTIONS(413),
    [anon_sym_QMARK] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(413),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LT_LT_DASH] = ACTIONS(63),
    [anon_sym_COLON_EQ] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(411),
    [sym__number_literal] = ACTIONS(413),
    [anon_sym_SQUOTE] = ACTIONS(411),
    [anon_sym_DQUOTE] = ACTIONS(411),
    [sym_return] = ACTIONS(413),
    [sym_next] = ACTIONS(413),
    [sym_break] = ACTIONS(413),
    [sym_true] = ACTIONS(413),
    [sym_false] = ACTIONS(413),
    [sym_null] = ACTIONS(413),
    [sym_inf] = ACTIONS(413),
    [sym_nan] = ACTIONS(413),
    [anon_sym_NA] = ACTIONS(413),
    [anon_sym_NA_integer_] = ACTIONS(413),
    [anon_sym_NA_real_] = ACTIONS(413),
    [anon_sym_NA_complex_] = ACTIONS(413),
    [anon_sym_NA_character_] = ACTIONS(413),
    [sym_dots] = ACTIONS(413),
    [sym_dot_dot_i] = ACTIONS(411),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(411),
    [sym__newline] = ACTIONS(411),
    [sym__raw_string_literal] = ACTIONS(411),
    [sym__external_else] = ACTIONS(411),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(411),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(411),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [219] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(417),
    [anon_sym_BSLASH] = ACTIONS(415),
    [anon_sym_function] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_repeat] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(415),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LT_LT_DASH] = ACTIONS(63),
    [anon_sym_COLON_EQ] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(415),
    [sym__number_literal] = ACTIONS(417),
    [anon_sym_SQUOTE] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(415),
    [sym_return] = ACTIONS(417),
    [sym_next] = ACTIONS(417),
    [sym_break] = ACTIONS(417),
    [sym_true] = ACTIONS(417),
    [sym_false] = ACTIONS(417),
    [sym_null] = ACTIONS(417),
    [sym_inf] = ACTIONS(417),
    [sym_nan] = ACTIONS(417),
    [anon_sym_NA] = ACTIONS(417),
    [anon_sym_NA_integer_] = ACTIONS(417),
    [anon_sym_NA_real_] = ACTIONS(417),
    [anon_sym_NA_complex_] = ACTIONS(417),
    [anon_sym_NA_character_] = ACTIONS(417),
    [sym_dots] = ACTIONS(417),
    [sym_dot_dot_i] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(415),
    [sym__newline] = ACTIONS(415),
    [sym__raw_string_literal] = ACTIONS(415),
    [sym__external_else] = ACTIONS(415),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(415),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(415),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [220] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(421),
    [anon_sym_BSLASH] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_repeat] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LT_LT_DASH] = ACTIONS(63),
    [anon_sym_COLON_EQ] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(419),
    [sym__number_literal] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(419),
    [anon_sym_DQUOTE] = ACTIONS(419),
    [sym_return] = ACTIONS(421),
    [sym_next] = ACTIONS(421),
    [sym_break] = ACTIONS(421),
    [sym_true] = ACTIONS(421),
    [sym_false] = ACTIONS(421),
    [sym_null] = ACTIONS(421),
    [sym_inf] = ACTIONS(421),
    [sym_nan] = ACTIONS(421),
    [anon_sym_NA] = ACTIONS(421),
    [anon_sym_NA_integer_] = ACTIONS(421),
    [anon_sym_NA_real_] = ACTIONS(421),
    [anon_sym_NA_complex_] = ACTIONS(421),
    [anon_sym_NA_character_] = ACTIONS(421),
    [sym_dots] = ACTIONS(421),
    [sym_dot_dot_i] = ACTIONS(419),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(419),
    [sym__newline] = ACTIONS(419),
    [sym__raw_string_literal] = ACTIONS(419),
    [sym__external_else] = ACTIONS(419),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(419),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(419),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [221] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(425),
    [anon_sym_BSLASH] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_repeat] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LT_LT_DASH] = ACTIONS(63),
    [anon_sym_COLON_EQ] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(423),
    [sym__number_literal] = ACTIONS(425),
    [anon_sym_SQUOTE] = ACTIONS(423),
    [anon_sym_DQUOTE] = ACTIONS(423),
    [sym_return] = ACTIONS(425),
    [sym_next] = ACTIONS(425),
    [sym_break] = ACTIONS(425),
    [sym_true] = ACTIONS(425),
    [sym_false] = ACTIONS(425),
    [sym_null] = ACTIONS(425),
    [sym_inf] = ACTIONS(425),
    [sym_nan] = ACTIONS(425),
    [anon_sym_NA] = ACTIONS(425),
    [anon_sym_NA_integer_] = ACTIONS(425),
    [anon_sym_NA_real_] = ACTIONS(425),
    [anon_sym_NA_complex_] = ACTIONS(425),
    [anon_sym_NA_character_] = ACTIONS(425),
    [sym_dots] = ACTIONS(425),
    [sym_dot_dot_i] = ACTIONS(423),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(423),
    [sym__newline] = ACTIONS(423),
    [sym__raw_string_literal] = ACTIONS(423),
    [sym__external_else] = ACTIONS(423),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(423),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(423),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [222] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(427),
    [anon_sym_BSLASH] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_repeat] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(281),
    [anon_sym_LT_LT_DASH] = ACTIONS(281),
    [anon_sym_COLON_EQ] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(429),
    [sym__number_literal] = ACTIONS(427),
    [anon_sym_SQUOTE] = ACTIONS(429),
    [anon_sym_DQUOTE] = ACTIONS(429),
    [sym_return] = ACTIONS(427),
    [sym_next] = ACTIONS(427),
    [sym_break] = ACTIONS(427),
    [sym_true] = ACTIONS(427),
    [sym_false] = ACTIONS(427),
    [sym_null] = ACTIONS(427),
    [sym_inf] = ACTIONS(427),
    [sym_nan] = ACTIONS(427),
    [anon_sym_NA] = ACTIONS(427),
    [anon_sym_NA_integer_] = ACTIONS(427),
    [anon_sym_NA_real_] = ACTIONS(427),
    [anon_sym_NA_complex_] = ACTIONS(427),
    [anon_sym_NA_character_] = ACTIONS(427),
    [sym_dots] = ACTIONS(427),
    [sym_dot_dot_i] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(429),
    [sym__newline] = ACTIONS(429),
    [sym__raw_string_literal] = ACTIONS(429),
    [sym__external_else] = ACTIONS(429),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(429),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(429),
  },
  [223] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(281),
    [anon_sym_LT_LT_DASH] = ACTIONS(281),
    [anon_sym_COLON_EQ] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym__newline] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_else] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(433),
  },
  [224] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(433),
    [anon_sym_LT_LT_DASH] = ACTIONS(433),
    [anon_sym_COLON_EQ] = ACTIONS(433),
    [anon_sym_DASH_GT] = ACTIONS(431),
    [anon_sym_DASH_GT_GT] = ACTIONS(433),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym__newline] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_else] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(433),
  },
  [225] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(433),
    [anon_sym_LT_LT_DASH] = ACTIONS(433),
    [anon_sym_COLON_EQ] = ACTIONS(433),
    [anon_sym_DASH_GT] = ACTIONS(431),
    [anon_sym_DASH_GT_GT] = ACTIONS(433),
    [anon_sym_PIPE] = ACTIONS(431),
    [anon_sym_AMP] = ACTIONS(431),
    [anon_sym_PIPE_PIPE] = ACTIONS(433),
    [anon_sym_AMP_AMP] = ACTIONS(433),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym__newline] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_else] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(433),
  },
  [226] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(433),
    [anon_sym_DASH] = ACTIONS(431),
    [anon_sym_LT_DASH] = ACTIONS(433),
    [anon_sym_LT_LT_DASH] = ACTIONS(433),
    [anon_sym_COLON_EQ] = ACTIONS(433),
    [anon_sym_DASH_GT] = ACTIONS(431),
    [anon_sym_DASH_GT_GT] = ACTIONS(433),
    [anon_sym_PIPE] = ACTIONS(431),
    [anon_sym_AMP] = ACTIONS(431),
    [anon_sym_PIPE_PIPE] = ACTIONS(433),
    [anon_sym_AMP_AMP] = ACTIONS(433),
    [anon_sym_LT] = ACTIONS(431),
    [anon_sym_LT_EQ] = ACTIONS(433),
    [anon_sym_GT] = ACTIONS(431),
    [anon_sym_GT_EQ] = ACTIONS(433),
    [anon_sym_EQ_EQ] = ACTIONS(433),
    [anon_sym_BANG_EQ] = ACTIONS(433),
    [anon_sym_STAR] = ACTIONS(431),
    [anon_sym_SLASH] = ACTIONS(433),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(433),
    [anon_sym_PIPE_GT] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(431),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym__newline] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_else] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(433),
  },
  [227] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(435),
    [anon_sym_BSLASH] = ACTIONS(437),
    [anon_sym_function] = ACTIONS(435),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(435),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_repeat] = ACTIONS(435),
    [anon_sym_QMARK] = ACTIONS(437),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(435),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(281),
    [anon_sym_LT_LT_DASH] = ACTIONS(281),
    [anon_sym_COLON_EQ] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(437),
    [sym__number_literal] = ACTIONS(435),
    [anon_sym_SQUOTE] = ACTIONS(437),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [sym_return] = ACTIONS(435),
    [sym_next] = ACTIONS(435),
    [sym_break] = ACTIONS(435),
    [sym_true] = ACTIONS(435),
    [sym_false] = ACTIONS(435),
    [sym_null] = ACTIONS(435),
    [sym_inf] = ACTIONS(435),
    [sym_nan] = ACTIONS(435),
    [anon_sym_NA] = ACTIONS(435),
    [anon_sym_NA_integer_] = ACTIONS(435),
    [anon_sym_NA_real_] = ACTIONS(435),
    [anon_sym_NA_complex_] = ACTIONS(435),
    [anon_sym_NA_character_] = ACTIONS(435),
    [sym_dots] = ACTIONS(435),
    [sym_dot_dot_i] = ACTIONS(437),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(437),
    [sym__newline] = ACTIONS(437),
    [sym__raw_string_literal] = ACTIONS(437),
    [sym__external_else] = ACTIONS(437),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(437),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(437),
  },
  [228] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(439),
    [anon_sym_BSLASH] = ACTIONS(441),
    [anon_sym_function] = ACTIONS(439),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(439),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(439),
    [anon_sym_repeat] = ACTIONS(439),
    [anon_sym_QMARK] = ACTIONS(441),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(439),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(281),
    [anon_sym_LT_LT_DASH] = ACTIONS(281),
    [anon_sym_COLON_EQ] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(441),
    [sym__number_literal] = ACTIONS(439),
    [anon_sym_SQUOTE] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(441),
    [sym_return] = ACTIONS(439),
    [sym_next] = ACTIONS(439),
    [sym_break] = ACTIONS(439),
    [sym_true] = ACTIONS(439),
    [sym_false] = ACTIONS(439),
    [sym_null] = ACTIONS(439),
    [sym_inf] = ACTIONS(439),
    [sym_nan] = ACTIONS(439),
    [anon_sym_NA] = ACTIONS(439),
    [anon_sym_NA_integer_] = ACTIONS(439),
    [anon_sym_NA_real_] = ACTIONS(439),
    [anon_sym_NA_complex_] = ACTIONS(439),
    [anon_sym_NA_character_] = ACTIONS(439),
    [sym_dots] = ACTIONS(439),
    [sym_dot_dot_i] = ACTIONS(441),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(441),
    [sym__newline] = ACTIONS(441),
    [sym__raw_string_literal] = ACTIONS(441),
    [sym__external_else] = ACTIONS(441),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(441),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(441),
  },
  [229] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(281),
    [anon_sym_LT_LT_DASH] = ACTIONS(281),
    [anon_sym_COLON_EQ] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym__newline] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(445),
  },
  [230] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(445),
    [anon_sym_LT_LT_DASH] = ACTIONS(445),
    [anon_sym_COLON_EQ] = ACTIONS(445),
    [anon_sym_DASH_GT] = ACTIONS(443),
    [anon_sym_DASH_GT_GT] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym__newline] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(445),
  },
  [231] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(445),
    [anon_sym_LT_LT_DASH] = ACTIONS(445),
    [anon_sym_COLON_EQ] = ACTIONS(445),
    [anon_sym_DASH_GT] = ACTIONS(443),
    [anon_sym_DASH_GT_GT] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(443),
    [anon_sym_AMP] = ACTIONS(443),
    [anon_sym_PIPE_PIPE] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(445),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym__newline] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(445),
  },
  [232] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(443),
    [anon_sym_LT_DASH] = ACTIONS(445),
    [anon_sym_LT_LT_DASH] = ACTIONS(445),
    [anon_sym_COLON_EQ] = ACTIONS(445),
    [anon_sym_DASH_GT] = ACTIONS(443),
    [anon_sym_DASH_GT_GT] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(443),
    [anon_sym_AMP] = ACTIONS(443),
    [anon_sym_PIPE_PIPE] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(445),
    [anon_sym_LT] = ACTIONS(443),
    [anon_sym_LT_EQ] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(443),
    [anon_sym_GT_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(445),
    [anon_sym_PIPE_GT] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(443),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym__newline] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(445),
  },
  [233] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(371),
  },
  [234] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(281),
    [anon_sym_LT_LT_DASH] = ACTIONS(281),
    [anon_sym_COLON_EQ] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(371),
  },
  [235] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(371),
  },
  [236] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(371),
  },
  [237] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(281),
    [anon_sym_LT_LT_DASH] = ACTIONS(281),
    [anon_sym_COLON_EQ] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(371),
  },
  [238] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(371),
  },
  [239] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(371),
  },
  [240] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(371),
  },
  [241] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(371),
  },
  [242] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(371),
  },
  [243] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(371),
    [anon_sym_PIPE_GT] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(373),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(371),
  },
  [244] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(371),
    [anon_sym_PIPE_GT] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(371),
  },
  [245] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(371),
    [anon_sym_PIPE_GT] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(373),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(371),
  },
  [246] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(375),
    [anon_sym_function] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_repeat] = ACTIONS(377),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(281),
    [anon_sym_LT_LT_DASH] = ACTIONS(281),
    [anon_sym_COLON_EQ] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(375),
    [sym__number_literal] = ACTIONS(377),
    [anon_sym_SQUOTE] = ACTIONS(375),
    [anon_sym_DQUOTE] = ACTIONS(375),
    [sym_return] = ACTIONS(377),
    [sym_next] = ACTIONS(377),
    [sym_break] = ACTIONS(377),
    [sym_true] = ACTIONS(377),
    [sym_false] = ACTIONS(377),
    [sym_null] = ACTIONS(377),
    [sym_inf] = ACTIONS(377),
    [sym_nan] = ACTIONS(377),
    [anon_sym_NA] = ACTIONS(377),
    [anon_sym_NA_integer_] = ACTIONS(377),
    [anon_sym_NA_real_] = ACTIONS(377),
    [anon_sym_NA_complex_] = ACTIONS(377),
    [anon_sym_NA_character_] = ACTIONS(377),
    [sym_dots] = ACTIONS(377),
    [sym_dot_dot_i] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(375),
    [sym__newline] = ACTIONS(375),
    [sym__raw_string_literal] = ACTIONS(375),
    [sym__external_else] = ACTIONS(375),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(375),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(375),
  },
  [247] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(379),
  },
  [248] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(281),
    [anon_sym_LT_LT_DASH] = ACTIONS(281),
    [anon_sym_COLON_EQ] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(379),
  },
  [249] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(379),
  },
  [250] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(379),
  },
  [251] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(281),
    [anon_sym_LT_LT_DASH] = ACTIONS(281),
    [anon_sym_COLON_EQ] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(379),
  },
  [252] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(379),
  },
  [253] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(379),
  },
  [254] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(379),
  },
  [255] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(379),
  },
  [256] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(379),
  },
  [257] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(379),
    [anon_sym_PIPE_GT] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(381),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(379),
  },
  [258] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(379),
    [anon_sym_PIPE_GT] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(379),
  },
  [259] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(379),
    [anon_sym_PIPE_GT] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(381),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_else] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(379),
  },
  [260] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(385),
    [anon_sym_BSLASH] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_for] = ACTIONS(385),
    [anon_sym_while] = ACTIONS(385),
    [anon_sym_repeat] = ACTIONS(385),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(281),
    [anon_sym_LT_LT_DASH] = ACTIONS(281),
    [anon_sym_COLON_EQ] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(383),
    [sym__number_literal] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [sym_return] = ACTIONS(385),
    [sym_next] = ACTIONS(385),
    [sym_break] = ACTIONS(385),
    [sym_true] = ACTIONS(385),
    [sym_false] = ACTIONS(385),
    [sym_null] = ACTIONS(385),
    [sym_inf] = ACTIONS(385),
    [sym_nan] = ACTIONS(385),
    [anon_sym_NA] = ACTIONS(385),
    [anon_sym_NA_integer_] = ACTIONS(385),
    [anon_sym_NA_real_] = ACTIONS(385),
    [anon_sym_NA_complex_] = ACTIONS(385),
    [anon_sym_NA_character_] = ACTIONS(385),
    [sym_dots] = ACTIONS(385),
    [sym_dot_dot_i] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(383),
    [sym__newline] = ACTIONS(383),
    [sym__raw_string_literal] = ACTIONS(383),
    [sym__external_else] = ACTIONS(383),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(383),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(383),
  },
  [261] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(389),
    [anon_sym_for] = ACTIONS(389),
    [anon_sym_while] = ACTIONS(389),
    [anon_sym_repeat] = ACTIONS(389),
    [anon_sym_QMARK] = ACTIONS(387),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(389),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(281),
    [anon_sym_LT_LT_DASH] = ACTIONS(281),
    [anon_sym_COLON_EQ] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(387),
    [sym__number_literal] = ACTIONS(389),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_return] = ACTIONS(389),
    [sym_next] = ACTIONS(389),
    [sym_break] = ACTIONS(389),
    [sym_true] = ACTIONS(389),
    [sym_false] = ACTIONS(389),
    [sym_null] = ACTIONS(389),
    [sym_inf] = ACTIONS(389),
    [sym_nan] = ACTIONS(389),
    [anon_sym_NA] = ACTIONS(389),
    [anon_sym_NA_integer_] = ACTIONS(389),
    [anon_sym_NA_real_] = ACTIONS(389),
    [anon_sym_NA_complex_] = ACTIONS(389),
    [anon_sym_NA_character_] = ACTIONS(389),
    [sym_dots] = ACTIONS(389),
    [sym_dot_dot_i] = ACTIONS(387),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym__newline] = ACTIONS(387),
    [sym__raw_string_literal] = ACTIONS(387),
    [sym__external_else] = ACTIONS(387),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(387),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(387),
  },
  [262] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_BSLASH] = ACTIONS(391),
    [anon_sym_function] = ACTIONS(393),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(393),
    [anon_sym_for] = ACTIONS(393),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_repeat] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(281),
    [anon_sym_LT_LT_DASH] = ACTIONS(281),
    [anon_sym_COLON_EQ] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(391),
    [sym__number_literal] = ACTIONS(393),
    [anon_sym_SQUOTE] = ACTIONS(391),
    [anon_sym_DQUOTE] = ACTIONS(391),
    [sym_return] = ACTIONS(393),
    [sym_next] = ACTIONS(393),
    [sym_break] = ACTIONS(393),
    [sym_true] = ACTIONS(393),
    [sym_false] = ACTIONS(393),
    [sym_null] = ACTIONS(393),
    [sym_inf] = ACTIONS(393),
    [sym_nan] = ACTIONS(393),
    [anon_sym_NA] = ACTIONS(393),
    [anon_sym_NA_integer_] = ACTIONS(393),
    [anon_sym_NA_real_] = ACTIONS(393),
    [anon_sym_NA_complex_] = ACTIONS(393),
    [anon_sym_NA_character_] = ACTIONS(393),
    [sym_dots] = ACTIONS(393),
    [sym_dot_dot_i] = ACTIONS(391),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(391),
    [sym__newline] = ACTIONS(391),
    [sym__raw_string_literal] = ACTIONS(391),
    [sym__external_else] = ACTIONS(391),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(391),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(391),
  },
  [263] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(397),
    [anon_sym_BSLASH] = ACTIONS(395),
    [anon_sym_function] = ACTIONS(397),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_while] = ACTIONS(397),
    [anon_sym_repeat] = ACTIONS(397),
    [anon_sym_QMARK] = ACTIONS(395),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(281),
    [anon_sym_LT_LT_DASH] = ACTIONS(281),
    [anon_sym_COLON_EQ] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(395),
    [sym__number_literal] = ACTIONS(397),
    [anon_sym_SQUOTE] = ACTIONS(395),
    [anon_sym_DQUOTE] = ACTIONS(395),
    [sym_return] = ACTIONS(397),
    [sym_next] = ACTIONS(397),
    [sym_break] = ACTIONS(397),
    [sym_true] = ACTIONS(397),
    [sym_false] = ACTIONS(397),
    [sym_null] = ACTIONS(397),
    [sym_inf] = ACTIONS(397),
    [sym_nan] = ACTIONS(397),
    [anon_sym_NA] = ACTIONS(397),
    [anon_sym_NA_integer_] = ACTIONS(397),
    [anon_sym_NA_real_] = ACTIONS(397),
    [anon_sym_NA_complex_] = ACTIONS(397),
    [anon_sym_NA_character_] = ACTIONS(397),
    [sym_dots] = ACTIONS(397),
    [sym_dot_dot_i] = ACTIONS(395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(395),
    [sym__newline] = ACTIONS(395),
    [sym__raw_string_literal] = ACTIONS(395),
    [sym__external_else] = ACTIONS(395),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(395),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(395),
  },
  [264] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(401),
    [anon_sym_BSLASH] = ACTIONS(399),
    [anon_sym_function] = ACTIONS(401),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(401),
    [anon_sym_for] = ACTIONS(401),
    [anon_sym_while] = ACTIONS(401),
    [anon_sym_repeat] = ACTIONS(401),
    [anon_sym_QMARK] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(281),
    [anon_sym_LT_LT_DASH] = ACTIONS(281),
    [anon_sym_COLON_EQ] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(399),
    [sym__number_literal] = ACTIONS(401),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [sym_return] = ACTIONS(401),
    [sym_next] = ACTIONS(401),
    [sym_break] = ACTIONS(401),
    [sym_true] = ACTIONS(401),
    [sym_false] = ACTIONS(401),
    [sym_null] = ACTIONS(401),
    [sym_inf] = ACTIONS(401),
    [sym_nan] = ACTIONS(401),
    [anon_sym_NA] = ACTIONS(401),
    [anon_sym_NA_integer_] = ACTIONS(401),
    [anon_sym_NA_real_] = ACTIONS(401),
    [anon_sym_NA_complex_] = ACTIONS(401),
    [anon_sym_NA_character_] = ACTIONS(401),
    [sym_dots] = ACTIONS(401),
    [sym_dot_dot_i] = ACTIONS(399),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(399),
    [sym__newline] = ACTIONS(399),
    [sym__raw_string_literal] = ACTIONS(399),
    [sym__external_else] = ACTIONS(399),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(399),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(399),
  },
  [265] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_BSLASH] = ACTIONS(403),
    [anon_sym_function] = ACTIONS(405),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(405),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_while] = ACTIONS(405),
    [anon_sym_repeat] = ACTIONS(405),
    [anon_sym_QMARK] = ACTIONS(403),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(405),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(281),
    [anon_sym_LT_LT_DASH] = ACTIONS(281),
    [anon_sym_COLON_EQ] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(403),
    [sym__number_literal] = ACTIONS(405),
    [anon_sym_SQUOTE] = ACTIONS(403),
    [anon_sym_DQUOTE] = ACTIONS(403),
    [sym_return] = ACTIONS(405),
    [sym_next] = ACTIONS(405),
    [sym_break] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_null] = ACTIONS(405),
    [sym_inf] = ACTIONS(405),
    [sym_nan] = ACTIONS(405),
    [anon_sym_NA] = ACTIONS(405),
    [anon_sym_NA_integer_] = ACTIONS(405),
    [anon_sym_NA_real_] = ACTIONS(405),
    [anon_sym_NA_complex_] = ACTIONS(405),
    [anon_sym_NA_character_] = ACTIONS(405),
    [sym_dots] = ACTIONS(405),
    [sym_dot_dot_i] = ACTIONS(403),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(403),
    [sym__newline] = ACTIONS(403),
    [sym__raw_string_literal] = ACTIONS(403),
    [sym__external_else] = ACTIONS(403),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(403),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(403),
  },
  [266] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_BSLASH] = ACTIONS(407),
    [anon_sym_function] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(409),
    [anon_sym_while] = ACTIONS(409),
    [anon_sym_repeat] = ACTIONS(409),
    [anon_sym_QMARK] = ACTIONS(407),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(409),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(281),
    [anon_sym_LT_LT_DASH] = ACTIONS(281),
    [anon_sym_COLON_EQ] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(407),
    [sym__number_literal] = ACTIONS(409),
    [anon_sym_SQUOTE] = ACTIONS(407),
    [anon_sym_DQUOTE] = ACTIONS(407),
    [sym_return] = ACTIONS(409),
    [sym_next] = ACTIONS(409),
    [sym_break] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_null] = ACTIONS(409),
    [sym_inf] = ACTIONS(409),
    [sym_nan] = ACTIONS(409),
    [anon_sym_NA] = ACTIONS(409),
    [anon_sym_NA_integer_] = ACTIONS(409),
    [anon_sym_NA_real_] = ACTIONS(409),
    [anon_sym_NA_complex_] = ACTIONS(409),
    [anon_sym_NA_character_] = ACTIONS(409),
    [sym_dots] = ACTIONS(409),
    [sym_dot_dot_i] = ACTIONS(407),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(407),
    [sym__newline] = ACTIONS(407),
    [sym__raw_string_literal] = ACTIONS(407),
    [sym__external_else] = ACTIONS(407),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(407),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(407),
  },
  [267] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(429),
    [sym_identifier] = ACTIONS(427),
    [anon_sym_BSLASH] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_repeat] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LT_LT_DASH] = ACTIONS(113),
    [anon_sym_COLON_EQ] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(429),
    [sym__number_literal] = ACTIONS(427),
    [anon_sym_SQUOTE] = ACTIONS(429),
    [anon_sym_DQUOTE] = ACTIONS(429),
    [sym_return] = ACTIONS(427),
    [sym_next] = ACTIONS(427),
    [sym_break] = ACTIONS(427),
    [sym_true] = ACTIONS(427),
    [sym_false] = ACTIONS(427),
    [sym_null] = ACTIONS(427),
    [sym_inf] = ACTIONS(427),
    [sym_nan] = ACTIONS(427),
    [anon_sym_NA] = ACTIONS(427),
    [anon_sym_NA_integer_] = ACTIONS(427),
    [anon_sym_NA_real_] = ACTIONS(427),
    [anon_sym_NA_complex_] = ACTIONS(427),
    [anon_sym_NA_character_] = ACTIONS(427),
    [sym_dots] = ACTIONS(427),
    [sym_dot_dot_i] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(429),
    [sym__semicolon] = ACTIONS(429),
    [sym__raw_string_literal] = ACTIONS(429),
    [sym__external_else] = ACTIONS(429),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(429),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [268] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_BSLASH] = ACTIONS(411),
    [anon_sym_function] = ACTIONS(413),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_repeat] = ACTIONS(413),
    [anon_sym_QMARK] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(413),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(281),
    [anon_sym_LT_LT_DASH] = ACTIONS(281),
    [anon_sym_COLON_EQ] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(411),
    [sym__number_literal] = ACTIONS(413),
    [anon_sym_SQUOTE] = ACTIONS(411),
    [anon_sym_DQUOTE] = ACTIONS(411),
    [sym_return] = ACTIONS(413),
    [sym_next] = ACTIONS(413),
    [sym_break] = ACTIONS(413),
    [sym_true] = ACTIONS(413),
    [sym_false] = ACTIONS(413),
    [sym_null] = ACTIONS(413),
    [sym_inf] = ACTIONS(413),
    [sym_nan] = ACTIONS(413),
    [anon_sym_NA] = ACTIONS(413),
    [anon_sym_NA_integer_] = ACTIONS(413),
    [anon_sym_NA_real_] = ACTIONS(413),
    [anon_sym_NA_complex_] = ACTIONS(413),
    [anon_sym_NA_character_] = ACTIONS(413),
    [sym_dots] = ACTIONS(413),
    [sym_dot_dot_i] = ACTIONS(411),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(411),
    [sym__newline] = ACTIONS(411),
    [sym__raw_string_literal] = ACTIONS(411),
    [sym__external_else] = ACTIONS(411),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(411),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(411),
  },
  [269] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(417),
    [anon_sym_BSLASH] = ACTIONS(415),
    [anon_sym_function] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_repeat] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(415),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(281),
    [anon_sym_LT_LT_DASH] = ACTIONS(281),
    [anon_sym_COLON_EQ] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(415),
    [sym__number_literal] = ACTIONS(417),
    [anon_sym_SQUOTE] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(415),
    [sym_return] = ACTIONS(417),
    [sym_next] = ACTIONS(417),
    [sym_break] = ACTIONS(417),
    [sym_true] = ACTIONS(417),
    [sym_false] = ACTIONS(417),
    [sym_null] = ACTIONS(417),
    [sym_inf] = ACTIONS(417),
    [sym_nan] = ACTIONS(417),
    [anon_sym_NA] = ACTIONS(417),
    [anon_sym_NA_integer_] = ACTIONS(417),
    [anon_sym_NA_real_] = ACTIONS(417),
    [anon_sym_NA_complex_] = ACTIONS(417),
    [anon_sym_NA_character_] = ACTIONS(417),
    [sym_dots] = ACTIONS(417),
    [sym_dot_dot_i] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(415),
    [sym__newline] = ACTIONS(415),
    [sym__raw_string_literal] = ACTIONS(415),
    [sym__external_else] = ACTIONS(415),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(415),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(415),
  },
  [270] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(421),
    [anon_sym_BSLASH] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_repeat] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(281),
    [anon_sym_LT_LT_DASH] = ACTIONS(281),
    [anon_sym_COLON_EQ] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(419),
    [sym__number_literal] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(419),
    [anon_sym_DQUOTE] = ACTIONS(419),
    [sym_return] = ACTIONS(421),
    [sym_next] = ACTIONS(421),
    [sym_break] = ACTIONS(421),
    [sym_true] = ACTIONS(421),
    [sym_false] = ACTIONS(421),
    [sym_null] = ACTIONS(421),
    [sym_inf] = ACTIONS(421),
    [sym_nan] = ACTIONS(421),
    [anon_sym_NA] = ACTIONS(421),
    [anon_sym_NA_integer_] = ACTIONS(421),
    [anon_sym_NA_real_] = ACTIONS(421),
    [anon_sym_NA_complex_] = ACTIONS(421),
    [anon_sym_NA_character_] = ACTIONS(421),
    [sym_dots] = ACTIONS(421),
    [sym_dot_dot_i] = ACTIONS(419),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(419),
    [sym__newline] = ACTIONS(419),
    [sym__raw_string_literal] = ACTIONS(419),
    [sym__external_else] = ACTIONS(419),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(419),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(419),
  },
  [271] = {
    [sym_call_arguments] = STATE(802),
    [sym_subset_arguments] = STATE(803),
    [sym_subset2_arguments] = STATE(804),
    [sym__open_parenthesis] = STATE(625),
    [sym__open_bracket] = STATE(626),
    [sym__open_bracket2] = STATE(627),
    [sym_identifier] = ACTIONS(425),
    [anon_sym_BSLASH] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(273),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_repeat] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_TILDE] = ACTIONS(275),
    [anon_sym_BANG] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(279),
    [anon_sym_LT_DASH] = ACTIONS(281),
    [anon_sym_LT_LT_DASH] = ACTIONS(281),
    [anon_sym_COLON_EQ] = ACTIONS(281),
    [anon_sym_DASH_GT] = ACTIONS(283),
    [anon_sym_DASH_GT_GT] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_AMP] = ACTIONS(289),
    [anon_sym_PIPE_PIPE] = ACTIONS(291),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(295),
    [anon_sym_LT_EQ] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_EQ] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_BANG_EQ] = ACTIONS(297),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(301),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [aux_sym_binary_operator_token1] = ACTIONS(305),
    [anon_sym_PIPE_GT] = ACTIONS(305),
    [anon_sym_COLON] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(309),
    [sym__hex_literal] = ACTIONS(423),
    [sym__number_literal] = ACTIONS(425),
    [anon_sym_SQUOTE] = ACTIONS(423),
    [anon_sym_DQUOTE] = ACTIONS(423),
    [sym_return] = ACTIONS(425),
    [sym_next] = ACTIONS(425),
    [sym_break] = ACTIONS(425),
    [sym_true] = ACTIONS(425),
    [sym_false] = ACTIONS(425),
    [sym_null] = ACTIONS(425),
    [sym_inf] = ACTIONS(425),
    [sym_nan] = ACTIONS(425),
    [anon_sym_NA] = ACTIONS(425),
    [anon_sym_NA_integer_] = ACTIONS(425),
    [anon_sym_NA_real_] = ACTIONS(425),
    [anon_sym_NA_complex_] = ACTIONS(425),
    [anon_sym_NA_character_] = ACTIONS(425),
    [sym_dots] = ACTIONS(425),
    [sym_dot_dot_i] = ACTIONS(423),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(423),
    [sym__newline] = ACTIONS(423),
    [sym__raw_string_literal] = ACTIONS(423),
    [sym__external_else] = ACTIONS(423),
    [sym__external_open_parenthesis] = ACTIONS(313),
    [sym__external_open_brace] = ACTIONS(423),
    [sym__external_open_bracket] = ACTIONS(315),
    [sym__external_open_bracket2] = ACTIONS(317),
    [sym__external_close_bracket2] = ACTIONS(423),
  },
  [272] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(433),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LT_LT_DASH] = ACTIONS(113),
    [anon_sym_COLON_EQ] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(433),
    [sym__semicolon] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_else] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [273] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(433),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(433),
    [anon_sym_LT_LT_DASH] = ACTIONS(433),
    [anon_sym_COLON_EQ] = ACTIONS(433),
    [anon_sym_DASH_GT] = ACTIONS(431),
    [anon_sym_DASH_GT_GT] = ACTIONS(433),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(433),
    [sym__semicolon] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_else] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [274] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(433),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(433),
    [anon_sym_LT_LT_DASH] = ACTIONS(433),
    [anon_sym_COLON_EQ] = ACTIONS(433),
    [anon_sym_DASH_GT] = ACTIONS(431),
    [anon_sym_DASH_GT_GT] = ACTIONS(433),
    [anon_sym_PIPE] = ACTIONS(431),
    [anon_sym_AMP] = ACTIONS(431),
    [anon_sym_PIPE_PIPE] = ACTIONS(433),
    [anon_sym_AMP_AMP] = ACTIONS(433),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(433),
    [sym__semicolon] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_else] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [275] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(433),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(433),
    [anon_sym_DASH] = ACTIONS(431),
    [anon_sym_LT_DASH] = ACTIONS(433),
    [anon_sym_LT_LT_DASH] = ACTIONS(433),
    [anon_sym_COLON_EQ] = ACTIONS(433),
    [anon_sym_DASH_GT] = ACTIONS(431),
    [anon_sym_DASH_GT_GT] = ACTIONS(433),
    [anon_sym_PIPE] = ACTIONS(431),
    [anon_sym_AMP] = ACTIONS(431),
    [anon_sym_PIPE_PIPE] = ACTIONS(433),
    [anon_sym_AMP_AMP] = ACTIONS(433),
    [anon_sym_LT] = ACTIONS(431),
    [anon_sym_LT_EQ] = ACTIONS(433),
    [anon_sym_GT] = ACTIONS(431),
    [anon_sym_GT_EQ] = ACTIONS(433),
    [anon_sym_EQ_EQ] = ACTIONS(433),
    [anon_sym_BANG_EQ] = ACTIONS(433),
    [anon_sym_STAR] = ACTIONS(431),
    [anon_sym_SLASH] = ACTIONS(433),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(433),
    [anon_sym_PIPE_GT] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(431),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(433),
    [sym__semicolon] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_else] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [276] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(437),
    [sym_identifier] = ACTIONS(435),
    [anon_sym_BSLASH] = ACTIONS(437),
    [anon_sym_function] = ACTIONS(435),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(435),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_repeat] = ACTIONS(435),
    [anon_sym_QMARK] = ACTIONS(437),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(435),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LT_LT_DASH] = ACTIONS(113),
    [anon_sym_COLON_EQ] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(437),
    [sym__number_literal] = ACTIONS(435),
    [anon_sym_SQUOTE] = ACTIONS(437),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [sym_return] = ACTIONS(435),
    [sym_next] = ACTIONS(435),
    [sym_break] = ACTIONS(435),
    [sym_true] = ACTIONS(435),
    [sym_false] = ACTIONS(435),
    [sym_null] = ACTIONS(435),
    [sym_inf] = ACTIONS(435),
    [sym_nan] = ACTIONS(435),
    [anon_sym_NA] = ACTIONS(435),
    [anon_sym_NA_integer_] = ACTIONS(435),
    [anon_sym_NA_real_] = ACTIONS(435),
    [anon_sym_NA_complex_] = ACTIONS(435),
    [anon_sym_NA_character_] = ACTIONS(435),
    [sym_dots] = ACTIONS(435),
    [sym_dot_dot_i] = ACTIONS(437),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(437),
    [sym__semicolon] = ACTIONS(437),
    [sym__raw_string_literal] = ACTIONS(437),
    [sym__external_else] = ACTIONS(437),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(437),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [277] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(441),
    [sym_identifier] = ACTIONS(439),
    [anon_sym_BSLASH] = ACTIONS(441),
    [anon_sym_function] = ACTIONS(439),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(439),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(439),
    [anon_sym_repeat] = ACTIONS(439),
    [anon_sym_QMARK] = ACTIONS(441),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(439),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LT_LT_DASH] = ACTIONS(113),
    [anon_sym_COLON_EQ] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(441),
    [sym__number_literal] = ACTIONS(439),
    [anon_sym_SQUOTE] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(441),
    [sym_return] = ACTIONS(439),
    [sym_next] = ACTIONS(439),
    [sym_break] = ACTIONS(439),
    [sym_true] = ACTIONS(439),
    [sym_false] = ACTIONS(439),
    [sym_null] = ACTIONS(439),
    [sym_inf] = ACTIONS(439),
    [sym_nan] = ACTIONS(439),
    [anon_sym_NA] = ACTIONS(439),
    [anon_sym_NA_integer_] = ACTIONS(439),
    [anon_sym_NA_real_] = ACTIONS(439),
    [anon_sym_NA_complex_] = ACTIONS(439),
    [anon_sym_NA_character_] = ACTIONS(439),
    [sym_dots] = ACTIONS(439),
    [sym_dot_dot_i] = ACTIONS(441),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(441),
    [sym__semicolon] = ACTIONS(441),
    [sym__raw_string_literal] = ACTIONS(441),
    [sym__external_else] = ACTIONS(441),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(441),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [278] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(445),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LT_LT_DASH] = ACTIONS(113),
    [anon_sym_COLON_EQ] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(445),
    [sym__semicolon] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [279] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(445),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(445),
    [anon_sym_LT_LT_DASH] = ACTIONS(445),
    [anon_sym_COLON_EQ] = ACTIONS(445),
    [anon_sym_DASH_GT] = ACTIONS(443),
    [anon_sym_DASH_GT_GT] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(445),
    [sym__semicolon] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [280] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(445),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(445),
    [anon_sym_LT_LT_DASH] = ACTIONS(445),
    [anon_sym_COLON_EQ] = ACTIONS(445),
    [anon_sym_DASH_GT] = ACTIONS(443),
    [anon_sym_DASH_GT_GT] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(443),
    [anon_sym_AMP] = ACTIONS(443),
    [anon_sym_PIPE_PIPE] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(445),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(445),
    [sym__semicolon] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [281] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(445),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(443),
    [anon_sym_LT_DASH] = ACTIONS(445),
    [anon_sym_LT_LT_DASH] = ACTIONS(445),
    [anon_sym_COLON_EQ] = ACTIONS(445),
    [anon_sym_DASH_GT] = ACTIONS(443),
    [anon_sym_DASH_GT_GT] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(443),
    [anon_sym_AMP] = ACTIONS(443),
    [anon_sym_PIPE_PIPE] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(445),
    [anon_sym_LT] = ACTIONS(443),
    [anon_sym_LT_EQ] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(443),
    [anon_sym_GT_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(445),
    [anon_sym_PIPE_GT] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(443),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(445),
    [sym__semicolon] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_else] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [282] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [283] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LT_LT_DASH] = ACTIONS(113),
    [anon_sym_COLON_EQ] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [284] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [285] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [286] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LT_LT_DASH] = ACTIONS(113),
    [anon_sym_COLON_EQ] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(115),
    [anon_sym_DASH_GT_GT] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [287] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(107),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [288] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(121),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [289] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(127),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(127),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [290] = {
    [sym_call_arguments] = STATE(817),
    [sym_subset_arguments] = STATE(834),
    [sym_subset2_arguments] = STATE(836),
    [sym__open_parenthesis] = STATE(605),
    [sym__open_bracket] = STATE(606),
    [sym__open_bracket2] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [aux_sym_binary_operator_token1] = ACTIONS(137),
    [anon_sym_PIPE_GT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_else] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(145),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(147),
    [sym__external_open_bracket2] = ACTIONS(149),
  },
  [291] = {
    [sym_call_arguments] = STATE(752),
    [sym_subset_arguments] = STATE(753),
    [sym_subset2_arguments] = STATE(754),
    [sym__open_parenthesis] = STATE(621),
    [sym__open_bracket] = STATE(622),
    [sym__open_bracket2] = STATE(623),
    [sym_identifier] = ACTIONS(439),
    [anon_sym_BSLASH] = ACTIONS(441),
    [anon_sym_function] = ACTIONS(439),
    [anon_sym_EQ] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(439),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(439),
    [anon_sym_repeat] = ACTIONS(439),
    [anon_sym_QMARK] = ACTIONS(441),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(439),
    [anon_sym_PLUS] = ACTIONS(59),
    [anon_sym_DASH] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LT_LT_DASH] = ACTIONS(63),
    [anon_sym_COLON_EQ] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_DASH_GT_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(69),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(73),
    [anon_sym_AMP_AMP] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_LT_EQ] = ACTIONS(79),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_GT_EQ] = ACTIONS(79),
    [anon_sym_EQ_EQ] = ACTIONS(79),
    [anon_sym_BANG_EQ] = ACTIONS(79),
    [anon_sym_STAR] = ACTIONS(81),
    [anon_sym_SLASH] = ACTIONS(83),
    [anon_sym_STAR_STAR] = ACTIONS(85),
    [anon_sym_CARET] = ACTIONS(85),
    [aux_sym_binary_operator_token1] = ACTIONS(87),
    [anon_sym_PIPE_GT] = ACTIONS(87),
    [anon_sym_COLON] = ACTIONS(89),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [sym__hex_literal] = ACTIONS(441),
    [sym__number_literal] = ACTIONS(439),
    [anon_sym_SQUOTE] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(441),
    [sym_return] = ACTIONS(439),
    [sym_next] = ACTIONS(439),
    [sym_break] = ACTIONS(439),
    [sym_true] = ACTIONS(439),
    [sym_false] = ACTIONS(439),
    [sym_null] = ACTIONS(439),
    [sym_inf] = ACTIONS(439),
    [sym_nan] = ACTIONS(439),
    [anon_sym_NA] = ACTIONS(439),
    [anon_sym_NA_integer_] = ACTIONS(439),
    [anon_sym_NA_real_] = ACTIONS(439),
    [anon_sym_NA_complex_] = ACTIONS(439),
    [anon_sym_NA_character_] = ACTIONS(439),
    [sym_dots] = ACTIONS(439),
    [sym_dot_dot_i] = ACTIONS(441),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(441),
    [sym__newline] = ACTIONS(441),
    [sym__raw_string_literal] = ACTIONS(441),
    [sym__external_else] = ACTIONS(441),
    [sym__external_open_parenthesis] = ACTIONS(95),
    [sym__external_open_brace] = ACTIONS(441),
    [sym__external_open_bracket] = ACTIONS(97),
    [sym__external_close_bracket] = ACTIONS(441),
    [sym__external_open_bracket2] = ACTIONS(99),
  },
  [292] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(447),
    [sym_identifier] = ACTIONS(449),
    [anon_sym_BSLASH] = ACTIONS(447),
    [anon_sym_function] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_for] = ACTIONS(449),
    [anon_sym_while] = ACTIONS(449),
    [anon_sym_repeat] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(447),
    [sym__number_literal] = ACTIONS(449),
    [anon_sym_SQUOTE] = ACTIONS(447),
    [anon_sym_DQUOTE] = ACTIONS(447),
    [sym_return] = ACTIONS(449),
    [sym_next] = ACTIONS(449),
    [sym_break] = ACTIONS(449),
    [sym_true] = ACTIONS(449),
    [sym_false] = ACTIONS(449),
    [sym_null] = ACTIONS(449),
    [sym_inf] = ACTIONS(449),
    [sym_nan] = ACTIONS(449),
    [anon_sym_NA] = ACTIONS(449),
    [anon_sym_NA_integer_] = ACTIONS(449),
    [anon_sym_NA_real_] = ACTIONS(449),
    [anon_sym_NA_complex_] = ACTIONS(449),
    [anon_sym_NA_character_] = ACTIONS(449),
    [sym_dots] = ACTIONS(449),
    [sym_dot_dot_i] = ACTIONS(447),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(447),
    [sym__semicolon] = ACTIONS(447),
    [sym__raw_string_literal] = ACTIONS(447),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(447),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [293] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_BSLASH] = ACTIONS(411),
    [anon_sym_function] = ACTIONS(413),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_repeat] = ACTIONS(413),
    [anon_sym_QMARK] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(413),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_COLON_EQ] = ACTIONS(505),
    [anon_sym_DASH_GT] = ACTIONS(507),
    [anon_sym_DASH_GT_GT] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(411),
    [sym__number_literal] = ACTIONS(413),
    [anon_sym_SQUOTE] = ACTIONS(411),
    [anon_sym_DQUOTE] = ACTIONS(411),
    [sym_return] = ACTIONS(413),
    [sym_next] = ACTIONS(413),
    [sym_break] = ACTIONS(413),
    [sym_true] = ACTIONS(413),
    [sym_false] = ACTIONS(413),
    [sym_null] = ACTIONS(413),
    [sym_inf] = ACTIONS(413),
    [sym_nan] = ACTIONS(413),
    [anon_sym_NA] = ACTIONS(413),
    [anon_sym_NA_integer_] = ACTIONS(413),
    [anon_sym_NA_real_] = ACTIONS(413),
    [anon_sym_NA_complex_] = ACTIONS(413),
    [anon_sym_NA_character_] = ACTIONS(413),
    [sym_dots] = ACTIONS(413),
    [sym_dot_dot_i] = ACTIONS(411),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(411),
    [sym__semicolon] = ACTIONS(411),
    [sym__raw_string_literal] = ACTIONS(411),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(411),
    [sym__external_close_brace] = ACTIONS(411),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [294] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(417),
    [anon_sym_BSLASH] = ACTIONS(415),
    [anon_sym_function] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_repeat] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(415),
    [anon_sym_TILDE] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_COLON_EQ] = ACTIONS(505),
    [anon_sym_DASH_GT] = ACTIONS(507),
    [anon_sym_DASH_GT_GT] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(415),
    [sym__number_literal] = ACTIONS(417),
    [anon_sym_SQUOTE] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(415),
    [sym_return] = ACTIONS(417),
    [sym_next] = ACTIONS(417),
    [sym_break] = ACTIONS(417),
    [sym_true] = ACTIONS(417),
    [sym_false] = ACTIONS(417),
    [sym_null] = ACTIONS(417),
    [sym_inf] = ACTIONS(417),
    [sym_nan] = ACTIONS(417),
    [anon_sym_NA] = ACTIONS(417),
    [anon_sym_NA_integer_] = ACTIONS(417),
    [anon_sym_NA_real_] = ACTIONS(417),
    [anon_sym_NA_complex_] = ACTIONS(417),
    [anon_sym_NA_character_] = ACTIONS(417),
    [sym_dots] = ACTIONS(417),
    [sym_dot_dot_i] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(415),
    [sym__semicolon] = ACTIONS(415),
    [sym__raw_string_literal] = ACTIONS(415),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(415),
    [sym__external_close_brace] = ACTIONS(415),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [295] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(421),
    [anon_sym_BSLASH] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_repeat] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_TILDE] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_COLON_EQ] = ACTIONS(505),
    [anon_sym_DASH_GT] = ACTIONS(507),
    [anon_sym_DASH_GT_GT] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(419),
    [sym__number_literal] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(419),
    [anon_sym_DQUOTE] = ACTIONS(419),
    [sym_return] = ACTIONS(421),
    [sym_next] = ACTIONS(421),
    [sym_break] = ACTIONS(421),
    [sym_true] = ACTIONS(421),
    [sym_false] = ACTIONS(421),
    [sym_null] = ACTIONS(421),
    [sym_inf] = ACTIONS(421),
    [sym_nan] = ACTIONS(421),
    [anon_sym_NA] = ACTIONS(421),
    [anon_sym_NA_integer_] = ACTIONS(421),
    [anon_sym_NA_real_] = ACTIONS(421),
    [anon_sym_NA_complex_] = ACTIONS(421),
    [anon_sym_NA_character_] = ACTIONS(421),
    [sym_dots] = ACTIONS(421),
    [sym_dot_dot_i] = ACTIONS(419),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(419),
    [sym__semicolon] = ACTIONS(419),
    [sym__raw_string_literal] = ACTIONS(419),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(419),
    [sym__external_close_brace] = ACTIONS(419),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [296] = {
    [sym_function_definition] = STATE(491),
    [sym_if_statement] = STATE(491),
    [sym_for_statement] = STATE(491),
    [sym_while_statement] = STATE(491),
    [sym_repeat_statement] = STATE(491),
    [sym_braced_expression] = STATE(491),
    [sym_parenthesized_expression] = STATE(491),
    [sym_call] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_subset2] = STATE(491),
    [sym__argument] = STATE(1934),
    [sym_argument] = STATE(1937),
    [sym__argument_named] = STATE(1909),
    [sym__argument_unnamed] = STATE(1932),
    [sym__argument_value] = STATE(1920),
    [sym_unary_operator] = STATE(491),
    [sym_binary_operator] = STATE(491),
    [sym_extract_operator] = STATE(491),
    [sym_namespace_operator] = STATE(491),
    [sym_integer] = STATE(491),
    [sym_complex] = STATE(491),
    [sym_float] = STATE(491),
    [sym__float_literal] = STATE(734),
    [sym_string] = STATE(728),
    [sym__single_quoted_string] = STATE(735),
    [sym__double_quoted_string] = STATE(736),
    [sym_na] = STATE(491),
    [sym__expression] = STATE(491),
    [sym__string_or_identifier] = STATE(2143),
    [sym__open_parenthesis] = STATE(948),
    [sym__open_brace] = STATE(751),
    [sym__close_bracket] = STATE(1980),
    [aux_sym_call_arguments_repeat1] = STATE(637),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_BSLASH] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_if] = ACTIONS(547),
    [anon_sym_for] = ACTIONS(549),
    [anon_sym_while] = ACTIONS(551),
    [anon_sym_repeat] = ACTIONS(553),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(557),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [sym__hex_literal] = ACTIONS(563),
    [sym__number_literal] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [sym_return] = ACTIONS(571),
    [sym_next] = ACTIONS(571),
    [sym_break] = ACTIONS(571),
    [sym_true] = ACTIONS(571),
    [sym_false] = ACTIONS(571),
    [sym_null] = ACTIONS(571),
    [sym_inf] = ACTIONS(571),
    [sym_nan] = ACTIONS(571),
    [anon_sym_NA] = ACTIONS(573),
    [anon_sym_NA_integer_] = ACTIONS(573),
    [anon_sym_NA_real_] = ACTIONS(573),
    [anon_sym_NA_complex_] = ACTIONS(573),
    [anon_sym_NA_character_] = ACTIONS(573),
    [sym_dots] = ACTIONS(575),
    [sym_dot_dot_i] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(579),
    [sym__newline] = ACTIONS(581),
    [sym__raw_string_literal] = ACTIONS(583),
    [sym__external_open_parenthesis] = ACTIONS(585),
    [sym__external_open_brace] = ACTIONS(587),
    [sym__external_close_bracket] = ACTIONS(589),
  },
  [297] = {
    [sym_function_definition] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_repeat_statement] = STATE(556),
    [sym_braced_expression] = STATE(556),
    [sym_parenthesized_expression] = STATE(556),
    [sym_call] = STATE(556),
    [sym_subset] = STATE(556),
    [sym_subset2] = STATE(556),
    [sym__argument] = STATE(1928),
    [sym_argument] = STATE(1930),
    [sym__argument_named] = STATE(1908),
    [sym__argument_unnamed] = STATE(1933),
    [sym__argument_value] = STATE(1936),
    [sym_unary_operator] = STATE(556),
    [sym_binary_operator] = STATE(556),
    [sym_extract_operator] = STATE(556),
    [sym_namespace_operator] = STATE(556),
    [sym_integer] = STATE(556),
    [sym_complex] = STATE(556),
    [sym_float] = STATE(556),
    [sym__float_literal] = STATE(710),
    [sym_string] = STATE(724),
    [sym__single_quoted_string] = STATE(725),
    [sym__double_quoted_string] = STATE(700),
    [sym_na] = STATE(556),
    [sym__expression] = STATE(556),
    [sym__string_or_identifier] = STATE(2142),
    [sym__open_parenthesis] = STATE(955),
    [sym__open_brace] = STATE(857),
    [sym__close_bracket2] = STATE(1977),
    [aux_sym_call_arguments_repeat1] = STATE(639),
    [sym_identifier] = ACTIONS(591),
    [anon_sym_BSLASH] = ACTIONS(593),
    [anon_sym_function] = ACTIONS(595),
    [anon_sym_if] = ACTIONS(597),
    [anon_sym_for] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_repeat] = ACTIONS(603),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [sym__hex_literal] = ACTIONS(613),
    [sym__number_literal] = ACTIONS(615),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(619),
    [sym_return] = ACTIONS(621),
    [sym_next] = ACTIONS(621),
    [sym_break] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_null] = ACTIONS(621),
    [sym_inf] = ACTIONS(621),
    [sym_nan] = ACTIONS(621),
    [anon_sym_NA] = ACTIONS(623),
    [anon_sym_NA_integer_] = ACTIONS(623),
    [anon_sym_NA_real_] = ACTIONS(623),
    [anon_sym_NA_complex_] = ACTIONS(623),
    [anon_sym_NA_character_] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(629),
    [sym__newline] = ACTIONS(631),
    [sym__raw_string_literal] = ACTIONS(633),
    [sym__external_open_parenthesis] = ACTIONS(635),
    [sym__external_open_brace] = ACTIONS(637),
    [sym__external_close_bracket2] = ACTIONS(639),
  },
  [298] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(427),
    [anon_sym_BSLASH] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_repeat] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_DASH_GT_GT] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(429),
    [sym__number_literal] = ACTIONS(427),
    [anon_sym_SQUOTE] = ACTIONS(429),
    [anon_sym_DQUOTE] = ACTIONS(429),
    [sym_return] = ACTIONS(427),
    [sym_next] = ACTIONS(427),
    [sym_break] = ACTIONS(427),
    [sym_true] = ACTIONS(427),
    [sym_false] = ACTIONS(427),
    [sym_null] = ACTIONS(427),
    [sym_inf] = ACTIONS(427),
    [sym_nan] = ACTIONS(427),
    [anon_sym_NA] = ACTIONS(427),
    [anon_sym_NA_integer_] = ACTIONS(427),
    [anon_sym_NA_real_] = ACTIONS(427),
    [anon_sym_NA_complex_] = ACTIONS(427),
    [anon_sym_NA_character_] = ACTIONS(427),
    [sym_dots] = ACTIONS(427),
    [sym_dot_dot_i] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(429),
    [sym__newline] = ACTIONS(429),
    [sym__raw_string_literal] = ACTIONS(429),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(429),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(429),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [299] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_DASH_GT_GT] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym__newline] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(433),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [300] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(433),
    [anon_sym_LT_LT_DASH] = ACTIONS(433),
    [anon_sym_COLON_EQ] = ACTIONS(433),
    [anon_sym_DASH_GT] = ACTIONS(431),
    [anon_sym_DASH_GT_GT] = ACTIONS(433),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym__newline] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(433),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [301] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(433),
    [anon_sym_LT_LT_DASH] = ACTIONS(433),
    [anon_sym_COLON_EQ] = ACTIONS(433),
    [anon_sym_DASH_GT] = ACTIONS(431),
    [anon_sym_DASH_GT_GT] = ACTIONS(433),
    [anon_sym_PIPE] = ACTIONS(431),
    [anon_sym_AMP] = ACTIONS(431),
    [anon_sym_PIPE_PIPE] = ACTIONS(433),
    [anon_sym_AMP_AMP] = ACTIONS(433),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym__newline] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(433),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [302] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(433),
    [anon_sym_DASH] = ACTIONS(431),
    [anon_sym_LT_DASH] = ACTIONS(433),
    [anon_sym_LT_LT_DASH] = ACTIONS(433),
    [anon_sym_COLON_EQ] = ACTIONS(433),
    [anon_sym_DASH_GT] = ACTIONS(431),
    [anon_sym_DASH_GT_GT] = ACTIONS(433),
    [anon_sym_PIPE] = ACTIONS(431),
    [anon_sym_AMP] = ACTIONS(431),
    [anon_sym_PIPE_PIPE] = ACTIONS(433),
    [anon_sym_AMP_AMP] = ACTIONS(433),
    [anon_sym_LT] = ACTIONS(431),
    [anon_sym_LT_EQ] = ACTIONS(433),
    [anon_sym_GT] = ACTIONS(431),
    [anon_sym_GT_EQ] = ACTIONS(433),
    [anon_sym_EQ_EQ] = ACTIONS(433),
    [anon_sym_BANG_EQ] = ACTIONS(433),
    [anon_sym_STAR] = ACTIONS(431),
    [anon_sym_SLASH] = ACTIONS(433),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(433),
    [anon_sym_PIPE_GT] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(431),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym__newline] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(433),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [303] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(435),
    [anon_sym_BSLASH] = ACTIONS(437),
    [anon_sym_function] = ACTIONS(435),
    [anon_sym_EQ] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(435),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_repeat] = ACTIONS(435),
    [anon_sym_QMARK] = ACTIONS(437),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(435),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_DASH_GT_GT] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(437),
    [sym__number_literal] = ACTIONS(435),
    [anon_sym_SQUOTE] = ACTIONS(437),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [sym_return] = ACTIONS(435),
    [sym_next] = ACTIONS(435),
    [sym_break] = ACTIONS(435),
    [sym_true] = ACTIONS(435),
    [sym_false] = ACTIONS(435),
    [sym_null] = ACTIONS(435),
    [sym_inf] = ACTIONS(435),
    [sym_nan] = ACTIONS(435),
    [anon_sym_NA] = ACTIONS(435),
    [anon_sym_NA_integer_] = ACTIONS(435),
    [anon_sym_NA_real_] = ACTIONS(435),
    [anon_sym_NA_complex_] = ACTIONS(435),
    [anon_sym_NA_character_] = ACTIONS(435),
    [sym_dots] = ACTIONS(435),
    [sym_dot_dot_i] = ACTIONS(437),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(437),
    [sym__newline] = ACTIONS(437),
    [sym__raw_string_literal] = ACTIONS(437),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(437),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(437),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [304] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(439),
    [anon_sym_BSLASH] = ACTIONS(441),
    [anon_sym_function] = ACTIONS(439),
    [anon_sym_EQ] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(439),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(439),
    [anon_sym_repeat] = ACTIONS(439),
    [anon_sym_QMARK] = ACTIONS(441),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(439),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_DASH_GT_GT] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(441),
    [sym__number_literal] = ACTIONS(439),
    [anon_sym_SQUOTE] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(441),
    [sym_return] = ACTIONS(439),
    [sym_next] = ACTIONS(439),
    [sym_break] = ACTIONS(439),
    [sym_true] = ACTIONS(439),
    [sym_false] = ACTIONS(439),
    [sym_null] = ACTIONS(439),
    [sym_inf] = ACTIONS(439),
    [sym_nan] = ACTIONS(439),
    [anon_sym_NA] = ACTIONS(439),
    [anon_sym_NA_integer_] = ACTIONS(439),
    [anon_sym_NA_real_] = ACTIONS(439),
    [anon_sym_NA_complex_] = ACTIONS(439),
    [anon_sym_NA_character_] = ACTIONS(439),
    [sym_dots] = ACTIONS(439),
    [sym_dot_dot_i] = ACTIONS(441),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(441),
    [sym__newline] = ACTIONS(441),
    [sym__raw_string_literal] = ACTIONS(441),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(441),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(441),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [305] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_DASH_GT_GT] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym__newline] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(445),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [306] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(445),
    [anon_sym_LT_LT_DASH] = ACTIONS(445),
    [anon_sym_COLON_EQ] = ACTIONS(445),
    [anon_sym_DASH_GT] = ACTIONS(443),
    [anon_sym_DASH_GT_GT] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym__newline] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(445),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [307] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(445),
    [anon_sym_LT_LT_DASH] = ACTIONS(445),
    [anon_sym_COLON_EQ] = ACTIONS(445),
    [anon_sym_DASH_GT] = ACTIONS(443),
    [anon_sym_DASH_GT_GT] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(443),
    [anon_sym_AMP] = ACTIONS(443),
    [anon_sym_PIPE_PIPE] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(445),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym__newline] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(445),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [308] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(443),
    [anon_sym_LT_DASH] = ACTIONS(445),
    [anon_sym_LT_LT_DASH] = ACTIONS(445),
    [anon_sym_COLON_EQ] = ACTIONS(445),
    [anon_sym_DASH_GT] = ACTIONS(443),
    [anon_sym_DASH_GT_GT] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(443),
    [anon_sym_AMP] = ACTIONS(443),
    [anon_sym_PIPE_PIPE] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(445),
    [anon_sym_LT] = ACTIONS(443),
    [anon_sym_LT_EQ] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(443),
    [anon_sym_GT_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(445),
    [anon_sym_PIPE_GT] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(443),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym__newline] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(445),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [309] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_DASH_GT_GT] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(371),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [310] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_DASH_GT_GT] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(371),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [311] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(371),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [312] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(371),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [313] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_DASH_GT_GT] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(371),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [314] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(371),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [315] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(371),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [316] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(371),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [317] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(371),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [318] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(371),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [319] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(371),
    [anon_sym_PIPE_GT] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(373),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(371),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [320] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(371),
    [anon_sym_PIPE_GT] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(371),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [321] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(371),
    [anon_sym_PIPE_GT] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(373),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(371),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [322] = {
    [sym_function_definition] = STATE(491),
    [sym_if_statement] = STATE(491),
    [sym_for_statement] = STATE(491),
    [sym_while_statement] = STATE(491),
    [sym_repeat_statement] = STATE(491),
    [sym_braced_expression] = STATE(491),
    [sym_parenthesized_expression] = STATE(491),
    [sym_call] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_subset2] = STATE(491),
    [sym__argument] = STATE(1934),
    [sym_argument] = STATE(1937),
    [sym__argument_named] = STATE(1909),
    [sym__argument_unnamed] = STATE(1932),
    [sym__argument_value] = STATE(1920),
    [sym_unary_operator] = STATE(491),
    [sym_binary_operator] = STATE(491),
    [sym_extract_operator] = STATE(491),
    [sym_namespace_operator] = STATE(491),
    [sym_integer] = STATE(491),
    [sym_complex] = STATE(491),
    [sym_float] = STATE(491),
    [sym__float_literal] = STATE(734),
    [sym_string] = STATE(728),
    [sym__single_quoted_string] = STATE(735),
    [sym__double_quoted_string] = STATE(736),
    [sym_na] = STATE(491),
    [sym__expression] = STATE(491),
    [sym__string_or_identifier] = STATE(2143),
    [sym__open_parenthesis] = STATE(948),
    [sym__open_brace] = STATE(751),
    [sym__close_bracket] = STATE(876),
    [aux_sym_call_arguments_repeat1] = STATE(637),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_BSLASH] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_if] = ACTIONS(547),
    [anon_sym_for] = ACTIONS(549),
    [anon_sym_while] = ACTIONS(551),
    [anon_sym_repeat] = ACTIONS(553),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(557),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [sym__hex_literal] = ACTIONS(563),
    [sym__number_literal] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [sym_return] = ACTIONS(571),
    [sym_next] = ACTIONS(571),
    [sym_break] = ACTIONS(571),
    [sym_true] = ACTIONS(571),
    [sym_false] = ACTIONS(571),
    [sym_null] = ACTIONS(571),
    [sym_inf] = ACTIONS(571),
    [sym_nan] = ACTIONS(571),
    [anon_sym_NA] = ACTIONS(573),
    [anon_sym_NA_integer_] = ACTIONS(573),
    [anon_sym_NA_real_] = ACTIONS(573),
    [anon_sym_NA_complex_] = ACTIONS(573),
    [anon_sym_NA_character_] = ACTIONS(573),
    [sym_dots] = ACTIONS(575),
    [sym_dot_dot_i] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(579),
    [sym__newline] = ACTIONS(581),
    [sym__raw_string_literal] = ACTIONS(583),
    [sym__external_open_parenthesis] = ACTIONS(585),
    [sym__external_open_brace] = ACTIONS(587),
    [sym__external_close_bracket] = ACTIONS(685),
  },
  [323] = {
    [sym_function_definition] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_repeat_statement] = STATE(556),
    [sym_braced_expression] = STATE(556),
    [sym_parenthesized_expression] = STATE(556),
    [sym_call] = STATE(556),
    [sym_subset] = STATE(556),
    [sym_subset2] = STATE(556),
    [sym__argument] = STATE(1928),
    [sym_argument] = STATE(1930),
    [sym__argument_named] = STATE(1908),
    [sym__argument_unnamed] = STATE(1933),
    [sym__argument_value] = STATE(1936),
    [sym_unary_operator] = STATE(556),
    [sym_binary_operator] = STATE(556),
    [sym_extract_operator] = STATE(556),
    [sym_namespace_operator] = STATE(556),
    [sym_integer] = STATE(556),
    [sym_complex] = STATE(556),
    [sym_float] = STATE(556),
    [sym__float_literal] = STATE(710),
    [sym_string] = STATE(724),
    [sym__single_quoted_string] = STATE(725),
    [sym__double_quoted_string] = STATE(700),
    [sym_na] = STATE(556),
    [sym__expression] = STATE(556),
    [sym__string_or_identifier] = STATE(2142),
    [sym__open_parenthesis] = STATE(955),
    [sym__open_brace] = STATE(857),
    [sym__close_bracket2] = STATE(875),
    [aux_sym_call_arguments_repeat1] = STATE(639),
    [sym_identifier] = ACTIONS(591),
    [anon_sym_BSLASH] = ACTIONS(593),
    [anon_sym_function] = ACTIONS(595),
    [anon_sym_if] = ACTIONS(597),
    [anon_sym_for] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_repeat] = ACTIONS(603),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [sym__hex_literal] = ACTIONS(613),
    [sym__number_literal] = ACTIONS(615),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(619),
    [sym_return] = ACTIONS(621),
    [sym_next] = ACTIONS(621),
    [sym_break] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_null] = ACTIONS(621),
    [sym_inf] = ACTIONS(621),
    [sym_nan] = ACTIONS(621),
    [anon_sym_NA] = ACTIONS(623),
    [anon_sym_NA_integer_] = ACTIONS(623),
    [anon_sym_NA_real_] = ACTIONS(623),
    [anon_sym_NA_complex_] = ACTIONS(623),
    [anon_sym_NA_character_] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(629),
    [sym__newline] = ACTIONS(631),
    [sym__raw_string_literal] = ACTIONS(633),
    [sym__external_open_parenthesis] = ACTIONS(635),
    [sym__external_open_brace] = ACTIONS(637),
    [sym__external_close_bracket2] = ACTIONS(687),
  },
  [324] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(375),
    [anon_sym_function] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_repeat] = ACTIONS(377),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_DASH_GT_GT] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(375),
    [sym__number_literal] = ACTIONS(377),
    [anon_sym_SQUOTE] = ACTIONS(375),
    [anon_sym_DQUOTE] = ACTIONS(375),
    [sym_return] = ACTIONS(377),
    [sym_next] = ACTIONS(377),
    [sym_break] = ACTIONS(377),
    [sym_true] = ACTIONS(377),
    [sym_false] = ACTIONS(377),
    [sym_null] = ACTIONS(377),
    [sym_inf] = ACTIONS(377),
    [sym_nan] = ACTIONS(377),
    [anon_sym_NA] = ACTIONS(377),
    [anon_sym_NA_integer_] = ACTIONS(377),
    [anon_sym_NA_real_] = ACTIONS(377),
    [anon_sym_NA_complex_] = ACTIONS(377),
    [anon_sym_NA_character_] = ACTIONS(377),
    [sym_dots] = ACTIONS(377),
    [sym_dot_dot_i] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(375),
    [sym__newline] = ACTIONS(375),
    [sym__raw_string_literal] = ACTIONS(375),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(375),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(375),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [325] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_DASH_GT_GT] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(379),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [326] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_DASH_GT_GT] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(379),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [327] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(379),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [328] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(379),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [329] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_DASH_GT_GT] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(379),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [330] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(379),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [331] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(379),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [332] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(379),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [333] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(379),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [334] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(379),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [335] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(379),
    [anon_sym_PIPE_GT] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(381),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(379),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [336] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(379),
    [anon_sym_PIPE_GT] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(379),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [337] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(379),
    [anon_sym_PIPE_GT] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(381),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(379),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [338] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(385),
    [anon_sym_BSLASH] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_EQ] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_for] = ACTIONS(385),
    [anon_sym_while] = ACTIONS(385),
    [anon_sym_repeat] = ACTIONS(385),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_DASH_GT_GT] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(383),
    [sym__number_literal] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [sym_return] = ACTIONS(385),
    [sym_next] = ACTIONS(385),
    [sym_break] = ACTIONS(385),
    [sym_true] = ACTIONS(385),
    [sym_false] = ACTIONS(385),
    [sym_null] = ACTIONS(385),
    [sym_inf] = ACTIONS(385),
    [sym_nan] = ACTIONS(385),
    [anon_sym_NA] = ACTIONS(385),
    [anon_sym_NA_integer_] = ACTIONS(385),
    [anon_sym_NA_real_] = ACTIONS(385),
    [anon_sym_NA_complex_] = ACTIONS(385),
    [anon_sym_NA_character_] = ACTIONS(385),
    [sym_dots] = ACTIONS(385),
    [sym_dot_dot_i] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(383),
    [sym__newline] = ACTIONS(383),
    [sym__raw_string_literal] = ACTIONS(383),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(383),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(383),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [339] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_EQ] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(389),
    [anon_sym_for] = ACTIONS(389),
    [anon_sym_while] = ACTIONS(389),
    [anon_sym_repeat] = ACTIONS(389),
    [anon_sym_QMARK] = ACTIONS(387),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(389),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_DASH_GT_GT] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(387),
    [sym__number_literal] = ACTIONS(389),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_return] = ACTIONS(389),
    [sym_next] = ACTIONS(389),
    [sym_break] = ACTIONS(389),
    [sym_true] = ACTIONS(389),
    [sym_false] = ACTIONS(389),
    [sym_null] = ACTIONS(389),
    [sym_inf] = ACTIONS(389),
    [sym_nan] = ACTIONS(389),
    [anon_sym_NA] = ACTIONS(389),
    [anon_sym_NA_integer_] = ACTIONS(389),
    [anon_sym_NA_real_] = ACTIONS(389),
    [anon_sym_NA_complex_] = ACTIONS(389),
    [anon_sym_NA_character_] = ACTIONS(389),
    [sym_dots] = ACTIONS(389),
    [sym_dot_dot_i] = ACTIONS(387),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym__newline] = ACTIONS(387),
    [sym__raw_string_literal] = ACTIONS(387),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(387),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(387),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [340] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_BSLASH] = ACTIONS(391),
    [anon_sym_function] = ACTIONS(393),
    [anon_sym_EQ] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(393),
    [anon_sym_for] = ACTIONS(393),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_repeat] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_DASH_GT_GT] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(391),
    [sym__number_literal] = ACTIONS(393),
    [anon_sym_SQUOTE] = ACTIONS(391),
    [anon_sym_DQUOTE] = ACTIONS(391),
    [sym_return] = ACTIONS(393),
    [sym_next] = ACTIONS(393),
    [sym_break] = ACTIONS(393),
    [sym_true] = ACTIONS(393),
    [sym_false] = ACTIONS(393),
    [sym_null] = ACTIONS(393),
    [sym_inf] = ACTIONS(393),
    [sym_nan] = ACTIONS(393),
    [anon_sym_NA] = ACTIONS(393),
    [anon_sym_NA_integer_] = ACTIONS(393),
    [anon_sym_NA_real_] = ACTIONS(393),
    [anon_sym_NA_complex_] = ACTIONS(393),
    [anon_sym_NA_character_] = ACTIONS(393),
    [sym_dots] = ACTIONS(393),
    [sym_dot_dot_i] = ACTIONS(391),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(391),
    [sym__newline] = ACTIONS(391),
    [sym__raw_string_literal] = ACTIONS(391),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(391),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(391),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [341] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(397),
    [anon_sym_BSLASH] = ACTIONS(395),
    [anon_sym_function] = ACTIONS(397),
    [anon_sym_EQ] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_while] = ACTIONS(397),
    [anon_sym_repeat] = ACTIONS(397),
    [anon_sym_QMARK] = ACTIONS(395),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_DASH_GT_GT] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(395),
    [sym__number_literal] = ACTIONS(397),
    [anon_sym_SQUOTE] = ACTIONS(395),
    [anon_sym_DQUOTE] = ACTIONS(395),
    [sym_return] = ACTIONS(397),
    [sym_next] = ACTIONS(397),
    [sym_break] = ACTIONS(397),
    [sym_true] = ACTIONS(397),
    [sym_false] = ACTIONS(397),
    [sym_null] = ACTIONS(397),
    [sym_inf] = ACTIONS(397),
    [sym_nan] = ACTIONS(397),
    [anon_sym_NA] = ACTIONS(397),
    [anon_sym_NA_integer_] = ACTIONS(397),
    [anon_sym_NA_real_] = ACTIONS(397),
    [anon_sym_NA_complex_] = ACTIONS(397),
    [anon_sym_NA_character_] = ACTIONS(397),
    [sym_dots] = ACTIONS(397),
    [sym_dot_dot_i] = ACTIONS(395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(395),
    [sym__newline] = ACTIONS(395),
    [sym__raw_string_literal] = ACTIONS(395),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(395),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(395),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [342] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(401),
    [anon_sym_BSLASH] = ACTIONS(399),
    [anon_sym_function] = ACTIONS(401),
    [anon_sym_EQ] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(401),
    [anon_sym_for] = ACTIONS(401),
    [anon_sym_while] = ACTIONS(401),
    [anon_sym_repeat] = ACTIONS(401),
    [anon_sym_QMARK] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_DASH_GT_GT] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(399),
    [sym__number_literal] = ACTIONS(401),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [sym_return] = ACTIONS(401),
    [sym_next] = ACTIONS(401),
    [sym_break] = ACTIONS(401),
    [sym_true] = ACTIONS(401),
    [sym_false] = ACTIONS(401),
    [sym_null] = ACTIONS(401),
    [sym_inf] = ACTIONS(401),
    [sym_nan] = ACTIONS(401),
    [anon_sym_NA] = ACTIONS(401),
    [anon_sym_NA_integer_] = ACTIONS(401),
    [anon_sym_NA_real_] = ACTIONS(401),
    [anon_sym_NA_complex_] = ACTIONS(401),
    [anon_sym_NA_character_] = ACTIONS(401),
    [sym_dots] = ACTIONS(401),
    [sym_dot_dot_i] = ACTIONS(399),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(399),
    [sym__newline] = ACTIONS(399),
    [sym__raw_string_literal] = ACTIONS(399),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(399),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(399),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [343] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_BSLASH] = ACTIONS(403),
    [anon_sym_function] = ACTIONS(405),
    [anon_sym_EQ] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(405),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_while] = ACTIONS(405),
    [anon_sym_repeat] = ACTIONS(405),
    [anon_sym_QMARK] = ACTIONS(403),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(405),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_DASH_GT_GT] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(403),
    [sym__number_literal] = ACTIONS(405),
    [anon_sym_SQUOTE] = ACTIONS(403),
    [anon_sym_DQUOTE] = ACTIONS(403),
    [sym_return] = ACTIONS(405),
    [sym_next] = ACTIONS(405),
    [sym_break] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_null] = ACTIONS(405),
    [sym_inf] = ACTIONS(405),
    [sym_nan] = ACTIONS(405),
    [anon_sym_NA] = ACTIONS(405),
    [anon_sym_NA_integer_] = ACTIONS(405),
    [anon_sym_NA_real_] = ACTIONS(405),
    [anon_sym_NA_complex_] = ACTIONS(405),
    [anon_sym_NA_character_] = ACTIONS(405),
    [sym_dots] = ACTIONS(405),
    [sym_dot_dot_i] = ACTIONS(403),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(403),
    [sym__newline] = ACTIONS(403),
    [sym__raw_string_literal] = ACTIONS(403),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(403),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(403),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [344] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_BSLASH] = ACTIONS(407),
    [anon_sym_function] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(409),
    [anon_sym_while] = ACTIONS(409),
    [anon_sym_repeat] = ACTIONS(409),
    [anon_sym_QMARK] = ACTIONS(407),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(409),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_DASH_GT_GT] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(407),
    [sym__number_literal] = ACTIONS(409),
    [anon_sym_SQUOTE] = ACTIONS(407),
    [anon_sym_DQUOTE] = ACTIONS(407),
    [sym_return] = ACTIONS(409),
    [sym_next] = ACTIONS(409),
    [sym_break] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_null] = ACTIONS(409),
    [sym_inf] = ACTIONS(409),
    [sym_nan] = ACTIONS(409),
    [anon_sym_NA] = ACTIONS(409),
    [anon_sym_NA_integer_] = ACTIONS(409),
    [anon_sym_NA_real_] = ACTIONS(409),
    [anon_sym_NA_complex_] = ACTIONS(409),
    [anon_sym_NA_character_] = ACTIONS(409),
    [sym_dots] = ACTIONS(409),
    [sym_dot_dot_i] = ACTIONS(407),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(407),
    [sym__newline] = ACTIONS(407),
    [sym__raw_string_literal] = ACTIONS(407),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(407),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(407),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [345] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(367),
    [anon_sym_BSLASH] = ACTIONS(369),
    [anon_sym_function] = ACTIONS(367),
    [anon_sym_EQ] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(367),
    [anon_sym_for] = ACTIONS(367),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_repeat] = ACTIONS(367),
    [anon_sym_QMARK] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_DASH_GT_GT] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(369),
    [sym__number_literal] = ACTIONS(367),
    [anon_sym_SQUOTE] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [sym_return] = ACTIONS(367),
    [sym_next] = ACTIONS(367),
    [sym_break] = ACTIONS(367),
    [sym_true] = ACTIONS(367),
    [sym_false] = ACTIONS(367),
    [sym_null] = ACTIONS(367),
    [sym_inf] = ACTIONS(367),
    [sym_nan] = ACTIONS(367),
    [anon_sym_NA] = ACTIONS(367),
    [anon_sym_NA_integer_] = ACTIONS(367),
    [anon_sym_NA_real_] = ACTIONS(367),
    [anon_sym_NA_complex_] = ACTIONS(367),
    [anon_sym_NA_character_] = ACTIONS(367),
    [sym_dots] = ACTIONS(367),
    [sym_dot_dot_i] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(369),
    [sym__newline] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(369),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(369),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(369),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [346] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_BSLASH] = ACTIONS(411),
    [anon_sym_function] = ACTIONS(413),
    [anon_sym_EQ] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_repeat] = ACTIONS(413),
    [anon_sym_QMARK] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(413),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_DASH_GT_GT] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(411),
    [sym__number_literal] = ACTIONS(413),
    [anon_sym_SQUOTE] = ACTIONS(411),
    [anon_sym_DQUOTE] = ACTIONS(411),
    [sym_return] = ACTIONS(413),
    [sym_next] = ACTIONS(413),
    [sym_break] = ACTIONS(413),
    [sym_true] = ACTIONS(413),
    [sym_false] = ACTIONS(413),
    [sym_null] = ACTIONS(413),
    [sym_inf] = ACTIONS(413),
    [sym_nan] = ACTIONS(413),
    [anon_sym_NA] = ACTIONS(413),
    [anon_sym_NA_integer_] = ACTIONS(413),
    [anon_sym_NA_real_] = ACTIONS(413),
    [anon_sym_NA_complex_] = ACTIONS(413),
    [anon_sym_NA_character_] = ACTIONS(413),
    [sym_dots] = ACTIONS(413),
    [sym_dot_dot_i] = ACTIONS(411),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(411),
    [sym__newline] = ACTIONS(411),
    [sym__raw_string_literal] = ACTIONS(411),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(411),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(411),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [347] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(417),
    [anon_sym_BSLASH] = ACTIONS(415),
    [anon_sym_function] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_repeat] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(415),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_DASH_GT_GT] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(415),
    [sym__number_literal] = ACTIONS(417),
    [anon_sym_SQUOTE] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(415),
    [sym_return] = ACTIONS(417),
    [sym_next] = ACTIONS(417),
    [sym_break] = ACTIONS(417),
    [sym_true] = ACTIONS(417),
    [sym_false] = ACTIONS(417),
    [sym_null] = ACTIONS(417),
    [sym_inf] = ACTIONS(417),
    [sym_nan] = ACTIONS(417),
    [anon_sym_NA] = ACTIONS(417),
    [anon_sym_NA_integer_] = ACTIONS(417),
    [anon_sym_NA_real_] = ACTIONS(417),
    [anon_sym_NA_complex_] = ACTIONS(417),
    [anon_sym_NA_character_] = ACTIONS(417),
    [sym_dots] = ACTIONS(417),
    [sym_dot_dot_i] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(415),
    [sym__newline] = ACTIONS(415),
    [sym__raw_string_literal] = ACTIONS(415),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(415),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(415),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [348] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(421),
    [anon_sym_BSLASH] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_repeat] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_DASH_GT_GT] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(419),
    [sym__number_literal] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(419),
    [anon_sym_DQUOTE] = ACTIONS(419),
    [sym_return] = ACTIONS(421),
    [sym_next] = ACTIONS(421),
    [sym_break] = ACTIONS(421),
    [sym_true] = ACTIONS(421),
    [sym_false] = ACTIONS(421),
    [sym_null] = ACTIONS(421),
    [sym_inf] = ACTIONS(421),
    [sym_nan] = ACTIONS(421),
    [anon_sym_NA] = ACTIONS(421),
    [anon_sym_NA_integer_] = ACTIONS(421),
    [anon_sym_NA_real_] = ACTIONS(421),
    [anon_sym_NA_complex_] = ACTIONS(421),
    [anon_sym_NA_character_] = ACTIONS(421),
    [sym_dots] = ACTIONS(421),
    [sym_dot_dot_i] = ACTIONS(419),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(419),
    [sym__newline] = ACTIONS(419),
    [sym__raw_string_literal] = ACTIONS(419),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(419),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(419),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [349] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(425),
    [anon_sym_BSLASH] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_repeat] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_DASH_GT_GT] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(423),
    [sym__number_literal] = ACTIONS(425),
    [anon_sym_SQUOTE] = ACTIONS(423),
    [anon_sym_DQUOTE] = ACTIONS(423),
    [sym_return] = ACTIONS(425),
    [sym_next] = ACTIONS(425),
    [sym_break] = ACTIONS(425),
    [sym_true] = ACTIONS(425),
    [sym_false] = ACTIONS(425),
    [sym_null] = ACTIONS(425),
    [sym_inf] = ACTIONS(425),
    [sym_nan] = ACTIONS(425),
    [anon_sym_NA] = ACTIONS(425),
    [anon_sym_NA_integer_] = ACTIONS(425),
    [anon_sym_NA_real_] = ACTIONS(425),
    [anon_sym_NA_complex_] = ACTIONS(425),
    [anon_sym_NA_character_] = ACTIONS(425),
    [sym_dots] = ACTIONS(425),
    [sym_dot_dot_i] = ACTIONS(423),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(423),
    [sym__newline] = ACTIONS(423),
    [sym__raw_string_literal] = ACTIONS(423),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(423),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(423),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [350] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(427),
    [anon_sym_BSLASH] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_repeat] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_COLON_EQ] = ACTIONS(697),
    [anon_sym_DASH_GT] = ACTIONS(699),
    [anon_sym_DASH_GT_GT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(429),
    [sym__number_literal] = ACTIONS(427),
    [anon_sym_SQUOTE] = ACTIONS(429),
    [anon_sym_DQUOTE] = ACTIONS(429),
    [sym_return] = ACTIONS(427),
    [sym_next] = ACTIONS(427),
    [sym_break] = ACTIONS(427),
    [sym_true] = ACTIONS(427),
    [sym_false] = ACTIONS(427),
    [sym_null] = ACTIONS(427),
    [sym_inf] = ACTIONS(427),
    [sym_nan] = ACTIONS(427),
    [anon_sym_NA] = ACTIONS(427),
    [anon_sym_NA_integer_] = ACTIONS(427),
    [anon_sym_NA_real_] = ACTIONS(427),
    [anon_sym_NA_complex_] = ACTIONS(427),
    [anon_sym_NA_character_] = ACTIONS(427),
    [sym_dots] = ACTIONS(427),
    [sym_dot_dot_i] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(429),
    [sym__newline] = ACTIONS(429),
    [sym__raw_string_literal] = ACTIONS(429),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(429),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(429),
  },
  [351] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_COLON_EQ] = ACTIONS(697),
    [anon_sym_DASH_GT] = ACTIONS(699),
    [anon_sym_DASH_GT_GT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym__newline] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(433),
  },
  [352] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(433),
    [anon_sym_LT_LT_DASH] = ACTIONS(433),
    [anon_sym_COLON_EQ] = ACTIONS(433),
    [anon_sym_DASH_GT] = ACTIONS(431),
    [anon_sym_DASH_GT_GT] = ACTIONS(433),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym__newline] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(433),
  },
  [353] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(433),
    [anon_sym_LT_LT_DASH] = ACTIONS(433),
    [anon_sym_COLON_EQ] = ACTIONS(433),
    [anon_sym_DASH_GT] = ACTIONS(431),
    [anon_sym_DASH_GT_GT] = ACTIONS(433),
    [anon_sym_PIPE] = ACTIONS(431),
    [anon_sym_AMP] = ACTIONS(431),
    [anon_sym_PIPE_PIPE] = ACTIONS(433),
    [anon_sym_AMP_AMP] = ACTIONS(433),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym__newline] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(433),
  },
  [354] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(433),
    [anon_sym_DASH] = ACTIONS(431),
    [anon_sym_LT_DASH] = ACTIONS(433),
    [anon_sym_LT_LT_DASH] = ACTIONS(433),
    [anon_sym_COLON_EQ] = ACTIONS(433),
    [anon_sym_DASH_GT] = ACTIONS(431),
    [anon_sym_DASH_GT_GT] = ACTIONS(433),
    [anon_sym_PIPE] = ACTIONS(431),
    [anon_sym_AMP] = ACTIONS(431),
    [anon_sym_PIPE_PIPE] = ACTIONS(433),
    [anon_sym_AMP_AMP] = ACTIONS(433),
    [anon_sym_LT] = ACTIONS(431),
    [anon_sym_LT_EQ] = ACTIONS(433),
    [anon_sym_GT] = ACTIONS(431),
    [anon_sym_GT_EQ] = ACTIONS(433),
    [anon_sym_EQ_EQ] = ACTIONS(433),
    [anon_sym_BANG_EQ] = ACTIONS(433),
    [anon_sym_STAR] = ACTIONS(431),
    [anon_sym_SLASH] = ACTIONS(433),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(433),
    [anon_sym_PIPE_GT] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(431),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym__newline] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(433),
  },
  [355] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(435),
    [anon_sym_BSLASH] = ACTIONS(437),
    [anon_sym_function] = ACTIONS(435),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(435),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_repeat] = ACTIONS(435),
    [anon_sym_QMARK] = ACTIONS(437),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(435),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_COLON_EQ] = ACTIONS(697),
    [anon_sym_DASH_GT] = ACTIONS(699),
    [anon_sym_DASH_GT_GT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(437),
    [sym__number_literal] = ACTIONS(435),
    [anon_sym_SQUOTE] = ACTIONS(437),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [sym_return] = ACTIONS(435),
    [sym_next] = ACTIONS(435),
    [sym_break] = ACTIONS(435),
    [sym_true] = ACTIONS(435),
    [sym_false] = ACTIONS(435),
    [sym_null] = ACTIONS(435),
    [sym_inf] = ACTIONS(435),
    [sym_nan] = ACTIONS(435),
    [anon_sym_NA] = ACTIONS(435),
    [anon_sym_NA_integer_] = ACTIONS(435),
    [anon_sym_NA_real_] = ACTIONS(435),
    [anon_sym_NA_complex_] = ACTIONS(435),
    [anon_sym_NA_character_] = ACTIONS(435),
    [sym_dots] = ACTIONS(435),
    [sym_dot_dot_i] = ACTIONS(437),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(437),
    [sym__newline] = ACTIONS(437),
    [sym__raw_string_literal] = ACTIONS(437),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(437),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(437),
  },
  [356] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(439),
    [anon_sym_BSLASH] = ACTIONS(441),
    [anon_sym_function] = ACTIONS(439),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(439),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(439),
    [anon_sym_repeat] = ACTIONS(439),
    [anon_sym_QMARK] = ACTIONS(441),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(439),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_COLON_EQ] = ACTIONS(697),
    [anon_sym_DASH_GT] = ACTIONS(699),
    [anon_sym_DASH_GT_GT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(441),
    [sym__number_literal] = ACTIONS(439),
    [anon_sym_SQUOTE] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(441),
    [sym_return] = ACTIONS(439),
    [sym_next] = ACTIONS(439),
    [sym_break] = ACTIONS(439),
    [sym_true] = ACTIONS(439),
    [sym_false] = ACTIONS(439),
    [sym_null] = ACTIONS(439),
    [sym_inf] = ACTIONS(439),
    [sym_nan] = ACTIONS(439),
    [anon_sym_NA] = ACTIONS(439),
    [anon_sym_NA_integer_] = ACTIONS(439),
    [anon_sym_NA_real_] = ACTIONS(439),
    [anon_sym_NA_complex_] = ACTIONS(439),
    [anon_sym_NA_character_] = ACTIONS(439),
    [sym_dots] = ACTIONS(439),
    [sym_dot_dot_i] = ACTIONS(441),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(441),
    [sym__newline] = ACTIONS(441),
    [sym__raw_string_literal] = ACTIONS(441),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(441),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(441),
  },
  [357] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_COLON_EQ] = ACTIONS(697),
    [anon_sym_DASH_GT] = ACTIONS(699),
    [anon_sym_DASH_GT_GT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym__newline] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(445),
  },
  [358] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(445),
    [anon_sym_LT_LT_DASH] = ACTIONS(445),
    [anon_sym_COLON_EQ] = ACTIONS(445),
    [anon_sym_DASH_GT] = ACTIONS(443),
    [anon_sym_DASH_GT_GT] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym__newline] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(445),
  },
  [359] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(445),
    [anon_sym_LT_LT_DASH] = ACTIONS(445),
    [anon_sym_COLON_EQ] = ACTIONS(445),
    [anon_sym_DASH_GT] = ACTIONS(443),
    [anon_sym_DASH_GT_GT] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(443),
    [anon_sym_AMP] = ACTIONS(443),
    [anon_sym_PIPE_PIPE] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(445),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym__newline] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(445),
  },
  [360] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(443),
    [anon_sym_LT_DASH] = ACTIONS(445),
    [anon_sym_LT_LT_DASH] = ACTIONS(445),
    [anon_sym_COLON_EQ] = ACTIONS(445),
    [anon_sym_DASH_GT] = ACTIONS(443),
    [anon_sym_DASH_GT_GT] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(443),
    [anon_sym_AMP] = ACTIONS(443),
    [anon_sym_PIPE_PIPE] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(445),
    [anon_sym_LT] = ACTIONS(443),
    [anon_sym_LT_EQ] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(443),
    [anon_sym_GT_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(445),
    [anon_sym_PIPE_GT] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(443),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym__newline] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(445),
  },
  [361] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(699),
    [anon_sym_DASH_GT_GT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(371),
  },
  [362] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_COLON_EQ] = ACTIONS(697),
    [anon_sym_DASH_GT] = ACTIONS(699),
    [anon_sym_DASH_GT_GT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(371),
  },
  [363] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(371),
  },
  [364] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(371),
  },
  [365] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_COLON_EQ] = ACTIONS(697),
    [anon_sym_DASH_GT] = ACTIONS(699),
    [anon_sym_DASH_GT_GT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(371),
  },
  [366] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(371),
  },
  [367] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(371),
  },
  [368] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(371),
  },
  [369] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(371),
  },
  [370] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(371),
  },
  [371] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(371),
    [anon_sym_PIPE_GT] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(373),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(371),
  },
  [372] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(371),
    [anon_sym_PIPE_GT] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(371),
  },
  [373] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(371),
    [anon_sym_PIPE_GT] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(373),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(371),
  },
  [374] = {
    [sym_function_definition] = STATE(491),
    [sym_if_statement] = STATE(491),
    [sym_for_statement] = STATE(491),
    [sym_while_statement] = STATE(491),
    [sym_repeat_statement] = STATE(491),
    [sym_braced_expression] = STATE(491),
    [sym_parenthesized_expression] = STATE(491),
    [sym_call] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_subset2] = STATE(491),
    [sym__argument] = STATE(1934),
    [sym_argument] = STATE(1937),
    [sym__argument_named] = STATE(1909),
    [sym__argument_unnamed] = STATE(1932),
    [sym__argument_value] = STATE(1920),
    [sym_unary_operator] = STATE(491),
    [sym_binary_operator] = STATE(491),
    [sym_extract_operator] = STATE(491),
    [sym_namespace_operator] = STATE(491),
    [sym_integer] = STATE(491),
    [sym_complex] = STATE(491),
    [sym_float] = STATE(491),
    [sym__float_literal] = STATE(734),
    [sym_string] = STATE(728),
    [sym__single_quoted_string] = STATE(735),
    [sym__double_quoted_string] = STATE(736),
    [sym_na] = STATE(491),
    [sym__expression] = STATE(491),
    [sym__string_or_identifier] = STATE(2143),
    [sym__open_parenthesis] = STATE(948),
    [sym__open_brace] = STATE(751),
    [sym__close_bracket] = STATE(999),
    [aux_sym_call_arguments_repeat1] = STATE(637),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_BSLASH] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_if] = ACTIONS(547),
    [anon_sym_for] = ACTIONS(549),
    [anon_sym_while] = ACTIONS(551),
    [anon_sym_repeat] = ACTIONS(553),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(557),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [sym__hex_literal] = ACTIONS(563),
    [sym__number_literal] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [sym_return] = ACTIONS(571),
    [sym_next] = ACTIONS(571),
    [sym_break] = ACTIONS(571),
    [sym_true] = ACTIONS(571),
    [sym_false] = ACTIONS(571),
    [sym_null] = ACTIONS(571),
    [sym_inf] = ACTIONS(571),
    [sym_nan] = ACTIONS(571),
    [anon_sym_NA] = ACTIONS(573),
    [anon_sym_NA_integer_] = ACTIONS(573),
    [anon_sym_NA_real_] = ACTIONS(573),
    [anon_sym_NA_complex_] = ACTIONS(573),
    [anon_sym_NA_character_] = ACTIONS(573),
    [sym_dots] = ACTIONS(575),
    [sym_dot_dot_i] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(579),
    [sym__newline] = ACTIONS(581),
    [sym__raw_string_literal] = ACTIONS(583),
    [sym__external_open_parenthesis] = ACTIONS(585),
    [sym__external_open_brace] = ACTIONS(587),
    [sym__external_close_bracket] = ACTIONS(733),
  },
  [375] = {
    [sym_function_definition] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_repeat_statement] = STATE(556),
    [sym_braced_expression] = STATE(556),
    [sym_parenthesized_expression] = STATE(556),
    [sym_call] = STATE(556),
    [sym_subset] = STATE(556),
    [sym_subset2] = STATE(556),
    [sym__argument] = STATE(1928),
    [sym_argument] = STATE(1930),
    [sym__argument_named] = STATE(1908),
    [sym__argument_unnamed] = STATE(1933),
    [sym__argument_value] = STATE(1936),
    [sym_unary_operator] = STATE(556),
    [sym_binary_operator] = STATE(556),
    [sym_extract_operator] = STATE(556),
    [sym_namespace_operator] = STATE(556),
    [sym_integer] = STATE(556),
    [sym_complex] = STATE(556),
    [sym_float] = STATE(556),
    [sym__float_literal] = STATE(710),
    [sym_string] = STATE(724),
    [sym__single_quoted_string] = STATE(725),
    [sym__double_quoted_string] = STATE(700),
    [sym_na] = STATE(556),
    [sym__expression] = STATE(556),
    [sym__string_or_identifier] = STATE(2142),
    [sym__open_parenthesis] = STATE(955),
    [sym__open_brace] = STATE(857),
    [sym__close_bracket2] = STATE(1000),
    [aux_sym_call_arguments_repeat1] = STATE(639),
    [sym_identifier] = ACTIONS(591),
    [anon_sym_BSLASH] = ACTIONS(593),
    [anon_sym_function] = ACTIONS(595),
    [anon_sym_if] = ACTIONS(597),
    [anon_sym_for] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_repeat] = ACTIONS(603),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [sym__hex_literal] = ACTIONS(613),
    [sym__number_literal] = ACTIONS(615),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(619),
    [sym_return] = ACTIONS(621),
    [sym_next] = ACTIONS(621),
    [sym_break] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_null] = ACTIONS(621),
    [sym_inf] = ACTIONS(621),
    [sym_nan] = ACTIONS(621),
    [anon_sym_NA] = ACTIONS(623),
    [anon_sym_NA_integer_] = ACTIONS(623),
    [anon_sym_NA_real_] = ACTIONS(623),
    [anon_sym_NA_complex_] = ACTIONS(623),
    [anon_sym_NA_character_] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(629),
    [sym__newline] = ACTIONS(631),
    [sym__raw_string_literal] = ACTIONS(633),
    [sym__external_open_parenthesis] = ACTIONS(635),
    [sym__external_open_brace] = ACTIONS(637),
    [sym__external_close_bracket2] = ACTIONS(735),
  },
  [376] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(375),
    [anon_sym_function] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_repeat] = ACTIONS(377),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_COLON_EQ] = ACTIONS(697),
    [anon_sym_DASH_GT] = ACTIONS(699),
    [anon_sym_DASH_GT_GT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(375),
    [sym__number_literal] = ACTIONS(377),
    [anon_sym_SQUOTE] = ACTIONS(375),
    [anon_sym_DQUOTE] = ACTIONS(375),
    [sym_return] = ACTIONS(377),
    [sym_next] = ACTIONS(377),
    [sym_break] = ACTIONS(377),
    [sym_true] = ACTIONS(377),
    [sym_false] = ACTIONS(377),
    [sym_null] = ACTIONS(377),
    [sym_inf] = ACTIONS(377),
    [sym_nan] = ACTIONS(377),
    [anon_sym_NA] = ACTIONS(377),
    [anon_sym_NA_integer_] = ACTIONS(377),
    [anon_sym_NA_real_] = ACTIONS(377),
    [anon_sym_NA_complex_] = ACTIONS(377),
    [anon_sym_NA_character_] = ACTIONS(377),
    [sym_dots] = ACTIONS(377),
    [sym_dot_dot_i] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(375),
    [sym__newline] = ACTIONS(375),
    [sym__raw_string_literal] = ACTIONS(375),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(375),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(375),
  },
  [377] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(699),
    [anon_sym_DASH_GT_GT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(379),
  },
  [378] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_COLON_EQ] = ACTIONS(697),
    [anon_sym_DASH_GT] = ACTIONS(699),
    [anon_sym_DASH_GT_GT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(379),
  },
  [379] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(379),
  },
  [380] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(379),
  },
  [381] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_COLON_EQ] = ACTIONS(697),
    [anon_sym_DASH_GT] = ACTIONS(699),
    [anon_sym_DASH_GT_GT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(379),
  },
  [382] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(379),
  },
  [383] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(379),
  },
  [384] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(379),
  },
  [385] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(379),
  },
  [386] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(379),
  },
  [387] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(379),
    [anon_sym_PIPE_GT] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(381),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(379),
  },
  [388] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(379),
    [anon_sym_PIPE_GT] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(379),
  },
  [389] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(379),
    [anon_sym_PIPE_GT] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(381),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(379),
  },
  [390] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(385),
    [anon_sym_BSLASH] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_for] = ACTIONS(385),
    [anon_sym_while] = ACTIONS(385),
    [anon_sym_repeat] = ACTIONS(385),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_COLON_EQ] = ACTIONS(697),
    [anon_sym_DASH_GT] = ACTIONS(699),
    [anon_sym_DASH_GT_GT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(383),
    [sym__number_literal] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [sym_return] = ACTIONS(385),
    [sym_next] = ACTIONS(385),
    [sym_break] = ACTIONS(385),
    [sym_true] = ACTIONS(385),
    [sym_false] = ACTIONS(385),
    [sym_null] = ACTIONS(385),
    [sym_inf] = ACTIONS(385),
    [sym_nan] = ACTIONS(385),
    [anon_sym_NA] = ACTIONS(385),
    [anon_sym_NA_integer_] = ACTIONS(385),
    [anon_sym_NA_real_] = ACTIONS(385),
    [anon_sym_NA_complex_] = ACTIONS(385),
    [anon_sym_NA_character_] = ACTIONS(385),
    [sym_dots] = ACTIONS(385),
    [sym_dot_dot_i] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(383),
    [sym__newline] = ACTIONS(383),
    [sym__raw_string_literal] = ACTIONS(383),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(383),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(383),
  },
  [391] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(389),
    [anon_sym_for] = ACTIONS(389),
    [anon_sym_while] = ACTIONS(389),
    [anon_sym_repeat] = ACTIONS(389),
    [anon_sym_QMARK] = ACTIONS(387),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(389),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_COLON_EQ] = ACTIONS(697),
    [anon_sym_DASH_GT] = ACTIONS(699),
    [anon_sym_DASH_GT_GT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(387),
    [sym__number_literal] = ACTIONS(389),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_return] = ACTIONS(389),
    [sym_next] = ACTIONS(389),
    [sym_break] = ACTIONS(389),
    [sym_true] = ACTIONS(389),
    [sym_false] = ACTIONS(389),
    [sym_null] = ACTIONS(389),
    [sym_inf] = ACTIONS(389),
    [sym_nan] = ACTIONS(389),
    [anon_sym_NA] = ACTIONS(389),
    [anon_sym_NA_integer_] = ACTIONS(389),
    [anon_sym_NA_real_] = ACTIONS(389),
    [anon_sym_NA_complex_] = ACTIONS(389),
    [anon_sym_NA_character_] = ACTIONS(389),
    [sym_dots] = ACTIONS(389),
    [sym_dot_dot_i] = ACTIONS(387),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym__newline] = ACTIONS(387),
    [sym__raw_string_literal] = ACTIONS(387),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(387),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(387),
  },
  [392] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_BSLASH] = ACTIONS(391),
    [anon_sym_function] = ACTIONS(393),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(393),
    [anon_sym_for] = ACTIONS(393),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_repeat] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_COLON_EQ] = ACTIONS(697),
    [anon_sym_DASH_GT] = ACTIONS(699),
    [anon_sym_DASH_GT_GT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(391),
    [sym__number_literal] = ACTIONS(393),
    [anon_sym_SQUOTE] = ACTIONS(391),
    [anon_sym_DQUOTE] = ACTIONS(391),
    [sym_return] = ACTIONS(393),
    [sym_next] = ACTIONS(393),
    [sym_break] = ACTIONS(393),
    [sym_true] = ACTIONS(393),
    [sym_false] = ACTIONS(393),
    [sym_null] = ACTIONS(393),
    [sym_inf] = ACTIONS(393),
    [sym_nan] = ACTIONS(393),
    [anon_sym_NA] = ACTIONS(393),
    [anon_sym_NA_integer_] = ACTIONS(393),
    [anon_sym_NA_real_] = ACTIONS(393),
    [anon_sym_NA_complex_] = ACTIONS(393),
    [anon_sym_NA_character_] = ACTIONS(393),
    [sym_dots] = ACTIONS(393),
    [sym_dot_dot_i] = ACTIONS(391),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(391),
    [sym__newline] = ACTIONS(391),
    [sym__raw_string_literal] = ACTIONS(391),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(391),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(391),
  },
  [393] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(397),
    [anon_sym_BSLASH] = ACTIONS(395),
    [anon_sym_function] = ACTIONS(397),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_while] = ACTIONS(397),
    [anon_sym_repeat] = ACTIONS(397),
    [anon_sym_QMARK] = ACTIONS(395),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_COLON_EQ] = ACTIONS(697),
    [anon_sym_DASH_GT] = ACTIONS(699),
    [anon_sym_DASH_GT_GT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(395),
    [sym__number_literal] = ACTIONS(397),
    [anon_sym_SQUOTE] = ACTIONS(395),
    [anon_sym_DQUOTE] = ACTIONS(395),
    [sym_return] = ACTIONS(397),
    [sym_next] = ACTIONS(397),
    [sym_break] = ACTIONS(397),
    [sym_true] = ACTIONS(397),
    [sym_false] = ACTIONS(397),
    [sym_null] = ACTIONS(397),
    [sym_inf] = ACTIONS(397),
    [sym_nan] = ACTIONS(397),
    [anon_sym_NA] = ACTIONS(397),
    [anon_sym_NA_integer_] = ACTIONS(397),
    [anon_sym_NA_real_] = ACTIONS(397),
    [anon_sym_NA_complex_] = ACTIONS(397),
    [anon_sym_NA_character_] = ACTIONS(397),
    [sym_dots] = ACTIONS(397),
    [sym_dot_dot_i] = ACTIONS(395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(395),
    [sym__newline] = ACTIONS(395),
    [sym__raw_string_literal] = ACTIONS(395),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(395),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(395),
  },
  [394] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(401),
    [anon_sym_BSLASH] = ACTIONS(399),
    [anon_sym_function] = ACTIONS(401),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(401),
    [anon_sym_for] = ACTIONS(401),
    [anon_sym_while] = ACTIONS(401),
    [anon_sym_repeat] = ACTIONS(401),
    [anon_sym_QMARK] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_COLON_EQ] = ACTIONS(697),
    [anon_sym_DASH_GT] = ACTIONS(699),
    [anon_sym_DASH_GT_GT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(399),
    [sym__number_literal] = ACTIONS(401),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [sym_return] = ACTIONS(401),
    [sym_next] = ACTIONS(401),
    [sym_break] = ACTIONS(401),
    [sym_true] = ACTIONS(401),
    [sym_false] = ACTIONS(401),
    [sym_null] = ACTIONS(401),
    [sym_inf] = ACTIONS(401),
    [sym_nan] = ACTIONS(401),
    [anon_sym_NA] = ACTIONS(401),
    [anon_sym_NA_integer_] = ACTIONS(401),
    [anon_sym_NA_real_] = ACTIONS(401),
    [anon_sym_NA_complex_] = ACTIONS(401),
    [anon_sym_NA_character_] = ACTIONS(401),
    [sym_dots] = ACTIONS(401),
    [sym_dot_dot_i] = ACTIONS(399),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(399),
    [sym__newline] = ACTIONS(399),
    [sym__raw_string_literal] = ACTIONS(399),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(399),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(399),
  },
  [395] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_BSLASH] = ACTIONS(403),
    [anon_sym_function] = ACTIONS(405),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(405),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_while] = ACTIONS(405),
    [anon_sym_repeat] = ACTIONS(405),
    [anon_sym_QMARK] = ACTIONS(403),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(405),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_COLON_EQ] = ACTIONS(697),
    [anon_sym_DASH_GT] = ACTIONS(699),
    [anon_sym_DASH_GT_GT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(403),
    [sym__number_literal] = ACTIONS(405),
    [anon_sym_SQUOTE] = ACTIONS(403),
    [anon_sym_DQUOTE] = ACTIONS(403),
    [sym_return] = ACTIONS(405),
    [sym_next] = ACTIONS(405),
    [sym_break] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_null] = ACTIONS(405),
    [sym_inf] = ACTIONS(405),
    [sym_nan] = ACTIONS(405),
    [anon_sym_NA] = ACTIONS(405),
    [anon_sym_NA_integer_] = ACTIONS(405),
    [anon_sym_NA_real_] = ACTIONS(405),
    [anon_sym_NA_complex_] = ACTIONS(405),
    [anon_sym_NA_character_] = ACTIONS(405),
    [sym_dots] = ACTIONS(405),
    [sym_dot_dot_i] = ACTIONS(403),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(403),
    [sym__newline] = ACTIONS(403),
    [sym__raw_string_literal] = ACTIONS(403),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(403),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(403),
  },
  [396] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_BSLASH] = ACTIONS(407),
    [anon_sym_function] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(409),
    [anon_sym_while] = ACTIONS(409),
    [anon_sym_repeat] = ACTIONS(409),
    [anon_sym_QMARK] = ACTIONS(407),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(409),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_COLON_EQ] = ACTIONS(697),
    [anon_sym_DASH_GT] = ACTIONS(699),
    [anon_sym_DASH_GT_GT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(407),
    [sym__number_literal] = ACTIONS(409),
    [anon_sym_SQUOTE] = ACTIONS(407),
    [anon_sym_DQUOTE] = ACTIONS(407),
    [sym_return] = ACTIONS(409),
    [sym_next] = ACTIONS(409),
    [sym_break] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_null] = ACTIONS(409),
    [sym_inf] = ACTIONS(409),
    [sym_nan] = ACTIONS(409),
    [anon_sym_NA] = ACTIONS(409),
    [anon_sym_NA_integer_] = ACTIONS(409),
    [anon_sym_NA_real_] = ACTIONS(409),
    [anon_sym_NA_complex_] = ACTIONS(409),
    [anon_sym_NA_character_] = ACTIONS(409),
    [sym_dots] = ACTIONS(409),
    [sym_dot_dot_i] = ACTIONS(407),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(407),
    [sym__newline] = ACTIONS(407),
    [sym__raw_string_literal] = ACTIONS(407),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(407),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(407),
  },
  [397] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(367),
    [anon_sym_BSLASH] = ACTIONS(369),
    [anon_sym_function] = ACTIONS(367),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(367),
    [anon_sym_for] = ACTIONS(367),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_repeat] = ACTIONS(367),
    [anon_sym_QMARK] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_COLON_EQ] = ACTIONS(697),
    [anon_sym_DASH_GT] = ACTIONS(699),
    [anon_sym_DASH_GT_GT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(369),
    [sym__number_literal] = ACTIONS(367),
    [anon_sym_SQUOTE] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [sym_return] = ACTIONS(367),
    [sym_next] = ACTIONS(367),
    [sym_break] = ACTIONS(367),
    [sym_true] = ACTIONS(367),
    [sym_false] = ACTIONS(367),
    [sym_null] = ACTIONS(367),
    [sym_inf] = ACTIONS(367),
    [sym_nan] = ACTIONS(367),
    [anon_sym_NA] = ACTIONS(367),
    [anon_sym_NA_integer_] = ACTIONS(367),
    [anon_sym_NA_real_] = ACTIONS(367),
    [anon_sym_NA_complex_] = ACTIONS(367),
    [anon_sym_NA_character_] = ACTIONS(367),
    [sym_dots] = ACTIONS(367),
    [sym_dot_dot_i] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(369),
    [sym__newline] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(369),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(369),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(369),
  },
  [398] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_BSLASH] = ACTIONS(411),
    [anon_sym_function] = ACTIONS(413),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_repeat] = ACTIONS(413),
    [anon_sym_QMARK] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(413),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_COLON_EQ] = ACTIONS(697),
    [anon_sym_DASH_GT] = ACTIONS(699),
    [anon_sym_DASH_GT_GT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(411),
    [sym__number_literal] = ACTIONS(413),
    [anon_sym_SQUOTE] = ACTIONS(411),
    [anon_sym_DQUOTE] = ACTIONS(411),
    [sym_return] = ACTIONS(413),
    [sym_next] = ACTIONS(413),
    [sym_break] = ACTIONS(413),
    [sym_true] = ACTIONS(413),
    [sym_false] = ACTIONS(413),
    [sym_null] = ACTIONS(413),
    [sym_inf] = ACTIONS(413),
    [sym_nan] = ACTIONS(413),
    [anon_sym_NA] = ACTIONS(413),
    [anon_sym_NA_integer_] = ACTIONS(413),
    [anon_sym_NA_real_] = ACTIONS(413),
    [anon_sym_NA_complex_] = ACTIONS(413),
    [anon_sym_NA_character_] = ACTIONS(413),
    [sym_dots] = ACTIONS(413),
    [sym_dot_dot_i] = ACTIONS(411),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(411),
    [sym__newline] = ACTIONS(411),
    [sym__raw_string_literal] = ACTIONS(411),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(411),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(411),
  },
  [399] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(417),
    [anon_sym_BSLASH] = ACTIONS(415),
    [anon_sym_function] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_repeat] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(415),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_COLON_EQ] = ACTIONS(697),
    [anon_sym_DASH_GT] = ACTIONS(699),
    [anon_sym_DASH_GT_GT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(415),
    [sym__number_literal] = ACTIONS(417),
    [anon_sym_SQUOTE] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(415),
    [sym_return] = ACTIONS(417),
    [sym_next] = ACTIONS(417),
    [sym_break] = ACTIONS(417),
    [sym_true] = ACTIONS(417),
    [sym_false] = ACTIONS(417),
    [sym_null] = ACTIONS(417),
    [sym_inf] = ACTIONS(417),
    [sym_nan] = ACTIONS(417),
    [anon_sym_NA] = ACTIONS(417),
    [anon_sym_NA_integer_] = ACTIONS(417),
    [anon_sym_NA_real_] = ACTIONS(417),
    [anon_sym_NA_complex_] = ACTIONS(417),
    [anon_sym_NA_character_] = ACTIONS(417),
    [sym_dots] = ACTIONS(417),
    [sym_dot_dot_i] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(415),
    [sym__newline] = ACTIONS(415),
    [sym__raw_string_literal] = ACTIONS(415),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(415),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(415),
  },
  [400] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(421),
    [anon_sym_BSLASH] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_repeat] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_COLON_EQ] = ACTIONS(697),
    [anon_sym_DASH_GT] = ACTIONS(699),
    [anon_sym_DASH_GT_GT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(419),
    [sym__number_literal] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(419),
    [anon_sym_DQUOTE] = ACTIONS(419),
    [sym_return] = ACTIONS(421),
    [sym_next] = ACTIONS(421),
    [sym_break] = ACTIONS(421),
    [sym_true] = ACTIONS(421),
    [sym_false] = ACTIONS(421),
    [sym_null] = ACTIONS(421),
    [sym_inf] = ACTIONS(421),
    [sym_nan] = ACTIONS(421),
    [anon_sym_NA] = ACTIONS(421),
    [anon_sym_NA_integer_] = ACTIONS(421),
    [anon_sym_NA_real_] = ACTIONS(421),
    [anon_sym_NA_complex_] = ACTIONS(421),
    [anon_sym_NA_character_] = ACTIONS(421),
    [sym_dots] = ACTIONS(421),
    [sym_dot_dot_i] = ACTIONS(419),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(419),
    [sym__newline] = ACTIONS(419),
    [sym__raw_string_literal] = ACTIONS(419),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(419),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(419),
  },
  [401] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(425),
    [anon_sym_BSLASH] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_repeat] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_COLON_EQ] = ACTIONS(697),
    [anon_sym_DASH_GT] = ACTIONS(699),
    [anon_sym_DASH_GT_GT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(423),
    [sym__number_literal] = ACTIONS(425),
    [anon_sym_SQUOTE] = ACTIONS(423),
    [anon_sym_DQUOTE] = ACTIONS(423),
    [sym_return] = ACTIONS(425),
    [sym_next] = ACTIONS(425),
    [sym_break] = ACTIONS(425),
    [sym_true] = ACTIONS(425),
    [sym_false] = ACTIONS(425),
    [sym_null] = ACTIONS(425),
    [sym_inf] = ACTIONS(425),
    [sym_nan] = ACTIONS(425),
    [anon_sym_NA] = ACTIONS(425),
    [anon_sym_NA_integer_] = ACTIONS(425),
    [anon_sym_NA_real_] = ACTIONS(425),
    [anon_sym_NA_complex_] = ACTIONS(425),
    [anon_sym_NA_character_] = ACTIONS(425),
    [sym_dots] = ACTIONS(425),
    [sym_dot_dot_i] = ACTIONS(423),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(423),
    [sym__newline] = ACTIONS(423),
    [sym__raw_string_literal] = ACTIONS(423),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(423),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(423),
  },
  [402] = {
    [sym_function_definition] = STATE(429),
    [sym_if_statement] = STATE(429),
    [sym_for_statement] = STATE(429),
    [sym_while_statement] = STATE(429),
    [sym_repeat_statement] = STATE(429),
    [sym_braced_expression] = STATE(429),
    [sym_parenthesized_expression] = STATE(429),
    [sym_call] = STATE(429),
    [sym_subset] = STATE(429),
    [sym_subset2] = STATE(429),
    [sym__argument] = STATE(1912),
    [sym_argument] = STATE(1916),
    [sym__argument_named] = STATE(1919),
    [sym__argument_unnamed] = STATE(1921),
    [sym__argument_value] = STATE(1927),
    [sym_unary_operator] = STATE(429),
    [sym_binary_operator] = STATE(429),
    [sym_extract_operator] = STATE(429),
    [sym_namespace_operator] = STATE(429),
    [sym_integer] = STATE(429),
    [sym_complex] = STATE(429),
    [sym_float] = STATE(429),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(721),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(429),
    [sym__expression] = STATE(429),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(964),
    [sym__open_brace] = STATE(842),
    [aux_sym_call_arguments_repeat1] = STATE(430),
    [sym_identifier] = ACTIONS(737),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(767),
    [sym_next] = ACTIONS(767),
    [sym_break] = ACTIONS(767),
    [sym_true] = ACTIONS(767),
    [sym_false] = ACTIONS(767),
    [sym_null] = ACTIONS(767),
    [sym_inf] = ACTIONS(767),
    [sym_nan] = ACTIONS(767),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(771),
    [sym_dot_dot_i] = ACTIONS(773),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(775),
    [sym__newline] = ACTIONS(777),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(783),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [403] = {
    [sym_function_definition] = STATE(491),
    [sym_if_statement] = STATE(491),
    [sym_for_statement] = STATE(491),
    [sym_while_statement] = STATE(491),
    [sym_repeat_statement] = STATE(491),
    [sym_braced_expression] = STATE(491),
    [sym_parenthesized_expression] = STATE(491),
    [sym_call] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_subset2] = STATE(491),
    [sym__argument] = STATE(1934),
    [sym_argument] = STATE(1937),
    [sym__argument_named] = STATE(1909),
    [sym__argument_unnamed] = STATE(1932),
    [sym__argument_value] = STATE(1920),
    [sym_unary_operator] = STATE(491),
    [sym_binary_operator] = STATE(491),
    [sym_extract_operator] = STATE(491),
    [sym_namespace_operator] = STATE(491),
    [sym_integer] = STATE(491),
    [sym_complex] = STATE(491),
    [sym_float] = STATE(491),
    [sym__float_literal] = STATE(734),
    [sym_string] = STATE(728),
    [sym__single_quoted_string] = STATE(735),
    [sym__double_quoted_string] = STATE(736),
    [sym_na] = STATE(491),
    [sym__expression] = STATE(491),
    [sym__string_or_identifier] = STATE(2143),
    [sym__open_parenthesis] = STATE(948),
    [sym__open_brace] = STATE(751),
    [sym__close_bracket] = STATE(980),
    [aux_sym_call_arguments_repeat1] = STATE(431),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_BSLASH] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_if] = ACTIONS(547),
    [anon_sym_for] = ACTIONS(549),
    [anon_sym_while] = ACTIONS(551),
    [anon_sym_repeat] = ACTIONS(553),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(557),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [sym__hex_literal] = ACTIONS(563),
    [sym__number_literal] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [sym_return] = ACTIONS(571),
    [sym_next] = ACTIONS(571),
    [sym_break] = ACTIONS(571),
    [sym_true] = ACTIONS(571),
    [sym_false] = ACTIONS(571),
    [sym_null] = ACTIONS(571),
    [sym_inf] = ACTIONS(571),
    [sym_nan] = ACTIONS(571),
    [anon_sym_NA] = ACTIONS(573),
    [anon_sym_NA_integer_] = ACTIONS(573),
    [anon_sym_NA_real_] = ACTIONS(573),
    [anon_sym_NA_complex_] = ACTIONS(573),
    [anon_sym_NA_character_] = ACTIONS(573),
    [sym_dots] = ACTIONS(575),
    [sym_dot_dot_i] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(579),
    [sym__newline] = ACTIONS(581),
    [sym__raw_string_literal] = ACTIONS(583),
    [sym__external_open_parenthesis] = ACTIONS(585),
    [sym__external_open_brace] = ACTIONS(587),
    [sym__external_close_bracket] = ACTIONS(787),
  },
  [404] = {
    [sym_function_definition] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_repeat_statement] = STATE(556),
    [sym_braced_expression] = STATE(556),
    [sym_parenthesized_expression] = STATE(556),
    [sym_call] = STATE(556),
    [sym_subset] = STATE(556),
    [sym_subset2] = STATE(556),
    [sym__argument] = STATE(1928),
    [sym_argument] = STATE(1930),
    [sym__argument_named] = STATE(1908),
    [sym__argument_unnamed] = STATE(1933),
    [sym__argument_value] = STATE(1936),
    [sym_unary_operator] = STATE(556),
    [sym_binary_operator] = STATE(556),
    [sym_extract_operator] = STATE(556),
    [sym_namespace_operator] = STATE(556),
    [sym_integer] = STATE(556),
    [sym_complex] = STATE(556),
    [sym_float] = STATE(556),
    [sym__float_literal] = STATE(710),
    [sym_string] = STATE(724),
    [sym__single_quoted_string] = STATE(725),
    [sym__double_quoted_string] = STATE(700),
    [sym_na] = STATE(556),
    [sym__expression] = STATE(556),
    [sym__string_or_identifier] = STATE(2142),
    [sym__open_parenthesis] = STATE(955),
    [sym__open_brace] = STATE(857),
    [sym__close_bracket2] = STATE(991),
    [aux_sym_call_arguments_repeat1] = STATE(432),
    [sym_identifier] = ACTIONS(591),
    [anon_sym_BSLASH] = ACTIONS(593),
    [anon_sym_function] = ACTIONS(595),
    [anon_sym_if] = ACTIONS(597),
    [anon_sym_for] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_repeat] = ACTIONS(603),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [sym__hex_literal] = ACTIONS(613),
    [sym__number_literal] = ACTIONS(615),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(619),
    [sym_return] = ACTIONS(621),
    [sym_next] = ACTIONS(621),
    [sym_break] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_null] = ACTIONS(621),
    [sym_inf] = ACTIONS(621),
    [sym_nan] = ACTIONS(621),
    [anon_sym_NA] = ACTIONS(623),
    [anon_sym_NA_integer_] = ACTIONS(623),
    [anon_sym_NA_real_] = ACTIONS(623),
    [anon_sym_NA_complex_] = ACTIONS(623),
    [anon_sym_NA_character_] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(629),
    [sym__newline] = ACTIONS(631),
    [sym__raw_string_literal] = ACTIONS(633),
    [sym__external_open_parenthesis] = ACTIONS(635),
    [sym__external_open_brace] = ACTIONS(637),
    [sym__external_close_bracket2] = ACTIONS(789),
  },
  [405] = {
    [sym_string] = STATE(770),
    [sym__single_quoted_string] = STATE(679),
    [sym__double_quoted_string] = STATE(680),
    [sym__string_or_identifier] = STATE(770),
    [aux_sym_function_definition_repeat1] = STATE(418),
    [ts_builtin_sym_end] = ACTIONS(791),
    [sym_identifier] = ACTIONS(793),
    [anon_sym_BSLASH] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(795),
    [anon_sym_EQ] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(795),
    [anon_sym_for] = ACTIONS(795),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_repeat] = ACTIONS(795),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(795),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LT_DASH] = ACTIONS(791),
    [anon_sym_LT_LT_DASH] = ACTIONS(791),
    [anon_sym_COLON_EQ] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_DASH_GT_GT] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(795),
    [anon_sym_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [anon_sym_LT] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_GT] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(791),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_BANG_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(795),
    [anon_sym_SLASH] = ACTIONS(791),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [aux_sym_binary_operator_token1] = ACTIONS(791),
    [anon_sym_PIPE_GT] = ACTIONS(791),
    [anon_sym_COLON] = ACTIONS(795),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [anon_sym_AT] = ACTIONS(791),
    [sym__hex_literal] = ACTIONS(791),
    [sym__number_literal] = ACTIONS(795),
    [anon_sym_SQUOTE] = ACTIONS(797),
    [anon_sym_DQUOTE] = ACTIONS(799),
    [sym_return] = ACTIONS(795),
    [sym_next] = ACTIONS(795),
    [sym_break] = ACTIONS(795),
    [sym_true] = ACTIONS(795),
    [sym_false] = ACTIONS(795),
    [sym_null] = ACTIONS(795),
    [sym_inf] = ACTIONS(795),
    [sym_nan] = ACTIONS(795),
    [anon_sym_NA] = ACTIONS(795),
    [anon_sym_NA_integer_] = ACTIONS(795),
    [anon_sym_NA_real_] = ACTIONS(795),
    [anon_sym_NA_complex_] = ACTIONS(795),
    [anon_sym_NA_character_] = ACTIONS(795),
    [sym_dots] = ACTIONS(795),
    [sym_dot_dot_i] = ACTIONS(791),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(801),
    [sym__semicolon] = ACTIONS(791),
    [sym__raw_string_literal] = ACTIONS(803),
    [sym__external_else] = ACTIONS(791),
    [sym__external_open_parenthesis] = ACTIONS(791),
    [sym__external_open_brace] = ACTIONS(791),
    [sym__external_open_bracket] = ACTIONS(791),
    [sym__external_open_bracket2] = ACTIONS(791),
  },
  [406] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(805),
    [anon_sym_BSLASH] = ACTIONS(807),
    [anon_sym_function] = ACTIONS(805),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(805),
    [anon_sym_for] = ACTIONS(805),
    [anon_sym_while] = ACTIONS(805),
    [anon_sym_repeat] = ACTIONS(805),
    [anon_sym_QMARK] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_COLON_EQ] = ACTIONS(505),
    [anon_sym_DASH_GT] = ACTIONS(507),
    [anon_sym_DASH_GT_GT] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(807),
    [sym__number_literal] = ACTIONS(805),
    [anon_sym_SQUOTE] = ACTIONS(807),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [sym_return] = ACTIONS(805),
    [sym_next] = ACTIONS(805),
    [sym_break] = ACTIONS(805),
    [sym_true] = ACTIONS(805),
    [sym_false] = ACTIONS(805),
    [sym_null] = ACTIONS(805),
    [sym_inf] = ACTIONS(805),
    [sym_nan] = ACTIONS(805),
    [anon_sym_NA] = ACTIONS(805),
    [anon_sym_NA_integer_] = ACTIONS(805),
    [anon_sym_NA_real_] = ACTIONS(805),
    [anon_sym_NA_complex_] = ACTIONS(805),
    [anon_sym_NA_character_] = ACTIONS(805),
    [sym_dots] = ACTIONS(805),
    [sym_dot_dot_i] = ACTIONS(807),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(807),
    [sym__semicolon] = ACTIONS(807),
    [sym__raw_string_literal] = ACTIONS(807),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(807),
    [sym__external_close_brace] = ACTIONS(807),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [407] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(437),
    [sym_identifier] = ACTIONS(435),
    [anon_sym_BSLASH] = ACTIONS(437),
    [anon_sym_function] = ACTIONS(435),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(435),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_repeat] = ACTIONS(435),
    [anon_sym_QMARK] = ACTIONS(437),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(435),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(437),
    [sym__number_literal] = ACTIONS(435),
    [anon_sym_SQUOTE] = ACTIONS(437),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [sym_return] = ACTIONS(435),
    [sym_next] = ACTIONS(435),
    [sym_break] = ACTIONS(435),
    [sym_true] = ACTIONS(435),
    [sym_false] = ACTIONS(435),
    [sym_null] = ACTIONS(435),
    [sym_inf] = ACTIONS(435),
    [sym_nan] = ACTIONS(435),
    [anon_sym_NA] = ACTIONS(435),
    [anon_sym_NA_integer_] = ACTIONS(435),
    [anon_sym_NA_real_] = ACTIONS(435),
    [anon_sym_NA_complex_] = ACTIONS(435),
    [anon_sym_NA_character_] = ACTIONS(435),
    [sym_dots] = ACTIONS(435),
    [sym_dot_dot_i] = ACTIONS(437),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(437),
    [sym__semicolon] = ACTIONS(437),
    [sym__raw_string_literal] = ACTIONS(437),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(437),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [408] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(441),
    [sym_identifier] = ACTIONS(439),
    [anon_sym_BSLASH] = ACTIONS(441),
    [anon_sym_function] = ACTIONS(439),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(439),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(439),
    [anon_sym_repeat] = ACTIONS(439),
    [anon_sym_QMARK] = ACTIONS(441),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(439),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(441),
    [sym__number_literal] = ACTIONS(439),
    [anon_sym_SQUOTE] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(441),
    [sym_return] = ACTIONS(439),
    [sym_next] = ACTIONS(439),
    [sym_break] = ACTIONS(439),
    [sym_true] = ACTIONS(439),
    [sym_false] = ACTIONS(439),
    [sym_null] = ACTIONS(439),
    [sym_inf] = ACTIONS(439),
    [sym_nan] = ACTIONS(439),
    [anon_sym_NA] = ACTIONS(439),
    [anon_sym_NA_integer_] = ACTIONS(439),
    [anon_sym_NA_real_] = ACTIONS(439),
    [anon_sym_NA_complex_] = ACTIONS(439),
    [anon_sym_NA_character_] = ACTIONS(439),
    [sym_dots] = ACTIONS(439),
    [sym_dot_dot_i] = ACTIONS(441),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(441),
    [sym__semicolon] = ACTIONS(441),
    [sym__raw_string_literal] = ACTIONS(441),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(441),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [409] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(445),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(445),
    [sym__semicolon] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [410] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(445),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(445),
    [anon_sym_LT_LT_DASH] = ACTIONS(445),
    [anon_sym_COLON_EQ] = ACTIONS(445),
    [anon_sym_DASH_GT] = ACTIONS(443),
    [anon_sym_DASH_GT_GT] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(445),
    [sym__semicolon] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [411] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(445),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(445),
    [anon_sym_LT_LT_DASH] = ACTIONS(445),
    [anon_sym_COLON_EQ] = ACTIONS(445),
    [anon_sym_DASH_GT] = ACTIONS(443),
    [anon_sym_DASH_GT_GT] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(443),
    [anon_sym_AMP] = ACTIONS(443),
    [anon_sym_PIPE_PIPE] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(445),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(445),
    [sym__semicolon] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [412] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(445),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(443),
    [anon_sym_LT_DASH] = ACTIONS(445),
    [anon_sym_LT_LT_DASH] = ACTIONS(445),
    [anon_sym_COLON_EQ] = ACTIONS(445),
    [anon_sym_DASH_GT] = ACTIONS(443),
    [anon_sym_DASH_GT_GT] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(443),
    [anon_sym_AMP] = ACTIONS(443),
    [anon_sym_PIPE_PIPE] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(445),
    [anon_sym_LT] = ACTIONS(443),
    [anon_sym_LT_EQ] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(443),
    [anon_sym_GT_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(445),
    [anon_sym_PIPE_GT] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(443),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(445),
    [sym__semicolon] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [413] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [414] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [415] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [416] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [417] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [418] = {
    [sym_string] = STATE(818),
    [sym__single_quoted_string] = STATE(679),
    [sym__double_quoted_string] = STATE(680),
    [sym__string_or_identifier] = STATE(818),
    [aux_sym_function_definition_repeat1] = STATE(720),
    [ts_builtin_sym_end] = ACTIONS(811),
    [sym_identifier] = ACTIONS(813),
    [anon_sym_BSLASH] = ACTIONS(811),
    [anon_sym_function] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(815),
    [anon_sym_if] = ACTIONS(815),
    [anon_sym_for] = ACTIONS(815),
    [anon_sym_while] = ACTIONS(815),
    [anon_sym_repeat] = ACTIONS(815),
    [anon_sym_QMARK] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(811),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_LT_DASH] = ACTIONS(811),
    [anon_sym_LT_LT_DASH] = ACTIONS(811),
    [anon_sym_COLON_EQ] = ACTIONS(811),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_DASH_GT_GT] = ACTIONS(811),
    [anon_sym_PIPE] = ACTIONS(815),
    [anon_sym_AMP] = ACTIONS(815),
    [anon_sym_PIPE_PIPE] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(811),
    [anon_sym_GT] = ACTIONS(815),
    [anon_sym_GT_EQ] = ACTIONS(811),
    [anon_sym_EQ_EQ] = ACTIONS(811),
    [anon_sym_BANG_EQ] = ACTIONS(811),
    [anon_sym_STAR] = ACTIONS(815),
    [anon_sym_SLASH] = ACTIONS(811),
    [anon_sym_STAR_STAR] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(811),
    [aux_sym_binary_operator_token1] = ACTIONS(811),
    [anon_sym_PIPE_GT] = ACTIONS(811),
    [anon_sym_COLON] = ACTIONS(815),
    [anon_sym_DOLLAR] = ACTIONS(811),
    [anon_sym_AT] = ACTIONS(811),
    [sym__hex_literal] = ACTIONS(811),
    [sym__number_literal] = ACTIONS(815),
    [anon_sym_SQUOTE] = ACTIONS(797),
    [anon_sym_DQUOTE] = ACTIONS(799),
    [sym_return] = ACTIONS(815),
    [sym_next] = ACTIONS(815),
    [sym_break] = ACTIONS(815),
    [sym_true] = ACTIONS(815),
    [sym_false] = ACTIONS(815),
    [sym_null] = ACTIONS(815),
    [sym_inf] = ACTIONS(815),
    [sym_nan] = ACTIONS(815),
    [anon_sym_NA] = ACTIONS(815),
    [anon_sym_NA_integer_] = ACTIONS(815),
    [anon_sym_NA_real_] = ACTIONS(815),
    [anon_sym_NA_complex_] = ACTIONS(815),
    [anon_sym_NA_character_] = ACTIONS(815),
    [sym_dots] = ACTIONS(815),
    [sym_dot_dot_i] = ACTIONS(811),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(811),
    [sym__semicolon] = ACTIONS(811),
    [sym__raw_string_literal] = ACTIONS(803),
    [sym__external_else] = ACTIONS(811),
    [sym__external_open_parenthesis] = ACTIONS(811),
    [sym__external_open_brace] = ACTIONS(811),
    [sym__external_open_bracket] = ACTIONS(811),
    [sym__external_open_bracket2] = ACTIONS(811),
  },
  [419] = {
    [sym_function_definition] = STATE(491),
    [sym_if_statement] = STATE(491),
    [sym_for_statement] = STATE(491),
    [sym_while_statement] = STATE(491),
    [sym_repeat_statement] = STATE(491),
    [sym_braced_expression] = STATE(491),
    [sym_parenthesized_expression] = STATE(491),
    [sym_call] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_subset2] = STATE(491),
    [sym__argument] = STATE(1934),
    [sym_argument] = STATE(1937),
    [sym__argument_named] = STATE(1909),
    [sym__argument_unnamed] = STATE(1932),
    [sym__argument_value] = STATE(1920),
    [sym_unary_operator] = STATE(491),
    [sym_binary_operator] = STATE(491),
    [sym_extract_operator] = STATE(491),
    [sym_namespace_operator] = STATE(491),
    [sym_integer] = STATE(491),
    [sym_complex] = STATE(491),
    [sym_float] = STATE(491),
    [sym__float_literal] = STATE(734),
    [sym_string] = STATE(728),
    [sym__single_quoted_string] = STATE(735),
    [sym__double_quoted_string] = STATE(736),
    [sym_na] = STATE(491),
    [sym__expression] = STATE(491),
    [sym__string_or_identifier] = STATE(2143),
    [sym__open_parenthesis] = STATE(948),
    [sym__open_brace] = STATE(751),
    [sym__close_bracket] = STATE(820),
    [aux_sym_call_arguments_repeat1] = STATE(637),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_BSLASH] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_if] = ACTIONS(547),
    [anon_sym_for] = ACTIONS(549),
    [anon_sym_while] = ACTIONS(551),
    [anon_sym_repeat] = ACTIONS(553),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(557),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [sym__hex_literal] = ACTIONS(563),
    [sym__number_literal] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [sym_return] = ACTIONS(571),
    [sym_next] = ACTIONS(571),
    [sym_break] = ACTIONS(571),
    [sym_true] = ACTIONS(571),
    [sym_false] = ACTIONS(571),
    [sym_null] = ACTIONS(571),
    [sym_inf] = ACTIONS(571),
    [sym_nan] = ACTIONS(571),
    [anon_sym_NA] = ACTIONS(573),
    [anon_sym_NA_integer_] = ACTIONS(573),
    [anon_sym_NA_real_] = ACTIONS(573),
    [anon_sym_NA_complex_] = ACTIONS(573),
    [anon_sym_NA_character_] = ACTIONS(573),
    [sym_dots] = ACTIONS(575),
    [sym_dot_dot_i] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(579),
    [sym__newline] = ACTIONS(581),
    [sym__raw_string_literal] = ACTIONS(583),
    [sym__external_open_parenthesis] = ACTIONS(585),
    [sym__external_open_brace] = ACTIONS(587),
    [sym__external_close_bracket] = ACTIONS(817),
  },
  [420] = {
    [sym_function_definition] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_repeat_statement] = STATE(556),
    [sym_braced_expression] = STATE(556),
    [sym_parenthesized_expression] = STATE(556),
    [sym_call] = STATE(556),
    [sym_subset] = STATE(556),
    [sym_subset2] = STATE(556),
    [sym__argument] = STATE(1928),
    [sym_argument] = STATE(1930),
    [sym__argument_named] = STATE(1908),
    [sym__argument_unnamed] = STATE(1933),
    [sym__argument_value] = STATE(1936),
    [sym_unary_operator] = STATE(556),
    [sym_binary_operator] = STATE(556),
    [sym_extract_operator] = STATE(556),
    [sym_namespace_operator] = STATE(556),
    [sym_integer] = STATE(556),
    [sym_complex] = STATE(556),
    [sym_float] = STATE(556),
    [sym__float_literal] = STATE(710),
    [sym_string] = STATE(724),
    [sym__single_quoted_string] = STATE(725),
    [sym__double_quoted_string] = STATE(700),
    [sym_na] = STATE(556),
    [sym__expression] = STATE(556),
    [sym__string_or_identifier] = STATE(2142),
    [sym__open_parenthesis] = STATE(955),
    [sym__open_brace] = STATE(857),
    [sym__close_bracket2] = STATE(821),
    [aux_sym_call_arguments_repeat1] = STATE(639),
    [sym_identifier] = ACTIONS(591),
    [anon_sym_BSLASH] = ACTIONS(593),
    [anon_sym_function] = ACTIONS(595),
    [anon_sym_if] = ACTIONS(597),
    [anon_sym_for] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_repeat] = ACTIONS(603),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [sym__hex_literal] = ACTIONS(613),
    [sym__number_literal] = ACTIONS(615),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(619),
    [sym_return] = ACTIONS(621),
    [sym_next] = ACTIONS(621),
    [sym_break] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_null] = ACTIONS(621),
    [sym_inf] = ACTIONS(621),
    [sym_nan] = ACTIONS(621),
    [anon_sym_NA] = ACTIONS(623),
    [anon_sym_NA_integer_] = ACTIONS(623),
    [anon_sym_NA_real_] = ACTIONS(623),
    [anon_sym_NA_complex_] = ACTIONS(623),
    [anon_sym_NA_character_] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(629),
    [sym__newline] = ACTIONS(631),
    [sym__raw_string_literal] = ACTIONS(633),
    [sym__external_open_parenthesis] = ACTIONS(635),
    [sym__external_open_brace] = ACTIONS(637),
    [sym__external_close_bracket2] = ACTIONS(819),
  },
  [421] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [422] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [423] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [424] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [425] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [426] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(371),
    [anon_sym_PIPE_GT] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(373),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [427] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(371),
    [anon_sym_PIPE_GT] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [428] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(371),
    [anon_sym_PIPE_GT] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(373),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [429] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(821),
    [anon_sym_BSLASH] = ACTIONS(823),
    [anon_sym_function] = ACTIONS(821),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_if] = ACTIONS(821),
    [anon_sym_for] = ACTIONS(821),
    [anon_sym_while] = ACTIONS(821),
    [anon_sym_repeat] = ACTIONS(821),
    [anon_sym_QMARK] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(821),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(835),
    [anon_sym_LT_LT_DASH] = ACTIONS(835),
    [anon_sym_COLON_EQ] = ACTIONS(835),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_DASH_GT_GT] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(823),
    [sym__number_literal] = ACTIONS(821),
    [anon_sym_SQUOTE] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(823),
    [sym_return] = ACTIONS(821),
    [sym_next] = ACTIONS(821),
    [sym_break] = ACTIONS(821),
    [sym_true] = ACTIONS(821),
    [sym_false] = ACTIONS(821),
    [sym_null] = ACTIONS(821),
    [sym_inf] = ACTIONS(821),
    [sym_nan] = ACTIONS(821),
    [anon_sym_NA] = ACTIONS(821),
    [anon_sym_NA_integer_] = ACTIONS(821),
    [anon_sym_NA_real_] = ACTIONS(821),
    [anon_sym_NA_complex_] = ACTIONS(821),
    [anon_sym_NA_character_] = ACTIONS(821),
    [sym_dots] = ACTIONS(821),
    [sym_dot_dot_i] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(823),
    [sym__newline] = ACTIONS(823),
    [sym__raw_string_literal] = ACTIONS(823),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(823),
    [sym__external_open_brace] = ACTIONS(823),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [430] = {
    [sym_function_definition] = STATE(429),
    [sym_if_statement] = STATE(429),
    [sym_for_statement] = STATE(429),
    [sym_while_statement] = STATE(429),
    [sym_repeat_statement] = STATE(429),
    [sym_braced_expression] = STATE(429),
    [sym_parenthesized_expression] = STATE(429),
    [sym_call] = STATE(429),
    [sym_subset] = STATE(429),
    [sym_subset2] = STATE(429),
    [sym__argument] = STATE(1912),
    [sym_argument] = STATE(1916),
    [sym__argument_named] = STATE(1919),
    [sym__argument_unnamed] = STATE(1921),
    [sym__argument_value] = STATE(1927),
    [sym_unary_operator] = STATE(429),
    [sym_binary_operator] = STATE(429),
    [sym_extract_operator] = STATE(429),
    [sym_namespace_operator] = STATE(429),
    [sym_integer] = STATE(429),
    [sym_complex] = STATE(429),
    [sym_float] = STATE(429),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(721),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(429),
    [sym__expression] = STATE(429),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(951),
    [sym__open_brace] = STATE(842),
    [aux_sym_call_arguments_repeat1] = STATE(647),
    [sym_identifier] = ACTIONS(737),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(767),
    [sym_next] = ACTIONS(767),
    [sym_break] = ACTIONS(767),
    [sym_true] = ACTIONS(767),
    [sym_false] = ACTIONS(767),
    [sym_null] = ACTIONS(767),
    [sym_inf] = ACTIONS(767),
    [sym_nan] = ACTIONS(767),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(771),
    [sym_dot_dot_i] = ACTIONS(773),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(775),
    [sym__newline] = ACTIONS(777),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(871),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [431] = {
    [sym_function_definition] = STATE(491),
    [sym_if_statement] = STATE(491),
    [sym_for_statement] = STATE(491),
    [sym_while_statement] = STATE(491),
    [sym_repeat_statement] = STATE(491),
    [sym_braced_expression] = STATE(491),
    [sym_parenthesized_expression] = STATE(491),
    [sym_call] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_subset2] = STATE(491),
    [sym__argument] = STATE(1934),
    [sym_argument] = STATE(1937),
    [sym__argument_named] = STATE(1909),
    [sym__argument_unnamed] = STATE(1932),
    [sym__argument_value] = STATE(1920),
    [sym_unary_operator] = STATE(491),
    [sym_binary_operator] = STATE(491),
    [sym_extract_operator] = STATE(491),
    [sym_namespace_operator] = STATE(491),
    [sym_integer] = STATE(491),
    [sym_complex] = STATE(491),
    [sym_float] = STATE(491),
    [sym__float_literal] = STATE(734),
    [sym_string] = STATE(728),
    [sym__single_quoted_string] = STATE(735),
    [sym__double_quoted_string] = STATE(736),
    [sym_na] = STATE(491),
    [sym__expression] = STATE(491),
    [sym__string_or_identifier] = STATE(2143),
    [sym__open_parenthesis] = STATE(948),
    [sym__open_brace] = STATE(751),
    [sym__close_bracket] = STATE(954),
    [aux_sym_call_arguments_repeat1] = STATE(637),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_BSLASH] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_if] = ACTIONS(547),
    [anon_sym_for] = ACTIONS(549),
    [anon_sym_while] = ACTIONS(551),
    [anon_sym_repeat] = ACTIONS(553),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(557),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [sym__hex_literal] = ACTIONS(563),
    [sym__number_literal] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [sym_return] = ACTIONS(571),
    [sym_next] = ACTIONS(571),
    [sym_break] = ACTIONS(571),
    [sym_true] = ACTIONS(571),
    [sym_false] = ACTIONS(571),
    [sym_null] = ACTIONS(571),
    [sym_inf] = ACTIONS(571),
    [sym_nan] = ACTIONS(571),
    [anon_sym_NA] = ACTIONS(573),
    [anon_sym_NA_integer_] = ACTIONS(573),
    [anon_sym_NA_real_] = ACTIONS(573),
    [anon_sym_NA_complex_] = ACTIONS(573),
    [anon_sym_NA_character_] = ACTIONS(573),
    [sym_dots] = ACTIONS(575),
    [sym_dot_dot_i] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(579),
    [sym__newline] = ACTIONS(581),
    [sym__raw_string_literal] = ACTIONS(583),
    [sym__external_open_parenthesis] = ACTIONS(585),
    [sym__external_open_brace] = ACTIONS(587),
    [sym__external_close_bracket] = ACTIONS(873),
  },
  [432] = {
    [sym_function_definition] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_repeat_statement] = STATE(556),
    [sym_braced_expression] = STATE(556),
    [sym_parenthesized_expression] = STATE(556),
    [sym_call] = STATE(556),
    [sym_subset] = STATE(556),
    [sym_subset2] = STATE(556),
    [sym__argument] = STATE(1928),
    [sym_argument] = STATE(1930),
    [sym__argument_named] = STATE(1908),
    [sym__argument_unnamed] = STATE(1933),
    [sym__argument_value] = STATE(1936),
    [sym_unary_operator] = STATE(556),
    [sym_binary_operator] = STATE(556),
    [sym_extract_operator] = STATE(556),
    [sym_namespace_operator] = STATE(556),
    [sym_integer] = STATE(556),
    [sym_complex] = STATE(556),
    [sym_float] = STATE(556),
    [sym__float_literal] = STATE(710),
    [sym_string] = STATE(724),
    [sym__single_quoted_string] = STATE(725),
    [sym__double_quoted_string] = STATE(700),
    [sym_na] = STATE(556),
    [sym__expression] = STATE(556),
    [sym__string_or_identifier] = STATE(2142),
    [sym__open_parenthesis] = STATE(955),
    [sym__open_brace] = STATE(857),
    [sym__close_bracket2] = STATE(957),
    [aux_sym_call_arguments_repeat1] = STATE(639),
    [sym_identifier] = ACTIONS(591),
    [anon_sym_BSLASH] = ACTIONS(593),
    [anon_sym_function] = ACTIONS(595),
    [anon_sym_if] = ACTIONS(597),
    [anon_sym_for] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_repeat] = ACTIONS(603),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [sym__hex_literal] = ACTIONS(613),
    [sym__number_literal] = ACTIONS(615),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(619),
    [sym_return] = ACTIONS(621),
    [sym_next] = ACTIONS(621),
    [sym_break] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_null] = ACTIONS(621),
    [sym_inf] = ACTIONS(621),
    [sym_nan] = ACTIONS(621),
    [anon_sym_NA] = ACTIONS(623),
    [anon_sym_NA_integer_] = ACTIONS(623),
    [anon_sym_NA_real_] = ACTIONS(623),
    [anon_sym_NA_complex_] = ACTIONS(623),
    [anon_sym_NA_character_] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(629),
    [sym__newline] = ACTIONS(631),
    [sym__raw_string_literal] = ACTIONS(633),
    [sym__external_open_parenthesis] = ACTIONS(635),
    [sym__external_open_brace] = ACTIONS(637),
    [sym__external_close_bracket2] = ACTIONS(875),
  },
  [433] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(375),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(375),
    [anon_sym_function] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_repeat] = ACTIONS(377),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(375),
    [sym__number_literal] = ACTIONS(377),
    [anon_sym_SQUOTE] = ACTIONS(375),
    [anon_sym_DQUOTE] = ACTIONS(375),
    [sym_return] = ACTIONS(377),
    [sym_next] = ACTIONS(377),
    [sym_break] = ACTIONS(377),
    [sym_true] = ACTIONS(377),
    [sym_false] = ACTIONS(377),
    [sym_null] = ACTIONS(377),
    [sym_inf] = ACTIONS(377),
    [sym_nan] = ACTIONS(377),
    [anon_sym_NA] = ACTIONS(377),
    [anon_sym_NA_integer_] = ACTIONS(377),
    [anon_sym_NA_real_] = ACTIONS(377),
    [anon_sym_NA_complex_] = ACTIONS(377),
    [anon_sym_NA_character_] = ACTIONS(377),
    [sym_dots] = ACTIONS(377),
    [sym_dot_dot_i] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(375),
    [sym__semicolon] = ACTIONS(375),
    [sym__raw_string_literal] = ACTIONS(375),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(375),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [434] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(379),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [435] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(379),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [436] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(379),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [437] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(379),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [438] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(379),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [439] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(379),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [440] = {
    [sym_string] = STATE(860),
    [sym__single_quoted_string] = STATE(684),
    [sym__double_quoted_string] = STATE(685),
    [sym__string_or_identifier] = STATE(860),
    [aux_sym_function_definition_repeat1] = STATE(451),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_BSLASH] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(795),
    [anon_sym_EQ] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(795),
    [anon_sym_for] = ACTIONS(795),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_repeat] = ACTIONS(795),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(795),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LT_DASH] = ACTIONS(791),
    [anon_sym_LT_LT_DASH] = ACTIONS(791),
    [anon_sym_COLON_EQ] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_DASH_GT_GT] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(795),
    [anon_sym_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [anon_sym_LT] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_GT] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(791),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_BANG_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(795),
    [anon_sym_SLASH] = ACTIONS(791),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [aux_sym_binary_operator_token1] = ACTIONS(791),
    [anon_sym_PIPE_GT] = ACTIONS(791),
    [anon_sym_COLON] = ACTIONS(795),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [anon_sym_AT] = ACTIONS(791),
    [sym__hex_literal] = ACTIONS(791),
    [sym__number_literal] = ACTIONS(795),
    [anon_sym_SQUOTE] = ACTIONS(879),
    [anon_sym_DQUOTE] = ACTIONS(881),
    [sym_return] = ACTIONS(795),
    [sym_next] = ACTIONS(795),
    [sym_break] = ACTIONS(795),
    [sym_true] = ACTIONS(795),
    [sym_false] = ACTIONS(795),
    [sym_null] = ACTIONS(795),
    [sym_inf] = ACTIONS(795),
    [sym_nan] = ACTIONS(795),
    [anon_sym_NA] = ACTIONS(795),
    [anon_sym_NA_integer_] = ACTIONS(795),
    [anon_sym_NA_real_] = ACTIONS(795),
    [anon_sym_NA_complex_] = ACTIONS(795),
    [anon_sym_NA_character_] = ACTIONS(795),
    [sym_dots] = ACTIONS(795),
    [sym_dot_dot_i] = ACTIONS(791),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(791),
    [sym__newline] = ACTIONS(883),
    [sym__raw_string_literal] = ACTIONS(885),
    [sym__external_else] = ACTIONS(791),
    [sym__external_open_parenthesis] = ACTIONS(791),
    [sym__external_close_parenthesis] = ACTIONS(791),
    [sym__external_open_brace] = ACTIONS(791),
    [sym__external_open_bracket] = ACTIONS(791),
    [sym__external_open_bracket2] = ACTIONS(791),
  },
  [441] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(379),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [442] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(379),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [443] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(379),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [444] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(379),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [445] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(379),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(379),
    [anon_sym_PIPE_GT] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(381),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [446] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(379),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(379),
    [anon_sym_PIPE_GT] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [447] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(379),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(379),
    [anon_sym_PIPE_GT] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(381),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [448] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(383),
    [sym_identifier] = ACTIONS(385),
    [anon_sym_BSLASH] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_for] = ACTIONS(385),
    [anon_sym_while] = ACTIONS(385),
    [anon_sym_repeat] = ACTIONS(385),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(383),
    [sym__number_literal] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [sym_return] = ACTIONS(385),
    [sym_next] = ACTIONS(385),
    [sym_break] = ACTIONS(385),
    [sym_true] = ACTIONS(385),
    [sym_false] = ACTIONS(385),
    [sym_null] = ACTIONS(385),
    [sym_inf] = ACTIONS(385),
    [sym_nan] = ACTIONS(385),
    [anon_sym_NA] = ACTIONS(385),
    [anon_sym_NA_integer_] = ACTIONS(385),
    [anon_sym_NA_real_] = ACTIONS(385),
    [anon_sym_NA_complex_] = ACTIONS(385),
    [anon_sym_NA_character_] = ACTIONS(385),
    [sym_dots] = ACTIONS(385),
    [sym_dot_dot_i] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(383),
    [sym__semicolon] = ACTIONS(383),
    [sym__raw_string_literal] = ACTIONS(383),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(383),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [449] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(387),
    [sym_identifier] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(389),
    [anon_sym_for] = ACTIONS(389),
    [anon_sym_while] = ACTIONS(389),
    [anon_sym_repeat] = ACTIONS(389),
    [anon_sym_QMARK] = ACTIONS(387),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(389),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(387),
    [sym__number_literal] = ACTIONS(389),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_return] = ACTIONS(389),
    [sym_next] = ACTIONS(389),
    [sym_break] = ACTIONS(389),
    [sym_true] = ACTIONS(389),
    [sym_false] = ACTIONS(389),
    [sym_null] = ACTIONS(389),
    [sym_inf] = ACTIONS(389),
    [sym_nan] = ACTIONS(389),
    [anon_sym_NA] = ACTIONS(389),
    [anon_sym_NA_integer_] = ACTIONS(389),
    [anon_sym_NA_real_] = ACTIONS(389),
    [anon_sym_NA_complex_] = ACTIONS(389),
    [anon_sym_NA_character_] = ACTIONS(389),
    [sym_dots] = ACTIONS(389),
    [sym_dot_dot_i] = ACTIONS(387),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(387),
    [sym__semicolon] = ACTIONS(387),
    [sym__raw_string_literal] = ACTIONS(387),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(387),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [450] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(391),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_BSLASH] = ACTIONS(391),
    [anon_sym_function] = ACTIONS(393),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(393),
    [anon_sym_for] = ACTIONS(393),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_repeat] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(391),
    [sym__number_literal] = ACTIONS(393),
    [anon_sym_SQUOTE] = ACTIONS(391),
    [anon_sym_DQUOTE] = ACTIONS(391),
    [sym_return] = ACTIONS(393),
    [sym_next] = ACTIONS(393),
    [sym_break] = ACTIONS(393),
    [sym_true] = ACTIONS(393),
    [sym_false] = ACTIONS(393),
    [sym_null] = ACTIONS(393),
    [sym_inf] = ACTIONS(393),
    [sym_nan] = ACTIONS(393),
    [anon_sym_NA] = ACTIONS(393),
    [anon_sym_NA_integer_] = ACTIONS(393),
    [anon_sym_NA_real_] = ACTIONS(393),
    [anon_sym_NA_complex_] = ACTIONS(393),
    [anon_sym_NA_character_] = ACTIONS(393),
    [sym_dots] = ACTIONS(393),
    [sym_dot_dot_i] = ACTIONS(391),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(391),
    [sym__semicolon] = ACTIONS(391),
    [sym__raw_string_literal] = ACTIONS(391),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(391),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [451] = {
    [sym_string] = STATE(792),
    [sym__single_quoted_string] = STATE(684),
    [sym__double_quoted_string] = STATE(685),
    [sym__string_or_identifier] = STATE(792),
    [aux_sym_function_definition_repeat1] = STATE(702),
    [sym_identifier] = ACTIONS(887),
    [anon_sym_BSLASH] = ACTIONS(811),
    [anon_sym_function] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(815),
    [anon_sym_if] = ACTIONS(815),
    [anon_sym_for] = ACTIONS(815),
    [anon_sym_while] = ACTIONS(815),
    [anon_sym_repeat] = ACTIONS(815),
    [anon_sym_QMARK] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(811),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_LT_DASH] = ACTIONS(811),
    [anon_sym_LT_LT_DASH] = ACTIONS(811),
    [anon_sym_COLON_EQ] = ACTIONS(811),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_DASH_GT_GT] = ACTIONS(811),
    [anon_sym_PIPE] = ACTIONS(815),
    [anon_sym_AMP] = ACTIONS(815),
    [anon_sym_PIPE_PIPE] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(811),
    [anon_sym_GT] = ACTIONS(815),
    [anon_sym_GT_EQ] = ACTIONS(811),
    [anon_sym_EQ_EQ] = ACTIONS(811),
    [anon_sym_BANG_EQ] = ACTIONS(811),
    [anon_sym_STAR] = ACTIONS(815),
    [anon_sym_SLASH] = ACTIONS(811),
    [anon_sym_STAR_STAR] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(811),
    [aux_sym_binary_operator_token1] = ACTIONS(811),
    [anon_sym_PIPE_GT] = ACTIONS(811),
    [anon_sym_COLON] = ACTIONS(815),
    [anon_sym_DOLLAR] = ACTIONS(811),
    [anon_sym_AT] = ACTIONS(811),
    [sym__hex_literal] = ACTIONS(811),
    [sym__number_literal] = ACTIONS(815),
    [anon_sym_SQUOTE] = ACTIONS(879),
    [anon_sym_DQUOTE] = ACTIONS(881),
    [sym_return] = ACTIONS(815),
    [sym_next] = ACTIONS(815),
    [sym_break] = ACTIONS(815),
    [sym_true] = ACTIONS(815),
    [sym_false] = ACTIONS(815),
    [sym_null] = ACTIONS(815),
    [sym_inf] = ACTIONS(815),
    [sym_nan] = ACTIONS(815),
    [anon_sym_NA] = ACTIONS(815),
    [anon_sym_NA_integer_] = ACTIONS(815),
    [anon_sym_NA_real_] = ACTIONS(815),
    [anon_sym_NA_complex_] = ACTIONS(815),
    [anon_sym_NA_character_] = ACTIONS(815),
    [sym_dots] = ACTIONS(815),
    [sym_dot_dot_i] = ACTIONS(811),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(811),
    [sym__newline] = ACTIONS(811),
    [sym__raw_string_literal] = ACTIONS(885),
    [sym__external_else] = ACTIONS(811),
    [sym__external_open_parenthesis] = ACTIONS(811),
    [sym__external_close_parenthesis] = ACTIONS(811),
    [sym__external_open_brace] = ACTIONS(811),
    [sym__external_open_bracket] = ACTIONS(811),
    [sym__external_open_bracket2] = ACTIONS(811),
  },
  [452] = {
    [sym_function_definition] = STATE(491),
    [sym_if_statement] = STATE(491),
    [sym_for_statement] = STATE(491),
    [sym_while_statement] = STATE(491),
    [sym_repeat_statement] = STATE(491),
    [sym_braced_expression] = STATE(491),
    [sym_parenthesized_expression] = STATE(491),
    [sym_call] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_subset2] = STATE(491),
    [sym__argument] = STATE(1934),
    [sym_argument] = STATE(1937),
    [sym__argument_named] = STATE(1909),
    [sym__argument_unnamed] = STATE(1932),
    [sym__argument_value] = STATE(1920),
    [sym_unary_operator] = STATE(491),
    [sym_binary_operator] = STATE(491),
    [sym_extract_operator] = STATE(491),
    [sym_namespace_operator] = STATE(491),
    [sym_integer] = STATE(491),
    [sym_complex] = STATE(491),
    [sym_float] = STATE(491),
    [sym__float_literal] = STATE(734),
    [sym_string] = STATE(728),
    [sym__single_quoted_string] = STATE(735),
    [sym__double_quoted_string] = STATE(736),
    [sym_na] = STATE(491),
    [sym__expression] = STATE(491),
    [sym__string_or_identifier] = STATE(2143),
    [sym__open_parenthesis] = STATE(948),
    [sym__open_brace] = STATE(751),
    [sym__close_bracket] = STATE(815),
    [aux_sym_call_arguments_repeat1] = STATE(637),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_BSLASH] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_if] = ACTIONS(547),
    [anon_sym_for] = ACTIONS(549),
    [anon_sym_while] = ACTIONS(551),
    [anon_sym_repeat] = ACTIONS(553),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(557),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [sym__hex_literal] = ACTIONS(563),
    [sym__number_literal] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [sym_return] = ACTIONS(571),
    [sym_next] = ACTIONS(571),
    [sym_break] = ACTIONS(571),
    [sym_true] = ACTIONS(571),
    [sym_false] = ACTIONS(571),
    [sym_null] = ACTIONS(571),
    [sym_inf] = ACTIONS(571),
    [sym_nan] = ACTIONS(571),
    [anon_sym_NA] = ACTIONS(573),
    [anon_sym_NA_integer_] = ACTIONS(573),
    [anon_sym_NA_real_] = ACTIONS(573),
    [anon_sym_NA_complex_] = ACTIONS(573),
    [anon_sym_NA_character_] = ACTIONS(573),
    [sym_dots] = ACTIONS(575),
    [sym_dot_dot_i] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(579),
    [sym__newline] = ACTIONS(581),
    [sym__raw_string_literal] = ACTIONS(583),
    [sym__external_open_parenthesis] = ACTIONS(585),
    [sym__external_open_brace] = ACTIONS(587),
    [sym__external_close_bracket] = ACTIONS(889),
  },
  [453] = {
    [sym_function_definition] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_repeat_statement] = STATE(556),
    [sym_braced_expression] = STATE(556),
    [sym_parenthesized_expression] = STATE(556),
    [sym_call] = STATE(556),
    [sym_subset] = STATE(556),
    [sym_subset2] = STATE(556),
    [sym__argument] = STATE(1928),
    [sym_argument] = STATE(1930),
    [sym__argument_named] = STATE(1908),
    [sym__argument_unnamed] = STATE(1933),
    [sym__argument_value] = STATE(1936),
    [sym_unary_operator] = STATE(556),
    [sym_binary_operator] = STATE(556),
    [sym_extract_operator] = STATE(556),
    [sym_namespace_operator] = STATE(556),
    [sym_integer] = STATE(556),
    [sym_complex] = STATE(556),
    [sym_float] = STATE(556),
    [sym__float_literal] = STATE(710),
    [sym_string] = STATE(724),
    [sym__single_quoted_string] = STATE(725),
    [sym__double_quoted_string] = STATE(700),
    [sym_na] = STATE(556),
    [sym__expression] = STATE(556),
    [sym__string_or_identifier] = STATE(2142),
    [sym__open_parenthesis] = STATE(955),
    [sym__open_brace] = STATE(857),
    [sym__close_bracket2] = STATE(759),
    [aux_sym_call_arguments_repeat1] = STATE(639),
    [sym_identifier] = ACTIONS(591),
    [anon_sym_BSLASH] = ACTIONS(593),
    [anon_sym_function] = ACTIONS(595),
    [anon_sym_if] = ACTIONS(597),
    [anon_sym_for] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_repeat] = ACTIONS(603),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [sym__hex_literal] = ACTIONS(613),
    [sym__number_literal] = ACTIONS(615),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(619),
    [sym_return] = ACTIONS(621),
    [sym_next] = ACTIONS(621),
    [sym_break] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_null] = ACTIONS(621),
    [sym_inf] = ACTIONS(621),
    [sym_nan] = ACTIONS(621),
    [anon_sym_NA] = ACTIONS(623),
    [anon_sym_NA_integer_] = ACTIONS(623),
    [anon_sym_NA_real_] = ACTIONS(623),
    [anon_sym_NA_complex_] = ACTIONS(623),
    [anon_sym_NA_character_] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(629),
    [sym__newline] = ACTIONS(631),
    [sym__raw_string_literal] = ACTIONS(633),
    [sym__external_open_parenthesis] = ACTIONS(635),
    [sym__external_open_brace] = ACTIONS(637),
    [sym__external_close_bracket2] = ACTIONS(891),
  },
  [454] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(395),
    [sym_identifier] = ACTIONS(397),
    [anon_sym_BSLASH] = ACTIONS(395),
    [anon_sym_function] = ACTIONS(397),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_while] = ACTIONS(397),
    [anon_sym_repeat] = ACTIONS(397),
    [anon_sym_QMARK] = ACTIONS(395),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(395),
    [sym__number_literal] = ACTIONS(397),
    [anon_sym_SQUOTE] = ACTIONS(395),
    [anon_sym_DQUOTE] = ACTIONS(395),
    [sym_return] = ACTIONS(397),
    [sym_next] = ACTIONS(397),
    [sym_break] = ACTIONS(397),
    [sym_true] = ACTIONS(397),
    [sym_false] = ACTIONS(397),
    [sym_null] = ACTIONS(397),
    [sym_inf] = ACTIONS(397),
    [sym_nan] = ACTIONS(397),
    [anon_sym_NA] = ACTIONS(397),
    [anon_sym_NA_integer_] = ACTIONS(397),
    [anon_sym_NA_real_] = ACTIONS(397),
    [anon_sym_NA_complex_] = ACTIONS(397),
    [anon_sym_NA_character_] = ACTIONS(397),
    [sym_dots] = ACTIONS(397),
    [sym_dot_dot_i] = ACTIONS(395),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(395),
    [sym__semicolon] = ACTIONS(395),
    [sym__raw_string_literal] = ACTIONS(395),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(395),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [455] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(399),
    [sym_identifier] = ACTIONS(401),
    [anon_sym_BSLASH] = ACTIONS(399),
    [anon_sym_function] = ACTIONS(401),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(401),
    [anon_sym_for] = ACTIONS(401),
    [anon_sym_while] = ACTIONS(401),
    [anon_sym_repeat] = ACTIONS(401),
    [anon_sym_QMARK] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(399),
    [sym__number_literal] = ACTIONS(401),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [sym_return] = ACTIONS(401),
    [sym_next] = ACTIONS(401),
    [sym_break] = ACTIONS(401),
    [sym_true] = ACTIONS(401),
    [sym_false] = ACTIONS(401),
    [sym_null] = ACTIONS(401),
    [sym_inf] = ACTIONS(401),
    [sym_nan] = ACTIONS(401),
    [anon_sym_NA] = ACTIONS(401),
    [anon_sym_NA_integer_] = ACTIONS(401),
    [anon_sym_NA_real_] = ACTIONS(401),
    [anon_sym_NA_complex_] = ACTIONS(401),
    [anon_sym_NA_character_] = ACTIONS(401),
    [sym_dots] = ACTIONS(401),
    [sym_dot_dot_i] = ACTIONS(399),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(399),
    [sym__semicolon] = ACTIONS(399),
    [sym__raw_string_literal] = ACTIONS(399),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(399),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [456] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(403),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_BSLASH] = ACTIONS(403),
    [anon_sym_function] = ACTIONS(405),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(405),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_while] = ACTIONS(405),
    [anon_sym_repeat] = ACTIONS(405),
    [anon_sym_QMARK] = ACTIONS(403),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(405),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(403),
    [sym__number_literal] = ACTIONS(405),
    [anon_sym_SQUOTE] = ACTIONS(403),
    [anon_sym_DQUOTE] = ACTIONS(403),
    [sym_return] = ACTIONS(405),
    [sym_next] = ACTIONS(405),
    [sym_break] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_null] = ACTIONS(405),
    [sym_inf] = ACTIONS(405),
    [sym_nan] = ACTIONS(405),
    [anon_sym_NA] = ACTIONS(405),
    [anon_sym_NA_integer_] = ACTIONS(405),
    [anon_sym_NA_real_] = ACTIONS(405),
    [anon_sym_NA_complex_] = ACTIONS(405),
    [anon_sym_NA_character_] = ACTIONS(405),
    [sym_dots] = ACTIONS(405),
    [sym_dot_dot_i] = ACTIONS(403),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(403),
    [sym__semicolon] = ACTIONS(403),
    [sym__raw_string_literal] = ACTIONS(403),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(403),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [457] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(407),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_BSLASH] = ACTIONS(407),
    [anon_sym_function] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(409),
    [anon_sym_while] = ACTIONS(409),
    [anon_sym_repeat] = ACTIONS(409),
    [anon_sym_QMARK] = ACTIONS(407),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(409),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(407),
    [sym__number_literal] = ACTIONS(409),
    [anon_sym_SQUOTE] = ACTIONS(407),
    [anon_sym_DQUOTE] = ACTIONS(407),
    [sym_return] = ACTIONS(409),
    [sym_next] = ACTIONS(409),
    [sym_break] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_null] = ACTIONS(409),
    [sym_inf] = ACTIONS(409),
    [sym_nan] = ACTIONS(409),
    [anon_sym_NA] = ACTIONS(409),
    [anon_sym_NA_integer_] = ACTIONS(409),
    [anon_sym_NA_real_] = ACTIONS(409),
    [anon_sym_NA_complex_] = ACTIONS(409),
    [anon_sym_NA_character_] = ACTIONS(409),
    [sym_dots] = ACTIONS(409),
    [sym_dot_dot_i] = ACTIONS(407),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(407),
    [sym__semicolon] = ACTIONS(407),
    [sym__raw_string_literal] = ACTIONS(407),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(407),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [458] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(369),
    [sym_identifier] = ACTIONS(367),
    [anon_sym_BSLASH] = ACTIONS(369),
    [anon_sym_function] = ACTIONS(367),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(367),
    [anon_sym_for] = ACTIONS(367),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_repeat] = ACTIONS(367),
    [anon_sym_QMARK] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(369),
    [sym__number_literal] = ACTIONS(367),
    [anon_sym_SQUOTE] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [sym_return] = ACTIONS(367),
    [sym_next] = ACTIONS(367),
    [sym_break] = ACTIONS(367),
    [sym_true] = ACTIONS(367),
    [sym_false] = ACTIONS(367),
    [sym_null] = ACTIONS(367),
    [sym_inf] = ACTIONS(367),
    [sym_nan] = ACTIONS(367),
    [anon_sym_NA] = ACTIONS(367),
    [anon_sym_NA_integer_] = ACTIONS(367),
    [anon_sym_NA_real_] = ACTIONS(367),
    [anon_sym_NA_complex_] = ACTIONS(367),
    [anon_sym_NA_character_] = ACTIONS(367),
    [sym_dots] = ACTIONS(367),
    [sym_dot_dot_i] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(369),
    [sym__semicolon] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(369),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(369),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [459] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(411),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_BSLASH] = ACTIONS(411),
    [anon_sym_function] = ACTIONS(413),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_repeat] = ACTIONS(413),
    [anon_sym_QMARK] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(413),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(411),
    [sym__number_literal] = ACTIONS(413),
    [anon_sym_SQUOTE] = ACTIONS(411),
    [anon_sym_DQUOTE] = ACTIONS(411),
    [sym_return] = ACTIONS(413),
    [sym_next] = ACTIONS(413),
    [sym_break] = ACTIONS(413),
    [sym_true] = ACTIONS(413),
    [sym_false] = ACTIONS(413),
    [sym_null] = ACTIONS(413),
    [sym_inf] = ACTIONS(413),
    [sym_nan] = ACTIONS(413),
    [anon_sym_NA] = ACTIONS(413),
    [anon_sym_NA_integer_] = ACTIONS(413),
    [anon_sym_NA_real_] = ACTIONS(413),
    [anon_sym_NA_complex_] = ACTIONS(413),
    [anon_sym_NA_character_] = ACTIONS(413),
    [sym_dots] = ACTIONS(413),
    [sym_dot_dot_i] = ACTIONS(411),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(411),
    [sym__semicolon] = ACTIONS(411),
    [sym__raw_string_literal] = ACTIONS(411),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(411),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [460] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(415),
    [sym_identifier] = ACTIONS(417),
    [anon_sym_BSLASH] = ACTIONS(415),
    [anon_sym_function] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_repeat] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(415),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(415),
    [sym__number_literal] = ACTIONS(417),
    [anon_sym_SQUOTE] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(415),
    [sym_return] = ACTIONS(417),
    [sym_next] = ACTIONS(417),
    [sym_break] = ACTIONS(417),
    [sym_true] = ACTIONS(417),
    [sym_false] = ACTIONS(417),
    [sym_null] = ACTIONS(417),
    [sym_inf] = ACTIONS(417),
    [sym_nan] = ACTIONS(417),
    [anon_sym_NA] = ACTIONS(417),
    [anon_sym_NA_integer_] = ACTIONS(417),
    [anon_sym_NA_real_] = ACTIONS(417),
    [anon_sym_NA_complex_] = ACTIONS(417),
    [anon_sym_NA_character_] = ACTIONS(417),
    [sym_dots] = ACTIONS(417),
    [sym_dot_dot_i] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(415),
    [sym__semicolon] = ACTIONS(415),
    [sym__raw_string_literal] = ACTIONS(415),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(415),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [461] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(419),
    [sym_identifier] = ACTIONS(421),
    [anon_sym_BSLASH] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_repeat] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(419),
    [sym__number_literal] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(419),
    [anon_sym_DQUOTE] = ACTIONS(419),
    [sym_return] = ACTIONS(421),
    [sym_next] = ACTIONS(421),
    [sym_break] = ACTIONS(421),
    [sym_true] = ACTIONS(421),
    [sym_false] = ACTIONS(421),
    [sym_null] = ACTIONS(421),
    [sym_inf] = ACTIONS(421),
    [sym_nan] = ACTIONS(421),
    [anon_sym_NA] = ACTIONS(421),
    [anon_sym_NA_integer_] = ACTIONS(421),
    [anon_sym_NA_real_] = ACTIONS(421),
    [anon_sym_NA_complex_] = ACTIONS(421),
    [anon_sym_NA_character_] = ACTIONS(421),
    [sym_dots] = ACTIONS(421),
    [sym_dot_dot_i] = ACTIONS(419),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(419),
    [sym__semicolon] = ACTIONS(419),
    [sym__raw_string_literal] = ACTIONS(419),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(419),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [462] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(423),
    [sym_identifier] = ACTIONS(425),
    [anon_sym_BSLASH] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_repeat] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(423),
    [sym__number_literal] = ACTIONS(425),
    [anon_sym_SQUOTE] = ACTIONS(423),
    [anon_sym_DQUOTE] = ACTIONS(423),
    [sym_return] = ACTIONS(425),
    [sym_next] = ACTIONS(425),
    [sym_break] = ACTIONS(425),
    [sym_true] = ACTIONS(425),
    [sym_false] = ACTIONS(425),
    [sym_null] = ACTIONS(425),
    [sym_inf] = ACTIONS(425),
    [sym_nan] = ACTIONS(425),
    [anon_sym_NA] = ACTIONS(425),
    [anon_sym_NA_integer_] = ACTIONS(425),
    [anon_sym_NA_real_] = ACTIONS(425),
    [anon_sym_NA_complex_] = ACTIONS(425),
    [anon_sym_NA_character_] = ACTIONS(425),
    [sym_dots] = ACTIONS(425),
    [sym_dot_dot_i] = ACTIONS(423),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(423),
    [sym__semicolon] = ACTIONS(423),
    [sym__raw_string_literal] = ACTIONS(423),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(423),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [463] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(427),
    [anon_sym_BSLASH] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_repeat] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(835),
    [anon_sym_LT_LT_DASH] = ACTIONS(835),
    [anon_sym_COLON_EQ] = ACTIONS(835),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_DASH_GT_GT] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(429),
    [sym__number_literal] = ACTIONS(427),
    [anon_sym_SQUOTE] = ACTIONS(429),
    [anon_sym_DQUOTE] = ACTIONS(429),
    [sym_return] = ACTIONS(427),
    [sym_next] = ACTIONS(427),
    [sym_break] = ACTIONS(427),
    [sym_true] = ACTIONS(427),
    [sym_false] = ACTIONS(427),
    [sym_null] = ACTIONS(427),
    [sym_inf] = ACTIONS(427),
    [sym_nan] = ACTIONS(427),
    [anon_sym_NA] = ACTIONS(427),
    [anon_sym_NA_integer_] = ACTIONS(427),
    [anon_sym_NA_real_] = ACTIONS(427),
    [anon_sym_NA_complex_] = ACTIONS(427),
    [anon_sym_NA_character_] = ACTIONS(427),
    [sym_dots] = ACTIONS(427),
    [sym_dot_dot_i] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(429),
    [sym__newline] = ACTIONS(429),
    [sym__raw_string_literal] = ACTIONS(429),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(429),
    [sym__external_open_brace] = ACTIONS(429),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [464] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(835),
    [anon_sym_LT_LT_DASH] = ACTIONS(835),
    [anon_sym_COLON_EQ] = ACTIONS(835),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_DASH_GT_GT] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym__newline] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(433),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [465] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(433),
    [anon_sym_LT_LT_DASH] = ACTIONS(433),
    [anon_sym_COLON_EQ] = ACTIONS(433),
    [anon_sym_DASH_GT] = ACTIONS(431),
    [anon_sym_DASH_GT_GT] = ACTIONS(433),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym__newline] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(433),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [466] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(433),
    [anon_sym_LT_LT_DASH] = ACTIONS(433),
    [anon_sym_COLON_EQ] = ACTIONS(433),
    [anon_sym_DASH_GT] = ACTIONS(431),
    [anon_sym_DASH_GT_GT] = ACTIONS(433),
    [anon_sym_PIPE] = ACTIONS(431),
    [anon_sym_AMP] = ACTIONS(431),
    [anon_sym_PIPE_PIPE] = ACTIONS(433),
    [anon_sym_AMP_AMP] = ACTIONS(433),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym__newline] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(433),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [467] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(433),
    [anon_sym_DASH] = ACTIONS(431),
    [anon_sym_LT_DASH] = ACTIONS(433),
    [anon_sym_LT_LT_DASH] = ACTIONS(433),
    [anon_sym_COLON_EQ] = ACTIONS(433),
    [anon_sym_DASH_GT] = ACTIONS(431),
    [anon_sym_DASH_GT_GT] = ACTIONS(433),
    [anon_sym_PIPE] = ACTIONS(431),
    [anon_sym_AMP] = ACTIONS(431),
    [anon_sym_PIPE_PIPE] = ACTIONS(433),
    [anon_sym_AMP_AMP] = ACTIONS(433),
    [anon_sym_LT] = ACTIONS(431),
    [anon_sym_LT_EQ] = ACTIONS(433),
    [anon_sym_GT] = ACTIONS(431),
    [anon_sym_GT_EQ] = ACTIONS(433),
    [anon_sym_EQ_EQ] = ACTIONS(433),
    [anon_sym_BANG_EQ] = ACTIONS(433),
    [anon_sym_STAR] = ACTIONS(431),
    [anon_sym_SLASH] = ACTIONS(433),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(433),
    [anon_sym_PIPE_GT] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(431),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym__newline] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(433),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [468] = {
    [sym_string] = STATE(774),
    [sym__single_quoted_string] = STATE(661),
    [sym__double_quoted_string] = STATE(686),
    [sym__string_or_identifier] = STATE(774),
    [aux_sym_function_definition_repeat1] = STATE(482),
    [sym_identifier] = ACTIONS(893),
    [anon_sym_BSLASH] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(795),
    [anon_sym_EQ] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(795),
    [anon_sym_for] = ACTIONS(795),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_repeat] = ACTIONS(795),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(795),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LT_DASH] = ACTIONS(791),
    [anon_sym_LT_LT_DASH] = ACTIONS(791),
    [anon_sym_COLON_EQ] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_DASH_GT_GT] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(795),
    [anon_sym_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [anon_sym_LT] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_GT] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(791),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_BANG_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(795),
    [anon_sym_SLASH] = ACTIONS(791),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [aux_sym_binary_operator_token1] = ACTIONS(791),
    [anon_sym_PIPE_GT] = ACTIONS(791),
    [anon_sym_COLON] = ACTIONS(795),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [anon_sym_AT] = ACTIONS(791),
    [sym__hex_literal] = ACTIONS(791),
    [sym__number_literal] = ACTIONS(795),
    [anon_sym_SQUOTE] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [sym_return] = ACTIONS(795),
    [sym_next] = ACTIONS(795),
    [sym_break] = ACTIONS(795),
    [sym_true] = ACTIONS(795),
    [sym_false] = ACTIONS(795),
    [sym_null] = ACTIONS(795),
    [sym_inf] = ACTIONS(795),
    [sym_nan] = ACTIONS(795),
    [anon_sym_NA] = ACTIONS(795),
    [anon_sym_NA_integer_] = ACTIONS(795),
    [anon_sym_NA_real_] = ACTIONS(795),
    [anon_sym_NA_complex_] = ACTIONS(795),
    [anon_sym_NA_character_] = ACTIONS(795),
    [sym_dots] = ACTIONS(795),
    [sym_dot_dot_i] = ACTIONS(791),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(899),
    [sym__semicolon] = ACTIONS(791),
    [sym__raw_string_literal] = ACTIONS(901),
    [sym__external_else] = ACTIONS(791),
    [sym__external_open_parenthesis] = ACTIONS(791),
    [sym__external_open_brace] = ACTIONS(791),
    [sym__external_close_brace] = ACTIONS(791),
    [sym__external_open_bracket] = ACTIONS(791),
    [sym__external_open_bracket2] = ACTIONS(791),
  },
  [469] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(435),
    [anon_sym_BSLASH] = ACTIONS(437),
    [anon_sym_function] = ACTIONS(435),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_if] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(435),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_repeat] = ACTIONS(435),
    [anon_sym_QMARK] = ACTIONS(437),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(435),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(835),
    [anon_sym_LT_LT_DASH] = ACTIONS(835),
    [anon_sym_COLON_EQ] = ACTIONS(835),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_DASH_GT_GT] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(437),
    [sym__number_literal] = ACTIONS(435),
    [anon_sym_SQUOTE] = ACTIONS(437),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [sym_return] = ACTIONS(435),
    [sym_next] = ACTIONS(435),
    [sym_break] = ACTIONS(435),
    [sym_true] = ACTIONS(435),
    [sym_false] = ACTIONS(435),
    [sym_null] = ACTIONS(435),
    [sym_inf] = ACTIONS(435),
    [sym_nan] = ACTIONS(435),
    [anon_sym_NA] = ACTIONS(435),
    [anon_sym_NA_integer_] = ACTIONS(435),
    [anon_sym_NA_real_] = ACTIONS(435),
    [anon_sym_NA_complex_] = ACTIONS(435),
    [anon_sym_NA_character_] = ACTIONS(435),
    [sym_dots] = ACTIONS(435),
    [sym_dot_dot_i] = ACTIONS(437),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(437),
    [sym__newline] = ACTIONS(437),
    [sym__raw_string_literal] = ACTIONS(437),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(437),
    [sym__external_open_brace] = ACTIONS(437),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [470] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(439),
    [anon_sym_BSLASH] = ACTIONS(441),
    [anon_sym_function] = ACTIONS(439),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_if] = ACTIONS(439),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(439),
    [anon_sym_repeat] = ACTIONS(439),
    [anon_sym_QMARK] = ACTIONS(441),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(439),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(835),
    [anon_sym_LT_LT_DASH] = ACTIONS(835),
    [anon_sym_COLON_EQ] = ACTIONS(835),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_DASH_GT_GT] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(441),
    [sym__number_literal] = ACTIONS(439),
    [anon_sym_SQUOTE] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(441),
    [sym_return] = ACTIONS(439),
    [sym_next] = ACTIONS(439),
    [sym_break] = ACTIONS(439),
    [sym_true] = ACTIONS(439),
    [sym_false] = ACTIONS(439),
    [sym_null] = ACTIONS(439),
    [sym_inf] = ACTIONS(439),
    [sym_nan] = ACTIONS(439),
    [anon_sym_NA] = ACTIONS(439),
    [anon_sym_NA_integer_] = ACTIONS(439),
    [anon_sym_NA_real_] = ACTIONS(439),
    [anon_sym_NA_complex_] = ACTIONS(439),
    [anon_sym_NA_character_] = ACTIONS(439),
    [sym_dots] = ACTIONS(439),
    [sym_dot_dot_i] = ACTIONS(441),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(441),
    [sym__newline] = ACTIONS(441),
    [sym__raw_string_literal] = ACTIONS(441),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(441),
    [sym__external_open_brace] = ACTIONS(441),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [471] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(835),
    [anon_sym_LT_LT_DASH] = ACTIONS(835),
    [anon_sym_COLON_EQ] = ACTIONS(835),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_DASH_GT_GT] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym__newline] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(445),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [472] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(445),
    [anon_sym_LT_LT_DASH] = ACTIONS(445),
    [anon_sym_COLON_EQ] = ACTIONS(445),
    [anon_sym_DASH_GT] = ACTIONS(443),
    [anon_sym_DASH_GT_GT] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym__newline] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(445),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [473] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(445),
    [anon_sym_LT_LT_DASH] = ACTIONS(445),
    [anon_sym_COLON_EQ] = ACTIONS(445),
    [anon_sym_DASH_GT] = ACTIONS(443),
    [anon_sym_DASH_GT_GT] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(443),
    [anon_sym_AMP] = ACTIONS(443),
    [anon_sym_PIPE_PIPE] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(445),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym__newline] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(445),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [474] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(443),
    [anon_sym_LT_DASH] = ACTIONS(445),
    [anon_sym_LT_LT_DASH] = ACTIONS(445),
    [anon_sym_COLON_EQ] = ACTIONS(445),
    [anon_sym_DASH_GT] = ACTIONS(443),
    [anon_sym_DASH_GT_GT] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(443),
    [anon_sym_AMP] = ACTIONS(443),
    [anon_sym_PIPE_PIPE] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(445),
    [anon_sym_LT] = ACTIONS(443),
    [anon_sym_LT_EQ] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(443),
    [anon_sym_GT_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(445),
    [anon_sym_PIPE_GT] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(443),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym__newline] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(445),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [475] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_DASH_GT_GT] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(371),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [476] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(835),
    [anon_sym_LT_LT_DASH] = ACTIONS(835),
    [anon_sym_COLON_EQ] = ACTIONS(835),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_DASH_GT_GT] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(371),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [477] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(371),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [478] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(371),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [479] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(835),
    [anon_sym_LT_LT_DASH] = ACTIONS(835),
    [anon_sym_COLON_EQ] = ACTIONS(835),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_DASH_GT_GT] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(371),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [480] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(371),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [481] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(371),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [482] = {
    [sym_string] = STATE(812),
    [sym__single_quoted_string] = STATE(661),
    [sym__double_quoted_string] = STATE(686),
    [sym__string_or_identifier] = STATE(812),
    [aux_sym_function_definition_repeat1] = STATE(723),
    [sym_identifier] = ACTIONS(903),
    [anon_sym_BSLASH] = ACTIONS(811),
    [anon_sym_function] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(815),
    [anon_sym_if] = ACTIONS(815),
    [anon_sym_for] = ACTIONS(815),
    [anon_sym_while] = ACTIONS(815),
    [anon_sym_repeat] = ACTIONS(815),
    [anon_sym_QMARK] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(811),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_LT_DASH] = ACTIONS(811),
    [anon_sym_LT_LT_DASH] = ACTIONS(811),
    [anon_sym_COLON_EQ] = ACTIONS(811),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_DASH_GT_GT] = ACTIONS(811),
    [anon_sym_PIPE] = ACTIONS(815),
    [anon_sym_AMP] = ACTIONS(815),
    [anon_sym_PIPE_PIPE] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(811),
    [anon_sym_GT] = ACTIONS(815),
    [anon_sym_GT_EQ] = ACTIONS(811),
    [anon_sym_EQ_EQ] = ACTIONS(811),
    [anon_sym_BANG_EQ] = ACTIONS(811),
    [anon_sym_STAR] = ACTIONS(815),
    [anon_sym_SLASH] = ACTIONS(811),
    [anon_sym_STAR_STAR] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(811),
    [aux_sym_binary_operator_token1] = ACTIONS(811),
    [anon_sym_PIPE_GT] = ACTIONS(811),
    [anon_sym_COLON] = ACTIONS(815),
    [anon_sym_DOLLAR] = ACTIONS(811),
    [anon_sym_AT] = ACTIONS(811),
    [sym__hex_literal] = ACTIONS(811),
    [sym__number_literal] = ACTIONS(815),
    [anon_sym_SQUOTE] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [sym_return] = ACTIONS(815),
    [sym_next] = ACTIONS(815),
    [sym_break] = ACTIONS(815),
    [sym_true] = ACTIONS(815),
    [sym_false] = ACTIONS(815),
    [sym_null] = ACTIONS(815),
    [sym_inf] = ACTIONS(815),
    [sym_nan] = ACTIONS(815),
    [anon_sym_NA] = ACTIONS(815),
    [anon_sym_NA_integer_] = ACTIONS(815),
    [anon_sym_NA_real_] = ACTIONS(815),
    [anon_sym_NA_complex_] = ACTIONS(815),
    [anon_sym_NA_character_] = ACTIONS(815),
    [sym_dots] = ACTIONS(815),
    [sym_dot_dot_i] = ACTIONS(811),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(811),
    [sym__semicolon] = ACTIONS(811),
    [sym__raw_string_literal] = ACTIONS(901),
    [sym__external_else] = ACTIONS(811),
    [sym__external_open_parenthesis] = ACTIONS(811),
    [sym__external_open_brace] = ACTIONS(811),
    [sym__external_close_brace] = ACTIONS(811),
    [sym__external_open_bracket] = ACTIONS(811),
    [sym__external_open_bracket2] = ACTIONS(811),
  },
  [483] = {
    [sym_function_definition] = STATE(491),
    [sym_if_statement] = STATE(491),
    [sym_for_statement] = STATE(491),
    [sym_while_statement] = STATE(491),
    [sym_repeat_statement] = STATE(491),
    [sym_braced_expression] = STATE(491),
    [sym_parenthesized_expression] = STATE(491),
    [sym_call] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_subset2] = STATE(491),
    [sym__argument] = STATE(1934),
    [sym_argument] = STATE(1937),
    [sym__argument_named] = STATE(1909),
    [sym__argument_unnamed] = STATE(1932),
    [sym__argument_value] = STATE(1920),
    [sym_unary_operator] = STATE(491),
    [sym_binary_operator] = STATE(491),
    [sym_extract_operator] = STATE(491),
    [sym_namespace_operator] = STATE(491),
    [sym_integer] = STATE(491),
    [sym_complex] = STATE(491),
    [sym_float] = STATE(491),
    [sym__float_literal] = STATE(734),
    [sym_string] = STATE(728),
    [sym__single_quoted_string] = STATE(735),
    [sym__double_quoted_string] = STATE(736),
    [sym_na] = STATE(491),
    [sym__expression] = STATE(491),
    [sym__string_or_identifier] = STATE(2143),
    [sym__open_parenthesis] = STATE(948),
    [sym__open_brace] = STATE(751),
    [sym__close_bracket] = STATE(814),
    [aux_sym_call_arguments_repeat1] = STATE(637),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_BSLASH] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_if] = ACTIONS(547),
    [anon_sym_for] = ACTIONS(549),
    [anon_sym_while] = ACTIONS(551),
    [anon_sym_repeat] = ACTIONS(553),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(557),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [sym__hex_literal] = ACTIONS(563),
    [sym__number_literal] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [sym_return] = ACTIONS(571),
    [sym_next] = ACTIONS(571),
    [sym_break] = ACTIONS(571),
    [sym_true] = ACTIONS(571),
    [sym_false] = ACTIONS(571),
    [sym_null] = ACTIONS(571),
    [sym_inf] = ACTIONS(571),
    [sym_nan] = ACTIONS(571),
    [anon_sym_NA] = ACTIONS(573),
    [anon_sym_NA_integer_] = ACTIONS(573),
    [anon_sym_NA_real_] = ACTIONS(573),
    [anon_sym_NA_complex_] = ACTIONS(573),
    [anon_sym_NA_character_] = ACTIONS(573),
    [sym_dots] = ACTIONS(575),
    [sym_dot_dot_i] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(579),
    [sym__newline] = ACTIONS(581),
    [sym__raw_string_literal] = ACTIONS(583),
    [sym__external_open_parenthesis] = ACTIONS(585),
    [sym__external_open_brace] = ACTIONS(587),
    [sym__external_close_bracket] = ACTIONS(905),
  },
  [484] = {
    [sym_function_definition] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_repeat_statement] = STATE(556),
    [sym_braced_expression] = STATE(556),
    [sym_parenthesized_expression] = STATE(556),
    [sym_call] = STATE(556),
    [sym_subset] = STATE(556),
    [sym_subset2] = STATE(556),
    [sym__argument] = STATE(1928),
    [sym_argument] = STATE(1930),
    [sym__argument_named] = STATE(1908),
    [sym__argument_unnamed] = STATE(1933),
    [sym__argument_value] = STATE(1936),
    [sym_unary_operator] = STATE(556),
    [sym_binary_operator] = STATE(556),
    [sym_extract_operator] = STATE(556),
    [sym_namespace_operator] = STATE(556),
    [sym_integer] = STATE(556),
    [sym_complex] = STATE(556),
    [sym_float] = STATE(556),
    [sym__float_literal] = STATE(710),
    [sym_string] = STATE(724),
    [sym__single_quoted_string] = STATE(725),
    [sym__double_quoted_string] = STATE(700),
    [sym_na] = STATE(556),
    [sym__expression] = STATE(556),
    [sym__string_or_identifier] = STATE(2142),
    [sym__open_parenthesis] = STATE(955),
    [sym__open_brace] = STATE(857),
    [sym__close_bracket2] = STATE(874),
    [aux_sym_call_arguments_repeat1] = STATE(639),
    [sym_identifier] = ACTIONS(591),
    [anon_sym_BSLASH] = ACTIONS(593),
    [anon_sym_function] = ACTIONS(595),
    [anon_sym_if] = ACTIONS(597),
    [anon_sym_for] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_repeat] = ACTIONS(603),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [sym__hex_literal] = ACTIONS(613),
    [sym__number_literal] = ACTIONS(615),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(619),
    [sym_return] = ACTIONS(621),
    [sym_next] = ACTIONS(621),
    [sym_break] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_null] = ACTIONS(621),
    [sym_inf] = ACTIONS(621),
    [sym_nan] = ACTIONS(621),
    [anon_sym_NA] = ACTIONS(623),
    [anon_sym_NA_integer_] = ACTIONS(623),
    [anon_sym_NA_real_] = ACTIONS(623),
    [anon_sym_NA_complex_] = ACTIONS(623),
    [anon_sym_NA_character_] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(629),
    [sym__newline] = ACTIONS(631),
    [sym__raw_string_literal] = ACTIONS(633),
    [sym__external_open_parenthesis] = ACTIONS(635),
    [sym__external_open_brace] = ACTIONS(637),
    [sym__external_close_bracket2] = ACTIONS(907),
  },
  [485] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(371),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [486] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(371),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [487] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(371),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [488] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(371),
    [anon_sym_PIPE_GT] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(373),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(371),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [489] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(371),
    [anon_sym_PIPE_GT] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(371),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [490] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(371),
    [anon_sym_PIPE_GT] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(373),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(371),
    [sym__newline] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(371),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [491] = {
    [sym_call_arguments] = STATE(959),
    [sym_subset_arguments] = STATE(966),
    [sym_subset2_arguments] = STATE(971),
    [sym__open_parenthesis] = STATE(597),
    [sym__open_bracket] = STATE(598),
    [sym__open_bracket2] = STATE(599),
    [sym_identifier] = ACTIONS(821),
    [anon_sym_BSLASH] = ACTIONS(823),
    [anon_sym_function] = ACTIONS(821),
    [anon_sym_EQ] = ACTIONS(641),
    [anon_sym_if] = ACTIONS(821),
    [anon_sym_for] = ACTIONS(821),
    [anon_sym_while] = ACTIONS(821),
    [anon_sym_repeat] = ACTIONS(821),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(821),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_LT_DASH] = ACTIONS(649),
    [anon_sym_LT_LT_DASH] = ACTIONS(649),
    [anon_sym_COLON_EQ] = ACTIONS(649),
    [anon_sym_DASH_GT] = ACTIONS(651),
    [anon_sym_DASH_GT_GT] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_LT] = ACTIONS(663),
    [anon_sym_LT_EQ] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_GT_EQ] = ACTIONS(665),
    [anon_sym_EQ_EQ] = ACTIONS(665),
    [anon_sym_BANG_EQ] = ACTIONS(665),
    [anon_sym_STAR] = ACTIONS(667),
    [anon_sym_SLASH] = ACTIONS(669),
    [anon_sym_STAR_STAR] = ACTIONS(671),
    [anon_sym_CARET] = ACTIONS(671),
    [aux_sym_binary_operator_token1] = ACTIONS(673),
    [anon_sym_PIPE_GT] = ACTIONS(673),
    [anon_sym_COLON] = ACTIONS(675),
    [anon_sym_DOLLAR] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(677),
    [sym__hex_literal] = ACTIONS(823),
    [sym__number_literal] = ACTIONS(821),
    [anon_sym_SQUOTE] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(823),
    [sym_return] = ACTIONS(821),
    [sym_next] = ACTIONS(821),
    [sym_break] = ACTIONS(821),
    [sym_true] = ACTIONS(821),
    [sym_false] = ACTIONS(821),
    [sym_null] = ACTIONS(821),
    [sym_inf] = ACTIONS(821),
    [sym_nan] = ACTIONS(821),
    [anon_sym_NA] = ACTIONS(821),
    [anon_sym_NA_integer_] = ACTIONS(821),
    [anon_sym_NA_real_] = ACTIONS(821),
    [anon_sym_NA_complex_] = ACTIONS(821),
    [anon_sym_NA_character_] = ACTIONS(821),
    [sym_dots] = ACTIONS(821),
    [sym_dot_dot_i] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(823),
    [sym__newline] = ACTIONS(823),
    [sym__raw_string_literal] = ACTIONS(823),
    [sym__external_open_parenthesis] = ACTIONS(679),
    [sym__external_open_brace] = ACTIONS(823),
    [sym__external_open_bracket] = ACTIONS(681),
    [sym__external_close_bracket] = ACTIONS(823),
    [sym__external_open_bracket2] = ACTIONS(683),
  },
  [492] = {
    [sym_function_definition] = STATE(429),
    [sym_if_statement] = STATE(429),
    [sym_for_statement] = STATE(429),
    [sym_while_statement] = STATE(429),
    [sym_repeat_statement] = STATE(429),
    [sym_braced_expression] = STATE(429),
    [sym_parenthesized_expression] = STATE(429),
    [sym_call] = STATE(429),
    [sym_subset] = STATE(429),
    [sym_subset2] = STATE(429),
    [sym__argument] = STATE(1912),
    [sym_argument] = STATE(1916),
    [sym__argument_named] = STATE(1919),
    [sym__argument_unnamed] = STATE(1921),
    [sym__argument_value] = STATE(1927),
    [sym_unary_operator] = STATE(429),
    [sym_binary_operator] = STATE(429),
    [sym_extract_operator] = STATE(429),
    [sym_namespace_operator] = STATE(429),
    [sym_integer] = STATE(429),
    [sym_complex] = STATE(429),
    [sym_float] = STATE(429),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(721),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(429),
    [sym__expression] = STATE(429),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(924),
    [sym__open_brace] = STATE(842),
    [aux_sym_call_arguments_repeat1] = STATE(647),
    [sym_identifier] = ACTIONS(737),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(767),
    [sym_next] = ACTIONS(767),
    [sym_break] = ACTIONS(767),
    [sym_true] = ACTIONS(767),
    [sym_false] = ACTIONS(767),
    [sym_null] = ACTIONS(767),
    [sym_inf] = ACTIONS(767),
    [sym_nan] = ACTIONS(767),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(771),
    [sym_dot_dot_i] = ACTIONS(773),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(775),
    [sym__newline] = ACTIONS(777),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(911),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [493] = {
    [sym_function_definition] = STATE(491),
    [sym_if_statement] = STATE(491),
    [sym_for_statement] = STATE(491),
    [sym_while_statement] = STATE(491),
    [sym_repeat_statement] = STATE(491),
    [sym_braced_expression] = STATE(491),
    [sym_parenthesized_expression] = STATE(491),
    [sym_call] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_subset2] = STATE(491),
    [sym__argument] = STATE(1934),
    [sym_argument] = STATE(1937),
    [sym__argument_named] = STATE(1909),
    [sym__argument_unnamed] = STATE(1932),
    [sym__argument_value] = STATE(1920),
    [sym_unary_operator] = STATE(491),
    [sym_binary_operator] = STATE(491),
    [sym_extract_operator] = STATE(491),
    [sym_namespace_operator] = STATE(491),
    [sym_integer] = STATE(491),
    [sym_complex] = STATE(491),
    [sym_float] = STATE(491),
    [sym__float_literal] = STATE(734),
    [sym_string] = STATE(728),
    [sym__single_quoted_string] = STATE(735),
    [sym__double_quoted_string] = STATE(736),
    [sym_na] = STATE(491),
    [sym__expression] = STATE(491),
    [sym__string_or_identifier] = STATE(2143),
    [sym__open_parenthesis] = STATE(948),
    [sym__open_brace] = STATE(751),
    [sym__close_bracket] = STATE(972),
    [aux_sym_call_arguments_repeat1] = STATE(637),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_BSLASH] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_if] = ACTIONS(547),
    [anon_sym_for] = ACTIONS(549),
    [anon_sym_while] = ACTIONS(551),
    [anon_sym_repeat] = ACTIONS(553),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(557),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [sym__hex_literal] = ACTIONS(563),
    [sym__number_literal] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [sym_return] = ACTIONS(571),
    [sym_next] = ACTIONS(571),
    [sym_break] = ACTIONS(571),
    [sym_true] = ACTIONS(571),
    [sym_false] = ACTIONS(571),
    [sym_null] = ACTIONS(571),
    [sym_inf] = ACTIONS(571),
    [sym_nan] = ACTIONS(571),
    [anon_sym_NA] = ACTIONS(573),
    [anon_sym_NA_integer_] = ACTIONS(573),
    [anon_sym_NA_real_] = ACTIONS(573),
    [anon_sym_NA_complex_] = ACTIONS(573),
    [anon_sym_NA_character_] = ACTIONS(573),
    [sym_dots] = ACTIONS(575),
    [sym_dot_dot_i] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(579),
    [sym__newline] = ACTIONS(581),
    [sym__raw_string_literal] = ACTIONS(583),
    [sym__external_open_parenthesis] = ACTIONS(585),
    [sym__external_open_brace] = ACTIONS(587),
    [sym__external_close_bracket] = ACTIONS(913),
  },
  [494] = {
    [sym_function_definition] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_repeat_statement] = STATE(556),
    [sym_braced_expression] = STATE(556),
    [sym_parenthesized_expression] = STATE(556),
    [sym_call] = STATE(556),
    [sym_subset] = STATE(556),
    [sym_subset2] = STATE(556),
    [sym__argument] = STATE(1928),
    [sym_argument] = STATE(1930),
    [sym__argument_named] = STATE(1908),
    [sym__argument_unnamed] = STATE(1933),
    [sym__argument_value] = STATE(1936),
    [sym_unary_operator] = STATE(556),
    [sym_binary_operator] = STATE(556),
    [sym_extract_operator] = STATE(556),
    [sym_namespace_operator] = STATE(556),
    [sym_integer] = STATE(556),
    [sym_complex] = STATE(556),
    [sym_float] = STATE(556),
    [sym__float_literal] = STATE(710),
    [sym_string] = STATE(724),
    [sym__single_quoted_string] = STATE(725),
    [sym__double_quoted_string] = STATE(700),
    [sym_na] = STATE(556),
    [sym__expression] = STATE(556),
    [sym__string_or_identifier] = STATE(2142),
    [sym__open_parenthesis] = STATE(955),
    [sym__open_brace] = STATE(857),
    [sym__close_bracket2] = STATE(984),
    [aux_sym_call_arguments_repeat1] = STATE(639),
    [sym_identifier] = ACTIONS(591),
    [anon_sym_BSLASH] = ACTIONS(593),
    [anon_sym_function] = ACTIONS(595),
    [anon_sym_if] = ACTIONS(597),
    [anon_sym_for] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_repeat] = ACTIONS(603),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [sym__hex_literal] = ACTIONS(613),
    [sym__number_literal] = ACTIONS(615),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(619),
    [sym_return] = ACTIONS(621),
    [sym_next] = ACTIONS(621),
    [sym_break] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_null] = ACTIONS(621),
    [sym_inf] = ACTIONS(621),
    [sym_nan] = ACTIONS(621),
    [anon_sym_NA] = ACTIONS(623),
    [anon_sym_NA_integer_] = ACTIONS(623),
    [anon_sym_NA_real_] = ACTIONS(623),
    [anon_sym_NA_complex_] = ACTIONS(623),
    [anon_sym_NA_character_] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(629),
    [sym__newline] = ACTIONS(631),
    [sym__raw_string_literal] = ACTIONS(633),
    [sym__external_open_parenthesis] = ACTIONS(635),
    [sym__external_open_brace] = ACTIONS(637),
    [sym__external_close_bracket2] = ACTIONS(915),
  },
  [495] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(375),
    [anon_sym_function] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_repeat] = ACTIONS(377),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(835),
    [anon_sym_LT_LT_DASH] = ACTIONS(835),
    [anon_sym_COLON_EQ] = ACTIONS(835),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_DASH_GT_GT] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(375),
    [sym__number_literal] = ACTIONS(377),
    [anon_sym_SQUOTE] = ACTIONS(375),
    [anon_sym_DQUOTE] = ACTIONS(375),
    [sym_return] = ACTIONS(377),
    [sym_next] = ACTIONS(377),
    [sym_break] = ACTIONS(377),
    [sym_true] = ACTIONS(377),
    [sym_false] = ACTIONS(377),
    [sym_null] = ACTIONS(377),
    [sym_inf] = ACTIONS(377),
    [sym_nan] = ACTIONS(377),
    [anon_sym_NA] = ACTIONS(377),
    [anon_sym_NA_integer_] = ACTIONS(377),
    [anon_sym_NA_real_] = ACTIONS(377),
    [anon_sym_NA_complex_] = ACTIONS(377),
    [anon_sym_NA_character_] = ACTIONS(377),
    [sym_dots] = ACTIONS(377),
    [sym_dot_dot_i] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(375),
    [sym__newline] = ACTIONS(375),
    [sym__raw_string_literal] = ACTIONS(375),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(375),
    [sym__external_open_brace] = ACTIONS(375),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [496] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_DASH_GT_GT] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(379),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [497] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(835),
    [anon_sym_LT_LT_DASH] = ACTIONS(835),
    [anon_sym_COLON_EQ] = ACTIONS(835),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_DASH_GT_GT] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(379),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [498] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(379),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [499] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(379),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [500] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(835),
    [anon_sym_LT_LT_DASH] = ACTIONS(835),
    [anon_sym_COLON_EQ] = ACTIONS(835),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_DASH_GT_GT] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(379),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [501] = {
    [sym_function_definition] = STATE(491),
    [sym_if_statement] = STATE(491),
    [sym_for_statement] = STATE(491),
    [sym_while_statement] = STATE(491),
    [sym_repeat_statement] = STATE(491),
    [sym_braced_expression] = STATE(491),
    [sym_parenthesized_expression] = STATE(491),
    [sym_call] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_subset2] = STATE(491),
    [sym__argument] = STATE(1934),
    [sym_argument] = STATE(1937),
    [sym__argument_named] = STATE(1909),
    [sym__argument_unnamed] = STATE(1932),
    [sym__argument_value] = STATE(1920),
    [sym_unary_operator] = STATE(491),
    [sym_binary_operator] = STATE(491),
    [sym_extract_operator] = STATE(491),
    [sym_namespace_operator] = STATE(491),
    [sym_integer] = STATE(491),
    [sym_complex] = STATE(491),
    [sym_float] = STATE(491),
    [sym__float_literal] = STATE(734),
    [sym_string] = STATE(728),
    [sym__single_quoted_string] = STATE(735),
    [sym__double_quoted_string] = STATE(736),
    [sym_na] = STATE(491),
    [sym__expression] = STATE(491),
    [sym__string_or_identifier] = STATE(2143),
    [sym__open_parenthesis] = STATE(948),
    [sym__open_brace] = STATE(751),
    [sym__close_bracket] = STATE(1963),
    [aux_sym_call_arguments_repeat1] = STATE(637),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_BSLASH] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_if] = ACTIONS(547),
    [anon_sym_for] = ACTIONS(549),
    [anon_sym_while] = ACTIONS(551),
    [anon_sym_repeat] = ACTIONS(553),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(557),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [sym__hex_literal] = ACTIONS(563),
    [sym__number_literal] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [sym_return] = ACTIONS(571),
    [sym_next] = ACTIONS(571),
    [sym_break] = ACTIONS(571),
    [sym_true] = ACTIONS(571),
    [sym_false] = ACTIONS(571),
    [sym_null] = ACTIONS(571),
    [sym_inf] = ACTIONS(571),
    [sym_nan] = ACTIONS(571),
    [anon_sym_NA] = ACTIONS(573),
    [anon_sym_NA_integer_] = ACTIONS(573),
    [anon_sym_NA_real_] = ACTIONS(573),
    [anon_sym_NA_complex_] = ACTIONS(573),
    [anon_sym_NA_character_] = ACTIONS(573),
    [sym_dots] = ACTIONS(575),
    [sym_dot_dot_i] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(579),
    [sym__newline] = ACTIONS(581),
    [sym__raw_string_literal] = ACTIONS(583),
    [sym__external_open_parenthesis] = ACTIONS(585),
    [sym__external_open_brace] = ACTIONS(587),
    [sym__external_close_bracket] = ACTIONS(917),
  },
  [502] = {
    [sym_function_definition] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_repeat_statement] = STATE(556),
    [sym_braced_expression] = STATE(556),
    [sym_parenthesized_expression] = STATE(556),
    [sym_call] = STATE(556),
    [sym_subset] = STATE(556),
    [sym_subset2] = STATE(556),
    [sym__argument] = STATE(1928),
    [sym_argument] = STATE(1930),
    [sym__argument_named] = STATE(1908),
    [sym__argument_unnamed] = STATE(1933),
    [sym__argument_value] = STATE(1936),
    [sym_unary_operator] = STATE(556),
    [sym_binary_operator] = STATE(556),
    [sym_extract_operator] = STATE(556),
    [sym_namespace_operator] = STATE(556),
    [sym_integer] = STATE(556),
    [sym_complex] = STATE(556),
    [sym_float] = STATE(556),
    [sym__float_literal] = STATE(710),
    [sym_string] = STATE(724),
    [sym__single_quoted_string] = STATE(725),
    [sym__double_quoted_string] = STATE(700),
    [sym_na] = STATE(556),
    [sym__expression] = STATE(556),
    [sym__string_or_identifier] = STATE(2142),
    [sym__open_parenthesis] = STATE(955),
    [sym__open_brace] = STATE(857),
    [sym__close_bracket2] = STATE(1966),
    [aux_sym_call_arguments_repeat1] = STATE(639),
    [sym_identifier] = ACTIONS(591),
    [anon_sym_BSLASH] = ACTIONS(593),
    [anon_sym_function] = ACTIONS(595),
    [anon_sym_if] = ACTIONS(597),
    [anon_sym_for] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_repeat] = ACTIONS(603),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [sym__hex_literal] = ACTIONS(613),
    [sym__number_literal] = ACTIONS(615),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(619),
    [sym_return] = ACTIONS(621),
    [sym_next] = ACTIONS(621),
    [sym_break] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_null] = ACTIONS(621),
    [sym_inf] = ACTIONS(621),
    [sym_nan] = ACTIONS(621),
    [anon_sym_NA] = ACTIONS(623),
    [anon_sym_NA_integer_] = ACTIONS(623),
    [anon_sym_NA_real_] = ACTIONS(623),
    [anon_sym_NA_complex_] = ACTIONS(623),
    [anon_sym_NA_character_] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(629),
    [sym__newline] = ACTIONS(631),
    [sym__raw_string_literal] = ACTIONS(633),
    [sym__external_open_parenthesis] = ACTIONS(635),
    [sym__external_open_brace] = ACTIONS(637),
    [sym__external_close_bracket2] = ACTIONS(919),
  },
  [503] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(379),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [504] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(379),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [505] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(379),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [506] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(379),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [507] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(379),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [508] = {
    [sym_string] = STATE(762),
    [sym__single_quoted_string] = STATE(656),
    [sym__double_quoted_string] = STATE(657),
    [sym__string_or_identifier] = STATE(762),
    [aux_sym_function_definition_repeat1] = STATE(519),
    [sym_identifier] = ACTIONS(921),
    [anon_sym_BSLASH] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(795),
    [anon_sym_EQ] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(795),
    [anon_sym_for] = ACTIONS(795),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_repeat] = ACTIONS(795),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(795),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LT_DASH] = ACTIONS(791),
    [anon_sym_LT_LT_DASH] = ACTIONS(791),
    [anon_sym_COLON_EQ] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_DASH_GT_GT] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(795),
    [anon_sym_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [anon_sym_LT] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_GT] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(791),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_BANG_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(795),
    [anon_sym_SLASH] = ACTIONS(791),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [aux_sym_binary_operator_token1] = ACTIONS(791),
    [anon_sym_PIPE_GT] = ACTIONS(791),
    [anon_sym_COLON] = ACTIONS(795),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [anon_sym_AT] = ACTIONS(791),
    [sym__hex_literal] = ACTIONS(791),
    [sym__number_literal] = ACTIONS(795),
    [anon_sym_SQUOTE] = ACTIONS(923),
    [anon_sym_DQUOTE] = ACTIONS(925),
    [sym_return] = ACTIONS(795),
    [sym_next] = ACTIONS(795),
    [sym_break] = ACTIONS(795),
    [sym_true] = ACTIONS(795),
    [sym_false] = ACTIONS(795),
    [sym_null] = ACTIONS(795),
    [sym_inf] = ACTIONS(795),
    [sym_nan] = ACTIONS(795),
    [anon_sym_NA] = ACTIONS(795),
    [anon_sym_NA_integer_] = ACTIONS(795),
    [anon_sym_NA_real_] = ACTIONS(795),
    [anon_sym_NA_complex_] = ACTIONS(795),
    [anon_sym_NA_character_] = ACTIONS(795),
    [sym_dots] = ACTIONS(795),
    [sym_dot_dot_i] = ACTIONS(791),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(791),
    [sym__newline] = ACTIONS(927),
    [sym__raw_string_literal] = ACTIONS(929),
    [sym__external_else] = ACTIONS(791),
    [sym__external_open_parenthesis] = ACTIONS(791),
    [sym__external_open_brace] = ACTIONS(791),
    [sym__external_open_bracket] = ACTIONS(791),
    [sym__external_close_bracket] = ACTIONS(791),
    [sym__external_open_bracket2] = ACTIONS(791),
  },
  [509] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(379),
    [anon_sym_PIPE_GT] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(381),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(379),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [510] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(379),
    [anon_sym_PIPE_GT] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(379),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [511] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(379),
    [anon_sym_PIPE_GT] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(381),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(379),
    [sym__newline] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(379),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [512] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(385),
    [anon_sym_BSLASH] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_for] = ACTIONS(385),
    [anon_sym_while] = ACTIONS(385),
    [anon_sym_repeat] = ACTIONS(385),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(835),
    [anon_sym_LT_LT_DASH] = ACTIONS(835),
    [anon_sym_COLON_EQ] = ACTIONS(835),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_DASH_GT_GT] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(383),
    [sym__number_literal] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [sym_return] = ACTIONS(385),
    [sym_next] = ACTIONS(385),
    [sym_break] = ACTIONS(385),
    [sym_true] = ACTIONS(385),
    [sym_false] = ACTIONS(385),
    [sym_null] = ACTIONS(385),
    [sym_inf] = ACTIONS(385),
    [sym_nan] = ACTIONS(385),
    [anon_sym_NA] = ACTIONS(385),
    [anon_sym_NA_integer_] = ACTIONS(385),
    [anon_sym_NA_real_] = ACTIONS(385),
    [anon_sym_NA_complex_] = ACTIONS(385),
    [anon_sym_NA_character_] = ACTIONS(385),
    [sym_dots] = ACTIONS(385),
    [sym_dot_dot_i] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(383),
    [sym__newline] = ACTIONS(383),
    [sym__raw_string_literal] = ACTIONS(383),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(383),
    [sym__external_open_brace] = ACTIONS(383),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [513] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_if] = ACTIONS(389),
    [anon_sym_for] = ACTIONS(389),
    [anon_sym_while] = ACTIONS(389),
    [anon_sym_repeat] = ACTIONS(389),
    [anon_sym_QMARK] = ACTIONS(387),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(389),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(835),
    [anon_sym_LT_LT_DASH] = ACTIONS(835),
    [anon_sym_COLON_EQ] = ACTIONS(835),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_DASH_GT_GT] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(387),
    [sym__number_literal] = ACTIONS(389),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_return] = ACTIONS(389),
    [sym_next] = ACTIONS(389),
    [sym_break] = ACTIONS(389),
    [sym_true] = ACTIONS(389),
    [sym_false] = ACTIONS(389),
    [sym_null] = ACTIONS(389),
    [sym_inf] = ACTIONS(389),
    [sym_nan] = ACTIONS(389),
    [anon_sym_NA] = ACTIONS(389),
    [anon_sym_NA_integer_] = ACTIONS(389),
    [anon_sym_NA_real_] = ACTIONS(389),
    [anon_sym_NA_complex_] = ACTIONS(389),
    [anon_sym_NA_character_] = ACTIONS(389),
    [sym_dots] = ACTIONS(389),
    [sym_dot_dot_i] = ACTIONS(387),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym__newline] = ACTIONS(387),
    [sym__raw_string_literal] = ACTIONS(387),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(387),
    [sym__external_open_brace] = ACTIONS(387),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [514] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_BSLASH] = ACTIONS(391),
    [anon_sym_function] = ACTIONS(393),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_if] = ACTIONS(393),
    [anon_sym_for] = ACTIONS(393),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_repeat] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(835),
    [anon_sym_LT_LT_DASH] = ACTIONS(835),
    [anon_sym_COLON_EQ] = ACTIONS(835),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_DASH_GT_GT] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(391),
    [sym__number_literal] = ACTIONS(393),
    [anon_sym_SQUOTE] = ACTIONS(391),
    [anon_sym_DQUOTE] = ACTIONS(391),
    [sym_return] = ACTIONS(393),
    [sym_next] = ACTIONS(393),
    [sym_break] = ACTIONS(393),
    [sym_true] = ACTIONS(393),
    [sym_false] = ACTIONS(393),
    [sym_null] = ACTIONS(393),
    [sym_inf] = ACTIONS(393),
    [sym_nan] = ACTIONS(393),
    [anon_sym_NA] = ACTIONS(393),
    [anon_sym_NA_integer_] = ACTIONS(393),
    [anon_sym_NA_real_] = ACTIONS(393),
    [anon_sym_NA_complex_] = ACTIONS(393),
    [anon_sym_NA_character_] = ACTIONS(393),
    [sym_dots] = ACTIONS(393),
    [sym_dot_dot_i] = ACTIONS(391),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(391),
    [sym__newline] = ACTIONS(391),
    [sym__raw_string_literal] = ACTIONS(391),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(391),
    [sym__external_open_brace] = ACTIONS(391),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [515] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(397),
    [anon_sym_BSLASH] = ACTIONS(395),
    [anon_sym_function] = ACTIONS(397),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_if] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_while] = ACTIONS(397),
    [anon_sym_repeat] = ACTIONS(397),
    [anon_sym_QMARK] = ACTIONS(395),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(835),
    [anon_sym_LT_LT_DASH] = ACTIONS(835),
    [anon_sym_COLON_EQ] = ACTIONS(835),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_DASH_GT_GT] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(395),
    [sym__number_literal] = ACTIONS(397),
    [anon_sym_SQUOTE] = ACTIONS(395),
    [anon_sym_DQUOTE] = ACTIONS(395),
    [sym_return] = ACTIONS(397),
    [sym_next] = ACTIONS(397),
    [sym_break] = ACTIONS(397),
    [sym_true] = ACTIONS(397),
    [sym_false] = ACTIONS(397),
    [sym_null] = ACTIONS(397),
    [sym_inf] = ACTIONS(397),
    [sym_nan] = ACTIONS(397),
    [anon_sym_NA] = ACTIONS(397),
    [anon_sym_NA_integer_] = ACTIONS(397),
    [anon_sym_NA_real_] = ACTIONS(397),
    [anon_sym_NA_complex_] = ACTIONS(397),
    [anon_sym_NA_character_] = ACTIONS(397),
    [sym_dots] = ACTIONS(397),
    [sym_dot_dot_i] = ACTIONS(395),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(395),
    [sym__newline] = ACTIONS(395),
    [sym__raw_string_literal] = ACTIONS(395),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(395),
    [sym__external_open_brace] = ACTIONS(395),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [516] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(429),
    [sym_identifier] = ACTIONS(427),
    [anon_sym_BSLASH] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_repeat] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(429),
    [sym__number_literal] = ACTIONS(427),
    [anon_sym_SQUOTE] = ACTIONS(429),
    [anon_sym_DQUOTE] = ACTIONS(429),
    [sym_return] = ACTIONS(427),
    [sym_next] = ACTIONS(427),
    [sym_break] = ACTIONS(427),
    [sym_true] = ACTIONS(427),
    [sym_false] = ACTIONS(427),
    [sym_null] = ACTIONS(427),
    [sym_inf] = ACTIONS(427),
    [sym_nan] = ACTIONS(427),
    [anon_sym_NA] = ACTIONS(427),
    [anon_sym_NA_integer_] = ACTIONS(427),
    [anon_sym_NA_real_] = ACTIONS(427),
    [anon_sym_NA_complex_] = ACTIONS(427),
    [anon_sym_NA_character_] = ACTIONS(427),
    [sym_dots] = ACTIONS(427),
    [sym_dot_dot_i] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(429),
    [sym__semicolon] = ACTIONS(429),
    [sym__raw_string_literal] = ACTIONS(429),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(429),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [517] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(401),
    [anon_sym_BSLASH] = ACTIONS(399),
    [anon_sym_function] = ACTIONS(401),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_if] = ACTIONS(401),
    [anon_sym_for] = ACTIONS(401),
    [anon_sym_while] = ACTIONS(401),
    [anon_sym_repeat] = ACTIONS(401),
    [anon_sym_QMARK] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(835),
    [anon_sym_LT_LT_DASH] = ACTIONS(835),
    [anon_sym_COLON_EQ] = ACTIONS(835),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_DASH_GT_GT] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(399),
    [sym__number_literal] = ACTIONS(401),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [sym_return] = ACTIONS(401),
    [sym_next] = ACTIONS(401),
    [sym_break] = ACTIONS(401),
    [sym_true] = ACTIONS(401),
    [sym_false] = ACTIONS(401),
    [sym_null] = ACTIONS(401),
    [sym_inf] = ACTIONS(401),
    [sym_nan] = ACTIONS(401),
    [anon_sym_NA] = ACTIONS(401),
    [anon_sym_NA_integer_] = ACTIONS(401),
    [anon_sym_NA_real_] = ACTIONS(401),
    [anon_sym_NA_complex_] = ACTIONS(401),
    [anon_sym_NA_character_] = ACTIONS(401),
    [sym_dots] = ACTIONS(401),
    [sym_dot_dot_i] = ACTIONS(399),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(399),
    [sym__newline] = ACTIONS(399),
    [sym__raw_string_literal] = ACTIONS(399),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(399),
    [sym__external_open_brace] = ACTIONS(399),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [518] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_BSLASH] = ACTIONS(403),
    [anon_sym_function] = ACTIONS(405),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_if] = ACTIONS(405),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_while] = ACTIONS(405),
    [anon_sym_repeat] = ACTIONS(405),
    [anon_sym_QMARK] = ACTIONS(403),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(405),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(835),
    [anon_sym_LT_LT_DASH] = ACTIONS(835),
    [anon_sym_COLON_EQ] = ACTIONS(835),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_DASH_GT_GT] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(403),
    [sym__number_literal] = ACTIONS(405),
    [anon_sym_SQUOTE] = ACTIONS(403),
    [anon_sym_DQUOTE] = ACTIONS(403),
    [sym_return] = ACTIONS(405),
    [sym_next] = ACTIONS(405),
    [sym_break] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_null] = ACTIONS(405),
    [sym_inf] = ACTIONS(405),
    [sym_nan] = ACTIONS(405),
    [anon_sym_NA] = ACTIONS(405),
    [anon_sym_NA_integer_] = ACTIONS(405),
    [anon_sym_NA_real_] = ACTIONS(405),
    [anon_sym_NA_complex_] = ACTIONS(405),
    [anon_sym_NA_character_] = ACTIONS(405),
    [sym_dots] = ACTIONS(405),
    [sym_dot_dot_i] = ACTIONS(403),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(403),
    [sym__newline] = ACTIONS(403),
    [sym__raw_string_literal] = ACTIONS(403),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(403),
    [sym__external_open_brace] = ACTIONS(403),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [519] = {
    [sym_string] = STATE(780),
    [sym__single_quoted_string] = STATE(656),
    [sym__double_quoted_string] = STATE(657),
    [sym__string_or_identifier] = STATE(780),
    [aux_sym_function_definition_repeat1] = STATE(731),
    [sym_identifier] = ACTIONS(931),
    [anon_sym_BSLASH] = ACTIONS(811),
    [anon_sym_function] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(815),
    [anon_sym_if] = ACTIONS(815),
    [anon_sym_for] = ACTIONS(815),
    [anon_sym_while] = ACTIONS(815),
    [anon_sym_repeat] = ACTIONS(815),
    [anon_sym_QMARK] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(811),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_LT_DASH] = ACTIONS(811),
    [anon_sym_LT_LT_DASH] = ACTIONS(811),
    [anon_sym_COLON_EQ] = ACTIONS(811),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_DASH_GT_GT] = ACTIONS(811),
    [anon_sym_PIPE] = ACTIONS(815),
    [anon_sym_AMP] = ACTIONS(815),
    [anon_sym_PIPE_PIPE] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(811),
    [anon_sym_GT] = ACTIONS(815),
    [anon_sym_GT_EQ] = ACTIONS(811),
    [anon_sym_EQ_EQ] = ACTIONS(811),
    [anon_sym_BANG_EQ] = ACTIONS(811),
    [anon_sym_STAR] = ACTIONS(815),
    [anon_sym_SLASH] = ACTIONS(811),
    [anon_sym_STAR_STAR] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(811),
    [aux_sym_binary_operator_token1] = ACTIONS(811),
    [anon_sym_PIPE_GT] = ACTIONS(811),
    [anon_sym_COLON] = ACTIONS(815),
    [anon_sym_DOLLAR] = ACTIONS(811),
    [anon_sym_AT] = ACTIONS(811),
    [sym__hex_literal] = ACTIONS(811),
    [sym__number_literal] = ACTIONS(815),
    [anon_sym_SQUOTE] = ACTIONS(923),
    [anon_sym_DQUOTE] = ACTIONS(925),
    [sym_return] = ACTIONS(815),
    [sym_next] = ACTIONS(815),
    [sym_break] = ACTIONS(815),
    [sym_true] = ACTIONS(815),
    [sym_false] = ACTIONS(815),
    [sym_null] = ACTIONS(815),
    [sym_inf] = ACTIONS(815),
    [sym_nan] = ACTIONS(815),
    [anon_sym_NA] = ACTIONS(815),
    [anon_sym_NA_integer_] = ACTIONS(815),
    [anon_sym_NA_real_] = ACTIONS(815),
    [anon_sym_NA_complex_] = ACTIONS(815),
    [anon_sym_NA_character_] = ACTIONS(815),
    [sym_dots] = ACTIONS(815),
    [sym_dot_dot_i] = ACTIONS(811),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(811),
    [sym__newline] = ACTIONS(811),
    [sym__raw_string_literal] = ACTIONS(929),
    [sym__external_else] = ACTIONS(811),
    [sym__external_open_parenthesis] = ACTIONS(811),
    [sym__external_open_brace] = ACTIONS(811),
    [sym__external_open_bracket] = ACTIONS(811),
    [sym__external_close_bracket] = ACTIONS(811),
    [sym__external_open_bracket2] = ACTIONS(811),
  },
  [520] = {
    [sym_function_definition] = STATE(491),
    [sym_if_statement] = STATE(491),
    [sym_for_statement] = STATE(491),
    [sym_while_statement] = STATE(491),
    [sym_repeat_statement] = STATE(491),
    [sym_braced_expression] = STATE(491),
    [sym_parenthesized_expression] = STATE(491),
    [sym_call] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_subset2] = STATE(491),
    [sym__argument] = STATE(1934),
    [sym_argument] = STATE(1937),
    [sym__argument_named] = STATE(1909),
    [sym__argument_unnamed] = STATE(1932),
    [sym__argument_value] = STATE(1920),
    [sym_unary_operator] = STATE(491),
    [sym_binary_operator] = STATE(491),
    [sym_extract_operator] = STATE(491),
    [sym_namespace_operator] = STATE(491),
    [sym_integer] = STATE(491),
    [sym_complex] = STATE(491),
    [sym_float] = STATE(491),
    [sym__float_literal] = STATE(734),
    [sym_string] = STATE(728),
    [sym__single_quoted_string] = STATE(735),
    [sym__double_quoted_string] = STATE(736),
    [sym_na] = STATE(491),
    [sym__expression] = STATE(491),
    [sym__string_or_identifier] = STATE(2143),
    [sym__open_parenthesis] = STATE(948),
    [sym__open_brace] = STATE(751),
    [sym__close_bracket] = STATE(782),
    [aux_sym_call_arguments_repeat1] = STATE(637),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_BSLASH] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_if] = ACTIONS(547),
    [anon_sym_for] = ACTIONS(549),
    [anon_sym_while] = ACTIONS(551),
    [anon_sym_repeat] = ACTIONS(553),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(557),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [sym__hex_literal] = ACTIONS(563),
    [sym__number_literal] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [sym_return] = ACTIONS(571),
    [sym_next] = ACTIONS(571),
    [sym_break] = ACTIONS(571),
    [sym_true] = ACTIONS(571),
    [sym_false] = ACTIONS(571),
    [sym_null] = ACTIONS(571),
    [sym_inf] = ACTIONS(571),
    [sym_nan] = ACTIONS(571),
    [anon_sym_NA] = ACTIONS(573),
    [anon_sym_NA_integer_] = ACTIONS(573),
    [anon_sym_NA_real_] = ACTIONS(573),
    [anon_sym_NA_complex_] = ACTIONS(573),
    [anon_sym_NA_character_] = ACTIONS(573),
    [sym_dots] = ACTIONS(575),
    [sym_dot_dot_i] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(579),
    [sym__newline] = ACTIONS(581),
    [sym__raw_string_literal] = ACTIONS(583),
    [sym__external_open_parenthesis] = ACTIONS(585),
    [sym__external_open_brace] = ACTIONS(587),
    [sym__external_close_bracket] = ACTIONS(933),
  },
  [521] = {
    [sym_function_definition] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_repeat_statement] = STATE(556),
    [sym_braced_expression] = STATE(556),
    [sym_parenthesized_expression] = STATE(556),
    [sym_call] = STATE(556),
    [sym_subset] = STATE(556),
    [sym_subset2] = STATE(556),
    [sym__argument] = STATE(1928),
    [sym_argument] = STATE(1930),
    [sym__argument_named] = STATE(1908),
    [sym__argument_unnamed] = STATE(1933),
    [sym__argument_value] = STATE(1936),
    [sym_unary_operator] = STATE(556),
    [sym_binary_operator] = STATE(556),
    [sym_extract_operator] = STATE(556),
    [sym_namespace_operator] = STATE(556),
    [sym_integer] = STATE(556),
    [sym_complex] = STATE(556),
    [sym_float] = STATE(556),
    [sym__float_literal] = STATE(710),
    [sym_string] = STATE(724),
    [sym__single_quoted_string] = STATE(725),
    [sym__double_quoted_string] = STATE(700),
    [sym_na] = STATE(556),
    [sym__expression] = STATE(556),
    [sym__string_or_identifier] = STATE(2142),
    [sym__open_parenthesis] = STATE(955),
    [sym__open_brace] = STATE(857),
    [sym__close_bracket2] = STATE(783),
    [aux_sym_call_arguments_repeat1] = STATE(639),
    [sym_identifier] = ACTIONS(591),
    [anon_sym_BSLASH] = ACTIONS(593),
    [anon_sym_function] = ACTIONS(595),
    [anon_sym_if] = ACTIONS(597),
    [anon_sym_for] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_repeat] = ACTIONS(603),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [sym__hex_literal] = ACTIONS(613),
    [sym__number_literal] = ACTIONS(615),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(619),
    [sym_return] = ACTIONS(621),
    [sym_next] = ACTIONS(621),
    [sym_break] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_null] = ACTIONS(621),
    [sym_inf] = ACTIONS(621),
    [sym_nan] = ACTIONS(621),
    [anon_sym_NA] = ACTIONS(623),
    [anon_sym_NA_integer_] = ACTIONS(623),
    [anon_sym_NA_real_] = ACTIONS(623),
    [anon_sym_NA_complex_] = ACTIONS(623),
    [anon_sym_NA_character_] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(629),
    [sym__newline] = ACTIONS(631),
    [sym__raw_string_literal] = ACTIONS(633),
    [sym__external_open_parenthesis] = ACTIONS(635),
    [sym__external_open_brace] = ACTIONS(637),
    [sym__external_close_bracket2] = ACTIONS(935),
  },
  [522] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_BSLASH] = ACTIONS(407),
    [anon_sym_function] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_if] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(409),
    [anon_sym_while] = ACTIONS(409),
    [anon_sym_repeat] = ACTIONS(409),
    [anon_sym_QMARK] = ACTIONS(407),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(409),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(835),
    [anon_sym_LT_LT_DASH] = ACTIONS(835),
    [anon_sym_COLON_EQ] = ACTIONS(835),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_DASH_GT_GT] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(407),
    [sym__number_literal] = ACTIONS(409),
    [anon_sym_SQUOTE] = ACTIONS(407),
    [anon_sym_DQUOTE] = ACTIONS(407),
    [sym_return] = ACTIONS(409),
    [sym_next] = ACTIONS(409),
    [sym_break] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_null] = ACTIONS(409),
    [sym_inf] = ACTIONS(409),
    [sym_nan] = ACTIONS(409),
    [anon_sym_NA] = ACTIONS(409),
    [anon_sym_NA_integer_] = ACTIONS(409),
    [anon_sym_NA_real_] = ACTIONS(409),
    [anon_sym_NA_complex_] = ACTIONS(409),
    [anon_sym_NA_character_] = ACTIONS(409),
    [sym_dots] = ACTIONS(409),
    [sym_dot_dot_i] = ACTIONS(407),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(407),
    [sym__newline] = ACTIONS(407),
    [sym__raw_string_literal] = ACTIONS(407),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(407),
    [sym__external_open_brace] = ACTIONS(407),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [523] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(367),
    [anon_sym_BSLASH] = ACTIONS(369),
    [anon_sym_function] = ACTIONS(367),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_if] = ACTIONS(367),
    [anon_sym_for] = ACTIONS(367),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_repeat] = ACTIONS(367),
    [anon_sym_QMARK] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(835),
    [anon_sym_LT_LT_DASH] = ACTIONS(835),
    [anon_sym_COLON_EQ] = ACTIONS(835),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_DASH_GT_GT] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(369),
    [sym__number_literal] = ACTIONS(367),
    [anon_sym_SQUOTE] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [sym_return] = ACTIONS(367),
    [sym_next] = ACTIONS(367),
    [sym_break] = ACTIONS(367),
    [sym_true] = ACTIONS(367),
    [sym_false] = ACTIONS(367),
    [sym_null] = ACTIONS(367),
    [sym_inf] = ACTIONS(367),
    [sym_nan] = ACTIONS(367),
    [anon_sym_NA] = ACTIONS(367),
    [anon_sym_NA_integer_] = ACTIONS(367),
    [anon_sym_NA_real_] = ACTIONS(367),
    [anon_sym_NA_complex_] = ACTIONS(367),
    [anon_sym_NA_character_] = ACTIONS(367),
    [sym_dots] = ACTIONS(367),
    [sym_dot_dot_i] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(369),
    [sym__newline] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(369),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(369),
    [sym__external_open_brace] = ACTIONS(369),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [524] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_BSLASH] = ACTIONS(411),
    [anon_sym_function] = ACTIONS(413),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_repeat] = ACTIONS(413),
    [anon_sym_QMARK] = ACTIONS(411),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(413),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(835),
    [anon_sym_LT_LT_DASH] = ACTIONS(835),
    [anon_sym_COLON_EQ] = ACTIONS(835),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_DASH_GT_GT] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(411),
    [sym__number_literal] = ACTIONS(413),
    [anon_sym_SQUOTE] = ACTIONS(411),
    [anon_sym_DQUOTE] = ACTIONS(411),
    [sym_return] = ACTIONS(413),
    [sym_next] = ACTIONS(413),
    [sym_break] = ACTIONS(413),
    [sym_true] = ACTIONS(413),
    [sym_false] = ACTIONS(413),
    [sym_null] = ACTIONS(413),
    [sym_inf] = ACTIONS(413),
    [sym_nan] = ACTIONS(413),
    [anon_sym_NA] = ACTIONS(413),
    [anon_sym_NA_integer_] = ACTIONS(413),
    [anon_sym_NA_real_] = ACTIONS(413),
    [anon_sym_NA_complex_] = ACTIONS(413),
    [anon_sym_NA_character_] = ACTIONS(413),
    [sym_dots] = ACTIONS(413),
    [sym_dot_dot_i] = ACTIONS(411),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(411),
    [sym__newline] = ACTIONS(411),
    [sym__raw_string_literal] = ACTIONS(411),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(411),
    [sym__external_open_brace] = ACTIONS(411),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [525] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(417),
    [anon_sym_BSLASH] = ACTIONS(415),
    [anon_sym_function] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_repeat] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(415),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(835),
    [anon_sym_LT_LT_DASH] = ACTIONS(835),
    [anon_sym_COLON_EQ] = ACTIONS(835),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_DASH_GT_GT] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(415),
    [sym__number_literal] = ACTIONS(417),
    [anon_sym_SQUOTE] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(415),
    [sym_return] = ACTIONS(417),
    [sym_next] = ACTIONS(417),
    [sym_break] = ACTIONS(417),
    [sym_true] = ACTIONS(417),
    [sym_false] = ACTIONS(417),
    [sym_null] = ACTIONS(417),
    [sym_inf] = ACTIONS(417),
    [sym_nan] = ACTIONS(417),
    [anon_sym_NA] = ACTIONS(417),
    [anon_sym_NA_integer_] = ACTIONS(417),
    [anon_sym_NA_real_] = ACTIONS(417),
    [anon_sym_NA_complex_] = ACTIONS(417),
    [anon_sym_NA_character_] = ACTIONS(417),
    [sym_dots] = ACTIONS(417),
    [sym_dot_dot_i] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(415),
    [sym__newline] = ACTIONS(415),
    [sym__raw_string_literal] = ACTIONS(415),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(415),
    [sym__external_open_brace] = ACTIONS(415),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [526] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(421),
    [anon_sym_BSLASH] = ACTIONS(419),
    [anon_sym_function] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_repeat] = ACTIONS(421),
    [anon_sym_QMARK] = ACTIONS(419),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(835),
    [anon_sym_LT_LT_DASH] = ACTIONS(835),
    [anon_sym_COLON_EQ] = ACTIONS(835),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_DASH_GT_GT] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(419),
    [sym__number_literal] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(419),
    [anon_sym_DQUOTE] = ACTIONS(419),
    [sym_return] = ACTIONS(421),
    [sym_next] = ACTIONS(421),
    [sym_break] = ACTIONS(421),
    [sym_true] = ACTIONS(421),
    [sym_false] = ACTIONS(421),
    [sym_null] = ACTIONS(421),
    [sym_inf] = ACTIONS(421),
    [sym_nan] = ACTIONS(421),
    [anon_sym_NA] = ACTIONS(421),
    [anon_sym_NA_integer_] = ACTIONS(421),
    [anon_sym_NA_real_] = ACTIONS(421),
    [anon_sym_NA_complex_] = ACTIONS(421),
    [anon_sym_NA_character_] = ACTIONS(421),
    [sym_dots] = ACTIONS(421),
    [sym_dot_dot_i] = ACTIONS(419),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(419),
    [sym__newline] = ACTIONS(419),
    [sym__raw_string_literal] = ACTIONS(419),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(419),
    [sym__external_open_brace] = ACTIONS(419),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [527] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(425),
    [anon_sym_BSLASH] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_repeat] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(835),
    [anon_sym_LT_LT_DASH] = ACTIONS(835),
    [anon_sym_COLON_EQ] = ACTIONS(835),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_DASH_GT_GT] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(423),
    [sym__number_literal] = ACTIONS(425),
    [anon_sym_SQUOTE] = ACTIONS(423),
    [anon_sym_DQUOTE] = ACTIONS(423),
    [sym_return] = ACTIONS(425),
    [sym_next] = ACTIONS(425),
    [sym_break] = ACTIONS(425),
    [sym_true] = ACTIONS(425),
    [sym_false] = ACTIONS(425),
    [sym_null] = ACTIONS(425),
    [sym_inf] = ACTIONS(425),
    [sym_nan] = ACTIONS(425),
    [anon_sym_NA] = ACTIONS(425),
    [anon_sym_NA_integer_] = ACTIONS(425),
    [anon_sym_NA_real_] = ACTIONS(425),
    [anon_sym_NA_complex_] = ACTIONS(425),
    [anon_sym_NA_character_] = ACTIONS(425),
    [sym_dots] = ACTIONS(425),
    [sym_dot_dot_i] = ACTIONS(423),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(423),
    [sym__newline] = ACTIONS(423),
    [sym__raw_string_literal] = ACTIONS(423),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(423),
    [sym__external_open_brace] = ACTIONS(423),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [528] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(427),
    [anon_sym_BSLASH] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_repeat] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_TILDE] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_COLON_EQ] = ACTIONS(505),
    [anon_sym_DASH_GT] = ACTIONS(507),
    [anon_sym_DASH_GT_GT] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(429),
    [sym__number_literal] = ACTIONS(427),
    [anon_sym_SQUOTE] = ACTIONS(429),
    [anon_sym_DQUOTE] = ACTIONS(429),
    [sym_return] = ACTIONS(427),
    [sym_next] = ACTIONS(427),
    [sym_break] = ACTIONS(427),
    [sym_true] = ACTIONS(427),
    [sym_false] = ACTIONS(427),
    [sym_null] = ACTIONS(427),
    [sym_inf] = ACTIONS(427),
    [sym_nan] = ACTIONS(427),
    [anon_sym_NA] = ACTIONS(427),
    [anon_sym_NA_integer_] = ACTIONS(427),
    [anon_sym_NA_real_] = ACTIONS(427),
    [anon_sym_NA_complex_] = ACTIONS(427),
    [anon_sym_NA_character_] = ACTIONS(427),
    [sym_dots] = ACTIONS(427),
    [sym_dot_dot_i] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(429),
    [sym__semicolon] = ACTIONS(429),
    [sym__raw_string_literal] = ACTIONS(429),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(429),
    [sym__external_close_brace] = ACTIONS(429),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [529] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_COLON_EQ] = ACTIONS(505),
    [anon_sym_DASH_GT] = ACTIONS(507),
    [anon_sym_DASH_GT_GT] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(433),
    [sym__semicolon] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_close_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [530] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(433),
    [anon_sym_LT_LT_DASH] = ACTIONS(433),
    [anon_sym_COLON_EQ] = ACTIONS(433),
    [anon_sym_DASH_GT] = ACTIONS(431),
    [anon_sym_DASH_GT_GT] = ACTIONS(433),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(433),
    [sym__semicolon] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_close_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [531] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(433),
    [anon_sym_LT_LT_DASH] = ACTIONS(433),
    [anon_sym_COLON_EQ] = ACTIONS(433),
    [anon_sym_DASH_GT] = ACTIONS(431),
    [anon_sym_DASH_GT_GT] = ACTIONS(433),
    [anon_sym_PIPE] = ACTIONS(431),
    [anon_sym_AMP] = ACTIONS(431),
    [anon_sym_PIPE_PIPE] = ACTIONS(433),
    [anon_sym_AMP_AMP] = ACTIONS(433),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(433),
    [sym__semicolon] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_close_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [532] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(433),
    [anon_sym_DASH] = ACTIONS(431),
    [anon_sym_LT_DASH] = ACTIONS(433),
    [anon_sym_LT_LT_DASH] = ACTIONS(433),
    [anon_sym_COLON_EQ] = ACTIONS(433),
    [anon_sym_DASH_GT] = ACTIONS(431),
    [anon_sym_DASH_GT_GT] = ACTIONS(433),
    [anon_sym_PIPE] = ACTIONS(431),
    [anon_sym_AMP] = ACTIONS(431),
    [anon_sym_PIPE_PIPE] = ACTIONS(433),
    [anon_sym_AMP_AMP] = ACTIONS(433),
    [anon_sym_LT] = ACTIONS(431),
    [anon_sym_LT_EQ] = ACTIONS(433),
    [anon_sym_GT] = ACTIONS(431),
    [anon_sym_GT_EQ] = ACTIONS(433),
    [anon_sym_EQ_EQ] = ACTIONS(433),
    [anon_sym_BANG_EQ] = ACTIONS(433),
    [anon_sym_STAR] = ACTIONS(431),
    [anon_sym_SLASH] = ACTIONS(433),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(433),
    [anon_sym_PIPE_GT] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(431),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(433),
    [sym__semicolon] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_close_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [533] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(435),
    [anon_sym_BSLASH] = ACTIONS(437),
    [anon_sym_function] = ACTIONS(435),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(435),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_repeat] = ACTIONS(435),
    [anon_sym_QMARK] = ACTIONS(437),
    [anon_sym_TILDE] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(435),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_COLON_EQ] = ACTIONS(505),
    [anon_sym_DASH_GT] = ACTIONS(507),
    [anon_sym_DASH_GT_GT] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(437),
    [sym__number_literal] = ACTIONS(435),
    [anon_sym_SQUOTE] = ACTIONS(437),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [sym_return] = ACTIONS(435),
    [sym_next] = ACTIONS(435),
    [sym_break] = ACTIONS(435),
    [sym_true] = ACTIONS(435),
    [sym_false] = ACTIONS(435),
    [sym_null] = ACTIONS(435),
    [sym_inf] = ACTIONS(435),
    [sym_nan] = ACTIONS(435),
    [anon_sym_NA] = ACTIONS(435),
    [anon_sym_NA_integer_] = ACTIONS(435),
    [anon_sym_NA_real_] = ACTIONS(435),
    [anon_sym_NA_complex_] = ACTIONS(435),
    [anon_sym_NA_character_] = ACTIONS(435),
    [sym_dots] = ACTIONS(435),
    [sym_dot_dot_i] = ACTIONS(437),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(437),
    [sym__semicolon] = ACTIONS(437),
    [sym__raw_string_literal] = ACTIONS(437),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(437),
    [sym__external_close_brace] = ACTIONS(437),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [534] = {
    [sym_string] = STATE(822),
    [sym__single_quoted_string] = STATE(672),
    [sym__double_quoted_string] = STATE(697),
    [sym__string_or_identifier] = STATE(822),
    [aux_sym_function_definition_repeat1] = STATE(552),
    [sym_identifier] = ACTIONS(937),
    [anon_sym_BSLASH] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(795),
    [anon_sym_EQ] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(795),
    [anon_sym_for] = ACTIONS(795),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_repeat] = ACTIONS(795),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(795),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LT_DASH] = ACTIONS(791),
    [anon_sym_LT_LT_DASH] = ACTIONS(791),
    [anon_sym_COLON_EQ] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_DASH_GT_GT] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(795),
    [anon_sym_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [anon_sym_LT] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_GT] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(791),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_BANG_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(795),
    [anon_sym_SLASH] = ACTIONS(791),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [aux_sym_binary_operator_token1] = ACTIONS(791),
    [anon_sym_PIPE_GT] = ACTIONS(791),
    [anon_sym_COLON] = ACTIONS(795),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [anon_sym_AT] = ACTIONS(791),
    [sym__hex_literal] = ACTIONS(791),
    [sym__number_literal] = ACTIONS(795),
    [anon_sym_SQUOTE] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [sym_return] = ACTIONS(795),
    [sym_next] = ACTIONS(795),
    [sym_break] = ACTIONS(795),
    [sym_true] = ACTIONS(795),
    [sym_false] = ACTIONS(795),
    [sym_null] = ACTIONS(795),
    [sym_inf] = ACTIONS(795),
    [sym_nan] = ACTIONS(795),
    [anon_sym_NA] = ACTIONS(795),
    [anon_sym_NA_integer_] = ACTIONS(795),
    [anon_sym_NA_real_] = ACTIONS(795),
    [anon_sym_NA_complex_] = ACTIONS(795),
    [anon_sym_NA_character_] = ACTIONS(795),
    [sym_dots] = ACTIONS(795),
    [sym_dot_dot_i] = ACTIONS(791),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(791),
    [sym__newline] = ACTIONS(943),
    [sym__raw_string_literal] = ACTIONS(945),
    [sym__external_else] = ACTIONS(791),
    [sym__external_open_parenthesis] = ACTIONS(791),
    [sym__external_open_brace] = ACTIONS(791),
    [sym__external_open_bracket] = ACTIONS(791),
    [sym__external_open_bracket2] = ACTIONS(791),
    [sym__external_close_bracket2] = ACTIONS(791),
  },
  [535] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(439),
    [anon_sym_BSLASH] = ACTIONS(441),
    [anon_sym_function] = ACTIONS(439),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(439),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(439),
    [anon_sym_repeat] = ACTIONS(439),
    [anon_sym_QMARK] = ACTIONS(441),
    [anon_sym_TILDE] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(439),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_COLON_EQ] = ACTIONS(505),
    [anon_sym_DASH_GT] = ACTIONS(507),
    [anon_sym_DASH_GT_GT] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(441),
    [sym__number_literal] = ACTIONS(439),
    [anon_sym_SQUOTE] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(441),
    [sym_return] = ACTIONS(439),
    [sym_next] = ACTIONS(439),
    [sym_break] = ACTIONS(439),
    [sym_true] = ACTIONS(439),
    [sym_false] = ACTIONS(439),
    [sym_null] = ACTIONS(439),
    [sym_inf] = ACTIONS(439),
    [sym_nan] = ACTIONS(439),
    [anon_sym_NA] = ACTIONS(439),
    [anon_sym_NA_integer_] = ACTIONS(439),
    [anon_sym_NA_real_] = ACTIONS(439),
    [anon_sym_NA_complex_] = ACTIONS(439),
    [anon_sym_NA_character_] = ACTIONS(439),
    [sym_dots] = ACTIONS(439),
    [sym_dot_dot_i] = ACTIONS(441),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(441),
    [sym__semicolon] = ACTIONS(441),
    [sym__raw_string_literal] = ACTIONS(441),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(441),
    [sym__external_close_brace] = ACTIONS(441),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [536] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_COLON_EQ] = ACTIONS(505),
    [anon_sym_DASH_GT] = ACTIONS(507),
    [anon_sym_DASH_GT_GT] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(445),
    [sym__semicolon] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_close_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [537] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(445),
    [anon_sym_LT_LT_DASH] = ACTIONS(445),
    [anon_sym_COLON_EQ] = ACTIONS(445),
    [anon_sym_DASH_GT] = ACTIONS(443),
    [anon_sym_DASH_GT_GT] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(445),
    [sym__semicolon] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_close_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [538] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(445),
    [anon_sym_LT_LT_DASH] = ACTIONS(445),
    [anon_sym_COLON_EQ] = ACTIONS(445),
    [anon_sym_DASH_GT] = ACTIONS(443),
    [anon_sym_DASH_GT_GT] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(443),
    [anon_sym_AMP] = ACTIONS(443),
    [anon_sym_PIPE_PIPE] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(445),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(445),
    [sym__semicolon] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_close_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [539] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(443),
    [anon_sym_BSLASH] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_EQ] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_repeat] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(443),
    [anon_sym_LT_DASH] = ACTIONS(445),
    [anon_sym_LT_LT_DASH] = ACTIONS(445),
    [anon_sym_COLON_EQ] = ACTIONS(445),
    [anon_sym_DASH_GT] = ACTIONS(443),
    [anon_sym_DASH_GT_GT] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(443),
    [anon_sym_AMP] = ACTIONS(443),
    [anon_sym_PIPE_PIPE] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(445),
    [anon_sym_LT] = ACTIONS(443),
    [anon_sym_LT_EQ] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(443),
    [anon_sym_GT_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(445),
    [anon_sym_PIPE_GT] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(443),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(445),
    [sym__number_literal] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [sym_return] = ACTIONS(443),
    [sym_next] = ACTIONS(443),
    [sym_break] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_null] = ACTIONS(443),
    [sym_inf] = ACTIONS(443),
    [sym_nan] = ACTIONS(443),
    [anon_sym_NA] = ACTIONS(443),
    [anon_sym_NA_integer_] = ACTIONS(443),
    [anon_sym_NA_real_] = ACTIONS(443),
    [anon_sym_NA_complex_] = ACTIONS(443),
    [anon_sym_NA_character_] = ACTIONS(443),
    [sym_dots] = ACTIONS(443),
    [sym_dot_dot_i] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(445),
    [sym__semicolon] = ACTIONS(445),
    [sym__raw_string_literal] = ACTIONS(445),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(445),
    [sym__external_close_brace] = ACTIONS(445),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [540] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(507),
    [anon_sym_DASH_GT_GT] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_close_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [541] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_COLON_EQ] = ACTIONS(505),
    [anon_sym_DASH_GT] = ACTIONS(507),
    [anon_sym_DASH_GT_GT] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_close_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [542] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_close_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [543] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_close_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [544] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_COLON_EQ] = ACTIONS(505),
    [anon_sym_DASH_GT] = ACTIONS(507),
    [anon_sym_DASH_GT_GT] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_close_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [545] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_close_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [546] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_close_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [547] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_close_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [548] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_close_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [549] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_close_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [550] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(371),
    [anon_sym_PIPE_GT] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(373),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_close_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [551] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(371),
    [anon_sym_PIPE_GT] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_close_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [552] = {
    [sym_string] = STATE(829),
    [sym__single_quoted_string] = STATE(672),
    [sym__double_quoted_string] = STATE(697),
    [sym__string_or_identifier] = STATE(829),
    [aux_sym_function_definition_repeat1] = STATE(732),
    [sym_identifier] = ACTIONS(947),
    [anon_sym_BSLASH] = ACTIONS(811),
    [anon_sym_function] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(815),
    [anon_sym_if] = ACTIONS(815),
    [anon_sym_for] = ACTIONS(815),
    [anon_sym_while] = ACTIONS(815),
    [anon_sym_repeat] = ACTIONS(815),
    [anon_sym_QMARK] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(811),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_LT_DASH] = ACTIONS(811),
    [anon_sym_LT_LT_DASH] = ACTIONS(811),
    [anon_sym_COLON_EQ] = ACTIONS(811),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_DASH_GT_GT] = ACTIONS(811),
    [anon_sym_PIPE] = ACTIONS(815),
    [anon_sym_AMP] = ACTIONS(815),
    [anon_sym_PIPE_PIPE] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(811),
    [anon_sym_GT] = ACTIONS(815),
    [anon_sym_GT_EQ] = ACTIONS(811),
    [anon_sym_EQ_EQ] = ACTIONS(811),
    [anon_sym_BANG_EQ] = ACTIONS(811),
    [anon_sym_STAR] = ACTIONS(815),
    [anon_sym_SLASH] = ACTIONS(811),
    [anon_sym_STAR_STAR] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(811),
    [aux_sym_binary_operator_token1] = ACTIONS(811),
    [anon_sym_PIPE_GT] = ACTIONS(811),
    [anon_sym_COLON] = ACTIONS(815),
    [anon_sym_DOLLAR] = ACTIONS(811),
    [anon_sym_AT] = ACTIONS(811),
    [sym__hex_literal] = ACTIONS(811),
    [sym__number_literal] = ACTIONS(815),
    [anon_sym_SQUOTE] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [sym_return] = ACTIONS(815),
    [sym_next] = ACTIONS(815),
    [sym_break] = ACTIONS(815),
    [sym_true] = ACTIONS(815),
    [sym_false] = ACTIONS(815),
    [sym_null] = ACTIONS(815),
    [sym_inf] = ACTIONS(815),
    [sym_nan] = ACTIONS(815),
    [anon_sym_NA] = ACTIONS(815),
    [anon_sym_NA_integer_] = ACTIONS(815),
    [anon_sym_NA_real_] = ACTIONS(815),
    [anon_sym_NA_complex_] = ACTIONS(815),
    [anon_sym_NA_character_] = ACTIONS(815),
    [sym_dots] = ACTIONS(815),
    [sym_dot_dot_i] = ACTIONS(811),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(811),
    [sym__newline] = ACTIONS(811),
    [sym__raw_string_literal] = ACTIONS(945),
    [sym__external_else] = ACTIONS(811),
    [sym__external_open_parenthesis] = ACTIONS(811),
    [sym__external_open_brace] = ACTIONS(811),
    [sym__external_open_bracket] = ACTIONS(811),
    [sym__external_open_bracket2] = ACTIONS(811),
    [sym__external_close_bracket2] = ACTIONS(811),
  },
  [553] = {
    [sym_function_definition] = STATE(491),
    [sym_if_statement] = STATE(491),
    [sym_for_statement] = STATE(491),
    [sym_while_statement] = STATE(491),
    [sym_repeat_statement] = STATE(491),
    [sym_braced_expression] = STATE(491),
    [sym_parenthesized_expression] = STATE(491),
    [sym_call] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_subset2] = STATE(491),
    [sym__argument] = STATE(1934),
    [sym_argument] = STATE(1937),
    [sym__argument_named] = STATE(1909),
    [sym__argument_unnamed] = STATE(1932),
    [sym__argument_value] = STATE(1920),
    [sym_unary_operator] = STATE(491),
    [sym_binary_operator] = STATE(491),
    [sym_extract_operator] = STATE(491),
    [sym_namespace_operator] = STATE(491),
    [sym_integer] = STATE(491),
    [sym_complex] = STATE(491),
    [sym_float] = STATE(491),
    [sym__float_literal] = STATE(734),
    [sym_string] = STATE(728),
    [sym__single_quoted_string] = STATE(735),
    [sym__double_quoted_string] = STATE(736),
    [sym_na] = STATE(491),
    [sym__expression] = STATE(491),
    [sym__string_or_identifier] = STATE(2143),
    [sym__open_parenthesis] = STATE(948),
    [sym__open_brace] = STATE(751),
    [sym__close_bracket] = STATE(831),
    [aux_sym_call_arguments_repeat1] = STATE(637),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_BSLASH] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_if] = ACTIONS(547),
    [anon_sym_for] = ACTIONS(549),
    [anon_sym_while] = ACTIONS(551),
    [anon_sym_repeat] = ACTIONS(553),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(557),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [sym__hex_literal] = ACTIONS(563),
    [sym__number_literal] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [sym_return] = ACTIONS(571),
    [sym_next] = ACTIONS(571),
    [sym_break] = ACTIONS(571),
    [sym_true] = ACTIONS(571),
    [sym_false] = ACTIONS(571),
    [sym_null] = ACTIONS(571),
    [sym_inf] = ACTIONS(571),
    [sym_nan] = ACTIONS(571),
    [anon_sym_NA] = ACTIONS(573),
    [anon_sym_NA_integer_] = ACTIONS(573),
    [anon_sym_NA_real_] = ACTIONS(573),
    [anon_sym_NA_complex_] = ACTIONS(573),
    [anon_sym_NA_character_] = ACTIONS(573),
    [sym_dots] = ACTIONS(575),
    [sym_dot_dot_i] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(579),
    [sym__newline] = ACTIONS(581),
    [sym__raw_string_literal] = ACTIONS(583),
    [sym__external_open_parenthesis] = ACTIONS(585),
    [sym__external_open_brace] = ACTIONS(587),
    [sym__external_close_bracket] = ACTIONS(949),
  },
  [554] = {
    [sym_function_definition] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_repeat_statement] = STATE(556),
    [sym_braced_expression] = STATE(556),
    [sym_parenthesized_expression] = STATE(556),
    [sym_call] = STATE(556),
    [sym_subset] = STATE(556),
    [sym_subset2] = STATE(556),
    [sym__argument] = STATE(1928),
    [sym_argument] = STATE(1930),
    [sym__argument_named] = STATE(1908),
    [sym__argument_unnamed] = STATE(1933),
    [sym__argument_value] = STATE(1936),
    [sym_unary_operator] = STATE(556),
    [sym_binary_operator] = STATE(556),
    [sym_extract_operator] = STATE(556),
    [sym_namespace_operator] = STATE(556),
    [sym_integer] = STATE(556),
    [sym_complex] = STATE(556),
    [sym_float] = STATE(556),
    [sym__float_literal] = STATE(710),
    [sym_string] = STATE(724),
    [sym__single_quoted_string] = STATE(725),
    [sym__double_quoted_string] = STATE(700),
    [sym_na] = STATE(556),
    [sym__expression] = STATE(556),
    [sym__string_or_identifier] = STATE(2142),
    [sym__open_parenthesis] = STATE(955),
    [sym__open_brace] = STATE(857),
    [sym__close_bracket2] = STATE(832),
    [aux_sym_call_arguments_repeat1] = STATE(639),
    [sym_identifier] = ACTIONS(591),
    [anon_sym_BSLASH] = ACTIONS(593),
    [anon_sym_function] = ACTIONS(595),
    [anon_sym_if] = ACTIONS(597),
    [anon_sym_for] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_repeat] = ACTIONS(603),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [sym__hex_literal] = ACTIONS(613),
    [sym__number_literal] = ACTIONS(615),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(619),
    [sym_return] = ACTIONS(621),
    [sym_next] = ACTIONS(621),
    [sym_break] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_null] = ACTIONS(621),
    [sym_inf] = ACTIONS(621),
    [sym_nan] = ACTIONS(621),
    [anon_sym_NA] = ACTIONS(623),
    [anon_sym_NA_integer_] = ACTIONS(623),
    [anon_sym_NA_real_] = ACTIONS(623),
    [anon_sym_NA_complex_] = ACTIONS(623),
    [anon_sym_NA_character_] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(629),
    [sym__newline] = ACTIONS(631),
    [sym__raw_string_literal] = ACTIONS(633),
    [sym__external_open_parenthesis] = ACTIONS(635),
    [sym__external_open_brace] = ACTIONS(637),
    [sym__external_close_bracket2] = ACTIONS(951),
  },
  [555] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(373),
    [anon_sym_BSLASH] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(373),
    [anon_sym_EQ] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_repeat] = ACTIONS(373),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_LT_DASH] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_COLON_EQ] = ACTIONS(371),
    [anon_sym_DASH_GT] = ACTIONS(373),
    [anon_sym_DASH_GT_GT] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(373),
    [anon_sym_AMP] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_LT_EQ] = ACTIONS(371),
    [anon_sym_GT] = ACTIONS(373),
    [anon_sym_GT_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(373),
    [anon_sym_SLASH] = ACTIONS(371),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(371),
    [anon_sym_PIPE_GT] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(373),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(371),
    [sym__number_literal] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [sym_return] = ACTIONS(373),
    [sym_next] = ACTIONS(373),
    [sym_break] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_null] = ACTIONS(373),
    [sym_inf] = ACTIONS(373),
    [sym_nan] = ACTIONS(373),
    [anon_sym_NA] = ACTIONS(373),
    [anon_sym_NA_integer_] = ACTIONS(373),
    [anon_sym_NA_real_] = ACTIONS(373),
    [anon_sym_NA_complex_] = ACTIONS(373),
    [anon_sym_NA_character_] = ACTIONS(373),
    [sym_dots] = ACTIONS(373),
    [sym_dot_dot_i] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(371),
    [sym__raw_string_literal] = ACTIONS(371),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(371),
    [sym__external_close_brace] = ACTIONS(371),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [556] = {
    [sym_call_arguments] = STATE(952),
    [sym_subset_arguments] = STATE(901),
    [sym_subset2_arguments] = STATE(906),
    [sym__open_parenthesis] = STATE(601),
    [sym__open_bracket] = STATE(602),
    [sym__open_bracket2] = STATE(603),
    [sym_identifier] = ACTIONS(821),
    [anon_sym_BSLASH] = ACTIONS(823),
    [anon_sym_function] = ACTIONS(821),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(821),
    [anon_sym_for] = ACTIONS(821),
    [anon_sym_while] = ACTIONS(821),
    [anon_sym_repeat] = ACTIONS(821),
    [anon_sym_QMARK] = ACTIONS(953),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(821),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_LT_DASH] = ACTIONS(697),
    [anon_sym_LT_LT_DASH] = ACTIONS(697),
    [anon_sym_COLON_EQ] = ACTIONS(697),
    [anon_sym_DASH_GT] = ACTIONS(699),
    [anon_sym_DASH_GT_GT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(703),
    [anon_sym_AMP] = ACTIONS(705),
    [anon_sym_PIPE_PIPE] = ACTIONS(707),
    [anon_sym_AMP_AMP] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(717),
    [anon_sym_STAR_STAR] = ACTIONS(719),
    [anon_sym_CARET] = ACTIONS(719),
    [aux_sym_binary_operator_token1] = ACTIONS(721),
    [anon_sym_PIPE_GT] = ACTIONS(721),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [sym__hex_literal] = ACTIONS(823),
    [sym__number_literal] = ACTIONS(821),
    [anon_sym_SQUOTE] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(823),
    [sym_return] = ACTIONS(821),
    [sym_next] = ACTIONS(821),
    [sym_break] = ACTIONS(821),
    [sym_true] = ACTIONS(821),
    [sym_false] = ACTIONS(821),
    [sym_null] = ACTIONS(821),
    [sym_inf] = ACTIONS(821),
    [sym_nan] = ACTIONS(821),
    [anon_sym_NA] = ACTIONS(821),
    [anon_sym_NA_integer_] = ACTIONS(821),
    [anon_sym_NA_real_] = ACTIONS(821),
    [anon_sym_NA_complex_] = ACTIONS(821),
    [anon_sym_NA_character_] = ACTIONS(821),
    [sym_dots] = ACTIONS(821),
    [sym_dot_dot_i] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(823),
    [sym__newline] = ACTIONS(823),
    [sym__raw_string_literal] = ACTIONS(823),
    [sym__external_open_parenthesis] = ACTIONS(727),
    [sym__external_open_brace] = ACTIONS(823),
    [sym__external_open_bracket] = ACTIONS(729),
    [sym__external_open_bracket2] = ACTIONS(731),
    [sym__external_close_bracket2] = ACTIONS(823),
  },
  [557] = {
    [sym_function_definition] = STATE(491),
    [sym_if_statement] = STATE(491),
    [sym_for_statement] = STATE(491),
    [sym_while_statement] = STATE(491),
    [sym_repeat_statement] = STATE(491),
    [sym_braced_expression] = STATE(491),
    [sym_parenthesized_expression] = STATE(491),
    [sym_call] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_subset2] = STATE(491),
    [sym__argument] = STATE(1934),
    [sym_argument] = STATE(1937),
    [sym__argument_named] = STATE(1909),
    [sym__argument_unnamed] = STATE(1932),
    [sym__argument_value] = STATE(1920),
    [sym_unary_operator] = STATE(491),
    [sym_binary_operator] = STATE(491),
    [sym_extract_operator] = STATE(491),
    [sym_namespace_operator] = STATE(491),
    [sym_integer] = STATE(491),
    [sym_complex] = STATE(491),
    [sym_float] = STATE(491),
    [sym__float_literal] = STATE(734),
    [sym_string] = STATE(728),
    [sym__single_quoted_string] = STATE(735),
    [sym__double_quoted_string] = STATE(736),
    [sym_na] = STATE(491),
    [sym__expression] = STATE(491),
    [sym__string_or_identifier] = STATE(2143),
    [sym__open_parenthesis] = STATE(948),
    [sym__open_brace] = STATE(751),
    [sym__close_bracket] = STATE(920),
    [aux_sym_call_arguments_repeat1] = STATE(637),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_BSLASH] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_if] = ACTIONS(547),
    [anon_sym_for] = ACTIONS(549),
    [anon_sym_while] = ACTIONS(551),
    [anon_sym_repeat] = ACTIONS(553),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(557),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [sym__hex_literal] = ACTIONS(563),
    [sym__number_literal] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [sym_return] = ACTIONS(571),
    [sym_next] = ACTIONS(571),
    [sym_break] = ACTIONS(571),
    [sym_true] = ACTIONS(571),
    [sym_false] = ACTIONS(571),
    [sym_null] = ACTIONS(571),
    [sym_inf] = ACTIONS(571),
    [sym_nan] = ACTIONS(571),
    [anon_sym_NA] = ACTIONS(573),
    [anon_sym_NA_integer_] = ACTIONS(573),
    [anon_sym_NA_real_] = ACTIONS(573),
    [anon_sym_NA_complex_] = ACTIONS(573),
    [anon_sym_NA_character_] = ACTIONS(573),
    [sym_dots] = ACTIONS(575),
    [sym_dot_dot_i] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(579),
    [sym__newline] = ACTIONS(581),
    [sym__raw_string_literal] = ACTIONS(583),
    [sym__external_open_parenthesis] = ACTIONS(585),
    [sym__external_open_brace] = ACTIONS(587),
    [sym__external_close_bracket] = ACTIONS(955),
  },
  [558] = {
    [sym_function_definition] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_repeat_statement] = STATE(556),
    [sym_braced_expression] = STATE(556),
    [sym_parenthesized_expression] = STATE(556),
    [sym_call] = STATE(556),
    [sym_subset] = STATE(556),
    [sym_subset2] = STATE(556),
    [sym__argument] = STATE(1928),
    [sym_argument] = STATE(1930),
    [sym__argument_named] = STATE(1908),
    [sym__argument_unnamed] = STATE(1933),
    [sym__argument_value] = STATE(1936),
    [sym_unary_operator] = STATE(556),
    [sym_binary_operator] = STATE(556),
    [sym_extract_operator] = STATE(556),
    [sym_namespace_operator] = STATE(556),
    [sym_integer] = STATE(556),
    [sym_complex] = STATE(556),
    [sym_float] = STATE(556),
    [sym__float_literal] = STATE(710),
    [sym_string] = STATE(724),
    [sym__single_quoted_string] = STATE(725),
    [sym__double_quoted_string] = STATE(700),
    [sym_na] = STATE(556),
    [sym__expression] = STATE(556),
    [sym__string_or_identifier] = STATE(2142),
    [sym__open_parenthesis] = STATE(955),
    [sym__open_brace] = STATE(857),
    [sym__close_bracket2] = STATE(921),
    [aux_sym_call_arguments_repeat1] = STATE(639),
    [sym_identifier] = ACTIONS(591),
    [anon_sym_BSLASH] = ACTIONS(593),
    [anon_sym_function] = ACTIONS(595),
    [anon_sym_if] = ACTIONS(597),
    [anon_sym_for] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_repeat] = ACTIONS(603),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [sym__hex_literal] = ACTIONS(613),
    [sym__number_literal] = ACTIONS(615),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(619),
    [sym_return] = ACTIONS(621),
    [sym_next] = ACTIONS(621),
    [sym_break] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_null] = ACTIONS(621),
    [sym_inf] = ACTIONS(621),
    [sym_nan] = ACTIONS(621),
    [anon_sym_NA] = ACTIONS(623),
    [anon_sym_NA_integer_] = ACTIONS(623),
    [anon_sym_NA_real_] = ACTIONS(623),
    [anon_sym_NA_complex_] = ACTIONS(623),
    [anon_sym_NA_character_] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(629),
    [sym__newline] = ACTIONS(631),
    [sym__raw_string_literal] = ACTIONS(633),
    [sym__external_open_parenthesis] = ACTIONS(635),
    [sym__external_open_brace] = ACTIONS(637),
    [sym__external_close_bracket2] = ACTIONS(957),
  },
  [559] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(375),
    [anon_sym_function] = ACTIONS(377),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_repeat] = ACTIONS(377),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_TILDE] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_COLON_EQ] = ACTIONS(505),
    [anon_sym_DASH_GT] = ACTIONS(507),
    [anon_sym_DASH_GT_GT] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(375),
    [sym__number_literal] = ACTIONS(377),
    [anon_sym_SQUOTE] = ACTIONS(375),
    [anon_sym_DQUOTE] = ACTIONS(375),
    [sym_return] = ACTIONS(377),
    [sym_next] = ACTIONS(377),
    [sym_break] = ACTIONS(377),
    [sym_true] = ACTIONS(377),
    [sym_false] = ACTIONS(377),
    [sym_null] = ACTIONS(377),
    [sym_inf] = ACTIONS(377),
    [sym_nan] = ACTIONS(377),
    [anon_sym_NA] = ACTIONS(377),
    [anon_sym_NA_integer_] = ACTIONS(377),
    [anon_sym_NA_real_] = ACTIONS(377),
    [anon_sym_NA_complex_] = ACTIONS(377),
    [anon_sym_NA_character_] = ACTIONS(377),
    [sym_dots] = ACTIONS(377),
    [sym_dot_dot_i] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(375),
    [sym__semicolon] = ACTIONS(375),
    [sym__raw_string_literal] = ACTIONS(375),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(375),
    [sym__external_close_brace] = ACTIONS(375),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [560] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(507),
    [anon_sym_DASH_GT_GT] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_close_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [561] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_COLON_EQ] = ACTIONS(505),
    [anon_sym_DASH_GT] = ACTIONS(507),
    [anon_sym_DASH_GT_GT] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_close_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [562] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_close_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [563] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_close_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [564] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_COLON_EQ] = ACTIONS(505),
    [anon_sym_DASH_GT] = ACTIONS(507),
    [anon_sym_DASH_GT_GT] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_close_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [565] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_close_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [566] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_close_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [567] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_close_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [568] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_close_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [569] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_close_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [570] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(379),
    [anon_sym_PIPE_GT] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(381),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_close_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [571] = {
    [sym_function_definition] = STATE(429),
    [sym_if_statement] = STATE(429),
    [sym_for_statement] = STATE(429),
    [sym_while_statement] = STATE(429),
    [sym_repeat_statement] = STATE(429),
    [sym_braced_expression] = STATE(429),
    [sym_parenthesized_expression] = STATE(429),
    [sym_call] = STATE(429),
    [sym_subset] = STATE(429),
    [sym_subset2] = STATE(429),
    [sym__argument] = STATE(1912),
    [sym_argument] = STATE(1916),
    [sym__argument_named] = STATE(1919),
    [sym__argument_unnamed] = STATE(1921),
    [sym__argument_value] = STATE(1927),
    [sym_unary_operator] = STATE(429),
    [sym_binary_operator] = STATE(429),
    [sym_extract_operator] = STATE(429),
    [sym_namespace_operator] = STATE(429),
    [sym_integer] = STATE(429),
    [sym_complex] = STATE(429),
    [sym_float] = STATE(429),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(721),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(429),
    [sym__expression] = STATE(429),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(925),
    [sym__open_brace] = STATE(842),
    [aux_sym_call_arguments_repeat1] = STATE(492),
    [sym_identifier] = ACTIONS(737),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(767),
    [sym_next] = ACTIONS(767),
    [sym_break] = ACTIONS(767),
    [sym_true] = ACTIONS(767),
    [sym_false] = ACTIONS(767),
    [sym_null] = ACTIONS(767),
    [sym_inf] = ACTIONS(767),
    [sym_nan] = ACTIONS(767),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(771),
    [sym_dot_dot_i] = ACTIONS(773),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(775),
    [sym__newline] = ACTIONS(777),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(959),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [572] = {
    [sym_function_definition] = STATE(491),
    [sym_if_statement] = STATE(491),
    [sym_for_statement] = STATE(491),
    [sym_while_statement] = STATE(491),
    [sym_repeat_statement] = STATE(491),
    [sym_braced_expression] = STATE(491),
    [sym_parenthesized_expression] = STATE(491),
    [sym_call] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_subset2] = STATE(491),
    [sym__argument] = STATE(1934),
    [sym_argument] = STATE(1937),
    [sym__argument_named] = STATE(1909),
    [sym__argument_unnamed] = STATE(1932),
    [sym__argument_value] = STATE(1920),
    [sym_unary_operator] = STATE(491),
    [sym_binary_operator] = STATE(491),
    [sym_extract_operator] = STATE(491),
    [sym_namespace_operator] = STATE(491),
    [sym_integer] = STATE(491),
    [sym_complex] = STATE(491),
    [sym_float] = STATE(491),
    [sym__float_literal] = STATE(734),
    [sym_string] = STATE(728),
    [sym__single_quoted_string] = STATE(735),
    [sym__double_quoted_string] = STATE(736),
    [sym_na] = STATE(491),
    [sym__expression] = STATE(491),
    [sym__string_or_identifier] = STATE(2143),
    [sym__open_parenthesis] = STATE(948),
    [sym__open_brace] = STATE(751),
    [sym__close_bracket] = STATE(928),
    [aux_sym_call_arguments_repeat1] = STATE(493),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_BSLASH] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_if] = ACTIONS(547),
    [anon_sym_for] = ACTIONS(549),
    [anon_sym_while] = ACTIONS(551),
    [anon_sym_repeat] = ACTIONS(553),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(557),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [sym__hex_literal] = ACTIONS(563),
    [sym__number_literal] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [sym_return] = ACTIONS(571),
    [sym_next] = ACTIONS(571),
    [sym_break] = ACTIONS(571),
    [sym_true] = ACTIONS(571),
    [sym_false] = ACTIONS(571),
    [sym_null] = ACTIONS(571),
    [sym_inf] = ACTIONS(571),
    [sym_nan] = ACTIONS(571),
    [anon_sym_NA] = ACTIONS(573),
    [anon_sym_NA_integer_] = ACTIONS(573),
    [anon_sym_NA_real_] = ACTIONS(573),
    [anon_sym_NA_complex_] = ACTIONS(573),
    [anon_sym_NA_character_] = ACTIONS(573),
    [sym_dots] = ACTIONS(575),
    [sym_dot_dot_i] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(579),
    [sym__newline] = ACTIONS(581),
    [sym__raw_string_literal] = ACTIONS(583),
    [sym__external_open_parenthesis] = ACTIONS(585),
    [sym__external_open_brace] = ACTIONS(587),
    [sym__external_close_bracket] = ACTIONS(961),
  },
  [573] = {
    [sym_function_definition] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_repeat_statement] = STATE(556),
    [sym_braced_expression] = STATE(556),
    [sym_parenthesized_expression] = STATE(556),
    [sym_call] = STATE(556),
    [sym_subset] = STATE(556),
    [sym_subset2] = STATE(556),
    [sym__argument] = STATE(1928),
    [sym_argument] = STATE(1930),
    [sym__argument_named] = STATE(1908),
    [sym__argument_unnamed] = STATE(1933),
    [sym__argument_value] = STATE(1936),
    [sym_unary_operator] = STATE(556),
    [sym_binary_operator] = STATE(556),
    [sym_extract_operator] = STATE(556),
    [sym_namespace_operator] = STATE(556),
    [sym_integer] = STATE(556),
    [sym_complex] = STATE(556),
    [sym_float] = STATE(556),
    [sym__float_literal] = STATE(710),
    [sym_string] = STATE(724),
    [sym__single_quoted_string] = STATE(725),
    [sym__double_quoted_string] = STATE(700),
    [sym_na] = STATE(556),
    [sym__expression] = STATE(556),
    [sym__string_or_identifier] = STATE(2142),
    [sym__open_parenthesis] = STATE(955),
    [sym__open_brace] = STATE(857),
    [sym__close_bracket2] = STATE(944),
    [aux_sym_call_arguments_repeat1] = STATE(494),
    [sym_identifier] = ACTIONS(591),
    [anon_sym_BSLASH] = ACTIONS(593),
    [anon_sym_function] = ACTIONS(595),
    [anon_sym_if] = ACTIONS(597),
    [anon_sym_for] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_repeat] = ACTIONS(603),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [sym__hex_literal] = ACTIONS(613),
    [sym__number_literal] = ACTIONS(615),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(619),
    [sym_return] = ACTIONS(621),
    [sym_next] = ACTIONS(621),
    [sym_break] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_null] = ACTIONS(621),
    [sym_inf] = ACTIONS(621),
    [sym_nan] = ACTIONS(621),
    [anon_sym_NA] = ACTIONS(623),
    [anon_sym_NA_integer_] = ACTIONS(623),
    [anon_sym_NA_real_] = ACTIONS(623),
    [anon_sym_NA_complex_] = ACTIONS(623),
    [anon_sym_NA_character_] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(629),
    [sym__newline] = ACTIONS(631),
    [sym__raw_string_literal] = ACTIONS(633),
    [sym__external_open_parenthesis] = ACTIONS(635),
    [sym__external_open_brace] = ACTIONS(637),
    [sym__external_close_bracket2] = ACTIONS(963),
  },
  [574] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(379),
    [anon_sym_PIPE_GT] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_close_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [575] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_BSLASH] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(381),
    [anon_sym_EQ] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_repeat] = ACTIONS(381),
    [anon_sym_QMARK] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_LT_DASH] = ACTIONS(379),
    [anon_sym_LT_LT_DASH] = ACTIONS(379),
    [anon_sym_COLON_EQ] = ACTIONS(379),
    [anon_sym_DASH_GT] = ACTIONS(381),
    [anon_sym_DASH_GT_GT] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
    [anon_sym_PIPE_PIPE] = ACTIONS(379),
    [anon_sym_AMP_AMP] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_LT_EQ] = ACTIONS(379),
    [anon_sym_GT] = ACTIONS(381),
    [anon_sym_GT_EQ] = ACTIONS(379),
    [anon_sym_EQ_EQ] = ACTIONS(379),
    [anon_sym_BANG_EQ] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(381),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(379),
    [anon_sym_PIPE_GT] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(381),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(379),
    [sym__number_literal] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(379),
    [sym_return] = ACTIONS(381),
    [sym_next] = ACTIONS(381),
    [sym_break] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_null] = ACTIONS(381),
    [sym_inf] = ACTIONS(381),
    [sym_nan] = ACTIONS(381),
    [anon_sym_NA] = ACTIONS(381),
    [anon_sym_NA_integer_] = ACTIONS(381),
    [anon_sym_NA_real_] = ACTIONS(381),
    [anon_sym_NA_complex_] = ACTIONS(381),
    [anon_sym_NA_character_] = ACTIONS(381),
    [sym_dots] = ACTIONS(381),
    [sym_dot_dot_i] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__semicolon] = ACTIONS(379),
    [sym__raw_string_literal] = ACTIONS(379),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(379),
    [sym__external_close_brace] = ACTIONS(379),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [576] = {
    [sym_function_definition] = STATE(429),
    [sym_if_statement] = STATE(429),
    [sym_for_statement] = STATE(429),
    [sym_while_statement] = STATE(429),
    [sym_repeat_statement] = STATE(429),
    [sym_braced_expression] = STATE(429),
    [sym_parenthesized_expression] = STATE(429),
    [sym_call] = STATE(429),
    [sym_subset] = STATE(429),
    [sym_subset2] = STATE(429),
    [sym__argument] = STATE(1912),
    [sym_argument] = STATE(1916),
    [sym__argument_named] = STATE(1919),
    [sym__argument_unnamed] = STATE(1921),
    [sym__argument_value] = STATE(1927),
    [sym_unary_operator] = STATE(429),
    [sym_binary_operator] = STATE(429),
    [sym_extract_operator] = STATE(429),
    [sym_namespace_operator] = STATE(429),
    [sym_integer] = STATE(429),
    [sym_complex] = STATE(429),
    [sym_float] = STATE(429),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(721),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(429),
    [sym__expression] = STATE(429),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(918),
    [sym__open_brace] = STATE(842),
    [aux_sym_call_arguments_repeat1] = STATE(647),
    [sym_identifier] = ACTIONS(737),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(767),
    [sym_next] = ACTIONS(767),
    [sym_break] = ACTIONS(767),
    [sym_true] = ACTIONS(767),
    [sym_false] = ACTIONS(767),
    [sym_null] = ACTIONS(767),
    [sym_inf] = ACTIONS(767),
    [sym_nan] = ACTIONS(767),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(771),
    [sym_dot_dot_i] = ACTIONS(773),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(775),
    [sym__newline] = ACTIONS(777),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(965),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [577] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(433),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_COLON_EQ] = ACTIONS(461),
    [anon_sym_DASH_GT] = ACTIONS(463),
    [anon_sym_DASH_GT_GT] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(433),
    [sym__semicolon] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [578] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(385),
    [anon_sym_BSLASH] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_for] = ACTIONS(385),
    [anon_sym_while] = ACTIONS(385),
    [anon_sym_repeat] = ACTIONS(385),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_TILDE] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_COLON_EQ] = ACTIONS(505),
    [anon_sym_DASH_GT] = ACTIONS(507),
    [anon_sym_DASH_GT_GT] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(383),
    [sym__number_literal] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(383),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [sym_return] = ACTIONS(385),
    [sym_next] = ACTIONS(385),
    [sym_break] = ACTIONS(385),
    [sym_true] = ACTIONS(385),
    [sym_false] = ACTIONS(385),
    [sym_null] = ACTIONS(385),
    [sym_inf] = ACTIONS(385),
    [sym_nan] = ACTIONS(385),
    [anon_sym_NA] = ACTIONS(385),
    [anon_sym_NA_integer_] = ACTIONS(385),
    [anon_sym_NA_real_] = ACTIONS(385),
    [anon_sym_NA_complex_] = ACTIONS(385),
    [anon_sym_NA_character_] = ACTIONS(385),
    [sym_dots] = ACTIONS(385),
    [sym_dot_dot_i] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(383),
    [sym__semicolon] = ACTIONS(383),
    [sym__raw_string_literal] = ACTIONS(383),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(383),
    [sym__external_close_brace] = ACTIONS(383),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [579] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(433),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(433),
    [anon_sym_LT_LT_DASH] = ACTIONS(433),
    [anon_sym_COLON_EQ] = ACTIONS(433),
    [anon_sym_DASH_GT] = ACTIONS(431),
    [anon_sym_DASH_GT_GT] = ACTIONS(433),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(433),
    [sym__semicolon] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [580] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(433),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_LT_DASH] = ACTIONS(433),
    [anon_sym_LT_LT_DASH] = ACTIONS(433),
    [anon_sym_COLON_EQ] = ACTIONS(433),
    [anon_sym_DASH_GT] = ACTIONS(431),
    [anon_sym_DASH_GT_GT] = ACTIONS(433),
    [anon_sym_PIPE] = ACTIONS(431),
    [anon_sym_AMP] = ACTIONS(431),
    [anon_sym_PIPE_PIPE] = ACTIONS(433),
    [anon_sym_AMP_AMP] = ACTIONS(433),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_EQ] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(477),
    [anon_sym_EQ_EQ] = ACTIONS(477),
    [anon_sym_BANG_EQ] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(485),
    [anon_sym_PIPE_GT] = ACTIONS(485),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(433),
    [sym__semicolon] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [581] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(389),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(389),
    [anon_sym_for] = ACTIONS(389),
    [anon_sym_while] = ACTIONS(389),
    [anon_sym_repeat] = ACTIONS(389),
    [anon_sym_QMARK] = ACTIONS(387),
    [anon_sym_TILDE] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(389),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_COLON_EQ] = ACTIONS(505),
    [anon_sym_DASH_GT] = ACTIONS(507),
    [anon_sym_DASH_GT_GT] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(387),
    [sym__number_literal] = ACTIONS(389),
    [anon_sym_SQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_return] = ACTIONS(389),
    [sym_next] = ACTIONS(389),
    [sym_break] = ACTIONS(389),
    [sym_true] = ACTIONS(389),
    [sym_false] = ACTIONS(389),
    [sym_null] = ACTIONS(389),
    [sym_inf] = ACTIONS(389),
    [sym_nan] = ACTIONS(389),
    [anon_sym_NA] = ACTIONS(389),
    [anon_sym_NA_integer_] = ACTIONS(389),
    [anon_sym_NA_real_] = ACTIONS(389),
    [anon_sym_NA_complex_] = ACTIONS(389),
    [anon_sym_NA_character_] = ACTIONS(389),
    [sym_dots] = ACTIONS(389),
    [sym_dot_dot_i] = ACTIONS(387),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(387),
    [sym__semicolon] = ACTIONS(387),
    [sym__raw_string_literal] = ACTIONS(387),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(387),
    [sym__external_close_brace] = ACTIONS(387),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [582] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_BSLASH] = ACTIONS(391),
    [anon_sym_function] = ACTIONS(393),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(393),
    [anon_sym_for] = ACTIONS(393),
    [anon_sym_while] = ACTIONS(393),
    [anon_sym_repeat] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_COLON_EQ] = ACTIONS(505),
    [anon_sym_DASH_GT] = ACTIONS(507),
    [anon_sym_DASH_GT_GT] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(391),
    [sym__number_literal] = ACTIONS(393),
    [anon_sym_SQUOTE] = ACTIONS(391),
    [anon_sym_DQUOTE] = ACTIONS(391),
    [sym_return] = ACTIONS(393),
    [sym_next] = ACTIONS(393),
    [sym_break] = ACTIONS(393),
    [sym_true] = ACTIONS(393),
    [sym_false] = ACTIONS(393),
    [sym_null] = ACTIONS(393),
    [sym_inf] = ACTIONS(393),
    [sym_nan] = ACTIONS(393),
    [anon_sym_NA] = ACTIONS(393),
    [anon_sym_NA_integer_] = ACTIONS(393),
    [anon_sym_NA_real_] = ACTIONS(393),
    [anon_sym_NA_complex_] = ACTIONS(393),
    [anon_sym_NA_character_] = ACTIONS(393),
    [sym_dots] = ACTIONS(393),
    [sym_dot_dot_i] = ACTIONS(391),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(391),
    [sym__semicolon] = ACTIONS(391),
    [sym__raw_string_literal] = ACTIONS(391),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(391),
    [sym__external_close_brace] = ACTIONS(391),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [583] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(397),
    [anon_sym_BSLASH] = ACTIONS(395),
    [anon_sym_function] = ACTIONS(397),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_while] = ACTIONS(397),
    [anon_sym_repeat] = ACTIONS(397),
    [anon_sym_QMARK] = ACTIONS(395),
    [anon_sym_TILDE] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_COLON_EQ] = ACTIONS(505),
    [anon_sym_DASH_GT] = ACTIONS(507),
    [anon_sym_DASH_GT_GT] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(395),
    [sym__number_literal] = ACTIONS(397),
    [anon_sym_SQUOTE] = ACTIONS(395),
    [anon_sym_DQUOTE] = ACTIONS(395),
    [sym_return] = ACTIONS(397),
    [sym_next] = ACTIONS(397),
    [sym_break] = ACTIONS(397),
    [sym_true] = ACTIONS(397),
    [sym_false] = ACTIONS(397),
    [sym_null] = ACTIONS(397),
    [sym_inf] = ACTIONS(397),
    [sym_nan] = ACTIONS(397),
    [anon_sym_NA] = ACTIONS(397),
    [anon_sym_NA_integer_] = ACTIONS(397),
    [anon_sym_NA_real_] = ACTIONS(397),
    [anon_sym_NA_complex_] = ACTIONS(397),
    [anon_sym_NA_character_] = ACTIONS(397),
    [sym_dots] = ACTIONS(397),
    [sym_dot_dot_i] = ACTIONS(395),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(395),
    [sym__semicolon] = ACTIONS(395),
    [sym__raw_string_literal] = ACTIONS(395),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(395),
    [sym__external_close_brace] = ACTIONS(395),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [584] = {
    [sym_call_arguments] = STATE(919),
    [sym_subset_arguments] = STATE(989),
    [sym_subset2_arguments] = STATE(945),
    [sym__open_parenthesis] = STATE(402),
    [sym__open_bracket] = STATE(403),
    [sym__open_bracket2] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(433),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_repeat] = ACTIONS(431),
    [anon_sym_QMARK] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(433),
    [anon_sym_DASH] = ACTIONS(431),
    [anon_sym_LT_DASH] = ACTIONS(433),
    [anon_sym_LT_LT_DASH] = ACTIONS(433),
    [anon_sym_COLON_EQ] = ACTIONS(433),
    [anon_sym_DASH_GT] = ACTIONS(431),
    [anon_sym_DASH_GT_GT] = ACTIONS(433),
    [anon_sym_PIPE] = ACTIONS(431),
    [anon_sym_AMP] = ACTIONS(431),
    [anon_sym_PIPE_PIPE] = ACTIONS(433),
    [anon_sym_AMP_AMP] = ACTIONS(433),
    [anon_sym_LT] = ACTIONS(431),
    [anon_sym_LT_EQ] = ACTIONS(433),
    [anon_sym_GT] = ACTIONS(431),
    [anon_sym_GT_EQ] = ACTIONS(433),
    [anon_sym_EQ_EQ] = ACTIONS(433),
    [anon_sym_BANG_EQ] = ACTIONS(433),
    [anon_sym_STAR] = ACTIONS(431),
    [anon_sym_SLASH] = ACTIONS(433),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(483),
    [aux_sym_binary_operator_token1] = ACTIONS(433),
    [anon_sym_PIPE_GT] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(431),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(489),
    [sym__hex_literal] = ACTIONS(433),
    [sym__number_literal] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_return] = ACTIONS(431),
    [sym_next] = ACTIONS(431),
    [sym_break] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_null] = ACTIONS(431),
    [sym_inf] = ACTIONS(431),
    [sym_nan] = ACTIONS(431),
    [anon_sym_NA] = ACTIONS(431),
    [anon_sym_NA_integer_] = ACTIONS(431),
    [anon_sym_NA_real_] = ACTIONS(431),
    [anon_sym_NA_complex_] = ACTIONS(431),
    [anon_sym_NA_character_] = ACTIONS(431),
    [sym_dots] = ACTIONS(431),
    [sym_dot_dot_i] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(433),
    [sym__semicolon] = ACTIONS(433),
    [sym__raw_string_literal] = ACTIONS(433),
    [sym__external_open_parenthesis] = ACTIONS(491),
    [sym__external_open_brace] = ACTIONS(433),
    [sym__external_open_bracket] = ACTIONS(493),
    [sym__external_open_bracket2] = ACTIONS(495),
  },
  [585] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(401),
    [anon_sym_BSLASH] = ACTIONS(399),
    [anon_sym_function] = ACTIONS(401),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(401),
    [anon_sym_for] = ACTIONS(401),
    [anon_sym_while] = ACTIONS(401),
    [anon_sym_repeat] = ACTIONS(401),
    [anon_sym_QMARK] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_COLON_EQ] = ACTIONS(505),
    [anon_sym_DASH_GT] = ACTIONS(507),
    [anon_sym_DASH_GT_GT] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(399),
    [sym__number_literal] = ACTIONS(401),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [sym_return] = ACTIONS(401),
    [sym_next] = ACTIONS(401),
    [sym_break] = ACTIONS(401),
    [sym_true] = ACTIONS(401),
    [sym_false] = ACTIONS(401),
    [sym_null] = ACTIONS(401),
    [sym_inf] = ACTIONS(401),
    [sym_nan] = ACTIONS(401),
    [anon_sym_NA] = ACTIONS(401),
    [anon_sym_NA_integer_] = ACTIONS(401),
    [anon_sym_NA_real_] = ACTIONS(401),
    [anon_sym_NA_complex_] = ACTIONS(401),
    [anon_sym_NA_character_] = ACTIONS(401),
    [sym_dots] = ACTIONS(401),
    [sym_dot_dot_i] = ACTIONS(399),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(399),
    [sym__semicolon] = ACTIONS(399),
    [sym__raw_string_literal] = ACTIONS(399),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(399),
    [sym__external_close_brace] = ACTIONS(399),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [586] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_BSLASH] = ACTIONS(403),
    [anon_sym_function] = ACTIONS(405),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(405),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_while] = ACTIONS(405),
    [anon_sym_repeat] = ACTIONS(405),
    [anon_sym_QMARK] = ACTIONS(403),
    [anon_sym_TILDE] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(405),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_COLON_EQ] = ACTIONS(505),
    [anon_sym_DASH_GT] = ACTIONS(507),
    [anon_sym_DASH_GT_GT] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(403),
    [sym__number_literal] = ACTIONS(405),
    [anon_sym_SQUOTE] = ACTIONS(403),
    [anon_sym_DQUOTE] = ACTIONS(403),
    [sym_return] = ACTIONS(405),
    [sym_next] = ACTIONS(405),
    [sym_break] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_null] = ACTIONS(405),
    [sym_inf] = ACTIONS(405),
    [sym_nan] = ACTIONS(405),
    [anon_sym_NA] = ACTIONS(405),
    [anon_sym_NA_integer_] = ACTIONS(405),
    [anon_sym_NA_real_] = ACTIONS(405),
    [anon_sym_NA_complex_] = ACTIONS(405),
    [anon_sym_NA_character_] = ACTIONS(405),
    [sym_dots] = ACTIONS(405),
    [sym_dot_dot_i] = ACTIONS(403),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(403),
    [sym__semicolon] = ACTIONS(403),
    [sym__raw_string_literal] = ACTIONS(403),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(403),
    [sym__external_close_brace] = ACTIONS(403),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [587] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_BSLASH] = ACTIONS(407),
    [anon_sym_function] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(409),
    [anon_sym_while] = ACTIONS(409),
    [anon_sym_repeat] = ACTIONS(409),
    [anon_sym_QMARK] = ACTIONS(407),
    [anon_sym_TILDE] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(409),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_COLON_EQ] = ACTIONS(505),
    [anon_sym_DASH_GT] = ACTIONS(507),
    [anon_sym_DASH_GT_GT] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(407),
    [sym__number_literal] = ACTIONS(409),
    [anon_sym_SQUOTE] = ACTIONS(407),
    [anon_sym_DQUOTE] = ACTIONS(407),
    [sym_return] = ACTIONS(409),
    [sym_next] = ACTIONS(409),
    [sym_break] = ACTIONS(409),
    [sym_true] = ACTIONS(409),
    [sym_false] = ACTIONS(409),
    [sym_null] = ACTIONS(409),
    [sym_inf] = ACTIONS(409),
    [sym_nan] = ACTIONS(409),
    [anon_sym_NA] = ACTIONS(409),
    [anon_sym_NA_integer_] = ACTIONS(409),
    [anon_sym_NA_real_] = ACTIONS(409),
    [anon_sym_NA_complex_] = ACTIONS(409),
    [anon_sym_NA_character_] = ACTIONS(409),
    [sym_dots] = ACTIONS(409),
    [sym_dot_dot_i] = ACTIONS(407),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(407),
    [sym__semicolon] = ACTIONS(407),
    [sym__raw_string_literal] = ACTIONS(407),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(407),
    [sym__external_close_brace] = ACTIONS(407),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [588] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(367),
    [anon_sym_BSLASH] = ACTIONS(369),
    [anon_sym_function] = ACTIONS(367),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(367),
    [anon_sym_for] = ACTIONS(367),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_repeat] = ACTIONS(367),
    [anon_sym_QMARK] = ACTIONS(369),
    [anon_sym_TILDE] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_COLON_EQ] = ACTIONS(505),
    [anon_sym_DASH_GT] = ACTIONS(507),
    [anon_sym_DASH_GT_GT] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(369),
    [sym__number_literal] = ACTIONS(367),
    [anon_sym_SQUOTE] = ACTIONS(369),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [sym_return] = ACTIONS(367),
    [sym_next] = ACTIONS(367),
    [sym_break] = ACTIONS(367),
    [sym_true] = ACTIONS(367),
    [sym_false] = ACTIONS(367),
    [sym_null] = ACTIONS(367),
    [sym_inf] = ACTIONS(367),
    [sym_nan] = ACTIONS(367),
    [anon_sym_NA] = ACTIONS(367),
    [anon_sym_NA_integer_] = ACTIONS(367),
    [anon_sym_NA_real_] = ACTIONS(367),
    [anon_sym_NA_complex_] = ACTIONS(367),
    [anon_sym_NA_character_] = ACTIONS(367),
    [sym_dots] = ACTIONS(367),
    [sym_dot_dot_i] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(369),
    [sym__semicolon] = ACTIONS(369),
    [sym__raw_string_literal] = ACTIONS(369),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(369),
    [sym__external_close_brace] = ACTIONS(369),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [589] = {
    [sym_function_definition] = STATE(429),
    [sym_if_statement] = STATE(429),
    [sym_for_statement] = STATE(429),
    [sym_while_statement] = STATE(429),
    [sym_repeat_statement] = STATE(429),
    [sym_braced_expression] = STATE(429),
    [sym_parenthesized_expression] = STATE(429),
    [sym_call] = STATE(429),
    [sym_subset] = STATE(429),
    [sym_subset2] = STATE(429),
    [sym__argument] = STATE(1912),
    [sym_argument] = STATE(1916),
    [sym__argument_named] = STATE(1919),
    [sym__argument_unnamed] = STATE(1921),
    [sym__argument_value] = STATE(1927),
    [sym_unary_operator] = STATE(429),
    [sym_binary_operator] = STATE(429),
    [sym_extract_operator] = STATE(429),
    [sym_namespace_operator] = STATE(429),
    [sym_integer] = STATE(429),
    [sym_complex] = STATE(429),
    [sym_float] = STATE(429),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(721),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(429),
    [sym__expression] = STATE(429),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(882),
    [sym__open_brace] = STATE(842),
    [aux_sym_call_arguments_repeat1] = STATE(576),
    [sym_identifier] = ACTIONS(737),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(767),
    [sym_next] = ACTIONS(767),
    [sym_break] = ACTIONS(767),
    [sym_true] = ACTIONS(767),
    [sym_false] = ACTIONS(767),
    [sym_null] = ACTIONS(767),
    [sym_inf] = ACTIONS(767),
    [sym_nan] = ACTIONS(767),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(771),
    [sym_dot_dot_i] = ACTIONS(773),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(775),
    [sym__newline] = ACTIONS(777),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(967),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [590] = {
    [sym_function_definition] = STATE(491),
    [sym_if_statement] = STATE(491),
    [sym_for_statement] = STATE(491),
    [sym_while_statement] = STATE(491),
    [sym_repeat_statement] = STATE(491),
    [sym_braced_expression] = STATE(491),
    [sym_parenthesized_expression] = STATE(491),
    [sym_call] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_subset2] = STATE(491),
    [sym__argument] = STATE(1934),
    [sym_argument] = STATE(1937),
    [sym__argument_named] = STATE(1909),
    [sym__argument_unnamed] = STATE(1932),
    [sym__argument_value] = STATE(1920),
    [sym_unary_operator] = STATE(491),
    [sym_binary_operator] = STATE(491),
    [sym_extract_operator] = STATE(491),
    [sym_namespace_operator] = STATE(491),
    [sym_integer] = STATE(491),
    [sym_complex] = STATE(491),
    [sym_float] = STATE(491),
    [sym__float_literal] = STATE(734),
    [sym_string] = STATE(728),
    [sym__single_quoted_string] = STATE(735),
    [sym__double_quoted_string] = STATE(736),
    [sym_na] = STATE(491),
    [sym__expression] = STATE(491),
    [sym__string_or_identifier] = STATE(2143),
    [sym__open_parenthesis] = STATE(948),
    [sym__open_brace] = STATE(751),
    [sym__close_bracket] = STATE(883),
    [aux_sym_call_arguments_repeat1] = STATE(557),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_BSLASH] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_if] = ACTIONS(547),
    [anon_sym_for] = ACTIONS(549),
    [anon_sym_while] = ACTIONS(551),
    [anon_sym_repeat] = ACTIONS(553),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(557),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [sym__hex_literal] = ACTIONS(563),
    [sym__number_literal] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [sym_return] = ACTIONS(571),
    [sym_next] = ACTIONS(571),
    [sym_break] = ACTIONS(571),
    [sym_true] = ACTIONS(571),
    [sym_false] = ACTIONS(571),
    [sym_null] = ACTIONS(571),
    [sym_inf] = ACTIONS(571),
    [sym_nan] = ACTIONS(571),
    [anon_sym_NA] = ACTIONS(573),
    [anon_sym_NA_integer_] = ACTIONS(573),
    [anon_sym_NA_real_] = ACTIONS(573),
    [anon_sym_NA_complex_] = ACTIONS(573),
    [anon_sym_NA_character_] = ACTIONS(573),
    [sym_dots] = ACTIONS(575),
    [sym_dot_dot_i] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(579),
    [sym__newline] = ACTIONS(581),
    [sym__raw_string_literal] = ACTIONS(583),
    [sym__external_open_parenthesis] = ACTIONS(585),
    [sym__external_open_brace] = ACTIONS(587),
    [sym__external_close_bracket] = ACTIONS(969),
  },
  [591] = {
    [sym_function_definition] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_repeat_statement] = STATE(556),
    [sym_braced_expression] = STATE(556),
    [sym_parenthesized_expression] = STATE(556),
    [sym_call] = STATE(556),
    [sym_subset] = STATE(556),
    [sym_subset2] = STATE(556),
    [sym__argument] = STATE(1928),
    [sym_argument] = STATE(1930),
    [sym__argument_named] = STATE(1908),
    [sym__argument_unnamed] = STATE(1933),
    [sym__argument_value] = STATE(1936),
    [sym_unary_operator] = STATE(556),
    [sym_binary_operator] = STATE(556),
    [sym_extract_operator] = STATE(556),
    [sym_namespace_operator] = STATE(556),
    [sym_integer] = STATE(556),
    [sym_complex] = STATE(556),
    [sym_float] = STATE(556),
    [sym__float_literal] = STATE(710),
    [sym_string] = STATE(724),
    [sym__single_quoted_string] = STATE(725),
    [sym__double_quoted_string] = STATE(700),
    [sym_na] = STATE(556),
    [sym__expression] = STATE(556),
    [sym__string_or_identifier] = STATE(2142),
    [sym__open_parenthesis] = STATE(955),
    [sym__open_brace] = STATE(857),
    [sym__close_bracket2] = STATE(885),
    [aux_sym_call_arguments_repeat1] = STATE(558),
    [sym_identifier] = ACTIONS(591),
    [anon_sym_BSLASH] = ACTIONS(593),
    [anon_sym_function] = ACTIONS(595),
    [anon_sym_if] = ACTIONS(597),
    [anon_sym_for] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_repeat] = ACTIONS(603),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [sym__hex_literal] = ACTIONS(613),
    [sym__number_literal] = ACTIONS(615),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(619),
    [sym_return] = ACTIONS(621),
    [sym_next] = ACTIONS(621),
    [sym_break] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_null] = ACTIONS(621),
    [sym_inf] = ACTIONS(621),
    [sym_nan] = ACTIONS(621),
    [anon_sym_NA] = ACTIONS(623),
    [anon_sym_NA_integer_] = ACTIONS(623),
    [anon_sym_NA_real_] = ACTIONS(623),
    [anon_sym_NA_complex_] = ACTIONS(623),
    [anon_sym_NA_character_] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(629),
    [sym__newline] = ACTIONS(631),
    [sym__raw_string_literal] = ACTIONS(633),
    [sym__external_open_parenthesis] = ACTIONS(635),
    [sym__external_open_brace] = ACTIONS(637),
    [sym__external_close_bracket2] = ACTIONS(971),
  },
  [592] = {
    [sym_function_definition] = STATE(429),
    [sym_if_statement] = STATE(429),
    [sym_for_statement] = STATE(429),
    [sym_while_statement] = STATE(429),
    [sym_repeat_statement] = STATE(429),
    [sym_braced_expression] = STATE(429),
    [sym_parenthesized_expression] = STATE(429),
    [sym_call] = STATE(429),
    [sym_subset] = STATE(429),
    [sym_subset2] = STATE(429),
    [sym__argument] = STATE(1912),
    [sym_argument] = STATE(1916),
    [sym__argument_named] = STATE(1919),
    [sym__argument_unnamed] = STATE(1921),
    [sym__argument_value] = STATE(1927),
    [sym_unary_operator] = STATE(429),
    [sym_binary_operator] = STATE(429),
    [sym_extract_operator] = STATE(429),
    [sym_namespace_operator] = STATE(429),
    [sym_integer] = STATE(429),
    [sym_complex] = STATE(429),
    [sym_float] = STATE(429),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(721),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(429),
    [sym__expression] = STATE(429),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(1973),
    [sym__open_brace] = STATE(842),
    [aux_sym_call_arguments_repeat1] = STATE(647),
    [sym_identifier] = ACTIONS(737),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(767),
    [sym_next] = ACTIONS(767),
    [sym_break] = ACTIONS(767),
    [sym_true] = ACTIONS(767),
    [sym_false] = ACTIONS(767),
    [sym_null] = ACTIONS(767),
    [sym_inf] = ACTIONS(767),
    [sym_nan] = ACTIONS(767),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(771),
    [sym_dot_dot_i] = ACTIONS(773),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(775),
    [sym__newline] = ACTIONS(777),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(973),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [593] = {
    [sym_function_definition] = STATE(429),
    [sym_if_statement] = STATE(429),
    [sym_for_statement] = STATE(429),
    [sym_while_statement] = STATE(429),
    [sym_repeat_statement] = STATE(429),
    [sym_braced_expression] = STATE(429),
    [sym_parenthesized_expression] = STATE(429),
    [sym_call] = STATE(429),
    [sym_subset] = STATE(429),
    [sym_subset2] = STATE(429),
    [sym__argument] = STATE(1912),
    [sym_argument] = STATE(1916),
    [sym__argument_named] = STATE(1919),
    [sym__argument_unnamed] = STATE(1921),
    [sym__argument_value] = STATE(1927),
    [sym_unary_operator] = STATE(429),
    [sym_binary_operator] = STATE(429),
    [sym_extract_operator] = STATE(429),
    [sym_namespace_operator] = STATE(429),
    [sym_integer] = STATE(429),
    [sym_complex] = STATE(429),
    [sym_float] = STATE(429),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(721),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(429),
    [sym__expression] = STATE(429),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(1984),
    [sym__open_brace] = STATE(842),
    [aux_sym_call_arguments_repeat1] = STATE(592),
    [sym_identifier] = ACTIONS(737),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(767),
    [sym_next] = ACTIONS(767),
    [sym_break] = ACTIONS(767),
    [sym_true] = ACTIONS(767),
    [sym_false] = ACTIONS(767),
    [sym_null] = ACTIONS(767),
    [sym_inf] = ACTIONS(767),
    [sym_nan] = ACTIONS(767),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(771),
    [sym_dot_dot_i] = ACTIONS(773),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(775),
    [sym__newline] = ACTIONS(777),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(975),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [594] = {
    [sym_function_definition] = STATE(491),
    [sym_if_statement] = STATE(491),
    [sym_for_statement] = STATE(491),
    [sym_while_statement] = STATE(491),
    [sym_repeat_statement] = STATE(491),
    [sym_braced_expression] = STATE(491),
    [sym_parenthesized_expression] = STATE(491),
    [sym_call] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_subset2] = STATE(491),
    [sym__argument] = STATE(1934),
    [sym_argument] = STATE(1937),
    [sym__argument_named] = STATE(1909),
    [sym__argument_unnamed] = STATE(1932),
    [sym__argument_value] = STATE(1920),
    [sym_unary_operator] = STATE(491),
    [sym_binary_operator] = STATE(491),
    [sym_extract_operator] = STATE(491),
    [sym_namespace_operator] = STATE(491),
    [sym_integer] = STATE(491),
    [sym_complex] = STATE(491),
    [sym_float] = STATE(491),
    [sym__float_literal] = STATE(734),
    [sym_string] = STATE(728),
    [sym__single_quoted_string] = STATE(735),
    [sym__double_quoted_string] = STATE(736),
    [sym_na] = STATE(491),
    [sym__expression] = STATE(491),
    [sym__string_or_identifier] = STATE(2143),
    [sym__open_parenthesis] = STATE(948),
    [sym__open_brace] = STATE(751),
    [sym__close_bracket] = STATE(1989),
    [aux_sym_call_arguments_repeat1] = STATE(296),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_BSLASH] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_if] = ACTIONS(547),
    [anon_sym_for] = ACTIONS(549),
    [anon_sym_while] = ACTIONS(551),
    [anon_sym_repeat] = ACTIONS(553),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(557),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [sym__hex_literal] = ACTIONS(563),
    [sym__number_literal] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [sym_return] = ACTIONS(571),
    [sym_next] = ACTIONS(571),
    [sym_break] = ACTIONS(571),
    [sym_true] = ACTIONS(571),
    [sym_false] = ACTIONS(571),
    [sym_null] = ACTIONS(571),
    [sym_inf] = ACTIONS(571),
    [sym_nan] = ACTIONS(571),
    [anon_sym_NA] = ACTIONS(573),
    [anon_sym_NA_integer_] = ACTIONS(573),
    [anon_sym_NA_real_] = ACTIONS(573),
    [anon_sym_NA_complex_] = ACTIONS(573),
    [anon_sym_NA_character_] = ACTIONS(573),
    [sym_dots] = ACTIONS(575),
    [sym_dot_dot_i] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(579),
    [sym__newline] = ACTIONS(581),
    [sym__raw_string_literal] = ACTIONS(583),
    [sym__external_open_parenthesis] = ACTIONS(585),
    [sym__external_open_brace] = ACTIONS(587),
    [sym__external_close_bracket] = ACTIONS(977),
  },
  [595] = {
    [sym_function_definition] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_repeat_statement] = STATE(556),
    [sym_braced_expression] = STATE(556),
    [sym_parenthesized_expression] = STATE(556),
    [sym_call] = STATE(556),
    [sym_subset] = STATE(556),
    [sym_subset2] = STATE(556),
    [sym__argument] = STATE(1928),
    [sym_argument] = STATE(1930),
    [sym__argument_named] = STATE(1908),
    [sym__argument_unnamed] = STATE(1933),
    [sym__argument_value] = STATE(1936),
    [sym_unary_operator] = STATE(556),
    [sym_binary_operator] = STATE(556),
    [sym_extract_operator] = STATE(556),
    [sym_namespace_operator] = STATE(556),
    [sym_integer] = STATE(556),
    [sym_complex] = STATE(556),
    [sym_float] = STATE(556),
    [sym__float_literal] = STATE(710),
    [sym_string] = STATE(724),
    [sym__single_quoted_string] = STATE(725),
    [sym__double_quoted_string] = STATE(700),
    [sym_na] = STATE(556),
    [sym__expression] = STATE(556),
    [sym__string_or_identifier] = STATE(2142),
    [sym__open_parenthesis] = STATE(955),
    [sym__open_brace] = STATE(857),
    [sym__close_bracket2] = STATE(1972),
    [aux_sym_call_arguments_repeat1] = STATE(297),
    [sym_identifier] = ACTIONS(591),
    [anon_sym_BSLASH] = ACTIONS(593),
    [anon_sym_function] = ACTIONS(595),
    [anon_sym_if] = ACTIONS(597),
    [anon_sym_for] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_repeat] = ACTIONS(603),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [sym__hex_literal] = ACTIONS(613),
    [sym__number_literal] = ACTIONS(615),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(619),
    [sym_return] = ACTIONS(621),
    [sym_next] = ACTIONS(621),
    [sym_break] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_null] = ACTIONS(621),
    [sym_inf] = ACTIONS(621),
    [sym_nan] = ACTIONS(621),
    [anon_sym_NA] = ACTIONS(623),
    [anon_sym_NA_integer_] = ACTIONS(623),
    [anon_sym_NA_real_] = ACTIONS(623),
    [anon_sym_NA_complex_] = ACTIONS(623),
    [anon_sym_NA_character_] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(629),
    [sym__newline] = ACTIONS(631),
    [sym__raw_string_literal] = ACTIONS(633),
    [sym__external_open_parenthesis] = ACTIONS(635),
    [sym__external_open_brace] = ACTIONS(637),
    [sym__external_close_bracket2] = ACTIONS(979),
  },
  [596] = {
    [sym_function_definition] = STATE(429),
    [sym_if_statement] = STATE(429),
    [sym_for_statement] = STATE(429),
    [sym_while_statement] = STATE(429),
    [sym_repeat_statement] = STATE(429),
    [sym_braced_expression] = STATE(429),
    [sym_parenthesized_expression] = STATE(429),
    [sym_call] = STATE(429),
    [sym_subset] = STATE(429),
    [sym_subset2] = STATE(429),
    [sym__argument] = STATE(1912),
    [sym_argument] = STATE(1916),
    [sym__argument_named] = STATE(1919),
    [sym__argument_unnamed] = STATE(1921),
    [sym__argument_value] = STATE(1927),
    [sym_unary_operator] = STATE(429),
    [sym_binary_operator] = STATE(429),
    [sym_extract_operator] = STATE(429),
    [sym_namespace_operator] = STATE(429),
    [sym_integer] = STATE(429),
    [sym_complex] = STATE(429),
    [sym_float] = STATE(429),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(721),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(429),
    [sym__expression] = STATE(429),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(985),
    [sym__open_brace] = STATE(842),
    [aux_sym_call_arguments_repeat1] = STATE(647),
    [sym_identifier] = ACTIONS(737),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(767),
    [sym_next] = ACTIONS(767),
    [sym_break] = ACTIONS(767),
    [sym_true] = ACTIONS(767),
    [sym_false] = ACTIONS(767),
    [sym_null] = ACTIONS(767),
    [sym_inf] = ACTIONS(767),
    [sym_nan] = ACTIONS(767),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(771),
    [sym_dot_dot_i] = ACTIONS(773),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(775),
    [sym__newline] = ACTIONS(777),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(981),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [597] = {
    [sym_function_definition] = STATE(429),
    [sym_if_statement] = STATE(429),
    [sym_for_statement] = STATE(429),
    [sym_while_statement] = STATE(429),
    [sym_repeat_statement] = STATE(429),
    [sym_braced_expression] = STATE(429),
    [sym_parenthesized_expression] = STATE(429),
    [sym_call] = STATE(429),
    [sym_subset] = STATE(429),
    [sym_subset2] = STATE(429),
    [sym__argument] = STATE(1912),
    [sym_argument] = STATE(1916),
    [sym__argument_named] = STATE(1919),
    [sym__argument_unnamed] = STATE(1921),
    [sym__argument_value] = STATE(1927),
    [sym_unary_operator] = STATE(429),
    [sym_binary_operator] = STATE(429),
    [sym_extract_operator] = STATE(429),
    [sym_namespace_operator] = STATE(429),
    [sym_integer] = STATE(429),
    [sym_complex] = STATE(429),
    [sym_float] = STATE(429),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(721),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(429),
    [sym__expression] = STATE(429),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(992),
    [sym__open_brace] = STATE(842),
    [aux_sym_call_arguments_repeat1] = STATE(596),
    [sym_identifier] = ACTIONS(737),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(767),
    [sym_next] = ACTIONS(767),
    [sym_break] = ACTIONS(767),
    [sym_true] = ACTIONS(767),
    [sym_false] = ACTIONS(767),
    [sym_null] = ACTIONS(767),
    [sym_inf] = ACTIONS(767),
    [sym_nan] = ACTIONS(767),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(771),
    [sym_dot_dot_i] = ACTIONS(773),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(775),
    [sym__newline] = ACTIONS(777),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(983),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [598] = {
    [sym_function_definition] = STATE(491),
    [sym_if_statement] = STATE(491),
    [sym_for_statement] = STATE(491),
    [sym_while_statement] = STATE(491),
    [sym_repeat_statement] = STATE(491),
    [sym_braced_expression] = STATE(491),
    [sym_parenthesized_expression] = STATE(491),
    [sym_call] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_subset2] = STATE(491),
    [sym__argument] = STATE(1934),
    [sym_argument] = STATE(1937),
    [sym__argument_named] = STATE(1909),
    [sym__argument_unnamed] = STATE(1932),
    [sym__argument_value] = STATE(1920),
    [sym_unary_operator] = STATE(491),
    [sym_binary_operator] = STATE(491),
    [sym_extract_operator] = STATE(491),
    [sym_namespace_operator] = STATE(491),
    [sym_integer] = STATE(491),
    [sym_complex] = STATE(491),
    [sym_float] = STATE(491),
    [sym__float_literal] = STATE(734),
    [sym_string] = STATE(728),
    [sym__single_quoted_string] = STATE(735),
    [sym__double_quoted_string] = STATE(736),
    [sym_na] = STATE(491),
    [sym__expression] = STATE(491),
    [sym__string_or_identifier] = STATE(2143),
    [sym__open_parenthesis] = STATE(948),
    [sym__open_brace] = STATE(751),
    [sym__close_bracket] = STATE(993),
    [aux_sym_call_arguments_repeat1] = STATE(322),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_BSLASH] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_if] = ACTIONS(547),
    [anon_sym_for] = ACTIONS(549),
    [anon_sym_while] = ACTIONS(551),
    [anon_sym_repeat] = ACTIONS(553),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(557),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [sym__hex_literal] = ACTIONS(563),
    [sym__number_literal] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [sym_return] = ACTIONS(571),
    [sym_next] = ACTIONS(571),
    [sym_break] = ACTIONS(571),
    [sym_true] = ACTIONS(571),
    [sym_false] = ACTIONS(571),
    [sym_null] = ACTIONS(571),
    [sym_inf] = ACTIONS(571),
    [sym_nan] = ACTIONS(571),
    [anon_sym_NA] = ACTIONS(573),
    [anon_sym_NA_integer_] = ACTIONS(573),
    [anon_sym_NA_real_] = ACTIONS(573),
    [anon_sym_NA_complex_] = ACTIONS(573),
    [anon_sym_NA_character_] = ACTIONS(573),
    [sym_dots] = ACTIONS(575),
    [sym_dot_dot_i] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(579),
    [sym__newline] = ACTIONS(581),
    [sym__raw_string_literal] = ACTIONS(583),
    [sym__external_open_parenthesis] = ACTIONS(585),
    [sym__external_open_brace] = ACTIONS(587),
    [sym__external_close_bracket] = ACTIONS(985),
  },
  [599] = {
    [sym_function_definition] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_repeat_statement] = STATE(556),
    [sym_braced_expression] = STATE(556),
    [sym_parenthesized_expression] = STATE(556),
    [sym_call] = STATE(556),
    [sym_subset] = STATE(556),
    [sym_subset2] = STATE(556),
    [sym__argument] = STATE(1928),
    [sym_argument] = STATE(1930),
    [sym__argument_named] = STATE(1908),
    [sym__argument_unnamed] = STATE(1933),
    [sym__argument_value] = STATE(1936),
    [sym_unary_operator] = STATE(556),
    [sym_binary_operator] = STATE(556),
    [sym_extract_operator] = STATE(556),
    [sym_namespace_operator] = STATE(556),
    [sym_integer] = STATE(556),
    [sym_complex] = STATE(556),
    [sym_float] = STATE(556),
    [sym__float_literal] = STATE(710),
    [sym_string] = STATE(724),
    [sym__single_quoted_string] = STATE(725),
    [sym__double_quoted_string] = STATE(700),
    [sym_na] = STATE(556),
    [sym__expression] = STATE(556),
    [sym__string_or_identifier] = STATE(2142),
    [sym__open_parenthesis] = STATE(955),
    [sym__open_brace] = STATE(857),
    [sym__close_bracket2] = STATE(889),
    [aux_sym_call_arguments_repeat1] = STATE(323),
    [sym_identifier] = ACTIONS(591),
    [anon_sym_BSLASH] = ACTIONS(593),
    [anon_sym_function] = ACTIONS(595),
    [anon_sym_if] = ACTIONS(597),
    [anon_sym_for] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_repeat] = ACTIONS(603),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [sym__hex_literal] = ACTIONS(613),
    [sym__number_literal] = ACTIONS(615),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(619),
    [sym_return] = ACTIONS(621),
    [sym_next] = ACTIONS(621),
    [sym_break] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_null] = ACTIONS(621),
    [sym_inf] = ACTIONS(621),
    [sym_nan] = ACTIONS(621),
    [anon_sym_NA] = ACTIONS(623),
    [anon_sym_NA_integer_] = ACTIONS(623),
    [anon_sym_NA_real_] = ACTIONS(623),
    [anon_sym_NA_complex_] = ACTIONS(623),
    [anon_sym_NA_character_] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(629),
    [sym__newline] = ACTIONS(631),
    [sym__raw_string_literal] = ACTIONS(633),
    [sym__external_open_parenthesis] = ACTIONS(635),
    [sym__external_open_brace] = ACTIONS(637),
    [sym__external_close_bracket2] = ACTIONS(987),
  },
  [600] = {
    [sym_function_definition] = STATE(429),
    [sym_if_statement] = STATE(429),
    [sym_for_statement] = STATE(429),
    [sym_while_statement] = STATE(429),
    [sym_repeat_statement] = STATE(429),
    [sym_braced_expression] = STATE(429),
    [sym_parenthesized_expression] = STATE(429),
    [sym_call] = STATE(429),
    [sym_subset] = STATE(429),
    [sym_subset2] = STATE(429),
    [sym__argument] = STATE(1912),
    [sym_argument] = STATE(1916),
    [sym__argument_named] = STATE(1919),
    [sym__argument_unnamed] = STATE(1921),
    [sym__argument_value] = STATE(1927),
    [sym_unary_operator] = STATE(429),
    [sym_binary_operator] = STATE(429),
    [sym_extract_operator] = STATE(429),
    [sym_namespace_operator] = STATE(429),
    [sym_integer] = STATE(429),
    [sym_complex] = STATE(429),
    [sym_float] = STATE(429),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(721),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(429),
    [sym__expression] = STATE(429),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(996),
    [sym__open_brace] = STATE(842),
    [aux_sym_call_arguments_repeat1] = STATE(647),
    [sym_identifier] = ACTIONS(737),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(767),
    [sym_next] = ACTIONS(767),
    [sym_break] = ACTIONS(767),
    [sym_true] = ACTIONS(767),
    [sym_false] = ACTIONS(767),
    [sym_null] = ACTIONS(767),
    [sym_inf] = ACTIONS(767),
    [sym_nan] = ACTIONS(767),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(771),
    [sym_dot_dot_i] = ACTIONS(773),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(775),
    [sym__newline] = ACTIONS(777),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(989),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [601] = {
    [sym_function_definition] = STATE(429),
    [sym_if_statement] = STATE(429),
    [sym_for_statement] = STATE(429),
    [sym_while_statement] = STATE(429),
    [sym_repeat_statement] = STATE(429),
    [sym_braced_expression] = STATE(429),
    [sym_parenthesized_expression] = STATE(429),
    [sym_call] = STATE(429),
    [sym_subset] = STATE(429),
    [sym_subset2] = STATE(429),
    [sym__argument] = STATE(1912),
    [sym_argument] = STATE(1916),
    [sym__argument_named] = STATE(1919),
    [sym__argument_unnamed] = STATE(1921),
    [sym__argument_value] = STATE(1927),
    [sym_unary_operator] = STATE(429),
    [sym_binary_operator] = STATE(429),
    [sym_extract_operator] = STATE(429),
    [sym_namespace_operator] = STATE(429),
    [sym_integer] = STATE(429),
    [sym_complex] = STATE(429),
    [sym_float] = STATE(429),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(721),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(429),
    [sym__expression] = STATE(429),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(904),
    [sym__open_brace] = STATE(842),
    [aux_sym_call_arguments_repeat1] = STATE(600),
    [sym_identifier] = ACTIONS(737),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(767),
    [sym_next] = ACTIONS(767),
    [sym_break] = ACTIONS(767),
    [sym_true] = ACTIONS(767),
    [sym_false] = ACTIONS(767),
    [sym_null] = ACTIONS(767),
    [sym_inf] = ACTIONS(767),
    [sym_nan] = ACTIONS(767),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(771),
    [sym_dot_dot_i] = ACTIONS(773),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(775),
    [sym__newline] = ACTIONS(777),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(991),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [602] = {
    [sym_function_definition] = STATE(491),
    [sym_if_statement] = STATE(491),
    [sym_for_statement] = STATE(491),
    [sym_while_statement] = STATE(491),
    [sym_repeat_statement] = STATE(491),
    [sym_braced_expression] = STATE(491),
    [sym_parenthesized_expression] = STATE(491),
    [sym_call] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_subset2] = STATE(491),
    [sym__argument] = STATE(1934),
    [sym_argument] = STATE(1937),
    [sym__argument_named] = STATE(1909),
    [sym__argument_unnamed] = STATE(1932),
    [sym__argument_value] = STATE(1920),
    [sym_unary_operator] = STATE(491),
    [sym_binary_operator] = STATE(491),
    [sym_extract_operator] = STATE(491),
    [sym_namespace_operator] = STATE(491),
    [sym_integer] = STATE(491),
    [sym_complex] = STATE(491),
    [sym_float] = STATE(491),
    [sym__float_literal] = STATE(734),
    [sym_string] = STATE(728),
    [sym__single_quoted_string] = STATE(735),
    [sym__double_quoted_string] = STATE(736),
    [sym_na] = STATE(491),
    [sym__expression] = STATE(491),
    [sym__string_or_identifier] = STATE(2143),
    [sym__open_parenthesis] = STATE(948),
    [sym__open_brace] = STATE(751),
    [sym__close_bracket] = STATE(909),
    [aux_sym_call_arguments_repeat1] = STATE(374),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_BSLASH] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_if] = ACTIONS(547),
    [anon_sym_for] = ACTIONS(549),
    [anon_sym_while] = ACTIONS(551),
    [anon_sym_repeat] = ACTIONS(553),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(557),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [sym__hex_literal] = ACTIONS(563),
    [sym__number_literal] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [sym_return] = ACTIONS(571),
    [sym_next] = ACTIONS(571),
    [sym_break] = ACTIONS(571),
    [sym_true] = ACTIONS(571),
    [sym_false] = ACTIONS(571),
    [sym_null] = ACTIONS(571),
    [sym_inf] = ACTIONS(571),
    [sym_nan] = ACTIONS(571),
    [anon_sym_NA] = ACTIONS(573),
    [anon_sym_NA_integer_] = ACTIONS(573),
    [anon_sym_NA_real_] = ACTIONS(573),
    [anon_sym_NA_complex_] = ACTIONS(573),
    [anon_sym_NA_character_] = ACTIONS(573),
    [sym_dots] = ACTIONS(575),
    [sym_dot_dot_i] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(579),
    [sym__newline] = ACTIONS(581),
    [sym__raw_string_literal] = ACTIONS(583),
    [sym__external_open_parenthesis] = ACTIONS(585),
    [sym__external_open_brace] = ACTIONS(587),
    [sym__external_close_bracket] = ACTIONS(993),
  },
  [603] = {
    [sym_function_definition] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_repeat_statement] = STATE(556),
    [sym_braced_expression] = STATE(556),
    [sym_parenthesized_expression] = STATE(556),
    [sym_call] = STATE(556),
    [sym_subset] = STATE(556),
    [sym_subset2] = STATE(556),
    [sym__argument] = STATE(1928),
    [sym_argument] = STATE(1930),
    [sym__argument_named] = STATE(1908),
    [sym__argument_unnamed] = STATE(1933),
    [sym__argument_value] = STATE(1936),
    [sym_unary_operator] = STATE(556),
    [sym_binary_operator] = STATE(556),
    [sym_extract_operator] = STATE(556),
    [sym_namespace_operator] = STATE(556),
    [sym_integer] = STATE(556),
    [sym_complex] = STATE(556),
    [sym_float] = STATE(556),
    [sym__float_literal] = STATE(710),
    [sym_string] = STATE(724),
    [sym__single_quoted_string] = STATE(725),
    [sym__double_quoted_string] = STATE(700),
    [sym_na] = STATE(556),
    [sym__expression] = STATE(556),
    [sym__string_or_identifier] = STATE(2142),
    [sym__open_parenthesis] = STATE(955),
    [sym__open_brace] = STATE(857),
    [sym__close_bracket2] = STATE(911),
    [aux_sym_call_arguments_repeat1] = STATE(375),
    [sym_identifier] = ACTIONS(591),
    [anon_sym_BSLASH] = ACTIONS(593),
    [anon_sym_function] = ACTIONS(595),
    [anon_sym_if] = ACTIONS(597),
    [anon_sym_for] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_repeat] = ACTIONS(603),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [sym__hex_literal] = ACTIONS(613),
    [sym__number_literal] = ACTIONS(615),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(619),
    [sym_return] = ACTIONS(621),
    [sym_next] = ACTIONS(621),
    [sym_break] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_null] = ACTIONS(621),
    [sym_inf] = ACTIONS(621),
    [sym_nan] = ACTIONS(621),
    [anon_sym_NA] = ACTIONS(623),
    [anon_sym_NA_integer_] = ACTIONS(623),
    [anon_sym_NA_real_] = ACTIONS(623),
    [anon_sym_NA_complex_] = ACTIONS(623),
    [anon_sym_NA_character_] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(629),
    [sym__newline] = ACTIONS(631),
    [sym__raw_string_literal] = ACTIONS(633),
    [sym__external_open_parenthesis] = ACTIONS(635),
    [sym__external_open_brace] = ACTIONS(637),
    [sym__external_close_bracket2] = ACTIONS(995),
  },
  [604] = {
    [sym_function_definition] = STATE(429),
    [sym_if_statement] = STATE(429),
    [sym_for_statement] = STATE(429),
    [sym_while_statement] = STATE(429),
    [sym_repeat_statement] = STATE(429),
    [sym_braced_expression] = STATE(429),
    [sym_parenthesized_expression] = STATE(429),
    [sym_call] = STATE(429),
    [sym_subset] = STATE(429),
    [sym_subset2] = STATE(429),
    [sym__argument] = STATE(1912),
    [sym_argument] = STATE(1916),
    [sym__argument_named] = STATE(1919),
    [sym__argument_unnamed] = STATE(1921),
    [sym__argument_value] = STATE(1927),
    [sym_unary_operator] = STATE(429),
    [sym_binary_operator] = STATE(429),
    [sym_extract_operator] = STATE(429),
    [sym_namespace_operator] = STATE(429),
    [sym_integer] = STATE(429),
    [sym_complex] = STATE(429),
    [sym_float] = STATE(429),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(721),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(429),
    [sym__expression] = STATE(429),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(819),
    [sym__open_brace] = STATE(842),
    [aux_sym_call_arguments_repeat1] = STATE(647),
    [sym_identifier] = ACTIONS(737),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(767),
    [sym_next] = ACTIONS(767),
    [sym_break] = ACTIONS(767),
    [sym_true] = ACTIONS(767),
    [sym_false] = ACTIONS(767),
    [sym_null] = ACTIONS(767),
    [sym_inf] = ACTIONS(767),
    [sym_nan] = ACTIONS(767),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(771),
    [sym_dot_dot_i] = ACTIONS(773),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(775),
    [sym__newline] = ACTIONS(777),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(997),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [605] = {
    [sym_function_definition] = STATE(429),
    [sym_if_statement] = STATE(429),
    [sym_for_statement] = STATE(429),
    [sym_while_statement] = STATE(429),
    [sym_repeat_statement] = STATE(429),
    [sym_braced_expression] = STATE(429),
    [sym_parenthesized_expression] = STATE(429),
    [sym_call] = STATE(429),
    [sym_subset] = STATE(429),
    [sym_subset2] = STATE(429),
    [sym__argument] = STATE(1912),
    [sym_argument] = STATE(1916),
    [sym__argument_named] = STATE(1919),
    [sym__argument_unnamed] = STATE(1921),
    [sym__argument_value] = STATE(1927),
    [sym_unary_operator] = STATE(429),
    [sym_binary_operator] = STATE(429),
    [sym_extract_operator] = STATE(429),
    [sym_namespace_operator] = STATE(429),
    [sym_integer] = STATE(429),
    [sym_complex] = STATE(429),
    [sym_float] = STATE(429),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(721),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(429),
    [sym__expression] = STATE(429),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(772),
    [sym__open_brace] = STATE(842),
    [aux_sym_call_arguments_repeat1] = STATE(604),
    [sym_identifier] = ACTIONS(737),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(767),
    [sym_next] = ACTIONS(767),
    [sym_break] = ACTIONS(767),
    [sym_true] = ACTIONS(767),
    [sym_false] = ACTIONS(767),
    [sym_null] = ACTIONS(767),
    [sym_inf] = ACTIONS(767),
    [sym_nan] = ACTIONS(767),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(771),
    [sym_dot_dot_i] = ACTIONS(773),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(775),
    [sym__newline] = ACTIONS(777),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(999),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [606] = {
    [sym_function_definition] = STATE(491),
    [sym_if_statement] = STATE(491),
    [sym_for_statement] = STATE(491),
    [sym_while_statement] = STATE(491),
    [sym_repeat_statement] = STATE(491),
    [sym_braced_expression] = STATE(491),
    [sym_parenthesized_expression] = STATE(491),
    [sym_call] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_subset2] = STATE(491),
    [sym__argument] = STATE(1934),
    [sym_argument] = STATE(1937),
    [sym__argument_named] = STATE(1909),
    [sym__argument_unnamed] = STATE(1932),
    [sym__argument_value] = STATE(1920),
    [sym_unary_operator] = STATE(491),
    [sym_binary_operator] = STATE(491),
    [sym_extract_operator] = STATE(491),
    [sym_namespace_operator] = STATE(491),
    [sym_integer] = STATE(491),
    [sym_complex] = STATE(491),
    [sym_float] = STATE(491),
    [sym__float_literal] = STATE(734),
    [sym_string] = STATE(728),
    [sym__single_quoted_string] = STATE(735),
    [sym__double_quoted_string] = STATE(736),
    [sym_na] = STATE(491),
    [sym__expression] = STATE(491),
    [sym__string_or_identifier] = STATE(2143),
    [sym__open_parenthesis] = STATE(948),
    [sym__open_brace] = STATE(751),
    [sym__close_bracket] = STATE(773),
    [aux_sym_call_arguments_repeat1] = STATE(419),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_BSLASH] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_if] = ACTIONS(547),
    [anon_sym_for] = ACTIONS(549),
    [anon_sym_while] = ACTIONS(551),
    [anon_sym_repeat] = ACTIONS(553),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(557),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [sym__hex_literal] = ACTIONS(563),
    [sym__number_literal] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [sym_return] = ACTIONS(571),
    [sym_next] = ACTIONS(571),
    [sym_break] = ACTIONS(571),
    [sym_true] = ACTIONS(571),
    [sym_false] = ACTIONS(571),
    [sym_null] = ACTIONS(571),
    [sym_inf] = ACTIONS(571),
    [sym_nan] = ACTIONS(571),
    [anon_sym_NA] = ACTIONS(573),
    [anon_sym_NA_integer_] = ACTIONS(573),
    [anon_sym_NA_real_] = ACTIONS(573),
    [anon_sym_NA_complex_] = ACTIONS(573),
    [anon_sym_NA_character_] = ACTIONS(573),
    [sym_dots] = ACTIONS(575),
    [sym_dot_dot_i] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(579),
    [sym__newline] = ACTIONS(581),
    [sym__raw_string_literal] = ACTIONS(583),
    [sym__external_open_parenthesis] = ACTIONS(585),
    [sym__external_open_brace] = ACTIONS(587),
    [sym__external_close_bracket] = ACTIONS(1001),
  },
  [607] = {
    [sym_function_definition] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_repeat_statement] = STATE(556),
    [sym_braced_expression] = STATE(556),
    [sym_parenthesized_expression] = STATE(556),
    [sym_call] = STATE(556),
    [sym_subset] = STATE(556),
    [sym_subset2] = STATE(556),
    [sym__argument] = STATE(1928),
    [sym_argument] = STATE(1930),
    [sym__argument_named] = STATE(1908),
    [sym__argument_unnamed] = STATE(1933),
    [sym__argument_value] = STATE(1936),
    [sym_unary_operator] = STATE(556),
    [sym_binary_operator] = STATE(556),
    [sym_extract_operator] = STATE(556),
    [sym_namespace_operator] = STATE(556),
    [sym_integer] = STATE(556),
    [sym_complex] = STATE(556),
    [sym_float] = STATE(556),
    [sym__float_literal] = STATE(710),
    [sym_string] = STATE(724),
    [sym__single_quoted_string] = STATE(725),
    [sym__double_quoted_string] = STATE(700),
    [sym_na] = STATE(556),
    [sym__expression] = STATE(556),
    [sym__string_or_identifier] = STATE(2142),
    [sym__open_parenthesis] = STATE(955),
    [sym__open_brace] = STATE(857),
    [sym__close_bracket2] = STATE(778),
    [aux_sym_call_arguments_repeat1] = STATE(420),
    [sym_identifier] = ACTIONS(591),
    [anon_sym_BSLASH] = ACTIONS(593),
    [anon_sym_function] = ACTIONS(595),
    [anon_sym_if] = ACTIONS(597),
    [anon_sym_for] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_repeat] = ACTIONS(603),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [sym__hex_literal] = ACTIONS(613),
    [sym__number_literal] = ACTIONS(615),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(619),
    [sym_return] = ACTIONS(621),
    [sym_next] = ACTIONS(621),
    [sym_break] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_null] = ACTIONS(621),
    [sym_inf] = ACTIONS(621),
    [sym_nan] = ACTIONS(621),
    [anon_sym_NA] = ACTIONS(623),
    [anon_sym_NA_integer_] = ACTIONS(623),
    [anon_sym_NA_real_] = ACTIONS(623),
    [anon_sym_NA_complex_] = ACTIONS(623),
    [anon_sym_NA_character_] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(629),
    [sym__newline] = ACTIONS(631),
    [sym__raw_string_literal] = ACTIONS(633),
    [sym__external_open_parenthesis] = ACTIONS(635),
    [sym__external_open_brace] = ACTIONS(637),
    [sym__external_close_bracket2] = ACTIONS(1003),
  },
  [608] = {
    [sym_function_definition] = STATE(429),
    [sym_if_statement] = STATE(429),
    [sym_for_statement] = STATE(429),
    [sym_while_statement] = STATE(429),
    [sym_repeat_statement] = STATE(429),
    [sym_braced_expression] = STATE(429),
    [sym_parenthesized_expression] = STATE(429),
    [sym_call] = STATE(429),
    [sym_subset] = STATE(429),
    [sym_subset2] = STATE(429),
    [sym__argument] = STATE(1912),
    [sym_argument] = STATE(1916),
    [sym__argument_named] = STATE(1919),
    [sym__argument_unnamed] = STATE(1921),
    [sym__argument_value] = STATE(1927),
    [sym_unary_operator] = STATE(429),
    [sym_binary_operator] = STATE(429),
    [sym_extract_operator] = STATE(429),
    [sym_namespace_operator] = STATE(429),
    [sym_integer] = STATE(429),
    [sym_complex] = STATE(429),
    [sym_float] = STATE(429),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(721),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(429),
    [sym__expression] = STATE(429),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(801),
    [sym__open_brace] = STATE(842),
    [aux_sym_call_arguments_repeat1] = STATE(647),
    [sym_identifier] = ACTIONS(737),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(767),
    [sym_next] = ACTIONS(767),
    [sym_break] = ACTIONS(767),
    [sym_true] = ACTIONS(767),
    [sym_false] = ACTIONS(767),
    [sym_null] = ACTIONS(767),
    [sym_inf] = ACTIONS(767),
    [sym_nan] = ACTIONS(767),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(771),
    [sym_dot_dot_i] = ACTIONS(773),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(775),
    [sym__newline] = ACTIONS(777),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1005),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [609] = {
    [sym_function_definition] = STATE(429),
    [sym_if_statement] = STATE(429),
    [sym_for_statement] = STATE(429),
    [sym_while_statement] = STATE(429),
    [sym_repeat_statement] = STATE(429),
    [sym_braced_expression] = STATE(429),
    [sym_parenthesized_expression] = STATE(429),
    [sym_call] = STATE(429),
    [sym_subset] = STATE(429),
    [sym_subset2] = STATE(429),
    [sym__argument] = STATE(1912),
    [sym_argument] = STATE(1916),
    [sym__argument_named] = STATE(1919),
    [sym__argument_unnamed] = STATE(1921),
    [sym__argument_value] = STATE(1927),
    [sym_unary_operator] = STATE(429),
    [sym_binary_operator] = STATE(429),
    [sym_extract_operator] = STATE(429),
    [sym_namespace_operator] = STATE(429),
    [sym_integer] = STATE(429),
    [sym_complex] = STATE(429),
    [sym_float] = STATE(429),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(721),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(429),
    [sym__expression] = STATE(429),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(862),
    [sym__open_brace] = STATE(842),
    [aux_sym_call_arguments_repeat1] = STATE(608),
    [sym_identifier] = ACTIONS(737),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(767),
    [sym_next] = ACTIONS(767),
    [sym_break] = ACTIONS(767),
    [sym_true] = ACTIONS(767),
    [sym_false] = ACTIONS(767),
    [sym_null] = ACTIONS(767),
    [sym_inf] = ACTIONS(767),
    [sym_nan] = ACTIONS(767),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(771),
    [sym_dot_dot_i] = ACTIONS(773),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(775),
    [sym__newline] = ACTIONS(777),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1007),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [610] = {
    [sym_function_definition] = STATE(491),
    [sym_if_statement] = STATE(491),
    [sym_for_statement] = STATE(491),
    [sym_while_statement] = STATE(491),
    [sym_repeat_statement] = STATE(491),
    [sym_braced_expression] = STATE(491),
    [sym_parenthesized_expression] = STATE(491),
    [sym_call] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_subset2] = STATE(491),
    [sym__argument] = STATE(1934),
    [sym_argument] = STATE(1937),
    [sym__argument_named] = STATE(1909),
    [sym__argument_unnamed] = STATE(1932),
    [sym__argument_value] = STATE(1920),
    [sym_unary_operator] = STATE(491),
    [sym_binary_operator] = STATE(491),
    [sym_extract_operator] = STATE(491),
    [sym_namespace_operator] = STATE(491),
    [sym_integer] = STATE(491),
    [sym_complex] = STATE(491),
    [sym_float] = STATE(491),
    [sym__float_literal] = STATE(734),
    [sym_string] = STATE(728),
    [sym__single_quoted_string] = STATE(735),
    [sym__double_quoted_string] = STATE(736),
    [sym_na] = STATE(491),
    [sym__expression] = STATE(491),
    [sym__string_or_identifier] = STATE(2143),
    [sym__open_parenthesis] = STATE(948),
    [sym__open_brace] = STATE(751),
    [sym__close_bracket] = STATE(863),
    [aux_sym_call_arguments_repeat1] = STATE(452),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_BSLASH] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_if] = ACTIONS(547),
    [anon_sym_for] = ACTIONS(549),
    [anon_sym_while] = ACTIONS(551),
    [anon_sym_repeat] = ACTIONS(553),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(557),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [sym__hex_literal] = ACTIONS(563),
    [sym__number_literal] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [sym_return] = ACTIONS(571),
    [sym_next] = ACTIONS(571),
    [sym_break] = ACTIONS(571),
    [sym_true] = ACTIONS(571),
    [sym_false] = ACTIONS(571),
    [sym_null] = ACTIONS(571),
    [sym_inf] = ACTIONS(571),
    [sym_nan] = ACTIONS(571),
    [anon_sym_NA] = ACTIONS(573),
    [anon_sym_NA_integer_] = ACTIONS(573),
    [anon_sym_NA_real_] = ACTIONS(573),
    [anon_sym_NA_complex_] = ACTIONS(573),
    [anon_sym_NA_character_] = ACTIONS(573),
    [sym_dots] = ACTIONS(575),
    [sym_dot_dot_i] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(579),
    [sym__newline] = ACTIONS(581),
    [sym__raw_string_literal] = ACTIONS(583),
    [sym__external_open_parenthesis] = ACTIONS(585),
    [sym__external_open_brace] = ACTIONS(587),
    [sym__external_close_bracket] = ACTIONS(1009),
  },
  [611] = {
    [sym_function_definition] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_repeat_statement] = STATE(556),
    [sym_braced_expression] = STATE(556),
    [sym_parenthesized_expression] = STATE(556),
    [sym_call] = STATE(556),
    [sym_subset] = STATE(556),
    [sym_subset2] = STATE(556),
    [sym__argument] = STATE(1928),
    [sym_argument] = STATE(1930),
    [sym__argument_named] = STATE(1908),
    [sym__argument_unnamed] = STATE(1933),
    [sym__argument_value] = STATE(1936),
    [sym_unary_operator] = STATE(556),
    [sym_binary_operator] = STATE(556),
    [sym_extract_operator] = STATE(556),
    [sym_namespace_operator] = STATE(556),
    [sym_integer] = STATE(556),
    [sym_complex] = STATE(556),
    [sym_float] = STATE(556),
    [sym__float_literal] = STATE(710),
    [sym_string] = STATE(724),
    [sym__single_quoted_string] = STATE(725),
    [sym__double_quoted_string] = STATE(700),
    [sym_na] = STATE(556),
    [sym__expression] = STATE(556),
    [sym__string_or_identifier] = STATE(2142),
    [sym__open_parenthesis] = STATE(955),
    [sym__open_brace] = STATE(857),
    [sym__close_bracket2] = STATE(865),
    [aux_sym_call_arguments_repeat1] = STATE(453),
    [sym_identifier] = ACTIONS(591),
    [anon_sym_BSLASH] = ACTIONS(593),
    [anon_sym_function] = ACTIONS(595),
    [anon_sym_if] = ACTIONS(597),
    [anon_sym_for] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_repeat] = ACTIONS(603),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [sym__hex_literal] = ACTIONS(613),
    [sym__number_literal] = ACTIONS(615),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(619),
    [sym_return] = ACTIONS(621),
    [sym_next] = ACTIONS(621),
    [sym_break] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_null] = ACTIONS(621),
    [sym_inf] = ACTIONS(621),
    [sym_nan] = ACTIONS(621),
    [anon_sym_NA] = ACTIONS(623),
    [anon_sym_NA_integer_] = ACTIONS(623),
    [anon_sym_NA_real_] = ACTIONS(623),
    [anon_sym_NA_complex_] = ACTIONS(623),
    [anon_sym_NA_character_] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(629),
    [sym__newline] = ACTIONS(631),
    [sym__raw_string_literal] = ACTIONS(633),
    [sym__external_open_parenthesis] = ACTIONS(635),
    [sym__external_open_brace] = ACTIONS(637),
    [sym__external_close_bracket2] = ACTIONS(1011),
  },
  [612] = {
    [sym_function_definition] = STATE(429),
    [sym_if_statement] = STATE(429),
    [sym_for_statement] = STATE(429),
    [sym_while_statement] = STATE(429),
    [sym_repeat_statement] = STATE(429),
    [sym_braced_expression] = STATE(429),
    [sym_parenthesized_expression] = STATE(429),
    [sym_call] = STATE(429),
    [sym_subset] = STATE(429),
    [sym_subset2] = STATE(429),
    [sym__argument] = STATE(1912),
    [sym_argument] = STATE(1916),
    [sym__argument_named] = STATE(1919),
    [sym__argument_unnamed] = STATE(1921),
    [sym__argument_value] = STATE(1927),
    [sym_unary_operator] = STATE(429),
    [sym_binary_operator] = STATE(429),
    [sym_extract_operator] = STATE(429),
    [sym_namespace_operator] = STATE(429),
    [sym_integer] = STATE(429),
    [sym_complex] = STATE(429),
    [sym_float] = STATE(429),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(721),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(429),
    [sym__expression] = STATE(429),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(813),
    [sym__open_brace] = STATE(842),
    [aux_sym_call_arguments_repeat1] = STATE(647),
    [sym_identifier] = ACTIONS(737),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(767),
    [sym_next] = ACTIONS(767),
    [sym_break] = ACTIONS(767),
    [sym_true] = ACTIONS(767),
    [sym_false] = ACTIONS(767),
    [sym_null] = ACTIONS(767),
    [sym_inf] = ACTIONS(767),
    [sym_nan] = ACTIONS(767),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(771),
    [sym_dot_dot_i] = ACTIONS(773),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(775),
    [sym__newline] = ACTIONS(777),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1013),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [613] = {
    [sym_function_definition] = STATE(429),
    [sym_if_statement] = STATE(429),
    [sym_for_statement] = STATE(429),
    [sym_while_statement] = STATE(429),
    [sym_repeat_statement] = STATE(429),
    [sym_braced_expression] = STATE(429),
    [sym_parenthesized_expression] = STATE(429),
    [sym_call] = STATE(429),
    [sym_subset] = STATE(429),
    [sym_subset2] = STATE(429),
    [sym__argument] = STATE(1912),
    [sym_argument] = STATE(1916),
    [sym__argument_named] = STATE(1919),
    [sym__argument_unnamed] = STATE(1921),
    [sym__argument_value] = STATE(1927),
    [sym_unary_operator] = STATE(429),
    [sym_binary_operator] = STATE(429),
    [sym_extract_operator] = STATE(429),
    [sym_namespace_operator] = STATE(429),
    [sym_integer] = STATE(429),
    [sym_complex] = STATE(429),
    [sym_float] = STATE(429),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(721),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(429),
    [sym__expression] = STATE(429),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(775),
    [sym__open_brace] = STATE(842),
    [aux_sym_call_arguments_repeat1] = STATE(612),
    [sym_identifier] = ACTIONS(737),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(767),
    [sym_next] = ACTIONS(767),
    [sym_break] = ACTIONS(767),
    [sym_true] = ACTIONS(767),
    [sym_false] = ACTIONS(767),
    [sym_null] = ACTIONS(767),
    [sym_inf] = ACTIONS(767),
    [sym_nan] = ACTIONS(767),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(771),
    [sym_dot_dot_i] = ACTIONS(773),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(775),
    [sym__newline] = ACTIONS(777),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1015),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [614] = {
    [sym_function_definition] = STATE(491),
    [sym_if_statement] = STATE(491),
    [sym_for_statement] = STATE(491),
    [sym_while_statement] = STATE(491),
    [sym_repeat_statement] = STATE(491),
    [sym_braced_expression] = STATE(491),
    [sym_parenthesized_expression] = STATE(491),
    [sym_call] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_subset2] = STATE(491),
    [sym__argument] = STATE(1934),
    [sym_argument] = STATE(1937),
    [sym__argument_named] = STATE(1909),
    [sym__argument_unnamed] = STATE(1932),
    [sym__argument_value] = STATE(1920),
    [sym_unary_operator] = STATE(491),
    [sym_binary_operator] = STATE(491),
    [sym_extract_operator] = STATE(491),
    [sym_namespace_operator] = STATE(491),
    [sym_integer] = STATE(491),
    [sym_complex] = STATE(491),
    [sym_float] = STATE(491),
    [sym__float_literal] = STATE(734),
    [sym_string] = STATE(728),
    [sym__single_quoted_string] = STATE(735),
    [sym__double_quoted_string] = STATE(736),
    [sym_na] = STATE(491),
    [sym__expression] = STATE(491),
    [sym__string_or_identifier] = STATE(2143),
    [sym__open_parenthesis] = STATE(948),
    [sym__open_brace] = STATE(751),
    [sym__close_bracket] = STATE(776),
    [aux_sym_call_arguments_repeat1] = STATE(483),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_BSLASH] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_if] = ACTIONS(547),
    [anon_sym_for] = ACTIONS(549),
    [anon_sym_while] = ACTIONS(551),
    [anon_sym_repeat] = ACTIONS(553),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(557),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [sym__hex_literal] = ACTIONS(563),
    [sym__number_literal] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [sym_return] = ACTIONS(571),
    [sym_next] = ACTIONS(571),
    [sym_break] = ACTIONS(571),
    [sym_true] = ACTIONS(571),
    [sym_false] = ACTIONS(571),
    [sym_null] = ACTIONS(571),
    [sym_inf] = ACTIONS(571),
    [sym_nan] = ACTIONS(571),
    [anon_sym_NA] = ACTIONS(573),
    [anon_sym_NA_integer_] = ACTIONS(573),
    [anon_sym_NA_real_] = ACTIONS(573),
    [anon_sym_NA_complex_] = ACTIONS(573),
    [anon_sym_NA_character_] = ACTIONS(573),
    [sym_dots] = ACTIONS(575),
    [sym_dot_dot_i] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(579),
    [sym__newline] = ACTIONS(581),
    [sym__raw_string_literal] = ACTIONS(583),
    [sym__external_open_parenthesis] = ACTIONS(585),
    [sym__external_open_brace] = ACTIONS(587),
    [sym__external_close_bracket] = ACTIONS(1017),
  },
  [615] = {
    [sym_function_definition] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_repeat_statement] = STATE(556),
    [sym_braced_expression] = STATE(556),
    [sym_parenthesized_expression] = STATE(556),
    [sym_call] = STATE(556),
    [sym_subset] = STATE(556),
    [sym_subset2] = STATE(556),
    [sym__argument] = STATE(1928),
    [sym_argument] = STATE(1930),
    [sym__argument_named] = STATE(1908),
    [sym__argument_unnamed] = STATE(1933),
    [sym__argument_value] = STATE(1936),
    [sym_unary_operator] = STATE(556),
    [sym_binary_operator] = STATE(556),
    [sym_extract_operator] = STATE(556),
    [sym_namespace_operator] = STATE(556),
    [sym_integer] = STATE(556),
    [sym_complex] = STATE(556),
    [sym_float] = STATE(556),
    [sym__float_literal] = STATE(710),
    [sym_string] = STATE(724),
    [sym__single_quoted_string] = STATE(725),
    [sym__double_quoted_string] = STATE(700),
    [sym_na] = STATE(556),
    [sym__expression] = STATE(556),
    [sym__string_or_identifier] = STATE(2142),
    [sym__open_parenthesis] = STATE(955),
    [sym__open_brace] = STATE(857),
    [sym__close_bracket2] = STATE(779),
    [aux_sym_call_arguments_repeat1] = STATE(484),
    [sym_identifier] = ACTIONS(591),
    [anon_sym_BSLASH] = ACTIONS(593),
    [anon_sym_function] = ACTIONS(595),
    [anon_sym_if] = ACTIONS(597),
    [anon_sym_for] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_repeat] = ACTIONS(603),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [sym__hex_literal] = ACTIONS(613),
    [sym__number_literal] = ACTIONS(615),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(619),
    [sym_return] = ACTIONS(621),
    [sym_next] = ACTIONS(621),
    [sym_break] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_null] = ACTIONS(621),
    [sym_inf] = ACTIONS(621),
    [sym_nan] = ACTIONS(621),
    [anon_sym_NA] = ACTIONS(623),
    [anon_sym_NA_integer_] = ACTIONS(623),
    [anon_sym_NA_real_] = ACTIONS(623),
    [anon_sym_NA_complex_] = ACTIONS(623),
    [anon_sym_NA_character_] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(629),
    [sym__newline] = ACTIONS(631),
    [sym__raw_string_literal] = ACTIONS(633),
    [sym__external_open_parenthesis] = ACTIONS(635),
    [sym__external_open_brace] = ACTIONS(637),
    [sym__external_close_bracket2] = ACTIONS(1019),
  },
  [616] = {
    [sym_function_definition] = STATE(429),
    [sym_if_statement] = STATE(429),
    [sym_for_statement] = STATE(429),
    [sym_while_statement] = STATE(429),
    [sym_repeat_statement] = STATE(429),
    [sym_braced_expression] = STATE(429),
    [sym_parenthesized_expression] = STATE(429),
    [sym_call] = STATE(429),
    [sym_subset] = STATE(429),
    [sym_subset2] = STATE(429),
    [sym__argument] = STATE(1912),
    [sym_argument] = STATE(1916),
    [sym__argument_named] = STATE(1919),
    [sym__argument_unnamed] = STATE(1921),
    [sym__argument_value] = STATE(1927),
    [sym_unary_operator] = STATE(429),
    [sym_binary_operator] = STATE(429),
    [sym_extract_operator] = STATE(429),
    [sym_namespace_operator] = STATE(429),
    [sym_integer] = STATE(429),
    [sym_complex] = STATE(429),
    [sym_float] = STATE(429),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(721),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(429),
    [sym__expression] = STATE(429),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(1962),
    [sym__open_brace] = STATE(842),
    [aux_sym_call_arguments_repeat1] = STATE(647),
    [sym_identifier] = ACTIONS(737),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(767),
    [sym_next] = ACTIONS(767),
    [sym_break] = ACTIONS(767),
    [sym_true] = ACTIONS(767),
    [sym_false] = ACTIONS(767),
    [sym_null] = ACTIONS(767),
    [sym_inf] = ACTIONS(767),
    [sym_nan] = ACTIONS(767),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(771),
    [sym_dot_dot_i] = ACTIONS(773),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(775),
    [sym__newline] = ACTIONS(777),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1021),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [617] = {
    [sym_function_definition] = STATE(429),
    [sym_if_statement] = STATE(429),
    [sym_for_statement] = STATE(429),
    [sym_while_statement] = STATE(429),
    [sym_repeat_statement] = STATE(429),
    [sym_braced_expression] = STATE(429),
    [sym_parenthesized_expression] = STATE(429),
    [sym_call] = STATE(429),
    [sym_subset] = STATE(429),
    [sym_subset2] = STATE(429),
    [sym__argument] = STATE(1912),
    [sym_argument] = STATE(1916),
    [sym__argument_named] = STATE(1919),
    [sym__argument_unnamed] = STATE(1921),
    [sym__argument_value] = STATE(1927),
    [sym_unary_operator] = STATE(429),
    [sym_binary_operator] = STATE(429),
    [sym_extract_operator] = STATE(429),
    [sym_namespace_operator] = STATE(429),
    [sym_integer] = STATE(429),
    [sym_complex] = STATE(429),
    [sym_float] = STATE(429),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(721),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(429),
    [sym__expression] = STATE(429),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(1967),
    [sym__open_brace] = STATE(842),
    [aux_sym_call_arguments_repeat1] = STATE(616),
    [sym_identifier] = ACTIONS(737),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(767),
    [sym_next] = ACTIONS(767),
    [sym_break] = ACTIONS(767),
    [sym_true] = ACTIONS(767),
    [sym_false] = ACTIONS(767),
    [sym_null] = ACTIONS(767),
    [sym_inf] = ACTIONS(767),
    [sym_nan] = ACTIONS(767),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(771),
    [sym_dot_dot_i] = ACTIONS(773),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(775),
    [sym__newline] = ACTIONS(777),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1023),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [618] = {
    [sym_function_definition] = STATE(491),
    [sym_if_statement] = STATE(491),
    [sym_for_statement] = STATE(491),
    [sym_while_statement] = STATE(491),
    [sym_repeat_statement] = STATE(491),
    [sym_braced_expression] = STATE(491),
    [sym_parenthesized_expression] = STATE(491),
    [sym_call] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_subset2] = STATE(491),
    [sym__argument] = STATE(1934),
    [sym_argument] = STATE(1937),
    [sym__argument_named] = STATE(1909),
    [sym__argument_unnamed] = STATE(1932),
    [sym__argument_value] = STATE(1920),
    [sym_unary_operator] = STATE(491),
    [sym_binary_operator] = STATE(491),
    [sym_extract_operator] = STATE(491),
    [sym_namespace_operator] = STATE(491),
    [sym_integer] = STATE(491),
    [sym_complex] = STATE(491),
    [sym_float] = STATE(491),
    [sym__float_literal] = STATE(734),
    [sym_string] = STATE(728),
    [sym__single_quoted_string] = STATE(735),
    [sym__double_quoted_string] = STATE(736),
    [sym_na] = STATE(491),
    [sym__expression] = STATE(491),
    [sym__string_or_identifier] = STATE(2143),
    [sym__open_parenthesis] = STATE(948),
    [sym__open_brace] = STATE(751),
    [sym__close_bracket] = STATE(1951),
    [aux_sym_call_arguments_repeat1] = STATE(501),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_BSLASH] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_if] = ACTIONS(547),
    [anon_sym_for] = ACTIONS(549),
    [anon_sym_while] = ACTIONS(551),
    [anon_sym_repeat] = ACTIONS(553),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(557),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [sym__hex_literal] = ACTIONS(563),
    [sym__number_literal] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [sym_return] = ACTIONS(571),
    [sym_next] = ACTIONS(571),
    [sym_break] = ACTIONS(571),
    [sym_true] = ACTIONS(571),
    [sym_false] = ACTIONS(571),
    [sym_null] = ACTIONS(571),
    [sym_inf] = ACTIONS(571),
    [sym_nan] = ACTIONS(571),
    [anon_sym_NA] = ACTIONS(573),
    [anon_sym_NA_integer_] = ACTIONS(573),
    [anon_sym_NA_real_] = ACTIONS(573),
    [anon_sym_NA_complex_] = ACTIONS(573),
    [anon_sym_NA_character_] = ACTIONS(573),
    [sym_dots] = ACTIONS(575),
    [sym_dot_dot_i] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(579),
    [sym__newline] = ACTIONS(581),
    [sym__raw_string_literal] = ACTIONS(583),
    [sym__external_open_parenthesis] = ACTIONS(585),
    [sym__external_open_brace] = ACTIONS(587),
    [sym__external_close_bracket] = ACTIONS(1025),
  },
  [619] = {
    [sym_function_definition] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_repeat_statement] = STATE(556),
    [sym_braced_expression] = STATE(556),
    [sym_parenthesized_expression] = STATE(556),
    [sym_call] = STATE(556),
    [sym_subset] = STATE(556),
    [sym_subset2] = STATE(556),
    [sym__argument] = STATE(1928),
    [sym_argument] = STATE(1930),
    [sym__argument_named] = STATE(1908),
    [sym__argument_unnamed] = STATE(1933),
    [sym__argument_value] = STATE(1936),
    [sym_unary_operator] = STATE(556),
    [sym_binary_operator] = STATE(556),
    [sym_extract_operator] = STATE(556),
    [sym_namespace_operator] = STATE(556),
    [sym_integer] = STATE(556),
    [sym_complex] = STATE(556),
    [sym_float] = STATE(556),
    [sym__float_literal] = STATE(710),
    [sym_string] = STATE(724),
    [sym__single_quoted_string] = STATE(725),
    [sym__double_quoted_string] = STATE(700),
    [sym_na] = STATE(556),
    [sym__expression] = STATE(556),
    [sym__string_or_identifier] = STATE(2142),
    [sym__open_parenthesis] = STATE(955),
    [sym__open_brace] = STATE(857),
    [sym__close_bracket2] = STATE(1961),
    [aux_sym_call_arguments_repeat1] = STATE(502),
    [sym_identifier] = ACTIONS(591),
    [anon_sym_BSLASH] = ACTIONS(593),
    [anon_sym_function] = ACTIONS(595),
    [anon_sym_if] = ACTIONS(597),
    [anon_sym_for] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_repeat] = ACTIONS(603),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [sym__hex_literal] = ACTIONS(613),
    [sym__number_literal] = ACTIONS(615),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(619),
    [sym_return] = ACTIONS(621),
    [sym_next] = ACTIONS(621),
    [sym_break] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_null] = ACTIONS(621),
    [sym_inf] = ACTIONS(621),
    [sym_nan] = ACTIONS(621),
    [anon_sym_NA] = ACTIONS(623),
    [anon_sym_NA_integer_] = ACTIONS(623),
    [anon_sym_NA_real_] = ACTIONS(623),
    [anon_sym_NA_complex_] = ACTIONS(623),
    [anon_sym_NA_character_] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(629),
    [sym__newline] = ACTIONS(631),
    [sym__raw_string_literal] = ACTIONS(633),
    [sym__external_open_parenthesis] = ACTIONS(635),
    [sym__external_open_brace] = ACTIONS(637),
    [sym__external_close_bracket2] = ACTIONS(1027),
  },
  [620] = {
    [sym_function_definition] = STATE(429),
    [sym_if_statement] = STATE(429),
    [sym_for_statement] = STATE(429),
    [sym_while_statement] = STATE(429),
    [sym_repeat_statement] = STATE(429),
    [sym_braced_expression] = STATE(429),
    [sym_parenthesized_expression] = STATE(429),
    [sym_call] = STATE(429),
    [sym_subset] = STATE(429),
    [sym_subset2] = STATE(429),
    [sym__argument] = STATE(1912),
    [sym_argument] = STATE(1916),
    [sym__argument_named] = STATE(1919),
    [sym__argument_unnamed] = STATE(1921),
    [sym__argument_value] = STATE(1927),
    [sym_unary_operator] = STATE(429),
    [sym_binary_operator] = STATE(429),
    [sym_extract_operator] = STATE(429),
    [sym_namespace_operator] = STATE(429),
    [sym_integer] = STATE(429),
    [sym_complex] = STATE(429),
    [sym_float] = STATE(429),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(721),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(429),
    [sym__expression] = STATE(429),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(781),
    [sym__open_brace] = STATE(842),
    [aux_sym_call_arguments_repeat1] = STATE(647),
    [sym_identifier] = ACTIONS(737),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(767),
    [sym_next] = ACTIONS(767),
    [sym_break] = ACTIONS(767),
    [sym_true] = ACTIONS(767),
    [sym_false] = ACTIONS(767),
    [sym_null] = ACTIONS(767),
    [sym_inf] = ACTIONS(767),
    [sym_nan] = ACTIONS(767),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(771),
    [sym_dot_dot_i] = ACTIONS(773),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(775),
    [sym__newline] = ACTIONS(777),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1029),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [621] = {
    [sym_function_definition] = STATE(429),
    [sym_if_statement] = STATE(429),
    [sym_for_statement] = STATE(429),
    [sym_while_statement] = STATE(429),
    [sym_repeat_statement] = STATE(429),
    [sym_braced_expression] = STATE(429),
    [sym_parenthesized_expression] = STATE(429),
    [sym_call] = STATE(429),
    [sym_subset] = STATE(429),
    [sym_subset2] = STATE(429),
    [sym__argument] = STATE(1912),
    [sym_argument] = STATE(1916),
    [sym__argument_named] = STATE(1919),
    [sym__argument_unnamed] = STATE(1921),
    [sym__argument_value] = STATE(1927),
    [sym_unary_operator] = STATE(429),
    [sym_binary_operator] = STATE(429),
    [sym_extract_operator] = STATE(429),
    [sym_namespace_operator] = STATE(429),
    [sym_integer] = STATE(429),
    [sym_complex] = STATE(429),
    [sym_float] = STATE(429),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(721),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(429),
    [sym__expression] = STATE(429),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(763),
    [sym__open_brace] = STATE(842),
    [aux_sym_call_arguments_repeat1] = STATE(620),
    [sym_identifier] = ACTIONS(737),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(767),
    [sym_next] = ACTIONS(767),
    [sym_break] = ACTIONS(767),
    [sym_true] = ACTIONS(767),
    [sym_false] = ACTIONS(767),
    [sym_null] = ACTIONS(767),
    [sym_inf] = ACTIONS(767),
    [sym_nan] = ACTIONS(767),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(771),
    [sym_dot_dot_i] = ACTIONS(773),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(775),
    [sym__newline] = ACTIONS(777),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1031),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [622] = {
    [sym_function_definition] = STATE(491),
    [sym_if_statement] = STATE(491),
    [sym_for_statement] = STATE(491),
    [sym_while_statement] = STATE(491),
    [sym_repeat_statement] = STATE(491),
    [sym_braced_expression] = STATE(491),
    [sym_parenthesized_expression] = STATE(491),
    [sym_call] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_subset2] = STATE(491),
    [sym__argument] = STATE(1934),
    [sym_argument] = STATE(1937),
    [sym__argument_named] = STATE(1909),
    [sym__argument_unnamed] = STATE(1932),
    [sym__argument_value] = STATE(1920),
    [sym_unary_operator] = STATE(491),
    [sym_binary_operator] = STATE(491),
    [sym_extract_operator] = STATE(491),
    [sym_namespace_operator] = STATE(491),
    [sym_integer] = STATE(491),
    [sym_complex] = STATE(491),
    [sym_float] = STATE(491),
    [sym__float_literal] = STATE(734),
    [sym_string] = STATE(728),
    [sym__single_quoted_string] = STATE(735),
    [sym__double_quoted_string] = STATE(736),
    [sym_na] = STATE(491),
    [sym__expression] = STATE(491),
    [sym__string_or_identifier] = STATE(2143),
    [sym__open_parenthesis] = STATE(948),
    [sym__open_brace] = STATE(751),
    [sym__close_bracket] = STATE(764),
    [aux_sym_call_arguments_repeat1] = STATE(520),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_BSLASH] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_if] = ACTIONS(547),
    [anon_sym_for] = ACTIONS(549),
    [anon_sym_while] = ACTIONS(551),
    [anon_sym_repeat] = ACTIONS(553),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(557),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [sym__hex_literal] = ACTIONS(563),
    [sym__number_literal] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [sym_return] = ACTIONS(571),
    [sym_next] = ACTIONS(571),
    [sym_break] = ACTIONS(571),
    [sym_true] = ACTIONS(571),
    [sym_false] = ACTIONS(571),
    [sym_null] = ACTIONS(571),
    [sym_inf] = ACTIONS(571),
    [sym_nan] = ACTIONS(571),
    [anon_sym_NA] = ACTIONS(573),
    [anon_sym_NA_integer_] = ACTIONS(573),
    [anon_sym_NA_real_] = ACTIONS(573),
    [anon_sym_NA_complex_] = ACTIONS(573),
    [anon_sym_NA_character_] = ACTIONS(573),
    [sym_dots] = ACTIONS(575),
    [sym_dot_dot_i] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(579),
    [sym__newline] = ACTIONS(581),
    [sym__raw_string_literal] = ACTIONS(583),
    [sym__external_open_parenthesis] = ACTIONS(585),
    [sym__external_open_brace] = ACTIONS(587),
    [sym__external_close_bracket] = ACTIONS(1033),
  },
  [623] = {
    [sym_function_definition] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_repeat_statement] = STATE(556),
    [sym_braced_expression] = STATE(556),
    [sym_parenthesized_expression] = STATE(556),
    [sym_call] = STATE(556),
    [sym_subset] = STATE(556),
    [sym_subset2] = STATE(556),
    [sym__argument] = STATE(1928),
    [sym_argument] = STATE(1930),
    [sym__argument_named] = STATE(1908),
    [sym__argument_unnamed] = STATE(1933),
    [sym__argument_value] = STATE(1936),
    [sym_unary_operator] = STATE(556),
    [sym_binary_operator] = STATE(556),
    [sym_extract_operator] = STATE(556),
    [sym_namespace_operator] = STATE(556),
    [sym_integer] = STATE(556),
    [sym_complex] = STATE(556),
    [sym_float] = STATE(556),
    [sym__float_literal] = STATE(710),
    [sym_string] = STATE(724),
    [sym__single_quoted_string] = STATE(725),
    [sym__double_quoted_string] = STATE(700),
    [sym_na] = STATE(556),
    [sym__expression] = STATE(556),
    [sym__string_or_identifier] = STATE(2142),
    [sym__open_parenthesis] = STATE(955),
    [sym__open_brace] = STATE(857),
    [sym__close_bracket2] = STATE(766),
    [aux_sym_call_arguments_repeat1] = STATE(521),
    [sym_identifier] = ACTIONS(591),
    [anon_sym_BSLASH] = ACTIONS(593),
    [anon_sym_function] = ACTIONS(595),
    [anon_sym_if] = ACTIONS(597),
    [anon_sym_for] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_repeat] = ACTIONS(603),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [sym__hex_literal] = ACTIONS(613),
    [sym__number_literal] = ACTIONS(615),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(619),
    [sym_return] = ACTIONS(621),
    [sym_next] = ACTIONS(621),
    [sym_break] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_null] = ACTIONS(621),
    [sym_inf] = ACTIONS(621),
    [sym_nan] = ACTIONS(621),
    [anon_sym_NA] = ACTIONS(623),
    [anon_sym_NA_integer_] = ACTIONS(623),
    [anon_sym_NA_real_] = ACTIONS(623),
    [anon_sym_NA_complex_] = ACTIONS(623),
    [anon_sym_NA_character_] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(629),
    [sym__newline] = ACTIONS(631),
    [sym__raw_string_literal] = ACTIONS(633),
    [sym__external_open_parenthesis] = ACTIONS(635),
    [sym__external_open_brace] = ACTIONS(637),
    [sym__external_close_bracket2] = ACTIONS(1035),
  },
  [624] = {
    [sym_function_definition] = STATE(429),
    [sym_if_statement] = STATE(429),
    [sym_for_statement] = STATE(429),
    [sym_while_statement] = STATE(429),
    [sym_repeat_statement] = STATE(429),
    [sym_braced_expression] = STATE(429),
    [sym_parenthesized_expression] = STATE(429),
    [sym_call] = STATE(429),
    [sym_subset] = STATE(429),
    [sym_subset2] = STATE(429),
    [sym__argument] = STATE(1912),
    [sym_argument] = STATE(1916),
    [sym__argument_named] = STATE(1919),
    [sym__argument_unnamed] = STATE(1921),
    [sym__argument_value] = STATE(1927),
    [sym_unary_operator] = STATE(429),
    [sym_binary_operator] = STATE(429),
    [sym_extract_operator] = STATE(429),
    [sym_namespace_operator] = STATE(429),
    [sym_integer] = STATE(429),
    [sym_complex] = STATE(429),
    [sym_float] = STATE(429),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(721),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(429),
    [sym__expression] = STATE(429),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(830),
    [sym__open_brace] = STATE(842),
    [aux_sym_call_arguments_repeat1] = STATE(647),
    [sym_identifier] = ACTIONS(737),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(767),
    [sym_next] = ACTIONS(767),
    [sym_break] = ACTIONS(767),
    [sym_true] = ACTIONS(767),
    [sym_false] = ACTIONS(767),
    [sym_null] = ACTIONS(767),
    [sym_inf] = ACTIONS(767),
    [sym_nan] = ACTIONS(767),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(771),
    [sym_dot_dot_i] = ACTIONS(773),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(775),
    [sym__newline] = ACTIONS(777),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1037),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [625] = {
    [sym_function_definition] = STATE(429),
    [sym_if_statement] = STATE(429),
    [sym_for_statement] = STATE(429),
    [sym_while_statement] = STATE(429),
    [sym_repeat_statement] = STATE(429),
    [sym_braced_expression] = STATE(429),
    [sym_parenthesized_expression] = STATE(429),
    [sym_call] = STATE(429),
    [sym_subset] = STATE(429),
    [sym_subset2] = STATE(429),
    [sym__argument] = STATE(1912),
    [sym_argument] = STATE(1916),
    [sym__argument_named] = STATE(1919),
    [sym__argument_unnamed] = STATE(1921),
    [sym__argument_value] = STATE(1927),
    [sym_unary_operator] = STATE(429),
    [sym_binary_operator] = STATE(429),
    [sym_extract_operator] = STATE(429),
    [sym_namespace_operator] = STATE(429),
    [sym_integer] = STATE(429),
    [sym_complex] = STATE(429),
    [sym_float] = STATE(429),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(721),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(429),
    [sym__expression] = STATE(429),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(823),
    [sym__open_brace] = STATE(842),
    [aux_sym_call_arguments_repeat1] = STATE(624),
    [sym_identifier] = ACTIONS(737),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(767),
    [sym_next] = ACTIONS(767),
    [sym_break] = ACTIONS(767),
    [sym_true] = ACTIONS(767),
    [sym_false] = ACTIONS(767),
    [sym_null] = ACTIONS(767),
    [sym_inf] = ACTIONS(767),
    [sym_nan] = ACTIONS(767),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(771),
    [sym_dot_dot_i] = ACTIONS(773),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(775),
    [sym__newline] = ACTIONS(777),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1039),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [626] = {
    [sym_function_definition] = STATE(491),
    [sym_if_statement] = STATE(491),
    [sym_for_statement] = STATE(491),
    [sym_while_statement] = STATE(491),
    [sym_repeat_statement] = STATE(491),
    [sym_braced_expression] = STATE(491),
    [sym_parenthesized_expression] = STATE(491),
    [sym_call] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_subset2] = STATE(491),
    [sym__argument] = STATE(1934),
    [sym_argument] = STATE(1937),
    [sym__argument_named] = STATE(1909),
    [sym__argument_unnamed] = STATE(1932),
    [sym__argument_value] = STATE(1920),
    [sym_unary_operator] = STATE(491),
    [sym_binary_operator] = STATE(491),
    [sym_extract_operator] = STATE(491),
    [sym_namespace_operator] = STATE(491),
    [sym_integer] = STATE(491),
    [sym_complex] = STATE(491),
    [sym_float] = STATE(491),
    [sym__float_literal] = STATE(734),
    [sym_string] = STATE(728),
    [sym__single_quoted_string] = STATE(735),
    [sym__double_quoted_string] = STATE(736),
    [sym_na] = STATE(491),
    [sym__expression] = STATE(491),
    [sym__string_or_identifier] = STATE(2143),
    [sym__open_parenthesis] = STATE(948),
    [sym__open_brace] = STATE(751),
    [sym__close_bracket] = STATE(824),
    [aux_sym_call_arguments_repeat1] = STATE(553),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_BSLASH] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_if] = ACTIONS(547),
    [anon_sym_for] = ACTIONS(549),
    [anon_sym_while] = ACTIONS(551),
    [anon_sym_repeat] = ACTIONS(553),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(557),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [sym__hex_literal] = ACTIONS(563),
    [sym__number_literal] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [sym_return] = ACTIONS(571),
    [sym_next] = ACTIONS(571),
    [sym_break] = ACTIONS(571),
    [sym_true] = ACTIONS(571),
    [sym_false] = ACTIONS(571),
    [sym_null] = ACTIONS(571),
    [sym_inf] = ACTIONS(571),
    [sym_nan] = ACTIONS(571),
    [anon_sym_NA] = ACTIONS(573),
    [anon_sym_NA_integer_] = ACTIONS(573),
    [anon_sym_NA_real_] = ACTIONS(573),
    [anon_sym_NA_complex_] = ACTIONS(573),
    [anon_sym_NA_character_] = ACTIONS(573),
    [sym_dots] = ACTIONS(575),
    [sym_dot_dot_i] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(579),
    [sym__newline] = ACTIONS(581),
    [sym__raw_string_literal] = ACTIONS(583),
    [sym__external_open_parenthesis] = ACTIONS(585),
    [sym__external_open_brace] = ACTIONS(587),
    [sym__external_close_bracket] = ACTIONS(1041),
  },
  [627] = {
    [sym_function_definition] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_repeat_statement] = STATE(556),
    [sym_braced_expression] = STATE(556),
    [sym_parenthesized_expression] = STATE(556),
    [sym_call] = STATE(556),
    [sym_subset] = STATE(556),
    [sym_subset2] = STATE(556),
    [sym__argument] = STATE(1928),
    [sym_argument] = STATE(1930),
    [sym__argument_named] = STATE(1908),
    [sym__argument_unnamed] = STATE(1933),
    [sym__argument_value] = STATE(1936),
    [sym_unary_operator] = STATE(556),
    [sym_binary_operator] = STATE(556),
    [sym_extract_operator] = STATE(556),
    [sym_namespace_operator] = STATE(556),
    [sym_integer] = STATE(556),
    [sym_complex] = STATE(556),
    [sym_float] = STATE(556),
    [sym__float_literal] = STATE(710),
    [sym_string] = STATE(724),
    [sym__single_quoted_string] = STATE(725),
    [sym__double_quoted_string] = STATE(700),
    [sym_na] = STATE(556),
    [sym__expression] = STATE(556),
    [sym__string_or_identifier] = STATE(2142),
    [sym__open_parenthesis] = STATE(955),
    [sym__open_brace] = STATE(857),
    [sym__close_bracket2] = STATE(825),
    [aux_sym_call_arguments_repeat1] = STATE(554),
    [sym_identifier] = ACTIONS(591),
    [anon_sym_BSLASH] = ACTIONS(593),
    [anon_sym_function] = ACTIONS(595),
    [anon_sym_if] = ACTIONS(597),
    [anon_sym_for] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_repeat] = ACTIONS(603),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [sym__hex_literal] = ACTIONS(613),
    [sym__number_literal] = ACTIONS(615),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(619),
    [sym_return] = ACTIONS(621),
    [sym_next] = ACTIONS(621),
    [sym_break] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_null] = ACTIONS(621),
    [sym_inf] = ACTIONS(621),
    [sym_nan] = ACTIONS(621),
    [anon_sym_NA] = ACTIONS(623),
    [anon_sym_NA_integer_] = ACTIONS(623),
    [anon_sym_NA_real_] = ACTIONS(623),
    [anon_sym_NA_complex_] = ACTIONS(623),
    [anon_sym_NA_character_] = ACTIONS(623),
    [sym_dots] = ACTIONS(625),
    [sym_dot_dot_i] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(629),
    [sym__newline] = ACTIONS(631),
    [sym__raw_string_literal] = ACTIONS(633),
    [sym__external_open_parenthesis] = ACTIONS(635),
    [sym__external_open_brace] = ACTIONS(637),
    [sym__external_close_bracket2] = ACTIONS(1043),
  },
  [628] = {
    [sym_call_arguments] = STATE(963),
    [sym_subset_arguments] = STATE(968),
    [sym_subset2_arguments] = STATE(970),
    [sym__open_parenthesis] = STATE(589),
    [sym__open_bracket] = STATE(590),
    [sym__open_bracket2] = STATE(591),
    [sym_identifier] = ACTIONS(425),
    [anon_sym_BSLASH] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_repeat] = ACTIONS(425),
    [anon_sym_QMARK] = ACTIONS(423),
    [anon_sym_TILDE] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_LT_DASH] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_COLON_EQ] = ACTIONS(505),
    [anon_sym_DASH_GT] = ACTIONS(507),
    [anon_sym_DASH_GT_GT] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(527),
    [aux_sym_binary_operator_token1] = ACTIONS(529),
    [anon_sym_PIPE_GT] = ACTIONS(529),
    [anon_sym_COLON] = ACTIONS(531),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(423),
    [sym__number_literal] = ACTIONS(425),
    [anon_sym_SQUOTE] = ACTIONS(423),
    [anon_sym_DQUOTE] = ACTIONS(423),
    [sym_return] = ACTIONS(425),
    [sym_next] = ACTIONS(425),
    [sym_break] = ACTIONS(425),
    [sym_true] = ACTIONS(425),
    [sym_false] = ACTIONS(425),
    [sym_null] = ACTIONS(425),
    [sym_inf] = ACTIONS(425),
    [sym_nan] = ACTIONS(425),
    [anon_sym_NA] = ACTIONS(425),
    [anon_sym_NA_integer_] = ACTIONS(425),
    [anon_sym_NA_real_] = ACTIONS(425),
    [anon_sym_NA_complex_] = ACTIONS(425),
    [anon_sym_NA_character_] = ACTIONS(425),
    [sym_dots] = ACTIONS(425),
    [sym_dot_dot_i] = ACTIONS(423),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(423),
    [sym__semicolon] = ACTIONS(423),
    [sym__raw_string_literal] = ACTIONS(423),
    [sym__external_open_parenthesis] = ACTIONS(535),
    [sym__external_open_brace] = ACTIONS(423),
    [sym__external_close_brace] = ACTIONS(423),
    [sym__external_open_bracket] = ACTIONS(537),
    [sym__external_open_bracket2] = ACTIONS(539),
  },
  [629] = {
    [sym_string] = STATE(977),
    [sym__single_quoted_string] = STATE(735),
    [sym__double_quoted_string] = STATE(736),
    [sym__string_or_identifier] = STATE(977),
    [aux_sym_function_definition_repeat1] = STATE(843),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_BSLASH] = ACTIONS(811),
    [anon_sym_function] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(815),
    [anon_sym_if] = ACTIONS(815),
    [anon_sym_for] = ACTIONS(815),
    [anon_sym_while] = ACTIONS(815),
    [anon_sym_repeat] = ACTIONS(815),
    [anon_sym_QMARK] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(811),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_LT_DASH] = ACTIONS(811),
    [anon_sym_LT_LT_DASH] = ACTIONS(811),
    [anon_sym_COLON_EQ] = ACTIONS(811),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_DASH_GT_GT] = ACTIONS(811),
    [anon_sym_PIPE] = ACTIONS(815),
    [anon_sym_AMP] = ACTIONS(815),
    [anon_sym_PIPE_PIPE] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(811),
    [anon_sym_GT] = ACTIONS(815),
    [anon_sym_GT_EQ] = ACTIONS(811),
    [anon_sym_EQ_EQ] = ACTIONS(811),
    [anon_sym_BANG_EQ] = ACTIONS(811),
    [anon_sym_STAR] = ACTIONS(815),
    [anon_sym_SLASH] = ACTIONS(811),
    [anon_sym_STAR_STAR] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(811),
    [aux_sym_binary_operator_token1] = ACTIONS(811),
    [anon_sym_PIPE_GT] = ACTIONS(811),
    [anon_sym_COLON] = ACTIONS(815),
    [anon_sym_DOLLAR] = ACTIONS(811),
    [anon_sym_AT] = ACTIONS(811),
    [sym__hex_literal] = ACTIONS(811),
    [sym__number_literal] = ACTIONS(815),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [sym_return] = ACTIONS(815),
    [sym_next] = ACTIONS(815),
    [sym_break] = ACTIONS(815),
    [sym_true] = ACTIONS(815),
    [sym_false] = ACTIONS(815),
    [sym_null] = ACTIONS(815),
    [sym_inf] = ACTIONS(815),
    [sym_nan] = ACTIONS(815),
    [anon_sym_NA] = ACTIONS(815),
    [anon_sym_NA_integer_] = ACTIONS(815),
    [anon_sym_NA_real_] = ACTIONS(815),
    [anon_sym_NA_complex_] = ACTIONS(815),
    [anon_sym_NA_character_] = ACTIONS(815),
    [sym_dots] = ACTIONS(815),
    [sym_dot_dot_i] = ACTIONS(811),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(811),
    [sym__newline] = ACTIONS(811),
    [sym__raw_string_literal] = ACTIONS(583),
    [sym__external_open_parenthesis] = ACTIONS(811),
    [sym__external_open_brace] = ACTIONS(811),
    [sym__external_open_bracket] = ACTIONS(811),
    [sym__external_close_bracket] = ACTIONS(811),
    [sym__external_open_bracket2] = ACTIONS(811),
  },
  [630] = {
    [sym_string] = STATE(895),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym__string_or_identifier] = STATE(895),
    [aux_sym_function_definition_repeat1] = STATE(634),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_BSLASH] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(795),
    [anon_sym_EQ] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(795),
    [anon_sym_for] = ACTIONS(795),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_repeat] = ACTIONS(795),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(795),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LT_DASH] = ACTIONS(791),
    [anon_sym_LT_LT_DASH] = ACTIONS(791),
    [anon_sym_COLON_EQ] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_DASH_GT_GT] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(795),
    [anon_sym_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [anon_sym_LT] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_GT] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(791),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_BANG_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(795),
    [anon_sym_SLASH] = ACTIONS(791),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [aux_sym_binary_operator_token1] = ACTIONS(791),
    [anon_sym_PIPE_GT] = ACTIONS(791),
    [anon_sym_COLON] = ACTIONS(795),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [anon_sym_AT] = ACTIONS(791),
    [sym__hex_literal] = ACTIONS(791),
    [sym__number_literal] = ACTIONS(795),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(795),
    [sym_next] = ACTIONS(795),
    [sym_break] = ACTIONS(795),
    [sym_true] = ACTIONS(795),
    [sym_false] = ACTIONS(795),
    [sym_null] = ACTIONS(795),
    [sym_inf] = ACTIONS(795),
    [sym_nan] = ACTIONS(795),
    [anon_sym_NA] = ACTIONS(795),
    [anon_sym_NA_integer_] = ACTIONS(795),
    [anon_sym_NA_real_] = ACTIONS(795),
    [anon_sym_NA_complex_] = ACTIONS(795),
    [anon_sym_NA_character_] = ACTIONS(795),
    [sym_dots] = ACTIONS(795),
    [sym_dot_dot_i] = ACTIONS(791),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(791),
    [sym__newline] = ACTIONS(1049),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(791),
    [sym__external_close_parenthesis] = ACTIONS(791),
    [sym__external_open_brace] = ACTIONS(791),
    [sym__external_open_bracket] = ACTIONS(791),
    [sym__external_open_bracket2] = ACTIONS(791),
  },
  [631] = {
    [sym_call_arguments] = STATE(942),
    [sym_subset_arguments] = STATE(903),
    [sym_subset2_arguments] = STATE(929),
    [sym__open_parenthesis] = STATE(571),
    [sym__open_bracket] = STATE(572),
    [sym__open_bracket2] = STATE(573),
    [sym_identifier] = ACTIONS(1051),
    [anon_sym_BSLASH] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_repeat] = ACTIONS(1051),
    [anon_sym_QMARK] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_LT_DASH] = ACTIONS(835),
    [anon_sym_LT_LT_DASH] = ACTIONS(835),
    [anon_sym_COLON_EQ] = ACTIONS(835),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_DASH_GT_GT] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_GT] = ACTIONS(849),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_SLASH] = ACTIONS(855),
    [anon_sym_STAR_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [aux_sym_binary_operator_token1] = ACTIONS(859),
    [anon_sym_PIPE_GT] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(1053),
    [sym__number_literal] = ACTIONS(1051),
    [anon_sym_SQUOTE] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [sym_return] = ACTIONS(1051),
    [sym_next] = ACTIONS(1051),
    [sym_break] = ACTIONS(1051),
    [sym_true] = ACTIONS(1051),
    [sym_false] = ACTIONS(1051),
    [sym_null] = ACTIONS(1051),
    [sym_inf] = ACTIONS(1051),
    [sym_nan] = ACTIONS(1051),
    [anon_sym_NA] = ACTIONS(1051),
    [anon_sym_NA_integer_] = ACTIONS(1051),
    [anon_sym_NA_real_] = ACTIONS(1051),
    [anon_sym_NA_complex_] = ACTIONS(1051),
    [anon_sym_NA_character_] = ACTIONS(1051),
    [sym_dots] = ACTIONS(1051),
    [sym_dot_dot_i] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1053),
    [sym__raw_string_literal] = ACTIONS(1053),
    [sym__external_open_parenthesis] = ACTIONS(865),
    [sym__external_close_parenthesis] = ACTIONS(1053),
    [sym__external_open_brace] = ACTIONS(1053),
    [sym__external_open_bracket] = ACTIONS(867),
    [sym__external_open_bracket2] = ACTIONS(869),
  },
  [632] = {
    [sym_string] = STATE(788),
    [sym__single_quoted_string] = STATE(661),
    [sym__double_quoted_string] = STATE(686),
    [sym__string_or_identifier] = STATE(788),
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_BSLASH] = ACTIONS(1057),
    [anon_sym_function] = ACTIONS(1059),
    [anon_sym_EQ] = ACTIONS(1059),
    [anon_sym_if] = ACTIONS(1059),
    [anon_sym_for] = ACTIONS(1059),
    [anon_sym_while] = ACTIONS(1059),
    [anon_sym_repeat] = ACTIONS(1059),
    [anon_sym_QMARK] = ACTIONS(1057),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_COLON_EQ] = ACTIONS(1057),
    [anon_sym_DASH_GT] = ACTIONS(1059),
    [anon_sym_DASH_GT_GT] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_LT_EQ] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1057),
    [anon_sym_EQ_EQ] = ACTIONS(1057),
    [anon_sym_BANG_EQ] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_STAR_STAR] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [aux_sym_binary_operator_token1] = ACTIONS(1057),
    [anon_sym_PIPE_GT] = ACTIONS(1057),
    [anon_sym_COLON] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1057),
    [anon_sym_AT] = ACTIONS(1057),
    [sym__hex_literal] = ACTIONS(1057),
    [sym__number_literal] = ACTIONS(1059),
    [anon_sym_SQUOTE] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [sym_return] = ACTIONS(1059),
    [sym_next] = ACTIONS(1059),
    [sym_break] = ACTIONS(1059),
    [sym_true] = ACTIONS(1059),
    [sym_false] = ACTIONS(1059),
    [sym_null] = ACTIONS(1059),
    [sym_inf] = ACTIONS(1059),
    [sym_nan] = ACTIONS(1059),
    [anon_sym_NA] = ACTIONS(1059),
    [anon_sym_NA_integer_] = ACTIONS(1059),
    [anon_sym_NA_real_] = ACTIONS(1059),
    [anon_sym_NA_complex_] = ACTIONS(1059),
    [anon_sym_NA_character_] = ACTIONS(1059),
    [sym_dots] = ACTIONS(1059),
    [sym_dot_dot_i] = ACTIONS(1057),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1057),
    [sym__semicolon] = ACTIONS(1057),
    [sym__raw_string_literal] = ACTIONS(901),
    [sym__external_else] = ACTIONS(1057),
    [sym__external_open_parenthesis] = ACTIONS(1057),
    [sym__external_open_brace] = ACTIONS(1057),
    [sym__external_close_brace] = ACTIONS(1057),
    [sym__external_open_bracket] = ACTIONS(1057),
    [sym__external_open_bracket2] = ACTIONS(1057),
  },
  [633] = {
    [sym_string] = STATE(784),
    [sym__single_quoted_string] = STATE(679),
    [sym__double_quoted_string] = STATE(680),
    [sym__string_or_identifier] = STATE(784),
    [ts_builtin_sym_end] = ACTIONS(1057),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_BSLASH] = ACTIONS(1057),
    [anon_sym_function] = ACTIONS(1059),
    [anon_sym_EQ] = ACTIONS(1059),
    [anon_sym_if] = ACTIONS(1059),
    [anon_sym_for] = ACTIONS(1059),
    [anon_sym_while] = ACTIONS(1059),
    [anon_sym_repeat] = ACTIONS(1059),
    [anon_sym_QMARK] = ACTIONS(1057),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_COLON_EQ] = ACTIONS(1057),
    [anon_sym_DASH_GT] = ACTIONS(1059),
    [anon_sym_DASH_GT_GT] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_LT_EQ] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1057),
    [anon_sym_EQ_EQ] = ACTIONS(1057),
    [anon_sym_BANG_EQ] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_STAR_STAR] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [aux_sym_binary_operator_token1] = ACTIONS(1057),
    [anon_sym_PIPE_GT] = ACTIONS(1057),
    [anon_sym_COLON] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1057),
    [anon_sym_AT] = ACTIONS(1057),
    [sym__hex_literal] = ACTIONS(1057),
    [sym__number_literal] = ACTIONS(1059),
    [anon_sym_SQUOTE] = ACTIONS(797),
    [anon_sym_DQUOTE] = ACTIONS(799),
    [sym_return] = ACTIONS(1059),
    [sym_next] = ACTIONS(1059),
    [sym_break] = ACTIONS(1059),
    [sym_true] = ACTIONS(1059),
    [sym_false] = ACTIONS(1059),
    [sym_null] = ACTIONS(1059),
    [sym_inf] = ACTIONS(1059),
    [sym_nan] = ACTIONS(1059),
    [anon_sym_NA] = ACTIONS(1059),
    [anon_sym_NA_integer_] = ACTIONS(1059),
    [anon_sym_NA_real_] = ACTIONS(1059),
    [anon_sym_NA_complex_] = ACTIONS(1059),
    [anon_sym_NA_character_] = ACTIONS(1059),
    [sym_dots] = ACTIONS(1059),
    [sym_dot_dot_i] = ACTIONS(1057),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1057),
    [sym__semicolon] = ACTIONS(1057),
    [sym__raw_string_literal] = ACTIONS(803),
    [sym__external_else] = ACTIONS(1057),
    [sym__external_open_parenthesis] = ACTIONS(1057),
    [sym__external_open_brace] = ACTIONS(1057),
    [sym__external_open_bracket] = ACTIONS(1057),
    [sym__external_open_bracket2] = ACTIONS(1057),
  },
  [634] = {
    [sym_string] = STATE(913),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym__string_or_identifier] = STATE(913),
    [aux_sym_function_definition_repeat1] = STATE(796),
    [sym_identifier] = ACTIONS(1063),
    [anon_sym_BSLASH] = ACTIONS(811),
    [anon_sym_function] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(815),
    [anon_sym_if] = ACTIONS(815),
    [anon_sym_for] = ACTIONS(815),
    [anon_sym_while] = ACTIONS(815),
    [anon_sym_repeat] = ACTIONS(815),
    [anon_sym_QMARK] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(811),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_LT_DASH] = ACTIONS(811),
    [anon_sym_LT_LT_DASH] = ACTIONS(811),
    [anon_sym_COLON_EQ] = ACTIONS(811),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_DASH_GT_GT] = ACTIONS(811),
    [anon_sym_PIPE] = ACTIONS(815),
    [anon_sym_AMP] = ACTIONS(815),
    [anon_sym_PIPE_PIPE] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(811),
    [anon_sym_GT] = ACTIONS(815),
    [anon_sym_GT_EQ] = ACTIONS(811),
    [anon_sym_EQ_EQ] = ACTIONS(811),
    [anon_sym_BANG_EQ] = ACTIONS(811),
    [anon_sym_STAR] = ACTIONS(815),
    [anon_sym_SLASH] = ACTIONS(811),
    [anon_sym_STAR_STAR] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(811),
    [aux_sym_binary_operator_token1] = ACTIONS(811),
    [anon_sym_PIPE_GT] = ACTIONS(811),
    [anon_sym_COLON] = ACTIONS(815),
    [anon_sym_DOLLAR] = ACTIONS(811),
    [anon_sym_AT] = ACTIONS(811),
    [sym__hex_literal] = ACTIONS(811),
    [sym__number_literal] = ACTIONS(815),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(815),
    [sym_next] = ACTIONS(815),
    [sym_break] = ACTIONS(815),
    [sym_true] = ACTIONS(815),
    [sym_false] = ACTIONS(815),
    [sym_null] = ACTIONS(815),
    [sym_inf] = ACTIONS(815),
    [sym_nan] = ACTIONS(815),
    [anon_sym_NA] = ACTIONS(815),
    [anon_sym_NA_integer_] = ACTIONS(815),
    [anon_sym_NA_real_] = ACTIONS(815),
    [anon_sym_NA_complex_] = ACTIONS(815),
    [anon_sym_NA_character_] = ACTIONS(815),
    [sym_dots] = ACTIONS(815),
    [sym_dot_dot_i] = ACTIONS(811),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(811),
    [sym__newline] = ACTIONS(811),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(811),
    [sym__external_close_parenthesis] = ACTIONS(811),
    [sym__external_open_brace] = ACTIONS(811),
    [sym__external_open_bracket] = ACTIONS(811),
    [sym__external_open_bracket2] = ACTIONS(811),
  },
  [635] = {
    [sym_string] = STATE(896),
    [sym__single_quoted_string] = STATE(725),
    [sym__double_quoted_string] = STATE(700),
    [sym__string_or_identifier] = STATE(896),
    [aux_sym_function_definition_repeat1] = STATE(643),
    [sym_identifier] = ACTIONS(1065),
    [anon_sym_BSLASH] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(795),
    [anon_sym_EQ] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(795),
    [anon_sym_for] = ACTIONS(795),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_repeat] = ACTIONS(795),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(795),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LT_DASH] = ACTIONS(791),
    [anon_sym_LT_LT_DASH] = ACTIONS(791),
    [anon_sym_COLON_EQ] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_DASH_GT_GT] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(795),
    [anon_sym_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [anon_sym_LT] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_GT] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(791),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_BANG_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(795),
    [anon_sym_SLASH] = ACTIONS(791),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [aux_sym_binary_operator_token1] = ACTIONS(791),
    [anon_sym_PIPE_GT] = ACTIONS(791),
    [anon_sym_COLON] = ACTIONS(795),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [anon_sym_AT] = ACTIONS(791),
    [sym__hex_literal] = ACTIONS(791),
    [sym__number_literal] = ACTIONS(795),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(619),
    [sym_return] = ACTIONS(795),
    [sym_next] = ACTIONS(795),
    [sym_break] = ACTIONS(795),
    [sym_true] = ACTIONS(795),
    [sym_false] = ACTIONS(795),
    [sym_null] = ACTIONS(795),
    [sym_inf] = ACTIONS(795),
    [sym_nan] = ACTIONS(795),
    [anon_sym_NA] = ACTIONS(795),
    [anon_sym_NA_integer_] = ACTIONS(795),
    [anon_sym_NA_real_] = ACTIONS(795),
    [anon_sym_NA_complex_] = ACTIONS(795),
    [anon_sym_NA_character_] = ACTIONS(795),
    [sym_dots] = ACTIONS(795),
    [sym_dot_dot_i] = ACTIONS(791),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(791),
    [sym__newline] = ACTIONS(1067),
    [sym__raw_string_literal] = ACTIONS(633),
    [sym__external_open_parenthesis] = ACTIONS(791),
    [sym__external_open_brace] = ACTIONS(791),
    [sym__external_open_bracket] = ACTIONS(791),
    [sym__external_open_bracket2] = ACTIONS(791),
    [sym__external_close_bracket2] = ACTIONS(791),
  },
  [636] = {
    [sym_string] = STATE(767),
    [sym__single_quoted_string] = STATE(656),
    [sym__double_quoted_string] = STATE(657),
    [sym__string_or_identifier] = STATE(767),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_BSLASH] = ACTIONS(1057),
    [anon_sym_function] = ACTIONS(1059),
    [anon_sym_EQ] = ACTIONS(1059),
    [anon_sym_if] = ACTIONS(1059),
    [anon_sym_for] = ACTIONS(1059),
    [anon_sym_while] = ACTIONS(1059),
    [anon_sym_repeat] = ACTIONS(1059),
    [anon_sym_QMARK] = ACTIONS(1057),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_COLON_EQ] = ACTIONS(1057),
    [anon_sym_DASH_GT] = ACTIONS(1059),
    [anon_sym_DASH_GT_GT] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_LT_EQ] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1057),
    [anon_sym_EQ_EQ] = ACTIONS(1057),
    [anon_sym_BANG_EQ] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_STAR_STAR] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [aux_sym_binary_operator_token1] = ACTIONS(1057),
    [anon_sym_PIPE_GT] = ACTIONS(1057),
    [anon_sym_COLON] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1057),
    [anon_sym_AT] = ACTIONS(1057),
    [sym__hex_literal] = ACTIONS(1057),
    [sym__number_literal] = ACTIONS(1059),
    [anon_sym_SQUOTE] = ACTIONS(923),
    [anon_sym_DQUOTE] = ACTIONS(925),
    [sym_return] = ACTIONS(1059),
    [sym_next] = ACTIONS(1059),
    [sym_break] = ACTIONS(1059),
    [sym_true] = ACTIONS(1059),
    [sym_false] = ACTIONS(1059),
    [sym_null] = ACTIONS(1059),
    [sym_inf] = ACTIONS(1059),
    [sym_nan] = ACTIONS(1059),
    [anon_sym_NA] = ACTIONS(1059),
    [anon_sym_NA_integer_] = ACTIONS(1059),
    [anon_sym_NA_real_] = ACTIONS(1059),
    [anon_sym_NA_complex_] = ACTIONS(1059),
    [anon_sym_NA_character_] = ACTIONS(1059),
    [sym_dots] = ACTIONS(1059),
    [sym_dot_dot_i] = ACTIONS(1057),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1057),
    [sym__newline] = ACTIONS(1057),
    [sym__raw_string_literal] = ACTIONS(929),
    [sym__external_else] = ACTIONS(1057),
    [sym__external_open_parenthesis] = ACTIONS(1057),
    [sym__external_open_brace] = ACTIONS(1057),
    [sym__external_open_bracket] = ACTIONS(1057),
    [sym__external_close_bracket] = ACTIONS(1057),
    [sym__external_open_bracket2] = ACTIONS(1057),
  },
  [637] = {
    [sym_function_definition] = STATE(491),
    [sym_if_statement] = STATE(491),
    [sym_for_statement] = STATE(491),
    [sym_while_statement] = STATE(491),
    [sym_repeat_statement] = STATE(491),
    [sym_braced_expression] = STATE(491),
    [sym_parenthesized_expression] = STATE(491),
    [sym_call] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_subset2] = STATE(491),
    [sym__argument] = STATE(1934),
    [sym_argument] = STATE(1937),
    [sym__argument_named] = STATE(1909),
    [sym__argument_unnamed] = STATE(1932),
    [sym__argument_value] = STATE(1920),
    [sym_unary_operator] = STATE(491),
    [sym_binary_operator] = STATE(491),
    [sym_extract_operator] = STATE(491),
    [sym_namespace_operator] = STATE(491),
    [sym_integer] = STATE(491),
    [sym_complex] = STATE(491),
    [sym_float] = STATE(491),
    [sym__float_literal] = STATE(734),
    [sym_string] = STATE(728),
    [sym__single_quoted_string] = STATE(735),
    [sym__double_quoted_string] = STATE(736),
    [sym_na] = STATE(491),
    [sym__expression] = STATE(491),
    [sym__string_or_identifier] = STATE(2143),
    [sym__open_parenthesis] = STATE(948),
    [sym__open_brace] = STATE(751),
    [aux_sym_call_arguments_repeat1] = STATE(637),
    [sym_identifier] = ACTIONS(1071),
    [anon_sym_BSLASH] = ACTIONS(1074),
    [anon_sym_function] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1080),
    [anon_sym_for] = ACTIONS(1083),
    [anon_sym_while] = ACTIONS(1086),
    [anon_sym_repeat] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1098),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [sym__hex_literal] = ACTIONS(1104),
    [sym__number_literal] = ACTIONS(1107),
    [anon_sym_SQUOTE] = ACTIONS(1110),
    [anon_sym_DQUOTE] = ACTIONS(1113),
    [sym_return] = ACTIONS(1116),
    [sym_next] = ACTIONS(1116),
    [sym_break] = ACTIONS(1116),
    [sym_true] = ACTIONS(1116),
    [sym_false] = ACTIONS(1116),
    [sym_null] = ACTIONS(1116),
    [sym_inf] = ACTIONS(1116),
    [sym_nan] = ACTIONS(1116),
    [anon_sym_NA] = ACTIONS(1119),
    [anon_sym_NA_integer_] = ACTIONS(1119),
    [anon_sym_NA_real_] = ACTIONS(1119),
    [anon_sym_NA_complex_] = ACTIONS(1119),
    [anon_sym_NA_character_] = ACTIONS(1119),
    [sym_dots] = ACTIONS(1122),
    [sym_dot_dot_i] = ACTIONS(1125),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1128),
    [sym__newline] = ACTIONS(1131),
    [sym__raw_string_literal] = ACTIONS(1134),
    [sym__external_open_parenthesis] = ACTIONS(1137),
    [sym__external_open_brace] = ACTIONS(1140),
    [sym__external_close_bracket] = ACTIONS(1143),
  },
  [638] = {
    [sym_string] = STATE(877),
    [sym__single_quoted_string] = STATE(743),
    [sym__double_quoted_string] = STATE(746),
    [sym__string_or_identifier] = STATE(877),
    [aux_sym_function_definition_repeat1] = STATE(642),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_BSLASH] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(795),
    [anon_sym_EQ] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(795),
    [anon_sym_for] = ACTIONS(795),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_repeat] = ACTIONS(795),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(795),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LT_DASH] = ACTIONS(791),
    [anon_sym_LT_LT_DASH] = ACTIONS(791),
    [anon_sym_COLON_EQ] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_DASH_GT_GT] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(795),
    [anon_sym_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [anon_sym_LT] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_GT] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(791),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_BANG_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(795),
    [anon_sym_SLASH] = ACTIONS(791),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [aux_sym_binary_operator_token1] = ACTIONS(791),
    [anon_sym_PIPE_GT] = ACTIONS(791),
    [anon_sym_COLON] = ACTIONS(795),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [anon_sym_AT] = ACTIONS(791),
    [sym__hex_literal] = ACTIONS(791),
    [sym__number_literal] = ACTIONS(795),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [sym_return] = ACTIONS(795),
    [sym_next] = ACTIONS(795),
    [sym_break] = ACTIONS(795),
    [sym_true] = ACTIONS(795),
    [sym_false] = ACTIONS(795),
    [sym_null] = ACTIONS(795),
    [sym_inf] = ACTIONS(795),
    [sym_nan] = ACTIONS(795),
    [anon_sym_NA] = ACTIONS(795),
    [anon_sym_NA_integer_] = ACTIONS(795),
    [anon_sym_NA_real_] = ACTIONS(795),
    [anon_sym_NA_complex_] = ACTIONS(795),
    [anon_sym_NA_character_] = ACTIONS(795),
    [sym_dots] = ACTIONS(795),
    [sym_dot_dot_i] = ACTIONS(791),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1151),
    [sym__semicolon] = ACTIONS(791),
    [sym__raw_string_literal] = ACTIONS(1153),
    [sym__external_open_parenthesis] = ACTIONS(791),
    [sym__external_open_brace] = ACTIONS(791),
    [sym__external_close_brace] = ACTIONS(791),
    [sym__external_open_bracket] = ACTIONS(791),
    [sym__external_open_bracket2] = ACTIONS(791),
  },
  [639] = {
    [sym_function_definition] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_repeat_statement] = STATE(556),
    [sym_braced_expression] = STATE(556),
    [sym_parenthesized_expression] = STATE(556),
    [sym_call] = STATE(556),
    [sym_subset] = STATE(556),
    [sym_subset2] = STATE(556),
    [sym__argument] = STATE(1928),
    [sym_argument] = STATE(1930),
    [sym__argument_named] = STATE(1908),
    [sym__argument_unnamed] = STATE(1933),
    [sym__argument_value] = STATE(1936),
    [sym_unary_operator] = STATE(556),
    [sym_binary_operator] = STATE(556),
    [sym_extract_operator] = STATE(556),
    [sym_namespace_operator] = STATE(556),
    [sym_integer] = STATE(556),
    [sym_complex] = STATE(556),
    [sym_float] = STATE(556),
    [sym__float_literal] = STATE(710),
    [sym_string] = STATE(724),
    [sym__single_quoted_string] = STATE(725),
    [sym__double_quoted_string] = STATE(700),
    [sym_na] = STATE(556),
    [sym__expression] = STATE(556),
    [sym__string_or_identifier] = STATE(2142),
    [sym__open_parenthesis] = STATE(955),
    [sym__open_brace] = STATE(857),
    [aux_sym_call_arguments_repeat1] = STATE(639),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_BSLASH] = ACTIONS(1158),
    [anon_sym_function] = ACTIONS(1161),
    [anon_sym_if] = ACTIONS(1164),
    [anon_sym_for] = ACTIONS(1167),
    [anon_sym_while] = ACTIONS(1170),
    [anon_sym_repeat] = ACTIONS(1173),
    [anon_sym_QMARK] = ACTIONS(1176),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_BANG] = ACTIONS(1182),
    [anon_sym_PLUS] = ACTIONS(1185),
    [anon_sym_DASH] = ACTIONS(1185),
    [sym__hex_literal] = ACTIONS(1188),
    [sym__number_literal] = ACTIONS(1191),
    [anon_sym_SQUOTE] = ACTIONS(1194),
    [anon_sym_DQUOTE] = ACTIONS(1197),
    [sym_return] = ACTIONS(1200),
    [sym_next] = ACTIONS(1200),
    [sym_break] = ACTIONS(1200),
    [sym_true] = ACTIONS(1200),
    [sym_false] = ACTIONS(1200),
    [sym_null] = ACTIONS(1200),
    [sym_inf] = ACTIONS(1200),
    [sym_nan] = ACTIONS(1200),
    [anon_sym_NA] = ACTIONS(1203),
    [anon_sym_NA_integer_] = ACTIONS(1203),
    [anon_sym_NA_real_] = ACTIONS(1203),
    [anon_sym_NA_complex_] = ACTIONS(1203),
    [anon_sym_NA_character_] = ACTIONS(1203),
    [sym_dots] = ACTIONS(1206),
    [sym_dot_dot_i] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1212),
    [sym__newline] = ACTIONS(1215),
    [sym__raw_string_literal] = ACTIONS(1218),
    [sym__external_open_parenthesis] = ACTIONS(1221),
    [sym__external_open_brace] = ACTIONS(1224),
    [sym__external_close_bracket2] = ACTIONS(1143),
  },
  [640] = {
    [sym_string] = STATE(826),
    [sym__single_quoted_string] = STATE(672),
    [sym__double_quoted_string] = STATE(697),
    [sym__string_or_identifier] = STATE(826),
    [sym_identifier] = ACTIONS(1227),
    [anon_sym_BSLASH] = ACTIONS(1057),
    [anon_sym_function] = ACTIONS(1059),
    [anon_sym_EQ] = ACTIONS(1059),
    [anon_sym_if] = ACTIONS(1059),
    [anon_sym_for] = ACTIONS(1059),
    [anon_sym_while] = ACTIONS(1059),
    [anon_sym_repeat] = ACTIONS(1059),
    [anon_sym_QMARK] = ACTIONS(1057),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_COLON_EQ] = ACTIONS(1057),
    [anon_sym_DASH_GT] = ACTIONS(1059),
    [anon_sym_DASH_GT_GT] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_LT_EQ] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1057),
    [anon_sym_EQ_EQ] = ACTIONS(1057),
    [anon_sym_BANG_EQ] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_STAR_STAR] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [aux_sym_binary_operator_token1] = ACTIONS(1057),
    [anon_sym_PIPE_GT] = ACTIONS(1057),
    [anon_sym_COLON] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1057),
    [anon_sym_AT] = ACTIONS(1057),
    [sym__hex_literal] = ACTIONS(1057),
    [sym__number_literal] = ACTIONS(1059),
    [anon_sym_SQUOTE] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [sym_return] = ACTIONS(1059),
    [sym_next] = ACTIONS(1059),
    [sym_break] = ACTIONS(1059),
    [sym_true] = ACTIONS(1059),
    [sym_false] = ACTIONS(1059),
    [sym_null] = ACTIONS(1059),
    [sym_inf] = ACTIONS(1059),
    [sym_nan] = ACTIONS(1059),
    [anon_sym_NA] = ACTIONS(1059),
    [anon_sym_NA_integer_] = ACTIONS(1059),
    [anon_sym_NA_real_] = ACTIONS(1059),
    [anon_sym_NA_complex_] = ACTIONS(1059),
    [anon_sym_NA_character_] = ACTIONS(1059),
    [sym_dots] = ACTIONS(1059),
    [sym_dot_dot_i] = ACTIONS(1057),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1057),
    [sym__newline] = ACTIONS(1057),
    [sym__raw_string_literal] = ACTIONS(945),
    [sym__external_else] = ACTIONS(1057),
    [sym__external_open_parenthesis] = ACTIONS(1057),
    [sym__external_open_brace] = ACTIONS(1057),
    [sym__external_open_bracket] = ACTIONS(1057),
    [sym__external_open_bracket2] = ACTIONS(1057),
    [sym__external_close_bracket2] = ACTIONS(1057),
  },
  [641] = {
    [sym_string] = STATE(947),
    [sym__single_quoted_string] = STATE(745),
    [sym__double_quoted_string] = STATE(747),
    [sym__string_or_identifier] = STATE(947),
    [aux_sym_function_definition_repeat1] = STATE(797),
    [ts_builtin_sym_end] = ACTIONS(811),
    [sym_identifier] = ACTIONS(1229),
    [anon_sym_BSLASH] = ACTIONS(811),
    [anon_sym_function] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(815),
    [anon_sym_if] = ACTIONS(815),
    [anon_sym_for] = ACTIONS(815),
    [anon_sym_while] = ACTIONS(815),
    [anon_sym_repeat] = ACTIONS(815),
    [anon_sym_QMARK] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(811),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_LT_DASH] = ACTIONS(811),
    [anon_sym_LT_LT_DASH] = ACTIONS(811),
    [anon_sym_COLON_EQ] = ACTIONS(811),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_DASH_GT_GT] = ACTIONS(811),
    [anon_sym_PIPE] = ACTIONS(815),
    [anon_sym_AMP] = ACTIONS(815),
    [anon_sym_PIPE_PIPE] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(811),
    [anon_sym_GT] = ACTIONS(815),
    [anon_sym_GT_EQ] = ACTIONS(811),
    [anon_sym_EQ_EQ] = ACTIONS(811),
    [anon_sym_BANG_EQ] = ACTIONS(811),
    [anon_sym_STAR] = ACTIONS(815),
    [anon_sym_SLASH] = ACTIONS(811),
    [anon_sym_STAR_STAR] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(811),
    [aux_sym_binary_operator_token1] = ACTIONS(811),
    [anon_sym_PIPE_GT] = ACTIONS(811),
    [anon_sym_COLON] = ACTIONS(815),
    [anon_sym_DOLLAR] = ACTIONS(811),
    [anon_sym_AT] = ACTIONS(811),
    [sym__hex_literal] = ACTIONS(811),
    [sym__number_literal] = ACTIONS(815),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_return] = ACTIONS(815),
    [sym_next] = ACTIONS(815),
    [sym_break] = ACTIONS(815),
    [sym_true] = ACTIONS(815),
    [sym_false] = ACTIONS(815),
    [sym_null] = ACTIONS(815),
    [sym_inf] = ACTIONS(815),
    [sym_nan] = ACTIONS(815),
    [anon_sym_NA] = ACTIONS(815),
    [anon_sym_NA_integer_] = ACTIONS(815),
    [anon_sym_NA_real_] = ACTIONS(815),
    [anon_sym_NA_complex_] = ACTIONS(815),
    [anon_sym_NA_character_] = ACTIONS(815),
    [sym_dots] = ACTIONS(815),
    [sym_dot_dot_i] = ACTIONS(811),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(811),
    [sym__semicolon] = ACTIONS(811),
    [sym__raw_string_literal] = ACTIONS(45),
    [sym__external_open_parenthesis] = ACTIONS(811),
    [sym__external_open_brace] = ACTIONS(811),
    [sym__external_open_bracket] = ACTIONS(811),
    [sym__external_open_bracket2] = ACTIONS(811),
  },
  [642] = {
    [sym_string] = STATE(914),
    [sym__single_quoted_string] = STATE(743),
    [sym__double_quoted_string] = STATE(746),
    [sym__string_or_identifier] = STATE(914),
    [aux_sym_function_definition_repeat1] = STATE(765),
    [sym_identifier] = ACTIONS(1231),
    [anon_sym_BSLASH] = ACTIONS(811),
    [anon_sym_function] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(815),
    [anon_sym_if] = ACTIONS(815),
    [anon_sym_for] = ACTIONS(815),
    [anon_sym_while] = ACTIONS(815),
    [anon_sym_repeat] = ACTIONS(815),
    [anon_sym_QMARK] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(811),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_LT_DASH] = ACTIONS(811),
    [anon_sym_LT_LT_DASH] = ACTIONS(811),
    [anon_sym_COLON_EQ] = ACTIONS(811),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_DASH_GT_GT] = ACTIONS(811),
    [anon_sym_PIPE] = ACTIONS(815),
    [anon_sym_AMP] = ACTIONS(815),
    [anon_sym_PIPE_PIPE] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(811),
    [anon_sym_GT] = ACTIONS(815),
    [anon_sym_GT_EQ] = ACTIONS(811),
    [anon_sym_EQ_EQ] = ACTIONS(811),
    [anon_sym_BANG_EQ] = ACTIONS(811),
    [anon_sym_STAR] = ACTIONS(815),
    [anon_sym_SLASH] = ACTIONS(811),
    [anon_sym_STAR_STAR] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(811),
    [aux_sym_binary_operator_token1] = ACTIONS(811),
    [anon_sym_PIPE_GT] = ACTIONS(811),
    [anon_sym_COLON] = ACTIONS(815),
    [anon_sym_DOLLAR] = ACTIONS(811),
    [anon_sym_AT] = ACTIONS(811),
    [sym__hex_literal] = ACTIONS(811),
    [sym__number_literal] = ACTIONS(815),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [sym_return] = ACTIONS(815),
    [sym_next] = ACTIONS(815),
    [sym_break] = ACTIONS(815),
    [sym_true] = ACTIONS(815),
    [sym_false] = ACTIONS(815),
    [sym_null] = ACTIONS(815),
    [sym_inf] = ACTIONS(815),
    [sym_nan] = ACTIONS(815),
    [anon_sym_NA] = ACTIONS(815),
    [anon_sym_NA_integer_] = ACTIONS(815),
    [anon_sym_NA_real_] = ACTIONS(815),
    [anon_sym_NA_complex_] = ACTIONS(815),
    [anon_sym_NA_character_] = ACTIONS(815),
    [sym_dots] = ACTIONS(815),
    [sym_dot_dot_i] = ACTIONS(811),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(811),
    [sym__semicolon] = ACTIONS(811),
    [sym__raw_string_literal] = ACTIONS(1153),
    [sym__external_open_parenthesis] = ACTIONS(811),
    [sym__external_open_brace] = ACTIONS(811),
    [sym__external_close_brace] = ACTIONS(811),
    [sym__external_open_bracket] = ACTIONS(811),
    [sym__external_open_bracket2] = ACTIONS(811),
  },
  [643] = {
    [sym_string] = STATE(994),
    [sym__single_quoted_string] = STATE(725),
    [sym__double_quoted_string] = STATE(700),
    [sym__string_or_identifier] = STATE(994),
    [aux_sym_function_definition_repeat1] = STATE(852),
    [sym_identifier] = ACTIONS(1233),
    [anon_sym_BSLASH] = ACTIONS(811),
    [anon_sym_function] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(815),
    [anon_sym_if] = ACTIONS(815),
    [anon_sym_for] = ACTIONS(815),
    [anon_sym_while] = ACTIONS(815),
    [anon_sym_repeat] = ACTIONS(815),
    [anon_sym_QMARK] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(811),
    [anon_sym_BANG] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(811),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_LT_DASH] = ACTIONS(811),
    [anon_sym_LT_LT_DASH] = ACTIONS(811),
    [anon_sym_COLON_EQ] = ACTIONS(811),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_DASH_GT_GT] = ACTIONS(811),
    [anon_sym_PIPE] = ACTIONS(815),
    [anon_sym_AMP] = ACTIONS(815),
    [anon_sym_PIPE_PIPE] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(811),
    [anon_sym_GT] = ACTIONS(815),
    [anon_sym_GT_EQ] = ACTIONS(811),
    [anon_sym_EQ_EQ] = ACTIONS(811),
    [anon_sym_BANG_EQ] = ACTIONS(811),
    [anon_sym_STAR] = ACTIONS(815),
    [anon_sym_SLASH] = ACTIONS(811),
    [anon_sym_STAR_STAR] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(811),
    [aux_sym_binary_operator_token1] = ACTIONS(811),
    [anon_sym_PIPE_GT] = ACTIONS(811),
    [anon_sym_COLON] = ACTIONS(815),
    [anon_sym_DOLLAR] = ACTIONS(811),
    [anon_sym_AT] = ACTIONS(811),
    [sym__hex_literal] = ACTIONS(811),
    [sym__number_literal] = ACTIONS(815),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(619),
    [sym_return] = ACTIONS(815),
    [sym_next] = ACTIONS(815),
    [sym_break] = ACTIONS(815),
    [sym_true] = ACTIONS(815),
    [sym_false] = ACTIONS(815),
    [sym_null] = ACTIONS(815),
    [sym_inf] = ACTIONS(815),
    [sym_nan] = ACTIONS(815),
    [anon_sym_NA] = ACTIONS(815),
    [anon_sym_NA_integer_] = ACTIONS(815),
    [anon_sym_NA_real_] = ACTIONS(815),
    [anon_sym_NA_complex_] = ACTIONS(815),
    [anon_sym_NA_character_] = ACTIONS(815),
    [sym_dots] = ACTIONS(815),
    [sym_dot_dot_i] = ACTIONS(811),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(811),
    [sym__newline] = ACTIONS(811),
    [sym__raw_string_literal] = ACTIONS(633),
    [sym__external_open_parenthesis] = ACTIONS(811),
    [sym__external_open_brace] = ACTIONS(811),
    [sym__external_open_bracket] = ACTIONS(811),
    [sym__external_open_bracket2] = ACTIONS(811),
    [sym__external_close_bracket2] = ACTIONS(811),
  },
  [644] = {
    [sym_string] = STATE(937),
    [sym__single_quoted_string] = STATE(745),
    [sym__double_quoted_string] = STATE(747),
    [sym__string_or_identifier] = STATE(937),
    [aux_sym_function_definition_repeat1] = STATE(641),
    [ts_builtin_sym_end] = ACTIONS(791),
    [sym_identifier] = ACTIONS(1235),
    [anon_sym_BSLASH] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(795),
    [anon_sym_EQ] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(795),
    [anon_sym_for] = ACTIONS(795),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_repeat] = ACTIONS(795),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(795),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LT_DASH] = ACTIONS(791),
    [anon_sym_LT_LT_DASH] = ACTIONS(791),
    [anon_sym_COLON_EQ] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_DASH_GT_GT] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(795),
    [anon_sym_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [anon_sym_LT] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_GT] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(791),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_BANG_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(795),
    [anon_sym_SLASH] = ACTIONS(791),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [aux_sym_binary_operator_token1] = ACTIONS(791),
    [anon_sym_PIPE_GT] = ACTIONS(791),
    [anon_sym_COLON] = ACTIONS(795),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [anon_sym_AT] = ACTIONS(791),
    [sym__hex_literal] = ACTIONS(791),
    [sym__number_literal] = ACTIONS(795),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_return] = ACTIONS(795),
    [sym_next] = ACTIONS(795),
    [sym_break] = ACTIONS(795),
    [sym_true] = ACTIONS(795),
    [sym_false] = ACTIONS(795),
    [sym_null] = ACTIONS(795),
    [sym_inf] = ACTIONS(795),
    [sym_nan] = ACTIONS(795),
    [anon_sym_NA] = ACTIONS(795),
    [anon_sym_NA_integer_] = ACTIONS(795),
    [anon_sym_NA_real_] = ACTIONS(795),
    [anon_sym_NA_complex_] = ACTIONS(795),
    [anon_sym_NA_character_] = ACTIONS(795),
    [sym_dots] = ACTIONS(795),
    [sym_dot_dot_i] = ACTIONS(791),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1237),
    [sym__semicolon] = ACTIONS(791),
    [sym__raw_string_literal] = ACTIONS(45),
    [sym__external_open_parenthesis] = ACTIONS(791),
    [sym__external_open_brace] = ACTIONS(791),
    [sym__external_open_bracket] = ACTIONS(791),
    [sym__external_open_bracket2] = ACTIONS(791),
  },
  [645] = {
    [sym_string] = STATE(866),
    [sym__single_quoted_string] = STATE(684),
    [sym__double_quoted_string] = STATE(685),
    [sym__string_or_identifier] = STATE(866),
    [sym_identifier] = ACTIONS(1239),
    [anon_sym_BSLASH] = ACTIONS(1057),
    [anon_sym_function] = ACTIONS(1059),
    [anon_sym_EQ] = ACTIONS(1059),
    [anon_sym_if] = ACTIONS(1059),
    [anon_sym_for] = ACTIONS(1059),
    [anon_sym_while] = ACTIONS(1059),
    [anon_sym_repeat] = ACTIONS(1059),
    [anon_sym_QMARK] = ACTIONS(1057),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_COLON_EQ] = ACTIONS(1057),
    [anon_sym_DASH_GT] = ACTIONS(1059),
    [anon_sym_DASH_GT_GT] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_LT_EQ] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1057),
    [anon_sym_EQ_EQ] = ACTIONS(1057),
    [anon_sym_BANG_EQ] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_STAR_STAR] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [aux_sym_binary_operator_token1] = ACTIONS(1057),
    [anon_sym_PIPE_GT] = ACTIONS(1057),
    [anon_sym_COLON] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1057),
    [anon_sym_AT] = ACTIONS(1057),
    [sym__hex_literal] = ACTIONS(1057),
    [sym__number_literal] = ACTIONS(1059),
    [anon_sym_SQUOTE] = ACTIONS(879),
    [anon_sym_DQUOTE] = ACTIONS(881),
    [sym_return] = ACTIONS(1059),
    [sym_next] = ACTIONS(1059),
    [sym_break] = ACTIONS(1059),
    [sym_true] = ACTIONS(1059),
    [sym_false] = ACTIONS(1059),
    [sym_null] = ACTIONS(1059),
    [sym_inf] = ACTIONS(1059),
    [sym_nan] = ACTIONS(1059),
    [anon_sym_NA] = ACTIONS(1059),
    [anon_sym_NA_integer_] = ACTIONS(1059),
    [anon_sym_NA_real_] = ACTIONS(1059),
    [anon_sym_NA_complex_] = ACTIONS(1059),
    [anon_sym_NA_character_] = ACTIONS(1059),
    [sym_dots] = ACTIONS(1059),
    [sym_dot_dot_i] = ACTIONS(1057),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1057),
    [sym__newline] = ACTIONS(1057),
    [sym__raw_string_literal] = ACTIONS(885),
    [sym__external_else] = ACTIONS(1057),
    [sym__external_open_parenthesis] = ACTIONS(1057),
    [sym__external_close_parenthesis] = ACTIONS(1057),
    [sym__external_open_brace] = ACTIONS(1057),
    [sym__external_open_bracket] = ACTIONS(1057),
    [sym__external_open_bracket2] = ACTIONS(1057),
  },
  [646] = {
    [sym_string] = STATE(986),
    [sym__single_quoted_string] = STATE(735),
    [sym__double_quoted_string] = STATE(736),
    [sym__string_or_identifier] = STATE(986),
    [aux_sym_function_definition_repeat1] = STATE(629),
    [sym_identifier] = ACTIONS(1241),
    [anon_sym_BSLASH] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(795),
    [anon_sym_EQ] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(795),
    [anon_sym_for] = ACTIONS(795),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_repeat] = ACTIONS(795),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(795),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LT_DASH] = ACTIONS(791),
    [anon_sym_LT_LT_DASH] = ACTIONS(791),
    [anon_sym_COLON_EQ] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_DASH_GT_GT] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(795),
    [anon_sym_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(791),
    [anon_sym_AMP_AMP] = ACTIONS(791),
    [anon_sym_LT] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(791),
    [anon_sym_GT] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(791),
    [anon_sym_EQ_EQ] = ACTIONS(791),
    [anon_sym_BANG_EQ] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(795),
    [anon_sym_SLASH] = ACTIONS(791),
    [anon_sym_STAR_STAR] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(791),
    [aux_sym_binary_operator_token1] = ACTIONS(791),
    [anon_sym_PIPE_GT] = ACTIONS(791),
    [anon_sym_COLON] = ACTIONS(795),
    [anon_sym_DOLLAR] = ACTIONS(791),
    [anon_sym_AT] = ACTIONS(791),
    [sym__hex_literal] = ACTIONS(791),
    [sym__number_literal] = ACTIONS(795),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [sym_return] = ACTIONS(795),
    [sym_next] = ACTIONS(795),
    [sym_break] = ACTIONS(795),
    [sym_true] = ACTIONS(795),
    [sym_false] = ACTIONS(795),
    [sym_null] = ACTIONS(795),
    [sym_inf] = ACTIONS(795),
    [sym_nan] = ACTIONS(795),
    [anon_sym_NA] = ACTIONS(795),
    [anon_sym_NA_integer_] = ACTIONS(795),
    [anon_sym_NA_real_] = ACTIONS(795),
    [anon_sym_NA_complex_] = ACTIONS(795),
    [anon_sym_NA_character_] = ACTIONS(795),
    [sym_dots] = ACTIONS(795),
    [sym_dot_dot_i] = ACTIONS(791),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(791),
    [sym__newline] = ACTIONS(1243),
    [sym__raw_string_literal] = ACTIONS(583),
    [sym__external_open_parenthesis] = ACTIONS(791),
    [sym__external_open_brace] = ACTIONS(791),
    [sym__external_open_bracket] = ACTIONS(791),
    [sym__external_close_bracket] = ACTIONS(791),
    [sym__external_open_bracket2] = ACTIONS(791),
  },
  [647] = {
    [sym_function_definition] = STATE(429),
    [sym_if_statement] = STATE(429),
    [sym_for_statement] = STATE(429),
    [sym_while_statement] = STATE(429),
    [sym_repeat_statement] = STATE(429),
    [sym_braced_expression] = STATE(429),
    [sym_parenthesized_expression] = STATE(429),
    [sym_call] = STATE(429),
    [sym_subset] = STATE(429),
    [sym_subset2] = STATE(429),
    [sym__argument] = STATE(1912),
    [sym_argument] = STATE(1916),
    [sym__argument_named] = STATE(1919),
    [sym__argument_unnamed] = STATE(1921),
    [sym__argument_value] = STATE(1927),
    [sym_unary_operator] = STATE(429),
    [sym_binary_operator] = STATE(429),
    [sym_extract_operator] = STATE(429),
    [sym_namespace_operator] = STATE(429),
    [sym_integer] = STATE(429),
    [sym_complex] = STATE(429),
    [sym_float] = STATE(429),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(721),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(429),
    [sym__expression] = STATE(429),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__open_brace] = STATE(842),
    [aux_sym_call_arguments_repeat1] = STATE(647),
    [sym_identifier] = ACTIONS(1245),
    [anon_sym_BSLASH] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1251),
    [anon_sym_if] = ACTIONS(1254),
    [anon_sym_for] = ACTIONS(1257),
    [anon_sym_while] = ACTIONS(1260),
    [anon_sym_repeat] = ACTIONS(1263),
    [anon_sym_QMARK] = ACTIONS(1266),
    [anon_sym_TILDE] = ACTIONS(1269),
    [anon_sym_BANG] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_DASH] = ACTIONS(1275),
    [sym__hex_literal] = ACTIONS(1278),
    [sym__number_literal] = ACTIONS(1281),
    [anon_sym_SQUOTE] = ACTIONS(1284),
    [anon_sym_DQUOTE] = ACTIONS(1287),
    [sym_return] = ACTIONS(1290),
    [sym_next] = ACTIONS(1290),
    [sym_break] = ACTIONS(1290),
    [sym_true] = ACTIONS(1290),
    [sym_false] = ACTIONS(1290),
    [sym_null] = ACTIONS(1290),
    [sym_inf] = ACTIONS(1290),
    [sym_nan] = ACTIONS(1290),
    [anon_sym_NA] = ACTIONS(1293),
    [anon_sym_NA_integer_] = ACTIONS(1293),
    [anon_sym_NA_real_] = ACTIONS(1293),
    [anon_sym_NA_complex_] = ACTIONS(1293),
    [anon_sym_NA_character_] = ACTIONS(1293),
    [sym_dots] = ACTIONS(1296),
    [sym_dot_dot_i] = ACTIONS(1299),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1302),
    [sym__newline] = ACTIONS(1305),
    [sym__raw_string_literal] = ACTIONS(1308),
    [sym__external_open_parenthesis] = ACTIONS(1311),
    [sym__external_close_parenthesis] = ACTIONS(1143),
    [sym__external_open_brace] = ACTIONS(1314),
  },
  [648] = {
    [sym_string] = STATE(878),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym__string_or_identifier] = STATE(878),
    [sym_identifier] = ACTIONS(1317),
    [anon_sym_BSLASH] = ACTIONS(1057),
    [anon_sym_function] = ACTIONS(1059),
    [anon_sym_EQ] = ACTIONS(1059),
    [anon_sym_if] = ACTIONS(1059),
    [anon_sym_for] = ACTIONS(1059),
    [anon_sym_while] = ACTIONS(1059),
    [anon_sym_repeat] = ACTIONS(1059),
    [anon_sym_QMARK] = ACTIONS(1057),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_COLON_EQ] = ACTIONS(1057),
    [anon_sym_DASH_GT] = ACTIONS(1059),
    [anon_sym_DASH_GT_GT] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_LT_EQ] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1057),
    [anon_sym_EQ_EQ] = ACTIONS(1057),
    [anon_sym_BANG_EQ] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_STAR_STAR] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [aux_sym_binary_operator_token1] = ACTIONS(1057),
    [anon_sym_PIPE_GT] = ACTIONS(1057),
    [anon_sym_COLON] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1057),
    [anon_sym_AT] = ACTIONS(1057),
    [sym__hex_literal] = ACTIONS(1057),
    [sym__number_literal] = ACTIONS(1059),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(1059),
    [sym_next] = ACTIONS(1059),
    [sym_break] = ACTIONS(1059),
    [sym_true] = ACTIONS(1059),
    [sym_false] = ACTIONS(1059),
    [sym_null] = ACTIONS(1059),
    [sym_inf] = ACTIONS(1059),
    [sym_nan] = ACTIONS(1059),
    [anon_sym_NA] = ACTIONS(1059),
    [anon_sym_NA_integer_] = ACTIONS(1059),
    [anon_sym_NA_real_] = ACTIONS(1059),
    [anon_sym_NA_complex_] = ACTIONS(1059),
    [anon_sym_NA_character_] = ACTIONS(1059),
    [sym_dots] = ACTIONS(1059),
    [sym_dot_dot_i] = ACTIONS(1057),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1057),
    [sym__newline] = ACTIONS(1057),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(1057),
    [sym__external_close_parenthesis] = ACTIONS(1057),
    [sym__external_open_brace] = ACTIONS(1057),
    [sym__external_open_bracket] = ACTIONS(1057),
    [sym__external_open_bracket2] = ACTIONS(1057),
  },
  [649] = {
    [sym_string] = STATE(881),
    [sym__single_quoted_string] = STATE(745),
    [sym__double_quoted_string] = STATE(747),
    [sym__string_or_identifier] = STATE(881),
    [ts_builtin_sym_end] = ACTIONS(1057),
    [sym_identifier] = ACTIONS(1319),
    [anon_sym_BSLASH] = ACTIONS(1057),
    [anon_sym_function] = ACTIONS(1059),
    [anon_sym_EQ] = ACTIONS(1059),
    [anon_sym_if] = ACTIONS(1059),
    [anon_sym_for] = ACTIONS(1059),
    [anon_sym_while] = ACTIONS(1059),
    [anon_sym_repeat] = ACTIONS(1059),
    [anon_sym_QMARK] = ACTIONS(1057),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_COLON_EQ] = ACTIONS(1057),
    [anon_sym_DASH_GT] = ACTIONS(1059),
    [anon_sym_DASH_GT_GT] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_LT_EQ] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1057),
    [anon_sym_EQ_EQ] = ACTIONS(1057),
    [anon_sym_BANG_EQ] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_STAR_STAR] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [aux_sym_binary_operator_token1] = ACTIONS(1057),
    [anon_sym_PIPE_GT] = ACTIONS(1057),
    [anon_sym_COLON] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1057),
    [anon_sym_AT] = ACTIONS(1057),
    [sym__hex_literal] = ACTIONS(1057),
    [sym__number_literal] = ACTIONS(1059),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_return] = ACTIONS(1059),
    [sym_next] = ACTIONS(1059),
    [sym_break] = ACTIONS(1059),
    [sym_true] = ACTIONS(1059),
    [sym_false] = ACTIONS(1059),
    [sym_null] = ACTIONS(1059),
    [sym_inf] = ACTIONS(1059),
    [sym_nan] = ACTIONS(1059),
    [anon_sym_NA] = ACTIONS(1059),
    [anon_sym_NA_integer_] = ACTIONS(1059),
    [anon_sym_NA_real_] = ACTIONS(1059),
    [anon_sym_NA_complex_] = ACTIONS(1059),
    [anon_sym_NA_character_] = ACTIONS(1059),
    [sym_dots] = ACTIONS(1059),
    [sym_dot_dot_i] = ACTIONS(1057),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1057),
    [sym__semicolon] = ACTIONS(1057),
    [sym__raw_string_literal] = ACTIONS(45),
    [sym__external_open_parenthesis] = ACTIONS(1057),
    [sym__external_open_brace] = ACTIONS(1057),
    [sym__external_open_bracket] = ACTIONS(1057),
    [sym__external_open_bracket2] = ACTIONS(1057),
  },
  [650] = {
    [sym_string] = STATE(931),
    [sym__single_quoted_string] = STATE(725),
    [sym__double_quoted_string] = STATE(700),
    [sym__string_or_identifier] = STATE(931),
    [sym_identifier] = ACTIONS(1321),
    [anon_sym_BSLASH] = ACTIONS(1057),
    [anon_sym_function] = ACTIONS(1059),
    [anon_sym_EQ] = ACTIONS(1059),
    [anon_sym_if] = ACTIONS(1059),
    [anon_sym_for] = ACTIONS(1059),
    [anon_sym_while] = ACTIONS(1059),
    [anon_sym_repeat] = ACTIONS(1059),
    [anon_sym_QMARK] = ACTIONS(1057),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_COLON_EQ] = ACTIONS(1057),
    [anon_sym_DASH_GT] = ACTIONS(1059),
    [anon_sym_DASH_GT_GT] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_LT_EQ] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1057),
    [anon_sym_EQ_EQ] = ACTIONS(1057),
    [anon_sym_BANG_EQ] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_STAR_STAR] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [aux_sym_binary_operator_token1] = ACTIONS(1057),
    [anon_sym_PIPE_GT] = ACTIONS(1057),
    [anon_sym_COLON] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1057),
    [anon_sym_AT] = ACTIONS(1057),
    [sym__hex_literal] = ACTIONS(1057),
    [sym__number_literal] = ACTIONS(1059),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(619),
    [sym_return] = ACTIONS(1059),
    [sym_next] = ACTIONS(1059),
    [sym_break] = ACTIONS(1059),
    [sym_true] = ACTIONS(1059),
    [sym_false] = ACTIONS(1059),
    [sym_null] = ACTIONS(1059),
    [sym_inf] = ACTIONS(1059),
    [sym_nan] = ACTIONS(1059),
    [anon_sym_NA] = ACTIONS(1059),
    [anon_sym_NA_integer_] = ACTIONS(1059),
    [anon_sym_NA_real_] = ACTIONS(1059),
    [anon_sym_NA_complex_] = ACTIONS(1059),
    [anon_sym_NA_character_] = ACTIONS(1059),
    [sym_dots] = ACTIONS(1059),
    [sym_dot_dot_i] = ACTIONS(1057),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1057),
    [sym__newline] = ACTIONS(1057),
    [sym__raw_string_literal] = ACTIONS(633),
    [sym__external_open_parenthesis] = ACTIONS(1057),
    [sym__external_open_brace] = ACTIONS(1057),
    [sym__external_open_bracket] = ACTIONS(1057),
    [sym__external_open_bracket2] = ACTIONS(1057),
    [sym__external_close_bracket2] = ACTIONS(1057),
  },
  [651] = {
    [sym_string] = STATE(886),
    [sym__single_quoted_string] = STATE(743),
    [sym__double_quoted_string] = STATE(746),
    [sym__string_or_identifier] = STATE(886),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_BSLASH] = ACTIONS(1057),
    [anon_sym_function] = ACTIONS(1059),
    [anon_sym_EQ] = ACTIONS(1059),
    [anon_sym_if] = ACTIONS(1059),
    [anon_sym_for] = ACTIONS(1059),
    [anon_sym_while] = ACTIONS(1059),
    [anon_sym_repeat] = ACTIONS(1059),
    [anon_sym_QMARK] = ACTIONS(1057),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_COLON_EQ] = ACTIONS(1057),
    [anon_sym_DASH_GT] = ACTIONS(1059),
    [anon_sym_DASH_GT_GT] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_LT_EQ] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1057),
    [anon_sym_EQ_EQ] = ACTIONS(1057),
    [anon_sym_BANG_EQ] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_STAR_STAR] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [aux_sym_binary_operator_token1] = ACTIONS(1057),
    [anon_sym_PIPE_GT] = ACTIONS(1057),
    [anon_sym_COLON] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1057),
    [anon_sym_AT] = ACTIONS(1057),
    [sym__hex_literal] = ACTIONS(1057),
    [sym__number_literal] = ACTIONS(1059),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [sym_return] = ACTIONS(1059),
    [sym_next] = ACTIONS(1059),
    [sym_break] = ACTIONS(1059),
    [sym_true] = ACTIONS(1059),
    [sym_false] = ACTIONS(1059),
    [sym_null] = ACTIONS(1059),
    [sym_inf] = ACTIONS(1059),
    [sym_nan] = ACTIONS(1059),
    [anon_sym_NA] = ACTIONS(1059),
    [anon_sym_NA_integer_] = ACTIONS(1059),
    [anon_sym_NA_real_] = ACTIONS(1059),
    [anon_sym_NA_complex_] = ACTIONS(1059),
    [anon_sym_NA_character_] = ACTIONS(1059),
    [sym_dots] = ACTIONS(1059),
    [sym_dot_dot_i] = ACTIONS(1057),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1057),
    [sym__semicolon] = ACTIONS(1057),
    [sym__raw_string_literal] = ACTIONS(1153),
    [sym__external_open_parenthesis] = ACTIONS(1057),
    [sym__external_open_brace] = ACTIONS(1057),
    [sym__external_close_brace] = ACTIONS(1057),
    [sym__external_open_bracket] = ACTIONS(1057),
    [sym__external_open_bracket2] = ACTIONS(1057),
  },
  [652] = {
    [sym_string] = STATE(998),
    [sym__single_quoted_string] = STATE(735),
    [sym__double_quoted_string] = STATE(736),
    [sym__string_or_identifier] = STATE(998),
    [sym_identifier] = ACTIONS(1325),
    [anon_sym_BSLASH] = ACTIONS(1057),
    [anon_sym_function] = ACTIONS(1059),
    [anon_sym_EQ] = ACTIONS(1059),
    [anon_sym_if] = ACTIONS(1059),
    [anon_sym_for] = ACTIONS(1059),
    [anon_sym_while] = ACTIONS(1059),
    [anon_sym_repeat] = ACTIONS(1059),
    [anon_sym_QMARK] = ACTIONS(1057),
    [anon_sym_TILDE] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_PLUS] = ACTIONS(1057),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_COLON_EQ] = ACTIONS(1057),
    [anon_sym_DASH_GT] = ACTIONS(1059),
    [anon_sym_DASH_GT_GT] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_LT_EQ] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1057),
    [anon_sym_EQ_EQ] = ACTIONS(1057),
    [anon_sym_BANG_EQ] = ACTIONS(1057),
    [anon_sym_STAR] = ACTIONS(1059),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_STAR_STAR] = ACTIONS(1057),
    [anon_sym_CARET] = ACTIONS(1057),
    [aux_sym_binary_operator_token1] = ACTIONS(1057),
    [anon_sym_PIPE_GT] = ACTIONS(1057),
    [anon_sym_COLON] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1057),
    [anon_sym_AT] = ACTIONS(1057),
    [sym__hex_literal] = ACTIONS(1057),
    [sym__number_literal] = ACTIONS(1059),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [sym_return] = ACTIONS(1059),
    [sym_next] = ACTIONS(1059),
    [sym_break] = ACTIONS(1059),
    [sym_true] = ACTIONS(1059),
    [sym_false] = ACTIONS(1059),
    [sym_null] = ACTIONS(1059),
    [sym_inf] = ACTIONS(1059),
    [sym_nan] = ACTIONS(1059),
    [anon_sym_NA] = ACTIONS(1059),
    [anon_sym_NA_integer_] = ACTIONS(1059),
    [anon_sym_NA_real_] = ACTIONS(1059),
    [anon_sym_NA_complex_] = ACTIONS(1059),
    [anon_sym_NA_character_] = ACTIONS(1059),
    [sym_dots] = ACTIONS(1059),
    [sym_dot_dot_i] = ACTIONS(1057),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1057),
    [sym__newline] = ACTIONS(1057),
    [sym__raw_string_literal] = ACTIONS(583),
    [sym__external_open_parenthesis] = ACTIONS(1057),
    [sym__external_open_brace] = ACTIONS(1057),
    [sym__external_open_bracket] = ACTIONS(1057),
    [sym__external_close_bracket] = ACTIONS(1057),
    [sym__external_open_bracket2] = ACTIONS(1057),
  },
  [653] = {
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_BSLASH] = ACTIONS(1329),
    [anon_sym_function] = ACTIONS(1327),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_repeat] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1329),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_LT_DASH] = ACTIONS(1329),
    [anon_sym_LT_LT_DASH] = ACTIONS(1329),
    [anon_sym_COLON_EQ] = ACTIONS(1329),
    [anon_sym_DASH_GT] = ACTIONS(1327),
    [anon_sym_DASH_GT_GT] = ACTIONS(1329),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1329),
    [anon_sym_AMP_AMP] = ACTIONS(1329),
    [anon_sym_LT] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1329),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1329),
    [anon_sym_EQ_EQ] = ACTIONS(1329),
    [anon_sym_BANG_EQ] = ACTIONS(1329),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_SLASH] = ACTIONS(1329),
    [anon_sym_STAR_STAR] = ACTIONS(1329),
    [anon_sym_CARET] = ACTIONS(1329),
    [aux_sym_binary_operator_token1] = ACTIONS(1329),
    [anon_sym_PIPE_GT] = ACTIONS(1329),
    [anon_sym_COLON] = ACTIONS(1327),
    [anon_sym_DOLLAR] = ACTIONS(1329),
    [anon_sym_AT] = ACTIONS(1329),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1329),
    [sym__hex_literal] = ACTIONS(1329),
    [sym__number_literal] = ACTIONS(1327),
    [anon_sym_SQUOTE] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(1329),
    [sym_return] = ACTIONS(1327),
    [sym_next] = ACTIONS(1327),
    [sym_break] = ACTIONS(1327),
    [sym_true] = ACTIONS(1327),
    [sym_false] = ACTIONS(1327),
    [sym_null] = ACTIONS(1327),
    [sym_inf] = ACTIONS(1327),
    [sym_nan] = ACTIONS(1327),
    [anon_sym_NA] = ACTIONS(1327),
    [anon_sym_NA_integer_] = ACTIONS(1327),
    [anon_sym_NA_real_] = ACTIONS(1327),
    [anon_sym_NA_complex_] = ACTIONS(1327),
    [anon_sym_NA_character_] = ACTIONS(1327),
    [sym_dots] = ACTIONS(1327),
    [sym_dot_dot_i] = ACTIONS(1329),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1329),
    [sym__newline] = ACTIONS(1329),
    [sym__raw_string_literal] = ACTIONS(1329),
    [sym__external_else] = ACTIONS(1329),
    [sym__external_open_parenthesis] = ACTIONS(1329),
    [sym__external_close_parenthesis] = ACTIONS(1329),
    [sym__external_open_brace] = ACTIONS(1329),
    [sym__external_open_bracket] = ACTIONS(1329),
    [sym__external_open_bracket2] = ACTIONS(1329),
  },
  [654] = {
    [sym_identifier] = ACTIONS(1331),
    [anon_sym_BSLASH] = ACTIONS(1333),
    [anon_sym_function] = ACTIONS(1331),
    [anon_sym_EQ] = ACTIONS(1331),
    [anon_sym_if] = ACTIONS(1331),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_while] = ACTIONS(1331),
    [anon_sym_repeat] = ACTIONS(1331),
    [anon_sym_QMARK] = ACTIONS(1333),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_LT_DASH] = ACTIONS(1333),
    [anon_sym_LT_LT_DASH] = ACTIONS(1333),
    [anon_sym_COLON_EQ] = ACTIONS(1333),
    [anon_sym_DASH_GT] = ACTIONS(1331),
    [anon_sym_DASH_GT_GT] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1331),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1333),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_GT_EQ] = ACTIONS(1333),
    [anon_sym_EQ_EQ] = ACTIONS(1333),
    [anon_sym_BANG_EQ] = ACTIONS(1333),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_SLASH] = ACTIONS(1333),
    [anon_sym_STAR_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1333),
    [aux_sym_binary_operator_token1] = ACTIONS(1333),
    [anon_sym_PIPE_GT] = ACTIONS(1333),
    [anon_sym_COLON] = ACTIONS(1331),
    [anon_sym_DOLLAR] = ACTIONS(1333),
    [anon_sym_AT] = ACTIONS(1333),
    [anon_sym_COLON_COLON] = ACTIONS(1335),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1337),
    [sym__hex_literal] = ACTIONS(1333),
    [sym__number_literal] = ACTIONS(1331),
    [anon_sym_SQUOTE] = ACTIONS(1333),
    [anon_sym_DQUOTE] = ACTIONS(1333),
    [sym_return] = ACTIONS(1331),
    [sym_next] = ACTIONS(1331),
    [sym_break] = ACTIONS(1331),
    [sym_true] = ACTIONS(1331),
    [sym_false] = ACTIONS(1331),
    [sym_null] = ACTIONS(1331),
    [sym_inf] = ACTIONS(1331),
    [sym_nan] = ACTIONS(1331),
    [anon_sym_NA] = ACTIONS(1331),
    [anon_sym_NA_integer_] = ACTIONS(1331),
    [anon_sym_NA_real_] = ACTIONS(1331),
    [anon_sym_NA_complex_] = ACTIONS(1331),
    [anon_sym_NA_character_] = ACTIONS(1331),
    [sym_dots] = ACTIONS(1331),
    [sym_dot_dot_i] = ACTIONS(1333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1333),
    [sym__newline] = ACTIONS(1333),
    [sym__raw_string_literal] = ACTIONS(1333),
    [sym__external_else] = ACTIONS(1333),
    [sym__external_open_parenthesis] = ACTIONS(1333),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_open_bracket] = ACTIONS(1333),
    [sym__external_close_bracket] = ACTIONS(1333),
    [sym__external_open_bracket2] = ACTIONS(1333),
  },
  [655] = {
    [sym_identifier] = ACTIONS(1339),
    [anon_sym_BSLASH] = ACTIONS(1341),
    [anon_sym_function] = ACTIONS(1339),
    [anon_sym_EQ] = ACTIONS(1339),
    [anon_sym_if] = ACTIONS(1339),
    [anon_sym_for] = ACTIONS(1339),
    [anon_sym_while] = ACTIONS(1339),
    [anon_sym_repeat] = ACTIONS(1339),
    [anon_sym_QMARK] = ACTIONS(1341),
    [anon_sym_TILDE] = ACTIONS(1341),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_LT_DASH] = ACTIONS(1341),
    [anon_sym_LT_LT_DASH] = ACTIONS(1341),
    [anon_sym_COLON_EQ] = ACTIONS(1341),
    [anon_sym_DASH_GT] = ACTIONS(1339),
    [anon_sym_DASH_GT_GT] = ACTIONS(1341),
    [anon_sym_PIPE] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_PIPE_PIPE] = ACTIONS(1341),
    [anon_sym_AMP_AMP] = ACTIONS(1341),
    [anon_sym_LT] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1341),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_GT_EQ] = ACTIONS(1341),
    [anon_sym_EQ_EQ] = ACTIONS(1341),
    [anon_sym_BANG_EQ] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_SLASH] = ACTIONS(1341),
    [anon_sym_STAR_STAR] = ACTIONS(1341),
    [anon_sym_CARET] = ACTIONS(1341),
    [aux_sym_binary_operator_token1] = ACTIONS(1341),
    [anon_sym_PIPE_GT] = ACTIONS(1341),
    [anon_sym_COLON] = ACTIONS(1339),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1341),
    [anon_sym_L] = ACTIONS(1343),
    [anon_sym_i] = ACTIONS(1345),
    [sym__hex_literal] = ACTIONS(1341),
    [sym__number_literal] = ACTIONS(1339),
    [anon_sym_SQUOTE] = ACTIONS(1341),
    [anon_sym_DQUOTE] = ACTIONS(1341),
    [sym_return] = ACTIONS(1339),
    [sym_next] = ACTIONS(1339),
    [sym_break] = ACTIONS(1339),
    [sym_true] = ACTIONS(1339),
    [sym_false] = ACTIONS(1339),
    [sym_null] = ACTIONS(1339),
    [sym_inf] = ACTIONS(1339),
    [sym_nan] = ACTIONS(1339),
    [anon_sym_NA] = ACTIONS(1339),
    [anon_sym_NA_integer_] = ACTIONS(1339),
    [anon_sym_NA_real_] = ACTIONS(1339),
    [anon_sym_NA_complex_] = ACTIONS(1339),
    [anon_sym_NA_character_] = ACTIONS(1339),
    [sym_dots] = ACTIONS(1339),
    [sym_dot_dot_i] = ACTIONS(1341),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1341),
    [sym__newline] = ACTIONS(1341),
    [sym__raw_string_literal] = ACTIONS(1341),
    [sym__external_else] = ACTIONS(1341),
    [sym__external_open_parenthesis] = ACTIONS(1341),
    [sym__external_open_brace] = ACTIONS(1341),
    [sym__external_open_bracket] = ACTIONS(1341),
    [sym__external_close_bracket] = ACTIONS(1341),
    [sym__external_open_bracket2] = ACTIONS(1341),
  },
  [656] = {
    [sym_identifier] = ACTIONS(1347),
    [anon_sym_BSLASH] = ACTIONS(1349),
    [anon_sym_function] = ACTIONS(1347),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_if] = ACTIONS(1347),
    [anon_sym_for] = ACTIONS(1347),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1347),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1347),
    [anon_sym_LT_DASH] = ACTIONS(1349),
    [anon_sym_LT_LT_DASH] = ACTIONS(1349),
    [anon_sym_COLON_EQ] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1347),
    [anon_sym_DASH_GT_GT] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1347),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_GT_EQ] = ACTIONS(1349),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_SLASH] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [aux_sym_binary_operator_token1] = ACTIONS(1349),
    [anon_sym_PIPE_GT] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(1347),
    [anon_sym_DOLLAR] = ACTIONS(1349),
    [anon_sym_AT] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1347),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1349),
    [sym__hex_literal] = ACTIONS(1349),
    [sym__number_literal] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1349),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [sym_return] = ACTIONS(1347),
    [sym_next] = ACTIONS(1347),
    [sym_break] = ACTIONS(1347),
    [sym_true] = ACTIONS(1347),
    [sym_false] = ACTIONS(1347),
    [sym_null] = ACTIONS(1347),
    [sym_inf] = ACTIONS(1347),
    [sym_nan] = ACTIONS(1347),
    [anon_sym_NA] = ACTIONS(1347),
    [anon_sym_NA_integer_] = ACTIONS(1347),
    [anon_sym_NA_real_] = ACTIONS(1347),
    [anon_sym_NA_complex_] = ACTIONS(1347),
    [anon_sym_NA_character_] = ACTIONS(1347),
    [sym_dots] = ACTIONS(1347),
    [sym_dot_dot_i] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1349),
    [sym__newline] = ACTIONS(1349),
    [sym__raw_string_literal] = ACTIONS(1349),
    [sym__external_else] = ACTIONS(1349),
    [sym__external_open_parenthesis] = ACTIONS(1349),
    [sym__external_open_brace] = ACTIONS(1349),
    [sym__external_open_bracket] = ACTIONS(1349),
    [sym__external_close_bracket] = ACTIONS(1349),
    [sym__external_open_bracket2] = ACTIONS(1349),
  },
  [657] = {
    [sym_identifier] = ACTIONS(1347),
    [anon_sym_BSLASH] = ACTIONS(1349),
    [anon_sym_function] = ACTIONS(1347),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_if] = ACTIONS(1347),
    [anon_sym_for] = ACTIONS(1347),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1347),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1347),
    [anon_sym_LT_DASH] = ACTIONS(1349),
    [anon_sym_LT_LT_DASH] = ACTIONS(1349),
    [anon_sym_COLON_EQ] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1347),
    [anon_sym_DASH_GT_GT] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1347),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_GT_EQ] = ACTIONS(1349),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_SLASH] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [aux_sym_binary_operator_token1] = ACTIONS(1349),
    [anon_sym_PIPE_GT] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(1347),
    [anon_sym_DOLLAR] = ACTIONS(1349),
    [anon_sym_AT] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1347),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1349),
    [sym__hex_literal] = ACTIONS(1349),
    [sym__number_literal] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1349),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [sym_return] = ACTIONS(1347),
    [sym_next] = ACTIONS(1347),
    [sym_break] = ACTIONS(1347),
    [sym_true] = ACTIONS(1347),
    [sym_false] = ACTIONS(1347),
    [sym_null] = ACTIONS(1347),
    [sym_inf] = ACTIONS(1347),
    [sym_nan] = ACTIONS(1347),
    [anon_sym_NA] = ACTIONS(1347),
    [anon_sym_NA_integer_] = ACTIONS(1347),
    [anon_sym_NA_real_] = ACTIONS(1347),
    [anon_sym_NA_complex_] = ACTIONS(1347),
    [anon_sym_NA_character_] = ACTIONS(1347),
    [sym_dots] = ACTIONS(1347),
    [sym_dot_dot_i] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1349),
    [sym__newline] = ACTIONS(1349),
    [sym__raw_string_literal] = ACTIONS(1349),
    [sym__external_else] = ACTIONS(1349),
    [sym__external_open_parenthesis] = ACTIONS(1349),
    [sym__external_open_brace] = ACTIONS(1349),
    [sym__external_open_bracket] = ACTIONS(1349),
    [sym__external_close_bracket] = ACTIONS(1349),
    [sym__external_open_bracket2] = ACTIONS(1349),
  },
  [658] = {
    [sym_identifier] = ACTIONS(1351),
    [anon_sym_BSLASH] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [anon_sym_repeat] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_PLUS] = ACTIONS(1353),
    [anon_sym_DASH] = ACTIONS(1351),
    [anon_sym_LT_DASH] = ACTIONS(1353),
    [anon_sym_LT_LT_DASH] = ACTIONS(1353),
    [anon_sym_COLON_EQ] = ACTIONS(1353),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_DASH_GT_GT] = ACTIONS(1353),
    [anon_sym_PIPE] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PIPE_PIPE] = ACTIONS(1353),
    [anon_sym_AMP_AMP] = ACTIONS(1353),
    [anon_sym_LT] = ACTIONS(1351),
    [anon_sym_LT_EQ] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(1351),
    [anon_sym_GT_EQ] = ACTIONS(1353),
    [anon_sym_EQ_EQ] = ACTIONS(1353),
    [anon_sym_BANG_EQ] = ACTIONS(1353),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_SLASH] = ACTIONS(1353),
    [anon_sym_STAR_STAR] = ACTIONS(1353),
    [anon_sym_CARET] = ACTIONS(1353),
    [aux_sym_binary_operator_token1] = ACTIONS(1353),
    [anon_sym_PIPE_GT] = ACTIONS(1353),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_DOLLAR] = ACTIONS(1353),
    [anon_sym_AT] = ACTIONS(1353),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1353),
    [sym__hex_literal] = ACTIONS(1353),
    [sym__number_literal] = ACTIONS(1351),
    [anon_sym_SQUOTE] = ACTIONS(1353),
    [anon_sym_DQUOTE] = ACTIONS(1353),
    [sym_return] = ACTIONS(1351),
    [sym_next] = ACTIONS(1351),
    [sym_break] = ACTIONS(1351),
    [sym_true] = ACTIONS(1351),
    [sym_false] = ACTIONS(1351),
    [sym_null] = ACTIONS(1351),
    [sym_inf] = ACTIONS(1351),
    [sym_nan] = ACTIONS(1351),
    [anon_sym_NA] = ACTIONS(1351),
    [anon_sym_NA_integer_] = ACTIONS(1351),
    [anon_sym_NA_real_] = ACTIONS(1351),
    [anon_sym_NA_complex_] = ACTIONS(1351),
    [anon_sym_NA_character_] = ACTIONS(1351),
    [sym_dots] = ACTIONS(1351),
    [sym_dot_dot_i] = ACTIONS(1353),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1353),
    [sym__newline] = ACTIONS(1353),
    [sym__raw_string_literal] = ACTIONS(1353),
    [sym__external_else] = ACTIONS(1353),
    [sym__external_open_parenthesis] = ACTIONS(1353),
    [sym__external_open_brace] = ACTIONS(1353),
    [sym__external_open_bracket] = ACTIONS(1353),
    [sym__external_close_bracket] = ACTIONS(1353),
    [sym__external_open_bracket2] = ACTIONS(1353),
  },
  [659] = {
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_BSLASH] = ACTIONS(1329),
    [anon_sym_function] = ACTIONS(1327),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_repeat] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1329),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_LT_DASH] = ACTIONS(1329),
    [anon_sym_LT_LT_DASH] = ACTIONS(1329),
    [anon_sym_COLON_EQ] = ACTIONS(1329),
    [anon_sym_DASH_GT] = ACTIONS(1327),
    [anon_sym_DASH_GT_GT] = ACTIONS(1329),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1329),
    [anon_sym_AMP_AMP] = ACTIONS(1329),
    [anon_sym_LT] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1329),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1329),
    [anon_sym_EQ_EQ] = ACTIONS(1329),
    [anon_sym_BANG_EQ] = ACTIONS(1329),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_SLASH] = ACTIONS(1329),
    [anon_sym_STAR_STAR] = ACTIONS(1329),
    [anon_sym_CARET] = ACTIONS(1329),
    [aux_sym_binary_operator_token1] = ACTIONS(1329),
    [anon_sym_PIPE_GT] = ACTIONS(1329),
    [anon_sym_COLON] = ACTIONS(1327),
    [anon_sym_DOLLAR] = ACTIONS(1329),
    [anon_sym_AT] = ACTIONS(1329),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1329),
    [sym__hex_literal] = ACTIONS(1329),
    [sym__number_literal] = ACTIONS(1327),
    [anon_sym_SQUOTE] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(1329),
    [sym_return] = ACTIONS(1327),
    [sym_next] = ACTIONS(1327),
    [sym_break] = ACTIONS(1327),
    [sym_true] = ACTIONS(1327),
    [sym_false] = ACTIONS(1327),
    [sym_null] = ACTIONS(1327),
    [sym_inf] = ACTIONS(1327),
    [sym_nan] = ACTIONS(1327),
    [anon_sym_NA] = ACTIONS(1327),
    [anon_sym_NA_integer_] = ACTIONS(1327),
    [anon_sym_NA_real_] = ACTIONS(1327),
    [anon_sym_NA_complex_] = ACTIONS(1327),
    [anon_sym_NA_character_] = ACTIONS(1327),
    [sym_dots] = ACTIONS(1327),
    [sym_dot_dot_i] = ACTIONS(1329),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1329),
    [sym__newline] = ACTIONS(1329),
    [sym__raw_string_literal] = ACTIONS(1329),
    [sym__external_else] = ACTIONS(1329),
    [sym__external_open_parenthesis] = ACTIONS(1329),
    [sym__external_open_brace] = ACTIONS(1329),
    [sym__external_open_bracket] = ACTIONS(1329),
    [sym__external_close_bracket] = ACTIONS(1329),
    [sym__external_open_bracket2] = ACTIONS(1329),
  },
  [660] = {
    [ts_builtin_sym_end] = ACTIONS(1355),
    [sym_identifier] = ACTIONS(1357),
    [anon_sym_BSLASH] = ACTIONS(1355),
    [anon_sym_function] = ACTIONS(1357),
    [anon_sym_EQ] = ACTIONS(1357),
    [anon_sym_if] = ACTIONS(1357),
    [anon_sym_for] = ACTIONS(1357),
    [anon_sym_while] = ACTIONS(1357),
    [anon_sym_repeat] = ACTIONS(1357),
    [anon_sym_QMARK] = ACTIONS(1355),
    [anon_sym_TILDE] = ACTIONS(1355),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1357),
    [anon_sym_LT_DASH] = ACTIONS(1355),
    [anon_sym_LT_LT_DASH] = ACTIONS(1355),
    [anon_sym_COLON_EQ] = ACTIONS(1355),
    [anon_sym_DASH_GT] = ACTIONS(1357),
    [anon_sym_DASH_GT_GT] = ACTIONS(1355),
    [anon_sym_PIPE] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_AMP_AMP] = ACTIONS(1355),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_LT_EQ] = ACTIONS(1355),
    [anon_sym_GT] = ACTIONS(1357),
    [anon_sym_GT_EQ] = ACTIONS(1355),
    [anon_sym_EQ_EQ] = ACTIONS(1355),
    [anon_sym_BANG_EQ] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1357),
    [anon_sym_SLASH] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1355),
    [anon_sym_CARET] = ACTIONS(1355),
    [aux_sym_binary_operator_token1] = ACTIONS(1355),
    [anon_sym_PIPE_GT] = ACTIONS(1355),
    [anon_sym_COLON] = ACTIONS(1357),
    [anon_sym_DOLLAR] = ACTIONS(1355),
    [anon_sym_AT] = ACTIONS(1355),
    [anon_sym_COLON_COLON] = ACTIONS(1357),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1355),
    [sym__hex_literal] = ACTIONS(1355),
    [sym__number_literal] = ACTIONS(1357),
    [anon_sym_SQUOTE] = ACTIONS(1355),
    [anon_sym_DQUOTE] = ACTIONS(1355),
    [sym_return] = ACTIONS(1357),
    [sym_next] = ACTIONS(1357),
    [sym_break] = ACTIONS(1357),
    [sym_true] = ACTIONS(1357),
    [sym_false] = ACTIONS(1357),
    [sym_null] = ACTIONS(1357),
    [sym_inf] = ACTIONS(1357),
    [sym_nan] = ACTIONS(1357),
    [anon_sym_NA] = ACTIONS(1357),
    [anon_sym_NA_integer_] = ACTIONS(1357),
    [anon_sym_NA_real_] = ACTIONS(1357),
    [anon_sym_NA_complex_] = ACTIONS(1357),
    [anon_sym_NA_character_] = ACTIONS(1357),
    [sym_dots] = ACTIONS(1357),
    [sym_dot_dot_i] = ACTIONS(1355),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1355),
    [sym__semicolon] = ACTIONS(1355),
    [sym__raw_string_literal] = ACTIONS(1355),
    [sym__external_else] = ACTIONS(1355),
    [sym__external_open_parenthesis] = ACTIONS(1355),
    [sym__external_open_brace] = ACTIONS(1355),
    [sym__external_open_bracket] = ACTIONS(1355),
    [sym__external_open_bracket2] = ACTIONS(1355),
  },
  [661] = {
    [sym_identifier] = ACTIONS(1347),
    [anon_sym_BSLASH] = ACTIONS(1349),
    [anon_sym_function] = ACTIONS(1347),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_if] = ACTIONS(1347),
    [anon_sym_for] = ACTIONS(1347),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1347),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1347),
    [anon_sym_LT_DASH] = ACTIONS(1349),
    [anon_sym_LT_LT_DASH] = ACTIONS(1349),
    [anon_sym_COLON_EQ] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1347),
    [anon_sym_DASH_GT_GT] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1347),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_GT_EQ] = ACTIONS(1349),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_SLASH] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [aux_sym_binary_operator_token1] = ACTIONS(1349),
    [anon_sym_PIPE_GT] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(1347),
    [anon_sym_DOLLAR] = ACTIONS(1349),
    [anon_sym_AT] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1347),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1349),
    [sym__hex_literal] = ACTIONS(1349),
    [sym__number_literal] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1349),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [sym_return] = ACTIONS(1347),
    [sym_next] = ACTIONS(1347),
    [sym_break] = ACTIONS(1347),
    [sym_true] = ACTIONS(1347),
    [sym_false] = ACTIONS(1347),
    [sym_null] = ACTIONS(1347),
    [sym_inf] = ACTIONS(1347),
    [sym_nan] = ACTIONS(1347),
    [anon_sym_NA] = ACTIONS(1347),
    [anon_sym_NA_integer_] = ACTIONS(1347),
    [anon_sym_NA_real_] = ACTIONS(1347),
    [anon_sym_NA_complex_] = ACTIONS(1347),
    [anon_sym_NA_character_] = ACTIONS(1347),
    [sym_dots] = ACTIONS(1347),
    [sym_dot_dot_i] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1349),
    [sym__semicolon] = ACTIONS(1349),
    [sym__raw_string_literal] = ACTIONS(1349),
    [sym__external_else] = ACTIONS(1349),
    [sym__external_open_parenthesis] = ACTIONS(1349),
    [sym__external_open_brace] = ACTIONS(1349),
    [sym__external_close_brace] = ACTIONS(1349),
    [sym__external_open_bracket] = ACTIONS(1349),
    [sym__external_open_bracket2] = ACTIONS(1349),
  },
  [662] = {
    [ts_builtin_sym_end] = ACTIONS(1359),
    [sym_identifier] = ACTIONS(1361),
    [anon_sym_BSLASH] = ACTIONS(1359),
    [anon_sym_function] = ACTIONS(1361),
    [anon_sym_EQ] = ACTIONS(1361),
    [anon_sym_if] = ACTIONS(1361),
    [anon_sym_for] = ACTIONS(1361),
    [anon_sym_while] = ACTIONS(1361),
    [anon_sym_repeat] = ACTIONS(1361),
    [anon_sym_QMARK] = ACTIONS(1359),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_BANG] = ACTIONS(1361),
    [anon_sym_PLUS] = ACTIONS(1359),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_LT_DASH] = ACTIONS(1359),
    [anon_sym_LT_LT_DASH] = ACTIONS(1359),
    [anon_sym_COLON_EQ] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [anon_sym_DASH_GT_GT] = ACTIONS(1359),
    [anon_sym_PIPE] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(1361),
    [anon_sym_PIPE_PIPE] = ACTIONS(1359),
    [anon_sym_AMP_AMP] = ACTIONS(1359),
    [anon_sym_LT] = ACTIONS(1361),
    [anon_sym_LT_EQ] = ACTIONS(1359),
    [anon_sym_GT] = ACTIONS(1361),
    [anon_sym_GT_EQ] = ACTIONS(1359),
    [anon_sym_EQ_EQ] = ACTIONS(1359),
    [anon_sym_BANG_EQ] = ACTIONS(1359),
    [anon_sym_STAR] = ACTIONS(1361),
    [anon_sym_SLASH] = ACTIONS(1359),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [aux_sym_binary_operator_token1] = ACTIONS(1359),
    [anon_sym_PIPE_GT] = ACTIONS(1359),
    [anon_sym_COLON] = ACTIONS(1361),
    [anon_sym_DOLLAR] = ACTIONS(1359),
    [anon_sym_AT] = ACTIONS(1359),
    [anon_sym_COLON_COLON] = ACTIONS(1361),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1359),
    [sym__hex_literal] = ACTIONS(1359),
    [sym__number_literal] = ACTIONS(1361),
    [anon_sym_SQUOTE] = ACTIONS(1359),
    [anon_sym_DQUOTE] = ACTIONS(1359),
    [sym_return] = ACTIONS(1361),
    [sym_next] = ACTIONS(1361),
    [sym_break] = ACTIONS(1361),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [sym_null] = ACTIONS(1361),
    [sym_inf] = ACTIONS(1361),
    [sym_nan] = ACTIONS(1361),
    [anon_sym_NA] = ACTIONS(1361),
    [anon_sym_NA_integer_] = ACTIONS(1361),
    [anon_sym_NA_real_] = ACTIONS(1361),
    [anon_sym_NA_complex_] = ACTIONS(1361),
    [anon_sym_NA_character_] = ACTIONS(1361),
    [sym_dots] = ACTIONS(1361),
    [sym_dot_dot_i] = ACTIONS(1359),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1359),
    [sym__semicolon] = ACTIONS(1359),
    [sym__raw_string_literal] = ACTIONS(1359),
    [sym__external_else] = ACTIONS(1359),
    [sym__external_open_parenthesis] = ACTIONS(1359),
    [sym__external_open_brace] = ACTIONS(1359),
    [sym__external_open_bracket] = ACTIONS(1359),
    [sym__external_open_bracket2] = ACTIONS(1359),
  },
  [663] = {
    [sym_identifier] = ACTIONS(1357),
    [anon_sym_BSLASH] = ACTIONS(1355),
    [anon_sym_function] = ACTIONS(1357),
    [anon_sym_EQ] = ACTIONS(1357),
    [anon_sym_if] = ACTIONS(1357),
    [anon_sym_for] = ACTIONS(1357),
    [anon_sym_while] = ACTIONS(1357),
    [anon_sym_repeat] = ACTIONS(1357),
    [anon_sym_QMARK] = ACTIONS(1355),
    [anon_sym_TILDE] = ACTIONS(1355),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1357),
    [anon_sym_LT_DASH] = ACTIONS(1355),
    [anon_sym_LT_LT_DASH] = ACTIONS(1355),
    [anon_sym_COLON_EQ] = ACTIONS(1355),
    [anon_sym_DASH_GT] = ACTIONS(1357),
    [anon_sym_DASH_GT_GT] = ACTIONS(1355),
    [anon_sym_PIPE] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_AMP_AMP] = ACTIONS(1355),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_LT_EQ] = ACTIONS(1355),
    [anon_sym_GT] = ACTIONS(1357),
    [anon_sym_GT_EQ] = ACTIONS(1355),
    [anon_sym_EQ_EQ] = ACTIONS(1355),
    [anon_sym_BANG_EQ] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1357),
    [anon_sym_SLASH] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1355),
    [anon_sym_CARET] = ACTIONS(1355),
    [aux_sym_binary_operator_token1] = ACTIONS(1355),
    [anon_sym_PIPE_GT] = ACTIONS(1355),
    [anon_sym_COLON] = ACTIONS(1357),
    [anon_sym_DOLLAR] = ACTIONS(1355),
    [anon_sym_AT] = ACTIONS(1355),
    [anon_sym_COLON_COLON] = ACTIONS(1357),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1355),
    [sym__hex_literal] = ACTIONS(1355),
    [sym__number_literal] = ACTIONS(1357),
    [anon_sym_SQUOTE] = ACTIONS(1355),
    [anon_sym_DQUOTE] = ACTIONS(1355),
    [sym_return] = ACTIONS(1357),
    [sym_next] = ACTIONS(1357),
    [sym_break] = ACTIONS(1357),
    [sym_true] = ACTIONS(1357),
    [sym_false] = ACTIONS(1357),
    [sym_null] = ACTIONS(1357),
    [sym_inf] = ACTIONS(1357),
    [sym_nan] = ACTIONS(1357),
    [anon_sym_NA] = ACTIONS(1357),
    [anon_sym_NA_integer_] = ACTIONS(1357),
    [anon_sym_NA_real_] = ACTIONS(1357),
    [anon_sym_NA_complex_] = ACTIONS(1357),
    [anon_sym_NA_character_] = ACTIONS(1357),
    [sym_dots] = ACTIONS(1357),
    [sym_dot_dot_i] = ACTIONS(1355),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1355),
    [sym__newline] = ACTIONS(1355),
    [sym__raw_string_literal] = ACTIONS(1355),
    [sym__external_else] = ACTIONS(1355),
    [sym__external_open_parenthesis] = ACTIONS(1355),
    [sym__external_open_brace] = ACTIONS(1355),
    [sym__external_open_bracket] = ACTIONS(1355),
    [sym__external_close_bracket] = ACTIONS(1355),
    [sym__external_open_bracket2] = ACTIONS(1355),
  },
  [664] = {
    [sym_identifier] = ACTIONS(1361),
    [anon_sym_BSLASH] = ACTIONS(1359),
    [anon_sym_function] = ACTIONS(1361),
    [anon_sym_EQ] = ACTIONS(1361),
    [anon_sym_if] = ACTIONS(1361),
    [anon_sym_for] = ACTIONS(1361),
    [anon_sym_while] = ACTIONS(1361),
    [anon_sym_repeat] = ACTIONS(1361),
    [anon_sym_QMARK] = ACTIONS(1359),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_BANG] = ACTIONS(1361),
    [anon_sym_PLUS] = ACTIONS(1359),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_LT_DASH] = ACTIONS(1359),
    [anon_sym_LT_LT_DASH] = ACTIONS(1359),
    [anon_sym_COLON_EQ] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [anon_sym_DASH_GT_GT] = ACTIONS(1359),
    [anon_sym_PIPE] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(1361),
    [anon_sym_PIPE_PIPE] = ACTIONS(1359),
    [anon_sym_AMP_AMP] = ACTIONS(1359),
    [anon_sym_LT] = ACTIONS(1361),
    [anon_sym_LT_EQ] = ACTIONS(1359),
    [anon_sym_GT] = ACTIONS(1361),
    [anon_sym_GT_EQ] = ACTIONS(1359),
    [anon_sym_EQ_EQ] = ACTIONS(1359),
    [anon_sym_BANG_EQ] = ACTIONS(1359),
    [anon_sym_STAR] = ACTIONS(1361),
    [anon_sym_SLASH] = ACTIONS(1359),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [aux_sym_binary_operator_token1] = ACTIONS(1359),
    [anon_sym_PIPE_GT] = ACTIONS(1359),
    [anon_sym_COLON] = ACTIONS(1361),
    [anon_sym_DOLLAR] = ACTIONS(1359),
    [anon_sym_AT] = ACTIONS(1359),
    [anon_sym_COLON_COLON] = ACTIONS(1361),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1359),
    [sym__hex_literal] = ACTIONS(1359),
    [sym__number_literal] = ACTIONS(1361),
    [anon_sym_SQUOTE] = ACTIONS(1359),
    [anon_sym_DQUOTE] = ACTIONS(1359),
    [sym_return] = ACTIONS(1361),
    [sym_next] = ACTIONS(1361),
    [sym_break] = ACTIONS(1361),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [sym_null] = ACTIONS(1361),
    [sym_inf] = ACTIONS(1361),
    [sym_nan] = ACTIONS(1361),
    [anon_sym_NA] = ACTIONS(1361),
    [anon_sym_NA_integer_] = ACTIONS(1361),
    [anon_sym_NA_real_] = ACTIONS(1361),
    [anon_sym_NA_complex_] = ACTIONS(1361),
    [anon_sym_NA_character_] = ACTIONS(1361),
    [sym_dots] = ACTIONS(1361),
    [sym_dot_dot_i] = ACTIONS(1359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1359),
    [sym__newline] = ACTIONS(1359),
    [sym__raw_string_literal] = ACTIONS(1359),
    [sym__external_else] = ACTIONS(1359),
    [sym__external_open_parenthesis] = ACTIONS(1359),
    [sym__external_open_brace] = ACTIONS(1359),
    [sym__external_open_bracket] = ACTIONS(1359),
    [sym__external_close_bracket] = ACTIONS(1359),
    [sym__external_open_bracket2] = ACTIONS(1359),
  },
  [665] = {
    [sym_identifier] = ACTIONS(1357),
    [anon_sym_BSLASH] = ACTIONS(1355),
    [anon_sym_function] = ACTIONS(1357),
    [anon_sym_EQ] = ACTIONS(1357),
    [anon_sym_if] = ACTIONS(1357),
    [anon_sym_for] = ACTIONS(1357),
    [anon_sym_while] = ACTIONS(1357),
    [anon_sym_repeat] = ACTIONS(1357),
    [anon_sym_QMARK] = ACTIONS(1355),
    [anon_sym_TILDE] = ACTIONS(1355),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1357),
    [anon_sym_LT_DASH] = ACTIONS(1355),
    [anon_sym_LT_LT_DASH] = ACTIONS(1355),
    [anon_sym_COLON_EQ] = ACTIONS(1355),
    [anon_sym_DASH_GT] = ACTIONS(1357),
    [anon_sym_DASH_GT_GT] = ACTIONS(1355),
    [anon_sym_PIPE] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_AMP_AMP] = ACTIONS(1355),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_LT_EQ] = ACTIONS(1355),
    [anon_sym_GT] = ACTIONS(1357),
    [anon_sym_GT_EQ] = ACTIONS(1355),
    [anon_sym_EQ_EQ] = ACTIONS(1355),
    [anon_sym_BANG_EQ] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1357),
    [anon_sym_SLASH] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1355),
    [anon_sym_CARET] = ACTIONS(1355),
    [aux_sym_binary_operator_token1] = ACTIONS(1355),
    [anon_sym_PIPE_GT] = ACTIONS(1355),
    [anon_sym_COLON] = ACTIONS(1357),
    [anon_sym_DOLLAR] = ACTIONS(1355),
    [anon_sym_AT] = ACTIONS(1355),
    [anon_sym_COLON_COLON] = ACTIONS(1357),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1355),
    [sym__hex_literal] = ACTIONS(1355),
    [sym__number_literal] = ACTIONS(1357),
    [anon_sym_SQUOTE] = ACTIONS(1355),
    [anon_sym_DQUOTE] = ACTIONS(1355),
    [sym_return] = ACTIONS(1357),
    [sym_next] = ACTIONS(1357),
    [sym_break] = ACTIONS(1357),
    [sym_true] = ACTIONS(1357),
    [sym_false] = ACTIONS(1357),
    [sym_null] = ACTIONS(1357),
    [sym_inf] = ACTIONS(1357),
    [sym_nan] = ACTIONS(1357),
    [anon_sym_NA] = ACTIONS(1357),
    [anon_sym_NA_integer_] = ACTIONS(1357),
    [anon_sym_NA_real_] = ACTIONS(1357),
    [anon_sym_NA_complex_] = ACTIONS(1357),
    [anon_sym_NA_character_] = ACTIONS(1357),
    [sym_dots] = ACTIONS(1357),
    [sym_dot_dot_i] = ACTIONS(1355),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1355),
    [sym__semicolon] = ACTIONS(1355),
    [sym__raw_string_literal] = ACTIONS(1355),
    [sym__external_else] = ACTIONS(1355),
    [sym__external_open_parenthesis] = ACTIONS(1355),
    [sym__external_open_brace] = ACTIONS(1355),
    [sym__external_close_brace] = ACTIONS(1355),
    [sym__external_open_bracket] = ACTIONS(1355),
    [sym__external_open_bracket2] = ACTIONS(1355),
  },
  [666] = {
    [sym_identifier] = ACTIONS(1361),
    [anon_sym_BSLASH] = ACTIONS(1359),
    [anon_sym_function] = ACTIONS(1361),
    [anon_sym_EQ] = ACTIONS(1361),
    [anon_sym_if] = ACTIONS(1361),
    [anon_sym_for] = ACTIONS(1361),
    [anon_sym_while] = ACTIONS(1361),
    [anon_sym_repeat] = ACTIONS(1361),
    [anon_sym_QMARK] = ACTIONS(1359),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_BANG] = ACTIONS(1361),
    [anon_sym_PLUS] = ACTIONS(1359),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_LT_DASH] = ACTIONS(1359),
    [anon_sym_LT_LT_DASH] = ACTIONS(1359),
    [anon_sym_COLON_EQ] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [anon_sym_DASH_GT_GT] = ACTIONS(1359),
    [anon_sym_PIPE] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(1361),
    [anon_sym_PIPE_PIPE] = ACTIONS(1359),
    [anon_sym_AMP_AMP] = ACTIONS(1359),
    [anon_sym_LT] = ACTIONS(1361),
    [anon_sym_LT_EQ] = ACTIONS(1359),
    [anon_sym_GT] = ACTIONS(1361),
    [anon_sym_GT_EQ] = ACTIONS(1359),
    [anon_sym_EQ_EQ] = ACTIONS(1359),
    [anon_sym_BANG_EQ] = ACTIONS(1359),
    [anon_sym_STAR] = ACTIONS(1361),
    [anon_sym_SLASH] = ACTIONS(1359),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [aux_sym_binary_operator_token1] = ACTIONS(1359),
    [anon_sym_PIPE_GT] = ACTIONS(1359),
    [anon_sym_COLON] = ACTIONS(1361),
    [anon_sym_DOLLAR] = ACTIONS(1359),
    [anon_sym_AT] = ACTIONS(1359),
    [anon_sym_COLON_COLON] = ACTIONS(1361),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1359),
    [sym__hex_literal] = ACTIONS(1359),
    [sym__number_literal] = ACTIONS(1361),
    [anon_sym_SQUOTE] = ACTIONS(1359),
    [anon_sym_DQUOTE] = ACTIONS(1359),
    [sym_return] = ACTIONS(1361),
    [sym_next] = ACTIONS(1361),
    [sym_break] = ACTIONS(1361),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [sym_null] = ACTIONS(1361),
    [sym_inf] = ACTIONS(1361),
    [sym_nan] = ACTIONS(1361),
    [anon_sym_NA] = ACTIONS(1361),
    [anon_sym_NA_integer_] = ACTIONS(1361),
    [anon_sym_NA_real_] = ACTIONS(1361),
    [anon_sym_NA_complex_] = ACTIONS(1361),
    [anon_sym_NA_character_] = ACTIONS(1361),
    [sym_dots] = ACTIONS(1361),
    [sym_dot_dot_i] = ACTIONS(1359),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1359),
    [sym__semicolon] = ACTIONS(1359),
    [sym__raw_string_literal] = ACTIONS(1359),
    [sym__external_else] = ACTIONS(1359),
    [sym__external_open_parenthesis] = ACTIONS(1359),
    [sym__external_open_brace] = ACTIONS(1359),
    [sym__external_close_brace] = ACTIONS(1359),
    [sym__external_open_bracket] = ACTIONS(1359),
    [sym__external_open_bracket2] = ACTIONS(1359),
  },
  [667] = {
    [ts_builtin_sym_end] = ACTIONS(1363),
    [sym_identifier] = ACTIONS(1365),
    [anon_sym_BSLASH] = ACTIONS(1363),
    [anon_sym_function] = ACTIONS(1365),
    [anon_sym_EQ] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(1365),
    [anon_sym_for] = ACTIONS(1365),
    [anon_sym_while] = ACTIONS(1365),
    [anon_sym_repeat] = ACTIONS(1365),
    [anon_sym_QMARK] = ACTIONS(1363),
    [anon_sym_TILDE] = ACTIONS(1363),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1365),
    [anon_sym_LT_DASH] = ACTIONS(1363),
    [anon_sym_LT_LT_DASH] = ACTIONS(1363),
    [anon_sym_COLON_EQ] = ACTIONS(1363),
    [anon_sym_DASH_GT] = ACTIONS(1365),
    [anon_sym_DASH_GT_GT] = ACTIONS(1363),
    [anon_sym_PIPE] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE_PIPE] = ACTIONS(1363),
    [anon_sym_AMP_AMP] = ACTIONS(1363),
    [anon_sym_LT] = ACTIONS(1365),
    [anon_sym_LT_EQ] = ACTIONS(1363),
    [anon_sym_GT] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1363),
    [anon_sym_EQ_EQ] = ACTIONS(1363),
    [anon_sym_BANG_EQ] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1365),
    [anon_sym_SLASH] = ACTIONS(1363),
    [anon_sym_STAR_STAR] = ACTIONS(1363),
    [anon_sym_CARET] = ACTIONS(1363),
    [aux_sym_binary_operator_token1] = ACTIONS(1363),
    [anon_sym_PIPE_GT] = ACTIONS(1363),
    [anon_sym_COLON] = ACTIONS(1365),
    [anon_sym_DOLLAR] = ACTIONS(1363),
    [anon_sym_AT] = ACTIONS(1363),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1363),
    [sym__hex_literal] = ACTIONS(1363),
    [sym__number_literal] = ACTIONS(1365),
    [anon_sym_SQUOTE] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1363),
    [sym_return] = ACTIONS(1365),
    [sym_next] = ACTIONS(1365),
    [sym_break] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_null] = ACTIONS(1365),
    [sym_inf] = ACTIONS(1365),
    [sym_nan] = ACTIONS(1365),
    [anon_sym_NA] = ACTIONS(1365),
    [anon_sym_NA_integer_] = ACTIONS(1365),
    [anon_sym_NA_real_] = ACTIONS(1365),
    [anon_sym_NA_complex_] = ACTIONS(1365),
    [anon_sym_NA_character_] = ACTIONS(1365),
    [sym_dots] = ACTIONS(1365),
    [sym_dot_dot_i] = ACTIONS(1363),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1363),
    [sym__semicolon] = ACTIONS(1363),
    [sym__raw_string_literal] = ACTIONS(1363),
    [sym__external_else] = ACTIONS(1363),
    [sym__external_open_parenthesis] = ACTIONS(1363),
    [sym__external_open_brace] = ACTIONS(1363),
    [sym__external_open_bracket] = ACTIONS(1363),
    [sym__external_open_bracket2] = ACTIONS(1363),
  },
  [668] = {
    [ts_builtin_sym_end] = ACTIONS(1333),
    [sym_identifier] = ACTIONS(1331),
    [anon_sym_BSLASH] = ACTIONS(1333),
    [anon_sym_function] = ACTIONS(1331),
    [anon_sym_EQ] = ACTIONS(1331),
    [anon_sym_if] = ACTIONS(1331),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_while] = ACTIONS(1331),
    [anon_sym_repeat] = ACTIONS(1331),
    [anon_sym_QMARK] = ACTIONS(1333),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_LT_DASH] = ACTIONS(1333),
    [anon_sym_LT_LT_DASH] = ACTIONS(1333),
    [anon_sym_COLON_EQ] = ACTIONS(1333),
    [anon_sym_DASH_GT] = ACTIONS(1331),
    [anon_sym_DASH_GT_GT] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1331),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1333),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_GT_EQ] = ACTIONS(1333),
    [anon_sym_EQ_EQ] = ACTIONS(1333),
    [anon_sym_BANG_EQ] = ACTIONS(1333),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_SLASH] = ACTIONS(1333),
    [anon_sym_STAR_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1333),
    [aux_sym_binary_operator_token1] = ACTIONS(1333),
    [anon_sym_PIPE_GT] = ACTIONS(1333),
    [anon_sym_COLON] = ACTIONS(1331),
    [anon_sym_DOLLAR] = ACTIONS(1333),
    [anon_sym_AT] = ACTIONS(1333),
    [anon_sym_COLON_COLON] = ACTIONS(1335),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1337),
    [sym__hex_literal] = ACTIONS(1333),
    [sym__number_literal] = ACTIONS(1331),
    [anon_sym_SQUOTE] = ACTIONS(1333),
    [anon_sym_DQUOTE] = ACTIONS(1333),
    [sym_return] = ACTIONS(1331),
    [sym_next] = ACTIONS(1331),
    [sym_break] = ACTIONS(1331),
    [sym_true] = ACTIONS(1331),
    [sym_false] = ACTIONS(1331),
    [sym_null] = ACTIONS(1331),
    [sym_inf] = ACTIONS(1331),
    [sym_nan] = ACTIONS(1331),
    [anon_sym_NA] = ACTIONS(1331),
    [anon_sym_NA_integer_] = ACTIONS(1331),
    [anon_sym_NA_real_] = ACTIONS(1331),
    [anon_sym_NA_complex_] = ACTIONS(1331),
    [anon_sym_NA_character_] = ACTIONS(1331),
    [sym_dots] = ACTIONS(1331),
    [sym_dot_dot_i] = ACTIONS(1333),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1333),
    [sym__semicolon] = ACTIONS(1333),
    [sym__raw_string_literal] = ACTIONS(1333),
    [sym__external_else] = ACTIONS(1333),
    [sym__external_open_parenthesis] = ACTIONS(1333),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_open_bracket] = ACTIONS(1333),
    [sym__external_open_bracket2] = ACTIONS(1333),
  },
  [669] = {
    [sym_identifier] = ACTIONS(1365),
    [anon_sym_BSLASH] = ACTIONS(1363),
    [anon_sym_function] = ACTIONS(1365),
    [anon_sym_EQ] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(1365),
    [anon_sym_for] = ACTIONS(1365),
    [anon_sym_while] = ACTIONS(1365),
    [anon_sym_repeat] = ACTIONS(1365),
    [anon_sym_QMARK] = ACTIONS(1363),
    [anon_sym_TILDE] = ACTIONS(1363),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1365),
    [anon_sym_LT_DASH] = ACTIONS(1363),
    [anon_sym_LT_LT_DASH] = ACTIONS(1363),
    [anon_sym_COLON_EQ] = ACTIONS(1363),
    [anon_sym_DASH_GT] = ACTIONS(1365),
    [anon_sym_DASH_GT_GT] = ACTIONS(1363),
    [anon_sym_PIPE] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE_PIPE] = ACTIONS(1363),
    [anon_sym_AMP_AMP] = ACTIONS(1363),
    [anon_sym_LT] = ACTIONS(1365),
    [anon_sym_LT_EQ] = ACTIONS(1363),
    [anon_sym_GT] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1363),
    [anon_sym_EQ_EQ] = ACTIONS(1363),
    [anon_sym_BANG_EQ] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1365),
    [anon_sym_SLASH] = ACTIONS(1363),
    [anon_sym_STAR_STAR] = ACTIONS(1363),
    [anon_sym_CARET] = ACTIONS(1363),
    [aux_sym_binary_operator_token1] = ACTIONS(1363),
    [anon_sym_PIPE_GT] = ACTIONS(1363),
    [anon_sym_COLON] = ACTIONS(1365),
    [anon_sym_DOLLAR] = ACTIONS(1363),
    [anon_sym_AT] = ACTIONS(1363),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1363),
    [sym__hex_literal] = ACTIONS(1363),
    [sym__number_literal] = ACTIONS(1365),
    [anon_sym_SQUOTE] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1363),
    [sym_return] = ACTIONS(1365),
    [sym_next] = ACTIONS(1365),
    [sym_break] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_null] = ACTIONS(1365),
    [sym_inf] = ACTIONS(1365),
    [sym_nan] = ACTIONS(1365),
    [anon_sym_NA] = ACTIONS(1365),
    [anon_sym_NA_integer_] = ACTIONS(1365),
    [anon_sym_NA_real_] = ACTIONS(1365),
    [anon_sym_NA_complex_] = ACTIONS(1365),
    [anon_sym_NA_character_] = ACTIONS(1365),
    [sym_dots] = ACTIONS(1365),
    [sym_dot_dot_i] = ACTIONS(1363),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1363),
    [sym__newline] = ACTIONS(1363),
    [sym__raw_string_literal] = ACTIONS(1363),
    [sym__external_else] = ACTIONS(1363),
    [sym__external_open_parenthesis] = ACTIONS(1363),
    [sym__external_open_brace] = ACTIONS(1363),
    [sym__external_open_bracket] = ACTIONS(1363),
    [sym__external_open_bracket2] = ACTIONS(1363),
    [sym__external_close_bracket2] = ACTIONS(1363),
  },
  [670] = {
    [sym_identifier] = ACTIONS(1331),
    [anon_sym_BSLASH] = ACTIONS(1333),
    [anon_sym_function] = ACTIONS(1331),
    [anon_sym_EQ] = ACTIONS(1331),
    [anon_sym_if] = ACTIONS(1331),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_while] = ACTIONS(1331),
    [anon_sym_repeat] = ACTIONS(1331),
    [anon_sym_QMARK] = ACTIONS(1333),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_LT_DASH] = ACTIONS(1333),
    [anon_sym_LT_LT_DASH] = ACTIONS(1333),
    [anon_sym_COLON_EQ] = ACTIONS(1333),
    [anon_sym_DASH_GT] = ACTIONS(1331),
    [anon_sym_DASH_GT_GT] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1331),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1333),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_GT_EQ] = ACTIONS(1333),
    [anon_sym_EQ_EQ] = ACTIONS(1333),
    [anon_sym_BANG_EQ] = ACTIONS(1333),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_SLASH] = ACTIONS(1333),
    [anon_sym_STAR_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1333),
    [aux_sym_binary_operator_token1] = ACTIONS(1333),
    [anon_sym_PIPE_GT] = ACTIONS(1333),
    [anon_sym_COLON] = ACTIONS(1331),
    [anon_sym_DOLLAR] = ACTIONS(1333),
    [anon_sym_AT] = ACTIONS(1333),
    [anon_sym_COLON_COLON] = ACTIONS(1335),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1337),
    [sym__hex_literal] = ACTIONS(1333),
    [sym__number_literal] = ACTIONS(1331),
    [anon_sym_SQUOTE] = ACTIONS(1333),
    [anon_sym_DQUOTE] = ACTIONS(1333),
    [sym_return] = ACTIONS(1331),
    [sym_next] = ACTIONS(1331),
    [sym_break] = ACTIONS(1331),
    [sym_true] = ACTIONS(1331),
    [sym_false] = ACTIONS(1331),
    [sym_null] = ACTIONS(1331),
    [sym_inf] = ACTIONS(1331),
    [sym_nan] = ACTIONS(1331),
    [anon_sym_NA] = ACTIONS(1331),
    [anon_sym_NA_integer_] = ACTIONS(1331),
    [anon_sym_NA_real_] = ACTIONS(1331),
    [anon_sym_NA_complex_] = ACTIONS(1331),
    [anon_sym_NA_character_] = ACTIONS(1331),
    [sym_dots] = ACTIONS(1331),
    [sym_dot_dot_i] = ACTIONS(1333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1333),
    [sym__newline] = ACTIONS(1333),
    [sym__raw_string_literal] = ACTIONS(1333),
    [sym__external_else] = ACTIONS(1333),
    [sym__external_open_parenthesis] = ACTIONS(1333),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_open_bracket] = ACTIONS(1333),
    [sym__external_open_bracket2] = ACTIONS(1333),
    [sym__external_close_bracket2] = ACTIONS(1333),
  },
  [671] = {
    [sym_identifier] = ACTIONS(1339),
    [anon_sym_BSLASH] = ACTIONS(1341),
    [anon_sym_function] = ACTIONS(1339),
    [anon_sym_EQ] = ACTIONS(1339),
    [anon_sym_if] = ACTIONS(1339),
    [anon_sym_for] = ACTIONS(1339),
    [anon_sym_while] = ACTIONS(1339),
    [anon_sym_repeat] = ACTIONS(1339),
    [anon_sym_QMARK] = ACTIONS(1341),
    [anon_sym_TILDE] = ACTIONS(1341),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_LT_DASH] = ACTIONS(1341),
    [anon_sym_LT_LT_DASH] = ACTIONS(1341),
    [anon_sym_COLON_EQ] = ACTIONS(1341),
    [anon_sym_DASH_GT] = ACTIONS(1339),
    [anon_sym_DASH_GT_GT] = ACTIONS(1341),
    [anon_sym_PIPE] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_PIPE_PIPE] = ACTIONS(1341),
    [anon_sym_AMP_AMP] = ACTIONS(1341),
    [anon_sym_LT] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1341),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_GT_EQ] = ACTIONS(1341),
    [anon_sym_EQ_EQ] = ACTIONS(1341),
    [anon_sym_BANG_EQ] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_SLASH] = ACTIONS(1341),
    [anon_sym_STAR_STAR] = ACTIONS(1341),
    [anon_sym_CARET] = ACTIONS(1341),
    [aux_sym_binary_operator_token1] = ACTIONS(1341),
    [anon_sym_PIPE_GT] = ACTIONS(1341),
    [anon_sym_COLON] = ACTIONS(1339),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1341),
    [anon_sym_L] = ACTIONS(1367),
    [anon_sym_i] = ACTIONS(1369),
    [sym__hex_literal] = ACTIONS(1341),
    [sym__number_literal] = ACTIONS(1339),
    [anon_sym_SQUOTE] = ACTIONS(1341),
    [anon_sym_DQUOTE] = ACTIONS(1341),
    [sym_return] = ACTIONS(1339),
    [sym_next] = ACTIONS(1339),
    [sym_break] = ACTIONS(1339),
    [sym_true] = ACTIONS(1339),
    [sym_false] = ACTIONS(1339),
    [sym_null] = ACTIONS(1339),
    [sym_inf] = ACTIONS(1339),
    [sym_nan] = ACTIONS(1339),
    [anon_sym_NA] = ACTIONS(1339),
    [anon_sym_NA_integer_] = ACTIONS(1339),
    [anon_sym_NA_real_] = ACTIONS(1339),
    [anon_sym_NA_complex_] = ACTIONS(1339),
    [anon_sym_NA_character_] = ACTIONS(1339),
    [sym_dots] = ACTIONS(1339),
    [sym_dot_dot_i] = ACTIONS(1341),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1341),
    [sym__newline] = ACTIONS(1341),
    [sym__raw_string_literal] = ACTIONS(1341),
    [sym__external_else] = ACTIONS(1341),
    [sym__external_open_parenthesis] = ACTIONS(1341),
    [sym__external_open_brace] = ACTIONS(1341),
    [sym__external_open_bracket] = ACTIONS(1341),
    [sym__external_open_bracket2] = ACTIONS(1341),
    [sym__external_close_bracket2] = ACTIONS(1341),
  },
  [672] = {
    [sym_identifier] = ACTIONS(1347),
    [anon_sym_BSLASH] = ACTIONS(1349),
    [anon_sym_function] = ACTIONS(1347),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_if] = ACTIONS(1347),
    [anon_sym_for] = ACTIONS(1347),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1347),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1347),
    [anon_sym_LT_DASH] = ACTIONS(1349),
    [anon_sym_LT_LT_DASH] = ACTIONS(1349),
    [anon_sym_COLON_EQ] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1347),
    [anon_sym_DASH_GT_GT] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1347),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_GT_EQ] = ACTIONS(1349),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_SLASH] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [aux_sym_binary_operator_token1] = ACTIONS(1349),
    [anon_sym_PIPE_GT] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(1347),
    [anon_sym_DOLLAR] = ACTIONS(1349),
    [anon_sym_AT] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1347),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1349),
    [sym__hex_literal] = ACTIONS(1349),
    [sym__number_literal] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1349),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [sym_return] = ACTIONS(1347),
    [sym_next] = ACTIONS(1347),
    [sym_break] = ACTIONS(1347),
    [sym_true] = ACTIONS(1347),
    [sym_false] = ACTIONS(1347),
    [sym_null] = ACTIONS(1347),
    [sym_inf] = ACTIONS(1347),
    [sym_nan] = ACTIONS(1347),
    [anon_sym_NA] = ACTIONS(1347),
    [anon_sym_NA_integer_] = ACTIONS(1347),
    [anon_sym_NA_real_] = ACTIONS(1347),
    [anon_sym_NA_complex_] = ACTIONS(1347),
    [anon_sym_NA_character_] = ACTIONS(1347),
    [sym_dots] = ACTIONS(1347),
    [sym_dot_dot_i] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1349),
    [sym__newline] = ACTIONS(1349),
    [sym__raw_string_literal] = ACTIONS(1349),
    [sym__external_else] = ACTIONS(1349),
    [sym__external_open_parenthesis] = ACTIONS(1349),
    [sym__external_open_brace] = ACTIONS(1349),
    [sym__external_open_bracket] = ACTIONS(1349),
    [sym__external_open_bracket2] = ACTIONS(1349),
    [sym__external_close_bracket2] = ACTIONS(1349),
  },
  [673] = {
    [sym_identifier] = ACTIONS(1365),
    [anon_sym_BSLASH] = ACTIONS(1363),
    [anon_sym_function] = ACTIONS(1365),
    [anon_sym_EQ] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(1365),
    [anon_sym_for] = ACTIONS(1365),
    [anon_sym_while] = ACTIONS(1365),
    [anon_sym_repeat] = ACTIONS(1365),
    [anon_sym_QMARK] = ACTIONS(1363),
    [anon_sym_TILDE] = ACTIONS(1363),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1365),
    [anon_sym_LT_DASH] = ACTIONS(1363),
    [anon_sym_LT_LT_DASH] = ACTIONS(1363),
    [anon_sym_COLON_EQ] = ACTIONS(1363),
    [anon_sym_DASH_GT] = ACTIONS(1365),
    [anon_sym_DASH_GT_GT] = ACTIONS(1363),
    [anon_sym_PIPE] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE_PIPE] = ACTIONS(1363),
    [anon_sym_AMP_AMP] = ACTIONS(1363),
    [anon_sym_LT] = ACTIONS(1365),
    [anon_sym_LT_EQ] = ACTIONS(1363),
    [anon_sym_GT] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1363),
    [anon_sym_EQ_EQ] = ACTIONS(1363),
    [anon_sym_BANG_EQ] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1365),
    [anon_sym_SLASH] = ACTIONS(1363),
    [anon_sym_STAR_STAR] = ACTIONS(1363),
    [anon_sym_CARET] = ACTIONS(1363),
    [aux_sym_binary_operator_token1] = ACTIONS(1363),
    [anon_sym_PIPE_GT] = ACTIONS(1363),
    [anon_sym_COLON] = ACTIONS(1365),
    [anon_sym_DOLLAR] = ACTIONS(1363),
    [anon_sym_AT] = ACTIONS(1363),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1363),
    [sym__hex_literal] = ACTIONS(1363),
    [sym__number_literal] = ACTIONS(1365),
    [anon_sym_SQUOTE] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1363),
    [sym_return] = ACTIONS(1365),
    [sym_next] = ACTIONS(1365),
    [sym_break] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_null] = ACTIONS(1365),
    [sym_inf] = ACTIONS(1365),
    [sym_nan] = ACTIONS(1365),
    [anon_sym_NA] = ACTIONS(1365),
    [anon_sym_NA_integer_] = ACTIONS(1365),
    [anon_sym_NA_real_] = ACTIONS(1365),
    [anon_sym_NA_complex_] = ACTIONS(1365),
    [anon_sym_NA_character_] = ACTIONS(1365),
    [sym_dots] = ACTIONS(1365),
    [sym_dot_dot_i] = ACTIONS(1363),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1363),
    [sym__semicolon] = ACTIONS(1363),
    [sym__raw_string_literal] = ACTIONS(1363),
    [sym__external_else] = ACTIONS(1363),
    [sym__external_open_parenthesis] = ACTIONS(1363),
    [sym__external_open_brace] = ACTIONS(1363),
    [sym__external_close_brace] = ACTIONS(1363),
    [sym__external_open_bracket] = ACTIONS(1363),
    [sym__external_open_bracket2] = ACTIONS(1363),
  },
  [674] = {
    [sym_identifier] = ACTIONS(1351),
    [anon_sym_BSLASH] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [anon_sym_repeat] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_PLUS] = ACTIONS(1353),
    [anon_sym_DASH] = ACTIONS(1351),
    [anon_sym_LT_DASH] = ACTIONS(1353),
    [anon_sym_LT_LT_DASH] = ACTIONS(1353),
    [anon_sym_COLON_EQ] = ACTIONS(1353),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_DASH_GT_GT] = ACTIONS(1353),
    [anon_sym_PIPE] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PIPE_PIPE] = ACTIONS(1353),
    [anon_sym_AMP_AMP] = ACTIONS(1353),
    [anon_sym_LT] = ACTIONS(1351),
    [anon_sym_LT_EQ] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(1351),
    [anon_sym_GT_EQ] = ACTIONS(1353),
    [anon_sym_EQ_EQ] = ACTIONS(1353),
    [anon_sym_BANG_EQ] = ACTIONS(1353),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_SLASH] = ACTIONS(1353),
    [anon_sym_STAR_STAR] = ACTIONS(1353),
    [anon_sym_CARET] = ACTIONS(1353),
    [aux_sym_binary_operator_token1] = ACTIONS(1353),
    [anon_sym_PIPE_GT] = ACTIONS(1353),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_DOLLAR] = ACTIONS(1353),
    [anon_sym_AT] = ACTIONS(1353),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1353),
    [sym__hex_literal] = ACTIONS(1353),
    [sym__number_literal] = ACTIONS(1351),
    [anon_sym_SQUOTE] = ACTIONS(1353),
    [anon_sym_DQUOTE] = ACTIONS(1353),
    [sym_return] = ACTIONS(1351),
    [sym_next] = ACTIONS(1351),
    [sym_break] = ACTIONS(1351),
    [sym_true] = ACTIONS(1351),
    [sym_false] = ACTIONS(1351),
    [sym_null] = ACTIONS(1351),
    [sym_inf] = ACTIONS(1351),
    [sym_nan] = ACTIONS(1351),
    [anon_sym_NA] = ACTIONS(1351),
    [anon_sym_NA_integer_] = ACTIONS(1351),
    [anon_sym_NA_real_] = ACTIONS(1351),
    [anon_sym_NA_complex_] = ACTIONS(1351),
    [anon_sym_NA_character_] = ACTIONS(1351),
    [sym_dots] = ACTIONS(1351),
    [sym_dot_dot_i] = ACTIONS(1353),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1353),
    [sym__newline] = ACTIONS(1353),
    [sym__raw_string_literal] = ACTIONS(1353),
    [sym__external_else] = ACTIONS(1353),
    [sym__external_open_parenthesis] = ACTIONS(1353),
    [sym__external_open_brace] = ACTIONS(1353),
    [sym__external_open_bracket] = ACTIONS(1353),
    [sym__external_open_bracket2] = ACTIONS(1353),
    [sym__external_close_bracket2] = ACTIONS(1353),
  },
  [675] = {
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_BSLASH] = ACTIONS(1329),
    [anon_sym_function] = ACTIONS(1327),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_repeat] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1329),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_LT_DASH] = ACTIONS(1329),
    [anon_sym_LT_LT_DASH] = ACTIONS(1329),
    [anon_sym_COLON_EQ] = ACTIONS(1329),
    [anon_sym_DASH_GT] = ACTIONS(1327),
    [anon_sym_DASH_GT_GT] = ACTIONS(1329),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1329),
    [anon_sym_AMP_AMP] = ACTIONS(1329),
    [anon_sym_LT] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1329),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1329),
    [anon_sym_EQ_EQ] = ACTIONS(1329),
    [anon_sym_BANG_EQ] = ACTIONS(1329),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_SLASH] = ACTIONS(1329),
    [anon_sym_STAR_STAR] = ACTIONS(1329),
    [anon_sym_CARET] = ACTIONS(1329),
    [aux_sym_binary_operator_token1] = ACTIONS(1329),
    [anon_sym_PIPE_GT] = ACTIONS(1329),
    [anon_sym_COLON] = ACTIONS(1327),
    [anon_sym_DOLLAR] = ACTIONS(1329),
    [anon_sym_AT] = ACTIONS(1329),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1329),
    [sym__hex_literal] = ACTIONS(1329),
    [sym__number_literal] = ACTIONS(1327),
    [anon_sym_SQUOTE] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(1329),
    [sym_return] = ACTIONS(1327),
    [sym_next] = ACTIONS(1327),
    [sym_break] = ACTIONS(1327),
    [sym_true] = ACTIONS(1327),
    [sym_false] = ACTIONS(1327),
    [sym_null] = ACTIONS(1327),
    [sym_inf] = ACTIONS(1327),
    [sym_nan] = ACTIONS(1327),
    [anon_sym_NA] = ACTIONS(1327),
    [anon_sym_NA_integer_] = ACTIONS(1327),
    [anon_sym_NA_real_] = ACTIONS(1327),
    [anon_sym_NA_complex_] = ACTIONS(1327),
    [anon_sym_NA_character_] = ACTIONS(1327),
    [sym_dots] = ACTIONS(1327),
    [sym_dot_dot_i] = ACTIONS(1329),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1329),
    [sym__newline] = ACTIONS(1329),
    [sym__raw_string_literal] = ACTIONS(1329),
    [sym__external_else] = ACTIONS(1329),
    [sym__external_open_parenthesis] = ACTIONS(1329),
    [sym__external_open_brace] = ACTIONS(1329),
    [sym__external_open_bracket] = ACTIONS(1329),
    [sym__external_open_bracket2] = ACTIONS(1329),
    [sym__external_close_bracket2] = ACTIONS(1329),
  },
  [676] = {
    [ts_builtin_sym_end] = ACTIONS(1341),
    [sym_identifier] = ACTIONS(1339),
    [anon_sym_BSLASH] = ACTIONS(1341),
    [anon_sym_function] = ACTIONS(1339),
    [anon_sym_EQ] = ACTIONS(1339),
    [anon_sym_if] = ACTIONS(1339),
    [anon_sym_for] = ACTIONS(1339),
    [anon_sym_while] = ACTIONS(1339),
    [anon_sym_repeat] = ACTIONS(1339),
    [anon_sym_QMARK] = ACTIONS(1341),
    [anon_sym_TILDE] = ACTIONS(1341),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_LT_DASH] = ACTIONS(1341),
    [anon_sym_LT_LT_DASH] = ACTIONS(1341),
    [anon_sym_COLON_EQ] = ACTIONS(1341),
    [anon_sym_DASH_GT] = ACTIONS(1339),
    [anon_sym_DASH_GT_GT] = ACTIONS(1341),
    [anon_sym_PIPE] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_PIPE_PIPE] = ACTIONS(1341),
    [anon_sym_AMP_AMP] = ACTIONS(1341),
    [anon_sym_LT] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1341),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_GT_EQ] = ACTIONS(1341),
    [anon_sym_EQ_EQ] = ACTIONS(1341),
    [anon_sym_BANG_EQ] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_SLASH] = ACTIONS(1341),
    [anon_sym_STAR_STAR] = ACTIONS(1341),
    [anon_sym_CARET] = ACTIONS(1341),
    [aux_sym_binary_operator_token1] = ACTIONS(1341),
    [anon_sym_PIPE_GT] = ACTIONS(1341),
    [anon_sym_COLON] = ACTIONS(1339),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1341),
    [anon_sym_L] = ACTIONS(1371),
    [anon_sym_i] = ACTIONS(1373),
    [sym__hex_literal] = ACTIONS(1341),
    [sym__number_literal] = ACTIONS(1339),
    [anon_sym_SQUOTE] = ACTIONS(1341),
    [anon_sym_DQUOTE] = ACTIONS(1341),
    [sym_return] = ACTIONS(1339),
    [sym_next] = ACTIONS(1339),
    [sym_break] = ACTIONS(1339),
    [sym_true] = ACTIONS(1339),
    [sym_false] = ACTIONS(1339),
    [sym_null] = ACTIONS(1339),
    [sym_inf] = ACTIONS(1339),
    [sym_nan] = ACTIONS(1339),
    [anon_sym_NA] = ACTIONS(1339),
    [anon_sym_NA_integer_] = ACTIONS(1339),
    [anon_sym_NA_real_] = ACTIONS(1339),
    [anon_sym_NA_complex_] = ACTIONS(1339),
    [anon_sym_NA_character_] = ACTIONS(1339),
    [sym_dots] = ACTIONS(1339),
    [sym_dot_dot_i] = ACTIONS(1341),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1341),
    [sym__semicolon] = ACTIONS(1341),
    [sym__raw_string_literal] = ACTIONS(1341),
    [sym__external_else] = ACTIONS(1341),
    [sym__external_open_parenthesis] = ACTIONS(1341),
    [sym__external_open_brace] = ACTIONS(1341),
    [sym__external_open_bracket] = ACTIONS(1341),
    [sym__external_open_bracket2] = ACTIONS(1341),
  },
  [677] = {
    [sym_identifier] = ACTIONS(1357),
    [anon_sym_BSLASH] = ACTIONS(1355),
    [anon_sym_function] = ACTIONS(1357),
    [anon_sym_EQ] = ACTIONS(1357),
    [anon_sym_if] = ACTIONS(1357),
    [anon_sym_for] = ACTIONS(1357),
    [anon_sym_while] = ACTIONS(1357),
    [anon_sym_repeat] = ACTIONS(1357),
    [anon_sym_QMARK] = ACTIONS(1355),
    [anon_sym_TILDE] = ACTIONS(1355),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1357),
    [anon_sym_LT_DASH] = ACTIONS(1355),
    [anon_sym_LT_LT_DASH] = ACTIONS(1355),
    [anon_sym_COLON_EQ] = ACTIONS(1355),
    [anon_sym_DASH_GT] = ACTIONS(1357),
    [anon_sym_DASH_GT_GT] = ACTIONS(1355),
    [anon_sym_PIPE] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_AMP_AMP] = ACTIONS(1355),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_LT_EQ] = ACTIONS(1355),
    [anon_sym_GT] = ACTIONS(1357),
    [anon_sym_GT_EQ] = ACTIONS(1355),
    [anon_sym_EQ_EQ] = ACTIONS(1355),
    [anon_sym_BANG_EQ] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1357),
    [anon_sym_SLASH] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1355),
    [anon_sym_CARET] = ACTIONS(1355),
    [aux_sym_binary_operator_token1] = ACTIONS(1355),
    [anon_sym_PIPE_GT] = ACTIONS(1355),
    [anon_sym_COLON] = ACTIONS(1357),
    [anon_sym_DOLLAR] = ACTIONS(1355),
    [anon_sym_AT] = ACTIONS(1355),
    [anon_sym_COLON_COLON] = ACTIONS(1357),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1355),
    [sym__hex_literal] = ACTIONS(1355),
    [sym__number_literal] = ACTIONS(1357),
    [anon_sym_SQUOTE] = ACTIONS(1355),
    [anon_sym_DQUOTE] = ACTIONS(1355),
    [sym_return] = ACTIONS(1357),
    [sym_next] = ACTIONS(1357),
    [sym_break] = ACTIONS(1357),
    [sym_true] = ACTIONS(1357),
    [sym_false] = ACTIONS(1357),
    [sym_null] = ACTIONS(1357),
    [sym_inf] = ACTIONS(1357),
    [sym_nan] = ACTIONS(1357),
    [anon_sym_NA] = ACTIONS(1357),
    [anon_sym_NA_integer_] = ACTIONS(1357),
    [anon_sym_NA_real_] = ACTIONS(1357),
    [anon_sym_NA_complex_] = ACTIONS(1357),
    [anon_sym_NA_character_] = ACTIONS(1357),
    [sym_dots] = ACTIONS(1357),
    [sym_dot_dot_i] = ACTIONS(1355),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1355),
    [sym__newline] = ACTIONS(1355),
    [sym__raw_string_literal] = ACTIONS(1355),
    [sym__external_else] = ACTIONS(1355),
    [sym__external_open_parenthesis] = ACTIONS(1355),
    [sym__external_open_brace] = ACTIONS(1355),
    [sym__external_open_bracket] = ACTIONS(1355),
    [sym__external_open_bracket2] = ACTIONS(1355),
    [sym__external_close_bracket2] = ACTIONS(1355),
  },
  [678] = {
    [sym_identifier] = ACTIONS(1361),
    [anon_sym_BSLASH] = ACTIONS(1359),
    [anon_sym_function] = ACTIONS(1361),
    [anon_sym_EQ] = ACTIONS(1361),
    [anon_sym_if] = ACTIONS(1361),
    [anon_sym_for] = ACTIONS(1361),
    [anon_sym_while] = ACTIONS(1361),
    [anon_sym_repeat] = ACTIONS(1361),
    [anon_sym_QMARK] = ACTIONS(1359),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_BANG] = ACTIONS(1361),
    [anon_sym_PLUS] = ACTIONS(1359),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_LT_DASH] = ACTIONS(1359),
    [anon_sym_LT_LT_DASH] = ACTIONS(1359),
    [anon_sym_COLON_EQ] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [anon_sym_DASH_GT_GT] = ACTIONS(1359),
    [anon_sym_PIPE] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(1361),
    [anon_sym_PIPE_PIPE] = ACTIONS(1359),
    [anon_sym_AMP_AMP] = ACTIONS(1359),
    [anon_sym_LT] = ACTIONS(1361),
    [anon_sym_LT_EQ] = ACTIONS(1359),
    [anon_sym_GT] = ACTIONS(1361),
    [anon_sym_GT_EQ] = ACTIONS(1359),
    [anon_sym_EQ_EQ] = ACTIONS(1359),
    [anon_sym_BANG_EQ] = ACTIONS(1359),
    [anon_sym_STAR] = ACTIONS(1361),
    [anon_sym_SLASH] = ACTIONS(1359),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [aux_sym_binary_operator_token1] = ACTIONS(1359),
    [anon_sym_PIPE_GT] = ACTIONS(1359),
    [anon_sym_COLON] = ACTIONS(1361),
    [anon_sym_DOLLAR] = ACTIONS(1359),
    [anon_sym_AT] = ACTIONS(1359),
    [anon_sym_COLON_COLON] = ACTIONS(1361),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1359),
    [sym__hex_literal] = ACTIONS(1359),
    [sym__number_literal] = ACTIONS(1361),
    [anon_sym_SQUOTE] = ACTIONS(1359),
    [anon_sym_DQUOTE] = ACTIONS(1359),
    [sym_return] = ACTIONS(1361),
    [sym_next] = ACTIONS(1361),
    [sym_break] = ACTIONS(1361),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [sym_null] = ACTIONS(1361),
    [sym_inf] = ACTIONS(1361),
    [sym_nan] = ACTIONS(1361),
    [anon_sym_NA] = ACTIONS(1361),
    [anon_sym_NA_integer_] = ACTIONS(1361),
    [anon_sym_NA_real_] = ACTIONS(1361),
    [anon_sym_NA_complex_] = ACTIONS(1361),
    [anon_sym_NA_character_] = ACTIONS(1361),
    [sym_dots] = ACTIONS(1361),
    [sym_dot_dot_i] = ACTIONS(1359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1359),
    [sym__newline] = ACTIONS(1359),
    [sym__raw_string_literal] = ACTIONS(1359),
    [sym__external_else] = ACTIONS(1359),
    [sym__external_open_parenthesis] = ACTIONS(1359),
    [sym__external_open_brace] = ACTIONS(1359),
    [sym__external_open_bracket] = ACTIONS(1359),
    [sym__external_open_bracket2] = ACTIONS(1359),
    [sym__external_close_bracket2] = ACTIONS(1359),
  },
  [679] = {
    [ts_builtin_sym_end] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1347),
    [anon_sym_BSLASH] = ACTIONS(1349),
    [anon_sym_function] = ACTIONS(1347),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_if] = ACTIONS(1347),
    [anon_sym_for] = ACTIONS(1347),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1347),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1347),
    [anon_sym_LT_DASH] = ACTIONS(1349),
    [anon_sym_LT_LT_DASH] = ACTIONS(1349),
    [anon_sym_COLON_EQ] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1347),
    [anon_sym_DASH_GT_GT] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1347),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_GT_EQ] = ACTIONS(1349),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_SLASH] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [aux_sym_binary_operator_token1] = ACTIONS(1349),
    [anon_sym_PIPE_GT] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(1347),
    [anon_sym_DOLLAR] = ACTIONS(1349),
    [anon_sym_AT] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1347),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1349),
    [sym__hex_literal] = ACTIONS(1349),
    [sym__number_literal] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1349),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [sym_return] = ACTIONS(1347),
    [sym_next] = ACTIONS(1347),
    [sym_break] = ACTIONS(1347),
    [sym_true] = ACTIONS(1347),
    [sym_false] = ACTIONS(1347),
    [sym_null] = ACTIONS(1347),
    [sym_inf] = ACTIONS(1347),
    [sym_nan] = ACTIONS(1347),
    [anon_sym_NA] = ACTIONS(1347),
    [anon_sym_NA_integer_] = ACTIONS(1347),
    [anon_sym_NA_real_] = ACTIONS(1347),
    [anon_sym_NA_complex_] = ACTIONS(1347),
    [anon_sym_NA_character_] = ACTIONS(1347),
    [sym_dots] = ACTIONS(1347),
    [sym_dot_dot_i] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1349),
    [sym__semicolon] = ACTIONS(1349),
    [sym__raw_string_literal] = ACTIONS(1349),
    [sym__external_else] = ACTIONS(1349),
    [sym__external_open_parenthesis] = ACTIONS(1349),
    [sym__external_open_brace] = ACTIONS(1349),
    [sym__external_open_bracket] = ACTIONS(1349),
    [sym__external_open_bracket2] = ACTIONS(1349),
  },
  [680] = {
    [ts_builtin_sym_end] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1347),
    [anon_sym_BSLASH] = ACTIONS(1349),
    [anon_sym_function] = ACTIONS(1347),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_if] = ACTIONS(1347),
    [anon_sym_for] = ACTIONS(1347),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1347),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1347),
    [anon_sym_LT_DASH] = ACTIONS(1349),
    [anon_sym_LT_LT_DASH] = ACTIONS(1349),
    [anon_sym_COLON_EQ] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1347),
    [anon_sym_DASH_GT_GT] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1347),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_GT_EQ] = ACTIONS(1349),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_SLASH] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [aux_sym_binary_operator_token1] = ACTIONS(1349),
    [anon_sym_PIPE_GT] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(1347),
    [anon_sym_DOLLAR] = ACTIONS(1349),
    [anon_sym_AT] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1347),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1349),
    [sym__hex_literal] = ACTIONS(1349),
    [sym__number_literal] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1349),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [sym_return] = ACTIONS(1347),
    [sym_next] = ACTIONS(1347),
    [sym_break] = ACTIONS(1347),
    [sym_true] = ACTIONS(1347),
    [sym_false] = ACTIONS(1347),
    [sym_null] = ACTIONS(1347),
    [sym_inf] = ACTIONS(1347),
    [sym_nan] = ACTIONS(1347),
    [anon_sym_NA] = ACTIONS(1347),
    [anon_sym_NA_integer_] = ACTIONS(1347),
    [anon_sym_NA_real_] = ACTIONS(1347),
    [anon_sym_NA_complex_] = ACTIONS(1347),
    [anon_sym_NA_character_] = ACTIONS(1347),
    [sym_dots] = ACTIONS(1347),
    [sym_dot_dot_i] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1349),
    [sym__semicolon] = ACTIONS(1349),
    [sym__raw_string_literal] = ACTIONS(1349),
    [sym__external_else] = ACTIONS(1349),
    [sym__external_open_parenthesis] = ACTIONS(1349),
    [sym__external_open_brace] = ACTIONS(1349),
    [sym__external_open_bracket] = ACTIONS(1349),
    [sym__external_open_bracket2] = ACTIONS(1349),
  },
  [681] = {
    [sym_identifier] = ACTIONS(1365),
    [anon_sym_BSLASH] = ACTIONS(1363),
    [anon_sym_function] = ACTIONS(1365),
    [anon_sym_EQ] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(1365),
    [anon_sym_for] = ACTIONS(1365),
    [anon_sym_while] = ACTIONS(1365),
    [anon_sym_repeat] = ACTIONS(1365),
    [anon_sym_QMARK] = ACTIONS(1363),
    [anon_sym_TILDE] = ACTIONS(1363),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1365),
    [anon_sym_LT_DASH] = ACTIONS(1363),
    [anon_sym_LT_LT_DASH] = ACTIONS(1363),
    [anon_sym_COLON_EQ] = ACTIONS(1363),
    [anon_sym_DASH_GT] = ACTIONS(1365),
    [anon_sym_DASH_GT_GT] = ACTIONS(1363),
    [anon_sym_PIPE] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE_PIPE] = ACTIONS(1363),
    [anon_sym_AMP_AMP] = ACTIONS(1363),
    [anon_sym_LT] = ACTIONS(1365),
    [anon_sym_LT_EQ] = ACTIONS(1363),
    [anon_sym_GT] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1363),
    [anon_sym_EQ_EQ] = ACTIONS(1363),
    [anon_sym_BANG_EQ] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1365),
    [anon_sym_SLASH] = ACTIONS(1363),
    [anon_sym_STAR_STAR] = ACTIONS(1363),
    [anon_sym_CARET] = ACTIONS(1363),
    [aux_sym_binary_operator_token1] = ACTIONS(1363),
    [anon_sym_PIPE_GT] = ACTIONS(1363),
    [anon_sym_COLON] = ACTIONS(1365),
    [anon_sym_DOLLAR] = ACTIONS(1363),
    [anon_sym_AT] = ACTIONS(1363),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1363),
    [sym__hex_literal] = ACTIONS(1363),
    [sym__number_literal] = ACTIONS(1365),
    [anon_sym_SQUOTE] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1363),
    [sym_return] = ACTIONS(1365),
    [sym_next] = ACTIONS(1365),
    [sym_break] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_null] = ACTIONS(1365),
    [sym_inf] = ACTIONS(1365),
    [sym_nan] = ACTIONS(1365),
    [anon_sym_NA] = ACTIONS(1365),
    [anon_sym_NA_integer_] = ACTIONS(1365),
    [anon_sym_NA_real_] = ACTIONS(1365),
    [anon_sym_NA_complex_] = ACTIONS(1365),
    [anon_sym_NA_character_] = ACTIONS(1365),
    [sym_dots] = ACTIONS(1365),
    [sym_dot_dot_i] = ACTIONS(1363),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1363),
    [sym__newline] = ACTIONS(1363),
    [sym__raw_string_literal] = ACTIONS(1363),
    [sym__external_else] = ACTIONS(1363),
    [sym__external_open_parenthesis] = ACTIONS(1363),
    [sym__external_close_parenthesis] = ACTIONS(1363),
    [sym__external_open_brace] = ACTIONS(1363),
    [sym__external_open_bracket] = ACTIONS(1363),
    [sym__external_open_bracket2] = ACTIONS(1363),
  },
  [682] = {
    [sym_identifier] = ACTIONS(1331),
    [anon_sym_BSLASH] = ACTIONS(1333),
    [anon_sym_function] = ACTIONS(1331),
    [anon_sym_EQ] = ACTIONS(1331),
    [anon_sym_if] = ACTIONS(1331),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_while] = ACTIONS(1331),
    [anon_sym_repeat] = ACTIONS(1331),
    [anon_sym_QMARK] = ACTIONS(1333),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_LT_DASH] = ACTIONS(1333),
    [anon_sym_LT_LT_DASH] = ACTIONS(1333),
    [anon_sym_COLON_EQ] = ACTIONS(1333),
    [anon_sym_DASH_GT] = ACTIONS(1331),
    [anon_sym_DASH_GT_GT] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1331),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1333),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_GT_EQ] = ACTIONS(1333),
    [anon_sym_EQ_EQ] = ACTIONS(1333),
    [anon_sym_BANG_EQ] = ACTIONS(1333),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_SLASH] = ACTIONS(1333),
    [anon_sym_STAR_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1333),
    [aux_sym_binary_operator_token1] = ACTIONS(1333),
    [anon_sym_PIPE_GT] = ACTIONS(1333),
    [anon_sym_COLON] = ACTIONS(1331),
    [anon_sym_DOLLAR] = ACTIONS(1333),
    [anon_sym_AT] = ACTIONS(1333),
    [anon_sym_COLON_COLON] = ACTIONS(1335),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1337),
    [sym__hex_literal] = ACTIONS(1333),
    [sym__number_literal] = ACTIONS(1331),
    [anon_sym_SQUOTE] = ACTIONS(1333),
    [anon_sym_DQUOTE] = ACTIONS(1333),
    [sym_return] = ACTIONS(1331),
    [sym_next] = ACTIONS(1331),
    [sym_break] = ACTIONS(1331),
    [sym_true] = ACTIONS(1331),
    [sym_false] = ACTIONS(1331),
    [sym_null] = ACTIONS(1331),
    [sym_inf] = ACTIONS(1331),
    [sym_nan] = ACTIONS(1331),
    [anon_sym_NA] = ACTIONS(1331),
    [anon_sym_NA_integer_] = ACTIONS(1331),
    [anon_sym_NA_real_] = ACTIONS(1331),
    [anon_sym_NA_complex_] = ACTIONS(1331),
    [anon_sym_NA_character_] = ACTIONS(1331),
    [sym_dots] = ACTIONS(1331),
    [sym_dot_dot_i] = ACTIONS(1333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1333),
    [sym__newline] = ACTIONS(1333),
    [sym__raw_string_literal] = ACTIONS(1333),
    [sym__external_else] = ACTIONS(1333),
    [sym__external_open_parenthesis] = ACTIONS(1333),
    [sym__external_close_parenthesis] = ACTIONS(1333),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_open_bracket] = ACTIONS(1333),
    [sym__external_open_bracket2] = ACTIONS(1333),
  },
  [683] = {
    [sym_identifier] = ACTIONS(1339),
    [anon_sym_BSLASH] = ACTIONS(1341),
    [anon_sym_function] = ACTIONS(1339),
    [anon_sym_EQ] = ACTIONS(1339),
    [anon_sym_if] = ACTIONS(1339),
    [anon_sym_for] = ACTIONS(1339),
    [anon_sym_while] = ACTIONS(1339),
    [anon_sym_repeat] = ACTIONS(1339),
    [anon_sym_QMARK] = ACTIONS(1341),
    [anon_sym_TILDE] = ACTIONS(1341),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_LT_DASH] = ACTIONS(1341),
    [anon_sym_LT_LT_DASH] = ACTIONS(1341),
    [anon_sym_COLON_EQ] = ACTIONS(1341),
    [anon_sym_DASH_GT] = ACTIONS(1339),
    [anon_sym_DASH_GT_GT] = ACTIONS(1341),
    [anon_sym_PIPE] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_PIPE_PIPE] = ACTIONS(1341),
    [anon_sym_AMP_AMP] = ACTIONS(1341),
    [anon_sym_LT] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1341),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_GT_EQ] = ACTIONS(1341),
    [anon_sym_EQ_EQ] = ACTIONS(1341),
    [anon_sym_BANG_EQ] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_SLASH] = ACTIONS(1341),
    [anon_sym_STAR_STAR] = ACTIONS(1341),
    [anon_sym_CARET] = ACTIONS(1341),
    [aux_sym_binary_operator_token1] = ACTIONS(1341),
    [anon_sym_PIPE_GT] = ACTIONS(1341),
    [anon_sym_COLON] = ACTIONS(1339),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1341),
    [anon_sym_L] = ACTIONS(1375),
    [anon_sym_i] = ACTIONS(1377),
    [sym__hex_literal] = ACTIONS(1341),
    [sym__number_literal] = ACTIONS(1339),
    [anon_sym_SQUOTE] = ACTIONS(1341),
    [anon_sym_DQUOTE] = ACTIONS(1341),
    [sym_return] = ACTIONS(1339),
    [sym_next] = ACTIONS(1339),
    [sym_break] = ACTIONS(1339),
    [sym_true] = ACTIONS(1339),
    [sym_false] = ACTIONS(1339),
    [sym_null] = ACTIONS(1339),
    [sym_inf] = ACTIONS(1339),
    [sym_nan] = ACTIONS(1339),
    [anon_sym_NA] = ACTIONS(1339),
    [anon_sym_NA_integer_] = ACTIONS(1339),
    [anon_sym_NA_real_] = ACTIONS(1339),
    [anon_sym_NA_complex_] = ACTIONS(1339),
    [anon_sym_NA_character_] = ACTIONS(1339),
    [sym_dots] = ACTIONS(1339),
    [sym_dot_dot_i] = ACTIONS(1341),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1341),
    [sym__newline] = ACTIONS(1341),
    [sym__raw_string_literal] = ACTIONS(1341),
    [sym__external_else] = ACTIONS(1341),
    [sym__external_open_parenthesis] = ACTIONS(1341),
    [sym__external_close_parenthesis] = ACTIONS(1341),
    [sym__external_open_brace] = ACTIONS(1341),
    [sym__external_open_bracket] = ACTIONS(1341),
    [sym__external_open_bracket2] = ACTIONS(1341),
  },
  [684] = {
    [sym_identifier] = ACTIONS(1347),
    [anon_sym_BSLASH] = ACTIONS(1349),
    [anon_sym_function] = ACTIONS(1347),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_if] = ACTIONS(1347),
    [anon_sym_for] = ACTIONS(1347),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1347),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1347),
    [anon_sym_LT_DASH] = ACTIONS(1349),
    [anon_sym_LT_LT_DASH] = ACTIONS(1349),
    [anon_sym_COLON_EQ] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1347),
    [anon_sym_DASH_GT_GT] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1347),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_GT_EQ] = ACTIONS(1349),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_SLASH] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [aux_sym_binary_operator_token1] = ACTIONS(1349),
    [anon_sym_PIPE_GT] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(1347),
    [anon_sym_DOLLAR] = ACTIONS(1349),
    [anon_sym_AT] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1347),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1349),
    [sym__hex_literal] = ACTIONS(1349),
    [sym__number_literal] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1349),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [sym_return] = ACTIONS(1347),
    [sym_next] = ACTIONS(1347),
    [sym_break] = ACTIONS(1347),
    [sym_true] = ACTIONS(1347),
    [sym_false] = ACTIONS(1347),
    [sym_null] = ACTIONS(1347),
    [sym_inf] = ACTIONS(1347),
    [sym_nan] = ACTIONS(1347),
    [anon_sym_NA] = ACTIONS(1347),
    [anon_sym_NA_integer_] = ACTIONS(1347),
    [anon_sym_NA_real_] = ACTIONS(1347),
    [anon_sym_NA_complex_] = ACTIONS(1347),
    [anon_sym_NA_character_] = ACTIONS(1347),
    [sym_dots] = ACTIONS(1347),
    [sym_dot_dot_i] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1349),
    [sym__newline] = ACTIONS(1349),
    [sym__raw_string_literal] = ACTIONS(1349),
    [sym__external_else] = ACTIONS(1349),
    [sym__external_open_parenthesis] = ACTIONS(1349),
    [sym__external_close_parenthesis] = ACTIONS(1349),
    [sym__external_open_brace] = ACTIONS(1349),
    [sym__external_open_bracket] = ACTIONS(1349),
    [sym__external_open_bracket2] = ACTIONS(1349),
  },
  [685] = {
    [sym_identifier] = ACTIONS(1347),
    [anon_sym_BSLASH] = ACTIONS(1349),
    [anon_sym_function] = ACTIONS(1347),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_if] = ACTIONS(1347),
    [anon_sym_for] = ACTIONS(1347),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1347),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1347),
    [anon_sym_LT_DASH] = ACTIONS(1349),
    [anon_sym_LT_LT_DASH] = ACTIONS(1349),
    [anon_sym_COLON_EQ] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1347),
    [anon_sym_DASH_GT_GT] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1347),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_GT_EQ] = ACTIONS(1349),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_SLASH] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [aux_sym_binary_operator_token1] = ACTIONS(1349),
    [anon_sym_PIPE_GT] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(1347),
    [anon_sym_DOLLAR] = ACTIONS(1349),
    [anon_sym_AT] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1347),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1349),
    [sym__hex_literal] = ACTIONS(1349),
    [sym__number_literal] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1349),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [sym_return] = ACTIONS(1347),
    [sym_next] = ACTIONS(1347),
    [sym_break] = ACTIONS(1347),
    [sym_true] = ACTIONS(1347),
    [sym_false] = ACTIONS(1347),
    [sym_null] = ACTIONS(1347),
    [sym_inf] = ACTIONS(1347),
    [sym_nan] = ACTIONS(1347),
    [anon_sym_NA] = ACTIONS(1347),
    [anon_sym_NA_integer_] = ACTIONS(1347),
    [anon_sym_NA_real_] = ACTIONS(1347),
    [anon_sym_NA_complex_] = ACTIONS(1347),
    [anon_sym_NA_character_] = ACTIONS(1347),
    [sym_dots] = ACTIONS(1347),
    [sym_dot_dot_i] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1349),
    [sym__newline] = ACTIONS(1349),
    [sym__raw_string_literal] = ACTIONS(1349),
    [sym__external_else] = ACTIONS(1349),
    [sym__external_open_parenthesis] = ACTIONS(1349),
    [sym__external_close_parenthesis] = ACTIONS(1349),
    [sym__external_open_brace] = ACTIONS(1349),
    [sym__external_open_bracket] = ACTIONS(1349),
    [sym__external_open_bracket2] = ACTIONS(1349),
  },
  [686] = {
    [sym_identifier] = ACTIONS(1347),
    [anon_sym_BSLASH] = ACTIONS(1349),
    [anon_sym_function] = ACTIONS(1347),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_if] = ACTIONS(1347),
    [anon_sym_for] = ACTIONS(1347),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1347),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1347),
    [anon_sym_LT_DASH] = ACTIONS(1349),
    [anon_sym_LT_LT_DASH] = ACTIONS(1349),
    [anon_sym_COLON_EQ] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1347),
    [anon_sym_DASH_GT_GT] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1347),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_GT_EQ] = ACTIONS(1349),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_SLASH] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [aux_sym_binary_operator_token1] = ACTIONS(1349),
    [anon_sym_PIPE_GT] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(1347),
    [anon_sym_DOLLAR] = ACTIONS(1349),
    [anon_sym_AT] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1347),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1349),
    [sym__hex_literal] = ACTIONS(1349),
    [sym__number_literal] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1349),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [sym_return] = ACTIONS(1347),
    [sym_next] = ACTIONS(1347),
    [sym_break] = ACTIONS(1347),
    [sym_true] = ACTIONS(1347),
    [sym_false] = ACTIONS(1347),
    [sym_null] = ACTIONS(1347),
    [sym_inf] = ACTIONS(1347),
    [sym_nan] = ACTIONS(1347),
    [anon_sym_NA] = ACTIONS(1347),
    [anon_sym_NA_integer_] = ACTIONS(1347),
    [anon_sym_NA_real_] = ACTIONS(1347),
    [anon_sym_NA_complex_] = ACTIONS(1347),
    [anon_sym_NA_character_] = ACTIONS(1347),
    [sym_dots] = ACTIONS(1347),
    [sym_dot_dot_i] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1349),
    [sym__semicolon] = ACTIONS(1349),
    [sym__raw_string_literal] = ACTIONS(1349),
    [sym__external_else] = ACTIONS(1349),
    [sym__external_open_parenthesis] = ACTIONS(1349),
    [sym__external_open_brace] = ACTIONS(1349),
    [sym__external_close_brace] = ACTIONS(1349),
    [sym__external_open_bracket] = ACTIONS(1349),
    [sym__external_open_bracket2] = ACTIONS(1349),
  },
  [687] = {
    [sym_identifier] = ACTIONS(1351),
    [anon_sym_BSLASH] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [anon_sym_repeat] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_PLUS] = ACTIONS(1353),
    [anon_sym_DASH] = ACTIONS(1351),
    [anon_sym_LT_DASH] = ACTIONS(1353),
    [anon_sym_LT_LT_DASH] = ACTIONS(1353),
    [anon_sym_COLON_EQ] = ACTIONS(1353),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_DASH_GT_GT] = ACTIONS(1353),
    [anon_sym_PIPE] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PIPE_PIPE] = ACTIONS(1353),
    [anon_sym_AMP_AMP] = ACTIONS(1353),
    [anon_sym_LT] = ACTIONS(1351),
    [anon_sym_LT_EQ] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(1351),
    [anon_sym_GT_EQ] = ACTIONS(1353),
    [anon_sym_EQ_EQ] = ACTIONS(1353),
    [anon_sym_BANG_EQ] = ACTIONS(1353),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_SLASH] = ACTIONS(1353),
    [anon_sym_STAR_STAR] = ACTIONS(1353),
    [anon_sym_CARET] = ACTIONS(1353),
    [aux_sym_binary_operator_token1] = ACTIONS(1353),
    [anon_sym_PIPE_GT] = ACTIONS(1353),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_DOLLAR] = ACTIONS(1353),
    [anon_sym_AT] = ACTIONS(1353),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1353),
    [sym__hex_literal] = ACTIONS(1353),
    [sym__number_literal] = ACTIONS(1351),
    [anon_sym_SQUOTE] = ACTIONS(1353),
    [anon_sym_DQUOTE] = ACTIONS(1353),
    [sym_return] = ACTIONS(1351),
    [sym_next] = ACTIONS(1351),
    [sym_break] = ACTIONS(1351),
    [sym_true] = ACTIONS(1351),
    [sym_false] = ACTIONS(1351),
    [sym_null] = ACTIONS(1351),
    [sym_inf] = ACTIONS(1351),
    [sym_nan] = ACTIONS(1351),
    [anon_sym_NA] = ACTIONS(1351),
    [anon_sym_NA_integer_] = ACTIONS(1351),
    [anon_sym_NA_real_] = ACTIONS(1351),
    [anon_sym_NA_complex_] = ACTIONS(1351),
    [anon_sym_NA_character_] = ACTIONS(1351),
    [sym_dots] = ACTIONS(1351),
    [sym_dot_dot_i] = ACTIONS(1353),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1353),
    [sym__newline] = ACTIONS(1353),
    [sym__raw_string_literal] = ACTIONS(1353),
    [sym__external_else] = ACTIONS(1353),
    [sym__external_open_parenthesis] = ACTIONS(1353),
    [sym__external_close_parenthesis] = ACTIONS(1353),
    [sym__external_open_brace] = ACTIONS(1353),
    [sym__external_open_bracket] = ACTIONS(1353),
    [sym__external_open_bracket2] = ACTIONS(1353),
  },
  [688] = {
    [sym_identifier] = ACTIONS(1331),
    [anon_sym_BSLASH] = ACTIONS(1333),
    [anon_sym_function] = ACTIONS(1331),
    [anon_sym_EQ] = ACTIONS(1331),
    [anon_sym_if] = ACTIONS(1331),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_while] = ACTIONS(1331),
    [anon_sym_repeat] = ACTIONS(1331),
    [anon_sym_QMARK] = ACTIONS(1333),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_LT_DASH] = ACTIONS(1333),
    [anon_sym_LT_LT_DASH] = ACTIONS(1333),
    [anon_sym_COLON_EQ] = ACTIONS(1333),
    [anon_sym_DASH_GT] = ACTIONS(1331),
    [anon_sym_DASH_GT_GT] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1331),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1333),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_GT_EQ] = ACTIONS(1333),
    [anon_sym_EQ_EQ] = ACTIONS(1333),
    [anon_sym_BANG_EQ] = ACTIONS(1333),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_SLASH] = ACTIONS(1333),
    [anon_sym_STAR_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1333),
    [aux_sym_binary_operator_token1] = ACTIONS(1333),
    [anon_sym_PIPE_GT] = ACTIONS(1333),
    [anon_sym_COLON] = ACTIONS(1331),
    [anon_sym_DOLLAR] = ACTIONS(1333),
    [anon_sym_AT] = ACTIONS(1333),
    [anon_sym_COLON_COLON] = ACTIONS(1335),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1337),
    [sym__hex_literal] = ACTIONS(1333),
    [sym__number_literal] = ACTIONS(1331),
    [anon_sym_SQUOTE] = ACTIONS(1333),
    [anon_sym_DQUOTE] = ACTIONS(1333),
    [sym_return] = ACTIONS(1331),
    [sym_next] = ACTIONS(1331),
    [sym_break] = ACTIONS(1331),
    [sym_true] = ACTIONS(1331),
    [sym_false] = ACTIONS(1331),
    [sym_null] = ACTIONS(1331),
    [sym_inf] = ACTIONS(1331),
    [sym_nan] = ACTIONS(1331),
    [anon_sym_NA] = ACTIONS(1331),
    [anon_sym_NA_integer_] = ACTIONS(1331),
    [anon_sym_NA_real_] = ACTIONS(1331),
    [anon_sym_NA_complex_] = ACTIONS(1331),
    [anon_sym_NA_character_] = ACTIONS(1331),
    [sym_dots] = ACTIONS(1331),
    [sym_dot_dot_i] = ACTIONS(1333),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1333),
    [sym__semicolon] = ACTIONS(1333),
    [sym__raw_string_literal] = ACTIONS(1333),
    [sym__external_else] = ACTIONS(1333),
    [sym__external_open_parenthesis] = ACTIONS(1333),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_close_brace] = ACTIONS(1333),
    [sym__external_open_bracket] = ACTIONS(1333),
    [sym__external_open_bracket2] = ACTIONS(1333),
  },
  [689] = {
    [ts_builtin_sym_end] = ACTIONS(1353),
    [sym_identifier] = ACTIONS(1351),
    [anon_sym_BSLASH] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [anon_sym_repeat] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_PLUS] = ACTIONS(1353),
    [anon_sym_DASH] = ACTIONS(1351),
    [anon_sym_LT_DASH] = ACTIONS(1353),
    [anon_sym_LT_LT_DASH] = ACTIONS(1353),
    [anon_sym_COLON_EQ] = ACTIONS(1353),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_DASH_GT_GT] = ACTIONS(1353),
    [anon_sym_PIPE] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PIPE_PIPE] = ACTIONS(1353),
    [anon_sym_AMP_AMP] = ACTIONS(1353),
    [anon_sym_LT] = ACTIONS(1351),
    [anon_sym_LT_EQ] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(1351),
    [anon_sym_GT_EQ] = ACTIONS(1353),
    [anon_sym_EQ_EQ] = ACTIONS(1353),
    [anon_sym_BANG_EQ] = ACTIONS(1353),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_SLASH] = ACTIONS(1353),
    [anon_sym_STAR_STAR] = ACTIONS(1353),
    [anon_sym_CARET] = ACTIONS(1353),
    [aux_sym_binary_operator_token1] = ACTIONS(1353),
    [anon_sym_PIPE_GT] = ACTIONS(1353),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_DOLLAR] = ACTIONS(1353),
    [anon_sym_AT] = ACTIONS(1353),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1353),
    [sym__hex_literal] = ACTIONS(1353),
    [sym__number_literal] = ACTIONS(1351),
    [anon_sym_SQUOTE] = ACTIONS(1353),
    [anon_sym_DQUOTE] = ACTIONS(1353),
    [sym_return] = ACTIONS(1351),
    [sym_next] = ACTIONS(1351),
    [sym_break] = ACTIONS(1351),
    [sym_true] = ACTIONS(1351),
    [sym_false] = ACTIONS(1351),
    [sym_null] = ACTIONS(1351),
    [sym_inf] = ACTIONS(1351),
    [sym_nan] = ACTIONS(1351),
    [anon_sym_NA] = ACTIONS(1351),
    [anon_sym_NA_integer_] = ACTIONS(1351),
    [anon_sym_NA_real_] = ACTIONS(1351),
    [anon_sym_NA_complex_] = ACTIONS(1351),
    [anon_sym_NA_character_] = ACTIONS(1351),
    [sym_dots] = ACTIONS(1351),
    [sym_dot_dot_i] = ACTIONS(1353),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1353),
    [sym__semicolon] = ACTIONS(1353),
    [sym__raw_string_literal] = ACTIONS(1353),
    [sym__external_else] = ACTIONS(1353),
    [sym__external_open_parenthesis] = ACTIONS(1353),
    [sym__external_open_brace] = ACTIONS(1353),
    [sym__external_open_bracket] = ACTIONS(1353),
    [sym__external_open_bracket2] = ACTIONS(1353),
  },
  [690] = {
    [ts_builtin_sym_end] = ACTIONS(1329),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_BSLASH] = ACTIONS(1329),
    [anon_sym_function] = ACTIONS(1327),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_repeat] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1329),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_LT_DASH] = ACTIONS(1329),
    [anon_sym_LT_LT_DASH] = ACTIONS(1329),
    [anon_sym_COLON_EQ] = ACTIONS(1329),
    [anon_sym_DASH_GT] = ACTIONS(1327),
    [anon_sym_DASH_GT_GT] = ACTIONS(1329),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1329),
    [anon_sym_AMP_AMP] = ACTIONS(1329),
    [anon_sym_LT] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1329),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1329),
    [anon_sym_EQ_EQ] = ACTIONS(1329),
    [anon_sym_BANG_EQ] = ACTIONS(1329),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_SLASH] = ACTIONS(1329),
    [anon_sym_STAR_STAR] = ACTIONS(1329),
    [anon_sym_CARET] = ACTIONS(1329),
    [aux_sym_binary_operator_token1] = ACTIONS(1329),
    [anon_sym_PIPE_GT] = ACTIONS(1329),
    [anon_sym_COLON] = ACTIONS(1327),
    [anon_sym_DOLLAR] = ACTIONS(1329),
    [anon_sym_AT] = ACTIONS(1329),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1329),
    [sym__hex_literal] = ACTIONS(1329),
    [sym__number_literal] = ACTIONS(1327),
    [anon_sym_SQUOTE] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(1329),
    [sym_return] = ACTIONS(1327),
    [sym_next] = ACTIONS(1327),
    [sym_break] = ACTIONS(1327),
    [sym_true] = ACTIONS(1327),
    [sym_false] = ACTIONS(1327),
    [sym_null] = ACTIONS(1327),
    [sym_inf] = ACTIONS(1327),
    [sym_nan] = ACTIONS(1327),
    [anon_sym_NA] = ACTIONS(1327),
    [anon_sym_NA_integer_] = ACTIONS(1327),
    [anon_sym_NA_real_] = ACTIONS(1327),
    [anon_sym_NA_complex_] = ACTIONS(1327),
    [anon_sym_NA_character_] = ACTIONS(1327),
    [sym_dots] = ACTIONS(1327),
    [sym_dot_dot_i] = ACTIONS(1329),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1329),
    [sym__semicolon] = ACTIONS(1329),
    [sym__raw_string_literal] = ACTIONS(1329),
    [sym__external_else] = ACTIONS(1329),
    [sym__external_open_parenthesis] = ACTIONS(1329),
    [sym__external_open_brace] = ACTIONS(1329),
    [sym__external_open_bracket] = ACTIONS(1329),
    [sym__external_open_bracket2] = ACTIONS(1329),
  },
  [691] = {
    [sym_identifier] = ACTIONS(1357),
    [anon_sym_BSLASH] = ACTIONS(1355),
    [anon_sym_function] = ACTIONS(1357),
    [anon_sym_EQ] = ACTIONS(1357),
    [anon_sym_if] = ACTIONS(1357),
    [anon_sym_for] = ACTIONS(1357),
    [anon_sym_while] = ACTIONS(1357),
    [anon_sym_repeat] = ACTIONS(1357),
    [anon_sym_QMARK] = ACTIONS(1355),
    [anon_sym_TILDE] = ACTIONS(1355),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1357),
    [anon_sym_LT_DASH] = ACTIONS(1355),
    [anon_sym_LT_LT_DASH] = ACTIONS(1355),
    [anon_sym_COLON_EQ] = ACTIONS(1355),
    [anon_sym_DASH_GT] = ACTIONS(1357),
    [anon_sym_DASH_GT_GT] = ACTIONS(1355),
    [anon_sym_PIPE] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_AMP_AMP] = ACTIONS(1355),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_LT_EQ] = ACTIONS(1355),
    [anon_sym_GT] = ACTIONS(1357),
    [anon_sym_GT_EQ] = ACTIONS(1355),
    [anon_sym_EQ_EQ] = ACTIONS(1355),
    [anon_sym_BANG_EQ] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1357),
    [anon_sym_SLASH] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1355),
    [anon_sym_CARET] = ACTIONS(1355),
    [aux_sym_binary_operator_token1] = ACTIONS(1355),
    [anon_sym_PIPE_GT] = ACTIONS(1355),
    [anon_sym_COLON] = ACTIONS(1357),
    [anon_sym_DOLLAR] = ACTIONS(1355),
    [anon_sym_AT] = ACTIONS(1355),
    [anon_sym_COLON_COLON] = ACTIONS(1357),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1355),
    [sym__hex_literal] = ACTIONS(1355),
    [sym__number_literal] = ACTIONS(1357),
    [anon_sym_SQUOTE] = ACTIONS(1355),
    [anon_sym_DQUOTE] = ACTIONS(1355),
    [sym_return] = ACTIONS(1357),
    [sym_next] = ACTIONS(1357),
    [sym_break] = ACTIONS(1357),
    [sym_true] = ACTIONS(1357),
    [sym_false] = ACTIONS(1357),
    [sym_null] = ACTIONS(1357),
    [sym_inf] = ACTIONS(1357),
    [sym_nan] = ACTIONS(1357),
    [anon_sym_NA] = ACTIONS(1357),
    [anon_sym_NA_integer_] = ACTIONS(1357),
    [anon_sym_NA_real_] = ACTIONS(1357),
    [anon_sym_NA_complex_] = ACTIONS(1357),
    [anon_sym_NA_character_] = ACTIONS(1357),
    [sym_dots] = ACTIONS(1357),
    [sym_dot_dot_i] = ACTIONS(1355),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1355),
    [sym__newline] = ACTIONS(1355),
    [sym__raw_string_literal] = ACTIONS(1355),
    [sym__external_else] = ACTIONS(1355),
    [sym__external_open_parenthesis] = ACTIONS(1355),
    [sym__external_close_parenthesis] = ACTIONS(1355),
    [sym__external_open_brace] = ACTIONS(1355),
    [sym__external_open_bracket] = ACTIONS(1355),
    [sym__external_open_bracket2] = ACTIONS(1355),
  },
  [692] = {
    [sym_identifier] = ACTIONS(1361),
    [anon_sym_BSLASH] = ACTIONS(1359),
    [anon_sym_function] = ACTIONS(1361),
    [anon_sym_EQ] = ACTIONS(1361),
    [anon_sym_if] = ACTIONS(1361),
    [anon_sym_for] = ACTIONS(1361),
    [anon_sym_while] = ACTIONS(1361),
    [anon_sym_repeat] = ACTIONS(1361),
    [anon_sym_QMARK] = ACTIONS(1359),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_BANG] = ACTIONS(1361),
    [anon_sym_PLUS] = ACTIONS(1359),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_LT_DASH] = ACTIONS(1359),
    [anon_sym_LT_LT_DASH] = ACTIONS(1359),
    [anon_sym_COLON_EQ] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [anon_sym_DASH_GT_GT] = ACTIONS(1359),
    [anon_sym_PIPE] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(1361),
    [anon_sym_PIPE_PIPE] = ACTIONS(1359),
    [anon_sym_AMP_AMP] = ACTIONS(1359),
    [anon_sym_LT] = ACTIONS(1361),
    [anon_sym_LT_EQ] = ACTIONS(1359),
    [anon_sym_GT] = ACTIONS(1361),
    [anon_sym_GT_EQ] = ACTIONS(1359),
    [anon_sym_EQ_EQ] = ACTIONS(1359),
    [anon_sym_BANG_EQ] = ACTIONS(1359),
    [anon_sym_STAR] = ACTIONS(1361),
    [anon_sym_SLASH] = ACTIONS(1359),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [aux_sym_binary_operator_token1] = ACTIONS(1359),
    [anon_sym_PIPE_GT] = ACTIONS(1359),
    [anon_sym_COLON] = ACTIONS(1361),
    [anon_sym_DOLLAR] = ACTIONS(1359),
    [anon_sym_AT] = ACTIONS(1359),
    [anon_sym_COLON_COLON] = ACTIONS(1361),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1359),
    [sym__hex_literal] = ACTIONS(1359),
    [sym__number_literal] = ACTIONS(1361),
    [anon_sym_SQUOTE] = ACTIONS(1359),
    [anon_sym_DQUOTE] = ACTIONS(1359),
    [sym_return] = ACTIONS(1361),
    [sym_next] = ACTIONS(1361),
    [sym_break] = ACTIONS(1361),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [sym_null] = ACTIONS(1361),
    [sym_inf] = ACTIONS(1361),
    [sym_nan] = ACTIONS(1361),
    [anon_sym_NA] = ACTIONS(1361),
    [anon_sym_NA_integer_] = ACTIONS(1361),
    [anon_sym_NA_real_] = ACTIONS(1361),
    [anon_sym_NA_complex_] = ACTIONS(1361),
    [anon_sym_NA_character_] = ACTIONS(1361),
    [sym_dots] = ACTIONS(1361),
    [sym_dot_dot_i] = ACTIONS(1359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1359),
    [sym__newline] = ACTIONS(1359),
    [sym__raw_string_literal] = ACTIONS(1359),
    [sym__external_else] = ACTIONS(1359),
    [sym__external_open_parenthesis] = ACTIONS(1359),
    [sym__external_close_parenthesis] = ACTIONS(1359),
    [sym__external_open_brace] = ACTIONS(1359),
    [sym__external_open_bracket] = ACTIONS(1359),
    [sym__external_open_bracket2] = ACTIONS(1359),
  },
  [693] = {
    [sym_identifier] = ACTIONS(1339),
    [anon_sym_BSLASH] = ACTIONS(1341),
    [anon_sym_function] = ACTIONS(1339),
    [anon_sym_EQ] = ACTIONS(1339),
    [anon_sym_if] = ACTIONS(1339),
    [anon_sym_for] = ACTIONS(1339),
    [anon_sym_while] = ACTIONS(1339),
    [anon_sym_repeat] = ACTIONS(1339),
    [anon_sym_QMARK] = ACTIONS(1341),
    [anon_sym_TILDE] = ACTIONS(1341),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_LT_DASH] = ACTIONS(1341),
    [anon_sym_LT_LT_DASH] = ACTIONS(1341),
    [anon_sym_COLON_EQ] = ACTIONS(1341),
    [anon_sym_DASH_GT] = ACTIONS(1339),
    [anon_sym_DASH_GT_GT] = ACTIONS(1341),
    [anon_sym_PIPE] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_PIPE_PIPE] = ACTIONS(1341),
    [anon_sym_AMP_AMP] = ACTIONS(1341),
    [anon_sym_LT] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1341),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_GT_EQ] = ACTIONS(1341),
    [anon_sym_EQ_EQ] = ACTIONS(1341),
    [anon_sym_BANG_EQ] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_SLASH] = ACTIONS(1341),
    [anon_sym_STAR_STAR] = ACTIONS(1341),
    [anon_sym_CARET] = ACTIONS(1341),
    [aux_sym_binary_operator_token1] = ACTIONS(1341),
    [anon_sym_PIPE_GT] = ACTIONS(1341),
    [anon_sym_COLON] = ACTIONS(1339),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1341),
    [anon_sym_L] = ACTIONS(1379),
    [anon_sym_i] = ACTIONS(1381),
    [sym__hex_literal] = ACTIONS(1341),
    [sym__number_literal] = ACTIONS(1339),
    [anon_sym_SQUOTE] = ACTIONS(1341),
    [anon_sym_DQUOTE] = ACTIONS(1341),
    [sym_return] = ACTIONS(1339),
    [sym_next] = ACTIONS(1339),
    [sym_break] = ACTIONS(1339),
    [sym_true] = ACTIONS(1339),
    [sym_false] = ACTIONS(1339),
    [sym_null] = ACTIONS(1339),
    [sym_inf] = ACTIONS(1339),
    [sym_nan] = ACTIONS(1339),
    [anon_sym_NA] = ACTIONS(1339),
    [anon_sym_NA_integer_] = ACTIONS(1339),
    [anon_sym_NA_real_] = ACTIONS(1339),
    [anon_sym_NA_complex_] = ACTIONS(1339),
    [anon_sym_NA_character_] = ACTIONS(1339),
    [sym_dots] = ACTIONS(1339),
    [sym_dot_dot_i] = ACTIONS(1341),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1341),
    [sym__semicolon] = ACTIONS(1341),
    [sym__raw_string_literal] = ACTIONS(1341),
    [sym__external_else] = ACTIONS(1341),
    [sym__external_open_parenthesis] = ACTIONS(1341),
    [sym__external_open_brace] = ACTIONS(1341),
    [sym__external_close_brace] = ACTIONS(1341),
    [sym__external_open_bracket] = ACTIONS(1341),
    [sym__external_open_bracket2] = ACTIONS(1341),
  },
  [694] = {
    [sym_identifier] = ACTIONS(1351),
    [anon_sym_BSLASH] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [anon_sym_repeat] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_PLUS] = ACTIONS(1353),
    [anon_sym_DASH] = ACTIONS(1351),
    [anon_sym_LT_DASH] = ACTIONS(1353),
    [anon_sym_LT_LT_DASH] = ACTIONS(1353),
    [anon_sym_COLON_EQ] = ACTIONS(1353),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_DASH_GT_GT] = ACTIONS(1353),
    [anon_sym_PIPE] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PIPE_PIPE] = ACTIONS(1353),
    [anon_sym_AMP_AMP] = ACTIONS(1353),
    [anon_sym_LT] = ACTIONS(1351),
    [anon_sym_LT_EQ] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(1351),
    [anon_sym_GT_EQ] = ACTIONS(1353),
    [anon_sym_EQ_EQ] = ACTIONS(1353),
    [anon_sym_BANG_EQ] = ACTIONS(1353),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_SLASH] = ACTIONS(1353),
    [anon_sym_STAR_STAR] = ACTIONS(1353),
    [anon_sym_CARET] = ACTIONS(1353),
    [aux_sym_binary_operator_token1] = ACTIONS(1353),
    [anon_sym_PIPE_GT] = ACTIONS(1353),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_DOLLAR] = ACTIONS(1353),
    [anon_sym_AT] = ACTIONS(1353),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1353),
    [sym__hex_literal] = ACTIONS(1353),
    [sym__number_literal] = ACTIONS(1351),
    [anon_sym_SQUOTE] = ACTIONS(1353),
    [anon_sym_DQUOTE] = ACTIONS(1353),
    [sym_return] = ACTIONS(1351),
    [sym_next] = ACTIONS(1351),
    [sym_break] = ACTIONS(1351),
    [sym_true] = ACTIONS(1351),
    [sym_false] = ACTIONS(1351),
    [sym_null] = ACTIONS(1351),
    [sym_inf] = ACTIONS(1351),
    [sym_nan] = ACTIONS(1351),
    [anon_sym_NA] = ACTIONS(1351),
    [anon_sym_NA_integer_] = ACTIONS(1351),
    [anon_sym_NA_real_] = ACTIONS(1351),
    [anon_sym_NA_complex_] = ACTIONS(1351),
    [anon_sym_NA_character_] = ACTIONS(1351),
    [sym_dots] = ACTIONS(1351),
    [sym_dot_dot_i] = ACTIONS(1353),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1353),
    [sym__semicolon] = ACTIONS(1353),
    [sym__raw_string_literal] = ACTIONS(1353),
    [sym__external_else] = ACTIONS(1353),
    [sym__external_open_parenthesis] = ACTIONS(1353),
    [sym__external_open_brace] = ACTIONS(1353),
    [sym__external_close_brace] = ACTIONS(1353),
    [sym__external_open_bracket] = ACTIONS(1353),
    [sym__external_open_bracket2] = ACTIONS(1353),
  },
  [695] = {
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_BSLASH] = ACTIONS(1329),
    [anon_sym_function] = ACTIONS(1327),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_repeat] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1329),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_LT_DASH] = ACTIONS(1329),
    [anon_sym_LT_LT_DASH] = ACTIONS(1329),
    [anon_sym_COLON_EQ] = ACTIONS(1329),
    [anon_sym_DASH_GT] = ACTIONS(1327),
    [anon_sym_DASH_GT_GT] = ACTIONS(1329),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1329),
    [anon_sym_AMP_AMP] = ACTIONS(1329),
    [anon_sym_LT] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1329),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1329),
    [anon_sym_EQ_EQ] = ACTIONS(1329),
    [anon_sym_BANG_EQ] = ACTIONS(1329),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_SLASH] = ACTIONS(1329),
    [anon_sym_STAR_STAR] = ACTIONS(1329),
    [anon_sym_CARET] = ACTIONS(1329),
    [aux_sym_binary_operator_token1] = ACTIONS(1329),
    [anon_sym_PIPE_GT] = ACTIONS(1329),
    [anon_sym_COLON] = ACTIONS(1327),
    [anon_sym_DOLLAR] = ACTIONS(1329),
    [anon_sym_AT] = ACTIONS(1329),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1329),
    [sym__hex_literal] = ACTIONS(1329),
    [sym__number_literal] = ACTIONS(1327),
    [anon_sym_SQUOTE] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(1329),
    [sym_return] = ACTIONS(1327),
    [sym_next] = ACTIONS(1327),
    [sym_break] = ACTIONS(1327),
    [sym_true] = ACTIONS(1327),
    [sym_false] = ACTIONS(1327),
    [sym_null] = ACTIONS(1327),
    [sym_inf] = ACTIONS(1327),
    [sym_nan] = ACTIONS(1327),
    [anon_sym_NA] = ACTIONS(1327),
    [anon_sym_NA_integer_] = ACTIONS(1327),
    [anon_sym_NA_real_] = ACTIONS(1327),
    [anon_sym_NA_complex_] = ACTIONS(1327),
    [anon_sym_NA_character_] = ACTIONS(1327),
    [sym_dots] = ACTIONS(1327),
    [sym_dot_dot_i] = ACTIONS(1329),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1329),
    [sym__semicolon] = ACTIONS(1329),
    [sym__raw_string_literal] = ACTIONS(1329),
    [sym__external_else] = ACTIONS(1329),
    [sym__external_open_parenthesis] = ACTIONS(1329),
    [sym__external_open_brace] = ACTIONS(1329),
    [sym__external_close_brace] = ACTIONS(1329),
    [sym__external_open_bracket] = ACTIONS(1329),
    [sym__external_open_bracket2] = ACTIONS(1329),
  },
  [696] = {
    [sym_identifier] = ACTIONS(1365),
    [anon_sym_BSLASH] = ACTIONS(1363),
    [anon_sym_function] = ACTIONS(1365),
    [anon_sym_EQ] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(1365),
    [anon_sym_for] = ACTIONS(1365),
    [anon_sym_while] = ACTIONS(1365),
    [anon_sym_repeat] = ACTIONS(1365),
    [anon_sym_QMARK] = ACTIONS(1363),
    [anon_sym_TILDE] = ACTIONS(1363),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1365),
    [anon_sym_LT_DASH] = ACTIONS(1363),
    [anon_sym_LT_LT_DASH] = ACTIONS(1363),
    [anon_sym_COLON_EQ] = ACTIONS(1363),
    [anon_sym_DASH_GT] = ACTIONS(1365),
    [anon_sym_DASH_GT_GT] = ACTIONS(1363),
    [anon_sym_PIPE] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE_PIPE] = ACTIONS(1363),
    [anon_sym_AMP_AMP] = ACTIONS(1363),
    [anon_sym_LT] = ACTIONS(1365),
    [anon_sym_LT_EQ] = ACTIONS(1363),
    [anon_sym_GT] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1363),
    [anon_sym_EQ_EQ] = ACTIONS(1363),
    [anon_sym_BANG_EQ] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1365),
    [anon_sym_SLASH] = ACTIONS(1363),
    [anon_sym_STAR_STAR] = ACTIONS(1363),
    [anon_sym_CARET] = ACTIONS(1363),
    [aux_sym_binary_operator_token1] = ACTIONS(1363),
    [anon_sym_PIPE_GT] = ACTIONS(1363),
    [anon_sym_COLON] = ACTIONS(1365),
    [anon_sym_DOLLAR] = ACTIONS(1363),
    [anon_sym_AT] = ACTIONS(1363),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1363),
    [sym__hex_literal] = ACTIONS(1363),
    [sym__number_literal] = ACTIONS(1365),
    [anon_sym_SQUOTE] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1363),
    [sym_return] = ACTIONS(1365),
    [sym_next] = ACTIONS(1365),
    [sym_break] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_null] = ACTIONS(1365),
    [sym_inf] = ACTIONS(1365),
    [sym_nan] = ACTIONS(1365),
    [anon_sym_NA] = ACTIONS(1365),
    [anon_sym_NA_integer_] = ACTIONS(1365),
    [anon_sym_NA_real_] = ACTIONS(1365),
    [anon_sym_NA_complex_] = ACTIONS(1365),
    [anon_sym_NA_character_] = ACTIONS(1365),
    [sym_dots] = ACTIONS(1365),
    [sym_dot_dot_i] = ACTIONS(1363),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1363),
    [sym__newline] = ACTIONS(1363),
    [sym__raw_string_literal] = ACTIONS(1363),
    [sym__external_else] = ACTIONS(1363),
    [sym__external_open_parenthesis] = ACTIONS(1363),
    [sym__external_open_brace] = ACTIONS(1363),
    [sym__external_open_bracket] = ACTIONS(1363),
    [sym__external_close_bracket] = ACTIONS(1363),
    [sym__external_open_bracket2] = ACTIONS(1363),
  },
  [697] = {
    [sym_identifier] = ACTIONS(1347),
    [anon_sym_BSLASH] = ACTIONS(1349),
    [anon_sym_function] = ACTIONS(1347),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_if] = ACTIONS(1347),
    [anon_sym_for] = ACTIONS(1347),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1347),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1347),
    [anon_sym_LT_DASH] = ACTIONS(1349),
    [anon_sym_LT_LT_DASH] = ACTIONS(1349),
    [anon_sym_COLON_EQ] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1347),
    [anon_sym_DASH_GT_GT] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1347),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_GT_EQ] = ACTIONS(1349),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_SLASH] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [aux_sym_binary_operator_token1] = ACTIONS(1349),
    [anon_sym_PIPE_GT] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(1347),
    [anon_sym_DOLLAR] = ACTIONS(1349),
    [anon_sym_AT] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1347),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1349),
    [sym__hex_literal] = ACTIONS(1349),
    [sym__number_literal] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1349),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [sym_return] = ACTIONS(1347),
    [sym_next] = ACTIONS(1347),
    [sym_break] = ACTIONS(1347),
    [sym_true] = ACTIONS(1347),
    [sym_false] = ACTIONS(1347),
    [sym_null] = ACTIONS(1347),
    [sym_inf] = ACTIONS(1347),
    [sym_nan] = ACTIONS(1347),
    [anon_sym_NA] = ACTIONS(1347),
    [anon_sym_NA_integer_] = ACTIONS(1347),
    [anon_sym_NA_real_] = ACTIONS(1347),
    [anon_sym_NA_complex_] = ACTIONS(1347),
    [anon_sym_NA_character_] = ACTIONS(1347),
    [sym_dots] = ACTIONS(1347),
    [sym_dot_dot_i] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1349),
    [sym__newline] = ACTIONS(1349),
    [sym__raw_string_literal] = ACTIONS(1349),
    [sym__external_else] = ACTIONS(1349),
    [sym__external_open_parenthesis] = ACTIONS(1349),
    [sym__external_open_brace] = ACTIONS(1349),
    [sym__external_open_bracket] = ACTIONS(1349),
    [sym__external_open_bracket2] = ACTIONS(1349),
    [sym__external_close_bracket2] = ACTIONS(1349),
  },
  [698] = {
    [sym_identifier] = ACTIONS(1365),
    [anon_sym_BSLASH] = ACTIONS(1363),
    [anon_sym_function] = ACTIONS(1365),
    [anon_sym_EQ] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(1365),
    [anon_sym_for] = ACTIONS(1365),
    [anon_sym_while] = ACTIONS(1365),
    [anon_sym_repeat] = ACTIONS(1365),
    [anon_sym_QMARK] = ACTIONS(1363),
    [anon_sym_TILDE] = ACTIONS(1363),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1365),
    [anon_sym_LT_DASH] = ACTIONS(1363),
    [anon_sym_LT_LT_DASH] = ACTIONS(1363),
    [anon_sym_COLON_EQ] = ACTIONS(1363),
    [anon_sym_DASH_GT] = ACTIONS(1365),
    [anon_sym_DASH_GT_GT] = ACTIONS(1363),
    [anon_sym_PIPE] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE_PIPE] = ACTIONS(1363),
    [anon_sym_AMP_AMP] = ACTIONS(1363),
    [anon_sym_LT] = ACTIONS(1365),
    [anon_sym_LT_EQ] = ACTIONS(1363),
    [anon_sym_GT] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1363),
    [anon_sym_EQ_EQ] = ACTIONS(1363),
    [anon_sym_BANG_EQ] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1365),
    [anon_sym_SLASH] = ACTIONS(1363),
    [anon_sym_STAR_STAR] = ACTIONS(1363),
    [anon_sym_CARET] = ACTIONS(1363),
    [aux_sym_binary_operator_token1] = ACTIONS(1363),
    [anon_sym_PIPE_GT] = ACTIONS(1363),
    [anon_sym_COLON] = ACTIONS(1365),
    [anon_sym_DOLLAR] = ACTIONS(1363),
    [anon_sym_AT] = ACTIONS(1363),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1363),
    [sym__hex_literal] = ACTIONS(1363),
    [sym__number_literal] = ACTIONS(1365),
    [anon_sym_SQUOTE] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1363),
    [sym_return] = ACTIONS(1365),
    [sym_next] = ACTIONS(1365),
    [sym_break] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_null] = ACTIONS(1365),
    [sym_inf] = ACTIONS(1365),
    [sym_nan] = ACTIONS(1365),
    [anon_sym_NA] = ACTIONS(1365),
    [anon_sym_NA_integer_] = ACTIONS(1365),
    [anon_sym_NA_real_] = ACTIONS(1365),
    [anon_sym_NA_complex_] = ACTIONS(1365),
    [anon_sym_NA_character_] = ACTIONS(1365),
    [sym_dots] = ACTIONS(1365),
    [sym_dot_dot_i] = ACTIONS(1363),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1363),
    [sym__semicolon] = ACTIONS(1363),
    [sym__raw_string_literal] = ACTIONS(1363),
    [sym__external_open_parenthesis] = ACTIONS(1363),
    [sym__external_open_brace] = ACTIONS(1363),
    [sym__external_close_brace] = ACTIONS(1363),
    [sym__external_open_bracket] = ACTIONS(1363),
    [sym__external_open_bracket2] = ACTIONS(1363),
  },
  [699] = {
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_BSLASH] = ACTIONS(1329),
    [anon_sym_function] = ACTIONS(1327),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_repeat] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1329),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_LT_DASH] = ACTIONS(1329),
    [anon_sym_LT_LT_DASH] = ACTIONS(1329),
    [anon_sym_COLON_EQ] = ACTIONS(1329),
    [anon_sym_DASH_GT] = ACTIONS(1327),
    [anon_sym_DASH_GT_GT] = ACTIONS(1329),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1329),
    [anon_sym_AMP_AMP] = ACTIONS(1329),
    [anon_sym_LT] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1329),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1329),
    [anon_sym_EQ_EQ] = ACTIONS(1329),
    [anon_sym_BANG_EQ] = ACTIONS(1329),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_SLASH] = ACTIONS(1329),
    [anon_sym_STAR_STAR] = ACTIONS(1329),
    [anon_sym_CARET] = ACTIONS(1329),
    [aux_sym_binary_operator_token1] = ACTIONS(1329),
    [anon_sym_PIPE_GT] = ACTIONS(1329),
    [anon_sym_COLON] = ACTIONS(1327),
    [anon_sym_DOLLAR] = ACTIONS(1329),
    [anon_sym_AT] = ACTIONS(1329),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1329),
    [sym__hex_literal] = ACTIONS(1329),
    [sym__number_literal] = ACTIONS(1327),
    [anon_sym_SQUOTE] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(1329),
    [sym_return] = ACTIONS(1327),
    [sym_next] = ACTIONS(1327),
    [sym_break] = ACTIONS(1327),
    [sym_true] = ACTIONS(1327),
    [sym_false] = ACTIONS(1327),
    [sym_null] = ACTIONS(1327),
    [sym_inf] = ACTIONS(1327),
    [sym_nan] = ACTIONS(1327),
    [anon_sym_NA] = ACTIONS(1327),
    [anon_sym_NA_integer_] = ACTIONS(1327),
    [anon_sym_NA_real_] = ACTIONS(1327),
    [anon_sym_NA_complex_] = ACTIONS(1327),
    [anon_sym_NA_character_] = ACTIONS(1327),
    [sym_dots] = ACTIONS(1327),
    [sym_dot_dot_i] = ACTIONS(1329),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1329),
    [sym__semicolon] = ACTIONS(1329),
    [sym__raw_string_literal] = ACTIONS(1329),
    [sym__external_open_parenthesis] = ACTIONS(1329),
    [sym__external_open_brace] = ACTIONS(1329),
    [sym__external_close_brace] = ACTIONS(1329),
    [sym__external_open_bracket] = ACTIONS(1329),
    [sym__external_open_bracket2] = ACTIONS(1329),
  },
  [700] = {
    [sym_identifier] = ACTIONS(1347),
    [anon_sym_BSLASH] = ACTIONS(1349),
    [anon_sym_function] = ACTIONS(1347),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_if] = ACTIONS(1347),
    [anon_sym_for] = ACTIONS(1347),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1347),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1347),
    [anon_sym_LT_DASH] = ACTIONS(1349),
    [anon_sym_LT_LT_DASH] = ACTIONS(1349),
    [anon_sym_COLON_EQ] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1347),
    [anon_sym_DASH_GT_GT] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1347),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_GT_EQ] = ACTIONS(1349),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_SLASH] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [aux_sym_binary_operator_token1] = ACTIONS(1349),
    [anon_sym_PIPE_GT] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(1347),
    [anon_sym_DOLLAR] = ACTIONS(1349),
    [anon_sym_AT] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1347),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1349),
    [sym__hex_literal] = ACTIONS(1349),
    [sym__number_literal] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1349),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [sym_return] = ACTIONS(1347),
    [sym_next] = ACTIONS(1347),
    [sym_break] = ACTIONS(1347),
    [sym_true] = ACTIONS(1347),
    [sym_false] = ACTIONS(1347),
    [sym_null] = ACTIONS(1347),
    [sym_inf] = ACTIONS(1347),
    [sym_nan] = ACTIONS(1347),
    [anon_sym_NA] = ACTIONS(1347),
    [anon_sym_NA_integer_] = ACTIONS(1347),
    [anon_sym_NA_real_] = ACTIONS(1347),
    [anon_sym_NA_complex_] = ACTIONS(1347),
    [anon_sym_NA_character_] = ACTIONS(1347),
    [sym_dots] = ACTIONS(1347),
    [sym_dot_dot_i] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1349),
    [sym__newline] = ACTIONS(1349),
    [sym__raw_string_literal] = ACTIONS(1349),
    [sym__external_open_parenthesis] = ACTIONS(1349),
    [sym__external_open_brace] = ACTIONS(1349),
    [sym__external_open_bracket] = ACTIONS(1349),
    [sym__external_open_bracket2] = ACTIONS(1349),
    [sym__external_close_bracket2] = ACTIONS(1349),
  },
  [701] = {
    [sym_identifier] = ACTIONS(1357),
    [anon_sym_BSLASH] = ACTIONS(1355),
    [anon_sym_function] = ACTIONS(1357),
    [anon_sym_EQ] = ACTIONS(1357),
    [anon_sym_if] = ACTIONS(1357),
    [anon_sym_for] = ACTIONS(1357),
    [anon_sym_while] = ACTIONS(1357),
    [anon_sym_repeat] = ACTIONS(1357),
    [anon_sym_QMARK] = ACTIONS(1355),
    [anon_sym_TILDE] = ACTIONS(1355),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1357),
    [anon_sym_LT_DASH] = ACTIONS(1355),
    [anon_sym_LT_LT_DASH] = ACTIONS(1355),
    [anon_sym_COLON_EQ] = ACTIONS(1355),
    [anon_sym_DASH_GT] = ACTIONS(1357),
    [anon_sym_DASH_GT_GT] = ACTIONS(1355),
    [anon_sym_PIPE] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_AMP_AMP] = ACTIONS(1355),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_LT_EQ] = ACTIONS(1355),
    [anon_sym_GT] = ACTIONS(1357),
    [anon_sym_GT_EQ] = ACTIONS(1355),
    [anon_sym_EQ_EQ] = ACTIONS(1355),
    [anon_sym_BANG_EQ] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1357),
    [anon_sym_SLASH] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1355),
    [anon_sym_CARET] = ACTIONS(1355),
    [aux_sym_binary_operator_token1] = ACTIONS(1355),
    [anon_sym_PIPE_GT] = ACTIONS(1355),
    [anon_sym_COLON] = ACTIONS(1357),
    [anon_sym_DOLLAR] = ACTIONS(1355),
    [anon_sym_AT] = ACTIONS(1355),
    [anon_sym_COLON_COLON] = ACTIONS(1357),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1355),
    [sym__hex_literal] = ACTIONS(1355),
    [sym__number_literal] = ACTIONS(1357),
    [anon_sym_SQUOTE] = ACTIONS(1355),
    [anon_sym_DQUOTE] = ACTIONS(1355),
    [sym_return] = ACTIONS(1357),
    [sym_next] = ACTIONS(1357),
    [sym_break] = ACTIONS(1357),
    [sym_true] = ACTIONS(1357),
    [sym_false] = ACTIONS(1357),
    [sym_null] = ACTIONS(1357),
    [sym_inf] = ACTIONS(1357),
    [sym_nan] = ACTIONS(1357),
    [anon_sym_NA] = ACTIONS(1357),
    [anon_sym_NA_integer_] = ACTIONS(1357),
    [anon_sym_NA_real_] = ACTIONS(1357),
    [anon_sym_NA_complex_] = ACTIONS(1357),
    [anon_sym_NA_character_] = ACTIONS(1357),
    [sym_dots] = ACTIONS(1357),
    [sym_dot_dot_i] = ACTIONS(1355),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1355),
    [sym__newline] = ACTIONS(1355),
    [sym__raw_string_literal] = ACTIONS(1355),
    [sym__external_open_parenthesis] = ACTIONS(1355),
    [sym__external_close_parenthesis] = ACTIONS(1355),
    [sym__external_open_brace] = ACTIONS(1355),
    [sym__external_open_bracket] = ACTIONS(1355),
    [sym__external_open_bracket2] = ACTIONS(1355),
  },
  [702] = {
    [aux_sym_function_definition_repeat1] = STATE(702),
    [sym_identifier] = ACTIONS(1383),
    [anon_sym_BSLASH] = ACTIONS(1385),
    [anon_sym_function] = ACTIONS(1383),
    [anon_sym_EQ] = ACTIONS(1383),
    [anon_sym_if] = ACTIONS(1383),
    [anon_sym_for] = ACTIONS(1383),
    [anon_sym_while] = ACTIONS(1383),
    [anon_sym_repeat] = ACTIONS(1383),
    [anon_sym_QMARK] = ACTIONS(1385),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1383),
    [anon_sym_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_COLON_EQ] = ACTIONS(1385),
    [anon_sym_DASH_GT] = ACTIONS(1383),
    [anon_sym_DASH_GT_GT] = ACTIONS(1385),
    [anon_sym_PIPE] = ACTIONS(1383),
    [anon_sym_AMP] = ACTIONS(1383),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1383),
    [anon_sym_LT_EQ] = ACTIONS(1385),
    [anon_sym_GT] = ACTIONS(1383),
    [anon_sym_GT_EQ] = ACTIONS(1385),
    [anon_sym_EQ_EQ] = ACTIONS(1385),
    [anon_sym_BANG_EQ] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_SLASH] = ACTIONS(1385),
    [anon_sym_STAR_STAR] = ACTIONS(1385),
    [anon_sym_CARET] = ACTIONS(1385),
    [aux_sym_binary_operator_token1] = ACTIONS(1385),
    [anon_sym_PIPE_GT] = ACTIONS(1385),
    [anon_sym_COLON] = ACTIONS(1383),
    [anon_sym_DOLLAR] = ACTIONS(1385),
    [anon_sym_AT] = ACTIONS(1385),
    [sym__hex_literal] = ACTIONS(1385),
    [sym__number_literal] = ACTIONS(1383),
    [anon_sym_SQUOTE] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [sym_return] = ACTIONS(1383),
    [sym_next] = ACTIONS(1383),
    [sym_break] = ACTIONS(1383),
    [sym_true] = ACTIONS(1383),
    [sym_false] = ACTIONS(1383),
    [sym_null] = ACTIONS(1383),
    [sym_inf] = ACTIONS(1383),
    [sym_nan] = ACTIONS(1383),
    [anon_sym_NA] = ACTIONS(1383),
    [anon_sym_NA_integer_] = ACTIONS(1383),
    [anon_sym_NA_real_] = ACTIONS(1383),
    [anon_sym_NA_complex_] = ACTIONS(1383),
    [anon_sym_NA_character_] = ACTIONS(1383),
    [sym_dots] = ACTIONS(1383),
    [sym_dot_dot_i] = ACTIONS(1385),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1385),
    [sym__newline] = ACTIONS(1387),
    [sym__raw_string_literal] = ACTIONS(1385),
    [sym__external_else] = ACTIONS(1385),
    [sym__external_open_parenthesis] = ACTIONS(1385),
    [sym__external_close_parenthesis] = ACTIONS(1385),
    [sym__external_open_brace] = ACTIONS(1385),
    [sym__external_open_bracket] = ACTIONS(1385),
    [sym__external_open_bracket2] = ACTIONS(1385),
  },
  [703] = {
    [sym_identifier] = ACTIONS(1361),
    [anon_sym_BSLASH] = ACTIONS(1359),
    [anon_sym_function] = ACTIONS(1361),
    [anon_sym_EQ] = ACTIONS(1361),
    [anon_sym_if] = ACTIONS(1361),
    [anon_sym_for] = ACTIONS(1361),
    [anon_sym_while] = ACTIONS(1361),
    [anon_sym_repeat] = ACTIONS(1361),
    [anon_sym_QMARK] = ACTIONS(1359),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_BANG] = ACTIONS(1361),
    [anon_sym_PLUS] = ACTIONS(1359),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_LT_DASH] = ACTIONS(1359),
    [anon_sym_LT_LT_DASH] = ACTIONS(1359),
    [anon_sym_COLON_EQ] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [anon_sym_DASH_GT_GT] = ACTIONS(1359),
    [anon_sym_PIPE] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(1361),
    [anon_sym_PIPE_PIPE] = ACTIONS(1359),
    [anon_sym_AMP_AMP] = ACTIONS(1359),
    [anon_sym_LT] = ACTIONS(1361),
    [anon_sym_LT_EQ] = ACTIONS(1359),
    [anon_sym_GT] = ACTIONS(1361),
    [anon_sym_GT_EQ] = ACTIONS(1359),
    [anon_sym_EQ_EQ] = ACTIONS(1359),
    [anon_sym_BANG_EQ] = ACTIONS(1359),
    [anon_sym_STAR] = ACTIONS(1361),
    [anon_sym_SLASH] = ACTIONS(1359),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [aux_sym_binary_operator_token1] = ACTIONS(1359),
    [anon_sym_PIPE_GT] = ACTIONS(1359),
    [anon_sym_COLON] = ACTIONS(1361),
    [anon_sym_DOLLAR] = ACTIONS(1359),
    [anon_sym_AT] = ACTIONS(1359),
    [anon_sym_COLON_COLON] = ACTIONS(1361),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1359),
    [sym__hex_literal] = ACTIONS(1359),
    [sym__number_literal] = ACTIONS(1361),
    [anon_sym_SQUOTE] = ACTIONS(1359),
    [anon_sym_DQUOTE] = ACTIONS(1359),
    [sym_return] = ACTIONS(1361),
    [sym_next] = ACTIONS(1361),
    [sym_break] = ACTIONS(1361),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [sym_null] = ACTIONS(1361),
    [sym_inf] = ACTIONS(1361),
    [sym_nan] = ACTIONS(1361),
    [anon_sym_NA] = ACTIONS(1361),
    [anon_sym_NA_integer_] = ACTIONS(1361),
    [anon_sym_NA_real_] = ACTIONS(1361),
    [anon_sym_NA_complex_] = ACTIONS(1361),
    [anon_sym_NA_character_] = ACTIONS(1361),
    [sym_dots] = ACTIONS(1361),
    [sym_dot_dot_i] = ACTIONS(1359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1359),
    [sym__newline] = ACTIONS(1359),
    [sym__raw_string_literal] = ACTIONS(1359),
    [sym__external_open_parenthesis] = ACTIONS(1359),
    [sym__external_close_parenthesis] = ACTIONS(1359),
    [sym__external_open_brace] = ACTIONS(1359),
    [sym__external_open_bracket] = ACTIONS(1359),
    [sym__external_open_bracket2] = ACTIONS(1359),
  },
  [704] = {
    [sym_identifier] = ACTIONS(1351),
    [anon_sym_BSLASH] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [anon_sym_repeat] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_PLUS] = ACTIONS(1353),
    [anon_sym_DASH] = ACTIONS(1351),
    [anon_sym_LT_DASH] = ACTIONS(1353),
    [anon_sym_LT_LT_DASH] = ACTIONS(1353),
    [anon_sym_COLON_EQ] = ACTIONS(1353),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_DASH_GT_GT] = ACTIONS(1353),
    [anon_sym_PIPE] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PIPE_PIPE] = ACTIONS(1353),
    [anon_sym_AMP_AMP] = ACTIONS(1353),
    [anon_sym_LT] = ACTIONS(1351),
    [anon_sym_LT_EQ] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(1351),
    [anon_sym_GT_EQ] = ACTIONS(1353),
    [anon_sym_EQ_EQ] = ACTIONS(1353),
    [anon_sym_BANG_EQ] = ACTIONS(1353),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_SLASH] = ACTIONS(1353),
    [anon_sym_STAR_STAR] = ACTIONS(1353),
    [anon_sym_CARET] = ACTIONS(1353),
    [aux_sym_binary_operator_token1] = ACTIONS(1353),
    [anon_sym_PIPE_GT] = ACTIONS(1353),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_DOLLAR] = ACTIONS(1353),
    [anon_sym_AT] = ACTIONS(1353),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1353),
    [sym__hex_literal] = ACTIONS(1353),
    [sym__number_literal] = ACTIONS(1351),
    [anon_sym_SQUOTE] = ACTIONS(1353),
    [anon_sym_DQUOTE] = ACTIONS(1353),
    [sym_return] = ACTIONS(1351),
    [sym_next] = ACTIONS(1351),
    [sym_break] = ACTIONS(1351),
    [sym_true] = ACTIONS(1351),
    [sym_false] = ACTIONS(1351),
    [sym_null] = ACTIONS(1351),
    [sym_inf] = ACTIONS(1351),
    [sym_nan] = ACTIONS(1351),
    [anon_sym_NA] = ACTIONS(1351),
    [anon_sym_NA_integer_] = ACTIONS(1351),
    [anon_sym_NA_real_] = ACTIONS(1351),
    [anon_sym_NA_complex_] = ACTIONS(1351),
    [anon_sym_NA_character_] = ACTIONS(1351),
    [sym_dots] = ACTIONS(1351),
    [sym_dot_dot_i] = ACTIONS(1353),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1353),
    [sym__newline] = ACTIONS(1353),
    [sym__raw_string_literal] = ACTIONS(1353),
    [sym__external_open_parenthesis] = ACTIONS(1353),
    [sym__external_open_brace] = ACTIONS(1353),
    [sym__external_open_bracket] = ACTIONS(1353),
    [sym__external_open_bracket2] = ACTIONS(1353),
    [sym__external_close_bracket2] = ACTIONS(1353),
  },
  [705] = {
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_BSLASH] = ACTIONS(1329),
    [anon_sym_function] = ACTIONS(1327),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_repeat] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1329),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_LT_DASH] = ACTIONS(1329),
    [anon_sym_LT_LT_DASH] = ACTIONS(1329),
    [anon_sym_COLON_EQ] = ACTIONS(1329),
    [anon_sym_DASH_GT] = ACTIONS(1327),
    [anon_sym_DASH_GT_GT] = ACTIONS(1329),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1329),
    [anon_sym_AMP_AMP] = ACTIONS(1329),
    [anon_sym_LT] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1329),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1329),
    [anon_sym_EQ_EQ] = ACTIONS(1329),
    [anon_sym_BANG_EQ] = ACTIONS(1329),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_SLASH] = ACTIONS(1329),
    [anon_sym_STAR_STAR] = ACTIONS(1329),
    [anon_sym_CARET] = ACTIONS(1329),
    [aux_sym_binary_operator_token1] = ACTIONS(1329),
    [anon_sym_PIPE_GT] = ACTIONS(1329),
    [anon_sym_COLON] = ACTIONS(1327),
    [anon_sym_DOLLAR] = ACTIONS(1329),
    [anon_sym_AT] = ACTIONS(1329),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1329),
    [sym__hex_literal] = ACTIONS(1329),
    [sym__number_literal] = ACTIONS(1327),
    [anon_sym_SQUOTE] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(1329),
    [sym_return] = ACTIONS(1327),
    [sym_next] = ACTIONS(1327),
    [sym_break] = ACTIONS(1327),
    [sym_true] = ACTIONS(1327),
    [sym_false] = ACTIONS(1327),
    [sym_null] = ACTIONS(1327),
    [sym_inf] = ACTIONS(1327),
    [sym_nan] = ACTIONS(1327),
    [anon_sym_NA] = ACTIONS(1327),
    [anon_sym_NA_integer_] = ACTIONS(1327),
    [anon_sym_NA_real_] = ACTIONS(1327),
    [anon_sym_NA_complex_] = ACTIONS(1327),
    [anon_sym_NA_character_] = ACTIONS(1327),
    [sym_dots] = ACTIONS(1327),
    [sym_dot_dot_i] = ACTIONS(1329),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1329),
    [sym__newline] = ACTIONS(1329),
    [sym__raw_string_literal] = ACTIONS(1329),
    [sym__external_open_parenthesis] = ACTIONS(1329),
    [sym__external_close_parenthesis] = ACTIONS(1329),
    [sym__external_open_brace] = ACTIONS(1329),
    [sym__external_open_bracket] = ACTIONS(1329),
    [sym__external_open_bracket2] = ACTIONS(1329),
  },
  [706] = {
    [ts_builtin_sym_end] = ACTIONS(1333),
    [sym_identifier] = ACTIONS(1331),
    [anon_sym_BSLASH] = ACTIONS(1333),
    [anon_sym_function] = ACTIONS(1331),
    [anon_sym_EQ] = ACTIONS(1331),
    [anon_sym_if] = ACTIONS(1331),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_while] = ACTIONS(1331),
    [anon_sym_repeat] = ACTIONS(1331),
    [anon_sym_QMARK] = ACTIONS(1333),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_LT_DASH] = ACTIONS(1333),
    [anon_sym_LT_LT_DASH] = ACTIONS(1333),
    [anon_sym_COLON_EQ] = ACTIONS(1333),
    [anon_sym_DASH_GT] = ACTIONS(1331),
    [anon_sym_DASH_GT_GT] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1331),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1333),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_GT_EQ] = ACTIONS(1333),
    [anon_sym_EQ_EQ] = ACTIONS(1333),
    [anon_sym_BANG_EQ] = ACTIONS(1333),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_SLASH] = ACTIONS(1333),
    [anon_sym_STAR_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1333),
    [aux_sym_binary_operator_token1] = ACTIONS(1333),
    [anon_sym_PIPE_GT] = ACTIONS(1333),
    [anon_sym_COLON] = ACTIONS(1331),
    [anon_sym_DOLLAR] = ACTIONS(1333),
    [anon_sym_AT] = ACTIONS(1333),
    [anon_sym_COLON_COLON] = ACTIONS(1335),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1337),
    [sym__hex_literal] = ACTIONS(1333),
    [sym__number_literal] = ACTIONS(1331),
    [anon_sym_SQUOTE] = ACTIONS(1333),
    [anon_sym_DQUOTE] = ACTIONS(1333),
    [sym_return] = ACTIONS(1331),
    [sym_next] = ACTIONS(1331),
    [sym_break] = ACTIONS(1331),
    [sym_true] = ACTIONS(1331),
    [sym_false] = ACTIONS(1331),
    [sym_null] = ACTIONS(1331),
    [sym_inf] = ACTIONS(1331),
    [sym_nan] = ACTIONS(1331),
    [anon_sym_NA] = ACTIONS(1331),
    [anon_sym_NA_integer_] = ACTIONS(1331),
    [anon_sym_NA_real_] = ACTIONS(1331),
    [anon_sym_NA_complex_] = ACTIONS(1331),
    [anon_sym_NA_character_] = ACTIONS(1331),
    [sym_dots] = ACTIONS(1331),
    [sym_dot_dot_i] = ACTIONS(1333),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1333),
    [sym__semicolon] = ACTIONS(1333),
    [sym__raw_string_literal] = ACTIONS(1333),
    [sym__external_open_parenthesis] = ACTIONS(1333),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_open_bracket] = ACTIONS(1333),
    [sym__external_open_bracket2] = ACTIONS(1333),
  },
  [707] = {
    [sym_identifier] = ACTIONS(1347),
    [anon_sym_BSLASH] = ACTIONS(1349),
    [anon_sym_function] = ACTIONS(1347),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_if] = ACTIONS(1347),
    [anon_sym_for] = ACTIONS(1347),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1347),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1347),
    [anon_sym_LT_DASH] = ACTIONS(1349),
    [anon_sym_LT_LT_DASH] = ACTIONS(1349),
    [anon_sym_COLON_EQ] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1347),
    [anon_sym_DASH_GT_GT] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1347),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_GT_EQ] = ACTIONS(1349),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_SLASH] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [aux_sym_binary_operator_token1] = ACTIONS(1349),
    [anon_sym_PIPE_GT] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(1347),
    [anon_sym_DOLLAR] = ACTIONS(1349),
    [anon_sym_AT] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1347),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1349),
    [sym__hex_literal] = ACTIONS(1349),
    [sym__number_literal] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1349),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [sym_return] = ACTIONS(1347),
    [sym_next] = ACTIONS(1347),
    [sym_break] = ACTIONS(1347),
    [sym_true] = ACTIONS(1347),
    [sym_false] = ACTIONS(1347),
    [sym_null] = ACTIONS(1347),
    [sym_inf] = ACTIONS(1347),
    [sym_nan] = ACTIONS(1347),
    [anon_sym_NA] = ACTIONS(1347),
    [anon_sym_NA_integer_] = ACTIONS(1347),
    [anon_sym_NA_real_] = ACTIONS(1347),
    [anon_sym_NA_complex_] = ACTIONS(1347),
    [anon_sym_NA_character_] = ACTIONS(1347),
    [sym_dots] = ACTIONS(1347),
    [sym_dot_dot_i] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1349),
    [sym__newline] = ACTIONS(1349),
    [sym__raw_string_literal] = ACTIONS(1349),
    [sym__external_open_parenthesis] = ACTIONS(1349),
    [sym__external_close_parenthesis] = ACTIONS(1349),
    [sym__external_open_brace] = ACTIONS(1349),
    [sym__external_open_bracket] = ACTIONS(1349),
    [sym__external_open_bracket2] = ACTIONS(1349),
  },
  [708] = {
    [sym_identifier] = ACTIONS(1347),
    [anon_sym_BSLASH] = ACTIONS(1349),
    [anon_sym_function] = ACTIONS(1347),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_if] = ACTIONS(1347),
    [anon_sym_for] = ACTIONS(1347),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1347),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1347),
    [anon_sym_LT_DASH] = ACTIONS(1349),
    [anon_sym_LT_LT_DASH] = ACTIONS(1349),
    [anon_sym_COLON_EQ] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1347),
    [anon_sym_DASH_GT_GT] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1347),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_GT_EQ] = ACTIONS(1349),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_SLASH] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [aux_sym_binary_operator_token1] = ACTIONS(1349),
    [anon_sym_PIPE_GT] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(1347),
    [anon_sym_DOLLAR] = ACTIONS(1349),
    [anon_sym_AT] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1347),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1349),
    [sym__hex_literal] = ACTIONS(1349),
    [sym__number_literal] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1349),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [sym_return] = ACTIONS(1347),
    [sym_next] = ACTIONS(1347),
    [sym_break] = ACTIONS(1347),
    [sym_true] = ACTIONS(1347),
    [sym_false] = ACTIONS(1347),
    [sym_null] = ACTIONS(1347),
    [sym_inf] = ACTIONS(1347),
    [sym_nan] = ACTIONS(1347),
    [anon_sym_NA] = ACTIONS(1347),
    [anon_sym_NA_integer_] = ACTIONS(1347),
    [anon_sym_NA_real_] = ACTIONS(1347),
    [anon_sym_NA_complex_] = ACTIONS(1347),
    [anon_sym_NA_character_] = ACTIONS(1347),
    [sym_dots] = ACTIONS(1347),
    [sym_dot_dot_i] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1349),
    [sym__newline] = ACTIONS(1349),
    [sym__raw_string_literal] = ACTIONS(1349),
    [sym__external_open_parenthesis] = ACTIONS(1349),
    [sym__external_close_parenthesis] = ACTIONS(1349),
    [sym__external_open_brace] = ACTIONS(1349),
    [sym__external_open_bracket] = ACTIONS(1349),
    [sym__external_open_bracket2] = ACTIONS(1349),
  },
  [709] = {
    [ts_builtin_sym_end] = ACTIONS(1363),
    [sym_identifier] = ACTIONS(1365),
    [anon_sym_BSLASH] = ACTIONS(1363),
    [anon_sym_function] = ACTIONS(1365),
    [anon_sym_EQ] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(1365),
    [anon_sym_for] = ACTIONS(1365),
    [anon_sym_while] = ACTIONS(1365),
    [anon_sym_repeat] = ACTIONS(1365),
    [anon_sym_QMARK] = ACTIONS(1363),
    [anon_sym_TILDE] = ACTIONS(1363),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1365),
    [anon_sym_LT_DASH] = ACTIONS(1363),
    [anon_sym_LT_LT_DASH] = ACTIONS(1363),
    [anon_sym_COLON_EQ] = ACTIONS(1363),
    [anon_sym_DASH_GT] = ACTIONS(1365),
    [anon_sym_DASH_GT_GT] = ACTIONS(1363),
    [anon_sym_PIPE] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE_PIPE] = ACTIONS(1363),
    [anon_sym_AMP_AMP] = ACTIONS(1363),
    [anon_sym_LT] = ACTIONS(1365),
    [anon_sym_LT_EQ] = ACTIONS(1363),
    [anon_sym_GT] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1363),
    [anon_sym_EQ_EQ] = ACTIONS(1363),
    [anon_sym_BANG_EQ] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1365),
    [anon_sym_SLASH] = ACTIONS(1363),
    [anon_sym_STAR_STAR] = ACTIONS(1363),
    [anon_sym_CARET] = ACTIONS(1363),
    [aux_sym_binary_operator_token1] = ACTIONS(1363),
    [anon_sym_PIPE_GT] = ACTIONS(1363),
    [anon_sym_COLON] = ACTIONS(1365),
    [anon_sym_DOLLAR] = ACTIONS(1363),
    [anon_sym_AT] = ACTIONS(1363),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1363),
    [sym__hex_literal] = ACTIONS(1363),
    [sym__number_literal] = ACTIONS(1365),
    [anon_sym_SQUOTE] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1363),
    [sym_return] = ACTIONS(1365),
    [sym_next] = ACTIONS(1365),
    [sym_break] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_null] = ACTIONS(1365),
    [sym_inf] = ACTIONS(1365),
    [sym_nan] = ACTIONS(1365),
    [anon_sym_NA] = ACTIONS(1365),
    [anon_sym_NA_integer_] = ACTIONS(1365),
    [anon_sym_NA_real_] = ACTIONS(1365),
    [anon_sym_NA_complex_] = ACTIONS(1365),
    [anon_sym_NA_character_] = ACTIONS(1365),
    [sym_dots] = ACTIONS(1365),
    [sym_dot_dot_i] = ACTIONS(1363),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1363),
    [sym__semicolon] = ACTIONS(1363),
    [sym__raw_string_literal] = ACTIONS(1363),
    [sym__external_open_parenthesis] = ACTIONS(1363),
    [sym__external_open_brace] = ACTIONS(1363),
    [sym__external_open_bracket] = ACTIONS(1363),
    [sym__external_open_bracket2] = ACTIONS(1363),
  },
  [710] = {
    [sym_identifier] = ACTIONS(1339),
    [anon_sym_BSLASH] = ACTIONS(1341),
    [anon_sym_function] = ACTIONS(1339),
    [anon_sym_EQ] = ACTIONS(1339),
    [anon_sym_if] = ACTIONS(1339),
    [anon_sym_for] = ACTIONS(1339),
    [anon_sym_while] = ACTIONS(1339),
    [anon_sym_repeat] = ACTIONS(1339),
    [anon_sym_QMARK] = ACTIONS(1341),
    [anon_sym_TILDE] = ACTIONS(1341),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_LT_DASH] = ACTIONS(1341),
    [anon_sym_LT_LT_DASH] = ACTIONS(1341),
    [anon_sym_COLON_EQ] = ACTIONS(1341),
    [anon_sym_DASH_GT] = ACTIONS(1339),
    [anon_sym_DASH_GT_GT] = ACTIONS(1341),
    [anon_sym_PIPE] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_PIPE_PIPE] = ACTIONS(1341),
    [anon_sym_AMP_AMP] = ACTIONS(1341),
    [anon_sym_LT] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1341),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_GT_EQ] = ACTIONS(1341),
    [anon_sym_EQ_EQ] = ACTIONS(1341),
    [anon_sym_BANG_EQ] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_SLASH] = ACTIONS(1341),
    [anon_sym_STAR_STAR] = ACTIONS(1341),
    [anon_sym_CARET] = ACTIONS(1341),
    [aux_sym_binary_operator_token1] = ACTIONS(1341),
    [anon_sym_PIPE_GT] = ACTIONS(1341),
    [anon_sym_COLON] = ACTIONS(1339),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1341),
    [anon_sym_L] = ACTIONS(1390),
    [anon_sym_i] = ACTIONS(1392),
    [sym__hex_literal] = ACTIONS(1341),
    [sym__number_literal] = ACTIONS(1339),
    [anon_sym_SQUOTE] = ACTIONS(1341),
    [anon_sym_DQUOTE] = ACTIONS(1341),
    [sym_return] = ACTIONS(1339),
    [sym_next] = ACTIONS(1339),
    [sym_break] = ACTIONS(1339),
    [sym_true] = ACTIONS(1339),
    [sym_false] = ACTIONS(1339),
    [sym_null] = ACTIONS(1339),
    [sym_inf] = ACTIONS(1339),
    [sym_nan] = ACTIONS(1339),
    [anon_sym_NA] = ACTIONS(1339),
    [anon_sym_NA_integer_] = ACTIONS(1339),
    [anon_sym_NA_real_] = ACTIONS(1339),
    [anon_sym_NA_complex_] = ACTIONS(1339),
    [anon_sym_NA_character_] = ACTIONS(1339),
    [sym_dots] = ACTIONS(1339),
    [sym_dot_dot_i] = ACTIONS(1341),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1341),
    [sym__newline] = ACTIONS(1341),
    [sym__raw_string_literal] = ACTIONS(1341),
    [sym__external_open_parenthesis] = ACTIONS(1341),
    [sym__external_open_brace] = ACTIONS(1341),
    [sym__external_open_bracket] = ACTIONS(1341),
    [sym__external_open_bracket2] = ACTIONS(1341),
    [sym__external_close_bracket2] = ACTIONS(1341),
  },
  [711] = {
    [sym_identifier] = ACTIONS(1357),
    [anon_sym_BSLASH] = ACTIONS(1355),
    [anon_sym_function] = ACTIONS(1357),
    [anon_sym_EQ] = ACTIONS(1357),
    [anon_sym_if] = ACTIONS(1357),
    [anon_sym_for] = ACTIONS(1357),
    [anon_sym_while] = ACTIONS(1357),
    [anon_sym_repeat] = ACTIONS(1357),
    [anon_sym_QMARK] = ACTIONS(1355),
    [anon_sym_TILDE] = ACTIONS(1355),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1357),
    [anon_sym_LT_DASH] = ACTIONS(1355),
    [anon_sym_LT_LT_DASH] = ACTIONS(1355),
    [anon_sym_COLON_EQ] = ACTIONS(1355),
    [anon_sym_DASH_GT] = ACTIONS(1357),
    [anon_sym_DASH_GT_GT] = ACTIONS(1355),
    [anon_sym_PIPE] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_AMP_AMP] = ACTIONS(1355),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_LT_EQ] = ACTIONS(1355),
    [anon_sym_GT] = ACTIONS(1357),
    [anon_sym_GT_EQ] = ACTIONS(1355),
    [anon_sym_EQ_EQ] = ACTIONS(1355),
    [anon_sym_BANG_EQ] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1357),
    [anon_sym_SLASH] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1355),
    [anon_sym_CARET] = ACTIONS(1355),
    [aux_sym_binary_operator_token1] = ACTIONS(1355),
    [anon_sym_PIPE_GT] = ACTIONS(1355),
    [anon_sym_COLON] = ACTIONS(1357),
    [anon_sym_DOLLAR] = ACTIONS(1355),
    [anon_sym_AT] = ACTIONS(1355),
    [anon_sym_COLON_COLON] = ACTIONS(1357),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1355),
    [sym__hex_literal] = ACTIONS(1355),
    [sym__number_literal] = ACTIONS(1357),
    [anon_sym_SQUOTE] = ACTIONS(1355),
    [anon_sym_DQUOTE] = ACTIONS(1355),
    [sym_return] = ACTIONS(1357),
    [sym_next] = ACTIONS(1357),
    [sym_break] = ACTIONS(1357),
    [sym_true] = ACTIONS(1357),
    [sym_false] = ACTIONS(1357),
    [sym_null] = ACTIONS(1357),
    [sym_inf] = ACTIONS(1357),
    [sym_nan] = ACTIONS(1357),
    [anon_sym_NA] = ACTIONS(1357),
    [anon_sym_NA_integer_] = ACTIONS(1357),
    [anon_sym_NA_real_] = ACTIONS(1357),
    [anon_sym_NA_complex_] = ACTIONS(1357),
    [anon_sym_NA_character_] = ACTIONS(1357),
    [sym_dots] = ACTIONS(1357),
    [sym_dot_dot_i] = ACTIONS(1355),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1355),
    [sym__newline] = ACTIONS(1355),
    [sym__raw_string_literal] = ACTIONS(1355),
    [sym__external_open_parenthesis] = ACTIONS(1355),
    [sym__external_open_brace] = ACTIONS(1355),
    [sym__external_open_bracket] = ACTIONS(1355),
    [sym__external_close_bracket] = ACTIONS(1355),
    [sym__external_open_bracket2] = ACTIONS(1355),
  },
  [712] = {
    [sym_identifier] = ACTIONS(1361),
    [anon_sym_BSLASH] = ACTIONS(1359),
    [anon_sym_function] = ACTIONS(1361),
    [anon_sym_EQ] = ACTIONS(1361),
    [anon_sym_if] = ACTIONS(1361),
    [anon_sym_for] = ACTIONS(1361),
    [anon_sym_while] = ACTIONS(1361),
    [anon_sym_repeat] = ACTIONS(1361),
    [anon_sym_QMARK] = ACTIONS(1359),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_BANG] = ACTIONS(1361),
    [anon_sym_PLUS] = ACTIONS(1359),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_LT_DASH] = ACTIONS(1359),
    [anon_sym_LT_LT_DASH] = ACTIONS(1359),
    [anon_sym_COLON_EQ] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [anon_sym_DASH_GT_GT] = ACTIONS(1359),
    [anon_sym_PIPE] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(1361),
    [anon_sym_PIPE_PIPE] = ACTIONS(1359),
    [anon_sym_AMP_AMP] = ACTIONS(1359),
    [anon_sym_LT] = ACTIONS(1361),
    [anon_sym_LT_EQ] = ACTIONS(1359),
    [anon_sym_GT] = ACTIONS(1361),
    [anon_sym_GT_EQ] = ACTIONS(1359),
    [anon_sym_EQ_EQ] = ACTIONS(1359),
    [anon_sym_BANG_EQ] = ACTIONS(1359),
    [anon_sym_STAR] = ACTIONS(1361),
    [anon_sym_SLASH] = ACTIONS(1359),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [aux_sym_binary_operator_token1] = ACTIONS(1359),
    [anon_sym_PIPE_GT] = ACTIONS(1359),
    [anon_sym_COLON] = ACTIONS(1361),
    [anon_sym_DOLLAR] = ACTIONS(1359),
    [anon_sym_AT] = ACTIONS(1359),
    [anon_sym_COLON_COLON] = ACTIONS(1361),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1359),
    [sym__hex_literal] = ACTIONS(1359),
    [sym__number_literal] = ACTIONS(1361),
    [anon_sym_SQUOTE] = ACTIONS(1359),
    [anon_sym_DQUOTE] = ACTIONS(1359),
    [sym_return] = ACTIONS(1361),
    [sym_next] = ACTIONS(1361),
    [sym_break] = ACTIONS(1361),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [sym_null] = ACTIONS(1361),
    [sym_inf] = ACTIONS(1361),
    [sym_nan] = ACTIONS(1361),
    [anon_sym_NA] = ACTIONS(1361),
    [anon_sym_NA_integer_] = ACTIONS(1361),
    [anon_sym_NA_real_] = ACTIONS(1361),
    [anon_sym_NA_complex_] = ACTIONS(1361),
    [anon_sym_NA_character_] = ACTIONS(1361),
    [sym_dots] = ACTIONS(1361),
    [sym_dot_dot_i] = ACTIONS(1359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1359),
    [sym__newline] = ACTIONS(1359),
    [sym__raw_string_literal] = ACTIONS(1359),
    [sym__external_open_parenthesis] = ACTIONS(1359),
    [sym__external_open_brace] = ACTIONS(1359),
    [sym__external_open_bracket] = ACTIONS(1359),
    [sym__external_close_bracket] = ACTIONS(1359),
    [sym__external_open_bracket2] = ACTIONS(1359),
  },
  [713] = {
    [sym_identifier] = ACTIONS(1365),
    [anon_sym_BSLASH] = ACTIONS(1363),
    [anon_sym_function] = ACTIONS(1365),
    [anon_sym_EQ] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(1365),
    [anon_sym_for] = ACTIONS(1365),
    [anon_sym_while] = ACTIONS(1365),
    [anon_sym_repeat] = ACTIONS(1365),
    [anon_sym_QMARK] = ACTIONS(1363),
    [anon_sym_TILDE] = ACTIONS(1363),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1365),
    [anon_sym_LT_DASH] = ACTIONS(1363),
    [anon_sym_LT_LT_DASH] = ACTIONS(1363),
    [anon_sym_COLON_EQ] = ACTIONS(1363),
    [anon_sym_DASH_GT] = ACTIONS(1365),
    [anon_sym_DASH_GT_GT] = ACTIONS(1363),
    [anon_sym_PIPE] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE_PIPE] = ACTIONS(1363),
    [anon_sym_AMP_AMP] = ACTIONS(1363),
    [anon_sym_LT] = ACTIONS(1365),
    [anon_sym_LT_EQ] = ACTIONS(1363),
    [anon_sym_GT] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1363),
    [anon_sym_EQ_EQ] = ACTIONS(1363),
    [anon_sym_BANG_EQ] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1365),
    [anon_sym_SLASH] = ACTIONS(1363),
    [anon_sym_STAR_STAR] = ACTIONS(1363),
    [anon_sym_CARET] = ACTIONS(1363),
    [aux_sym_binary_operator_token1] = ACTIONS(1363),
    [anon_sym_PIPE_GT] = ACTIONS(1363),
    [anon_sym_COLON] = ACTIONS(1365),
    [anon_sym_DOLLAR] = ACTIONS(1363),
    [anon_sym_AT] = ACTIONS(1363),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1363),
    [sym__hex_literal] = ACTIONS(1363),
    [sym__number_literal] = ACTIONS(1365),
    [anon_sym_SQUOTE] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1363),
    [sym_return] = ACTIONS(1365),
    [sym_next] = ACTIONS(1365),
    [sym_break] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_null] = ACTIONS(1365),
    [sym_inf] = ACTIONS(1365),
    [sym_nan] = ACTIONS(1365),
    [anon_sym_NA] = ACTIONS(1365),
    [anon_sym_NA_integer_] = ACTIONS(1365),
    [anon_sym_NA_real_] = ACTIONS(1365),
    [anon_sym_NA_complex_] = ACTIONS(1365),
    [anon_sym_NA_character_] = ACTIONS(1365),
    [sym_dots] = ACTIONS(1365),
    [sym_dot_dot_i] = ACTIONS(1363),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1363),
    [sym__newline] = ACTIONS(1363),
    [sym__raw_string_literal] = ACTIONS(1363),
    [sym__external_open_parenthesis] = ACTIONS(1363),
    [sym__external_open_brace] = ACTIONS(1363),
    [sym__external_open_bracket] = ACTIONS(1363),
    [sym__external_close_bracket] = ACTIONS(1363),
    [sym__external_open_bracket2] = ACTIONS(1363),
  },
  [714] = {
    [sym_identifier] = ACTIONS(1331),
    [anon_sym_BSLASH] = ACTIONS(1333),
    [anon_sym_function] = ACTIONS(1331),
    [anon_sym_EQ] = ACTIONS(1331),
    [anon_sym_if] = ACTIONS(1331),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_while] = ACTIONS(1331),
    [anon_sym_repeat] = ACTIONS(1331),
    [anon_sym_QMARK] = ACTIONS(1333),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_LT_DASH] = ACTIONS(1333),
    [anon_sym_LT_LT_DASH] = ACTIONS(1333),
    [anon_sym_COLON_EQ] = ACTIONS(1333),
    [anon_sym_DASH_GT] = ACTIONS(1331),
    [anon_sym_DASH_GT_GT] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1331),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1333),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_GT_EQ] = ACTIONS(1333),
    [anon_sym_EQ_EQ] = ACTIONS(1333),
    [anon_sym_BANG_EQ] = ACTIONS(1333),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_SLASH] = ACTIONS(1333),
    [anon_sym_STAR_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1333),
    [aux_sym_binary_operator_token1] = ACTIONS(1333),
    [anon_sym_PIPE_GT] = ACTIONS(1333),
    [anon_sym_COLON] = ACTIONS(1331),
    [anon_sym_DOLLAR] = ACTIONS(1333),
    [anon_sym_AT] = ACTIONS(1333),
    [anon_sym_COLON_COLON] = ACTIONS(1335),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1337),
    [sym__hex_literal] = ACTIONS(1333),
    [sym__number_literal] = ACTIONS(1331),
    [anon_sym_SQUOTE] = ACTIONS(1333),
    [anon_sym_DQUOTE] = ACTIONS(1333),
    [sym_return] = ACTIONS(1331),
    [sym_next] = ACTIONS(1331),
    [sym_break] = ACTIONS(1331),
    [sym_true] = ACTIONS(1331),
    [sym_false] = ACTIONS(1331),
    [sym_null] = ACTIONS(1331),
    [sym_inf] = ACTIONS(1331),
    [sym_nan] = ACTIONS(1331),
    [anon_sym_NA] = ACTIONS(1331),
    [anon_sym_NA_integer_] = ACTIONS(1331),
    [anon_sym_NA_real_] = ACTIONS(1331),
    [anon_sym_NA_complex_] = ACTIONS(1331),
    [anon_sym_NA_character_] = ACTIONS(1331),
    [sym_dots] = ACTIONS(1331),
    [sym_dot_dot_i] = ACTIONS(1333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1333),
    [sym__newline] = ACTIONS(1333),
    [sym__raw_string_literal] = ACTIONS(1333),
    [sym__external_open_parenthesis] = ACTIONS(1333),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_open_bracket] = ACTIONS(1333),
    [sym__external_close_bracket] = ACTIONS(1333),
    [sym__external_open_bracket2] = ACTIONS(1333),
  },
  [715] = {
    [sym_identifier] = ACTIONS(1357),
    [anon_sym_BSLASH] = ACTIONS(1355),
    [anon_sym_function] = ACTIONS(1357),
    [anon_sym_EQ] = ACTIONS(1357),
    [anon_sym_if] = ACTIONS(1357),
    [anon_sym_for] = ACTIONS(1357),
    [anon_sym_while] = ACTIONS(1357),
    [anon_sym_repeat] = ACTIONS(1357),
    [anon_sym_QMARK] = ACTIONS(1355),
    [anon_sym_TILDE] = ACTIONS(1355),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1357),
    [anon_sym_LT_DASH] = ACTIONS(1355),
    [anon_sym_LT_LT_DASH] = ACTIONS(1355),
    [anon_sym_COLON_EQ] = ACTIONS(1355),
    [anon_sym_DASH_GT] = ACTIONS(1357),
    [anon_sym_DASH_GT_GT] = ACTIONS(1355),
    [anon_sym_PIPE] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_AMP_AMP] = ACTIONS(1355),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_LT_EQ] = ACTIONS(1355),
    [anon_sym_GT] = ACTIONS(1357),
    [anon_sym_GT_EQ] = ACTIONS(1355),
    [anon_sym_EQ_EQ] = ACTIONS(1355),
    [anon_sym_BANG_EQ] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1357),
    [anon_sym_SLASH] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1355),
    [anon_sym_CARET] = ACTIONS(1355),
    [aux_sym_binary_operator_token1] = ACTIONS(1355),
    [anon_sym_PIPE_GT] = ACTIONS(1355),
    [anon_sym_COLON] = ACTIONS(1357),
    [anon_sym_DOLLAR] = ACTIONS(1355),
    [anon_sym_AT] = ACTIONS(1355),
    [anon_sym_COLON_COLON] = ACTIONS(1357),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1355),
    [sym__hex_literal] = ACTIONS(1355),
    [sym__number_literal] = ACTIONS(1357),
    [anon_sym_SQUOTE] = ACTIONS(1355),
    [anon_sym_DQUOTE] = ACTIONS(1355),
    [sym_return] = ACTIONS(1357),
    [sym_next] = ACTIONS(1357),
    [sym_break] = ACTIONS(1357),
    [sym_true] = ACTIONS(1357),
    [sym_false] = ACTIONS(1357),
    [sym_null] = ACTIONS(1357),
    [sym_inf] = ACTIONS(1357),
    [sym_nan] = ACTIONS(1357),
    [anon_sym_NA] = ACTIONS(1357),
    [anon_sym_NA_integer_] = ACTIONS(1357),
    [anon_sym_NA_real_] = ACTIONS(1357),
    [anon_sym_NA_complex_] = ACTIONS(1357),
    [anon_sym_NA_character_] = ACTIONS(1357),
    [sym_dots] = ACTIONS(1357),
    [sym_dot_dot_i] = ACTIONS(1355),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1355),
    [sym__semicolon] = ACTIONS(1355),
    [sym__raw_string_literal] = ACTIONS(1355),
    [sym__external_open_parenthesis] = ACTIONS(1355),
    [sym__external_open_brace] = ACTIONS(1355),
    [sym__external_close_brace] = ACTIONS(1355),
    [sym__external_open_bracket] = ACTIONS(1355),
    [sym__external_open_bracket2] = ACTIONS(1355),
  },
  [716] = {
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_BSLASH] = ACTIONS(1329),
    [anon_sym_function] = ACTIONS(1327),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_repeat] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1329),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_LT_DASH] = ACTIONS(1329),
    [anon_sym_LT_LT_DASH] = ACTIONS(1329),
    [anon_sym_COLON_EQ] = ACTIONS(1329),
    [anon_sym_DASH_GT] = ACTIONS(1327),
    [anon_sym_DASH_GT_GT] = ACTIONS(1329),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1329),
    [anon_sym_AMP_AMP] = ACTIONS(1329),
    [anon_sym_LT] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1329),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1329),
    [anon_sym_EQ_EQ] = ACTIONS(1329),
    [anon_sym_BANG_EQ] = ACTIONS(1329),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_SLASH] = ACTIONS(1329),
    [anon_sym_STAR_STAR] = ACTIONS(1329),
    [anon_sym_CARET] = ACTIONS(1329),
    [aux_sym_binary_operator_token1] = ACTIONS(1329),
    [anon_sym_PIPE_GT] = ACTIONS(1329),
    [anon_sym_COLON] = ACTIONS(1327),
    [anon_sym_DOLLAR] = ACTIONS(1329),
    [anon_sym_AT] = ACTIONS(1329),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1329),
    [sym__hex_literal] = ACTIONS(1329),
    [sym__number_literal] = ACTIONS(1327),
    [anon_sym_SQUOTE] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(1329),
    [sym_return] = ACTIONS(1327),
    [sym_next] = ACTIONS(1327),
    [sym_break] = ACTIONS(1327),
    [sym_true] = ACTIONS(1327),
    [sym_false] = ACTIONS(1327),
    [sym_null] = ACTIONS(1327),
    [sym_inf] = ACTIONS(1327),
    [sym_nan] = ACTIONS(1327),
    [anon_sym_NA] = ACTIONS(1327),
    [anon_sym_NA_integer_] = ACTIONS(1327),
    [anon_sym_NA_real_] = ACTIONS(1327),
    [anon_sym_NA_complex_] = ACTIONS(1327),
    [anon_sym_NA_character_] = ACTIONS(1327),
    [sym_dots] = ACTIONS(1327),
    [sym_dot_dot_i] = ACTIONS(1329),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1329),
    [sym__newline] = ACTIONS(1329),
    [sym__raw_string_literal] = ACTIONS(1329),
    [sym__external_open_parenthesis] = ACTIONS(1329),
    [sym__external_open_brace] = ACTIONS(1329),
    [sym__external_open_bracket] = ACTIONS(1329),
    [sym__external_open_bracket2] = ACTIONS(1329),
    [sym__external_close_bracket2] = ACTIONS(1329),
  },
  [717] = {
    [sym_identifier] = ACTIONS(1365),
    [anon_sym_BSLASH] = ACTIONS(1363),
    [anon_sym_function] = ACTIONS(1365),
    [anon_sym_EQ] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(1365),
    [anon_sym_for] = ACTIONS(1365),
    [anon_sym_while] = ACTIONS(1365),
    [anon_sym_repeat] = ACTIONS(1365),
    [anon_sym_QMARK] = ACTIONS(1363),
    [anon_sym_TILDE] = ACTIONS(1363),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1365),
    [anon_sym_LT_DASH] = ACTIONS(1363),
    [anon_sym_LT_LT_DASH] = ACTIONS(1363),
    [anon_sym_COLON_EQ] = ACTIONS(1363),
    [anon_sym_DASH_GT] = ACTIONS(1365),
    [anon_sym_DASH_GT_GT] = ACTIONS(1363),
    [anon_sym_PIPE] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE_PIPE] = ACTIONS(1363),
    [anon_sym_AMP_AMP] = ACTIONS(1363),
    [anon_sym_LT] = ACTIONS(1365),
    [anon_sym_LT_EQ] = ACTIONS(1363),
    [anon_sym_GT] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1363),
    [anon_sym_EQ_EQ] = ACTIONS(1363),
    [anon_sym_BANG_EQ] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1365),
    [anon_sym_SLASH] = ACTIONS(1363),
    [anon_sym_STAR_STAR] = ACTIONS(1363),
    [anon_sym_CARET] = ACTIONS(1363),
    [aux_sym_binary_operator_token1] = ACTIONS(1363),
    [anon_sym_PIPE_GT] = ACTIONS(1363),
    [anon_sym_COLON] = ACTIONS(1365),
    [anon_sym_DOLLAR] = ACTIONS(1363),
    [anon_sym_AT] = ACTIONS(1363),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1363),
    [sym__hex_literal] = ACTIONS(1363),
    [sym__number_literal] = ACTIONS(1365),
    [anon_sym_SQUOTE] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1363),
    [sym_return] = ACTIONS(1365),
    [sym_next] = ACTIONS(1365),
    [sym_break] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_null] = ACTIONS(1365),
    [sym_inf] = ACTIONS(1365),
    [sym_nan] = ACTIONS(1365),
    [anon_sym_NA] = ACTIONS(1365),
    [anon_sym_NA_integer_] = ACTIONS(1365),
    [anon_sym_NA_real_] = ACTIONS(1365),
    [anon_sym_NA_complex_] = ACTIONS(1365),
    [anon_sym_NA_character_] = ACTIONS(1365),
    [sym_dots] = ACTIONS(1365),
    [sym_dot_dot_i] = ACTIONS(1363),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1363),
    [sym__newline] = ACTIONS(1363),
    [sym__raw_string_literal] = ACTIONS(1363),
    [sym__external_open_parenthesis] = ACTIONS(1363),
    [sym__external_open_brace] = ACTIONS(1363),
    [sym__external_open_bracket] = ACTIONS(1363),
    [sym__external_open_bracket2] = ACTIONS(1363),
    [sym__external_close_bracket2] = ACTIONS(1363),
  },
  [718] = {
    [sym_identifier] = ACTIONS(1361),
    [anon_sym_BSLASH] = ACTIONS(1359),
    [anon_sym_function] = ACTIONS(1361),
    [anon_sym_EQ] = ACTIONS(1361),
    [anon_sym_if] = ACTIONS(1361),
    [anon_sym_for] = ACTIONS(1361),
    [anon_sym_while] = ACTIONS(1361),
    [anon_sym_repeat] = ACTIONS(1361),
    [anon_sym_QMARK] = ACTIONS(1359),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_BANG] = ACTIONS(1361),
    [anon_sym_PLUS] = ACTIONS(1359),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_LT_DASH] = ACTIONS(1359),
    [anon_sym_LT_LT_DASH] = ACTIONS(1359),
    [anon_sym_COLON_EQ] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [anon_sym_DASH_GT_GT] = ACTIONS(1359),
    [anon_sym_PIPE] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(1361),
    [anon_sym_PIPE_PIPE] = ACTIONS(1359),
    [anon_sym_AMP_AMP] = ACTIONS(1359),
    [anon_sym_LT] = ACTIONS(1361),
    [anon_sym_LT_EQ] = ACTIONS(1359),
    [anon_sym_GT] = ACTIONS(1361),
    [anon_sym_GT_EQ] = ACTIONS(1359),
    [anon_sym_EQ_EQ] = ACTIONS(1359),
    [anon_sym_BANG_EQ] = ACTIONS(1359),
    [anon_sym_STAR] = ACTIONS(1361),
    [anon_sym_SLASH] = ACTIONS(1359),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [aux_sym_binary_operator_token1] = ACTIONS(1359),
    [anon_sym_PIPE_GT] = ACTIONS(1359),
    [anon_sym_COLON] = ACTIONS(1361),
    [anon_sym_DOLLAR] = ACTIONS(1359),
    [anon_sym_AT] = ACTIONS(1359),
    [anon_sym_COLON_COLON] = ACTIONS(1361),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1359),
    [sym__hex_literal] = ACTIONS(1359),
    [sym__number_literal] = ACTIONS(1361),
    [anon_sym_SQUOTE] = ACTIONS(1359),
    [anon_sym_DQUOTE] = ACTIONS(1359),
    [sym_return] = ACTIONS(1361),
    [sym_next] = ACTIONS(1361),
    [sym_break] = ACTIONS(1361),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [sym_null] = ACTIONS(1361),
    [sym_inf] = ACTIONS(1361),
    [sym_nan] = ACTIONS(1361),
    [anon_sym_NA] = ACTIONS(1361),
    [anon_sym_NA_integer_] = ACTIONS(1361),
    [anon_sym_NA_real_] = ACTIONS(1361),
    [anon_sym_NA_complex_] = ACTIONS(1361),
    [anon_sym_NA_character_] = ACTIONS(1361),
    [sym_dots] = ACTIONS(1361),
    [sym_dot_dot_i] = ACTIONS(1359),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1359),
    [sym__semicolon] = ACTIONS(1359),
    [sym__raw_string_literal] = ACTIONS(1359),
    [sym__external_open_parenthesis] = ACTIONS(1359),
    [sym__external_open_brace] = ACTIONS(1359),
    [sym__external_close_brace] = ACTIONS(1359),
    [sym__external_open_bracket] = ACTIONS(1359),
    [sym__external_open_bracket2] = ACTIONS(1359),
  },
  [719] = {
    [sym_identifier] = ACTIONS(1351),
    [anon_sym_BSLASH] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [anon_sym_repeat] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_PLUS] = ACTIONS(1353),
    [anon_sym_DASH] = ACTIONS(1351),
    [anon_sym_LT_DASH] = ACTIONS(1353),
    [anon_sym_LT_LT_DASH] = ACTIONS(1353),
    [anon_sym_COLON_EQ] = ACTIONS(1353),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_DASH_GT_GT] = ACTIONS(1353),
    [anon_sym_PIPE] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PIPE_PIPE] = ACTIONS(1353),
    [anon_sym_AMP_AMP] = ACTIONS(1353),
    [anon_sym_LT] = ACTIONS(1351),
    [anon_sym_LT_EQ] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(1351),
    [anon_sym_GT_EQ] = ACTIONS(1353),
    [anon_sym_EQ_EQ] = ACTIONS(1353),
    [anon_sym_BANG_EQ] = ACTIONS(1353),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_SLASH] = ACTIONS(1353),
    [anon_sym_STAR_STAR] = ACTIONS(1353),
    [anon_sym_CARET] = ACTIONS(1353),
    [aux_sym_binary_operator_token1] = ACTIONS(1353),
    [anon_sym_PIPE_GT] = ACTIONS(1353),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_DOLLAR] = ACTIONS(1353),
    [anon_sym_AT] = ACTIONS(1353),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1353),
    [sym__hex_literal] = ACTIONS(1353),
    [sym__number_literal] = ACTIONS(1351),
    [anon_sym_SQUOTE] = ACTIONS(1353),
    [anon_sym_DQUOTE] = ACTIONS(1353),
    [sym_return] = ACTIONS(1351),
    [sym_next] = ACTIONS(1351),
    [sym_break] = ACTIONS(1351),
    [sym_true] = ACTIONS(1351),
    [sym_false] = ACTIONS(1351),
    [sym_null] = ACTIONS(1351),
    [sym_inf] = ACTIONS(1351),
    [sym_nan] = ACTIONS(1351),
    [anon_sym_NA] = ACTIONS(1351),
    [anon_sym_NA_integer_] = ACTIONS(1351),
    [anon_sym_NA_real_] = ACTIONS(1351),
    [anon_sym_NA_complex_] = ACTIONS(1351),
    [anon_sym_NA_character_] = ACTIONS(1351),
    [sym_dots] = ACTIONS(1351),
    [sym_dot_dot_i] = ACTIONS(1353),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1353),
    [sym__newline] = ACTIONS(1353),
    [sym__raw_string_literal] = ACTIONS(1353),
    [sym__external_open_parenthesis] = ACTIONS(1353),
    [sym__external_open_brace] = ACTIONS(1353),
    [sym__external_open_bracket] = ACTIONS(1353),
    [sym__external_close_bracket] = ACTIONS(1353),
    [sym__external_open_bracket2] = ACTIONS(1353),
  },
  [720] = {
    [aux_sym_function_definition_repeat1] = STATE(720),
    [ts_builtin_sym_end] = ACTIONS(1385),
    [sym_identifier] = ACTIONS(1383),
    [anon_sym_BSLASH] = ACTIONS(1385),
    [anon_sym_function] = ACTIONS(1383),
    [anon_sym_EQ] = ACTIONS(1383),
    [anon_sym_if] = ACTIONS(1383),
    [anon_sym_for] = ACTIONS(1383),
    [anon_sym_while] = ACTIONS(1383),
    [anon_sym_repeat] = ACTIONS(1383),
    [anon_sym_QMARK] = ACTIONS(1385),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1383),
    [anon_sym_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_COLON_EQ] = ACTIONS(1385),
    [anon_sym_DASH_GT] = ACTIONS(1383),
    [anon_sym_DASH_GT_GT] = ACTIONS(1385),
    [anon_sym_PIPE] = ACTIONS(1383),
    [anon_sym_AMP] = ACTIONS(1383),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1383),
    [anon_sym_LT_EQ] = ACTIONS(1385),
    [anon_sym_GT] = ACTIONS(1383),
    [anon_sym_GT_EQ] = ACTIONS(1385),
    [anon_sym_EQ_EQ] = ACTIONS(1385),
    [anon_sym_BANG_EQ] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_SLASH] = ACTIONS(1385),
    [anon_sym_STAR_STAR] = ACTIONS(1385),
    [anon_sym_CARET] = ACTIONS(1385),
    [aux_sym_binary_operator_token1] = ACTIONS(1385),
    [anon_sym_PIPE_GT] = ACTIONS(1385),
    [anon_sym_COLON] = ACTIONS(1383),
    [anon_sym_DOLLAR] = ACTIONS(1385),
    [anon_sym_AT] = ACTIONS(1385),
    [sym__hex_literal] = ACTIONS(1385),
    [sym__number_literal] = ACTIONS(1383),
    [anon_sym_SQUOTE] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [sym_return] = ACTIONS(1383),
    [sym_next] = ACTIONS(1383),
    [sym_break] = ACTIONS(1383),
    [sym_true] = ACTIONS(1383),
    [sym_false] = ACTIONS(1383),
    [sym_null] = ACTIONS(1383),
    [sym_inf] = ACTIONS(1383),
    [sym_nan] = ACTIONS(1383),
    [anon_sym_NA] = ACTIONS(1383),
    [anon_sym_NA_integer_] = ACTIONS(1383),
    [anon_sym_NA_real_] = ACTIONS(1383),
    [anon_sym_NA_complex_] = ACTIONS(1383),
    [anon_sym_NA_character_] = ACTIONS(1383),
    [sym_dots] = ACTIONS(1383),
    [sym_dot_dot_i] = ACTIONS(1385),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1394),
    [sym__semicolon] = ACTIONS(1385),
    [sym__raw_string_literal] = ACTIONS(1385),
    [sym__external_else] = ACTIONS(1385),
    [sym__external_open_parenthesis] = ACTIONS(1385),
    [sym__external_open_brace] = ACTIONS(1385),
    [sym__external_open_bracket] = ACTIONS(1385),
    [sym__external_open_bracket2] = ACTIONS(1385),
  },
  [721] = {
    [sym_identifier] = ACTIONS(1331),
    [anon_sym_BSLASH] = ACTIONS(1333),
    [anon_sym_function] = ACTIONS(1331),
    [anon_sym_EQ] = ACTIONS(1397),
    [anon_sym_if] = ACTIONS(1331),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_while] = ACTIONS(1331),
    [anon_sym_repeat] = ACTIONS(1331),
    [anon_sym_QMARK] = ACTIONS(1333),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_LT_DASH] = ACTIONS(1333),
    [anon_sym_LT_LT_DASH] = ACTIONS(1333),
    [anon_sym_COLON_EQ] = ACTIONS(1333),
    [anon_sym_DASH_GT] = ACTIONS(1331),
    [anon_sym_DASH_GT_GT] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1331),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1333),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_GT_EQ] = ACTIONS(1333),
    [anon_sym_EQ_EQ] = ACTIONS(1333),
    [anon_sym_BANG_EQ] = ACTIONS(1333),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_SLASH] = ACTIONS(1333),
    [anon_sym_STAR_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1333),
    [aux_sym_binary_operator_token1] = ACTIONS(1333),
    [anon_sym_PIPE_GT] = ACTIONS(1333),
    [anon_sym_COLON] = ACTIONS(1331),
    [anon_sym_DOLLAR] = ACTIONS(1333),
    [anon_sym_AT] = ACTIONS(1333),
    [anon_sym_COLON_COLON] = ACTIONS(1335),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1337),
    [sym__hex_literal] = ACTIONS(1333),
    [sym__number_literal] = ACTIONS(1331),
    [anon_sym_SQUOTE] = ACTIONS(1333),
    [anon_sym_DQUOTE] = ACTIONS(1333),
    [sym_return] = ACTIONS(1331),
    [sym_next] = ACTIONS(1331),
    [sym_break] = ACTIONS(1331),
    [sym_true] = ACTIONS(1331),
    [sym_false] = ACTIONS(1331),
    [sym_null] = ACTIONS(1331),
    [sym_inf] = ACTIONS(1331),
    [sym_nan] = ACTIONS(1331),
    [anon_sym_NA] = ACTIONS(1331),
    [anon_sym_NA_integer_] = ACTIONS(1331),
    [anon_sym_NA_real_] = ACTIONS(1331),
    [anon_sym_NA_complex_] = ACTIONS(1331),
    [anon_sym_NA_character_] = ACTIONS(1331),
    [sym_dots] = ACTIONS(1331),
    [sym_dot_dot_i] = ACTIONS(1333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1333),
    [sym__newline] = ACTIONS(1333),
    [sym__raw_string_literal] = ACTIONS(1333),
    [sym__external_open_parenthesis] = ACTIONS(1333),
    [sym__external_close_parenthesis] = ACTIONS(1333),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_open_bracket] = ACTIONS(1333),
    [sym__external_open_bracket2] = ACTIONS(1333),
  },
  [722] = {
    [sym_identifier] = ACTIONS(1339),
    [anon_sym_BSLASH] = ACTIONS(1341),
    [anon_sym_function] = ACTIONS(1339),
    [anon_sym_EQ] = ACTIONS(1339),
    [anon_sym_if] = ACTIONS(1339),
    [anon_sym_for] = ACTIONS(1339),
    [anon_sym_while] = ACTIONS(1339),
    [anon_sym_repeat] = ACTIONS(1339),
    [anon_sym_QMARK] = ACTIONS(1341),
    [anon_sym_TILDE] = ACTIONS(1341),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_LT_DASH] = ACTIONS(1341),
    [anon_sym_LT_LT_DASH] = ACTIONS(1341),
    [anon_sym_COLON_EQ] = ACTIONS(1341),
    [anon_sym_DASH_GT] = ACTIONS(1339),
    [anon_sym_DASH_GT_GT] = ACTIONS(1341),
    [anon_sym_PIPE] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_PIPE_PIPE] = ACTIONS(1341),
    [anon_sym_AMP_AMP] = ACTIONS(1341),
    [anon_sym_LT] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1341),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_GT_EQ] = ACTIONS(1341),
    [anon_sym_EQ_EQ] = ACTIONS(1341),
    [anon_sym_BANG_EQ] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_SLASH] = ACTIONS(1341),
    [anon_sym_STAR_STAR] = ACTIONS(1341),
    [anon_sym_CARET] = ACTIONS(1341),
    [aux_sym_binary_operator_token1] = ACTIONS(1341),
    [anon_sym_PIPE_GT] = ACTIONS(1341),
    [anon_sym_COLON] = ACTIONS(1339),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1341),
    [anon_sym_L] = ACTIONS(1399),
    [anon_sym_i] = ACTIONS(1401),
    [sym__hex_literal] = ACTIONS(1341),
    [sym__number_literal] = ACTIONS(1339),
    [anon_sym_SQUOTE] = ACTIONS(1341),
    [anon_sym_DQUOTE] = ACTIONS(1341),
    [sym_return] = ACTIONS(1339),
    [sym_next] = ACTIONS(1339),
    [sym_break] = ACTIONS(1339),
    [sym_true] = ACTIONS(1339),
    [sym_false] = ACTIONS(1339),
    [sym_null] = ACTIONS(1339),
    [sym_inf] = ACTIONS(1339),
    [sym_nan] = ACTIONS(1339),
    [anon_sym_NA] = ACTIONS(1339),
    [anon_sym_NA_integer_] = ACTIONS(1339),
    [anon_sym_NA_real_] = ACTIONS(1339),
    [anon_sym_NA_complex_] = ACTIONS(1339),
    [anon_sym_NA_character_] = ACTIONS(1339),
    [sym_dots] = ACTIONS(1339),
    [sym_dot_dot_i] = ACTIONS(1341),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1341),
    [sym__newline] = ACTIONS(1341),
    [sym__raw_string_literal] = ACTIONS(1341),
    [sym__external_open_parenthesis] = ACTIONS(1341),
    [sym__external_close_parenthesis] = ACTIONS(1341),
    [sym__external_open_brace] = ACTIONS(1341),
    [sym__external_open_bracket] = ACTIONS(1341),
    [sym__external_open_bracket2] = ACTIONS(1341),
  },
  [723] = {
    [aux_sym_function_definition_repeat1] = STATE(723),
    [sym_identifier] = ACTIONS(1383),
    [anon_sym_BSLASH] = ACTIONS(1385),
    [anon_sym_function] = ACTIONS(1383),
    [anon_sym_EQ] = ACTIONS(1383),
    [anon_sym_if] = ACTIONS(1383),
    [anon_sym_for] = ACTIONS(1383),
    [anon_sym_while] = ACTIONS(1383),
    [anon_sym_repeat] = ACTIONS(1383),
    [anon_sym_QMARK] = ACTIONS(1385),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1383),
    [anon_sym_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_COLON_EQ] = ACTIONS(1385),
    [anon_sym_DASH_GT] = ACTIONS(1383),
    [anon_sym_DASH_GT_GT] = ACTIONS(1385),
    [anon_sym_PIPE] = ACTIONS(1383),
    [anon_sym_AMP] = ACTIONS(1383),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1383),
    [anon_sym_LT_EQ] = ACTIONS(1385),
    [anon_sym_GT] = ACTIONS(1383),
    [anon_sym_GT_EQ] = ACTIONS(1385),
    [anon_sym_EQ_EQ] = ACTIONS(1385),
    [anon_sym_BANG_EQ] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_SLASH] = ACTIONS(1385),
    [anon_sym_STAR_STAR] = ACTIONS(1385),
    [anon_sym_CARET] = ACTIONS(1385),
    [aux_sym_binary_operator_token1] = ACTIONS(1385),
    [anon_sym_PIPE_GT] = ACTIONS(1385),
    [anon_sym_COLON] = ACTIONS(1383),
    [anon_sym_DOLLAR] = ACTIONS(1385),
    [anon_sym_AT] = ACTIONS(1385),
    [sym__hex_literal] = ACTIONS(1385),
    [sym__number_literal] = ACTIONS(1383),
    [anon_sym_SQUOTE] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [sym_return] = ACTIONS(1383),
    [sym_next] = ACTIONS(1383),
    [sym_break] = ACTIONS(1383),
    [sym_true] = ACTIONS(1383),
    [sym_false] = ACTIONS(1383),
    [sym_null] = ACTIONS(1383),
    [sym_inf] = ACTIONS(1383),
    [sym_nan] = ACTIONS(1383),
    [anon_sym_NA] = ACTIONS(1383),
    [anon_sym_NA_integer_] = ACTIONS(1383),
    [anon_sym_NA_real_] = ACTIONS(1383),
    [anon_sym_NA_complex_] = ACTIONS(1383),
    [anon_sym_NA_character_] = ACTIONS(1383),
    [sym_dots] = ACTIONS(1383),
    [sym_dot_dot_i] = ACTIONS(1385),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1403),
    [sym__semicolon] = ACTIONS(1385),
    [sym__raw_string_literal] = ACTIONS(1385),
    [sym__external_else] = ACTIONS(1385),
    [sym__external_open_parenthesis] = ACTIONS(1385),
    [sym__external_open_brace] = ACTIONS(1385),
    [sym__external_close_brace] = ACTIONS(1385),
    [sym__external_open_bracket] = ACTIONS(1385),
    [sym__external_open_bracket2] = ACTIONS(1385),
  },
  [724] = {
    [sym_identifier] = ACTIONS(1331),
    [anon_sym_BSLASH] = ACTIONS(1333),
    [anon_sym_function] = ACTIONS(1331),
    [anon_sym_EQ] = ACTIONS(1406),
    [anon_sym_if] = ACTIONS(1331),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_while] = ACTIONS(1331),
    [anon_sym_repeat] = ACTIONS(1331),
    [anon_sym_QMARK] = ACTIONS(1333),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_LT_DASH] = ACTIONS(1333),
    [anon_sym_LT_LT_DASH] = ACTIONS(1333),
    [anon_sym_COLON_EQ] = ACTIONS(1333),
    [anon_sym_DASH_GT] = ACTIONS(1331),
    [anon_sym_DASH_GT_GT] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1331),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1333),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_GT_EQ] = ACTIONS(1333),
    [anon_sym_EQ_EQ] = ACTIONS(1333),
    [anon_sym_BANG_EQ] = ACTIONS(1333),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_SLASH] = ACTIONS(1333),
    [anon_sym_STAR_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1333),
    [aux_sym_binary_operator_token1] = ACTIONS(1333),
    [anon_sym_PIPE_GT] = ACTIONS(1333),
    [anon_sym_COLON] = ACTIONS(1331),
    [anon_sym_DOLLAR] = ACTIONS(1333),
    [anon_sym_AT] = ACTIONS(1333),
    [anon_sym_COLON_COLON] = ACTIONS(1335),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1337),
    [sym__hex_literal] = ACTIONS(1333),
    [sym__number_literal] = ACTIONS(1331),
    [anon_sym_SQUOTE] = ACTIONS(1333),
    [anon_sym_DQUOTE] = ACTIONS(1333),
    [sym_return] = ACTIONS(1331),
    [sym_next] = ACTIONS(1331),
    [sym_break] = ACTIONS(1331),
    [sym_true] = ACTIONS(1331),
    [sym_false] = ACTIONS(1331),
    [sym_null] = ACTIONS(1331),
    [sym_inf] = ACTIONS(1331),
    [sym_nan] = ACTIONS(1331),
    [anon_sym_NA] = ACTIONS(1331),
    [anon_sym_NA_integer_] = ACTIONS(1331),
    [anon_sym_NA_real_] = ACTIONS(1331),
    [anon_sym_NA_complex_] = ACTIONS(1331),
    [anon_sym_NA_character_] = ACTIONS(1331),
    [sym_dots] = ACTIONS(1331),
    [sym_dot_dot_i] = ACTIONS(1333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1333),
    [sym__newline] = ACTIONS(1333),
    [sym__raw_string_literal] = ACTIONS(1333),
    [sym__external_open_parenthesis] = ACTIONS(1333),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_open_bracket] = ACTIONS(1333),
    [sym__external_open_bracket2] = ACTIONS(1333),
    [sym__external_close_bracket2] = ACTIONS(1333),
  },
  [725] = {
    [sym_identifier] = ACTIONS(1347),
    [anon_sym_BSLASH] = ACTIONS(1349),
    [anon_sym_function] = ACTIONS(1347),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_if] = ACTIONS(1347),
    [anon_sym_for] = ACTIONS(1347),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1347),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1347),
    [anon_sym_LT_DASH] = ACTIONS(1349),
    [anon_sym_LT_LT_DASH] = ACTIONS(1349),
    [anon_sym_COLON_EQ] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1347),
    [anon_sym_DASH_GT_GT] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1347),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_GT_EQ] = ACTIONS(1349),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_SLASH] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [aux_sym_binary_operator_token1] = ACTIONS(1349),
    [anon_sym_PIPE_GT] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(1347),
    [anon_sym_DOLLAR] = ACTIONS(1349),
    [anon_sym_AT] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1347),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1349),
    [sym__hex_literal] = ACTIONS(1349),
    [sym__number_literal] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1349),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [sym_return] = ACTIONS(1347),
    [sym_next] = ACTIONS(1347),
    [sym_break] = ACTIONS(1347),
    [sym_true] = ACTIONS(1347),
    [sym_false] = ACTIONS(1347),
    [sym_null] = ACTIONS(1347),
    [sym_inf] = ACTIONS(1347),
    [sym_nan] = ACTIONS(1347),
    [anon_sym_NA] = ACTIONS(1347),
    [anon_sym_NA_integer_] = ACTIONS(1347),
    [anon_sym_NA_real_] = ACTIONS(1347),
    [anon_sym_NA_complex_] = ACTIONS(1347),
    [anon_sym_NA_character_] = ACTIONS(1347),
    [sym_dots] = ACTIONS(1347),
    [sym_dot_dot_i] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1349),
    [sym__newline] = ACTIONS(1349),
    [sym__raw_string_literal] = ACTIONS(1349),
    [sym__external_open_parenthesis] = ACTIONS(1349),
    [sym__external_open_brace] = ACTIONS(1349),
    [sym__external_open_bracket] = ACTIONS(1349),
    [sym__external_open_bracket2] = ACTIONS(1349),
    [sym__external_close_bracket2] = ACTIONS(1349),
  },
  [726] = {
    [sym_identifier] = ACTIONS(1331),
    [anon_sym_BSLASH] = ACTIONS(1333),
    [anon_sym_function] = ACTIONS(1331),
    [anon_sym_EQ] = ACTIONS(1331),
    [anon_sym_if] = ACTIONS(1331),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_while] = ACTIONS(1331),
    [anon_sym_repeat] = ACTIONS(1331),
    [anon_sym_QMARK] = ACTIONS(1333),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_LT_DASH] = ACTIONS(1333),
    [anon_sym_LT_LT_DASH] = ACTIONS(1333),
    [anon_sym_COLON_EQ] = ACTIONS(1333),
    [anon_sym_DASH_GT] = ACTIONS(1331),
    [anon_sym_DASH_GT_GT] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1331),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1333),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_GT_EQ] = ACTIONS(1333),
    [anon_sym_EQ_EQ] = ACTIONS(1333),
    [anon_sym_BANG_EQ] = ACTIONS(1333),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_SLASH] = ACTIONS(1333),
    [anon_sym_STAR_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1333),
    [aux_sym_binary_operator_token1] = ACTIONS(1333),
    [anon_sym_PIPE_GT] = ACTIONS(1333),
    [anon_sym_COLON] = ACTIONS(1331),
    [anon_sym_DOLLAR] = ACTIONS(1333),
    [anon_sym_AT] = ACTIONS(1333),
    [anon_sym_COLON_COLON] = ACTIONS(1335),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1337),
    [sym__hex_literal] = ACTIONS(1333),
    [sym__number_literal] = ACTIONS(1331),
    [anon_sym_SQUOTE] = ACTIONS(1333),
    [anon_sym_DQUOTE] = ACTIONS(1333),
    [sym_return] = ACTIONS(1331),
    [sym_next] = ACTIONS(1331),
    [sym_break] = ACTIONS(1331),
    [sym_true] = ACTIONS(1331),
    [sym_false] = ACTIONS(1331),
    [sym_null] = ACTIONS(1331),
    [sym_inf] = ACTIONS(1331),
    [sym_nan] = ACTIONS(1331),
    [anon_sym_NA] = ACTIONS(1331),
    [anon_sym_NA_integer_] = ACTIONS(1331),
    [anon_sym_NA_real_] = ACTIONS(1331),
    [anon_sym_NA_complex_] = ACTIONS(1331),
    [anon_sym_NA_character_] = ACTIONS(1331),
    [sym_dots] = ACTIONS(1331),
    [sym_dot_dot_i] = ACTIONS(1333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1333),
    [sym__newline] = ACTIONS(1333),
    [sym__raw_string_literal] = ACTIONS(1333),
    [sym__external_open_parenthesis] = ACTIONS(1333),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_open_bracket] = ACTIONS(1333),
    [sym__external_open_bracket2] = ACTIONS(1333),
    [sym__external_close_bracket2] = ACTIONS(1333),
  },
  [727] = {
    [sym_identifier] = ACTIONS(1351),
    [anon_sym_BSLASH] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [anon_sym_repeat] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_PLUS] = ACTIONS(1353),
    [anon_sym_DASH] = ACTIONS(1351),
    [anon_sym_LT_DASH] = ACTIONS(1353),
    [anon_sym_LT_LT_DASH] = ACTIONS(1353),
    [anon_sym_COLON_EQ] = ACTIONS(1353),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_DASH_GT_GT] = ACTIONS(1353),
    [anon_sym_PIPE] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PIPE_PIPE] = ACTIONS(1353),
    [anon_sym_AMP_AMP] = ACTIONS(1353),
    [anon_sym_LT] = ACTIONS(1351),
    [anon_sym_LT_EQ] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(1351),
    [anon_sym_GT_EQ] = ACTIONS(1353),
    [anon_sym_EQ_EQ] = ACTIONS(1353),
    [anon_sym_BANG_EQ] = ACTIONS(1353),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_SLASH] = ACTIONS(1353),
    [anon_sym_STAR_STAR] = ACTIONS(1353),
    [anon_sym_CARET] = ACTIONS(1353),
    [aux_sym_binary_operator_token1] = ACTIONS(1353),
    [anon_sym_PIPE_GT] = ACTIONS(1353),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_DOLLAR] = ACTIONS(1353),
    [anon_sym_AT] = ACTIONS(1353),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1353),
    [sym__hex_literal] = ACTIONS(1353),
    [sym__number_literal] = ACTIONS(1351),
    [anon_sym_SQUOTE] = ACTIONS(1353),
    [anon_sym_DQUOTE] = ACTIONS(1353),
    [sym_return] = ACTIONS(1351),
    [sym_next] = ACTIONS(1351),
    [sym_break] = ACTIONS(1351),
    [sym_true] = ACTIONS(1351),
    [sym_false] = ACTIONS(1351),
    [sym_null] = ACTIONS(1351),
    [sym_inf] = ACTIONS(1351),
    [sym_nan] = ACTIONS(1351),
    [anon_sym_NA] = ACTIONS(1351),
    [anon_sym_NA_integer_] = ACTIONS(1351),
    [anon_sym_NA_real_] = ACTIONS(1351),
    [anon_sym_NA_complex_] = ACTIONS(1351),
    [anon_sym_NA_character_] = ACTIONS(1351),
    [sym_dots] = ACTIONS(1351),
    [sym_dot_dot_i] = ACTIONS(1353),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1353),
    [sym__newline] = ACTIONS(1353),
    [sym__raw_string_literal] = ACTIONS(1353),
    [sym__external_open_parenthesis] = ACTIONS(1353),
    [sym__external_close_parenthesis] = ACTIONS(1353),
    [sym__external_open_brace] = ACTIONS(1353),
    [sym__external_open_bracket] = ACTIONS(1353),
    [sym__external_open_bracket2] = ACTIONS(1353),
  },
  [728] = {
    [sym_identifier] = ACTIONS(1331),
    [anon_sym_BSLASH] = ACTIONS(1333),
    [anon_sym_function] = ACTIONS(1331),
    [anon_sym_EQ] = ACTIONS(1408),
    [anon_sym_if] = ACTIONS(1331),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_while] = ACTIONS(1331),
    [anon_sym_repeat] = ACTIONS(1331),
    [anon_sym_QMARK] = ACTIONS(1333),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_LT_DASH] = ACTIONS(1333),
    [anon_sym_LT_LT_DASH] = ACTIONS(1333),
    [anon_sym_COLON_EQ] = ACTIONS(1333),
    [anon_sym_DASH_GT] = ACTIONS(1331),
    [anon_sym_DASH_GT_GT] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1331),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1333),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_GT_EQ] = ACTIONS(1333),
    [anon_sym_EQ_EQ] = ACTIONS(1333),
    [anon_sym_BANG_EQ] = ACTIONS(1333),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_SLASH] = ACTIONS(1333),
    [anon_sym_STAR_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1333),
    [aux_sym_binary_operator_token1] = ACTIONS(1333),
    [anon_sym_PIPE_GT] = ACTIONS(1333),
    [anon_sym_COLON] = ACTIONS(1331),
    [anon_sym_DOLLAR] = ACTIONS(1333),
    [anon_sym_AT] = ACTIONS(1333),
    [anon_sym_COLON_COLON] = ACTIONS(1335),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1337),
    [sym__hex_literal] = ACTIONS(1333),
    [sym__number_literal] = ACTIONS(1331),
    [anon_sym_SQUOTE] = ACTIONS(1333),
    [anon_sym_DQUOTE] = ACTIONS(1333),
    [sym_return] = ACTIONS(1331),
    [sym_next] = ACTIONS(1331),
    [sym_break] = ACTIONS(1331),
    [sym_true] = ACTIONS(1331),
    [sym_false] = ACTIONS(1331),
    [sym_null] = ACTIONS(1331),
    [sym_inf] = ACTIONS(1331),
    [sym_nan] = ACTIONS(1331),
    [anon_sym_NA] = ACTIONS(1331),
    [anon_sym_NA_integer_] = ACTIONS(1331),
    [anon_sym_NA_real_] = ACTIONS(1331),
    [anon_sym_NA_complex_] = ACTIONS(1331),
    [anon_sym_NA_character_] = ACTIONS(1331),
    [sym_dots] = ACTIONS(1331),
    [sym_dot_dot_i] = ACTIONS(1333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1333),
    [sym__newline] = ACTIONS(1333),
    [sym__raw_string_literal] = ACTIONS(1333),
    [sym__external_open_parenthesis] = ACTIONS(1333),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_open_bracket] = ACTIONS(1333),
    [sym__external_close_bracket] = ACTIONS(1333),
    [sym__external_open_bracket2] = ACTIONS(1333),
  },
  [729] = {
    [ts_builtin_sym_end] = ACTIONS(1355),
    [sym_identifier] = ACTIONS(1357),
    [anon_sym_BSLASH] = ACTIONS(1355),
    [anon_sym_function] = ACTIONS(1357),
    [anon_sym_EQ] = ACTIONS(1357),
    [anon_sym_if] = ACTIONS(1357),
    [anon_sym_for] = ACTIONS(1357),
    [anon_sym_while] = ACTIONS(1357),
    [anon_sym_repeat] = ACTIONS(1357),
    [anon_sym_QMARK] = ACTIONS(1355),
    [anon_sym_TILDE] = ACTIONS(1355),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1357),
    [anon_sym_LT_DASH] = ACTIONS(1355),
    [anon_sym_LT_LT_DASH] = ACTIONS(1355),
    [anon_sym_COLON_EQ] = ACTIONS(1355),
    [anon_sym_DASH_GT] = ACTIONS(1357),
    [anon_sym_DASH_GT_GT] = ACTIONS(1355),
    [anon_sym_PIPE] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_AMP_AMP] = ACTIONS(1355),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_LT_EQ] = ACTIONS(1355),
    [anon_sym_GT] = ACTIONS(1357),
    [anon_sym_GT_EQ] = ACTIONS(1355),
    [anon_sym_EQ_EQ] = ACTIONS(1355),
    [anon_sym_BANG_EQ] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1357),
    [anon_sym_SLASH] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1355),
    [anon_sym_CARET] = ACTIONS(1355),
    [aux_sym_binary_operator_token1] = ACTIONS(1355),
    [anon_sym_PIPE_GT] = ACTIONS(1355),
    [anon_sym_COLON] = ACTIONS(1357),
    [anon_sym_DOLLAR] = ACTIONS(1355),
    [anon_sym_AT] = ACTIONS(1355),
    [anon_sym_COLON_COLON] = ACTIONS(1357),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1355),
    [sym__hex_literal] = ACTIONS(1355),
    [sym__number_literal] = ACTIONS(1357),
    [anon_sym_SQUOTE] = ACTIONS(1355),
    [anon_sym_DQUOTE] = ACTIONS(1355),
    [sym_return] = ACTIONS(1357),
    [sym_next] = ACTIONS(1357),
    [sym_break] = ACTIONS(1357),
    [sym_true] = ACTIONS(1357),
    [sym_false] = ACTIONS(1357),
    [sym_null] = ACTIONS(1357),
    [sym_inf] = ACTIONS(1357),
    [sym_nan] = ACTIONS(1357),
    [anon_sym_NA] = ACTIONS(1357),
    [anon_sym_NA_integer_] = ACTIONS(1357),
    [anon_sym_NA_real_] = ACTIONS(1357),
    [anon_sym_NA_complex_] = ACTIONS(1357),
    [anon_sym_NA_character_] = ACTIONS(1357),
    [sym_dots] = ACTIONS(1357),
    [sym_dot_dot_i] = ACTIONS(1355),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1355),
    [sym__semicolon] = ACTIONS(1355),
    [sym__raw_string_literal] = ACTIONS(1355),
    [sym__external_open_parenthesis] = ACTIONS(1355),
    [sym__external_open_brace] = ACTIONS(1355),
    [sym__external_open_bracket] = ACTIONS(1355),
    [sym__external_open_bracket2] = ACTIONS(1355),
  },
  [730] = {
    [ts_builtin_sym_end] = ACTIONS(1359),
    [sym_identifier] = ACTIONS(1361),
    [anon_sym_BSLASH] = ACTIONS(1359),
    [anon_sym_function] = ACTIONS(1361),
    [anon_sym_EQ] = ACTIONS(1361),
    [anon_sym_if] = ACTIONS(1361),
    [anon_sym_for] = ACTIONS(1361),
    [anon_sym_while] = ACTIONS(1361),
    [anon_sym_repeat] = ACTIONS(1361),
    [anon_sym_QMARK] = ACTIONS(1359),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_BANG] = ACTIONS(1361),
    [anon_sym_PLUS] = ACTIONS(1359),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_LT_DASH] = ACTIONS(1359),
    [anon_sym_LT_LT_DASH] = ACTIONS(1359),
    [anon_sym_COLON_EQ] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [anon_sym_DASH_GT_GT] = ACTIONS(1359),
    [anon_sym_PIPE] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(1361),
    [anon_sym_PIPE_PIPE] = ACTIONS(1359),
    [anon_sym_AMP_AMP] = ACTIONS(1359),
    [anon_sym_LT] = ACTIONS(1361),
    [anon_sym_LT_EQ] = ACTIONS(1359),
    [anon_sym_GT] = ACTIONS(1361),
    [anon_sym_GT_EQ] = ACTIONS(1359),
    [anon_sym_EQ_EQ] = ACTIONS(1359),
    [anon_sym_BANG_EQ] = ACTIONS(1359),
    [anon_sym_STAR] = ACTIONS(1361),
    [anon_sym_SLASH] = ACTIONS(1359),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [aux_sym_binary_operator_token1] = ACTIONS(1359),
    [anon_sym_PIPE_GT] = ACTIONS(1359),
    [anon_sym_COLON] = ACTIONS(1361),
    [anon_sym_DOLLAR] = ACTIONS(1359),
    [anon_sym_AT] = ACTIONS(1359),
    [anon_sym_COLON_COLON] = ACTIONS(1361),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1359),
    [sym__hex_literal] = ACTIONS(1359),
    [sym__number_literal] = ACTIONS(1361),
    [anon_sym_SQUOTE] = ACTIONS(1359),
    [anon_sym_DQUOTE] = ACTIONS(1359),
    [sym_return] = ACTIONS(1361),
    [sym_next] = ACTIONS(1361),
    [sym_break] = ACTIONS(1361),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [sym_null] = ACTIONS(1361),
    [sym_inf] = ACTIONS(1361),
    [sym_nan] = ACTIONS(1361),
    [anon_sym_NA] = ACTIONS(1361),
    [anon_sym_NA_integer_] = ACTIONS(1361),
    [anon_sym_NA_real_] = ACTIONS(1361),
    [anon_sym_NA_complex_] = ACTIONS(1361),
    [anon_sym_NA_character_] = ACTIONS(1361),
    [sym_dots] = ACTIONS(1361),
    [sym_dot_dot_i] = ACTIONS(1359),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1359),
    [sym__semicolon] = ACTIONS(1359),
    [sym__raw_string_literal] = ACTIONS(1359),
    [sym__external_open_parenthesis] = ACTIONS(1359),
    [sym__external_open_brace] = ACTIONS(1359),
    [sym__external_open_bracket] = ACTIONS(1359),
    [sym__external_open_bracket2] = ACTIONS(1359),
  },
  [731] = {
    [aux_sym_function_definition_repeat1] = STATE(731),
    [sym_identifier] = ACTIONS(1383),
    [anon_sym_BSLASH] = ACTIONS(1385),
    [anon_sym_function] = ACTIONS(1383),
    [anon_sym_EQ] = ACTIONS(1383),
    [anon_sym_if] = ACTIONS(1383),
    [anon_sym_for] = ACTIONS(1383),
    [anon_sym_while] = ACTIONS(1383),
    [anon_sym_repeat] = ACTIONS(1383),
    [anon_sym_QMARK] = ACTIONS(1385),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1383),
    [anon_sym_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_COLON_EQ] = ACTIONS(1385),
    [anon_sym_DASH_GT] = ACTIONS(1383),
    [anon_sym_DASH_GT_GT] = ACTIONS(1385),
    [anon_sym_PIPE] = ACTIONS(1383),
    [anon_sym_AMP] = ACTIONS(1383),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1383),
    [anon_sym_LT_EQ] = ACTIONS(1385),
    [anon_sym_GT] = ACTIONS(1383),
    [anon_sym_GT_EQ] = ACTIONS(1385),
    [anon_sym_EQ_EQ] = ACTIONS(1385),
    [anon_sym_BANG_EQ] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_SLASH] = ACTIONS(1385),
    [anon_sym_STAR_STAR] = ACTIONS(1385),
    [anon_sym_CARET] = ACTIONS(1385),
    [aux_sym_binary_operator_token1] = ACTIONS(1385),
    [anon_sym_PIPE_GT] = ACTIONS(1385),
    [anon_sym_COLON] = ACTIONS(1383),
    [anon_sym_DOLLAR] = ACTIONS(1385),
    [anon_sym_AT] = ACTIONS(1385),
    [sym__hex_literal] = ACTIONS(1385),
    [sym__number_literal] = ACTIONS(1383),
    [anon_sym_SQUOTE] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [sym_return] = ACTIONS(1383),
    [sym_next] = ACTIONS(1383),
    [sym_break] = ACTIONS(1383),
    [sym_true] = ACTIONS(1383),
    [sym_false] = ACTIONS(1383),
    [sym_null] = ACTIONS(1383),
    [sym_inf] = ACTIONS(1383),
    [sym_nan] = ACTIONS(1383),
    [anon_sym_NA] = ACTIONS(1383),
    [anon_sym_NA_integer_] = ACTIONS(1383),
    [anon_sym_NA_real_] = ACTIONS(1383),
    [anon_sym_NA_complex_] = ACTIONS(1383),
    [anon_sym_NA_character_] = ACTIONS(1383),
    [sym_dots] = ACTIONS(1383),
    [sym_dot_dot_i] = ACTIONS(1385),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1385),
    [sym__newline] = ACTIONS(1410),
    [sym__raw_string_literal] = ACTIONS(1385),
    [sym__external_else] = ACTIONS(1385),
    [sym__external_open_parenthesis] = ACTIONS(1385),
    [sym__external_open_brace] = ACTIONS(1385),
    [sym__external_open_bracket] = ACTIONS(1385),
    [sym__external_close_bracket] = ACTIONS(1385),
    [sym__external_open_bracket2] = ACTIONS(1385),
  },
  [732] = {
    [aux_sym_function_definition_repeat1] = STATE(732),
    [sym_identifier] = ACTIONS(1383),
    [anon_sym_BSLASH] = ACTIONS(1385),
    [anon_sym_function] = ACTIONS(1383),
    [anon_sym_EQ] = ACTIONS(1383),
    [anon_sym_if] = ACTIONS(1383),
    [anon_sym_for] = ACTIONS(1383),
    [anon_sym_while] = ACTIONS(1383),
    [anon_sym_repeat] = ACTIONS(1383),
    [anon_sym_QMARK] = ACTIONS(1385),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1383),
    [anon_sym_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_COLON_EQ] = ACTIONS(1385),
    [anon_sym_DASH_GT] = ACTIONS(1383),
    [anon_sym_DASH_GT_GT] = ACTIONS(1385),
    [anon_sym_PIPE] = ACTIONS(1383),
    [anon_sym_AMP] = ACTIONS(1383),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1383),
    [anon_sym_LT_EQ] = ACTIONS(1385),
    [anon_sym_GT] = ACTIONS(1383),
    [anon_sym_GT_EQ] = ACTIONS(1385),
    [anon_sym_EQ_EQ] = ACTIONS(1385),
    [anon_sym_BANG_EQ] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_SLASH] = ACTIONS(1385),
    [anon_sym_STAR_STAR] = ACTIONS(1385),
    [anon_sym_CARET] = ACTIONS(1385),
    [aux_sym_binary_operator_token1] = ACTIONS(1385),
    [anon_sym_PIPE_GT] = ACTIONS(1385),
    [anon_sym_COLON] = ACTIONS(1383),
    [anon_sym_DOLLAR] = ACTIONS(1385),
    [anon_sym_AT] = ACTIONS(1385),
    [sym__hex_literal] = ACTIONS(1385),
    [sym__number_literal] = ACTIONS(1383),
    [anon_sym_SQUOTE] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [sym_return] = ACTIONS(1383),
    [sym_next] = ACTIONS(1383),
    [sym_break] = ACTIONS(1383),
    [sym_true] = ACTIONS(1383),
    [sym_false] = ACTIONS(1383),
    [sym_null] = ACTIONS(1383),
    [sym_inf] = ACTIONS(1383),
    [sym_nan] = ACTIONS(1383),
    [anon_sym_NA] = ACTIONS(1383),
    [anon_sym_NA_integer_] = ACTIONS(1383),
    [anon_sym_NA_real_] = ACTIONS(1383),
    [anon_sym_NA_complex_] = ACTIONS(1383),
    [anon_sym_NA_character_] = ACTIONS(1383),
    [sym_dots] = ACTIONS(1383),
    [sym_dot_dot_i] = ACTIONS(1385),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1385),
    [sym__newline] = ACTIONS(1413),
    [sym__raw_string_literal] = ACTIONS(1385),
    [sym__external_else] = ACTIONS(1385),
    [sym__external_open_parenthesis] = ACTIONS(1385),
    [sym__external_open_brace] = ACTIONS(1385),
    [sym__external_open_bracket] = ACTIONS(1385),
    [sym__external_open_bracket2] = ACTIONS(1385),
    [sym__external_close_bracket2] = ACTIONS(1385),
  },
  [733] = {
    [ts_builtin_sym_end] = ACTIONS(1353),
    [sym_identifier] = ACTIONS(1351),
    [anon_sym_BSLASH] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [anon_sym_repeat] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_PLUS] = ACTIONS(1353),
    [anon_sym_DASH] = ACTIONS(1351),
    [anon_sym_LT_DASH] = ACTIONS(1353),
    [anon_sym_LT_LT_DASH] = ACTIONS(1353),
    [anon_sym_COLON_EQ] = ACTIONS(1353),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_DASH_GT_GT] = ACTIONS(1353),
    [anon_sym_PIPE] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PIPE_PIPE] = ACTIONS(1353),
    [anon_sym_AMP_AMP] = ACTIONS(1353),
    [anon_sym_LT] = ACTIONS(1351),
    [anon_sym_LT_EQ] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(1351),
    [anon_sym_GT_EQ] = ACTIONS(1353),
    [anon_sym_EQ_EQ] = ACTIONS(1353),
    [anon_sym_BANG_EQ] = ACTIONS(1353),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_SLASH] = ACTIONS(1353),
    [anon_sym_STAR_STAR] = ACTIONS(1353),
    [anon_sym_CARET] = ACTIONS(1353),
    [aux_sym_binary_operator_token1] = ACTIONS(1353),
    [anon_sym_PIPE_GT] = ACTIONS(1353),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_DOLLAR] = ACTIONS(1353),
    [anon_sym_AT] = ACTIONS(1353),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1353),
    [sym__hex_literal] = ACTIONS(1353),
    [sym__number_literal] = ACTIONS(1351),
    [anon_sym_SQUOTE] = ACTIONS(1353),
    [anon_sym_DQUOTE] = ACTIONS(1353),
    [sym_return] = ACTIONS(1351),
    [sym_next] = ACTIONS(1351),
    [sym_break] = ACTIONS(1351),
    [sym_true] = ACTIONS(1351),
    [sym_false] = ACTIONS(1351),
    [sym_null] = ACTIONS(1351),
    [sym_inf] = ACTIONS(1351),
    [sym_nan] = ACTIONS(1351),
    [anon_sym_NA] = ACTIONS(1351),
    [anon_sym_NA_integer_] = ACTIONS(1351),
    [anon_sym_NA_real_] = ACTIONS(1351),
    [anon_sym_NA_complex_] = ACTIONS(1351),
    [anon_sym_NA_character_] = ACTIONS(1351),
    [sym_dots] = ACTIONS(1351),
    [sym_dot_dot_i] = ACTIONS(1353),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1353),
    [sym__semicolon] = ACTIONS(1353),
    [sym__raw_string_literal] = ACTIONS(1353),
    [sym__external_open_parenthesis] = ACTIONS(1353),
    [sym__external_open_brace] = ACTIONS(1353),
    [sym__external_open_bracket] = ACTIONS(1353),
    [sym__external_open_bracket2] = ACTIONS(1353),
  },
  [734] = {
    [sym_identifier] = ACTIONS(1339),
    [anon_sym_BSLASH] = ACTIONS(1341),
    [anon_sym_function] = ACTIONS(1339),
    [anon_sym_EQ] = ACTIONS(1339),
    [anon_sym_if] = ACTIONS(1339),
    [anon_sym_for] = ACTIONS(1339),
    [anon_sym_while] = ACTIONS(1339),
    [anon_sym_repeat] = ACTIONS(1339),
    [anon_sym_QMARK] = ACTIONS(1341),
    [anon_sym_TILDE] = ACTIONS(1341),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_LT_DASH] = ACTIONS(1341),
    [anon_sym_LT_LT_DASH] = ACTIONS(1341),
    [anon_sym_COLON_EQ] = ACTIONS(1341),
    [anon_sym_DASH_GT] = ACTIONS(1339),
    [anon_sym_DASH_GT_GT] = ACTIONS(1341),
    [anon_sym_PIPE] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_PIPE_PIPE] = ACTIONS(1341),
    [anon_sym_AMP_AMP] = ACTIONS(1341),
    [anon_sym_LT] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1341),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_GT_EQ] = ACTIONS(1341),
    [anon_sym_EQ_EQ] = ACTIONS(1341),
    [anon_sym_BANG_EQ] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_SLASH] = ACTIONS(1341),
    [anon_sym_STAR_STAR] = ACTIONS(1341),
    [anon_sym_CARET] = ACTIONS(1341),
    [aux_sym_binary_operator_token1] = ACTIONS(1341),
    [anon_sym_PIPE_GT] = ACTIONS(1341),
    [anon_sym_COLON] = ACTIONS(1339),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1341),
    [anon_sym_L] = ACTIONS(1416),
    [anon_sym_i] = ACTIONS(1418),
    [sym__hex_literal] = ACTIONS(1341),
    [sym__number_literal] = ACTIONS(1339),
    [anon_sym_SQUOTE] = ACTIONS(1341),
    [anon_sym_DQUOTE] = ACTIONS(1341),
    [sym_return] = ACTIONS(1339),
    [sym_next] = ACTIONS(1339),
    [sym_break] = ACTIONS(1339),
    [sym_true] = ACTIONS(1339),
    [sym_false] = ACTIONS(1339),
    [sym_null] = ACTIONS(1339),
    [sym_inf] = ACTIONS(1339),
    [sym_nan] = ACTIONS(1339),
    [anon_sym_NA] = ACTIONS(1339),
    [anon_sym_NA_integer_] = ACTIONS(1339),
    [anon_sym_NA_real_] = ACTIONS(1339),
    [anon_sym_NA_complex_] = ACTIONS(1339),
    [anon_sym_NA_character_] = ACTIONS(1339),
    [sym_dots] = ACTIONS(1339),
    [sym_dot_dot_i] = ACTIONS(1341),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1341),
    [sym__newline] = ACTIONS(1341),
    [sym__raw_string_literal] = ACTIONS(1341),
    [sym__external_open_parenthesis] = ACTIONS(1341),
    [sym__external_open_brace] = ACTIONS(1341),
    [sym__external_open_bracket] = ACTIONS(1341),
    [sym__external_close_bracket] = ACTIONS(1341),
    [sym__external_open_bracket2] = ACTIONS(1341),
  },
  [735] = {
    [sym_identifier] = ACTIONS(1347),
    [anon_sym_BSLASH] = ACTIONS(1349),
    [anon_sym_function] = ACTIONS(1347),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_if] = ACTIONS(1347),
    [anon_sym_for] = ACTIONS(1347),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1347),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1347),
    [anon_sym_LT_DASH] = ACTIONS(1349),
    [anon_sym_LT_LT_DASH] = ACTIONS(1349),
    [anon_sym_COLON_EQ] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1347),
    [anon_sym_DASH_GT_GT] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1347),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_GT_EQ] = ACTIONS(1349),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_SLASH] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [aux_sym_binary_operator_token1] = ACTIONS(1349),
    [anon_sym_PIPE_GT] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(1347),
    [anon_sym_DOLLAR] = ACTIONS(1349),
    [anon_sym_AT] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1347),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1349),
    [sym__hex_literal] = ACTIONS(1349),
    [sym__number_literal] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1349),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [sym_return] = ACTIONS(1347),
    [sym_next] = ACTIONS(1347),
    [sym_break] = ACTIONS(1347),
    [sym_true] = ACTIONS(1347),
    [sym_false] = ACTIONS(1347),
    [sym_null] = ACTIONS(1347),
    [sym_inf] = ACTIONS(1347),
    [sym_nan] = ACTIONS(1347),
    [anon_sym_NA] = ACTIONS(1347),
    [anon_sym_NA_integer_] = ACTIONS(1347),
    [anon_sym_NA_real_] = ACTIONS(1347),
    [anon_sym_NA_complex_] = ACTIONS(1347),
    [anon_sym_NA_character_] = ACTIONS(1347),
    [sym_dots] = ACTIONS(1347),
    [sym_dot_dot_i] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1349),
    [sym__newline] = ACTIONS(1349),
    [sym__raw_string_literal] = ACTIONS(1349),
    [sym__external_open_parenthesis] = ACTIONS(1349),
    [sym__external_open_brace] = ACTIONS(1349),
    [sym__external_open_bracket] = ACTIONS(1349),
    [sym__external_close_bracket] = ACTIONS(1349),
    [sym__external_open_bracket2] = ACTIONS(1349),
  },
  [736] = {
    [sym_identifier] = ACTIONS(1347),
    [anon_sym_BSLASH] = ACTIONS(1349),
    [anon_sym_function] = ACTIONS(1347),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_if] = ACTIONS(1347),
    [anon_sym_for] = ACTIONS(1347),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1347),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1347),
    [anon_sym_LT_DASH] = ACTIONS(1349),
    [anon_sym_LT_LT_DASH] = ACTIONS(1349),
    [anon_sym_COLON_EQ] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1347),
    [anon_sym_DASH_GT_GT] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1347),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_GT_EQ] = ACTIONS(1349),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_SLASH] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [aux_sym_binary_operator_token1] = ACTIONS(1349),
    [anon_sym_PIPE_GT] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(1347),
    [anon_sym_DOLLAR] = ACTIONS(1349),
    [anon_sym_AT] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1347),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1349),
    [sym__hex_literal] = ACTIONS(1349),
    [sym__number_literal] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1349),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [sym_return] = ACTIONS(1347),
    [sym_next] = ACTIONS(1347),
    [sym_break] = ACTIONS(1347),
    [sym_true] = ACTIONS(1347),
    [sym_false] = ACTIONS(1347),
    [sym_null] = ACTIONS(1347),
    [sym_inf] = ACTIONS(1347),
    [sym_nan] = ACTIONS(1347),
    [anon_sym_NA] = ACTIONS(1347),
    [anon_sym_NA_integer_] = ACTIONS(1347),
    [anon_sym_NA_real_] = ACTIONS(1347),
    [anon_sym_NA_complex_] = ACTIONS(1347),
    [anon_sym_NA_character_] = ACTIONS(1347),
    [sym_dots] = ACTIONS(1347),
    [sym_dot_dot_i] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1349),
    [sym__newline] = ACTIONS(1349),
    [sym__raw_string_literal] = ACTIONS(1349),
    [sym__external_open_parenthesis] = ACTIONS(1349),
    [sym__external_open_brace] = ACTIONS(1349),
    [sym__external_open_bracket] = ACTIONS(1349),
    [sym__external_close_bracket] = ACTIONS(1349),
    [sym__external_open_bracket2] = ACTIONS(1349),
  },
  [737] = {
    [sym_identifier] = ACTIONS(1357),
    [anon_sym_BSLASH] = ACTIONS(1355),
    [anon_sym_function] = ACTIONS(1357),
    [anon_sym_EQ] = ACTIONS(1357),
    [anon_sym_if] = ACTIONS(1357),
    [anon_sym_for] = ACTIONS(1357),
    [anon_sym_while] = ACTIONS(1357),
    [anon_sym_repeat] = ACTIONS(1357),
    [anon_sym_QMARK] = ACTIONS(1355),
    [anon_sym_TILDE] = ACTIONS(1355),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1357),
    [anon_sym_LT_DASH] = ACTIONS(1355),
    [anon_sym_LT_LT_DASH] = ACTIONS(1355),
    [anon_sym_COLON_EQ] = ACTIONS(1355),
    [anon_sym_DASH_GT] = ACTIONS(1357),
    [anon_sym_DASH_GT_GT] = ACTIONS(1355),
    [anon_sym_PIPE] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_AMP_AMP] = ACTIONS(1355),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_LT_EQ] = ACTIONS(1355),
    [anon_sym_GT] = ACTIONS(1357),
    [anon_sym_GT_EQ] = ACTIONS(1355),
    [anon_sym_EQ_EQ] = ACTIONS(1355),
    [anon_sym_BANG_EQ] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1357),
    [anon_sym_SLASH] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1355),
    [anon_sym_CARET] = ACTIONS(1355),
    [aux_sym_binary_operator_token1] = ACTIONS(1355),
    [anon_sym_PIPE_GT] = ACTIONS(1355),
    [anon_sym_COLON] = ACTIONS(1357),
    [anon_sym_DOLLAR] = ACTIONS(1355),
    [anon_sym_AT] = ACTIONS(1355),
    [anon_sym_COLON_COLON] = ACTIONS(1357),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1355),
    [sym__hex_literal] = ACTIONS(1355),
    [sym__number_literal] = ACTIONS(1357),
    [anon_sym_SQUOTE] = ACTIONS(1355),
    [anon_sym_DQUOTE] = ACTIONS(1355),
    [sym_return] = ACTIONS(1357),
    [sym_next] = ACTIONS(1357),
    [sym_break] = ACTIONS(1357),
    [sym_true] = ACTIONS(1357),
    [sym_false] = ACTIONS(1357),
    [sym_null] = ACTIONS(1357),
    [sym_inf] = ACTIONS(1357),
    [sym_nan] = ACTIONS(1357),
    [anon_sym_NA] = ACTIONS(1357),
    [anon_sym_NA_integer_] = ACTIONS(1357),
    [anon_sym_NA_real_] = ACTIONS(1357),
    [anon_sym_NA_complex_] = ACTIONS(1357),
    [anon_sym_NA_character_] = ACTIONS(1357),
    [sym_dots] = ACTIONS(1357),
    [sym_dot_dot_i] = ACTIONS(1355),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1355),
    [sym__newline] = ACTIONS(1355),
    [sym__raw_string_literal] = ACTIONS(1355),
    [sym__external_open_parenthesis] = ACTIONS(1355),
    [sym__external_open_brace] = ACTIONS(1355),
    [sym__external_open_bracket] = ACTIONS(1355),
    [sym__external_open_bracket2] = ACTIONS(1355),
    [sym__external_close_bracket2] = ACTIONS(1355),
  },
  [738] = {
    [ts_builtin_sym_end] = ACTIONS(1329),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_BSLASH] = ACTIONS(1329),
    [anon_sym_function] = ACTIONS(1327),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_repeat] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1329),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_LT_DASH] = ACTIONS(1329),
    [anon_sym_LT_LT_DASH] = ACTIONS(1329),
    [anon_sym_COLON_EQ] = ACTIONS(1329),
    [anon_sym_DASH_GT] = ACTIONS(1327),
    [anon_sym_DASH_GT_GT] = ACTIONS(1329),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1329),
    [anon_sym_AMP_AMP] = ACTIONS(1329),
    [anon_sym_LT] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1329),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1329),
    [anon_sym_EQ_EQ] = ACTIONS(1329),
    [anon_sym_BANG_EQ] = ACTIONS(1329),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_SLASH] = ACTIONS(1329),
    [anon_sym_STAR_STAR] = ACTIONS(1329),
    [anon_sym_CARET] = ACTIONS(1329),
    [aux_sym_binary_operator_token1] = ACTIONS(1329),
    [anon_sym_PIPE_GT] = ACTIONS(1329),
    [anon_sym_COLON] = ACTIONS(1327),
    [anon_sym_DOLLAR] = ACTIONS(1329),
    [anon_sym_AT] = ACTIONS(1329),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1329),
    [sym__hex_literal] = ACTIONS(1329),
    [sym__number_literal] = ACTIONS(1327),
    [anon_sym_SQUOTE] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(1329),
    [sym_return] = ACTIONS(1327),
    [sym_next] = ACTIONS(1327),
    [sym_break] = ACTIONS(1327),
    [sym_true] = ACTIONS(1327),
    [sym_false] = ACTIONS(1327),
    [sym_null] = ACTIONS(1327),
    [sym_inf] = ACTIONS(1327),
    [sym_nan] = ACTIONS(1327),
    [anon_sym_NA] = ACTIONS(1327),
    [anon_sym_NA_integer_] = ACTIONS(1327),
    [anon_sym_NA_real_] = ACTIONS(1327),
    [anon_sym_NA_complex_] = ACTIONS(1327),
    [anon_sym_NA_character_] = ACTIONS(1327),
    [sym_dots] = ACTIONS(1327),
    [sym_dot_dot_i] = ACTIONS(1329),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1329),
    [sym__semicolon] = ACTIONS(1329),
    [sym__raw_string_literal] = ACTIONS(1329),
    [sym__external_open_parenthesis] = ACTIONS(1329),
    [sym__external_open_brace] = ACTIONS(1329),
    [sym__external_open_bracket] = ACTIONS(1329),
    [sym__external_open_bracket2] = ACTIONS(1329),
  },
  [739] = {
    [sym_identifier] = ACTIONS(1331),
    [anon_sym_BSLASH] = ACTIONS(1333),
    [anon_sym_function] = ACTIONS(1331),
    [anon_sym_EQ] = ACTIONS(1331),
    [anon_sym_if] = ACTIONS(1331),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_while] = ACTIONS(1331),
    [anon_sym_repeat] = ACTIONS(1331),
    [anon_sym_QMARK] = ACTIONS(1333),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_LT_DASH] = ACTIONS(1333),
    [anon_sym_LT_LT_DASH] = ACTIONS(1333),
    [anon_sym_COLON_EQ] = ACTIONS(1333),
    [anon_sym_DASH_GT] = ACTIONS(1331),
    [anon_sym_DASH_GT_GT] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1331),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1333),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_GT_EQ] = ACTIONS(1333),
    [anon_sym_EQ_EQ] = ACTIONS(1333),
    [anon_sym_BANG_EQ] = ACTIONS(1333),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_SLASH] = ACTIONS(1333),
    [anon_sym_STAR_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1333),
    [aux_sym_binary_operator_token1] = ACTIONS(1333),
    [anon_sym_PIPE_GT] = ACTIONS(1333),
    [anon_sym_COLON] = ACTIONS(1331),
    [anon_sym_DOLLAR] = ACTIONS(1333),
    [anon_sym_AT] = ACTIONS(1333),
    [anon_sym_COLON_COLON] = ACTIONS(1335),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1337),
    [sym__hex_literal] = ACTIONS(1333),
    [sym__number_literal] = ACTIONS(1331),
    [anon_sym_SQUOTE] = ACTIONS(1333),
    [anon_sym_DQUOTE] = ACTIONS(1333),
    [sym_return] = ACTIONS(1331),
    [sym_next] = ACTIONS(1331),
    [sym_break] = ACTIONS(1331),
    [sym_true] = ACTIONS(1331),
    [sym_false] = ACTIONS(1331),
    [sym_null] = ACTIONS(1331),
    [sym_inf] = ACTIONS(1331),
    [sym_nan] = ACTIONS(1331),
    [anon_sym_NA] = ACTIONS(1331),
    [anon_sym_NA_integer_] = ACTIONS(1331),
    [anon_sym_NA_real_] = ACTIONS(1331),
    [anon_sym_NA_complex_] = ACTIONS(1331),
    [anon_sym_NA_character_] = ACTIONS(1331),
    [sym_dots] = ACTIONS(1331),
    [sym_dot_dot_i] = ACTIONS(1333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1333),
    [sym__newline] = ACTIONS(1333),
    [sym__raw_string_literal] = ACTIONS(1333),
    [sym__external_open_parenthesis] = ACTIONS(1333),
    [sym__external_close_parenthesis] = ACTIONS(1333),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_open_bracket] = ACTIONS(1333),
    [sym__external_open_bracket2] = ACTIONS(1333),
  },
  [740] = {
    [sym_identifier] = ACTIONS(1331),
    [anon_sym_BSLASH] = ACTIONS(1333),
    [anon_sym_function] = ACTIONS(1331),
    [anon_sym_EQ] = ACTIONS(1331),
    [anon_sym_if] = ACTIONS(1331),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_while] = ACTIONS(1331),
    [anon_sym_repeat] = ACTIONS(1331),
    [anon_sym_QMARK] = ACTIONS(1333),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_LT_DASH] = ACTIONS(1333),
    [anon_sym_LT_LT_DASH] = ACTIONS(1333),
    [anon_sym_COLON_EQ] = ACTIONS(1333),
    [anon_sym_DASH_GT] = ACTIONS(1331),
    [anon_sym_DASH_GT_GT] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1331),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1333),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_GT_EQ] = ACTIONS(1333),
    [anon_sym_EQ_EQ] = ACTIONS(1333),
    [anon_sym_BANG_EQ] = ACTIONS(1333),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_SLASH] = ACTIONS(1333),
    [anon_sym_STAR_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1333),
    [aux_sym_binary_operator_token1] = ACTIONS(1333),
    [anon_sym_PIPE_GT] = ACTIONS(1333),
    [anon_sym_COLON] = ACTIONS(1331),
    [anon_sym_DOLLAR] = ACTIONS(1333),
    [anon_sym_AT] = ACTIONS(1333),
    [anon_sym_COLON_COLON] = ACTIONS(1335),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1337),
    [sym__hex_literal] = ACTIONS(1333),
    [sym__number_literal] = ACTIONS(1331),
    [anon_sym_SQUOTE] = ACTIONS(1333),
    [anon_sym_DQUOTE] = ACTIONS(1333),
    [sym_return] = ACTIONS(1331),
    [sym_next] = ACTIONS(1331),
    [sym_break] = ACTIONS(1331),
    [sym_true] = ACTIONS(1331),
    [sym_false] = ACTIONS(1331),
    [sym_null] = ACTIONS(1331),
    [sym_inf] = ACTIONS(1331),
    [sym_nan] = ACTIONS(1331),
    [anon_sym_NA] = ACTIONS(1331),
    [anon_sym_NA_integer_] = ACTIONS(1331),
    [anon_sym_NA_real_] = ACTIONS(1331),
    [anon_sym_NA_complex_] = ACTIONS(1331),
    [anon_sym_NA_character_] = ACTIONS(1331),
    [sym_dots] = ACTIONS(1331),
    [sym_dot_dot_i] = ACTIONS(1333),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1333),
    [sym__semicolon] = ACTIONS(1333),
    [sym__raw_string_literal] = ACTIONS(1333),
    [sym__external_open_parenthesis] = ACTIONS(1333),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_close_brace] = ACTIONS(1333),
    [sym__external_open_bracket] = ACTIONS(1333),
    [sym__external_open_bracket2] = ACTIONS(1333),
  },
  [741] = {
    [sym_identifier] = ACTIONS(1339),
    [anon_sym_BSLASH] = ACTIONS(1341),
    [anon_sym_function] = ACTIONS(1339),
    [anon_sym_EQ] = ACTIONS(1339),
    [anon_sym_if] = ACTIONS(1339),
    [anon_sym_for] = ACTIONS(1339),
    [anon_sym_while] = ACTIONS(1339),
    [anon_sym_repeat] = ACTIONS(1339),
    [anon_sym_QMARK] = ACTIONS(1341),
    [anon_sym_TILDE] = ACTIONS(1341),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_LT_DASH] = ACTIONS(1341),
    [anon_sym_LT_LT_DASH] = ACTIONS(1341),
    [anon_sym_COLON_EQ] = ACTIONS(1341),
    [anon_sym_DASH_GT] = ACTIONS(1339),
    [anon_sym_DASH_GT_GT] = ACTIONS(1341),
    [anon_sym_PIPE] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_PIPE_PIPE] = ACTIONS(1341),
    [anon_sym_AMP_AMP] = ACTIONS(1341),
    [anon_sym_LT] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1341),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_GT_EQ] = ACTIONS(1341),
    [anon_sym_EQ_EQ] = ACTIONS(1341),
    [anon_sym_BANG_EQ] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_SLASH] = ACTIONS(1341),
    [anon_sym_STAR_STAR] = ACTIONS(1341),
    [anon_sym_CARET] = ACTIONS(1341),
    [aux_sym_binary_operator_token1] = ACTIONS(1341),
    [anon_sym_PIPE_GT] = ACTIONS(1341),
    [anon_sym_COLON] = ACTIONS(1339),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1341),
    [anon_sym_L] = ACTIONS(1420),
    [anon_sym_i] = ACTIONS(1422),
    [sym__hex_literal] = ACTIONS(1341),
    [sym__number_literal] = ACTIONS(1339),
    [anon_sym_SQUOTE] = ACTIONS(1341),
    [anon_sym_DQUOTE] = ACTIONS(1341),
    [sym_return] = ACTIONS(1339),
    [sym_next] = ACTIONS(1339),
    [sym_break] = ACTIONS(1339),
    [sym_true] = ACTIONS(1339),
    [sym_false] = ACTIONS(1339),
    [sym_null] = ACTIONS(1339),
    [sym_inf] = ACTIONS(1339),
    [sym_nan] = ACTIONS(1339),
    [anon_sym_NA] = ACTIONS(1339),
    [anon_sym_NA_integer_] = ACTIONS(1339),
    [anon_sym_NA_real_] = ACTIONS(1339),
    [anon_sym_NA_complex_] = ACTIONS(1339),
    [anon_sym_NA_character_] = ACTIONS(1339),
    [sym_dots] = ACTIONS(1339),
    [sym_dot_dot_i] = ACTIONS(1341),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1341),
    [sym__semicolon] = ACTIONS(1341),
    [sym__raw_string_literal] = ACTIONS(1341),
    [sym__external_open_parenthesis] = ACTIONS(1341),
    [sym__external_open_brace] = ACTIONS(1341),
    [sym__external_close_brace] = ACTIONS(1341),
    [sym__external_open_bracket] = ACTIONS(1341),
    [sym__external_open_bracket2] = ACTIONS(1341),
  },
  [742] = {
    [sym_identifier] = ACTIONS(1365),
    [anon_sym_BSLASH] = ACTIONS(1363),
    [anon_sym_function] = ACTIONS(1365),
    [anon_sym_EQ] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(1365),
    [anon_sym_for] = ACTIONS(1365),
    [anon_sym_while] = ACTIONS(1365),
    [anon_sym_repeat] = ACTIONS(1365),
    [anon_sym_QMARK] = ACTIONS(1363),
    [anon_sym_TILDE] = ACTIONS(1363),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_PLUS] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1365),
    [anon_sym_LT_DASH] = ACTIONS(1363),
    [anon_sym_LT_LT_DASH] = ACTIONS(1363),
    [anon_sym_COLON_EQ] = ACTIONS(1363),
    [anon_sym_DASH_GT] = ACTIONS(1365),
    [anon_sym_DASH_GT_GT] = ACTIONS(1363),
    [anon_sym_PIPE] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE_PIPE] = ACTIONS(1363),
    [anon_sym_AMP_AMP] = ACTIONS(1363),
    [anon_sym_LT] = ACTIONS(1365),
    [anon_sym_LT_EQ] = ACTIONS(1363),
    [anon_sym_GT] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1363),
    [anon_sym_EQ_EQ] = ACTIONS(1363),
    [anon_sym_BANG_EQ] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(1365),
    [anon_sym_SLASH] = ACTIONS(1363),
    [anon_sym_STAR_STAR] = ACTIONS(1363),
    [anon_sym_CARET] = ACTIONS(1363),
    [aux_sym_binary_operator_token1] = ACTIONS(1363),
    [anon_sym_PIPE_GT] = ACTIONS(1363),
    [anon_sym_COLON] = ACTIONS(1365),
    [anon_sym_DOLLAR] = ACTIONS(1363),
    [anon_sym_AT] = ACTIONS(1363),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1363),
    [sym__hex_literal] = ACTIONS(1363),
    [sym__number_literal] = ACTIONS(1365),
    [anon_sym_SQUOTE] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1363),
    [sym_return] = ACTIONS(1365),
    [sym_next] = ACTIONS(1365),
    [sym_break] = ACTIONS(1365),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [sym_null] = ACTIONS(1365),
    [sym_inf] = ACTIONS(1365),
    [sym_nan] = ACTIONS(1365),
    [anon_sym_NA] = ACTIONS(1365),
    [anon_sym_NA_integer_] = ACTIONS(1365),
    [anon_sym_NA_real_] = ACTIONS(1365),
    [anon_sym_NA_complex_] = ACTIONS(1365),
    [anon_sym_NA_character_] = ACTIONS(1365),
    [sym_dots] = ACTIONS(1365),
    [sym_dot_dot_i] = ACTIONS(1363),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1363),
    [sym__newline] = ACTIONS(1363),
    [sym__raw_string_literal] = ACTIONS(1363),
    [sym__external_open_parenthesis] = ACTIONS(1363),
    [sym__external_close_parenthesis] = ACTIONS(1363),
    [sym__external_open_brace] = ACTIONS(1363),
    [sym__external_open_bracket] = ACTIONS(1363),
    [sym__external_open_bracket2] = ACTIONS(1363),
  },
  [743] = {
    [sym_identifier] = ACTIONS(1347),
    [anon_sym_BSLASH] = ACTIONS(1349),
    [anon_sym_function] = ACTIONS(1347),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_if] = ACTIONS(1347),
    [anon_sym_for] = ACTIONS(1347),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1347),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1347),
    [anon_sym_LT_DASH] = ACTIONS(1349),
    [anon_sym_LT_LT_DASH] = ACTIONS(1349),
    [anon_sym_COLON_EQ] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1347),
    [anon_sym_DASH_GT_GT] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1347),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_GT_EQ] = ACTIONS(1349),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_SLASH] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [aux_sym_binary_operator_token1] = ACTIONS(1349),
    [anon_sym_PIPE_GT] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(1347),
    [anon_sym_DOLLAR] = ACTIONS(1349),
    [anon_sym_AT] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1347),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1349),
    [sym__hex_literal] = ACTIONS(1349),
    [sym__number_literal] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1349),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [sym_return] = ACTIONS(1347),
    [sym_next] = ACTIONS(1347),
    [sym_break] = ACTIONS(1347),
    [sym_true] = ACTIONS(1347),
    [sym_false] = ACTIONS(1347),
    [sym_null] = ACTIONS(1347),
    [sym_inf] = ACTIONS(1347),
    [sym_nan] = ACTIONS(1347),
    [anon_sym_NA] = ACTIONS(1347),
    [anon_sym_NA_integer_] = ACTIONS(1347),
    [anon_sym_NA_real_] = ACTIONS(1347),
    [anon_sym_NA_complex_] = ACTIONS(1347),
    [anon_sym_NA_character_] = ACTIONS(1347),
    [sym_dots] = ACTIONS(1347),
    [sym_dot_dot_i] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1349),
    [sym__semicolon] = ACTIONS(1349),
    [sym__raw_string_literal] = ACTIONS(1349),
    [sym__external_open_parenthesis] = ACTIONS(1349),
    [sym__external_open_brace] = ACTIONS(1349),
    [sym__external_close_brace] = ACTIONS(1349),
    [sym__external_open_bracket] = ACTIONS(1349),
    [sym__external_open_bracket2] = ACTIONS(1349),
  },
  [744] = {
    [ts_builtin_sym_end] = ACTIONS(1341),
    [sym_identifier] = ACTIONS(1339),
    [anon_sym_BSLASH] = ACTIONS(1341),
    [anon_sym_function] = ACTIONS(1339),
    [anon_sym_EQ] = ACTIONS(1339),
    [anon_sym_if] = ACTIONS(1339),
    [anon_sym_for] = ACTIONS(1339),
    [anon_sym_while] = ACTIONS(1339),
    [anon_sym_repeat] = ACTIONS(1339),
    [anon_sym_QMARK] = ACTIONS(1341),
    [anon_sym_TILDE] = ACTIONS(1341),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_LT_DASH] = ACTIONS(1341),
    [anon_sym_LT_LT_DASH] = ACTIONS(1341),
    [anon_sym_COLON_EQ] = ACTIONS(1341),
    [anon_sym_DASH_GT] = ACTIONS(1339),
    [anon_sym_DASH_GT_GT] = ACTIONS(1341),
    [anon_sym_PIPE] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_PIPE_PIPE] = ACTIONS(1341),
    [anon_sym_AMP_AMP] = ACTIONS(1341),
    [anon_sym_LT] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1341),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_GT_EQ] = ACTIONS(1341),
    [anon_sym_EQ_EQ] = ACTIONS(1341),
    [anon_sym_BANG_EQ] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_SLASH] = ACTIONS(1341),
    [anon_sym_STAR_STAR] = ACTIONS(1341),
    [anon_sym_CARET] = ACTIONS(1341),
    [aux_sym_binary_operator_token1] = ACTIONS(1341),
    [anon_sym_PIPE_GT] = ACTIONS(1341),
    [anon_sym_COLON] = ACTIONS(1339),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1341),
    [anon_sym_L] = ACTIONS(1424),
    [anon_sym_i] = ACTIONS(1426),
    [sym__hex_literal] = ACTIONS(1341),
    [sym__number_literal] = ACTIONS(1339),
    [anon_sym_SQUOTE] = ACTIONS(1341),
    [anon_sym_DQUOTE] = ACTIONS(1341),
    [sym_return] = ACTIONS(1339),
    [sym_next] = ACTIONS(1339),
    [sym_break] = ACTIONS(1339),
    [sym_true] = ACTIONS(1339),
    [sym_false] = ACTIONS(1339),
    [sym_null] = ACTIONS(1339),
    [sym_inf] = ACTIONS(1339),
    [sym_nan] = ACTIONS(1339),
    [anon_sym_NA] = ACTIONS(1339),
    [anon_sym_NA_integer_] = ACTIONS(1339),
    [anon_sym_NA_real_] = ACTIONS(1339),
    [anon_sym_NA_complex_] = ACTIONS(1339),
    [anon_sym_NA_character_] = ACTIONS(1339),
    [sym_dots] = ACTIONS(1339),
    [sym_dot_dot_i] = ACTIONS(1341),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1341),
    [sym__semicolon] = ACTIONS(1341),
    [sym__raw_string_literal] = ACTIONS(1341),
    [sym__external_open_parenthesis] = ACTIONS(1341),
    [sym__external_open_brace] = ACTIONS(1341),
    [sym__external_open_bracket] = ACTIONS(1341),
    [sym__external_open_bracket2] = ACTIONS(1341),
  },
  [745] = {
    [ts_builtin_sym_end] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1347),
    [anon_sym_BSLASH] = ACTIONS(1349),
    [anon_sym_function] = ACTIONS(1347),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_if] = ACTIONS(1347),
    [anon_sym_for] = ACTIONS(1347),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1347),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1347),
    [anon_sym_LT_DASH] = ACTIONS(1349),
    [anon_sym_LT_LT_DASH] = ACTIONS(1349),
    [anon_sym_COLON_EQ] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1347),
    [anon_sym_DASH_GT_GT] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1347),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_GT_EQ] = ACTIONS(1349),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_SLASH] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [aux_sym_binary_operator_token1] = ACTIONS(1349),
    [anon_sym_PIPE_GT] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(1347),
    [anon_sym_DOLLAR] = ACTIONS(1349),
    [anon_sym_AT] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1347),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1349),
    [sym__hex_literal] = ACTIONS(1349),
    [sym__number_literal] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1349),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [sym_return] = ACTIONS(1347),
    [sym_next] = ACTIONS(1347),
    [sym_break] = ACTIONS(1347),
    [sym_true] = ACTIONS(1347),
    [sym_false] = ACTIONS(1347),
    [sym_null] = ACTIONS(1347),
    [sym_inf] = ACTIONS(1347),
    [sym_nan] = ACTIONS(1347),
    [anon_sym_NA] = ACTIONS(1347),
    [anon_sym_NA_integer_] = ACTIONS(1347),
    [anon_sym_NA_real_] = ACTIONS(1347),
    [anon_sym_NA_complex_] = ACTIONS(1347),
    [anon_sym_NA_character_] = ACTIONS(1347),
    [sym_dots] = ACTIONS(1347),
    [sym_dot_dot_i] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1349),
    [sym__semicolon] = ACTIONS(1349),
    [sym__raw_string_literal] = ACTIONS(1349),
    [sym__external_open_parenthesis] = ACTIONS(1349),
    [sym__external_open_brace] = ACTIONS(1349),
    [sym__external_open_bracket] = ACTIONS(1349),
    [sym__external_open_bracket2] = ACTIONS(1349),
  },
  [746] = {
    [sym_identifier] = ACTIONS(1347),
    [anon_sym_BSLASH] = ACTIONS(1349),
    [anon_sym_function] = ACTIONS(1347),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_if] = ACTIONS(1347),
    [anon_sym_for] = ACTIONS(1347),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1347),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1347),
    [anon_sym_LT_DASH] = ACTIONS(1349),
    [anon_sym_LT_LT_DASH] = ACTIONS(1349),
    [anon_sym_COLON_EQ] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1347),
    [anon_sym_DASH_GT_GT] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1347),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_GT_EQ] = ACTIONS(1349),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_SLASH] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [aux_sym_binary_operator_token1] = ACTIONS(1349),
    [anon_sym_PIPE_GT] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(1347),
    [anon_sym_DOLLAR] = ACTIONS(1349),
    [anon_sym_AT] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1347),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1349),
    [sym__hex_literal] = ACTIONS(1349),
    [sym__number_literal] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1349),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [sym_return] = ACTIONS(1347),
    [sym_next] = ACTIONS(1347),
    [sym_break] = ACTIONS(1347),
    [sym_true] = ACTIONS(1347),
    [sym_false] = ACTIONS(1347),
    [sym_null] = ACTIONS(1347),
    [sym_inf] = ACTIONS(1347),
    [sym_nan] = ACTIONS(1347),
    [anon_sym_NA] = ACTIONS(1347),
    [anon_sym_NA_integer_] = ACTIONS(1347),
    [anon_sym_NA_real_] = ACTIONS(1347),
    [anon_sym_NA_complex_] = ACTIONS(1347),
    [anon_sym_NA_character_] = ACTIONS(1347),
    [sym_dots] = ACTIONS(1347),
    [sym_dot_dot_i] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1349),
    [sym__semicolon] = ACTIONS(1349),
    [sym__raw_string_literal] = ACTIONS(1349),
    [sym__external_open_parenthesis] = ACTIONS(1349),
    [sym__external_open_brace] = ACTIONS(1349),
    [sym__external_close_brace] = ACTIONS(1349),
    [sym__external_open_bracket] = ACTIONS(1349),
    [sym__external_open_bracket2] = ACTIONS(1349),
  },
  [747] = {
    [ts_builtin_sym_end] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1347),
    [anon_sym_BSLASH] = ACTIONS(1349),
    [anon_sym_function] = ACTIONS(1347),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_if] = ACTIONS(1347),
    [anon_sym_for] = ACTIONS(1347),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_repeat] = ACTIONS(1347),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1347),
    [anon_sym_LT_DASH] = ACTIONS(1349),
    [anon_sym_LT_LT_DASH] = ACTIONS(1349),
    [anon_sym_COLON_EQ] = ACTIONS(1349),
    [anon_sym_DASH_GT] = ACTIONS(1347),
    [anon_sym_DASH_GT_GT] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1347),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_GT_EQ] = ACTIONS(1349),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_SLASH] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [aux_sym_binary_operator_token1] = ACTIONS(1349),
    [anon_sym_PIPE_GT] = ACTIONS(1349),
    [anon_sym_COLON] = ACTIONS(1347),
    [anon_sym_DOLLAR] = ACTIONS(1349),
    [anon_sym_AT] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1347),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1349),
    [sym__hex_literal] = ACTIONS(1349),
    [sym__number_literal] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1349),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [sym_return] = ACTIONS(1347),
    [sym_next] = ACTIONS(1347),
    [sym_break] = ACTIONS(1347),
    [sym_true] = ACTIONS(1347),
    [sym_false] = ACTIONS(1347),
    [sym_null] = ACTIONS(1347),
    [sym_inf] = ACTIONS(1347),
    [sym_nan] = ACTIONS(1347),
    [anon_sym_NA] = ACTIONS(1347),
    [anon_sym_NA_integer_] = ACTIONS(1347),
    [anon_sym_NA_real_] = ACTIONS(1347),
    [anon_sym_NA_complex_] = ACTIONS(1347),
    [anon_sym_NA_character_] = ACTIONS(1347),
    [sym_dots] = ACTIONS(1347),
    [sym_dot_dot_i] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1349),
    [sym__semicolon] = ACTIONS(1349),
    [sym__raw_string_literal] = ACTIONS(1349),
    [sym__external_open_parenthesis] = ACTIONS(1349),
    [sym__external_open_brace] = ACTIONS(1349),
    [sym__external_open_bracket] = ACTIONS(1349),
    [sym__external_open_bracket2] = ACTIONS(1349),
  },
  [748] = {
    [sym_identifier] = ACTIONS(1361),
    [anon_sym_BSLASH] = ACTIONS(1359),
    [anon_sym_function] = ACTIONS(1361),
    [anon_sym_EQ] = ACTIONS(1361),
    [anon_sym_if] = ACTIONS(1361),
    [anon_sym_for] = ACTIONS(1361),
    [anon_sym_while] = ACTIONS(1361),
    [anon_sym_repeat] = ACTIONS(1361),
    [anon_sym_QMARK] = ACTIONS(1359),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_BANG] = ACTIONS(1361),
    [anon_sym_PLUS] = ACTIONS(1359),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_LT_DASH] = ACTIONS(1359),
    [anon_sym_LT_LT_DASH] = ACTIONS(1359),
    [anon_sym_COLON_EQ] = ACTIONS(1359),
    [anon_sym_DASH_GT] = ACTIONS(1361),
    [anon_sym_DASH_GT_GT] = ACTIONS(1359),
    [anon_sym_PIPE] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(1361),
    [anon_sym_PIPE_PIPE] = ACTIONS(1359),
    [anon_sym_AMP_AMP] = ACTIONS(1359),
    [anon_sym_LT] = ACTIONS(1361),
    [anon_sym_LT_EQ] = ACTIONS(1359),
    [anon_sym_GT] = ACTIONS(1361),
    [anon_sym_GT_EQ] = ACTIONS(1359),
    [anon_sym_EQ_EQ] = ACTIONS(1359),
    [anon_sym_BANG_EQ] = ACTIONS(1359),
    [anon_sym_STAR] = ACTIONS(1361),
    [anon_sym_SLASH] = ACTIONS(1359),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [aux_sym_binary_operator_token1] = ACTIONS(1359),
    [anon_sym_PIPE_GT] = ACTIONS(1359),
    [anon_sym_COLON] = ACTIONS(1361),
    [anon_sym_DOLLAR] = ACTIONS(1359),
    [anon_sym_AT] = ACTIONS(1359),
    [anon_sym_COLON_COLON] = ACTIONS(1361),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1359),
    [sym__hex_literal] = ACTIONS(1359),
    [sym__number_literal] = ACTIONS(1361),
    [anon_sym_SQUOTE] = ACTIONS(1359),
    [anon_sym_DQUOTE] = ACTIONS(1359),
    [sym_return] = ACTIONS(1361),
    [sym_next] = ACTIONS(1361),
    [sym_break] = ACTIONS(1361),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [sym_null] = ACTIONS(1361),
    [sym_inf] = ACTIONS(1361),
    [sym_nan] = ACTIONS(1361),
    [anon_sym_NA] = ACTIONS(1361),
    [anon_sym_NA_integer_] = ACTIONS(1361),
    [anon_sym_NA_real_] = ACTIONS(1361),
    [anon_sym_NA_complex_] = ACTIONS(1361),
    [anon_sym_NA_character_] = ACTIONS(1361),
    [sym_dots] = ACTIONS(1361),
    [sym_dot_dot_i] = ACTIONS(1359),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1359),
    [sym__newline] = ACTIONS(1359),
    [sym__raw_string_literal] = ACTIONS(1359),
    [sym__external_open_parenthesis] = ACTIONS(1359),
    [sym__external_open_brace] = ACTIONS(1359),
    [sym__external_open_bracket] = ACTIONS(1359),
    [sym__external_open_bracket2] = ACTIONS(1359),
    [sym__external_close_bracket2] = ACTIONS(1359),
  },
  [749] = {
    [sym_identifier] = ACTIONS(1351),
    [anon_sym_BSLASH] = ACTIONS(1353),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [anon_sym_repeat] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_PLUS] = ACTIONS(1353),
    [anon_sym_DASH] = ACTIONS(1351),
    [anon_sym_LT_DASH] = ACTIONS(1353),
    [anon_sym_LT_LT_DASH] = ACTIONS(1353),
    [anon_sym_COLON_EQ] = ACTIONS(1353),
    [anon_sym_DASH_GT] = ACTIONS(1351),
    [anon_sym_DASH_GT_GT] = ACTIONS(1353),
    [anon_sym_PIPE] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PIPE_PIPE] = ACTIONS(1353),
    [anon_sym_AMP_AMP] = ACTIONS(1353),
    [anon_sym_LT] = ACTIONS(1351),
    [anon_sym_LT_EQ] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(1351),
    [anon_sym_GT_EQ] = ACTIONS(1353),
    [anon_sym_EQ_EQ] = ACTIONS(1353),
    [anon_sym_BANG_EQ] = ACTIONS(1353),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_SLASH] = ACTIONS(1353),
    [anon_sym_STAR_STAR] = ACTIONS(1353),
    [anon_sym_CARET] = ACTIONS(1353),
    [aux_sym_binary_operator_token1] = ACTIONS(1353),
    [anon_sym_PIPE_GT] = ACTIONS(1353),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_DOLLAR] = ACTIONS(1353),
    [anon_sym_AT] = ACTIONS(1353),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1353),
    [sym__hex_literal] = ACTIONS(1353),
    [sym__number_literal] = ACTIONS(1351),
    [anon_sym_SQUOTE] = ACTIONS(1353),
    [anon_sym_DQUOTE] = ACTIONS(1353),
    [sym_return] = ACTIONS(1351),
    [sym_next] = ACTIONS(1351),
    [sym_break] = ACTIONS(1351),
    [sym_true] = ACTIONS(1351),
    [sym_false] = ACTIONS(1351),
    [sym_null] = ACTIONS(1351),
    [sym_inf] = ACTIONS(1351),
    [sym_nan] = ACTIONS(1351),
    [anon_sym_NA] = ACTIONS(1351),
    [anon_sym_NA_integer_] = ACTIONS(1351),
    [anon_sym_NA_real_] = ACTIONS(1351),
    [anon_sym_NA_complex_] = ACTIONS(1351),
    [anon_sym_NA_character_] = ACTIONS(1351),
    [sym_dots] = ACTIONS(1351),
    [sym_dot_dot_i] = ACTIONS(1353),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1353),
    [sym__semicolon] = ACTIONS(1353),
    [sym__raw_string_literal] = ACTIONS(1353),
    [sym__external_open_parenthesis] = ACTIONS(1353),
    [sym__external_open_brace] = ACTIONS(1353),
    [sym__external_close_brace] = ACTIONS(1353),
    [sym__external_open_bracket] = ACTIONS(1353),
    [sym__external_open_bracket2] = ACTIONS(1353),
  },
  [750] = {
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_BSLASH] = ACTIONS(1329),
    [anon_sym_function] = ACTIONS(1327),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_repeat] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1329),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_LT_DASH] = ACTIONS(1329),
    [anon_sym_LT_LT_DASH] = ACTIONS(1329),
    [anon_sym_COLON_EQ] = ACTIONS(1329),
    [anon_sym_DASH_GT] = ACTIONS(1327),
    [anon_sym_DASH_GT_GT] = ACTIONS(1329),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1329),
    [anon_sym_AMP_AMP] = ACTIONS(1329),
    [anon_sym_LT] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1329),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_GT_EQ] = ACTIONS(1329),
    [anon_sym_EQ_EQ] = ACTIONS(1329),
    [anon_sym_BANG_EQ] = ACTIONS(1329),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_SLASH] = ACTIONS(1329),
    [anon_sym_STAR_STAR] = ACTIONS(1329),
    [anon_sym_CARET] = ACTIONS(1329),
    [aux_sym_binary_operator_token1] = ACTIONS(1329),
    [anon_sym_PIPE_GT] = ACTIONS(1329),
    [anon_sym_COLON] = ACTIONS(1327),
    [anon_sym_DOLLAR] = ACTIONS(1329),
    [anon_sym_AT] = ACTIONS(1329),
    [anon_sym_COLON_COLON] = ACTIONS(1327),
    [anon_sym_COLON_COLON_COLON] = ACTIONS(1329),
    [sym__hex_literal] = ACTIONS(1329),
    [sym__number_literal] = ACTIONS(1327),
    [anon_sym_SQUOTE] = ACTIONS(1329),
    [anon_sym_DQUOTE] = ACTIONS(1329),
    [sym_return] = ACTIONS(1327),
    [sym_next] = ACTIONS(1327),
    [sym_break] = ACTIONS(1327),
    [sym_true] = ACTIONS(1327),
    [sym_false] = ACTIONS(1327),
    [sym_null] = ACTIONS(1327),
    [sym_inf] = ACTIONS(1327),
    [sym_nan] = ACTIONS(1327),
    [anon_sym_NA] = ACTIONS(1327),
    [anon_sym_NA_integer_] = ACTIONS(1327),
    [anon_sym_NA_real_] = ACTIONS(1327),
    [anon_sym_NA_complex_] = ACTIONS(1327),
    [anon_sym_NA_character_] = ACTIONS(1327),
    [sym_dots] = ACTIONS(1327),
    [sym_dot_dot_i] = ACTIONS(1329),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1329),
    [sym__newline] = ACTIONS(1329),
    [sym__raw_string_literal] = ACTIONS(1329),
    [sym__external_open_parenthesis] = ACTIONS(1329),
    [sym__external_open_brace] = ACTIONS(1329),
    [sym__external_open_bracket] = ACTIONS(1329),
    [sym__external_close_bracket] = ACTIONS(1329),
    [sym__external_open_bracket2] = ACTIONS(1329),
  },
  [751] = {
    [sym_function_definition] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_repeat_statement] = STATE(406),
    [sym_braced_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_call] = STATE(406),
    [sym_subset] = STATE(406),
    [sym_subset2] = STATE(406),
    [sym_unary_operator] = STATE(406),
    [sym_binary_operator] = STATE(406),
    [sym_extract_operator] = STATE(406),
    [sym_namespace_operator] = STATE(406),
    [sym_integer] = STATE(406),
    [sym_complex] = STATE(406),
    [sym_float] = STATE(406),
    [sym__float_literal] = STATE(741),
    [sym_string] = STATE(740),
    [sym__single_quoted_string] = STATE(743),
    [sym__double_quoted_string] = STATE(746),
    [sym_na] = STATE(406),
    [sym__expression] = STATE(406),
    [sym__string_or_identifier] = STATE(2136),
    [sym__open_parenthesis] = STATE(934),
    [sym__open_brace] = STATE(853),
    [sym__close_brace] = STATE(930),
    [aux_sym_braced_expression_repeat1] = STATE(758),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1430),
    [anon_sym_function] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_repeat] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [sym__hex_literal] = ACTIONS(1450),
    [sym__number_literal] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [sym_return] = ACTIONS(1454),
    [sym_next] = ACTIONS(1454),
    [sym_break] = ACTIONS(1454),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [sym_null] = ACTIONS(1454),
    [sym_inf] = ACTIONS(1454),
    [sym_nan] = ACTIONS(1454),
    [anon_sym_NA] = ACTIONS(1456),
    [anon_sym_NA_integer_] = ACTIONS(1456),
    [anon_sym_NA_real_] = ACTIONS(1456),
    [anon_sym_NA_complex_] = ACTIONS(1456),
    [anon_sym_NA_character_] = ACTIONS(1456),
    [sym_dots] = ACTIONS(1454),
    [sym_dot_dot_i] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1460),
    [sym__semicolon] = ACTIONS(1460),
    [sym__raw_string_literal] = ACTIONS(1153),
    [sym__external_open_parenthesis] = ACTIONS(1462),
    [sym__external_open_brace] = ACTIONS(1464),
    [sym__external_close_brace] = ACTIONS(1466),
  },
  [752] = {
    [sym_identifier] = ACTIONS(1468),
    [anon_sym_BSLASH] = ACTIONS(1470),
    [anon_sym_function] = ACTIONS(1468),
    [anon_sym_EQ] = ACTIONS(1468),
    [anon_sym_if] = ACTIONS(1468),
    [anon_sym_for] = ACTIONS(1468),
    [anon_sym_while] = ACTIONS(1468),
    [anon_sym_repeat] = ACTIONS(1468),
    [anon_sym_QMARK] = ACTIONS(1470),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_BANG] = ACTIONS(1468),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1468),
    [anon_sym_LT_DASH] = ACTIONS(1470),
    [anon_sym_LT_LT_DASH] = ACTIONS(1470),
    [anon_sym_COLON_EQ] = ACTIONS(1470),
    [anon_sym_DASH_GT] = ACTIONS(1468),
    [anon_sym_DASH_GT_GT] = ACTIONS(1470),
    [anon_sym_PIPE] = ACTIONS(1468),
    [anon_sym_AMP] = ACTIONS(1468),
    [anon_sym_PIPE_PIPE] = ACTIONS(1470),
    [anon_sym_AMP_AMP] = ACTIONS(1470),
    [anon_sym_LT] = ACTIONS(1468),
    [anon_sym_LT_EQ] = ACTIONS(1470),
    [anon_sym_GT] = ACTIONS(1468),
    [anon_sym_GT_EQ] = ACTIONS(1470),
    [anon_sym_EQ_EQ] = ACTIONS(1470),
    [anon_sym_BANG_EQ] = ACTIONS(1470),
    [anon_sym_STAR] = ACTIONS(1468),
    [anon_sym_SLASH] = ACTIONS(1470),
    [anon_sym_STAR_STAR] = ACTIONS(1470),
    [anon_sym_CARET] = ACTIONS(1470),
    [aux_sym_binary_operator_token1] = ACTIONS(1470),
    [anon_sym_PIPE_GT] = ACTIONS(1470),
    [anon_sym_COLON] = ACTIONS(1468),
    [anon_sym_DOLLAR] = ACTIONS(1470),
    [anon_sym_AT] = ACTIONS(1470),
    [sym__hex_literal] = ACTIONS(1470),
    [sym__number_literal] = ACTIONS(1468),
    [anon_sym_SQUOTE] = ACTIONS(1470),
    [anon_sym_DQUOTE] = ACTIONS(1470),
    [sym_return] = ACTIONS(1468),
    [sym_next] = ACTIONS(1468),
    [sym_break] = ACTIONS(1468),
    [sym_true] = ACTIONS(1468),
    [sym_false] = ACTIONS(1468),
    [sym_null] = ACTIONS(1468),
    [sym_inf] = ACTIONS(1468),
    [sym_nan] = ACTIONS(1468),
    [anon_sym_NA] = ACTIONS(1468),
    [anon_sym_NA_integer_] = ACTIONS(1468),
    [anon_sym_NA_real_] = ACTIONS(1468),
    [anon_sym_NA_complex_] = ACTIONS(1468),
    [anon_sym_NA_character_] = ACTIONS(1468),
    [sym_dots] = ACTIONS(1468),
    [sym_dot_dot_i] = ACTIONS(1470),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1470),
    [sym__newline] = ACTIONS(1470),
    [sym__raw_string_literal] = ACTIONS(1470),
    [sym__external_else] = ACTIONS(1470),
    [sym__external_open_parenthesis] = ACTIONS(1470),
    [sym__external_open_brace] = ACTIONS(1470),
    [sym__external_open_bracket] = ACTIONS(1470),
    [sym__external_close_bracket] = ACTIONS(1470),
    [sym__external_open_bracket2] = ACTIONS(1470),
  },
  [753] = {
    [sym_identifier] = ACTIONS(1472),
    [anon_sym_BSLASH] = ACTIONS(1474),
    [anon_sym_function] = ACTIONS(1472),
    [anon_sym_EQ] = ACTIONS(1472),
    [anon_sym_if] = ACTIONS(1472),
    [anon_sym_for] = ACTIONS(1472),
    [anon_sym_while] = ACTIONS(1472),
    [anon_sym_repeat] = ACTIONS(1472),
    [anon_sym_QMARK] = ACTIONS(1474),
    [anon_sym_TILDE] = ACTIONS(1474),
    [anon_sym_BANG] = ACTIONS(1472),
    [anon_sym_PLUS] = ACTIONS(1474),
    [anon_sym_DASH] = ACTIONS(1472),
    [anon_sym_LT_DASH] = ACTIONS(1474),
    [anon_sym_LT_LT_DASH] = ACTIONS(1474),
    [anon_sym_COLON_EQ] = ACTIONS(1474),
    [anon_sym_DASH_GT] = ACTIONS(1472),
    [anon_sym_DASH_GT_GT] = ACTIONS(1474),
    [anon_sym_PIPE] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1472),
    [anon_sym_PIPE_PIPE] = ACTIONS(1474),
    [anon_sym_AMP_AMP] = ACTIONS(1474),
    [anon_sym_LT] = ACTIONS(1472),
    [anon_sym_LT_EQ] = ACTIONS(1474),
    [anon_sym_GT] = ACTIONS(1472),
    [anon_sym_GT_EQ] = ACTIONS(1474),
    [anon_sym_EQ_EQ] = ACTIONS(1474),
    [anon_sym_BANG_EQ] = ACTIONS(1474),
    [anon_sym_STAR] = ACTIONS(1472),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_STAR_STAR] = ACTIONS(1474),
    [anon_sym_CARET] = ACTIONS(1474),
    [aux_sym_binary_operator_token1] = ACTIONS(1474),
    [anon_sym_PIPE_GT] = ACTIONS(1474),
    [anon_sym_COLON] = ACTIONS(1472),
    [anon_sym_DOLLAR] = ACTIONS(1474),
    [anon_sym_AT] = ACTIONS(1474),
    [sym__hex_literal] = ACTIONS(1474),
    [sym__number_literal] = ACTIONS(1472),
    [anon_sym_SQUOTE] = ACTIONS(1474),
    [anon_sym_DQUOTE] = ACTIONS(1474),
    [sym_return] = ACTIONS(1472),
    [sym_next] = ACTIONS(1472),
    [sym_break] = ACTIONS(1472),
    [sym_true] = ACTIONS(1472),
    [sym_false] = ACTIONS(1472),
    [sym_null] = ACTIONS(1472),
    [sym_inf] = ACTIONS(1472),
    [sym_nan] = ACTIONS(1472),
    [anon_sym_NA] = ACTIONS(1472),
    [anon_sym_NA_integer_] = ACTIONS(1472),
    [anon_sym_NA_real_] = ACTIONS(1472),
    [anon_sym_NA_complex_] = ACTIONS(1472),
    [anon_sym_NA_character_] = ACTIONS(1472),
    [sym_dots] = ACTIONS(1472),
    [sym_dot_dot_i] = ACTIONS(1474),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1474),
    [sym__newline] = ACTIONS(1474),
    [sym__raw_string_literal] = ACTIONS(1474),
    [sym__external_else] = ACTIONS(1474),
    [sym__external_open_parenthesis] = ACTIONS(1474),
    [sym__external_open_brace] = ACTIONS(1474),
    [sym__external_open_bracket] = ACTIONS(1474),
    [sym__external_close_bracket] = ACTIONS(1474),
    [sym__external_open_bracket2] = ACTIONS(1474),
  },
  [754] = {
    [sym_identifier] = ACTIONS(1476),
    [anon_sym_BSLASH] = ACTIONS(1478),
    [anon_sym_function] = ACTIONS(1476),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_if] = ACTIONS(1476),
    [anon_sym_for] = ACTIONS(1476),
    [anon_sym_while] = ACTIONS(1476),
    [anon_sym_repeat] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_BANG] = ACTIONS(1476),
    [anon_sym_PLUS] = ACTIONS(1478),
    [anon_sym_DASH] = ACTIONS(1476),
    [anon_sym_LT_DASH] = ACTIONS(1478),
    [anon_sym_LT_LT_DASH] = ACTIONS(1478),
    [anon_sym_COLON_EQ] = ACTIONS(1478),
    [anon_sym_DASH_GT] = ACTIONS(1476),
    [anon_sym_DASH_GT_GT] = ACTIONS(1478),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1478),
    [anon_sym_AMP_AMP] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_EQ] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_GT_EQ] = ACTIONS(1478),
    [anon_sym_EQ_EQ] = ACTIONS(1478),
    [anon_sym_BANG_EQ] = ACTIONS(1478),
    [anon_sym_STAR] = ACTIONS(1476),
    [anon_sym_SLASH] = ACTIONS(1478),
    [anon_sym_STAR_STAR] = ACTIONS(1478),
    [anon_sym_CARET] = ACTIONS(1478),
    [aux_sym_binary_operator_token1] = ACTIONS(1478),
    [anon_sym_PIPE_GT] = ACTIONS(1478),
    [anon_sym_COLON] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1478),
    [anon_sym_AT] = ACTIONS(1478),
    [sym__hex_literal] = ACTIONS(1478),
    [sym__number_literal] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_DQUOTE] = ACTIONS(1478),
    [sym_return] = ACTIONS(1476),
    [sym_next] = ACTIONS(1476),
    [sym_break] = ACTIONS(1476),
    [sym_true] = ACTIONS(1476),
    [sym_false] = ACTIONS(1476),
    [sym_null] = ACTIONS(1476),
    [sym_inf] = ACTIONS(1476),
    [sym_nan] = ACTIONS(1476),
    [anon_sym_NA] = ACTIONS(1476),
    [anon_sym_NA_integer_] = ACTIONS(1476),
    [anon_sym_NA_real_] = ACTIONS(1476),
    [anon_sym_NA_complex_] = ACTIONS(1476),
    [anon_sym_NA_character_] = ACTIONS(1476),
    [sym_dots] = ACTIONS(1476),
    [sym_dot_dot_i] = ACTIONS(1478),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1478),
    [sym__newline] = ACTIONS(1478),
    [sym__raw_string_literal] = ACTIONS(1478),
    [sym__external_else] = ACTIONS(1478),
    [sym__external_open_parenthesis] = ACTIONS(1478),
    [sym__external_open_brace] = ACTIONS(1478),
    [sym__external_open_bracket] = ACTIONS(1478),
    [sym__external_close_bracket] = ACTIONS(1478),
    [sym__external_open_bracket2] = ACTIONS(1478),
  },
  [755] = {
    [sym_identifier] = ACTIONS(1480),
    [anon_sym_BSLASH] = ACTIONS(1482),
    [anon_sym_function] = ACTIONS(1480),
    [anon_sym_EQ] = ACTIONS(1480),
    [anon_sym_if] = ACTIONS(1480),
    [anon_sym_for] = ACTIONS(1480),
    [anon_sym_while] = ACTIONS(1480),
    [anon_sym_repeat] = ACTIONS(1480),
    [anon_sym_QMARK] = ACTIONS(1482),
    [anon_sym_TILDE] = ACTIONS(1482),
    [anon_sym_BANG] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1482),
    [anon_sym_DASH] = ACTIONS(1480),
    [anon_sym_LT_DASH] = ACTIONS(1482),
    [anon_sym_LT_LT_DASH] = ACTIONS(1482),
    [anon_sym_COLON_EQ] = ACTIONS(1482),
    [anon_sym_DASH_GT] = ACTIONS(1480),
    [anon_sym_DASH_GT_GT] = ACTIONS(1482),
    [anon_sym_PIPE] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1480),
    [anon_sym_PIPE_PIPE] = ACTIONS(1482),
    [anon_sym_AMP_AMP] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(1480),
    [anon_sym_LT_EQ] = ACTIONS(1482),
    [anon_sym_GT] = ACTIONS(1480),
    [anon_sym_GT_EQ] = ACTIONS(1482),
    [anon_sym_EQ_EQ] = ACTIONS(1482),
    [anon_sym_BANG_EQ] = ACTIONS(1482),
    [anon_sym_STAR] = ACTIONS(1480),
    [anon_sym_SLASH] = ACTIONS(1482),
    [anon_sym_STAR_STAR] = ACTIONS(1482),
    [anon_sym_CARET] = ACTIONS(1482),
    [aux_sym_binary_operator_token1] = ACTIONS(1482),
    [anon_sym_PIPE_GT] = ACTIONS(1482),
    [anon_sym_COLON] = ACTIONS(1480),
    [anon_sym_DOLLAR] = ACTIONS(1482),
    [anon_sym_AT] = ACTIONS(1482),
    [sym__hex_literal] = ACTIONS(1482),
    [sym__number_literal] = ACTIONS(1480),
    [anon_sym_SQUOTE] = ACTIONS(1482),
    [anon_sym_DQUOTE] = ACTIONS(1482),
    [sym_return] = ACTIONS(1480),
    [sym_next] = ACTIONS(1480),
    [sym_break] = ACTIONS(1480),
    [sym_true] = ACTIONS(1480),
    [sym_false] = ACTIONS(1480),
    [sym_null] = ACTIONS(1480),
    [sym_inf] = ACTIONS(1480),
    [sym_nan] = ACTIONS(1480),
    [anon_sym_NA] = ACTIONS(1480),
    [anon_sym_NA_integer_] = ACTIONS(1480),
    [anon_sym_NA_real_] = ACTIONS(1480),
    [anon_sym_NA_complex_] = ACTIONS(1480),
    [anon_sym_NA_character_] = ACTIONS(1480),
    [sym_dots] = ACTIONS(1480),
    [sym_dot_dot_i] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1482),
    [sym__newline] = ACTIONS(1482),
    [sym__raw_string_literal] = ACTIONS(1482),
    [sym__external_else] = ACTIONS(1482),
    [sym__external_open_parenthesis] = ACTIONS(1482),
    [sym__external_open_brace] = ACTIONS(1482),
    [sym__external_open_bracket] = ACTIONS(1482),
    [sym__external_close_bracket] = ACTIONS(1482),
    [sym__external_open_bracket2] = ACTIONS(1482),
  },
  [756] = {
    [sym_identifier] = ACTIONS(1484),
    [anon_sym_BSLASH] = ACTIONS(1486),
    [anon_sym_function] = ACTIONS(1484),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_if] = ACTIONS(1484),
    [anon_sym_for] = ACTIONS(1484),
    [anon_sym_while] = ACTIONS(1484),
    [anon_sym_repeat] = ACTIONS(1484),
    [anon_sym_QMARK] = ACTIONS(1486),
    [anon_sym_TILDE] = ACTIONS(1486),
    [anon_sym_BANG] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_LT_DASH] = ACTIONS(1486),
    [anon_sym_LT_LT_DASH] = ACTIONS(1486),
    [anon_sym_COLON_EQ] = ACTIONS(1486),
    [anon_sym_DASH_GT] = ACTIONS(1484),
    [anon_sym_DASH_GT_GT] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1484),
    [anon_sym_AMP] = ACTIONS(1484),
    [anon_sym_PIPE_PIPE] = ACTIONS(1486),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_LT] = ACTIONS(1484),
    [anon_sym_LT_EQ] = ACTIONS(1486),
    [anon_sym_GT] = ACTIONS(1484),
    [anon_sym_GT_EQ] = ACTIONS(1486),
    [anon_sym_EQ_EQ] = ACTIONS(1486),
    [anon_sym_BANG_EQ] = ACTIONS(1486),
    [anon_sym_STAR] = ACTIONS(1484),
    [anon_sym_SLASH] = ACTIONS(1486),
    [anon_sym_STAR_STAR] = ACTIONS(1486),
    [anon_sym_CARET] = ACTIONS(1486),
    [aux_sym_binary_operator_token1] = ACTIONS(1486),
    [anon_sym_PIPE_GT] = ACTIONS(1486),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(1486),
    [anon_sym_AT] = ACTIONS(1486),
    [sym__hex_literal] = ACTIONS(1486),
    [sym__number_literal] = ACTIONS(1484),
    [anon_sym_SQUOTE] = ACTIONS(1486),
    [anon_sym_DQUOTE] = ACTIONS(1486),
    [sym_return] = ACTIONS(1484),
    [sym_next] = ACTIONS(1484),
    [sym_break] = ACTIONS(1484),
    [sym_true] = ACTIONS(1484),
    [sym_false] = ACTIONS(1484),
    [sym_null] = ACTIONS(1484),
    [sym_inf] = ACTIONS(1484),
    [sym_nan] = ACTIONS(1484),
    [anon_sym_NA] = ACTIONS(1484),
    [anon_sym_NA_integer_] = ACTIONS(1484),
    [anon_sym_NA_real_] = ACTIONS(1484),
    [anon_sym_NA_complex_] = ACTIONS(1484),
    [anon_sym_NA_character_] = ACTIONS(1484),
    [sym_dots] = ACTIONS(1484),
    [sym_dot_dot_i] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1486),
    [sym__newline] = ACTIONS(1486),
    [sym__raw_string_literal] = ACTIONS(1486),
    [sym__external_else] = ACTIONS(1486),
    [sym__external_open_parenthesis] = ACTIONS(1486),
    [sym__external_open_brace] = ACTIONS(1486),
    [sym__external_open_bracket] = ACTIONS(1486),
    [sym__external_close_bracket] = ACTIONS(1486),
    [sym__external_open_bracket2] = ACTIONS(1486),
  },
  [757] = {
    [sym_function_definition] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_repeat_statement] = STATE(406),
    [sym_braced_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_call] = STATE(406),
    [sym_subset] = STATE(406),
    [sym_subset2] = STATE(406),
    [sym_unary_operator] = STATE(406),
    [sym_binary_operator] = STATE(406),
    [sym_extract_operator] = STATE(406),
    [sym_namespace_operator] = STATE(406),
    [sym_integer] = STATE(406),
    [sym_complex] = STATE(406),
    [sym_float] = STATE(406),
    [sym__float_literal] = STATE(741),
    [sym_string] = STATE(740),
    [sym__single_quoted_string] = STATE(743),
    [sym__double_quoted_string] = STATE(746),
    [sym_na] = STATE(406),
    [sym__expression] = STATE(406),
    [sym__string_or_identifier] = STATE(2136),
    [sym__open_parenthesis] = STATE(934),
    [sym__open_brace] = STATE(853),
    [sym__close_brace] = STATE(769),
    [aux_sym_braced_expression_repeat1] = STATE(894),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1430),
    [anon_sym_function] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_repeat] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [sym__hex_literal] = ACTIONS(1450),
    [sym__number_literal] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [sym_return] = ACTIONS(1454),
    [sym_next] = ACTIONS(1454),
    [sym_break] = ACTIONS(1454),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [sym_null] = ACTIONS(1454),
    [sym_inf] = ACTIONS(1454),
    [sym_nan] = ACTIONS(1454),
    [anon_sym_NA] = ACTIONS(1456),
    [anon_sym_NA_integer_] = ACTIONS(1456),
    [anon_sym_NA_real_] = ACTIONS(1456),
    [anon_sym_NA_complex_] = ACTIONS(1456),
    [anon_sym_NA_character_] = ACTIONS(1456),
    [sym_dots] = ACTIONS(1454),
    [sym_dot_dot_i] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1460),
    [sym__semicolon] = ACTIONS(1460),
    [sym__raw_string_literal] = ACTIONS(1153),
    [sym__external_open_parenthesis] = ACTIONS(1462),
    [sym__external_open_brace] = ACTIONS(1464),
    [sym__external_close_brace] = ACTIONS(1488),
  },
  [758] = {
    [sym_function_definition] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_repeat_statement] = STATE(406),
    [sym_braced_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_call] = STATE(406),
    [sym_subset] = STATE(406),
    [sym_subset2] = STATE(406),
    [sym_unary_operator] = STATE(406),
    [sym_binary_operator] = STATE(406),
    [sym_extract_operator] = STATE(406),
    [sym_namespace_operator] = STATE(406),
    [sym_integer] = STATE(406),
    [sym_complex] = STATE(406),
    [sym_float] = STATE(406),
    [sym__float_literal] = STATE(741),
    [sym_string] = STATE(740),
    [sym__single_quoted_string] = STATE(743),
    [sym__double_quoted_string] = STATE(746),
    [sym_na] = STATE(406),
    [sym__expression] = STATE(406),
    [sym__string_or_identifier] = STATE(2136),
    [sym__open_parenthesis] = STATE(934),
    [sym__open_brace] = STATE(853),
    [sym__close_brace] = STATE(905),
    [aux_sym_braced_expression_repeat1] = STATE(894),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1430),
    [anon_sym_function] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_repeat] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [sym__hex_literal] = ACTIONS(1450),
    [sym__number_literal] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [sym_return] = ACTIONS(1454),
    [sym_next] = ACTIONS(1454),
    [sym_break] = ACTIONS(1454),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [sym_null] = ACTIONS(1454),
    [sym_inf] = ACTIONS(1454),
    [sym_nan] = ACTIONS(1454),
    [anon_sym_NA] = ACTIONS(1456),
    [anon_sym_NA_integer_] = ACTIONS(1456),
    [anon_sym_NA_real_] = ACTIONS(1456),
    [anon_sym_NA_complex_] = ACTIONS(1456),
    [anon_sym_NA_character_] = ACTIONS(1456),
    [sym_dots] = ACTIONS(1454),
    [sym_dot_dot_i] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1460),
    [sym__semicolon] = ACTIONS(1460),
    [sym__raw_string_literal] = ACTIONS(1153),
    [sym__external_open_parenthesis] = ACTIONS(1462),
    [sym__external_open_brace] = ACTIONS(1464),
    [sym__external_close_brace] = ACTIONS(1490),
  },
  [759] = {
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_BSLASH] = ACTIONS(1494),
    [anon_sym_function] = ACTIONS(1492),
    [anon_sym_EQ] = ACTIONS(1492),
    [anon_sym_if] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(1492),
    [anon_sym_while] = ACTIONS(1492),
    [anon_sym_repeat] = ACTIONS(1492),
    [anon_sym_QMARK] = ACTIONS(1494),
    [anon_sym_TILDE] = ACTIONS(1494),
    [anon_sym_BANG] = ACTIONS(1492),
    [anon_sym_PLUS] = ACTIONS(1494),
    [anon_sym_DASH] = ACTIONS(1492),
    [anon_sym_LT_DASH] = ACTIONS(1494),
    [anon_sym_LT_LT_DASH] = ACTIONS(1494),
    [anon_sym_COLON_EQ] = ACTIONS(1494),
    [anon_sym_DASH_GT] = ACTIONS(1492),
    [anon_sym_DASH_GT_GT] = ACTIONS(1494),
    [anon_sym_PIPE] = ACTIONS(1492),
    [anon_sym_AMP] = ACTIONS(1492),
    [anon_sym_PIPE_PIPE] = ACTIONS(1494),
    [anon_sym_AMP_AMP] = ACTIONS(1494),
    [anon_sym_LT] = ACTIONS(1492),
    [anon_sym_LT_EQ] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1492),
    [anon_sym_GT_EQ] = ACTIONS(1494),
    [anon_sym_EQ_EQ] = ACTIONS(1494),
    [anon_sym_BANG_EQ] = ACTIONS(1494),
    [anon_sym_STAR] = ACTIONS(1492),
    [anon_sym_SLASH] = ACTIONS(1494),
    [anon_sym_STAR_STAR] = ACTIONS(1494),
    [anon_sym_CARET] = ACTIONS(1494),
    [aux_sym_binary_operator_token1] = ACTIONS(1494),
    [anon_sym_PIPE_GT] = ACTIONS(1494),
    [anon_sym_COLON] = ACTIONS(1492),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [anon_sym_AT] = ACTIONS(1494),
    [sym__hex_literal] = ACTIONS(1494),
    [sym__number_literal] = ACTIONS(1492),
    [anon_sym_SQUOTE] = ACTIONS(1494),
    [anon_sym_DQUOTE] = ACTIONS(1494),
    [sym_return] = ACTIONS(1492),
    [sym_next] = ACTIONS(1492),
    [sym_break] = ACTIONS(1492),
    [sym_true] = ACTIONS(1492),
    [sym_false] = ACTIONS(1492),
    [sym_null] = ACTIONS(1492),
    [sym_inf] = ACTIONS(1492),
    [sym_nan] = ACTIONS(1492),
    [anon_sym_NA] = ACTIONS(1492),
    [anon_sym_NA_integer_] = ACTIONS(1492),
    [anon_sym_NA_real_] = ACTIONS(1492),
    [anon_sym_NA_complex_] = ACTIONS(1492),
    [anon_sym_NA_character_] = ACTIONS(1492),
    [sym_dots] = ACTIONS(1492),
    [sym_dot_dot_i] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1494),
    [sym__newline] = ACTIONS(1494),
    [sym__raw_string_literal] = ACTIONS(1494),
    [sym__external_else] = ACTIONS(1494),
    [sym__external_open_parenthesis] = ACTIONS(1494),
    [sym__external_close_parenthesis] = ACTIONS(1494),
    [sym__external_open_brace] = ACTIONS(1494),
    [sym__external_open_bracket] = ACTIONS(1494),
    [sym__external_open_bracket2] = ACTIONS(1494),
  },
  [760] = {
    [sym_function_definition] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_repeat_statement] = STATE(406),
    [sym_braced_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_call] = STATE(406),
    [sym_subset] = STATE(406),
    [sym_subset2] = STATE(406),
    [sym_unary_operator] = STATE(406),
    [sym_binary_operator] = STATE(406),
    [sym_extract_operator] = STATE(406),
    [sym_namespace_operator] = STATE(406),
    [sym_integer] = STATE(406),
    [sym_complex] = STATE(406),
    [sym_float] = STATE(406),
    [sym__float_literal] = STATE(741),
    [sym_string] = STATE(740),
    [sym__single_quoted_string] = STATE(743),
    [sym__double_quoted_string] = STATE(746),
    [sym_na] = STATE(406),
    [sym__expression] = STATE(406),
    [sym__string_or_identifier] = STATE(2136),
    [sym__open_parenthesis] = STATE(934),
    [sym__open_brace] = STATE(853),
    [sym__close_brace] = STATE(961),
    [aux_sym_braced_expression_repeat1] = STATE(859),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1430),
    [anon_sym_function] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_repeat] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [sym__hex_literal] = ACTIONS(1450),
    [sym__number_literal] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [sym_return] = ACTIONS(1454),
    [sym_next] = ACTIONS(1454),
    [sym_break] = ACTIONS(1454),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [sym_null] = ACTIONS(1454),
    [sym_inf] = ACTIONS(1454),
    [sym_nan] = ACTIONS(1454),
    [anon_sym_NA] = ACTIONS(1456),
    [anon_sym_NA_integer_] = ACTIONS(1456),
    [anon_sym_NA_real_] = ACTIONS(1456),
    [anon_sym_NA_complex_] = ACTIONS(1456),
    [anon_sym_NA_character_] = ACTIONS(1456),
    [sym_dots] = ACTIONS(1454),
    [sym_dot_dot_i] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1460),
    [sym__semicolon] = ACTIONS(1460),
    [sym__raw_string_literal] = ACTIONS(1153),
    [sym__external_open_parenthesis] = ACTIONS(1462),
    [sym__external_open_brace] = ACTIONS(1464),
    [sym__external_close_brace] = ACTIONS(1496),
  },
  [761] = {
    [sym_function_definition] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_repeat_statement] = STATE(406),
    [sym_braced_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_call] = STATE(406),
    [sym_subset] = STATE(406),
    [sym_subset2] = STATE(406),
    [sym_unary_operator] = STATE(406),
    [sym_binary_operator] = STATE(406),
    [sym_extract_operator] = STATE(406),
    [sym_namespace_operator] = STATE(406),
    [sym_integer] = STATE(406),
    [sym_complex] = STATE(406),
    [sym_float] = STATE(406),
    [sym__float_literal] = STATE(741),
    [sym_string] = STATE(740),
    [sym__single_quoted_string] = STATE(743),
    [sym__double_quoted_string] = STATE(746),
    [sym_na] = STATE(406),
    [sym__expression] = STATE(406),
    [sym__string_or_identifier] = STATE(2136),
    [sym__open_parenthesis] = STATE(934),
    [sym__open_brace] = STATE(853),
    [sym__close_brace] = STATE(936),
    [aux_sym_braced_expression_repeat1] = STATE(894),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1430),
    [anon_sym_function] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_repeat] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [sym__hex_literal] = ACTIONS(1450),
    [sym__number_literal] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [sym_return] = ACTIONS(1454),
    [sym_next] = ACTIONS(1454),
    [sym_break] = ACTIONS(1454),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [sym_null] = ACTIONS(1454),
    [sym_inf] = ACTIONS(1454),
    [sym_nan] = ACTIONS(1454),
    [anon_sym_NA] = ACTIONS(1456),
    [anon_sym_NA_integer_] = ACTIONS(1456),
    [anon_sym_NA_real_] = ACTIONS(1456),
    [anon_sym_NA_complex_] = ACTIONS(1456),
    [anon_sym_NA_character_] = ACTIONS(1456),
    [sym_dots] = ACTIONS(1454),
    [sym_dot_dot_i] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1460),
    [sym__semicolon] = ACTIONS(1460),
    [sym__raw_string_literal] = ACTIONS(1153),
    [sym__external_open_parenthesis] = ACTIONS(1462),
    [sym__external_open_brace] = ACTIONS(1464),
    [sym__external_close_brace] = ACTIONS(1498),
  },
  [762] = {
    [sym_identifier] = ACTIONS(1500),
    [anon_sym_BSLASH] = ACTIONS(1502),
    [anon_sym_function] = ACTIONS(1500),
    [anon_sym_EQ] = ACTIONS(1500),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_for] = ACTIONS(1500),
    [anon_sym_while] = ACTIONS(1500),
    [anon_sym_repeat] = ACTIONS(1500),
    [anon_sym_QMARK] = ACTIONS(1502),
    [anon_sym_TILDE] = ACTIONS(1502),
    [anon_sym_BANG] = ACTIONS(1500),
    [anon_sym_PLUS] = ACTIONS(1502),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_LT_DASH] = ACTIONS(1502),
    [anon_sym_LT_LT_DASH] = ACTIONS(1502),
    [anon_sym_COLON_EQ] = ACTIONS(1502),
    [anon_sym_DASH_GT] = ACTIONS(1500),
    [anon_sym_DASH_GT_GT] = ACTIONS(1502),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_AMP] = ACTIONS(1500),
    [anon_sym_PIPE_PIPE] = ACTIONS(1502),
    [anon_sym_AMP_AMP] = ACTIONS(1502),
    [anon_sym_LT] = ACTIONS(1500),
    [anon_sym_LT_EQ] = ACTIONS(1502),
    [anon_sym_GT] = ACTIONS(1500),
    [anon_sym_GT_EQ] = ACTIONS(1502),
    [anon_sym_EQ_EQ] = ACTIONS(1502),
    [anon_sym_BANG_EQ] = ACTIONS(1502),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1502),
    [anon_sym_STAR_STAR] = ACTIONS(1502),
    [anon_sym_CARET] = ACTIONS(1502),
    [aux_sym_binary_operator_token1] = ACTIONS(1502),
    [anon_sym_PIPE_GT] = ACTIONS(1502),
    [anon_sym_COLON] = ACTIONS(1500),
    [anon_sym_DOLLAR] = ACTIONS(1502),
    [anon_sym_AT] = ACTIONS(1502),
    [sym__hex_literal] = ACTIONS(1502),
    [sym__number_literal] = ACTIONS(1500),
    [anon_sym_SQUOTE] = ACTIONS(1502),
    [anon_sym_DQUOTE] = ACTIONS(1502),
    [sym_return] = ACTIONS(1500),
    [sym_next] = ACTIONS(1500),
    [sym_break] = ACTIONS(1500),
    [sym_true] = ACTIONS(1500),
    [sym_false] = ACTIONS(1500),
    [sym_null] = ACTIONS(1500),
    [sym_inf] = ACTIONS(1500),
    [sym_nan] = ACTIONS(1500),
    [anon_sym_NA] = ACTIONS(1500),
    [anon_sym_NA_integer_] = ACTIONS(1500),
    [anon_sym_NA_real_] = ACTIONS(1500),
    [anon_sym_NA_complex_] = ACTIONS(1500),
    [anon_sym_NA_character_] = ACTIONS(1500),
    [sym_dots] = ACTIONS(1500),
    [sym_dot_dot_i] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1502),
    [sym__newline] = ACTIONS(1502),
    [sym__raw_string_literal] = ACTIONS(1502),
    [sym__external_else] = ACTIONS(1502),
    [sym__external_open_parenthesis] = ACTIONS(1502),
    [sym__external_open_brace] = ACTIONS(1502),
    [sym__external_open_bracket] = ACTIONS(1502),
    [sym__external_close_bracket] = ACTIONS(1502),
    [sym__external_open_bracket2] = ACTIONS(1502),
  },
  [763] = {
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_BSLASH] = ACTIONS(1506),
    [anon_sym_function] = ACTIONS(1504),
    [anon_sym_EQ] = ACTIONS(1504),
    [anon_sym_if] = ACTIONS(1504),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1504),
    [anon_sym_repeat] = ACTIONS(1504),
    [anon_sym_QMARK] = ACTIONS(1506),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_BANG] = ACTIONS(1504),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1504),
    [anon_sym_LT_DASH] = ACTIONS(1506),
    [anon_sym_LT_LT_DASH] = ACTIONS(1506),
    [anon_sym_COLON_EQ] = ACTIONS(1506),
    [anon_sym_DASH_GT] = ACTIONS(1504),
    [anon_sym_DASH_GT_GT] = ACTIONS(1506),
    [anon_sym_PIPE] = ACTIONS(1504),
    [anon_sym_AMP] = ACTIONS(1504),
    [anon_sym_PIPE_PIPE] = ACTIONS(1506),
    [anon_sym_AMP_AMP] = ACTIONS(1506),
    [anon_sym_LT] = ACTIONS(1504),
    [anon_sym_LT_EQ] = ACTIONS(1506),
    [anon_sym_GT] = ACTIONS(1504),
    [anon_sym_GT_EQ] = ACTIONS(1506),
    [anon_sym_EQ_EQ] = ACTIONS(1506),
    [anon_sym_BANG_EQ] = ACTIONS(1506),
    [anon_sym_STAR] = ACTIONS(1504),
    [anon_sym_SLASH] = ACTIONS(1506),
    [anon_sym_STAR_STAR] = ACTIONS(1506),
    [anon_sym_CARET] = ACTIONS(1506),
    [aux_sym_binary_operator_token1] = ACTIONS(1506),
    [anon_sym_PIPE_GT] = ACTIONS(1506),
    [anon_sym_COLON] = ACTIONS(1504),
    [anon_sym_DOLLAR] = ACTIONS(1506),
    [anon_sym_AT] = ACTIONS(1506),
    [sym__hex_literal] = ACTIONS(1506),
    [sym__number_literal] = ACTIONS(1504),
    [anon_sym_SQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1506),
    [sym_return] = ACTIONS(1504),
    [sym_next] = ACTIONS(1504),
    [sym_break] = ACTIONS(1504),
    [sym_true] = ACTIONS(1504),
    [sym_false] = ACTIONS(1504),
    [sym_null] = ACTIONS(1504),
    [sym_inf] = ACTIONS(1504),
    [sym_nan] = ACTIONS(1504),
    [anon_sym_NA] = ACTIONS(1504),
    [anon_sym_NA_integer_] = ACTIONS(1504),
    [anon_sym_NA_real_] = ACTIONS(1504),
    [anon_sym_NA_complex_] = ACTIONS(1504),
    [anon_sym_NA_character_] = ACTIONS(1504),
    [sym_dots] = ACTIONS(1504),
    [sym_dot_dot_i] = ACTIONS(1506),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1506),
    [sym__newline] = ACTIONS(1506),
    [sym__raw_string_literal] = ACTIONS(1506),
    [sym__external_else] = ACTIONS(1506),
    [sym__external_open_parenthesis] = ACTIONS(1506),
    [sym__external_open_brace] = ACTIONS(1506),
    [sym__external_open_bracket] = ACTIONS(1506),
    [sym__external_close_bracket] = ACTIONS(1506),
    [sym__external_open_bracket2] = ACTIONS(1506),
  },
  [764] = {
    [sym_identifier] = ACTIONS(1508),
    [anon_sym_BSLASH] = ACTIONS(1510),
    [anon_sym_function] = ACTIONS(1508),
    [anon_sym_EQ] = ACTIONS(1508),
    [anon_sym_if] = ACTIONS(1508),
    [anon_sym_for] = ACTIONS(1508),
    [anon_sym_while] = ACTIONS(1508),
    [anon_sym_repeat] = ACTIONS(1508),
    [anon_sym_QMARK] = ACTIONS(1510),
    [anon_sym_TILDE] = ACTIONS(1510),
    [anon_sym_BANG] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1510),
    [anon_sym_DASH] = ACTIONS(1508),
    [anon_sym_LT_DASH] = ACTIONS(1510),
    [anon_sym_LT_LT_DASH] = ACTIONS(1510),
    [anon_sym_COLON_EQ] = ACTIONS(1510),
    [anon_sym_DASH_GT] = ACTIONS(1508),
    [anon_sym_DASH_GT_GT] = ACTIONS(1510),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PIPE_PIPE] = ACTIONS(1510),
    [anon_sym_AMP_AMP] = ACTIONS(1510),
    [anon_sym_LT] = ACTIONS(1508),
    [anon_sym_LT_EQ] = ACTIONS(1510),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_GT_EQ] = ACTIONS(1510),
    [anon_sym_EQ_EQ] = ACTIONS(1510),
    [anon_sym_BANG_EQ] = ACTIONS(1510),
    [anon_sym_STAR] = ACTIONS(1508),
    [anon_sym_SLASH] = ACTIONS(1510),
    [anon_sym_STAR_STAR] = ACTIONS(1510),
    [anon_sym_CARET] = ACTIONS(1510),
    [aux_sym_binary_operator_token1] = ACTIONS(1510),
    [anon_sym_PIPE_GT] = ACTIONS(1510),
    [anon_sym_COLON] = ACTIONS(1508),
    [anon_sym_DOLLAR] = ACTIONS(1510),
    [anon_sym_AT] = ACTIONS(1510),
    [sym__hex_literal] = ACTIONS(1510),
    [sym__number_literal] = ACTIONS(1508),
    [anon_sym_SQUOTE] = ACTIONS(1510),
    [anon_sym_DQUOTE] = ACTIONS(1510),
    [sym_return] = ACTIONS(1508),
    [sym_next] = ACTIONS(1508),
    [sym_break] = ACTIONS(1508),
    [sym_true] = ACTIONS(1508),
    [sym_false] = ACTIONS(1508),
    [sym_null] = ACTIONS(1508),
    [sym_inf] = ACTIONS(1508),
    [sym_nan] = ACTIONS(1508),
    [anon_sym_NA] = ACTIONS(1508),
    [anon_sym_NA_integer_] = ACTIONS(1508),
    [anon_sym_NA_real_] = ACTIONS(1508),
    [anon_sym_NA_complex_] = ACTIONS(1508),
    [anon_sym_NA_character_] = ACTIONS(1508),
    [sym_dots] = ACTIONS(1508),
    [sym_dot_dot_i] = ACTIONS(1510),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1510),
    [sym__newline] = ACTIONS(1510),
    [sym__raw_string_literal] = ACTIONS(1510),
    [sym__external_else] = ACTIONS(1510),
    [sym__external_open_parenthesis] = ACTIONS(1510),
    [sym__external_open_brace] = ACTIONS(1510),
    [sym__external_open_bracket] = ACTIONS(1510),
    [sym__external_close_bracket] = ACTIONS(1510),
    [sym__external_open_bracket2] = ACTIONS(1510),
  },
  [765] = {
    [aux_sym_function_definition_repeat1] = STATE(765),
    [sym_identifier] = ACTIONS(1383),
    [anon_sym_BSLASH] = ACTIONS(1385),
    [anon_sym_function] = ACTIONS(1383),
    [anon_sym_EQ] = ACTIONS(1383),
    [anon_sym_if] = ACTIONS(1383),
    [anon_sym_for] = ACTIONS(1383),
    [anon_sym_while] = ACTIONS(1383),
    [anon_sym_repeat] = ACTIONS(1383),
    [anon_sym_QMARK] = ACTIONS(1385),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1383),
    [anon_sym_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_COLON_EQ] = ACTIONS(1385),
    [anon_sym_DASH_GT] = ACTIONS(1383),
    [anon_sym_DASH_GT_GT] = ACTIONS(1385),
    [anon_sym_PIPE] = ACTIONS(1383),
    [anon_sym_AMP] = ACTIONS(1383),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1383),
    [anon_sym_LT_EQ] = ACTIONS(1385),
    [anon_sym_GT] = ACTIONS(1383),
    [anon_sym_GT_EQ] = ACTIONS(1385),
    [anon_sym_EQ_EQ] = ACTIONS(1385),
    [anon_sym_BANG_EQ] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_SLASH] = ACTIONS(1385),
    [anon_sym_STAR_STAR] = ACTIONS(1385),
    [anon_sym_CARET] = ACTIONS(1385),
    [aux_sym_binary_operator_token1] = ACTIONS(1385),
    [anon_sym_PIPE_GT] = ACTIONS(1385),
    [anon_sym_COLON] = ACTIONS(1383),
    [anon_sym_DOLLAR] = ACTIONS(1385),
    [anon_sym_AT] = ACTIONS(1385),
    [sym__hex_literal] = ACTIONS(1385),
    [sym__number_literal] = ACTIONS(1383),
    [anon_sym_SQUOTE] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [sym_return] = ACTIONS(1383),
    [sym_next] = ACTIONS(1383),
    [sym_break] = ACTIONS(1383),
    [sym_true] = ACTIONS(1383),
    [sym_false] = ACTIONS(1383),
    [sym_null] = ACTIONS(1383),
    [sym_inf] = ACTIONS(1383),
    [sym_nan] = ACTIONS(1383),
    [anon_sym_NA] = ACTIONS(1383),
    [anon_sym_NA_integer_] = ACTIONS(1383),
    [anon_sym_NA_real_] = ACTIONS(1383),
    [anon_sym_NA_complex_] = ACTIONS(1383),
    [anon_sym_NA_character_] = ACTIONS(1383),
    [sym_dots] = ACTIONS(1383),
    [sym_dot_dot_i] = ACTIONS(1385),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1512),
    [sym__semicolon] = ACTIONS(1385),
    [sym__raw_string_literal] = ACTIONS(1385),
    [sym__external_open_parenthesis] = ACTIONS(1385),
    [sym__external_open_brace] = ACTIONS(1385),
    [sym__external_close_brace] = ACTIONS(1385),
    [sym__external_open_bracket] = ACTIONS(1385),
    [sym__external_open_bracket2] = ACTIONS(1385),
  },
  [766] = {
    [sym_identifier] = ACTIONS(1515),
    [anon_sym_BSLASH] = ACTIONS(1517),
    [anon_sym_function] = ACTIONS(1515),
    [anon_sym_EQ] = ACTIONS(1515),
    [anon_sym_if] = ACTIONS(1515),
    [anon_sym_for] = ACTIONS(1515),
    [anon_sym_while] = ACTIONS(1515),
    [anon_sym_repeat] = ACTIONS(1515),
    [anon_sym_QMARK] = ACTIONS(1517),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_DASH] = ACTIONS(1515),
    [anon_sym_LT_DASH] = ACTIONS(1517),
    [anon_sym_LT_LT_DASH] = ACTIONS(1517),
    [anon_sym_COLON_EQ] = ACTIONS(1517),
    [anon_sym_DASH_GT] = ACTIONS(1515),
    [anon_sym_DASH_GT_GT] = ACTIONS(1517),
    [anon_sym_PIPE] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_PIPE_PIPE] = ACTIONS(1517),
    [anon_sym_AMP_AMP] = ACTIONS(1517),
    [anon_sym_LT] = ACTIONS(1515),
    [anon_sym_LT_EQ] = ACTIONS(1517),
    [anon_sym_GT] = ACTIONS(1515),
    [anon_sym_GT_EQ] = ACTIONS(1517),
    [anon_sym_EQ_EQ] = ACTIONS(1517),
    [anon_sym_BANG_EQ] = ACTIONS(1517),
    [anon_sym_STAR] = ACTIONS(1515),
    [anon_sym_SLASH] = ACTIONS(1517),
    [anon_sym_STAR_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [aux_sym_binary_operator_token1] = ACTIONS(1517),
    [anon_sym_PIPE_GT] = ACTIONS(1517),
    [anon_sym_COLON] = ACTIONS(1515),
    [anon_sym_DOLLAR] = ACTIONS(1517),
    [anon_sym_AT] = ACTIONS(1517),
    [sym__hex_literal] = ACTIONS(1517),
    [sym__number_literal] = ACTIONS(1515),
    [anon_sym_SQUOTE] = ACTIONS(1517),
    [anon_sym_DQUOTE] = ACTIONS(1517),
    [sym_return] = ACTIONS(1515),
    [sym_next] = ACTIONS(1515),
    [sym_break] = ACTIONS(1515),
    [sym_true] = ACTIONS(1515),
    [sym_false] = ACTIONS(1515),
    [sym_null] = ACTIONS(1515),
    [sym_inf] = ACTIONS(1515),
    [sym_nan] = ACTIONS(1515),
    [anon_sym_NA] = ACTIONS(1515),
    [anon_sym_NA_integer_] = ACTIONS(1515),
    [anon_sym_NA_real_] = ACTIONS(1515),
    [anon_sym_NA_complex_] = ACTIONS(1515),
    [anon_sym_NA_character_] = ACTIONS(1515),
    [sym_dots] = ACTIONS(1515),
    [sym_dot_dot_i] = ACTIONS(1517),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1517),
    [sym__newline] = ACTIONS(1517),
    [sym__raw_string_literal] = ACTIONS(1517),
    [sym__external_else] = ACTIONS(1517),
    [sym__external_open_parenthesis] = ACTIONS(1517),
    [sym__external_open_brace] = ACTIONS(1517),
    [sym__external_open_bracket] = ACTIONS(1517),
    [sym__external_close_bracket] = ACTIONS(1517),
    [sym__external_open_bracket2] = ACTIONS(1517),
  },
  [767] = {
    [sym_identifier] = ACTIONS(1519),
    [anon_sym_BSLASH] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(1519),
    [anon_sym_EQ] = ACTIONS(1519),
    [anon_sym_if] = ACTIONS(1519),
    [anon_sym_for] = ACTIONS(1519),
    [anon_sym_while] = ACTIONS(1519),
    [anon_sym_repeat] = ACTIONS(1519),
    [anon_sym_QMARK] = ACTIONS(1521),
    [anon_sym_TILDE] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1519),
    [anon_sym_PLUS] = ACTIONS(1521),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_LT_DASH] = ACTIONS(1521),
    [anon_sym_LT_LT_DASH] = ACTIONS(1521),
    [anon_sym_COLON_EQ] = ACTIONS(1521),
    [anon_sym_DASH_GT] = ACTIONS(1519),
    [anon_sym_DASH_GT_GT] = ACTIONS(1521),
    [anon_sym_PIPE] = ACTIONS(1519),
    [anon_sym_AMP] = ACTIONS(1519),
    [anon_sym_PIPE_PIPE] = ACTIONS(1521),
    [anon_sym_AMP_AMP] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_LT_EQ] = ACTIONS(1521),
    [anon_sym_GT] = ACTIONS(1519),
    [anon_sym_GT_EQ] = ACTIONS(1521),
    [anon_sym_EQ_EQ] = ACTIONS(1521),
    [anon_sym_BANG_EQ] = ACTIONS(1521),
    [anon_sym_STAR] = ACTIONS(1519),
    [anon_sym_SLASH] = ACTIONS(1521),
    [anon_sym_STAR_STAR] = ACTIONS(1521),
    [anon_sym_CARET] = ACTIONS(1521),
    [aux_sym_binary_operator_token1] = ACTIONS(1521),
    [anon_sym_PIPE_GT] = ACTIONS(1521),
    [anon_sym_COLON] = ACTIONS(1519),
    [anon_sym_DOLLAR] = ACTIONS(1521),
    [anon_sym_AT] = ACTIONS(1521),
    [sym__hex_literal] = ACTIONS(1521),
    [sym__number_literal] = ACTIONS(1519),
    [anon_sym_SQUOTE] = ACTIONS(1521),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [sym_return] = ACTIONS(1519),
    [sym_next] = ACTIONS(1519),
    [sym_break] = ACTIONS(1519),
    [sym_true] = ACTIONS(1519),
    [sym_false] = ACTIONS(1519),
    [sym_null] = ACTIONS(1519),
    [sym_inf] = ACTIONS(1519),
    [sym_nan] = ACTIONS(1519),
    [anon_sym_NA] = ACTIONS(1519),
    [anon_sym_NA_integer_] = ACTIONS(1519),
    [anon_sym_NA_real_] = ACTIONS(1519),
    [anon_sym_NA_complex_] = ACTIONS(1519),
    [anon_sym_NA_character_] = ACTIONS(1519),
    [sym_dots] = ACTIONS(1519),
    [sym_dot_dot_i] = ACTIONS(1521),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1521),
    [sym__newline] = ACTIONS(1521),
    [sym__raw_string_literal] = ACTIONS(1521),
    [sym__external_else] = ACTIONS(1521),
    [sym__external_open_parenthesis] = ACTIONS(1521),
    [sym__external_open_brace] = ACTIONS(1521),
    [sym__external_open_bracket] = ACTIONS(1521),
    [sym__external_close_bracket] = ACTIONS(1521),
    [sym__external_open_bracket2] = ACTIONS(1521),
  },
  [768] = {
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_BSLASH] = ACTIONS(1525),
    [anon_sym_function] = ACTIONS(1523),
    [anon_sym_EQ] = ACTIONS(1523),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_for] = ACTIONS(1523),
    [anon_sym_while] = ACTIONS(1523),
    [anon_sym_repeat] = ACTIONS(1523),
    [anon_sym_QMARK] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(1525),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1523),
    [anon_sym_LT_DASH] = ACTIONS(1525),
    [anon_sym_LT_LT_DASH] = ACTIONS(1525),
    [anon_sym_COLON_EQ] = ACTIONS(1525),
    [anon_sym_DASH_GT] = ACTIONS(1523),
    [anon_sym_DASH_GT_GT] = ACTIONS(1525),
    [anon_sym_PIPE] = ACTIONS(1523),
    [anon_sym_AMP] = ACTIONS(1523),
    [anon_sym_PIPE_PIPE] = ACTIONS(1525),
    [anon_sym_AMP_AMP] = ACTIONS(1525),
    [anon_sym_LT] = ACTIONS(1523),
    [anon_sym_LT_EQ] = ACTIONS(1525),
    [anon_sym_GT] = ACTIONS(1523),
    [anon_sym_GT_EQ] = ACTIONS(1525),
    [anon_sym_EQ_EQ] = ACTIONS(1525),
    [anon_sym_BANG_EQ] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1523),
    [anon_sym_SLASH] = ACTIONS(1525),
    [anon_sym_STAR_STAR] = ACTIONS(1525),
    [anon_sym_CARET] = ACTIONS(1525),
    [aux_sym_binary_operator_token1] = ACTIONS(1525),
    [anon_sym_PIPE_GT] = ACTIONS(1525),
    [anon_sym_COLON] = ACTIONS(1523),
    [anon_sym_DOLLAR] = ACTIONS(1525),
    [anon_sym_AT] = ACTIONS(1525),
    [sym__hex_literal] = ACTIONS(1525),
    [sym__number_literal] = ACTIONS(1523),
    [anon_sym_SQUOTE] = ACTIONS(1525),
    [anon_sym_DQUOTE] = ACTIONS(1525),
    [sym_return] = ACTIONS(1523),
    [sym_next] = ACTIONS(1523),
    [sym_break] = ACTIONS(1523),
    [sym_true] = ACTIONS(1523),
    [sym_false] = ACTIONS(1523),
    [sym_null] = ACTIONS(1523),
    [sym_inf] = ACTIONS(1523),
    [sym_nan] = ACTIONS(1523),
    [anon_sym_NA] = ACTIONS(1523),
    [anon_sym_NA_integer_] = ACTIONS(1523),
    [anon_sym_NA_real_] = ACTIONS(1523),
    [anon_sym_NA_complex_] = ACTIONS(1523),
    [anon_sym_NA_character_] = ACTIONS(1523),
    [sym_dots] = ACTIONS(1523),
    [sym_dot_dot_i] = ACTIONS(1525),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1525),
    [sym__newline] = ACTIONS(1525),
    [sym__raw_string_literal] = ACTIONS(1525),
    [sym__external_else] = ACTIONS(1525),
    [sym__external_open_parenthesis] = ACTIONS(1525),
    [sym__external_open_brace] = ACTIONS(1525),
    [sym__external_open_bracket] = ACTIONS(1525),
    [sym__external_close_bracket] = ACTIONS(1525),
    [sym__external_open_bracket2] = ACTIONS(1525),
  },
  [769] = {
    [sym_identifier] = ACTIONS(1527),
    [anon_sym_BSLASH] = ACTIONS(1529),
    [anon_sym_function] = ACTIONS(1527),
    [anon_sym_EQ] = ACTIONS(1527),
    [anon_sym_if] = ACTIONS(1527),
    [anon_sym_for] = ACTIONS(1527),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_repeat] = ACTIONS(1527),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_TILDE] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1527),
    [anon_sym_LT_DASH] = ACTIONS(1529),
    [anon_sym_LT_LT_DASH] = ACTIONS(1529),
    [anon_sym_COLON_EQ] = ACTIONS(1529),
    [anon_sym_DASH_GT] = ACTIONS(1527),
    [anon_sym_DASH_GT_GT] = ACTIONS(1529),
    [anon_sym_PIPE] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1527),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1527),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1529),
    [anon_sym_BANG_EQ] = ACTIONS(1529),
    [anon_sym_STAR] = ACTIONS(1527),
    [anon_sym_SLASH] = ACTIONS(1529),
    [anon_sym_STAR_STAR] = ACTIONS(1529),
    [anon_sym_CARET] = ACTIONS(1529),
    [aux_sym_binary_operator_token1] = ACTIONS(1529),
    [anon_sym_PIPE_GT] = ACTIONS(1529),
    [anon_sym_COLON] = ACTIONS(1527),
    [anon_sym_DOLLAR] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(1529),
    [sym__hex_literal] = ACTIONS(1529),
    [sym__number_literal] = ACTIONS(1527),
    [anon_sym_SQUOTE] = ACTIONS(1529),
    [anon_sym_DQUOTE] = ACTIONS(1529),
    [sym_return] = ACTIONS(1527),
    [sym_next] = ACTIONS(1527),
    [sym_break] = ACTIONS(1527),
    [sym_true] = ACTIONS(1527),
    [sym_false] = ACTIONS(1527),
    [sym_null] = ACTIONS(1527),
    [sym_inf] = ACTIONS(1527),
    [sym_nan] = ACTIONS(1527),
    [anon_sym_NA] = ACTIONS(1527),
    [anon_sym_NA_integer_] = ACTIONS(1527),
    [anon_sym_NA_real_] = ACTIONS(1527),
    [anon_sym_NA_complex_] = ACTIONS(1527),
    [anon_sym_NA_character_] = ACTIONS(1527),
    [sym_dots] = ACTIONS(1527),
    [sym_dot_dot_i] = ACTIONS(1529),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1529),
    [sym__newline] = ACTIONS(1529),
    [sym__raw_string_literal] = ACTIONS(1529),
    [sym__external_else] = ACTIONS(1529),
    [sym__external_open_parenthesis] = ACTIONS(1529),
    [sym__external_open_brace] = ACTIONS(1529),
    [sym__external_open_bracket] = ACTIONS(1529),
    [sym__external_close_bracket] = ACTIONS(1529),
    [sym__external_open_bracket2] = ACTIONS(1529),
  },
  [770] = {
    [ts_builtin_sym_end] = ACTIONS(1502),
    [sym_identifier] = ACTIONS(1500),
    [anon_sym_BSLASH] = ACTIONS(1502),
    [anon_sym_function] = ACTIONS(1500),
    [anon_sym_EQ] = ACTIONS(1500),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_for] = ACTIONS(1500),
    [anon_sym_while] = ACTIONS(1500),
    [anon_sym_repeat] = ACTIONS(1500),
    [anon_sym_QMARK] = ACTIONS(1502),
    [anon_sym_TILDE] = ACTIONS(1502),
    [anon_sym_BANG] = ACTIONS(1500),
    [anon_sym_PLUS] = ACTIONS(1502),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_LT_DASH] = ACTIONS(1502),
    [anon_sym_LT_LT_DASH] = ACTIONS(1502),
    [anon_sym_COLON_EQ] = ACTIONS(1502),
    [anon_sym_DASH_GT] = ACTIONS(1500),
    [anon_sym_DASH_GT_GT] = ACTIONS(1502),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_AMP] = ACTIONS(1500),
    [anon_sym_PIPE_PIPE] = ACTIONS(1502),
    [anon_sym_AMP_AMP] = ACTIONS(1502),
    [anon_sym_LT] = ACTIONS(1500),
    [anon_sym_LT_EQ] = ACTIONS(1502),
    [anon_sym_GT] = ACTIONS(1500),
    [anon_sym_GT_EQ] = ACTIONS(1502),
    [anon_sym_EQ_EQ] = ACTIONS(1502),
    [anon_sym_BANG_EQ] = ACTIONS(1502),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1502),
    [anon_sym_STAR_STAR] = ACTIONS(1502),
    [anon_sym_CARET] = ACTIONS(1502),
    [aux_sym_binary_operator_token1] = ACTIONS(1502),
    [anon_sym_PIPE_GT] = ACTIONS(1502),
    [anon_sym_COLON] = ACTIONS(1500),
    [anon_sym_DOLLAR] = ACTIONS(1502),
    [anon_sym_AT] = ACTIONS(1502),
    [sym__hex_literal] = ACTIONS(1502),
    [sym__number_literal] = ACTIONS(1500),
    [anon_sym_SQUOTE] = ACTIONS(1502),
    [anon_sym_DQUOTE] = ACTIONS(1502),
    [sym_return] = ACTIONS(1500),
    [sym_next] = ACTIONS(1500),
    [sym_break] = ACTIONS(1500),
    [sym_true] = ACTIONS(1500),
    [sym_false] = ACTIONS(1500),
    [sym_null] = ACTIONS(1500),
    [sym_inf] = ACTIONS(1500),
    [sym_nan] = ACTIONS(1500),
    [anon_sym_NA] = ACTIONS(1500),
    [anon_sym_NA_integer_] = ACTIONS(1500),
    [anon_sym_NA_real_] = ACTIONS(1500),
    [anon_sym_NA_complex_] = ACTIONS(1500),
    [anon_sym_NA_character_] = ACTIONS(1500),
    [sym_dots] = ACTIONS(1500),
    [sym_dot_dot_i] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1502),
    [sym__semicolon] = ACTIONS(1502),
    [sym__raw_string_literal] = ACTIONS(1502),
    [sym__external_else] = ACTIONS(1502),
    [sym__external_open_parenthesis] = ACTIONS(1502),
    [sym__external_open_brace] = ACTIONS(1502),
    [sym__external_open_bracket] = ACTIONS(1502),
    [sym__external_open_bracket2] = ACTIONS(1502),
  },
  [771] = {
    [ts_builtin_sym_end] = ACTIONS(1531),
    [sym_identifier] = ACTIONS(1533),
    [anon_sym_BSLASH] = ACTIONS(1531),
    [anon_sym_function] = ACTIONS(1533),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_if] = ACTIONS(1533),
    [anon_sym_for] = ACTIONS(1533),
    [anon_sym_while] = ACTIONS(1533),
    [anon_sym_repeat] = ACTIONS(1533),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_LT_DASH] = ACTIONS(1531),
    [anon_sym_LT_LT_DASH] = ACTIONS(1531),
    [anon_sym_COLON_EQ] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1533),
    [anon_sym_DASH_GT_GT] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1531),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_CARET] = ACTIONS(1531),
    [aux_sym_binary_operator_token1] = ACTIONS(1531),
    [anon_sym_PIPE_GT] = ACTIONS(1531),
    [anon_sym_COLON] = ACTIONS(1533),
    [anon_sym_DOLLAR] = ACTIONS(1531),
    [anon_sym_AT] = ACTIONS(1531),
    [sym__hex_literal] = ACTIONS(1531),
    [sym__number_literal] = ACTIONS(1533),
    [anon_sym_SQUOTE] = ACTIONS(1531),
    [anon_sym_DQUOTE] = ACTIONS(1531),
    [sym_return] = ACTIONS(1533),
    [sym_next] = ACTIONS(1533),
    [sym_break] = ACTIONS(1533),
    [sym_true] = ACTIONS(1533),
    [sym_false] = ACTIONS(1533),
    [sym_null] = ACTIONS(1533),
    [sym_inf] = ACTIONS(1533),
    [sym_nan] = ACTIONS(1533),
    [anon_sym_NA] = ACTIONS(1533),
    [anon_sym_NA_integer_] = ACTIONS(1533),
    [anon_sym_NA_real_] = ACTIONS(1533),
    [anon_sym_NA_complex_] = ACTIONS(1533),
    [anon_sym_NA_character_] = ACTIONS(1533),
    [sym_dots] = ACTIONS(1533),
    [sym_dot_dot_i] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1531),
    [sym__semicolon] = ACTIONS(1531),
    [sym__raw_string_literal] = ACTIONS(1531),
    [sym__external_else] = ACTIONS(1531),
    [sym__external_open_parenthesis] = ACTIONS(1531),
    [sym__external_open_brace] = ACTIONS(1531),
    [sym__external_open_bracket] = ACTIONS(1531),
    [sym__external_open_bracket2] = ACTIONS(1531),
  },
  [772] = {
    [ts_builtin_sym_end] = ACTIONS(1506),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_BSLASH] = ACTIONS(1506),
    [anon_sym_function] = ACTIONS(1504),
    [anon_sym_EQ] = ACTIONS(1504),
    [anon_sym_if] = ACTIONS(1504),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1504),
    [anon_sym_repeat] = ACTIONS(1504),
    [anon_sym_QMARK] = ACTIONS(1506),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_BANG] = ACTIONS(1504),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1504),
    [anon_sym_LT_DASH] = ACTIONS(1506),
    [anon_sym_LT_LT_DASH] = ACTIONS(1506),
    [anon_sym_COLON_EQ] = ACTIONS(1506),
    [anon_sym_DASH_GT] = ACTIONS(1504),
    [anon_sym_DASH_GT_GT] = ACTIONS(1506),
    [anon_sym_PIPE] = ACTIONS(1504),
    [anon_sym_AMP] = ACTIONS(1504),
    [anon_sym_PIPE_PIPE] = ACTIONS(1506),
    [anon_sym_AMP_AMP] = ACTIONS(1506),
    [anon_sym_LT] = ACTIONS(1504),
    [anon_sym_LT_EQ] = ACTIONS(1506),
    [anon_sym_GT] = ACTIONS(1504),
    [anon_sym_GT_EQ] = ACTIONS(1506),
    [anon_sym_EQ_EQ] = ACTIONS(1506),
    [anon_sym_BANG_EQ] = ACTIONS(1506),
    [anon_sym_STAR] = ACTIONS(1504),
    [anon_sym_SLASH] = ACTIONS(1506),
    [anon_sym_STAR_STAR] = ACTIONS(1506),
    [anon_sym_CARET] = ACTIONS(1506),
    [aux_sym_binary_operator_token1] = ACTIONS(1506),
    [anon_sym_PIPE_GT] = ACTIONS(1506),
    [anon_sym_COLON] = ACTIONS(1504),
    [anon_sym_DOLLAR] = ACTIONS(1506),
    [anon_sym_AT] = ACTIONS(1506),
    [sym__hex_literal] = ACTIONS(1506),
    [sym__number_literal] = ACTIONS(1504),
    [anon_sym_SQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1506),
    [sym_return] = ACTIONS(1504),
    [sym_next] = ACTIONS(1504),
    [sym_break] = ACTIONS(1504),
    [sym_true] = ACTIONS(1504),
    [sym_false] = ACTIONS(1504),
    [sym_null] = ACTIONS(1504),
    [sym_inf] = ACTIONS(1504),
    [sym_nan] = ACTIONS(1504),
    [anon_sym_NA] = ACTIONS(1504),
    [anon_sym_NA_integer_] = ACTIONS(1504),
    [anon_sym_NA_real_] = ACTIONS(1504),
    [anon_sym_NA_complex_] = ACTIONS(1504),
    [anon_sym_NA_character_] = ACTIONS(1504),
    [sym_dots] = ACTIONS(1504),
    [sym_dot_dot_i] = ACTIONS(1506),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1506),
    [sym__semicolon] = ACTIONS(1506),
    [sym__raw_string_literal] = ACTIONS(1506),
    [sym__external_else] = ACTIONS(1506),
    [sym__external_open_parenthesis] = ACTIONS(1506),
    [sym__external_open_brace] = ACTIONS(1506),
    [sym__external_open_bracket] = ACTIONS(1506),
    [sym__external_open_bracket2] = ACTIONS(1506),
  },
  [773] = {
    [ts_builtin_sym_end] = ACTIONS(1510),
    [sym_identifier] = ACTIONS(1508),
    [anon_sym_BSLASH] = ACTIONS(1510),
    [anon_sym_function] = ACTIONS(1508),
    [anon_sym_EQ] = ACTIONS(1508),
    [anon_sym_if] = ACTIONS(1508),
    [anon_sym_for] = ACTIONS(1508),
    [anon_sym_while] = ACTIONS(1508),
    [anon_sym_repeat] = ACTIONS(1508),
    [anon_sym_QMARK] = ACTIONS(1510),
    [anon_sym_TILDE] = ACTIONS(1510),
    [anon_sym_BANG] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1510),
    [anon_sym_DASH] = ACTIONS(1508),
    [anon_sym_LT_DASH] = ACTIONS(1510),
    [anon_sym_LT_LT_DASH] = ACTIONS(1510),
    [anon_sym_COLON_EQ] = ACTIONS(1510),
    [anon_sym_DASH_GT] = ACTIONS(1508),
    [anon_sym_DASH_GT_GT] = ACTIONS(1510),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PIPE_PIPE] = ACTIONS(1510),
    [anon_sym_AMP_AMP] = ACTIONS(1510),
    [anon_sym_LT] = ACTIONS(1508),
    [anon_sym_LT_EQ] = ACTIONS(1510),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_GT_EQ] = ACTIONS(1510),
    [anon_sym_EQ_EQ] = ACTIONS(1510),
    [anon_sym_BANG_EQ] = ACTIONS(1510),
    [anon_sym_STAR] = ACTIONS(1508),
    [anon_sym_SLASH] = ACTIONS(1510),
    [anon_sym_STAR_STAR] = ACTIONS(1510),
    [anon_sym_CARET] = ACTIONS(1510),
    [aux_sym_binary_operator_token1] = ACTIONS(1510),
    [anon_sym_PIPE_GT] = ACTIONS(1510),
    [anon_sym_COLON] = ACTIONS(1508),
    [anon_sym_DOLLAR] = ACTIONS(1510),
    [anon_sym_AT] = ACTIONS(1510),
    [sym__hex_literal] = ACTIONS(1510),
    [sym__number_literal] = ACTIONS(1508),
    [anon_sym_SQUOTE] = ACTIONS(1510),
    [anon_sym_DQUOTE] = ACTIONS(1510),
    [sym_return] = ACTIONS(1508),
    [sym_next] = ACTIONS(1508),
    [sym_break] = ACTIONS(1508),
    [sym_true] = ACTIONS(1508),
    [sym_false] = ACTIONS(1508),
    [sym_null] = ACTIONS(1508),
    [sym_inf] = ACTIONS(1508),
    [sym_nan] = ACTIONS(1508),
    [anon_sym_NA] = ACTIONS(1508),
    [anon_sym_NA_integer_] = ACTIONS(1508),
    [anon_sym_NA_real_] = ACTIONS(1508),
    [anon_sym_NA_complex_] = ACTIONS(1508),
    [anon_sym_NA_character_] = ACTIONS(1508),
    [sym_dots] = ACTIONS(1508),
    [sym_dot_dot_i] = ACTIONS(1510),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1510),
    [sym__semicolon] = ACTIONS(1510),
    [sym__raw_string_literal] = ACTIONS(1510),
    [sym__external_else] = ACTIONS(1510),
    [sym__external_open_parenthesis] = ACTIONS(1510),
    [sym__external_open_brace] = ACTIONS(1510),
    [sym__external_open_bracket] = ACTIONS(1510),
    [sym__external_open_bracket2] = ACTIONS(1510),
  },
  [774] = {
    [sym_identifier] = ACTIONS(1500),
    [anon_sym_BSLASH] = ACTIONS(1502),
    [anon_sym_function] = ACTIONS(1500),
    [anon_sym_EQ] = ACTIONS(1500),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_for] = ACTIONS(1500),
    [anon_sym_while] = ACTIONS(1500),
    [anon_sym_repeat] = ACTIONS(1500),
    [anon_sym_QMARK] = ACTIONS(1502),
    [anon_sym_TILDE] = ACTIONS(1502),
    [anon_sym_BANG] = ACTIONS(1500),
    [anon_sym_PLUS] = ACTIONS(1502),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_LT_DASH] = ACTIONS(1502),
    [anon_sym_LT_LT_DASH] = ACTIONS(1502),
    [anon_sym_COLON_EQ] = ACTIONS(1502),
    [anon_sym_DASH_GT] = ACTIONS(1500),
    [anon_sym_DASH_GT_GT] = ACTIONS(1502),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_AMP] = ACTIONS(1500),
    [anon_sym_PIPE_PIPE] = ACTIONS(1502),
    [anon_sym_AMP_AMP] = ACTIONS(1502),
    [anon_sym_LT] = ACTIONS(1500),
    [anon_sym_LT_EQ] = ACTIONS(1502),
    [anon_sym_GT] = ACTIONS(1500),
    [anon_sym_GT_EQ] = ACTIONS(1502),
    [anon_sym_EQ_EQ] = ACTIONS(1502),
    [anon_sym_BANG_EQ] = ACTIONS(1502),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1502),
    [anon_sym_STAR_STAR] = ACTIONS(1502),
    [anon_sym_CARET] = ACTIONS(1502),
    [aux_sym_binary_operator_token1] = ACTIONS(1502),
    [anon_sym_PIPE_GT] = ACTIONS(1502),
    [anon_sym_COLON] = ACTIONS(1500),
    [anon_sym_DOLLAR] = ACTIONS(1502),
    [anon_sym_AT] = ACTIONS(1502),
    [sym__hex_literal] = ACTIONS(1502),
    [sym__number_literal] = ACTIONS(1500),
    [anon_sym_SQUOTE] = ACTIONS(1502),
    [anon_sym_DQUOTE] = ACTIONS(1502),
    [sym_return] = ACTIONS(1500),
    [sym_next] = ACTIONS(1500),
    [sym_break] = ACTIONS(1500),
    [sym_true] = ACTIONS(1500),
    [sym_false] = ACTIONS(1500),
    [sym_null] = ACTIONS(1500),
    [sym_inf] = ACTIONS(1500),
    [sym_nan] = ACTIONS(1500),
    [anon_sym_NA] = ACTIONS(1500),
    [anon_sym_NA_integer_] = ACTIONS(1500),
    [anon_sym_NA_real_] = ACTIONS(1500),
    [anon_sym_NA_complex_] = ACTIONS(1500),
    [anon_sym_NA_character_] = ACTIONS(1500),
    [sym_dots] = ACTIONS(1500),
    [sym_dot_dot_i] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1502),
    [sym__semicolon] = ACTIONS(1502),
    [sym__raw_string_literal] = ACTIONS(1502),
    [sym__external_else] = ACTIONS(1502),
    [sym__external_open_parenthesis] = ACTIONS(1502),
    [sym__external_open_brace] = ACTIONS(1502),
    [sym__external_close_brace] = ACTIONS(1502),
    [sym__external_open_bracket] = ACTIONS(1502),
    [sym__external_open_bracket2] = ACTIONS(1502),
  },
  [775] = {
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_BSLASH] = ACTIONS(1506),
    [anon_sym_function] = ACTIONS(1504),
    [anon_sym_EQ] = ACTIONS(1504),
    [anon_sym_if] = ACTIONS(1504),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1504),
    [anon_sym_repeat] = ACTIONS(1504),
    [anon_sym_QMARK] = ACTIONS(1506),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_BANG] = ACTIONS(1504),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1504),
    [anon_sym_LT_DASH] = ACTIONS(1506),
    [anon_sym_LT_LT_DASH] = ACTIONS(1506),
    [anon_sym_COLON_EQ] = ACTIONS(1506),
    [anon_sym_DASH_GT] = ACTIONS(1504),
    [anon_sym_DASH_GT_GT] = ACTIONS(1506),
    [anon_sym_PIPE] = ACTIONS(1504),
    [anon_sym_AMP] = ACTIONS(1504),
    [anon_sym_PIPE_PIPE] = ACTIONS(1506),
    [anon_sym_AMP_AMP] = ACTIONS(1506),
    [anon_sym_LT] = ACTIONS(1504),
    [anon_sym_LT_EQ] = ACTIONS(1506),
    [anon_sym_GT] = ACTIONS(1504),
    [anon_sym_GT_EQ] = ACTIONS(1506),
    [anon_sym_EQ_EQ] = ACTIONS(1506),
    [anon_sym_BANG_EQ] = ACTIONS(1506),
    [anon_sym_STAR] = ACTIONS(1504),
    [anon_sym_SLASH] = ACTIONS(1506),
    [anon_sym_STAR_STAR] = ACTIONS(1506),
    [anon_sym_CARET] = ACTIONS(1506),
    [aux_sym_binary_operator_token1] = ACTIONS(1506),
    [anon_sym_PIPE_GT] = ACTIONS(1506),
    [anon_sym_COLON] = ACTIONS(1504),
    [anon_sym_DOLLAR] = ACTIONS(1506),
    [anon_sym_AT] = ACTIONS(1506),
    [sym__hex_literal] = ACTIONS(1506),
    [sym__number_literal] = ACTIONS(1504),
    [anon_sym_SQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1506),
    [sym_return] = ACTIONS(1504),
    [sym_next] = ACTIONS(1504),
    [sym_break] = ACTIONS(1504),
    [sym_true] = ACTIONS(1504),
    [sym_false] = ACTIONS(1504),
    [sym_null] = ACTIONS(1504),
    [sym_inf] = ACTIONS(1504),
    [sym_nan] = ACTIONS(1504),
    [anon_sym_NA] = ACTIONS(1504),
    [anon_sym_NA_integer_] = ACTIONS(1504),
    [anon_sym_NA_real_] = ACTIONS(1504),
    [anon_sym_NA_complex_] = ACTIONS(1504),
    [anon_sym_NA_character_] = ACTIONS(1504),
    [sym_dots] = ACTIONS(1504),
    [sym_dot_dot_i] = ACTIONS(1506),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1506),
    [sym__semicolon] = ACTIONS(1506),
    [sym__raw_string_literal] = ACTIONS(1506),
    [sym__external_else] = ACTIONS(1506),
    [sym__external_open_parenthesis] = ACTIONS(1506),
    [sym__external_open_brace] = ACTIONS(1506),
    [sym__external_close_brace] = ACTIONS(1506),
    [sym__external_open_bracket] = ACTIONS(1506),
    [sym__external_open_bracket2] = ACTIONS(1506),
  },
  [776] = {
    [sym_identifier] = ACTIONS(1508),
    [anon_sym_BSLASH] = ACTIONS(1510),
    [anon_sym_function] = ACTIONS(1508),
    [anon_sym_EQ] = ACTIONS(1508),
    [anon_sym_if] = ACTIONS(1508),
    [anon_sym_for] = ACTIONS(1508),
    [anon_sym_while] = ACTIONS(1508),
    [anon_sym_repeat] = ACTIONS(1508),
    [anon_sym_QMARK] = ACTIONS(1510),
    [anon_sym_TILDE] = ACTIONS(1510),
    [anon_sym_BANG] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1510),
    [anon_sym_DASH] = ACTIONS(1508),
    [anon_sym_LT_DASH] = ACTIONS(1510),
    [anon_sym_LT_LT_DASH] = ACTIONS(1510),
    [anon_sym_COLON_EQ] = ACTIONS(1510),
    [anon_sym_DASH_GT] = ACTIONS(1508),
    [anon_sym_DASH_GT_GT] = ACTIONS(1510),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PIPE_PIPE] = ACTIONS(1510),
    [anon_sym_AMP_AMP] = ACTIONS(1510),
    [anon_sym_LT] = ACTIONS(1508),
    [anon_sym_LT_EQ] = ACTIONS(1510),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_GT_EQ] = ACTIONS(1510),
    [anon_sym_EQ_EQ] = ACTIONS(1510),
    [anon_sym_BANG_EQ] = ACTIONS(1510),
    [anon_sym_STAR] = ACTIONS(1508),
    [anon_sym_SLASH] = ACTIONS(1510),
    [anon_sym_STAR_STAR] = ACTIONS(1510),
    [anon_sym_CARET] = ACTIONS(1510),
    [aux_sym_binary_operator_token1] = ACTIONS(1510),
    [anon_sym_PIPE_GT] = ACTIONS(1510),
    [anon_sym_COLON] = ACTIONS(1508),
    [anon_sym_DOLLAR] = ACTIONS(1510),
    [anon_sym_AT] = ACTIONS(1510),
    [sym__hex_literal] = ACTIONS(1510),
    [sym__number_literal] = ACTIONS(1508),
    [anon_sym_SQUOTE] = ACTIONS(1510),
    [anon_sym_DQUOTE] = ACTIONS(1510),
    [sym_return] = ACTIONS(1508),
    [sym_next] = ACTIONS(1508),
    [sym_break] = ACTIONS(1508),
    [sym_true] = ACTIONS(1508),
    [sym_false] = ACTIONS(1508),
    [sym_null] = ACTIONS(1508),
    [sym_inf] = ACTIONS(1508),
    [sym_nan] = ACTIONS(1508),
    [anon_sym_NA] = ACTIONS(1508),
    [anon_sym_NA_integer_] = ACTIONS(1508),
    [anon_sym_NA_real_] = ACTIONS(1508),
    [anon_sym_NA_complex_] = ACTIONS(1508),
    [anon_sym_NA_character_] = ACTIONS(1508),
    [sym_dots] = ACTIONS(1508),
    [sym_dot_dot_i] = ACTIONS(1510),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1510),
    [sym__semicolon] = ACTIONS(1510),
    [sym__raw_string_literal] = ACTIONS(1510),
    [sym__external_else] = ACTIONS(1510),
    [sym__external_open_parenthesis] = ACTIONS(1510),
    [sym__external_open_brace] = ACTIONS(1510),
    [sym__external_close_brace] = ACTIONS(1510),
    [sym__external_open_bracket] = ACTIONS(1510),
    [sym__external_open_bracket2] = ACTIONS(1510),
  },
  [777] = {
    [sym_identifier] = ACTIONS(1535),
    [anon_sym_BSLASH] = ACTIONS(1537),
    [anon_sym_function] = ACTIONS(1535),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_if] = ACTIONS(1535),
    [anon_sym_for] = ACTIONS(1535),
    [anon_sym_while] = ACTIONS(1535),
    [anon_sym_repeat] = ACTIONS(1535),
    [anon_sym_QMARK] = ACTIONS(1537),
    [anon_sym_TILDE] = ACTIONS(1537),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1535),
    [anon_sym_LT_DASH] = ACTIONS(1537),
    [anon_sym_LT_LT_DASH] = ACTIONS(1537),
    [anon_sym_COLON_EQ] = ACTIONS(1537),
    [anon_sym_DASH_GT] = ACTIONS(1535),
    [anon_sym_DASH_GT_GT] = ACTIONS(1537),
    [anon_sym_PIPE] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_PIPE_PIPE] = ACTIONS(1537),
    [anon_sym_AMP_AMP] = ACTIONS(1537),
    [anon_sym_LT] = ACTIONS(1535),
    [anon_sym_LT_EQ] = ACTIONS(1537),
    [anon_sym_GT] = ACTIONS(1535),
    [anon_sym_GT_EQ] = ACTIONS(1537),
    [anon_sym_EQ_EQ] = ACTIONS(1537),
    [anon_sym_BANG_EQ] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_SLASH] = ACTIONS(1537),
    [anon_sym_STAR_STAR] = ACTIONS(1537),
    [anon_sym_CARET] = ACTIONS(1537),
    [aux_sym_binary_operator_token1] = ACTIONS(1537),
    [anon_sym_PIPE_GT] = ACTIONS(1537),
    [anon_sym_COLON] = ACTIONS(1535),
    [anon_sym_DOLLAR] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(1537),
    [sym__hex_literal] = ACTIONS(1537),
    [sym__number_literal] = ACTIONS(1535),
    [anon_sym_SQUOTE] = ACTIONS(1537),
    [anon_sym_DQUOTE] = ACTIONS(1537),
    [sym_return] = ACTIONS(1535),
    [sym_next] = ACTIONS(1535),
    [sym_break] = ACTIONS(1535),
    [sym_true] = ACTIONS(1535),
    [sym_false] = ACTIONS(1535),
    [sym_null] = ACTIONS(1535),
    [sym_inf] = ACTIONS(1535),
    [sym_nan] = ACTIONS(1535),
    [anon_sym_NA] = ACTIONS(1535),
    [anon_sym_NA_integer_] = ACTIONS(1535),
    [anon_sym_NA_real_] = ACTIONS(1535),
    [anon_sym_NA_complex_] = ACTIONS(1535),
    [anon_sym_NA_character_] = ACTIONS(1535),
    [sym_dots] = ACTIONS(1535),
    [sym_dot_dot_i] = ACTIONS(1537),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1537),
    [sym__semicolon] = ACTIONS(1537),
    [sym__raw_string_literal] = ACTIONS(1537),
    [sym__external_else] = ACTIONS(1537),
    [sym__external_open_parenthesis] = ACTIONS(1537),
    [sym__external_open_brace] = ACTIONS(1537),
    [sym__external_close_brace] = ACTIONS(1537),
    [sym__external_open_bracket] = ACTIONS(1537),
    [sym__external_open_bracket2] = ACTIONS(1537),
  },
  [778] = {
    [ts_builtin_sym_end] = ACTIONS(1517),
    [sym_identifier] = ACTIONS(1515),
    [anon_sym_BSLASH] = ACTIONS(1517),
    [anon_sym_function] = ACTIONS(1515),
    [anon_sym_EQ] = ACTIONS(1515),
    [anon_sym_if] = ACTIONS(1515),
    [anon_sym_for] = ACTIONS(1515),
    [anon_sym_while] = ACTIONS(1515),
    [anon_sym_repeat] = ACTIONS(1515),
    [anon_sym_QMARK] = ACTIONS(1517),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_DASH] = ACTIONS(1515),
    [anon_sym_LT_DASH] = ACTIONS(1517),
    [anon_sym_LT_LT_DASH] = ACTIONS(1517),
    [anon_sym_COLON_EQ] = ACTIONS(1517),
    [anon_sym_DASH_GT] = ACTIONS(1515),
    [anon_sym_DASH_GT_GT] = ACTIONS(1517),
    [anon_sym_PIPE] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_PIPE_PIPE] = ACTIONS(1517),
    [anon_sym_AMP_AMP] = ACTIONS(1517),
    [anon_sym_LT] = ACTIONS(1515),
    [anon_sym_LT_EQ] = ACTIONS(1517),
    [anon_sym_GT] = ACTIONS(1515),
    [anon_sym_GT_EQ] = ACTIONS(1517),
    [anon_sym_EQ_EQ] = ACTIONS(1517),
    [anon_sym_BANG_EQ] = ACTIONS(1517),
    [anon_sym_STAR] = ACTIONS(1515),
    [anon_sym_SLASH] = ACTIONS(1517),
    [anon_sym_STAR_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [aux_sym_binary_operator_token1] = ACTIONS(1517),
    [anon_sym_PIPE_GT] = ACTIONS(1517),
    [anon_sym_COLON] = ACTIONS(1515),
    [anon_sym_DOLLAR] = ACTIONS(1517),
    [anon_sym_AT] = ACTIONS(1517),
    [sym__hex_literal] = ACTIONS(1517),
    [sym__number_literal] = ACTIONS(1515),
    [anon_sym_SQUOTE] = ACTIONS(1517),
    [anon_sym_DQUOTE] = ACTIONS(1517),
    [sym_return] = ACTIONS(1515),
    [sym_next] = ACTIONS(1515),
    [sym_break] = ACTIONS(1515),
    [sym_true] = ACTIONS(1515),
    [sym_false] = ACTIONS(1515),
    [sym_null] = ACTIONS(1515),
    [sym_inf] = ACTIONS(1515),
    [sym_nan] = ACTIONS(1515),
    [anon_sym_NA] = ACTIONS(1515),
    [anon_sym_NA_integer_] = ACTIONS(1515),
    [anon_sym_NA_real_] = ACTIONS(1515),
    [anon_sym_NA_complex_] = ACTIONS(1515),
    [anon_sym_NA_character_] = ACTIONS(1515),
    [sym_dots] = ACTIONS(1515),
    [sym_dot_dot_i] = ACTIONS(1517),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1517),
    [sym__semicolon] = ACTIONS(1517),
    [sym__raw_string_literal] = ACTIONS(1517),
    [sym__external_else] = ACTIONS(1517),
    [sym__external_open_parenthesis] = ACTIONS(1517),
    [sym__external_open_brace] = ACTIONS(1517),
    [sym__external_open_bracket] = ACTIONS(1517),
    [sym__external_open_bracket2] = ACTIONS(1517),
  },
  [779] = {
    [sym_identifier] = ACTIONS(1515),
    [anon_sym_BSLASH] = ACTIONS(1517),
    [anon_sym_function] = ACTIONS(1515),
    [anon_sym_EQ] = ACTIONS(1515),
    [anon_sym_if] = ACTIONS(1515),
    [anon_sym_for] = ACTIONS(1515),
    [anon_sym_while] = ACTIONS(1515),
    [anon_sym_repeat] = ACTIONS(1515),
    [anon_sym_QMARK] = ACTIONS(1517),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_DASH] = ACTIONS(1515),
    [anon_sym_LT_DASH] = ACTIONS(1517),
    [anon_sym_LT_LT_DASH] = ACTIONS(1517),
    [anon_sym_COLON_EQ] = ACTIONS(1517),
    [anon_sym_DASH_GT] = ACTIONS(1515),
    [anon_sym_DASH_GT_GT] = ACTIONS(1517),
    [anon_sym_PIPE] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_PIPE_PIPE] = ACTIONS(1517),
    [anon_sym_AMP_AMP] = ACTIONS(1517),
    [anon_sym_LT] = ACTIONS(1515),
    [anon_sym_LT_EQ] = ACTIONS(1517),
    [anon_sym_GT] = ACTIONS(1515),
    [anon_sym_GT_EQ] = ACTIONS(1517),
    [anon_sym_EQ_EQ] = ACTIONS(1517),
    [anon_sym_BANG_EQ] = ACTIONS(1517),
    [anon_sym_STAR] = ACTIONS(1515),
    [anon_sym_SLASH] = ACTIONS(1517),
    [anon_sym_STAR_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [aux_sym_binary_operator_token1] = ACTIONS(1517),
    [anon_sym_PIPE_GT] = ACTIONS(1517),
    [anon_sym_COLON] = ACTIONS(1515),
    [anon_sym_DOLLAR] = ACTIONS(1517),
    [anon_sym_AT] = ACTIONS(1517),
    [sym__hex_literal] = ACTIONS(1517),
    [sym__number_literal] = ACTIONS(1515),
    [anon_sym_SQUOTE] = ACTIONS(1517),
    [anon_sym_DQUOTE] = ACTIONS(1517),
    [sym_return] = ACTIONS(1515),
    [sym_next] = ACTIONS(1515),
    [sym_break] = ACTIONS(1515),
    [sym_true] = ACTIONS(1515),
    [sym_false] = ACTIONS(1515),
    [sym_null] = ACTIONS(1515),
    [sym_inf] = ACTIONS(1515),
    [sym_nan] = ACTIONS(1515),
    [anon_sym_NA] = ACTIONS(1515),
    [anon_sym_NA_integer_] = ACTIONS(1515),
    [anon_sym_NA_real_] = ACTIONS(1515),
    [anon_sym_NA_complex_] = ACTIONS(1515),
    [anon_sym_NA_character_] = ACTIONS(1515),
    [sym_dots] = ACTIONS(1515),
    [sym_dot_dot_i] = ACTIONS(1517),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1517),
    [sym__semicolon] = ACTIONS(1517),
    [sym__raw_string_literal] = ACTIONS(1517),
    [sym__external_else] = ACTIONS(1517),
    [sym__external_open_parenthesis] = ACTIONS(1517),
    [sym__external_open_brace] = ACTIONS(1517),
    [sym__external_close_brace] = ACTIONS(1517),
    [sym__external_open_bracket] = ACTIONS(1517),
    [sym__external_open_bracket2] = ACTIONS(1517),
  },
  [780] = {
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_BSLASH] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1539),
    [anon_sym_if] = ACTIONS(1539),
    [anon_sym_for] = ACTIONS(1539),
    [anon_sym_while] = ACTIONS(1539),
    [anon_sym_repeat] = ACTIONS(1539),
    [anon_sym_QMARK] = ACTIONS(1541),
    [anon_sym_TILDE] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1539),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1539),
    [anon_sym_LT_DASH] = ACTIONS(1541),
    [anon_sym_LT_LT_DASH] = ACTIONS(1541),
    [anon_sym_COLON_EQ] = ACTIONS(1541),
    [anon_sym_DASH_GT] = ACTIONS(1539),
    [anon_sym_DASH_GT_GT] = ACTIONS(1541),
    [anon_sym_PIPE] = ACTIONS(1539),
    [anon_sym_AMP] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1541),
    [anon_sym_GT] = ACTIONS(1539),
    [anon_sym_GT_EQ] = ACTIONS(1541),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1539),
    [anon_sym_SLASH] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_CARET] = ACTIONS(1541),
    [aux_sym_binary_operator_token1] = ACTIONS(1541),
    [anon_sym_PIPE_GT] = ACTIONS(1541),
    [anon_sym_COLON] = ACTIONS(1539),
    [anon_sym_DOLLAR] = ACTIONS(1541),
    [anon_sym_AT] = ACTIONS(1541),
    [sym__hex_literal] = ACTIONS(1541),
    [sym__number_literal] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(1541),
    [anon_sym_DQUOTE] = ACTIONS(1541),
    [sym_return] = ACTIONS(1539),
    [sym_next] = ACTIONS(1539),
    [sym_break] = ACTIONS(1539),
    [sym_true] = ACTIONS(1539),
    [sym_false] = ACTIONS(1539),
    [sym_null] = ACTIONS(1539),
    [sym_inf] = ACTIONS(1539),
    [sym_nan] = ACTIONS(1539),
    [anon_sym_NA] = ACTIONS(1539),
    [anon_sym_NA_integer_] = ACTIONS(1539),
    [anon_sym_NA_real_] = ACTIONS(1539),
    [anon_sym_NA_complex_] = ACTIONS(1539),
    [anon_sym_NA_character_] = ACTIONS(1539),
    [sym_dots] = ACTIONS(1539),
    [sym_dot_dot_i] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1541),
    [sym__newline] = ACTIONS(1541),
    [sym__raw_string_literal] = ACTIONS(1541),
    [sym__external_else] = ACTIONS(1541),
    [sym__external_open_parenthesis] = ACTIONS(1541),
    [sym__external_open_brace] = ACTIONS(1541),
    [sym__external_open_bracket] = ACTIONS(1541),
    [sym__external_close_bracket] = ACTIONS(1541),
    [sym__external_open_bracket2] = ACTIONS(1541),
  },
  [781] = {
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_BSLASH] = ACTIONS(1545),
    [anon_sym_function] = ACTIONS(1543),
    [anon_sym_EQ] = ACTIONS(1543),
    [anon_sym_if] = ACTIONS(1543),
    [anon_sym_for] = ACTIONS(1543),
    [anon_sym_while] = ACTIONS(1543),
    [anon_sym_repeat] = ACTIONS(1543),
    [anon_sym_QMARK] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1543),
    [anon_sym_PLUS] = ACTIONS(1545),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_LT_DASH] = ACTIONS(1545),
    [anon_sym_LT_LT_DASH] = ACTIONS(1545),
    [anon_sym_COLON_EQ] = ACTIONS(1545),
    [anon_sym_DASH_GT] = ACTIONS(1543),
    [anon_sym_DASH_GT_GT] = ACTIONS(1545),
    [anon_sym_PIPE] = ACTIONS(1543),
    [anon_sym_AMP] = ACTIONS(1543),
    [anon_sym_PIPE_PIPE] = ACTIONS(1545),
    [anon_sym_AMP_AMP] = ACTIONS(1545),
    [anon_sym_LT] = ACTIONS(1543),
    [anon_sym_LT_EQ] = ACTIONS(1545),
    [anon_sym_GT] = ACTIONS(1543),
    [anon_sym_GT_EQ] = ACTIONS(1545),
    [anon_sym_EQ_EQ] = ACTIONS(1545),
    [anon_sym_BANG_EQ] = ACTIONS(1545),
    [anon_sym_STAR] = ACTIONS(1543),
    [anon_sym_SLASH] = ACTIONS(1545),
    [anon_sym_STAR_STAR] = ACTIONS(1545),
    [anon_sym_CARET] = ACTIONS(1545),
    [aux_sym_binary_operator_token1] = ACTIONS(1545),
    [anon_sym_PIPE_GT] = ACTIONS(1545),
    [anon_sym_COLON] = ACTIONS(1543),
    [anon_sym_DOLLAR] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(1545),
    [sym__hex_literal] = ACTIONS(1545),
    [sym__number_literal] = ACTIONS(1543),
    [anon_sym_SQUOTE] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1545),
    [sym_return] = ACTIONS(1543),
    [sym_next] = ACTIONS(1543),
    [sym_break] = ACTIONS(1543),
    [sym_true] = ACTIONS(1543),
    [sym_false] = ACTIONS(1543),
    [sym_null] = ACTIONS(1543),
    [sym_inf] = ACTIONS(1543),
    [sym_nan] = ACTIONS(1543),
    [anon_sym_NA] = ACTIONS(1543),
    [anon_sym_NA_integer_] = ACTIONS(1543),
    [anon_sym_NA_real_] = ACTIONS(1543),
    [anon_sym_NA_complex_] = ACTIONS(1543),
    [anon_sym_NA_character_] = ACTIONS(1543),
    [sym_dots] = ACTIONS(1543),
    [sym_dot_dot_i] = ACTIONS(1545),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1545),
    [sym__newline] = ACTIONS(1545),
    [sym__raw_string_literal] = ACTIONS(1545),
    [sym__external_else] = ACTIONS(1545),
    [sym__external_open_parenthesis] = ACTIONS(1545),
    [sym__external_open_brace] = ACTIONS(1545),
    [sym__external_open_bracket] = ACTIONS(1545),
    [sym__external_close_bracket] = ACTIONS(1545),
    [sym__external_open_bracket2] = ACTIONS(1545),
  },
  [782] = {
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_BSLASH] = ACTIONS(1549),
    [anon_sym_function] = ACTIONS(1547),
    [anon_sym_EQ] = ACTIONS(1547),
    [anon_sym_if] = ACTIONS(1547),
    [anon_sym_for] = ACTIONS(1547),
    [anon_sym_while] = ACTIONS(1547),
    [anon_sym_repeat] = ACTIONS(1547),
    [anon_sym_QMARK] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1547),
    [anon_sym_LT_DASH] = ACTIONS(1549),
    [anon_sym_LT_LT_DASH] = ACTIONS(1549),
    [anon_sym_COLON_EQ] = ACTIONS(1549),
    [anon_sym_DASH_GT] = ACTIONS(1547),
    [anon_sym_DASH_GT_GT] = ACTIONS(1549),
    [anon_sym_PIPE] = ACTIONS(1547),
    [anon_sym_AMP] = ACTIONS(1547),
    [anon_sym_PIPE_PIPE] = ACTIONS(1549),
    [anon_sym_AMP_AMP] = ACTIONS(1549),
    [anon_sym_LT] = ACTIONS(1547),
    [anon_sym_LT_EQ] = ACTIONS(1549),
    [anon_sym_GT] = ACTIONS(1547),
    [anon_sym_GT_EQ] = ACTIONS(1549),
    [anon_sym_EQ_EQ] = ACTIONS(1549),
    [anon_sym_BANG_EQ] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_SLASH] = ACTIONS(1549),
    [anon_sym_STAR_STAR] = ACTIONS(1549),
    [anon_sym_CARET] = ACTIONS(1549),
    [aux_sym_binary_operator_token1] = ACTIONS(1549),
    [anon_sym_PIPE_GT] = ACTIONS(1549),
    [anon_sym_COLON] = ACTIONS(1547),
    [anon_sym_DOLLAR] = ACTIONS(1549),
    [anon_sym_AT] = ACTIONS(1549),
    [sym__hex_literal] = ACTIONS(1549),
    [sym__number_literal] = ACTIONS(1547),
    [anon_sym_SQUOTE] = ACTIONS(1549),
    [anon_sym_DQUOTE] = ACTIONS(1549),
    [sym_return] = ACTIONS(1547),
    [sym_next] = ACTIONS(1547),
    [sym_break] = ACTIONS(1547),
    [sym_true] = ACTIONS(1547),
    [sym_false] = ACTIONS(1547),
    [sym_null] = ACTIONS(1547),
    [sym_inf] = ACTIONS(1547),
    [sym_nan] = ACTIONS(1547),
    [anon_sym_NA] = ACTIONS(1547),
    [anon_sym_NA_integer_] = ACTIONS(1547),
    [anon_sym_NA_real_] = ACTIONS(1547),
    [anon_sym_NA_complex_] = ACTIONS(1547),
    [anon_sym_NA_character_] = ACTIONS(1547),
    [sym_dots] = ACTIONS(1547),
    [sym_dot_dot_i] = ACTIONS(1549),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1549),
    [sym__newline] = ACTIONS(1549),
    [sym__raw_string_literal] = ACTIONS(1549),
    [sym__external_else] = ACTIONS(1549),
    [sym__external_open_parenthesis] = ACTIONS(1549),
    [sym__external_open_brace] = ACTIONS(1549),
    [sym__external_open_bracket] = ACTIONS(1549),
    [sym__external_close_bracket] = ACTIONS(1549),
    [sym__external_open_bracket2] = ACTIONS(1549),
  },
  [783] = {
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_BSLASH] = ACTIONS(1494),
    [anon_sym_function] = ACTIONS(1492),
    [anon_sym_EQ] = ACTIONS(1492),
    [anon_sym_if] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(1492),
    [anon_sym_while] = ACTIONS(1492),
    [anon_sym_repeat] = ACTIONS(1492),
    [anon_sym_QMARK] = ACTIONS(1494),
    [anon_sym_TILDE] = ACTIONS(1494),
    [anon_sym_BANG] = ACTIONS(1492),
    [anon_sym_PLUS] = ACTIONS(1494),
    [anon_sym_DASH] = ACTIONS(1492),
    [anon_sym_LT_DASH] = ACTIONS(1494),
    [anon_sym_LT_LT_DASH] = ACTIONS(1494),
    [anon_sym_COLON_EQ] = ACTIONS(1494),
    [anon_sym_DASH_GT] = ACTIONS(1492),
    [anon_sym_DASH_GT_GT] = ACTIONS(1494),
    [anon_sym_PIPE] = ACTIONS(1492),
    [anon_sym_AMP] = ACTIONS(1492),
    [anon_sym_PIPE_PIPE] = ACTIONS(1494),
    [anon_sym_AMP_AMP] = ACTIONS(1494),
    [anon_sym_LT] = ACTIONS(1492),
    [anon_sym_LT_EQ] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1492),
    [anon_sym_GT_EQ] = ACTIONS(1494),
    [anon_sym_EQ_EQ] = ACTIONS(1494),
    [anon_sym_BANG_EQ] = ACTIONS(1494),
    [anon_sym_STAR] = ACTIONS(1492),
    [anon_sym_SLASH] = ACTIONS(1494),
    [anon_sym_STAR_STAR] = ACTIONS(1494),
    [anon_sym_CARET] = ACTIONS(1494),
    [aux_sym_binary_operator_token1] = ACTIONS(1494),
    [anon_sym_PIPE_GT] = ACTIONS(1494),
    [anon_sym_COLON] = ACTIONS(1492),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [anon_sym_AT] = ACTIONS(1494),
    [sym__hex_literal] = ACTIONS(1494),
    [sym__number_literal] = ACTIONS(1492),
    [anon_sym_SQUOTE] = ACTIONS(1494),
    [anon_sym_DQUOTE] = ACTIONS(1494),
    [sym_return] = ACTIONS(1492),
    [sym_next] = ACTIONS(1492),
    [sym_break] = ACTIONS(1492),
    [sym_true] = ACTIONS(1492),
    [sym_false] = ACTIONS(1492),
    [sym_null] = ACTIONS(1492),
    [sym_inf] = ACTIONS(1492),
    [sym_nan] = ACTIONS(1492),
    [anon_sym_NA] = ACTIONS(1492),
    [anon_sym_NA_integer_] = ACTIONS(1492),
    [anon_sym_NA_real_] = ACTIONS(1492),
    [anon_sym_NA_complex_] = ACTIONS(1492),
    [anon_sym_NA_character_] = ACTIONS(1492),
    [sym_dots] = ACTIONS(1492),
    [sym_dot_dot_i] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1494),
    [sym__newline] = ACTIONS(1494),
    [sym__raw_string_literal] = ACTIONS(1494),
    [sym__external_else] = ACTIONS(1494),
    [sym__external_open_parenthesis] = ACTIONS(1494),
    [sym__external_open_brace] = ACTIONS(1494),
    [sym__external_open_bracket] = ACTIONS(1494),
    [sym__external_close_bracket] = ACTIONS(1494),
    [sym__external_open_bracket2] = ACTIONS(1494),
  },
  [784] = {
    [ts_builtin_sym_end] = ACTIONS(1521),
    [sym_identifier] = ACTIONS(1519),
    [anon_sym_BSLASH] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(1519),
    [anon_sym_EQ] = ACTIONS(1519),
    [anon_sym_if] = ACTIONS(1519),
    [anon_sym_for] = ACTIONS(1519),
    [anon_sym_while] = ACTIONS(1519),
    [anon_sym_repeat] = ACTIONS(1519),
    [anon_sym_QMARK] = ACTIONS(1521),
    [anon_sym_TILDE] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1519),
    [anon_sym_PLUS] = ACTIONS(1521),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_LT_DASH] = ACTIONS(1521),
    [anon_sym_LT_LT_DASH] = ACTIONS(1521),
    [anon_sym_COLON_EQ] = ACTIONS(1521),
    [anon_sym_DASH_GT] = ACTIONS(1519),
    [anon_sym_DASH_GT_GT] = ACTIONS(1521),
    [anon_sym_PIPE] = ACTIONS(1519),
    [anon_sym_AMP] = ACTIONS(1519),
    [anon_sym_PIPE_PIPE] = ACTIONS(1521),
    [anon_sym_AMP_AMP] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_LT_EQ] = ACTIONS(1521),
    [anon_sym_GT] = ACTIONS(1519),
    [anon_sym_GT_EQ] = ACTIONS(1521),
    [anon_sym_EQ_EQ] = ACTIONS(1521),
    [anon_sym_BANG_EQ] = ACTIONS(1521),
    [anon_sym_STAR] = ACTIONS(1519),
    [anon_sym_SLASH] = ACTIONS(1521),
    [anon_sym_STAR_STAR] = ACTIONS(1521),
    [anon_sym_CARET] = ACTIONS(1521),
    [aux_sym_binary_operator_token1] = ACTIONS(1521),
    [anon_sym_PIPE_GT] = ACTIONS(1521),
    [anon_sym_COLON] = ACTIONS(1519),
    [anon_sym_DOLLAR] = ACTIONS(1521),
    [anon_sym_AT] = ACTIONS(1521),
    [sym__hex_literal] = ACTIONS(1521),
    [sym__number_literal] = ACTIONS(1519),
    [anon_sym_SQUOTE] = ACTIONS(1521),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [sym_return] = ACTIONS(1519),
    [sym_next] = ACTIONS(1519),
    [sym_break] = ACTIONS(1519),
    [sym_true] = ACTIONS(1519),
    [sym_false] = ACTIONS(1519),
    [sym_null] = ACTIONS(1519),
    [sym_inf] = ACTIONS(1519),
    [sym_nan] = ACTIONS(1519),
    [anon_sym_NA] = ACTIONS(1519),
    [anon_sym_NA_integer_] = ACTIONS(1519),
    [anon_sym_NA_real_] = ACTIONS(1519),
    [anon_sym_NA_complex_] = ACTIONS(1519),
    [anon_sym_NA_character_] = ACTIONS(1519),
    [sym_dots] = ACTIONS(1519),
    [sym_dot_dot_i] = ACTIONS(1521),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1521),
    [sym__semicolon] = ACTIONS(1521),
    [sym__raw_string_literal] = ACTIONS(1521),
    [sym__external_else] = ACTIONS(1521),
    [sym__external_open_parenthesis] = ACTIONS(1521),
    [sym__external_open_brace] = ACTIONS(1521),
    [sym__external_open_bracket] = ACTIONS(1521),
    [sym__external_open_bracket2] = ACTIONS(1521),
  },
  [785] = {
    [ts_builtin_sym_end] = ACTIONS(1525),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_BSLASH] = ACTIONS(1525),
    [anon_sym_function] = ACTIONS(1523),
    [anon_sym_EQ] = ACTIONS(1523),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_for] = ACTIONS(1523),
    [anon_sym_while] = ACTIONS(1523),
    [anon_sym_repeat] = ACTIONS(1523),
    [anon_sym_QMARK] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(1525),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1523),
    [anon_sym_LT_DASH] = ACTIONS(1525),
    [anon_sym_LT_LT_DASH] = ACTIONS(1525),
    [anon_sym_COLON_EQ] = ACTIONS(1525),
    [anon_sym_DASH_GT] = ACTIONS(1523),
    [anon_sym_DASH_GT_GT] = ACTIONS(1525),
    [anon_sym_PIPE] = ACTIONS(1523),
    [anon_sym_AMP] = ACTIONS(1523),
    [anon_sym_PIPE_PIPE] = ACTIONS(1525),
    [anon_sym_AMP_AMP] = ACTIONS(1525),
    [anon_sym_LT] = ACTIONS(1523),
    [anon_sym_LT_EQ] = ACTIONS(1525),
    [anon_sym_GT] = ACTIONS(1523),
    [anon_sym_GT_EQ] = ACTIONS(1525),
    [anon_sym_EQ_EQ] = ACTIONS(1525),
    [anon_sym_BANG_EQ] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1523),
    [anon_sym_SLASH] = ACTIONS(1525),
    [anon_sym_STAR_STAR] = ACTIONS(1525),
    [anon_sym_CARET] = ACTIONS(1525),
    [aux_sym_binary_operator_token1] = ACTIONS(1525),
    [anon_sym_PIPE_GT] = ACTIONS(1525),
    [anon_sym_COLON] = ACTIONS(1523),
    [anon_sym_DOLLAR] = ACTIONS(1525),
    [anon_sym_AT] = ACTIONS(1525),
    [sym__hex_literal] = ACTIONS(1525),
    [sym__number_literal] = ACTIONS(1523),
    [anon_sym_SQUOTE] = ACTIONS(1525),
    [anon_sym_DQUOTE] = ACTIONS(1525),
    [sym_return] = ACTIONS(1523),
    [sym_next] = ACTIONS(1523),
    [sym_break] = ACTIONS(1523),
    [sym_true] = ACTIONS(1523),
    [sym_false] = ACTIONS(1523),
    [sym_null] = ACTIONS(1523),
    [sym_inf] = ACTIONS(1523),
    [sym_nan] = ACTIONS(1523),
    [anon_sym_NA] = ACTIONS(1523),
    [anon_sym_NA_integer_] = ACTIONS(1523),
    [anon_sym_NA_real_] = ACTIONS(1523),
    [anon_sym_NA_complex_] = ACTIONS(1523),
    [anon_sym_NA_character_] = ACTIONS(1523),
    [sym_dots] = ACTIONS(1523),
    [sym_dot_dot_i] = ACTIONS(1525),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1525),
    [sym__semicolon] = ACTIONS(1525),
    [sym__raw_string_literal] = ACTIONS(1525),
    [sym__external_else] = ACTIONS(1525),
    [sym__external_open_parenthesis] = ACTIONS(1525),
    [sym__external_open_brace] = ACTIONS(1525),
    [sym__external_open_bracket] = ACTIONS(1525),
    [sym__external_open_bracket2] = ACTIONS(1525),
  },
  [786] = {
    [ts_builtin_sym_end] = ACTIONS(1529),
    [sym_identifier] = ACTIONS(1527),
    [anon_sym_BSLASH] = ACTIONS(1529),
    [anon_sym_function] = ACTIONS(1527),
    [anon_sym_EQ] = ACTIONS(1527),
    [anon_sym_if] = ACTIONS(1527),
    [anon_sym_for] = ACTIONS(1527),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_repeat] = ACTIONS(1527),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_TILDE] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1527),
    [anon_sym_LT_DASH] = ACTIONS(1529),
    [anon_sym_LT_LT_DASH] = ACTIONS(1529),
    [anon_sym_COLON_EQ] = ACTIONS(1529),
    [anon_sym_DASH_GT] = ACTIONS(1527),
    [anon_sym_DASH_GT_GT] = ACTIONS(1529),
    [anon_sym_PIPE] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1527),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1527),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1529),
    [anon_sym_BANG_EQ] = ACTIONS(1529),
    [anon_sym_STAR] = ACTIONS(1527),
    [anon_sym_SLASH] = ACTIONS(1529),
    [anon_sym_STAR_STAR] = ACTIONS(1529),
    [anon_sym_CARET] = ACTIONS(1529),
    [aux_sym_binary_operator_token1] = ACTIONS(1529),
    [anon_sym_PIPE_GT] = ACTIONS(1529),
    [anon_sym_COLON] = ACTIONS(1527),
    [anon_sym_DOLLAR] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(1529),
    [sym__hex_literal] = ACTIONS(1529),
    [sym__number_literal] = ACTIONS(1527),
    [anon_sym_SQUOTE] = ACTIONS(1529),
    [anon_sym_DQUOTE] = ACTIONS(1529),
    [sym_return] = ACTIONS(1527),
    [sym_next] = ACTIONS(1527),
    [sym_break] = ACTIONS(1527),
    [sym_true] = ACTIONS(1527),
    [sym_false] = ACTIONS(1527),
    [sym_null] = ACTIONS(1527),
    [sym_inf] = ACTIONS(1527),
    [sym_nan] = ACTIONS(1527),
    [anon_sym_NA] = ACTIONS(1527),
    [anon_sym_NA_integer_] = ACTIONS(1527),
    [anon_sym_NA_real_] = ACTIONS(1527),
    [anon_sym_NA_complex_] = ACTIONS(1527),
    [anon_sym_NA_character_] = ACTIONS(1527),
    [sym_dots] = ACTIONS(1527),
    [sym_dot_dot_i] = ACTIONS(1529),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1529),
    [sym__semicolon] = ACTIONS(1529),
    [sym__raw_string_literal] = ACTIONS(1529),
    [sym__external_else] = ACTIONS(1529),
    [sym__external_open_parenthesis] = ACTIONS(1529),
    [sym__external_open_brace] = ACTIONS(1529),
    [sym__external_open_bracket] = ACTIONS(1529),
    [sym__external_open_bracket2] = ACTIONS(1529),
  },
  [787] = {
    [sym_identifier] = ACTIONS(1551),
    [anon_sym_BSLASH] = ACTIONS(1553),
    [anon_sym_function] = ACTIONS(1551),
    [anon_sym_EQ] = ACTIONS(1551),
    [anon_sym_if] = ACTIONS(1551),
    [anon_sym_for] = ACTIONS(1551),
    [anon_sym_while] = ACTIONS(1551),
    [anon_sym_repeat] = ACTIONS(1551),
    [anon_sym_QMARK] = ACTIONS(1553),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_PLUS] = ACTIONS(1553),
    [anon_sym_DASH] = ACTIONS(1551),
    [anon_sym_LT_DASH] = ACTIONS(1553),
    [anon_sym_LT_LT_DASH] = ACTIONS(1553),
    [anon_sym_COLON_EQ] = ACTIONS(1553),
    [anon_sym_DASH_GT] = ACTIONS(1551),
    [anon_sym_DASH_GT_GT] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_PIPE_PIPE] = ACTIONS(1553),
    [anon_sym_AMP_AMP] = ACTIONS(1553),
    [anon_sym_LT] = ACTIONS(1551),
    [anon_sym_LT_EQ] = ACTIONS(1553),
    [anon_sym_GT] = ACTIONS(1551),
    [anon_sym_GT_EQ] = ACTIONS(1553),
    [anon_sym_EQ_EQ] = ACTIONS(1553),
    [anon_sym_BANG_EQ] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(1551),
    [anon_sym_SLASH] = ACTIONS(1553),
    [anon_sym_STAR_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [aux_sym_binary_operator_token1] = ACTIONS(1553),
    [anon_sym_PIPE_GT] = ACTIONS(1553),
    [anon_sym_COLON] = ACTIONS(1551),
    [anon_sym_DOLLAR] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(1553),
    [sym__hex_literal] = ACTIONS(1553),
    [sym__number_literal] = ACTIONS(1551),
    [anon_sym_SQUOTE] = ACTIONS(1553),
    [anon_sym_DQUOTE] = ACTIONS(1553),
    [sym_return] = ACTIONS(1551),
    [sym_next] = ACTIONS(1551),
    [sym_break] = ACTIONS(1551),
    [sym_true] = ACTIONS(1551),
    [sym_false] = ACTIONS(1551),
    [sym_null] = ACTIONS(1551),
    [sym_inf] = ACTIONS(1551),
    [sym_nan] = ACTIONS(1551),
    [anon_sym_NA] = ACTIONS(1551),
    [anon_sym_NA_integer_] = ACTIONS(1551),
    [anon_sym_NA_real_] = ACTIONS(1551),
    [anon_sym_NA_complex_] = ACTIONS(1551),
    [anon_sym_NA_character_] = ACTIONS(1551),
    [sym_dots] = ACTIONS(1551),
    [sym_dot_dot_i] = ACTIONS(1553),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1553),
    [sym__semicolon] = ACTIONS(1553),
    [sym__raw_string_literal] = ACTIONS(1553),
    [sym__external_else] = ACTIONS(1553),
    [sym__external_open_parenthesis] = ACTIONS(1553),
    [sym__external_open_brace] = ACTIONS(1553),
    [sym__external_close_brace] = ACTIONS(1553),
    [sym__external_open_bracket] = ACTIONS(1553),
    [sym__external_open_bracket2] = ACTIONS(1553),
  },
  [788] = {
    [sym_identifier] = ACTIONS(1519),
    [anon_sym_BSLASH] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(1519),
    [anon_sym_EQ] = ACTIONS(1519),
    [anon_sym_if] = ACTIONS(1519),
    [anon_sym_for] = ACTIONS(1519),
    [anon_sym_while] = ACTIONS(1519),
    [anon_sym_repeat] = ACTIONS(1519),
    [anon_sym_QMARK] = ACTIONS(1521),
    [anon_sym_TILDE] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1519),
    [anon_sym_PLUS] = ACTIONS(1521),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_LT_DASH] = ACTIONS(1521),
    [anon_sym_LT_LT_DASH] = ACTIONS(1521),
    [anon_sym_COLON_EQ] = ACTIONS(1521),
    [anon_sym_DASH_GT] = ACTIONS(1519),
    [anon_sym_DASH_GT_GT] = ACTIONS(1521),
    [anon_sym_PIPE] = ACTIONS(1519),
    [anon_sym_AMP] = ACTIONS(1519),
    [anon_sym_PIPE_PIPE] = ACTIONS(1521),
    [anon_sym_AMP_AMP] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_LT_EQ] = ACTIONS(1521),
    [anon_sym_GT] = ACTIONS(1519),
    [anon_sym_GT_EQ] = ACTIONS(1521),
    [anon_sym_EQ_EQ] = ACTIONS(1521),
    [anon_sym_BANG_EQ] = ACTIONS(1521),
    [anon_sym_STAR] = ACTIONS(1519),
    [anon_sym_SLASH] = ACTIONS(1521),
    [anon_sym_STAR_STAR] = ACTIONS(1521),
    [anon_sym_CARET] = ACTIONS(1521),
    [aux_sym_binary_operator_token1] = ACTIONS(1521),
    [anon_sym_PIPE_GT] = ACTIONS(1521),
    [anon_sym_COLON] = ACTIONS(1519),
    [anon_sym_DOLLAR] = ACTIONS(1521),
    [anon_sym_AT] = ACTIONS(1521),
    [sym__hex_literal] = ACTIONS(1521),
    [sym__number_literal] = ACTIONS(1519),
    [anon_sym_SQUOTE] = ACTIONS(1521),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [sym_return] = ACTIONS(1519),
    [sym_next] = ACTIONS(1519),
    [sym_break] = ACTIONS(1519),
    [sym_true] = ACTIONS(1519),
    [sym_false] = ACTIONS(1519),
    [sym_null] = ACTIONS(1519),
    [sym_inf] = ACTIONS(1519),
    [sym_nan] = ACTIONS(1519),
    [anon_sym_NA] = ACTIONS(1519),
    [anon_sym_NA_integer_] = ACTIONS(1519),
    [anon_sym_NA_real_] = ACTIONS(1519),
    [anon_sym_NA_complex_] = ACTIONS(1519),
    [anon_sym_NA_character_] = ACTIONS(1519),
    [sym_dots] = ACTIONS(1519),
    [sym_dot_dot_i] = ACTIONS(1521),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1521),
    [sym__semicolon] = ACTIONS(1521),
    [sym__raw_string_literal] = ACTIONS(1521),
    [sym__external_else] = ACTIONS(1521),
    [sym__external_open_parenthesis] = ACTIONS(1521),
    [sym__external_open_brace] = ACTIONS(1521),
    [sym__external_close_brace] = ACTIONS(1521),
    [sym__external_open_bracket] = ACTIONS(1521),
    [sym__external_open_bracket2] = ACTIONS(1521),
  },
  [789] = {
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_BSLASH] = ACTIONS(1525),
    [anon_sym_function] = ACTIONS(1523),
    [anon_sym_EQ] = ACTIONS(1523),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_for] = ACTIONS(1523),
    [anon_sym_while] = ACTIONS(1523),
    [anon_sym_repeat] = ACTIONS(1523),
    [anon_sym_QMARK] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(1525),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1523),
    [anon_sym_LT_DASH] = ACTIONS(1525),
    [anon_sym_LT_LT_DASH] = ACTIONS(1525),
    [anon_sym_COLON_EQ] = ACTIONS(1525),
    [anon_sym_DASH_GT] = ACTIONS(1523),
    [anon_sym_DASH_GT_GT] = ACTIONS(1525),
    [anon_sym_PIPE] = ACTIONS(1523),
    [anon_sym_AMP] = ACTIONS(1523),
    [anon_sym_PIPE_PIPE] = ACTIONS(1525),
    [anon_sym_AMP_AMP] = ACTIONS(1525),
    [anon_sym_LT] = ACTIONS(1523),
    [anon_sym_LT_EQ] = ACTIONS(1525),
    [anon_sym_GT] = ACTIONS(1523),
    [anon_sym_GT_EQ] = ACTIONS(1525),
    [anon_sym_EQ_EQ] = ACTIONS(1525),
    [anon_sym_BANG_EQ] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1523),
    [anon_sym_SLASH] = ACTIONS(1525),
    [anon_sym_STAR_STAR] = ACTIONS(1525),
    [anon_sym_CARET] = ACTIONS(1525),
    [aux_sym_binary_operator_token1] = ACTIONS(1525),
    [anon_sym_PIPE_GT] = ACTIONS(1525),
    [anon_sym_COLON] = ACTIONS(1523),
    [anon_sym_DOLLAR] = ACTIONS(1525),
    [anon_sym_AT] = ACTIONS(1525),
    [sym__hex_literal] = ACTIONS(1525),
    [sym__number_literal] = ACTIONS(1523),
    [anon_sym_SQUOTE] = ACTIONS(1525),
    [anon_sym_DQUOTE] = ACTIONS(1525),
    [sym_return] = ACTIONS(1523),
    [sym_next] = ACTIONS(1523),
    [sym_break] = ACTIONS(1523),
    [sym_true] = ACTIONS(1523),
    [sym_false] = ACTIONS(1523),
    [sym_null] = ACTIONS(1523),
    [sym_inf] = ACTIONS(1523),
    [sym_nan] = ACTIONS(1523),
    [anon_sym_NA] = ACTIONS(1523),
    [anon_sym_NA_integer_] = ACTIONS(1523),
    [anon_sym_NA_real_] = ACTIONS(1523),
    [anon_sym_NA_complex_] = ACTIONS(1523),
    [anon_sym_NA_character_] = ACTIONS(1523),
    [sym_dots] = ACTIONS(1523),
    [sym_dot_dot_i] = ACTIONS(1525),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1525),
    [sym__semicolon] = ACTIONS(1525),
    [sym__raw_string_literal] = ACTIONS(1525),
    [sym__external_else] = ACTIONS(1525),
    [sym__external_open_parenthesis] = ACTIONS(1525),
    [sym__external_open_brace] = ACTIONS(1525),
    [sym__external_close_brace] = ACTIONS(1525),
    [sym__external_open_bracket] = ACTIONS(1525),
    [sym__external_open_bracket2] = ACTIONS(1525),
  },
  [790] = {
    [sym_identifier] = ACTIONS(1527),
    [anon_sym_BSLASH] = ACTIONS(1529),
    [anon_sym_function] = ACTIONS(1527),
    [anon_sym_EQ] = ACTIONS(1527),
    [anon_sym_if] = ACTIONS(1527),
    [anon_sym_for] = ACTIONS(1527),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_repeat] = ACTIONS(1527),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_TILDE] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1527),
    [anon_sym_LT_DASH] = ACTIONS(1529),
    [anon_sym_LT_LT_DASH] = ACTIONS(1529),
    [anon_sym_COLON_EQ] = ACTIONS(1529),
    [anon_sym_DASH_GT] = ACTIONS(1527),
    [anon_sym_DASH_GT_GT] = ACTIONS(1529),
    [anon_sym_PIPE] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1527),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1527),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1529),
    [anon_sym_BANG_EQ] = ACTIONS(1529),
    [anon_sym_STAR] = ACTIONS(1527),
    [anon_sym_SLASH] = ACTIONS(1529),
    [anon_sym_STAR_STAR] = ACTIONS(1529),
    [anon_sym_CARET] = ACTIONS(1529),
    [aux_sym_binary_operator_token1] = ACTIONS(1529),
    [anon_sym_PIPE_GT] = ACTIONS(1529),
    [anon_sym_COLON] = ACTIONS(1527),
    [anon_sym_DOLLAR] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(1529),
    [sym__hex_literal] = ACTIONS(1529),
    [sym__number_literal] = ACTIONS(1527),
    [anon_sym_SQUOTE] = ACTIONS(1529),
    [anon_sym_DQUOTE] = ACTIONS(1529),
    [sym_return] = ACTIONS(1527),
    [sym_next] = ACTIONS(1527),
    [sym_break] = ACTIONS(1527),
    [sym_true] = ACTIONS(1527),
    [sym_false] = ACTIONS(1527),
    [sym_null] = ACTIONS(1527),
    [sym_inf] = ACTIONS(1527),
    [sym_nan] = ACTIONS(1527),
    [anon_sym_NA] = ACTIONS(1527),
    [anon_sym_NA_integer_] = ACTIONS(1527),
    [anon_sym_NA_real_] = ACTIONS(1527),
    [anon_sym_NA_complex_] = ACTIONS(1527),
    [anon_sym_NA_character_] = ACTIONS(1527),
    [sym_dots] = ACTIONS(1527),
    [sym_dot_dot_i] = ACTIONS(1529),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1529),
    [sym__semicolon] = ACTIONS(1529),
    [sym__raw_string_literal] = ACTIONS(1529),
    [sym__external_else] = ACTIONS(1529),
    [sym__external_open_parenthesis] = ACTIONS(1529),
    [sym__external_open_brace] = ACTIONS(1529),
    [sym__external_close_brace] = ACTIONS(1529),
    [sym__external_open_bracket] = ACTIONS(1529),
    [sym__external_open_bracket2] = ACTIONS(1529),
  },
  [791] = {
    [sym_identifier] = ACTIONS(1533),
    [anon_sym_BSLASH] = ACTIONS(1531),
    [anon_sym_function] = ACTIONS(1533),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_if] = ACTIONS(1533),
    [anon_sym_for] = ACTIONS(1533),
    [anon_sym_while] = ACTIONS(1533),
    [anon_sym_repeat] = ACTIONS(1533),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_LT_DASH] = ACTIONS(1531),
    [anon_sym_LT_LT_DASH] = ACTIONS(1531),
    [anon_sym_COLON_EQ] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1533),
    [anon_sym_DASH_GT_GT] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1531),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_CARET] = ACTIONS(1531),
    [aux_sym_binary_operator_token1] = ACTIONS(1531),
    [anon_sym_PIPE_GT] = ACTIONS(1531),
    [anon_sym_COLON] = ACTIONS(1533),
    [anon_sym_DOLLAR] = ACTIONS(1531),
    [anon_sym_AT] = ACTIONS(1531),
    [sym__hex_literal] = ACTIONS(1531),
    [sym__number_literal] = ACTIONS(1533),
    [anon_sym_SQUOTE] = ACTIONS(1531),
    [anon_sym_DQUOTE] = ACTIONS(1531),
    [sym_return] = ACTIONS(1533),
    [sym_next] = ACTIONS(1533),
    [sym_break] = ACTIONS(1533),
    [sym_true] = ACTIONS(1533),
    [sym_false] = ACTIONS(1533),
    [sym_null] = ACTIONS(1533),
    [sym_inf] = ACTIONS(1533),
    [sym_nan] = ACTIONS(1533),
    [anon_sym_NA] = ACTIONS(1533),
    [anon_sym_NA_integer_] = ACTIONS(1533),
    [anon_sym_NA_real_] = ACTIONS(1533),
    [anon_sym_NA_complex_] = ACTIONS(1533),
    [anon_sym_NA_character_] = ACTIONS(1533),
    [sym_dots] = ACTIONS(1533),
    [sym_dot_dot_i] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1531),
    [sym__newline] = ACTIONS(1531),
    [sym__raw_string_literal] = ACTIONS(1531),
    [sym__external_else] = ACTIONS(1531),
    [sym__external_open_parenthesis] = ACTIONS(1531),
    [sym__external_open_brace] = ACTIONS(1531),
    [sym__external_open_bracket] = ACTIONS(1531),
    [sym__external_open_bracket2] = ACTIONS(1531),
    [sym__external_close_bracket2] = ACTIONS(1531),
  },
  [792] = {
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_BSLASH] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1539),
    [anon_sym_if] = ACTIONS(1539),
    [anon_sym_for] = ACTIONS(1539),
    [anon_sym_while] = ACTIONS(1539),
    [anon_sym_repeat] = ACTIONS(1539),
    [anon_sym_QMARK] = ACTIONS(1541),
    [anon_sym_TILDE] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1539),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1539),
    [anon_sym_LT_DASH] = ACTIONS(1541),
    [anon_sym_LT_LT_DASH] = ACTIONS(1541),
    [anon_sym_COLON_EQ] = ACTIONS(1541),
    [anon_sym_DASH_GT] = ACTIONS(1539),
    [anon_sym_DASH_GT_GT] = ACTIONS(1541),
    [anon_sym_PIPE] = ACTIONS(1539),
    [anon_sym_AMP] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1541),
    [anon_sym_GT] = ACTIONS(1539),
    [anon_sym_GT_EQ] = ACTIONS(1541),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1539),
    [anon_sym_SLASH] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_CARET] = ACTIONS(1541),
    [aux_sym_binary_operator_token1] = ACTIONS(1541),
    [anon_sym_PIPE_GT] = ACTIONS(1541),
    [anon_sym_COLON] = ACTIONS(1539),
    [anon_sym_DOLLAR] = ACTIONS(1541),
    [anon_sym_AT] = ACTIONS(1541),
    [sym__hex_literal] = ACTIONS(1541),
    [sym__number_literal] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(1541),
    [anon_sym_DQUOTE] = ACTIONS(1541),
    [sym_return] = ACTIONS(1539),
    [sym_next] = ACTIONS(1539),
    [sym_break] = ACTIONS(1539),
    [sym_true] = ACTIONS(1539),
    [sym_false] = ACTIONS(1539),
    [sym_null] = ACTIONS(1539),
    [sym_inf] = ACTIONS(1539),
    [sym_nan] = ACTIONS(1539),
    [anon_sym_NA] = ACTIONS(1539),
    [anon_sym_NA_integer_] = ACTIONS(1539),
    [anon_sym_NA_real_] = ACTIONS(1539),
    [anon_sym_NA_complex_] = ACTIONS(1539),
    [anon_sym_NA_character_] = ACTIONS(1539),
    [sym_dots] = ACTIONS(1539),
    [sym_dot_dot_i] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1541),
    [sym__newline] = ACTIONS(1541),
    [sym__raw_string_literal] = ACTIONS(1541),
    [sym__external_else] = ACTIONS(1541),
    [sym__external_open_parenthesis] = ACTIONS(1541),
    [sym__external_close_parenthesis] = ACTIONS(1541),
    [sym__external_open_brace] = ACTIONS(1541),
    [sym__external_open_bracket] = ACTIONS(1541),
    [sym__external_open_bracket2] = ACTIONS(1541),
  },
  [793] = {
    [sym_identifier] = ACTIONS(1468),
    [anon_sym_BSLASH] = ACTIONS(1470),
    [anon_sym_function] = ACTIONS(1468),
    [anon_sym_EQ] = ACTIONS(1468),
    [anon_sym_if] = ACTIONS(1468),
    [anon_sym_for] = ACTIONS(1468),
    [anon_sym_while] = ACTIONS(1468),
    [anon_sym_repeat] = ACTIONS(1468),
    [anon_sym_QMARK] = ACTIONS(1470),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_BANG] = ACTIONS(1468),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1468),
    [anon_sym_LT_DASH] = ACTIONS(1470),
    [anon_sym_LT_LT_DASH] = ACTIONS(1470),
    [anon_sym_COLON_EQ] = ACTIONS(1470),
    [anon_sym_DASH_GT] = ACTIONS(1468),
    [anon_sym_DASH_GT_GT] = ACTIONS(1470),
    [anon_sym_PIPE] = ACTIONS(1468),
    [anon_sym_AMP] = ACTIONS(1468),
    [anon_sym_PIPE_PIPE] = ACTIONS(1470),
    [anon_sym_AMP_AMP] = ACTIONS(1470),
    [anon_sym_LT] = ACTIONS(1468),
    [anon_sym_LT_EQ] = ACTIONS(1470),
    [anon_sym_GT] = ACTIONS(1468),
    [anon_sym_GT_EQ] = ACTIONS(1470),
    [anon_sym_EQ_EQ] = ACTIONS(1470),
    [anon_sym_BANG_EQ] = ACTIONS(1470),
    [anon_sym_STAR] = ACTIONS(1468),
    [anon_sym_SLASH] = ACTIONS(1470),
    [anon_sym_STAR_STAR] = ACTIONS(1470),
    [anon_sym_CARET] = ACTIONS(1470),
    [aux_sym_binary_operator_token1] = ACTIONS(1470),
    [anon_sym_PIPE_GT] = ACTIONS(1470),
    [anon_sym_COLON] = ACTIONS(1468),
    [anon_sym_DOLLAR] = ACTIONS(1470),
    [anon_sym_AT] = ACTIONS(1470),
    [sym__hex_literal] = ACTIONS(1470),
    [sym__number_literal] = ACTIONS(1468),
    [anon_sym_SQUOTE] = ACTIONS(1470),
    [anon_sym_DQUOTE] = ACTIONS(1470),
    [sym_return] = ACTIONS(1468),
    [sym_next] = ACTIONS(1468),
    [sym_break] = ACTIONS(1468),
    [sym_true] = ACTIONS(1468),
    [sym_false] = ACTIONS(1468),
    [sym_null] = ACTIONS(1468),
    [sym_inf] = ACTIONS(1468),
    [sym_nan] = ACTIONS(1468),
    [anon_sym_NA] = ACTIONS(1468),
    [anon_sym_NA_integer_] = ACTIONS(1468),
    [anon_sym_NA_real_] = ACTIONS(1468),
    [anon_sym_NA_complex_] = ACTIONS(1468),
    [anon_sym_NA_character_] = ACTIONS(1468),
    [sym_dots] = ACTIONS(1468),
    [sym_dot_dot_i] = ACTIONS(1470),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1470),
    [sym__semicolon] = ACTIONS(1470),
    [sym__raw_string_literal] = ACTIONS(1470),
    [sym__external_else] = ACTIONS(1470),
    [sym__external_open_parenthesis] = ACTIONS(1470),
    [sym__external_open_brace] = ACTIONS(1470),
    [sym__external_close_brace] = ACTIONS(1470),
    [sym__external_open_bracket] = ACTIONS(1470),
    [sym__external_open_bracket2] = ACTIONS(1470),
  },
  [794] = {
    [sym_identifier] = ACTIONS(1472),
    [anon_sym_BSLASH] = ACTIONS(1474),
    [anon_sym_function] = ACTIONS(1472),
    [anon_sym_EQ] = ACTIONS(1472),
    [anon_sym_if] = ACTIONS(1472),
    [anon_sym_for] = ACTIONS(1472),
    [anon_sym_while] = ACTIONS(1472),
    [anon_sym_repeat] = ACTIONS(1472),
    [anon_sym_QMARK] = ACTIONS(1474),
    [anon_sym_TILDE] = ACTIONS(1474),
    [anon_sym_BANG] = ACTIONS(1472),
    [anon_sym_PLUS] = ACTIONS(1474),
    [anon_sym_DASH] = ACTIONS(1472),
    [anon_sym_LT_DASH] = ACTIONS(1474),
    [anon_sym_LT_LT_DASH] = ACTIONS(1474),
    [anon_sym_COLON_EQ] = ACTIONS(1474),
    [anon_sym_DASH_GT] = ACTIONS(1472),
    [anon_sym_DASH_GT_GT] = ACTIONS(1474),
    [anon_sym_PIPE] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1472),
    [anon_sym_PIPE_PIPE] = ACTIONS(1474),
    [anon_sym_AMP_AMP] = ACTIONS(1474),
    [anon_sym_LT] = ACTIONS(1472),
    [anon_sym_LT_EQ] = ACTIONS(1474),
    [anon_sym_GT] = ACTIONS(1472),
    [anon_sym_GT_EQ] = ACTIONS(1474),
    [anon_sym_EQ_EQ] = ACTIONS(1474),
    [anon_sym_BANG_EQ] = ACTIONS(1474),
    [anon_sym_STAR] = ACTIONS(1472),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_STAR_STAR] = ACTIONS(1474),
    [anon_sym_CARET] = ACTIONS(1474),
    [aux_sym_binary_operator_token1] = ACTIONS(1474),
    [anon_sym_PIPE_GT] = ACTIONS(1474),
    [anon_sym_COLON] = ACTIONS(1472),
    [anon_sym_DOLLAR] = ACTIONS(1474),
    [anon_sym_AT] = ACTIONS(1474),
    [sym__hex_literal] = ACTIONS(1474),
    [sym__number_literal] = ACTIONS(1472),
    [anon_sym_SQUOTE] = ACTIONS(1474),
    [anon_sym_DQUOTE] = ACTIONS(1474),
    [sym_return] = ACTIONS(1472),
    [sym_next] = ACTIONS(1472),
    [sym_break] = ACTIONS(1472),
    [sym_true] = ACTIONS(1472),
    [sym_false] = ACTIONS(1472),
    [sym_null] = ACTIONS(1472),
    [sym_inf] = ACTIONS(1472),
    [sym_nan] = ACTIONS(1472),
    [anon_sym_NA] = ACTIONS(1472),
    [anon_sym_NA_integer_] = ACTIONS(1472),
    [anon_sym_NA_real_] = ACTIONS(1472),
    [anon_sym_NA_complex_] = ACTIONS(1472),
    [anon_sym_NA_character_] = ACTIONS(1472),
    [sym_dots] = ACTIONS(1472),
    [sym_dot_dot_i] = ACTIONS(1474),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1474),
    [sym__semicolon] = ACTIONS(1474),
    [sym__raw_string_literal] = ACTIONS(1474),
    [sym__external_else] = ACTIONS(1474),
    [sym__external_open_parenthesis] = ACTIONS(1474),
    [sym__external_open_brace] = ACTIONS(1474),
    [sym__external_close_brace] = ACTIONS(1474),
    [sym__external_open_bracket] = ACTIONS(1474),
    [sym__external_open_bracket2] = ACTIONS(1474),
  },
  [795] = {
    [sym_function_definition] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_repeat_statement] = STATE(406),
    [sym_braced_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_call] = STATE(406),
    [sym_subset] = STATE(406),
    [sym_subset2] = STATE(406),
    [sym_unary_operator] = STATE(406),
    [sym_binary_operator] = STATE(406),
    [sym_extract_operator] = STATE(406),
    [sym_namespace_operator] = STATE(406),
    [sym_integer] = STATE(406),
    [sym_complex] = STATE(406),
    [sym_float] = STATE(406),
    [sym__float_literal] = STATE(741),
    [sym_string] = STATE(740),
    [sym__single_quoted_string] = STATE(743),
    [sym__double_quoted_string] = STATE(746),
    [sym_na] = STATE(406),
    [sym__expression] = STATE(406),
    [sym__string_or_identifier] = STATE(2136),
    [sym__open_parenthesis] = STATE(934),
    [sym__open_brace] = STATE(853),
    [sym__close_brace] = STATE(888),
    [aux_sym_braced_expression_repeat1] = STATE(894),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1430),
    [anon_sym_function] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_repeat] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [sym__hex_literal] = ACTIONS(1450),
    [sym__number_literal] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [sym_return] = ACTIONS(1454),
    [sym_next] = ACTIONS(1454),
    [sym_break] = ACTIONS(1454),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [sym_null] = ACTIONS(1454),
    [sym_inf] = ACTIONS(1454),
    [sym_nan] = ACTIONS(1454),
    [anon_sym_NA] = ACTIONS(1456),
    [anon_sym_NA_integer_] = ACTIONS(1456),
    [anon_sym_NA_real_] = ACTIONS(1456),
    [anon_sym_NA_complex_] = ACTIONS(1456),
    [anon_sym_NA_character_] = ACTIONS(1456),
    [sym_dots] = ACTIONS(1454),
    [sym_dot_dot_i] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1460),
    [sym__semicolon] = ACTIONS(1460),
    [sym__raw_string_literal] = ACTIONS(1153),
    [sym__external_open_parenthesis] = ACTIONS(1462),
    [sym__external_open_brace] = ACTIONS(1464),
    [sym__external_close_brace] = ACTIONS(1555),
  },
  [796] = {
    [aux_sym_function_definition_repeat1] = STATE(796),
    [sym_identifier] = ACTIONS(1383),
    [anon_sym_BSLASH] = ACTIONS(1385),
    [anon_sym_function] = ACTIONS(1383),
    [anon_sym_EQ] = ACTIONS(1383),
    [anon_sym_if] = ACTIONS(1383),
    [anon_sym_for] = ACTIONS(1383),
    [anon_sym_while] = ACTIONS(1383),
    [anon_sym_repeat] = ACTIONS(1383),
    [anon_sym_QMARK] = ACTIONS(1385),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1383),
    [anon_sym_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_COLON_EQ] = ACTIONS(1385),
    [anon_sym_DASH_GT] = ACTIONS(1383),
    [anon_sym_DASH_GT_GT] = ACTIONS(1385),
    [anon_sym_PIPE] = ACTIONS(1383),
    [anon_sym_AMP] = ACTIONS(1383),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1383),
    [anon_sym_LT_EQ] = ACTIONS(1385),
    [anon_sym_GT] = ACTIONS(1383),
    [anon_sym_GT_EQ] = ACTIONS(1385),
    [anon_sym_EQ_EQ] = ACTIONS(1385),
    [anon_sym_BANG_EQ] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_SLASH] = ACTIONS(1385),
    [anon_sym_STAR_STAR] = ACTIONS(1385),
    [anon_sym_CARET] = ACTIONS(1385),
    [aux_sym_binary_operator_token1] = ACTIONS(1385),
    [anon_sym_PIPE_GT] = ACTIONS(1385),
    [anon_sym_COLON] = ACTIONS(1383),
    [anon_sym_DOLLAR] = ACTIONS(1385),
    [anon_sym_AT] = ACTIONS(1385),
    [sym__hex_literal] = ACTIONS(1385),
    [sym__number_literal] = ACTIONS(1383),
    [anon_sym_SQUOTE] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [sym_return] = ACTIONS(1383),
    [sym_next] = ACTIONS(1383),
    [sym_break] = ACTIONS(1383),
    [sym_true] = ACTIONS(1383),
    [sym_false] = ACTIONS(1383),
    [sym_null] = ACTIONS(1383),
    [sym_inf] = ACTIONS(1383),
    [sym_nan] = ACTIONS(1383),
    [anon_sym_NA] = ACTIONS(1383),
    [anon_sym_NA_integer_] = ACTIONS(1383),
    [anon_sym_NA_real_] = ACTIONS(1383),
    [anon_sym_NA_complex_] = ACTIONS(1383),
    [anon_sym_NA_character_] = ACTIONS(1383),
    [sym_dots] = ACTIONS(1383),
    [sym_dot_dot_i] = ACTIONS(1385),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1385),
    [sym__newline] = ACTIONS(1557),
    [sym__raw_string_literal] = ACTIONS(1385),
    [sym__external_open_parenthesis] = ACTIONS(1385),
    [sym__external_close_parenthesis] = ACTIONS(1385),
    [sym__external_open_brace] = ACTIONS(1385),
    [sym__external_open_bracket] = ACTIONS(1385),
    [sym__external_open_bracket2] = ACTIONS(1385),
  },
  [797] = {
    [aux_sym_function_definition_repeat1] = STATE(797),
    [ts_builtin_sym_end] = ACTIONS(1385),
    [sym_identifier] = ACTIONS(1383),
    [anon_sym_BSLASH] = ACTIONS(1385),
    [anon_sym_function] = ACTIONS(1383),
    [anon_sym_EQ] = ACTIONS(1383),
    [anon_sym_if] = ACTIONS(1383),
    [anon_sym_for] = ACTIONS(1383),
    [anon_sym_while] = ACTIONS(1383),
    [anon_sym_repeat] = ACTIONS(1383),
    [anon_sym_QMARK] = ACTIONS(1385),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1383),
    [anon_sym_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_COLON_EQ] = ACTIONS(1385),
    [anon_sym_DASH_GT] = ACTIONS(1383),
    [anon_sym_DASH_GT_GT] = ACTIONS(1385),
    [anon_sym_PIPE] = ACTIONS(1383),
    [anon_sym_AMP] = ACTIONS(1383),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1383),
    [anon_sym_LT_EQ] = ACTIONS(1385),
    [anon_sym_GT] = ACTIONS(1383),
    [anon_sym_GT_EQ] = ACTIONS(1385),
    [anon_sym_EQ_EQ] = ACTIONS(1385),
    [anon_sym_BANG_EQ] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_SLASH] = ACTIONS(1385),
    [anon_sym_STAR_STAR] = ACTIONS(1385),
    [anon_sym_CARET] = ACTIONS(1385),
    [aux_sym_binary_operator_token1] = ACTIONS(1385),
    [anon_sym_PIPE_GT] = ACTIONS(1385),
    [anon_sym_COLON] = ACTIONS(1383),
    [anon_sym_DOLLAR] = ACTIONS(1385),
    [anon_sym_AT] = ACTIONS(1385),
    [sym__hex_literal] = ACTIONS(1385),
    [sym__number_literal] = ACTIONS(1383),
    [anon_sym_SQUOTE] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [sym_return] = ACTIONS(1383),
    [sym_next] = ACTIONS(1383),
    [sym_break] = ACTIONS(1383),
    [sym_true] = ACTIONS(1383),
    [sym_false] = ACTIONS(1383),
    [sym_null] = ACTIONS(1383),
    [sym_inf] = ACTIONS(1383),
    [sym_nan] = ACTIONS(1383),
    [anon_sym_NA] = ACTIONS(1383),
    [anon_sym_NA_integer_] = ACTIONS(1383),
    [anon_sym_NA_real_] = ACTIONS(1383),
    [anon_sym_NA_complex_] = ACTIONS(1383),
    [anon_sym_NA_character_] = ACTIONS(1383),
    [sym_dots] = ACTIONS(1383),
    [sym_dot_dot_i] = ACTIONS(1385),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1560),
    [sym__semicolon] = ACTIONS(1385),
    [sym__raw_string_literal] = ACTIONS(1385),
    [sym__external_open_parenthesis] = ACTIONS(1385),
    [sym__external_open_brace] = ACTIONS(1385),
    [sym__external_open_bracket] = ACTIONS(1385),
    [sym__external_open_bracket2] = ACTIONS(1385),
  },
  [798] = {
    [sym_identifier] = ACTIONS(1476),
    [anon_sym_BSLASH] = ACTIONS(1478),
    [anon_sym_function] = ACTIONS(1476),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_if] = ACTIONS(1476),
    [anon_sym_for] = ACTIONS(1476),
    [anon_sym_while] = ACTIONS(1476),
    [anon_sym_repeat] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_BANG] = ACTIONS(1476),
    [anon_sym_PLUS] = ACTIONS(1478),
    [anon_sym_DASH] = ACTIONS(1476),
    [anon_sym_LT_DASH] = ACTIONS(1478),
    [anon_sym_LT_LT_DASH] = ACTIONS(1478),
    [anon_sym_COLON_EQ] = ACTIONS(1478),
    [anon_sym_DASH_GT] = ACTIONS(1476),
    [anon_sym_DASH_GT_GT] = ACTIONS(1478),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1478),
    [anon_sym_AMP_AMP] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_EQ] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_GT_EQ] = ACTIONS(1478),
    [anon_sym_EQ_EQ] = ACTIONS(1478),
    [anon_sym_BANG_EQ] = ACTIONS(1478),
    [anon_sym_STAR] = ACTIONS(1476),
    [anon_sym_SLASH] = ACTIONS(1478),
    [anon_sym_STAR_STAR] = ACTIONS(1478),
    [anon_sym_CARET] = ACTIONS(1478),
    [aux_sym_binary_operator_token1] = ACTIONS(1478),
    [anon_sym_PIPE_GT] = ACTIONS(1478),
    [anon_sym_COLON] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1478),
    [anon_sym_AT] = ACTIONS(1478),
    [sym__hex_literal] = ACTIONS(1478),
    [sym__number_literal] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_DQUOTE] = ACTIONS(1478),
    [sym_return] = ACTIONS(1476),
    [sym_next] = ACTIONS(1476),
    [sym_break] = ACTIONS(1476),
    [sym_true] = ACTIONS(1476),
    [sym_false] = ACTIONS(1476),
    [sym_null] = ACTIONS(1476),
    [sym_inf] = ACTIONS(1476),
    [sym_nan] = ACTIONS(1476),
    [anon_sym_NA] = ACTIONS(1476),
    [anon_sym_NA_integer_] = ACTIONS(1476),
    [anon_sym_NA_real_] = ACTIONS(1476),
    [anon_sym_NA_complex_] = ACTIONS(1476),
    [anon_sym_NA_character_] = ACTIONS(1476),
    [sym_dots] = ACTIONS(1476),
    [sym_dot_dot_i] = ACTIONS(1478),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1478),
    [sym__semicolon] = ACTIONS(1478),
    [sym__raw_string_literal] = ACTIONS(1478),
    [sym__external_else] = ACTIONS(1478),
    [sym__external_open_parenthesis] = ACTIONS(1478),
    [sym__external_open_brace] = ACTIONS(1478),
    [sym__external_close_brace] = ACTIONS(1478),
    [sym__external_open_bracket] = ACTIONS(1478),
    [sym__external_open_bracket2] = ACTIONS(1478),
  },
  [799] = {
    [sym_identifier] = ACTIONS(1535),
    [anon_sym_BSLASH] = ACTIONS(1537),
    [anon_sym_function] = ACTIONS(1535),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_if] = ACTIONS(1535),
    [anon_sym_for] = ACTIONS(1535),
    [anon_sym_while] = ACTIONS(1535),
    [anon_sym_repeat] = ACTIONS(1535),
    [anon_sym_QMARK] = ACTIONS(1537),
    [anon_sym_TILDE] = ACTIONS(1537),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1535),
    [anon_sym_LT_DASH] = ACTIONS(1537),
    [anon_sym_LT_LT_DASH] = ACTIONS(1537),
    [anon_sym_COLON_EQ] = ACTIONS(1537),
    [anon_sym_DASH_GT] = ACTIONS(1535),
    [anon_sym_DASH_GT_GT] = ACTIONS(1537),
    [anon_sym_PIPE] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_PIPE_PIPE] = ACTIONS(1537),
    [anon_sym_AMP_AMP] = ACTIONS(1537),
    [anon_sym_LT] = ACTIONS(1535),
    [anon_sym_LT_EQ] = ACTIONS(1537),
    [anon_sym_GT] = ACTIONS(1535),
    [anon_sym_GT_EQ] = ACTIONS(1537),
    [anon_sym_EQ_EQ] = ACTIONS(1537),
    [anon_sym_BANG_EQ] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_SLASH] = ACTIONS(1537),
    [anon_sym_STAR_STAR] = ACTIONS(1537),
    [anon_sym_CARET] = ACTIONS(1537),
    [aux_sym_binary_operator_token1] = ACTIONS(1537),
    [anon_sym_PIPE_GT] = ACTIONS(1537),
    [anon_sym_COLON] = ACTIONS(1535),
    [anon_sym_DOLLAR] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(1537),
    [sym__hex_literal] = ACTIONS(1537),
    [sym__number_literal] = ACTIONS(1535),
    [anon_sym_SQUOTE] = ACTIONS(1537),
    [anon_sym_DQUOTE] = ACTIONS(1537),
    [sym_return] = ACTIONS(1535),
    [sym_next] = ACTIONS(1535),
    [sym_break] = ACTIONS(1535),
    [sym_true] = ACTIONS(1535),
    [sym_false] = ACTIONS(1535),
    [sym_null] = ACTIONS(1535),
    [sym_inf] = ACTIONS(1535),
    [sym_nan] = ACTIONS(1535),
    [anon_sym_NA] = ACTIONS(1535),
    [anon_sym_NA_integer_] = ACTIONS(1535),
    [anon_sym_NA_real_] = ACTIONS(1535),
    [anon_sym_NA_complex_] = ACTIONS(1535),
    [anon_sym_NA_character_] = ACTIONS(1535),
    [sym_dots] = ACTIONS(1535),
    [sym_dot_dot_i] = ACTIONS(1537),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1537),
    [sym__newline] = ACTIONS(1537),
    [sym__raw_string_literal] = ACTIONS(1537),
    [sym__external_else] = ACTIONS(1537),
    [sym__external_open_parenthesis] = ACTIONS(1537),
    [sym__external_open_brace] = ACTIONS(1537),
    [sym__external_open_bracket] = ACTIONS(1537),
    [sym__external_open_bracket2] = ACTIONS(1537),
    [sym__external_close_bracket2] = ACTIONS(1537),
  },
  [800] = {
    [sym_identifier] = ACTIONS(1551),
    [anon_sym_BSLASH] = ACTIONS(1553),
    [anon_sym_function] = ACTIONS(1551),
    [anon_sym_EQ] = ACTIONS(1551),
    [anon_sym_if] = ACTIONS(1551),
    [anon_sym_for] = ACTIONS(1551),
    [anon_sym_while] = ACTIONS(1551),
    [anon_sym_repeat] = ACTIONS(1551),
    [anon_sym_QMARK] = ACTIONS(1553),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_PLUS] = ACTIONS(1553),
    [anon_sym_DASH] = ACTIONS(1551),
    [anon_sym_LT_DASH] = ACTIONS(1553),
    [anon_sym_LT_LT_DASH] = ACTIONS(1553),
    [anon_sym_COLON_EQ] = ACTIONS(1553),
    [anon_sym_DASH_GT] = ACTIONS(1551),
    [anon_sym_DASH_GT_GT] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_PIPE_PIPE] = ACTIONS(1553),
    [anon_sym_AMP_AMP] = ACTIONS(1553),
    [anon_sym_LT] = ACTIONS(1551),
    [anon_sym_LT_EQ] = ACTIONS(1553),
    [anon_sym_GT] = ACTIONS(1551),
    [anon_sym_GT_EQ] = ACTIONS(1553),
    [anon_sym_EQ_EQ] = ACTIONS(1553),
    [anon_sym_BANG_EQ] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(1551),
    [anon_sym_SLASH] = ACTIONS(1553),
    [anon_sym_STAR_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [aux_sym_binary_operator_token1] = ACTIONS(1553),
    [anon_sym_PIPE_GT] = ACTIONS(1553),
    [anon_sym_COLON] = ACTIONS(1551),
    [anon_sym_DOLLAR] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(1553),
    [sym__hex_literal] = ACTIONS(1553),
    [sym__number_literal] = ACTIONS(1551),
    [anon_sym_SQUOTE] = ACTIONS(1553),
    [anon_sym_DQUOTE] = ACTIONS(1553),
    [sym_return] = ACTIONS(1551),
    [sym_next] = ACTIONS(1551),
    [sym_break] = ACTIONS(1551),
    [sym_true] = ACTIONS(1551),
    [sym_false] = ACTIONS(1551),
    [sym_null] = ACTIONS(1551),
    [sym_inf] = ACTIONS(1551),
    [sym_nan] = ACTIONS(1551),
    [anon_sym_NA] = ACTIONS(1551),
    [anon_sym_NA_integer_] = ACTIONS(1551),
    [anon_sym_NA_real_] = ACTIONS(1551),
    [anon_sym_NA_complex_] = ACTIONS(1551),
    [anon_sym_NA_character_] = ACTIONS(1551),
    [sym_dots] = ACTIONS(1551),
    [sym_dot_dot_i] = ACTIONS(1553),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1553),
    [sym__newline] = ACTIONS(1553),
    [sym__raw_string_literal] = ACTIONS(1553),
    [sym__external_else] = ACTIONS(1553),
    [sym__external_open_parenthesis] = ACTIONS(1553),
    [sym__external_open_brace] = ACTIONS(1553),
    [sym__external_open_bracket] = ACTIONS(1553),
    [sym__external_open_bracket2] = ACTIONS(1553),
    [sym__external_close_bracket2] = ACTIONS(1553),
  },
  [801] = {
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_BSLASH] = ACTIONS(1545),
    [anon_sym_function] = ACTIONS(1543),
    [anon_sym_EQ] = ACTIONS(1543),
    [anon_sym_if] = ACTIONS(1543),
    [anon_sym_for] = ACTIONS(1543),
    [anon_sym_while] = ACTIONS(1543),
    [anon_sym_repeat] = ACTIONS(1543),
    [anon_sym_QMARK] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1543),
    [anon_sym_PLUS] = ACTIONS(1545),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_LT_DASH] = ACTIONS(1545),
    [anon_sym_LT_LT_DASH] = ACTIONS(1545),
    [anon_sym_COLON_EQ] = ACTIONS(1545),
    [anon_sym_DASH_GT] = ACTIONS(1543),
    [anon_sym_DASH_GT_GT] = ACTIONS(1545),
    [anon_sym_PIPE] = ACTIONS(1543),
    [anon_sym_AMP] = ACTIONS(1543),
    [anon_sym_PIPE_PIPE] = ACTIONS(1545),
    [anon_sym_AMP_AMP] = ACTIONS(1545),
    [anon_sym_LT] = ACTIONS(1543),
    [anon_sym_LT_EQ] = ACTIONS(1545),
    [anon_sym_GT] = ACTIONS(1543),
    [anon_sym_GT_EQ] = ACTIONS(1545),
    [anon_sym_EQ_EQ] = ACTIONS(1545),
    [anon_sym_BANG_EQ] = ACTIONS(1545),
    [anon_sym_STAR] = ACTIONS(1543),
    [anon_sym_SLASH] = ACTIONS(1545),
    [anon_sym_STAR_STAR] = ACTIONS(1545),
    [anon_sym_CARET] = ACTIONS(1545),
    [aux_sym_binary_operator_token1] = ACTIONS(1545),
    [anon_sym_PIPE_GT] = ACTIONS(1545),
    [anon_sym_COLON] = ACTIONS(1543),
    [anon_sym_DOLLAR] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(1545),
    [sym__hex_literal] = ACTIONS(1545),
    [sym__number_literal] = ACTIONS(1543),
    [anon_sym_SQUOTE] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1545),
    [sym_return] = ACTIONS(1543),
    [sym_next] = ACTIONS(1543),
    [sym_break] = ACTIONS(1543),
    [sym_true] = ACTIONS(1543),
    [sym_false] = ACTIONS(1543),
    [sym_null] = ACTIONS(1543),
    [sym_inf] = ACTIONS(1543),
    [sym_nan] = ACTIONS(1543),
    [anon_sym_NA] = ACTIONS(1543),
    [anon_sym_NA_integer_] = ACTIONS(1543),
    [anon_sym_NA_real_] = ACTIONS(1543),
    [anon_sym_NA_complex_] = ACTIONS(1543),
    [anon_sym_NA_character_] = ACTIONS(1543),
    [sym_dots] = ACTIONS(1543),
    [sym_dot_dot_i] = ACTIONS(1545),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1545),
    [sym__newline] = ACTIONS(1545),
    [sym__raw_string_literal] = ACTIONS(1545),
    [sym__external_else] = ACTIONS(1545),
    [sym__external_open_parenthesis] = ACTIONS(1545),
    [sym__external_close_parenthesis] = ACTIONS(1545),
    [sym__external_open_brace] = ACTIONS(1545),
    [sym__external_open_bracket] = ACTIONS(1545),
    [sym__external_open_bracket2] = ACTIONS(1545),
  },
  [802] = {
    [sym_identifier] = ACTIONS(1468),
    [anon_sym_BSLASH] = ACTIONS(1470),
    [anon_sym_function] = ACTIONS(1468),
    [anon_sym_EQ] = ACTIONS(1468),
    [anon_sym_if] = ACTIONS(1468),
    [anon_sym_for] = ACTIONS(1468),
    [anon_sym_while] = ACTIONS(1468),
    [anon_sym_repeat] = ACTIONS(1468),
    [anon_sym_QMARK] = ACTIONS(1470),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_BANG] = ACTIONS(1468),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1468),
    [anon_sym_LT_DASH] = ACTIONS(1470),
    [anon_sym_LT_LT_DASH] = ACTIONS(1470),
    [anon_sym_COLON_EQ] = ACTIONS(1470),
    [anon_sym_DASH_GT] = ACTIONS(1468),
    [anon_sym_DASH_GT_GT] = ACTIONS(1470),
    [anon_sym_PIPE] = ACTIONS(1468),
    [anon_sym_AMP] = ACTIONS(1468),
    [anon_sym_PIPE_PIPE] = ACTIONS(1470),
    [anon_sym_AMP_AMP] = ACTIONS(1470),
    [anon_sym_LT] = ACTIONS(1468),
    [anon_sym_LT_EQ] = ACTIONS(1470),
    [anon_sym_GT] = ACTIONS(1468),
    [anon_sym_GT_EQ] = ACTIONS(1470),
    [anon_sym_EQ_EQ] = ACTIONS(1470),
    [anon_sym_BANG_EQ] = ACTIONS(1470),
    [anon_sym_STAR] = ACTIONS(1468),
    [anon_sym_SLASH] = ACTIONS(1470),
    [anon_sym_STAR_STAR] = ACTIONS(1470),
    [anon_sym_CARET] = ACTIONS(1470),
    [aux_sym_binary_operator_token1] = ACTIONS(1470),
    [anon_sym_PIPE_GT] = ACTIONS(1470),
    [anon_sym_COLON] = ACTIONS(1468),
    [anon_sym_DOLLAR] = ACTIONS(1470),
    [anon_sym_AT] = ACTIONS(1470),
    [sym__hex_literal] = ACTIONS(1470),
    [sym__number_literal] = ACTIONS(1468),
    [anon_sym_SQUOTE] = ACTIONS(1470),
    [anon_sym_DQUOTE] = ACTIONS(1470),
    [sym_return] = ACTIONS(1468),
    [sym_next] = ACTIONS(1468),
    [sym_break] = ACTIONS(1468),
    [sym_true] = ACTIONS(1468),
    [sym_false] = ACTIONS(1468),
    [sym_null] = ACTIONS(1468),
    [sym_inf] = ACTIONS(1468),
    [sym_nan] = ACTIONS(1468),
    [anon_sym_NA] = ACTIONS(1468),
    [anon_sym_NA_integer_] = ACTIONS(1468),
    [anon_sym_NA_real_] = ACTIONS(1468),
    [anon_sym_NA_complex_] = ACTIONS(1468),
    [anon_sym_NA_character_] = ACTIONS(1468),
    [sym_dots] = ACTIONS(1468),
    [sym_dot_dot_i] = ACTIONS(1470),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1470),
    [sym__newline] = ACTIONS(1470),
    [sym__raw_string_literal] = ACTIONS(1470),
    [sym__external_else] = ACTIONS(1470),
    [sym__external_open_parenthesis] = ACTIONS(1470),
    [sym__external_open_brace] = ACTIONS(1470),
    [sym__external_open_bracket] = ACTIONS(1470),
    [sym__external_open_bracket2] = ACTIONS(1470),
    [sym__external_close_bracket2] = ACTIONS(1470),
  },
  [803] = {
    [sym_identifier] = ACTIONS(1472),
    [anon_sym_BSLASH] = ACTIONS(1474),
    [anon_sym_function] = ACTIONS(1472),
    [anon_sym_EQ] = ACTIONS(1472),
    [anon_sym_if] = ACTIONS(1472),
    [anon_sym_for] = ACTIONS(1472),
    [anon_sym_while] = ACTIONS(1472),
    [anon_sym_repeat] = ACTIONS(1472),
    [anon_sym_QMARK] = ACTIONS(1474),
    [anon_sym_TILDE] = ACTIONS(1474),
    [anon_sym_BANG] = ACTIONS(1472),
    [anon_sym_PLUS] = ACTIONS(1474),
    [anon_sym_DASH] = ACTIONS(1472),
    [anon_sym_LT_DASH] = ACTIONS(1474),
    [anon_sym_LT_LT_DASH] = ACTIONS(1474),
    [anon_sym_COLON_EQ] = ACTIONS(1474),
    [anon_sym_DASH_GT] = ACTIONS(1472),
    [anon_sym_DASH_GT_GT] = ACTIONS(1474),
    [anon_sym_PIPE] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1472),
    [anon_sym_PIPE_PIPE] = ACTIONS(1474),
    [anon_sym_AMP_AMP] = ACTIONS(1474),
    [anon_sym_LT] = ACTIONS(1472),
    [anon_sym_LT_EQ] = ACTIONS(1474),
    [anon_sym_GT] = ACTIONS(1472),
    [anon_sym_GT_EQ] = ACTIONS(1474),
    [anon_sym_EQ_EQ] = ACTIONS(1474),
    [anon_sym_BANG_EQ] = ACTIONS(1474),
    [anon_sym_STAR] = ACTIONS(1472),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_STAR_STAR] = ACTIONS(1474),
    [anon_sym_CARET] = ACTIONS(1474),
    [aux_sym_binary_operator_token1] = ACTIONS(1474),
    [anon_sym_PIPE_GT] = ACTIONS(1474),
    [anon_sym_COLON] = ACTIONS(1472),
    [anon_sym_DOLLAR] = ACTIONS(1474),
    [anon_sym_AT] = ACTIONS(1474),
    [sym__hex_literal] = ACTIONS(1474),
    [sym__number_literal] = ACTIONS(1472),
    [anon_sym_SQUOTE] = ACTIONS(1474),
    [anon_sym_DQUOTE] = ACTIONS(1474),
    [sym_return] = ACTIONS(1472),
    [sym_next] = ACTIONS(1472),
    [sym_break] = ACTIONS(1472),
    [sym_true] = ACTIONS(1472),
    [sym_false] = ACTIONS(1472),
    [sym_null] = ACTIONS(1472),
    [sym_inf] = ACTIONS(1472),
    [sym_nan] = ACTIONS(1472),
    [anon_sym_NA] = ACTIONS(1472),
    [anon_sym_NA_integer_] = ACTIONS(1472),
    [anon_sym_NA_real_] = ACTIONS(1472),
    [anon_sym_NA_complex_] = ACTIONS(1472),
    [anon_sym_NA_character_] = ACTIONS(1472),
    [sym_dots] = ACTIONS(1472),
    [sym_dot_dot_i] = ACTIONS(1474),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1474),
    [sym__newline] = ACTIONS(1474),
    [sym__raw_string_literal] = ACTIONS(1474),
    [sym__external_else] = ACTIONS(1474),
    [sym__external_open_parenthesis] = ACTIONS(1474),
    [sym__external_open_brace] = ACTIONS(1474),
    [sym__external_open_bracket] = ACTIONS(1474),
    [sym__external_open_bracket2] = ACTIONS(1474),
    [sym__external_close_bracket2] = ACTIONS(1474),
  },
  [804] = {
    [sym_identifier] = ACTIONS(1476),
    [anon_sym_BSLASH] = ACTIONS(1478),
    [anon_sym_function] = ACTIONS(1476),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_if] = ACTIONS(1476),
    [anon_sym_for] = ACTIONS(1476),
    [anon_sym_while] = ACTIONS(1476),
    [anon_sym_repeat] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_BANG] = ACTIONS(1476),
    [anon_sym_PLUS] = ACTIONS(1478),
    [anon_sym_DASH] = ACTIONS(1476),
    [anon_sym_LT_DASH] = ACTIONS(1478),
    [anon_sym_LT_LT_DASH] = ACTIONS(1478),
    [anon_sym_COLON_EQ] = ACTIONS(1478),
    [anon_sym_DASH_GT] = ACTIONS(1476),
    [anon_sym_DASH_GT_GT] = ACTIONS(1478),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1478),
    [anon_sym_AMP_AMP] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_EQ] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_GT_EQ] = ACTIONS(1478),
    [anon_sym_EQ_EQ] = ACTIONS(1478),
    [anon_sym_BANG_EQ] = ACTIONS(1478),
    [anon_sym_STAR] = ACTIONS(1476),
    [anon_sym_SLASH] = ACTIONS(1478),
    [anon_sym_STAR_STAR] = ACTIONS(1478),
    [anon_sym_CARET] = ACTIONS(1478),
    [aux_sym_binary_operator_token1] = ACTIONS(1478),
    [anon_sym_PIPE_GT] = ACTIONS(1478),
    [anon_sym_COLON] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1478),
    [anon_sym_AT] = ACTIONS(1478),
    [sym__hex_literal] = ACTIONS(1478),
    [sym__number_literal] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_DQUOTE] = ACTIONS(1478),
    [sym_return] = ACTIONS(1476),
    [sym_next] = ACTIONS(1476),
    [sym_break] = ACTIONS(1476),
    [sym_true] = ACTIONS(1476),
    [sym_false] = ACTIONS(1476),
    [sym_null] = ACTIONS(1476),
    [sym_inf] = ACTIONS(1476),
    [sym_nan] = ACTIONS(1476),
    [anon_sym_NA] = ACTIONS(1476),
    [anon_sym_NA_integer_] = ACTIONS(1476),
    [anon_sym_NA_real_] = ACTIONS(1476),
    [anon_sym_NA_complex_] = ACTIONS(1476),
    [anon_sym_NA_character_] = ACTIONS(1476),
    [sym_dots] = ACTIONS(1476),
    [sym_dot_dot_i] = ACTIONS(1478),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1478),
    [sym__newline] = ACTIONS(1478),
    [sym__raw_string_literal] = ACTIONS(1478),
    [sym__external_else] = ACTIONS(1478),
    [sym__external_open_parenthesis] = ACTIONS(1478),
    [sym__external_open_brace] = ACTIONS(1478),
    [sym__external_open_bracket] = ACTIONS(1478),
    [sym__external_open_bracket2] = ACTIONS(1478),
    [sym__external_close_bracket2] = ACTIONS(1478),
  },
  [805] = {
    [sym_identifier] = ACTIONS(1480),
    [anon_sym_BSLASH] = ACTIONS(1482),
    [anon_sym_function] = ACTIONS(1480),
    [anon_sym_EQ] = ACTIONS(1480),
    [anon_sym_if] = ACTIONS(1480),
    [anon_sym_for] = ACTIONS(1480),
    [anon_sym_while] = ACTIONS(1480),
    [anon_sym_repeat] = ACTIONS(1480),
    [anon_sym_QMARK] = ACTIONS(1482),
    [anon_sym_TILDE] = ACTIONS(1482),
    [anon_sym_BANG] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1482),
    [anon_sym_DASH] = ACTIONS(1480),
    [anon_sym_LT_DASH] = ACTIONS(1482),
    [anon_sym_LT_LT_DASH] = ACTIONS(1482),
    [anon_sym_COLON_EQ] = ACTIONS(1482),
    [anon_sym_DASH_GT] = ACTIONS(1480),
    [anon_sym_DASH_GT_GT] = ACTIONS(1482),
    [anon_sym_PIPE] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1480),
    [anon_sym_PIPE_PIPE] = ACTIONS(1482),
    [anon_sym_AMP_AMP] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(1480),
    [anon_sym_LT_EQ] = ACTIONS(1482),
    [anon_sym_GT] = ACTIONS(1480),
    [anon_sym_GT_EQ] = ACTIONS(1482),
    [anon_sym_EQ_EQ] = ACTIONS(1482),
    [anon_sym_BANG_EQ] = ACTIONS(1482),
    [anon_sym_STAR] = ACTIONS(1480),
    [anon_sym_SLASH] = ACTIONS(1482),
    [anon_sym_STAR_STAR] = ACTIONS(1482),
    [anon_sym_CARET] = ACTIONS(1482),
    [aux_sym_binary_operator_token1] = ACTIONS(1482),
    [anon_sym_PIPE_GT] = ACTIONS(1482),
    [anon_sym_COLON] = ACTIONS(1480),
    [anon_sym_DOLLAR] = ACTIONS(1482),
    [anon_sym_AT] = ACTIONS(1482),
    [sym__hex_literal] = ACTIONS(1482),
    [sym__number_literal] = ACTIONS(1480),
    [anon_sym_SQUOTE] = ACTIONS(1482),
    [anon_sym_DQUOTE] = ACTIONS(1482),
    [sym_return] = ACTIONS(1480),
    [sym_next] = ACTIONS(1480),
    [sym_break] = ACTIONS(1480),
    [sym_true] = ACTIONS(1480),
    [sym_false] = ACTIONS(1480),
    [sym_null] = ACTIONS(1480),
    [sym_inf] = ACTIONS(1480),
    [sym_nan] = ACTIONS(1480),
    [anon_sym_NA] = ACTIONS(1480),
    [anon_sym_NA_integer_] = ACTIONS(1480),
    [anon_sym_NA_real_] = ACTIONS(1480),
    [anon_sym_NA_complex_] = ACTIONS(1480),
    [anon_sym_NA_character_] = ACTIONS(1480),
    [sym_dots] = ACTIONS(1480),
    [sym_dot_dot_i] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1482),
    [sym__semicolon] = ACTIONS(1482),
    [sym__raw_string_literal] = ACTIONS(1482),
    [sym__external_else] = ACTIONS(1482),
    [sym__external_open_parenthesis] = ACTIONS(1482),
    [sym__external_open_brace] = ACTIONS(1482),
    [sym__external_close_brace] = ACTIONS(1482),
    [sym__external_open_bracket] = ACTIONS(1482),
    [sym__external_open_bracket2] = ACTIONS(1482),
  },
  [806] = {
    [sym_identifier] = ACTIONS(1480),
    [anon_sym_BSLASH] = ACTIONS(1482),
    [anon_sym_function] = ACTIONS(1480),
    [anon_sym_EQ] = ACTIONS(1480),
    [anon_sym_if] = ACTIONS(1480),
    [anon_sym_for] = ACTIONS(1480),
    [anon_sym_while] = ACTIONS(1480),
    [anon_sym_repeat] = ACTIONS(1480),
    [anon_sym_QMARK] = ACTIONS(1482),
    [anon_sym_TILDE] = ACTIONS(1482),
    [anon_sym_BANG] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1482),
    [anon_sym_DASH] = ACTIONS(1480),
    [anon_sym_LT_DASH] = ACTIONS(1482),
    [anon_sym_LT_LT_DASH] = ACTIONS(1482),
    [anon_sym_COLON_EQ] = ACTIONS(1482),
    [anon_sym_DASH_GT] = ACTIONS(1480),
    [anon_sym_DASH_GT_GT] = ACTIONS(1482),
    [anon_sym_PIPE] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1480),
    [anon_sym_PIPE_PIPE] = ACTIONS(1482),
    [anon_sym_AMP_AMP] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(1480),
    [anon_sym_LT_EQ] = ACTIONS(1482),
    [anon_sym_GT] = ACTIONS(1480),
    [anon_sym_GT_EQ] = ACTIONS(1482),
    [anon_sym_EQ_EQ] = ACTIONS(1482),
    [anon_sym_BANG_EQ] = ACTIONS(1482),
    [anon_sym_STAR] = ACTIONS(1480),
    [anon_sym_SLASH] = ACTIONS(1482),
    [anon_sym_STAR_STAR] = ACTIONS(1482),
    [anon_sym_CARET] = ACTIONS(1482),
    [aux_sym_binary_operator_token1] = ACTIONS(1482),
    [anon_sym_PIPE_GT] = ACTIONS(1482),
    [anon_sym_COLON] = ACTIONS(1480),
    [anon_sym_DOLLAR] = ACTIONS(1482),
    [anon_sym_AT] = ACTIONS(1482),
    [sym__hex_literal] = ACTIONS(1482),
    [sym__number_literal] = ACTIONS(1480),
    [anon_sym_SQUOTE] = ACTIONS(1482),
    [anon_sym_DQUOTE] = ACTIONS(1482),
    [sym_return] = ACTIONS(1480),
    [sym_next] = ACTIONS(1480),
    [sym_break] = ACTIONS(1480),
    [sym_true] = ACTIONS(1480),
    [sym_false] = ACTIONS(1480),
    [sym_null] = ACTIONS(1480),
    [sym_inf] = ACTIONS(1480),
    [sym_nan] = ACTIONS(1480),
    [anon_sym_NA] = ACTIONS(1480),
    [anon_sym_NA_integer_] = ACTIONS(1480),
    [anon_sym_NA_real_] = ACTIONS(1480),
    [anon_sym_NA_complex_] = ACTIONS(1480),
    [anon_sym_NA_character_] = ACTIONS(1480),
    [sym_dots] = ACTIONS(1480),
    [sym_dot_dot_i] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1482),
    [sym__newline] = ACTIONS(1482),
    [sym__raw_string_literal] = ACTIONS(1482),
    [sym__external_else] = ACTIONS(1482),
    [sym__external_open_parenthesis] = ACTIONS(1482),
    [sym__external_open_brace] = ACTIONS(1482),
    [sym__external_open_bracket] = ACTIONS(1482),
    [sym__external_open_bracket2] = ACTIONS(1482),
    [sym__external_close_bracket2] = ACTIONS(1482),
  },
  [807] = {
    [sym_identifier] = ACTIONS(1484),
    [anon_sym_BSLASH] = ACTIONS(1486),
    [anon_sym_function] = ACTIONS(1484),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_if] = ACTIONS(1484),
    [anon_sym_for] = ACTIONS(1484),
    [anon_sym_while] = ACTIONS(1484),
    [anon_sym_repeat] = ACTIONS(1484),
    [anon_sym_QMARK] = ACTIONS(1486),
    [anon_sym_TILDE] = ACTIONS(1486),
    [anon_sym_BANG] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_LT_DASH] = ACTIONS(1486),
    [anon_sym_LT_LT_DASH] = ACTIONS(1486),
    [anon_sym_COLON_EQ] = ACTIONS(1486),
    [anon_sym_DASH_GT] = ACTIONS(1484),
    [anon_sym_DASH_GT_GT] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1484),
    [anon_sym_AMP] = ACTIONS(1484),
    [anon_sym_PIPE_PIPE] = ACTIONS(1486),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_LT] = ACTIONS(1484),
    [anon_sym_LT_EQ] = ACTIONS(1486),
    [anon_sym_GT] = ACTIONS(1484),
    [anon_sym_GT_EQ] = ACTIONS(1486),
    [anon_sym_EQ_EQ] = ACTIONS(1486),
    [anon_sym_BANG_EQ] = ACTIONS(1486),
    [anon_sym_STAR] = ACTIONS(1484),
    [anon_sym_SLASH] = ACTIONS(1486),
    [anon_sym_STAR_STAR] = ACTIONS(1486),
    [anon_sym_CARET] = ACTIONS(1486),
    [aux_sym_binary_operator_token1] = ACTIONS(1486),
    [anon_sym_PIPE_GT] = ACTIONS(1486),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(1486),
    [anon_sym_AT] = ACTIONS(1486),
    [sym__hex_literal] = ACTIONS(1486),
    [sym__number_literal] = ACTIONS(1484),
    [anon_sym_SQUOTE] = ACTIONS(1486),
    [anon_sym_DQUOTE] = ACTIONS(1486),
    [sym_return] = ACTIONS(1484),
    [sym_next] = ACTIONS(1484),
    [sym_break] = ACTIONS(1484),
    [sym_true] = ACTIONS(1484),
    [sym_false] = ACTIONS(1484),
    [sym_null] = ACTIONS(1484),
    [sym_inf] = ACTIONS(1484),
    [sym_nan] = ACTIONS(1484),
    [anon_sym_NA] = ACTIONS(1484),
    [anon_sym_NA_integer_] = ACTIONS(1484),
    [anon_sym_NA_real_] = ACTIONS(1484),
    [anon_sym_NA_complex_] = ACTIONS(1484),
    [anon_sym_NA_character_] = ACTIONS(1484),
    [sym_dots] = ACTIONS(1484),
    [sym_dot_dot_i] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1486),
    [sym__newline] = ACTIONS(1486),
    [sym__raw_string_literal] = ACTIONS(1486),
    [sym__external_else] = ACTIONS(1486),
    [sym__external_open_parenthesis] = ACTIONS(1486),
    [sym__external_open_brace] = ACTIONS(1486),
    [sym__external_open_bracket] = ACTIONS(1486),
    [sym__external_open_bracket2] = ACTIONS(1486),
    [sym__external_close_bracket2] = ACTIONS(1486),
  },
  [808] = {
    [sym_function_definition] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_repeat_statement] = STATE(406),
    [sym_braced_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_call] = STATE(406),
    [sym_subset] = STATE(406),
    [sym_subset2] = STATE(406),
    [sym_unary_operator] = STATE(406),
    [sym_binary_operator] = STATE(406),
    [sym_extract_operator] = STATE(406),
    [sym_namespace_operator] = STATE(406),
    [sym_integer] = STATE(406),
    [sym_complex] = STATE(406),
    [sym_float] = STATE(406),
    [sym__float_literal] = STATE(741),
    [sym_string] = STATE(740),
    [sym__single_quoted_string] = STATE(743),
    [sym__double_quoted_string] = STATE(746),
    [sym_na] = STATE(406),
    [sym__expression] = STATE(406),
    [sym__string_or_identifier] = STATE(2136),
    [sym__open_parenthesis] = STATE(934),
    [sym__open_brace] = STATE(853),
    [sym__close_brace] = STATE(828),
    [aux_sym_braced_expression_repeat1] = STATE(894),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1430),
    [anon_sym_function] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_repeat] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [sym__hex_literal] = ACTIONS(1450),
    [sym__number_literal] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [sym_return] = ACTIONS(1454),
    [sym_next] = ACTIONS(1454),
    [sym_break] = ACTIONS(1454),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [sym_null] = ACTIONS(1454),
    [sym_inf] = ACTIONS(1454),
    [sym_nan] = ACTIONS(1454),
    [anon_sym_NA] = ACTIONS(1456),
    [anon_sym_NA_integer_] = ACTIONS(1456),
    [anon_sym_NA_real_] = ACTIONS(1456),
    [anon_sym_NA_complex_] = ACTIONS(1456),
    [anon_sym_NA_character_] = ACTIONS(1456),
    [sym_dots] = ACTIONS(1454),
    [sym_dot_dot_i] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1460),
    [sym__semicolon] = ACTIONS(1460),
    [sym__raw_string_literal] = ACTIONS(1153),
    [sym__external_open_parenthesis] = ACTIONS(1462),
    [sym__external_open_brace] = ACTIONS(1464),
    [sym__external_close_brace] = ACTIONS(1563),
  },
  [809] = {
    [ts_builtin_sym_end] = ACTIONS(1537),
    [sym_identifier] = ACTIONS(1535),
    [anon_sym_BSLASH] = ACTIONS(1537),
    [anon_sym_function] = ACTIONS(1535),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_if] = ACTIONS(1535),
    [anon_sym_for] = ACTIONS(1535),
    [anon_sym_while] = ACTIONS(1535),
    [anon_sym_repeat] = ACTIONS(1535),
    [anon_sym_QMARK] = ACTIONS(1537),
    [anon_sym_TILDE] = ACTIONS(1537),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1535),
    [anon_sym_LT_DASH] = ACTIONS(1537),
    [anon_sym_LT_LT_DASH] = ACTIONS(1537),
    [anon_sym_COLON_EQ] = ACTIONS(1537),
    [anon_sym_DASH_GT] = ACTIONS(1535),
    [anon_sym_DASH_GT_GT] = ACTIONS(1537),
    [anon_sym_PIPE] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_PIPE_PIPE] = ACTIONS(1537),
    [anon_sym_AMP_AMP] = ACTIONS(1537),
    [anon_sym_LT] = ACTIONS(1535),
    [anon_sym_LT_EQ] = ACTIONS(1537),
    [anon_sym_GT] = ACTIONS(1535),
    [anon_sym_GT_EQ] = ACTIONS(1537),
    [anon_sym_EQ_EQ] = ACTIONS(1537),
    [anon_sym_BANG_EQ] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_SLASH] = ACTIONS(1537),
    [anon_sym_STAR_STAR] = ACTIONS(1537),
    [anon_sym_CARET] = ACTIONS(1537),
    [aux_sym_binary_operator_token1] = ACTIONS(1537),
    [anon_sym_PIPE_GT] = ACTIONS(1537),
    [anon_sym_COLON] = ACTIONS(1535),
    [anon_sym_DOLLAR] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(1537),
    [sym__hex_literal] = ACTIONS(1537),
    [sym__number_literal] = ACTIONS(1535),
    [anon_sym_SQUOTE] = ACTIONS(1537),
    [anon_sym_DQUOTE] = ACTIONS(1537),
    [sym_return] = ACTIONS(1535),
    [sym_next] = ACTIONS(1535),
    [sym_break] = ACTIONS(1535),
    [sym_true] = ACTIONS(1535),
    [sym_false] = ACTIONS(1535),
    [sym_null] = ACTIONS(1535),
    [sym_inf] = ACTIONS(1535),
    [sym_nan] = ACTIONS(1535),
    [anon_sym_NA] = ACTIONS(1535),
    [anon_sym_NA_integer_] = ACTIONS(1535),
    [anon_sym_NA_real_] = ACTIONS(1535),
    [anon_sym_NA_complex_] = ACTIONS(1535),
    [anon_sym_NA_character_] = ACTIONS(1535),
    [sym_dots] = ACTIONS(1535),
    [sym_dot_dot_i] = ACTIONS(1537),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1537),
    [sym__semicolon] = ACTIONS(1537),
    [sym__raw_string_literal] = ACTIONS(1537),
    [sym__external_else] = ACTIONS(1537),
    [sym__external_open_parenthesis] = ACTIONS(1537),
    [sym__external_open_brace] = ACTIONS(1537),
    [sym__external_open_bracket] = ACTIONS(1537),
    [sym__external_open_bracket2] = ACTIONS(1537),
  },
  [810] = {
    [sym_function_definition] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_repeat_statement] = STATE(406),
    [sym_braced_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_call] = STATE(406),
    [sym_subset] = STATE(406),
    [sym_subset2] = STATE(406),
    [sym_unary_operator] = STATE(406),
    [sym_binary_operator] = STATE(406),
    [sym_extract_operator] = STATE(406),
    [sym_namespace_operator] = STATE(406),
    [sym_integer] = STATE(406),
    [sym_complex] = STATE(406),
    [sym_float] = STATE(406),
    [sym__float_literal] = STATE(741),
    [sym_string] = STATE(740),
    [sym__single_quoted_string] = STATE(743),
    [sym__double_quoted_string] = STATE(746),
    [sym_na] = STATE(406),
    [sym__expression] = STATE(406),
    [sym__string_or_identifier] = STATE(2136),
    [sym__open_parenthesis] = STATE(934),
    [sym__open_brace] = STATE(853),
    [sym__close_brace] = STATE(1990),
    [aux_sym_braced_expression_repeat1] = STATE(894),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1430),
    [anon_sym_function] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_repeat] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [sym__hex_literal] = ACTIONS(1450),
    [sym__number_literal] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [sym_return] = ACTIONS(1454),
    [sym_next] = ACTIONS(1454),
    [sym_break] = ACTIONS(1454),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [sym_null] = ACTIONS(1454),
    [sym_inf] = ACTIONS(1454),
    [sym_nan] = ACTIONS(1454),
    [anon_sym_NA] = ACTIONS(1456),
    [anon_sym_NA_integer_] = ACTIONS(1456),
    [anon_sym_NA_real_] = ACTIONS(1456),
    [anon_sym_NA_complex_] = ACTIONS(1456),
    [anon_sym_NA_character_] = ACTIONS(1456),
    [sym_dots] = ACTIONS(1454),
    [sym_dot_dot_i] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1460),
    [sym__semicolon] = ACTIONS(1460),
    [sym__raw_string_literal] = ACTIONS(1153),
    [sym__external_open_parenthesis] = ACTIONS(1462),
    [sym__external_open_brace] = ACTIONS(1464),
    [sym__external_close_brace] = ACTIONS(1565),
  },
  [811] = {
    [ts_builtin_sym_end] = ACTIONS(1553),
    [sym_identifier] = ACTIONS(1551),
    [anon_sym_BSLASH] = ACTIONS(1553),
    [anon_sym_function] = ACTIONS(1551),
    [anon_sym_EQ] = ACTIONS(1551),
    [anon_sym_if] = ACTIONS(1551),
    [anon_sym_for] = ACTIONS(1551),
    [anon_sym_while] = ACTIONS(1551),
    [anon_sym_repeat] = ACTIONS(1551),
    [anon_sym_QMARK] = ACTIONS(1553),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_PLUS] = ACTIONS(1553),
    [anon_sym_DASH] = ACTIONS(1551),
    [anon_sym_LT_DASH] = ACTIONS(1553),
    [anon_sym_LT_LT_DASH] = ACTIONS(1553),
    [anon_sym_COLON_EQ] = ACTIONS(1553),
    [anon_sym_DASH_GT] = ACTIONS(1551),
    [anon_sym_DASH_GT_GT] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_PIPE_PIPE] = ACTIONS(1553),
    [anon_sym_AMP_AMP] = ACTIONS(1553),
    [anon_sym_LT] = ACTIONS(1551),
    [anon_sym_LT_EQ] = ACTIONS(1553),
    [anon_sym_GT] = ACTIONS(1551),
    [anon_sym_GT_EQ] = ACTIONS(1553),
    [anon_sym_EQ_EQ] = ACTIONS(1553),
    [anon_sym_BANG_EQ] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(1551),
    [anon_sym_SLASH] = ACTIONS(1553),
    [anon_sym_STAR_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [aux_sym_binary_operator_token1] = ACTIONS(1553),
    [anon_sym_PIPE_GT] = ACTIONS(1553),
    [anon_sym_COLON] = ACTIONS(1551),
    [anon_sym_DOLLAR] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(1553),
    [sym__hex_literal] = ACTIONS(1553),
    [sym__number_literal] = ACTIONS(1551),
    [anon_sym_SQUOTE] = ACTIONS(1553),
    [anon_sym_DQUOTE] = ACTIONS(1553),
    [sym_return] = ACTIONS(1551),
    [sym_next] = ACTIONS(1551),
    [sym_break] = ACTIONS(1551),
    [sym_true] = ACTIONS(1551),
    [sym_false] = ACTIONS(1551),
    [sym_null] = ACTIONS(1551),
    [sym_inf] = ACTIONS(1551),
    [sym_nan] = ACTIONS(1551),
    [anon_sym_NA] = ACTIONS(1551),
    [anon_sym_NA_integer_] = ACTIONS(1551),
    [anon_sym_NA_real_] = ACTIONS(1551),
    [anon_sym_NA_complex_] = ACTIONS(1551),
    [anon_sym_NA_character_] = ACTIONS(1551),
    [sym_dots] = ACTIONS(1551),
    [sym_dot_dot_i] = ACTIONS(1553),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1553),
    [sym__semicolon] = ACTIONS(1553),
    [sym__raw_string_literal] = ACTIONS(1553),
    [sym__external_else] = ACTIONS(1553),
    [sym__external_open_parenthesis] = ACTIONS(1553),
    [sym__external_open_brace] = ACTIONS(1553),
    [sym__external_open_bracket] = ACTIONS(1553),
    [sym__external_open_bracket2] = ACTIONS(1553),
  },
  [812] = {
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_BSLASH] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1539),
    [anon_sym_if] = ACTIONS(1539),
    [anon_sym_for] = ACTIONS(1539),
    [anon_sym_while] = ACTIONS(1539),
    [anon_sym_repeat] = ACTIONS(1539),
    [anon_sym_QMARK] = ACTIONS(1541),
    [anon_sym_TILDE] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1539),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1539),
    [anon_sym_LT_DASH] = ACTIONS(1541),
    [anon_sym_LT_LT_DASH] = ACTIONS(1541),
    [anon_sym_COLON_EQ] = ACTIONS(1541),
    [anon_sym_DASH_GT] = ACTIONS(1539),
    [anon_sym_DASH_GT_GT] = ACTIONS(1541),
    [anon_sym_PIPE] = ACTIONS(1539),
    [anon_sym_AMP] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1541),
    [anon_sym_GT] = ACTIONS(1539),
    [anon_sym_GT_EQ] = ACTIONS(1541),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1539),
    [anon_sym_SLASH] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_CARET] = ACTIONS(1541),
    [aux_sym_binary_operator_token1] = ACTIONS(1541),
    [anon_sym_PIPE_GT] = ACTIONS(1541),
    [anon_sym_COLON] = ACTIONS(1539),
    [anon_sym_DOLLAR] = ACTIONS(1541),
    [anon_sym_AT] = ACTIONS(1541),
    [sym__hex_literal] = ACTIONS(1541),
    [sym__number_literal] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(1541),
    [anon_sym_DQUOTE] = ACTIONS(1541),
    [sym_return] = ACTIONS(1539),
    [sym_next] = ACTIONS(1539),
    [sym_break] = ACTIONS(1539),
    [sym_true] = ACTIONS(1539),
    [sym_false] = ACTIONS(1539),
    [sym_null] = ACTIONS(1539),
    [sym_inf] = ACTIONS(1539),
    [sym_nan] = ACTIONS(1539),
    [anon_sym_NA] = ACTIONS(1539),
    [anon_sym_NA_integer_] = ACTIONS(1539),
    [anon_sym_NA_real_] = ACTIONS(1539),
    [anon_sym_NA_complex_] = ACTIONS(1539),
    [anon_sym_NA_character_] = ACTIONS(1539),
    [sym_dots] = ACTIONS(1539),
    [sym_dot_dot_i] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1541),
    [sym__semicolon] = ACTIONS(1541),
    [sym__raw_string_literal] = ACTIONS(1541),
    [sym__external_else] = ACTIONS(1541),
    [sym__external_open_parenthesis] = ACTIONS(1541),
    [sym__external_open_brace] = ACTIONS(1541),
    [sym__external_close_brace] = ACTIONS(1541),
    [sym__external_open_bracket] = ACTIONS(1541),
    [sym__external_open_bracket2] = ACTIONS(1541),
  },
  [813] = {
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_BSLASH] = ACTIONS(1545),
    [anon_sym_function] = ACTIONS(1543),
    [anon_sym_EQ] = ACTIONS(1543),
    [anon_sym_if] = ACTIONS(1543),
    [anon_sym_for] = ACTIONS(1543),
    [anon_sym_while] = ACTIONS(1543),
    [anon_sym_repeat] = ACTIONS(1543),
    [anon_sym_QMARK] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1543),
    [anon_sym_PLUS] = ACTIONS(1545),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_LT_DASH] = ACTIONS(1545),
    [anon_sym_LT_LT_DASH] = ACTIONS(1545),
    [anon_sym_COLON_EQ] = ACTIONS(1545),
    [anon_sym_DASH_GT] = ACTIONS(1543),
    [anon_sym_DASH_GT_GT] = ACTIONS(1545),
    [anon_sym_PIPE] = ACTIONS(1543),
    [anon_sym_AMP] = ACTIONS(1543),
    [anon_sym_PIPE_PIPE] = ACTIONS(1545),
    [anon_sym_AMP_AMP] = ACTIONS(1545),
    [anon_sym_LT] = ACTIONS(1543),
    [anon_sym_LT_EQ] = ACTIONS(1545),
    [anon_sym_GT] = ACTIONS(1543),
    [anon_sym_GT_EQ] = ACTIONS(1545),
    [anon_sym_EQ_EQ] = ACTIONS(1545),
    [anon_sym_BANG_EQ] = ACTIONS(1545),
    [anon_sym_STAR] = ACTIONS(1543),
    [anon_sym_SLASH] = ACTIONS(1545),
    [anon_sym_STAR_STAR] = ACTIONS(1545),
    [anon_sym_CARET] = ACTIONS(1545),
    [aux_sym_binary_operator_token1] = ACTIONS(1545),
    [anon_sym_PIPE_GT] = ACTIONS(1545),
    [anon_sym_COLON] = ACTIONS(1543),
    [anon_sym_DOLLAR] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(1545),
    [sym__hex_literal] = ACTIONS(1545),
    [sym__number_literal] = ACTIONS(1543),
    [anon_sym_SQUOTE] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1545),
    [sym_return] = ACTIONS(1543),
    [sym_next] = ACTIONS(1543),
    [sym_break] = ACTIONS(1543),
    [sym_true] = ACTIONS(1543),
    [sym_false] = ACTIONS(1543),
    [sym_null] = ACTIONS(1543),
    [sym_inf] = ACTIONS(1543),
    [sym_nan] = ACTIONS(1543),
    [anon_sym_NA] = ACTIONS(1543),
    [anon_sym_NA_integer_] = ACTIONS(1543),
    [anon_sym_NA_real_] = ACTIONS(1543),
    [anon_sym_NA_complex_] = ACTIONS(1543),
    [anon_sym_NA_character_] = ACTIONS(1543),
    [sym_dots] = ACTIONS(1543),
    [sym_dot_dot_i] = ACTIONS(1545),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1545),
    [sym__semicolon] = ACTIONS(1545),
    [sym__raw_string_literal] = ACTIONS(1545),
    [sym__external_else] = ACTIONS(1545),
    [sym__external_open_parenthesis] = ACTIONS(1545),
    [sym__external_open_brace] = ACTIONS(1545),
    [sym__external_close_brace] = ACTIONS(1545),
    [sym__external_open_bracket] = ACTIONS(1545),
    [sym__external_open_bracket2] = ACTIONS(1545),
  },
  [814] = {
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_BSLASH] = ACTIONS(1549),
    [anon_sym_function] = ACTIONS(1547),
    [anon_sym_EQ] = ACTIONS(1547),
    [anon_sym_if] = ACTIONS(1547),
    [anon_sym_for] = ACTIONS(1547),
    [anon_sym_while] = ACTIONS(1547),
    [anon_sym_repeat] = ACTIONS(1547),
    [anon_sym_QMARK] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1547),
    [anon_sym_LT_DASH] = ACTIONS(1549),
    [anon_sym_LT_LT_DASH] = ACTIONS(1549),
    [anon_sym_COLON_EQ] = ACTIONS(1549),
    [anon_sym_DASH_GT] = ACTIONS(1547),
    [anon_sym_DASH_GT_GT] = ACTIONS(1549),
    [anon_sym_PIPE] = ACTIONS(1547),
    [anon_sym_AMP] = ACTIONS(1547),
    [anon_sym_PIPE_PIPE] = ACTIONS(1549),
    [anon_sym_AMP_AMP] = ACTIONS(1549),
    [anon_sym_LT] = ACTIONS(1547),
    [anon_sym_LT_EQ] = ACTIONS(1549),
    [anon_sym_GT] = ACTIONS(1547),
    [anon_sym_GT_EQ] = ACTIONS(1549),
    [anon_sym_EQ_EQ] = ACTIONS(1549),
    [anon_sym_BANG_EQ] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_SLASH] = ACTIONS(1549),
    [anon_sym_STAR_STAR] = ACTIONS(1549),
    [anon_sym_CARET] = ACTIONS(1549),
    [aux_sym_binary_operator_token1] = ACTIONS(1549),
    [anon_sym_PIPE_GT] = ACTIONS(1549),
    [anon_sym_COLON] = ACTIONS(1547),
    [anon_sym_DOLLAR] = ACTIONS(1549),
    [anon_sym_AT] = ACTIONS(1549),
    [sym__hex_literal] = ACTIONS(1549),
    [sym__number_literal] = ACTIONS(1547),
    [anon_sym_SQUOTE] = ACTIONS(1549),
    [anon_sym_DQUOTE] = ACTIONS(1549),
    [sym_return] = ACTIONS(1547),
    [sym_next] = ACTIONS(1547),
    [sym_break] = ACTIONS(1547),
    [sym_true] = ACTIONS(1547),
    [sym_false] = ACTIONS(1547),
    [sym_null] = ACTIONS(1547),
    [sym_inf] = ACTIONS(1547),
    [sym_nan] = ACTIONS(1547),
    [anon_sym_NA] = ACTIONS(1547),
    [anon_sym_NA_integer_] = ACTIONS(1547),
    [anon_sym_NA_real_] = ACTIONS(1547),
    [anon_sym_NA_complex_] = ACTIONS(1547),
    [anon_sym_NA_character_] = ACTIONS(1547),
    [sym_dots] = ACTIONS(1547),
    [sym_dot_dot_i] = ACTIONS(1549),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1549),
    [sym__semicolon] = ACTIONS(1549),
    [sym__raw_string_literal] = ACTIONS(1549),
    [sym__external_else] = ACTIONS(1549),
    [sym__external_open_parenthesis] = ACTIONS(1549),
    [sym__external_open_brace] = ACTIONS(1549),
    [sym__external_close_brace] = ACTIONS(1549),
    [sym__external_open_bracket] = ACTIONS(1549),
    [sym__external_open_bracket2] = ACTIONS(1549),
  },
  [815] = {
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_BSLASH] = ACTIONS(1549),
    [anon_sym_function] = ACTIONS(1547),
    [anon_sym_EQ] = ACTIONS(1547),
    [anon_sym_if] = ACTIONS(1547),
    [anon_sym_for] = ACTIONS(1547),
    [anon_sym_while] = ACTIONS(1547),
    [anon_sym_repeat] = ACTIONS(1547),
    [anon_sym_QMARK] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1547),
    [anon_sym_LT_DASH] = ACTIONS(1549),
    [anon_sym_LT_LT_DASH] = ACTIONS(1549),
    [anon_sym_COLON_EQ] = ACTIONS(1549),
    [anon_sym_DASH_GT] = ACTIONS(1547),
    [anon_sym_DASH_GT_GT] = ACTIONS(1549),
    [anon_sym_PIPE] = ACTIONS(1547),
    [anon_sym_AMP] = ACTIONS(1547),
    [anon_sym_PIPE_PIPE] = ACTIONS(1549),
    [anon_sym_AMP_AMP] = ACTIONS(1549),
    [anon_sym_LT] = ACTIONS(1547),
    [anon_sym_LT_EQ] = ACTIONS(1549),
    [anon_sym_GT] = ACTIONS(1547),
    [anon_sym_GT_EQ] = ACTIONS(1549),
    [anon_sym_EQ_EQ] = ACTIONS(1549),
    [anon_sym_BANG_EQ] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_SLASH] = ACTIONS(1549),
    [anon_sym_STAR_STAR] = ACTIONS(1549),
    [anon_sym_CARET] = ACTIONS(1549),
    [aux_sym_binary_operator_token1] = ACTIONS(1549),
    [anon_sym_PIPE_GT] = ACTIONS(1549),
    [anon_sym_COLON] = ACTIONS(1547),
    [anon_sym_DOLLAR] = ACTIONS(1549),
    [anon_sym_AT] = ACTIONS(1549),
    [sym__hex_literal] = ACTIONS(1549),
    [sym__number_literal] = ACTIONS(1547),
    [anon_sym_SQUOTE] = ACTIONS(1549),
    [anon_sym_DQUOTE] = ACTIONS(1549),
    [sym_return] = ACTIONS(1547),
    [sym_next] = ACTIONS(1547),
    [sym_break] = ACTIONS(1547),
    [sym_true] = ACTIONS(1547),
    [sym_false] = ACTIONS(1547),
    [sym_null] = ACTIONS(1547),
    [sym_inf] = ACTIONS(1547),
    [sym_nan] = ACTIONS(1547),
    [anon_sym_NA] = ACTIONS(1547),
    [anon_sym_NA_integer_] = ACTIONS(1547),
    [anon_sym_NA_real_] = ACTIONS(1547),
    [anon_sym_NA_complex_] = ACTIONS(1547),
    [anon_sym_NA_character_] = ACTIONS(1547),
    [sym_dots] = ACTIONS(1547),
    [sym_dot_dot_i] = ACTIONS(1549),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1549),
    [sym__newline] = ACTIONS(1549),
    [sym__raw_string_literal] = ACTIONS(1549),
    [sym__external_else] = ACTIONS(1549),
    [sym__external_open_parenthesis] = ACTIONS(1549),
    [sym__external_close_parenthesis] = ACTIONS(1549),
    [sym__external_open_brace] = ACTIONS(1549),
    [sym__external_open_bracket] = ACTIONS(1549),
    [sym__external_open_bracket2] = ACTIONS(1549),
  },
  [816] = {
    [sym_identifier] = ACTIONS(1484),
    [anon_sym_BSLASH] = ACTIONS(1486),
    [anon_sym_function] = ACTIONS(1484),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_if] = ACTIONS(1484),
    [anon_sym_for] = ACTIONS(1484),
    [anon_sym_while] = ACTIONS(1484),
    [anon_sym_repeat] = ACTIONS(1484),
    [anon_sym_QMARK] = ACTIONS(1486),
    [anon_sym_TILDE] = ACTIONS(1486),
    [anon_sym_BANG] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_LT_DASH] = ACTIONS(1486),
    [anon_sym_LT_LT_DASH] = ACTIONS(1486),
    [anon_sym_COLON_EQ] = ACTIONS(1486),
    [anon_sym_DASH_GT] = ACTIONS(1484),
    [anon_sym_DASH_GT_GT] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1484),
    [anon_sym_AMP] = ACTIONS(1484),
    [anon_sym_PIPE_PIPE] = ACTIONS(1486),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_LT] = ACTIONS(1484),
    [anon_sym_LT_EQ] = ACTIONS(1486),
    [anon_sym_GT] = ACTIONS(1484),
    [anon_sym_GT_EQ] = ACTIONS(1486),
    [anon_sym_EQ_EQ] = ACTIONS(1486),
    [anon_sym_BANG_EQ] = ACTIONS(1486),
    [anon_sym_STAR] = ACTIONS(1484),
    [anon_sym_SLASH] = ACTIONS(1486),
    [anon_sym_STAR_STAR] = ACTIONS(1486),
    [anon_sym_CARET] = ACTIONS(1486),
    [aux_sym_binary_operator_token1] = ACTIONS(1486),
    [anon_sym_PIPE_GT] = ACTIONS(1486),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(1486),
    [anon_sym_AT] = ACTIONS(1486),
    [sym__hex_literal] = ACTIONS(1486),
    [sym__number_literal] = ACTIONS(1484),
    [anon_sym_SQUOTE] = ACTIONS(1486),
    [anon_sym_DQUOTE] = ACTIONS(1486),
    [sym_return] = ACTIONS(1484),
    [sym_next] = ACTIONS(1484),
    [sym_break] = ACTIONS(1484),
    [sym_true] = ACTIONS(1484),
    [sym_false] = ACTIONS(1484),
    [sym_null] = ACTIONS(1484),
    [sym_inf] = ACTIONS(1484),
    [sym_nan] = ACTIONS(1484),
    [anon_sym_NA] = ACTIONS(1484),
    [anon_sym_NA_integer_] = ACTIONS(1484),
    [anon_sym_NA_real_] = ACTIONS(1484),
    [anon_sym_NA_complex_] = ACTIONS(1484),
    [anon_sym_NA_character_] = ACTIONS(1484),
    [sym_dots] = ACTIONS(1484),
    [sym_dot_dot_i] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1486),
    [sym__semicolon] = ACTIONS(1486),
    [sym__raw_string_literal] = ACTIONS(1486),
    [sym__external_else] = ACTIONS(1486),
    [sym__external_open_parenthesis] = ACTIONS(1486),
    [sym__external_open_brace] = ACTIONS(1486),
    [sym__external_close_brace] = ACTIONS(1486),
    [sym__external_open_bracket] = ACTIONS(1486),
    [sym__external_open_bracket2] = ACTIONS(1486),
  },
  [817] = {
    [ts_builtin_sym_end] = ACTIONS(1470),
    [sym_identifier] = ACTIONS(1468),
    [anon_sym_BSLASH] = ACTIONS(1470),
    [anon_sym_function] = ACTIONS(1468),
    [anon_sym_EQ] = ACTIONS(1468),
    [anon_sym_if] = ACTIONS(1468),
    [anon_sym_for] = ACTIONS(1468),
    [anon_sym_while] = ACTIONS(1468),
    [anon_sym_repeat] = ACTIONS(1468),
    [anon_sym_QMARK] = ACTIONS(1470),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_BANG] = ACTIONS(1468),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1468),
    [anon_sym_LT_DASH] = ACTIONS(1470),
    [anon_sym_LT_LT_DASH] = ACTIONS(1470),
    [anon_sym_COLON_EQ] = ACTIONS(1470),
    [anon_sym_DASH_GT] = ACTIONS(1468),
    [anon_sym_DASH_GT_GT] = ACTIONS(1470),
    [anon_sym_PIPE] = ACTIONS(1468),
    [anon_sym_AMP] = ACTIONS(1468),
    [anon_sym_PIPE_PIPE] = ACTIONS(1470),
    [anon_sym_AMP_AMP] = ACTIONS(1470),
    [anon_sym_LT] = ACTIONS(1468),
    [anon_sym_LT_EQ] = ACTIONS(1470),
    [anon_sym_GT] = ACTIONS(1468),
    [anon_sym_GT_EQ] = ACTIONS(1470),
    [anon_sym_EQ_EQ] = ACTIONS(1470),
    [anon_sym_BANG_EQ] = ACTIONS(1470),
    [anon_sym_STAR] = ACTIONS(1468),
    [anon_sym_SLASH] = ACTIONS(1470),
    [anon_sym_STAR_STAR] = ACTIONS(1470),
    [anon_sym_CARET] = ACTIONS(1470),
    [aux_sym_binary_operator_token1] = ACTIONS(1470),
    [anon_sym_PIPE_GT] = ACTIONS(1470),
    [anon_sym_COLON] = ACTIONS(1468),
    [anon_sym_DOLLAR] = ACTIONS(1470),
    [anon_sym_AT] = ACTIONS(1470),
    [sym__hex_literal] = ACTIONS(1470),
    [sym__number_literal] = ACTIONS(1468),
    [anon_sym_SQUOTE] = ACTIONS(1470),
    [anon_sym_DQUOTE] = ACTIONS(1470),
    [sym_return] = ACTIONS(1468),
    [sym_next] = ACTIONS(1468),
    [sym_break] = ACTIONS(1468),
    [sym_true] = ACTIONS(1468),
    [sym_false] = ACTIONS(1468),
    [sym_null] = ACTIONS(1468),
    [sym_inf] = ACTIONS(1468),
    [sym_nan] = ACTIONS(1468),
    [anon_sym_NA] = ACTIONS(1468),
    [anon_sym_NA_integer_] = ACTIONS(1468),
    [anon_sym_NA_real_] = ACTIONS(1468),
    [anon_sym_NA_complex_] = ACTIONS(1468),
    [anon_sym_NA_character_] = ACTIONS(1468),
    [sym_dots] = ACTIONS(1468),
    [sym_dot_dot_i] = ACTIONS(1470),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1470),
    [sym__semicolon] = ACTIONS(1470),
    [sym__raw_string_literal] = ACTIONS(1470),
    [sym__external_else] = ACTIONS(1470),
    [sym__external_open_parenthesis] = ACTIONS(1470),
    [sym__external_open_brace] = ACTIONS(1470),
    [sym__external_open_bracket] = ACTIONS(1470),
    [sym__external_open_bracket2] = ACTIONS(1470),
  },
  [818] = {
    [ts_builtin_sym_end] = ACTIONS(1541),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_BSLASH] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1539),
    [anon_sym_if] = ACTIONS(1539),
    [anon_sym_for] = ACTIONS(1539),
    [anon_sym_while] = ACTIONS(1539),
    [anon_sym_repeat] = ACTIONS(1539),
    [anon_sym_QMARK] = ACTIONS(1541),
    [anon_sym_TILDE] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1539),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1539),
    [anon_sym_LT_DASH] = ACTIONS(1541),
    [anon_sym_LT_LT_DASH] = ACTIONS(1541),
    [anon_sym_COLON_EQ] = ACTIONS(1541),
    [anon_sym_DASH_GT] = ACTIONS(1539),
    [anon_sym_DASH_GT_GT] = ACTIONS(1541),
    [anon_sym_PIPE] = ACTIONS(1539),
    [anon_sym_AMP] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1541),
    [anon_sym_GT] = ACTIONS(1539),
    [anon_sym_GT_EQ] = ACTIONS(1541),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1539),
    [anon_sym_SLASH] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_CARET] = ACTIONS(1541),
    [aux_sym_binary_operator_token1] = ACTIONS(1541),
    [anon_sym_PIPE_GT] = ACTIONS(1541),
    [anon_sym_COLON] = ACTIONS(1539),
    [anon_sym_DOLLAR] = ACTIONS(1541),
    [anon_sym_AT] = ACTIONS(1541),
    [sym__hex_literal] = ACTIONS(1541),
    [sym__number_literal] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(1541),
    [anon_sym_DQUOTE] = ACTIONS(1541),
    [sym_return] = ACTIONS(1539),
    [sym_next] = ACTIONS(1539),
    [sym_break] = ACTIONS(1539),
    [sym_true] = ACTIONS(1539),
    [sym_false] = ACTIONS(1539),
    [sym_null] = ACTIONS(1539),
    [sym_inf] = ACTIONS(1539),
    [sym_nan] = ACTIONS(1539),
    [anon_sym_NA] = ACTIONS(1539),
    [anon_sym_NA_integer_] = ACTIONS(1539),
    [anon_sym_NA_real_] = ACTIONS(1539),
    [anon_sym_NA_complex_] = ACTIONS(1539),
    [anon_sym_NA_character_] = ACTIONS(1539),
    [sym_dots] = ACTIONS(1539),
    [sym_dot_dot_i] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1541),
    [sym__semicolon] = ACTIONS(1541),
    [sym__raw_string_literal] = ACTIONS(1541),
    [sym__external_else] = ACTIONS(1541),
    [sym__external_open_parenthesis] = ACTIONS(1541),
    [sym__external_open_brace] = ACTIONS(1541),
    [sym__external_open_bracket] = ACTIONS(1541),
    [sym__external_open_bracket2] = ACTIONS(1541),
  },
  [819] = {
    [ts_builtin_sym_end] = ACTIONS(1545),
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_BSLASH] = ACTIONS(1545),
    [anon_sym_function] = ACTIONS(1543),
    [anon_sym_EQ] = ACTIONS(1543),
    [anon_sym_if] = ACTIONS(1543),
    [anon_sym_for] = ACTIONS(1543),
    [anon_sym_while] = ACTIONS(1543),
    [anon_sym_repeat] = ACTIONS(1543),
    [anon_sym_QMARK] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1543),
    [anon_sym_PLUS] = ACTIONS(1545),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_LT_DASH] = ACTIONS(1545),
    [anon_sym_LT_LT_DASH] = ACTIONS(1545),
    [anon_sym_COLON_EQ] = ACTIONS(1545),
    [anon_sym_DASH_GT] = ACTIONS(1543),
    [anon_sym_DASH_GT_GT] = ACTIONS(1545),
    [anon_sym_PIPE] = ACTIONS(1543),
    [anon_sym_AMP] = ACTIONS(1543),
    [anon_sym_PIPE_PIPE] = ACTIONS(1545),
    [anon_sym_AMP_AMP] = ACTIONS(1545),
    [anon_sym_LT] = ACTIONS(1543),
    [anon_sym_LT_EQ] = ACTIONS(1545),
    [anon_sym_GT] = ACTIONS(1543),
    [anon_sym_GT_EQ] = ACTIONS(1545),
    [anon_sym_EQ_EQ] = ACTIONS(1545),
    [anon_sym_BANG_EQ] = ACTIONS(1545),
    [anon_sym_STAR] = ACTIONS(1543),
    [anon_sym_SLASH] = ACTIONS(1545),
    [anon_sym_STAR_STAR] = ACTIONS(1545),
    [anon_sym_CARET] = ACTIONS(1545),
    [aux_sym_binary_operator_token1] = ACTIONS(1545),
    [anon_sym_PIPE_GT] = ACTIONS(1545),
    [anon_sym_COLON] = ACTIONS(1543),
    [anon_sym_DOLLAR] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(1545),
    [sym__hex_literal] = ACTIONS(1545),
    [sym__number_literal] = ACTIONS(1543),
    [anon_sym_SQUOTE] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1545),
    [sym_return] = ACTIONS(1543),
    [sym_next] = ACTIONS(1543),
    [sym_break] = ACTIONS(1543),
    [sym_true] = ACTIONS(1543),
    [sym_false] = ACTIONS(1543),
    [sym_null] = ACTIONS(1543),
    [sym_inf] = ACTIONS(1543),
    [sym_nan] = ACTIONS(1543),
    [anon_sym_NA] = ACTIONS(1543),
    [anon_sym_NA_integer_] = ACTIONS(1543),
    [anon_sym_NA_real_] = ACTIONS(1543),
    [anon_sym_NA_complex_] = ACTIONS(1543),
    [anon_sym_NA_character_] = ACTIONS(1543),
    [sym_dots] = ACTIONS(1543),
    [sym_dot_dot_i] = ACTIONS(1545),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1545),
    [sym__semicolon] = ACTIONS(1545),
    [sym__raw_string_literal] = ACTIONS(1545),
    [sym__external_else] = ACTIONS(1545),
    [sym__external_open_parenthesis] = ACTIONS(1545),
    [sym__external_open_brace] = ACTIONS(1545),
    [sym__external_open_bracket] = ACTIONS(1545),
    [sym__external_open_bracket2] = ACTIONS(1545),
  },
  [820] = {
    [ts_builtin_sym_end] = ACTIONS(1549),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_BSLASH] = ACTIONS(1549),
    [anon_sym_function] = ACTIONS(1547),
    [anon_sym_EQ] = ACTIONS(1547),
    [anon_sym_if] = ACTIONS(1547),
    [anon_sym_for] = ACTIONS(1547),
    [anon_sym_while] = ACTIONS(1547),
    [anon_sym_repeat] = ACTIONS(1547),
    [anon_sym_QMARK] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1547),
    [anon_sym_LT_DASH] = ACTIONS(1549),
    [anon_sym_LT_LT_DASH] = ACTIONS(1549),
    [anon_sym_COLON_EQ] = ACTIONS(1549),
    [anon_sym_DASH_GT] = ACTIONS(1547),
    [anon_sym_DASH_GT_GT] = ACTIONS(1549),
    [anon_sym_PIPE] = ACTIONS(1547),
    [anon_sym_AMP] = ACTIONS(1547),
    [anon_sym_PIPE_PIPE] = ACTIONS(1549),
    [anon_sym_AMP_AMP] = ACTIONS(1549),
    [anon_sym_LT] = ACTIONS(1547),
    [anon_sym_LT_EQ] = ACTIONS(1549),
    [anon_sym_GT] = ACTIONS(1547),
    [anon_sym_GT_EQ] = ACTIONS(1549),
    [anon_sym_EQ_EQ] = ACTIONS(1549),
    [anon_sym_BANG_EQ] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_SLASH] = ACTIONS(1549),
    [anon_sym_STAR_STAR] = ACTIONS(1549),
    [anon_sym_CARET] = ACTIONS(1549),
    [aux_sym_binary_operator_token1] = ACTIONS(1549),
    [anon_sym_PIPE_GT] = ACTIONS(1549),
    [anon_sym_COLON] = ACTIONS(1547),
    [anon_sym_DOLLAR] = ACTIONS(1549),
    [anon_sym_AT] = ACTIONS(1549),
    [sym__hex_literal] = ACTIONS(1549),
    [sym__number_literal] = ACTIONS(1547),
    [anon_sym_SQUOTE] = ACTIONS(1549),
    [anon_sym_DQUOTE] = ACTIONS(1549),
    [sym_return] = ACTIONS(1547),
    [sym_next] = ACTIONS(1547),
    [sym_break] = ACTIONS(1547),
    [sym_true] = ACTIONS(1547),
    [sym_false] = ACTIONS(1547),
    [sym_null] = ACTIONS(1547),
    [sym_inf] = ACTIONS(1547),
    [sym_nan] = ACTIONS(1547),
    [anon_sym_NA] = ACTIONS(1547),
    [anon_sym_NA_integer_] = ACTIONS(1547),
    [anon_sym_NA_real_] = ACTIONS(1547),
    [anon_sym_NA_complex_] = ACTIONS(1547),
    [anon_sym_NA_character_] = ACTIONS(1547),
    [sym_dots] = ACTIONS(1547),
    [sym_dot_dot_i] = ACTIONS(1549),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1549),
    [sym__semicolon] = ACTIONS(1549),
    [sym__raw_string_literal] = ACTIONS(1549),
    [sym__external_else] = ACTIONS(1549),
    [sym__external_open_parenthesis] = ACTIONS(1549),
    [sym__external_open_brace] = ACTIONS(1549),
    [sym__external_open_bracket] = ACTIONS(1549),
    [sym__external_open_bracket2] = ACTIONS(1549),
  },
  [821] = {
    [ts_builtin_sym_end] = ACTIONS(1494),
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_BSLASH] = ACTIONS(1494),
    [anon_sym_function] = ACTIONS(1492),
    [anon_sym_EQ] = ACTIONS(1492),
    [anon_sym_if] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(1492),
    [anon_sym_while] = ACTIONS(1492),
    [anon_sym_repeat] = ACTIONS(1492),
    [anon_sym_QMARK] = ACTIONS(1494),
    [anon_sym_TILDE] = ACTIONS(1494),
    [anon_sym_BANG] = ACTIONS(1492),
    [anon_sym_PLUS] = ACTIONS(1494),
    [anon_sym_DASH] = ACTIONS(1492),
    [anon_sym_LT_DASH] = ACTIONS(1494),
    [anon_sym_LT_LT_DASH] = ACTIONS(1494),
    [anon_sym_COLON_EQ] = ACTIONS(1494),
    [anon_sym_DASH_GT] = ACTIONS(1492),
    [anon_sym_DASH_GT_GT] = ACTIONS(1494),
    [anon_sym_PIPE] = ACTIONS(1492),
    [anon_sym_AMP] = ACTIONS(1492),
    [anon_sym_PIPE_PIPE] = ACTIONS(1494),
    [anon_sym_AMP_AMP] = ACTIONS(1494),
    [anon_sym_LT] = ACTIONS(1492),
    [anon_sym_LT_EQ] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1492),
    [anon_sym_GT_EQ] = ACTIONS(1494),
    [anon_sym_EQ_EQ] = ACTIONS(1494),
    [anon_sym_BANG_EQ] = ACTIONS(1494),
    [anon_sym_STAR] = ACTIONS(1492),
    [anon_sym_SLASH] = ACTIONS(1494),
    [anon_sym_STAR_STAR] = ACTIONS(1494),
    [anon_sym_CARET] = ACTIONS(1494),
    [aux_sym_binary_operator_token1] = ACTIONS(1494),
    [anon_sym_PIPE_GT] = ACTIONS(1494),
    [anon_sym_COLON] = ACTIONS(1492),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [anon_sym_AT] = ACTIONS(1494),
    [sym__hex_literal] = ACTIONS(1494),
    [sym__number_literal] = ACTIONS(1492),
    [anon_sym_SQUOTE] = ACTIONS(1494),
    [anon_sym_DQUOTE] = ACTIONS(1494),
    [sym_return] = ACTIONS(1492),
    [sym_next] = ACTIONS(1492),
    [sym_break] = ACTIONS(1492),
    [sym_true] = ACTIONS(1492),
    [sym_false] = ACTIONS(1492),
    [sym_null] = ACTIONS(1492),
    [sym_inf] = ACTIONS(1492),
    [sym_nan] = ACTIONS(1492),
    [anon_sym_NA] = ACTIONS(1492),
    [anon_sym_NA_integer_] = ACTIONS(1492),
    [anon_sym_NA_real_] = ACTIONS(1492),
    [anon_sym_NA_complex_] = ACTIONS(1492),
    [anon_sym_NA_character_] = ACTIONS(1492),
    [sym_dots] = ACTIONS(1492),
    [sym_dot_dot_i] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1494),
    [sym__semicolon] = ACTIONS(1494),
    [sym__raw_string_literal] = ACTIONS(1494),
    [sym__external_else] = ACTIONS(1494),
    [sym__external_open_parenthesis] = ACTIONS(1494),
    [sym__external_open_brace] = ACTIONS(1494),
    [sym__external_open_bracket] = ACTIONS(1494),
    [sym__external_open_bracket2] = ACTIONS(1494),
  },
  [822] = {
    [sym_identifier] = ACTIONS(1500),
    [anon_sym_BSLASH] = ACTIONS(1502),
    [anon_sym_function] = ACTIONS(1500),
    [anon_sym_EQ] = ACTIONS(1500),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_for] = ACTIONS(1500),
    [anon_sym_while] = ACTIONS(1500),
    [anon_sym_repeat] = ACTIONS(1500),
    [anon_sym_QMARK] = ACTIONS(1502),
    [anon_sym_TILDE] = ACTIONS(1502),
    [anon_sym_BANG] = ACTIONS(1500),
    [anon_sym_PLUS] = ACTIONS(1502),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_LT_DASH] = ACTIONS(1502),
    [anon_sym_LT_LT_DASH] = ACTIONS(1502),
    [anon_sym_COLON_EQ] = ACTIONS(1502),
    [anon_sym_DASH_GT] = ACTIONS(1500),
    [anon_sym_DASH_GT_GT] = ACTIONS(1502),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_AMP] = ACTIONS(1500),
    [anon_sym_PIPE_PIPE] = ACTIONS(1502),
    [anon_sym_AMP_AMP] = ACTIONS(1502),
    [anon_sym_LT] = ACTIONS(1500),
    [anon_sym_LT_EQ] = ACTIONS(1502),
    [anon_sym_GT] = ACTIONS(1500),
    [anon_sym_GT_EQ] = ACTIONS(1502),
    [anon_sym_EQ_EQ] = ACTIONS(1502),
    [anon_sym_BANG_EQ] = ACTIONS(1502),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1502),
    [anon_sym_STAR_STAR] = ACTIONS(1502),
    [anon_sym_CARET] = ACTIONS(1502),
    [aux_sym_binary_operator_token1] = ACTIONS(1502),
    [anon_sym_PIPE_GT] = ACTIONS(1502),
    [anon_sym_COLON] = ACTIONS(1500),
    [anon_sym_DOLLAR] = ACTIONS(1502),
    [anon_sym_AT] = ACTIONS(1502),
    [sym__hex_literal] = ACTIONS(1502),
    [sym__number_literal] = ACTIONS(1500),
    [anon_sym_SQUOTE] = ACTIONS(1502),
    [anon_sym_DQUOTE] = ACTIONS(1502),
    [sym_return] = ACTIONS(1500),
    [sym_next] = ACTIONS(1500),
    [sym_break] = ACTIONS(1500),
    [sym_true] = ACTIONS(1500),
    [sym_false] = ACTIONS(1500),
    [sym_null] = ACTIONS(1500),
    [sym_inf] = ACTIONS(1500),
    [sym_nan] = ACTIONS(1500),
    [anon_sym_NA] = ACTIONS(1500),
    [anon_sym_NA_integer_] = ACTIONS(1500),
    [anon_sym_NA_real_] = ACTIONS(1500),
    [anon_sym_NA_complex_] = ACTIONS(1500),
    [anon_sym_NA_character_] = ACTIONS(1500),
    [sym_dots] = ACTIONS(1500),
    [sym_dot_dot_i] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1502),
    [sym__newline] = ACTIONS(1502),
    [sym__raw_string_literal] = ACTIONS(1502),
    [sym__external_else] = ACTIONS(1502),
    [sym__external_open_parenthesis] = ACTIONS(1502),
    [sym__external_open_brace] = ACTIONS(1502),
    [sym__external_open_bracket] = ACTIONS(1502),
    [sym__external_open_bracket2] = ACTIONS(1502),
    [sym__external_close_bracket2] = ACTIONS(1502),
  },
  [823] = {
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_BSLASH] = ACTIONS(1506),
    [anon_sym_function] = ACTIONS(1504),
    [anon_sym_EQ] = ACTIONS(1504),
    [anon_sym_if] = ACTIONS(1504),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1504),
    [anon_sym_repeat] = ACTIONS(1504),
    [anon_sym_QMARK] = ACTIONS(1506),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_BANG] = ACTIONS(1504),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1504),
    [anon_sym_LT_DASH] = ACTIONS(1506),
    [anon_sym_LT_LT_DASH] = ACTIONS(1506),
    [anon_sym_COLON_EQ] = ACTIONS(1506),
    [anon_sym_DASH_GT] = ACTIONS(1504),
    [anon_sym_DASH_GT_GT] = ACTIONS(1506),
    [anon_sym_PIPE] = ACTIONS(1504),
    [anon_sym_AMP] = ACTIONS(1504),
    [anon_sym_PIPE_PIPE] = ACTIONS(1506),
    [anon_sym_AMP_AMP] = ACTIONS(1506),
    [anon_sym_LT] = ACTIONS(1504),
    [anon_sym_LT_EQ] = ACTIONS(1506),
    [anon_sym_GT] = ACTIONS(1504),
    [anon_sym_GT_EQ] = ACTIONS(1506),
    [anon_sym_EQ_EQ] = ACTIONS(1506),
    [anon_sym_BANG_EQ] = ACTIONS(1506),
    [anon_sym_STAR] = ACTIONS(1504),
    [anon_sym_SLASH] = ACTIONS(1506),
    [anon_sym_STAR_STAR] = ACTIONS(1506),
    [anon_sym_CARET] = ACTIONS(1506),
    [aux_sym_binary_operator_token1] = ACTIONS(1506),
    [anon_sym_PIPE_GT] = ACTIONS(1506),
    [anon_sym_COLON] = ACTIONS(1504),
    [anon_sym_DOLLAR] = ACTIONS(1506),
    [anon_sym_AT] = ACTIONS(1506),
    [sym__hex_literal] = ACTIONS(1506),
    [sym__number_literal] = ACTIONS(1504),
    [anon_sym_SQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1506),
    [sym_return] = ACTIONS(1504),
    [sym_next] = ACTIONS(1504),
    [sym_break] = ACTIONS(1504),
    [sym_true] = ACTIONS(1504),
    [sym_false] = ACTIONS(1504),
    [sym_null] = ACTIONS(1504),
    [sym_inf] = ACTIONS(1504),
    [sym_nan] = ACTIONS(1504),
    [anon_sym_NA] = ACTIONS(1504),
    [anon_sym_NA_integer_] = ACTIONS(1504),
    [anon_sym_NA_real_] = ACTIONS(1504),
    [anon_sym_NA_complex_] = ACTIONS(1504),
    [anon_sym_NA_character_] = ACTIONS(1504),
    [sym_dots] = ACTIONS(1504),
    [sym_dot_dot_i] = ACTIONS(1506),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1506),
    [sym__newline] = ACTIONS(1506),
    [sym__raw_string_literal] = ACTIONS(1506),
    [sym__external_else] = ACTIONS(1506),
    [sym__external_open_parenthesis] = ACTIONS(1506),
    [sym__external_open_brace] = ACTIONS(1506),
    [sym__external_open_bracket] = ACTIONS(1506),
    [sym__external_open_bracket2] = ACTIONS(1506),
    [sym__external_close_bracket2] = ACTIONS(1506),
  },
  [824] = {
    [sym_identifier] = ACTIONS(1508),
    [anon_sym_BSLASH] = ACTIONS(1510),
    [anon_sym_function] = ACTIONS(1508),
    [anon_sym_EQ] = ACTIONS(1508),
    [anon_sym_if] = ACTIONS(1508),
    [anon_sym_for] = ACTIONS(1508),
    [anon_sym_while] = ACTIONS(1508),
    [anon_sym_repeat] = ACTIONS(1508),
    [anon_sym_QMARK] = ACTIONS(1510),
    [anon_sym_TILDE] = ACTIONS(1510),
    [anon_sym_BANG] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1510),
    [anon_sym_DASH] = ACTIONS(1508),
    [anon_sym_LT_DASH] = ACTIONS(1510),
    [anon_sym_LT_LT_DASH] = ACTIONS(1510),
    [anon_sym_COLON_EQ] = ACTIONS(1510),
    [anon_sym_DASH_GT] = ACTIONS(1508),
    [anon_sym_DASH_GT_GT] = ACTIONS(1510),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PIPE_PIPE] = ACTIONS(1510),
    [anon_sym_AMP_AMP] = ACTIONS(1510),
    [anon_sym_LT] = ACTIONS(1508),
    [anon_sym_LT_EQ] = ACTIONS(1510),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_GT_EQ] = ACTIONS(1510),
    [anon_sym_EQ_EQ] = ACTIONS(1510),
    [anon_sym_BANG_EQ] = ACTIONS(1510),
    [anon_sym_STAR] = ACTIONS(1508),
    [anon_sym_SLASH] = ACTIONS(1510),
    [anon_sym_STAR_STAR] = ACTIONS(1510),
    [anon_sym_CARET] = ACTIONS(1510),
    [aux_sym_binary_operator_token1] = ACTIONS(1510),
    [anon_sym_PIPE_GT] = ACTIONS(1510),
    [anon_sym_COLON] = ACTIONS(1508),
    [anon_sym_DOLLAR] = ACTIONS(1510),
    [anon_sym_AT] = ACTIONS(1510),
    [sym__hex_literal] = ACTIONS(1510),
    [sym__number_literal] = ACTIONS(1508),
    [anon_sym_SQUOTE] = ACTIONS(1510),
    [anon_sym_DQUOTE] = ACTIONS(1510),
    [sym_return] = ACTIONS(1508),
    [sym_next] = ACTIONS(1508),
    [sym_break] = ACTIONS(1508),
    [sym_true] = ACTIONS(1508),
    [sym_false] = ACTIONS(1508),
    [sym_null] = ACTIONS(1508),
    [sym_inf] = ACTIONS(1508),
    [sym_nan] = ACTIONS(1508),
    [anon_sym_NA] = ACTIONS(1508),
    [anon_sym_NA_integer_] = ACTIONS(1508),
    [anon_sym_NA_real_] = ACTIONS(1508),
    [anon_sym_NA_complex_] = ACTIONS(1508),
    [anon_sym_NA_character_] = ACTIONS(1508),
    [sym_dots] = ACTIONS(1508),
    [sym_dot_dot_i] = ACTIONS(1510),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1510),
    [sym__newline] = ACTIONS(1510),
    [sym__raw_string_literal] = ACTIONS(1510),
    [sym__external_else] = ACTIONS(1510),
    [sym__external_open_parenthesis] = ACTIONS(1510),
    [sym__external_open_brace] = ACTIONS(1510),
    [sym__external_open_bracket] = ACTIONS(1510),
    [sym__external_open_bracket2] = ACTIONS(1510),
    [sym__external_close_bracket2] = ACTIONS(1510),
  },
  [825] = {
    [sym_identifier] = ACTIONS(1515),
    [anon_sym_BSLASH] = ACTIONS(1517),
    [anon_sym_function] = ACTIONS(1515),
    [anon_sym_EQ] = ACTIONS(1515),
    [anon_sym_if] = ACTIONS(1515),
    [anon_sym_for] = ACTIONS(1515),
    [anon_sym_while] = ACTIONS(1515),
    [anon_sym_repeat] = ACTIONS(1515),
    [anon_sym_QMARK] = ACTIONS(1517),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_DASH] = ACTIONS(1515),
    [anon_sym_LT_DASH] = ACTIONS(1517),
    [anon_sym_LT_LT_DASH] = ACTIONS(1517),
    [anon_sym_COLON_EQ] = ACTIONS(1517),
    [anon_sym_DASH_GT] = ACTIONS(1515),
    [anon_sym_DASH_GT_GT] = ACTIONS(1517),
    [anon_sym_PIPE] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_PIPE_PIPE] = ACTIONS(1517),
    [anon_sym_AMP_AMP] = ACTIONS(1517),
    [anon_sym_LT] = ACTIONS(1515),
    [anon_sym_LT_EQ] = ACTIONS(1517),
    [anon_sym_GT] = ACTIONS(1515),
    [anon_sym_GT_EQ] = ACTIONS(1517),
    [anon_sym_EQ_EQ] = ACTIONS(1517),
    [anon_sym_BANG_EQ] = ACTIONS(1517),
    [anon_sym_STAR] = ACTIONS(1515),
    [anon_sym_SLASH] = ACTIONS(1517),
    [anon_sym_STAR_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [aux_sym_binary_operator_token1] = ACTIONS(1517),
    [anon_sym_PIPE_GT] = ACTIONS(1517),
    [anon_sym_COLON] = ACTIONS(1515),
    [anon_sym_DOLLAR] = ACTIONS(1517),
    [anon_sym_AT] = ACTIONS(1517),
    [sym__hex_literal] = ACTIONS(1517),
    [sym__number_literal] = ACTIONS(1515),
    [anon_sym_SQUOTE] = ACTIONS(1517),
    [anon_sym_DQUOTE] = ACTIONS(1517),
    [sym_return] = ACTIONS(1515),
    [sym_next] = ACTIONS(1515),
    [sym_break] = ACTIONS(1515),
    [sym_true] = ACTIONS(1515),
    [sym_false] = ACTIONS(1515),
    [sym_null] = ACTIONS(1515),
    [sym_inf] = ACTIONS(1515),
    [sym_nan] = ACTIONS(1515),
    [anon_sym_NA] = ACTIONS(1515),
    [anon_sym_NA_integer_] = ACTIONS(1515),
    [anon_sym_NA_real_] = ACTIONS(1515),
    [anon_sym_NA_complex_] = ACTIONS(1515),
    [anon_sym_NA_character_] = ACTIONS(1515),
    [sym_dots] = ACTIONS(1515),
    [sym_dot_dot_i] = ACTIONS(1517),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1517),
    [sym__newline] = ACTIONS(1517),
    [sym__raw_string_literal] = ACTIONS(1517),
    [sym__external_else] = ACTIONS(1517),
    [sym__external_open_parenthesis] = ACTIONS(1517),
    [sym__external_open_brace] = ACTIONS(1517),
    [sym__external_open_bracket] = ACTIONS(1517),
    [sym__external_open_bracket2] = ACTIONS(1517),
    [sym__external_close_bracket2] = ACTIONS(1517),
  },
  [826] = {
    [sym_identifier] = ACTIONS(1519),
    [anon_sym_BSLASH] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(1519),
    [anon_sym_EQ] = ACTIONS(1519),
    [anon_sym_if] = ACTIONS(1519),
    [anon_sym_for] = ACTIONS(1519),
    [anon_sym_while] = ACTIONS(1519),
    [anon_sym_repeat] = ACTIONS(1519),
    [anon_sym_QMARK] = ACTIONS(1521),
    [anon_sym_TILDE] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1519),
    [anon_sym_PLUS] = ACTIONS(1521),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_LT_DASH] = ACTIONS(1521),
    [anon_sym_LT_LT_DASH] = ACTIONS(1521),
    [anon_sym_COLON_EQ] = ACTIONS(1521),
    [anon_sym_DASH_GT] = ACTIONS(1519),
    [anon_sym_DASH_GT_GT] = ACTIONS(1521),
    [anon_sym_PIPE] = ACTIONS(1519),
    [anon_sym_AMP] = ACTIONS(1519),
    [anon_sym_PIPE_PIPE] = ACTIONS(1521),
    [anon_sym_AMP_AMP] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_LT_EQ] = ACTIONS(1521),
    [anon_sym_GT] = ACTIONS(1519),
    [anon_sym_GT_EQ] = ACTIONS(1521),
    [anon_sym_EQ_EQ] = ACTIONS(1521),
    [anon_sym_BANG_EQ] = ACTIONS(1521),
    [anon_sym_STAR] = ACTIONS(1519),
    [anon_sym_SLASH] = ACTIONS(1521),
    [anon_sym_STAR_STAR] = ACTIONS(1521),
    [anon_sym_CARET] = ACTIONS(1521),
    [aux_sym_binary_operator_token1] = ACTIONS(1521),
    [anon_sym_PIPE_GT] = ACTIONS(1521),
    [anon_sym_COLON] = ACTIONS(1519),
    [anon_sym_DOLLAR] = ACTIONS(1521),
    [anon_sym_AT] = ACTIONS(1521),
    [sym__hex_literal] = ACTIONS(1521),
    [sym__number_literal] = ACTIONS(1519),
    [anon_sym_SQUOTE] = ACTIONS(1521),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [sym_return] = ACTIONS(1519),
    [sym_next] = ACTIONS(1519),
    [sym_break] = ACTIONS(1519),
    [sym_true] = ACTIONS(1519),
    [sym_false] = ACTIONS(1519),
    [sym_null] = ACTIONS(1519),
    [sym_inf] = ACTIONS(1519),
    [sym_nan] = ACTIONS(1519),
    [anon_sym_NA] = ACTIONS(1519),
    [anon_sym_NA_integer_] = ACTIONS(1519),
    [anon_sym_NA_real_] = ACTIONS(1519),
    [anon_sym_NA_complex_] = ACTIONS(1519),
    [anon_sym_NA_character_] = ACTIONS(1519),
    [sym_dots] = ACTIONS(1519),
    [sym_dot_dot_i] = ACTIONS(1521),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1521),
    [sym__newline] = ACTIONS(1521),
    [sym__raw_string_literal] = ACTIONS(1521),
    [sym__external_else] = ACTIONS(1521),
    [sym__external_open_parenthesis] = ACTIONS(1521),
    [sym__external_open_brace] = ACTIONS(1521),
    [sym__external_open_bracket] = ACTIONS(1521),
    [sym__external_open_bracket2] = ACTIONS(1521),
    [sym__external_close_bracket2] = ACTIONS(1521),
  },
  [827] = {
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_BSLASH] = ACTIONS(1525),
    [anon_sym_function] = ACTIONS(1523),
    [anon_sym_EQ] = ACTIONS(1523),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_for] = ACTIONS(1523),
    [anon_sym_while] = ACTIONS(1523),
    [anon_sym_repeat] = ACTIONS(1523),
    [anon_sym_QMARK] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(1525),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1523),
    [anon_sym_LT_DASH] = ACTIONS(1525),
    [anon_sym_LT_LT_DASH] = ACTIONS(1525),
    [anon_sym_COLON_EQ] = ACTIONS(1525),
    [anon_sym_DASH_GT] = ACTIONS(1523),
    [anon_sym_DASH_GT_GT] = ACTIONS(1525),
    [anon_sym_PIPE] = ACTIONS(1523),
    [anon_sym_AMP] = ACTIONS(1523),
    [anon_sym_PIPE_PIPE] = ACTIONS(1525),
    [anon_sym_AMP_AMP] = ACTIONS(1525),
    [anon_sym_LT] = ACTIONS(1523),
    [anon_sym_LT_EQ] = ACTIONS(1525),
    [anon_sym_GT] = ACTIONS(1523),
    [anon_sym_GT_EQ] = ACTIONS(1525),
    [anon_sym_EQ_EQ] = ACTIONS(1525),
    [anon_sym_BANG_EQ] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1523),
    [anon_sym_SLASH] = ACTIONS(1525),
    [anon_sym_STAR_STAR] = ACTIONS(1525),
    [anon_sym_CARET] = ACTIONS(1525),
    [aux_sym_binary_operator_token1] = ACTIONS(1525),
    [anon_sym_PIPE_GT] = ACTIONS(1525),
    [anon_sym_COLON] = ACTIONS(1523),
    [anon_sym_DOLLAR] = ACTIONS(1525),
    [anon_sym_AT] = ACTIONS(1525),
    [sym__hex_literal] = ACTIONS(1525),
    [sym__number_literal] = ACTIONS(1523),
    [anon_sym_SQUOTE] = ACTIONS(1525),
    [anon_sym_DQUOTE] = ACTIONS(1525),
    [sym_return] = ACTIONS(1523),
    [sym_next] = ACTIONS(1523),
    [sym_break] = ACTIONS(1523),
    [sym_true] = ACTIONS(1523),
    [sym_false] = ACTIONS(1523),
    [sym_null] = ACTIONS(1523),
    [sym_inf] = ACTIONS(1523),
    [sym_nan] = ACTIONS(1523),
    [anon_sym_NA] = ACTIONS(1523),
    [anon_sym_NA_integer_] = ACTIONS(1523),
    [anon_sym_NA_real_] = ACTIONS(1523),
    [anon_sym_NA_complex_] = ACTIONS(1523),
    [anon_sym_NA_character_] = ACTIONS(1523),
    [sym_dots] = ACTIONS(1523),
    [sym_dot_dot_i] = ACTIONS(1525),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1525),
    [sym__newline] = ACTIONS(1525),
    [sym__raw_string_literal] = ACTIONS(1525),
    [sym__external_else] = ACTIONS(1525),
    [sym__external_open_parenthesis] = ACTIONS(1525),
    [sym__external_open_brace] = ACTIONS(1525),
    [sym__external_open_bracket] = ACTIONS(1525),
    [sym__external_open_bracket2] = ACTIONS(1525),
    [sym__external_close_bracket2] = ACTIONS(1525),
  },
  [828] = {
    [sym_identifier] = ACTIONS(1527),
    [anon_sym_BSLASH] = ACTIONS(1529),
    [anon_sym_function] = ACTIONS(1527),
    [anon_sym_EQ] = ACTIONS(1527),
    [anon_sym_if] = ACTIONS(1527),
    [anon_sym_for] = ACTIONS(1527),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_repeat] = ACTIONS(1527),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_TILDE] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1527),
    [anon_sym_LT_DASH] = ACTIONS(1529),
    [anon_sym_LT_LT_DASH] = ACTIONS(1529),
    [anon_sym_COLON_EQ] = ACTIONS(1529),
    [anon_sym_DASH_GT] = ACTIONS(1527),
    [anon_sym_DASH_GT_GT] = ACTIONS(1529),
    [anon_sym_PIPE] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1527),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1527),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1529),
    [anon_sym_BANG_EQ] = ACTIONS(1529),
    [anon_sym_STAR] = ACTIONS(1527),
    [anon_sym_SLASH] = ACTIONS(1529),
    [anon_sym_STAR_STAR] = ACTIONS(1529),
    [anon_sym_CARET] = ACTIONS(1529),
    [aux_sym_binary_operator_token1] = ACTIONS(1529),
    [anon_sym_PIPE_GT] = ACTIONS(1529),
    [anon_sym_COLON] = ACTIONS(1527),
    [anon_sym_DOLLAR] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(1529),
    [sym__hex_literal] = ACTIONS(1529),
    [sym__number_literal] = ACTIONS(1527),
    [anon_sym_SQUOTE] = ACTIONS(1529),
    [anon_sym_DQUOTE] = ACTIONS(1529),
    [sym_return] = ACTIONS(1527),
    [sym_next] = ACTIONS(1527),
    [sym_break] = ACTIONS(1527),
    [sym_true] = ACTIONS(1527),
    [sym_false] = ACTIONS(1527),
    [sym_null] = ACTIONS(1527),
    [sym_inf] = ACTIONS(1527),
    [sym_nan] = ACTIONS(1527),
    [anon_sym_NA] = ACTIONS(1527),
    [anon_sym_NA_integer_] = ACTIONS(1527),
    [anon_sym_NA_real_] = ACTIONS(1527),
    [anon_sym_NA_complex_] = ACTIONS(1527),
    [anon_sym_NA_character_] = ACTIONS(1527),
    [sym_dots] = ACTIONS(1527),
    [sym_dot_dot_i] = ACTIONS(1529),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1529),
    [sym__newline] = ACTIONS(1529),
    [sym__raw_string_literal] = ACTIONS(1529),
    [sym__external_else] = ACTIONS(1529),
    [sym__external_open_parenthesis] = ACTIONS(1529),
    [sym__external_open_brace] = ACTIONS(1529),
    [sym__external_open_bracket] = ACTIONS(1529),
    [sym__external_open_bracket2] = ACTIONS(1529),
    [sym__external_close_bracket2] = ACTIONS(1529),
  },
  [829] = {
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_BSLASH] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1539),
    [anon_sym_if] = ACTIONS(1539),
    [anon_sym_for] = ACTIONS(1539),
    [anon_sym_while] = ACTIONS(1539),
    [anon_sym_repeat] = ACTIONS(1539),
    [anon_sym_QMARK] = ACTIONS(1541),
    [anon_sym_TILDE] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1539),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1539),
    [anon_sym_LT_DASH] = ACTIONS(1541),
    [anon_sym_LT_LT_DASH] = ACTIONS(1541),
    [anon_sym_COLON_EQ] = ACTIONS(1541),
    [anon_sym_DASH_GT] = ACTIONS(1539),
    [anon_sym_DASH_GT_GT] = ACTIONS(1541),
    [anon_sym_PIPE] = ACTIONS(1539),
    [anon_sym_AMP] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1541),
    [anon_sym_GT] = ACTIONS(1539),
    [anon_sym_GT_EQ] = ACTIONS(1541),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1539),
    [anon_sym_SLASH] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_CARET] = ACTIONS(1541),
    [aux_sym_binary_operator_token1] = ACTIONS(1541),
    [anon_sym_PIPE_GT] = ACTIONS(1541),
    [anon_sym_COLON] = ACTIONS(1539),
    [anon_sym_DOLLAR] = ACTIONS(1541),
    [anon_sym_AT] = ACTIONS(1541),
    [sym__hex_literal] = ACTIONS(1541),
    [sym__number_literal] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(1541),
    [anon_sym_DQUOTE] = ACTIONS(1541),
    [sym_return] = ACTIONS(1539),
    [sym_next] = ACTIONS(1539),
    [sym_break] = ACTIONS(1539),
    [sym_true] = ACTIONS(1539),
    [sym_false] = ACTIONS(1539),
    [sym_null] = ACTIONS(1539),
    [sym_inf] = ACTIONS(1539),
    [sym_nan] = ACTIONS(1539),
    [anon_sym_NA] = ACTIONS(1539),
    [anon_sym_NA_integer_] = ACTIONS(1539),
    [anon_sym_NA_real_] = ACTIONS(1539),
    [anon_sym_NA_complex_] = ACTIONS(1539),
    [anon_sym_NA_character_] = ACTIONS(1539),
    [sym_dots] = ACTIONS(1539),
    [sym_dot_dot_i] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1541),
    [sym__newline] = ACTIONS(1541),
    [sym__raw_string_literal] = ACTIONS(1541),
    [sym__external_else] = ACTIONS(1541),
    [sym__external_open_parenthesis] = ACTIONS(1541),
    [sym__external_open_brace] = ACTIONS(1541),
    [sym__external_open_bracket] = ACTIONS(1541),
    [sym__external_open_bracket2] = ACTIONS(1541),
    [sym__external_close_bracket2] = ACTIONS(1541),
  },
  [830] = {
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_BSLASH] = ACTIONS(1545),
    [anon_sym_function] = ACTIONS(1543),
    [anon_sym_EQ] = ACTIONS(1543),
    [anon_sym_if] = ACTIONS(1543),
    [anon_sym_for] = ACTIONS(1543),
    [anon_sym_while] = ACTIONS(1543),
    [anon_sym_repeat] = ACTIONS(1543),
    [anon_sym_QMARK] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1543),
    [anon_sym_PLUS] = ACTIONS(1545),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_LT_DASH] = ACTIONS(1545),
    [anon_sym_LT_LT_DASH] = ACTIONS(1545),
    [anon_sym_COLON_EQ] = ACTIONS(1545),
    [anon_sym_DASH_GT] = ACTIONS(1543),
    [anon_sym_DASH_GT_GT] = ACTIONS(1545),
    [anon_sym_PIPE] = ACTIONS(1543),
    [anon_sym_AMP] = ACTIONS(1543),
    [anon_sym_PIPE_PIPE] = ACTIONS(1545),
    [anon_sym_AMP_AMP] = ACTIONS(1545),
    [anon_sym_LT] = ACTIONS(1543),
    [anon_sym_LT_EQ] = ACTIONS(1545),
    [anon_sym_GT] = ACTIONS(1543),
    [anon_sym_GT_EQ] = ACTIONS(1545),
    [anon_sym_EQ_EQ] = ACTIONS(1545),
    [anon_sym_BANG_EQ] = ACTIONS(1545),
    [anon_sym_STAR] = ACTIONS(1543),
    [anon_sym_SLASH] = ACTIONS(1545),
    [anon_sym_STAR_STAR] = ACTIONS(1545),
    [anon_sym_CARET] = ACTIONS(1545),
    [aux_sym_binary_operator_token1] = ACTIONS(1545),
    [anon_sym_PIPE_GT] = ACTIONS(1545),
    [anon_sym_COLON] = ACTIONS(1543),
    [anon_sym_DOLLAR] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(1545),
    [sym__hex_literal] = ACTIONS(1545),
    [sym__number_literal] = ACTIONS(1543),
    [anon_sym_SQUOTE] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1545),
    [sym_return] = ACTIONS(1543),
    [sym_next] = ACTIONS(1543),
    [sym_break] = ACTIONS(1543),
    [sym_true] = ACTIONS(1543),
    [sym_false] = ACTIONS(1543),
    [sym_null] = ACTIONS(1543),
    [sym_inf] = ACTIONS(1543),
    [sym_nan] = ACTIONS(1543),
    [anon_sym_NA] = ACTIONS(1543),
    [anon_sym_NA_integer_] = ACTIONS(1543),
    [anon_sym_NA_real_] = ACTIONS(1543),
    [anon_sym_NA_complex_] = ACTIONS(1543),
    [anon_sym_NA_character_] = ACTIONS(1543),
    [sym_dots] = ACTIONS(1543),
    [sym_dot_dot_i] = ACTIONS(1545),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1545),
    [sym__newline] = ACTIONS(1545),
    [sym__raw_string_literal] = ACTIONS(1545),
    [sym__external_else] = ACTIONS(1545),
    [sym__external_open_parenthesis] = ACTIONS(1545),
    [sym__external_open_brace] = ACTIONS(1545),
    [sym__external_open_bracket] = ACTIONS(1545),
    [sym__external_open_bracket2] = ACTIONS(1545),
    [sym__external_close_bracket2] = ACTIONS(1545),
  },
  [831] = {
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_BSLASH] = ACTIONS(1549),
    [anon_sym_function] = ACTIONS(1547),
    [anon_sym_EQ] = ACTIONS(1547),
    [anon_sym_if] = ACTIONS(1547),
    [anon_sym_for] = ACTIONS(1547),
    [anon_sym_while] = ACTIONS(1547),
    [anon_sym_repeat] = ACTIONS(1547),
    [anon_sym_QMARK] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1547),
    [anon_sym_LT_DASH] = ACTIONS(1549),
    [anon_sym_LT_LT_DASH] = ACTIONS(1549),
    [anon_sym_COLON_EQ] = ACTIONS(1549),
    [anon_sym_DASH_GT] = ACTIONS(1547),
    [anon_sym_DASH_GT_GT] = ACTIONS(1549),
    [anon_sym_PIPE] = ACTIONS(1547),
    [anon_sym_AMP] = ACTIONS(1547),
    [anon_sym_PIPE_PIPE] = ACTIONS(1549),
    [anon_sym_AMP_AMP] = ACTIONS(1549),
    [anon_sym_LT] = ACTIONS(1547),
    [anon_sym_LT_EQ] = ACTIONS(1549),
    [anon_sym_GT] = ACTIONS(1547),
    [anon_sym_GT_EQ] = ACTIONS(1549),
    [anon_sym_EQ_EQ] = ACTIONS(1549),
    [anon_sym_BANG_EQ] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_SLASH] = ACTIONS(1549),
    [anon_sym_STAR_STAR] = ACTIONS(1549),
    [anon_sym_CARET] = ACTIONS(1549),
    [aux_sym_binary_operator_token1] = ACTIONS(1549),
    [anon_sym_PIPE_GT] = ACTIONS(1549),
    [anon_sym_COLON] = ACTIONS(1547),
    [anon_sym_DOLLAR] = ACTIONS(1549),
    [anon_sym_AT] = ACTIONS(1549),
    [sym__hex_literal] = ACTIONS(1549),
    [sym__number_literal] = ACTIONS(1547),
    [anon_sym_SQUOTE] = ACTIONS(1549),
    [anon_sym_DQUOTE] = ACTIONS(1549),
    [sym_return] = ACTIONS(1547),
    [sym_next] = ACTIONS(1547),
    [sym_break] = ACTIONS(1547),
    [sym_true] = ACTIONS(1547),
    [sym_false] = ACTIONS(1547),
    [sym_null] = ACTIONS(1547),
    [sym_inf] = ACTIONS(1547),
    [sym_nan] = ACTIONS(1547),
    [anon_sym_NA] = ACTIONS(1547),
    [anon_sym_NA_integer_] = ACTIONS(1547),
    [anon_sym_NA_real_] = ACTIONS(1547),
    [anon_sym_NA_complex_] = ACTIONS(1547),
    [anon_sym_NA_character_] = ACTIONS(1547),
    [sym_dots] = ACTIONS(1547),
    [sym_dot_dot_i] = ACTIONS(1549),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1549),
    [sym__newline] = ACTIONS(1549),
    [sym__raw_string_literal] = ACTIONS(1549),
    [sym__external_else] = ACTIONS(1549),
    [sym__external_open_parenthesis] = ACTIONS(1549),
    [sym__external_open_brace] = ACTIONS(1549),
    [sym__external_open_bracket] = ACTIONS(1549),
    [sym__external_open_bracket2] = ACTIONS(1549),
    [sym__external_close_bracket2] = ACTIONS(1549),
  },
  [832] = {
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_BSLASH] = ACTIONS(1494),
    [anon_sym_function] = ACTIONS(1492),
    [anon_sym_EQ] = ACTIONS(1492),
    [anon_sym_if] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(1492),
    [anon_sym_while] = ACTIONS(1492),
    [anon_sym_repeat] = ACTIONS(1492),
    [anon_sym_QMARK] = ACTIONS(1494),
    [anon_sym_TILDE] = ACTIONS(1494),
    [anon_sym_BANG] = ACTIONS(1492),
    [anon_sym_PLUS] = ACTIONS(1494),
    [anon_sym_DASH] = ACTIONS(1492),
    [anon_sym_LT_DASH] = ACTIONS(1494),
    [anon_sym_LT_LT_DASH] = ACTIONS(1494),
    [anon_sym_COLON_EQ] = ACTIONS(1494),
    [anon_sym_DASH_GT] = ACTIONS(1492),
    [anon_sym_DASH_GT_GT] = ACTIONS(1494),
    [anon_sym_PIPE] = ACTIONS(1492),
    [anon_sym_AMP] = ACTIONS(1492),
    [anon_sym_PIPE_PIPE] = ACTIONS(1494),
    [anon_sym_AMP_AMP] = ACTIONS(1494),
    [anon_sym_LT] = ACTIONS(1492),
    [anon_sym_LT_EQ] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1492),
    [anon_sym_GT_EQ] = ACTIONS(1494),
    [anon_sym_EQ_EQ] = ACTIONS(1494),
    [anon_sym_BANG_EQ] = ACTIONS(1494),
    [anon_sym_STAR] = ACTIONS(1492),
    [anon_sym_SLASH] = ACTIONS(1494),
    [anon_sym_STAR_STAR] = ACTIONS(1494),
    [anon_sym_CARET] = ACTIONS(1494),
    [aux_sym_binary_operator_token1] = ACTIONS(1494),
    [anon_sym_PIPE_GT] = ACTIONS(1494),
    [anon_sym_COLON] = ACTIONS(1492),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [anon_sym_AT] = ACTIONS(1494),
    [sym__hex_literal] = ACTIONS(1494),
    [sym__number_literal] = ACTIONS(1492),
    [anon_sym_SQUOTE] = ACTIONS(1494),
    [anon_sym_DQUOTE] = ACTIONS(1494),
    [sym_return] = ACTIONS(1492),
    [sym_next] = ACTIONS(1492),
    [sym_break] = ACTIONS(1492),
    [sym_true] = ACTIONS(1492),
    [sym_false] = ACTIONS(1492),
    [sym_null] = ACTIONS(1492),
    [sym_inf] = ACTIONS(1492),
    [sym_nan] = ACTIONS(1492),
    [anon_sym_NA] = ACTIONS(1492),
    [anon_sym_NA_integer_] = ACTIONS(1492),
    [anon_sym_NA_real_] = ACTIONS(1492),
    [anon_sym_NA_complex_] = ACTIONS(1492),
    [anon_sym_NA_character_] = ACTIONS(1492),
    [sym_dots] = ACTIONS(1492),
    [sym_dot_dot_i] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1494),
    [sym__newline] = ACTIONS(1494),
    [sym__raw_string_literal] = ACTIONS(1494),
    [sym__external_else] = ACTIONS(1494),
    [sym__external_open_parenthesis] = ACTIONS(1494),
    [sym__external_open_brace] = ACTIONS(1494),
    [sym__external_open_bracket] = ACTIONS(1494),
    [sym__external_open_bracket2] = ACTIONS(1494),
    [sym__external_close_bracket2] = ACTIONS(1494),
  },
  [833] = {
    [sym_identifier] = ACTIONS(1551),
    [anon_sym_BSLASH] = ACTIONS(1553),
    [anon_sym_function] = ACTIONS(1551),
    [anon_sym_EQ] = ACTIONS(1551),
    [anon_sym_if] = ACTIONS(1551),
    [anon_sym_for] = ACTIONS(1551),
    [anon_sym_while] = ACTIONS(1551),
    [anon_sym_repeat] = ACTIONS(1551),
    [anon_sym_QMARK] = ACTIONS(1553),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_PLUS] = ACTIONS(1553),
    [anon_sym_DASH] = ACTIONS(1551),
    [anon_sym_LT_DASH] = ACTIONS(1553),
    [anon_sym_LT_LT_DASH] = ACTIONS(1553),
    [anon_sym_COLON_EQ] = ACTIONS(1553),
    [anon_sym_DASH_GT] = ACTIONS(1551),
    [anon_sym_DASH_GT_GT] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_PIPE_PIPE] = ACTIONS(1553),
    [anon_sym_AMP_AMP] = ACTIONS(1553),
    [anon_sym_LT] = ACTIONS(1551),
    [anon_sym_LT_EQ] = ACTIONS(1553),
    [anon_sym_GT] = ACTIONS(1551),
    [anon_sym_GT_EQ] = ACTIONS(1553),
    [anon_sym_EQ_EQ] = ACTIONS(1553),
    [anon_sym_BANG_EQ] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(1551),
    [anon_sym_SLASH] = ACTIONS(1553),
    [anon_sym_STAR_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [aux_sym_binary_operator_token1] = ACTIONS(1553),
    [anon_sym_PIPE_GT] = ACTIONS(1553),
    [anon_sym_COLON] = ACTIONS(1551),
    [anon_sym_DOLLAR] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(1553),
    [sym__hex_literal] = ACTIONS(1553),
    [sym__number_literal] = ACTIONS(1551),
    [anon_sym_SQUOTE] = ACTIONS(1553),
    [anon_sym_DQUOTE] = ACTIONS(1553),
    [sym_return] = ACTIONS(1551),
    [sym_next] = ACTIONS(1551),
    [sym_break] = ACTIONS(1551),
    [sym_true] = ACTIONS(1551),
    [sym_false] = ACTIONS(1551),
    [sym_null] = ACTIONS(1551),
    [sym_inf] = ACTIONS(1551),
    [sym_nan] = ACTIONS(1551),
    [anon_sym_NA] = ACTIONS(1551),
    [anon_sym_NA_integer_] = ACTIONS(1551),
    [anon_sym_NA_real_] = ACTIONS(1551),
    [anon_sym_NA_complex_] = ACTIONS(1551),
    [anon_sym_NA_character_] = ACTIONS(1551),
    [sym_dots] = ACTIONS(1551),
    [sym_dot_dot_i] = ACTIONS(1553),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1553),
    [sym__newline] = ACTIONS(1553),
    [sym__raw_string_literal] = ACTIONS(1553),
    [sym__external_else] = ACTIONS(1553),
    [sym__external_open_parenthesis] = ACTIONS(1553),
    [sym__external_open_brace] = ACTIONS(1553),
    [sym__external_open_bracket] = ACTIONS(1553),
    [sym__external_close_bracket] = ACTIONS(1553),
    [sym__external_open_bracket2] = ACTIONS(1553),
  },
  [834] = {
    [ts_builtin_sym_end] = ACTIONS(1474),
    [sym_identifier] = ACTIONS(1472),
    [anon_sym_BSLASH] = ACTIONS(1474),
    [anon_sym_function] = ACTIONS(1472),
    [anon_sym_EQ] = ACTIONS(1472),
    [anon_sym_if] = ACTIONS(1472),
    [anon_sym_for] = ACTIONS(1472),
    [anon_sym_while] = ACTIONS(1472),
    [anon_sym_repeat] = ACTIONS(1472),
    [anon_sym_QMARK] = ACTIONS(1474),
    [anon_sym_TILDE] = ACTIONS(1474),
    [anon_sym_BANG] = ACTIONS(1472),
    [anon_sym_PLUS] = ACTIONS(1474),
    [anon_sym_DASH] = ACTIONS(1472),
    [anon_sym_LT_DASH] = ACTIONS(1474),
    [anon_sym_LT_LT_DASH] = ACTIONS(1474),
    [anon_sym_COLON_EQ] = ACTIONS(1474),
    [anon_sym_DASH_GT] = ACTIONS(1472),
    [anon_sym_DASH_GT_GT] = ACTIONS(1474),
    [anon_sym_PIPE] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1472),
    [anon_sym_PIPE_PIPE] = ACTIONS(1474),
    [anon_sym_AMP_AMP] = ACTIONS(1474),
    [anon_sym_LT] = ACTIONS(1472),
    [anon_sym_LT_EQ] = ACTIONS(1474),
    [anon_sym_GT] = ACTIONS(1472),
    [anon_sym_GT_EQ] = ACTIONS(1474),
    [anon_sym_EQ_EQ] = ACTIONS(1474),
    [anon_sym_BANG_EQ] = ACTIONS(1474),
    [anon_sym_STAR] = ACTIONS(1472),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_STAR_STAR] = ACTIONS(1474),
    [anon_sym_CARET] = ACTIONS(1474),
    [aux_sym_binary_operator_token1] = ACTIONS(1474),
    [anon_sym_PIPE_GT] = ACTIONS(1474),
    [anon_sym_COLON] = ACTIONS(1472),
    [anon_sym_DOLLAR] = ACTIONS(1474),
    [anon_sym_AT] = ACTIONS(1474),
    [sym__hex_literal] = ACTIONS(1474),
    [sym__number_literal] = ACTIONS(1472),
    [anon_sym_SQUOTE] = ACTIONS(1474),
    [anon_sym_DQUOTE] = ACTIONS(1474),
    [sym_return] = ACTIONS(1472),
    [sym_next] = ACTIONS(1472),
    [sym_break] = ACTIONS(1472),
    [sym_true] = ACTIONS(1472),
    [sym_false] = ACTIONS(1472),
    [sym_null] = ACTIONS(1472),
    [sym_inf] = ACTIONS(1472),
    [sym_nan] = ACTIONS(1472),
    [anon_sym_NA] = ACTIONS(1472),
    [anon_sym_NA_integer_] = ACTIONS(1472),
    [anon_sym_NA_real_] = ACTIONS(1472),
    [anon_sym_NA_complex_] = ACTIONS(1472),
    [anon_sym_NA_character_] = ACTIONS(1472),
    [sym_dots] = ACTIONS(1472),
    [sym_dot_dot_i] = ACTIONS(1474),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1474),
    [sym__semicolon] = ACTIONS(1474),
    [sym__raw_string_literal] = ACTIONS(1474),
    [sym__external_else] = ACTIONS(1474),
    [sym__external_open_parenthesis] = ACTIONS(1474),
    [sym__external_open_brace] = ACTIONS(1474),
    [sym__external_open_bracket] = ACTIONS(1474),
    [sym__external_open_bracket2] = ACTIONS(1474),
  },
  [835] = {
    [sym_identifier] = ACTIONS(1533),
    [anon_sym_BSLASH] = ACTIONS(1531),
    [anon_sym_function] = ACTIONS(1533),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_if] = ACTIONS(1533),
    [anon_sym_for] = ACTIONS(1533),
    [anon_sym_while] = ACTIONS(1533),
    [anon_sym_repeat] = ACTIONS(1533),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_LT_DASH] = ACTIONS(1531),
    [anon_sym_LT_LT_DASH] = ACTIONS(1531),
    [anon_sym_COLON_EQ] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1533),
    [anon_sym_DASH_GT_GT] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1531),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_CARET] = ACTIONS(1531),
    [aux_sym_binary_operator_token1] = ACTIONS(1531),
    [anon_sym_PIPE_GT] = ACTIONS(1531),
    [anon_sym_COLON] = ACTIONS(1533),
    [anon_sym_DOLLAR] = ACTIONS(1531),
    [anon_sym_AT] = ACTIONS(1531),
    [sym__hex_literal] = ACTIONS(1531),
    [sym__number_literal] = ACTIONS(1533),
    [anon_sym_SQUOTE] = ACTIONS(1531),
    [anon_sym_DQUOTE] = ACTIONS(1531),
    [sym_return] = ACTIONS(1533),
    [sym_next] = ACTIONS(1533),
    [sym_break] = ACTIONS(1533),
    [sym_true] = ACTIONS(1533),
    [sym_false] = ACTIONS(1533),
    [sym_null] = ACTIONS(1533),
    [sym_inf] = ACTIONS(1533),
    [sym_nan] = ACTIONS(1533),
    [anon_sym_NA] = ACTIONS(1533),
    [anon_sym_NA_integer_] = ACTIONS(1533),
    [anon_sym_NA_real_] = ACTIONS(1533),
    [anon_sym_NA_complex_] = ACTIONS(1533),
    [anon_sym_NA_character_] = ACTIONS(1533),
    [sym_dots] = ACTIONS(1533),
    [sym_dot_dot_i] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1531),
    [sym__newline] = ACTIONS(1531),
    [sym__raw_string_literal] = ACTIONS(1531),
    [sym__external_else] = ACTIONS(1531),
    [sym__external_open_parenthesis] = ACTIONS(1531),
    [sym__external_close_parenthesis] = ACTIONS(1531),
    [sym__external_open_brace] = ACTIONS(1531),
    [sym__external_open_bracket] = ACTIONS(1531),
    [sym__external_open_bracket2] = ACTIONS(1531),
  },
  [836] = {
    [ts_builtin_sym_end] = ACTIONS(1478),
    [sym_identifier] = ACTIONS(1476),
    [anon_sym_BSLASH] = ACTIONS(1478),
    [anon_sym_function] = ACTIONS(1476),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_if] = ACTIONS(1476),
    [anon_sym_for] = ACTIONS(1476),
    [anon_sym_while] = ACTIONS(1476),
    [anon_sym_repeat] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_BANG] = ACTIONS(1476),
    [anon_sym_PLUS] = ACTIONS(1478),
    [anon_sym_DASH] = ACTIONS(1476),
    [anon_sym_LT_DASH] = ACTIONS(1478),
    [anon_sym_LT_LT_DASH] = ACTIONS(1478),
    [anon_sym_COLON_EQ] = ACTIONS(1478),
    [anon_sym_DASH_GT] = ACTIONS(1476),
    [anon_sym_DASH_GT_GT] = ACTIONS(1478),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1478),
    [anon_sym_AMP_AMP] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_EQ] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_GT_EQ] = ACTIONS(1478),
    [anon_sym_EQ_EQ] = ACTIONS(1478),
    [anon_sym_BANG_EQ] = ACTIONS(1478),
    [anon_sym_STAR] = ACTIONS(1476),
    [anon_sym_SLASH] = ACTIONS(1478),
    [anon_sym_STAR_STAR] = ACTIONS(1478),
    [anon_sym_CARET] = ACTIONS(1478),
    [aux_sym_binary_operator_token1] = ACTIONS(1478),
    [anon_sym_PIPE_GT] = ACTIONS(1478),
    [anon_sym_COLON] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1478),
    [anon_sym_AT] = ACTIONS(1478),
    [sym__hex_literal] = ACTIONS(1478),
    [sym__number_literal] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_DQUOTE] = ACTIONS(1478),
    [sym_return] = ACTIONS(1476),
    [sym_next] = ACTIONS(1476),
    [sym_break] = ACTIONS(1476),
    [sym_true] = ACTIONS(1476),
    [sym_false] = ACTIONS(1476),
    [sym_null] = ACTIONS(1476),
    [sym_inf] = ACTIONS(1476),
    [sym_nan] = ACTIONS(1476),
    [anon_sym_NA] = ACTIONS(1476),
    [anon_sym_NA_integer_] = ACTIONS(1476),
    [anon_sym_NA_real_] = ACTIONS(1476),
    [anon_sym_NA_complex_] = ACTIONS(1476),
    [anon_sym_NA_character_] = ACTIONS(1476),
    [sym_dots] = ACTIONS(1476),
    [sym_dot_dot_i] = ACTIONS(1478),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1478),
    [sym__semicolon] = ACTIONS(1478),
    [sym__raw_string_literal] = ACTIONS(1478),
    [sym__external_else] = ACTIONS(1478),
    [sym__external_open_parenthesis] = ACTIONS(1478),
    [sym__external_open_brace] = ACTIONS(1478),
    [sym__external_open_bracket] = ACTIONS(1478),
    [sym__external_open_bracket2] = ACTIONS(1478),
  },
  [837] = {
    [sym_function_definition] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_repeat_statement] = STATE(406),
    [sym_braced_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_call] = STATE(406),
    [sym_subset] = STATE(406),
    [sym_subset2] = STATE(406),
    [sym_unary_operator] = STATE(406),
    [sym_binary_operator] = STATE(406),
    [sym_extract_operator] = STATE(406),
    [sym_namespace_operator] = STATE(406),
    [sym_integer] = STATE(406),
    [sym_complex] = STATE(406),
    [sym_float] = STATE(406),
    [sym__float_literal] = STATE(741),
    [sym_string] = STATE(740),
    [sym__single_quoted_string] = STATE(743),
    [sym__double_quoted_string] = STATE(746),
    [sym_na] = STATE(406),
    [sym__expression] = STATE(406),
    [sym__string_or_identifier] = STATE(2136),
    [sym__open_parenthesis] = STATE(934),
    [sym__open_brace] = STATE(853),
    [sym__close_brace] = STATE(790),
    [aux_sym_braced_expression_repeat1] = STATE(894),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1430),
    [anon_sym_function] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_repeat] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [sym__hex_literal] = ACTIONS(1450),
    [sym__number_literal] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [sym_return] = ACTIONS(1454),
    [sym_next] = ACTIONS(1454),
    [sym_break] = ACTIONS(1454),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [sym_null] = ACTIONS(1454),
    [sym_inf] = ACTIONS(1454),
    [sym_nan] = ACTIONS(1454),
    [anon_sym_NA] = ACTIONS(1456),
    [anon_sym_NA_integer_] = ACTIONS(1456),
    [anon_sym_NA_real_] = ACTIONS(1456),
    [anon_sym_NA_complex_] = ACTIONS(1456),
    [anon_sym_NA_character_] = ACTIONS(1456),
    [sym_dots] = ACTIONS(1454),
    [sym_dot_dot_i] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1460),
    [sym__semicolon] = ACTIONS(1460),
    [sym__raw_string_literal] = ACTIONS(1153),
    [sym__external_open_parenthesis] = ACTIONS(1462),
    [sym__external_open_brace] = ACTIONS(1464),
    [sym__external_close_brace] = ACTIONS(1567),
  },
  [838] = {
    [ts_builtin_sym_end] = ACTIONS(1482),
    [sym_identifier] = ACTIONS(1480),
    [anon_sym_BSLASH] = ACTIONS(1482),
    [anon_sym_function] = ACTIONS(1480),
    [anon_sym_EQ] = ACTIONS(1480),
    [anon_sym_if] = ACTIONS(1480),
    [anon_sym_for] = ACTIONS(1480),
    [anon_sym_while] = ACTIONS(1480),
    [anon_sym_repeat] = ACTIONS(1480),
    [anon_sym_QMARK] = ACTIONS(1482),
    [anon_sym_TILDE] = ACTIONS(1482),
    [anon_sym_BANG] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1482),
    [anon_sym_DASH] = ACTIONS(1480),
    [anon_sym_LT_DASH] = ACTIONS(1482),
    [anon_sym_LT_LT_DASH] = ACTIONS(1482),
    [anon_sym_COLON_EQ] = ACTIONS(1482),
    [anon_sym_DASH_GT] = ACTIONS(1480),
    [anon_sym_DASH_GT_GT] = ACTIONS(1482),
    [anon_sym_PIPE] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1480),
    [anon_sym_PIPE_PIPE] = ACTIONS(1482),
    [anon_sym_AMP_AMP] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(1480),
    [anon_sym_LT_EQ] = ACTIONS(1482),
    [anon_sym_GT] = ACTIONS(1480),
    [anon_sym_GT_EQ] = ACTIONS(1482),
    [anon_sym_EQ_EQ] = ACTIONS(1482),
    [anon_sym_BANG_EQ] = ACTIONS(1482),
    [anon_sym_STAR] = ACTIONS(1480),
    [anon_sym_SLASH] = ACTIONS(1482),
    [anon_sym_STAR_STAR] = ACTIONS(1482),
    [anon_sym_CARET] = ACTIONS(1482),
    [aux_sym_binary_operator_token1] = ACTIONS(1482),
    [anon_sym_PIPE_GT] = ACTIONS(1482),
    [anon_sym_COLON] = ACTIONS(1480),
    [anon_sym_DOLLAR] = ACTIONS(1482),
    [anon_sym_AT] = ACTIONS(1482),
    [sym__hex_literal] = ACTIONS(1482),
    [sym__number_literal] = ACTIONS(1480),
    [anon_sym_SQUOTE] = ACTIONS(1482),
    [anon_sym_DQUOTE] = ACTIONS(1482),
    [sym_return] = ACTIONS(1480),
    [sym_next] = ACTIONS(1480),
    [sym_break] = ACTIONS(1480),
    [sym_true] = ACTIONS(1480),
    [sym_false] = ACTIONS(1480),
    [sym_null] = ACTIONS(1480),
    [sym_inf] = ACTIONS(1480),
    [sym_nan] = ACTIONS(1480),
    [anon_sym_NA] = ACTIONS(1480),
    [anon_sym_NA_integer_] = ACTIONS(1480),
    [anon_sym_NA_real_] = ACTIONS(1480),
    [anon_sym_NA_complex_] = ACTIONS(1480),
    [anon_sym_NA_character_] = ACTIONS(1480),
    [sym_dots] = ACTIONS(1480),
    [sym_dot_dot_i] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1482),
    [sym__semicolon] = ACTIONS(1482),
    [sym__raw_string_literal] = ACTIONS(1482),
    [sym__external_else] = ACTIONS(1482),
    [sym__external_open_parenthesis] = ACTIONS(1482),
    [sym__external_open_brace] = ACTIONS(1482),
    [sym__external_open_bracket] = ACTIONS(1482),
    [sym__external_open_bracket2] = ACTIONS(1482),
  },
  [839] = {
    [ts_builtin_sym_end] = ACTIONS(1486),
    [sym_identifier] = ACTIONS(1484),
    [anon_sym_BSLASH] = ACTIONS(1486),
    [anon_sym_function] = ACTIONS(1484),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_if] = ACTIONS(1484),
    [anon_sym_for] = ACTIONS(1484),
    [anon_sym_while] = ACTIONS(1484),
    [anon_sym_repeat] = ACTIONS(1484),
    [anon_sym_QMARK] = ACTIONS(1486),
    [anon_sym_TILDE] = ACTIONS(1486),
    [anon_sym_BANG] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_LT_DASH] = ACTIONS(1486),
    [anon_sym_LT_LT_DASH] = ACTIONS(1486),
    [anon_sym_COLON_EQ] = ACTIONS(1486),
    [anon_sym_DASH_GT] = ACTIONS(1484),
    [anon_sym_DASH_GT_GT] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1484),
    [anon_sym_AMP] = ACTIONS(1484),
    [anon_sym_PIPE_PIPE] = ACTIONS(1486),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_LT] = ACTIONS(1484),
    [anon_sym_LT_EQ] = ACTIONS(1486),
    [anon_sym_GT] = ACTIONS(1484),
    [anon_sym_GT_EQ] = ACTIONS(1486),
    [anon_sym_EQ_EQ] = ACTIONS(1486),
    [anon_sym_BANG_EQ] = ACTIONS(1486),
    [anon_sym_STAR] = ACTIONS(1484),
    [anon_sym_SLASH] = ACTIONS(1486),
    [anon_sym_STAR_STAR] = ACTIONS(1486),
    [anon_sym_CARET] = ACTIONS(1486),
    [aux_sym_binary_operator_token1] = ACTIONS(1486),
    [anon_sym_PIPE_GT] = ACTIONS(1486),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(1486),
    [anon_sym_AT] = ACTIONS(1486),
    [sym__hex_literal] = ACTIONS(1486),
    [sym__number_literal] = ACTIONS(1484),
    [anon_sym_SQUOTE] = ACTIONS(1486),
    [anon_sym_DQUOTE] = ACTIONS(1486),
    [sym_return] = ACTIONS(1484),
    [sym_next] = ACTIONS(1484),
    [sym_break] = ACTIONS(1484),
    [sym_true] = ACTIONS(1484),
    [sym_false] = ACTIONS(1484),
    [sym_null] = ACTIONS(1484),
    [sym_inf] = ACTIONS(1484),
    [sym_nan] = ACTIONS(1484),
    [anon_sym_NA] = ACTIONS(1484),
    [anon_sym_NA_integer_] = ACTIONS(1484),
    [anon_sym_NA_real_] = ACTIONS(1484),
    [anon_sym_NA_complex_] = ACTIONS(1484),
    [anon_sym_NA_character_] = ACTIONS(1484),
    [sym_dots] = ACTIONS(1484),
    [sym_dot_dot_i] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1486),
    [sym__semicolon] = ACTIONS(1486),
    [sym__raw_string_literal] = ACTIONS(1486),
    [sym__external_else] = ACTIONS(1486),
    [sym__external_open_parenthesis] = ACTIONS(1486),
    [sym__external_open_brace] = ACTIONS(1486),
    [sym__external_open_bracket] = ACTIONS(1486),
    [sym__external_open_bracket2] = ACTIONS(1486),
  },
  [840] = {
    [sym_function_definition] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_repeat_statement] = STATE(406),
    [sym_braced_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_call] = STATE(406),
    [sym_subset] = STATE(406),
    [sym_subset2] = STATE(406),
    [sym_unary_operator] = STATE(406),
    [sym_binary_operator] = STATE(406),
    [sym_extract_operator] = STATE(406),
    [sym_namespace_operator] = STATE(406),
    [sym_integer] = STATE(406),
    [sym_complex] = STATE(406),
    [sym_float] = STATE(406),
    [sym__float_literal] = STATE(741),
    [sym_string] = STATE(740),
    [sym__single_quoted_string] = STATE(743),
    [sym__double_quoted_string] = STATE(746),
    [sym_na] = STATE(406),
    [sym__expression] = STATE(406),
    [sym__string_or_identifier] = STATE(2136),
    [sym__open_parenthesis] = STATE(934),
    [sym__open_brace] = STATE(853),
    [sym__close_brace] = STATE(786),
    [aux_sym_braced_expression_repeat1] = STATE(894),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1430),
    [anon_sym_function] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_repeat] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [sym__hex_literal] = ACTIONS(1450),
    [sym__number_literal] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [sym_return] = ACTIONS(1454),
    [sym_next] = ACTIONS(1454),
    [sym_break] = ACTIONS(1454),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [sym_null] = ACTIONS(1454),
    [sym_inf] = ACTIONS(1454),
    [sym_nan] = ACTIONS(1454),
    [anon_sym_NA] = ACTIONS(1456),
    [anon_sym_NA_integer_] = ACTIONS(1456),
    [anon_sym_NA_real_] = ACTIONS(1456),
    [anon_sym_NA_complex_] = ACTIONS(1456),
    [anon_sym_NA_character_] = ACTIONS(1456),
    [sym_dots] = ACTIONS(1454),
    [sym_dot_dot_i] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1460),
    [sym__semicolon] = ACTIONS(1460),
    [sym__raw_string_literal] = ACTIONS(1153),
    [sym__external_open_parenthesis] = ACTIONS(1462),
    [sym__external_open_brace] = ACTIONS(1464),
    [sym__external_close_brace] = ACTIONS(1569),
  },
  [841] = {
    [sym_function_definition] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_repeat_statement] = STATE(406),
    [sym_braced_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_call] = STATE(406),
    [sym_subset] = STATE(406),
    [sym_subset2] = STATE(406),
    [sym_unary_operator] = STATE(406),
    [sym_binary_operator] = STATE(406),
    [sym_extract_operator] = STATE(406),
    [sym_namespace_operator] = STATE(406),
    [sym_integer] = STATE(406),
    [sym_complex] = STATE(406),
    [sym_float] = STATE(406),
    [sym__float_literal] = STATE(741),
    [sym_string] = STATE(740),
    [sym__single_quoted_string] = STATE(743),
    [sym__double_quoted_string] = STATE(746),
    [sym_na] = STATE(406),
    [sym__expression] = STATE(406),
    [sym__string_or_identifier] = STATE(2136),
    [sym__open_parenthesis] = STATE(934),
    [sym__open_brace] = STATE(853),
    [sym__close_brace] = STATE(1953),
    [aux_sym_braced_expression_repeat1] = STATE(894),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1430),
    [anon_sym_function] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_repeat] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [sym__hex_literal] = ACTIONS(1450),
    [sym__number_literal] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [sym_return] = ACTIONS(1454),
    [sym_next] = ACTIONS(1454),
    [sym_break] = ACTIONS(1454),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [sym_null] = ACTIONS(1454),
    [sym_inf] = ACTIONS(1454),
    [sym_nan] = ACTIONS(1454),
    [anon_sym_NA] = ACTIONS(1456),
    [anon_sym_NA_integer_] = ACTIONS(1456),
    [anon_sym_NA_real_] = ACTIONS(1456),
    [anon_sym_NA_complex_] = ACTIONS(1456),
    [anon_sym_NA_character_] = ACTIONS(1456),
    [sym_dots] = ACTIONS(1454),
    [sym_dot_dot_i] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1460),
    [sym__semicolon] = ACTIONS(1460),
    [sym__raw_string_literal] = ACTIONS(1153),
    [sym__external_open_parenthesis] = ACTIONS(1462),
    [sym__external_open_brace] = ACTIONS(1464),
    [sym__external_close_brace] = ACTIONS(1571),
  },
  [842] = {
    [sym_function_definition] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_repeat_statement] = STATE(406),
    [sym_braced_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_call] = STATE(406),
    [sym_subset] = STATE(406),
    [sym_subset2] = STATE(406),
    [sym_unary_operator] = STATE(406),
    [sym_binary_operator] = STATE(406),
    [sym_extract_operator] = STATE(406),
    [sym_namespace_operator] = STATE(406),
    [sym_integer] = STATE(406),
    [sym_complex] = STATE(406),
    [sym_float] = STATE(406),
    [sym__float_literal] = STATE(741),
    [sym_string] = STATE(740),
    [sym__single_quoted_string] = STATE(743),
    [sym__double_quoted_string] = STATE(746),
    [sym_na] = STATE(406),
    [sym__expression] = STATE(406),
    [sym__string_or_identifier] = STATE(2136),
    [sym__open_parenthesis] = STATE(934),
    [sym__open_brace] = STATE(853),
    [sym__close_brace] = STATE(943),
    [aux_sym_braced_expression_repeat1] = STATE(856),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1430),
    [anon_sym_function] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_repeat] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [sym__hex_literal] = ACTIONS(1450),
    [sym__number_literal] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [sym_return] = ACTIONS(1454),
    [sym_next] = ACTIONS(1454),
    [sym_break] = ACTIONS(1454),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [sym_null] = ACTIONS(1454),
    [sym_inf] = ACTIONS(1454),
    [sym_nan] = ACTIONS(1454),
    [anon_sym_NA] = ACTIONS(1456),
    [anon_sym_NA_integer_] = ACTIONS(1456),
    [anon_sym_NA_real_] = ACTIONS(1456),
    [anon_sym_NA_complex_] = ACTIONS(1456),
    [anon_sym_NA_character_] = ACTIONS(1456),
    [sym_dots] = ACTIONS(1454),
    [sym_dot_dot_i] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1460),
    [sym__semicolon] = ACTIONS(1460),
    [sym__raw_string_literal] = ACTIONS(1153),
    [sym__external_open_parenthesis] = ACTIONS(1462),
    [sym__external_open_brace] = ACTIONS(1464),
    [sym__external_close_brace] = ACTIONS(1573),
  },
  [843] = {
    [aux_sym_function_definition_repeat1] = STATE(843),
    [sym_identifier] = ACTIONS(1383),
    [anon_sym_BSLASH] = ACTIONS(1385),
    [anon_sym_function] = ACTIONS(1383),
    [anon_sym_EQ] = ACTIONS(1383),
    [anon_sym_if] = ACTIONS(1383),
    [anon_sym_for] = ACTIONS(1383),
    [anon_sym_while] = ACTIONS(1383),
    [anon_sym_repeat] = ACTIONS(1383),
    [anon_sym_QMARK] = ACTIONS(1385),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1383),
    [anon_sym_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_COLON_EQ] = ACTIONS(1385),
    [anon_sym_DASH_GT] = ACTIONS(1383),
    [anon_sym_DASH_GT_GT] = ACTIONS(1385),
    [anon_sym_PIPE] = ACTIONS(1383),
    [anon_sym_AMP] = ACTIONS(1383),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1383),
    [anon_sym_LT_EQ] = ACTIONS(1385),
    [anon_sym_GT] = ACTIONS(1383),
    [anon_sym_GT_EQ] = ACTIONS(1385),
    [anon_sym_EQ_EQ] = ACTIONS(1385),
    [anon_sym_BANG_EQ] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_SLASH] = ACTIONS(1385),
    [anon_sym_STAR_STAR] = ACTIONS(1385),
    [anon_sym_CARET] = ACTIONS(1385),
    [aux_sym_binary_operator_token1] = ACTIONS(1385),
    [anon_sym_PIPE_GT] = ACTIONS(1385),
    [anon_sym_COLON] = ACTIONS(1383),
    [anon_sym_DOLLAR] = ACTIONS(1385),
    [anon_sym_AT] = ACTIONS(1385),
    [sym__hex_literal] = ACTIONS(1385),
    [sym__number_literal] = ACTIONS(1383),
    [anon_sym_SQUOTE] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [sym_return] = ACTIONS(1383),
    [sym_next] = ACTIONS(1383),
    [sym_break] = ACTIONS(1383),
    [sym_true] = ACTIONS(1383),
    [sym_false] = ACTIONS(1383),
    [sym_null] = ACTIONS(1383),
    [sym_inf] = ACTIONS(1383),
    [sym_nan] = ACTIONS(1383),
    [anon_sym_NA] = ACTIONS(1383),
    [anon_sym_NA_integer_] = ACTIONS(1383),
    [anon_sym_NA_real_] = ACTIONS(1383),
    [anon_sym_NA_complex_] = ACTIONS(1383),
    [anon_sym_NA_character_] = ACTIONS(1383),
    [sym_dots] = ACTIONS(1383),
    [sym_dot_dot_i] = ACTIONS(1385),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1385),
    [sym__newline] = ACTIONS(1575),
    [sym__raw_string_literal] = ACTIONS(1385),
    [sym__external_open_parenthesis] = ACTIONS(1385),
    [sym__external_open_brace] = ACTIONS(1385),
    [sym__external_open_bracket] = ACTIONS(1385),
    [sym__external_close_bracket] = ACTIONS(1385),
    [sym__external_open_bracket2] = ACTIONS(1385),
  },
  [844] = {
    [sym_identifier] = ACTIONS(1535),
    [anon_sym_BSLASH] = ACTIONS(1537),
    [anon_sym_function] = ACTIONS(1535),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_if] = ACTIONS(1535),
    [anon_sym_for] = ACTIONS(1535),
    [anon_sym_while] = ACTIONS(1535),
    [anon_sym_repeat] = ACTIONS(1535),
    [anon_sym_QMARK] = ACTIONS(1537),
    [anon_sym_TILDE] = ACTIONS(1537),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1535),
    [anon_sym_LT_DASH] = ACTIONS(1537),
    [anon_sym_LT_LT_DASH] = ACTIONS(1537),
    [anon_sym_COLON_EQ] = ACTIONS(1537),
    [anon_sym_DASH_GT] = ACTIONS(1535),
    [anon_sym_DASH_GT_GT] = ACTIONS(1537),
    [anon_sym_PIPE] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_PIPE_PIPE] = ACTIONS(1537),
    [anon_sym_AMP_AMP] = ACTIONS(1537),
    [anon_sym_LT] = ACTIONS(1535),
    [anon_sym_LT_EQ] = ACTIONS(1537),
    [anon_sym_GT] = ACTIONS(1535),
    [anon_sym_GT_EQ] = ACTIONS(1537),
    [anon_sym_EQ_EQ] = ACTIONS(1537),
    [anon_sym_BANG_EQ] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_SLASH] = ACTIONS(1537),
    [anon_sym_STAR_STAR] = ACTIONS(1537),
    [anon_sym_CARET] = ACTIONS(1537),
    [aux_sym_binary_operator_token1] = ACTIONS(1537),
    [anon_sym_PIPE_GT] = ACTIONS(1537),
    [anon_sym_COLON] = ACTIONS(1535),
    [anon_sym_DOLLAR] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(1537),
    [sym__hex_literal] = ACTIONS(1537),
    [sym__number_literal] = ACTIONS(1535),
    [anon_sym_SQUOTE] = ACTIONS(1537),
    [anon_sym_DQUOTE] = ACTIONS(1537),
    [sym_return] = ACTIONS(1535),
    [sym_next] = ACTIONS(1535),
    [sym_break] = ACTIONS(1535),
    [sym_true] = ACTIONS(1535),
    [sym_false] = ACTIONS(1535),
    [sym_null] = ACTIONS(1535),
    [sym_inf] = ACTIONS(1535),
    [sym_nan] = ACTIONS(1535),
    [anon_sym_NA] = ACTIONS(1535),
    [anon_sym_NA_integer_] = ACTIONS(1535),
    [anon_sym_NA_real_] = ACTIONS(1535),
    [anon_sym_NA_complex_] = ACTIONS(1535),
    [anon_sym_NA_character_] = ACTIONS(1535),
    [sym_dots] = ACTIONS(1535),
    [sym_dot_dot_i] = ACTIONS(1537),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1537),
    [sym__newline] = ACTIONS(1537),
    [sym__raw_string_literal] = ACTIONS(1537),
    [sym__external_else] = ACTIONS(1537),
    [sym__external_open_parenthesis] = ACTIONS(1537),
    [sym__external_close_parenthesis] = ACTIONS(1537),
    [sym__external_open_brace] = ACTIONS(1537),
    [sym__external_open_bracket] = ACTIONS(1537),
    [sym__external_open_bracket2] = ACTIONS(1537),
  },
  [845] = {
    [sym_identifier] = ACTIONS(1551),
    [anon_sym_BSLASH] = ACTIONS(1553),
    [anon_sym_function] = ACTIONS(1551),
    [anon_sym_EQ] = ACTIONS(1551),
    [anon_sym_if] = ACTIONS(1551),
    [anon_sym_for] = ACTIONS(1551),
    [anon_sym_while] = ACTIONS(1551),
    [anon_sym_repeat] = ACTIONS(1551),
    [anon_sym_QMARK] = ACTIONS(1553),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_PLUS] = ACTIONS(1553),
    [anon_sym_DASH] = ACTIONS(1551),
    [anon_sym_LT_DASH] = ACTIONS(1553),
    [anon_sym_LT_LT_DASH] = ACTIONS(1553),
    [anon_sym_COLON_EQ] = ACTIONS(1553),
    [anon_sym_DASH_GT] = ACTIONS(1551),
    [anon_sym_DASH_GT_GT] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_PIPE_PIPE] = ACTIONS(1553),
    [anon_sym_AMP_AMP] = ACTIONS(1553),
    [anon_sym_LT] = ACTIONS(1551),
    [anon_sym_LT_EQ] = ACTIONS(1553),
    [anon_sym_GT] = ACTIONS(1551),
    [anon_sym_GT_EQ] = ACTIONS(1553),
    [anon_sym_EQ_EQ] = ACTIONS(1553),
    [anon_sym_BANG_EQ] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(1551),
    [anon_sym_SLASH] = ACTIONS(1553),
    [anon_sym_STAR_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [aux_sym_binary_operator_token1] = ACTIONS(1553),
    [anon_sym_PIPE_GT] = ACTIONS(1553),
    [anon_sym_COLON] = ACTIONS(1551),
    [anon_sym_DOLLAR] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(1553),
    [sym__hex_literal] = ACTIONS(1553),
    [sym__number_literal] = ACTIONS(1551),
    [anon_sym_SQUOTE] = ACTIONS(1553),
    [anon_sym_DQUOTE] = ACTIONS(1553),
    [sym_return] = ACTIONS(1551),
    [sym_next] = ACTIONS(1551),
    [sym_break] = ACTIONS(1551),
    [sym_true] = ACTIONS(1551),
    [sym_false] = ACTIONS(1551),
    [sym_null] = ACTIONS(1551),
    [sym_inf] = ACTIONS(1551),
    [sym_nan] = ACTIONS(1551),
    [anon_sym_NA] = ACTIONS(1551),
    [anon_sym_NA_integer_] = ACTIONS(1551),
    [anon_sym_NA_real_] = ACTIONS(1551),
    [anon_sym_NA_complex_] = ACTIONS(1551),
    [anon_sym_NA_character_] = ACTIONS(1551),
    [sym_dots] = ACTIONS(1551),
    [sym_dot_dot_i] = ACTIONS(1553),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1553),
    [sym__newline] = ACTIONS(1553),
    [sym__raw_string_literal] = ACTIONS(1553),
    [sym__external_else] = ACTIONS(1553),
    [sym__external_open_parenthesis] = ACTIONS(1553),
    [sym__external_close_parenthesis] = ACTIONS(1553),
    [sym__external_open_brace] = ACTIONS(1553),
    [sym__external_open_bracket] = ACTIONS(1553),
    [sym__external_open_bracket2] = ACTIONS(1553),
  },
  [846] = {
    [sym_identifier] = ACTIONS(1468),
    [anon_sym_BSLASH] = ACTIONS(1470),
    [anon_sym_function] = ACTIONS(1468),
    [anon_sym_EQ] = ACTIONS(1468),
    [anon_sym_if] = ACTIONS(1468),
    [anon_sym_for] = ACTIONS(1468),
    [anon_sym_while] = ACTIONS(1468),
    [anon_sym_repeat] = ACTIONS(1468),
    [anon_sym_QMARK] = ACTIONS(1470),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_BANG] = ACTIONS(1468),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1468),
    [anon_sym_LT_DASH] = ACTIONS(1470),
    [anon_sym_LT_LT_DASH] = ACTIONS(1470),
    [anon_sym_COLON_EQ] = ACTIONS(1470),
    [anon_sym_DASH_GT] = ACTIONS(1468),
    [anon_sym_DASH_GT_GT] = ACTIONS(1470),
    [anon_sym_PIPE] = ACTIONS(1468),
    [anon_sym_AMP] = ACTIONS(1468),
    [anon_sym_PIPE_PIPE] = ACTIONS(1470),
    [anon_sym_AMP_AMP] = ACTIONS(1470),
    [anon_sym_LT] = ACTIONS(1468),
    [anon_sym_LT_EQ] = ACTIONS(1470),
    [anon_sym_GT] = ACTIONS(1468),
    [anon_sym_GT_EQ] = ACTIONS(1470),
    [anon_sym_EQ_EQ] = ACTIONS(1470),
    [anon_sym_BANG_EQ] = ACTIONS(1470),
    [anon_sym_STAR] = ACTIONS(1468),
    [anon_sym_SLASH] = ACTIONS(1470),
    [anon_sym_STAR_STAR] = ACTIONS(1470),
    [anon_sym_CARET] = ACTIONS(1470),
    [aux_sym_binary_operator_token1] = ACTIONS(1470),
    [anon_sym_PIPE_GT] = ACTIONS(1470),
    [anon_sym_COLON] = ACTIONS(1468),
    [anon_sym_DOLLAR] = ACTIONS(1470),
    [anon_sym_AT] = ACTIONS(1470),
    [sym__hex_literal] = ACTIONS(1470),
    [sym__number_literal] = ACTIONS(1468),
    [anon_sym_SQUOTE] = ACTIONS(1470),
    [anon_sym_DQUOTE] = ACTIONS(1470),
    [sym_return] = ACTIONS(1468),
    [sym_next] = ACTIONS(1468),
    [sym_break] = ACTIONS(1468),
    [sym_true] = ACTIONS(1468),
    [sym_false] = ACTIONS(1468),
    [sym_null] = ACTIONS(1468),
    [sym_inf] = ACTIONS(1468),
    [sym_nan] = ACTIONS(1468),
    [anon_sym_NA] = ACTIONS(1468),
    [anon_sym_NA_integer_] = ACTIONS(1468),
    [anon_sym_NA_real_] = ACTIONS(1468),
    [anon_sym_NA_complex_] = ACTIONS(1468),
    [anon_sym_NA_character_] = ACTIONS(1468),
    [sym_dots] = ACTIONS(1468),
    [sym_dot_dot_i] = ACTIONS(1470),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1470),
    [sym__newline] = ACTIONS(1470),
    [sym__raw_string_literal] = ACTIONS(1470),
    [sym__external_else] = ACTIONS(1470),
    [sym__external_open_parenthesis] = ACTIONS(1470),
    [sym__external_close_parenthesis] = ACTIONS(1470),
    [sym__external_open_brace] = ACTIONS(1470),
    [sym__external_open_bracket] = ACTIONS(1470),
    [sym__external_open_bracket2] = ACTIONS(1470),
  },
  [847] = {
    [sym_identifier] = ACTIONS(1472),
    [anon_sym_BSLASH] = ACTIONS(1474),
    [anon_sym_function] = ACTIONS(1472),
    [anon_sym_EQ] = ACTIONS(1472),
    [anon_sym_if] = ACTIONS(1472),
    [anon_sym_for] = ACTIONS(1472),
    [anon_sym_while] = ACTIONS(1472),
    [anon_sym_repeat] = ACTIONS(1472),
    [anon_sym_QMARK] = ACTIONS(1474),
    [anon_sym_TILDE] = ACTIONS(1474),
    [anon_sym_BANG] = ACTIONS(1472),
    [anon_sym_PLUS] = ACTIONS(1474),
    [anon_sym_DASH] = ACTIONS(1472),
    [anon_sym_LT_DASH] = ACTIONS(1474),
    [anon_sym_LT_LT_DASH] = ACTIONS(1474),
    [anon_sym_COLON_EQ] = ACTIONS(1474),
    [anon_sym_DASH_GT] = ACTIONS(1472),
    [anon_sym_DASH_GT_GT] = ACTIONS(1474),
    [anon_sym_PIPE] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1472),
    [anon_sym_PIPE_PIPE] = ACTIONS(1474),
    [anon_sym_AMP_AMP] = ACTIONS(1474),
    [anon_sym_LT] = ACTIONS(1472),
    [anon_sym_LT_EQ] = ACTIONS(1474),
    [anon_sym_GT] = ACTIONS(1472),
    [anon_sym_GT_EQ] = ACTIONS(1474),
    [anon_sym_EQ_EQ] = ACTIONS(1474),
    [anon_sym_BANG_EQ] = ACTIONS(1474),
    [anon_sym_STAR] = ACTIONS(1472),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_STAR_STAR] = ACTIONS(1474),
    [anon_sym_CARET] = ACTIONS(1474),
    [aux_sym_binary_operator_token1] = ACTIONS(1474),
    [anon_sym_PIPE_GT] = ACTIONS(1474),
    [anon_sym_COLON] = ACTIONS(1472),
    [anon_sym_DOLLAR] = ACTIONS(1474),
    [anon_sym_AT] = ACTIONS(1474),
    [sym__hex_literal] = ACTIONS(1474),
    [sym__number_literal] = ACTIONS(1472),
    [anon_sym_SQUOTE] = ACTIONS(1474),
    [anon_sym_DQUOTE] = ACTIONS(1474),
    [sym_return] = ACTIONS(1472),
    [sym_next] = ACTIONS(1472),
    [sym_break] = ACTIONS(1472),
    [sym_true] = ACTIONS(1472),
    [sym_false] = ACTIONS(1472),
    [sym_null] = ACTIONS(1472),
    [sym_inf] = ACTIONS(1472),
    [sym_nan] = ACTIONS(1472),
    [anon_sym_NA] = ACTIONS(1472),
    [anon_sym_NA_integer_] = ACTIONS(1472),
    [anon_sym_NA_real_] = ACTIONS(1472),
    [anon_sym_NA_complex_] = ACTIONS(1472),
    [anon_sym_NA_character_] = ACTIONS(1472),
    [sym_dots] = ACTIONS(1472),
    [sym_dot_dot_i] = ACTIONS(1474),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1474),
    [sym__newline] = ACTIONS(1474),
    [sym__raw_string_literal] = ACTIONS(1474),
    [sym__external_else] = ACTIONS(1474),
    [sym__external_open_parenthesis] = ACTIONS(1474),
    [sym__external_close_parenthesis] = ACTIONS(1474),
    [sym__external_open_brace] = ACTIONS(1474),
    [sym__external_open_bracket] = ACTIONS(1474),
    [sym__external_open_bracket2] = ACTIONS(1474),
  },
  [848] = {
    [sym_identifier] = ACTIONS(1476),
    [anon_sym_BSLASH] = ACTIONS(1478),
    [anon_sym_function] = ACTIONS(1476),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_if] = ACTIONS(1476),
    [anon_sym_for] = ACTIONS(1476),
    [anon_sym_while] = ACTIONS(1476),
    [anon_sym_repeat] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_BANG] = ACTIONS(1476),
    [anon_sym_PLUS] = ACTIONS(1478),
    [anon_sym_DASH] = ACTIONS(1476),
    [anon_sym_LT_DASH] = ACTIONS(1478),
    [anon_sym_LT_LT_DASH] = ACTIONS(1478),
    [anon_sym_COLON_EQ] = ACTIONS(1478),
    [anon_sym_DASH_GT] = ACTIONS(1476),
    [anon_sym_DASH_GT_GT] = ACTIONS(1478),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1478),
    [anon_sym_AMP_AMP] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_EQ] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_GT_EQ] = ACTIONS(1478),
    [anon_sym_EQ_EQ] = ACTIONS(1478),
    [anon_sym_BANG_EQ] = ACTIONS(1478),
    [anon_sym_STAR] = ACTIONS(1476),
    [anon_sym_SLASH] = ACTIONS(1478),
    [anon_sym_STAR_STAR] = ACTIONS(1478),
    [anon_sym_CARET] = ACTIONS(1478),
    [aux_sym_binary_operator_token1] = ACTIONS(1478),
    [anon_sym_PIPE_GT] = ACTIONS(1478),
    [anon_sym_COLON] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1478),
    [anon_sym_AT] = ACTIONS(1478),
    [sym__hex_literal] = ACTIONS(1478),
    [sym__number_literal] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_DQUOTE] = ACTIONS(1478),
    [sym_return] = ACTIONS(1476),
    [sym_next] = ACTIONS(1476),
    [sym_break] = ACTIONS(1476),
    [sym_true] = ACTIONS(1476),
    [sym_false] = ACTIONS(1476),
    [sym_null] = ACTIONS(1476),
    [sym_inf] = ACTIONS(1476),
    [sym_nan] = ACTIONS(1476),
    [anon_sym_NA] = ACTIONS(1476),
    [anon_sym_NA_integer_] = ACTIONS(1476),
    [anon_sym_NA_real_] = ACTIONS(1476),
    [anon_sym_NA_complex_] = ACTIONS(1476),
    [anon_sym_NA_character_] = ACTIONS(1476),
    [sym_dots] = ACTIONS(1476),
    [sym_dot_dot_i] = ACTIONS(1478),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1478),
    [sym__newline] = ACTIONS(1478),
    [sym__raw_string_literal] = ACTIONS(1478),
    [sym__external_else] = ACTIONS(1478),
    [sym__external_open_parenthesis] = ACTIONS(1478),
    [sym__external_close_parenthesis] = ACTIONS(1478),
    [sym__external_open_brace] = ACTIONS(1478),
    [sym__external_open_bracket] = ACTIONS(1478),
    [sym__external_open_bracket2] = ACTIONS(1478),
  },
  [849] = {
    [sym_identifier] = ACTIONS(1480),
    [anon_sym_BSLASH] = ACTIONS(1482),
    [anon_sym_function] = ACTIONS(1480),
    [anon_sym_EQ] = ACTIONS(1480),
    [anon_sym_if] = ACTIONS(1480),
    [anon_sym_for] = ACTIONS(1480),
    [anon_sym_while] = ACTIONS(1480),
    [anon_sym_repeat] = ACTIONS(1480),
    [anon_sym_QMARK] = ACTIONS(1482),
    [anon_sym_TILDE] = ACTIONS(1482),
    [anon_sym_BANG] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1482),
    [anon_sym_DASH] = ACTIONS(1480),
    [anon_sym_LT_DASH] = ACTIONS(1482),
    [anon_sym_LT_LT_DASH] = ACTIONS(1482),
    [anon_sym_COLON_EQ] = ACTIONS(1482),
    [anon_sym_DASH_GT] = ACTIONS(1480),
    [anon_sym_DASH_GT_GT] = ACTIONS(1482),
    [anon_sym_PIPE] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1480),
    [anon_sym_PIPE_PIPE] = ACTIONS(1482),
    [anon_sym_AMP_AMP] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(1480),
    [anon_sym_LT_EQ] = ACTIONS(1482),
    [anon_sym_GT] = ACTIONS(1480),
    [anon_sym_GT_EQ] = ACTIONS(1482),
    [anon_sym_EQ_EQ] = ACTIONS(1482),
    [anon_sym_BANG_EQ] = ACTIONS(1482),
    [anon_sym_STAR] = ACTIONS(1480),
    [anon_sym_SLASH] = ACTIONS(1482),
    [anon_sym_STAR_STAR] = ACTIONS(1482),
    [anon_sym_CARET] = ACTIONS(1482),
    [aux_sym_binary_operator_token1] = ACTIONS(1482),
    [anon_sym_PIPE_GT] = ACTIONS(1482),
    [anon_sym_COLON] = ACTIONS(1480),
    [anon_sym_DOLLAR] = ACTIONS(1482),
    [anon_sym_AT] = ACTIONS(1482),
    [sym__hex_literal] = ACTIONS(1482),
    [sym__number_literal] = ACTIONS(1480),
    [anon_sym_SQUOTE] = ACTIONS(1482),
    [anon_sym_DQUOTE] = ACTIONS(1482),
    [sym_return] = ACTIONS(1480),
    [sym_next] = ACTIONS(1480),
    [sym_break] = ACTIONS(1480),
    [sym_true] = ACTIONS(1480),
    [sym_false] = ACTIONS(1480),
    [sym_null] = ACTIONS(1480),
    [sym_inf] = ACTIONS(1480),
    [sym_nan] = ACTIONS(1480),
    [anon_sym_NA] = ACTIONS(1480),
    [anon_sym_NA_integer_] = ACTIONS(1480),
    [anon_sym_NA_real_] = ACTIONS(1480),
    [anon_sym_NA_complex_] = ACTIONS(1480),
    [anon_sym_NA_character_] = ACTIONS(1480),
    [sym_dots] = ACTIONS(1480),
    [sym_dot_dot_i] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1482),
    [sym__newline] = ACTIONS(1482),
    [sym__raw_string_literal] = ACTIONS(1482),
    [sym__external_else] = ACTIONS(1482),
    [sym__external_open_parenthesis] = ACTIONS(1482),
    [sym__external_close_parenthesis] = ACTIONS(1482),
    [sym__external_open_brace] = ACTIONS(1482),
    [sym__external_open_bracket] = ACTIONS(1482),
    [sym__external_open_bracket2] = ACTIONS(1482),
  },
  [850] = {
    [sym_identifier] = ACTIONS(1484),
    [anon_sym_BSLASH] = ACTIONS(1486),
    [anon_sym_function] = ACTIONS(1484),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_if] = ACTIONS(1484),
    [anon_sym_for] = ACTIONS(1484),
    [anon_sym_while] = ACTIONS(1484),
    [anon_sym_repeat] = ACTIONS(1484),
    [anon_sym_QMARK] = ACTIONS(1486),
    [anon_sym_TILDE] = ACTIONS(1486),
    [anon_sym_BANG] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_LT_DASH] = ACTIONS(1486),
    [anon_sym_LT_LT_DASH] = ACTIONS(1486),
    [anon_sym_COLON_EQ] = ACTIONS(1486),
    [anon_sym_DASH_GT] = ACTIONS(1484),
    [anon_sym_DASH_GT_GT] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1484),
    [anon_sym_AMP] = ACTIONS(1484),
    [anon_sym_PIPE_PIPE] = ACTIONS(1486),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_LT] = ACTIONS(1484),
    [anon_sym_LT_EQ] = ACTIONS(1486),
    [anon_sym_GT] = ACTIONS(1484),
    [anon_sym_GT_EQ] = ACTIONS(1486),
    [anon_sym_EQ_EQ] = ACTIONS(1486),
    [anon_sym_BANG_EQ] = ACTIONS(1486),
    [anon_sym_STAR] = ACTIONS(1484),
    [anon_sym_SLASH] = ACTIONS(1486),
    [anon_sym_STAR_STAR] = ACTIONS(1486),
    [anon_sym_CARET] = ACTIONS(1486),
    [aux_sym_binary_operator_token1] = ACTIONS(1486),
    [anon_sym_PIPE_GT] = ACTIONS(1486),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(1486),
    [anon_sym_AT] = ACTIONS(1486),
    [sym__hex_literal] = ACTIONS(1486),
    [sym__number_literal] = ACTIONS(1484),
    [anon_sym_SQUOTE] = ACTIONS(1486),
    [anon_sym_DQUOTE] = ACTIONS(1486),
    [sym_return] = ACTIONS(1484),
    [sym_next] = ACTIONS(1484),
    [sym_break] = ACTIONS(1484),
    [sym_true] = ACTIONS(1484),
    [sym_false] = ACTIONS(1484),
    [sym_null] = ACTIONS(1484),
    [sym_inf] = ACTIONS(1484),
    [sym_nan] = ACTIONS(1484),
    [anon_sym_NA] = ACTIONS(1484),
    [anon_sym_NA_integer_] = ACTIONS(1484),
    [anon_sym_NA_real_] = ACTIONS(1484),
    [anon_sym_NA_complex_] = ACTIONS(1484),
    [anon_sym_NA_character_] = ACTIONS(1484),
    [sym_dots] = ACTIONS(1484),
    [sym_dot_dot_i] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1486),
    [sym__newline] = ACTIONS(1486),
    [sym__raw_string_literal] = ACTIONS(1486),
    [sym__external_else] = ACTIONS(1486),
    [sym__external_open_parenthesis] = ACTIONS(1486),
    [sym__external_close_parenthesis] = ACTIONS(1486),
    [sym__external_open_brace] = ACTIONS(1486),
    [sym__external_open_bracket] = ACTIONS(1486),
    [sym__external_open_bracket2] = ACTIONS(1486),
  },
  [851] = {
    [sym_function_definition] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_repeat_statement] = STATE(406),
    [sym_braced_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_call] = STATE(406),
    [sym_subset] = STATE(406),
    [sym_subset2] = STATE(406),
    [sym_unary_operator] = STATE(406),
    [sym_binary_operator] = STATE(406),
    [sym_extract_operator] = STATE(406),
    [sym_namespace_operator] = STATE(406),
    [sym_integer] = STATE(406),
    [sym_complex] = STATE(406),
    [sym_float] = STATE(406),
    [sym__float_literal] = STATE(741),
    [sym_string] = STATE(740),
    [sym__single_quoted_string] = STATE(743),
    [sym__double_quoted_string] = STATE(746),
    [sym_na] = STATE(406),
    [sym__expression] = STATE(406),
    [sym__string_or_identifier] = STATE(2136),
    [sym__open_parenthesis] = STATE(934),
    [sym__open_brace] = STATE(853),
    [sym__close_brace] = STATE(869),
    [aux_sym_braced_expression_repeat1] = STATE(894),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1430),
    [anon_sym_function] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_repeat] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [sym__hex_literal] = ACTIONS(1450),
    [sym__number_literal] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [sym_return] = ACTIONS(1454),
    [sym_next] = ACTIONS(1454),
    [sym_break] = ACTIONS(1454),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [sym_null] = ACTIONS(1454),
    [sym_inf] = ACTIONS(1454),
    [sym_nan] = ACTIONS(1454),
    [anon_sym_NA] = ACTIONS(1456),
    [anon_sym_NA_integer_] = ACTIONS(1456),
    [anon_sym_NA_real_] = ACTIONS(1456),
    [anon_sym_NA_complex_] = ACTIONS(1456),
    [anon_sym_NA_character_] = ACTIONS(1456),
    [sym_dots] = ACTIONS(1454),
    [sym_dot_dot_i] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1460),
    [sym__semicolon] = ACTIONS(1460),
    [sym__raw_string_literal] = ACTIONS(1153),
    [sym__external_open_parenthesis] = ACTIONS(1462),
    [sym__external_open_brace] = ACTIONS(1464),
    [sym__external_close_brace] = ACTIONS(1578),
  },
  [852] = {
    [aux_sym_function_definition_repeat1] = STATE(852),
    [sym_identifier] = ACTIONS(1383),
    [anon_sym_BSLASH] = ACTIONS(1385),
    [anon_sym_function] = ACTIONS(1383),
    [anon_sym_EQ] = ACTIONS(1383),
    [anon_sym_if] = ACTIONS(1383),
    [anon_sym_for] = ACTIONS(1383),
    [anon_sym_while] = ACTIONS(1383),
    [anon_sym_repeat] = ACTIONS(1383),
    [anon_sym_QMARK] = ACTIONS(1385),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_DASH] = ACTIONS(1383),
    [anon_sym_LT_DASH] = ACTIONS(1385),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_COLON_EQ] = ACTIONS(1385),
    [anon_sym_DASH_GT] = ACTIONS(1383),
    [anon_sym_DASH_GT_GT] = ACTIONS(1385),
    [anon_sym_PIPE] = ACTIONS(1383),
    [anon_sym_AMP] = ACTIONS(1383),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1383),
    [anon_sym_LT_EQ] = ACTIONS(1385),
    [anon_sym_GT] = ACTIONS(1383),
    [anon_sym_GT_EQ] = ACTIONS(1385),
    [anon_sym_EQ_EQ] = ACTIONS(1385),
    [anon_sym_BANG_EQ] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_SLASH] = ACTIONS(1385),
    [anon_sym_STAR_STAR] = ACTIONS(1385),
    [anon_sym_CARET] = ACTIONS(1385),
    [aux_sym_binary_operator_token1] = ACTIONS(1385),
    [anon_sym_PIPE_GT] = ACTIONS(1385),
    [anon_sym_COLON] = ACTIONS(1383),
    [anon_sym_DOLLAR] = ACTIONS(1385),
    [anon_sym_AT] = ACTIONS(1385),
    [sym__hex_literal] = ACTIONS(1385),
    [sym__number_literal] = ACTIONS(1383),
    [anon_sym_SQUOTE] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [sym_return] = ACTIONS(1383),
    [sym_next] = ACTIONS(1383),
    [sym_break] = ACTIONS(1383),
    [sym_true] = ACTIONS(1383),
    [sym_false] = ACTIONS(1383),
    [sym_null] = ACTIONS(1383),
    [sym_inf] = ACTIONS(1383),
    [sym_nan] = ACTIONS(1383),
    [anon_sym_NA] = ACTIONS(1383),
    [anon_sym_NA_integer_] = ACTIONS(1383),
    [anon_sym_NA_real_] = ACTIONS(1383),
    [anon_sym_NA_complex_] = ACTIONS(1383),
    [anon_sym_NA_character_] = ACTIONS(1383),
    [sym_dots] = ACTIONS(1383),
    [sym_dot_dot_i] = ACTIONS(1385),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1385),
    [sym__newline] = ACTIONS(1580),
    [sym__raw_string_literal] = ACTIONS(1385),
    [sym__external_open_parenthesis] = ACTIONS(1385),
    [sym__external_open_brace] = ACTIONS(1385),
    [sym__external_open_bracket] = ACTIONS(1385),
    [sym__external_open_bracket2] = ACTIONS(1385),
    [sym__external_close_bracket2] = ACTIONS(1385),
  },
  [853] = {
    [sym_function_definition] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_repeat_statement] = STATE(406),
    [sym_braced_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_call] = STATE(406),
    [sym_subset] = STATE(406),
    [sym_subset2] = STATE(406),
    [sym_unary_operator] = STATE(406),
    [sym_binary_operator] = STATE(406),
    [sym_extract_operator] = STATE(406),
    [sym_namespace_operator] = STATE(406),
    [sym_integer] = STATE(406),
    [sym_complex] = STATE(406),
    [sym_float] = STATE(406),
    [sym__float_literal] = STATE(741),
    [sym_string] = STATE(740),
    [sym__single_quoted_string] = STATE(743),
    [sym__double_quoted_string] = STATE(746),
    [sym_na] = STATE(406),
    [sym__expression] = STATE(406),
    [sym__string_or_identifier] = STATE(2136),
    [sym__open_parenthesis] = STATE(934),
    [sym__open_brace] = STATE(853),
    [sym__close_brace] = STATE(946),
    [aux_sym_braced_expression_repeat1] = STATE(795),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1430),
    [anon_sym_function] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_repeat] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [sym__hex_literal] = ACTIONS(1450),
    [sym__number_literal] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [sym_return] = ACTIONS(1454),
    [sym_next] = ACTIONS(1454),
    [sym_break] = ACTIONS(1454),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [sym_null] = ACTIONS(1454),
    [sym_inf] = ACTIONS(1454),
    [sym_nan] = ACTIONS(1454),
    [anon_sym_NA] = ACTIONS(1456),
    [anon_sym_NA_integer_] = ACTIONS(1456),
    [anon_sym_NA_real_] = ACTIONS(1456),
    [anon_sym_NA_complex_] = ACTIONS(1456),
    [anon_sym_NA_character_] = ACTIONS(1456),
    [sym_dots] = ACTIONS(1454),
    [sym_dot_dot_i] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1460),
    [sym__semicolon] = ACTIONS(1460),
    [sym__raw_string_literal] = ACTIONS(1153),
    [sym__external_open_parenthesis] = ACTIONS(1462),
    [sym__external_open_brace] = ACTIONS(1464),
    [sym__external_close_brace] = ACTIONS(1583),
  },
  [854] = {
    [sym_identifier] = ACTIONS(1533),
    [anon_sym_BSLASH] = ACTIONS(1531),
    [anon_sym_function] = ACTIONS(1533),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_if] = ACTIONS(1533),
    [anon_sym_for] = ACTIONS(1533),
    [anon_sym_while] = ACTIONS(1533),
    [anon_sym_repeat] = ACTIONS(1533),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_LT_DASH] = ACTIONS(1531),
    [anon_sym_LT_LT_DASH] = ACTIONS(1531),
    [anon_sym_COLON_EQ] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1533),
    [anon_sym_DASH_GT_GT] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1531),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_CARET] = ACTIONS(1531),
    [aux_sym_binary_operator_token1] = ACTIONS(1531),
    [anon_sym_PIPE_GT] = ACTIONS(1531),
    [anon_sym_COLON] = ACTIONS(1533),
    [anon_sym_DOLLAR] = ACTIONS(1531),
    [anon_sym_AT] = ACTIONS(1531),
    [sym__hex_literal] = ACTIONS(1531),
    [sym__number_literal] = ACTIONS(1533),
    [anon_sym_SQUOTE] = ACTIONS(1531),
    [anon_sym_DQUOTE] = ACTIONS(1531),
    [sym_return] = ACTIONS(1533),
    [sym_next] = ACTIONS(1533),
    [sym_break] = ACTIONS(1533),
    [sym_true] = ACTIONS(1533),
    [sym_false] = ACTIONS(1533),
    [sym_null] = ACTIONS(1533),
    [sym_inf] = ACTIONS(1533),
    [sym_nan] = ACTIONS(1533),
    [anon_sym_NA] = ACTIONS(1533),
    [anon_sym_NA_integer_] = ACTIONS(1533),
    [anon_sym_NA_real_] = ACTIONS(1533),
    [anon_sym_NA_complex_] = ACTIONS(1533),
    [anon_sym_NA_character_] = ACTIONS(1533),
    [sym_dots] = ACTIONS(1533),
    [sym_dot_dot_i] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1531),
    [sym__newline] = ACTIONS(1531),
    [sym__raw_string_literal] = ACTIONS(1531),
    [sym__external_else] = ACTIONS(1531),
    [sym__external_open_parenthesis] = ACTIONS(1531),
    [sym__external_open_brace] = ACTIONS(1531),
    [sym__external_open_bracket] = ACTIONS(1531),
    [sym__external_close_bracket] = ACTIONS(1531),
    [sym__external_open_bracket2] = ACTIONS(1531),
  },
  [855] = {
    [sym_function_definition] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_repeat_statement] = STATE(406),
    [sym_braced_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_call] = STATE(406),
    [sym_subset] = STATE(406),
    [sym_subset2] = STATE(406),
    [sym_unary_operator] = STATE(406),
    [sym_binary_operator] = STATE(406),
    [sym_extract_operator] = STATE(406),
    [sym_namespace_operator] = STATE(406),
    [sym_integer] = STATE(406),
    [sym_complex] = STATE(406),
    [sym_float] = STATE(406),
    [sym__float_literal] = STATE(741),
    [sym_string] = STATE(740),
    [sym__single_quoted_string] = STATE(743),
    [sym__double_quoted_string] = STATE(746),
    [sym_na] = STATE(406),
    [sym__expression] = STATE(406),
    [sym__string_or_identifier] = STATE(2136),
    [sym__open_parenthesis] = STATE(934),
    [sym__open_brace] = STATE(853),
    [sym__close_brace] = STATE(1983),
    [aux_sym_braced_expression_repeat1] = STATE(810),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1430),
    [anon_sym_function] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_repeat] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [sym__hex_literal] = ACTIONS(1450),
    [sym__number_literal] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [sym_return] = ACTIONS(1454),
    [sym_next] = ACTIONS(1454),
    [sym_break] = ACTIONS(1454),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [sym_null] = ACTIONS(1454),
    [sym_inf] = ACTIONS(1454),
    [sym_nan] = ACTIONS(1454),
    [anon_sym_NA] = ACTIONS(1456),
    [anon_sym_NA_integer_] = ACTIONS(1456),
    [anon_sym_NA_real_] = ACTIONS(1456),
    [anon_sym_NA_complex_] = ACTIONS(1456),
    [anon_sym_NA_character_] = ACTIONS(1456),
    [sym_dots] = ACTIONS(1454),
    [sym_dot_dot_i] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1460),
    [sym__semicolon] = ACTIONS(1460),
    [sym__raw_string_literal] = ACTIONS(1153),
    [sym__external_open_parenthesis] = ACTIONS(1462),
    [sym__external_open_brace] = ACTIONS(1464),
    [sym__external_close_brace] = ACTIONS(1585),
  },
  [856] = {
    [sym_function_definition] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_repeat_statement] = STATE(406),
    [sym_braced_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_call] = STATE(406),
    [sym_subset] = STATE(406),
    [sym_subset2] = STATE(406),
    [sym_unary_operator] = STATE(406),
    [sym_binary_operator] = STATE(406),
    [sym_extract_operator] = STATE(406),
    [sym_namespace_operator] = STATE(406),
    [sym_integer] = STATE(406),
    [sym_complex] = STATE(406),
    [sym_float] = STATE(406),
    [sym__float_literal] = STATE(741),
    [sym_string] = STATE(740),
    [sym__single_quoted_string] = STATE(743),
    [sym__double_quoted_string] = STATE(746),
    [sym_na] = STATE(406),
    [sym__expression] = STATE(406),
    [sym__string_or_identifier] = STATE(2136),
    [sym__open_parenthesis] = STATE(934),
    [sym__open_brace] = STATE(853),
    [sym__close_brace] = STATE(897),
    [aux_sym_braced_expression_repeat1] = STATE(894),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1430),
    [anon_sym_function] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_repeat] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [sym__hex_literal] = ACTIONS(1450),
    [sym__number_literal] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [sym_return] = ACTIONS(1454),
    [sym_next] = ACTIONS(1454),
    [sym_break] = ACTIONS(1454),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [sym_null] = ACTIONS(1454),
    [sym_inf] = ACTIONS(1454),
    [sym_nan] = ACTIONS(1454),
    [anon_sym_NA] = ACTIONS(1456),
    [anon_sym_NA_integer_] = ACTIONS(1456),
    [anon_sym_NA_real_] = ACTIONS(1456),
    [anon_sym_NA_complex_] = ACTIONS(1456),
    [anon_sym_NA_character_] = ACTIONS(1456),
    [sym_dots] = ACTIONS(1454),
    [sym_dot_dot_i] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1460),
    [sym__semicolon] = ACTIONS(1460),
    [sym__raw_string_literal] = ACTIONS(1153),
    [sym__external_open_parenthesis] = ACTIONS(1462),
    [sym__external_open_brace] = ACTIONS(1464),
    [sym__external_close_brace] = ACTIONS(1587),
  },
  [857] = {
    [sym_function_definition] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_repeat_statement] = STATE(406),
    [sym_braced_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_call] = STATE(406),
    [sym_subset] = STATE(406),
    [sym_subset2] = STATE(406),
    [sym_unary_operator] = STATE(406),
    [sym_binary_operator] = STATE(406),
    [sym_extract_operator] = STATE(406),
    [sym_namespace_operator] = STATE(406),
    [sym_integer] = STATE(406),
    [sym_complex] = STATE(406),
    [sym_float] = STATE(406),
    [sym__float_literal] = STATE(741),
    [sym_string] = STATE(740),
    [sym__single_quoted_string] = STATE(743),
    [sym__double_quoted_string] = STATE(746),
    [sym_na] = STATE(406),
    [sym__expression] = STATE(406),
    [sym__string_or_identifier] = STATE(2136),
    [sym__open_parenthesis] = STATE(934),
    [sym__open_brace] = STATE(853),
    [sym__close_brace] = STATE(900),
    [aux_sym_braced_expression_repeat1] = STATE(761),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1430),
    [anon_sym_function] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_repeat] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [sym__hex_literal] = ACTIONS(1450),
    [sym__number_literal] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [sym_return] = ACTIONS(1454),
    [sym_next] = ACTIONS(1454),
    [sym_break] = ACTIONS(1454),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [sym_null] = ACTIONS(1454),
    [sym_inf] = ACTIONS(1454),
    [sym_nan] = ACTIONS(1454),
    [anon_sym_NA] = ACTIONS(1456),
    [anon_sym_NA_integer_] = ACTIONS(1456),
    [anon_sym_NA_real_] = ACTIONS(1456),
    [anon_sym_NA_complex_] = ACTIONS(1456),
    [anon_sym_NA_character_] = ACTIONS(1456),
    [sym_dots] = ACTIONS(1454),
    [sym_dot_dot_i] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1460),
    [sym__semicolon] = ACTIONS(1460),
    [sym__raw_string_literal] = ACTIONS(1153),
    [sym__external_open_parenthesis] = ACTIONS(1462),
    [sym__external_open_brace] = ACTIONS(1464),
    [sym__external_close_brace] = ACTIONS(1589),
  },
  [858] = {
    [sym_function_definition] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_repeat_statement] = STATE(406),
    [sym_braced_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_call] = STATE(406),
    [sym_subset] = STATE(406),
    [sym_subset2] = STATE(406),
    [sym_unary_operator] = STATE(406),
    [sym_binary_operator] = STATE(406),
    [sym_extract_operator] = STATE(406),
    [sym_namespace_operator] = STATE(406),
    [sym_integer] = STATE(406),
    [sym_complex] = STATE(406),
    [sym_float] = STATE(406),
    [sym__float_literal] = STATE(741),
    [sym_string] = STATE(740),
    [sym__single_quoted_string] = STATE(743),
    [sym__double_quoted_string] = STATE(746),
    [sym_na] = STATE(406),
    [sym__expression] = STATE(406),
    [sym__string_or_identifier] = STATE(2136),
    [sym__open_parenthesis] = STATE(934),
    [sym__open_brace] = STATE(853),
    [sym__close_brace] = STATE(839),
    [aux_sym_braced_expression_repeat1] = STATE(840),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1430),
    [anon_sym_function] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_repeat] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [sym__hex_literal] = ACTIONS(1450),
    [sym__number_literal] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [sym_return] = ACTIONS(1454),
    [sym_next] = ACTIONS(1454),
    [sym_break] = ACTIONS(1454),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [sym_null] = ACTIONS(1454),
    [sym_inf] = ACTIONS(1454),
    [sym_nan] = ACTIONS(1454),
    [anon_sym_NA] = ACTIONS(1456),
    [anon_sym_NA_integer_] = ACTIONS(1456),
    [anon_sym_NA_real_] = ACTIONS(1456),
    [anon_sym_NA_complex_] = ACTIONS(1456),
    [anon_sym_NA_character_] = ACTIONS(1456),
    [sym_dots] = ACTIONS(1454),
    [sym_dot_dot_i] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1460),
    [sym__semicolon] = ACTIONS(1460),
    [sym__raw_string_literal] = ACTIONS(1153),
    [sym__external_open_parenthesis] = ACTIONS(1462),
    [sym__external_open_brace] = ACTIONS(1464),
    [sym__external_close_brace] = ACTIONS(1591),
  },
  [859] = {
    [sym_function_definition] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_repeat_statement] = STATE(406),
    [sym_braced_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_call] = STATE(406),
    [sym_subset] = STATE(406),
    [sym_subset2] = STATE(406),
    [sym_unary_operator] = STATE(406),
    [sym_binary_operator] = STATE(406),
    [sym_extract_operator] = STATE(406),
    [sym_namespace_operator] = STATE(406),
    [sym_integer] = STATE(406),
    [sym_complex] = STATE(406),
    [sym_float] = STATE(406),
    [sym__float_literal] = STATE(741),
    [sym_string] = STATE(740),
    [sym__single_quoted_string] = STATE(743),
    [sym__double_quoted_string] = STATE(746),
    [sym_na] = STATE(406),
    [sym__expression] = STATE(406),
    [sym__string_or_identifier] = STATE(2136),
    [sym__open_parenthesis] = STATE(934),
    [sym__open_brace] = STATE(853),
    [sym__close_brace] = STATE(893),
    [aux_sym_braced_expression_repeat1] = STATE(894),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1430),
    [anon_sym_function] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_repeat] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [sym__hex_literal] = ACTIONS(1450),
    [sym__number_literal] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [sym_return] = ACTIONS(1454),
    [sym_next] = ACTIONS(1454),
    [sym_break] = ACTIONS(1454),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [sym_null] = ACTIONS(1454),
    [sym_inf] = ACTIONS(1454),
    [sym_nan] = ACTIONS(1454),
    [anon_sym_NA] = ACTIONS(1456),
    [anon_sym_NA_integer_] = ACTIONS(1456),
    [anon_sym_NA_real_] = ACTIONS(1456),
    [anon_sym_NA_complex_] = ACTIONS(1456),
    [anon_sym_NA_character_] = ACTIONS(1456),
    [sym_dots] = ACTIONS(1454),
    [sym_dot_dot_i] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1460),
    [sym__semicolon] = ACTIONS(1460),
    [sym__raw_string_literal] = ACTIONS(1153),
    [sym__external_open_parenthesis] = ACTIONS(1462),
    [sym__external_open_brace] = ACTIONS(1464),
    [sym__external_close_brace] = ACTIONS(1593),
  },
  [860] = {
    [sym_identifier] = ACTIONS(1500),
    [anon_sym_BSLASH] = ACTIONS(1502),
    [anon_sym_function] = ACTIONS(1500),
    [anon_sym_EQ] = ACTIONS(1500),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_for] = ACTIONS(1500),
    [anon_sym_while] = ACTIONS(1500),
    [anon_sym_repeat] = ACTIONS(1500),
    [anon_sym_QMARK] = ACTIONS(1502),
    [anon_sym_TILDE] = ACTIONS(1502),
    [anon_sym_BANG] = ACTIONS(1500),
    [anon_sym_PLUS] = ACTIONS(1502),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_LT_DASH] = ACTIONS(1502),
    [anon_sym_LT_LT_DASH] = ACTIONS(1502),
    [anon_sym_COLON_EQ] = ACTIONS(1502),
    [anon_sym_DASH_GT] = ACTIONS(1500),
    [anon_sym_DASH_GT_GT] = ACTIONS(1502),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_AMP] = ACTIONS(1500),
    [anon_sym_PIPE_PIPE] = ACTIONS(1502),
    [anon_sym_AMP_AMP] = ACTIONS(1502),
    [anon_sym_LT] = ACTIONS(1500),
    [anon_sym_LT_EQ] = ACTIONS(1502),
    [anon_sym_GT] = ACTIONS(1500),
    [anon_sym_GT_EQ] = ACTIONS(1502),
    [anon_sym_EQ_EQ] = ACTIONS(1502),
    [anon_sym_BANG_EQ] = ACTIONS(1502),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1502),
    [anon_sym_STAR_STAR] = ACTIONS(1502),
    [anon_sym_CARET] = ACTIONS(1502),
    [aux_sym_binary_operator_token1] = ACTIONS(1502),
    [anon_sym_PIPE_GT] = ACTIONS(1502),
    [anon_sym_COLON] = ACTIONS(1500),
    [anon_sym_DOLLAR] = ACTIONS(1502),
    [anon_sym_AT] = ACTIONS(1502),
    [sym__hex_literal] = ACTIONS(1502),
    [sym__number_literal] = ACTIONS(1500),
    [anon_sym_SQUOTE] = ACTIONS(1502),
    [anon_sym_DQUOTE] = ACTIONS(1502),
    [sym_return] = ACTIONS(1500),
    [sym_next] = ACTIONS(1500),
    [sym_break] = ACTIONS(1500),
    [sym_true] = ACTIONS(1500),
    [sym_false] = ACTIONS(1500),
    [sym_null] = ACTIONS(1500),
    [sym_inf] = ACTIONS(1500),
    [sym_nan] = ACTIONS(1500),
    [anon_sym_NA] = ACTIONS(1500),
    [anon_sym_NA_integer_] = ACTIONS(1500),
    [anon_sym_NA_real_] = ACTIONS(1500),
    [anon_sym_NA_complex_] = ACTIONS(1500),
    [anon_sym_NA_character_] = ACTIONS(1500),
    [sym_dots] = ACTIONS(1500),
    [sym_dot_dot_i] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1502),
    [sym__newline] = ACTIONS(1502),
    [sym__raw_string_literal] = ACTIONS(1502),
    [sym__external_else] = ACTIONS(1502),
    [sym__external_open_parenthesis] = ACTIONS(1502),
    [sym__external_close_parenthesis] = ACTIONS(1502),
    [sym__external_open_brace] = ACTIONS(1502),
    [sym__external_open_bracket] = ACTIONS(1502),
    [sym__external_open_bracket2] = ACTIONS(1502),
  },
  [861] = {
    [sym_function_definition] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_repeat_statement] = STATE(406),
    [sym_braced_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_call] = STATE(406),
    [sym_subset] = STATE(406),
    [sym_subset2] = STATE(406),
    [sym_unary_operator] = STATE(406),
    [sym_binary_operator] = STATE(406),
    [sym_extract_operator] = STATE(406),
    [sym_namespace_operator] = STATE(406),
    [sym_integer] = STATE(406),
    [sym_complex] = STATE(406),
    [sym_float] = STATE(406),
    [sym__float_literal] = STATE(741),
    [sym_string] = STATE(740),
    [sym__single_quoted_string] = STATE(743),
    [sym__double_quoted_string] = STATE(746),
    [sym_na] = STATE(406),
    [sym__expression] = STATE(406),
    [sym__string_or_identifier] = STATE(2136),
    [sym__open_parenthesis] = STATE(934),
    [sym__open_brace] = STATE(853),
    [sym__close_brace] = STATE(850),
    [aux_sym_braced_expression_repeat1] = STATE(851),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1430),
    [anon_sym_function] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_repeat] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [sym__hex_literal] = ACTIONS(1450),
    [sym__number_literal] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [sym_return] = ACTIONS(1454),
    [sym_next] = ACTIONS(1454),
    [sym_break] = ACTIONS(1454),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [sym_null] = ACTIONS(1454),
    [sym_inf] = ACTIONS(1454),
    [sym_nan] = ACTIONS(1454),
    [anon_sym_NA] = ACTIONS(1456),
    [anon_sym_NA_integer_] = ACTIONS(1456),
    [anon_sym_NA_real_] = ACTIONS(1456),
    [anon_sym_NA_complex_] = ACTIONS(1456),
    [anon_sym_NA_character_] = ACTIONS(1456),
    [sym_dots] = ACTIONS(1454),
    [sym_dot_dot_i] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1460),
    [sym__semicolon] = ACTIONS(1460),
    [sym__raw_string_literal] = ACTIONS(1153),
    [sym__external_open_parenthesis] = ACTIONS(1462),
    [sym__external_open_brace] = ACTIONS(1464),
    [sym__external_close_brace] = ACTIONS(1595),
  },
  [862] = {
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_BSLASH] = ACTIONS(1506),
    [anon_sym_function] = ACTIONS(1504),
    [anon_sym_EQ] = ACTIONS(1504),
    [anon_sym_if] = ACTIONS(1504),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1504),
    [anon_sym_repeat] = ACTIONS(1504),
    [anon_sym_QMARK] = ACTIONS(1506),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_BANG] = ACTIONS(1504),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1504),
    [anon_sym_LT_DASH] = ACTIONS(1506),
    [anon_sym_LT_LT_DASH] = ACTIONS(1506),
    [anon_sym_COLON_EQ] = ACTIONS(1506),
    [anon_sym_DASH_GT] = ACTIONS(1504),
    [anon_sym_DASH_GT_GT] = ACTIONS(1506),
    [anon_sym_PIPE] = ACTIONS(1504),
    [anon_sym_AMP] = ACTIONS(1504),
    [anon_sym_PIPE_PIPE] = ACTIONS(1506),
    [anon_sym_AMP_AMP] = ACTIONS(1506),
    [anon_sym_LT] = ACTIONS(1504),
    [anon_sym_LT_EQ] = ACTIONS(1506),
    [anon_sym_GT] = ACTIONS(1504),
    [anon_sym_GT_EQ] = ACTIONS(1506),
    [anon_sym_EQ_EQ] = ACTIONS(1506),
    [anon_sym_BANG_EQ] = ACTIONS(1506),
    [anon_sym_STAR] = ACTIONS(1504),
    [anon_sym_SLASH] = ACTIONS(1506),
    [anon_sym_STAR_STAR] = ACTIONS(1506),
    [anon_sym_CARET] = ACTIONS(1506),
    [aux_sym_binary_operator_token1] = ACTIONS(1506),
    [anon_sym_PIPE_GT] = ACTIONS(1506),
    [anon_sym_COLON] = ACTIONS(1504),
    [anon_sym_DOLLAR] = ACTIONS(1506),
    [anon_sym_AT] = ACTIONS(1506),
    [sym__hex_literal] = ACTIONS(1506),
    [sym__number_literal] = ACTIONS(1504),
    [anon_sym_SQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1506),
    [sym_return] = ACTIONS(1504),
    [sym_next] = ACTIONS(1504),
    [sym_break] = ACTIONS(1504),
    [sym_true] = ACTIONS(1504),
    [sym_false] = ACTIONS(1504),
    [sym_null] = ACTIONS(1504),
    [sym_inf] = ACTIONS(1504),
    [sym_nan] = ACTIONS(1504),
    [anon_sym_NA] = ACTIONS(1504),
    [anon_sym_NA_integer_] = ACTIONS(1504),
    [anon_sym_NA_real_] = ACTIONS(1504),
    [anon_sym_NA_complex_] = ACTIONS(1504),
    [anon_sym_NA_character_] = ACTIONS(1504),
    [sym_dots] = ACTIONS(1504),
    [sym_dot_dot_i] = ACTIONS(1506),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1506),
    [sym__newline] = ACTIONS(1506),
    [sym__raw_string_literal] = ACTIONS(1506),
    [sym__external_else] = ACTIONS(1506),
    [sym__external_open_parenthesis] = ACTIONS(1506),
    [sym__external_close_parenthesis] = ACTIONS(1506),
    [sym__external_open_brace] = ACTIONS(1506),
    [sym__external_open_bracket] = ACTIONS(1506),
    [sym__external_open_bracket2] = ACTIONS(1506),
  },
  [863] = {
    [sym_identifier] = ACTIONS(1508),
    [anon_sym_BSLASH] = ACTIONS(1510),
    [anon_sym_function] = ACTIONS(1508),
    [anon_sym_EQ] = ACTIONS(1508),
    [anon_sym_if] = ACTIONS(1508),
    [anon_sym_for] = ACTIONS(1508),
    [anon_sym_while] = ACTIONS(1508),
    [anon_sym_repeat] = ACTIONS(1508),
    [anon_sym_QMARK] = ACTIONS(1510),
    [anon_sym_TILDE] = ACTIONS(1510),
    [anon_sym_BANG] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1510),
    [anon_sym_DASH] = ACTIONS(1508),
    [anon_sym_LT_DASH] = ACTIONS(1510),
    [anon_sym_LT_LT_DASH] = ACTIONS(1510),
    [anon_sym_COLON_EQ] = ACTIONS(1510),
    [anon_sym_DASH_GT] = ACTIONS(1508),
    [anon_sym_DASH_GT_GT] = ACTIONS(1510),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PIPE_PIPE] = ACTIONS(1510),
    [anon_sym_AMP_AMP] = ACTIONS(1510),
    [anon_sym_LT] = ACTIONS(1508),
    [anon_sym_LT_EQ] = ACTIONS(1510),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_GT_EQ] = ACTIONS(1510),
    [anon_sym_EQ_EQ] = ACTIONS(1510),
    [anon_sym_BANG_EQ] = ACTIONS(1510),
    [anon_sym_STAR] = ACTIONS(1508),
    [anon_sym_SLASH] = ACTIONS(1510),
    [anon_sym_STAR_STAR] = ACTIONS(1510),
    [anon_sym_CARET] = ACTIONS(1510),
    [aux_sym_binary_operator_token1] = ACTIONS(1510),
    [anon_sym_PIPE_GT] = ACTIONS(1510),
    [anon_sym_COLON] = ACTIONS(1508),
    [anon_sym_DOLLAR] = ACTIONS(1510),
    [anon_sym_AT] = ACTIONS(1510),
    [sym__hex_literal] = ACTIONS(1510),
    [sym__number_literal] = ACTIONS(1508),
    [anon_sym_SQUOTE] = ACTIONS(1510),
    [anon_sym_DQUOTE] = ACTIONS(1510),
    [sym_return] = ACTIONS(1508),
    [sym_next] = ACTIONS(1508),
    [sym_break] = ACTIONS(1508),
    [sym_true] = ACTIONS(1508),
    [sym_false] = ACTIONS(1508),
    [sym_null] = ACTIONS(1508),
    [sym_inf] = ACTIONS(1508),
    [sym_nan] = ACTIONS(1508),
    [anon_sym_NA] = ACTIONS(1508),
    [anon_sym_NA_integer_] = ACTIONS(1508),
    [anon_sym_NA_real_] = ACTIONS(1508),
    [anon_sym_NA_complex_] = ACTIONS(1508),
    [anon_sym_NA_character_] = ACTIONS(1508),
    [sym_dots] = ACTIONS(1508),
    [sym_dot_dot_i] = ACTIONS(1510),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1510),
    [sym__newline] = ACTIONS(1510),
    [sym__raw_string_literal] = ACTIONS(1510),
    [sym__external_else] = ACTIONS(1510),
    [sym__external_open_parenthesis] = ACTIONS(1510),
    [sym__external_close_parenthesis] = ACTIONS(1510),
    [sym__external_open_brace] = ACTIONS(1510),
    [sym__external_open_bracket] = ACTIONS(1510),
    [sym__external_open_bracket2] = ACTIONS(1510),
  },
  [864] = {
    [sym_function_definition] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_repeat_statement] = STATE(406),
    [sym_braced_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_call] = STATE(406),
    [sym_subset] = STATE(406),
    [sym_subset2] = STATE(406),
    [sym_unary_operator] = STATE(406),
    [sym_binary_operator] = STATE(406),
    [sym_extract_operator] = STATE(406),
    [sym_namespace_operator] = STATE(406),
    [sym_integer] = STATE(406),
    [sym_complex] = STATE(406),
    [sym_float] = STATE(406),
    [sym__float_literal] = STATE(741),
    [sym_string] = STATE(740),
    [sym__single_quoted_string] = STATE(743),
    [sym__double_quoted_string] = STATE(746),
    [sym_na] = STATE(406),
    [sym__expression] = STATE(406),
    [sym__string_or_identifier] = STATE(2136),
    [sym__open_parenthesis] = STATE(934),
    [sym__open_brace] = STATE(853),
    [sym__close_brace] = STATE(816),
    [aux_sym_braced_expression_repeat1] = STATE(837),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1430),
    [anon_sym_function] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_repeat] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [sym__hex_literal] = ACTIONS(1450),
    [sym__number_literal] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [sym_return] = ACTIONS(1454),
    [sym_next] = ACTIONS(1454),
    [sym_break] = ACTIONS(1454),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [sym_null] = ACTIONS(1454),
    [sym_inf] = ACTIONS(1454),
    [sym_nan] = ACTIONS(1454),
    [anon_sym_NA] = ACTIONS(1456),
    [anon_sym_NA_integer_] = ACTIONS(1456),
    [anon_sym_NA_real_] = ACTIONS(1456),
    [anon_sym_NA_complex_] = ACTIONS(1456),
    [anon_sym_NA_character_] = ACTIONS(1456),
    [sym_dots] = ACTIONS(1454),
    [sym_dot_dot_i] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1460),
    [sym__semicolon] = ACTIONS(1460),
    [sym__raw_string_literal] = ACTIONS(1153),
    [sym__external_open_parenthesis] = ACTIONS(1462),
    [sym__external_open_brace] = ACTIONS(1464),
    [sym__external_close_brace] = ACTIONS(1597),
  },
  [865] = {
    [sym_identifier] = ACTIONS(1515),
    [anon_sym_BSLASH] = ACTIONS(1517),
    [anon_sym_function] = ACTIONS(1515),
    [anon_sym_EQ] = ACTIONS(1515),
    [anon_sym_if] = ACTIONS(1515),
    [anon_sym_for] = ACTIONS(1515),
    [anon_sym_while] = ACTIONS(1515),
    [anon_sym_repeat] = ACTIONS(1515),
    [anon_sym_QMARK] = ACTIONS(1517),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_DASH] = ACTIONS(1515),
    [anon_sym_LT_DASH] = ACTIONS(1517),
    [anon_sym_LT_LT_DASH] = ACTIONS(1517),
    [anon_sym_COLON_EQ] = ACTIONS(1517),
    [anon_sym_DASH_GT] = ACTIONS(1515),
    [anon_sym_DASH_GT_GT] = ACTIONS(1517),
    [anon_sym_PIPE] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_PIPE_PIPE] = ACTIONS(1517),
    [anon_sym_AMP_AMP] = ACTIONS(1517),
    [anon_sym_LT] = ACTIONS(1515),
    [anon_sym_LT_EQ] = ACTIONS(1517),
    [anon_sym_GT] = ACTIONS(1515),
    [anon_sym_GT_EQ] = ACTIONS(1517),
    [anon_sym_EQ_EQ] = ACTIONS(1517),
    [anon_sym_BANG_EQ] = ACTIONS(1517),
    [anon_sym_STAR] = ACTIONS(1515),
    [anon_sym_SLASH] = ACTIONS(1517),
    [anon_sym_STAR_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [aux_sym_binary_operator_token1] = ACTIONS(1517),
    [anon_sym_PIPE_GT] = ACTIONS(1517),
    [anon_sym_COLON] = ACTIONS(1515),
    [anon_sym_DOLLAR] = ACTIONS(1517),
    [anon_sym_AT] = ACTIONS(1517),
    [sym__hex_literal] = ACTIONS(1517),
    [sym__number_literal] = ACTIONS(1515),
    [anon_sym_SQUOTE] = ACTIONS(1517),
    [anon_sym_DQUOTE] = ACTIONS(1517),
    [sym_return] = ACTIONS(1515),
    [sym_next] = ACTIONS(1515),
    [sym_break] = ACTIONS(1515),
    [sym_true] = ACTIONS(1515),
    [sym_false] = ACTIONS(1515),
    [sym_null] = ACTIONS(1515),
    [sym_inf] = ACTIONS(1515),
    [sym_nan] = ACTIONS(1515),
    [anon_sym_NA] = ACTIONS(1515),
    [anon_sym_NA_integer_] = ACTIONS(1515),
    [anon_sym_NA_real_] = ACTIONS(1515),
    [anon_sym_NA_complex_] = ACTIONS(1515),
    [anon_sym_NA_character_] = ACTIONS(1515),
    [sym_dots] = ACTIONS(1515),
    [sym_dot_dot_i] = ACTIONS(1517),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1517),
    [sym__newline] = ACTIONS(1517),
    [sym__raw_string_literal] = ACTIONS(1517),
    [sym__external_else] = ACTIONS(1517),
    [sym__external_open_parenthesis] = ACTIONS(1517),
    [sym__external_close_parenthesis] = ACTIONS(1517),
    [sym__external_open_brace] = ACTIONS(1517),
    [sym__external_open_bracket] = ACTIONS(1517),
    [sym__external_open_bracket2] = ACTIONS(1517),
  },
  [866] = {
    [sym_identifier] = ACTIONS(1519),
    [anon_sym_BSLASH] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(1519),
    [anon_sym_EQ] = ACTIONS(1519),
    [anon_sym_if] = ACTIONS(1519),
    [anon_sym_for] = ACTIONS(1519),
    [anon_sym_while] = ACTIONS(1519),
    [anon_sym_repeat] = ACTIONS(1519),
    [anon_sym_QMARK] = ACTIONS(1521),
    [anon_sym_TILDE] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1519),
    [anon_sym_PLUS] = ACTIONS(1521),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_LT_DASH] = ACTIONS(1521),
    [anon_sym_LT_LT_DASH] = ACTIONS(1521),
    [anon_sym_COLON_EQ] = ACTIONS(1521),
    [anon_sym_DASH_GT] = ACTIONS(1519),
    [anon_sym_DASH_GT_GT] = ACTIONS(1521),
    [anon_sym_PIPE] = ACTIONS(1519),
    [anon_sym_AMP] = ACTIONS(1519),
    [anon_sym_PIPE_PIPE] = ACTIONS(1521),
    [anon_sym_AMP_AMP] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_LT_EQ] = ACTIONS(1521),
    [anon_sym_GT] = ACTIONS(1519),
    [anon_sym_GT_EQ] = ACTIONS(1521),
    [anon_sym_EQ_EQ] = ACTIONS(1521),
    [anon_sym_BANG_EQ] = ACTIONS(1521),
    [anon_sym_STAR] = ACTIONS(1519),
    [anon_sym_SLASH] = ACTIONS(1521),
    [anon_sym_STAR_STAR] = ACTIONS(1521),
    [anon_sym_CARET] = ACTIONS(1521),
    [aux_sym_binary_operator_token1] = ACTIONS(1521),
    [anon_sym_PIPE_GT] = ACTIONS(1521),
    [anon_sym_COLON] = ACTIONS(1519),
    [anon_sym_DOLLAR] = ACTIONS(1521),
    [anon_sym_AT] = ACTIONS(1521),
    [sym__hex_literal] = ACTIONS(1521),
    [sym__number_literal] = ACTIONS(1519),
    [anon_sym_SQUOTE] = ACTIONS(1521),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [sym_return] = ACTIONS(1519),
    [sym_next] = ACTIONS(1519),
    [sym_break] = ACTIONS(1519),
    [sym_true] = ACTIONS(1519),
    [sym_false] = ACTIONS(1519),
    [sym_null] = ACTIONS(1519),
    [sym_inf] = ACTIONS(1519),
    [sym_nan] = ACTIONS(1519),
    [anon_sym_NA] = ACTIONS(1519),
    [anon_sym_NA_integer_] = ACTIONS(1519),
    [anon_sym_NA_real_] = ACTIONS(1519),
    [anon_sym_NA_complex_] = ACTIONS(1519),
    [anon_sym_NA_character_] = ACTIONS(1519),
    [sym_dots] = ACTIONS(1519),
    [sym_dot_dot_i] = ACTIONS(1521),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1521),
    [sym__newline] = ACTIONS(1521),
    [sym__raw_string_literal] = ACTIONS(1521),
    [sym__external_else] = ACTIONS(1521),
    [sym__external_open_parenthesis] = ACTIONS(1521),
    [sym__external_close_parenthesis] = ACTIONS(1521),
    [sym__external_open_brace] = ACTIONS(1521),
    [sym__external_open_bracket] = ACTIONS(1521),
    [sym__external_open_bracket2] = ACTIONS(1521),
  },
  [867] = {
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_BSLASH] = ACTIONS(1525),
    [anon_sym_function] = ACTIONS(1523),
    [anon_sym_EQ] = ACTIONS(1523),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_for] = ACTIONS(1523),
    [anon_sym_while] = ACTIONS(1523),
    [anon_sym_repeat] = ACTIONS(1523),
    [anon_sym_QMARK] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(1525),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1523),
    [anon_sym_LT_DASH] = ACTIONS(1525),
    [anon_sym_LT_LT_DASH] = ACTIONS(1525),
    [anon_sym_COLON_EQ] = ACTIONS(1525),
    [anon_sym_DASH_GT] = ACTIONS(1523),
    [anon_sym_DASH_GT_GT] = ACTIONS(1525),
    [anon_sym_PIPE] = ACTIONS(1523),
    [anon_sym_AMP] = ACTIONS(1523),
    [anon_sym_PIPE_PIPE] = ACTIONS(1525),
    [anon_sym_AMP_AMP] = ACTIONS(1525),
    [anon_sym_LT] = ACTIONS(1523),
    [anon_sym_LT_EQ] = ACTIONS(1525),
    [anon_sym_GT] = ACTIONS(1523),
    [anon_sym_GT_EQ] = ACTIONS(1525),
    [anon_sym_EQ_EQ] = ACTIONS(1525),
    [anon_sym_BANG_EQ] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1523),
    [anon_sym_SLASH] = ACTIONS(1525),
    [anon_sym_STAR_STAR] = ACTIONS(1525),
    [anon_sym_CARET] = ACTIONS(1525),
    [aux_sym_binary_operator_token1] = ACTIONS(1525),
    [anon_sym_PIPE_GT] = ACTIONS(1525),
    [anon_sym_COLON] = ACTIONS(1523),
    [anon_sym_DOLLAR] = ACTIONS(1525),
    [anon_sym_AT] = ACTIONS(1525),
    [sym__hex_literal] = ACTIONS(1525),
    [sym__number_literal] = ACTIONS(1523),
    [anon_sym_SQUOTE] = ACTIONS(1525),
    [anon_sym_DQUOTE] = ACTIONS(1525),
    [sym_return] = ACTIONS(1523),
    [sym_next] = ACTIONS(1523),
    [sym_break] = ACTIONS(1523),
    [sym_true] = ACTIONS(1523),
    [sym_false] = ACTIONS(1523),
    [sym_null] = ACTIONS(1523),
    [sym_inf] = ACTIONS(1523),
    [sym_nan] = ACTIONS(1523),
    [anon_sym_NA] = ACTIONS(1523),
    [anon_sym_NA_integer_] = ACTIONS(1523),
    [anon_sym_NA_real_] = ACTIONS(1523),
    [anon_sym_NA_complex_] = ACTIONS(1523),
    [anon_sym_NA_character_] = ACTIONS(1523),
    [sym_dots] = ACTIONS(1523),
    [sym_dot_dot_i] = ACTIONS(1525),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1525),
    [sym__newline] = ACTIONS(1525),
    [sym__raw_string_literal] = ACTIONS(1525),
    [sym__external_else] = ACTIONS(1525),
    [sym__external_open_parenthesis] = ACTIONS(1525),
    [sym__external_close_parenthesis] = ACTIONS(1525),
    [sym__external_open_brace] = ACTIONS(1525),
    [sym__external_open_bracket] = ACTIONS(1525),
    [sym__external_open_bracket2] = ACTIONS(1525),
  },
  [868] = {
    [sym_function_definition] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_repeat_statement] = STATE(406),
    [sym_braced_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_call] = STATE(406),
    [sym_subset] = STATE(406),
    [sym_subset2] = STATE(406),
    [sym_unary_operator] = STATE(406),
    [sym_binary_operator] = STATE(406),
    [sym_extract_operator] = STATE(406),
    [sym_namespace_operator] = STATE(406),
    [sym_integer] = STATE(406),
    [sym_complex] = STATE(406),
    [sym_float] = STATE(406),
    [sym__float_literal] = STATE(741),
    [sym_string] = STATE(740),
    [sym__single_quoted_string] = STATE(743),
    [sym__double_quoted_string] = STATE(746),
    [sym_na] = STATE(406),
    [sym__expression] = STATE(406),
    [sym__string_or_identifier] = STATE(2136),
    [sym__open_parenthesis] = STATE(934),
    [sym__open_brace] = STATE(853),
    [sym__close_brace] = STATE(1968),
    [aux_sym_braced_expression_repeat1] = STATE(841),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1430),
    [anon_sym_function] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_repeat] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [sym__hex_literal] = ACTIONS(1450),
    [sym__number_literal] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [sym_return] = ACTIONS(1454),
    [sym_next] = ACTIONS(1454),
    [sym_break] = ACTIONS(1454),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [sym_null] = ACTIONS(1454),
    [sym_inf] = ACTIONS(1454),
    [sym_nan] = ACTIONS(1454),
    [anon_sym_NA] = ACTIONS(1456),
    [anon_sym_NA_integer_] = ACTIONS(1456),
    [anon_sym_NA_real_] = ACTIONS(1456),
    [anon_sym_NA_complex_] = ACTIONS(1456),
    [anon_sym_NA_character_] = ACTIONS(1456),
    [sym_dots] = ACTIONS(1454),
    [sym_dot_dot_i] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1460),
    [sym__semicolon] = ACTIONS(1460),
    [sym__raw_string_literal] = ACTIONS(1153),
    [sym__external_open_parenthesis] = ACTIONS(1462),
    [sym__external_open_brace] = ACTIONS(1464),
    [sym__external_close_brace] = ACTIONS(1599),
  },
  [869] = {
    [sym_identifier] = ACTIONS(1527),
    [anon_sym_BSLASH] = ACTIONS(1529),
    [anon_sym_function] = ACTIONS(1527),
    [anon_sym_EQ] = ACTIONS(1527),
    [anon_sym_if] = ACTIONS(1527),
    [anon_sym_for] = ACTIONS(1527),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_repeat] = ACTIONS(1527),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_TILDE] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1527),
    [anon_sym_LT_DASH] = ACTIONS(1529),
    [anon_sym_LT_LT_DASH] = ACTIONS(1529),
    [anon_sym_COLON_EQ] = ACTIONS(1529),
    [anon_sym_DASH_GT] = ACTIONS(1527),
    [anon_sym_DASH_GT_GT] = ACTIONS(1529),
    [anon_sym_PIPE] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1527),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1527),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1529),
    [anon_sym_BANG_EQ] = ACTIONS(1529),
    [anon_sym_STAR] = ACTIONS(1527),
    [anon_sym_SLASH] = ACTIONS(1529),
    [anon_sym_STAR_STAR] = ACTIONS(1529),
    [anon_sym_CARET] = ACTIONS(1529),
    [aux_sym_binary_operator_token1] = ACTIONS(1529),
    [anon_sym_PIPE_GT] = ACTIONS(1529),
    [anon_sym_COLON] = ACTIONS(1527),
    [anon_sym_DOLLAR] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(1529),
    [sym__hex_literal] = ACTIONS(1529),
    [sym__number_literal] = ACTIONS(1527),
    [anon_sym_SQUOTE] = ACTIONS(1529),
    [anon_sym_DQUOTE] = ACTIONS(1529),
    [sym_return] = ACTIONS(1527),
    [sym_next] = ACTIONS(1527),
    [sym_break] = ACTIONS(1527),
    [sym_true] = ACTIONS(1527),
    [sym_false] = ACTIONS(1527),
    [sym_null] = ACTIONS(1527),
    [sym_inf] = ACTIONS(1527),
    [sym_nan] = ACTIONS(1527),
    [anon_sym_NA] = ACTIONS(1527),
    [anon_sym_NA_integer_] = ACTIONS(1527),
    [anon_sym_NA_real_] = ACTIONS(1527),
    [anon_sym_NA_complex_] = ACTIONS(1527),
    [anon_sym_NA_character_] = ACTIONS(1527),
    [sym_dots] = ACTIONS(1527),
    [sym_dot_dot_i] = ACTIONS(1529),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1529),
    [sym__newline] = ACTIONS(1529),
    [sym__raw_string_literal] = ACTIONS(1529),
    [sym__external_else] = ACTIONS(1529),
    [sym__external_open_parenthesis] = ACTIONS(1529),
    [sym__external_close_parenthesis] = ACTIONS(1529),
    [sym__external_open_brace] = ACTIONS(1529),
    [sym__external_open_bracket] = ACTIONS(1529),
    [sym__external_open_bracket2] = ACTIONS(1529),
  },
  [870] = {
    [sym_identifier] = ACTIONS(1533),
    [anon_sym_BSLASH] = ACTIONS(1531),
    [anon_sym_function] = ACTIONS(1533),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_if] = ACTIONS(1533),
    [anon_sym_for] = ACTIONS(1533),
    [anon_sym_while] = ACTIONS(1533),
    [anon_sym_repeat] = ACTIONS(1533),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_LT_DASH] = ACTIONS(1531),
    [anon_sym_LT_LT_DASH] = ACTIONS(1531),
    [anon_sym_COLON_EQ] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1533),
    [anon_sym_DASH_GT_GT] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1531),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_CARET] = ACTIONS(1531),
    [aux_sym_binary_operator_token1] = ACTIONS(1531),
    [anon_sym_PIPE_GT] = ACTIONS(1531),
    [anon_sym_COLON] = ACTIONS(1533),
    [anon_sym_DOLLAR] = ACTIONS(1531),
    [anon_sym_AT] = ACTIONS(1531),
    [sym__hex_literal] = ACTIONS(1531),
    [sym__number_literal] = ACTIONS(1533),
    [anon_sym_SQUOTE] = ACTIONS(1531),
    [anon_sym_DQUOTE] = ACTIONS(1531),
    [sym_return] = ACTIONS(1533),
    [sym_next] = ACTIONS(1533),
    [sym_break] = ACTIONS(1533),
    [sym_true] = ACTIONS(1533),
    [sym_false] = ACTIONS(1533),
    [sym_null] = ACTIONS(1533),
    [sym_inf] = ACTIONS(1533),
    [sym_nan] = ACTIONS(1533),
    [anon_sym_NA] = ACTIONS(1533),
    [anon_sym_NA_integer_] = ACTIONS(1533),
    [anon_sym_NA_real_] = ACTIONS(1533),
    [anon_sym_NA_complex_] = ACTIONS(1533),
    [anon_sym_NA_character_] = ACTIONS(1533),
    [sym_dots] = ACTIONS(1533),
    [sym_dot_dot_i] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1531),
    [sym__semicolon] = ACTIONS(1531),
    [sym__raw_string_literal] = ACTIONS(1531),
    [sym__external_else] = ACTIONS(1531),
    [sym__external_open_parenthesis] = ACTIONS(1531),
    [sym__external_open_brace] = ACTIONS(1531),
    [sym__external_close_brace] = ACTIONS(1531),
    [sym__external_open_bracket] = ACTIONS(1531),
    [sym__external_open_bracket2] = ACTIONS(1531),
  },
  [871] = {
    [sym_function_definition] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_repeat_statement] = STATE(406),
    [sym_braced_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_call] = STATE(406),
    [sym_subset] = STATE(406),
    [sym_subset2] = STATE(406),
    [sym_unary_operator] = STATE(406),
    [sym_binary_operator] = STATE(406),
    [sym_extract_operator] = STATE(406),
    [sym_namespace_operator] = STATE(406),
    [sym_integer] = STATE(406),
    [sym_complex] = STATE(406),
    [sym_float] = STATE(406),
    [sym__float_literal] = STATE(741),
    [sym_string] = STATE(740),
    [sym__single_quoted_string] = STATE(743),
    [sym__double_quoted_string] = STATE(746),
    [sym_na] = STATE(406),
    [sym__expression] = STATE(406),
    [sym__string_or_identifier] = STATE(2136),
    [sym__open_parenthesis] = STATE(934),
    [sym__open_brace] = STATE(853),
    [sym__close_brace] = STATE(756),
    [aux_sym_braced_expression_repeat1] = STATE(757),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1430),
    [anon_sym_function] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_repeat] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [sym__hex_literal] = ACTIONS(1450),
    [sym__number_literal] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [sym_return] = ACTIONS(1454),
    [sym_next] = ACTIONS(1454),
    [sym_break] = ACTIONS(1454),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [sym_null] = ACTIONS(1454),
    [sym_inf] = ACTIONS(1454),
    [sym_nan] = ACTIONS(1454),
    [anon_sym_NA] = ACTIONS(1456),
    [anon_sym_NA_integer_] = ACTIONS(1456),
    [anon_sym_NA_real_] = ACTIONS(1456),
    [anon_sym_NA_complex_] = ACTIONS(1456),
    [anon_sym_NA_character_] = ACTIONS(1456),
    [sym_dots] = ACTIONS(1454),
    [sym_dot_dot_i] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1460),
    [sym__semicolon] = ACTIONS(1460),
    [sym__raw_string_literal] = ACTIONS(1153),
    [sym__external_open_parenthesis] = ACTIONS(1462),
    [sym__external_open_brace] = ACTIONS(1464),
    [sym__external_close_brace] = ACTIONS(1601),
  },
  [872] = {
    [sym_function_definition] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_repeat_statement] = STATE(406),
    [sym_braced_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_call] = STATE(406),
    [sym_subset] = STATE(406),
    [sym_subset2] = STATE(406),
    [sym_unary_operator] = STATE(406),
    [sym_binary_operator] = STATE(406),
    [sym_extract_operator] = STATE(406),
    [sym_namespace_operator] = STATE(406),
    [sym_integer] = STATE(406),
    [sym_complex] = STATE(406),
    [sym_float] = STATE(406),
    [sym__float_literal] = STATE(741),
    [sym_string] = STATE(740),
    [sym__single_quoted_string] = STATE(743),
    [sym__double_quoted_string] = STATE(746),
    [sym_na] = STATE(406),
    [sym__expression] = STATE(406),
    [sym__string_or_identifier] = STATE(2136),
    [sym__open_parenthesis] = STATE(934),
    [sym__open_brace] = STATE(853),
    [sym__close_brace] = STATE(807),
    [aux_sym_braced_expression_repeat1] = STATE(808),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1430),
    [anon_sym_function] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_repeat] = ACTIONS(1440),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [sym__hex_literal] = ACTIONS(1450),
    [sym__number_literal] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [sym_return] = ACTIONS(1454),
    [sym_next] = ACTIONS(1454),
    [sym_break] = ACTIONS(1454),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [sym_null] = ACTIONS(1454),
    [sym_inf] = ACTIONS(1454),
    [sym_nan] = ACTIONS(1454),
    [anon_sym_NA] = ACTIONS(1456),
    [anon_sym_NA_integer_] = ACTIONS(1456),
    [anon_sym_NA_real_] = ACTIONS(1456),
    [anon_sym_NA_complex_] = ACTIONS(1456),
    [anon_sym_NA_character_] = ACTIONS(1456),
    [sym_dots] = ACTIONS(1454),
    [sym_dot_dot_i] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1460),
    [sym__semicolon] = ACTIONS(1460),
    [sym__raw_string_literal] = ACTIONS(1153),
    [sym__external_open_parenthesis] = ACTIONS(1462),
    [sym__external_open_brace] = ACTIONS(1464),
    [sym__external_close_brace] = ACTIONS(1603),
  },
  [873] = {
    [sym_identifier] = ACTIONS(1535),
    [anon_sym_BSLASH] = ACTIONS(1537),
    [anon_sym_function] = ACTIONS(1535),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_if] = ACTIONS(1535),
    [anon_sym_for] = ACTIONS(1535),
    [anon_sym_while] = ACTIONS(1535),
    [anon_sym_repeat] = ACTIONS(1535),
    [anon_sym_QMARK] = ACTIONS(1537),
    [anon_sym_TILDE] = ACTIONS(1537),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1535),
    [anon_sym_LT_DASH] = ACTIONS(1537),
    [anon_sym_LT_LT_DASH] = ACTIONS(1537),
    [anon_sym_COLON_EQ] = ACTIONS(1537),
    [anon_sym_DASH_GT] = ACTIONS(1535),
    [anon_sym_DASH_GT_GT] = ACTIONS(1537),
    [anon_sym_PIPE] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_PIPE_PIPE] = ACTIONS(1537),
    [anon_sym_AMP_AMP] = ACTIONS(1537),
    [anon_sym_LT] = ACTIONS(1535),
    [anon_sym_LT_EQ] = ACTIONS(1537),
    [anon_sym_GT] = ACTIONS(1535),
    [anon_sym_GT_EQ] = ACTIONS(1537),
    [anon_sym_EQ_EQ] = ACTIONS(1537),
    [anon_sym_BANG_EQ] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_SLASH] = ACTIONS(1537),
    [anon_sym_STAR_STAR] = ACTIONS(1537),
    [anon_sym_CARET] = ACTIONS(1537),
    [aux_sym_binary_operator_token1] = ACTIONS(1537),
    [anon_sym_PIPE_GT] = ACTIONS(1537),
    [anon_sym_COLON] = ACTIONS(1535),
    [anon_sym_DOLLAR] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(1537),
    [sym__hex_literal] = ACTIONS(1537),
    [sym__number_literal] = ACTIONS(1535),
    [anon_sym_SQUOTE] = ACTIONS(1537),
    [anon_sym_DQUOTE] = ACTIONS(1537),
    [sym_return] = ACTIONS(1535),
    [sym_next] = ACTIONS(1535),
    [sym_break] = ACTIONS(1535),
    [sym_true] = ACTIONS(1535),
    [sym_false] = ACTIONS(1535),
    [sym_null] = ACTIONS(1535),
    [sym_inf] = ACTIONS(1535),
    [sym_nan] = ACTIONS(1535),
    [anon_sym_NA] = ACTIONS(1535),
    [anon_sym_NA_integer_] = ACTIONS(1535),
    [anon_sym_NA_real_] = ACTIONS(1535),
    [anon_sym_NA_complex_] = ACTIONS(1535),
    [anon_sym_NA_character_] = ACTIONS(1535),
    [sym_dots] = ACTIONS(1535),
    [sym_dot_dot_i] = ACTIONS(1537),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1537),
    [sym__newline] = ACTIONS(1537),
    [sym__raw_string_literal] = ACTIONS(1537),
    [sym__external_else] = ACTIONS(1537),
    [sym__external_open_parenthesis] = ACTIONS(1537),
    [sym__external_open_brace] = ACTIONS(1537),
    [sym__external_open_bracket] = ACTIONS(1537),
    [sym__external_close_bracket] = ACTIONS(1537),
    [sym__external_open_bracket2] = ACTIONS(1537),
  },
  [874] = {
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_BSLASH] = ACTIONS(1494),
    [anon_sym_function] = ACTIONS(1492),
    [anon_sym_EQ] = ACTIONS(1492),
    [anon_sym_if] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(1492),
    [anon_sym_while] = ACTIONS(1492),
    [anon_sym_repeat] = ACTIONS(1492),
    [anon_sym_QMARK] = ACTIONS(1494),
    [anon_sym_TILDE] = ACTIONS(1494),
    [anon_sym_BANG] = ACTIONS(1492),
    [anon_sym_PLUS] = ACTIONS(1494),
    [anon_sym_DASH] = ACTIONS(1492),
    [anon_sym_LT_DASH] = ACTIONS(1494),
    [anon_sym_LT_LT_DASH] = ACTIONS(1494),
    [anon_sym_COLON_EQ] = ACTIONS(1494),
    [anon_sym_DASH_GT] = ACTIONS(1492),
    [anon_sym_DASH_GT_GT] = ACTIONS(1494),
    [anon_sym_PIPE] = ACTIONS(1492),
    [anon_sym_AMP] = ACTIONS(1492),
    [anon_sym_PIPE_PIPE] = ACTIONS(1494),
    [anon_sym_AMP_AMP] = ACTIONS(1494),
    [anon_sym_LT] = ACTIONS(1492),
    [anon_sym_LT_EQ] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1492),
    [anon_sym_GT_EQ] = ACTIONS(1494),
    [anon_sym_EQ_EQ] = ACTIONS(1494),
    [anon_sym_BANG_EQ] = ACTIONS(1494),
    [anon_sym_STAR] = ACTIONS(1492),
    [anon_sym_SLASH] = ACTIONS(1494),
    [anon_sym_STAR_STAR] = ACTIONS(1494),
    [anon_sym_CARET] = ACTIONS(1494),
    [aux_sym_binary_operator_token1] = ACTIONS(1494),
    [anon_sym_PIPE_GT] = ACTIONS(1494),
    [anon_sym_COLON] = ACTIONS(1492),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [anon_sym_AT] = ACTIONS(1494),
    [sym__hex_literal] = ACTIONS(1494),
    [sym__number_literal] = ACTIONS(1492),
    [anon_sym_SQUOTE] = ACTIONS(1494),
    [anon_sym_DQUOTE] = ACTIONS(1494),
    [sym_return] = ACTIONS(1492),
    [sym_next] = ACTIONS(1492),
    [sym_break] = ACTIONS(1492),
    [sym_true] = ACTIONS(1492),
    [sym_false] = ACTIONS(1492),
    [sym_null] = ACTIONS(1492),
    [sym_inf] = ACTIONS(1492),
    [sym_nan] = ACTIONS(1492),
    [anon_sym_NA] = ACTIONS(1492),
    [anon_sym_NA_integer_] = ACTIONS(1492),
    [anon_sym_NA_real_] = ACTIONS(1492),
    [anon_sym_NA_complex_] = ACTIONS(1492),
    [anon_sym_NA_character_] = ACTIONS(1492),
    [sym_dots] = ACTIONS(1492),
    [sym_dot_dot_i] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1494),
    [sym__semicolon] = ACTIONS(1494),
    [sym__raw_string_literal] = ACTIONS(1494),
    [sym__external_else] = ACTIONS(1494),
    [sym__external_open_parenthesis] = ACTIONS(1494),
    [sym__external_open_brace] = ACTIONS(1494),
    [sym__external_close_brace] = ACTIONS(1494),
    [sym__external_open_bracket] = ACTIONS(1494),
    [sym__external_open_bracket2] = ACTIONS(1494),
  },
  [875] = {
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_BSLASH] = ACTIONS(1494),
    [anon_sym_function] = ACTIONS(1492),
    [anon_sym_EQ] = ACTIONS(1492),
    [anon_sym_if] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(1492),
    [anon_sym_while] = ACTIONS(1492),
    [anon_sym_repeat] = ACTIONS(1492),
    [anon_sym_QMARK] = ACTIONS(1494),
    [anon_sym_TILDE] = ACTIONS(1494),
    [anon_sym_BANG] = ACTIONS(1492),
    [anon_sym_PLUS] = ACTIONS(1494),
    [anon_sym_DASH] = ACTIONS(1492),
    [anon_sym_LT_DASH] = ACTIONS(1494),
    [anon_sym_LT_LT_DASH] = ACTIONS(1494),
    [anon_sym_COLON_EQ] = ACTIONS(1494),
    [anon_sym_DASH_GT] = ACTIONS(1492),
    [anon_sym_DASH_GT_GT] = ACTIONS(1494),
    [anon_sym_PIPE] = ACTIONS(1492),
    [anon_sym_AMP] = ACTIONS(1492),
    [anon_sym_PIPE_PIPE] = ACTIONS(1494),
    [anon_sym_AMP_AMP] = ACTIONS(1494),
    [anon_sym_LT] = ACTIONS(1492),
    [anon_sym_LT_EQ] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1492),
    [anon_sym_GT_EQ] = ACTIONS(1494),
    [anon_sym_EQ_EQ] = ACTIONS(1494),
    [anon_sym_BANG_EQ] = ACTIONS(1494),
    [anon_sym_STAR] = ACTIONS(1492),
    [anon_sym_SLASH] = ACTIONS(1494),
    [anon_sym_STAR_STAR] = ACTIONS(1494),
    [anon_sym_CARET] = ACTIONS(1494),
    [aux_sym_binary_operator_token1] = ACTIONS(1494),
    [anon_sym_PIPE_GT] = ACTIONS(1494),
    [anon_sym_COLON] = ACTIONS(1492),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [anon_sym_AT] = ACTIONS(1494),
    [sym__hex_literal] = ACTIONS(1494),
    [sym__number_literal] = ACTIONS(1492),
    [anon_sym_SQUOTE] = ACTIONS(1494),
    [anon_sym_DQUOTE] = ACTIONS(1494),
    [sym_return] = ACTIONS(1492),
    [sym_next] = ACTIONS(1492),
    [sym_break] = ACTIONS(1492),
    [sym_true] = ACTIONS(1492),
    [sym_false] = ACTIONS(1492),
    [sym_null] = ACTIONS(1492),
    [sym_inf] = ACTIONS(1492),
    [sym_nan] = ACTIONS(1492),
    [anon_sym_NA] = ACTIONS(1492),
    [anon_sym_NA_integer_] = ACTIONS(1492),
    [anon_sym_NA_real_] = ACTIONS(1492),
    [anon_sym_NA_complex_] = ACTIONS(1492),
    [anon_sym_NA_character_] = ACTIONS(1492),
    [sym_dots] = ACTIONS(1492),
    [sym_dot_dot_i] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1494),
    [sym__newline] = ACTIONS(1494),
    [sym__raw_string_literal] = ACTIONS(1494),
    [sym__external_open_parenthesis] = ACTIONS(1494),
    [sym__external_open_brace] = ACTIONS(1494),
    [sym__external_open_bracket] = ACTIONS(1494),
    [sym__external_close_bracket] = ACTIONS(1494),
    [sym__external_open_bracket2] = ACTIONS(1494),
  },
  [876] = {
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_BSLASH] = ACTIONS(1549),
    [anon_sym_function] = ACTIONS(1547),
    [anon_sym_EQ] = ACTIONS(1547),
    [anon_sym_if] = ACTIONS(1547),
    [anon_sym_for] = ACTIONS(1547),
    [anon_sym_while] = ACTIONS(1547),
    [anon_sym_repeat] = ACTIONS(1547),
    [anon_sym_QMARK] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1547),
    [anon_sym_LT_DASH] = ACTIONS(1549),
    [anon_sym_LT_LT_DASH] = ACTIONS(1549),
    [anon_sym_COLON_EQ] = ACTIONS(1549),
    [anon_sym_DASH_GT] = ACTIONS(1547),
    [anon_sym_DASH_GT_GT] = ACTIONS(1549),
    [anon_sym_PIPE] = ACTIONS(1547),
    [anon_sym_AMP] = ACTIONS(1547),
    [anon_sym_PIPE_PIPE] = ACTIONS(1549),
    [anon_sym_AMP_AMP] = ACTIONS(1549),
    [anon_sym_LT] = ACTIONS(1547),
    [anon_sym_LT_EQ] = ACTIONS(1549),
    [anon_sym_GT] = ACTIONS(1547),
    [anon_sym_GT_EQ] = ACTIONS(1549),
    [anon_sym_EQ_EQ] = ACTIONS(1549),
    [anon_sym_BANG_EQ] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_SLASH] = ACTIONS(1549),
    [anon_sym_STAR_STAR] = ACTIONS(1549),
    [anon_sym_CARET] = ACTIONS(1549),
    [aux_sym_binary_operator_token1] = ACTIONS(1549),
    [anon_sym_PIPE_GT] = ACTIONS(1549),
    [anon_sym_COLON] = ACTIONS(1547),
    [anon_sym_DOLLAR] = ACTIONS(1549),
    [anon_sym_AT] = ACTIONS(1549),
    [sym__hex_literal] = ACTIONS(1549),
    [sym__number_literal] = ACTIONS(1547),
    [anon_sym_SQUOTE] = ACTIONS(1549),
    [anon_sym_DQUOTE] = ACTIONS(1549),
    [sym_return] = ACTIONS(1547),
    [sym_next] = ACTIONS(1547),
    [sym_break] = ACTIONS(1547),
    [sym_true] = ACTIONS(1547),
    [sym_false] = ACTIONS(1547),
    [sym_null] = ACTIONS(1547),
    [sym_inf] = ACTIONS(1547),
    [sym_nan] = ACTIONS(1547),
    [anon_sym_NA] = ACTIONS(1547),
    [anon_sym_NA_integer_] = ACTIONS(1547),
    [anon_sym_NA_real_] = ACTIONS(1547),
    [anon_sym_NA_complex_] = ACTIONS(1547),
    [anon_sym_NA_character_] = ACTIONS(1547),
    [sym_dots] = ACTIONS(1547),
    [sym_dot_dot_i] = ACTIONS(1549),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1549),
    [sym__newline] = ACTIONS(1549),
    [sym__raw_string_literal] = ACTIONS(1549),
    [sym__external_open_parenthesis] = ACTIONS(1549),
    [sym__external_open_brace] = ACTIONS(1549),
    [sym__external_open_bracket] = ACTIONS(1549),
    [sym__external_close_bracket] = ACTIONS(1549),
    [sym__external_open_bracket2] = ACTIONS(1549),
  },
  [877] = {
    [sym_identifier] = ACTIONS(1500),
    [anon_sym_BSLASH] = ACTIONS(1502),
    [anon_sym_function] = ACTIONS(1500),
    [anon_sym_EQ] = ACTIONS(1500),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_for] = ACTIONS(1500),
    [anon_sym_while] = ACTIONS(1500),
    [anon_sym_repeat] = ACTIONS(1500),
    [anon_sym_QMARK] = ACTIONS(1502),
    [anon_sym_TILDE] = ACTIONS(1502),
    [anon_sym_BANG] = ACTIONS(1500),
    [anon_sym_PLUS] = ACTIONS(1502),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_LT_DASH] = ACTIONS(1502),
    [anon_sym_LT_LT_DASH] = ACTIONS(1502),
    [anon_sym_COLON_EQ] = ACTIONS(1502),
    [anon_sym_DASH_GT] = ACTIONS(1500),
    [anon_sym_DASH_GT_GT] = ACTIONS(1502),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_AMP] = ACTIONS(1500),
    [anon_sym_PIPE_PIPE] = ACTIONS(1502),
    [anon_sym_AMP_AMP] = ACTIONS(1502),
    [anon_sym_LT] = ACTIONS(1500),
    [anon_sym_LT_EQ] = ACTIONS(1502),
    [anon_sym_GT] = ACTIONS(1500),
    [anon_sym_GT_EQ] = ACTIONS(1502),
    [anon_sym_EQ_EQ] = ACTIONS(1502),
    [anon_sym_BANG_EQ] = ACTIONS(1502),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1502),
    [anon_sym_STAR_STAR] = ACTIONS(1502),
    [anon_sym_CARET] = ACTIONS(1502),
    [aux_sym_binary_operator_token1] = ACTIONS(1502),
    [anon_sym_PIPE_GT] = ACTIONS(1502),
    [anon_sym_COLON] = ACTIONS(1500),
    [anon_sym_DOLLAR] = ACTIONS(1502),
    [anon_sym_AT] = ACTIONS(1502),
    [sym__hex_literal] = ACTIONS(1502),
    [sym__number_literal] = ACTIONS(1500),
    [anon_sym_SQUOTE] = ACTIONS(1502),
    [anon_sym_DQUOTE] = ACTIONS(1502),
    [sym_return] = ACTIONS(1500),
    [sym_next] = ACTIONS(1500),
    [sym_break] = ACTIONS(1500),
    [sym_true] = ACTIONS(1500),
    [sym_false] = ACTIONS(1500),
    [sym_null] = ACTIONS(1500),
    [sym_inf] = ACTIONS(1500),
    [sym_nan] = ACTIONS(1500),
    [anon_sym_NA] = ACTIONS(1500),
    [anon_sym_NA_integer_] = ACTIONS(1500),
    [anon_sym_NA_real_] = ACTIONS(1500),
    [anon_sym_NA_complex_] = ACTIONS(1500),
    [anon_sym_NA_character_] = ACTIONS(1500),
    [sym_dots] = ACTIONS(1500),
    [sym_dot_dot_i] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1502),
    [sym__semicolon] = ACTIONS(1502),
    [sym__raw_string_literal] = ACTIONS(1502),
    [sym__external_open_parenthesis] = ACTIONS(1502),
    [sym__external_open_brace] = ACTIONS(1502),
    [sym__external_close_brace] = ACTIONS(1502),
    [sym__external_open_bracket] = ACTIONS(1502),
    [sym__external_open_bracket2] = ACTIONS(1502),
  },
  [878] = {
    [sym_identifier] = ACTIONS(1519),
    [anon_sym_BSLASH] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(1519),
    [anon_sym_EQ] = ACTIONS(1519),
    [anon_sym_if] = ACTIONS(1519),
    [anon_sym_for] = ACTIONS(1519),
    [anon_sym_while] = ACTIONS(1519),
    [anon_sym_repeat] = ACTIONS(1519),
    [anon_sym_QMARK] = ACTIONS(1521),
    [anon_sym_TILDE] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1519),
    [anon_sym_PLUS] = ACTIONS(1521),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_LT_DASH] = ACTIONS(1521),
    [anon_sym_LT_LT_DASH] = ACTIONS(1521),
    [anon_sym_COLON_EQ] = ACTIONS(1521),
    [anon_sym_DASH_GT] = ACTIONS(1519),
    [anon_sym_DASH_GT_GT] = ACTIONS(1521),
    [anon_sym_PIPE] = ACTIONS(1519),
    [anon_sym_AMP] = ACTIONS(1519),
    [anon_sym_PIPE_PIPE] = ACTIONS(1521),
    [anon_sym_AMP_AMP] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_LT_EQ] = ACTIONS(1521),
    [anon_sym_GT] = ACTIONS(1519),
    [anon_sym_GT_EQ] = ACTIONS(1521),
    [anon_sym_EQ_EQ] = ACTIONS(1521),
    [anon_sym_BANG_EQ] = ACTIONS(1521),
    [anon_sym_STAR] = ACTIONS(1519),
    [anon_sym_SLASH] = ACTIONS(1521),
    [anon_sym_STAR_STAR] = ACTIONS(1521),
    [anon_sym_CARET] = ACTIONS(1521),
    [aux_sym_binary_operator_token1] = ACTIONS(1521),
    [anon_sym_PIPE_GT] = ACTIONS(1521),
    [anon_sym_COLON] = ACTIONS(1519),
    [anon_sym_DOLLAR] = ACTIONS(1521),
    [anon_sym_AT] = ACTIONS(1521),
    [sym__hex_literal] = ACTIONS(1521),
    [sym__number_literal] = ACTIONS(1519),
    [anon_sym_SQUOTE] = ACTIONS(1521),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [sym_return] = ACTIONS(1519),
    [sym_next] = ACTIONS(1519),
    [sym_break] = ACTIONS(1519),
    [sym_true] = ACTIONS(1519),
    [sym_false] = ACTIONS(1519),
    [sym_null] = ACTIONS(1519),
    [sym_inf] = ACTIONS(1519),
    [sym_nan] = ACTIONS(1519),
    [anon_sym_NA] = ACTIONS(1519),
    [anon_sym_NA_integer_] = ACTIONS(1519),
    [anon_sym_NA_real_] = ACTIONS(1519),
    [anon_sym_NA_complex_] = ACTIONS(1519),
    [anon_sym_NA_character_] = ACTIONS(1519),
    [sym_dots] = ACTIONS(1519),
    [sym_dot_dot_i] = ACTIONS(1521),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1521),
    [sym__newline] = ACTIONS(1521),
    [sym__raw_string_literal] = ACTIONS(1521),
    [sym__external_open_parenthesis] = ACTIONS(1521),
    [sym__external_close_parenthesis] = ACTIONS(1521),
    [sym__external_open_brace] = ACTIONS(1521),
    [sym__external_open_bracket] = ACTIONS(1521),
    [sym__external_open_bracket2] = ACTIONS(1521),
  },
  [879] = {
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_BSLASH] = ACTIONS(1525),
    [anon_sym_function] = ACTIONS(1523),
    [anon_sym_EQ] = ACTIONS(1523),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_for] = ACTIONS(1523),
    [anon_sym_while] = ACTIONS(1523),
    [anon_sym_repeat] = ACTIONS(1523),
    [anon_sym_QMARK] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(1525),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1523),
    [anon_sym_LT_DASH] = ACTIONS(1525),
    [anon_sym_LT_LT_DASH] = ACTIONS(1525),
    [anon_sym_COLON_EQ] = ACTIONS(1525),
    [anon_sym_DASH_GT] = ACTIONS(1523),
    [anon_sym_DASH_GT_GT] = ACTIONS(1525),
    [anon_sym_PIPE] = ACTIONS(1523),
    [anon_sym_AMP] = ACTIONS(1523),
    [anon_sym_PIPE_PIPE] = ACTIONS(1525),
    [anon_sym_AMP_AMP] = ACTIONS(1525),
    [anon_sym_LT] = ACTIONS(1523),
    [anon_sym_LT_EQ] = ACTIONS(1525),
    [anon_sym_GT] = ACTIONS(1523),
    [anon_sym_GT_EQ] = ACTIONS(1525),
    [anon_sym_EQ_EQ] = ACTIONS(1525),
    [anon_sym_BANG_EQ] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1523),
    [anon_sym_SLASH] = ACTIONS(1525),
    [anon_sym_STAR_STAR] = ACTIONS(1525),
    [anon_sym_CARET] = ACTIONS(1525),
    [aux_sym_binary_operator_token1] = ACTIONS(1525),
    [anon_sym_PIPE_GT] = ACTIONS(1525),
    [anon_sym_COLON] = ACTIONS(1523),
    [anon_sym_DOLLAR] = ACTIONS(1525),
    [anon_sym_AT] = ACTIONS(1525),
    [sym__hex_literal] = ACTIONS(1525),
    [sym__number_literal] = ACTIONS(1523),
    [anon_sym_SQUOTE] = ACTIONS(1525),
    [anon_sym_DQUOTE] = ACTIONS(1525),
    [sym_return] = ACTIONS(1523),
    [sym_next] = ACTIONS(1523),
    [sym_break] = ACTIONS(1523),
    [sym_true] = ACTIONS(1523),
    [sym_false] = ACTIONS(1523),
    [sym_null] = ACTIONS(1523),
    [sym_inf] = ACTIONS(1523),
    [sym_nan] = ACTIONS(1523),
    [anon_sym_NA] = ACTIONS(1523),
    [anon_sym_NA_integer_] = ACTIONS(1523),
    [anon_sym_NA_real_] = ACTIONS(1523),
    [anon_sym_NA_complex_] = ACTIONS(1523),
    [anon_sym_NA_character_] = ACTIONS(1523),
    [sym_dots] = ACTIONS(1523),
    [sym_dot_dot_i] = ACTIONS(1525),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1525),
    [sym__newline] = ACTIONS(1525),
    [sym__raw_string_literal] = ACTIONS(1525),
    [sym__external_open_parenthesis] = ACTIONS(1525),
    [sym__external_close_parenthesis] = ACTIONS(1525),
    [sym__external_open_brace] = ACTIONS(1525),
    [sym__external_open_bracket] = ACTIONS(1525),
    [sym__external_open_bracket2] = ACTIONS(1525),
  },
  [880] = {
    [sym_identifier] = ACTIONS(1331),
    [anon_sym_BSLASH] = ACTIONS(1333),
    [anon_sym_function] = ACTIONS(1331),
    [anon_sym_EQ] = ACTIONS(1406),
    [anon_sym_if] = ACTIONS(1331),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_while] = ACTIONS(1331),
    [anon_sym_repeat] = ACTIONS(1331),
    [anon_sym_QMARK] = ACTIONS(1333),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_LT_DASH] = ACTIONS(1333),
    [anon_sym_LT_LT_DASH] = ACTIONS(1333),
    [anon_sym_COLON_EQ] = ACTIONS(1333),
    [anon_sym_DASH_GT] = ACTIONS(1331),
    [anon_sym_DASH_GT_GT] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1331),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1333),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_GT_EQ] = ACTIONS(1333),
    [anon_sym_EQ_EQ] = ACTIONS(1333),
    [anon_sym_BANG_EQ] = ACTIONS(1333),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_SLASH] = ACTIONS(1333),
    [anon_sym_STAR_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1333),
    [aux_sym_binary_operator_token1] = ACTIONS(1333),
    [anon_sym_PIPE_GT] = ACTIONS(1333),
    [anon_sym_COLON] = ACTIONS(1331),
    [anon_sym_DOLLAR] = ACTIONS(1333),
    [anon_sym_AT] = ACTIONS(1333),
    [sym__hex_literal] = ACTIONS(1333),
    [sym__number_literal] = ACTIONS(1331),
    [anon_sym_SQUOTE] = ACTIONS(1333),
    [anon_sym_DQUOTE] = ACTIONS(1333),
    [sym_return] = ACTIONS(1331),
    [sym_next] = ACTIONS(1331),
    [sym_break] = ACTIONS(1331),
    [sym_true] = ACTIONS(1331),
    [sym_false] = ACTIONS(1331),
    [sym_null] = ACTIONS(1331),
    [sym_inf] = ACTIONS(1331),
    [sym_nan] = ACTIONS(1331),
    [anon_sym_NA] = ACTIONS(1331),
    [anon_sym_NA_integer_] = ACTIONS(1331),
    [anon_sym_NA_real_] = ACTIONS(1331),
    [anon_sym_NA_complex_] = ACTIONS(1331),
    [anon_sym_NA_character_] = ACTIONS(1331),
    [sym_dots] = ACTIONS(1331),
    [sym_dot_dot_i] = ACTIONS(1333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1333),
    [sym__newline] = ACTIONS(1333),
    [sym__raw_string_literal] = ACTIONS(1333),
    [sym__external_open_parenthesis] = ACTIONS(1333),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_open_bracket] = ACTIONS(1333),
    [sym__external_open_bracket2] = ACTIONS(1333),
    [sym__external_close_bracket2] = ACTIONS(1333),
  },
  [881] = {
    [ts_builtin_sym_end] = ACTIONS(1521),
    [sym_identifier] = ACTIONS(1519),
    [anon_sym_BSLASH] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(1519),
    [anon_sym_EQ] = ACTIONS(1519),
    [anon_sym_if] = ACTIONS(1519),
    [anon_sym_for] = ACTIONS(1519),
    [anon_sym_while] = ACTIONS(1519),
    [anon_sym_repeat] = ACTIONS(1519),
    [anon_sym_QMARK] = ACTIONS(1521),
    [anon_sym_TILDE] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1519),
    [anon_sym_PLUS] = ACTIONS(1521),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_LT_DASH] = ACTIONS(1521),
    [anon_sym_LT_LT_DASH] = ACTIONS(1521),
    [anon_sym_COLON_EQ] = ACTIONS(1521),
    [anon_sym_DASH_GT] = ACTIONS(1519),
    [anon_sym_DASH_GT_GT] = ACTIONS(1521),
    [anon_sym_PIPE] = ACTIONS(1519),
    [anon_sym_AMP] = ACTIONS(1519),
    [anon_sym_PIPE_PIPE] = ACTIONS(1521),
    [anon_sym_AMP_AMP] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_LT_EQ] = ACTIONS(1521),
    [anon_sym_GT] = ACTIONS(1519),
    [anon_sym_GT_EQ] = ACTIONS(1521),
    [anon_sym_EQ_EQ] = ACTIONS(1521),
    [anon_sym_BANG_EQ] = ACTIONS(1521),
    [anon_sym_STAR] = ACTIONS(1519),
    [anon_sym_SLASH] = ACTIONS(1521),
    [anon_sym_STAR_STAR] = ACTIONS(1521),
    [anon_sym_CARET] = ACTIONS(1521),
    [aux_sym_binary_operator_token1] = ACTIONS(1521),
    [anon_sym_PIPE_GT] = ACTIONS(1521),
    [anon_sym_COLON] = ACTIONS(1519),
    [anon_sym_DOLLAR] = ACTIONS(1521),
    [anon_sym_AT] = ACTIONS(1521),
    [sym__hex_literal] = ACTIONS(1521),
    [sym__number_literal] = ACTIONS(1519),
    [anon_sym_SQUOTE] = ACTIONS(1521),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [sym_return] = ACTIONS(1519),
    [sym_next] = ACTIONS(1519),
    [sym_break] = ACTIONS(1519),
    [sym_true] = ACTIONS(1519),
    [sym_false] = ACTIONS(1519),
    [sym_null] = ACTIONS(1519),
    [sym_inf] = ACTIONS(1519),
    [sym_nan] = ACTIONS(1519),
    [anon_sym_NA] = ACTIONS(1519),
    [anon_sym_NA_integer_] = ACTIONS(1519),
    [anon_sym_NA_real_] = ACTIONS(1519),
    [anon_sym_NA_complex_] = ACTIONS(1519),
    [anon_sym_NA_character_] = ACTIONS(1519),
    [sym_dots] = ACTIONS(1519),
    [sym_dot_dot_i] = ACTIONS(1521),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1521),
    [sym__semicolon] = ACTIONS(1521),
    [sym__raw_string_literal] = ACTIONS(1521),
    [sym__external_open_parenthesis] = ACTIONS(1521),
    [sym__external_open_brace] = ACTIONS(1521),
    [sym__external_open_bracket] = ACTIONS(1521),
    [sym__external_open_bracket2] = ACTIONS(1521),
  },
  [882] = {
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_BSLASH] = ACTIONS(1506),
    [anon_sym_function] = ACTIONS(1504),
    [anon_sym_EQ] = ACTIONS(1504),
    [anon_sym_if] = ACTIONS(1504),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1504),
    [anon_sym_repeat] = ACTIONS(1504),
    [anon_sym_QMARK] = ACTIONS(1506),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_BANG] = ACTIONS(1504),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1504),
    [anon_sym_LT_DASH] = ACTIONS(1506),
    [anon_sym_LT_LT_DASH] = ACTIONS(1506),
    [anon_sym_COLON_EQ] = ACTIONS(1506),
    [anon_sym_DASH_GT] = ACTIONS(1504),
    [anon_sym_DASH_GT_GT] = ACTIONS(1506),
    [anon_sym_PIPE] = ACTIONS(1504),
    [anon_sym_AMP] = ACTIONS(1504),
    [anon_sym_PIPE_PIPE] = ACTIONS(1506),
    [anon_sym_AMP_AMP] = ACTIONS(1506),
    [anon_sym_LT] = ACTIONS(1504),
    [anon_sym_LT_EQ] = ACTIONS(1506),
    [anon_sym_GT] = ACTIONS(1504),
    [anon_sym_GT_EQ] = ACTIONS(1506),
    [anon_sym_EQ_EQ] = ACTIONS(1506),
    [anon_sym_BANG_EQ] = ACTIONS(1506),
    [anon_sym_STAR] = ACTIONS(1504),
    [anon_sym_SLASH] = ACTIONS(1506),
    [anon_sym_STAR_STAR] = ACTIONS(1506),
    [anon_sym_CARET] = ACTIONS(1506),
    [aux_sym_binary_operator_token1] = ACTIONS(1506),
    [anon_sym_PIPE_GT] = ACTIONS(1506),
    [anon_sym_COLON] = ACTIONS(1504),
    [anon_sym_DOLLAR] = ACTIONS(1506),
    [anon_sym_AT] = ACTIONS(1506),
    [sym__hex_literal] = ACTIONS(1506),
    [sym__number_literal] = ACTIONS(1504),
    [anon_sym_SQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1506),
    [sym_return] = ACTIONS(1504),
    [sym_next] = ACTIONS(1504),
    [sym_break] = ACTIONS(1504),
    [sym_true] = ACTIONS(1504),
    [sym_false] = ACTIONS(1504),
    [sym_null] = ACTIONS(1504),
    [sym_inf] = ACTIONS(1504),
    [sym_nan] = ACTIONS(1504),
    [anon_sym_NA] = ACTIONS(1504),
    [anon_sym_NA_integer_] = ACTIONS(1504),
    [anon_sym_NA_real_] = ACTIONS(1504),
    [anon_sym_NA_complex_] = ACTIONS(1504),
    [anon_sym_NA_character_] = ACTIONS(1504),
    [sym_dots] = ACTIONS(1504),
    [sym_dot_dot_i] = ACTIONS(1506),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1506),
    [sym__semicolon] = ACTIONS(1506),
    [sym__raw_string_literal] = ACTIONS(1506),
    [sym__external_open_parenthesis] = ACTIONS(1506),
    [sym__external_open_brace] = ACTIONS(1506),
    [sym__external_close_brace] = ACTIONS(1506),
    [sym__external_open_bracket] = ACTIONS(1506),
    [sym__external_open_bracket2] = ACTIONS(1506),
  },
  [883] = {
    [sym_identifier] = ACTIONS(1508),
    [anon_sym_BSLASH] = ACTIONS(1510),
    [anon_sym_function] = ACTIONS(1508),
    [anon_sym_EQ] = ACTIONS(1508),
    [anon_sym_if] = ACTIONS(1508),
    [anon_sym_for] = ACTIONS(1508),
    [anon_sym_while] = ACTIONS(1508),
    [anon_sym_repeat] = ACTIONS(1508),
    [anon_sym_QMARK] = ACTIONS(1510),
    [anon_sym_TILDE] = ACTIONS(1510),
    [anon_sym_BANG] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1510),
    [anon_sym_DASH] = ACTIONS(1508),
    [anon_sym_LT_DASH] = ACTIONS(1510),
    [anon_sym_LT_LT_DASH] = ACTIONS(1510),
    [anon_sym_COLON_EQ] = ACTIONS(1510),
    [anon_sym_DASH_GT] = ACTIONS(1508),
    [anon_sym_DASH_GT_GT] = ACTIONS(1510),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PIPE_PIPE] = ACTIONS(1510),
    [anon_sym_AMP_AMP] = ACTIONS(1510),
    [anon_sym_LT] = ACTIONS(1508),
    [anon_sym_LT_EQ] = ACTIONS(1510),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_GT_EQ] = ACTIONS(1510),
    [anon_sym_EQ_EQ] = ACTIONS(1510),
    [anon_sym_BANG_EQ] = ACTIONS(1510),
    [anon_sym_STAR] = ACTIONS(1508),
    [anon_sym_SLASH] = ACTIONS(1510),
    [anon_sym_STAR_STAR] = ACTIONS(1510),
    [anon_sym_CARET] = ACTIONS(1510),
    [aux_sym_binary_operator_token1] = ACTIONS(1510),
    [anon_sym_PIPE_GT] = ACTIONS(1510),
    [anon_sym_COLON] = ACTIONS(1508),
    [anon_sym_DOLLAR] = ACTIONS(1510),
    [anon_sym_AT] = ACTIONS(1510),
    [sym__hex_literal] = ACTIONS(1510),
    [sym__number_literal] = ACTIONS(1508),
    [anon_sym_SQUOTE] = ACTIONS(1510),
    [anon_sym_DQUOTE] = ACTIONS(1510),
    [sym_return] = ACTIONS(1508),
    [sym_next] = ACTIONS(1508),
    [sym_break] = ACTIONS(1508),
    [sym_true] = ACTIONS(1508),
    [sym_false] = ACTIONS(1508),
    [sym_null] = ACTIONS(1508),
    [sym_inf] = ACTIONS(1508),
    [sym_nan] = ACTIONS(1508),
    [anon_sym_NA] = ACTIONS(1508),
    [anon_sym_NA_integer_] = ACTIONS(1508),
    [anon_sym_NA_real_] = ACTIONS(1508),
    [anon_sym_NA_complex_] = ACTIONS(1508),
    [anon_sym_NA_character_] = ACTIONS(1508),
    [sym_dots] = ACTIONS(1508),
    [sym_dot_dot_i] = ACTIONS(1510),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1510),
    [sym__semicolon] = ACTIONS(1510),
    [sym__raw_string_literal] = ACTIONS(1510),
    [sym__external_open_parenthesis] = ACTIONS(1510),
    [sym__external_open_brace] = ACTIONS(1510),
    [sym__external_close_brace] = ACTIONS(1510),
    [sym__external_open_bracket] = ACTIONS(1510),
    [sym__external_open_bracket2] = ACTIONS(1510),
  },
  [884] = {
    [ts_builtin_sym_end] = ACTIONS(1525),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_BSLASH] = ACTIONS(1525),
    [anon_sym_function] = ACTIONS(1523),
    [anon_sym_EQ] = ACTIONS(1523),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_for] = ACTIONS(1523),
    [anon_sym_while] = ACTIONS(1523),
    [anon_sym_repeat] = ACTIONS(1523),
    [anon_sym_QMARK] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(1525),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1523),
    [anon_sym_LT_DASH] = ACTIONS(1525),
    [anon_sym_LT_LT_DASH] = ACTIONS(1525),
    [anon_sym_COLON_EQ] = ACTIONS(1525),
    [anon_sym_DASH_GT] = ACTIONS(1523),
    [anon_sym_DASH_GT_GT] = ACTIONS(1525),
    [anon_sym_PIPE] = ACTIONS(1523),
    [anon_sym_AMP] = ACTIONS(1523),
    [anon_sym_PIPE_PIPE] = ACTIONS(1525),
    [anon_sym_AMP_AMP] = ACTIONS(1525),
    [anon_sym_LT] = ACTIONS(1523),
    [anon_sym_LT_EQ] = ACTIONS(1525),
    [anon_sym_GT] = ACTIONS(1523),
    [anon_sym_GT_EQ] = ACTIONS(1525),
    [anon_sym_EQ_EQ] = ACTIONS(1525),
    [anon_sym_BANG_EQ] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1523),
    [anon_sym_SLASH] = ACTIONS(1525),
    [anon_sym_STAR_STAR] = ACTIONS(1525),
    [anon_sym_CARET] = ACTIONS(1525),
    [aux_sym_binary_operator_token1] = ACTIONS(1525),
    [anon_sym_PIPE_GT] = ACTIONS(1525),
    [anon_sym_COLON] = ACTIONS(1523),
    [anon_sym_DOLLAR] = ACTIONS(1525),
    [anon_sym_AT] = ACTIONS(1525),
    [sym__hex_literal] = ACTIONS(1525),
    [sym__number_literal] = ACTIONS(1523),
    [anon_sym_SQUOTE] = ACTIONS(1525),
    [anon_sym_DQUOTE] = ACTIONS(1525),
    [sym_return] = ACTIONS(1523),
    [sym_next] = ACTIONS(1523),
    [sym_break] = ACTIONS(1523),
    [sym_true] = ACTIONS(1523),
    [sym_false] = ACTIONS(1523),
    [sym_null] = ACTIONS(1523),
    [sym_inf] = ACTIONS(1523),
    [sym_nan] = ACTIONS(1523),
    [anon_sym_NA] = ACTIONS(1523),
    [anon_sym_NA_integer_] = ACTIONS(1523),
    [anon_sym_NA_real_] = ACTIONS(1523),
    [anon_sym_NA_complex_] = ACTIONS(1523),
    [anon_sym_NA_character_] = ACTIONS(1523),
    [sym_dots] = ACTIONS(1523),
    [sym_dot_dot_i] = ACTIONS(1525),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1525),
    [sym__semicolon] = ACTIONS(1525),
    [sym__raw_string_literal] = ACTIONS(1525),
    [sym__external_open_parenthesis] = ACTIONS(1525),
    [sym__external_open_brace] = ACTIONS(1525),
    [sym__external_open_bracket] = ACTIONS(1525),
    [sym__external_open_bracket2] = ACTIONS(1525),
  },
  [885] = {
    [sym_identifier] = ACTIONS(1515),
    [anon_sym_BSLASH] = ACTIONS(1517),
    [anon_sym_function] = ACTIONS(1515),
    [anon_sym_EQ] = ACTIONS(1515),
    [anon_sym_if] = ACTIONS(1515),
    [anon_sym_for] = ACTIONS(1515),
    [anon_sym_while] = ACTIONS(1515),
    [anon_sym_repeat] = ACTIONS(1515),
    [anon_sym_QMARK] = ACTIONS(1517),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_DASH] = ACTIONS(1515),
    [anon_sym_LT_DASH] = ACTIONS(1517),
    [anon_sym_LT_LT_DASH] = ACTIONS(1517),
    [anon_sym_COLON_EQ] = ACTIONS(1517),
    [anon_sym_DASH_GT] = ACTIONS(1515),
    [anon_sym_DASH_GT_GT] = ACTIONS(1517),
    [anon_sym_PIPE] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_PIPE_PIPE] = ACTIONS(1517),
    [anon_sym_AMP_AMP] = ACTIONS(1517),
    [anon_sym_LT] = ACTIONS(1515),
    [anon_sym_LT_EQ] = ACTIONS(1517),
    [anon_sym_GT] = ACTIONS(1515),
    [anon_sym_GT_EQ] = ACTIONS(1517),
    [anon_sym_EQ_EQ] = ACTIONS(1517),
    [anon_sym_BANG_EQ] = ACTIONS(1517),
    [anon_sym_STAR] = ACTIONS(1515),
    [anon_sym_SLASH] = ACTIONS(1517),
    [anon_sym_STAR_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [aux_sym_binary_operator_token1] = ACTIONS(1517),
    [anon_sym_PIPE_GT] = ACTIONS(1517),
    [anon_sym_COLON] = ACTIONS(1515),
    [anon_sym_DOLLAR] = ACTIONS(1517),
    [anon_sym_AT] = ACTIONS(1517),
    [sym__hex_literal] = ACTIONS(1517),
    [sym__number_literal] = ACTIONS(1515),
    [anon_sym_SQUOTE] = ACTIONS(1517),
    [anon_sym_DQUOTE] = ACTIONS(1517),
    [sym_return] = ACTIONS(1515),
    [sym_next] = ACTIONS(1515),
    [sym_break] = ACTIONS(1515),
    [sym_true] = ACTIONS(1515),
    [sym_false] = ACTIONS(1515),
    [sym_null] = ACTIONS(1515),
    [sym_inf] = ACTIONS(1515),
    [sym_nan] = ACTIONS(1515),
    [anon_sym_NA] = ACTIONS(1515),
    [anon_sym_NA_integer_] = ACTIONS(1515),
    [anon_sym_NA_real_] = ACTIONS(1515),
    [anon_sym_NA_complex_] = ACTIONS(1515),
    [anon_sym_NA_character_] = ACTIONS(1515),
    [sym_dots] = ACTIONS(1515),
    [sym_dot_dot_i] = ACTIONS(1517),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1517),
    [sym__semicolon] = ACTIONS(1517),
    [sym__raw_string_literal] = ACTIONS(1517),
    [sym__external_open_parenthesis] = ACTIONS(1517),
    [sym__external_open_brace] = ACTIONS(1517),
    [sym__external_close_brace] = ACTIONS(1517),
    [sym__external_open_bracket] = ACTIONS(1517),
    [sym__external_open_bracket2] = ACTIONS(1517),
  },
  [886] = {
    [sym_identifier] = ACTIONS(1519),
    [anon_sym_BSLASH] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(1519),
    [anon_sym_EQ] = ACTIONS(1519),
    [anon_sym_if] = ACTIONS(1519),
    [anon_sym_for] = ACTIONS(1519),
    [anon_sym_while] = ACTIONS(1519),
    [anon_sym_repeat] = ACTIONS(1519),
    [anon_sym_QMARK] = ACTIONS(1521),
    [anon_sym_TILDE] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1519),
    [anon_sym_PLUS] = ACTIONS(1521),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_LT_DASH] = ACTIONS(1521),
    [anon_sym_LT_LT_DASH] = ACTIONS(1521),
    [anon_sym_COLON_EQ] = ACTIONS(1521),
    [anon_sym_DASH_GT] = ACTIONS(1519),
    [anon_sym_DASH_GT_GT] = ACTIONS(1521),
    [anon_sym_PIPE] = ACTIONS(1519),
    [anon_sym_AMP] = ACTIONS(1519),
    [anon_sym_PIPE_PIPE] = ACTIONS(1521),
    [anon_sym_AMP_AMP] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_LT_EQ] = ACTIONS(1521),
    [anon_sym_GT] = ACTIONS(1519),
    [anon_sym_GT_EQ] = ACTIONS(1521),
    [anon_sym_EQ_EQ] = ACTIONS(1521),
    [anon_sym_BANG_EQ] = ACTIONS(1521),
    [anon_sym_STAR] = ACTIONS(1519),
    [anon_sym_SLASH] = ACTIONS(1521),
    [anon_sym_STAR_STAR] = ACTIONS(1521),
    [anon_sym_CARET] = ACTIONS(1521),
    [aux_sym_binary_operator_token1] = ACTIONS(1521),
    [anon_sym_PIPE_GT] = ACTIONS(1521),
    [anon_sym_COLON] = ACTIONS(1519),
    [anon_sym_DOLLAR] = ACTIONS(1521),
    [anon_sym_AT] = ACTIONS(1521),
    [sym__hex_literal] = ACTIONS(1521),
    [sym__number_literal] = ACTIONS(1519),
    [anon_sym_SQUOTE] = ACTIONS(1521),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [sym_return] = ACTIONS(1519),
    [sym_next] = ACTIONS(1519),
    [sym_break] = ACTIONS(1519),
    [sym_true] = ACTIONS(1519),
    [sym_false] = ACTIONS(1519),
    [sym_null] = ACTIONS(1519),
    [sym_inf] = ACTIONS(1519),
    [sym_nan] = ACTIONS(1519),
    [anon_sym_NA] = ACTIONS(1519),
    [anon_sym_NA_integer_] = ACTIONS(1519),
    [anon_sym_NA_real_] = ACTIONS(1519),
    [anon_sym_NA_complex_] = ACTIONS(1519),
    [anon_sym_NA_character_] = ACTIONS(1519),
    [sym_dots] = ACTIONS(1519),
    [sym_dot_dot_i] = ACTIONS(1521),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1521),
    [sym__semicolon] = ACTIONS(1521),
    [sym__raw_string_literal] = ACTIONS(1521),
    [sym__external_open_parenthesis] = ACTIONS(1521),
    [sym__external_open_brace] = ACTIONS(1521),
    [sym__external_close_brace] = ACTIONS(1521),
    [sym__external_open_bracket] = ACTIONS(1521),
    [sym__external_open_bracket2] = ACTIONS(1521),
  },
  [887] = {
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_BSLASH] = ACTIONS(1525),
    [anon_sym_function] = ACTIONS(1523),
    [anon_sym_EQ] = ACTIONS(1523),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_for] = ACTIONS(1523),
    [anon_sym_while] = ACTIONS(1523),
    [anon_sym_repeat] = ACTIONS(1523),
    [anon_sym_QMARK] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(1525),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1523),
    [anon_sym_LT_DASH] = ACTIONS(1525),
    [anon_sym_LT_LT_DASH] = ACTIONS(1525),
    [anon_sym_COLON_EQ] = ACTIONS(1525),
    [anon_sym_DASH_GT] = ACTIONS(1523),
    [anon_sym_DASH_GT_GT] = ACTIONS(1525),
    [anon_sym_PIPE] = ACTIONS(1523),
    [anon_sym_AMP] = ACTIONS(1523),
    [anon_sym_PIPE_PIPE] = ACTIONS(1525),
    [anon_sym_AMP_AMP] = ACTIONS(1525),
    [anon_sym_LT] = ACTIONS(1523),
    [anon_sym_LT_EQ] = ACTIONS(1525),
    [anon_sym_GT] = ACTIONS(1523),
    [anon_sym_GT_EQ] = ACTIONS(1525),
    [anon_sym_EQ_EQ] = ACTIONS(1525),
    [anon_sym_BANG_EQ] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1523),
    [anon_sym_SLASH] = ACTIONS(1525),
    [anon_sym_STAR_STAR] = ACTIONS(1525),
    [anon_sym_CARET] = ACTIONS(1525),
    [aux_sym_binary_operator_token1] = ACTIONS(1525),
    [anon_sym_PIPE_GT] = ACTIONS(1525),
    [anon_sym_COLON] = ACTIONS(1523),
    [anon_sym_DOLLAR] = ACTIONS(1525),
    [anon_sym_AT] = ACTIONS(1525),
    [sym__hex_literal] = ACTIONS(1525),
    [sym__number_literal] = ACTIONS(1523),
    [anon_sym_SQUOTE] = ACTIONS(1525),
    [anon_sym_DQUOTE] = ACTIONS(1525),
    [sym_return] = ACTIONS(1523),
    [sym_next] = ACTIONS(1523),
    [sym_break] = ACTIONS(1523),
    [sym_true] = ACTIONS(1523),
    [sym_false] = ACTIONS(1523),
    [sym_null] = ACTIONS(1523),
    [sym_inf] = ACTIONS(1523),
    [sym_nan] = ACTIONS(1523),
    [anon_sym_NA] = ACTIONS(1523),
    [anon_sym_NA_integer_] = ACTIONS(1523),
    [anon_sym_NA_real_] = ACTIONS(1523),
    [anon_sym_NA_complex_] = ACTIONS(1523),
    [anon_sym_NA_character_] = ACTIONS(1523),
    [sym_dots] = ACTIONS(1523),
    [sym_dot_dot_i] = ACTIONS(1525),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1525),
    [sym__semicolon] = ACTIONS(1525),
    [sym__raw_string_literal] = ACTIONS(1525),
    [sym__external_open_parenthesis] = ACTIONS(1525),
    [sym__external_open_brace] = ACTIONS(1525),
    [sym__external_close_brace] = ACTIONS(1525),
    [sym__external_open_bracket] = ACTIONS(1525),
    [sym__external_open_bracket2] = ACTIONS(1525),
  },
  [888] = {
    [sym_identifier] = ACTIONS(1527),
    [anon_sym_BSLASH] = ACTIONS(1529),
    [anon_sym_function] = ACTIONS(1527),
    [anon_sym_EQ] = ACTIONS(1527),
    [anon_sym_if] = ACTIONS(1527),
    [anon_sym_for] = ACTIONS(1527),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_repeat] = ACTIONS(1527),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_TILDE] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1527),
    [anon_sym_LT_DASH] = ACTIONS(1529),
    [anon_sym_LT_LT_DASH] = ACTIONS(1529),
    [anon_sym_COLON_EQ] = ACTIONS(1529),
    [anon_sym_DASH_GT] = ACTIONS(1527),
    [anon_sym_DASH_GT_GT] = ACTIONS(1529),
    [anon_sym_PIPE] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1527),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1527),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1529),
    [anon_sym_BANG_EQ] = ACTIONS(1529),
    [anon_sym_STAR] = ACTIONS(1527),
    [anon_sym_SLASH] = ACTIONS(1529),
    [anon_sym_STAR_STAR] = ACTIONS(1529),
    [anon_sym_CARET] = ACTIONS(1529),
    [aux_sym_binary_operator_token1] = ACTIONS(1529),
    [anon_sym_PIPE_GT] = ACTIONS(1529),
    [anon_sym_COLON] = ACTIONS(1527),
    [anon_sym_DOLLAR] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(1529),
    [sym__hex_literal] = ACTIONS(1529),
    [sym__number_literal] = ACTIONS(1527),
    [anon_sym_SQUOTE] = ACTIONS(1529),
    [anon_sym_DQUOTE] = ACTIONS(1529),
    [sym_return] = ACTIONS(1527),
    [sym_next] = ACTIONS(1527),
    [sym_break] = ACTIONS(1527),
    [sym_true] = ACTIONS(1527),
    [sym_false] = ACTIONS(1527),
    [sym_null] = ACTIONS(1527),
    [sym_inf] = ACTIONS(1527),
    [sym_nan] = ACTIONS(1527),
    [anon_sym_NA] = ACTIONS(1527),
    [anon_sym_NA_integer_] = ACTIONS(1527),
    [anon_sym_NA_real_] = ACTIONS(1527),
    [anon_sym_NA_complex_] = ACTIONS(1527),
    [anon_sym_NA_character_] = ACTIONS(1527),
    [sym_dots] = ACTIONS(1527),
    [sym_dot_dot_i] = ACTIONS(1529),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1529),
    [sym__semicolon] = ACTIONS(1529),
    [sym__raw_string_literal] = ACTIONS(1529),
    [sym__external_open_parenthesis] = ACTIONS(1529),
    [sym__external_open_brace] = ACTIONS(1529),
    [sym__external_close_brace] = ACTIONS(1529),
    [sym__external_open_bracket] = ACTIONS(1529),
    [sym__external_open_bracket2] = ACTIONS(1529),
  },
  [889] = {
    [sym_identifier] = ACTIONS(1515),
    [anon_sym_BSLASH] = ACTIONS(1517),
    [anon_sym_function] = ACTIONS(1515),
    [anon_sym_EQ] = ACTIONS(1515),
    [anon_sym_if] = ACTIONS(1515),
    [anon_sym_for] = ACTIONS(1515),
    [anon_sym_while] = ACTIONS(1515),
    [anon_sym_repeat] = ACTIONS(1515),
    [anon_sym_QMARK] = ACTIONS(1517),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_DASH] = ACTIONS(1515),
    [anon_sym_LT_DASH] = ACTIONS(1517),
    [anon_sym_LT_LT_DASH] = ACTIONS(1517),
    [anon_sym_COLON_EQ] = ACTIONS(1517),
    [anon_sym_DASH_GT] = ACTIONS(1515),
    [anon_sym_DASH_GT_GT] = ACTIONS(1517),
    [anon_sym_PIPE] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_PIPE_PIPE] = ACTIONS(1517),
    [anon_sym_AMP_AMP] = ACTIONS(1517),
    [anon_sym_LT] = ACTIONS(1515),
    [anon_sym_LT_EQ] = ACTIONS(1517),
    [anon_sym_GT] = ACTIONS(1515),
    [anon_sym_GT_EQ] = ACTIONS(1517),
    [anon_sym_EQ_EQ] = ACTIONS(1517),
    [anon_sym_BANG_EQ] = ACTIONS(1517),
    [anon_sym_STAR] = ACTIONS(1515),
    [anon_sym_SLASH] = ACTIONS(1517),
    [anon_sym_STAR_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [aux_sym_binary_operator_token1] = ACTIONS(1517),
    [anon_sym_PIPE_GT] = ACTIONS(1517),
    [anon_sym_COLON] = ACTIONS(1515),
    [anon_sym_DOLLAR] = ACTIONS(1517),
    [anon_sym_AT] = ACTIONS(1517),
    [sym__hex_literal] = ACTIONS(1517),
    [sym__number_literal] = ACTIONS(1515),
    [anon_sym_SQUOTE] = ACTIONS(1517),
    [anon_sym_DQUOTE] = ACTIONS(1517),
    [sym_return] = ACTIONS(1515),
    [sym_next] = ACTIONS(1515),
    [sym_break] = ACTIONS(1515),
    [sym_true] = ACTIONS(1515),
    [sym_false] = ACTIONS(1515),
    [sym_null] = ACTIONS(1515),
    [sym_inf] = ACTIONS(1515),
    [sym_nan] = ACTIONS(1515),
    [anon_sym_NA] = ACTIONS(1515),
    [anon_sym_NA_integer_] = ACTIONS(1515),
    [anon_sym_NA_real_] = ACTIONS(1515),
    [anon_sym_NA_complex_] = ACTIONS(1515),
    [anon_sym_NA_character_] = ACTIONS(1515),
    [sym_dots] = ACTIONS(1515),
    [sym_dot_dot_i] = ACTIONS(1517),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1517),
    [sym__newline] = ACTIONS(1517),
    [sym__raw_string_literal] = ACTIONS(1517),
    [sym__external_open_parenthesis] = ACTIONS(1517),
    [sym__external_open_brace] = ACTIONS(1517),
    [sym__external_open_bracket] = ACTIONS(1517),
    [sym__external_close_bracket] = ACTIONS(1517),
    [sym__external_open_bracket2] = ACTIONS(1517),
  },
  [890] = {
    [sym_identifier] = ACTIONS(1535),
    [anon_sym_BSLASH] = ACTIONS(1537),
    [anon_sym_function] = ACTIONS(1535),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_if] = ACTIONS(1535),
    [anon_sym_for] = ACTIONS(1535),
    [anon_sym_while] = ACTIONS(1535),
    [anon_sym_repeat] = ACTIONS(1535),
    [anon_sym_QMARK] = ACTIONS(1537),
    [anon_sym_TILDE] = ACTIONS(1537),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1535),
    [anon_sym_LT_DASH] = ACTIONS(1537),
    [anon_sym_LT_LT_DASH] = ACTIONS(1537),
    [anon_sym_COLON_EQ] = ACTIONS(1537),
    [anon_sym_DASH_GT] = ACTIONS(1535),
    [anon_sym_DASH_GT_GT] = ACTIONS(1537),
    [anon_sym_PIPE] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_PIPE_PIPE] = ACTIONS(1537),
    [anon_sym_AMP_AMP] = ACTIONS(1537),
    [anon_sym_LT] = ACTIONS(1535),
    [anon_sym_LT_EQ] = ACTIONS(1537),
    [anon_sym_GT] = ACTIONS(1535),
    [anon_sym_GT_EQ] = ACTIONS(1537),
    [anon_sym_EQ_EQ] = ACTIONS(1537),
    [anon_sym_BANG_EQ] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_SLASH] = ACTIONS(1537),
    [anon_sym_STAR_STAR] = ACTIONS(1537),
    [anon_sym_CARET] = ACTIONS(1537),
    [aux_sym_binary_operator_token1] = ACTIONS(1537),
    [anon_sym_PIPE_GT] = ACTIONS(1537),
    [anon_sym_COLON] = ACTIONS(1535),
    [anon_sym_DOLLAR] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(1537),
    [sym__hex_literal] = ACTIONS(1537),
    [sym__number_literal] = ACTIONS(1535),
    [anon_sym_SQUOTE] = ACTIONS(1537),
    [anon_sym_DQUOTE] = ACTIONS(1537),
    [sym_return] = ACTIONS(1535),
    [sym_next] = ACTIONS(1535),
    [sym_break] = ACTIONS(1535),
    [sym_true] = ACTIONS(1535),
    [sym_false] = ACTIONS(1535),
    [sym_null] = ACTIONS(1535),
    [sym_inf] = ACTIONS(1535),
    [sym_nan] = ACTIONS(1535),
    [anon_sym_NA] = ACTIONS(1535),
    [anon_sym_NA_integer_] = ACTIONS(1535),
    [anon_sym_NA_real_] = ACTIONS(1535),
    [anon_sym_NA_complex_] = ACTIONS(1535),
    [anon_sym_NA_character_] = ACTIONS(1535),
    [sym_dots] = ACTIONS(1535),
    [sym_dot_dot_i] = ACTIONS(1537),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1537),
    [sym__newline] = ACTIONS(1537),
    [sym__raw_string_literal] = ACTIONS(1537),
    [sym__external_open_parenthesis] = ACTIONS(1537),
    [sym__external_close_parenthesis] = ACTIONS(1537),
    [sym__external_open_brace] = ACTIONS(1537),
    [sym__external_open_bracket] = ACTIONS(1537),
    [sym__external_open_bracket2] = ACTIONS(1537),
  },
  [891] = {
    [sym_function_definition] = STATE(292),
    [sym_if_statement] = STATE(292),
    [sym_for_statement] = STATE(292),
    [sym_while_statement] = STATE(292),
    [sym_repeat_statement] = STATE(292),
    [sym_braced_expression] = STATE(292),
    [sym_parenthesized_expression] = STATE(292),
    [sym_call] = STATE(292),
    [sym_subset] = STATE(292),
    [sym_subset2] = STATE(292),
    [sym_unary_operator] = STATE(292),
    [sym_binary_operator] = STATE(292),
    [sym_extract_operator] = STATE(292),
    [sym_namespace_operator] = STATE(292),
    [sym_integer] = STATE(292),
    [sym_complex] = STATE(292),
    [sym_float] = STATE(292),
    [sym__float_literal] = STATE(744),
    [sym_string] = STATE(706),
    [sym__single_quoted_string] = STATE(745),
    [sym__double_quoted_string] = STATE(747),
    [sym_na] = STATE(292),
    [sym__expression] = STATE(292),
    [sym__string_or_identifier] = STATE(2134),
    [sym__open_parenthesis] = STATE(987),
    [sym__open_brace] = STATE(760),
    [aux_sym_program_repeat1] = STATE(975),
    [ts_builtin_sym_end] = ACTIONS(1605),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_BSLASH] = ACTIONS(9),
    [anon_sym_function] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_for] = ACTIONS(15),
    [anon_sym_while] = ACTIONS(17),
    [anon_sym_repeat] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(27),
    [sym__hex_literal] = ACTIONS(29),
    [sym__number_literal] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_return] = ACTIONS(37),
    [sym_next] = ACTIONS(37),
    [sym_break] = ACTIONS(37),
    [sym_true] = ACTIONS(37),
    [sym_false] = ACTIONS(37),
    [sym_null] = ACTIONS(37),
    [sym_inf] = ACTIONS(37),
    [sym_nan] = ACTIONS(37),
    [anon_sym_NA] = ACTIONS(39),
    [anon_sym_NA_integer_] = ACTIONS(39),
    [anon_sym_NA_real_] = ACTIONS(39),
    [anon_sym_NA_complex_] = ACTIONS(39),
    [anon_sym_NA_character_] = ACTIONS(39),
    [sym_dots] = ACTIONS(37),
    [sym_dot_dot_i] = ACTIONS(41),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1607),
    [sym__semicolon] = ACTIONS(1607),
    [sym__raw_string_literal] = ACTIONS(45),
    [sym__external_open_parenthesis] = ACTIONS(47),
    [sym__external_open_brace] = ACTIONS(49),
  },
  [892] = {
    [sym_identifier] = ACTIONS(1551),
    [anon_sym_BSLASH] = ACTIONS(1553),
    [anon_sym_function] = ACTIONS(1551),
    [anon_sym_EQ] = ACTIONS(1551),
    [anon_sym_if] = ACTIONS(1551),
    [anon_sym_for] = ACTIONS(1551),
    [anon_sym_while] = ACTIONS(1551),
    [anon_sym_repeat] = ACTIONS(1551),
    [anon_sym_QMARK] = ACTIONS(1553),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_PLUS] = ACTIONS(1553),
    [anon_sym_DASH] = ACTIONS(1551),
    [anon_sym_LT_DASH] = ACTIONS(1553),
    [anon_sym_LT_LT_DASH] = ACTIONS(1553),
    [anon_sym_COLON_EQ] = ACTIONS(1553),
    [anon_sym_DASH_GT] = ACTIONS(1551),
    [anon_sym_DASH_GT_GT] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_PIPE_PIPE] = ACTIONS(1553),
    [anon_sym_AMP_AMP] = ACTIONS(1553),
    [anon_sym_LT] = ACTIONS(1551),
    [anon_sym_LT_EQ] = ACTIONS(1553),
    [anon_sym_GT] = ACTIONS(1551),
    [anon_sym_GT_EQ] = ACTIONS(1553),
    [anon_sym_EQ_EQ] = ACTIONS(1553),
    [anon_sym_BANG_EQ] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(1551),
    [anon_sym_SLASH] = ACTIONS(1553),
    [anon_sym_STAR_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [aux_sym_binary_operator_token1] = ACTIONS(1553),
    [anon_sym_PIPE_GT] = ACTIONS(1553),
    [anon_sym_COLON] = ACTIONS(1551),
    [anon_sym_DOLLAR] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(1553),
    [sym__hex_literal] = ACTIONS(1553),
    [sym__number_literal] = ACTIONS(1551),
    [anon_sym_SQUOTE] = ACTIONS(1553),
    [anon_sym_DQUOTE] = ACTIONS(1553),
    [sym_return] = ACTIONS(1551),
    [sym_next] = ACTIONS(1551),
    [sym_break] = ACTIONS(1551),
    [sym_true] = ACTIONS(1551),
    [sym_false] = ACTIONS(1551),
    [sym_null] = ACTIONS(1551),
    [sym_inf] = ACTIONS(1551),
    [sym_nan] = ACTIONS(1551),
    [anon_sym_NA] = ACTIONS(1551),
    [anon_sym_NA_integer_] = ACTIONS(1551),
    [anon_sym_NA_real_] = ACTIONS(1551),
    [anon_sym_NA_complex_] = ACTIONS(1551),
    [anon_sym_NA_character_] = ACTIONS(1551),
    [sym_dots] = ACTIONS(1551),
    [sym_dot_dot_i] = ACTIONS(1553),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1553),
    [sym__newline] = ACTIONS(1553),
    [sym__raw_string_literal] = ACTIONS(1553),
    [sym__external_open_parenthesis] = ACTIONS(1553),
    [sym__external_close_parenthesis] = ACTIONS(1553),
    [sym__external_open_brace] = ACTIONS(1553),
    [sym__external_open_bracket] = ACTIONS(1553),
    [sym__external_open_bracket2] = ACTIONS(1553),
  },
  [893] = {
    [ts_builtin_sym_end] = ACTIONS(1529),
    [sym_identifier] = ACTIONS(1527),
    [anon_sym_BSLASH] = ACTIONS(1529),
    [anon_sym_function] = ACTIONS(1527),
    [anon_sym_EQ] = ACTIONS(1527),
    [anon_sym_if] = ACTIONS(1527),
    [anon_sym_for] = ACTIONS(1527),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_repeat] = ACTIONS(1527),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_TILDE] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1527),
    [anon_sym_LT_DASH] = ACTIONS(1529),
    [anon_sym_LT_LT_DASH] = ACTIONS(1529),
    [anon_sym_COLON_EQ] = ACTIONS(1529),
    [anon_sym_DASH_GT] = ACTIONS(1527),
    [anon_sym_DASH_GT_GT] = ACTIONS(1529),
    [anon_sym_PIPE] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1527),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1527),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1529),
    [anon_sym_BANG_EQ] = ACTIONS(1529),
    [anon_sym_STAR] = ACTIONS(1527),
    [anon_sym_SLASH] = ACTIONS(1529),
    [anon_sym_STAR_STAR] = ACTIONS(1529),
    [anon_sym_CARET] = ACTIONS(1529),
    [aux_sym_binary_operator_token1] = ACTIONS(1529),
    [anon_sym_PIPE_GT] = ACTIONS(1529),
    [anon_sym_COLON] = ACTIONS(1527),
    [anon_sym_DOLLAR] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(1529),
    [sym__hex_literal] = ACTIONS(1529),
    [sym__number_literal] = ACTIONS(1527),
    [anon_sym_SQUOTE] = ACTIONS(1529),
    [anon_sym_DQUOTE] = ACTIONS(1529),
    [sym_return] = ACTIONS(1527),
    [sym_next] = ACTIONS(1527),
    [sym_break] = ACTIONS(1527),
    [sym_true] = ACTIONS(1527),
    [sym_false] = ACTIONS(1527),
    [sym_null] = ACTIONS(1527),
    [sym_inf] = ACTIONS(1527),
    [sym_nan] = ACTIONS(1527),
    [anon_sym_NA] = ACTIONS(1527),
    [anon_sym_NA_integer_] = ACTIONS(1527),
    [anon_sym_NA_real_] = ACTIONS(1527),
    [anon_sym_NA_complex_] = ACTIONS(1527),
    [anon_sym_NA_character_] = ACTIONS(1527),
    [sym_dots] = ACTIONS(1527),
    [sym_dot_dot_i] = ACTIONS(1529),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1529),
    [sym__semicolon] = ACTIONS(1529),
    [sym__raw_string_literal] = ACTIONS(1529),
    [sym__external_open_parenthesis] = ACTIONS(1529),
    [sym__external_open_brace] = ACTIONS(1529),
    [sym__external_open_bracket] = ACTIONS(1529),
    [sym__external_open_bracket2] = ACTIONS(1529),
  },
  [894] = {
    [sym_function_definition] = STATE(406),
    [sym_if_statement] = STATE(406),
    [sym_for_statement] = STATE(406),
    [sym_while_statement] = STATE(406),
    [sym_repeat_statement] = STATE(406),
    [sym_braced_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_call] = STATE(406),
    [sym_subset] = STATE(406),
    [sym_subset2] = STATE(406),
    [sym_unary_operator] = STATE(406),
    [sym_binary_operator] = STATE(406),
    [sym_extract_operator] = STATE(406),
    [sym_namespace_operator] = STATE(406),
    [sym_integer] = STATE(406),
    [sym_complex] = STATE(406),
    [sym_float] = STATE(406),
    [sym__float_literal] = STATE(741),
    [sym_string] = STATE(740),
    [sym__single_quoted_string] = STATE(743),
    [sym__double_quoted_string] = STATE(746),
    [sym_na] = STATE(406),
    [sym__expression] = STATE(406),
    [sym__string_or_identifier] = STATE(2136),
    [sym__open_parenthesis] = STATE(934),
    [sym__open_brace] = STATE(853),
    [aux_sym_braced_expression_repeat1] = STATE(894),
    [sym_identifier] = ACTIONS(1609),
    [anon_sym_BSLASH] = ACTIONS(1612),
    [anon_sym_function] = ACTIONS(1615),
    [anon_sym_if] = ACTIONS(1618),
    [anon_sym_for] = ACTIONS(1621),
    [anon_sym_while] = ACTIONS(1624),
    [anon_sym_repeat] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(1630),
    [anon_sym_TILDE] = ACTIONS(1633),
    [anon_sym_BANG] = ACTIONS(1636),
    [anon_sym_PLUS] = ACTIONS(1639),
    [anon_sym_DASH] = ACTIONS(1639),
    [sym__hex_literal] = ACTIONS(1642),
    [sym__number_literal] = ACTIONS(1645),
    [anon_sym_SQUOTE] = ACTIONS(1648),
    [anon_sym_DQUOTE] = ACTIONS(1651),
    [sym_return] = ACTIONS(1654),
    [sym_next] = ACTIONS(1654),
    [sym_break] = ACTIONS(1654),
    [sym_true] = ACTIONS(1654),
    [sym_false] = ACTIONS(1654),
    [sym_null] = ACTIONS(1654),
    [sym_inf] = ACTIONS(1654),
    [sym_nan] = ACTIONS(1654),
    [anon_sym_NA] = ACTIONS(1657),
    [anon_sym_NA_integer_] = ACTIONS(1657),
    [anon_sym_NA_real_] = ACTIONS(1657),
    [anon_sym_NA_complex_] = ACTIONS(1657),
    [anon_sym_NA_character_] = ACTIONS(1657),
    [sym_dots] = ACTIONS(1654),
    [sym_dot_dot_i] = ACTIONS(1660),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1663),
    [sym__semicolon] = ACTIONS(1663),
    [sym__raw_string_literal] = ACTIONS(1666),
    [sym__external_open_parenthesis] = ACTIONS(1669),
    [sym__external_open_brace] = ACTIONS(1672),
    [sym__external_close_brace] = ACTIONS(1675),
  },
  [895] = {
    [sym_identifier] = ACTIONS(1500),
    [anon_sym_BSLASH] = ACTIONS(1502),
    [anon_sym_function] = ACTIONS(1500),
    [anon_sym_EQ] = ACTIONS(1500),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_for] = ACTIONS(1500),
    [anon_sym_while] = ACTIONS(1500),
    [anon_sym_repeat] = ACTIONS(1500),
    [anon_sym_QMARK] = ACTIONS(1502),
    [anon_sym_TILDE] = ACTIONS(1502),
    [anon_sym_BANG] = ACTIONS(1500),
    [anon_sym_PLUS] = ACTIONS(1502),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_LT_DASH] = ACTIONS(1502),
    [anon_sym_LT_LT_DASH] = ACTIONS(1502),
    [anon_sym_COLON_EQ] = ACTIONS(1502),
    [anon_sym_DASH_GT] = ACTIONS(1500),
    [anon_sym_DASH_GT_GT] = ACTIONS(1502),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_AMP] = ACTIONS(1500),
    [anon_sym_PIPE_PIPE] = ACTIONS(1502),
    [anon_sym_AMP_AMP] = ACTIONS(1502),
    [anon_sym_LT] = ACTIONS(1500),
    [anon_sym_LT_EQ] = ACTIONS(1502),
    [anon_sym_GT] = ACTIONS(1500),
    [anon_sym_GT_EQ] = ACTIONS(1502),
    [anon_sym_EQ_EQ] = ACTIONS(1502),
    [anon_sym_BANG_EQ] = ACTIONS(1502),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1502),
    [anon_sym_STAR_STAR] = ACTIONS(1502),
    [anon_sym_CARET] = ACTIONS(1502),
    [aux_sym_binary_operator_token1] = ACTIONS(1502),
    [anon_sym_PIPE_GT] = ACTIONS(1502),
    [anon_sym_COLON] = ACTIONS(1500),
    [anon_sym_DOLLAR] = ACTIONS(1502),
    [anon_sym_AT] = ACTIONS(1502),
    [sym__hex_literal] = ACTIONS(1502),
    [sym__number_literal] = ACTIONS(1500),
    [anon_sym_SQUOTE] = ACTIONS(1502),
    [anon_sym_DQUOTE] = ACTIONS(1502),
    [sym_return] = ACTIONS(1500),
    [sym_next] = ACTIONS(1500),
    [sym_break] = ACTIONS(1500),
    [sym_true] = ACTIONS(1500),
    [sym_false] = ACTIONS(1500),
    [sym_null] = ACTIONS(1500),
    [sym_inf] = ACTIONS(1500),
    [sym_nan] = ACTIONS(1500),
    [anon_sym_NA] = ACTIONS(1500),
    [anon_sym_NA_integer_] = ACTIONS(1500),
    [anon_sym_NA_real_] = ACTIONS(1500),
    [anon_sym_NA_complex_] = ACTIONS(1500),
    [anon_sym_NA_character_] = ACTIONS(1500),
    [sym_dots] = ACTIONS(1500),
    [sym_dot_dot_i] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1502),
    [sym__newline] = ACTIONS(1502),
    [sym__raw_string_literal] = ACTIONS(1502),
    [sym__external_open_parenthesis] = ACTIONS(1502),
    [sym__external_close_parenthesis] = ACTIONS(1502),
    [sym__external_open_brace] = ACTIONS(1502),
    [sym__external_open_bracket] = ACTIONS(1502),
    [sym__external_open_bracket2] = ACTIONS(1502),
  },
  [896] = {
    [sym_identifier] = ACTIONS(1500),
    [anon_sym_BSLASH] = ACTIONS(1502),
    [anon_sym_function] = ACTIONS(1500),
    [anon_sym_EQ] = ACTIONS(1500),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_for] = ACTIONS(1500),
    [anon_sym_while] = ACTIONS(1500),
    [anon_sym_repeat] = ACTIONS(1500),
    [anon_sym_QMARK] = ACTIONS(1502),
    [anon_sym_TILDE] = ACTIONS(1502),
    [anon_sym_BANG] = ACTIONS(1500),
    [anon_sym_PLUS] = ACTIONS(1502),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_LT_DASH] = ACTIONS(1502),
    [anon_sym_LT_LT_DASH] = ACTIONS(1502),
    [anon_sym_COLON_EQ] = ACTIONS(1502),
    [anon_sym_DASH_GT] = ACTIONS(1500),
    [anon_sym_DASH_GT_GT] = ACTIONS(1502),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_AMP] = ACTIONS(1500),
    [anon_sym_PIPE_PIPE] = ACTIONS(1502),
    [anon_sym_AMP_AMP] = ACTIONS(1502),
    [anon_sym_LT] = ACTIONS(1500),
    [anon_sym_LT_EQ] = ACTIONS(1502),
    [anon_sym_GT] = ACTIONS(1500),
    [anon_sym_GT_EQ] = ACTIONS(1502),
    [anon_sym_EQ_EQ] = ACTIONS(1502),
    [anon_sym_BANG_EQ] = ACTIONS(1502),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1502),
    [anon_sym_STAR_STAR] = ACTIONS(1502),
    [anon_sym_CARET] = ACTIONS(1502),
    [aux_sym_binary_operator_token1] = ACTIONS(1502),
    [anon_sym_PIPE_GT] = ACTIONS(1502),
    [anon_sym_COLON] = ACTIONS(1500),
    [anon_sym_DOLLAR] = ACTIONS(1502),
    [anon_sym_AT] = ACTIONS(1502),
    [sym__hex_literal] = ACTIONS(1502),
    [sym__number_literal] = ACTIONS(1500),
    [anon_sym_SQUOTE] = ACTIONS(1502),
    [anon_sym_DQUOTE] = ACTIONS(1502),
    [sym_return] = ACTIONS(1500),
    [sym_next] = ACTIONS(1500),
    [sym_break] = ACTIONS(1500),
    [sym_true] = ACTIONS(1500),
    [sym_false] = ACTIONS(1500),
    [sym_null] = ACTIONS(1500),
    [sym_inf] = ACTIONS(1500),
    [sym_nan] = ACTIONS(1500),
    [anon_sym_NA] = ACTIONS(1500),
    [anon_sym_NA_integer_] = ACTIONS(1500),
    [anon_sym_NA_real_] = ACTIONS(1500),
    [anon_sym_NA_complex_] = ACTIONS(1500),
    [anon_sym_NA_character_] = ACTIONS(1500),
    [sym_dots] = ACTIONS(1500),
    [sym_dot_dot_i] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1502),
    [sym__newline] = ACTIONS(1502),
    [sym__raw_string_literal] = ACTIONS(1502),
    [sym__external_open_parenthesis] = ACTIONS(1502),
    [sym__external_open_brace] = ACTIONS(1502),
    [sym__external_open_bracket] = ACTIONS(1502),
    [sym__external_open_bracket2] = ACTIONS(1502),
    [sym__external_close_bracket2] = ACTIONS(1502),
  },
  [897] = {
    [sym_identifier] = ACTIONS(1527),
    [anon_sym_BSLASH] = ACTIONS(1529),
    [anon_sym_function] = ACTIONS(1527),
    [anon_sym_EQ] = ACTIONS(1527),
    [anon_sym_if] = ACTIONS(1527),
    [anon_sym_for] = ACTIONS(1527),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_repeat] = ACTIONS(1527),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_TILDE] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1527),
    [anon_sym_LT_DASH] = ACTIONS(1529),
    [anon_sym_LT_LT_DASH] = ACTIONS(1529),
    [anon_sym_COLON_EQ] = ACTIONS(1529),
    [anon_sym_DASH_GT] = ACTIONS(1527),
    [anon_sym_DASH_GT_GT] = ACTIONS(1529),
    [anon_sym_PIPE] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1527),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1527),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1529),
    [anon_sym_BANG_EQ] = ACTIONS(1529),
    [anon_sym_STAR] = ACTIONS(1527),
    [anon_sym_SLASH] = ACTIONS(1529),
    [anon_sym_STAR_STAR] = ACTIONS(1529),
    [anon_sym_CARET] = ACTIONS(1529),
    [aux_sym_binary_operator_token1] = ACTIONS(1529),
    [anon_sym_PIPE_GT] = ACTIONS(1529),
    [anon_sym_COLON] = ACTIONS(1527),
    [anon_sym_DOLLAR] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(1529),
    [sym__hex_literal] = ACTIONS(1529),
    [sym__number_literal] = ACTIONS(1527),
    [anon_sym_SQUOTE] = ACTIONS(1529),
    [anon_sym_DQUOTE] = ACTIONS(1529),
    [sym_return] = ACTIONS(1527),
    [sym_next] = ACTIONS(1527),
    [sym_break] = ACTIONS(1527),
    [sym_true] = ACTIONS(1527),
    [sym_false] = ACTIONS(1527),
    [sym_null] = ACTIONS(1527),
    [sym_inf] = ACTIONS(1527),
    [sym_nan] = ACTIONS(1527),
    [anon_sym_NA] = ACTIONS(1527),
    [anon_sym_NA_integer_] = ACTIONS(1527),
    [anon_sym_NA_real_] = ACTIONS(1527),
    [anon_sym_NA_complex_] = ACTIONS(1527),
    [anon_sym_NA_character_] = ACTIONS(1527),
    [sym_dots] = ACTIONS(1527),
    [sym_dot_dot_i] = ACTIONS(1529),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1529),
    [sym__newline] = ACTIONS(1529),
    [sym__raw_string_literal] = ACTIONS(1529),
    [sym__external_open_parenthesis] = ACTIONS(1529),
    [sym__external_close_parenthesis] = ACTIONS(1529),
    [sym__external_open_brace] = ACTIONS(1529),
    [sym__external_open_bracket] = ACTIONS(1529),
    [sym__external_open_bracket2] = ACTIONS(1529),
  },
  [898] = {
    [sym_identifier] = ACTIONS(1533),
    [anon_sym_BSLASH] = ACTIONS(1531),
    [anon_sym_function] = ACTIONS(1533),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_if] = ACTIONS(1533),
    [anon_sym_for] = ACTIONS(1533),
    [anon_sym_while] = ACTIONS(1533),
    [anon_sym_repeat] = ACTIONS(1533),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_LT_DASH] = ACTIONS(1531),
    [anon_sym_LT_LT_DASH] = ACTIONS(1531),
    [anon_sym_COLON_EQ] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1533),
    [anon_sym_DASH_GT_GT] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1531),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_CARET] = ACTIONS(1531),
    [aux_sym_binary_operator_token1] = ACTIONS(1531),
    [anon_sym_PIPE_GT] = ACTIONS(1531),
    [anon_sym_COLON] = ACTIONS(1533),
    [anon_sym_DOLLAR] = ACTIONS(1531),
    [anon_sym_AT] = ACTIONS(1531),
    [sym__hex_literal] = ACTIONS(1531),
    [sym__number_literal] = ACTIONS(1533),
    [anon_sym_SQUOTE] = ACTIONS(1531),
    [anon_sym_DQUOTE] = ACTIONS(1531),
    [sym_return] = ACTIONS(1533),
    [sym_next] = ACTIONS(1533),
    [sym_break] = ACTIONS(1533),
    [sym_true] = ACTIONS(1533),
    [sym_false] = ACTIONS(1533),
    [sym_null] = ACTIONS(1533),
    [sym_inf] = ACTIONS(1533),
    [sym_nan] = ACTIONS(1533),
    [anon_sym_NA] = ACTIONS(1533),
    [anon_sym_NA_integer_] = ACTIONS(1533),
    [anon_sym_NA_real_] = ACTIONS(1533),
    [anon_sym_NA_complex_] = ACTIONS(1533),
    [anon_sym_NA_character_] = ACTIONS(1533),
    [sym_dots] = ACTIONS(1533),
    [sym_dot_dot_i] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1531),
    [sym__semicolon] = ACTIONS(1531),
    [sym__raw_string_literal] = ACTIONS(1531),
    [sym__external_open_parenthesis] = ACTIONS(1531),
    [sym__external_open_brace] = ACTIONS(1531),
    [sym__external_close_brace] = ACTIONS(1531),
    [sym__external_open_bracket] = ACTIONS(1531),
    [sym__external_open_bracket2] = ACTIONS(1531),
  },
  [899] = {
    [sym_identifier] = ACTIONS(1480),
    [anon_sym_BSLASH] = ACTIONS(1482),
    [anon_sym_function] = ACTIONS(1480),
    [anon_sym_EQ] = ACTIONS(1480),
    [anon_sym_if] = ACTIONS(1480),
    [anon_sym_for] = ACTIONS(1480),
    [anon_sym_while] = ACTIONS(1480),
    [anon_sym_repeat] = ACTIONS(1480),
    [anon_sym_QMARK] = ACTIONS(1482),
    [anon_sym_TILDE] = ACTIONS(1482),
    [anon_sym_BANG] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1482),
    [anon_sym_DASH] = ACTIONS(1480),
    [anon_sym_LT_DASH] = ACTIONS(1482),
    [anon_sym_LT_LT_DASH] = ACTIONS(1482),
    [anon_sym_COLON_EQ] = ACTIONS(1482),
    [anon_sym_DASH_GT] = ACTIONS(1480),
    [anon_sym_DASH_GT_GT] = ACTIONS(1482),
    [anon_sym_PIPE] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1480),
    [anon_sym_PIPE_PIPE] = ACTIONS(1482),
    [anon_sym_AMP_AMP] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(1480),
    [anon_sym_LT_EQ] = ACTIONS(1482),
    [anon_sym_GT] = ACTIONS(1480),
    [anon_sym_GT_EQ] = ACTIONS(1482),
    [anon_sym_EQ_EQ] = ACTIONS(1482),
    [anon_sym_BANG_EQ] = ACTIONS(1482),
    [anon_sym_STAR] = ACTIONS(1480),
    [anon_sym_SLASH] = ACTIONS(1482),
    [anon_sym_STAR_STAR] = ACTIONS(1482),
    [anon_sym_CARET] = ACTIONS(1482),
    [aux_sym_binary_operator_token1] = ACTIONS(1482),
    [anon_sym_PIPE_GT] = ACTIONS(1482),
    [anon_sym_COLON] = ACTIONS(1480),
    [anon_sym_DOLLAR] = ACTIONS(1482),
    [anon_sym_AT] = ACTIONS(1482),
    [sym__hex_literal] = ACTIONS(1482),
    [sym__number_literal] = ACTIONS(1480),
    [anon_sym_SQUOTE] = ACTIONS(1482),
    [anon_sym_DQUOTE] = ACTIONS(1482),
    [sym_return] = ACTIONS(1480),
    [sym_next] = ACTIONS(1480),
    [sym_break] = ACTIONS(1480),
    [sym_true] = ACTIONS(1480),
    [sym_false] = ACTIONS(1480),
    [sym_null] = ACTIONS(1480),
    [sym_inf] = ACTIONS(1480),
    [sym_nan] = ACTIONS(1480),
    [anon_sym_NA] = ACTIONS(1480),
    [anon_sym_NA_integer_] = ACTIONS(1480),
    [anon_sym_NA_real_] = ACTIONS(1480),
    [anon_sym_NA_complex_] = ACTIONS(1480),
    [anon_sym_NA_character_] = ACTIONS(1480),
    [sym_dots] = ACTIONS(1480),
    [sym_dot_dot_i] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1482),
    [sym__newline] = ACTIONS(1482),
    [sym__raw_string_literal] = ACTIONS(1482),
    [sym__external_open_parenthesis] = ACTIONS(1482),
    [sym__external_open_brace] = ACTIONS(1482),
    [sym__external_open_bracket] = ACTIONS(1482),
    [sym__external_open_bracket2] = ACTIONS(1482),
    [sym__external_close_bracket2] = ACTIONS(1482),
  },
  [900] = {
    [sym_identifier] = ACTIONS(1484),
    [anon_sym_BSLASH] = ACTIONS(1486),
    [anon_sym_function] = ACTIONS(1484),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_if] = ACTIONS(1484),
    [anon_sym_for] = ACTIONS(1484),
    [anon_sym_while] = ACTIONS(1484),
    [anon_sym_repeat] = ACTIONS(1484),
    [anon_sym_QMARK] = ACTIONS(1486),
    [anon_sym_TILDE] = ACTIONS(1486),
    [anon_sym_BANG] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_LT_DASH] = ACTIONS(1486),
    [anon_sym_LT_LT_DASH] = ACTIONS(1486),
    [anon_sym_COLON_EQ] = ACTIONS(1486),
    [anon_sym_DASH_GT] = ACTIONS(1484),
    [anon_sym_DASH_GT_GT] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1484),
    [anon_sym_AMP] = ACTIONS(1484),
    [anon_sym_PIPE_PIPE] = ACTIONS(1486),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_LT] = ACTIONS(1484),
    [anon_sym_LT_EQ] = ACTIONS(1486),
    [anon_sym_GT] = ACTIONS(1484),
    [anon_sym_GT_EQ] = ACTIONS(1486),
    [anon_sym_EQ_EQ] = ACTIONS(1486),
    [anon_sym_BANG_EQ] = ACTIONS(1486),
    [anon_sym_STAR] = ACTIONS(1484),
    [anon_sym_SLASH] = ACTIONS(1486),
    [anon_sym_STAR_STAR] = ACTIONS(1486),
    [anon_sym_CARET] = ACTIONS(1486),
    [aux_sym_binary_operator_token1] = ACTIONS(1486),
    [anon_sym_PIPE_GT] = ACTIONS(1486),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(1486),
    [anon_sym_AT] = ACTIONS(1486),
    [sym__hex_literal] = ACTIONS(1486),
    [sym__number_literal] = ACTIONS(1484),
    [anon_sym_SQUOTE] = ACTIONS(1486),
    [anon_sym_DQUOTE] = ACTIONS(1486),
    [sym_return] = ACTIONS(1484),
    [sym_next] = ACTIONS(1484),
    [sym_break] = ACTIONS(1484),
    [sym_true] = ACTIONS(1484),
    [sym_false] = ACTIONS(1484),
    [sym_null] = ACTIONS(1484),
    [sym_inf] = ACTIONS(1484),
    [sym_nan] = ACTIONS(1484),
    [anon_sym_NA] = ACTIONS(1484),
    [anon_sym_NA_integer_] = ACTIONS(1484),
    [anon_sym_NA_real_] = ACTIONS(1484),
    [anon_sym_NA_complex_] = ACTIONS(1484),
    [anon_sym_NA_character_] = ACTIONS(1484),
    [sym_dots] = ACTIONS(1484),
    [sym_dot_dot_i] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1486),
    [sym__newline] = ACTIONS(1486),
    [sym__raw_string_literal] = ACTIONS(1486),
    [sym__external_open_parenthesis] = ACTIONS(1486),
    [sym__external_open_brace] = ACTIONS(1486),
    [sym__external_open_bracket] = ACTIONS(1486),
    [sym__external_open_bracket2] = ACTIONS(1486),
    [sym__external_close_bracket2] = ACTIONS(1486),
  },
  [901] = {
    [sym_identifier] = ACTIONS(1472),
    [anon_sym_BSLASH] = ACTIONS(1474),
    [anon_sym_function] = ACTIONS(1472),
    [anon_sym_EQ] = ACTIONS(1472),
    [anon_sym_if] = ACTIONS(1472),
    [anon_sym_for] = ACTIONS(1472),
    [anon_sym_while] = ACTIONS(1472),
    [anon_sym_repeat] = ACTIONS(1472),
    [anon_sym_QMARK] = ACTIONS(1474),
    [anon_sym_TILDE] = ACTIONS(1474),
    [anon_sym_BANG] = ACTIONS(1472),
    [anon_sym_PLUS] = ACTIONS(1474),
    [anon_sym_DASH] = ACTIONS(1472),
    [anon_sym_LT_DASH] = ACTIONS(1474),
    [anon_sym_LT_LT_DASH] = ACTIONS(1474),
    [anon_sym_COLON_EQ] = ACTIONS(1474),
    [anon_sym_DASH_GT] = ACTIONS(1472),
    [anon_sym_DASH_GT_GT] = ACTIONS(1474),
    [anon_sym_PIPE] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1472),
    [anon_sym_PIPE_PIPE] = ACTIONS(1474),
    [anon_sym_AMP_AMP] = ACTIONS(1474),
    [anon_sym_LT] = ACTIONS(1472),
    [anon_sym_LT_EQ] = ACTIONS(1474),
    [anon_sym_GT] = ACTIONS(1472),
    [anon_sym_GT_EQ] = ACTIONS(1474),
    [anon_sym_EQ_EQ] = ACTIONS(1474),
    [anon_sym_BANG_EQ] = ACTIONS(1474),
    [anon_sym_STAR] = ACTIONS(1472),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_STAR_STAR] = ACTIONS(1474),
    [anon_sym_CARET] = ACTIONS(1474),
    [aux_sym_binary_operator_token1] = ACTIONS(1474),
    [anon_sym_PIPE_GT] = ACTIONS(1474),
    [anon_sym_COLON] = ACTIONS(1472),
    [anon_sym_DOLLAR] = ACTIONS(1474),
    [anon_sym_AT] = ACTIONS(1474),
    [sym__hex_literal] = ACTIONS(1474),
    [sym__number_literal] = ACTIONS(1472),
    [anon_sym_SQUOTE] = ACTIONS(1474),
    [anon_sym_DQUOTE] = ACTIONS(1474),
    [sym_return] = ACTIONS(1472),
    [sym_next] = ACTIONS(1472),
    [sym_break] = ACTIONS(1472),
    [sym_true] = ACTIONS(1472),
    [sym_false] = ACTIONS(1472),
    [sym_null] = ACTIONS(1472),
    [sym_inf] = ACTIONS(1472),
    [sym_nan] = ACTIONS(1472),
    [anon_sym_NA] = ACTIONS(1472),
    [anon_sym_NA_integer_] = ACTIONS(1472),
    [anon_sym_NA_real_] = ACTIONS(1472),
    [anon_sym_NA_complex_] = ACTIONS(1472),
    [anon_sym_NA_character_] = ACTIONS(1472),
    [sym_dots] = ACTIONS(1472),
    [sym_dot_dot_i] = ACTIONS(1474),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1474),
    [sym__newline] = ACTIONS(1474),
    [sym__raw_string_literal] = ACTIONS(1474),
    [sym__external_open_parenthesis] = ACTIONS(1474),
    [sym__external_open_brace] = ACTIONS(1474),
    [sym__external_open_bracket] = ACTIONS(1474),
    [sym__external_open_bracket2] = ACTIONS(1474),
    [sym__external_close_bracket2] = ACTIONS(1474),
  },
  [902] = {
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_BSLASH] = ACTIONS(1525),
    [anon_sym_function] = ACTIONS(1523),
    [anon_sym_EQ] = ACTIONS(1523),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_for] = ACTIONS(1523),
    [anon_sym_while] = ACTIONS(1523),
    [anon_sym_repeat] = ACTIONS(1523),
    [anon_sym_QMARK] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(1525),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1523),
    [anon_sym_LT_DASH] = ACTIONS(1525),
    [anon_sym_LT_LT_DASH] = ACTIONS(1525),
    [anon_sym_COLON_EQ] = ACTIONS(1525),
    [anon_sym_DASH_GT] = ACTIONS(1523),
    [anon_sym_DASH_GT_GT] = ACTIONS(1525),
    [anon_sym_PIPE] = ACTIONS(1523),
    [anon_sym_AMP] = ACTIONS(1523),
    [anon_sym_PIPE_PIPE] = ACTIONS(1525),
    [anon_sym_AMP_AMP] = ACTIONS(1525),
    [anon_sym_LT] = ACTIONS(1523),
    [anon_sym_LT_EQ] = ACTIONS(1525),
    [anon_sym_GT] = ACTIONS(1523),
    [anon_sym_GT_EQ] = ACTIONS(1525),
    [anon_sym_EQ_EQ] = ACTIONS(1525),
    [anon_sym_BANG_EQ] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1523),
    [anon_sym_SLASH] = ACTIONS(1525),
    [anon_sym_STAR_STAR] = ACTIONS(1525),
    [anon_sym_CARET] = ACTIONS(1525),
    [aux_sym_binary_operator_token1] = ACTIONS(1525),
    [anon_sym_PIPE_GT] = ACTIONS(1525),
    [anon_sym_COLON] = ACTIONS(1523),
    [anon_sym_DOLLAR] = ACTIONS(1525),
    [anon_sym_AT] = ACTIONS(1525),
    [sym__hex_literal] = ACTIONS(1525),
    [sym__number_literal] = ACTIONS(1523),
    [anon_sym_SQUOTE] = ACTIONS(1525),
    [anon_sym_DQUOTE] = ACTIONS(1525),
    [sym_return] = ACTIONS(1523),
    [sym_next] = ACTIONS(1523),
    [sym_break] = ACTIONS(1523),
    [sym_true] = ACTIONS(1523),
    [sym_false] = ACTIONS(1523),
    [sym_null] = ACTIONS(1523),
    [sym_inf] = ACTIONS(1523),
    [sym_nan] = ACTIONS(1523),
    [anon_sym_NA] = ACTIONS(1523),
    [anon_sym_NA_integer_] = ACTIONS(1523),
    [anon_sym_NA_real_] = ACTIONS(1523),
    [anon_sym_NA_complex_] = ACTIONS(1523),
    [anon_sym_NA_character_] = ACTIONS(1523),
    [sym_dots] = ACTIONS(1523),
    [sym_dot_dot_i] = ACTIONS(1525),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1525),
    [sym__newline] = ACTIONS(1525),
    [sym__raw_string_literal] = ACTIONS(1525),
    [sym__external_open_parenthesis] = ACTIONS(1525),
    [sym__external_open_brace] = ACTIONS(1525),
    [sym__external_open_bracket] = ACTIONS(1525),
    [sym__external_close_bracket] = ACTIONS(1525),
    [sym__external_open_bracket2] = ACTIONS(1525),
  },
  [903] = {
    [sym_identifier] = ACTIONS(1472),
    [anon_sym_BSLASH] = ACTIONS(1474),
    [anon_sym_function] = ACTIONS(1472),
    [anon_sym_EQ] = ACTIONS(1472),
    [anon_sym_if] = ACTIONS(1472),
    [anon_sym_for] = ACTIONS(1472),
    [anon_sym_while] = ACTIONS(1472),
    [anon_sym_repeat] = ACTIONS(1472),
    [anon_sym_QMARK] = ACTIONS(1474),
    [anon_sym_TILDE] = ACTIONS(1474),
    [anon_sym_BANG] = ACTIONS(1472),
    [anon_sym_PLUS] = ACTIONS(1474),
    [anon_sym_DASH] = ACTIONS(1472),
    [anon_sym_LT_DASH] = ACTIONS(1474),
    [anon_sym_LT_LT_DASH] = ACTIONS(1474),
    [anon_sym_COLON_EQ] = ACTIONS(1474),
    [anon_sym_DASH_GT] = ACTIONS(1472),
    [anon_sym_DASH_GT_GT] = ACTIONS(1474),
    [anon_sym_PIPE] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1472),
    [anon_sym_PIPE_PIPE] = ACTIONS(1474),
    [anon_sym_AMP_AMP] = ACTIONS(1474),
    [anon_sym_LT] = ACTIONS(1472),
    [anon_sym_LT_EQ] = ACTIONS(1474),
    [anon_sym_GT] = ACTIONS(1472),
    [anon_sym_GT_EQ] = ACTIONS(1474),
    [anon_sym_EQ_EQ] = ACTIONS(1474),
    [anon_sym_BANG_EQ] = ACTIONS(1474),
    [anon_sym_STAR] = ACTIONS(1472),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_STAR_STAR] = ACTIONS(1474),
    [anon_sym_CARET] = ACTIONS(1474),
    [aux_sym_binary_operator_token1] = ACTIONS(1474),
    [anon_sym_PIPE_GT] = ACTIONS(1474),
    [anon_sym_COLON] = ACTIONS(1472),
    [anon_sym_DOLLAR] = ACTIONS(1474),
    [anon_sym_AT] = ACTIONS(1474),
    [sym__hex_literal] = ACTIONS(1474),
    [sym__number_literal] = ACTIONS(1472),
    [anon_sym_SQUOTE] = ACTIONS(1474),
    [anon_sym_DQUOTE] = ACTIONS(1474),
    [sym_return] = ACTIONS(1472),
    [sym_next] = ACTIONS(1472),
    [sym_break] = ACTIONS(1472),
    [sym_true] = ACTIONS(1472),
    [sym_false] = ACTIONS(1472),
    [sym_null] = ACTIONS(1472),
    [sym_inf] = ACTIONS(1472),
    [sym_nan] = ACTIONS(1472),
    [anon_sym_NA] = ACTIONS(1472),
    [anon_sym_NA_integer_] = ACTIONS(1472),
    [anon_sym_NA_real_] = ACTIONS(1472),
    [anon_sym_NA_complex_] = ACTIONS(1472),
    [anon_sym_NA_character_] = ACTIONS(1472),
    [sym_dots] = ACTIONS(1472),
    [sym_dot_dot_i] = ACTIONS(1474),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1474),
    [sym__newline] = ACTIONS(1474),
    [sym__raw_string_literal] = ACTIONS(1474),
    [sym__external_open_parenthesis] = ACTIONS(1474),
    [sym__external_close_parenthesis] = ACTIONS(1474),
    [sym__external_open_brace] = ACTIONS(1474),
    [sym__external_open_bracket] = ACTIONS(1474),
    [sym__external_open_bracket2] = ACTIONS(1474),
  },
  [904] = {
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_BSLASH] = ACTIONS(1506),
    [anon_sym_function] = ACTIONS(1504),
    [anon_sym_EQ] = ACTIONS(1504),
    [anon_sym_if] = ACTIONS(1504),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1504),
    [anon_sym_repeat] = ACTIONS(1504),
    [anon_sym_QMARK] = ACTIONS(1506),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_BANG] = ACTIONS(1504),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1504),
    [anon_sym_LT_DASH] = ACTIONS(1506),
    [anon_sym_LT_LT_DASH] = ACTIONS(1506),
    [anon_sym_COLON_EQ] = ACTIONS(1506),
    [anon_sym_DASH_GT] = ACTIONS(1504),
    [anon_sym_DASH_GT_GT] = ACTIONS(1506),
    [anon_sym_PIPE] = ACTIONS(1504),
    [anon_sym_AMP] = ACTIONS(1504),
    [anon_sym_PIPE_PIPE] = ACTIONS(1506),
    [anon_sym_AMP_AMP] = ACTIONS(1506),
    [anon_sym_LT] = ACTIONS(1504),
    [anon_sym_LT_EQ] = ACTIONS(1506),
    [anon_sym_GT] = ACTIONS(1504),
    [anon_sym_GT_EQ] = ACTIONS(1506),
    [anon_sym_EQ_EQ] = ACTIONS(1506),
    [anon_sym_BANG_EQ] = ACTIONS(1506),
    [anon_sym_STAR] = ACTIONS(1504),
    [anon_sym_SLASH] = ACTIONS(1506),
    [anon_sym_STAR_STAR] = ACTIONS(1506),
    [anon_sym_CARET] = ACTIONS(1506),
    [aux_sym_binary_operator_token1] = ACTIONS(1506),
    [anon_sym_PIPE_GT] = ACTIONS(1506),
    [anon_sym_COLON] = ACTIONS(1504),
    [anon_sym_DOLLAR] = ACTIONS(1506),
    [anon_sym_AT] = ACTIONS(1506),
    [sym__hex_literal] = ACTIONS(1506),
    [sym__number_literal] = ACTIONS(1504),
    [anon_sym_SQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1506),
    [sym_return] = ACTIONS(1504),
    [sym_next] = ACTIONS(1504),
    [sym_break] = ACTIONS(1504),
    [sym_true] = ACTIONS(1504),
    [sym_false] = ACTIONS(1504),
    [sym_null] = ACTIONS(1504),
    [sym_inf] = ACTIONS(1504),
    [sym_nan] = ACTIONS(1504),
    [anon_sym_NA] = ACTIONS(1504),
    [anon_sym_NA_integer_] = ACTIONS(1504),
    [anon_sym_NA_real_] = ACTIONS(1504),
    [anon_sym_NA_complex_] = ACTIONS(1504),
    [anon_sym_NA_character_] = ACTIONS(1504),
    [sym_dots] = ACTIONS(1504),
    [sym_dot_dot_i] = ACTIONS(1506),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1506),
    [sym__newline] = ACTIONS(1506),
    [sym__raw_string_literal] = ACTIONS(1506),
    [sym__external_open_parenthesis] = ACTIONS(1506),
    [sym__external_open_brace] = ACTIONS(1506),
    [sym__external_open_bracket] = ACTIONS(1506),
    [sym__external_open_bracket2] = ACTIONS(1506),
    [sym__external_close_bracket2] = ACTIONS(1506),
  },
  [905] = {
    [sym_identifier] = ACTIONS(1527),
    [anon_sym_BSLASH] = ACTIONS(1529),
    [anon_sym_function] = ACTIONS(1527),
    [anon_sym_EQ] = ACTIONS(1527),
    [anon_sym_if] = ACTIONS(1527),
    [anon_sym_for] = ACTIONS(1527),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_repeat] = ACTIONS(1527),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_TILDE] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1527),
    [anon_sym_LT_DASH] = ACTIONS(1529),
    [anon_sym_LT_LT_DASH] = ACTIONS(1529),
    [anon_sym_COLON_EQ] = ACTIONS(1529),
    [anon_sym_DASH_GT] = ACTIONS(1527),
    [anon_sym_DASH_GT_GT] = ACTIONS(1529),
    [anon_sym_PIPE] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1527),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1527),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1529),
    [anon_sym_BANG_EQ] = ACTIONS(1529),
    [anon_sym_STAR] = ACTIONS(1527),
    [anon_sym_SLASH] = ACTIONS(1529),
    [anon_sym_STAR_STAR] = ACTIONS(1529),
    [anon_sym_CARET] = ACTIONS(1529),
    [aux_sym_binary_operator_token1] = ACTIONS(1529),
    [anon_sym_PIPE_GT] = ACTIONS(1529),
    [anon_sym_COLON] = ACTIONS(1527),
    [anon_sym_DOLLAR] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(1529),
    [sym__hex_literal] = ACTIONS(1529),
    [sym__number_literal] = ACTIONS(1527),
    [anon_sym_SQUOTE] = ACTIONS(1529),
    [anon_sym_DQUOTE] = ACTIONS(1529),
    [sym_return] = ACTIONS(1527),
    [sym_next] = ACTIONS(1527),
    [sym_break] = ACTIONS(1527),
    [sym_true] = ACTIONS(1527),
    [sym_false] = ACTIONS(1527),
    [sym_null] = ACTIONS(1527),
    [sym_inf] = ACTIONS(1527),
    [sym_nan] = ACTIONS(1527),
    [anon_sym_NA] = ACTIONS(1527),
    [anon_sym_NA_integer_] = ACTIONS(1527),
    [anon_sym_NA_real_] = ACTIONS(1527),
    [anon_sym_NA_complex_] = ACTIONS(1527),
    [anon_sym_NA_character_] = ACTIONS(1527),
    [sym_dots] = ACTIONS(1527),
    [sym_dot_dot_i] = ACTIONS(1529),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1529),
    [sym__newline] = ACTIONS(1529),
    [sym__raw_string_literal] = ACTIONS(1529),
    [sym__external_open_parenthesis] = ACTIONS(1529),
    [sym__external_open_brace] = ACTIONS(1529),
    [sym__external_open_bracket] = ACTIONS(1529),
    [sym__external_close_bracket] = ACTIONS(1529),
    [sym__external_open_bracket2] = ACTIONS(1529),
  },
  [906] = {
    [sym_identifier] = ACTIONS(1476),
    [anon_sym_BSLASH] = ACTIONS(1478),
    [anon_sym_function] = ACTIONS(1476),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_if] = ACTIONS(1476),
    [anon_sym_for] = ACTIONS(1476),
    [anon_sym_while] = ACTIONS(1476),
    [anon_sym_repeat] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_BANG] = ACTIONS(1476),
    [anon_sym_PLUS] = ACTIONS(1478),
    [anon_sym_DASH] = ACTIONS(1476),
    [anon_sym_LT_DASH] = ACTIONS(1478),
    [anon_sym_LT_LT_DASH] = ACTIONS(1478),
    [anon_sym_COLON_EQ] = ACTIONS(1478),
    [anon_sym_DASH_GT] = ACTIONS(1476),
    [anon_sym_DASH_GT_GT] = ACTIONS(1478),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1478),
    [anon_sym_AMP_AMP] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_EQ] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_GT_EQ] = ACTIONS(1478),
    [anon_sym_EQ_EQ] = ACTIONS(1478),
    [anon_sym_BANG_EQ] = ACTIONS(1478),
    [anon_sym_STAR] = ACTIONS(1476),
    [anon_sym_SLASH] = ACTIONS(1478),
    [anon_sym_STAR_STAR] = ACTIONS(1478),
    [anon_sym_CARET] = ACTIONS(1478),
    [aux_sym_binary_operator_token1] = ACTIONS(1478),
    [anon_sym_PIPE_GT] = ACTIONS(1478),
    [anon_sym_COLON] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1478),
    [anon_sym_AT] = ACTIONS(1478),
    [sym__hex_literal] = ACTIONS(1478),
    [sym__number_literal] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_DQUOTE] = ACTIONS(1478),
    [sym_return] = ACTIONS(1476),
    [sym_next] = ACTIONS(1476),
    [sym_break] = ACTIONS(1476),
    [sym_true] = ACTIONS(1476),
    [sym_false] = ACTIONS(1476),
    [sym_null] = ACTIONS(1476),
    [sym_inf] = ACTIONS(1476),
    [sym_nan] = ACTIONS(1476),
    [anon_sym_NA] = ACTIONS(1476),
    [anon_sym_NA_integer_] = ACTIONS(1476),
    [anon_sym_NA_real_] = ACTIONS(1476),
    [anon_sym_NA_complex_] = ACTIONS(1476),
    [anon_sym_NA_character_] = ACTIONS(1476),
    [sym_dots] = ACTIONS(1476),
    [sym_dot_dot_i] = ACTIONS(1478),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1478),
    [sym__newline] = ACTIONS(1478),
    [sym__raw_string_literal] = ACTIONS(1478),
    [sym__external_open_parenthesis] = ACTIONS(1478),
    [sym__external_open_brace] = ACTIONS(1478),
    [sym__external_open_bracket] = ACTIONS(1478),
    [sym__external_open_bracket2] = ACTIONS(1478),
    [sym__external_close_bracket2] = ACTIONS(1478),
  },
  [907] = {
    [sym_function_definition] = STATE(631),
    [sym_if_statement] = STATE(631),
    [sym_for_statement] = STATE(631),
    [sym_while_statement] = STATE(631),
    [sym_repeat_statement] = STATE(631),
    [sym_braced_expression] = STATE(631),
    [sym_parenthesized_expression] = STATE(631),
    [sym_call] = STATE(631),
    [sym_subset] = STATE(631),
    [sym_subset2] = STATE(631),
    [sym_unary_operator] = STATE(631),
    [sym_binary_operator] = STATE(631),
    [sym_extract_operator] = STATE(631),
    [sym_namespace_operator] = STATE(631),
    [sym_integer] = STATE(631),
    [sym_complex] = STATE(631),
    [sym_float] = STATE(631),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(739),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(631),
    [sym__expression] = STATE(631),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(910),
    [sym__open_brace] = STATE(842),
    [aux_sym_parenthesized_expression_repeat1] = STATE(927),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(1679),
    [sym_next] = ACTIONS(1679),
    [sym_break] = ACTIONS(1679),
    [sym_true] = ACTIONS(1679),
    [sym_false] = ACTIONS(1679),
    [sym_null] = ACTIONS(1679),
    [sym_inf] = ACTIONS(1679),
    [sym_nan] = ACTIONS(1679),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(1679),
    [sym_dot_dot_i] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1683),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1685),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [908] = {
    [sym_identifier] = ACTIONS(1533),
    [anon_sym_BSLASH] = ACTIONS(1531),
    [anon_sym_function] = ACTIONS(1533),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_if] = ACTIONS(1533),
    [anon_sym_for] = ACTIONS(1533),
    [anon_sym_while] = ACTIONS(1533),
    [anon_sym_repeat] = ACTIONS(1533),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_LT_DASH] = ACTIONS(1531),
    [anon_sym_LT_LT_DASH] = ACTIONS(1531),
    [anon_sym_COLON_EQ] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1533),
    [anon_sym_DASH_GT_GT] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1531),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_CARET] = ACTIONS(1531),
    [aux_sym_binary_operator_token1] = ACTIONS(1531),
    [anon_sym_PIPE_GT] = ACTIONS(1531),
    [anon_sym_COLON] = ACTIONS(1533),
    [anon_sym_DOLLAR] = ACTIONS(1531),
    [anon_sym_AT] = ACTIONS(1531),
    [sym__hex_literal] = ACTIONS(1531),
    [sym__number_literal] = ACTIONS(1533),
    [anon_sym_SQUOTE] = ACTIONS(1531),
    [anon_sym_DQUOTE] = ACTIONS(1531),
    [sym_return] = ACTIONS(1533),
    [sym_next] = ACTIONS(1533),
    [sym_break] = ACTIONS(1533),
    [sym_true] = ACTIONS(1533),
    [sym_false] = ACTIONS(1533),
    [sym_null] = ACTIONS(1533),
    [sym_inf] = ACTIONS(1533),
    [sym_nan] = ACTIONS(1533),
    [anon_sym_NA] = ACTIONS(1533),
    [anon_sym_NA_integer_] = ACTIONS(1533),
    [anon_sym_NA_real_] = ACTIONS(1533),
    [anon_sym_NA_complex_] = ACTIONS(1533),
    [anon_sym_NA_character_] = ACTIONS(1533),
    [sym_dots] = ACTIONS(1533),
    [sym_dot_dot_i] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1531),
    [sym__newline] = ACTIONS(1531),
    [sym__raw_string_literal] = ACTIONS(1531),
    [sym__external_open_parenthesis] = ACTIONS(1531),
    [sym__external_open_brace] = ACTIONS(1531),
    [sym__external_open_bracket] = ACTIONS(1531),
    [sym__external_close_bracket] = ACTIONS(1531),
    [sym__external_open_bracket2] = ACTIONS(1531),
  },
  [909] = {
    [sym_identifier] = ACTIONS(1508),
    [anon_sym_BSLASH] = ACTIONS(1510),
    [anon_sym_function] = ACTIONS(1508),
    [anon_sym_EQ] = ACTIONS(1508),
    [anon_sym_if] = ACTIONS(1508),
    [anon_sym_for] = ACTIONS(1508),
    [anon_sym_while] = ACTIONS(1508),
    [anon_sym_repeat] = ACTIONS(1508),
    [anon_sym_QMARK] = ACTIONS(1510),
    [anon_sym_TILDE] = ACTIONS(1510),
    [anon_sym_BANG] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1510),
    [anon_sym_DASH] = ACTIONS(1508),
    [anon_sym_LT_DASH] = ACTIONS(1510),
    [anon_sym_LT_LT_DASH] = ACTIONS(1510),
    [anon_sym_COLON_EQ] = ACTIONS(1510),
    [anon_sym_DASH_GT] = ACTIONS(1508),
    [anon_sym_DASH_GT_GT] = ACTIONS(1510),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PIPE_PIPE] = ACTIONS(1510),
    [anon_sym_AMP_AMP] = ACTIONS(1510),
    [anon_sym_LT] = ACTIONS(1508),
    [anon_sym_LT_EQ] = ACTIONS(1510),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_GT_EQ] = ACTIONS(1510),
    [anon_sym_EQ_EQ] = ACTIONS(1510),
    [anon_sym_BANG_EQ] = ACTIONS(1510),
    [anon_sym_STAR] = ACTIONS(1508),
    [anon_sym_SLASH] = ACTIONS(1510),
    [anon_sym_STAR_STAR] = ACTIONS(1510),
    [anon_sym_CARET] = ACTIONS(1510),
    [aux_sym_binary_operator_token1] = ACTIONS(1510),
    [anon_sym_PIPE_GT] = ACTIONS(1510),
    [anon_sym_COLON] = ACTIONS(1508),
    [anon_sym_DOLLAR] = ACTIONS(1510),
    [anon_sym_AT] = ACTIONS(1510),
    [sym__hex_literal] = ACTIONS(1510),
    [sym__number_literal] = ACTIONS(1508),
    [anon_sym_SQUOTE] = ACTIONS(1510),
    [anon_sym_DQUOTE] = ACTIONS(1510),
    [sym_return] = ACTIONS(1508),
    [sym_next] = ACTIONS(1508),
    [sym_break] = ACTIONS(1508),
    [sym_true] = ACTIONS(1508),
    [sym_false] = ACTIONS(1508),
    [sym_null] = ACTIONS(1508),
    [sym_inf] = ACTIONS(1508),
    [sym_nan] = ACTIONS(1508),
    [anon_sym_NA] = ACTIONS(1508),
    [anon_sym_NA_integer_] = ACTIONS(1508),
    [anon_sym_NA_real_] = ACTIONS(1508),
    [anon_sym_NA_complex_] = ACTIONS(1508),
    [anon_sym_NA_character_] = ACTIONS(1508),
    [sym_dots] = ACTIONS(1508),
    [sym_dot_dot_i] = ACTIONS(1510),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1510),
    [sym__newline] = ACTIONS(1510),
    [sym__raw_string_literal] = ACTIONS(1510),
    [sym__external_open_parenthesis] = ACTIONS(1510),
    [sym__external_open_brace] = ACTIONS(1510),
    [sym__external_open_bracket] = ACTIONS(1510),
    [sym__external_open_bracket2] = ACTIONS(1510),
    [sym__external_close_bracket2] = ACTIONS(1510),
  },
  [910] = {
    [sym_identifier] = ACTIONS(1480),
    [anon_sym_BSLASH] = ACTIONS(1482),
    [anon_sym_function] = ACTIONS(1480),
    [anon_sym_EQ] = ACTIONS(1480),
    [anon_sym_if] = ACTIONS(1480),
    [anon_sym_for] = ACTIONS(1480),
    [anon_sym_while] = ACTIONS(1480),
    [anon_sym_repeat] = ACTIONS(1480),
    [anon_sym_QMARK] = ACTIONS(1482),
    [anon_sym_TILDE] = ACTIONS(1482),
    [anon_sym_BANG] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1482),
    [anon_sym_DASH] = ACTIONS(1480),
    [anon_sym_LT_DASH] = ACTIONS(1482),
    [anon_sym_LT_LT_DASH] = ACTIONS(1482),
    [anon_sym_COLON_EQ] = ACTIONS(1482),
    [anon_sym_DASH_GT] = ACTIONS(1480),
    [anon_sym_DASH_GT_GT] = ACTIONS(1482),
    [anon_sym_PIPE] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1480),
    [anon_sym_PIPE_PIPE] = ACTIONS(1482),
    [anon_sym_AMP_AMP] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(1480),
    [anon_sym_LT_EQ] = ACTIONS(1482),
    [anon_sym_GT] = ACTIONS(1480),
    [anon_sym_GT_EQ] = ACTIONS(1482),
    [anon_sym_EQ_EQ] = ACTIONS(1482),
    [anon_sym_BANG_EQ] = ACTIONS(1482),
    [anon_sym_STAR] = ACTIONS(1480),
    [anon_sym_SLASH] = ACTIONS(1482),
    [anon_sym_STAR_STAR] = ACTIONS(1482),
    [anon_sym_CARET] = ACTIONS(1482),
    [aux_sym_binary_operator_token1] = ACTIONS(1482),
    [anon_sym_PIPE_GT] = ACTIONS(1482),
    [anon_sym_COLON] = ACTIONS(1480),
    [anon_sym_DOLLAR] = ACTIONS(1482),
    [anon_sym_AT] = ACTIONS(1482),
    [sym__hex_literal] = ACTIONS(1482),
    [sym__number_literal] = ACTIONS(1480),
    [anon_sym_SQUOTE] = ACTIONS(1482),
    [anon_sym_DQUOTE] = ACTIONS(1482),
    [sym_return] = ACTIONS(1480),
    [sym_next] = ACTIONS(1480),
    [sym_break] = ACTIONS(1480),
    [sym_true] = ACTIONS(1480),
    [sym_false] = ACTIONS(1480),
    [sym_null] = ACTIONS(1480),
    [sym_inf] = ACTIONS(1480),
    [sym_nan] = ACTIONS(1480),
    [anon_sym_NA] = ACTIONS(1480),
    [anon_sym_NA_integer_] = ACTIONS(1480),
    [anon_sym_NA_real_] = ACTIONS(1480),
    [anon_sym_NA_complex_] = ACTIONS(1480),
    [anon_sym_NA_character_] = ACTIONS(1480),
    [sym_dots] = ACTIONS(1480),
    [sym_dot_dot_i] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1482),
    [sym__newline] = ACTIONS(1482),
    [sym__raw_string_literal] = ACTIONS(1482),
    [sym__external_open_parenthesis] = ACTIONS(1482),
    [sym__external_close_parenthesis] = ACTIONS(1482),
    [sym__external_open_brace] = ACTIONS(1482),
    [sym__external_open_bracket] = ACTIONS(1482),
    [sym__external_open_bracket2] = ACTIONS(1482),
  },
  [911] = {
    [sym_identifier] = ACTIONS(1515),
    [anon_sym_BSLASH] = ACTIONS(1517),
    [anon_sym_function] = ACTIONS(1515),
    [anon_sym_EQ] = ACTIONS(1515),
    [anon_sym_if] = ACTIONS(1515),
    [anon_sym_for] = ACTIONS(1515),
    [anon_sym_while] = ACTIONS(1515),
    [anon_sym_repeat] = ACTIONS(1515),
    [anon_sym_QMARK] = ACTIONS(1517),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_DASH] = ACTIONS(1515),
    [anon_sym_LT_DASH] = ACTIONS(1517),
    [anon_sym_LT_LT_DASH] = ACTIONS(1517),
    [anon_sym_COLON_EQ] = ACTIONS(1517),
    [anon_sym_DASH_GT] = ACTIONS(1515),
    [anon_sym_DASH_GT_GT] = ACTIONS(1517),
    [anon_sym_PIPE] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_PIPE_PIPE] = ACTIONS(1517),
    [anon_sym_AMP_AMP] = ACTIONS(1517),
    [anon_sym_LT] = ACTIONS(1515),
    [anon_sym_LT_EQ] = ACTIONS(1517),
    [anon_sym_GT] = ACTIONS(1515),
    [anon_sym_GT_EQ] = ACTIONS(1517),
    [anon_sym_EQ_EQ] = ACTIONS(1517),
    [anon_sym_BANG_EQ] = ACTIONS(1517),
    [anon_sym_STAR] = ACTIONS(1515),
    [anon_sym_SLASH] = ACTIONS(1517),
    [anon_sym_STAR_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [aux_sym_binary_operator_token1] = ACTIONS(1517),
    [anon_sym_PIPE_GT] = ACTIONS(1517),
    [anon_sym_COLON] = ACTIONS(1515),
    [anon_sym_DOLLAR] = ACTIONS(1517),
    [anon_sym_AT] = ACTIONS(1517),
    [sym__hex_literal] = ACTIONS(1517),
    [sym__number_literal] = ACTIONS(1515),
    [anon_sym_SQUOTE] = ACTIONS(1517),
    [anon_sym_DQUOTE] = ACTIONS(1517),
    [sym_return] = ACTIONS(1515),
    [sym_next] = ACTIONS(1515),
    [sym_break] = ACTIONS(1515),
    [sym_true] = ACTIONS(1515),
    [sym_false] = ACTIONS(1515),
    [sym_null] = ACTIONS(1515),
    [sym_inf] = ACTIONS(1515),
    [sym_nan] = ACTIONS(1515),
    [anon_sym_NA] = ACTIONS(1515),
    [anon_sym_NA_integer_] = ACTIONS(1515),
    [anon_sym_NA_real_] = ACTIONS(1515),
    [anon_sym_NA_complex_] = ACTIONS(1515),
    [anon_sym_NA_character_] = ACTIONS(1515),
    [sym_dots] = ACTIONS(1515),
    [sym_dot_dot_i] = ACTIONS(1517),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1517),
    [sym__newline] = ACTIONS(1517),
    [sym__raw_string_literal] = ACTIONS(1517),
    [sym__external_open_parenthesis] = ACTIONS(1517),
    [sym__external_open_brace] = ACTIONS(1517),
    [sym__external_open_bracket] = ACTIONS(1517),
    [sym__external_open_bracket2] = ACTIONS(1517),
    [sym__external_close_bracket2] = ACTIONS(1517),
  },
  [912] = {
    [ts_builtin_sym_end] = ACTIONS(1482),
    [sym_identifier] = ACTIONS(1480),
    [anon_sym_BSLASH] = ACTIONS(1482),
    [anon_sym_function] = ACTIONS(1480),
    [anon_sym_EQ] = ACTIONS(1480),
    [anon_sym_if] = ACTIONS(1480),
    [anon_sym_for] = ACTIONS(1480),
    [anon_sym_while] = ACTIONS(1480),
    [anon_sym_repeat] = ACTIONS(1480),
    [anon_sym_QMARK] = ACTIONS(1482),
    [anon_sym_TILDE] = ACTIONS(1482),
    [anon_sym_BANG] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1482),
    [anon_sym_DASH] = ACTIONS(1480),
    [anon_sym_LT_DASH] = ACTIONS(1482),
    [anon_sym_LT_LT_DASH] = ACTIONS(1482),
    [anon_sym_COLON_EQ] = ACTIONS(1482),
    [anon_sym_DASH_GT] = ACTIONS(1480),
    [anon_sym_DASH_GT_GT] = ACTIONS(1482),
    [anon_sym_PIPE] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1480),
    [anon_sym_PIPE_PIPE] = ACTIONS(1482),
    [anon_sym_AMP_AMP] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(1480),
    [anon_sym_LT_EQ] = ACTIONS(1482),
    [anon_sym_GT] = ACTIONS(1480),
    [anon_sym_GT_EQ] = ACTIONS(1482),
    [anon_sym_EQ_EQ] = ACTIONS(1482),
    [anon_sym_BANG_EQ] = ACTIONS(1482),
    [anon_sym_STAR] = ACTIONS(1480),
    [anon_sym_SLASH] = ACTIONS(1482),
    [anon_sym_STAR_STAR] = ACTIONS(1482),
    [anon_sym_CARET] = ACTIONS(1482),
    [aux_sym_binary_operator_token1] = ACTIONS(1482),
    [anon_sym_PIPE_GT] = ACTIONS(1482),
    [anon_sym_COLON] = ACTIONS(1480),
    [anon_sym_DOLLAR] = ACTIONS(1482),
    [anon_sym_AT] = ACTIONS(1482),
    [sym__hex_literal] = ACTIONS(1482),
    [sym__number_literal] = ACTIONS(1480),
    [anon_sym_SQUOTE] = ACTIONS(1482),
    [anon_sym_DQUOTE] = ACTIONS(1482),
    [sym_return] = ACTIONS(1480),
    [sym_next] = ACTIONS(1480),
    [sym_break] = ACTIONS(1480),
    [sym_true] = ACTIONS(1480),
    [sym_false] = ACTIONS(1480),
    [sym_null] = ACTIONS(1480),
    [sym_inf] = ACTIONS(1480),
    [sym_nan] = ACTIONS(1480),
    [anon_sym_NA] = ACTIONS(1480),
    [anon_sym_NA_integer_] = ACTIONS(1480),
    [anon_sym_NA_real_] = ACTIONS(1480),
    [anon_sym_NA_complex_] = ACTIONS(1480),
    [anon_sym_NA_character_] = ACTIONS(1480),
    [sym_dots] = ACTIONS(1480),
    [sym_dot_dot_i] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1482),
    [sym__semicolon] = ACTIONS(1482),
    [sym__raw_string_literal] = ACTIONS(1482),
    [sym__external_open_parenthesis] = ACTIONS(1482),
    [sym__external_open_brace] = ACTIONS(1482),
    [sym__external_open_bracket] = ACTIONS(1482),
    [sym__external_open_bracket2] = ACTIONS(1482),
  },
  [913] = {
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_BSLASH] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1539),
    [anon_sym_if] = ACTIONS(1539),
    [anon_sym_for] = ACTIONS(1539),
    [anon_sym_while] = ACTIONS(1539),
    [anon_sym_repeat] = ACTIONS(1539),
    [anon_sym_QMARK] = ACTIONS(1541),
    [anon_sym_TILDE] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1539),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1539),
    [anon_sym_LT_DASH] = ACTIONS(1541),
    [anon_sym_LT_LT_DASH] = ACTIONS(1541),
    [anon_sym_COLON_EQ] = ACTIONS(1541),
    [anon_sym_DASH_GT] = ACTIONS(1539),
    [anon_sym_DASH_GT_GT] = ACTIONS(1541),
    [anon_sym_PIPE] = ACTIONS(1539),
    [anon_sym_AMP] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1541),
    [anon_sym_GT] = ACTIONS(1539),
    [anon_sym_GT_EQ] = ACTIONS(1541),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1539),
    [anon_sym_SLASH] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_CARET] = ACTIONS(1541),
    [aux_sym_binary_operator_token1] = ACTIONS(1541),
    [anon_sym_PIPE_GT] = ACTIONS(1541),
    [anon_sym_COLON] = ACTIONS(1539),
    [anon_sym_DOLLAR] = ACTIONS(1541),
    [anon_sym_AT] = ACTIONS(1541),
    [sym__hex_literal] = ACTIONS(1541),
    [sym__number_literal] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(1541),
    [anon_sym_DQUOTE] = ACTIONS(1541),
    [sym_return] = ACTIONS(1539),
    [sym_next] = ACTIONS(1539),
    [sym_break] = ACTIONS(1539),
    [sym_true] = ACTIONS(1539),
    [sym_false] = ACTIONS(1539),
    [sym_null] = ACTIONS(1539),
    [sym_inf] = ACTIONS(1539),
    [sym_nan] = ACTIONS(1539),
    [anon_sym_NA] = ACTIONS(1539),
    [anon_sym_NA_integer_] = ACTIONS(1539),
    [anon_sym_NA_real_] = ACTIONS(1539),
    [anon_sym_NA_complex_] = ACTIONS(1539),
    [anon_sym_NA_character_] = ACTIONS(1539),
    [sym_dots] = ACTIONS(1539),
    [sym_dot_dot_i] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1541),
    [sym__newline] = ACTIONS(1541),
    [sym__raw_string_literal] = ACTIONS(1541),
    [sym__external_open_parenthesis] = ACTIONS(1541),
    [sym__external_close_parenthesis] = ACTIONS(1541),
    [sym__external_open_brace] = ACTIONS(1541),
    [sym__external_open_bracket] = ACTIONS(1541),
    [sym__external_open_bracket2] = ACTIONS(1541),
  },
  [914] = {
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_BSLASH] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1539),
    [anon_sym_if] = ACTIONS(1539),
    [anon_sym_for] = ACTIONS(1539),
    [anon_sym_while] = ACTIONS(1539),
    [anon_sym_repeat] = ACTIONS(1539),
    [anon_sym_QMARK] = ACTIONS(1541),
    [anon_sym_TILDE] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1539),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1539),
    [anon_sym_LT_DASH] = ACTIONS(1541),
    [anon_sym_LT_LT_DASH] = ACTIONS(1541),
    [anon_sym_COLON_EQ] = ACTIONS(1541),
    [anon_sym_DASH_GT] = ACTIONS(1539),
    [anon_sym_DASH_GT_GT] = ACTIONS(1541),
    [anon_sym_PIPE] = ACTIONS(1539),
    [anon_sym_AMP] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1541),
    [anon_sym_GT] = ACTIONS(1539),
    [anon_sym_GT_EQ] = ACTIONS(1541),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1539),
    [anon_sym_SLASH] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_CARET] = ACTIONS(1541),
    [aux_sym_binary_operator_token1] = ACTIONS(1541),
    [anon_sym_PIPE_GT] = ACTIONS(1541),
    [anon_sym_COLON] = ACTIONS(1539),
    [anon_sym_DOLLAR] = ACTIONS(1541),
    [anon_sym_AT] = ACTIONS(1541),
    [sym__hex_literal] = ACTIONS(1541),
    [sym__number_literal] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(1541),
    [anon_sym_DQUOTE] = ACTIONS(1541),
    [sym_return] = ACTIONS(1539),
    [sym_next] = ACTIONS(1539),
    [sym_break] = ACTIONS(1539),
    [sym_true] = ACTIONS(1539),
    [sym_false] = ACTIONS(1539),
    [sym_null] = ACTIONS(1539),
    [sym_inf] = ACTIONS(1539),
    [sym_nan] = ACTIONS(1539),
    [anon_sym_NA] = ACTIONS(1539),
    [anon_sym_NA_integer_] = ACTIONS(1539),
    [anon_sym_NA_real_] = ACTIONS(1539),
    [anon_sym_NA_complex_] = ACTIONS(1539),
    [anon_sym_NA_character_] = ACTIONS(1539),
    [sym_dots] = ACTIONS(1539),
    [sym_dot_dot_i] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1541),
    [sym__semicolon] = ACTIONS(1541),
    [sym__raw_string_literal] = ACTIONS(1541),
    [sym__external_open_parenthesis] = ACTIONS(1541),
    [sym__external_open_brace] = ACTIONS(1541),
    [sym__external_close_brace] = ACTIONS(1541),
    [sym__external_open_bracket] = ACTIONS(1541),
    [sym__external_open_bracket2] = ACTIONS(1541),
  },
  [915] = {
    [sym_function_definition] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_repeat_statement] = STATE(556),
    [sym_braced_expression] = STATE(556),
    [sym_parenthesized_expression] = STATE(556),
    [sym_call] = STATE(556),
    [sym_subset] = STATE(556),
    [sym_subset2] = STATE(556),
    [sym__argument_value] = STATE(1924),
    [sym_unary_operator] = STATE(556),
    [sym_binary_operator] = STATE(556),
    [sym_extract_operator] = STATE(556),
    [sym_namespace_operator] = STATE(556),
    [sym_integer] = STATE(556),
    [sym_complex] = STATE(556),
    [sym_float] = STATE(556),
    [sym__float_literal] = STATE(710),
    [sym_string] = STATE(726),
    [sym__single_quoted_string] = STATE(725),
    [sym__double_quoted_string] = STATE(700),
    [sym_na] = STATE(556),
    [sym__expression] = STATE(556),
    [sym__string_or_identifier] = STATE(2142),
    [sym__open_parenthesis] = STATE(955),
    [sym__open_brace] = STATE(857),
    [sym_identifier] = ACTIONS(1687),
    [anon_sym_BSLASH] = ACTIONS(593),
    [anon_sym_function] = ACTIONS(595),
    [anon_sym_if] = ACTIONS(597),
    [anon_sym_for] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(601),
    [anon_sym_repeat] = ACTIONS(603),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [sym__hex_literal] = ACTIONS(613),
    [sym__number_literal] = ACTIONS(615),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(619),
    [sym_return] = ACTIONS(621),
    [sym_next] = ACTIONS(621),
    [sym_break] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_null] = ACTIONS(621),
    [sym_inf] = ACTIONS(621),
    [sym_nan] = ACTIONS(621),
    [anon_sym_NA] = ACTIONS(623),
    [anon_sym_NA_integer_] = ACTIONS(623),
    [anon_sym_NA_real_] = ACTIONS(623),
    [anon_sym_NA_complex_] = ACTIONS(623),
    [anon_sym_NA_character_] = ACTIONS(623),
    [sym_dots] = ACTIONS(621),
    [sym_dot_dot_i] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1689),
    [sym__newline] = ACTIONS(631),
    [sym__raw_string_literal] = ACTIONS(633),
    [sym__external_open_parenthesis] = ACTIONS(635),
    [sym__external_open_brace] = ACTIONS(637),
    [sym__external_close_bracket2] = ACTIONS(1689),
  },
  [916] = {
    [sym_function_definition] = STATE(631),
    [sym_if_statement] = STATE(631),
    [sym_for_statement] = STATE(631),
    [sym_while_statement] = STATE(631),
    [sym_repeat_statement] = STATE(631),
    [sym_braced_expression] = STATE(631),
    [sym_parenthesized_expression] = STATE(631),
    [sym_call] = STATE(631),
    [sym_subset] = STATE(631),
    [sym_subset2] = STATE(631),
    [sym_unary_operator] = STATE(631),
    [sym_binary_operator] = STATE(631),
    [sym_extract_operator] = STATE(631),
    [sym_namespace_operator] = STATE(631),
    [sym_integer] = STATE(631),
    [sym_complex] = STATE(631),
    [sym_float] = STATE(631),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(739),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(631),
    [sym__expression] = STATE(631),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(887),
    [sym__open_brace] = STATE(842),
    [aux_sym_parenthesized_expression_repeat1] = STATE(1003),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(1679),
    [sym_next] = ACTIONS(1679),
    [sym_break] = ACTIONS(1679),
    [sym_true] = ACTIONS(1679),
    [sym_false] = ACTIONS(1679),
    [sym_null] = ACTIONS(1679),
    [sym_inf] = ACTIONS(1679),
    [sym_nan] = ACTIONS(1679),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(1679),
    [sym_dot_dot_i] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1683),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1691),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [917] = {
    [sym_identifier] = ACTIONS(1331),
    [anon_sym_BSLASH] = ACTIONS(1333),
    [anon_sym_function] = ACTIONS(1331),
    [anon_sym_EQ] = ACTIONS(1408),
    [anon_sym_if] = ACTIONS(1331),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_while] = ACTIONS(1331),
    [anon_sym_repeat] = ACTIONS(1331),
    [anon_sym_QMARK] = ACTIONS(1333),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_LT_DASH] = ACTIONS(1333),
    [anon_sym_LT_LT_DASH] = ACTIONS(1333),
    [anon_sym_COLON_EQ] = ACTIONS(1333),
    [anon_sym_DASH_GT] = ACTIONS(1331),
    [anon_sym_DASH_GT_GT] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1331),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1333),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_GT_EQ] = ACTIONS(1333),
    [anon_sym_EQ_EQ] = ACTIONS(1333),
    [anon_sym_BANG_EQ] = ACTIONS(1333),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_SLASH] = ACTIONS(1333),
    [anon_sym_STAR_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1333),
    [aux_sym_binary_operator_token1] = ACTIONS(1333),
    [anon_sym_PIPE_GT] = ACTIONS(1333),
    [anon_sym_COLON] = ACTIONS(1331),
    [anon_sym_DOLLAR] = ACTIONS(1333),
    [anon_sym_AT] = ACTIONS(1333),
    [sym__hex_literal] = ACTIONS(1333),
    [sym__number_literal] = ACTIONS(1331),
    [anon_sym_SQUOTE] = ACTIONS(1333),
    [anon_sym_DQUOTE] = ACTIONS(1333),
    [sym_return] = ACTIONS(1331),
    [sym_next] = ACTIONS(1331),
    [sym_break] = ACTIONS(1331),
    [sym_true] = ACTIONS(1331),
    [sym_false] = ACTIONS(1331),
    [sym_null] = ACTIONS(1331),
    [sym_inf] = ACTIONS(1331),
    [sym_nan] = ACTIONS(1331),
    [anon_sym_NA] = ACTIONS(1331),
    [anon_sym_NA_integer_] = ACTIONS(1331),
    [anon_sym_NA_real_] = ACTIONS(1331),
    [anon_sym_NA_complex_] = ACTIONS(1331),
    [anon_sym_NA_character_] = ACTIONS(1331),
    [sym_dots] = ACTIONS(1331),
    [sym_dot_dot_i] = ACTIONS(1333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1333),
    [sym__newline] = ACTIONS(1333),
    [sym__raw_string_literal] = ACTIONS(1333),
    [sym__external_open_parenthesis] = ACTIONS(1333),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_open_bracket] = ACTIONS(1333),
    [sym__external_close_bracket] = ACTIONS(1333),
    [sym__external_open_bracket2] = ACTIONS(1333),
  },
  [918] = {
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_BSLASH] = ACTIONS(1545),
    [anon_sym_function] = ACTIONS(1543),
    [anon_sym_EQ] = ACTIONS(1543),
    [anon_sym_if] = ACTIONS(1543),
    [anon_sym_for] = ACTIONS(1543),
    [anon_sym_while] = ACTIONS(1543),
    [anon_sym_repeat] = ACTIONS(1543),
    [anon_sym_QMARK] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1543),
    [anon_sym_PLUS] = ACTIONS(1545),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_LT_DASH] = ACTIONS(1545),
    [anon_sym_LT_LT_DASH] = ACTIONS(1545),
    [anon_sym_COLON_EQ] = ACTIONS(1545),
    [anon_sym_DASH_GT] = ACTIONS(1543),
    [anon_sym_DASH_GT_GT] = ACTIONS(1545),
    [anon_sym_PIPE] = ACTIONS(1543),
    [anon_sym_AMP] = ACTIONS(1543),
    [anon_sym_PIPE_PIPE] = ACTIONS(1545),
    [anon_sym_AMP_AMP] = ACTIONS(1545),
    [anon_sym_LT] = ACTIONS(1543),
    [anon_sym_LT_EQ] = ACTIONS(1545),
    [anon_sym_GT] = ACTIONS(1543),
    [anon_sym_GT_EQ] = ACTIONS(1545),
    [anon_sym_EQ_EQ] = ACTIONS(1545),
    [anon_sym_BANG_EQ] = ACTIONS(1545),
    [anon_sym_STAR] = ACTIONS(1543),
    [anon_sym_SLASH] = ACTIONS(1545),
    [anon_sym_STAR_STAR] = ACTIONS(1545),
    [anon_sym_CARET] = ACTIONS(1545),
    [aux_sym_binary_operator_token1] = ACTIONS(1545),
    [anon_sym_PIPE_GT] = ACTIONS(1545),
    [anon_sym_COLON] = ACTIONS(1543),
    [anon_sym_DOLLAR] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(1545),
    [sym__hex_literal] = ACTIONS(1545),
    [sym__number_literal] = ACTIONS(1543),
    [anon_sym_SQUOTE] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1545),
    [sym_return] = ACTIONS(1543),
    [sym_next] = ACTIONS(1543),
    [sym_break] = ACTIONS(1543),
    [sym_true] = ACTIONS(1543),
    [sym_false] = ACTIONS(1543),
    [sym_null] = ACTIONS(1543),
    [sym_inf] = ACTIONS(1543),
    [sym_nan] = ACTIONS(1543),
    [anon_sym_NA] = ACTIONS(1543),
    [anon_sym_NA_integer_] = ACTIONS(1543),
    [anon_sym_NA_real_] = ACTIONS(1543),
    [anon_sym_NA_complex_] = ACTIONS(1543),
    [anon_sym_NA_character_] = ACTIONS(1543),
    [sym_dots] = ACTIONS(1543),
    [sym_dot_dot_i] = ACTIONS(1545),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1545),
    [sym__semicolon] = ACTIONS(1545),
    [sym__raw_string_literal] = ACTIONS(1545),
    [sym__external_open_parenthesis] = ACTIONS(1545),
    [sym__external_open_brace] = ACTIONS(1545),
    [sym__external_close_brace] = ACTIONS(1545),
    [sym__external_open_bracket] = ACTIONS(1545),
    [sym__external_open_bracket2] = ACTIONS(1545),
  },
  [919] = {
    [ts_builtin_sym_end] = ACTIONS(1470),
    [sym_identifier] = ACTIONS(1468),
    [anon_sym_BSLASH] = ACTIONS(1470),
    [anon_sym_function] = ACTIONS(1468),
    [anon_sym_EQ] = ACTIONS(1468),
    [anon_sym_if] = ACTIONS(1468),
    [anon_sym_for] = ACTIONS(1468),
    [anon_sym_while] = ACTIONS(1468),
    [anon_sym_repeat] = ACTIONS(1468),
    [anon_sym_QMARK] = ACTIONS(1470),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_BANG] = ACTIONS(1468),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1468),
    [anon_sym_LT_DASH] = ACTIONS(1470),
    [anon_sym_LT_LT_DASH] = ACTIONS(1470),
    [anon_sym_COLON_EQ] = ACTIONS(1470),
    [anon_sym_DASH_GT] = ACTIONS(1468),
    [anon_sym_DASH_GT_GT] = ACTIONS(1470),
    [anon_sym_PIPE] = ACTIONS(1468),
    [anon_sym_AMP] = ACTIONS(1468),
    [anon_sym_PIPE_PIPE] = ACTIONS(1470),
    [anon_sym_AMP_AMP] = ACTIONS(1470),
    [anon_sym_LT] = ACTIONS(1468),
    [anon_sym_LT_EQ] = ACTIONS(1470),
    [anon_sym_GT] = ACTIONS(1468),
    [anon_sym_GT_EQ] = ACTIONS(1470),
    [anon_sym_EQ_EQ] = ACTIONS(1470),
    [anon_sym_BANG_EQ] = ACTIONS(1470),
    [anon_sym_STAR] = ACTIONS(1468),
    [anon_sym_SLASH] = ACTIONS(1470),
    [anon_sym_STAR_STAR] = ACTIONS(1470),
    [anon_sym_CARET] = ACTIONS(1470),
    [aux_sym_binary_operator_token1] = ACTIONS(1470),
    [anon_sym_PIPE_GT] = ACTIONS(1470),
    [anon_sym_COLON] = ACTIONS(1468),
    [anon_sym_DOLLAR] = ACTIONS(1470),
    [anon_sym_AT] = ACTIONS(1470),
    [sym__hex_literal] = ACTIONS(1470),
    [sym__number_literal] = ACTIONS(1468),
    [anon_sym_SQUOTE] = ACTIONS(1470),
    [anon_sym_DQUOTE] = ACTIONS(1470),
    [sym_return] = ACTIONS(1468),
    [sym_next] = ACTIONS(1468),
    [sym_break] = ACTIONS(1468),
    [sym_true] = ACTIONS(1468),
    [sym_false] = ACTIONS(1468),
    [sym_null] = ACTIONS(1468),
    [sym_inf] = ACTIONS(1468),
    [sym_nan] = ACTIONS(1468),
    [anon_sym_NA] = ACTIONS(1468),
    [anon_sym_NA_integer_] = ACTIONS(1468),
    [anon_sym_NA_real_] = ACTIONS(1468),
    [anon_sym_NA_complex_] = ACTIONS(1468),
    [anon_sym_NA_character_] = ACTIONS(1468),
    [sym_dots] = ACTIONS(1468),
    [sym_dot_dot_i] = ACTIONS(1470),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1470),
    [sym__semicolon] = ACTIONS(1470),
    [sym__raw_string_literal] = ACTIONS(1470),
    [sym__external_open_parenthesis] = ACTIONS(1470),
    [sym__external_open_brace] = ACTIONS(1470),
    [sym__external_open_bracket] = ACTIONS(1470),
    [sym__external_open_bracket2] = ACTIONS(1470),
  },
  [920] = {
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_BSLASH] = ACTIONS(1549),
    [anon_sym_function] = ACTIONS(1547),
    [anon_sym_EQ] = ACTIONS(1547),
    [anon_sym_if] = ACTIONS(1547),
    [anon_sym_for] = ACTIONS(1547),
    [anon_sym_while] = ACTIONS(1547),
    [anon_sym_repeat] = ACTIONS(1547),
    [anon_sym_QMARK] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1547),
    [anon_sym_LT_DASH] = ACTIONS(1549),
    [anon_sym_LT_LT_DASH] = ACTIONS(1549),
    [anon_sym_COLON_EQ] = ACTIONS(1549),
    [anon_sym_DASH_GT] = ACTIONS(1547),
    [anon_sym_DASH_GT_GT] = ACTIONS(1549),
    [anon_sym_PIPE] = ACTIONS(1547),
    [anon_sym_AMP] = ACTIONS(1547),
    [anon_sym_PIPE_PIPE] = ACTIONS(1549),
    [anon_sym_AMP_AMP] = ACTIONS(1549),
    [anon_sym_LT] = ACTIONS(1547),
    [anon_sym_LT_EQ] = ACTIONS(1549),
    [anon_sym_GT] = ACTIONS(1547),
    [anon_sym_GT_EQ] = ACTIONS(1549),
    [anon_sym_EQ_EQ] = ACTIONS(1549),
    [anon_sym_BANG_EQ] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_SLASH] = ACTIONS(1549),
    [anon_sym_STAR_STAR] = ACTIONS(1549),
    [anon_sym_CARET] = ACTIONS(1549),
    [aux_sym_binary_operator_token1] = ACTIONS(1549),
    [anon_sym_PIPE_GT] = ACTIONS(1549),
    [anon_sym_COLON] = ACTIONS(1547),
    [anon_sym_DOLLAR] = ACTIONS(1549),
    [anon_sym_AT] = ACTIONS(1549),
    [sym__hex_literal] = ACTIONS(1549),
    [sym__number_literal] = ACTIONS(1547),
    [anon_sym_SQUOTE] = ACTIONS(1549),
    [anon_sym_DQUOTE] = ACTIONS(1549),
    [sym_return] = ACTIONS(1547),
    [sym_next] = ACTIONS(1547),
    [sym_break] = ACTIONS(1547),
    [sym_true] = ACTIONS(1547),
    [sym_false] = ACTIONS(1547),
    [sym_null] = ACTIONS(1547),
    [sym_inf] = ACTIONS(1547),
    [sym_nan] = ACTIONS(1547),
    [anon_sym_NA] = ACTIONS(1547),
    [anon_sym_NA_integer_] = ACTIONS(1547),
    [anon_sym_NA_real_] = ACTIONS(1547),
    [anon_sym_NA_complex_] = ACTIONS(1547),
    [anon_sym_NA_character_] = ACTIONS(1547),
    [sym_dots] = ACTIONS(1547),
    [sym_dot_dot_i] = ACTIONS(1549),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1549),
    [sym__semicolon] = ACTIONS(1549),
    [sym__raw_string_literal] = ACTIONS(1549),
    [sym__external_open_parenthesis] = ACTIONS(1549),
    [sym__external_open_brace] = ACTIONS(1549),
    [sym__external_close_brace] = ACTIONS(1549),
    [sym__external_open_bracket] = ACTIONS(1549),
    [sym__external_open_bracket2] = ACTIONS(1549),
  },
  [921] = {
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_BSLASH] = ACTIONS(1494),
    [anon_sym_function] = ACTIONS(1492),
    [anon_sym_EQ] = ACTIONS(1492),
    [anon_sym_if] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(1492),
    [anon_sym_while] = ACTIONS(1492),
    [anon_sym_repeat] = ACTIONS(1492),
    [anon_sym_QMARK] = ACTIONS(1494),
    [anon_sym_TILDE] = ACTIONS(1494),
    [anon_sym_BANG] = ACTIONS(1492),
    [anon_sym_PLUS] = ACTIONS(1494),
    [anon_sym_DASH] = ACTIONS(1492),
    [anon_sym_LT_DASH] = ACTIONS(1494),
    [anon_sym_LT_LT_DASH] = ACTIONS(1494),
    [anon_sym_COLON_EQ] = ACTIONS(1494),
    [anon_sym_DASH_GT] = ACTIONS(1492),
    [anon_sym_DASH_GT_GT] = ACTIONS(1494),
    [anon_sym_PIPE] = ACTIONS(1492),
    [anon_sym_AMP] = ACTIONS(1492),
    [anon_sym_PIPE_PIPE] = ACTIONS(1494),
    [anon_sym_AMP_AMP] = ACTIONS(1494),
    [anon_sym_LT] = ACTIONS(1492),
    [anon_sym_LT_EQ] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1492),
    [anon_sym_GT_EQ] = ACTIONS(1494),
    [anon_sym_EQ_EQ] = ACTIONS(1494),
    [anon_sym_BANG_EQ] = ACTIONS(1494),
    [anon_sym_STAR] = ACTIONS(1492),
    [anon_sym_SLASH] = ACTIONS(1494),
    [anon_sym_STAR_STAR] = ACTIONS(1494),
    [anon_sym_CARET] = ACTIONS(1494),
    [aux_sym_binary_operator_token1] = ACTIONS(1494),
    [anon_sym_PIPE_GT] = ACTIONS(1494),
    [anon_sym_COLON] = ACTIONS(1492),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [anon_sym_AT] = ACTIONS(1494),
    [sym__hex_literal] = ACTIONS(1494),
    [sym__number_literal] = ACTIONS(1492),
    [anon_sym_SQUOTE] = ACTIONS(1494),
    [anon_sym_DQUOTE] = ACTIONS(1494),
    [sym_return] = ACTIONS(1492),
    [sym_next] = ACTIONS(1492),
    [sym_break] = ACTIONS(1492),
    [sym_true] = ACTIONS(1492),
    [sym_false] = ACTIONS(1492),
    [sym_null] = ACTIONS(1492),
    [sym_inf] = ACTIONS(1492),
    [sym_nan] = ACTIONS(1492),
    [anon_sym_NA] = ACTIONS(1492),
    [anon_sym_NA_integer_] = ACTIONS(1492),
    [anon_sym_NA_real_] = ACTIONS(1492),
    [anon_sym_NA_complex_] = ACTIONS(1492),
    [anon_sym_NA_character_] = ACTIONS(1492),
    [sym_dots] = ACTIONS(1492),
    [sym_dot_dot_i] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1494),
    [sym__semicolon] = ACTIONS(1494),
    [sym__raw_string_literal] = ACTIONS(1494),
    [sym__external_open_parenthesis] = ACTIONS(1494),
    [sym__external_open_brace] = ACTIONS(1494),
    [sym__external_close_brace] = ACTIONS(1494),
    [sym__external_open_bracket] = ACTIONS(1494),
    [sym__external_open_bracket2] = ACTIONS(1494),
  },
  [922] = {
    [sym_function_definition] = STATE(491),
    [sym_if_statement] = STATE(491),
    [sym_for_statement] = STATE(491),
    [sym_while_statement] = STATE(491),
    [sym_repeat_statement] = STATE(491),
    [sym_braced_expression] = STATE(491),
    [sym_parenthesized_expression] = STATE(491),
    [sym_call] = STATE(491),
    [sym_subset] = STATE(491),
    [sym_subset2] = STATE(491),
    [sym__argument_value] = STATE(1938),
    [sym_unary_operator] = STATE(491),
    [sym_binary_operator] = STATE(491),
    [sym_extract_operator] = STATE(491),
    [sym_namespace_operator] = STATE(491),
    [sym_integer] = STATE(491),
    [sym_complex] = STATE(491),
    [sym_float] = STATE(491),
    [sym__float_literal] = STATE(734),
    [sym_string] = STATE(714),
    [sym__single_quoted_string] = STATE(735),
    [sym__double_quoted_string] = STATE(736),
    [sym_na] = STATE(491),
    [sym__expression] = STATE(491),
    [sym__string_or_identifier] = STATE(2143),
    [sym__open_parenthesis] = STATE(948),
    [sym__open_brace] = STATE(751),
    [sym_identifier] = ACTIONS(1693),
    [anon_sym_BSLASH] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_if] = ACTIONS(547),
    [anon_sym_for] = ACTIONS(549),
    [anon_sym_while] = ACTIONS(551),
    [anon_sym_repeat] = ACTIONS(553),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(557),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [sym__hex_literal] = ACTIONS(563),
    [sym__number_literal] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(569),
    [sym_return] = ACTIONS(571),
    [sym_next] = ACTIONS(571),
    [sym_break] = ACTIONS(571),
    [sym_true] = ACTIONS(571),
    [sym_false] = ACTIONS(571),
    [sym_null] = ACTIONS(571),
    [sym_inf] = ACTIONS(571),
    [sym_nan] = ACTIONS(571),
    [anon_sym_NA] = ACTIONS(573),
    [anon_sym_NA_integer_] = ACTIONS(573),
    [anon_sym_NA_real_] = ACTIONS(573),
    [anon_sym_NA_complex_] = ACTIONS(573),
    [anon_sym_NA_character_] = ACTIONS(573),
    [sym_dots] = ACTIONS(571),
    [sym_dot_dot_i] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1689),
    [sym__newline] = ACTIONS(581),
    [sym__raw_string_literal] = ACTIONS(583),
    [sym__external_open_parenthesis] = ACTIONS(585),
    [sym__external_open_brace] = ACTIONS(587),
    [sym__external_close_bracket] = ACTIONS(1689),
  },
  [923] = {
    [sym_identifier] = ACTIONS(1535),
    [anon_sym_BSLASH] = ACTIONS(1537),
    [anon_sym_function] = ACTIONS(1535),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_if] = ACTIONS(1535),
    [anon_sym_for] = ACTIONS(1535),
    [anon_sym_while] = ACTIONS(1535),
    [anon_sym_repeat] = ACTIONS(1535),
    [anon_sym_QMARK] = ACTIONS(1537),
    [anon_sym_TILDE] = ACTIONS(1537),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1535),
    [anon_sym_LT_DASH] = ACTIONS(1537),
    [anon_sym_LT_LT_DASH] = ACTIONS(1537),
    [anon_sym_COLON_EQ] = ACTIONS(1537),
    [anon_sym_DASH_GT] = ACTIONS(1535),
    [anon_sym_DASH_GT_GT] = ACTIONS(1537),
    [anon_sym_PIPE] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_PIPE_PIPE] = ACTIONS(1537),
    [anon_sym_AMP_AMP] = ACTIONS(1537),
    [anon_sym_LT] = ACTIONS(1535),
    [anon_sym_LT_EQ] = ACTIONS(1537),
    [anon_sym_GT] = ACTIONS(1535),
    [anon_sym_GT_EQ] = ACTIONS(1537),
    [anon_sym_EQ_EQ] = ACTIONS(1537),
    [anon_sym_BANG_EQ] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_SLASH] = ACTIONS(1537),
    [anon_sym_STAR_STAR] = ACTIONS(1537),
    [anon_sym_CARET] = ACTIONS(1537),
    [aux_sym_binary_operator_token1] = ACTIONS(1537),
    [anon_sym_PIPE_GT] = ACTIONS(1537),
    [anon_sym_COLON] = ACTIONS(1535),
    [anon_sym_DOLLAR] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(1537),
    [sym__hex_literal] = ACTIONS(1537),
    [sym__number_literal] = ACTIONS(1535),
    [anon_sym_SQUOTE] = ACTIONS(1537),
    [anon_sym_DQUOTE] = ACTIONS(1537),
    [sym_return] = ACTIONS(1535),
    [sym_next] = ACTIONS(1535),
    [sym_break] = ACTIONS(1535),
    [sym_true] = ACTIONS(1535),
    [sym_false] = ACTIONS(1535),
    [sym_null] = ACTIONS(1535),
    [sym_inf] = ACTIONS(1535),
    [sym_nan] = ACTIONS(1535),
    [anon_sym_NA] = ACTIONS(1535),
    [anon_sym_NA_integer_] = ACTIONS(1535),
    [anon_sym_NA_real_] = ACTIONS(1535),
    [anon_sym_NA_complex_] = ACTIONS(1535),
    [anon_sym_NA_character_] = ACTIONS(1535),
    [sym_dots] = ACTIONS(1535),
    [sym_dot_dot_i] = ACTIONS(1537),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1537),
    [sym__newline] = ACTIONS(1537),
    [sym__raw_string_literal] = ACTIONS(1537),
    [sym__external_open_parenthesis] = ACTIONS(1537),
    [sym__external_open_brace] = ACTIONS(1537),
    [sym__external_open_bracket] = ACTIONS(1537),
    [sym__external_close_bracket] = ACTIONS(1537),
    [sym__external_open_bracket2] = ACTIONS(1537),
  },
  [924] = {
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_BSLASH] = ACTIONS(1545),
    [anon_sym_function] = ACTIONS(1543),
    [anon_sym_EQ] = ACTIONS(1543),
    [anon_sym_if] = ACTIONS(1543),
    [anon_sym_for] = ACTIONS(1543),
    [anon_sym_while] = ACTIONS(1543),
    [anon_sym_repeat] = ACTIONS(1543),
    [anon_sym_QMARK] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1543),
    [anon_sym_PLUS] = ACTIONS(1545),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_LT_DASH] = ACTIONS(1545),
    [anon_sym_LT_LT_DASH] = ACTIONS(1545),
    [anon_sym_COLON_EQ] = ACTIONS(1545),
    [anon_sym_DASH_GT] = ACTIONS(1543),
    [anon_sym_DASH_GT_GT] = ACTIONS(1545),
    [anon_sym_PIPE] = ACTIONS(1543),
    [anon_sym_AMP] = ACTIONS(1543),
    [anon_sym_PIPE_PIPE] = ACTIONS(1545),
    [anon_sym_AMP_AMP] = ACTIONS(1545),
    [anon_sym_LT] = ACTIONS(1543),
    [anon_sym_LT_EQ] = ACTIONS(1545),
    [anon_sym_GT] = ACTIONS(1543),
    [anon_sym_GT_EQ] = ACTIONS(1545),
    [anon_sym_EQ_EQ] = ACTIONS(1545),
    [anon_sym_BANG_EQ] = ACTIONS(1545),
    [anon_sym_STAR] = ACTIONS(1543),
    [anon_sym_SLASH] = ACTIONS(1545),
    [anon_sym_STAR_STAR] = ACTIONS(1545),
    [anon_sym_CARET] = ACTIONS(1545),
    [aux_sym_binary_operator_token1] = ACTIONS(1545),
    [anon_sym_PIPE_GT] = ACTIONS(1545),
    [anon_sym_COLON] = ACTIONS(1543),
    [anon_sym_DOLLAR] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(1545),
    [sym__hex_literal] = ACTIONS(1545),
    [sym__number_literal] = ACTIONS(1543),
    [anon_sym_SQUOTE] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1545),
    [sym_return] = ACTIONS(1543),
    [sym_next] = ACTIONS(1543),
    [sym_break] = ACTIONS(1543),
    [sym_true] = ACTIONS(1543),
    [sym_false] = ACTIONS(1543),
    [sym_null] = ACTIONS(1543),
    [sym_inf] = ACTIONS(1543),
    [sym_nan] = ACTIONS(1543),
    [anon_sym_NA] = ACTIONS(1543),
    [anon_sym_NA_integer_] = ACTIONS(1543),
    [anon_sym_NA_real_] = ACTIONS(1543),
    [anon_sym_NA_complex_] = ACTIONS(1543),
    [anon_sym_NA_character_] = ACTIONS(1543),
    [sym_dots] = ACTIONS(1543),
    [sym_dot_dot_i] = ACTIONS(1545),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1545),
    [sym__newline] = ACTIONS(1545),
    [sym__raw_string_literal] = ACTIONS(1545),
    [sym__external_open_parenthesis] = ACTIONS(1545),
    [sym__external_close_parenthesis] = ACTIONS(1545),
    [sym__external_open_brace] = ACTIONS(1545),
    [sym__external_open_bracket] = ACTIONS(1545),
    [sym__external_open_bracket2] = ACTIONS(1545),
  },
  [925] = {
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_BSLASH] = ACTIONS(1506),
    [anon_sym_function] = ACTIONS(1504),
    [anon_sym_EQ] = ACTIONS(1504),
    [anon_sym_if] = ACTIONS(1504),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1504),
    [anon_sym_repeat] = ACTIONS(1504),
    [anon_sym_QMARK] = ACTIONS(1506),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_BANG] = ACTIONS(1504),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1504),
    [anon_sym_LT_DASH] = ACTIONS(1506),
    [anon_sym_LT_LT_DASH] = ACTIONS(1506),
    [anon_sym_COLON_EQ] = ACTIONS(1506),
    [anon_sym_DASH_GT] = ACTIONS(1504),
    [anon_sym_DASH_GT_GT] = ACTIONS(1506),
    [anon_sym_PIPE] = ACTIONS(1504),
    [anon_sym_AMP] = ACTIONS(1504),
    [anon_sym_PIPE_PIPE] = ACTIONS(1506),
    [anon_sym_AMP_AMP] = ACTIONS(1506),
    [anon_sym_LT] = ACTIONS(1504),
    [anon_sym_LT_EQ] = ACTIONS(1506),
    [anon_sym_GT] = ACTIONS(1504),
    [anon_sym_GT_EQ] = ACTIONS(1506),
    [anon_sym_EQ_EQ] = ACTIONS(1506),
    [anon_sym_BANG_EQ] = ACTIONS(1506),
    [anon_sym_STAR] = ACTIONS(1504),
    [anon_sym_SLASH] = ACTIONS(1506),
    [anon_sym_STAR_STAR] = ACTIONS(1506),
    [anon_sym_CARET] = ACTIONS(1506),
    [aux_sym_binary_operator_token1] = ACTIONS(1506),
    [anon_sym_PIPE_GT] = ACTIONS(1506),
    [anon_sym_COLON] = ACTIONS(1504),
    [anon_sym_DOLLAR] = ACTIONS(1506),
    [anon_sym_AT] = ACTIONS(1506),
    [sym__hex_literal] = ACTIONS(1506),
    [sym__number_literal] = ACTIONS(1504),
    [anon_sym_SQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1506),
    [sym_return] = ACTIONS(1504),
    [sym_next] = ACTIONS(1504),
    [sym_break] = ACTIONS(1504),
    [sym_true] = ACTIONS(1504),
    [sym_false] = ACTIONS(1504),
    [sym_null] = ACTIONS(1504),
    [sym_inf] = ACTIONS(1504),
    [sym_nan] = ACTIONS(1504),
    [anon_sym_NA] = ACTIONS(1504),
    [anon_sym_NA_integer_] = ACTIONS(1504),
    [anon_sym_NA_real_] = ACTIONS(1504),
    [anon_sym_NA_complex_] = ACTIONS(1504),
    [anon_sym_NA_character_] = ACTIONS(1504),
    [sym_dots] = ACTIONS(1504),
    [sym_dot_dot_i] = ACTIONS(1506),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1506),
    [sym__newline] = ACTIONS(1506),
    [sym__raw_string_literal] = ACTIONS(1506),
    [sym__external_open_parenthesis] = ACTIONS(1506),
    [sym__external_close_parenthesis] = ACTIONS(1506),
    [sym__external_open_brace] = ACTIONS(1506),
    [sym__external_open_bracket] = ACTIONS(1506),
    [sym__external_open_bracket2] = ACTIONS(1506),
  },
  [926] = {
    [sym_identifier] = ACTIONS(1533),
    [anon_sym_BSLASH] = ACTIONS(1531),
    [anon_sym_function] = ACTIONS(1533),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_if] = ACTIONS(1533),
    [anon_sym_for] = ACTIONS(1533),
    [anon_sym_while] = ACTIONS(1533),
    [anon_sym_repeat] = ACTIONS(1533),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_LT_DASH] = ACTIONS(1531),
    [anon_sym_LT_LT_DASH] = ACTIONS(1531),
    [anon_sym_COLON_EQ] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1533),
    [anon_sym_DASH_GT_GT] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1531),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_CARET] = ACTIONS(1531),
    [aux_sym_binary_operator_token1] = ACTIONS(1531),
    [anon_sym_PIPE_GT] = ACTIONS(1531),
    [anon_sym_COLON] = ACTIONS(1533),
    [anon_sym_DOLLAR] = ACTIONS(1531),
    [anon_sym_AT] = ACTIONS(1531),
    [sym__hex_literal] = ACTIONS(1531),
    [sym__number_literal] = ACTIONS(1533),
    [anon_sym_SQUOTE] = ACTIONS(1531),
    [anon_sym_DQUOTE] = ACTIONS(1531),
    [sym_return] = ACTIONS(1533),
    [sym_next] = ACTIONS(1533),
    [sym_break] = ACTIONS(1533),
    [sym_true] = ACTIONS(1533),
    [sym_false] = ACTIONS(1533),
    [sym_null] = ACTIONS(1533),
    [sym_inf] = ACTIONS(1533),
    [sym_nan] = ACTIONS(1533),
    [anon_sym_NA] = ACTIONS(1533),
    [anon_sym_NA_integer_] = ACTIONS(1533),
    [anon_sym_NA_real_] = ACTIONS(1533),
    [anon_sym_NA_complex_] = ACTIONS(1533),
    [anon_sym_NA_character_] = ACTIONS(1533),
    [sym_dots] = ACTIONS(1533),
    [sym_dot_dot_i] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1531),
    [sym__newline] = ACTIONS(1531),
    [sym__raw_string_literal] = ACTIONS(1531),
    [sym__external_open_parenthesis] = ACTIONS(1531),
    [sym__external_open_brace] = ACTIONS(1531),
    [sym__external_open_bracket] = ACTIONS(1531),
    [sym__external_open_bracket2] = ACTIONS(1531),
    [sym__external_close_bracket2] = ACTIONS(1531),
  },
  [927] = {
    [sym_function_definition] = STATE(631),
    [sym_if_statement] = STATE(631),
    [sym_for_statement] = STATE(631),
    [sym_while_statement] = STATE(631),
    [sym_repeat_statement] = STATE(631),
    [sym_braced_expression] = STATE(631),
    [sym_parenthesized_expression] = STATE(631),
    [sym_call] = STATE(631),
    [sym_subset] = STATE(631),
    [sym_subset2] = STATE(631),
    [sym_unary_operator] = STATE(631),
    [sym_binary_operator] = STATE(631),
    [sym_extract_operator] = STATE(631),
    [sym_namespace_operator] = STATE(631),
    [sym_integer] = STATE(631),
    [sym_complex] = STATE(631),
    [sym_float] = STATE(631),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(739),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(631),
    [sym__expression] = STATE(631),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(879),
    [sym__open_brace] = STATE(842),
    [aux_sym_parenthesized_expression_repeat1] = STATE(1003),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(1679),
    [sym_next] = ACTIONS(1679),
    [sym_break] = ACTIONS(1679),
    [sym_true] = ACTIONS(1679),
    [sym_false] = ACTIONS(1679),
    [sym_null] = ACTIONS(1679),
    [sym_inf] = ACTIONS(1679),
    [sym_nan] = ACTIONS(1679),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(1679),
    [sym_dot_dot_i] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1683),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1695),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [928] = {
    [sym_identifier] = ACTIONS(1508),
    [anon_sym_BSLASH] = ACTIONS(1510),
    [anon_sym_function] = ACTIONS(1508),
    [anon_sym_EQ] = ACTIONS(1508),
    [anon_sym_if] = ACTIONS(1508),
    [anon_sym_for] = ACTIONS(1508),
    [anon_sym_while] = ACTIONS(1508),
    [anon_sym_repeat] = ACTIONS(1508),
    [anon_sym_QMARK] = ACTIONS(1510),
    [anon_sym_TILDE] = ACTIONS(1510),
    [anon_sym_BANG] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1510),
    [anon_sym_DASH] = ACTIONS(1508),
    [anon_sym_LT_DASH] = ACTIONS(1510),
    [anon_sym_LT_LT_DASH] = ACTIONS(1510),
    [anon_sym_COLON_EQ] = ACTIONS(1510),
    [anon_sym_DASH_GT] = ACTIONS(1508),
    [anon_sym_DASH_GT_GT] = ACTIONS(1510),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PIPE_PIPE] = ACTIONS(1510),
    [anon_sym_AMP_AMP] = ACTIONS(1510),
    [anon_sym_LT] = ACTIONS(1508),
    [anon_sym_LT_EQ] = ACTIONS(1510),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_GT_EQ] = ACTIONS(1510),
    [anon_sym_EQ_EQ] = ACTIONS(1510),
    [anon_sym_BANG_EQ] = ACTIONS(1510),
    [anon_sym_STAR] = ACTIONS(1508),
    [anon_sym_SLASH] = ACTIONS(1510),
    [anon_sym_STAR_STAR] = ACTIONS(1510),
    [anon_sym_CARET] = ACTIONS(1510),
    [aux_sym_binary_operator_token1] = ACTIONS(1510),
    [anon_sym_PIPE_GT] = ACTIONS(1510),
    [anon_sym_COLON] = ACTIONS(1508),
    [anon_sym_DOLLAR] = ACTIONS(1510),
    [anon_sym_AT] = ACTIONS(1510),
    [sym__hex_literal] = ACTIONS(1510),
    [sym__number_literal] = ACTIONS(1508),
    [anon_sym_SQUOTE] = ACTIONS(1510),
    [anon_sym_DQUOTE] = ACTIONS(1510),
    [sym_return] = ACTIONS(1508),
    [sym_next] = ACTIONS(1508),
    [sym_break] = ACTIONS(1508),
    [sym_true] = ACTIONS(1508),
    [sym_false] = ACTIONS(1508),
    [sym_null] = ACTIONS(1508),
    [sym_inf] = ACTIONS(1508),
    [sym_nan] = ACTIONS(1508),
    [anon_sym_NA] = ACTIONS(1508),
    [anon_sym_NA_integer_] = ACTIONS(1508),
    [anon_sym_NA_real_] = ACTIONS(1508),
    [anon_sym_NA_complex_] = ACTIONS(1508),
    [anon_sym_NA_character_] = ACTIONS(1508),
    [sym_dots] = ACTIONS(1508),
    [sym_dot_dot_i] = ACTIONS(1510),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1510),
    [sym__newline] = ACTIONS(1510),
    [sym__raw_string_literal] = ACTIONS(1510),
    [sym__external_open_parenthesis] = ACTIONS(1510),
    [sym__external_close_parenthesis] = ACTIONS(1510),
    [sym__external_open_brace] = ACTIONS(1510),
    [sym__external_open_bracket] = ACTIONS(1510),
    [sym__external_open_bracket2] = ACTIONS(1510),
  },
  [929] = {
    [sym_identifier] = ACTIONS(1476),
    [anon_sym_BSLASH] = ACTIONS(1478),
    [anon_sym_function] = ACTIONS(1476),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_if] = ACTIONS(1476),
    [anon_sym_for] = ACTIONS(1476),
    [anon_sym_while] = ACTIONS(1476),
    [anon_sym_repeat] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_BANG] = ACTIONS(1476),
    [anon_sym_PLUS] = ACTIONS(1478),
    [anon_sym_DASH] = ACTIONS(1476),
    [anon_sym_LT_DASH] = ACTIONS(1478),
    [anon_sym_LT_LT_DASH] = ACTIONS(1478),
    [anon_sym_COLON_EQ] = ACTIONS(1478),
    [anon_sym_DASH_GT] = ACTIONS(1476),
    [anon_sym_DASH_GT_GT] = ACTIONS(1478),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1478),
    [anon_sym_AMP_AMP] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_EQ] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_GT_EQ] = ACTIONS(1478),
    [anon_sym_EQ_EQ] = ACTIONS(1478),
    [anon_sym_BANG_EQ] = ACTIONS(1478),
    [anon_sym_STAR] = ACTIONS(1476),
    [anon_sym_SLASH] = ACTIONS(1478),
    [anon_sym_STAR_STAR] = ACTIONS(1478),
    [anon_sym_CARET] = ACTIONS(1478),
    [aux_sym_binary_operator_token1] = ACTIONS(1478),
    [anon_sym_PIPE_GT] = ACTIONS(1478),
    [anon_sym_COLON] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1478),
    [anon_sym_AT] = ACTIONS(1478),
    [sym__hex_literal] = ACTIONS(1478),
    [sym__number_literal] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_DQUOTE] = ACTIONS(1478),
    [sym_return] = ACTIONS(1476),
    [sym_next] = ACTIONS(1476),
    [sym_break] = ACTIONS(1476),
    [sym_true] = ACTIONS(1476),
    [sym_false] = ACTIONS(1476),
    [sym_null] = ACTIONS(1476),
    [sym_inf] = ACTIONS(1476),
    [sym_nan] = ACTIONS(1476),
    [anon_sym_NA] = ACTIONS(1476),
    [anon_sym_NA_integer_] = ACTIONS(1476),
    [anon_sym_NA_real_] = ACTIONS(1476),
    [anon_sym_NA_complex_] = ACTIONS(1476),
    [anon_sym_NA_character_] = ACTIONS(1476),
    [sym_dots] = ACTIONS(1476),
    [sym_dot_dot_i] = ACTIONS(1478),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1478),
    [sym__newline] = ACTIONS(1478),
    [sym__raw_string_literal] = ACTIONS(1478),
    [sym__external_open_parenthesis] = ACTIONS(1478),
    [sym__external_close_parenthesis] = ACTIONS(1478),
    [sym__external_open_brace] = ACTIONS(1478),
    [sym__external_open_bracket] = ACTIONS(1478),
    [sym__external_open_bracket2] = ACTIONS(1478),
  },
  [930] = {
    [sym_identifier] = ACTIONS(1484),
    [anon_sym_BSLASH] = ACTIONS(1486),
    [anon_sym_function] = ACTIONS(1484),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_if] = ACTIONS(1484),
    [anon_sym_for] = ACTIONS(1484),
    [anon_sym_while] = ACTIONS(1484),
    [anon_sym_repeat] = ACTIONS(1484),
    [anon_sym_QMARK] = ACTIONS(1486),
    [anon_sym_TILDE] = ACTIONS(1486),
    [anon_sym_BANG] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_LT_DASH] = ACTIONS(1486),
    [anon_sym_LT_LT_DASH] = ACTIONS(1486),
    [anon_sym_COLON_EQ] = ACTIONS(1486),
    [anon_sym_DASH_GT] = ACTIONS(1484),
    [anon_sym_DASH_GT_GT] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1484),
    [anon_sym_AMP] = ACTIONS(1484),
    [anon_sym_PIPE_PIPE] = ACTIONS(1486),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_LT] = ACTIONS(1484),
    [anon_sym_LT_EQ] = ACTIONS(1486),
    [anon_sym_GT] = ACTIONS(1484),
    [anon_sym_GT_EQ] = ACTIONS(1486),
    [anon_sym_EQ_EQ] = ACTIONS(1486),
    [anon_sym_BANG_EQ] = ACTIONS(1486),
    [anon_sym_STAR] = ACTIONS(1484),
    [anon_sym_SLASH] = ACTIONS(1486),
    [anon_sym_STAR_STAR] = ACTIONS(1486),
    [anon_sym_CARET] = ACTIONS(1486),
    [aux_sym_binary_operator_token1] = ACTIONS(1486),
    [anon_sym_PIPE_GT] = ACTIONS(1486),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(1486),
    [anon_sym_AT] = ACTIONS(1486),
    [sym__hex_literal] = ACTIONS(1486),
    [sym__number_literal] = ACTIONS(1484),
    [anon_sym_SQUOTE] = ACTIONS(1486),
    [anon_sym_DQUOTE] = ACTIONS(1486),
    [sym_return] = ACTIONS(1484),
    [sym_next] = ACTIONS(1484),
    [sym_break] = ACTIONS(1484),
    [sym_true] = ACTIONS(1484),
    [sym_false] = ACTIONS(1484),
    [sym_null] = ACTIONS(1484),
    [sym_inf] = ACTIONS(1484),
    [sym_nan] = ACTIONS(1484),
    [anon_sym_NA] = ACTIONS(1484),
    [anon_sym_NA_integer_] = ACTIONS(1484),
    [anon_sym_NA_real_] = ACTIONS(1484),
    [anon_sym_NA_complex_] = ACTIONS(1484),
    [anon_sym_NA_character_] = ACTIONS(1484),
    [sym_dots] = ACTIONS(1484),
    [sym_dot_dot_i] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1486),
    [sym__newline] = ACTIONS(1486),
    [sym__raw_string_literal] = ACTIONS(1486),
    [sym__external_open_parenthesis] = ACTIONS(1486),
    [sym__external_open_brace] = ACTIONS(1486),
    [sym__external_open_bracket] = ACTIONS(1486),
    [sym__external_close_bracket] = ACTIONS(1486),
    [sym__external_open_bracket2] = ACTIONS(1486),
  },
  [931] = {
    [sym_identifier] = ACTIONS(1519),
    [anon_sym_BSLASH] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(1519),
    [anon_sym_EQ] = ACTIONS(1519),
    [anon_sym_if] = ACTIONS(1519),
    [anon_sym_for] = ACTIONS(1519),
    [anon_sym_while] = ACTIONS(1519),
    [anon_sym_repeat] = ACTIONS(1519),
    [anon_sym_QMARK] = ACTIONS(1521),
    [anon_sym_TILDE] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1519),
    [anon_sym_PLUS] = ACTIONS(1521),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_LT_DASH] = ACTIONS(1521),
    [anon_sym_LT_LT_DASH] = ACTIONS(1521),
    [anon_sym_COLON_EQ] = ACTIONS(1521),
    [anon_sym_DASH_GT] = ACTIONS(1519),
    [anon_sym_DASH_GT_GT] = ACTIONS(1521),
    [anon_sym_PIPE] = ACTIONS(1519),
    [anon_sym_AMP] = ACTIONS(1519),
    [anon_sym_PIPE_PIPE] = ACTIONS(1521),
    [anon_sym_AMP_AMP] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_LT_EQ] = ACTIONS(1521),
    [anon_sym_GT] = ACTIONS(1519),
    [anon_sym_GT_EQ] = ACTIONS(1521),
    [anon_sym_EQ_EQ] = ACTIONS(1521),
    [anon_sym_BANG_EQ] = ACTIONS(1521),
    [anon_sym_STAR] = ACTIONS(1519),
    [anon_sym_SLASH] = ACTIONS(1521),
    [anon_sym_STAR_STAR] = ACTIONS(1521),
    [anon_sym_CARET] = ACTIONS(1521),
    [aux_sym_binary_operator_token1] = ACTIONS(1521),
    [anon_sym_PIPE_GT] = ACTIONS(1521),
    [anon_sym_COLON] = ACTIONS(1519),
    [anon_sym_DOLLAR] = ACTIONS(1521),
    [anon_sym_AT] = ACTIONS(1521),
    [sym__hex_literal] = ACTIONS(1521),
    [sym__number_literal] = ACTIONS(1519),
    [anon_sym_SQUOTE] = ACTIONS(1521),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [sym_return] = ACTIONS(1519),
    [sym_next] = ACTIONS(1519),
    [sym_break] = ACTIONS(1519),
    [sym_true] = ACTIONS(1519),
    [sym_false] = ACTIONS(1519),
    [sym_null] = ACTIONS(1519),
    [sym_inf] = ACTIONS(1519),
    [sym_nan] = ACTIONS(1519),
    [anon_sym_NA] = ACTIONS(1519),
    [anon_sym_NA_integer_] = ACTIONS(1519),
    [anon_sym_NA_real_] = ACTIONS(1519),
    [anon_sym_NA_complex_] = ACTIONS(1519),
    [anon_sym_NA_character_] = ACTIONS(1519),
    [sym_dots] = ACTIONS(1519),
    [sym_dot_dot_i] = ACTIONS(1521),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1521),
    [sym__newline] = ACTIONS(1521),
    [sym__raw_string_literal] = ACTIONS(1521),
    [sym__external_open_parenthesis] = ACTIONS(1521),
    [sym__external_open_brace] = ACTIONS(1521),
    [sym__external_open_bracket] = ACTIONS(1521),
    [sym__external_open_bracket2] = ACTIONS(1521),
    [sym__external_close_bracket2] = ACTIONS(1521),
  },
  [932] = {
    [sym_identifier] = ACTIONS(1535),
    [anon_sym_BSLASH] = ACTIONS(1537),
    [anon_sym_function] = ACTIONS(1535),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_if] = ACTIONS(1535),
    [anon_sym_for] = ACTIONS(1535),
    [anon_sym_while] = ACTIONS(1535),
    [anon_sym_repeat] = ACTIONS(1535),
    [anon_sym_QMARK] = ACTIONS(1537),
    [anon_sym_TILDE] = ACTIONS(1537),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1535),
    [anon_sym_LT_DASH] = ACTIONS(1537),
    [anon_sym_LT_LT_DASH] = ACTIONS(1537),
    [anon_sym_COLON_EQ] = ACTIONS(1537),
    [anon_sym_DASH_GT] = ACTIONS(1535),
    [anon_sym_DASH_GT_GT] = ACTIONS(1537),
    [anon_sym_PIPE] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_PIPE_PIPE] = ACTIONS(1537),
    [anon_sym_AMP_AMP] = ACTIONS(1537),
    [anon_sym_LT] = ACTIONS(1535),
    [anon_sym_LT_EQ] = ACTIONS(1537),
    [anon_sym_GT] = ACTIONS(1535),
    [anon_sym_GT_EQ] = ACTIONS(1537),
    [anon_sym_EQ_EQ] = ACTIONS(1537),
    [anon_sym_BANG_EQ] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_SLASH] = ACTIONS(1537),
    [anon_sym_STAR_STAR] = ACTIONS(1537),
    [anon_sym_CARET] = ACTIONS(1537),
    [aux_sym_binary_operator_token1] = ACTIONS(1537),
    [anon_sym_PIPE_GT] = ACTIONS(1537),
    [anon_sym_COLON] = ACTIONS(1535),
    [anon_sym_DOLLAR] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(1537),
    [sym__hex_literal] = ACTIONS(1537),
    [sym__number_literal] = ACTIONS(1535),
    [anon_sym_SQUOTE] = ACTIONS(1537),
    [anon_sym_DQUOTE] = ACTIONS(1537),
    [sym_return] = ACTIONS(1535),
    [sym_next] = ACTIONS(1535),
    [sym_break] = ACTIONS(1535),
    [sym_true] = ACTIONS(1535),
    [sym_false] = ACTIONS(1535),
    [sym_null] = ACTIONS(1535),
    [sym_inf] = ACTIONS(1535),
    [sym_nan] = ACTIONS(1535),
    [anon_sym_NA] = ACTIONS(1535),
    [anon_sym_NA_integer_] = ACTIONS(1535),
    [anon_sym_NA_real_] = ACTIONS(1535),
    [anon_sym_NA_complex_] = ACTIONS(1535),
    [anon_sym_NA_character_] = ACTIONS(1535),
    [sym_dots] = ACTIONS(1535),
    [sym_dot_dot_i] = ACTIONS(1537),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1537),
    [sym__semicolon] = ACTIONS(1537),
    [sym__raw_string_literal] = ACTIONS(1537),
    [sym__external_open_parenthesis] = ACTIONS(1537),
    [sym__external_open_brace] = ACTIONS(1537),
    [sym__external_close_brace] = ACTIONS(1537),
    [sym__external_open_bracket] = ACTIONS(1537),
    [sym__external_open_bracket2] = ACTIONS(1537),
  },
  [933] = {
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_BSLASH] = ACTIONS(1525),
    [anon_sym_function] = ACTIONS(1523),
    [anon_sym_EQ] = ACTIONS(1523),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_for] = ACTIONS(1523),
    [anon_sym_while] = ACTIONS(1523),
    [anon_sym_repeat] = ACTIONS(1523),
    [anon_sym_QMARK] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(1525),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1523),
    [anon_sym_LT_DASH] = ACTIONS(1525),
    [anon_sym_LT_LT_DASH] = ACTIONS(1525),
    [anon_sym_COLON_EQ] = ACTIONS(1525),
    [anon_sym_DASH_GT] = ACTIONS(1523),
    [anon_sym_DASH_GT_GT] = ACTIONS(1525),
    [anon_sym_PIPE] = ACTIONS(1523),
    [anon_sym_AMP] = ACTIONS(1523),
    [anon_sym_PIPE_PIPE] = ACTIONS(1525),
    [anon_sym_AMP_AMP] = ACTIONS(1525),
    [anon_sym_LT] = ACTIONS(1523),
    [anon_sym_LT_EQ] = ACTIONS(1525),
    [anon_sym_GT] = ACTIONS(1523),
    [anon_sym_GT_EQ] = ACTIONS(1525),
    [anon_sym_EQ_EQ] = ACTIONS(1525),
    [anon_sym_BANG_EQ] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1523),
    [anon_sym_SLASH] = ACTIONS(1525),
    [anon_sym_STAR_STAR] = ACTIONS(1525),
    [anon_sym_CARET] = ACTIONS(1525),
    [aux_sym_binary_operator_token1] = ACTIONS(1525),
    [anon_sym_PIPE_GT] = ACTIONS(1525),
    [anon_sym_COLON] = ACTIONS(1523),
    [anon_sym_DOLLAR] = ACTIONS(1525),
    [anon_sym_AT] = ACTIONS(1525),
    [sym__hex_literal] = ACTIONS(1525),
    [sym__number_literal] = ACTIONS(1523),
    [anon_sym_SQUOTE] = ACTIONS(1525),
    [anon_sym_DQUOTE] = ACTIONS(1525),
    [sym_return] = ACTIONS(1523),
    [sym_next] = ACTIONS(1523),
    [sym_break] = ACTIONS(1523),
    [sym_true] = ACTIONS(1523),
    [sym_false] = ACTIONS(1523),
    [sym_null] = ACTIONS(1523),
    [sym_inf] = ACTIONS(1523),
    [sym_nan] = ACTIONS(1523),
    [anon_sym_NA] = ACTIONS(1523),
    [anon_sym_NA_integer_] = ACTIONS(1523),
    [anon_sym_NA_real_] = ACTIONS(1523),
    [anon_sym_NA_complex_] = ACTIONS(1523),
    [anon_sym_NA_character_] = ACTIONS(1523),
    [sym_dots] = ACTIONS(1523),
    [sym_dot_dot_i] = ACTIONS(1525),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1525),
    [sym__newline] = ACTIONS(1525),
    [sym__raw_string_literal] = ACTIONS(1525),
    [sym__external_open_parenthesis] = ACTIONS(1525),
    [sym__external_open_brace] = ACTIONS(1525),
    [sym__external_open_bracket] = ACTIONS(1525),
    [sym__external_open_bracket2] = ACTIONS(1525),
    [sym__external_close_bracket2] = ACTIONS(1525),
  },
  [934] = {
    [sym_function_definition] = STATE(631),
    [sym_if_statement] = STATE(631),
    [sym_for_statement] = STATE(631),
    [sym_while_statement] = STATE(631),
    [sym_repeat_statement] = STATE(631),
    [sym_braced_expression] = STATE(631),
    [sym_parenthesized_expression] = STATE(631),
    [sym_call] = STATE(631),
    [sym_subset] = STATE(631),
    [sym_subset2] = STATE(631),
    [sym_unary_operator] = STATE(631),
    [sym_binary_operator] = STATE(631),
    [sym_extract_operator] = STATE(631),
    [sym_namespace_operator] = STATE(631),
    [sym_integer] = STATE(631),
    [sym_complex] = STATE(631),
    [sym_float] = STATE(631),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(739),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(631),
    [sym__expression] = STATE(631),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(1001),
    [sym__open_brace] = STATE(842),
    [aux_sym_parenthesized_expression_repeat1] = STATE(916),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(1679),
    [sym_next] = ACTIONS(1679),
    [sym_break] = ACTIONS(1679),
    [sym_true] = ACTIONS(1679),
    [sym_false] = ACTIONS(1679),
    [sym_null] = ACTIONS(1679),
    [sym_inf] = ACTIONS(1679),
    [sym_nan] = ACTIONS(1679),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(1679),
    [sym_dot_dot_i] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1683),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1697),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [935] = {
    [sym_identifier] = ACTIONS(1551),
    [anon_sym_BSLASH] = ACTIONS(1553),
    [anon_sym_function] = ACTIONS(1551),
    [anon_sym_EQ] = ACTIONS(1551),
    [anon_sym_if] = ACTIONS(1551),
    [anon_sym_for] = ACTIONS(1551),
    [anon_sym_while] = ACTIONS(1551),
    [anon_sym_repeat] = ACTIONS(1551),
    [anon_sym_QMARK] = ACTIONS(1553),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_PLUS] = ACTIONS(1553),
    [anon_sym_DASH] = ACTIONS(1551),
    [anon_sym_LT_DASH] = ACTIONS(1553),
    [anon_sym_LT_LT_DASH] = ACTIONS(1553),
    [anon_sym_COLON_EQ] = ACTIONS(1553),
    [anon_sym_DASH_GT] = ACTIONS(1551),
    [anon_sym_DASH_GT_GT] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_PIPE_PIPE] = ACTIONS(1553),
    [anon_sym_AMP_AMP] = ACTIONS(1553),
    [anon_sym_LT] = ACTIONS(1551),
    [anon_sym_LT_EQ] = ACTIONS(1553),
    [anon_sym_GT] = ACTIONS(1551),
    [anon_sym_GT_EQ] = ACTIONS(1553),
    [anon_sym_EQ_EQ] = ACTIONS(1553),
    [anon_sym_BANG_EQ] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(1551),
    [anon_sym_SLASH] = ACTIONS(1553),
    [anon_sym_STAR_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [aux_sym_binary_operator_token1] = ACTIONS(1553),
    [anon_sym_PIPE_GT] = ACTIONS(1553),
    [anon_sym_COLON] = ACTIONS(1551),
    [anon_sym_DOLLAR] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(1553),
    [sym__hex_literal] = ACTIONS(1553),
    [sym__number_literal] = ACTIONS(1551),
    [anon_sym_SQUOTE] = ACTIONS(1553),
    [anon_sym_DQUOTE] = ACTIONS(1553),
    [sym_return] = ACTIONS(1551),
    [sym_next] = ACTIONS(1551),
    [sym_break] = ACTIONS(1551),
    [sym_true] = ACTIONS(1551),
    [sym_false] = ACTIONS(1551),
    [sym_null] = ACTIONS(1551),
    [sym_inf] = ACTIONS(1551),
    [sym_nan] = ACTIONS(1551),
    [anon_sym_NA] = ACTIONS(1551),
    [anon_sym_NA_integer_] = ACTIONS(1551),
    [anon_sym_NA_real_] = ACTIONS(1551),
    [anon_sym_NA_complex_] = ACTIONS(1551),
    [anon_sym_NA_character_] = ACTIONS(1551),
    [sym_dots] = ACTIONS(1551),
    [sym_dot_dot_i] = ACTIONS(1553),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1553),
    [sym__semicolon] = ACTIONS(1553),
    [sym__raw_string_literal] = ACTIONS(1553),
    [sym__external_open_parenthesis] = ACTIONS(1553),
    [sym__external_open_brace] = ACTIONS(1553),
    [sym__external_close_brace] = ACTIONS(1553),
    [sym__external_open_bracket] = ACTIONS(1553),
    [sym__external_open_bracket2] = ACTIONS(1553),
  },
  [936] = {
    [sym_identifier] = ACTIONS(1527),
    [anon_sym_BSLASH] = ACTIONS(1529),
    [anon_sym_function] = ACTIONS(1527),
    [anon_sym_EQ] = ACTIONS(1527),
    [anon_sym_if] = ACTIONS(1527),
    [anon_sym_for] = ACTIONS(1527),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_repeat] = ACTIONS(1527),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_TILDE] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1527),
    [anon_sym_LT_DASH] = ACTIONS(1529),
    [anon_sym_LT_LT_DASH] = ACTIONS(1529),
    [anon_sym_COLON_EQ] = ACTIONS(1529),
    [anon_sym_DASH_GT] = ACTIONS(1527),
    [anon_sym_DASH_GT_GT] = ACTIONS(1529),
    [anon_sym_PIPE] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1527),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1527),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1529),
    [anon_sym_BANG_EQ] = ACTIONS(1529),
    [anon_sym_STAR] = ACTIONS(1527),
    [anon_sym_SLASH] = ACTIONS(1529),
    [anon_sym_STAR_STAR] = ACTIONS(1529),
    [anon_sym_CARET] = ACTIONS(1529),
    [aux_sym_binary_operator_token1] = ACTIONS(1529),
    [anon_sym_PIPE_GT] = ACTIONS(1529),
    [anon_sym_COLON] = ACTIONS(1527),
    [anon_sym_DOLLAR] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(1529),
    [sym__hex_literal] = ACTIONS(1529),
    [sym__number_literal] = ACTIONS(1527),
    [anon_sym_SQUOTE] = ACTIONS(1529),
    [anon_sym_DQUOTE] = ACTIONS(1529),
    [sym_return] = ACTIONS(1527),
    [sym_next] = ACTIONS(1527),
    [sym_break] = ACTIONS(1527),
    [sym_true] = ACTIONS(1527),
    [sym_false] = ACTIONS(1527),
    [sym_null] = ACTIONS(1527),
    [sym_inf] = ACTIONS(1527),
    [sym_nan] = ACTIONS(1527),
    [anon_sym_NA] = ACTIONS(1527),
    [anon_sym_NA_integer_] = ACTIONS(1527),
    [anon_sym_NA_real_] = ACTIONS(1527),
    [anon_sym_NA_complex_] = ACTIONS(1527),
    [anon_sym_NA_character_] = ACTIONS(1527),
    [sym_dots] = ACTIONS(1527),
    [sym_dot_dot_i] = ACTIONS(1529),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1529),
    [sym__newline] = ACTIONS(1529),
    [sym__raw_string_literal] = ACTIONS(1529),
    [sym__external_open_parenthesis] = ACTIONS(1529),
    [sym__external_open_brace] = ACTIONS(1529),
    [sym__external_open_bracket] = ACTIONS(1529),
    [sym__external_open_bracket2] = ACTIONS(1529),
    [sym__external_close_bracket2] = ACTIONS(1529),
  },
  [937] = {
    [ts_builtin_sym_end] = ACTIONS(1502),
    [sym_identifier] = ACTIONS(1500),
    [anon_sym_BSLASH] = ACTIONS(1502),
    [anon_sym_function] = ACTIONS(1500),
    [anon_sym_EQ] = ACTIONS(1500),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_for] = ACTIONS(1500),
    [anon_sym_while] = ACTIONS(1500),
    [anon_sym_repeat] = ACTIONS(1500),
    [anon_sym_QMARK] = ACTIONS(1502),
    [anon_sym_TILDE] = ACTIONS(1502),
    [anon_sym_BANG] = ACTIONS(1500),
    [anon_sym_PLUS] = ACTIONS(1502),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_LT_DASH] = ACTIONS(1502),
    [anon_sym_LT_LT_DASH] = ACTIONS(1502),
    [anon_sym_COLON_EQ] = ACTIONS(1502),
    [anon_sym_DASH_GT] = ACTIONS(1500),
    [anon_sym_DASH_GT_GT] = ACTIONS(1502),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_AMP] = ACTIONS(1500),
    [anon_sym_PIPE_PIPE] = ACTIONS(1502),
    [anon_sym_AMP_AMP] = ACTIONS(1502),
    [anon_sym_LT] = ACTIONS(1500),
    [anon_sym_LT_EQ] = ACTIONS(1502),
    [anon_sym_GT] = ACTIONS(1500),
    [anon_sym_GT_EQ] = ACTIONS(1502),
    [anon_sym_EQ_EQ] = ACTIONS(1502),
    [anon_sym_BANG_EQ] = ACTIONS(1502),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1502),
    [anon_sym_STAR_STAR] = ACTIONS(1502),
    [anon_sym_CARET] = ACTIONS(1502),
    [aux_sym_binary_operator_token1] = ACTIONS(1502),
    [anon_sym_PIPE_GT] = ACTIONS(1502),
    [anon_sym_COLON] = ACTIONS(1500),
    [anon_sym_DOLLAR] = ACTIONS(1502),
    [anon_sym_AT] = ACTIONS(1502),
    [sym__hex_literal] = ACTIONS(1502),
    [sym__number_literal] = ACTIONS(1500),
    [anon_sym_SQUOTE] = ACTIONS(1502),
    [anon_sym_DQUOTE] = ACTIONS(1502),
    [sym_return] = ACTIONS(1500),
    [sym_next] = ACTIONS(1500),
    [sym_break] = ACTIONS(1500),
    [sym_true] = ACTIONS(1500),
    [sym_false] = ACTIONS(1500),
    [sym_null] = ACTIONS(1500),
    [sym_inf] = ACTIONS(1500),
    [sym_nan] = ACTIONS(1500),
    [anon_sym_NA] = ACTIONS(1500),
    [anon_sym_NA_integer_] = ACTIONS(1500),
    [anon_sym_NA_real_] = ACTIONS(1500),
    [anon_sym_NA_complex_] = ACTIONS(1500),
    [anon_sym_NA_character_] = ACTIONS(1500),
    [sym_dots] = ACTIONS(1500),
    [sym_dot_dot_i] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1502),
    [sym__semicolon] = ACTIONS(1502),
    [sym__raw_string_literal] = ACTIONS(1502),
    [sym__external_open_parenthesis] = ACTIONS(1502),
    [sym__external_open_brace] = ACTIONS(1502),
    [sym__external_open_bracket] = ACTIONS(1502),
    [sym__external_open_bracket2] = ACTIONS(1502),
  },
  [938] = {
    [ts_builtin_sym_end] = ACTIONS(1537),
    [sym_identifier] = ACTIONS(1535),
    [anon_sym_BSLASH] = ACTIONS(1537),
    [anon_sym_function] = ACTIONS(1535),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_if] = ACTIONS(1535),
    [anon_sym_for] = ACTIONS(1535),
    [anon_sym_while] = ACTIONS(1535),
    [anon_sym_repeat] = ACTIONS(1535),
    [anon_sym_QMARK] = ACTIONS(1537),
    [anon_sym_TILDE] = ACTIONS(1537),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1535),
    [anon_sym_LT_DASH] = ACTIONS(1537),
    [anon_sym_LT_LT_DASH] = ACTIONS(1537),
    [anon_sym_COLON_EQ] = ACTIONS(1537),
    [anon_sym_DASH_GT] = ACTIONS(1535),
    [anon_sym_DASH_GT_GT] = ACTIONS(1537),
    [anon_sym_PIPE] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_PIPE_PIPE] = ACTIONS(1537),
    [anon_sym_AMP_AMP] = ACTIONS(1537),
    [anon_sym_LT] = ACTIONS(1535),
    [anon_sym_LT_EQ] = ACTIONS(1537),
    [anon_sym_GT] = ACTIONS(1535),
    [anon_sym_GT_EQ] = ACTIONS(1537),
    [anon_sym_EQ_EQ] = ACTIONS(1537),
    [anon_sym_BANG_EQ] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_SLASH] = ACTIONS(1537),
    [anon_sym_STAR_STAR] = ACTIONS(1537),
    [anon_sym_CARET] = ACTIONS(1537),
    [aux_sym_binary_operator_token1] = ACTIONS(1537),
    [anon_sym_PIPE_GT] = ACTIONS(1537),
    [anon_sym_COLON] = ACTIONS(1535),
    [anon_sym_DOLLAR] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(1537),
    [sym__hex_literal] = ACTIONS(1537),
    [sym__number_literal] = ACTIONS(1535),
    [anon_sym_SQUOTE] = ACTIONS(1537),
    [anon_sym_DQUOTE] = ACTIONS(1537),
    [sym_return] = ACTIONS(1535),
    [sym_next] = ACTIONS(1535),
    [sym_break] = ACTIONS(1535),
    [sym_true] = ACTIONS(1535),
    [sym_false] = ACTIONS(1535),
    [sym_null] = ACTIONS(1535),
    [sym_inf] = ACTIONS(1535),
    [sym_nan] = ACTIONS(1535),
    [anon_sym_NA] = ACTIONS(1535),
    [anon_sym_NA_integer_] = ACTIONS(1535),
    [anon_sym_NA_real_] = ACTIONS(1535),
    [anon_sym_NA_complex_] = ACTIONS(1535),
    [anon_sym_NA_character_] = ACTIONS(1535),
    [sym_dots] = ACTIONS(1535),
    [sym_dot_dot_i] = ACTIONS(1537),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1537),
    [sym__semicolon] = ACTIONS(1537),
    [sym__raw_string_literal] = ACTIONS(1537),
    [sym__external_open_parenthesis] = ACTIONS(1537),
    [sym__external_open_brace] = ACTIONS(1537),
    [sym__external_open_bracket] = ACTIONS(1537),
    [sym__external_open_bracket2] = ACTIONS(1537),
  },
  [939] = {
    [sym_function_definition] = STATE(631),
    [sym_if_statement] = STATE(631),
    [sym_for_statement] = STATE(631),
    [sym_while_statement] = STATE(631),
    [sym_repeat_statement] = STATE(631),
    [sym_braced_expression] = STATE(631),
    [sym_parenthesized_expression] = STATE(631),
    [sym_call] = STATE(631),
    [sym_subset] = STATE(631),
    [sym_subset2] = STATE(631),
    [sym_unary_operator] = STATE(631),
    [sym_binary_operator] = STATE(631),
    [sym_extract_operator] = STATE(631),
    [sym_namespace_operator] = STATE(631),
    [sym_integer] = STATE(631),
    [sym_complex] = STATE(631),
    [sym_float] = STATE(631),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(739),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(631),
    [sym__expression] = STATE(631),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(1985),
    [sym__open_brace] = STATE(842),
    [aux_sym_parenthesized_expression_repeat1] = STATE(1003),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(1679),
    [sym_next] = ACTIONS(1679),
    [sym_break] = ACTIONS(1679),
    [sym_true] = ACTIONS(1679),
    [sym_false] = ACTIONS(1679),
    [sym_null] = ACTIONS(1679),
    [sym_inf] = ACTIONS(1679),
    [sym_nan] = ACTIONS(1679),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(1679),
    [sym_dot_dot_i] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1683),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1699),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [940] = {
    [sym_identifier] = ACTIONS(1551),
    [anon_sym_BSLASH] = ACTIONS(1553),
    [anon_sym_function] = ACTIONS(1551),
    [anon_sym_EQ] = ACTIONS(1551),
    [anon_sym_if] = ACTIONS(1551),
    [anon_sym_for] = ACTIONS(1551),
    [anon_sym_while] = ACTIONS(1551),
    [anon_sym_repeat] = ACTIONS(1551),
    [anon_sym_QMARK] = ACTIONS(1553),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_PLUS] = ACTIONS(1553),
    [anon_sym_DASH] = ACTIONS(1551),
    [anon_sym_LT_DASH] = ACTIONS(1553),
    [anon_sym_LT_LT_DASH] = ACTIONS(1553),
    [anon_sym_COLON_EQ] = ACTIONS(1553),
    [anon_sym_DASH_GT] = ACTIONS(1551),
    [anon_sym_DASH_GT_GT] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_PIPE_PIPE] = ACTIONS(1553),
    [anon_sym_AMP_AMP] = ACTIONS(1553),
    [anon_sym_LT] = ACTIONS(1551),
    [anon_sym_LT_EQ] = ACTIONS(1553),
    [anon_sym_GT] = ACTIONS(1551),
    [anon_sym_GT_EQ] = ACTIONS(1553),
    [anon_sym_EQ_EQ] = ACTIONS(1553),
    [anon_sym_BANG_EQ] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(1551),
    [anon_sym_SLASH] = ACTIONS(1553),
    [anon_sym_STAR_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [aux_sym_binary_operator_token1] = ACTIONS(1553),
    [anon_sym_PIPE_GT] = ACTIONS(1553),
    [anon_sym_COLON] = ACTIONS(1551),
    [anon_sym_DOLLAR] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(1553),
    [sym__hex_literal] = ACTIONS(1553),
    [sym__number_literal] = ACTIONS(1551),
    [anon_sym_SQUOTE] = ACTIONS(1553),
    [anon_sym_DQUOTE] = ACTIONS(1553),
    [sym_return] = ACTIONS(1551),
    [sym_next] = ACTIONS(1551),
    [sym_break] = ACTIONS(1551),
    [sym_true] = ACTIONS(1551),
    [sym_false] = ACTIONS(1551),
    [sym_null] = ACTIONS(1551),
    [sym_inf] = ACTIONS(1551),
    [sym_nan] = ACTIONS(1551),
    [anon_sym_NA] = ACTIONS(1551),
    [anon_sym_NA_integer_] = ACTIONS(1551),
    [anon_sym_NA_real_] = ACTIONS(1551),
    [anon_sym_NA_complex_] = ACTIONS(1551),
    [anon_sym_NA_character_] = ACTIONS(1551),
    [sym_dots] = ACTIONS(1551),
    [sym_dot_dot_i] = ACTIONS(1553),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1553),
    [sym__newline] = ACTIONS(1553),
    [sym__raw_string_literal] = ACTIONS(1553),
    [sym__external_open_parenthesis] = ACTIONS(1553),
    [sym__external_open_brace] = ACTIONS(1553),
    [sym__external_open_bracket] = ACTIONS(1553),
    [sym__external_close_bracket] = ACTIONS(1553),
    [sym__external_open_bracket2] = ACTIONS(1553),
  },
  [941] = {
    [sym_function_definition] = STATE(631),
    [sym_if_statement] = STATE(631),
    [sym_for_statement] = STATE(631),
    [sym_while_statement] = STATE(631),
    [sym_repeat_statement] = STATE(631),
    [sym_braced_expression] = STATE(631),
    [sym_parenthesized_expression] = STATE(631),
    [sym_call] = STATE(631),
    [sym_subset] = STATE(631),
    [sym_subset2] = STATE(631),
    [sym_unary_operator] = STATE(631),
    [sym_binary_operator] = STATE(631),
    [sym_extract_operator] = STATE(631),
    [sym_namespace_operator] = STATE(631),
    [sym_integer] = STATE(631),
    [sym_complex] = STATE(631),
    [sym_float] = STATE(631),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(739),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(631),
    [sym__expression] = STATE(631),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(1982),
    [sym__open_brace] = STATE(842),
    [aux_sym_parenthesized_expression_repeat1] = STATE(939),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(1679),
    [sym_next] = ACTIONS(1679),
    [sym_break] = ACTIONS(1679),
    [sym_true] = ACTIONS(1679),
    [sym_false] = ACTIONS(1679),
    [sym_null] = ACTIONS(1679),
    [sym_inf] = ACTIONS(1679),
    [sym_nan] = ACTIONS(1679),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(1679),
    [sym_dot_dot_i] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1683),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1701),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [942] = {
    [sym_identifier] = ACTIONS(1468),
    [anon_sym_BSLASH] = ACTIONS(1470),
    [anon_sym_function] = ACTIONS(1468),
    [anon_sym_EQ] = ACTIONS(1468),
    [anon_sym_if] = ACTIONS(1468),
    [anon_sym_for] = ACTIONS(1468),
    [anon_sym_while] = ACTIONS(1468),
    [anon_sym_repeat] = ACTIONS(1468),
    [anon_sym_QMARK] = ACTIONS(1470),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_BANG] = ACTIONS(1468),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1468),
    [anon_sym_LT_DASH] = ACTIONS(1470),
    [anon_sym_LT_LT_DASH] = ACTIONS(1470),
    [anon_sym_COLON_EQ] = ACTIONS(1470),
    [anon_sym_DASH_GT] = ACTIONS(1468),
    [anon_sym_DASH_GT_GT] = ACTIONS(1470),
    [anon_sym_PIPE] = ACTIONS(1468),
    [anon_sym_AMP] = ACTIONS(1468),
    [anon_sym_PIPE_PIPE] = ACTIONS(1470),
    [anon_sym_AMP_AMP] = ACTIONS(1470),
    [anon_sym_LT] = ACTIONS(1468),
    [anon_sym_LT_EQ] = ACTIONS(1470),
    [anon_sym_GT] = ACTIONS(1468),
    [anon_sym_GT_EQ] = ACTIONS(1470),
    [anon_sym_EQ_EQ] = ACTIONS(1470),
    [anon_sym_BANG_EQ] = ACTIONS(1470),
    [anon_sym_STAR] = ACTIONS(1468),
    [anon_sym_SLASH] = ACTIONS(1470),
    [anon_sym_STAR_STAR] = ACTIONS(1470),
    [anon_sym_CARET] = ACTIONS(1470),
    [aux_sym_binary_operator_token1] = ACTIONS(1470),
    [anon_sym_PIPE_GT] = ACTIONS(1470),
    [anon_sym_COLON] = ACTIONS(1468),
    [anon_sym_DOLLAR] = ACTIONS(1470),
    [anon_sym_AT] = ACTIONS(1470),
    [sym__hex_literal] = ACTIONS(1470),
    [sym__number_literal] = ACTIONS(1468),
    [anon_sym_SQUOTE] = ACTIONS(1470),
    [anon_sym_DQUOTE] = ACTIONS(1470),
    [sym_return] = ACTIONS(1468),
    [sym_next] = ACTIONS(1468),
    [sym_break] = ACTIONS(1468),
    [sym_true] = ACTIONS(1468),
    [sym_false] = ACTIONS(1468),
    [sym_null] = ACTIONS(1468),
    [sym_inf] = ACTIONS(1468),
    [sym_nan] = ACTIONS(1468),
    [anon_sym_NA] = ACTIONS(1468),
    [anon_sym_NA_integer_] = ACTIONS(1468),
    [anon_sym_NA_real_] = ACTIONS(1468),
    [anon_sym_NA_complex_] = ACTIONS(1468),
    [anon_sym_NA_character_] = ACTIONS(1468),
    [sym_dots] = ACTIONS(1468),
    [sym_dot_dot_i] = ACTIONS(1470),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1470),
    [sym__newline] = ACTIONS(1470),
    [sym__raw_string_literal] = ACTIONS(1470),
    [sym__external_open_parenthesis] = ACTIONS(1470),
    [sym__external_close_parenthesis] = ACTIONS(1470),
    [sym__external_open_brace] = ACTIONS(1470),
    [sym__external_open_bracket] = ACTIONS(1470),
    [sym__external_open_bracket2] = ACTIONS(1470),
  },
  [943] = {
    [sym_identifier] = ACTIONS(1484),
    [anon_sym_BSLASH] = ACTIONS(1486),
    [anon_sym_function] = ACTIONS(1484),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_if] = ACTIONS(1484),
    [anon_sym_for] = ACTIONS(1484),
    [anon_sym_while] = ACTIONS(1484),
    [anon_sym_repeat] = ACTIONS(1484),
    [anon_sym_QMARK] = ACTIONS(1486),
    [anon_sym_TILDE] = ACTIONS(1486),
    [anon_sym_BANG] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_LT_DASH] = ACTIONS(1486),
    [anon_sym_LT_LT_DASH] = ACTIONS(1486),
    [anon_sym_COLON_EQ] = ACTIONS(1486),
    [anon_sym_DASH_GT] = ACTIONS(1484),
    [anon_sym_DASH_GT_GT] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1484),
    [anon_sym_AMP] = ACTIONS(1484),
    [anon_sym_PIPE_PIPE] = ACTIONS(1486),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_LT] = ACTIONS(1484),
    [anon_sym_LT_EQ] = ACTIONS(1486),
    [anon_sym_GT] = ACTIONS(1484),
    [anon_sym_GT_EQ] = ACTIONS(1486),
    [anon_sym_EQ_EQ] = ACTIONS(1486),
    [anon_sym_BANG_EQ] = ACTIONS(1486),
    [anon_sym_STAR] = ACTIONS(1484),
    [anon_sym_SLASH] = ACTIONS(1486),
    [anon_sym_STAR_STAR] = ACTIONS(1486),
    [anon_sym_CARET] = ACTIONS(1486),
    [aux_sym_binary_operator_token1] = ACTIONS(1486),
    [anon_sym_PIPE_GT] = ACTIONS(1486),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(1486),
    [anon_sym_AT] = ACTIONS(1486),
    [sym__hex_literal] = ACTIONS(1486),
    [sym__number_literal] = ACTIONS(1484),
    [anon_sym_SQUOTE] = ACTIONS(1486),
    [anon_sym_DQUOTE] = ACTIONS(1486),
    [sym_return] = ACTIONS(1484),
    [sym_next] = ACTIONS(1484),
    [sym_break] = ACTIONS(1484),
    [sym_true] = ACTIONS(1484),
    [sym_false] = ACTIONS(1484),
    [sym_null] = ACTIONS(1484),
    [sym_inf] = ACTIONS(1484),
    [sym_nan] = ACTIONS(1484),
    [anon_sym_NA] = ACTIONS(1484),
    [anon_sym_NA_integer_] = ACTIONS(1484),
    [anon_sym_NA_real_] = ACTIONS(1484),
    [anon_sym_NA_complex_] = ACTIONS(1484),
    [anon_sym_NA_character_] = ACTIONS(1484),
    [sym_dots] = ACTIONS(1484),
    [sym_dot_dot_i] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1486),
    [sym__newline] = ACTIONS(1486),
    [sym__raw_string_literal] = ACTIONS(1486),
    [sym__external_open_parenthesis] = ACTIONS(1486),
    [sym__external_close_parenthesis] = ACTIONS(1486),
    [sym__external_open_brace] = ACTIONS(1486),
    [sym__external_open_bracket] = ACTIONS(1486),
    [sym__external_open_bracket2] = ACTIONS(1486),
  },
  [944] = {
    [sym_identifier] = ACTIONS(1515),
    [anon_sym_BSLASH] = ACTIONS(1517),
    [anon_sym_function] = ACTIONS(1515),
    [anon_sym_EQ] = ACTIONS(1515),
    [anon_sym_if] = ACTIONS(1515),
    [anon_sym_for] = ACTIONS(1515),
    [anon_sym_while] = ACTIONS(1515),
    [anon_sym_repeat] = ACTIONS(1515),
    [anon_sym_QMARK] = ACTIONS(1517),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_DASH] = ACTIONS(1515),
    [anon_sym_LT_DASH] = ACTIONS(1517),
    [anon_sym_LT_LT_DASH] = ACTIONS(1517),
    [anon_sym_COLON_EQ] = ACTIONS(1517),
    [anon_sym_DASH_GT] = ACTIONS(1515),
    [anon_sym_DASH_GT_GT] = ACTIONS(1517),
    [anon_sym_PIPE] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_PIPE_PIPE] = ACTIONS(1517),
    [anon_sym_AMP_AMP] = ACTIONS(1517),
    [anon_sym_LT] = ACTIONS(1515),
    [anon_sym_LT_EQ] = ACTIONS(1517),
    [anon_sym_GT] = ACTIONS(1515),
    [anon_sym_GT_EQ] = ACTIONS(1517),
    [anon_sym_EQ_EQ] = ACTIONS(1517),
    [anon_sym_BANG_EQ] = ACTIONS(1517),
    [anon_sym_STAR] = ACTIONS(1515),
    [anon_sym_SLASH] = ACTIONS(1517),
    [anon_sym_STAR_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [aux_sym_binary_operator_token1] = ACTIONS(1517),
    [anon_sym_PIPE_GT] = ACTIONS(1517),
    [anon_sym_COLON] = ACTIONS(1515),
    [anon_sym_DOLLAR] = ACTIONS(1517),
    [anon_sym_AT] = ACTIONS(1517),
    [sym__hex_literal] = ACTIONS(1517),
    [sym__number_literal] = ACTIONS(1515),
    [anon_sym_SQUOTE] = ACTIONS(1517),
    [anon_sym_DQUOTE] = ACTIONS(1517),
    [sym_return] = ACTIONS(1515),
    [sym_next] = ACTIONS(1515),
    [sym_break] = ACTIONS(1515),
    [sym_true] = ACTIONS(1515),
    [sym_false] = ACTIONS(1515),
    [sym_null] = ACTIONS(1515),
    [sym_inf] = ACTIONS(1515),
    [sym_nan] = ACTIONS(1515),
    [anon_sym_NA] = ACTIONS(1515),
    [anon_sym_NA_integer_] = ACTIONS(1515),
    [anon_sym_NA_real_] = ACTIONS(1515),
    [anon_sym_NA_complex_] = ACTIONS(1515),
    [anon_sym_NA_character_] = ACTIONS(1515),
    [sym_dots] = ACTIONS(1515),
    [sym_dot_dot_i] = ACTIONS(1517),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1517),
    [sym__newline] = ACTIONS(1517),
    [sym__raw_string_literal] = ACTIONS(1517),
    [sym__external_open_parenthesis] = ACTIONS(1517),
    [sym__external_close_parenthesis] = ACTIONS(1517),
    [sym__external_open_brace] = ACTIONS(1517),
    [sym__external_open_bracket] = ACTIONS(1517),
    [sym__external_open_bracket2] = ACTIONS(1517),
  },
  [945] = {
    [ts_builtin_sym_end] = ACTIONS(1478),
    [sym_identifier] = ACTIONS(1476),
    [anon_sym_BSLASH] = ACTIONS(1478),
    [anon_sym_function] = ACTIONS(1476),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_if] = ACTIONS(1476),
    [anon_sym_for] = ACTIONS(1476),
    [anon_sym_while] = ACTIONS(1476),
    [anon_sym_repeat] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_BANG] = ACTIONS(1476),
    [anon_sym_PLUS] = ACTIONS(1478),
    [anon_sym_DASH] = ACTIONS(1476),
    [anon_sym_LT_DASH] = ACTIONS(1478),
    [anon_sym_LT_LT_DASH] = ACTIONS(1478),
    [anon_sym_COLON_EQ] = ACTIONS(1478),
    [anon_sym_DASH_GT] = ACTIONS(1476),
    [anon_sym_DASH_GT_GT] = ACTIONS(1478),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1478),
    [anon_sym_AMP_AMP] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_EQ] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_GT_EQ] = ACTIONS(1478),
    [anon_sym_EQ_EQ] = ACTIONS(1478),
    [anon_sym_BANG_EQ] = ACTIONS(1478),
    [anon_sym_STAR] = ACTIONS(1476),
    [anon_sym_SLASH] = ACTIONS(1478),
    [anon_sym_STAR_STAR] = ACTIONS(1478),
    [anon_sym_CARET] = ACTIONS(1478),
    [aux_sym_binary_operator_token1] = ACTIONS(1478),
    [anon_sym_PIPE_GT] = ACTIONS(1478),
    [anon_sym_COLON] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1478),
    [anon_sym_AT] = ACTIONS(1478),
    [sym__hex_literal] = ACTIONS(1478),
    [sym__number_literal] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_DQUOTE] = ACTIONS(1478),
    [sym_return] = ACTIONS(1476),
    [sym_next] = ACTIONS(1476),
    [sym_break] = ACTIONS(1476),
    [sym_true] = ACTIONS(1476),
    [sym_false] = ACTIONS(1476),
    [sym_null] = ACTIONS(1476),
    [sym_inf] = ACTIONS(1476),
    [sym_nan] = ACTIONS(1476),
    [anon_sym_NA] = ACTIONS(1476),
    [anon_sym_NA_integer_] = ACTIONS(1476),
    [anon_sym_NA_real_] = ACTIONS(1476),
    [anon_sym_NA_complex_] = ACTIONS(1476),
    [anon_sym_NA_character_] = ACTIONS(1476),
    [sym_dots] = ACTIONS(1476),
    [sym_dot_dot_i] = ACTIONS(1478),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1478),
    [sym__semicolon] = ACTIONS(1478),
    [sym__raw_string_literal] = ACTIONS(1478),
    [sym__external_open_parenthesis] = ACTIONS(1478),
    [sym__external_open_brace] = ACTIONS(1478),
    [sym__external_open_bracket] = ACTIONS(1478),
    [sym__external_open_bracket2] = ACTIONS(1478),
  },
  [946] = {
    [sym_identifier] = ACTIONS(1484),
    [anon_sym_BSLASH] = ACTIONS(1486),
    [anon_sym_function] = ACTIONS(1484),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_if] = ACTIONS(1484),
    [anon_sym_for] = ACTIONS(1484),
    [anon_sym_while] = ACTIONS(1484),
    [anon_sym_repeat] = ACTIONS(1484),
    [anon_sym_QMARK] = ACTIONS(1486),
    [anon_sym_TILDE] = ACTIONS(1486),
    [anon_sym_BANG] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_LT_DASH] = ACTIONS(1486),
    [anon_sym_LT_LT_DASH] = ACTIONS(1486),
    [anon_sym_COLON_EQ] = ACTIONS(1486),
    [anon_sym_DASH_GT] = ACTIONS(1484),
    [anon_sym_DASH_GT_GT] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1484),
    [anon_sym_AMP] = ACTIONS(1484),
    [anon_sym_PIPE_PIPE] = ACTIONS(1486),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_LT] = ACTIONS(1484),
    [anon_sym_LT_EQ] = ACTIONS(1486),
    [anon_sym_GT] = ACTIONS(1484),
    [anon_sym_GT_EQ] = ACTIONS(1486),
    [anon_sym_EQ_EQ] = ACTIONS(1486),
    [anon_sym_BANG_EQ] = ACTIONS(1486),
    [anon_sym_STAR] = ACTIONS(1484),
    [anon_sym_SLASH] = ACTIONS(1486),
    [anon_sym_STAR_STAR] = ACTIONS(1486),
    [anon_sym_CARET] = ACTIONS(1486),
    [aux_sym_binary_operator_token1] = ACTIONS(1486),
    [anon_sym_PIPE_GT] = ACTIONS(1486),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(1486),
    [anon_sym_AT] = ACTIONS(1486),
    [sym__hex_literal] = ACTIONS(1486),
    [sym__number_literal] = ACTIONS(1484),
    [anon_sym_SQUOTE] = ACTIONS(1486),
    [anon_sym_DQUOTE] = ACTIONS(1486),
    [sym_return] = ACTIONS(1484),
    [sym_next] = ACTIONS(1484),
    [sym_break] = ACTIONS(1484),
    [sym_true] = ACTIONS(1484),
    [sym_false] = ACTIONS(1484),
    [sym_null] = ACTIONS(1484),
    [sym_inf] = ACTIONS(1484),
    [sym_nan] = ACTIONS(1484),
    [anon_sym_NA] = ACTIONS(1484),
    [anon_sym_NA_integer_] = ACTIONS(1484),
    [anon_sym_NA_real_] = ACTIONS(1484),
    [anon_sym_NA_complex_] = ACTIONS(1484),
    [anon_sym_NA_character_] = ACTIONS(1484),
    [sym_dots] = ACTIONS(1484),
    [sym_dot_dot_i] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1486),
    [sym__semicolon] = ACTIONS(1486),
    [sym__raw_string_literal] = ACTIONS(1486),
    [sym__external_open_parenthesis] = ACTIONS(1486),
    [sym__external_open_brace] = ACTIONS(1486),
    [sym__external_close_brace] = ACTIONS(1486),
    [sym__external_open_bracket] = ACTIONS(1486),
    [sym__external_open_bracket2] = ACTIONS(1486),
  },
  [947] = {
    [ts_builtin_sym_end] = ACTIONS(1541),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_BSLASH] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1539),
    [anon_sym_if] = ACTIONS(1539),
    [anon_sym_for] = ACTIONS(1539),
    [anon_sym_while] = ACTIONS(1539),
    [anon_sym_repeat] = ACTIONS(1539),
    [anon_sym_QMARK] = ACTIONS(1541),
    [anon_sym_TILDE] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1539),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1539),
    [anon_sym_LT_DASH] = ACTIONS(1541),
    [anon_sym_LT_LT_DASH] = ACTIONS(1541),
    [anon_sym_COLON_EQ] = ACTIONS(1541),
    [anon_sym_DASH_GT] = ACTIONS(1539),
    [anon_sym_DASH_GT_GT] = ACTIONS(1541),
    [anon_sym_PIPE] = ACTIONS(1539),
    [anon_sym_AMP] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1541),
    [anon_sym_GT] = ACTIONS(1539),
    [anon_sym_GT_EQ] = ACTIONS(1541),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1539),
    [anon_sym_SLASH] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_CARET] = ACTIONS(1541),
    [aux_sym_binary_operator_token1] = ACTIONS(1541),
    [anon_sym_PIPE_GT] = ACTIONS(1541),
    [anon_sym_COLON] = ACTIONS(1539),
    [anon_sym_DOLLAR] = ACTIONS(1541),
    [anon_sym_AT] = ACTIONS(1541),
    [sym__hex_literal] = ACTIONS(1541),
    [sym__number_literal] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(1541),
    [anon_sym_DQUOTE] = ACTIONS(1541),
    [sym_return] = ACTIONS(1539),
    [sym_next] = ACTIONS(1539),
    [sym_break] = ACTIONS(1539),
    [sym_true] = ACTIONS(1539),
    [sym_false] = ACTIONS(1539),
    [sym_null] = ACTIONS(1539),
    [sym_inf] = ACTIONS(1539),
    [sym_nan] = ACTIONS(1539),
    [anon_sym_NA] = ACTIONS(1539),
    [anon_sym_NA_integer_] = ACTIONS(1539),
    [anon_sym_NA_real_] = ACTIONS(1539),
    [anon_sym_NA_complex_] = ACTIONS(1539),
    [anon_sym_NA_character_] = ACTIONS(1539),
    [sym_dots] = ACTIONS(1539),
    [sym_dot_dot_i] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1541),
    [sym__semicolon] = ACTIONS(1541),
    [sym__raw_string_literal] = ACTIONS(1541),
    [sym__external_open_parenthesis] = ACTIONS(1541),
    [sym__external_open_brace] = ACTIONS(1541),
    [sym__external_open_bracket] = ACTIONS(1541),
    [sym__external_open_bracket2] = ACTIONS(1541),
  },
  [948] = {
    [sym_function_definition] = STATE(631),
    [sym_if_statement] = STATE(631),
    [sym_for_statement] = STATE(631),
    [sym_while_statement] = STATE(631),
    [sym_repeat_statement] = STATE(631),
    [sym_braced_expression] = STATE(631),
    [sym_parenthesized_expression] = STATE(631),
    [sym_call] = STATE(631),
    [sym_subset] = STATE(631),
    [sym_subset2] = STATE(631),
    [sym_unary_operator] = STATE(631),
    [sym_binary_operator] = STATE(631),
    [sym_extract_operator] = STATE(631),
    [sym_namespace_operator] = STATE(631),
    [sym_integer] = STATE(631),
    [sym_complex] = STATE(631),
    [sym_float] = STATE(631),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(739),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(631),
    [sym__expression] = STATE(631),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(979),
    [sym__open_brace] = STATE(842),
    [aux_sym_parenthesized_expression_repeat1] = STATE(1002),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(1679),
    [sym_next] = ACTIONS(1679),
    [sym_break] = ACTIONS(1679),
    [sym_true] = ACTIONS(1679),
    [sym_false] = ACTIONS(1679),
    [sym_null] = ACTIONS(1679),
    [sym_inf] = ACTIONS(1679),
    [sym_nan] = ACTIONS(1679),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(1679),
    [sym_dot_dot_i] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1683),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1703),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [949] = {
    [sym_function_definition] = STATE(631),
    [sym_if_statement] = STATE(631),
    [sym_for_statement] = STATE(631),
    [sym_while_statement] = STATE(631),
    [sym_repeat_statement] = STATE(631),
    [sym_braced_expression] = STATE(631),
    [sym_parenthesized_expression] = STATE(631),
    [sym_call] = STATE(631),
    [sym_subset] = STATE(631),
    [sym_subset2] = STATE(631),
    [sym_unary_operator] = STATE(631),
    [sym_binary_operator] = STATE(631),
    [sym_extract_operator] = STATE(631),
    [sym_namespace_operator] = STATE(631),
    [sym_integer] = STATE(631),
    [sym_complex] = STATE(631),
    [sym_float] = STATE(631),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(739),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(631),
    [sym__expression] = STATE(631),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(884),
    [sym__open_brace] = STATE(842),
    [aux_sym_parenthesized_expression_repeat1] = STATE(1003),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(1679),
    [sym_next] = ACTIONS(1679),
    [sym_break] = ACTIONS(1679),
    [sym_true] = ACTIONS(1679),
    [sym_false] = ACTIONS(1679),
    [sym_null] = ACTIONS(1679),
    [sym_inf] = ACTIONS(1679),
    [sym_nan] = ACTIONS(1679),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(1679),
    [sym_dot_dot_i] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1683),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1705),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [950] = {
    [sym_function_definition] = STATE(429),
    [sym_if_statement] = STATE(429),
    [sym_for_statement] = STATE(429),
    [sym_while_statement] = STATE(429),
    [sym_repeat_statement] = STATE(429),
    [sym_braced_expression] = STATE(429),
    [sym_parenthesized_expression] = STATE(429),
    [sym_call] = STATE(429),
    [sym_subset] = STATE(429),
    [sym_subset2] = STATE(429),
    [sym__argument_value] = STATE(1931),
    [sym_unary_operator] = STATE(429),
    [sym_binary_operator] = STATE(429),
    [sym_extract_operator] = STATE(429),
    [sym_namespace_operator] = STATE(429),
    [sym_integer] = STATE(429),
    [sym_complex] = STATE(429),
    [sym_float] = STATE(429),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(739),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(429),
    [sym__expression] = STATE(429),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__open_brace] = STATE(842),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(767),
    [sym_next] = ACTIONS(767),
    [sym_break] = ACTIONS(767),
    [sym_true] = ACTIONS(767),
    [sym_false] = ACTIONS(767),
    [sym_null] = ACTIONS(767),
    [sym_inf] = ACTIONS(767),
    [sym_nan] = ACTIONS(767),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(767),
    [sym_dot_dot_i] = ACTIONS(773),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1689),
    [sym__newline] = ACTIONS(777),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1689),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [951] = {
    [ts_builtin_sym_end] = ACTIONS(1545),
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_BSLASH] = ACTIONS(1545),
    [anon_sym_function] = ACTIONS(1543),
    [anon_sym_EQ] = ACTIONS(1543),
    [anon_sym_if] = ACTIONS(1543),
    [anon_sym_for] = ACTIONS(1543),
    [anon_sym_while] = ACTIONS(1543),
    [anon_sym_repeat] = ACTIONS(1543),
    [anon_sym_QMARK] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1543),
    [anon_sym_PLUS] = ACTIONS(1545),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_LT_DASH] = ACTIONS(1545),
    [anon_sym_LT_LT_DASH] = ACTIONS(1545),
    [anon_sym_COLON_EQ] = ACTIONS(1545),
    [anon_sym_DASH_GT] = ACTIONS(1543),
    [anon_sym_DASH_GT_GT] = ACTIONS(1545),
    [anon_sym_PIPE] = ACTIONS(1543),
    [anon_sym_AMP] = ACTIONS(1543),
    [anon_sym_PIPE_PIPE] = ACTIONS(1545),
    [anon_sym_AMP_AMP] = ACTIONS(1545),
    [anon_sym_LT] = ACTIONS(1543),
    [anon_sym_LT_EQ] = ACTIONS(1545),
    [anon_sym_GT] = ACTIONS(1543),
    [anon_sym_GT_EQ] = ACTIONS(1545),
    [anon_sym_EQ_EQ] = ACTIONS(1545),
    [anon_sym_BANG_EQ] = ACTIONS(1545),
    [anon_sym_STAR] = ACTIONS(1543),
    [anon_sym_SLASH] = ACTIONS(1545),
    [anon_sym_STAR_STAR] = ACTIONS(1545),
    [anon_sym_CARET] = ACTIONS(1545),
    [aux_sym_binary_operator_token1] = ACTIONS(1545),
    [anon_sym_PIPE_GT] = ACTIONS(1545),
    [anon_sym_COLON] = ACTIONS(1543),
    [anon_sym_DOLLAR] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(1545),
    [sym__hex_literal] = ACTIONS(1545),
    [sym__number_literal] = ACTIONS(1543),
    [anon_sym_SQUOTE] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1545),
    [sym_return] = ACTIONS(1543),
    [sym_next] = ACTIONS(1543),
    [sym_break] = ACTIONS(1543),
    [sym_true] = ACTIONS(1543),
    [sym_false] = ACTIONS(1543),
    [sym_null] = ACTIONS(1543),
    [sym_inf] = ACTIONS(1543),
    [sym_nan] = ACTIONS(1543),
    [anon_sym_NA] = ACTIONS(1543),
    [anon_sym_NA_integer_] = ACTIONS(1543),
    [anon_sym_NA_real_] = ACTIONS(1543),
    [anon_sym_NA_complex_] = ACTIONS(1543),
    [anon_sym_NA_character_] = ACTIONS(1543),
    [sym_dots] = ACTIONS(1543),
    [sym_dot_dot_i] = ACTIONS(1545),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1545),
    [sym__semicolon] = ACTIONS(1545),
    [sym__raw_string_literal] = ACTIONS(1545),
    [sym__external_open_parenthesis] = ACTIONS(1545),
    [sym__external_open_brace] = ACTIONS(1545),
    [sym__external_open_bracket] = ACTIONS(1545),
    [sym__external_open_bracket2] = ACTIONS(1545),
  },
  [952] = {
    [sym_identifier] = ACTIONS(1468),
    [anon_sym_BSLASH] = ACTIONS(1470),
    [anon_sym_function] = ACTIONS(1468),
    [anon_sym_EQ] = ACTIONS(1468),
    [anon_sym_if] = ACTIONS(1468),
    [anon_sym_for] = ACTIONS(1468),
    [anon_sym_while] = ACTIONS(1468),
    [anon_sym_repeat] = ACTIONS(1468),
    [anon_sym_QMARK] = ACTIONS(1470),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_BANG] = ACTIONS(1468),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1468),
    [anon_sym_LT_DASH] = ACTIONS(1470),
    [anon_sym_LT_LT_DASH] = ACTIONS(1470),
    [anon_sym_COLON_EQ] = ACTIONS(1470),
    [anon_sym_DASH_GT] = ACTIONS(1468),
    [anon_sym_DASH_GT_GT] = ACTIONS(1470),
    [anon_sym_PIPE] = ACTIONS(1468),
    [anon_sym_AMP] = ACTIONS(1468),
    [anon_sym_PIPE_PIPE] = ACTIONS(1470),
    [anon_sym_AMP_AMP] = ACTIONS(1470),
    [anon_sym_LT] = ACTIONS(1468),
    [anon_sym_LT_EQ] = ACTIONS(1470),
    [anon_sym_GT] = ACTIONS(1468),
    [anon_sym_GT_EQ] = ACTIONS(1470),
    [anon_sym_EQ_EQ] = ACTIONS(1470),
    [anon_sym_BANG_EQ] = ACTIONS(1470),
    [anon_sym_STAR] = ACTIONS(1468),
    [anon_sym_SLASH] = ACTIONS(1470),
    [anon_sym_STAR_STAR] = ACTIONS(1470),
    [anon_sym_CARET] = ACTIONS(1470),
    [aux_sym_binary_operator_token1] = ACTIONS(1470),
    [anon_sym_PIPE_GT] = ACTIONS(1470),
    [anon_sym_COLON] = ACTIONS(1468),
    [anon_sym_DOLLAR] = ACTIONS(1470),
    [anon_sym_AT] = ACTIONS(1470),
    [sym__hex_literal] = ACTIONS(1470),
    [sym__number_literal] = ACTIONS(1468),
    [anon_sym_SQUOTE] = ACTIONS(1470),
    [anon_sym_DQUOTE] = ACTIONS(1470),
    [sym_return] = ACTIONS(1468),
    [sym_next] = ACTIONS(1468),
    [sym_break] = ACTIONS(1468),
    [sym_true] = ACTIONS(1468),
    [sym_false] = ACTIONS(1468),
    [sym_null] = ACTIONS(1468),
    [sym_inf] = ACTIONS(1468),
    [sym_nan] = ACTIONS(1468),
    [anon_sym_NA] = ACTIONS(1468),
    [anon_sym_NA_integer_] = ACTIONS(1468),
    [anon_sym_NA_real_] = ACTIONS(1468),
    [anon_sym_NA_complex_] = ACTIONS(1468),
    [anon_sym_NA_character_] = ACTIONS(1468),
    [sym_dots] = ACTIONS(1468),
    [sym_dot_dot_i] = ACTIONS(1470),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1470),
    [sym__newline] = ACTIONS(1470),
    [sym__raw_string_literal] = ACTIONS(1470),
    [sym__external_open_parenthesis] = ACTIONS(1470),
    [sym__external_open_brace] = ACTIONS(1470),
    [sym__external_open_bracket] = ACTIONS(1470),
    [sym__external_open_bracket2] = ACTIONS(1470),
    [sym__external_close_bracket2] = ACTIONS(1470),
  },
  [953] = {
    [sym_function_definition] = STATE(631),
    [sym_if_statement] = STATE(631),
    [sym_for_statement] = STATE(631),
    [sym_while_statement] = STATE(631),
    [sym_repeat_statement] = STATE(631),
    [sym_braced_expression] = STATE(631),
    [sym_parenthesized_expression] = STATE(631),
    [sym_call] = STATE(631),
    [sym_subset] = STATE(631),
    [sym_subset2] = STATE(631),
    [sym_unary_operator] = STATE(631),
    [sym_binary_operator] = STATE(631),
    [sym_extract_operator] = STATE(631),
    [sym_namespace_operator] = STATE(631),
    [sym_integer] = STATE(631),
    [sym_complex] = STATE(631),
    [sym_float] = STATE(631),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(739),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(631),
    [sym__expression] = STATE(631),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(933),
    [sym__open_brace] = STATE(842),
    [aux_sym_parenthesized_expression_repeat1] = STATE(1003),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(1679),
    [sym_next] = ACTIONS(1679),
    [sym_break] = ACTIONS(1679),
    [sym_true] = ACTIONS(1679),
    [sym_false] = ACTIONS(1679),
    [sym_null] = ACTIONS(1679),
    [sym_inf] = ACTIONS(1679),
    [sym_nan] = ACTIONS(1679),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(1679),
    [sym_dot_dot_i] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1683),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1707),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [954] = {
    [ts_builtin_sym_end] = ACTIONS(1549),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_BSLASH] = ACTIONS(1549),
    [anon_sym_function] = ACTIONS(1547),
    [anon_sym_EQ] = ACTIONS(1547),
    [anon_sym_if] = ACTIONS(1547),
    [anon_sym_for] = ACTIONS(1547),
    [anon_sym_while] = ACTIONS(1547),
    [anon_sym_repeat] = ACTIONS(1547),
    [anon_sym_QMARK] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1547),
    [anon_sym_LT_DASH] = ACTIONS(1549),
    [anon_sym_LT_LT_DASH] = ACTIONS(1549),
    [anon_sym_COLON_EQ] = ACTIONS(1549),
    [anon_sym_DASH_GT] = ACTIONS(1547),
    [anon_sym_DASH_GT_GT] = ACTIONS(1549),
    [anon_sym_PIPE] = ACTIONS(1547),
    [anon_sym_AMP] = ACTIONS(1547),
    [anon_sym_PIPE_PIPE] = ACTIONS(1549),
    [anon_sym_AMP_AMP] = ACTIONS(1549),
    [anon_sym_LT] = ACTIONS(1547),
    [anon_sym_LT_EQ] = ACTIONS(1549),
    [anon_sym_GT] = ACTIONS(1547),
    [anon_sym_GT_EQ] = ACTIONS(1549),
    [anon_sym_EQ_EQ] = ACTIONS(1549),
    [anon_sym_BANG_EQ] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_SLASH] = ACTIONS(1549),
    [anon_sym_STAR_STAR] = ACTIONS(1549),
    [anon_sym_CARET] = ACTIONS(1549),
    [aux_sym_binary_operator_token1] = ACTIONS(1549),
    [anon_sym_PIPE_GT] = ACTIONS(1549),
    [anon_sym_COLON] = ACTIONS(1547),
    [anon_sym_DOLLAR] = ACTIONS(1549),
    [anon_sym_AT] = ACTIONS(1549),
    [sym__hex_literal] = ACTIONS(1549),
    [sym__number_literal] = ACTIONS(1547),
    [anon_sym_SQUOTE] = ACTIONS(1549),
    [anon_sym_DQUOTE] = ACTIONS(1549),
    [sym_return] = ACTIONS(1547),
    [sym_next] = ACTIONS(1547),
    [sym_break] = ACTIONS(1547),
    [sym_true] = ACTIONS(1547),
    [sym_false] = ACTIONS(1547),
    [sym_null] = ACTIONS(1547),
    [sym_inf] = ACTIONS(1547),
    [sym_nan] = ACTIONS(1547),
    [anon_sym_NA] = ACTIONS(1547),
    [anon_sym_NA_integer_] = ACTIONS(1547),
    [anon_sym_NA_real_] = ACTIONS(1547),
    [anon_sym_NA_complex_] = ACTIONS(1547),
    [anon_sym_NA_character_] = ACTIONS(1547),
    [sym_dots] = ACTIONS(1547),
    [sym_dot_dot_i] = ACTIONS(1549),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1549),
    [sym__semicolon] = ACTIONS(1549),
    [sym__raw_string_literal] = ACTIONS(1549),
    [sym__external_open_parenthesis] = ACTIONS(1549),
    [sym__external_open_brace] = ACTIONS(1549),
    [sym__external_open_bracket] = ACTIONS(1549),
    [sym__external_open_bracket2] = ACTIONS(1549),
  },
  [955] = {
    [sym_function_definition] = STATE(631),
    [sym_if_statement] = STATE(631),
    [sym_for_statement] = STATE(631),
    [sym_while_statement] = STATE(631),
    [sym_repeat_statement] = STATE(631),
    [sym_braced_expression] = STATE(631),
    [sym_parenthesized_expression] = STATE(631),
    [sym_call] = STATE(631),
    [sym_subset] = STATE(631),
    [sym_subset2] = STATE(631),
    [sym_unary_operator] = STATE(631),
    [sym_binary_operator] = STATE(631),
    [sym_extract_operator] = STATE(631),
    [sym_namespace_operator] = STATE(631),
    [sym_integer] = STATE(631),
    [sym_complex] = STATE(631),
    [sym_float] = STATE(631),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(739),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(631),
    [sym__expression] = STATE(631),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(899),
    [sym__open_brace] = STATE(842),
    [aux_sym_parenthesized_expression_repeat1] = STATE(953),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(1679),
    [sym_next] = ACTIONS(1679),
    [sym_break] = ACTIONS(1679),
    [sym_true] = ACTIONS(1679),
    [sym_false] = ACTIONS(1679),
    [sym_null] = ACTIONS(1679),
    [sym_inf] = ACTIONS(1679),
    [sym_nan] = ACTIONS(1679),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(1679),
    [sym_dot_dot_i] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1683),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1709),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [956] = {
    [sym_identifier] = ACTIONS(1331),
    [anon_sym_BSLASH] = ACTIONS(1333),
    [anon_sym_function] = ACTIONS(1331),
    [anon_sym_EQ] = ACTIONS(1397),
    [anon_sym_if] = ACTIONS(1331),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_while] = ACTIONS(1331),
    [anon_sym_repeat] = ACTIONS(1331),
    [anon_sym_QMARK] = ACTIONS(1333),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_LT_DASH] = ACTIONS(1333),
    [anon_sym_LT_LT_DASH] = ACTIONS(1333),
    [anon_sym_COLON_EQ] = ACTIONS(1333),
    [anon_sym_DASH_GT] = ACTIONS(1331),
    [anon_sym_DASH_GT_GT] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1331),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1333),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_GT_EQ] = ACTIONS(1333),
    [anon_sym_EQ_EQ] = ACTIONS(1333),
    [anon_sym_BANG_EQ] = ACTIONS(1333),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_SLASH] = ACTIONS(1333),
    [anon_sym_STAR_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1333),
    [aux_sym_binary_operator_token1] = ACTIONS(1333),
    [anon_sym_PIPE_GT] = ACTIONS(1333),
    [anon_sym_COLON] = ACTIONS(1331),
    [anon_sym_DOLLAR] = ACTIONS(1333),
    [anon_sym_AT] = ACTIONS(1333),
    [sym__hex_literal] = ACTIONS(1333),
    [sym__number_literal] = ACTIONS(1331),
    [anon_sym_SQUOTE] = ACTIONS(1333),
    [anon_sym_DQUOTE] = ACTIONS(1333),
    [sym_return] = ACTIONS(1331),
    [sym_next] = ACTIONS(1331),
    [sym_break] = ACTIONS(1331),
    [sym_true] = ACTIONS(1331),
    [sym_false] = ACTIONS(1331),
    [sym_null] = ACTIONS(1331),
    [sym_inf] = ACTIONS(1331),
    [sym_nan] = ACTIONS(1331),
    [anon_sym_NA] = ACTIONS(1331),
    [anon_sym_NA_integer_] = ACTIONS(1331),
    [anon_sym_NA_real_] = ACTIONS(1331),
    [anon_sym_NA_complex_] = ACTIONS(1331),
    [anon_sym_NA_character_] = ACTIONS(1331),
    [sym_dots] = ACTIONS(1331),
    [sym_dot_dot_i] = ACTIONS(1333),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1333),
    [sym__newline] = ACTIONS(1333),
    [sym__raw_string_literal] = ACTIONS(1333),
    [sym__external_open_parenthesis] = ACTIONS(1333),
    [sym__external_close_parenthesis] = ACTIONS(1333),
    [sym__external_open_brace] = ACTIONS(1333),
    [sym__external_open_bracket] = ACTIONS(1333),
    [sym__external_open_bracket2] = ACTIONS(1333),
  },
  [957] = {
    [ts_builtin_sym_end] = ACTIONS(1494),
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_BSLASH] = ACTIONS(1494),
    [anon_sym_function] = ACTIONS(1492),
    [anon_sym_EQ] = ACTIONS(1492),
    [anon_sym_if] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(1492),
    [anon_sym_while] = ACTIONS(1492),
    [anon_sym_repeat] = ACTIONS(1492),
    [anon_sym_QMARK] = ACTIONS(1494),
    [anon_sym_TILDE] = ACTIONS(1494),
    [anon_sym_BANG] = ACTIONS(1492),
    [anon_sym_PLUS] = ACTIONS(1494),
    [anon_sym_DASH] = ACTIONS(1492),
    [anon_sym_LT_DASH] = ACTIONS(1494),
    [anon_sym_LT_LT_DASH] = ACTIONS(1494),
    [anon_sym_COLON_EQ] = ACTIONS(1494),
    [anon_sym_DASH_GT] = ACTIONS(1492),
    [anon_sym_DASH_GT_GT] = ACTIONS(1494),
    [anon_sym_PIPE] = ACTIONS(1492),
    [anon_sym_AMP] = ACTIONS(1492),
    [anon_sym_PIPE_PIPE] = ACTIONS(1494),
    [anon_sym_AMP_AMP] = ACTIONS(1494),
    [anon_sym_LT] = ACTIONS(1492),
    [anon_sym_LT_EQ] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1492),
    [anon_sym_GT_EQ] = ACTIONS(1494),
    [anon_sym_EQ_EQ] = ACTIONS(1494),
    [anon_sym_BANG_EQ] = ACTIONS(1494),
    [anon_sym_STAR] = ACTIONS(1492),
    [anon_sym_SLASH] = ACTIONS(1494),
    [anon_sym_STAR_STAR] = ACTIONS(1494),
    [anon_sym_CARET] = ACTIONS(1494),
    [aux_sym_binary_operator_token1] = ACTIONS(1494),
    [anon_sym_PIPE_GT] = ACTIONS(1494),
    [anon_sym_COLON] = ACTIONS(1492),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [anon_sym_AT] = ACTIONS(1494),
    [sym__hex_literal] = ACTIONS(1494),
    [sym__number_literal] = ACTIONS(1492),
    [anon_sym_SQUOTE] = ACTIONS(1494),
    [anon_sym_DQUOTE] = ACTIONS(1494),
    [sym_return] = ACTIONS(1492),
    [sym_next] = ACTIONS(1492),
    [sym_break] = ACTIONS(1492),
    [sym_true] = ACTIONS(1492),
    [sym_false] = ACTIONS(1492),
    [sym_null] = ACTIONS(1492),
    [sym_inf] = ACTIONS(1492),
    [sym_nan] = ACTIONS(1492),
    [anon_sym_NA] = ACTIONS(1492),
    [anon_sym_NA_integer_] = ACTIONS(1492),
    [anon_sym_NA_real_] = ACTIONS(1492),
    [anon_sym_NA_complex_] = ACTIONS(1492),
    [anon_sym_NA_character_] = ACTIONS(1492),
    [sym_dots] = ACTIONS(1492),
    [sym_dot_dot_i] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1494),
    [sym__semicolon] = ACTIONS(1494),
    [sym__raw_string_literal] = ACTIONS(1494),
    [sym__external_open_parenthesis] = ACTIONS(1494),
    [sym__external_open_brace] = ACTIONS(1494),
    [sym__external_open_bracket] = ACTIONS(1494),
    [sym__external_open_bracket2] = ACTIONS(1494),
  },
  [958] = {
    [ts_builtin_sym_end] = ACTIONS(1531),
    [sym_identifier] = ACTIONS(1533),
    [anon_sym_BSLASH] = ACTIONS(1531),
    [anon_sym_function] = ACTIONS(1533),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_if] = ACTIONS(1533),
    [anon_sym_for] = ACTIONS(1533),
    [anon_sym_while] = ACTIONS(1533),
    [anon_sym_repeat] = ACTIONS(1533),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_LT_DASH] = ACTIONS(1531),
    [anon_sym_LT_LT_DASH] = ACTIONS(1531),
    [anon_sym_COLON_EQ] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1533),
    [anon_sym_DASH_GT_GT] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1531),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_CARET] = ACTIONS(1531),
    [aux_sym_binary_operator_token1] = ACTIONS(1531),
    [anon_sym_PIPE_GT] = ACTIONS(1531),
    [anon_sym_COLON] = ACTIONS(1533),
    [anon_sym_DOLLAR] = ACTIONS(1531),
    [anon_sym_AT] = ACTIONS(1531),
    [sym__hex_literal] = ACTIONS(1531),
    [sym__number_literal] = ACTIONS(1533),
    [anon_sym_SQUOTE] = ACTIONS(1531),
    [anon_sym_DQUOTE] = ACTIONS(1531),
    [sym_return] = ACTIONS(1533),
    [sym_next] = ACTIONS(1533),
    [sym_break] = ACTIONS(1533),
    [sym_true] = ACTIONS(1533),
    [sym_false] = ACTIONS(1533),
    [sym_null] = ACTIONS(1533),
    [sym_inf] = ACTIONS(1533),
    [sym_nan] = ACTIONS(1533),
    [anon_sym_NA] = ACTIONS(1533),
    [anon_sym_NA_integer_] = ACTIONS(1533),
    [anon_sym_NA_real_] = ACTIONS(1533),
    [anon_sym_NA_complex_] = ACTIONS(1533),
    [anon_sym_NA_character_] = ACTIONS(1533),
    [sym_dots] = ACTIONS(1533),
    [sym_dot_dot_i] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1531),
    [sym__semicolon] = ACTIONS(1531),
    [sym__raw_string_literal] = ACTIONS(1531),
    [sym__external_open_parenthesis] = ACTIONS(1531),
    [sym__external_open_brace] = ACTIONS(1531),
    [sym__external_open_bracket] = ACTIONS(1531),
    [sym__external_open_bracket2] = ACTIONS(1531),
  },
  [959] = {
    [sym_identifier] = ACTIONS(1468),
    [anon_sym_BSLASH] = ACTIONS(1470),
    [anon_sym_function] = ACTIONS(1468),
    [anon_sym_EQ] = ACTIONS(1468),
    [anon_sym_if] = ACTIONS(1468),
    [anon_sym_for] = ACTIONS(1468),
    [anon_sym_while] = ACTIONS(1468),
    [anon_sym_repeat] = ACTIONS(1468),
    [anon_sym_QMARK] = ACTIONS(1470),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_BANG] = ACTIONS(1468),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1468),
    [anon_sym_LT_DASH] = ACTIONS(1470),
    [anon_sym_LT_LT_DASH] = ACTIONS(1470),
    [anon_sym_COLON_EQ] = ACTIONS(1470),
    [anon_sym_DASH_GT] = ACTIONS(1468),
    [anon_sym_DASH_GT_GT] = ACTIONS(1470),
    [anon_sym_PIPE] = ACTIONS(1468),
    [anon_sym_AMP] = ACTIONS(1468),
    [anon_sym_PIPE_PIPE] = ACTIONS(1470),
    [anon_sym_AMP_AMP] = ACTIONS(1470),
    [anon_sym_LT] = ACTIONS(1468),
    [anon_sym_LT_EQ] = ACTIONS(1470),
    [anon_sym_GT] = ACTIONS(1468),
    [anon_sym_GT_EQ] = ACTIONS(1470),
    [anon_sym_EQ_EQ] = ACTIONS(1470),
    [anon_sym_BANG_EQ] = ACTIONS(1470),
    [anon_sym_STAR] = ACTIONS(1468),
    [anon_sym_SLASH] = ACTIONS(1470),
    [anon_sym_STAR_STAR] = ACTIONS(1470),
    [anon_sym_CARET] = ACTIONS(1470),
    [aux_sym_binary_operator_token1] = ACTIONS(1470),
    [anon_sym_PIPE_GT] = ACTIONS(1470),
    [anon_sym_COLON] = ACTIONS(1468),
    [anon_sym_DOLLAR] = ACTIONS(1470),
    [anon_sym_AT] = ACTIONS(1470),
    [sym__hex_literal] = ACTIONS(1470),
    [sym__number_literal] = ACTIONS(1468),
    [anon_sym_SQUOTE] = ACTIONS(1470),
    [anon_sym_DQUOTE] = ACTIONS(1470),
    [sym_return] = ACTIONS(1468),
    [sym_next] = ACTIONS(1468),
    [sym_break] = ACTIONS(1468),
    [sym_true] = ACTIONS(1468),
    [sym_false] = ACTIONS(1468),
    [sym_null] = ACTIONS(1468),
    [sym_inf] = ACTIONS(1468),
    [sym_nan] = ACTIONS(1468),
    [anon_sym_NA] = ACTIONS(1468),
    [anon_sym_NA_integer_] = ACTIONS(1468),
    [anon_sym_NA_real_] = ACTIONS(1468),
    [anon_sym_NA_complex_] = ACTIONS(1468),
    [anon_sym_NA_character_] = ACTIONS(1468),
    [sym_dots] = ACTIONS(1468),
    [sym_dot_dot_i] = ACTIONS(1470),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1470),
    [sym__newline] = ACTIONS(1470),
    [sym__raw_string_literal] = ACTIONS(1470),
    [sym__external_open_parenthesis] = ACTIONS(1470),
    [sym__external_open_brace] = ACTIONS(1470),
    [sym__external_open_bracket] = ACTIONS(1470),
    [sym__external_close_bracket] = ACTIONS(1470),
    [sym__external_open_bracket2] = ACTIONS(1470),
  },
  [960] = {
    [sym_function_definition] = STATE(631),
    [sym_if_statement] = STATE(631),
    [sym_for_statement] = STATE(631),
    [sym_while_statement] = STATE(631),
    [sym_repeat_statement] = STATE(631),
    [sym_braced_expression] = STATE(631),
    [sym_parenthesized_expression] = STATE(631),
    [sym_call] = STATE(631),
    [sym_subset] = STATE(631),
    [sym_subset2] = STATE(631),
    [sym_unary_operator] = STATE(631),
    [sym_binary_operator] = STATE(631),
    [sym_extract_operator] = STATE(631),
    [sym_namespace_operator] = STATE(631),
    [sym_integer] = STATE(631),
    [sym_complex] = STATE(631),
    [sym_float] = STATE(631),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(739),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(631),
    [sym__expression] = STATE(631),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(785),
    [sym__open_brace] = STATE(842),
    [aux_sym_parenthesized_expression_repeat1] = STATE(1003),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(1679),
    [sym_next] = ACTIONS(1679),
    [sym_break] = ACTIONS(1679),
    [sym_true] = ACTIONS(1679),
    [sym_false] = ACTIONS(1679),
    [sym_null] = ACTIONS(1679),
    [sym_inf] = ACTIONS(1679),
    [sym_nan] = ACTIONS(1679),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(1679),
    [sym_dot_dot_i] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1683),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1711),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [961] = {
    [ts_builtin_sym_end] = ACTIONS(1486),
    [sym_identifier] = ACTIONS(1484),
    [anon_sym_BSLASH] = ACTIONS(1486),
    [anon_sym_function] = ACTIONS(1484),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_if] = ACTIONS(1484),
    [anon_sym_for] = ACTIONS(1484),
    [anon_sym_while] = ACTIONS(1484),
    [anon_sym_repeat] = ACTIONS(1484),
    [anon_sym_QMARK] = ACTIONS(1486),
    [anon_sym_TILDE] = ACTIONS(1486),
    [anon_sym_BANG] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_LT_DASH] = ACTIONS(1486),
    [anon_sym_LT_LT_DASH] = ACTIONS(1486),
    [anon_sym_COLON_EQ] = ACTIONS(1486),
    [anon_sym_DASH_GT] = ACTIONS(1484),
    [anon_sym_DASH_GT_GT] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1484),
    [anon_sym_AMP] = ACTIONS(1484),
    [anon_sym_PIPE_PIPE] = ACTIONS(1486),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_LT] = ACTIONS(1484),
    [anon_sym_LT_EQ] = ACTIONS(1486),
    [anon_sym_GT] = ACTIONS(1484),
    [anon_sym_GT_EQ] = ACTIONS(1486),
    [anon_sym_EQ_EQ] = ACTIONS(1486),
    [anon_sym_BANG_EQ] = ACTIONS(1486),
    [anon_sym_STAR] = ACTIONS(1484),
    [anon_sym_SLASH] = ACTIONS(1486),
    [anon_sym_STAR_STAR] = ACTIONS(1486),
    [anon_sym_CARET] = ACTIONS(1486),
    [aux_sym_binary_operator_token1] = ACTIONS(1486),
    [anon_sym_PIPE_GT] = ACTIONS(1486),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(1486),
    [anon_sym_AT] = ACTIONS(1486),
    [sym__hex_literal] = ACTIONS(1486),
    [sym__number_literal] = ACTIONS(1484),
    [anon_sym_SQUOTE] = ACTIONS(1486),
    [anon_sym_DQUOTE] = ACTIONS(1486),
    [sym_return] = ACTIONS(1484),
    [sym_next] = ACTIONS(1484),
    [sym_break] = ACTIONS(1484),
    [sym_true] = ACTIONS(1484),
    [sym_false] = ACTIONS(1484),
    [sym_null] = ACTIONS(1484),
    [sym_inf] = ACTIONS(1484),
    [sym_nan] = ACTIONS(1484),
    [anon_sym_NA] = ACTIONS(1484),
    [anon_sym_NA_integer_] = ACTIONS(1484),
    [anon_sym_NA_real_] = ACTIONS(1484),
    [anon_sym_NA_complex_] = ACTIONS(1484),
    [anon_sym_NA_character_] = ACTIONS(1484),
    [sym_dots] = ACTIONS(1484),
    [sym_dot_dot_i] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1486),
    [sym__semicolon] = ACTIONS(1486),
    [sym__raw_string_literal] = ACTIONS(1486),
    [sym__external_open_parenthesis] = ACTIONS(1486),
    [sym__external_open_brace] = ACTIONS(1486),
    [sym__external_open_bracket] = ACTIONS(1486),
    [sym__external_open_bracket2] = ACTIONS(1486),
  },
  [962] = {
    [sym_function_definition] = STATE(631),
    [sym_if_statement] = STATE(631),
    [sym_for_statement] = STATE(631),
    [sym_while_statement] = STATE(631),
    [sym_repeat_statement] = STATE(631),
    [sym_braced_expression] = STATE(631),
    [sym_parenthesized_expression] = STATE(631),
    [sym_call] = STATE(631),
    [sym_subset] = STATE(631),
    [sym_subset2] = STATE(631),
    [sym_unary_operator] = STATE(631),
    [sym_binary_operator] = STATE(631),
    [sym_extract_operator] = STATE(631),
    [sym_namespace_operator] = STATE(631),
    [sym_integer] = STATE(631),
    [sym_complex] = STATE(631),
    [sym_float] = STATE(631),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(739),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(631),
    [sym__expression] = STATE(631),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(838),
    [sym__open_brace] = STATE(842),
    [aux_sym_parenthesized_expression_repeat1] = STATE(960),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(1679),
    [sym_next] = ACTIONS(1679),
    [sym_break] = ACTIONS(1679),
    [sym_true] = ACTIONS(1679),
    [sym_false] = ACTIONS(1679),
    [sym_null] = ACTIONS(1679),
    [sym_inf] = ACTIONS(1679),
    [sym_nan] = ACTIONS(1679),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(1679),
    [sym_dot_dot_i] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1683),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1713),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [963] = {
    [sym_identifier] = ACTIONS(1468),
    [anon_sym_BSLASH] = ACTIONS(1470),
    [anon_sym_function] = ACTIONS(1468),
    [anon_sym_EQ] = ACTIONS(1468),
    [anon_sym_if] = ACTIONS(1468),
    [anon_sym_for] = ACTIONS(1468),
    [anon_sym_while] = ACTIONS(1468),
    [anon_sym_repeat] = ACTIONS(1468),
    [anon_sym_QMARK] = ACTIONS(1470),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_BANG] = ACTIONS(1468),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1468),
    [anon_sym_LT_DASH] = ACTIONS(1470),
    [anon_sym_LT_LT_DASH] = ACTIONS(1470),
    [anon_sym_COLON_EQ] = ACTIONS(1470),
    [anon_sym_DASH_GT] = ACTIONS(1468),
    [anon_sym_DASH_GT_GT] = ACTIONS(1470),
    [anon_sym_PIPE] = ACTIONS(1468),
    [anon_sym_AMP] = ACTIONS(1468),
    [anon_sym_PIPE_PIPE] = ACTIONS(1470),
    [anon_sym_AMP_AMP] = ACTIONS(1470),
    [anon_sym_LT] = ACTIONS(1468),
    [anon_sym_LT_EQ] = ACTIONS(1470),
    [anon_sym_GT] = ACTIONS(1468),
    [anon_sym_GT_EQ] = ACTIONS(1470),
    [anon_sym_EQ_EQ] = ACTIONS(1470),
    [anon_sym_BANG_EQ] = ACTIONS(1470),
    [anon_sym_STAR] = ACTIONS(1468),
    [anon_sym_SLASH] = ACTIONS(1470),
    [anon_sym_STAR_STAR] = ACTIONS(1470),
    [anon_sym_CARET] = ACTIONS(1470),
    [aux_sym_binary_operator_token1] = ACTIONS(1470),
    [anon_sym_PIPE_GT] = ACTIONS(1470),
    [anon_sym_COLON] = ACTIONS(1468),
    [anon_sym_DOLLAR] = ACTIONS(1470),
    [anon_sym_AT] = ACTIONS(1470),
    [sym__hex_literal] = ACTIONS(1470),
    [sym__number_literal] = ACTIONS(1468),
    [anon_sym_SQUOTE] = ACTIONS(1470),
    [anon_sym_DQUOTE] = ACTIONS(1470),
    [sym_return] = ACTIONS(1468),
    [sym_next] = ACTIONS(1468),
    [sym_break] = ACTIONS(1468),
    [sym_true] = ACTIONS(1468),
    [sym_false] = ACTIONS(1468),
    [sym_null] = ACTIONS(1468),
    [sym_inf] = ACTIONS(1468),
    [sym_nan] = ACTIONS(1468),
    [anon_sym_NA] = ACTIONS(1468),
    [anon_sym_NA_integer_] = ACTIONS(1468),
    [anon_sym_NA_real_] = ACTIONS(1468),
    [anon_sym_NA_complex_] = ACTIONS(1468),
    [anon_sym_NA_character_] = ACTIONS(1468),
    [sym_dots] = ACTIONS(1468),
    [sym_dot_dot_i] = ACTIONS(1470),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1470),
    [sym__semicolon] = ACTIONS(1470),
    [sym__raw_string_literal] = ACTIONS(1470),
    [sym__external_open_parenthesis] = ACTIONS(1470),
    [sym__external_open_brace] = ACTIONS(1470),
    [sym__external_close_brace] = ACTIONS(1470),
    [sym__external_open_bracket] = ACTIONS(1470),
    [sym__external_open_bracket2] = ACTIONS(1470),
  },
  [964] = {
    [ts_builtin_sym_end] = ACTIONS(1506),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_BSLASH] = ACTIONS(1506),
    [anon_sym_function] = ACTIONS(1504),
    [anon_sym_EQ] = ACTIONS(1504),
    [anon_sym_if] = ACTIONS(1504),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1504),
    [anon_sym_repeat] = ACTIONS(1504),
    [anon_sym_QMARK] = ACTIONS(1506),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_BANG] = ACTIONS(1504),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1504),
    [anon_sym_LT_DASH] = ACTIONS(1506),
    [anon_sym_LT_LT_DASH] = ACTIONS(1506),
    [anon_sym_COLON_EQ] = ACTIONS(1506),
    [anon_sym_DASH_GT] = ACTIONS(1504),
    [anon_sym_DASH_GT_GT] = ACTIONS(1506),
    [anon_sym_PIPE] = ACTIONS(1504),
    [anon_sym_AMP] = ACTIONS(1504),
    [anon_sym_PIPE_PIPE] = ACTIONS(1506),
    [anon_sym_AMP_AMP] = ACTIONS(1506),
    [anon_sym_LT] = ACTIONS(1504),
    [anon_sym_LT_EQ] = ACTIONS(1506),
    [anon_sym_GT] = ACTIONS(1504),
    [anon_sym_GT_EQ] = ACTIONS(1506),
    [anon_sym_EQ_EQ] = ACTIONS(1506),
    [anon_sym_BANG_EQ] = ACTIONS(1506),
    [anon_sym_STAR] = ACTIONS(1504),
    [anon_sym_SLASH] = ACTIONS(1506),
    [anon_sym_STAR_STAR] = ACTIONS(1506),
    [anon_sym_CARET] = ACTIONS(1506),
    [aux_sym_binary_operator_token1] = ACTIONS(1506),
    [anon_sym_PIPE_GT] = ACTIONS(1506),
    [anon_sym_COLON] = ACTIONS(1504),
    [anon_sym_DOLLAR] = ACTIONS(1506),
    [anon_sym_AT] = ACTIONS(1506),
    [sym__hex_literal] = ACTIONS(1506),
    [sym__number_literal] = ACTIONS(1504),
    [anon_sym_SQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1506),
    [sym_return] = ACTIONS(1504),
    [sym_next] = ACTIONS(1504),
    [sym_break] = ACTIONS(1504),
    [sym_true] = ACTIONS(1504),
    [sym_false] = ACTIONS(1504),
    [sym_null] = ACTIONS(1504),
    [sym_inf] = ACTIONS(1504),
    [sym_nan] = ACTIONS(1504),
    [anon_sym_NA] = ACTIONS(1504),
    [anon_sym_NA_integer_] = ACTIONS(1504),
    [anon_sym_NA_real_] = ACTIONS(1504),
    [anon_sym_NA_complex_] = ACTIONS(1504),
    [anon_sym_NA_character_] = ACTIONS(1504),
    [sym_dots] = ACTIONS(1504),
    [sym_dot_dot_i] = ACTIONS(1506),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1506),
    [sym__semicolon] = ACTIONS(1506),
    [sym__raw_string_literal] = ACTIONS(1506),
    [sym__external_open_parenthesis] = ACTIONS(1506),
    [sym__external_open_brace] = ACTIONS(1506),
    [sym__external_open_bracket] = ACTIONS(1506),
    [sym__external_open_bracket2] = ACTIONS(1506),
  },
  [965] = {
    [ts_builtin_sym_end] = ACTIONS(1553),
    [sym_identifier] = ACTIONS(1551),
    [anon_sym_BSLASH] = ACTIONS(1553),
    [anon_sym_function] = ACTIONS(1551),
    [anon_sym_EQ] = ACTIONS(1551),
    [anon_sym_if] = ACTIONS(1551),
    [anon_sym_for] = ACTIONS(1551),
    [anon_sym_while] = ACTIONS(1551),
    [anon_sym_repeat] = ACTIONS(1551),
    [anon_sym_QMARK] = ACTIONS(1553),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_PLUS] = ACTIONS(1553),
    [anon_sym_DASH] = ACTIONS(1551),
    [anon_sym_LT_DASH] = ACTIONS(1553),
    [anon_sym_LT_LT_DASH] = ACTIONS(1553),
    [anon_sym_COLON_EQ] = ACTIONS(1553),
    [anon_sym_DASH_GT] = ACTIONS(1551),
    [anon_sym_DASH_GT_GT] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_PIPE_PIPE] = ACTIONS(1553),
    [anon_sym_AMP_AMP] = ACTIONS(1553),
    [anon_sym_LT] = ACTIONS(1551),
    [anon_sym_LT_EQ] = ACTIONS(1553),
    [anon_sym_GT] = ACTIONS(1551),
    [anon_sym_GT_EQ] = ACTIONS(1553),
    [anon_sym_EQ_EQ] = ACTIONS(1553),
    [anon_sym_BANG_EQ] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(1551),
    [anon_sym_SLASH] = ACTIONS(1553),
    [anon_sym_STAR_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [aux_sym_binary_operator_token1] = ACTIONS(1553),
    [anon_sym_PIPE_GT] = ACTIONS(1553),
    [anon_sym_COLON] = ACTIONS(1551),
    [anon_sym_DOLLAR] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(1553),
    [sym__hex_literal] = ACTIONS(1553),
    [sym__number_literal] = ACTIONS(1551),
    [anon_sym_SQUOTE] = ACTIONS(1553),
    [anon_sym_DQUOTE] = ACTIONS(1553),
    [sym_return] = ACTIONS(1551),
    [sym_next] = ACTIONS(1551),
    [sym_break] = ACTIONS(1551),
    [sym_true] = ACTIONS(1551),
    [sym_false] = ACTIONS(1551),
    [sym_null] = ACTIONS(1551),
    [sym_inf] = ACTIONS(1551),
    [sym_nan] = ACTIONS(1551),
    [anon_sym_NA] = ACTIONS(1551),
    [anon_sym_NA_integer_] = ACTIONS(1551),
    [anon_sym_NA_real_] = ACTIONS(1551),
    [anon_sym_NA_complex_] = ACTIONS(1551),
    [anon_sym_NA_character_] = ACTIONS(1551),
    [sym_dots] = ACTIONS(1551),
    [sym_dot_dot_i] = ACTIONS(1553),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1553),
    [sym__semicolon] = ACTIONS(1553),
    [sym__raw_string_literal] = ACTIONS(1553),
    [sym__external_open_parenthesis] = ACTIONS(1553),
    [sym__external_open_brace] = ACTIONS(1553),
    [sym__external_open_bracket] = ACTIONS(1553),
    [sym__external_open_bracket2] = ACTIONS(1553),
  },
  [966] = {
    [sym_identifier] = ACTIONS(1472),
    [anon_sym_BSLASH] = ACTIONS(1474),
    [anon_sym_function] = ACTIONS(1472),
    [anon_sym_EQ] = ACTIONS(1472),
    [anon_sym_if] = ACTIONS(1472),
    [anon_sym_for] = ACTIONS(1472),
    [anon_sym_while] = ACTIONS(1472),
    [anon_sym_repeat] = ACTIONS(1472),
    [anon_sym_QMARK] = ACTIONS(1474),
    [anon_sym_TILDE] = ACTIONS(1474),
    [anon_sym_BANG] = ACTIONS(1472),
    [anon_sym_PLUS] = ACTIONS(1474),
    [anon_sym_DASH] = ACTIONS(1472),
    [anon_sym_LT_DASH] = ACTIONS(1474),
    [anon_sym_LT_LT_DASH] = ACTIONS(1474),
    [anon_sym_COLON_EQ] = ACTIONS(1474),
    [anon_sym_DASH_GT] = ACTIONS(1472),
    [anon_sym_DASH_GT_GT] = ACTIONS(1474),
    [anon_sym_PIPE] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1472),
    [anon_sym_PIPE_PIPE] = ACTIONS(1474),
    [anon_sym_AMP_AMP] = ACTIONS(1474),
    [anon_sym_LT] = ACTIONS(1472),
    [anon_sym_LT_EQ] = ACTIONS(1474),
    [anon_sym_GT] = ACTIONS(1472),
    [anon_sym_GT_EQ] = ACTIONS(1474),
    [anon_sym_EQ_EQ] = ACTIONS(1474),
    [anon_sym_BANG_EQ] = ACTIONS(1474),
    [anon_sym_STAR] = ACTIONS(1472),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_STAR_STAR] = ACTIONS(1474),
    [anon_sym_CARET] = ACTIONS(1474),
    [aux_sym_binary_operator_token1] = ACTIONS(1474),
    [anon_sym_PIPE_GT] = ACTIONS(1474),
    [anon_sym_COLON] = ACTIONS(1472),
    [anon_sym_DOLLAR] = ACTIONS(1474),
    [anon_sym_AT] = ACTIONS(1474),
    [sym__hex_literal] = ACTIONS(1474),
    [sym__number_literal] = ACTIONS(1472),
    [anon_sym_SQUOTE] = ACTIONS(1474),
    [anon_sym_DQUOTE] = ACTIONS(1474),
    [sym_return] = ACTIONS(1472),
    [sym_next] = ACTIONS(1472),
    [sym_break] = ACTIONS(1472),
    [sym_true] = ACTIONS(1472),
    [sym_false] = ACTIONS(1472),
    [sym_null] = ACTIONS(1472),
    [sym_inf] = ACTIONS(1472),
    [sym_nan] = ACTIONS(1472),
    [anon_sym_NA] = ACTIONS(1472),
    [anon_sym_NA_integer_] = ACTIONS(1472),
    [anon_sym_NA_real_] = ACTIONS(1472),
    [anon_sym_NA_complex_] = ACTIONS(1472),
    [anon_sym_NA_character_] = ACTIONS(1472),
    [sym_dots] = ACTIONS(1472),
    [sym_dot_dot_i] = ACTIONS(1474),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1474),
    [sym__newline] = ACTIONS(1474),
    [sym__raw_string_literal] = ACTIONS(1474),
    [sym__external_open_parenthesis] = ACTIONS(1474),
    [sym__external_open_brace] = ACTIONS(1474),
    [sym__external_open_bracket] = ACTIONS(1474),
    [sym__external_close_bracket] = ACTIONS(1474),
    [sym__external_open_bracket2] = ACTIONS(1474),
  },
  [967] = {
    [sym_function_definition] = STATE(631),
    [sym_if_statement] = STATE(631),
    [sym_for_statement] = STATE(631),
    [sym_while_statement] = STATE(631),
    [sym_repeat_statement] = STATE(631),
    [sym_braced_expression] = STATE(631),
    [sym_parenthesized_expression] = STATE(631),
    [sym_call] = STATE(631),
    [sym_subset] = STATE(631),
    [sym_subset2] = STATE(631),
    [sym_unary_operator] = STATE(631),
    [sym_binary_operator] = STATE(631),
    [sym_extract_operator] = STATE(631),
    [sym_namespace_operator] = STATE(631),
    [sym_integer] = STATE(631),
    [sym_complex] = STATE(631),
    [sym_float] = STATE(631),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(739),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(631),
    [sym__expression] = STATE(631),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(867),
    [sym__open_brace] = STATE(842),
    [aux_sym_parenthesized_expression_repeat1] = STATE(1003),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(1679),
    [sym_next] = ACTIONS(1679),
    [sym_break] = ACTIONS(1679),
    [sym_true] = ACTIONS(1679),
    [sym_false] = ACTIONS(1679),
    [sym_null] = ACTIONS(1679),
    [sym_inf] = ACTIONS(1679),
    [sym_nan] = ACTIONS(1679),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(1679),
    [sym_dot_dot_i] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1683),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1715),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [968] = {
    [sym_identifier] = ACTIONS(1472),
    [anon_sym_BSLASH] = ACTIONS(1474),
    [anon_sym_function] = ACTIONS(1472),
    [anon_sym_EQ] = ACTIONS(1472),
    [anon_sym_if] = ACTIONS(1472),
    [anon_sym_for] = ACTIONS(1472),
    [anon_sym_while] = ACTIONS(1472),
    [anon_sym_repeat] = ACTIONS(1472),
    [anon_sym_QMARK] = ACTIONS(1474),
    [anon_sym_TILDE] = ACTIONS(1474),
    [anon_sym_BANG] = ACTIONS(1472),
    [anon_sym_PLUS] = ACTIONS(1474),
    [anon_sym_DASH] = ACTIONS(1472),
    [anon_sym_LT_DASH] = ACTIONS(1474),
    [anon_sym_LT_LT_DASH] = ACTIONS(1474),
    [anon_sym_COLON_EQ] = ACTIONS(1474),
    [anon_sym_DASH_GT] = ACTIONS(1472),
    [anon_sym_DASH_GT_GT] = ACTIONS(1474),
    [anon_sym_PIPE] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1472),
    [anon_sym_PIPE_PIPE] = ACTIONS(1474),
    [anon_sym_AMP_AMP] = ACTIONS(1474),
    [anon_sym_LT] = ACTIONS(1472),
    [anon_sym_LT_EQ] = ACTIONS(1474),
    [anon_sym_GT] = ACTIONS(1472),
    [anon_sym_GT_EQ] = ACTIONS(1474),
    [anon_sym_EQ_EQ] = ACTIONS(1474),
    [anon_sym_BANG_EQ] = ACTIONS(1474),
    [anon_sym_STAR] = ACTIONS(1472),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_STAR_STAR] = ACTIONS(1474),
    [anon_sym_CARET] = ACTIONS(1474),
    [aux_sym_binary_operator_token1] = ACTIONS(1474),
    [anon_sym_PIPE_GT] = ACTIONS(1474),
    [anon_sym_COLON] = ACTIONS(1472),
    [anon_sym_DOLLAR] = ACTIONS(1474),
    [anon_sym_AT] = ACTIONS(1474),
    [sym__hex_literal] = ACTIONS(1474),
    [sym__number_literal] = ACTIONS(1472),
    [anon_sym_SQUOTE] = ACTIONS(1474),
    [anon_sym_DQUOTE] = ACTIONS(1474),
    [sym_return] = ACTIONS(1472),
    [sym_next] = ACTIONS(1472),
    [sym_break] = ACTIONS(1472),
    [sym_true] = ACTIONS(1472),
    [sym_false] = ACTIONS(1472),
    [sym_null] = ACTIONS(1472),
    [sym_inf] = ACTIONS(1472),
    [sym_nan] = ACTIONS(1472),
    [anon_sym_NA] = ACTIONS(1472),
    [anon_sym_NA_integer_] = ACTIONS(1472),
    [anon_sym_NA_real_] = ACTIONS(1472),
    [anon_sym_NA_complex_] = ACTIONS(1472),
    [anon_sym_NA_character_] = ACTIONS(1472),
    [sym_dots] = ACTIONS(1472),
    [sym_dot_dot_i] = ACTIONS(1474),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1474),
    [sym__semicolon] = ACTIONS(1474),
    [sym__raw_string_literal] = ACTIONS(1474),
    [sym__external_open_parenthesis] = ACTIONS(1474),
    [sym__external_open_brace] = ACTIONS(1474),
    [sym__external_close_brace] = ACTIONS(1474),
    [sym__external_open_bracket] = ACTIONS(1474),
    [sym__external_open_bracket2] = ACTIONS(1474),
  },
  [969] = {
    [sym_function_definition] = STATE(631),
    [sym_if_statement] = STATE(631),
    [sym_for_statement] = STATE(631),
    [sym_while_statement] = STATE(631),
    [sym_repeat_statement] = STATE(631),
    [sym_braced_expression] = STATE(631),
    [sym_parenthesized_expression] = STATE(631),
    [sym_call] = STATE(631),
    [sym_subset] = STATE(631),
    [sym_subset2] = STATE(631),
    [sym_unary_operator] = STATE(631),
    [sym_binary_operator] = STATE(631),
    [sym_extract_operator] = STATE(631),
    [sym_namespace_operator] = STATE(631),
    [sym_integer] = STATE(631),
    [sym_complex] = STATE(631),
    [sym_float] = STATE(631),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(739),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(631),
    [sym__expression] = STATE(631),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(849),
    [sym__open_brace] = STATE(842),
    [aux_sym_parenthesized_expression_repeat1] = STATE(967),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(1679),
    [sym_next] = ACTIONS(1679),
    [sym_break] = ACTIONS(1679),
    [sym_true] = ACTIONS(1679),
    [sym_false] = ACTIONS(1679),
    [sym_null] = ACTIONS(1679),
    [sym_inf] = ACTIONS(1679),
    [sym_nan] = ACTIONS(1679),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(1679),
    [sym_dot_dot_i] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1683),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1717),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [970] = {
    [sym_identifier] = ACTIONS(1476),
    [anon_sym_BSLASH] = ACTIONS(1478),
    [anon_sym_function] = ACTIONS(1476),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_if] = ACTIONS(1476),
    [anon_sym_for] = ACTIONS(1476),
    [anon_sym_while] = ACTIONS(1476),
    [anon_sym_repeat] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_BANG] = ACTIONS(1476),
    [anon_sym_PLUS] = ACTIONS(1478),
    [anon_sym_DASH] = ACTIONS(1476),
    [anon_sym_LT_DASH] = ACTIONS(1478),
    [anon_sym_LT_LT_DASH] = ACTIONS(1478),
    [anon_sym_COLON_EQ] = ACTIONS(1478),
    [anon_sym_DASH_GT] = ACTIONS(1476),
    [anon_sym_DASH_GT_GT] = ACTIONS(1478),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1478),
    [anon_sym_AMP_AMP] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_EQ] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_GT_EQ] = ACTIONS(1478),
    [anon_sym_EQ_EQ] = ACTIONS(1478),
    [anon_sym_BANG_EQ] = ACTIONS(1478),
    [anon_sym_STAR] = ACTIONS(1476),
    [anon_sym_SLASH] = ACTIONS(1478),
    [anon_sym_STAR_STAR] = ACTIONS(1478),
    [anon_sym_CARET] = ACTIONS(1478),
    [aux_sym_binary_operator_token1] = ACTIONS(1478),
    [anon_sym_PIPE_GT] = ACTIONS(1478),
    [anon_sym_COLON] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1478),
    [anon_sym_AT] = ACTIONS(1478),
    [sym__hex_literal] = ACTIONS(1478),
    [sym__number_literal] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_DQUOTE] = ACTIONS(1478),
    [sym_return] = ACTIONS(1476),
    [sym_next] = ACTIONS(1476),
    [sym_break] = ACTIONS(1476),
    [sym_true] = ACTIONS(1476),
    [sym_false] = ACTIONS(1476),
    [sym_null] = ACTIONS(1476),
    [sym_inf] = ACTIONS(1476),
    [sym_nan] = ACTIONS(1476),
    [anon_sym_NA] = ACTIONS(1476),
    [anon_sym_NA_integer_] = ACTIONS(1476),
    [anon_sym_NA_real_] = ACTIONS(1476),
    [anon_sym_NA_complex_] = ACTIONS(1476),
    [anon_sym_NA_character_] = ACTIONS(1476),
    [sym_dots] = ACTIONS(1476),
    [sym_dot_dot_i] = ACTIONS(1478),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1478),
    [sym__semicolon] = ACTIONS(1478),
    [sym__raw_string_literal] = ACTIONS(1478),
    [sym__external_open_parenthesis] = ACTIONS(1478),
    [sym__external_open_brace] = ACTIONS(1478),
    [sym__external_close_brace] = ACTIONS(1478),
    [sym__external_open_bracket] = ACTIONS(1478),
    [sym__external_open_bracket2] = ACTIONS(1478),
  },
  [971] = {
    [sym_identifier] = ACTIONS(1476),
    [anon_sym_BSLASH] = ACTIONS(1478),
    [anon_sym_function] = ACTIONS(1476),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_if] = ACTIONS(1476),
    [anon_sym_for] = ACTIONS(1476),
    [anon_sym_while] = ACTIONS(1476),
    [anon_sym_repeat] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_BANG] = ACTIONS(1476),
    [anon_sym_PLUS] = ACTIONS(1478),
    [anon_sym_DASH] = ACTIONS(1476),
    [anon_sym_LT_DASH] = ACTIONS(1478),
    [anon_sym_LT_LT_DASH] = ACTIONS(1478),
    [anon_sym_COLON_EQ] = ACTIONS(1478),
    [anon_sym_DASH_GT] = ACTIONS(1476),
    [anon_sym_DASH_GT_GT] = ACTIONS(1478),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1478),
    [anon_sym_AMP_AMP] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_EQ] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_GT_EQ] = ACTIONS(1478),
    [anon_sym_EQ_EQ] = ACTIONS(1478),
    [anon_sym_BANG_EQ] = ACTIONS(1478),
    [anon_sym_STAR] = ACTIONS(1476),
    [anon_sym_SLASH] = ACTIONS(1478),
    [anon_sym_STAR_STAR] = ACTIONS(1478),
    [anon_sym_CARET] = ACTIONS(1478),
    [aux_sym_binary_operator_token1] = ACTIONS(1478),
    [anon_sym_PIPE_GT] = ACTIONS(1478),
    [anon_sym_COLON] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1478),
    [anon_sym_AT] = ACTIONS(1478),
    [sym__hex_literal] = ACTIONS(1478),
    [sym__number_literal] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_DQUOTE] = ACTIONS(1478),
    [sym_return] = ACTIONS(1476),
    [sym_next] = ACTIONS(1476),
    [sym_break] = ACTIONS(1476),
    [sym_true] = ACTIONS(1476),
    [sym_false] = ACTIONS(1476),
    [sym_null] = ACTIONS(1476),
    [sym_inf] = ACTIONS(1476),
    [sym_nan] = ACTIONS(1476),
    [anon_sym_NA] = ACTIONS(1476),
    [anon_sym_NA_integer_] = ACTIONS(1476),
    [anon_sym_NA_real_] = ACTIONS(1476),
    [anon_sym_NA_complex_] = ACTIONS(1476),
    [anon_sym_NA_character_] = ACTIONS(1476),
    [sym_dots] = ACTIONS(1476),
    [sym_dot_dot_i] = ACTIONS(1478),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1478),
    [sym__newline] = ACTIONS(1478),
    [sym__raw_string_literal] = ACTIONS(1478),
    [sym__external_open_parenthesis] = ACTIONS(1478),
    [sym__external_open_brace] = ACTIONS(1478),
    [sym__external_open_bracket] = ACTIONS(1478),
    [sym__external_close_bracket] = ACTIONS(1478),
    [sym__external_open_bracket2] = ACTIONS(1478),
  },
  [972] = {
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_BSLASH] = ACTIONS(1549),
    [anon_sym_function] = ACTIONS(1547),
    [anon_sym_EQ] = ACTIONS(1547),
    [anon_sym_if] = ACTIONS(1547),
    [anon_sym_for] = ACTIONS(1547),
    [anon_sym_while] = ACTIONS(1547),
    [anon_sym_repeat] = ACTIONS(1547),
    [anon_sym_QMARK] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1547),
    [anon_sym_LT_DASH] = ACTIONS(1549),
    [anon_sym_LT_LT_DASH] = ACTIONS(1549),
    [anon_sym_COLON_EQ] = ACTIONS(1549),
    [anon_sym_DASH_GT] = ACTIONS(1547),
    [anon_sym_DASH_GT_GT] = ACTIONS(1549),
    [anon_sym_PIPE] = ACTIONS(1547),
    [anon_sym_AMP] = ACTIONS(1547),
    [anon_sym_PIPE_PIPE] = ACTIONS(1549),
    [anon_sym_AMP_AMP] = ACTIONS(1549),
    [anon_sym_LT] = ACTIONS(1547),
    [anon_sym_LT_EQ] = ACTIONS(1549),
    [anon_sym_GT] = ACTIONS(1547),
    [anon_sym_GT_EQ] = ACTIONS(1549),
    [anon_sym_EQ_EQ] = ACTIONS(1549),
    [anon_sym_BANG_EQ] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_SLASH] = ACTIONS(1549),
    [anon_sym_STAR_STAR] = ACTIONS(1549),
    [anon_sym_CARET] = ACTIONS(1549),
    [aux_sym_binary_operator_token1] = ACTIONS(1549),
    [anon_sym_PIPE_GT] = ACTIONS(1549),
    [anon_sym_COLON] = ACTIONS(1547),
    [anon_sym_DOLLAR] = ACTIONS(1549),
    [anon_sym_AT] = ACTIONS(1549),
    [sym__hex_literal] = ACTIONS(1549),
    [sym__number_literal] = ACTIONS(1547),
    [anon_sym_SQUOTE] = ACTIONS(1549),
    [anon_sym_DQUOTE] = ACTIONS(1549),
    [sym_return] = ACTIONS(1547),
    [sym_next] = ACTIONS(1547),
    [sym_break] = ACTIONS(1547),
    [sym_true] = ACTIONS(1547),
    [sym_false] = ACTIONS(1547),
    [sym_null] = ACTIONS(1547),
    [sym_inf] = ACTIONS(1547),
    [sym_nan] = ACTIONS(1547),
    [anon_sym_NA] = ACTIONS(1547),
    [anon_sym_NA_integer_] = ACTIONS(1547),
    [anon_sym_NA_real_] = ACTIONS(1547),
    [anon_sym_NA_complex_] = ACTIONS(1547),
    [anon_sym_NA_character_] = ACTIONS(1547),
    [sym_dots] = ACTIONS(1547),
    [sym_dot_dot_i] = ACTIONS(1549),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1549),
    [sym__newline] = ACTIONS(1549),
    [sym__raw_string_literal] = ACTIONS(1549),
    [sym__external_open_parenthesis] = ACTIONS(1549),
    [sym__external_close_parenthesis] = ACTIONS(1549),
    [sym__external_open_brace] = ACTIONS(1549),
    [sym__external_open_bracket] = ACTIONS(1549),
    [sym__external_open_bracket2] = ACTIONS(1549),
  },
  [973] = {
    [sym_identifier] = ACTIONS(1535),
    [anon_sym_BSLASH] = ACTIONS(1537),
    [anon_sym_function] = ACTIONS(1535),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_if] = ACTIONS(1535),
    [anon_sym_for] = ACTIONS(1535),
    [anon_sym_while] = ACTIONS(1535),
    [anon_sym_repeat] = ACTIONS(1535),
    [anon_sym_QMARK] = ACTIONS(1537),
    [anon_sym_TILDE] = ACTIONS(1537),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1535),
    [anon_sym_LT_DASH] = ACTIONS(1537),
    [anon_sym_LT_LT_DASH] = ACTIONS(1537),
    [anon_sym_COLON_EQ] = ACTIONS(1537),
    [anon_sym_DASH_GT] = ACTIONS(1535),
    [anon_sym_DASH_GT_GT] = ACTIONS(1537),
    [anon_sym_PIPE] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_PIPE_PIPE] = ACTIONS(1537),
    [anon_sym_AMP_AMP] = ACTIONS(1537),
    [anon_sym_LT] = ACTIONS(1535),
    [anon_sym_LT_EQ] = ACTIONS(1537),
    [anon_sym_GT] = ACTIONS(1535),
    [anon_sym_GT_EQ] = ACTIONS(1537),
    [anon_sym_EQ_EQ] = ACTIONS(1537),
    [anon_sym_BANG_EQ] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_SLASH] = ACTIONS(1537),
    [anon_sym_STAR_STAR] = ACTIONS(1537),
    [anon_sym_CARET] = ACTIONS(1537),
    [aux_sym_binary_operator_token1] = ACTIONS(1537),
    [anon_sym_PIPE_GT] = ACTIONS(1537),
    [anon_sym_COLON] = ACTIONS(1535),
    [anon_sym_DOLLAR] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(1537),
    [sym__hex_literal] = ACTIONS(1537),
    [sym__number_literal] = ACTIONS(1535),
    [anon_sym_SQUOTE] = ACTIONS(1537),
    [anon_sym_DQUOTE] = ACTIONS(1537),
    [sym_return] = ACTIONS(1535),
    [sym_next] = ACTIONS(1535),
    [sym_break] = ACTIONS(1535),
    [sym_true] = ACTIONS(1535),
    [sym_false] = ACTIONS(1535),
    [sym_null] = ACTIONS(1535),
    [sym_inf] = ACTIONS(1535),
    [sym_nan] = ACTIONS(1535),
    [anon_sym_NA] = ACTIONS(1535),
    [anon_sym_NA_integer_] = ACTIONS(1535),
    [anon_sym_NA_real_] = ACTIONS(1535),
    [anon_sym_NA_complex_] = ACTIONS(1535),
    [anon_sym_NA_character_] = ACTIONS(1535),
    [sym_dots] = ACTIONS(1535),
    [sym_dot_dot_i] = ACTIONS(1537),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1537),
    [sym__newline] = ACTIONS(1537),
    [sym__raw_string_literal] = ACTIONS(1537),
    [sym__external_open_parenthesis] = ACTIONS(1537),
    [sym__external_open_brace] = ACTIONS(1537),
    [sym__external_open_bracket] = ACTIONS(1537),
    [sym__external_open_bracket2] = ACTIONS(1537),
    [sym__external_close_bracket2] = ACTIONS(1537),
  },
  [974] = {
    [sym_function_definition] = STATE(631),
    [sym_if_statement] = STATE(631),
    [sym_for_statement] = STATE(631),
    [sym_while_statement] = STATE(631),
    [sym_repeat_statement] = STATE(631),
    [sym_braced_expression] = STATE(631),
    [sym_parenthesized_expression] = STATE(631),
    [sym_call] = STATE(631),
    [sym_subset] = STATE(631),
    [sym_subset2] = STATE(631),
    [sym_unary_operator] = STATE(631),
    [sym_binary_operator] = STATE(631),
    [sym_extract_operator] = STATE(631),
    [sym_namespace_operator] = STATE(631),
    [sym_integer] = STATE(631),
    [sym_complex] = STATE(631),
    [sym_float] = STATE(631),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(739),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(631),
    [sym__expression] = STATE(631),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(789),
    [sym__open_brace] = STATE(842),
    [aux_sym_parenthesized_expression_repeat1] = STATE(1003),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(1679),
    [sym_next] = ACTIONS(1679),
    [sym_break] = ACTIONS(1679),
    [sym_true] = ACTIONS(1679),
    [sym_false] = ACTIONS(1679),
    [sym_null] = ACTIONS(1679),
    [sym_inf] = ACTIONS(1679),
    [sym_nan] = ACTIONS(1679),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(1679),
    [sym_dot_dot_i] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1683),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1719),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [975] = {
    [sym_function_definition] = STATE(292),
    [sym_if_statement] = STATE(292),
    [sym_for_statement] = STATE(292),
    [sym_while_statement] = STATE(292),
    [sym_repeat_statement] = STATE(292),
    [sym_braced_expression] = STATE(292),
    [sym_parenthesized_expression] = STATE(292),
    [sym_call] = STATE(292),
    [sym_subset] = STATE(292),
    [sym_subset2] = STATE(292),
    [sym_unary_operator] = STATE(292),
    [sym_binary_operator] = STATE(292),
    [sym_extract_operator] = STATE(292),
    [sym_namespace_operator] = STATE(292),
    [sym_integer] = STATE(292),
    [sym_complex] = STATE(292),
    [sym_float] = STATE(292),
    [sym__float_literal] = STATE(744),
    [sym_string] = STATE(706),
    [sym__single_quoted_string] = STATE(745),
    [sym__double_quoted_string] = STATE(747),
    [sym_na] = STATE(292),
    [sym__expression] = STATE(292),
    [sym__string_or_identifier] = STATE(2134),
    [sym__open_parenthesis] = STATE(987),
    [sym__open_brace] = STATE(760),
    [aux_sym_program_repeat1] = STATE(975),
    [ts_builtin_sym_end] = ACTIONS(1721),
    [sym_identifier] = ACTIONS(1723),
    [anon_sym_BSLASH] = ACTIONS(1726),
    [anon_sym_function] = ACTIONS(1729),
    [anon_sym_if] = ACTIONS(1732),
    [anon_sym_for] = ACTIONS(1735),
    [anon_sym_while] = ACTIONS(1738),
    [anon_sym_repeat] = ACTIONS(1741),
    [anon_sym_QMARK] = ACTIONS(1744),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_BANG] = ACTIONS(1750),
    [anon_sym_PLUS] = ACTIONS(1753),
    [anon_sym_DASH] = ACTIONS(1753),
    [sym__hex_literal] = ACTIONS(1756),
    [sym__number_literal] = ACTIONS(1759),
    [anon_sym_SQUOTE] = ACTIONS(1762),
    [anon_sym_DQUOTE] = ACTIONS(1765),
    [sym_return] = ACTIONS(1768),
    [sym_next] = ACTIONS(1768),
    [sym_break] = ACTIONS(1768),
    [sym_true] = ACTIONS(1768),
    [sym_false] = ACTIONS(1768),
    [sym_null] = ACTIONS(1768),
    [sym_inf] = ACTIONS(1768),
    [sym_nan] = ACTIONS(1768),
    [anon_sym_NA] = ACTIONS(1771),
    [anon_sym_NA_integer_] = ACTIONS(1771),
    [anon_sym_NA_real_] = ACTIONS(1771),
    [anon_sym_NA_complex_] = ACTIONS(1771),
    [anon_sym_NA_character_] = ACTIONS(1771),
    [sym_dots] = ACTIONS(1768),
    [sym_dot_dot_i] = ACTIONS(1774),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1777),
    [sym__semicolon] = ACTIONS(1777),
    [sym__raw_string_literal] = ACTIONS(1780),
    [sym__external_open_parenthesis] = ACTIONS(1783),
    [sym__external_open_brace] = ACTIONS(1786),
  },
  [976] = {
    [sym_function_definition] = STATE(631),
    [sym_if_statement] = STATE(631),
    [sym_for_statement] = STATE(631),
    [sym_while_statement] = STATE(631),
    [sym_repeat_statement] = STATE(631),
    [sym_braced_expression] = STATE(631),
    [sym_parenthesized_expression] = STATE(631),
    [sym_call] = STATE(631),
    [sym_subset] = STATE(631),
    [sym_subset2] = STATE(631),
    [sym_unary_operator] = STATE(631),
    [sym_binary_operator] = STATE(631),
    [sym_extract_operator] = STATE(631),
    [sym_namespace_operator] = STATE(631),
    [sym_integer] = STATE(631),
    [sym_complex] = STATE(631),
    [sym_float] = STATE(631),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(739),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(631),
    [sym__expression] = STATE(631),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(805),
    [sym__open_brace] = STATE(842),
    [aux_sym_parenthesized_expression_repeat1] = STATE(974),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(1679),
    [sym_next] = ACTIONS(1679),
    [sym_break] = ACTIONS(1679),
    [sym_true] = ACTIONS(1679),
    [sym_false] = ACTIONS(1679),
    [sym_null] = ACTIONS(1679),
    [sym_inf] = ACTIONS(1679),
    [sym_nan] = ACTIONS(1679),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(1679),
    [sym_dot_dot_i] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1683),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1789),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [977] = {
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_BSLASH] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1539),
    [anon_sym_if] = ACTIONS(1539),
    [anon_sym_for] = ACTIONS(1539),
    [anon_sym_while] = ACTIONS(1539),
    [anon_sym_repeat] = ACTIONS(1539),
    [anon_sym_QMARK] = ACTIONS(1541),
    [anon_sym_TILDE] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1539),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1539),
    [anon_sym_LT_DASH] = ACTIONS(1541),
    [anon_sym_LT_LT_DASH] = ACTIONS(1541),
    [anon_sym_COLON_EQ] = ACTIONS(1541),
    [anon_sym_DASH_GT] = ACTIONS(1539),
    [anon_sym_DASH_GT_GT] = ACTIONS(1541),
    [anon_sym_PIPE] = ACTIONS(1539),
    [anon_sym_AMP] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1541),
    [anon_sym_GT] = ACTIONS(1539),
    [anon_sym_GT_EQ] = ACTIONS(1541),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1539),
    [anon_sym_SLASH] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_CARET] = ACTIONS(1541),
    [aux_sym_binary_operator_token1] = ACTIONS(1541),
    [anon_sym_PIPE_GT] = ACTIONS(1541),
    [anon_sym_COLON] = ACTIONS(1539),
    [anon_sym_DOLLAR] = ACTIONS(1541),
    [anon_sym_AT] = ACTIONS(1541),
    [sym__hex_literal] = ACTIONS(1541),
    [sym__number_literal] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(1541),
    [anon_sym_DQUOTE] = ACTIONS(1541),
    [sym_return] = ACTIONS(1539),
    [sym_next] = ACTIONS(1539),
    [sym_break] = ACTIONS(1539),
    [sym_true] = ACTIONS(1539),
    [sym_false] = ACTIONS(1539),
    [sym_null] = ACTIONS(1539),
    [sym_inf] = ACTIONS(1539),
    [sym_nan] = ACTIONS(1539),
    [anon_sym_NA] = ACTIONS(1539),
    [anon_sym_NA_integer_] = ACTIONS(1539),
    [anon_sym_NA_real_] = ACTIONS(1539),
    [anon_sym_NA_complex_] = ACTIONS(1539),
    [anon_sym_NA_character_] = ACTIONS(1539),
    [sym_dots] = ACTIONS(1539),
    [sym_dot_dot_i] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1541),
    [sym__newline] = ACTIONS(1541),
    [sym__raw_string_literal] = ACTIONS(1541),
    [sym__external_open_parenthesis] = ACTIONS(1541),
    [sym__external_open_brace] = ACTIONS(1541),
    [sym__external_open_bracket] = ACTIONS(1541),
    [sym__external_close_bracket] = ACTIONS(1541),
    [sym__external_open_bracket2] = ACTIONS(1541),
  },
  [978] = {
    [sym_identifier] = ACTIONS(1551),
    [anon_sym_BSLASH] = ACTIONS(1553),
    [anon_sym_function] = ACTIONS(1551),
    [anon_sym_EQ] = ACTIONS(1551),
    [anon_sym_if] = ACTIONS(1551),
    [anon_sym_for] = ACTIONS(1551),
    [anon_sym_while] = ACTIONS(1551),
    [anon_sym_repeat] = ACTIONS(1551),
    [anon_sym_QMARK] = ACTIONS(1553),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_PLUS] = ACTIONS(1553),
    [anon_sym_DASH] = ACTIONS(1551),
    [anon_sym_LT_DASH] = ACTIONS(1553),
    [anon_sym_LT_LT_DASH] = ACTIONS(1553),
    [anon_sym_COLON_EQ] = ACTIONS(1553),
    [anon_sym_DASH_GT] = ACTIONS(1551),
    [anon_sym_DASH_GT_GT] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_PIPE_PIPE] = ACTIONS(1553),
    [anon_sym_AMP_AMP] = ACTIONS(1553),
    [anon_sym_LT] = ACTIONS(1551),
    [anon_sym_LT_EQ] = ACTIONS(1553),
    [anon_sym_GT] = ACTIONS(1551),
    [anon_sym_GT_EQ] = ACTIONS(1553),
    [anon_sym_EQ_EQ] = ACTIONS(1553),
    [anon_sym_BANG_EQ] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(1551),
    [anon_sym_SLASH] = ACTIONS(1553),
    [anon_sym_STAR_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [aux_sym_binary_operator_token1] = ACTIONS(1553),
    [anon_sym_PIPE_GT] = ACTIONS(1553),
    [anon_sym_COLON] = ACTIONS(1551),
    [anon_sym_DOLLAR] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(1553),
    [sym__hex_literal] = ACTIONS(1553),
    [sym__number_literal] = ACTIONS(1551),
    [anon_sym_SQUOTE] = ACTIONS(1553),
    [anon_sym_DQUOTE] = ACTIONS(1553),
    [sym_return] = ACTIONS(1551),
    [sym_next] = ACTIONS(1551),
    [sym_break] = ACTIONS(1551),
    [sym_true] = ACTIONS(1551),
    [sym_false] = ACTIONS(1551),
    [sym_null] = ACTIONS(1551),
    [sym_inf] = ACTIONS(1551),
    [sym_nan] = ACTIONS(1551),
    [anon_sym_NA] = ACTIONS(1551),
    [anon_sym_NA_integer_] = ACTIONS(1551),
    [anon_sym_NA_real_] = ACTIONS(1551),
    [anon_sym_NA_complex_] = ACTIONS(1551),
    [anon_sym_NA_character_] = ACTIONS(1551),
    [sym_dots] = ACTIONS(1551),
    [sym_dot_dot_i] = ACTIONS(1553),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1553),
    [sym__newline] = ACTIONS(1553),
    [sym__raw_string_literal] = ACTIONS(1553),
    [sym__external_open_parenthesis] = ACTIONS(1553),
    [sym__external_open_brace] = ACTIONS(1553),
    [sym__external_open_bracket] = ACTIONS(1553),
    [sym__external_open_bracket2] = ACTIONS(1553),
    [sym__external_close_bracket2] = ACTIONS(1553),
  },
  [979] = {
    [sym_identifier] = ACTIONS(1480),
    [anon_sym_BSLASH] = ACTIONS(1482),
    [anon_sym_function] = ACTIONS(1480),
    [anon_sym_EQ] = ACTIONS(1480),
    [anon_sym_if] = ACTIONS(1480),
    [anon_sym_for] = ACTIONS(1480),
    [anon_sym_while] = ACTIONS(1480),
    [anon_sym_repeat] = ACTIONS(1480),
    [anon_sym_QMARK] = ACTIONS(1482),
    [anon_sym_TILDE] = ACTIONS(1482),
    [anon_sym_BANG] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1482),
    [anon_sym_DASH] = ACTIONS(1480),
    [anon_sym_LT_DASH] = ACTIONS(1482),
    [anon_sym_LT_LT_DASH] = ACTIONS(1482),
    [anon_sym_COLON_EQ] = ACTIONS(1482),
    [anon_sym_DASH_GT] = ACTIONS(1480),
    [anon_sym_DASH_GT_GT] = ACTIONS(1482),
    [anon_sym_PIPE] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1480),
    [anon_sym_PIPE_PIPE] = ACTIONS(1482),
    [anon_sym_AMP_AMP] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(1480),
    [anon_sym_LT_EQ] = ACTIONS(1482),
    [anon_sym_GT] = ACTIONS(1480),
    [anon_sym_GT_EQ] = ACTIONS(1482),
    [anon_sym_EQ_EQ] = ACTIONS(1482),
    [anon_sym_BANG_EQ] = ACTIONS(1482),
    [anon_sym_STAR] = ACTIONS(1480),
    [anon_sym_SLASH] = ACTIONS(1482),
    [anon_sym_STAR_STAR] = ACTIONS(1482),
    [anon_sym_CARET] = ACTIONS(1482),
    [aux_sym_binary_operator_token1] = ACTIONS(1482),
    [anon_sym_PIPE_GT] = ACTIONS(1482),
    [anon_sym_COLON] = ACTIONS(1480),
    [anon_sym_DOLLAR] = ACTIONS(1482),
    [anon_sym_AT] = ACTIONS(1482),
    [sym__hex_literal] = ACTIONS(1482),
    [sym__number_literal] = ACTIONS(1480),
    [anon_sym_SQUOTE] = ACTIONS(1482),
    [anon_sym_DQUOTE] = ACTIONS(1482),
    [sym_return] = ACTIONS(1480),
    [sym_next] = ACTIONS(1480),
    [sym_break] = ACTIONS(1480),
    [sym_true] = ACTIONS(1480),
    [sym_false] = ACTIONS(1480),
    [sym_null] = ACTIONS(1480),
    [sym_inf] = ACTIONS(1480),
    [sym_nan] = ACTIONS(1480),
    [anon_sym_NA] = ACTIONS(1480),
    [anon_sym_NA_integer_] = ACTIONS(1480),
    [anon_sym_NA_real_] = ACTIONS(1480),
    [anon_sym_NA_complex_] = ACTIONS(1480),
    [anon_sym_NA_character_] = ACTIONS(1480),
    [sym_dots] = ACTIONS(1480),
    [sym_dot_dot_i] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1482),
    [sym__newline] = ACTIONS(1482),
    [sym__raw_string_literal] = ACTIONS(1482),
    [sym__external_open_parenthesis] = ACTIONS(1482),
    [sym__external_open_brace] = ACTIONS(1482),
    [sym__external_open_bracket] = ACTIONS(1482),
    [sym__external_close_bracket] = ACTIONS(1482),
    [sym__external_open_bracket2] = ACTIONS(1482),
  },
  [980] = {
    [ts_builtin_sym_end] = ACTIONS(1510),
    [sym_identifier] = ACTIONS(1508),
    [anon_sym_BSLASH] = ACTIONS(1510),
    [anon_sym_function] = ACTIONS(1508),
    [anon_sym_EQ] = ACTIONS(1508),
    [anon_sym_if] = ACTIONS(1508),
    [anon_sym_for] = ACTIONS(1508),
    [anon_sym_while] = ACTIONS(1508),
    [anon_sym_repeat] = ACTIONS(1508),
    [anon_sym_QMARK] = ACTIONS(1510),
    [anon_sym_TILDE] = ACTIONS(1510),
    [anon_sym_BANG] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1510),
    [anon_sym_DASH] = ACTIONS(1508),
    [anon_sym_LT_DASH] = ACTIONS(1510),
    [anon_sym_LT_LT_DASH] = ACTIONS(1510),
    [anon_sym_COLON_EQ] = ACTIONS(1510),
    [anon_sym_DASH_GT] = ACTIONS(1508),
    [anon_sym_DASH_GT_GT] = ACTIONS(1510),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PIPE_PIPE] = ACTIONS(1510),
    [anon_sym_AMP_AMP] = ACTIONS(1510),
    [anon_sym_LT] = ACTIONS(1508),
    [anon_sym_LT_EQ] = ACTIONS(1510),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_GT_EQ] = ACTIONS(1510),
    [anon_sym_EQ_EQ] = ACTIONS(1510),
    [anon_sym_BANG_EQ] = ACTIONS(1510),
    [anon_sym_STAR] = ACTIONS(1508),
    [anon_sym_SLASH] = ACTIONS(1510),
    [anon_sym_STAR_STAR] = ACTIONS(1510),
    [anon_sym_CARET] = ACTIONS(1510),
    [aux_sym_binary_operator_token1] = ACTIONS(1510),
    [anon_sym_PIPE_GT] = ACTIONS(1510),
    [anon_sym_COLON] = ACTIONS(1508),
    [anon_sym_DOLLAR] = ACTIONS(1510),
    [anon_sym_AT] = ACTIONS(1510),
    [sym__hex_literal] = ACTIONS(1510),
    [sym__number_literal] = ACTIONS(1508),
    [anon_sym_SQUOTE] = ACTIONS(1510),
    [anon_sym_DQUOTE] = ACTIONS(1510),
    [sym_return] = ACTIONS(1508),
    [sym_next] = ACTIONS(1508),
    [sym_break] = ACTIONS(1508),
    [sym_true] = ACTIONS(1508),
    [sym_false] = ACTIONS(1508),
    [sym_null] = ACTIONS(1508),
    [sym_inf] = ACTIONS(1508),
    [sym_nan] = ACTIONS(1508),
    [anon_sym_NA] = ACTIONS(1508),
    [anon_sym_NA_integer_] = ACTIONS(1508),
    [anon_sym_NA_real_] = ACTIONS(1508),
    [anon_sym_NA_complex_] = ACTIONS(1508),
    [anon_sym_NA_character_] = ACTIONS(1508),
    [sym_dots] = ACTIONS(1508),
    [sym_dot_dot_i] = ACTIONS(1510),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1510),
    [sym__semicolon] = ACTIONS(1510),
    [sym__raw_string_literal] = ACTIONS(1510),
    [sym__external_open_parenthesis] = ACTIONS(1510),
    [sym__external_open_brace] = ACTIONS(1510),
    [sym__external_open_bracket] = ACTIONS(1510),
    [sym__external_open_bracket2] = ACTIONS(1510),
  },
  [981] = {
    [sym_function_definition] = STATE(631),
    [sym_if_statement] = STATE(631),
    [sym_for_statement] = STATE(631),
    [sym_while_statement] = STATE(631),
    [sym_repeat_statement] = STATE(631),
    [sym_braced_expression] = STATE(631),
    [sym_parenthesized_expression] = STATE(631),
    [sym_call] = STATE(631),
    [sym_subset] = STATE(631),
    [sym_subset2] = STATE(631),
    [sym_unary_operator] = STATE(631),
    [sym_binary_operator] = STATE(631),
    [sym_extract_operator] = STATE(631),
    [sym_namespace_operator] = STATE(631),
    [sym_integer] = STATE(631),
    [sym_complex] = STATE(631),
    [sym_float] = STATE(631),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(739),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(631),
    [sym__expression] = STATE(631),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(1969),
    [sym__open_brace] = STATE(842),
    [aux_sym_parenthesized_expression_repeat1] = STATE(1003),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(1679),
    [sym_next] = ACTIONS(1679),
    [sym_break] = ACTIONS(1679),
    [sym_true] = ACTIONS(1679),
    [sym_false] = ACTIONS(1679),
    [sym_null] = ACTIONS(1679),
    [sym_inf] = ACTIONS(1679),
    [sym_nan] = ACTIONS(1679),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(1679),
    [sym_dot_dot_i] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1683),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1791),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [982] = {
    [sym_identifier] = ACTIONS(1533),
    [anon_sym_BSLASH] = ACTIONS(1531),
    [anon_sym_function] = ACTIONS(1533),
    [anon_sym_EQ] = ACTIONS(1533),
    [anon_sym_if] = ACTIONS(1533),
    [anon_sym_for] = ACTIONS(1533),
    [anon_sym_while] = ACTIONS(1533),
    [anon_sym_repeat] = ACTIONS(1533),
    [anon_sym_QMARK] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_LT_DASH] = ACTIONS(1531),
    [anon_sym_LT_LT_DASH] = ACTIONS(1531),
    [anon_sym_COLON_EQ] = ACTIONS(1531),
    [anon_sym_DASH_GT] = ACTIONS(1533),
    [anon_sym_DASH_GT_GT] = ACTIONS(1531),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_LT_EQ] = ACTIONS(1531),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_GT_EQ] = ACTIONS(1531),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1531),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_CARET] = ACTIONS(1531),
    [aux_sym_binary_operator_token1] = ACTIONS(1531),
    [anon_sym_PIPE_GT] = ACTIONS(1531),
    [anon_sym_COLON] = ACTIONS(1533),
    [anon_sym_DOLLAR] = ACTIONS(1531),
    [anon_sym_AT] = ACTIONS(1531),
    [sym__hex_literal] = ACTIONS(1531),
    [sym__number_literal] = ACTIONS(1533),
    [anon_sym_SQUOTE] = ACTIONS(1531),
    [anon_sym_DQUOTE] = ACTIONS(1531),
    [sym_return] = ACTIONS(1533),
    [sym_next] = ACTIONS(1533),
    [sym_break] = ACTIONS(1533),
    [sym_true] = ACTIONS(1533),
    [sym_false] = ACTIONS(1533),
    [sym_null] = ACTIONS(1533),
    [sym_inf] = ACTIONS(1533),
    [sym_nan] = ACTIONS(1533),
    [anon_sym_NA] = ACTIONS(1533),
    [anon_sym_NA_integer_] = ACTIONS(1533),
    [anon_sym_NA_real_] = ACTIONS(1533),
    [anon_sym_NA_complex_] = ACTIONS(1533),
    [anon_sym_NA_character_] = ACTIONS(1533),
    [sym_dots] = ACTIONS(1533),
    [sym_dot_dot_i] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1531),
    [sym__newline] = ACTIONS(1531),
    [sym__raw_string_literal] = ACTIONS(1531),
    [sym__external_open_parenthesis] = ACTIONS(1531),
    [sym__external_close_parenthesis] = ACTIONS(1531),
    [sym__external_open_brace] = ACTIONS(1531),
    [sym__external_open_bracket] = ACTIONS(1531),
    [sym__external_open_bracket2] = ACTIONS(1531),
  },
  [983] = {
    [sym_function_definition] = STATE(631),
    [sym_if_statement] = STATE(631),
    [sym_for_statement] = STATE(631),
    [sym_while_statement] = STATE(631),
    [sym_repeat_statement] = STATE(631),
    [sym_braced_expression] = STATE(631),
    [sym_parenthesized_expression] = STATE(631),
    [sym_call] = STATE(631),
    [sym_subset] = STATE(631),
    [sym_subset2] = STATE(631),
    [sym_unary_operator] = STATE(631),
    [sym_binary_operator] = STATE(631),
    [sym_extract_operator] = STATE(631),
    [sym_namespace_operator] = STATE(631),
    [sym_integer] = STATE(631),
    [sym_complex] = STATE(631),
    [sym_float] = STATE(631),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(739),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(631),
    [sym__expression] = STATE(631),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(1965),
    [sym__open_brace] = STATE(842),
    [aux_sym_parenthesized_expression_repeat1] = STATE(981),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(1679),
    [sym_next] = ACTIONS(1679),
    [sym_break] = ACTIONS(1679),
    [sym_true] = ACTIONS(1679),
    [sym_false] = ACTIONS(1679),
    [sym_null] = ACTIONS(1679),
    [sym_inf] = ACTIONS(1679),
    [sym_nan] = ACTIONS(1679),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(1679),
    [sym_dot_dot_i] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1683),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1793),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [984] = {
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_BSLASH] = ACTIONS(1494),
    [anon_sym_function] = ACTIONS(1492),
    [anon_sym_EQ] = ACTIONS(1492),
    [anon_sym_if] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(1492),
    [anon_sym_while] = ACTIONS(1492),
    [anon_sym_repeat] = ACTIONS(1492),
    [anon_sym_QMARK] = ACTIONS(1494),
    [anon_sym_TILDE] = ACTIONS(1494),
    [anon_sym_BANG] = ACTIONS(1492),
    [anon_sym_PLUS] = ACTIONS(1494),
    [anon_sym_DASH] = ACTIONS(1492),
    [anon_sym_LT_DASH] = ACTIONS(1494),
    [anon_sym_LT_LT_DASH] = ACTIONS(1494),
    [anon_sym_COLON_EQ] = ACTIONS(1494),
    [anon_sym_DASH_GT] = ACTIONS(1492),
    [anon_sym_DASH_GT_GT] = ACTIONS(1494),
    [anon_sym_PIPE] = ACTIONS(1492),
    [anon_sym_AMP] = ACTIONS(1492),
    [anon_sym_PIPE_PIPE] = ACTIONS(1494),
    [anon_sym_AMP_AMP] = ACTIONS(1494),
    [anon_sym_LT] = ACTIONS(1492),
    [anon_sym_LT_EQ] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1492),
    [anon_sym_GT_EQ] = ACTIONS(1494),
    [anon_sym_EQ_EQ] = ACTIONS(1494),
    [anon_sym_BANG_EQ] = ACTIONS(1494),
    [anon_sym_STAR] = ACTIONS(1492),
    [anon_sym_SLASH] = ACTIONS(1494),
    [anon_sym_STAR_STAR] = ACTIONS(1494),
    [anon_sym_CARET] = ACTIONS(1494),
    [aux_sym_binary_operator_token1] = ACTIONS(1494),
    [anon_sym_PIPE_GT] = ACTIONS(1494),
    [anon_sym_COLON] = ACTIONS(1492),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [anon_sym_AT] = ACTIONS(1494),
    [sym__hex_literal] = ACTIONS(1494),
    [sym__number_literal] = ACTIONS(1492),
    [anon_sym_SQUOTE] = ACTIONS(1494),
    [anon_sym_DQUOTE] = ACTIONS(1494),
    [sym_return] = ACTIONS(1492),
    [sym_next] = ACTIONS(1492),
    [sym_break] = ACTIONS(1492),
    [sym_true] = ACTIONS(1492),
    [sym_false] = ACTIONS(1492),
    [sym_null] = ACTIONS(1492),
    [sym_inf] = ACTIONS(1492),
    [sym_nan] = ACTIONS(1492),
    [anon_sym_NA] = ACTIONS(1492),
    [anon_sym_NA_integer_] = ACTIONS(1492),
    [anon_sym_NA_real_] = ACTIONS(1492),
    [anon_sym_NA_complex_] = ACTIONS(1492),
    [anon_sym_NA_character_] = ACTIONS(1492),
    [sym_dots] = ACTIONS(1492),
    [sym_dot_dot_i] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1494),
    [sym__newline] = ACTIONS(1494),
    [sym__raw_string_literal] = ACTIONS(1494),
    [sym__external_open_parenthesis] = ACTIONS(1494),
    [sym__external_close_parenthesis] = ACTIONS(1494),
    [sym__external_open_brace] = ACTIONS(1494),
    [sym__external_open_bracket] = ACTIONS(1494),
    [sym__external_open_bracket2] = ACTIONS(1494),
  },
  [985] = {
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_BSLASH] = ACTIONS(1545),
    [anon_sym_function] = ACTIONS(1543),
    [anon_sym_EQ] = ACTIONS(1543),
    [anon_sym_if] = ACTIONS(1543),
    [anon_sym_for] = ACTIONS(1543),
    [anon_sym_while] = ACTIONS(1543),
    [anon_sym_repeat] = ACTIONS(1543),
    [anon_sym_QMARK] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1543),
    [anon_sym_PLUS] = ACTIONS(1545),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_LT_DASH] = ACTIONS(1545),
    [anon_sym_LT_LT_DASH] = ACTIONS(1545),
    [anon_sym_COLON_EQ] = ACTIONS(1545),
    [anon_sym_DASH_GT] = ACTIONS(1543),
    [anon_sym_DASH_GT_GT] = ACTIONS(1545),
    [anon_sym_PIPE] = ACTIONS(1543),
    [anon_sym_AMP] = ACTIONS(1543),
    [anon_sym_PIPE_PIPE] = ACTIONS(1545),
    [anon_sym_AMP_AMP] = ACTIONS(1545),
    [anon_sym_LT] = ACTIONS(1543),
    [anon_sym_LT_EQ] = ACTIONS(1545),
    [anon_sym_GT] = ACTIONS(1543),
    [anon_sym_GT_EQ] = ACTIONS(1545),
    [anon_sym_EQ_EQ] = ACTIONS(1545),
    [anon_sym_BANG_EQ] = ACTIONS(1545),
    [anon_sym_STAR] = ACTIONS(1543),
    [anon_sym_SLASH] = ACTIONS(1545),
    [anon_sym_STAR_STAR] = ACTIONS(1545),
    [anon_sym_CARET] = ACTIONS(1545),
    [aux_sym_binary_operator_token1] = ACTIONS(1545),
    [anon_sym_PIPE_GT] = ACTIONS(1545),
    [anon_sym_COLON] = ACTIONS(1543),
    [anon_sym_DOLLAR] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(1545),
    [sym__hex_literal] = ACTIONS(1545),
    [sym__number_literal] = ACTIONS(1543),
    [anon_sym_SQUOTE] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1545),
    [sym_return] = ACTIONS(1543),
    [sym_next] = ACTIONS(1543),
    [sym_break] = ACTIONS(1543),
    [sym_true] = ACTIONS(1543),
    [sym_false] = ACTIONS(1543),
    [sym_null] = ACTIONS(1543),
    [sym_inf] = ACTIONS(1543),
    [sym_nan] = ACTIONS(1543),
    [anon_sym_NA] = ACTIONS(1543),
    [anon_sym_NA_integer_] = ACTIONS(1543),
    [anon_sym_NA_real_] = ACTIONS(1543),
    [anon_sym_NA_complex_] = ACTIONS(1543),
    [anon_sym_NA_character_] = ACTIONS(1543),
    [sym_dots] = ACTIONS(1543),
    [sym_dot_dot_i] = ACTIONS(1545),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1545),
    [sym__newline] = ACTIONS(1545),
    [sym__raw_string_literal] = ACTIONS(1545),
    [sym__external_open_parenthesis] = ACTIONS(1545),
    [sym__external_open_brace] = ACTIONS(1545),
    [sym__external_open_bracket] = ACTIONS(1545),
    [sym__external_close_bracket] = ACTIONS(1545),
    [sym__external_open_bracket2] = ACTIONS(1545),
  },
  [986] = {
    [sym_identifier] = ACTIONS(1500),
    [anon_sym_BSLASH] = ACTIONS(1502),
    [anon_sym_function] = ACTIONS(1500),
    [anon_sym_EQ] = ACTIONS(1500),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_for] = ACTIONS(1500),
    [anon_sym_while] = ACTIONS(1500),
    [anon_sym_repeat] = ACTIONS(1500),
    [anon_sym_QMARK] = ACTIONS(1502),
    [anon_sym_TILDE] = ACTIONS(1502),
    [anon_sym_BANG] = ACTIONS(1500),
    [anon_sym_PLUS] = ACTIONS(1502),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_LT_DASH] = ACTIONS(1502),
    [anon_sym_LT_LT_DASH] = ACTIONS(1502),
    [anon_sym_COLON_EQ] = ACTIONS(1502),
    [anon_sym_DASH_GT] = ACTIONS(1500),
    [anon_sym_DASH_GT_GT] = ACTIONS(1502),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_AMP] = ACTIONS(1500),
    [anon_sym_PIPE_PIPE] = ACTIONS(1502),
    [anon_sym_AMP_AMP] = ACTIONS(1502),
    [anon_sym_LT] = ACTIONS(1500),
    [anon_sym_LT_EQ] = ACTIONS(1502),
    [anon_sym_GT] = ACTIONS(1500),
    [anon_sym_GT_EQ] = ACTIONS(1502),
    [anon_sym_EQ_EQ] = ACTIONS(1502),
    [anon_sym_BANG_EQ] = ACTIONS(1502),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1502),
    [anon_sym_STAR_STAR] = ACTIONS(1502),
    [anon_sym_CARET] = ACTIONS(1502),
    [aux_sym_binary_operator_token1] = ACTIONS(1502),
    [anon_sym_PIPE_GT] = ACTIONS(1502),
    [anon_sym_COLON] = ACTIONS(1500),
    [anon_sym_DOLLAR] = ACTIONS(1502),
    [anon_sym_AT] = ACTIONS(1502),
    [sym__hex_literal] = ACTIONS(1502),
    [sym__number_literal] = ACTIONS(1500),
    [anon_sym_SQUOTE] = ACTIONS(1502),
    [anon_sym_DQUOTE] = ACTIONS(1502),
    [sym_return] = ACTIONS(1500),
    [sym_next] = ACTIONS(1500),
    [sym_break] = ACTIONS(1500),
    [sym_true] = ACTIONS(1500),
    [sym_false] = ACTIONS(1500),
    [sym_null] = ACTIONS(1500),
    [sym_inf] = ACTIONS(1500),
    [sym_nan] = ACTIONS(1500),
    [anon_sym_NA] = ACTIONS(1500),
    [anon_sym_NA_integer_] = ACTIONS(1500),
    [anon_sym_NA_real_] = ACTIONS(1500),
    [anon_sym_NA_complex_] = ACTIONS(1500),
    [anon_sym_NA_character_] = ACTIONS(1500),
    [sym_dots] = ACTIONS(1500),
    [sym_dot_dot_i] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1502),
    [sym__newline] = ACTIONS(1502),
    [sym__raw_string_literal] = ACTIONS(1502),
    [sym__external_open_parenthesis] = ACTIONS(1502),
    [sym__external_open_brace] = ACTIONS(1502),
    [sym__external_open_bracket] = ACTIONS(1502),
    [sym__external_close_bracket] = ACTIONS(1502),
    [sym__external_open_bracket2] = ACTIONS(1502),
  },
  [987] = {
    [sym_function_definition] = STATE(631),
    [sym_if_statement] = STATE(631),
    [sym_for_statement] = STATE(631),
    [sym_while_statement] = STATE(631),
    [sym_repeat_statement] = STATE(631),
    [sym_braced_expression] = STATE(631),
    [sym_parenthesized_expression] = STATE(631),
    [sym_call] = STATE(631),
    [sym_subset] = STATE(631),
    [sym_subset2] = STATE(631),
    [sym_unary_operator] = STATE(631),
    [sym_binary_operator] = STATE(631),
    [sym_extract_operator] = STATE(631),
    [sym_namespace_operator] = STATE(631),
    [sym_integer] = STATE(631),
    [sym_complex] = STATE(631),
    [sym_float] = STATE(631),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(739),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(631),
    [sym__expression] = STATE(631),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(912),
    [sym__open_brace] = STATE(842),
    [aux_sym_parenthesized_expression_repeat1] = STATE(949),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(1679),
    [sym_next] = ACTIONS(1679),
    [sym_break] = ACTIONS(1679),
    [sym_true] = ACTIONS(1679),
    [sym_false] = ACTIONS(1679),
    [sym_null] = ACTIONS(1679),
    [sym_inf] = ACTIONS(1679),
    [sym_nan] = ACTIONS(1679),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(1679),
    [sym_dot_dot_i] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1683),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1795),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [988] = {
    [sym_function_definition] = STATE(631),
    [sym_if_statement] = STATE(631),
    [sym_for_statement] = STATE(631),
    [sym_while_statement] = STATE(631),
    [sym_repeat_statement] = STATE(631),
    [sym_braced_expression] = STATE(631),
    [sym_parenthesized_expression] = STATE(631),
    [sym_call] = STATE(631),
    [sym_subset] = STATE(631),
    [sym_subset2] = STATE(631),
    [sym_unary_operator] = STATE(631),
    [sym_binary_operator] = STATE(631),
    [sym_extract_operator] = STATE(631),
    [sym_namespace_operator] = STATE(631),
    [sym_integer] = STATE(631),
    [sym_complex] = STATE(631),
    [sym_float] = STATE(631),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(739),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(631),
    [sym__expression] = STATE(631),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(768),
    [sym__open_brace] = STATE(842),
    [aux_sym_parenthesized_expression_repeat1] = STATE(1003),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(1679),
    [sym_next] = ACTIONS(1679),
    [sym_break] = ACTIONS(1679),
    [sym_true] = ACTIONS(1679),
    [sym_false] = ACTIONS(1679),
    [sym_null] = ACTIONS(1679),
    [sym_inf] = ACTIONS(1679),
    [sym_nan] = ACTIONS(1679),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(1679),
    [sym_dot_dot_i] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1683),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1797),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [989] = {
    [ts_builtin_sym_end] = ACTIONS(1474),
    [sym_identifier] = ACTIONS(1472),
    [anon_sym_BSLASH] = ACTIONS(1474),
    [anon_sym_function] = ACTIONS(1472),
    [anon_sym_EQ] = ACTIONS(1472),
    [anon_sym_if] = ACTIONS(1472),
    [anon_sym_for] = ACTIONS(1472),
    [anon_sym_while] = ACTIONS(1472),
    [anon_sym_repeat] = ACTIONS(1472),
    [anon_sym_QMARK] = ACTIONS(1474),
    [anon_sym_TILDE] = ACTIONS(1474),
    [anon_sym_BANG] = ACTIONS(1472),
    [anon_sym_PLUS] = ACTIONS(1474),
    [anon_sym_DASH] = ACTIONS(1472),
    [anon_sym_LT_DASH] = ACTIONS(1474),
    [anon_sym_LT_LT_DASH] = ACTIONS(1474),
    [anon_sym_COLON_EQ] = ACTIONS(1474),
    [anon_sym_DASH_GT] = ACTIONS(1472),
    [anon_sym_DASH_GT_GT] = ACTIONS(1474),
    [anon_sym_PIPE] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1472),
    [anon_sym_PIPE_PIPE] = ACTIONS(1474),
    [anon_sym_AMP_AMP] = ACTIONS(1474),
    [anon_sym_LT] = ACTIONS(1472),
    [anon_sym_LT_EQ] = ACTIONS(1474),
    [anon_sym_GT] = ACTIONS(1472),
    [anon_sym_GT_EQ] = ACTIONS(1474),
    [anon_sym_EQ_EQ] = ACTIONS(1474),
    [anon_sym_BANG_EQ] = ACTIONS(1474),
    [anon_sym_STAR] = ACTIONS(1472),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_STAR_STAR] = ACTIONS(1474),
    [anon_sym_CARET] = ACTIONS(1474),
    [aux_sym_binary_operator_token1] = ACTIONS(1474),
    [anon_sym_PIPE_GT] = ACTIONS(1474),
    [anon_sym_COLON] = ACTIONS(1472),
    [anon_sym_DOLLAR] = ACTIONS(1474),
    [anon_sym_AT] = ACTIONS(1474),
    [sym__hex_literal] = ACTIONS(1474),
    [sym__number_literal] = ACTIONS(1472),
    [anon_sym_SQUOTE] = ACTIONS(1474),
    [anon_sym_DQUOTE] = ACTIONS(1474),
    [sym_return] = ACTIONS(1472),
    [sym_next] = ACTIONS(1472),
    [sym_break] = ACTIONS(1472),
    [sym_true] = ACTIONS(1472),
    [sym_false] = ACTIONS(1472),
    [sym_null] = ACTIONS(1472),
    [sym_inf] = ACTIONS(1472),
    [sym_nan] = ACTIONS(1472),
    [anon_sym_NA] = ACTIONS(1472),
    [anon_sym_NA_integer_] = ACTIONS(1472),
    [anon_sym_NA_real_] = ACTIONS(1472),
    [anon_sym_NA_complex_] = ACTIONS(1472),
    [anon_sym_NA_character_] = ACTIONS(1472),
    [sym_dots] = ACTIONS(1472),
    [sym_dot_dot_i] = ACTIONS(1474),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1474),
    [sym__semicolon] = ACTIONS(1474),
    [sym__raw_string_literal] = ACTIONS(1474),
    [sym__external_open_parenthesis] = ACTIONS(1474),
    [sym__external_open_brace] = ACTIONS(1474),
    [sym__external_open_bracket] = ACTIONS(1474),
    [sym__external_open_bracket2] = ACTIONS(1474),
  },
  [990] = {
    [sym_function_definition] = STATE(631),
    [sym_if_statement] = STATE(631),
    [sym_for_statement] = STATE(631),
    [sym_while_statement] = STATE(631),
    [sym_repeat_statement] = STATE(631),
    [sym_braced_expression] = STATE(631),
    [sym_parenthesized_expression] = STATE(631),
    [sym_call] = STATE(631),
    [sym_subset] = STATE(631),
    [sym_subset2] = STATE(631),
    [sym_unary_operator] = STATE(631),
    [sym_binary_operator] = STATE(631),
    [sym_extract_operator] = STATE(631),
    [sym_namespace_operator] = STATE(631),
    [sym_integer] = STATE(631),
    [sym_complex] = STATE(631),
    [sym_float] = STATE(631),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(739),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(631),
    [sym__expression] = STATE(631),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(755),
    [sym__open_brace] = STATE(842),
    [aux_sym_parenthesized_expression_repeat1] = STATE(988),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(1679),
    [sym_next] = ACTIONS(1679),
    [sym_break] = ACTIONS(1679),
    [sym_true] = ACTIONS(1679),
    [sym_false] = ACTIONS(1679),
    [sym_null] = ACTIONS(1679),
    [sym_inf] = ACTIONS(1679),
    [sym_nan] = ACTIONS(1679),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(1679),
    [sym_dot_dot_i] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1683),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1799),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [991] = {
    [ts_builtin_sym_end] = ACTIONS(1517),
    [sym_identifier] = ACTIONS(1515),
    [anon_sym_BSLASH] = ACTIONS(1517),
    [anon_sym_function] = ACTIONS(1515),
    [anon_sym_EQ] = ACTIONS(1515),
    [anon_sym_if] = ACTIONS(1515),
    [anon_sym_for] = ACTIONS(1515),
    [anon_sym_while] = ACTIONS(1515),
    [anon_sym_repeat] = ACTIONS(1515),
    [anon_sym_QMARK] = ACTIONS(1517),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_BANG] = ACTIONS(1515),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_DASH] = ACTIONS(1515),
    [anon_sym_LT_DASH] = ACTIONS(1517),
    [anon_sym_LT_LT_DASH] = ACTIONS(1517),
    [anon_sym_COLON_EQ] = ACTIONS(1517),
    [anon_sym_DASH_GT] = ACTIONS(1515),
    [anon_sym_DASH_GT_GT] = ACTIONS(1517),
    [anon_sym_PIPE] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1515),
    [anon_sym_PIPE_PIPE] = ACTIONS(1517),
    [anon_sym_AMP_AMP] = ACTIONS(1517),
    [anon_sym_LT] = ACTIONS(1515),
    [anon_sym_LT_EQ] = ACTIONS(1517),
    [anon_sym_GT] = ACTIONS(1515),
    [anon_sym_GT_EQ] = ACTIONS(1517),
    [anon_sym_EQ_EQ] = ACTIONS(1517),
    [anon_sym_BANG_EQ] = ACTIONS(1517),
    [anon_sym_STAR] = ACTIONS(1515),
    [anon_sym_SLASH] = ACTIONS(1517),
    [anon_sym_STAR_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [aux_sym_binary_operator_token1] = ACTIONS(1517),
    [anon_sym_PIPE_GT] = ACTIONS(1517),
    [anon_sym_COLON] = ACTIONS(1515),
    [anon_sym_DOLLAR] = ACTIONS(1517),
    [anon_sym_AT] = ACTIONS(1517),
    [sym__hex_literal] = ACTIONS(1517),
    [sym__number_literal] = ACTIONS(1515),
    [anon_sym_SQUOTE] = ACTIONS(1517),
    [anon_sym_DQUOTE] = ACTIONS(1517),
    [sym_return] = ACTIONS(1515),
    [sym_next] = ACTIONS(1515),
    [sym_break] = ACTIONS(1515),
    [sym_true] = ACTIONS(1515),
    [sym_false] = ACTIONS(1515),
    [sym_null] = ACTIONS(1515),
    [sym_inf] = ACTIONS(1515),
    [sym_nan] = ACTIONS(1515),
    [anon_sym_NA] = ACTIONS(1515),
    [anon_sym_NA_integer_] = ACTIONS(1515),
    [anon_sym_NA_real_] = ACTIONS(1515),
    [anon_sym_NA_complex_] = ACTIONS(1515),
    [anon_sym_NA_character_] = ACTIONS(1515),
    [sym_dots] = ACTIONS(1515),
    [sym_dot_dot_i] = ACTIONS(1517),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1517),
    [sym__semicolon] = ACTIONS(1517),
    [sym__raw_string_literal] = ACTIONS(1517),
    [sym__external_open_parenthesis] = ACTIONS(1517),
    [sym__external_open_brace] = ACTIONS(1517),
    [sym__external_open_bracket] = ACTIONS(1517),
    [sym__external_open_bracket2] = ACTIONS(1517),
  },
  [992] = {
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_BSLASH] = ACTIONS(1506),
    [anon_sym_function] = ACTIONS(1504),
    [anon_sym_EQ] = ACTIONS(1504),
    [anon_sym_if] = ACTIONS(1504),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1504),
    [anon_sym_repeat] = ACTIONS(1504),
    [anon_sym_QMARK] = ACTIONS(1506),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_BANG] = ACTIONS(1504),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1504),
    [anon_sym_LT_DASH] = ACTIONS(1506),
    [anon_sym_LT_LT_DASH] = ACTIONS(1506),
    [anon_sym_COLON_EQ] = ACTIONS(1506),
    [anon_sym_DASH_GT] = ACTIONS(1504),
    [anon_sym_DASH_GT_GT] = ACTIONS(1506),
    [anon_sym_PIPE] = ACTIONS(1504),
    [anon_sym_AMP] = ACTIONS(1504),
    [anon_sym_PIPE_PIPE] = ACTIONS(1506),
    [anon_sym_AMP_AMP] = ACTIONS(1506),
    [anon_sym_LT] = ACTIONS(1504),
    [anon_sym_LT_EQ] = ACTIONS(1506),
    [anon_sym_GT] = ACTIONS(1504),
    [anon_sym_GT_EQ] = ACTIONS(1506),
    [anon_sym_EQ_EQ] = ACTIONS(1506),
    [anon_sym_BANG_EQ] = ACTIONS(1506),
    [anon_sym_STAR] = ACTIONS(1504),
    [anon_sym_SLASH] = ACTIONS(1506),
    [anon_sym_STAR_STAR] = ACTIONS(1506),
    [anon_sym_CARET] = ACTIONS(1506),
    [aux_sym_binary_operator_token1] = ACTIONS(1506),
    [anon_sym_PIPE_GT] = ACTIONS(1506),
    [anon_sym_COLON] = ACTIONS(1504),
    [anon_sym_DOLLAR] = ACTIONS(1506),
    [anon_sym_AT] = ACTIONS(1506),
    [sym__hex_literal] = ACTIONS(1506),
    [sym__number_literal] = ACTIONS(1504),
    [anon_sym_SQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1506),
    [sym_return] = ACTIONS(1504),
    [sym_next] = ACTIONS(1504),
    [sym_break] = ACTIONS(1504),
    [sym_true] = ACTIONS(1504),
    [sym_false] = ACTIONS(1504),
    [sym_null] = ACTIONS(1504),
    [sym_inf] = ACTIONS(1504),
    [sym_nan] = ACTIONS(1504),
    [anon_sym_NA] = ACTIONS(1504),
    [anon_sym_NA_integer_] = ACTIONS(1504),
    [anon_sym_NA_real_] = ACTIONS(1504),
    [anon_sym_NA_complex_] = ACTIONS(1504),
    [anon_sym_NA_character_] = ACTIONS(1504),
    [sym_dots] = ACTIONS(1504),
    [sym_dot_dot_i] = ACTIONS(1506),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1506),
    [sym__newline] = ACTIONS(1506),
    [sym__raw_string_literal] = ACTIONS(1506),
    [sym__external_open_parenthesis] = ACTIONS(1506),
    [sym__external_open_brace] = ACTIONS(1506),
    [sym__external_open_bracket] = ACTIONS(1506),
    [sym__external_close_bracket] = ACTIONS(1506),
    [sym__external_open_bracket2] = ACTIONS(1506),
  },
  [993] = {
    [sym_identifier] = ACTIONS(1508),
    [anon_sym_BSLASH] = ACTIONS(1510),
    [anon_sym_function] = ACTIONS(1508),
    [anon_sym_EQ] = ACTIONS(1508),
    [anon_sym_if] = ACTIONS(1508),
    [anon_sym_for] = ACTIONS(1508),
    [anon_sym_while] = ACTIONS(1508),
    [anon_sym_repeat] = ACTIONS(1508),
    [anon_sym_QMARK] = ACTIONS(1510),
    [anon_sym_TILDE] = ACTIONS(1510),
    [anon_sym_BANG] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1510),
    [anon_sym_DASH] = ACTIONS(1508),
    [anon_sym_LT_DASH] = ACTIONS(1510),
    [anon_sym_LT_LT_DASH] = ACTIONS(1510),
    [anon_sym_COLON_EQ] = ACTIONS(1510),
    [anon_sym_DASH_GT] = ACTIONS(1508),
    [anon_sym_DASH_GT_GT] = ACTIONS(1510),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PIPE_PIPE] = ACTIONS(1510),
    [anon_sym_AMP_AMP] = ACTIONS(1510),
    [anon_sym_LT] = ACTIONS(1508),
    [anon_sym_LT_EQ] = ACTIONS(1510),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_GT_EQ] = ACTIONS(1510),
    [anon_sym_EQ_EQ] = ACTIONS(1510),
    [anon_sym_BANG_EQ] = ACTIONS(1510),
    [anon_sym_STAR] = ACTIONS(1508),
    [anon_sym_SLASH] = ACTIONS(1510),
    [anon_sym_STAR_STAR] = ACTIONS(1510),
    [anon_sym_CARET] = ACTIONS(1510),
    [aux_sym_binary_operator_token1] = ACTIONS(1510),
    [anon_sym_PIPE_GT] = ACTIONS(1510),
    [anon_sym_COLON] = ACTIONS(1508),
    [anon_sym_DOLLAR] = ACTIONS(1510),
    [anon_sym_AT] = ACTIONS(1510),
    [sym__hex_literal] = ACTIONS(1510),
    [sym__number_literal] = ACTIONS(1508),
    [anon_sym_SQUOTE] = ACTIONS(1510),
    [anon_sym_DQUOTE] = ACTIONS(1510),
    [sym_return] = ACTIONS(1508),
    [sym_next] = ACTIONS(1508),
    [sym_break] = ACTIONS(1508),
    [sym_true] = ACTIONS(1508),
    [sym_false] = ACTIONS(1508),
    [sym_null] = ACTIONS(1508),
    [sym_inf] = ACTIONS(1508),
    [sym_nan] = ACTIONS(1508),
    [anon_sym_NA] = ACTIONS(1508),
    [anon_sym_NA_integer_] = ACTIONS(1508),
    [anon_sym_NA_real_] = ACTIONS(1508),
    [anon_sym_NA_complex_] = ACTIONS(1508),
    [anon_sym_NA_character_] = ACTIONS(1508),
    [sym_dots] = ACTIONS(1508),
    [sym_dot_dot_i] = ACTIONS(1510),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1510),
    [sym__newline] = ACTIONS(1510),
    [sym__raw_string_literal] = ACTIONS(1510),
    [sym__external_open_parenthesis] = ACTIONS(1510),
    [sym__external_open_brace] = ACTIONS(1510),
    [sym__external_open_bracket] = ACTIONS(1510),
    [sym__external_close_bracket] = ACTIONS(1510),
    [sym__external_open_bracket2] = ACTIONS(1510),
  },
  [994] = {
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_BSLASH] = ACTIONS(1541),
    [anon_sym_function] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1539),
    [anon_sym_if] = ACTIONS(1539),
    [anon_sym_for] = ACTIONS(1539),
    [anon_sym_while] = ACTIONS(1539),
    [anon_sym_repeat] = ACTIONS(1539),
    [anon_sym_QMARK] = ACTIONS(1541),
    [anon_sym_TILDE] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1539),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1539),
    [anon_sym_LT_DASH] = ACTIONS(1541),
    [anon_sym_LT_LT_DASH] = ACTIONS(1541),
    [anon_sym_COLON_EQ] = ACTIONS(1541),
    [anon_sym_DASH_GT] = ACTIONS(1539),
    [anon_sym_DASH_GT_GT] = ACTIONS(1541),
    [anon_sym_PIPE] = ACTIONS(1539),
    [anon_sym_AMP] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1541),
    [anon_sym_GT] = ACTIONS(1539),
    [anon_sym_GT_EQ] = ACTIONS(1541),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1539),
    [anon_sym_SLASH] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_CARET] = ACTIONS(1541),
    [aux_sym_binary_operator_token1] = ACTIONS(1541),
    [anon_sym_PIPE_GT] = ACTIONS(1541),
    [anon_sym_COLON] = ACTIONS(1539),
    [anon_sym_DOLLAR] = ACTIONS(1541),
    [anon_sym_AT] = ACTIONS(1541),
    [sym__hex_literal] = ACTIONS(1541),
    [sym__number_literal] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(1541),
    [anon_sym_DQUOTE] = ACTIONS(1541),
    [sym_return] = ACTIONS(1539),
    [sym_next] = ACTIONS(1539),
    [sym_break] = ACTIONS(1539),
    [sym_true] = ACTIONS(1539),
    [sym_false] = ACTIONS(1539),
    [sym_null] = ACTIONS(1539),
    [sym_inf] = ACTIONS(1539),
    [sym_nan] = ACTIONS(1539),
    [anon_sym_NA] = ACTIONS(1539),
    [anon_sym_NA_integer_] = ACTIONS(1539),
    [anon_sym_NA_real_] = ACTIONS(1539),
    [anon_sym_NA_complex_] = ACTIONS(1539),
    [anon_sym_NA_character_] = ACTIONS(1539),
    [sym_dots] = ACTIONS(1539),
    [sym_dot_dot_i] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1541),
    [sym__newline] = ACTIONS(1541),
    [sym__raw_string_literal] = ACTIONS(1541),
    [sym__external_open_parenthesis] = ACTIONS(1541),
    [sym__external_open_brace] = ACTIONS(1541),
    [sym__external_open_bracket] = ACTIONS(1541),
    [sym__external_open_bracket2] = ACTIONS(1541),
    [sym__external_close_bracket2] = ACTIONS(1541),
  },
  [995] = {
    [sym_function_definition] = STATE(631),
    [sym_if_statement] = STATE(631),
    [sym_for_statement] = STATE(631),
    [sym_while_statement] = STATE(631),
    [sym_repeat_statement] = STATE(631),
    [sym_braced_expression] = STATE(631),
    [sym_parenthesized_expression] = STATE(631),
    [sym_call] = STATE(631),
    [sym_subset] = STATE(631),
    [sym_subset2] = STATE(631),
    [sym_unary_operator] = STATE(631),
    [sym_binary_operator] = STATE(631),
    [sym_extract_operator] = STATE(631),
    [sym_namespace_operator] = STATE(631),
    [sym_integer] = STATE(631),
    [sym_complex] = STATE(631),
    [sym_float] = STATE(631),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(739),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(631),
    [sym__expression] = STATE(631),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(827),
    [sym__open_brace] = STATE(842),
    [aux_sym_parenthesized_expression_repeat1] = STATE(1003),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(1679),
    [sym_next] = ACTIONS(1679),
    [sym_break] = ACTIONS(1679),
    [sym_true] = ACTIONS(1679),
    [sym_false] = ACTIONS(1679),
    [sym_null] = ACTIONS(1679),
    [sym_inf] = ACTIONS(1679),
    [sym_nan] = ACTIONS(1679),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(1679),
    [sym_dot_dot_i] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1683),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1801),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [996] = {
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_BSLASH] = ACTIONS(1545),
    [anon_sym_function] = ACTIONS(1543),
    [anon_sym_EQ] = ACTIONS(1543),
    [anon_sym_if] = ACTIONS(1543),
    [anon_sym_for] = ACTIONS(1543),
    [anon_sym_while] = ACTIONS(1543),
    [anon_sym_repeat] = ACTIONS(1543),
    [anon_sym_QMARK] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1543),
    [anon_sym_PLUS] = ACTIONS(1545),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_LT_DASH] = ACTIONS(1545),
    [anon_sym_LT_LT_DASH] = ACTIONS(1545),
    [anon_sym_COLON_EQ] = ACTIONS(1545),
    [anon_sym_DASH_GT] = ACTIONS(1543),
    [anon_sym_DASH_GT_GT] = ACTIONS(1545),
    [anon_sym_PIPE] = ACTIONS(1543),
    [anon_sym_AMP] = ACTIONS(1543),
    [anon_sym_PIPE_PIPE] = ACTIONS(1545),
    [anon_sym_AMP_AMP] = ACTIONS(1545),
    [anon_sym_LT] = ACTIONS(1543),
    [anon_sym_LT_EQ] = ACTIONS(1545),
    [anon_sym_GT] = ACTIONS(1543),
    [anon_sym_GT_EQ] = ACTIONS(1545),
    [anon_sym_EQ_EQ] = ACTIONS(1545),
    [anon_sym_BANG_EQ] = ACTIONS(1545),
    [anon_sym_STAR] = ACTIONS(1543),
    [anon_sym_SLASH] = ACTIONS(1545),
    [anon_sym_STAR_STAR] = ACTIONS(1545),
    [anon_sym_CARET] = ACTIONS(1545),
    [aux_sym_binary_operator_token1] = ACTIONS(1545),
    [anon_sym_PIPE_GT] = ACTIONS(1545),
    [anon_sym_COLON] = ACTIONS(1543),
    [anon_sym_DOLLAR] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(1545),
    [sym__hex_literal] = ACTIONS(1545),
    [sym__number_literal] = ACTIONS(1543),
    [anon_sym_SQUOTE] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1545),
    [sym_return] = ACTIONS(1543),
    [sym_next] = ACTIONS(1543),
    [sym_break] = ACTIONS(1543),
    [sym_true] = ACTIONS(1543),
    [sym_false] = ACTIONS(1543),
    [sym_null] = ACTIONS(1543),
    [sym_inf] = ACTIONS(1543),
    [sym_nan] = ACTIONS(1543),
    [anon_sym_NA] = ACTIONS(1543),
    [anon_sym_NA_integer_] = ACTIONS(1543),
    [anon_sym_NA_real_] = ACTIONS(1543),
    [anon_sym_NA_complex_] = ACTIONS(1543),
    [anon_sym_NA_character_] = ACTIONS(1543),
    [sym_dots] = ACTIONS(1543),
    [sym_dot_dot_i] = ACTIONS(1545),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1545),
    [sym__newline] = ACTIONS(1545),
    [sym__raw_string_literal] = ACTIONS(1545),
    [sym__external_open_parenthesis] = ACTIONS(1545),
    [sym__external_open_brace] = ACTIONS(1545),
    [sym__external_open_bracket] = ACTIONS(1545),
    [sym__external_open_bracket2] = ACTIONS(1545),
    [sym__external_close_bracket2] = ACTIONS(1545),
  },
  [997] = {
    [sym_function_definition] = STATE(631),
    [sym_if_statement] = STATE(631),
    [sym_for_statement] = STATE(631),
    [sym_while_statement] = STATE(631),
    [sym_repeat_statement] = STATE(631),
    [sym_braced_expression] = STATE(631),
    [sym_parenthesized_expression] = STATE(631),
    [sym_call] = STATE(631),
    [sym_subset] = STATE(631),
    [sym_subset2] = STATE(631),
    [sym_unary_operator] = STATE(631),
    [sym_binary_operator] = STATE(631),
    [sym_extract_operator] = STATE(631),
    [sym_namespace_operator] = STATE(631),
    [sym_integer] = STATE(631),
    [sym_complex] = STATE(631),
    [sym_float] = STATE(631),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(739),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(631),
    [sym__expression] = STATE(631),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(806),
    [sym__open_brace] = STATE(842),
    [aux_sym_parenthesized_expression_repeat1] = STATE(995),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(1679),
    [sym_next] = ACTIONS(1679),
    [sym_break] = ACTIONS(1679),
    [sym_true] = ACTIONS(1679),
    [sym_false] = ACTIONS(1679),
    [sym_null] = ACTIONS(1679),
    [sym_inf] = ACTIONS(1679),
    [sym_nan] = ACTIONS(1679),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(1679),
    [sym_dot_dot_i] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1683),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1803),
    [sym__external_open_brace] = ACTIONS(785),
  },
  [998] = {
    [sym_identifier] = ACTIONS(1519),
    [anon_sym_BSLASH] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(1519),
    [anon_sym_EQ] = ACTIONS(1519),
    [anon_sym_if] = ACTIONS(1519),
    [anon_sym_for] = ACTIONS(1519),
    [anon_sym_while] = ACTIONS(1519),
    [anon_sym_repeat] = ACTIONS(1519),
    [anon_sym_QMARK] = ACTIONS(1521),
    [anon_sym_TILDE] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1519),
    [anon_sym_PLUS] = ACTIONS(1521),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_LT_DASH] = ACTIONS(1521),
    [anon_sym_LT_LT_DASH] = ACTIONS(1521),
    [anon_sym_COLON_EQ] = ACTIONS(1521),
    [anon_sym_DASH_GT] = ACTIONS(1519),
    [anon_sym_DASH_GT_GT] = ACTIONS(1521),
    [anon_sym_PIPE] = ACTIONS(1519),
    [anon_sym_AMP] = ACTIONS(1519),
    [anon_sym_PIPE_PIPE] = ACTIONS(1521),
    [anon_sym_AMP_AMP] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_LT_EQ] = ACTIONS(1521),
    [anon_sym_GT] = ACTIONS(1519),
    [anon_sym_GT_EQ] = ACTIONS(1521),
    [anon_sym_EQ_EQ] = ACTIONS(1521),
    [anon_sym_BANG_EQ] = ACTIONS(1521),
    [anon_sym_STAR] = ACTIONS(1519),
    [anon_sym_SLASH] = ACTIONS(1521),
    [anon_sym_STAR_STAR] = ACTIONS(1521),
    [anon_sym_CARET] = ACTIONS(1521),
    [aux_sym_binary_operator_token1] = ACTIONS(1521),
    [anon_sym_PIPE_GT] = ACTIONS(1521),
    [anon_sym_COLON] = ACTIONS(1519),
    [anon_sym_DOLLAR] = ACTIONS(1521),
    [anon_sym_AT] = ACTIONS(1521),
    [sym__hex_literal] = ACTIONS(1521),
    [sym__number_literal] = ACTIONS(1519),
    [anon_sym_SQUOTE] = ACTIONS(1521),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [sym_return] = ACTIONS(1519),
    [sym_next] = ACTIONS(1519),
    [sym_break] = ACTIONS(1519),
    [sym_true] = ACTIONS(1519),
    [sym_false] = ACTIONS(1519),
    [sym_null] = ACTIONS(1519),
    [sym_inf] = ACTIONS(1519),
    [sym_nan] = ACTIONS(1519),
    [anon_sym_NA] = ACTIONS(1519),
    [anon_sym_NA_integer_] = ACTIONS(1519),
    [anon_sym_NA_real_] = ACTIONS(1519),
    [anon_sym_NA_complex_] = ACTIONS(1519),
    [anon_sym_NA_character_] = ACTIONS(1519),
    [sym_dots] = ACTIONS(1519),
    [sym_dot_dot_i] = ACTIONS(1521),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1521),
    [sym__newline] = ACTIONS(1521),
    [sym__raw_string_literal] = ACTIONS(1521),
    [sym__external_open_parenthesis] = ACTIONS(1521),
    [sym__external_open_brace] = ACTIONS(1521),
    [sym__external_open_bracket] = ACTIONS(1521),
    [sym__external_close_bracket] = ACTIONS(1521),
    [sym__external_open_bracket2] = ACTIONS(1521),
  },
  [999] = {
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_BSLASH] = ACTIONS(1549),
    [anon_sym_function] = ACTIONS(1547),
    [anon_sym_EQ] = ACTIONS(1547),
    [anon_sym_if] = ACTIONS(1547),
    [anon_sym_for] = ACTIONS(1547),
    [anon_sym_while] = ACTIONS(1547),
    [anon_sym_repeat] = ACTIONS(1547),
    [anon_sym_QMARK] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1547),
    [anon_sym_LT_DASH] = ACTIONS(1549),
    [anon_sym_LT_LT_DASH] = ACTIONS(1549),
    [anon_sym_COLON_EQ] = ACTIONS(1549),
    [anon_sym_DASH_GT] = ACTIONS(1547),
    [anon_sym_DASH_GT_GT] = ACTIONS(1549),
    [anon_sym_PIPE] = ACTIONS(1547),
    [anon_sym_AMP] = ACTIONS(1547),
    [anon_sym_PIPE_PIPE] = ACTIONS(1549),
    [anon_sym_AMP_AMP] = ACTIONS(1549),
    [anon_sym_LT] = ACTIONS(1547),
    [anon_sym_LT_EQ] = ACTIONS(1549),
    [anon_sym_GT] = ACTIONS(1547),
    [anon_sym_GT_EQ] = ACTIONS(1549),
    [anon_sym_EQ_EQ] = ACTIONS(1549),
    [anon_sym_BANG_EQ] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_SLASH] = ACTIONS(1549),
    [anon_sym_STAR_STAR] = ACTIONS(1549),
    [anon_sym_CARET] = ACTIONS(1549),
    [aux_sym_binary_operator_token1] = ACTIONS(1549),
    [anon_sym_PIPE_GT] = ACTIONS(1549),
    [anon_sym_COLON] = ACTIONS(1547),
    [anon_sym_DOLLAR] = ACTIONS(1549),
    [anon_sym_AT] = ACTIONS(1549),
    [sym__hex_literal] = ACTIONS(1549),
    [sym__number_literal] = ACTIONS(1547),
    [anon_sym_SQUOTE] = ACTIONS(1549),
    [anon_sym_DQUOTE] = ACTIONS(1549),
    [sym_return] = ACTIONS(1547),
    [sym_next] = ACTIONS(1547),
    [sym_break] = ACTIONS(1547),
    [sym_true] = ACTIONS(1547),
    [sym_false] = ACTIONS(1547),
    [sym_null] = ACTIONS(1547),
    [sym_inf] = ACTIONS(1547),
    [sym_nan] = ACTIONS(1547),
    [anon_sym_NA] = ACTIONS(1547),
    [anon_sym_NA_integer_] = ACTIONS(1547),
    [anon_sym_NA_real_] = ACTIONS(1547),
    [anon_sym_NA_complex_] = ACTIONS(1547),
    [anon_sym_NA_character_] = ACTIONS(1547),
    [sym_dots] = ACTIONS(1547),
    [sym_dot_dot_i] = ACTIONS(1549),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1549),
    [sym__newline] = ACTIONS(1549),
    [sym__raw_string_literal] = ACTIONS(1549),
    [sym__external_open_parenthesis] = ACTIONS(1549),
    [sym__external_open_brace] = ACTIONS(1549),
    [sym__external_open_bracket] = ACTIONS(1549),
    [sym__external_open_bracket2] = ACTIONS(1549),
    [sym__external_close_bracket2] = ACTIONS(1549),
  },
  [1000] = {
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_BSLASH] = ACTIONS(1494),
    [anon_sym_function] = ACTIONS(1492),
    [anon_sym_EQ] = ACTIONS(1492),
    [anon_sym_if] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(1492),
    [anon_sym_while] = ACTIONS(1492),
    [anon_sym_repeat] = ACTIONS(1492),
    [anon_sym_QMARK] = ACTIONS(1494),
    [anon_sym_TILDE] = ACTIONS(1494),
    [anon_sym_BANG] = ACTIONS(1492),
    [anon_sym_PLUS] = ACTIONS(1494),
    [anon_sym_DASH] = ACTIONS(1492),
    [anon_sym_LT_DASH] = ACTIONS(1494),
    [anon_sym_LT_LT_DASH] = ACTIONS(1494),
    [anon_sym_COLON_EQ] = ACTIONS(1494),
    [anon_sym_DASH_GT] = ACTIONS(1492),
    [anon_sym_DASH_GT_GT] = ACTIONS(1494),
    [anon_sym_PIPE] = ACTIONS(1492),
    [anon_sym_AMP] = ACTIONS(1492),
    [anon_sym_PIPE_PIPE] = ACTIONS(1494),
    [anon_sym_AMP_AMP] = ACTIONS(1494),
    [anon_sym_LT] = ACTIONS(1492),
    [anon_sym_LT_EQ] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1492),
    [anon_sym_GT_EQ] = ACTIONS(1494),
    [anon_sym_EQ_EQ] = ACTIONS(1494),
    [anon_sym_BANG_EQ] = ACTIONS(1494),
    [anon_sym_STAR] = ACTIONS(1492),
    [anon_sym_SLASH] = ACTIONS(1494),
    [anon_sym_STAR_STAR] = ACTIONS(1494),
    [anon_sym_CARET] = ACTIONS(1494),
    [aux_sym_binary_operator_token1] = ACTIONS(1494),
    [anon_sym_PIPE_GT] = ACTIONS(1494),
    [anon_sym_COLON] = ACTIONS(1492),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [anon_sym_AT] = ACTIONS(1494),
    [sym__hex_literal] = ACTIONS(1494),
    [sym__number_literal] = ACTIONS(1492),
    [anon_sym_SQUOTE] = ACTIONS(1494),
    [anon_sym_DQUOTE] = ACTIONS(1494),
    [sym_return] = ACTIONS(1492),
    [sym_next] = ACTIONS(1492),
    [sym_break] = ACTIONS(1492),
    [sym_true] = ACTIONS(1492),
    [sym_false] = ACTIONS(1492),
    [sym_null] = ACTIONS(1492),
    [sym_inf] = ACTIONS(1492),
    [sym_nan] = ACTIONS(1492),
    [anon_sym_NA] = ACTIONS(1492),
    [anon_sym_NA_integer_] = ACTIONS(1492),
    [anon_sym_NA_real_] = ACTIONS(1492),
    [anon_sym_NA_complex_] = ACTIONS(1492),
    [anon_sym_NA_character_] = ACTIONS(1492),
    [sym_dots] = ACTIONS(1492),
    [sym_dot_dot_i] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [sym_comma] = ACTIONS(1494),
    [sym__newline] = ACTIONS(1494),
    [sym__raw_string_literal] = ACTIONS(1494),
    [sym__external_open_parenthesis] = ACTIONS(1494),
    [sym__external_open_brace] = ACTIONS(1494),
    [sym__external_open_bracket] = ACTIONS(1494),
    [sym__external_open_bracket2] = ACTIONS(1494),
    [sym__external_close_bracket2] = ACTIONS(1494),
  },
  [1001] = {
    [sym_identifier] = ACTIONS(1480),
    [anon_sym_BSLASH] = ACTIONS(1482),
    [anon_sym_function] = ACTIONS(1480),
    [anon_sym_EQ] = ACTIONS(1480),
    [anon_sym_if] = ACTIONS(1480),
    [anon_sym_for] = ACTIONS(1480),
    [anon_sym_while] = ACTIONS(1480),
    [anon_sym_repeat] = ACTIONS(1480),
    [anon_sym_QMARK] = ACTIONS(1482),
    [anon_sym_TILDE] = ACTIONS(1482),
    [anon_sym_BANG] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1482),
    [anon_sym_DASH] = ACTIONS(1480),
    [anon_sym_LT_DASH] = ACTIONS(1482),
    [anon_sym_LT_LT_DASH] = ACTIONS(1482),
    [anon_sym_COLON_EQ] = ACTIONS(1482),
    [anon_sym_DASH_GT] = ACTIONS(1480),
    [anon_sym_DASH_GT_GT] = ACTIONS(1482),
    [anon_sym_PIPE] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1480),
    [anon_sym_PIPE_PIPE] = ACTIONS(1482),
    [anon_sym_AMP_AMP] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(1480),
    [anon_sym_LT_EQ] = ACTIONS(1482),
    [anon_sym_GT] = ACTIONS(1480),
    [anon_sym_GT_EQ] = ACTIONS(1482),
    [anon_sym_EQ_EQ] = ACTIONS(1482),
    [anon_sym_BANG_EQ] = ACTIONS(1482),
    [anon_sym_STAR] = ACTIONS(1480),
    [anon_sym_SLASH] = ACTIONS(1482),
    [anon_sym_STAR_STAR] = ACTIONS(1482),
    [anon_sym_CARET] = ACTIONS(1482),
    [aux_sym_binary_operator_token1] = ACTIONS(1482),
    [anon_sym_PIPE_GT] = ACTIONS(1482),
    [anon_sym_COLON] = ACTIONS(1480),
    [anon_sym_DOLLAR] = ACTIONS(1482),
    [anon_sym_AT] = ACTIONS(1482),
    [sym__hex_literal] = ACTIONS(1482),
    [sym__number_literal] = ACTIONS(1480),
    [anon_sym_SQUOTE] = ACTIONS(1482),
    [anon_sym_DQUOTE] = ACTIONS(1482),
    [sym_return] = ACTIONS(1480),
    [sym_next] = ACTIONS(1480),
    [sym_break] = ACTIONS(1480),
    [sym_true] = ACTIONS(1480),
    [sym_false] = ACTIONS(1480),
    [sym_null] = ACTIONS(1480),
    [sym_inf] = ACTIONS(1480),
    [sym_nan] = ACTIONS(1480),
    [anon_sym_NA] = ACTIONS(1480),
    [anon_sym_NA_integer_] = ACTIONS(1480),
    [anon_sym_NA_real_] = ACTIONS(1480),
    [anon_sym_NA_complex_] = ACTIONS(1480),
    [anon_sym_NA_character_] = ACTIONS(1480),
    [sym_dots] = ACTIONS(1480),
    [sym_dot_dot_i] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1482),
    [sym__semicolon] = ACTIONS(1482),
    [sym__raw_string_literal] = ACTIONS(1482),
    [sym__external_open_parenthesis] = ACTIONS(1482),
    [sym__external_open_brace] = ACTIONS(1482),
    [sym__external_close_brace] = ACTIONS(1482),
    [sym__external_open_bracket] = ACTIONS(1482),
    [sym__external_open_bracket2] = ACTIONS(1482),
  },
  [1002] = {
    [sym_function_definition] = STATE(631),
    [sym_if_statement] = STATE(631),
    [sym_for_statement] = STATE(631),
    [sym_while_statement] = STATE(631),
    [sym_repeat_statement] = STATE(631),
    [sym_braced_expression] = STATE(631),
    [sym_parenthesized_expression] = STATE(631),
    [sym_call] = STATE(631),
    [sym_subset] = STATE(631),
    [sym_subset2] = STATE(631),
    [sym_unary_operator] = STATE(631),
    [sym_binary_operator] = STATE(631),
    [sym_extract_operator] = STATE(631),
    [sym_namespace_operator] = STATE(631),
    [sym_integer] = STATE(631),
    [sym_complex] = STATE(631),
    [sym_float] = STATE(631),
    [sym__float_literal] = STATE(722),
    [sym_string] = STATE(739),
    [sym__single_quoted_string] = STATE(707),
    [sym__double_quoted_string] = STATE(708),
    [sym_na] = STATE(631),
    [sym__expression] = STATE(631),
    [sym__string_or_identifier] = STATE(2140),
    [sym__open_parenthesis] = STATE(907),
    [sym__close_parenthesis] = STATE(902),
    [sym__open_brace] = STATE(842),
    [aux_sym_parenthesized_expression_repeat1] = STATE(1003),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_BSLASH] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_repeat] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [sym__hex_literal] = ACTIONS(759),
    [sym__number_literal] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(765),
    [sym_return] = ACTIONS(1679),
    [sym_next] = ACTIONS(1679),
    [sym_break] = ACTIONS(1679),
    [sym_true] = ACTIONS(1679),
    [sym_false] = ACTIONS(1679),
    [sym_null] = ACTIONS(1679),
    [sym_inf] = ACTIONS(1679),
    [sym_nan] = ACTIONS(1679),
    [anon_sym_NA] = ACTIONS(769),
    [anon_sym_NA_integer_] = ACTIONS(769),
    [anon_sym_NA_real_] = ACTIONS(769),
    [anon_sym_NA_complex_] = ACTIONS(769),
    [anon_sym_NA_character_] = ACTIONS(769),
    [sym_dots] = ACTIONS(1679),
    [sym_dot_dot_i] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1683),
    [sym__raw_string_literal] = ACTIONS(779),
    [sym__external_open_parenthesis] = ACTIONS(781),
    [sym__external_close_parenthesis] = ACTIONS(1805),
    [sym__external_open_brace] = ACTIONS(785),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1807), 1,
      sym_identifier,
    ACTIONS(1810), 1,
      anon_sym_BSLASH,
    ACTIONS(1813), 1,
      anon_sym_function,
    ACTIONS(1816), 1,
      anon_sym_if,
    ACTIONS(1819), 1,
      anon_sym_for,
    ACTIONS(1822), 1,
      anon_sym_while,
    ACTIONS(1825), 1,
      anon_sym_repeat,
    ACTIONS(1828), 1,
      anon_sym_QMARK,
    ACTIONS(1831), 1,
      anon_sym_TILDE,
    ACTIONS(1834), 1,
      anon_sym_BANG,
    ACTIONS(1840), 1,
      sym__hex_literal,
    ACTIONS(1843), 1,
      sym__number_literal,
    ACTIONS(1846), 1,
      anon_sym_SQUOTE,
    ACTIONS(1849), 1,
      anon_sym_DQUOTE,
    ACTIONS(1858), 1,
      sym_dot_dot_i,
    ACTIONS(1861), 1,
      sym__newline,
    ACTIONS(1864), 1,
      sym__raw_string_literal,
    ACTIONS(1867), 1,
      sym__external_open_parenthesis,
    ACTIONS(1870), 1,
      sym__external_close_parenthesis,
    ACTIONS(1872), 1,
      sym__external_open_brace,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1003), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(1837), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1855), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1852), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(631), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [131] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(1877), 1,
      sym_dot_dot_i,
    ACTIONS(1879), 1,
      sym__newline,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1008), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1875), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(485), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [259] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(1883), 1,
      sym_dot_dot_i,
    ACTIONS(1885), 1,
      sym__newline,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1881), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(504), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [387] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1917), 1,
      sym_dot_dot_i,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1913), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(51), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [515] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(1925), 1,
      sym_dot_dot_i,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1923), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(52), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [643] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1929), 1,
      sym_dot_dot_i,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1927), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(505), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [771] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(1933), 1,
      sym_dot_dot_i,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1931), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(53), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [899] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(1937), 1,
      sym_dot_dot_i,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1935), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(54), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [1027] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(1941), 1,
      sym_dot_dot_i,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1939), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(55), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [1155] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1945), 1,
      sym_dot_dot_i,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1943), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(506), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [1283] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(1949), 1,
      sym_dot_dot_i,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1947), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(56), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [1411] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1953), 1,
      sym_dot_dot_i,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1951), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(628), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [1539] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(1957), 1,
      sym_dot_dot_i,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1955), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(57), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [1667] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(1961), 1,
      sym_dot_dot_i,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1959), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(58), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [1795] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1965), 1,
      sym_dot_dot_i,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1963), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(507), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [1923] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(1969), 1,
      sym_dot_dot_i,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(1967), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(59), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [2051] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2005), 1,
      sym_dot_dot_i,
    ACTIONS(2007), 1,
      sym__newline,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1026), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2001), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1903), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [2179] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2017), 1,
      sym_dot_dot_i,
    ACTIONS(2019), 1,
      sym__newline,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1027), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2015), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1802), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [2307] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2023), 1,
      sym_dot_dot_i,
    ACTIONS(2025), 1,
      sym__newline,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1028), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2021), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1854), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [2435] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2029), 1,
      sym_dot_dot_i,
    ACTIONS(2031), 1,
      sym__newline,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1029), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2027), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1900), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [2563] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2035), 1,
      sym_dot_dot_i,
    ACTIONS(2037), 1,
      sym__newline,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1030), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2033), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1788), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [2691] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(2041), 1,
      sym_dot_dot_i,
    ACTIONS(2043), 1,
      sym__newline,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1034), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2039), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(60), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [2819] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2047), 1,
      sym_dot_dot_i,
    ACTIONS(2049), 1,
      sym__newline,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1059), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2045), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1787), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [2947] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2053), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2051), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1868), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [3075] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2057), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2055), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1879), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [3203] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2061), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2059), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1889), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [3331] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2065), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2063), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1894), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [3459] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2069), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2067), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1895), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [3587] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2073), 1,
      sym_dot_dot_i,
    ACTIONS(2075), 1,
      sym__newline,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1076), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2071), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1848), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [3715] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2079), 1,
      sym_dot_dot_i,
    ACTIONS(2081), 1,
      sym__newline,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1077), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2077), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1906), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [3843] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2085), 1,
      sym_dot_dot_i,
    ACTIONS(2087), 1,
      sym__newline,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1078), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2083), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1840), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [3971] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(2091), 1,
      sym_dot_dot_i,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2089), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(61), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [4099] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(2095), 1,
      sym_dot_dot_i,
    ACTIONS(2097), 1,
      sym__newline,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1039), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2093), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(62), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [4227] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(2101), 1,
      sym_dot_dot_i,
    ACTIONS(2103), 1,
      sym__newline,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1042), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2099), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(64), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [4355] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2107), 1,
      sym_dot_dot_i,
    ACTIONS(2109), 1,
      sym__newline,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1080), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2105), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1852), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [4483] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2113), 1,
      sym_dot_dot_i,
    ACTIONS(2115), 1,
      sym__newline,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1081), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2111), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1901), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [4611] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(2119), 1,
      sym_dot_dot_i,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2117), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(65), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [4739] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2123), 1,
      sym_dot_dot_i,
    ACTIONS(2125), 1,
      sym__newline,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1082), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2121), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1784), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [4867] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2129), 1,
      sym_dot_dot_i,
    ACTIONS(2131), 1,
      sym__newline,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1083), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2127), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1843), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [4995] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(2135), 1,
      sym_dot_dot_i,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2133), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(68), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [5123] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(2139), 1,
      sym_dot_dot_i,
    ACTIONS(2141), 1,
      sym__newline,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1049), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2137), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(69), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [5251] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2145), 1,
      sym_dot_dot_i,
    ACTIONS(2147), 1,
      sym__newline,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1084), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2143), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1865), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [5379] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2151), 1,
      sym_dot_dot_i,
    ACTIONS(2153), 1,
      sym__newline,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1087), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2149), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1881), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [5507] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2157), 1,
      sym_dot_dot_i,
    ACTIONS(2159), 1,
      sym__newline,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1090), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2155), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1785), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [5635] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2163), 1,
      sym_dot_dot_i,
    ACTIONS(2165), 1,
      sym__newline,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1093), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2161), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1833), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [5763] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2169), 1,
      sym_dot_dot_i,
    ACTIONS(2171), 1,
      sym__newline,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1096), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2167), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1862), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [5891] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(2175), 1,
      sym_dot_dot_i,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2173), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(71), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [6019] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2179), 1,
      sym_dot_dot_i,
    ACTIONS(2181), 1,
      sym__newline,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1099), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2177), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1883), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [6147] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(2185), 1,
      sym_dot_dot_i,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2183), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(50), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [6275] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2217), 1,
      sym_dot_dot_i,
    ACTIONS(2219), 1,
      sym__newline,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1058), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2213), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(73), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [6403] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2227), 1,
      sym_dot_dot_i,
    ACTIONS(2229), 1,
      sym__newline,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1060), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2225), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(74), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [6531] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2233), 1,
      sym_dot_dot_i,
    ACTIONS(2235), 1,
      sym__newline,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1062), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2231), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(75), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [6659] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2239), 1,
      sym_dot_dot_i,
    ACTIONS(2241), 1,
      sym__newline,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1063), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2237), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(76), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [6787] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2245), 1,
      sym_dot_dot_i,
    ACTIONS(2247), 1,
      sym__newline,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1079), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2243), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(77), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [6915] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2251), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2249), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(78), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [7043] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2255), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2253), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(79), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [7171] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2259), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2257), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1794), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [7299] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2263), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2261), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(80), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [7427] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2267), 1,
      sym_dot_dot_i,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2265), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(509), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [7555] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2271), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2269), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(81), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [7683] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2275), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2273), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(82), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [7811] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2279), 1,
      sym_dot_dot_i,
    ACTIONS(2281), 1,
      sym__newline,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1085), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2277), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(83), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [7939] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2285), 1,
      sym_dot_dot_i,
    ACTIONS(2287), 1,
      sym__newline,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1088), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2283), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(85), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [8067] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2291), 1,
      sym_dot_dot_i,
    ACTIONS(2293), 1,
      sym__newline,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1089), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2289), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(86), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [8195] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2297), 1,
      sym_dot_dot_i,
    ACTIONS(2299), 1,
      sym__newline,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1091), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2295), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(87), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [8323] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2303), 1,
      sym_dot_dot_i,
    ACTIONS(2305), 1,
      sym__newline,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1092), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2301), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(88), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [8451] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2309), 1,
      sym_dot_dot_i,
    ACTIONS(2311), 1,
      sym__newline,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1094), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2307), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(89), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [8579] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2315), 1,
      sym_dot_dot_i,
    ACTIONS(2317), 1,
      sym__newline,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1095), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2313), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(90), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [8707] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2321), 1,
      sym_dot_dot_i,
    ACTIONS(2323), 1,
      sym__newline,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1097), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2319), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(91), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [8835] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2327), 1,
      sym_dot_dot_i,
    ACTIONS(2329), 1,
      sym__newline,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1098), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2325), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(92), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [8963] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2333), 1,
      sym_dot_dot_i,
    ACTIONS(2335), 1,
      sym__newline,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1100), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2331), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(93), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [9091] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2339), 1,
      sym_dot_dot_i,
    ACTIONS(2341), 1,
      sym__newline,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1101), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2337), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(94), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [9219] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2345), 1,
      sym_dot_dot_i,
    ACTIONS(2347), 1,
      sym__newline,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1102), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2343), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(95), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [9347] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2351), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2349), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1795), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [9475] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2355), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2353), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1796), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [9603] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2359), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2357), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1797), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [9731] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2363), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2361), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(96), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [9859] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2367), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2365), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1798), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [9987] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2371), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2369), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1801), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [10115] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2375), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2373), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1806), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [10243] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2379), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2377), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1807), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [10371] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2383), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2381), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1808), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [10499] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2387), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2385), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(97), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [10627] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2391), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2389), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(98), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [10755] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2395), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2393), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1811), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [10883] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2399), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2397), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(99), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [11011] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2403), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2401), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(100), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [11139] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2407), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2405), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1812), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [11267] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2411), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2409), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(101), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [11395] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2415), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2413), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(102), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [11523] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2419), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2417), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1816), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [11651] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2423), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2421), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(103), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [11779] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2427), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2425), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(104), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [11907] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2431), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2429), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1817), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [12035] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2435), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2433), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(105), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [12163] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2439), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2437), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(106), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [12291] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2443), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2441), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1819), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [12419] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2447), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2445), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(107), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [12547] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2451), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2449), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(108), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [12675] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2455), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2453), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(109), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [12803] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2459), 1,
      sym_dot_dot_i,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2457), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(510), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [12931] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2463), 1,
      sym_dot_dot_i,
    ACTIONS(2465), 1,
      sym__newline,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1109), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2461), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1827), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [13059] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2469), 1,
      sym_dot_dot_i,
    ACTIONS(2471), 1,
      sym__newline,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1106), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2467), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(110), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [13187] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2475), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2473), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(111), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [13315] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2479), 1,
      sym_dot_dot_i,
    ACTIONS(2481), 1,
      sym__newline,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1111), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2477), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(112), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [13443] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2485), 1,
      sym_dot_dot_i,
    ACTIONS(2487), 1,
      sym__newline,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1112), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2483), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(114), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [13571] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2491), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2489), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1853), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [13699] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2495), 1,
      sym_dot_dot_i,
    ACTIONS(2497), 1,
      sym__newline,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1115), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2493), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1861), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [13827] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2501), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2499), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(115), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [13955] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2505), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2503), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(118), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [14083] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2509), 1,
      sym_dot_dot_i,
    ACTIONS(2511), 1,
      sym__newline,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1116), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2507), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(119), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [14211] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2515), 1,
      sym_dot_dot_i,
    ACTIONS(2517), 1,
      sym__newline,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1122), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2513), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1873), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [14339] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2521), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2519), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1877), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [14467] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(2525), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2523), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(121), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [14595] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2557), 1,
      sym_dot_dot_i,
    ACTIONS(2559), 1,
      sym__newline,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1125), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2553), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(122), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [14723] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2567), 1,
      sym_dot_dot_i,
    ACTIONS(2569), 1,
      sym__newline,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1126), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2565), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(123), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [14851] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2573), 1,
      sym_dot_dot_i,
    ACTIONS(2575), 1,
      sym__newline,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1127), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2571), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(124), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [14979] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2579), 1,
      sym_dot_dot_i,
    ACTIONS(2581), 1,
      sym__newline,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1128), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2577), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(125), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [15107] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2585), 1,
      sym_dot_dot_i,
    ACTIONS(2587), 1,
      sym__newline,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1129), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2583), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(126), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [15235] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2591), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2589), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1805), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [15363] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2595), 1,
      sym_dot_dot_i,
    ACTIONS(2597), 1,
      sym__newline,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1130), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2593), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1844), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [15491] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2601), 1,
      sym_dot_dot_i,
    ACTIONS(2603), 1,
      sym__newline,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1150), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2599), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(127), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [15619] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2607), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2605), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(128), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [15747] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2611), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2609), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(129), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [15875] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2615), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2613), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(130), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [16003] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2619), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2617), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(131), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [16131] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2623), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2621), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(132), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [16259] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2627), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2625), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1874), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [16387] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(2631), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2633), 2,
      sym__external_close_parenthesis,
      sym_comma,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2629), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1851), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [16513] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2637), 1,
      sym_dot_dot_i,
    ACTIONS(2639), 1,
      sym__newline,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1156), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2635), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(133), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [16641] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2643), 1,
      sym_dot_dot_i,
    ACTIONS(2645), 1,
      sym__newline,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1159), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2641), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(135), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [16769] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2649), 1,
      sym_dot_dot_i,
    ACTIONS(2651), 1,
      sym__newline,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1161), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2647), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(136), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [16897] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2655), 1,
      sym_dot_dot_i,
    ACTIONS(2657), 1,
      sym__newline,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1162), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2653), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(137), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [17025] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2661), 1,
      sym_dot_dot_i,
    ACTIONS(2663), 1,
      sym__newline,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1163), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2659), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(138), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [17153] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2667), 1,
      sym_dot_dot_i,
    ACTIONS(2669), 1,
      sym__newline,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1164), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2665), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(139), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [17281] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2673), 1,
      sym_dot_dot_i,
    ACTIONS(2675), 1,
      sym__newline,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1165), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2671), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(140), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [17409] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2679), 1,
      sym_dot_dot_i,
    ACTIONS(2681), 1,
      sym__newline,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1167), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2677), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(141), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [17537] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2685), 1,
      sym_dot_dot_i,
    ACTIONS(2687), 1,
      sym__newline,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1169), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2683), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(142), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [17665] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2691), 1,
      sym_dot_dot_i,
    ACTIONS(2693), 1,
      sym__newline,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1171), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2689), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(143), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [17793] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2697), 1,
      sym_dot_dot_i,
    ACTIONS(2699), 1,
      sym__newline,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1173), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2695), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(144), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [17921] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2703), 1,
      sym_dot_dot_i,
    ACTIONS(2705), 1,
      sym__newline,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1175), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2701), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(145), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [18049] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(2709), 1,
      sym_dot_dot_i,
    ACTIONS(2711), 1,
      sym__newline,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1153), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2707), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(298), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [18177] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(2715), 1,
      sym_dot_dot_i,
    ACTIONS(2717), 1,
      sym__newline,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1154), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2713), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(299), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [18305] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(2721), 1,
      sym_dot_dot_i,
    ACTIONS(2723), 1,
      sym__newline,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1155), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2719), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(300), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [18433] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(2727), 1,
      sym_dot_dot_i,
    ACTIONS(2729), 1,
      sym__newline,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1157), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2725), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(301), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [18561] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(2733), 1,
      sym_dot_dot_i,
    ACTIONS(2735), 1,
      sym__newline,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1160), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2731), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(302), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [18689] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2739), 1,
      sym_dot_dot_i,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2737), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(511), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [18817] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2743), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2741), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(146), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [18945] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(2747), 1,
      sym_dot_dot_i,
    ACTIONS(2749), 1,
      sym__newline,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1188), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2745), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(303), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [19073] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(2753), 1,
      sym_dot_dot_i,
    ACTIONS(2755), 1,
      sym__newline,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1258), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2751), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(18), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [19201] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2759), 1,
      sym_dot_dot_i,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2757), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(304), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [19329] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2763), 1,
      sym_dot_dot_i,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2761), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(305), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [19457] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2767), 1,
      sym_dot_dot_i,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2765), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(306), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [19585] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2771), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2769), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(147), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [19713] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2775), 1,
      sym_dot_dot_i,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2773), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(307), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [19841] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2779), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2777), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(148), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [19969] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2783), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2781), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(149), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [20097] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2787), 1,
      sym_dot_dot_i,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2785), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(308), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [20225] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2791), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2789), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(150), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [20353] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2795), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2793), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(151), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [20481] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2799), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2797), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(152), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [20609] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2803), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2801), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(153), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [20737] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2807), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2805), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(154), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [20865] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(2811), 1,
      sym_dot_dot_i,
    ACTIONS(2813), 1,
      sym__newline,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1191), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2809), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(309), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [20993] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2817), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2815), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(155), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [21121] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(2821), 1,
      sym_dot_dot_i,
    ACTIONS(2823), 1,
      sym__newline,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1195), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2819), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(310), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [21249] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2827), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2825), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(156), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [21377] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(2831), 1,
      sym_dot_dot_i,
    ACTIONS(2833), 1,
      sym__newline,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1197), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2829), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(311), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [21505] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2837), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2835), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(157), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [21633] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(2841), 1,
      sym_dot_dot_i,
    ACTIONS(2843), 1,
      sym__newline,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1200), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2839), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(312), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [21761] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2847), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2845), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(158), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [21889] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(2851), 1,
      sym_dot_dot_i,
    ACTIONS(2853), 1,
      sym__newline,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1201), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2849), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(313), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [22017] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2857), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2855), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(159), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [22145] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(2861), 1,
      sym_dot_dot_i,
    ACTIONS(2863), 1,
      sym__newline,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1202), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2859), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(314), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [22273] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(2867), 1,
      sym_dot_dot_i,
    ACTIONS(2869), 1,
      sym__newline,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1204), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2865), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(315), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [22401] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(2873), 1,
      sym_dot_dot_i,
    ACTIONS(2875), 1,
      sym__newline,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1229), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2871), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(316), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [22529] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(2879), 1,
      sym_dot_dot_i,
    ACTIONS(2881), 1,
      sym__newline,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1243), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2877), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(317), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [22657] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(2885), 1,
      sym_dot_dot_i,
    ACTIONS(2887), 1,
      sym__newline,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1257), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2883), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(318), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [22785] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(2891), 1,
      sym_dot_dot_i,
    ACTIONS(2893), 1,
      sym__newline,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1259), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2889), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(319), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [22913] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(2897), 1,
      sym_dot_dot_i,
    ACTIONS(2899), 1,
      sym__newline,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1261), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2895), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(320), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [23041] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(2903), 1,
      sym_dot_dot_i,
    ACTIONS(2905), 1,
      sym__newline,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1264), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2901), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(321), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [23169] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(2909), 1,
      sym_dot_dot_i,
    ACTIONS(2911), 1,
      sym__newline,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1284), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2907), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(448), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [23297] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2915), 1,
      sym_dot_dot_i,
    ACTIONS(2917), 1,
      sym__newline,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1192), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2913), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(160), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [23425] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2921), 1,
      sym_dot_dot_i,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2919), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(408), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [23553] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(2925), 1,
      sym_dot_dot_i,
    ACTIONS(2927), 1,
      sym__newline,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1266), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2923), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(512), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [23681] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2931), 1,
      sym_dot_dot_i,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2929), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(324), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [23809] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2935), 1,
      sym_dot_dot_i,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2933), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(409), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [23937] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2939), 1,
      sym_dot_dot_i,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2937), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(433), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [24065] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2943), 1,
      sym_dot_dot_i,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2941), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(325), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [24193] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2947), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2945), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(161), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [24321] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2951), 1,
      sym_dot_dot_i,
    ACTIONS(2953), 1,
      sym__newline,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1196), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2949), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(162), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [24449] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2957), 1,
      sym_dot_dot_i,
    ACTIONS(2959), 1,
      sym__newline,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1198), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2955), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(164), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [24577] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2963), 1,
      sym_dot_dot_i,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2961), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(326), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [24705] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2967), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2965), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(165), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [24833] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2971), 1,
      sym_dot_dot_i,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2969), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(327), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [24961] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2975), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2973), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(168), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [25089] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2979), 1,
      sym_dot_dot_i,
    ACTIONS(2981), 1,
      sym__newline,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1203), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2977), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(169), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [25217] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2985), 1,
      sym_dot_dot_i,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2983), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(328), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [25345] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2989), 1,
      sym_dot_dot_i,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2987), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(329), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [25473] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2993), 1,
      sym_dot_dot_i,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2991), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(330), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [25601] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(2997), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2995), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(171), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [25729] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3001), 1,
      sym_dot_dot_i,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(2999), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(331), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [25857] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3037), 1,
      sym_dot_dot_i,
    ACTIONS(3039), 1,
      sym__newline,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1211), 1,
      aux_sym_function_definition_repeat1,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3033), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1754), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [25985] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3049), 1,
      sym_dot_dot_i,
    ACTIONS(3051), 1,
      sym__newline,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1212), 1,
      aux_sym_function_definition_repeat1,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3047), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1757), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [26113] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3055), 1,
      sym_dot_dot_i,
    ACTIONS(3057), 1,
      sym__newline,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1213), 1,
      aux_sym_function_definition_repeat1,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3053), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1742), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [26241] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3061), 1,
      sym_dot_dot_i,
    ACTIONS(3063), 1,
      sym__newline,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1214), 1,
      aux_sym_function_definition_repeat1,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3059), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1743), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [26369] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3067), 1,
      sym_dot_dot_i,
    ACTIONS(3069), 1,
      sym__newline,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1215), 1,
      aux_sym_function_definition_repeat1,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3065), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1759), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [26497] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3073), 1,
      sym_dot_dot_i,
    ACTIONS(3075), 1,
      sym__newline,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1228), 1,
      aux_sym_function_definition_repeat1,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3071), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1755), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [26625] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3079), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3077), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1777), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [26753] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3083), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3081), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1735), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [26881] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3087), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3085), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1738), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [27009] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3091), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3089), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1740), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [27137] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3095), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3093), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1741), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [27265] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3099), 1,
      sym_dot_dot_i,
    ACTIONS(3101), 1,
      sym__newline,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1230), 1,
      aux_sym_function_definition_repeat1,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3097), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1746), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [27393] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3105), 1,
      sym_dot_dot_i,
    ACTIONS(3107), 1,
      sym__newline,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1232), 1,
      aux_sym_function_definition_repeat1,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3103), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1750), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [27521] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3111), 1,
      sym_dot_dot_i,
    ACTIONS(3113), 1,
      sym__newline,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1233), 1,
      aux_sym_function_definition_repeat1,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3109), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1751), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [27649] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3117), 1,
      sym_dot_dot_i,
    ACTIONS(3119), 1,
      sym__newline,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1234), 1,
      aux_sym_function_definition_repeat1,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3115), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1752), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [27777] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3123), 1,
      sym_dot_dot_i,
    ACTIONS(3125), 1,
      sym__newline,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1235), 1,
      aux_sym_function_definition_repeat1,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3121), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1753), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [27905] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3129), 1,
      sym_dot_dot_i,
    ACTIONS(3131), 1,
      sym__newline,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1236), 1,
      aux_sym_function_definition_repeat1,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3127), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1733), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [28033] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3135), 1,
      sym_dot_dot_i,
    ACTIONS(3137), 1,
      sym__newline,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1237), 1,
      aux_sym_function_definition_repeat1,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3133), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1756), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [28161] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3141), 1,
      sym_dot_dot_i,
    ACTIONS(3143), 1,
      sym__newline,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1238), 1,
      aux_sym_function_definition_repeat1,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3139), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1783), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [28289] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3147), 1,
      sym_dot_dot_i,
    ACTIONS(3149), 1,
      sym__newline,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1239), 1,
      aux_sym_function_definition_repeat1,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3145), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1758), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [28417] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3153), 1,
      sym_dot_dot_i,
    ACTIONS(3155), 1,
      sym__newline,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1240), 1,
      aux_sym_function_definition_repeat1,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3151), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1760), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [28545] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3159), 1,
      sym_dot_dot_i,
    ACTIONS(3161), 1,
      sym__newline,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1241), 1,
      aux_sym_function_definition_repeat1,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3157), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1761), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [28673] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3165), 1,
      sym_dot_dot_i,
    ACTIONS(3167), 1,
      sym__newline,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1242), 1,
      aux_sym_function_definition_repeat1,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3163), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1762), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [28801] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3171), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3169), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1765), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [28929] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3175), 1,
      sym_dot_dot_i,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3173), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(332), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [29057] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3179), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3177), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1766), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [29185] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3183), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3181), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1767), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [29313] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3187), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3185), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1768), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [29441] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3191), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3189), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1769), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [29569] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3195), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3193), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1770), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [29697] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3199), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3197), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1771), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [29825] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3203), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3201), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1773), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [29953] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3207), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3205), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1774), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [30081] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3211), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3209), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1775), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [30209] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3215), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3213), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1776), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [30337] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3219), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3217), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1778), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [30465] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3223), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3221), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1779), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [30593] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3227), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3225), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1780), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [30721] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3231), 1,
      sym_dot_dot_i,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3229), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(333), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [30849] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3235), 1,
      sym_dot_dot_i,
    ACTIONS(3237), 1,
      sym__newline,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1245), 1,
      aux_sym_function_definition_repeat1,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3233), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1781), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [30977] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3241), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3239), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1744), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [31105] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3245), 1,
      sym_dot_dot_i,
    ACTIONS(3247), 1,
      sym__newline,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1248), 1,
      aux_sym_function_definition_repeat1,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3243), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1747), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [31233] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3251), 1,
      sym_dot_dot_i,
    ACTIONS(3253), 1,
      sym__newline,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1249), 1,
      aux_sym_function_definition_repeat1,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3249), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1745), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [31361] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3257), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3255), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1763), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [31489] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3261), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3259), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1782), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [31617] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3265), 1,
      sym_dot_dot_i,
    ACTIONS(3267), 1,
      sym__newline,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1251), 1,
      aux_sym_function_definition_repeat1,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3263), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1734), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [31745] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(3271), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3269), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1737), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [31873] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3303), 1,
      sym_dot_dot_i,
    ACTIONS(3305), 1,
      sym__newline,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1263), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3299), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(172), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [32001] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3313), 1,
      sym_dot_dot_i,
    ACTIONS(3315), 1,
      sym__newline,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1265), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3311), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(173), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [32129] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3319), 1,
      sym_dot_dot_i,
    ACTIONS(3321), 1,
      sym__newline,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1267), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3317), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(174), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [32257] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3325), 1,
      sym_dot_dot_i,
    ACTIONS(3327), 1,
      sym__newline,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1269), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3323), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(175), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [32385] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3331), 1,
      sym_dot_dot_i,
    ACTIONS(3333), 1,
      sym__newline,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1270), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3329), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(176), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [32513] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3337), 1,
      sym_dot_dot_i,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3335), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(334), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [32641] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(3341), 1,
      sym_dot_dot_i,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3339), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(4), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [32769] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3345), 1,
      sym_dot_dot_i,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3343), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(335), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [32897] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(3349), 1,
      sym_dot_dot_i,
    ACTIONS(3351), 1,
      sym__newline,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1291), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3347), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(34), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [33025] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3355), 1,
      sym_dot_dot_i,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3353), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(336), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [33153] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3359), 1,
      sym_dot_dot_i,
    ACTIONS(3361), 1,
      sym__newline,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1288), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3357), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(177), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [33281] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3365), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3363), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(291), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [33409] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3369), 1,
      sym_dot_dot_i,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3367), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(337), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [33537] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3373), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3371), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(179), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [33665] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3377), 1,
      sym_dot_dot_i,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3375), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(513), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [33793] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3381), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3379), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(180), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [33921] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(3385), 1,
      sym_dot_dot_i,
    ACTIONS(3387), 1,
      sym__newline,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1286), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3383), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(514), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [34049] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3391), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3389), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(181), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [34177] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3395), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3393), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(182), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [34305] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(3399), 1,
      sym_dot_dot_i,
    ACTIONS(3401), 1,
      sym__newline,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1289), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3397), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(517), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [34433] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3405), 1,
      sym_dot_dot_i,
    ACTIONS(3407), 1,
      sym__newline,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1295), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3403), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(183), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [34561] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3411), 1,
      sym_dot_dot_i,
    ACTIONS(3413), 1,
      sym__newline,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1298), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3409), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(185), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [34689] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3417), 1,
      sym_dot_dot_i,
    ACTIONS(3419), 1,
      sym__newline,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1300), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3415), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(186), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [34817] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3423), 1,
      sym_dot_dot_i,
    ACTIONS(3425), 1,
      sym__newline,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1302), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3421), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(187), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [34945] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3429), 1,
      sym_dot_dot_i,
    ACTIONS(3431), 1,
      sym__newline,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1304), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3427), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(188), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [35073] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3435), 1,
      sym_dot_dot_i,
    ACTIONS(3437), 1,
      sym__newline,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1306), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3433), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(189), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [35201] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3441), 1,
      sym_dot_dot_i,
    ACTIONS(3443), 1,
      sym__newline,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1308), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3439), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(190), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [35329] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3447), 1,
      sym_dot_dot_i,
    ACTIONS(3449), 1,
      sym__newline,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1310), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3445), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(191), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [35457] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3453), 1,
      sym_dot_dot_i,
    ACTIONS(3455), 1,
      sym__newline,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1311), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3451), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(192), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [35585] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3459), 1,
      sym_dot_dot_i,
    ACTIONS(3461), 1,
      sym__newline,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1313), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3457), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(193), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [35713] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3465), 1,
      sym_dot_dot_i,
    ACTIONS(3467), 1,
      sym__newline,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1315), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3463), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(194), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [35841] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3471), 1,
      sym_dot_dot_i,
    ACTIONS(3473), 1,
      sym__newline,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1317), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3469), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(195), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [35969] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3477), 1,
      sym_dot_dot_i,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3475), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(449), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [36097] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(3481), 1,
      sym_dot_dot_i,
    ACTIONS(3483), 1,
      sym__newline,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1297), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3479), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(450), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [36225] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3487), 1,
      sym_dot_dot_i,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3485), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(518), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [36353] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(3491), 1,
      sym_dot_dot_i,
    ACTIONS(3493), 1,
      sym__newline,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1307), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3489), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(338), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [36481] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3497), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3495), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(196), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [36609] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3501), 1,
      sym_dot_dot_i,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3499), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(524), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [36737] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(3505), 1,
      sym_dot_dot_i,
    ACTIONS(3507), 1,
      sym__newline,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1294), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3503), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(525), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [36865] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(3511), 1,
      sym_dot_dot_i,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3509), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(3), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [36993] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(3515), 1,
      sym_dot_dot_i,
    ACTIONS(3517), 1,
      sym__newline,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1320), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3513), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(455), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [37121] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3521), 1,
      sym_dot_dot_i,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3519), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(410), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [37249] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3525), 1,
      sym_dot_dot_i,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3523), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(527), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [37377] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3529), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3527), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(197), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [37505] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3533), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3531), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(198), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [37633] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3537), 1,
      sym_dot_dot_i,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3535), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(456), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [37761] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3541), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3539), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(199), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [37889] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3545), 1,
      sym_dot_dot_i,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3543), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(411), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [38017] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3549), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3547), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(200), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [38145] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(3553), 1,
      sym_dot_dot_i,
    ACTIONS(3555), 1,
      sym__newline,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1326), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3551), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(528), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [38273] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3559), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3557), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(201), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [38401] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(3563), 1,
      sym_dot_dot_i,
    ACTIONS(3565), 1,
      sym__newline,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1327), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3561), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(529), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [38529] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3569), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3567), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(202), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [38657] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(3573), 1,
      sym_dot_dot_i,
    ACTIONS(3575), 1,
      sym__newline,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1329), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3571), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(530), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [38785] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3579), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3577), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(203), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [38913] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3583), 1,
      sym_dot_dot_i,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3581), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(339), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [39041] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3587), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3585), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(204), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [39169] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(3591), 1,
      sym_dot_dot_i,
    ACTIONS(3593), 1,
      sym__newline,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1318), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3589), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(340), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [39297] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3597), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3595), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(205), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [39425] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3601), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3599), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(206), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [39553] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(3605), 1,
      sym_dot_dot_i,
    ACTIONS(3607), 1,
      sym__newline,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1335), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3603), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(531), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [39681] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3611), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3609), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(207), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [39809] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(3615), 1,
      sym_dot_dot_i,
    ACTIONS(3617), 1,
      sym__newline,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1336), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3613), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(532), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [39937] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3621), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3619), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(208), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [40065] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(3625), 1,
      sym_dot_dot_i,
    ACTIONS(3627), 1,
      sym__newline,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1321), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3623), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(342), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [40193] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3631), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3629), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(209), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [40321] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3635), 1,
      sym_dot_dot_i,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3633), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(343), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [40449] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3639), 1,
      sym_dot_dot_i,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3637), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(412), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [40577] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3643), 1,
      sym_dot_dot_i,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3641), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(459), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [40705] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3647), 1,
      sym_dot_dot_i,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3645), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(346), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [40833] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(3651), 1,
      sym_dot_dot_i,
    ACTIONS(3653), 1,
      sym__newline,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1328), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3649), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(347), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [40961] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(3657), 1,
      sym_dot_dot_i,
    ACTIONS(3659), 1,
      sym__newline,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1414), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3655), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(533), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [41089] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3663), 1,
      sym_dot_dot_i,
    ACTIONS(3665), 1,
      sym__newline,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1337), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3661), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(210), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [41217] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(3669), 1,
      sym_dot_dot_i,
    ACTIONS(3671), 1,
      sym__newline,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1343), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3667), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(460), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [41345] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3675), 1,
      sym_dot_dot_i,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3673), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(535), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [41473] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3679), 1,
      sym_dot_dot_i,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3677), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(536), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [41601] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3683), 1,
      sym_dot_dot_i,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3681), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(349), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [41729] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3687), 1,
      sym_dot_dot_i,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3685), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(537), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [41857] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(3691), 1,
      sym_dot_dot_i,
    ACTIONS(3693), 1,
      sym__newline,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1344), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3689), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(350), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [41985] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(3697), 1,
      sym_dot_dot_i,
    ACTIONS(3699), 1,
      sym__newline,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1347), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3695), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(351), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [42113] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(3703), 1,
      sym_dot_dot_i,
    ACTIONS(3705), 1,
      sym__newline,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1349), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3701), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(352), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [42241] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(3709), 1,
      sym_dot_dot_i,
    ACTIONS(3711), 1,
      sym__newline,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1352), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3707), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(353), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [42369] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(3715), 1,
      sym_dot_dot_i,
    ACTIONS(3717), 1,
      sym__newline,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1354), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3713), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(354), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [42497] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3721), 1,
      sym_dot_dot_i,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3719), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(538), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [42625] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3725), 1,
      sym_dot_dot_i,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3723), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(539), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [42753] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3729), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3727), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(211), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [42881] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3733), 1,
      sym_dot_dot_i,
    ACTIONS(3735), 1,
      sym__newline,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1342), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3731), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(212), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [43009] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3739), 1,
      sym_dot_dot_i,
    ACTIONS(3741), 1,
      sym__newline,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1345), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3737), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(214), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [43137] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3745), 1,
      sym_dot_dot_i,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3743), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(434), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [43265] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(3749), 1,
      sym_dot_dot_i,
    ACTIONS(3751), 1,
      sym__newline,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1404), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3747), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(355), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [43393] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3755), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3753), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(215), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [43521] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3759), 1,
      sym_dot_dot_i,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3757), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(462), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [43649] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3763), 1,
      sym_dot_dot_i,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3761), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(356), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [43777] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3767), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3765), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(218), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [43905] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3771), 1,
      sym_dot_dot_i,
    ACTIONS(3773), 1,
      sym__newline,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1351), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3769), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(219), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [44033] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3777), 1,
      sym_dot_dot_i,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3775), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(357), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [44161] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(3781), 1,
      sym_dot_dot_i,
    ACTIONS(3783), 1,
      sym__newline,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1441), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3779), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(540), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [44289] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3787), 1,
      sym_dot_dot_i,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3785), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(358), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [44417] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(3791), 1,
      sym_dot_dot_i,
    ACTIONS(3793), 1,
      sym__newline,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1446), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3789), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(541), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [44545] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(3797), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3795), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(221), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [44673] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3801), 1,
      sym_dot_dot_i,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3799), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(359), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [44801] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(3805), 1,
      sym_dot_dot_i,
    ACTIONS(3807), 1,
      sym__newline,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1450), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3803), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(542), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [44929] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3811), 1,
      sym_dot_dot_i,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3809), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(360), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [45057] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3843), 1,
      sym_dot_dot_i,
    ACTIONS(3845), 1,
      sym__newline,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1367), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3839), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(222), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [45185] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(3853), 1,
      sym_dot_dot_i,
    ACTIONS(3855), 1,
      sym__newline,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1369), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3851), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(223), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [45313] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(3859), 1,
      sym_dot_dot_i,
    ACTIONS(3861), 1,
      sym__newline,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1371), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3857), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(224), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [45441] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(3865), 1,
      sym_dot_dot_i,
    ACTIONS(3867), 1,
      sym__newline,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1373), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3863), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(225), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [45569] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(3871), 1,
      sym_dot_dot_i,
    ACTIONS(3873), 1,
      sym__newline,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1375), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3869), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(226), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [45697] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(3877), 1,
      sym_dot_dot_i,
    ACTIONS(3879), 1,
      sym__newline,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1452), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3875), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(543), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [45825] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(3883), 1,
      sym_dot_dot_i,
    ACTIONS(3885), 1,
      sym__newline,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1454), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3881), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(544), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [45953] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(3889), 1,
      sym_dot_dot_i,
    ACTIONS(3891), 1,
      sym__newline,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1456), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3887), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(545), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [46081] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(3895), 1,
      sym_dot_dot_i,
    ACTIONS(3897), 1,
      sym__newline,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1458), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3893), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(546), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [46209] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(3901), 1,
      sym_dot_dot_i,
    ACTIONS(3903), 1,
      sym__newline,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1418), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3899), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(361), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [46337] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(3907), 1,
      sym_dot_dot_i,
    ACTIONS(3909), 1,
      sym__newline,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1401), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3905), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(227), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [46465] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(3913), 1,
      sym_dot_dot_i,
    ACTIONS(3915), 1,
      sym__newline,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1421), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3911), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(362), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [46593] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(3919), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3917), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(228), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [46721] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(3923), 1,
      sym_dot_dot_i,
    ACTIONS(3925), 1,
      sym__newline,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1425), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3921), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(363), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [46849] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(3929), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3927), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(229), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [46977] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(3933), 1,
      sym_dot_dot_i,
    ACTIONS(3935), 1,
      sym__newline,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1429), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3931), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(364), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [47105] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(3939), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3937), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(230), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [47233] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(3943), 1,
      sym_dot_dot_i,
    ACTIONS(3945), 1,
      sym__newline,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1432), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3941), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(365), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [47361] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(3949), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3947), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(231), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [47489] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(3953), 1,
      sym_dot_dot_i,
    ACTIONS(3955), 1,
      sym__newline,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1434), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3951), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(366), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [47617] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(3959), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3957), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(232), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [47745] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(3963), 1,
      sym_dot_dot_i,
    ACTIONS(3965), 1,
      sym__newline,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1436), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3961), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(367), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [47873] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(3969), 1,
      sym_dot_dot_i,
    ACTIONS(3971), 1,
      sym__newline,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1438), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3967), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(368), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [48001] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(3975), 1,
      sym_dot_dot_i,
    ACTIONS(3977), 1,
      sym__newline,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1440), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3973), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(369), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [48129] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(3981), 1,
      sym_dot_dot_i,
    ACTIONS(3983), 1,
      sym__newline,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1443), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3979), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(370), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [48257] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(3987), 1,
      sym_dot_dot_i,
    ACTIONS(3989), 1,
      sym__newline,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1408), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3985), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(233), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [48385] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(3993), 1,
      sym_dot_dot_i,
    ACTIONS(3995), 1,
      sym__newline,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1412), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3991), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(235), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [48513] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(3999), 1,
      sym_dot_dot_i,
    ACTIONS(4001), 1,
      sym__newline,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1413), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(3997), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(236), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [48641] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4005), 1,
      sym_dot_dot_i,
    ACTIONS(4007), 1,
      sym__newline,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1415), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4003), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(237), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [48769] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4011), 1,
      sym_dot_dot_i,
    ACTIONS(4013), 1,
      sym__newline,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1417), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4009), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(238), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [48897] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4017), 1,
      sym_dot_dot_i,
    ACTIONS(4019), 1,
      sym__newline,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1419), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4015), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(239), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [49025] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4023), 1,
      sym_dot_dot_i,
    ACTIONS(4025), 1,
      sym__newline,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1420), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4021), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(240), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [49153] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4029), 1,
      sym_dot_dot_i,
    ACTIONS(4031), 1,
      sym__newline,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1422), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4027), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(241), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [49281] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4035), 1,
      sym_dot_dot_i,
    ACTIONS(4037), 1,
      sym__newline,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1424), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4033), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(242), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [49409] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4041), 1,
      sym_dot_dot_i,
    ACTIONS(4043), 1,
      sym__newline,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1426), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4039), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(243), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [49537] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4047), 1,
      sym_dot_dot_i,
    ACTIONS(4049), 1,
      sym__newline,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1428), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4045), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(244), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [49665] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4053), 1,
      sym_dot_dot_i,
    ACTIONS(4055), 1,
      sym__newline,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1430), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4051), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(245), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [49793] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(4059), 1,
      sym_dot_dot_i,
    ACTIONS(4061), 1,
      sym__newline,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1445), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4057), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(371), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [49921] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(4065), 1,
      sym_dot_dot_i,
    ACTIONS(4067), 1,
      sym__newline,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1447), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4063), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(372), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [50049] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(4071), 1,
      sym_dot_dot_i,
    ACTIONS(4073), 1,
      sym__newline,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1449), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4069), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(373), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [50177] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(4077), 1,
      sym_dot_dot_i,
    ACTIONS(4079), 1,
      sym__newline,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1460), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4075), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(547), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [50305] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(4083), 1,
      sym_dot_dot_i,
    ACTIONS(4085), 1,
      sym__newline,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1467), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4081), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(548), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [50433] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(4089), 1,
      sym_dot_dot_i,
    ACTIONS(4091), 1,
      sym__newline,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1471), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4087), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(549), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [50561] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(4095), 1,
      sym_dot_dot_i,
    ACTIONS(4097), 1,
      sym__newline,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1473), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4093), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(550), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [50689] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(4101), 1,
      sym_dot_dot_i,
    ACTIONS(4103), 1,
      sym__newline,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1475), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4099), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(551), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [50817] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(4107), 1,
      sym_dot_dot_i,
    ACTIONS(4109), 1,
      sym__newline,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1478), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4105), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(555), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [50945] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4113), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4111), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(246), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [51073] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4117), 1,
      sym_dot_dot_i,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4115), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(435), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [51201] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(4121), 1,
      sym_dot_dot_i,
    ACTIONS(4123), 1,
      sym__newline,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1433), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4119), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(463), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [51329] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4127), 1,
      sym_dot_dot_i,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4125), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(376), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [51457] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(4131), 1,
      sym_dot_dot_i,
    ACTIONS(4133), 1,
      sym__newline,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1437), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4129), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(464), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [51585] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(4137), 1,
      sym_dot_dot_i,
    ACTIONS(4139), 1,
      sym__newline,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1444), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4135), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(465), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [51713] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_dot_dot_i,
    ACTIONS(4145), 1,
      sym__newline,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1451), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4141), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(466), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [51841] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4149), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4147), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(247), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [51969] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(4153), 1,
      sym_dot_dot_i,
    ACTIONS(4155), 1,
      sym__newline,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1455), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4151), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(467), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [52097] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4159), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4157), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(248), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [52225] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4163), 1,
      sym_dot_dot_i,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4161), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(436), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [52353] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4167), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4165), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(249), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [52481] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4171), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4169), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(250), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [52609] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4175), 1,
      sym_dot_dot_i,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4173), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(559), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [52737] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4179), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4177), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(251), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [52865] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4183), 1,
      sym_dot_dot_i,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4181), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(437), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [52993] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4187), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4185), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(252), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [53121] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4191), 1,
      sym_dot_dot_i,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4189), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(377), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [53249] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4195), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4193), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(253), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [53377] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4199), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4197), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(254), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [53505] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4203), 1,
      sym_dot_dot_i,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4201), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(378), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [53633] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4207), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4205), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(255), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [53761] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4211), 1,
      sym_dot_dot_i,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4209), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(438), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [53889] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4215), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4213), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(256), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [54017] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4219), 1,
      sym_dot_dot_i,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4217), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(379), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [54145] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4223), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4221), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(257), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [54273] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      sym_dot_dot_i,
    ACTIONS(4229), 1,
      sym__newline,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1523), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4225), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(469), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [54401] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4233), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4231), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(258), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [54529] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4237), 1,
      sym_dot_dot_i,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4235), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(380), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [54657] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4241), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4239), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(259), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [54785] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(4245), 1,
      sym_dot_dot_i,
    ACTIONS(4247), 1,
      sym__newline,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1186), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4243), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(516), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [54913] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4251), 1,
      sym_dot_dot_i,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4249), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(381), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [55041] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4255), 1,
      sym_dot_dot_i,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4253), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(470), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [55169] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4259), 1,
      sym_dot_dot_i,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4257), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(382), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [55297] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4263), 1,
      sym_dot_dot_i,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4261), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(439), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [55425] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4267), 1,
      sym_dot_dot_i,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4265), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(383), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [55553] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4271), 1,
      sym_dot_dot_i,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4269), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(471), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [55681] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4275), 1,
      sym_dot_dot_i,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4273), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(384), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [55809] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(4279), 1,
      sym_dot_dot_i,
    ACTIONS(4281), 1,
      sym__newline,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1189), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4277), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(577), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [55937] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4285), 1,
      sym_dot_dot_i,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4283), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(385), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [56065] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4289), 1,
      sym_dot_dot_i,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4287), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(560), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [56193] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4293), 1,
      sym_dot_dot_i,
    ACTIONS(4295), 1,
      sym__newline,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1461), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4291), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(260), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [56321] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4299), 1,
      sym_dot_dot_i,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4297), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(386), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [56449] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4303), 1,
      sym_dot_dot_i,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4301), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(472), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [56577] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4307), 1,
      sym_dot_dot_i,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4305), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(387), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [56705] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4311), 1,
      sym_dot_dot_i,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4309), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(561), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [56833] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4315), 1,
      sym_dot_dot_i,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4313), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(388), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [56961] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4319), 1,
      sym_dot_dot_i,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4317), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(441), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [57089] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4323), 1,
      sym_dot_dot_i,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4321), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(389), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [57217] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4327), 1,
      sym_dot_dot_i,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4325), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(562), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [57345] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4331), 1,
      sym_dot_dot_i,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4329), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(473), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [57473] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4335), 1,
      sym_dot_dot_i,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4333), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(563), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [57601] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(4339), 1,
      sym_dot_dot_i,
    ACTIONS(4341), 1,
      sym__newline,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1340), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4337), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(413), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [57729] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4345), 1,
      sym_dot_dot_i,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4343), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(564), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [57857] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4349), 1,
      sym_dot_dot_i,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4347), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(474), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [57985] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4353), 1,
      sym_dot_dot_i,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4351), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(565), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [58113] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4357), 1,
      sym_dot_dot_i,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4355), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(442), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [58241] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4361), 1,
      sym_dot_dot_i,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4359), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(566), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [58369] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(4365), 1,
      sym_dot_dot_i,
    ACTIONS(4367), 1,
      sym__newline,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1402), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4363), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(414), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [58497] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4371), 1,
      sym_dot_dot_i,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4369), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(567), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [58625] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4375), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4373), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(261), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [58753] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4379), 1,
      sym_dot_dot_i,
    ACTIONS(4381), 1,
      sym__newline,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1466), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4377), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(262), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [58881] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4385), 1,
      sym_dot_dot_i,
    ACTIONS(4387), 1,
      sym__newline,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1469), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4383), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(264), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [59009] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(4391), 1,
      sym_dot_dot_i,
    ACTIONS(4393), 1,
      sym__newline,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1486), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4389), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(390), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [59137] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4397), 1,
      sym_dot_dot_i,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4395), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(443), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [59265] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4401), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4399), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(265), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [59393] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4405), 1,
      sym_dot_dot_i,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4403), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(568), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [59521] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(4409), 1,
      sym_dot_dot_i,
    ACTIONS(4411), 1,
      sym__newline,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1411), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4407), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(415), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [59649] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4415), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4413), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(268), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [59777] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4419), 1,
      sym_dot_dot_i,
    ACTIONS(4421), 1,
      sym__newline,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1476), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4417), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(269), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [59905] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4425), 1,
      sym_dot_dot_i,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4423), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(569), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [60033] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(4429), 1,
      sym_dot_dot_i,
    ACTIONS(4431), 1,
      sym__newline,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1541), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4427), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(475), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [60161] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4435), 1,
      sym_dot_dot_i,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4433), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(570), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [60289] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(4439), 1,
      sym_dot_dot_i,
    ACTIONS(4441), 1,
      sym__newline,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1563), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4437), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(476), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [60417] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4445), 1,
      sym_dot_dot_i,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4443), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(574), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [60545] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4449), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4447), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(271), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [60673] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(4453), 1,
      sym_dot_dot_i,
    ACTIONS(4455), 1,
      sym__newline,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1564), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4451), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(477), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [60801] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4459), 1,
      sym_dot_dot_i,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4457), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(575), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [60929] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(4463), 1,
      sym_dot_dot_i,
    ACTIONS(4465), 1,
      sym__newline,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1573), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4461), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(478), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [61057] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(4469), 1,
      sym_dot_dot_i,
    ACTIONS(4471), 1,
      sym__newline,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1580), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4467), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(479), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [61185] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(4475), 1,
      sym_dot_dot_i,
    ACTIONS(4477), 1,
      sym__newline,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1587), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4473), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(480), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [61313] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(4481), 1,
      sym_dot_dot_i,
    ACTIONS(4483), 1,
      sym__newline,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1005), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4479), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(481), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [61441] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(4487), 1,
      sym_dot_dot_i,
    ACTIONS(4489), 1,
      sym__newline,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1484), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4485), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(5), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [61569] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(4493), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4491), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(6), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [61697] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(4497), 1,
      sym_dot_dot_i,
    ACTIONS(4499), 1,
      sym__newline,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1487), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4495), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(7), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [61825] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4503), 1,
      sym_dot_dot_i,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4501), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(391), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [61953] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(4507), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4505), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(8), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [62081] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(4511), 1,
      sym_dot_dot_i,
    ACTIONS(4513), 1,
      sym__newline,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1493), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4509), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(392), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [62209] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4517), 1,
      sym_dot_dot_i,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4515), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(444), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [62337] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(4521), 1,
      sym_dot_dot_i,
    ACTIONS(4523), 1,
      sym__newline,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1497), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4519), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(394), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [62465] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(4527), 1,
      sym_dot_dot_i,
    ACTIONS(4529), 1,
      sym__newline,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1012), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4525), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(486), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [62593] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(4533), 1,
      sym_dot_dot_i,
    ACTIONS(4535), 1,
      sym__newline,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1017), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4531), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(487), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [62721] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4539), 1,
      sym_dot_dot_i,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4537), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(395), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [62849] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(4543), 1,
      sym_dot_dot_i,
    ACTIONS(4545), 1,
      sym__newline,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1061), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4541), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(488), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [62977] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(4549), 1,
      sym_dot_dot_i,
    ACTIONS(4551), 1,
      sym__newline,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1103), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4547), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(489), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [63105] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(4555), 1,
      sym_dot_dot_i,
    ACTIONS(4557), 1,
      sym__newline,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1149), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4553), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(490), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [63233] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4561), 1,
      sym_dot_dot_i,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4559), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(398), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [63361] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(4565), 1,
      sym_dot_dot_i,
    ACTIONS(4567), 1,
      sym__newline,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1504), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4563), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(399), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [63489] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(4571), 1,
      sym_dot_dot_i,
    ACTIONS(4573), 1,
      sym__newline,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1416), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4569), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(416), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [63617] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4577), 1,
      sym_dot_dot_i,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4575), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(445), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [63745] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(4581), 1,
      sym_dot_dot_i,
    ACTIONS(4583), 1,
      sym__newline,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1423), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4579), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(417), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [63873] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4587), 1,
      sym_dot_dot_i,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4585), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(446), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [64001] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(4591), 1,
      sym_dot_dot_i,
    ACTIONS(4593), 1,
      sym__newline,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1569), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4589), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(578), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [64129] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4597), 1,
      sym_dot_dot_i,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4595), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(401), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [64257] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(4601), 1,
      sym_dot_dot_i,
    ACTIONS(4603), 1,
      sym__newline,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1435), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4599), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(421), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [64385] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4607), 1,
      sym_dot_dot_i,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4605), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(447), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [64513] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(4611), 1,
      sym_dot_dot_i,
    ACTIONS(4613), 1,
      sym__newline,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1508), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4609), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(9), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [64641] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(4617), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4615), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(10), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [64769] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(4621), 1,
      sym_dot_dot_i,
    ACTIONS(4623), 1,
      sym__newline,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1510), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4619), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(11), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [64897] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(4627), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4625), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(12), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [65025] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(4631), 1,
      sym_dot_dot_i,
    ACTIONS(4633), 1,
      sym__newline,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1448), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4629), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(422), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [65153] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(4637), 1,
      sym_dot_dot_i,
    ACTIONS(4639), 1,
      sym__newline,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1526), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4635), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(267), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [65281] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(4643), 1,
      sym_dot_dot_i,
    ACTIONS(4645), 1,
      sym__newline,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1531), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4641), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(272), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [65409] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(4649), 1,
      sym_dot_dot_i,
    ACTIONS(4651), 1,
      sym__newline,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1532), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4647), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(273), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [65537] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(4655), 1,
      sym_dot_dot_i,
    ACTIONS(4657), 1,
      sym__newline,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1533), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4653), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(274), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [65665] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(4661), 1,
      sym_dot_dot_i,
    ACTIONS(4663), 1,
      sym__newline,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1538), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4659), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(275), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [65793] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(4667), 1,
      sym_dot_dot_i,
    ACTIONS(4669), 1,
      sym__newline,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1457), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4665), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(423), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [65921] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(4673), 1,
      sym_dot_dot_i,
    ACTIONS(4675), 1,
      sym__newline,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1519), 1,
      aux_sym_function_definition_repeat1,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4671), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1728), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [66049] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(4679), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4677), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1731), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [66177] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(4683), 1,
      sym_dot_dot_i,
    ACTIONS(4685), 1,
      sym__newline,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1521), 1,
      aux_sym_function_definition_repeat1,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4681), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1732), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [66305] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(4689), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4687), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1724), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [66433] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(4693), 1,
      sym_dot_dot_i,
    ACTIONS(4695), 1,
      sym__newline,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1465), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4691), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(424), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [66561] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4699), 1,
      sym_dot_dot_i,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4697), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(495), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [66689] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(4703), 1,
      sym_dot_dot_i,
    ACTIONS(4705), 1,
      sym__newline,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1572), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4701), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(276), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [66817] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(4709), 1,
      sym_dot_dot_i,
    ACTIONS(4711), 1,
      sym__newline,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1489), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4707), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(425), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [66945] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(4715), 1,
      sym_dot_dot_i,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4713), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(277), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [67073] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(4719), 1,
      sym_dot_dot_i,
    ACTIONS(4721), 1,
      sym__newline,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1528), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4717), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(13), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [67201] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(4725), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4723), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(14), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [67329] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(4729), 1,
      sym_dot_dot_i,
    ACTIONS(4731), 1,
      sym__newline,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1530), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4727), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(15), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [67457] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(4735), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4733), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(16), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [67585] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(4739), 1,
      sym_dot_dot_i,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4737), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(278), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [67713] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(4743), 1,
      sym_dot_dot_i,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4741), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(279), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [67841] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(4747), 1,
      sym_dot_dot_i,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4745), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(280), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [67969] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4751), 1,
      sym_dot_dot_i,
    ACTIONS(4753), 1,
      sym__newline,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1535), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4749), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(17), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [68097] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4757), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4755), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(41), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [68225] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4761), 1,
      sym_dot_dot_i,
    ACTIONS(4763), 1,
      sym__newline,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1537), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4759), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(19), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [68353] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(4767), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4765), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(20), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [68481] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(4771), 1,
      sym_dot_dot_i,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4769), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(281), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [68609] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(4775), 1,
      sym_dot_dot_i,
    ACTIONS(4777), 1,
      sym__newline,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1500), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4773), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(426), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [68737] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(4781), 1,
      sym_dot_dot_i,
    ACTIONS(4783), 1,
      sym__newline,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1502), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4779), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(427), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [68865] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4787), 1,
      sym_dot_dot_i,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4785), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(496), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [68993] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(4791), 1,
      sym_dot_dot_i,
    ACTIONS(4793), 1,
      sym__newline,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1588), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4789), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(282), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [69121] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(4797), 1,
      sym_dot_dot_i,
    ACTIONS(4799), 1,
      sym__newline,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1592), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4795), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(284), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [69249] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(4803), 1,
      sym_dot_dot_i,
    ACTIONS(4805), 1,
      sym__newline,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1545), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4801), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(26), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [69377] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(4809), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4807), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(27), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [69505] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(4813), 1,
      sym_dot_dot_i,
    ACTIONS(4815), 1,
      sym__newline,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1547), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4811), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(28), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [69633] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(4819), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4817), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(29), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [69761] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(4823), 1,
      sym_dot_dot_i,
    ACTIONS(4825), 1,
      sym__newline,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1051), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4821), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(285), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [69889] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(4829), 1,
      sym_dot_dot_i,
    ACTIONS(4831), 1,
      sym__newline,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1006), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4827), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(286), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [70017] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(4835), 1,
      sym_dot_dot_i,
    ACTIONS(4837), 1,
      sym__newline,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1007), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4833), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(287), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [70145] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(4841), 1,
      sym_dot_dot_i,
    ACTIONS(4843), 1,
      sym__newline,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1009), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4839), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(288), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [70273] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(4847), 1,
      sym_dot_dot_i,
    ACTIONS(4849), 1,
      sym__newline,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1010), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4845), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(289), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [70401] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(4853), 1,
      sym_dot_dot_i,
    ACTIONS(4855), 1,
      sym__newline,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1011), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4851), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(290), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [70529] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(4859), 1,
      sym_dot_dot_i,
    ACTIONS(4861), 1,
      sym__newline,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1013), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4857), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(178), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [70657] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(4865), 1,
      sym_dot_dot_i,
    ACTIONS(4867), 1,
      sym__newline,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1556), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4863), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(30), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [70785] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(4871), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4869), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(31), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [70913] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(4875), 1,
      sym_dot_dot_i,
    ACTIONS(4877), 1,
      sym__newline,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1558), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4873), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(32), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [71041] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(4881), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4879), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(33), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [71169] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(4885), 1,
      sym_dot_dot_i,
    ACTIONS(4887), 1,
      sym__newline,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1015), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4883), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(43), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [71297] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(4891), 1,
      sym_dot_dot_i,
    ACTIONS(4893), 1,
      sym__newline,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1016), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4889), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(44), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [71425] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(4897), 1,
      sym_dot_dot_i,
    ACTIONS(4899), 1,
      sym__newline,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1018), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4895), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(45), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [71553] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(4903), 1,
      sym_dot_dot_i,
    ACTIONS(4905), 1,
      sym__newline,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1506), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4901), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(428), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [71681] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4909), 1,
      sym_dot_dot_i,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4907), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(497), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [71809] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4913), 1,
      sym_dot_dot_i,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4911), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(498), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [71937] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(4917), 1,
      sym_dot_dot_i,
    ACTIONS(4919), 1,
      sym__newline,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1566), 1,
      aux_sym_function_definition_repeat1,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4915), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1726), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [72065] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(4923), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4921), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1730), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [72193] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(4927), 1,
      sym_dot_dot_i,
    ACTIONS(4929), 1,
      sym__newline,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1568), 1,
      aux_sym_function_definition_repeat1,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4925), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1725), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [72321] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(4933), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4931), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1727), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [72449] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4937), 1,
      sym_dot_dot_i,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4935), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(581), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [72577] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(4941), 1,
      sym_dot_dot_i,
    ACTIONS(4943), 1,
      sym__newline,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1581), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4939), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(582), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [72705] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(4947), 1,
      sym_dot_dot_i,
    ACTIONS(4949), 1,
      sym__newline,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1293), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4945), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(579), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [72833] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(4953), 1,
      sym_dot_dot_i,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4951), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(46), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [72961] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4957), 1,
      sym_dot_dot_i,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4955), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(499), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [73089] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(4961), 1,
      sym_dot_dot_i,
    ACTIONS(4963), 1,
      sym__newline,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1575), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4959), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(2), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [73217] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(4967), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4965), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(35), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [73345] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(4971), 1,
      sym_dot_dot_i,
    ACTIONS(4973), 1,
      sym__newline,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1577), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4969), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(36), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [73473] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(4977), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4975), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(37), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [73601] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(4981), 1,
      sym_dot_dot_i,
    ACTIONS(4983), 1,
      sym__newline,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1591), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4979), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(585), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [73729] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(4987), 1,
      sym_dot_dot_i,
    ACTIONS(4989), 1,
      sym__newline,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1299), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4985), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(580), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [73857] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4993), 1,
      sym_dot_dot_i,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4991), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(500), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [73985] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(4997), 1,
      sym_dot_dot_i,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4995), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(586), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [74113] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(5001), 1,
      sym_dot_dot_i,
    ACTIONS(5003), 1,
      sym__newline,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1319), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(4999), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(584), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [74241] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(5007), 1,
      sym_dot_dot_i,
    ACTIONS(5009), 1,
      sym__newline,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1584), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5005), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(38), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [74369] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(5013), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5011), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(39), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [74497] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(5017), 1,
      sym_dot_dot_i,
    ACTIONS(5019), 1,
      sym__newline,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1586), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5015), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(40), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [74625] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(5023), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5021), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(21), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [74753] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(5027), 1,
      sym_dot_dot_i,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5025), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(503), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [74881] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(5031), 1,
      sym_dot_dot_i,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5029), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(47), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [75009] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(5035), 1,
      sym_dot_dot_i,
    ACTIONS(5037), 1,
      sym__newline,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(1190), 1,
      aux_sym_function_definition_repeat1,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5033), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(407), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [75137] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(5041), 1,
      sym_dot_dot_i,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5039), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(48), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [75265] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(5045), 1,
      sym_dot_dot_i,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5043), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(293), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [75393] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(5049), 1,
      sym_dot_dot_i,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5047), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(49), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [75521] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(5053), 1,
      sym_dot_dot_i,
    ACTIONS(5055), 1,
      sym__newline,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(1014), 1,
      aux_sym_function_definition_repeat1,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5051), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(294), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [75649] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(5059), 1,
      sym_dot_dot_i,
    ACTIONS(5061), 1,
      sym__newline,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1595), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5057), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(22), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [75777] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(5065), 1,
      sym_dot_dot_i,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5063), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(23), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [75905] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(5069), 1,
      sym_dot_dot_i,
    ACTIONS(5071), 1,
      sym__newline,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1597), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5067), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(24), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [76033] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1885), 1,
      sym__newline,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(5075), 1,
      sym_dot_dot_i,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5073), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(25), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [76161] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(5079), 1,
      sym_dot_dot_i,
    ACTIONS(5081), 1,
      sym__newline,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(1057), 1,
      aux_sym_function_definition_repeat1,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5077), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(72), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [76289] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(5085), 1,
      sym_dot_dot_i,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5083), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(345), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [76411] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5089), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5087), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1905), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [76533] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(5093), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5091), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(220), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [76655] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5097), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5095), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1836), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [76777] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(5101), 1,
      sym_dot_dot_i,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5099), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(63), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [76899] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(5105), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5103), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(217), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [77021] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5109), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5107), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1869), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [77143] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(5113), 1,
      sym_dot_dot_i,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5111), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(295), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [77265] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(5117), 1,
      sym_dot_dot_i,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5115), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(66), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [77387] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(5121), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5119), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1739), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [77509] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(5125), 1,
      sym_dot_dot_i,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5123), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(67), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [77631] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(5129), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5127), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(263), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [77753] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(5133), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5131), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1764), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [77875] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(5137), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5135), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1772), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [77997] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(5141), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5139), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(266), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [78119] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(5145), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5143), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(42), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [78241] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      sym_identifier,
    ACTIONS(3005), 1,
      anon_sym_BSLASH,
    ACTIONS(3007), 1,
      anon_sym_function,
    ACTIONS(3009), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_for,
    ACTIONS(3013), 1,
      anon_sym_while,
    ACTIONS(3015), 1,
      anon_sym_repeat,
    ACTIONS(3017), 1,
      anon_sym_QMARK,
    ACTIONS(3019), 1,
      anon_sym_TILDE,
    ACTIONS(3021), 1,
      anon_sym_BANG,
    ACTIONS(3025), 1,
      sym__hex_literal,
    ACTIONS(3027), 1,
      sym__number_literal,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(3043), 1,
      sym__external_open_parenthesis,
    ACTIONS(3045), 1,
      sym__external_open_brace,
    ACTIONS(5149), 1,
      sym_dot_dot_i,
    STATE(868), 1,
      sym__open_brace,
    STATE(983), 1,
      sym__open_parenthesis,
    STATE(1914), 1,
      sym__float_literal,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1929), 1,
      sym_string,
    STATE(2144), 1,
      sym__string_or_identifier,
    ACTIONS(3023), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3035), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5147), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1736), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [78363] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_SQUOTE,
    ACTIONS(941), 1,
      anon_sym_DQUOTE,
    ACTIONS(945), 1,
      sym__raw_string_literal,
    ACTIONS(3813), 1,
      sym_identifier,
    ACTIONS(3815), 1,
      anon_sym_BSLASH,
    ACTIONS(3817), 1,
      anon_sym_function,
    ACTIONS(3819), 1,
      anon_sym_if,
    ACTIONS(3821), 1,
      anon_sym_for,
    ACTIONS(3823), 1,
      anon_sym_while,
    ACTIONS(3825), 1,
      anon_sym_repeat,
    ACTIONS(3827), 1,
      anon_sym_QMARK,
    ACTIONS(3829), 1,
      anon_sym_TILDE,
    ACTIONS(3831), 1,
      anon_sym_BANG,
    ACTIONS(3835), 1,
      sym__hex_literal,
    ACTIONS(3837), 1,
      sym__number_literal,
    ACTIONS(3847), 1,
      sym__external_open_parenthesis,
    ACTIONS(3849), 1,
      sym__external_open_brace,
    ACTIONS(5153), 1,
      sym_dot_dot_i,
    STATE(670), 1,
      sym_string,
    STATE(671), 1,
      sym__float_literal,
    STATE(672), 1,
      sym__single_quoted_string,
    STATE(697), 1,
      sym__double_quoted_string,
    STATE(872), 1,
      sym__open_brace,
    STATE(997), 1,
      sym__open_parenthesis,
    STATE(2147), 1,
      sym__string_or_identifier,
    ACTIONS(3833), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3841), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5151), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(270), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [78485] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(5157), 1,
      sym_dot_dot_i,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5155), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(393), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [78607] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(5161), 1,
      sym_dot_dot_i,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5159), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(396), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [78729] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(5165), 1,
      sym_dot_dot_i,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5163), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(397), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [78851] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(5169), 1,
      sym_dot_dot_i,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5167), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(515), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [78973] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5173), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5171), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1815), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [79095] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_BSLASH,
    ACTIONS(595), 1,
      anon_sym_function,
    ACTIONS(597), 1,
      anon_sym_if,
    ACTIONS(599), 1,
      anon_sym_for,
    ACTIONS(601), 1,
      anon_sym_while,
    ACTIONS(603), 1,
      anon_sym_repeat,
    ACTIONS(605), 1,
      anon_sym_QMARK,
    ACTIONS(607), 1,
      anon_sym_TILDE,
    ACTIONS(609), 1,
      anon_sym_BANG,
    ACTIONS(613), 1,
      sym__hex_literal,
    ACTIONS(615), 1,
      sym__number_literal,
    ACTIONS(617), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_DQUOTE,
    ACTIONS(633), 1,
      sym__raw_string_literal,
    ACTIONS(635), 1,
      sym__external_open_parenthesis,
    ACTIONS(637), 1,
      sym__external_open_brace,
    ACTIONS(1687), 1,
      sym_identifier,
    ACTIONS(5177), 1,
      sym_dot_dot_i,
    STATE(700), 1,
      sym__double_quoted_string,
    STATE(710), 1,
      sym__float_literal,
    STATE(725), 1,
      sym__single_quoted_string,
    STATE(726), 1,
      sym_string,
    STATE(857), 1,
      sym__open_brace,
    STATE(955), 1,
      sym__open_parenthesis,
    STATE(2142), 1,
      sym__string_or_identifier,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(623), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5175), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(400), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [79217] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5181), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5179), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1902), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [79339] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(5185), 1,
      sym_dot_dot_i,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5183), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(522), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [79461] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(5189), 1,
      sym_dot_dot_i,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5187), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(523), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [79583] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(5193), 1,
      sym_dot_dot_i,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5191), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(454), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [79705] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5197), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5195), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1823), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [79827] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 1,
      anon_sym_BSLASH,
    ACTIONS(741), 1,
      anon_sym_function,
    ACTIONS(743), 1,
      anon_sym_if,
    ACTIONS(745), 1,
      anon_sym_for,
    ACTIONS(747), 1,
      anon_sym_while,
    ACTIONS(749), 1,
      anon_sym_repeat,
    ACTIONS(751), 1,
      anon_sym_QMARK,
    ACTIONS(753), 1,
      anon_sym_TILDE,
    ACTIONS(755), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym__hex_literal,
    ACTIONS(761), 1,
      sym__number_literal,
    ACTIONS(763), 1,
      anon_sym_SQUOTE,
    ACTIONS(765), 1,
      anon_sym_DQUOTE,
    ACTIONS(779), 1,
      sym__raw_string_literal,
    ACTIONS(781), 1,
      sym__external_open_parenthesis,
    ACTIONS(785), 1,
      sym__external_open_brace,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(5201), 1,
      sym_dot_dot_i,
    STATE(707), 1,
      sym__single_quoted_string,
    STATE(708), 1,
      sym__double_quoted_string,
    STATE(722), 1,
      sym__float_literal,
    STATE(739), 1,
      sym_string,
    STATE(842), 1,
      sym__open_brace,
    STATE(907), 1,
      sym__open_parenthesis,
    STATE(2140), 1,
      sym__string_or_identifier,
    ACTIONS(757), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(769), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5199), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(526), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [79949] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5205), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5203), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1904), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [80071] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_SQUOTE,
    ACTIONS(799), 1,
      anon_sym_DQUOTE,
    ACTIONS(803), 1,
      sym__raw_string_literal,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_BSLASH,
    ACTIONS(1891), 1,
      anon_sym_function,
    ACTIONS(1893), 1,
      anon_sym_if,
    ACTIONS(1895), 1,
      anon_sym_for,
    ACTIONS(1897), 1,
      anon_sym_while,
    ACTIONS(1899), 1,
      anon_sym_repeat,
    ACTIONS(1901), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_TILDE,
    ACTIONS(1905), 1,
      anon_sym_BANG,
    ACTIONS(1909), 1,
      sym__hex_literal,
    ACTIONS(1911), 1,
      sym__number_literal,
    ACTIONS(1919), 1,
      sym__external_open_parenthesis,
    ACTIONS(1921), 1,
      sym__external_open_brace,
    ACTIONS(5209), 1,
      sym_dot_dot_i,
    STATE(668), 1,
      sym_string,
    STATE(676), 1,
      sym__float_literal,
    STATE(679), 1,
      sym__single_quoted_string,
    STATE(680), 1,
      sym__double_quoted_string,
    STATE(858), 1,
      sym__open_brace,
    STATE(962), 1,
      sym__open_parenthesis,
    STATE(2141), 1,
      sym__string_or_identifier,
    ACTIONS(1907), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1915), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5207), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(70), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [80193] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(5213), 1,
      sym_dot_dot_i,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5211), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(341), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [80315] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(5217), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5215), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(113), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [80437] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(5221), 1,
      sym_dot_dot_i,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5219), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(457), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [80559] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(5225), 1,
      sym_dot_dot_i,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5223), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(458), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [80681] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(5229), 1,
      sym_dot_dot_i,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5227), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(344), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [80803] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5233), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5231), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1898), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [80925] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(5237), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5235), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(163), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [81047] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5241), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5239), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1839), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [81169] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(5245), 1,
      sym_dot_dot_i,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5243), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(583), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [81291] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(5249), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5247), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(116), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [81413] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5253), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5251), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1789), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [81535] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_BSLASH,
    ACTIONS(545), 1,
      anon_sym_function,
    ACTIONS(547), 1,
      anon_sym_if,
    ACTIONS(549), 1,
      anon_sym_for,
    ACTIONS(551), 1,
      anon_sym_while,
    ACTIONS(553), 1,
      anon_sym_repeat,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(557), 1,
      anon_sym_TILDE,
    ACTIONS(559), 1,
      anon_sym_BANG,
    ACTIONS(563), 1,
      sym__hex_literal,
    ACTIONS(565), 1,
      sym__number_literal,
    ACTIONS(567), 1,
      anon_sym_SQUOTE,
    ACTIONS(569), 1,
      anon_sym_DQUOTE,
    ACTIONS(583), 1,
      sym__raw_string_literal,
    ACTIONS(585), 1,
      sym__external_open_parenthesis,
    ACTIONS(587), 1,
      sym__external_open_brace,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(5257), 1,
      sym_dot_dot_i,
    STATE(714), 1,
      sym_string,
    STATE(734), 1,
      sym__float_literal,
    STATE(735), 1,
      sym__single_quoted_string,
    STATE(736), 1,
      sym__double_quoted_string,
    STATE(751), 1,
      sym__open_brace,
    STATE(948), 1,
      sym__open_parenthesis,
    STATE(2143), 1,
      sym__string_or_identifier,
    ACTIONS(561), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(573), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5255), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(348), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [81657] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(5261), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5259), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(117), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [81779] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(5265), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5263), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(166), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [81901] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(5269), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5267), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(167), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [82023] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(5273), 1,
      sym_dot_dot_i,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5271), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(587), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [82145] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_SQUOTE,
    ACTIONS(1149), 1,
      anon_sym_DQUOTE,
    ACTIONS(1153), 1,
      sym__raw_string_literal,
    ACTIONS(1428), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_BSLASH,
    ACTIONS(1432), 1,
      anon_sym_function,
    ACTIONS(1434), 1,
      anon_sym_if,
    ACTIONS(1436), 1,
      anon_sym_for,
    ACTIONS(1438), 1,
      anon_sym_while,
    ACTIONS(1440), 1,
      anon_sym_repeat,
    ACTIONS(1442), 1,
      anon_sym_QMARK,
    ACTIONS(1444), 1,
      anon_sym_TILDE,
    ACTIONS(1446), 1,
      anon_sym_BANG,
    ACTIONS(1450), 1,
      sym__hex_literal,
    ACTIONS(1452), 1,
      sym__number_literal,
    ACTIONS(1462), 1,
      sym__external_open_parenthesis,
    ACTIONS(1464), 1,
      sym__external_open_brace,
    ACTIONS(5277), 1,
      sym_dot_dot_i,
    STATE(740), 1,
      sym_string,
    STATE(741), 1,
      sym__float_literal,
    STATE(743), 1,
      sym__single_quoted_string,
    STATE(746), 1,
      sym__double_quoted_string,
    STATE(853), 1,
      sym__open_brace,
    STATE(934), 1,
      sym__open_parenthesis,
    STATE(2136), 1,
      sym__string_or_identifier,
    ACTIONS(1448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1456), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5275), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(588), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [82267] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_BSLASH,
    ACTIONS(11), 1,
      anon_sym_function,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_for,
    ACTIONS(17), 1,
      anon_sym_while,
    ACTIONS(19), 1,
      anon_sym_repeat,
    ACTIONS(21), 1,
      anon_sym_QMARK,
    ACTIONS(23), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_BANG,
    ACTIONS(29), 1,
      sym__hex_literal,
    ACTIONS(31), 1,
      sym__number_literal,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      sym__raw_string_literal,
    ACTIONS(47), 1,
      sym__external_open_parenthesis,
    ACTIONS(49), 1,
      sym__external_open_brace,
    ACTIONS(5281), 1,
      sym_dot_dot_i,
    STATE(706), 1,
      sym_string,
    STATE(744), 1,
      sym__float_literal,
    STATE(745), 1,
      sym__single_quoted_string,
    STATE(747), 1,
      sym__double_quoted_string,
    STATE(760), 1,
      sym__open_brace,
    STATE(987), 1,
      sym__open_parenthesis,
    STATE(2134), 1,
      sym__string_or_identifier,
    ACTIONS(27), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(39), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5279), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(461), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [82389] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_SQUOTE,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(901), 1,
      sym__raw_string_literal,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_BSLASH,
    ACTIONS(2531), 1,
      anon_sym_function,
    ACTIONS(2533), 1,
      anon_sym_if,
    ACTIONS(2535), 1,
      anon_sym_for,
    ACTIONS(2537), 1,
      anon_sym_while,
    ACTIONS(2539), 1,
      anon_sym_repeat,
    ACTIONS(2541), 1,
      anon_sym_QMARK,
    ACTIONS(2543), 1,
      anon_sym_TILDE,
    ACTIONS(2545), 1,
      anon_sym_BANG,
    ACTIONS(2549), 1,
      sym__hex_literal,
    ACTIONS(2551), 1,
      sym__number_literal,
    ACTIONS(2561), 1,
      sym__external_open_parenthesis,
    ACTIONS(2563), 1,
      sym__external_open_brace,
    ACTIONS(5285), 1,
      sym_dot_dot_i,
    STATE(661), 1,
      sym__single_quoted_string,
    STATE(686), 1,
      sym__double_quoted_string,
    STATE(688), 1,
      sym_string,
    STATE(693), 1,
      sym__float_literal,
    STATE(864), 1,
      sym__open_brace,
    STATE(976), 1,
      sym__open_parenthesis,
    STATE(2137), 1,
      sym__string_or_identifier,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5283), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(170), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [82511] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(5289), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5287), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(213), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [82633] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_DQUOTE,
    ACTIONS(885), 1,
      sym__raw_string_literal,
    ACTIONS(2187), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_BSLASH,
    ACTIONS(2191), 1,
      anon_sym_function,
    ACTIONS(2193), 1,
      anon_sym_if,
    ACTIONS(2195), 1,
      anon_sym_for,
    ACTIONS(2197), 1,
      anon_sym_while,
    ACTIONS(2199), 1,
      anon_sym_repeat,
    ACTIONS(2201), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_TILDE,
    ACTIONS(2205), 1,
      anon_sym_BANG,
    ACTIONS(2209), 1,
      sym__hex_literal,
    ACTIONS(2211), 1,
      sym__number_literal,
    ACTIONS(2221), 1,
      sym__external_open_parenthesis,
    ACTIONS(2223), 1,
      sym__external_open_brace,
    ACTIONS(5293), 1,
      sym_dot_dot_i,
    STATE(682), 1,
      sym_string,
    STATE(683), 1,
      sym__float_literal,
    STATE(684), 1,
      sym__single_quoted_string,
    STATE(685), 1,
      sym__double_quoted_string,
    STATE(861), 1,
      sym__open_brace,
    STATE(969), 1,
      sym__open_parenthesis,
    STATE(2139), 1,
      sym__string_or_identifier,
    ACTIONS(2207), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2215), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5291), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(120), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [82755] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5297), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5295), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1892), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [82877] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5301), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5299), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1893), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [82999] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5305), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5303), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1897), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [83121] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5309), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5307), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1899), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [83243] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_SQUOTE,
    ACTIONS(925), 1,
      anon_sym_DQUOTE,
    ACTIONS(929), 1,
      sym__raw_string_literal,
    ACTIONS(3273), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      anon_sym_BSLASH,
    ACTIONS(3277), 1,
      anon_sym_function,
    ACTIONS(3279), 1,
      anon_sym_if,
    ACTIONS(3281), 1,
      anon_sym_for,
    ACTIONS(3283), 1,
      anon_sym_while,
    ACTIONS(3285), 1,
      anon_sym_repeat,
    ACTIONS(3287), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_TILDE,
    ACTIONS(3291), 1,
      anon_sym_BANG,
    ACTIONS(3295), 1,
      sym__hex_literal,
    ACTIONS(3297), 1,
      sym__number_literal,
    ACTIONS(3307), 1,
      sym__external_open_parenthesis,
    ACTIONS(3309), 1,
      sym__external_open_brace,
    ACTIONS(5313), 1,
      sym_dot_dot_i,
    STATE(654), 1,
      sym_string,
    STATE(655), 1,
      sym__float_literal,
    STATE(656), 1,
      sym__single_quoted_string,
    STATE(657), 1,
      sym__double_quoted_string,
    STATE(871), 1,
      sym__open_brace,
    STATE(990), 1,
      sym__open_parenthesis,
    STATE(2148), 1,
      sym__string_or_identifier,
    ACTIONS(3293), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3301), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5311), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(216), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [83365] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5317), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5315), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1790), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [83487] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5321), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5319), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1791), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [83609] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5325), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5323), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1792), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [83731] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5329), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5327), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1793), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [83853] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5333), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5331), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1799), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [83975] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5337), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5335), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1800), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [84097] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5341), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5339), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1803), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [84219] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5345), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5343), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1804), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [84341] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5349), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5347), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1809), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [84463] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5353), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5351), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1810), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [84585] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5357), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5355), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1813), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [84707] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5361), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5359), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1814), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [84829] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5365), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5363), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1818), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [84951] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5369), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5367), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1820), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [85073] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5373), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5371), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1821), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [85195] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5377), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5375), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1822), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [85317] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5381), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5379), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1824), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [85439] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5385), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5383), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1825), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [85561] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5389), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5387), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1826), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [85683] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5393), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5391), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1828), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [85805] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5397), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5395), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1829), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [85927] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5401), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5399), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1830), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [86049] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5405), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5403), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1831), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [86171] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5409), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5407), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1832), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [86293] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5413), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5411), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1834), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [86415] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5417), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5415), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1835), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [86537] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5421), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5419), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1837), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [86659] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5425), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5423), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1838), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [86781] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5429), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5427), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1841), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [86903] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5433), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5431), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1842), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [87025] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5437), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5435), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1845), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [87147] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5441), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5439), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1846), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [87269] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5445), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5443), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1847), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [87391] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5449), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5447), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1907), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [87513] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5453), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5451), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1849), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [87635] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5457), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5455), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1850), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [87757] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5461), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5459), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1855), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [87879] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5465), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5463), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1856), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [88001] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5469), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5467), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1857), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [88123] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5473), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5471), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1858), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [88245] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5477), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5475), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1859), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [88367] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5481), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5479), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1860), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [88489] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5485), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5483), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1863), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [88611] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5489), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5487), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1864), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [88733] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5493), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5491), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1866), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [88855] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5497), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5495), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1867), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [88977] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5501), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5499), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1870), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [89099] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5505), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5503), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1872), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [89221] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5509), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5507), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1875), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [89343] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5513), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5511), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1876), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [89465] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5517), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5515), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1878), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [89587] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5521), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5519), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1880), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [89709] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5525), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5523), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1882), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [89831] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5529), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5527), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1884), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [89953] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5533), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5531), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1885), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [90075] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5537), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5535), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1886), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [90197] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5541), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5539), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1887), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [90319] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5545), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5543), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1888), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [90441] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5549), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5547), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1890), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [90563] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5553), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5551), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1891), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [90685] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5557), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5555), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1896), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [90807] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      sym_identifier,
    ACTIONS(1973), 1,
      anon_sym_BSLASH,
    ACTIONS(1975), 1,
      anon_sym_function,
    ACTIONS(1977), 1,
      anon_sym_if,
    ACTIONS(1979), 1,
      anon_sym_for,
    ACTIONS(1981), 1,
      anon_sym_while,
    ACTIONS(1983), 1,
      anon_sym_repeat,
    ACTIONS(1985), 1,
      anon_sym_QMARK,
    ACTIONS(1987), 1,
      anon_sym_TILDE,
    ACTIONS(1989), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      sym__hex_literal,
    ACTIONS(1995), 1,
      sym__number_literal,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(2011), 1,
      sym__external_open_parenthesis,
    ACTIONS(2013), 1,
      sym__external_open_brace,
    ACTIONS(5561), 1,
      sym_dot_dot_i,
    STATE(855), 1,
      sym__open_brace,
    STATE(941), 1,
      sym__open_parenthesis,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1945), 1,
      sym__float_literal,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1948), 1,
      sym_string,
    STATE(2145), 1,
      sym__string_or_identifier,
    ACTIONS(1991), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2003), 5,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
    ACTIONS(5559), 9,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      sym_dots,
    STATE(1786), 19,
      sym_function_definition,
      sym_if_statement,
      sym_for_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_braced_expression,
      sym_parenthesized_expression,
      sym_call,
      sym_subset,
      sym_subset2,
      sym_unary_operator,
      sym_binary_operator,
      sym_extract_operator,
      sym_namespace_operator,
      sym_integer,
      sym_complex,
      sym_float,
      sym_na,
      sym__expression,
  [90929] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(5563), 1,
      sym_identifier,
    ACTIONS(5565), 1,
      sym__newline,
    STATE(1720), 1,
      aux_sym_function_definition_repeat1,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1956), 2,
      sym_string,
      sym__string_or_identifier,
    ACTIONS(795), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(791), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [91000] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(5567), 1,
      sym_identifier,
    ACTIONS(5569), 1,
      sym__newline,
    STATE(1749), 1,
      aux_sym_function_definition_repeat1,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1958), 2,
      sym_string,
      sym__string_or_identifier,
    ACTIONS(815), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(811), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [91071] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(5571), 1,
      sym_identifier,
    ACTIONS(5573), 1,
      sym__newline,
    STATE(1722), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1974), 2,
      sym_string,
      sym__string_or_identifier,
    ACTIONS(795), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(791), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [91141] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(5575), 1,
      sym_identifier,
    ACTIONS(5577), 1,
      sym__newline,
    STATE(1871), 1,
      aux_sym_function_definition_repeat1,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1986), 2,
      sym_string,
      sym__string_or_identifier,
    ACTIONS(815), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(811), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [91211] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3029), 1,
      anon_sym_SQUOTE,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    ACTIONS(3041), 1,
      sym__raw_string_literal,
    ACTIONS(5579), 1,
      sym_identifier,
    STATE(1922), 1,
      sym__single_quoted_string,
    STATE(1923), 1,
      sym__double_quoted_string,
    STATE(1957), 2,
      sym_string,
      sym__string_or_identifier,
    ACTIONS(1059), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1057), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [91276] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5619), 1,
      sym__external_else,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1605), 1,
      sym__else,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(101), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5589), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [91384] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    ACTIONS(5627), 1,
      sym__external_else,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1612), 1,
      sym__else,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(207), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5589), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [91492] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    ACTIONS(5629), 1,
      sym__external_else,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1608), 1,
      sym__else,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(53), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5589), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [91600] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    ACTIONS(5631), 1,
      sym__external_else,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1615), 1,
      sym__else,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(101), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5589), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [91708] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    ACTIONS(5633), 1,
      sym__external_else,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1638), 1,
      sym__else,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(53), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5589), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [91816] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_DQUOTE,
    ACTIONS(2009), 1,
      sym__raw_string_literal,
    ACTIONS(5635), 1,
      sym_identifier,
    STATE(1941), 1,
      sym__double_quoted_string,
    STATE(1947), 1,
      sym__single_quoted_string,
    STATE(1976), 2,
      sym_string,
      sym__string_or_identifier,
    ACTIONS(1059), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1057), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [91880] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    ACTIONS(5637), 1,
      sym__external_else,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1611), 1,
      sym__else,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(151), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5589), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [91988] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    ACTIONS(5639), 1,
      sym__external_else,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1629), 1,
      sym__else,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(151), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5589), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [92096] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    ACTIONS(5641), 1,
      sym__external_else,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1600), 1,
      sym__else,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(207), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5589), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [92204] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(373), 3,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(371), 10,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      sym_comma,
  [92295] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5589), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(415), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [92398] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5589), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(445), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [92501] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5589), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(419), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [92604] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5589), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(423), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [92707] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(443), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(445), 9,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [92802] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5589), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(395), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [92905] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(443), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(445), 11,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [92992] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(443), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(445), 19,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [93063] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(431), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(433), 9,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [93158] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(431), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(433), 11,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [93245] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5589), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(387), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93348] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5589), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(399), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93451] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(371), 7,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      sym_comma,
  [93552] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5589), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(391), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93655] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5589), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(371), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93758] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5643), 1,
      sym__newline,
    STATE(1749), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1383), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1385), 30,
      sym__raw_string_literal,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_identifier,
      sym_comma,
  [93811] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(373), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(371), 9,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [93906] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(373), 7,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(371), 16,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [93985] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5589), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(371), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [94088] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(373), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(371), 8,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [94185] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5589), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(429), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [94288] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5589), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(437), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [94391] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(373), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(371), 11,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [94478] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5589), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(433), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [94581] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(373), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(371), 17,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      sym_comma,
  [94656] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(431), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(433), 19,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [94727] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(373), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(371), 19,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [94798] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(373), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(371), 19,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [94871] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(373), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(371), 19,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [94942] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5589), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(403), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [95045] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5589), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(407), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [95148] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5589), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(375), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [95251] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(379), 7,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      sym_comma,
  [95352] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5589), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(379), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [95455] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(381), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(379), 9,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [95550] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(381), 7,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(379), 16,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [95629] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5589), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(379), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [95732] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(381), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(379), 8,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [95829] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5589), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(369), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [95932] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(381), 3,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(379), 10,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      sym_comma,
  [96023] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(381), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(379), 11,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [96110] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(381), 6,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(379), 15,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [96193] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(381), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(379), 17,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      sym_comma,
  [96268] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5589), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(441), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96371] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(381), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(379), 19,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [96442] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(381), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(379), 19,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [96515] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(381), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(379), 19,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [96586] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5589), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(383), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96689] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_EQ,
    ACTIONS(5583), 1,
      anon_sym_TILDE,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5591), 1,
      anon_sym_DASH_GT,
    ACTIONS(5593), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5595), 1,
      anon_sym_PIPE,
    ACTIONS(5597), 1,
      anon_sym_AMP,
    ACTIONS(5599), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5601), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5603), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5589), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(411), 4,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5605), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96792] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5585), 1,
      anon_sym_PLUS,
    ACTIONS(5587), 1,
      anon_sym_DASH,
    ACTIONS(5607), 1,
      anon_sym_STAR,
    ACTIONS(5609), 1,
      anon_sym_SLASH,
    ACTIONS(5615), 1,
      anon_sym_COLON,
    ACTIONS(5621), 1,
      sym__external_open_parenthesis,
    ACTIONS(5623), 1,
      sym__external_open_bracket,
    ACTIONS(5625), 1,
      sym__external_open_bracket2,
    STATE(617), 1,
      sym__open_parenthesis,
    STATE(618), 1,
      sym__open_bracket,
    STATE(619), 1,
      sym__open_bracket2,
    STATE(1950), 1,
      sym_call_arguments,
    STATE(1960), 1,
      sym_subset2_arguments,
    STATE(1970), 1,
      sym_subset_arguments,
    ACTIONS(5611), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5613), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5617), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(373), 6,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(371), 15,
      sym__external_else,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [96875] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(373), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(371), 7,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [96971] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(373), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(371), 16,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      sym_comma,
  [97045] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5692), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1184), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [97151] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(437), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [97253] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(431), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(433), 18,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [97323] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5694), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1260), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [97429] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5696), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1503), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [97535] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5698), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1570), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [97641] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5700), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1578), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [97747] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5702), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1593), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [97853] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(375), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [97955] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(379), 6,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      sym_comma,
  [98055] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(379), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [98157] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(381), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(379), 8,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [98251] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(381), 7,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(379), 15,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [98329] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5704), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1104), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [98435] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5706), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1110), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [98541] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(379), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [98643] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(433), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [98745] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5708), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1114), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [98851] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5710), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1123), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [98957] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(411), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [99059] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(381), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(379), 7,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [99155] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(381), 3,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(379), 9,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      sym_comma,
  [99245] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(381), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(379), 10,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [99331] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5712), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1287), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [99437] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5714), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1309), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [99543] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(381), 6,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(379), 14,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [99625] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(381), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(379), 16,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      sym_comma,
  [99699] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5716), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1316), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [99805] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5718), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1322), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [99911] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5720), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1325), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [100017] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(381), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(379), 18,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [100087] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(381), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(379), 18,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [100159] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5722), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1464), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [100265] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(381), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(379), 18,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [100335] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5724), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1488), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [100441] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5726), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1490), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [100547] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5728), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1498), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [100653] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5730), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1285), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [100759] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5732), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1024), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [100865] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5734), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1035), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [100971] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5736), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1036), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [101077] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(383), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [101179] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5738), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1043), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [101285] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5740), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1105), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [101391] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5742), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1107), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [101497] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5744), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1108), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [101603] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5746), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1113), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [101709] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(373), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(371), 18,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [101779] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5748), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1185), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [101885] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5750), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1193), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [101991] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5752), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1152), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [102097] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5754), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1194), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [102203] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5756), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1199), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [102309] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(395), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [102411] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(373), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(371), 8,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [102505] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5758), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1244), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [102611] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5760), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1246), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [102717] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(373), 3,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(371), 9,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      sym_comma,
  [102807] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(415), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [102909] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5762), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1247), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [103015] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5764), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1250), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [103121] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5766), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1324), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [103227] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(371), 6,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      sym_comma,
  [103327] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5768), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1339), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [103433] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5770), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1346), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [103539] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5772), 2,
      sym__external_close_parenthesis,
      sym_comma,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [103643] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(373), 7,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(371), 15,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [103721] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(387), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [103823] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(431), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(433), 8,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [103917] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5774), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1442), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [104023] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5776), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1462), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [104129] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5778), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1463), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [104235] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5780), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1470), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [104341] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5782), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1483), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [104447] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5784), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1485), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [104553] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(391), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [104655] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(373), 8,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
    ACTIONS(371), 18,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [104727] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5786), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1507), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [104833] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5788), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1509), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [104939] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(373), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(371), 10,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [105025] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5790), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1518), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [105131] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5792), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1520), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [105237] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(441), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [105339] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(419), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [105441] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5794), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1527), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [105547] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5796), 1,
      sym__newline,
    STATE(1871), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1383), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1385), 29,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_identifier,
      sym_comma,
  [105599] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5799), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1529), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [105705] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(399), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [105807] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(423), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [105909] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5801), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1534), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [106015] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5803), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1536), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [106121] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(403), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [106223] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5805), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1544), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [106329] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(445), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [106431] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5807), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1546), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [106537] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(373), 6,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(371), 14,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      sym_comma,
  [106619] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5809), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1555), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [106725] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(373), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(371), 18,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [106795] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5811), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1557), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [106901] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5813), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1565), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [107007] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5815), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1567), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [107113] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5817), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1574), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [107219] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5819), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1576), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [107325] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(443), 2,
      anon_sym_EQ,
      anon_sym_DASH_GT,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(445), 8,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      sym_comma,
  [107419] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5821), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1583), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [107525] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5823), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1585), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [107631] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5825), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1187), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [107737] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5827), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1268), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [107843] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(443), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(445), 10,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [107929] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(443), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(445), 18,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      sym_comma,
  [107999] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5829), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1594), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [108105] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5831), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1271), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [108211] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5833), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1596), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [108317] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5835), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1290), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [108423] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(431), 4,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(433), 10,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      sym_comma,
  [108509] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(371), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [108611] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5837), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1292), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [108717] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(429), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [108819] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(407), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [108921] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(369), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [109023] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(371), 3,
      sym__external_close_parenthesis,
      anon_sym_QMARK,
      sym_comma,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [109125] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_TILDE,
    ACTIONS(5648), 1,
      anon_sym_PLUS,
    ACTIONS(5650), 1,
      anon_sym_DASH,
    ACTIONS(5652), 1,
      anon_sym_PIPE,
    ACTIONS(5654), 1,
      anon_sym_AMP,
    ACTIONS(5656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5664), 1,
      anon_sym_STAR,
    ACTIONS(5666), 1,
      anon_sym_SLASH,
    ACTIONS(5672), 1,
      anon_sym_COLON,
    ACTIONS(5676), 1,
      sym__external_open_parenthesis,
    ACTIONS(5678), 1,
      sym__external_open_bracket,
    ACTIONS(5680), 1,
      sym__external_open_bracket2,
    ACTIONS(5682), 1,
      anon_sym_EQ,
    ACTIONS(5684), 1,
      anon_sym_QMARK,
    ACTIONS(5688), 1,
      anon_sym_DASH_GT,
    ACTIONS(5690), 1,
      anon_sym_DASH_GT_GT,
    ACTIONS(5839), 1,
      sym__external_close_parenthesis,
    STATE(593), 1,
      sym__open_parenthesis,
    STATE(594), 1,
      sym__open_bracket,
    STATE(595), 1,
      sym__open_bracket2,
    STATE(1338), 1,
      sym__close_parenthesis,
    STATE(1979), 1,
      sym_call_arguments,
    STATE(1987), 1,
      sym_subset_arguments,
    STATE(1988), 1,
      sym_subset2_arguments,
    ACTIONS(5660), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5668), 2,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
    ACTIONS(5670), 2,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
    ACTIONS(5674), 2,
      anon_sym_DOLLAR,
      anon_sym_AT,
    ACTIONS(5686), 3,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
    ACTIONS(5662), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [109231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5843), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      sym__external_close_bracket2,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(5841), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [109276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5843), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      sym__external_close_bracket,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(5841), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [109321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1357), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(1355), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [109366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1361), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(1359), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [109411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5847), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_brace,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(5845), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [109456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1365), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(1363), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [109501] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5849), 1,
      anon_sym_L,
    ACTIONS(5851), 1,
      anon_sym_i,
    ACTIONS(1339), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1341), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [109550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1351), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(1353), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [109595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5855), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_brace,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(5853), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [109640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1327), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(1329), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [109685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(823), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_brace,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(821), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [109730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5843), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_brace,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(5841), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [109775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5859), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      sym__external_close_bracket,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(5857), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [109820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5863), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_brace,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(5861), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [109865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1347), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(1349), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [109910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1347), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(1349), 27,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [109955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5867), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      sym__external_close_bracket2,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(5865), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [110000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(823), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      sym__external_close_bracket2,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(821), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [110045] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(823), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      sym__external_close_bracket,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(821), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [110090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5859), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_brace,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(5857), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [110135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5847), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      sym__external_close_bracket2,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(5845), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [110180] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1335), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1337), 1,
      anon_sym_COLON_COLON_COLON,
    ACTIONS(1331), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1333), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [110229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5855), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      sym__external_close_bracket2,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(5853), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [110274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5867), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_brace,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(5865), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [110319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5863), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      sym__external_close_bracket,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(5861), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [110364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5863), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      sym__external_close_bracket2,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(5861), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [110409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5847), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      sym__external_close_bracket,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(5845), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [110454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(807), 16,
      sym__newline,
      sym__semicolon,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      sym__external_close_brace,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
    ACTIONS(805), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [110499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5859), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      sym__external_close_bracket2,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(5857), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [110544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5855), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      sym__external_close_bracket,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(5853), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [110589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5867), 16,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      sym__external_close_bracket,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
      sym_comma,
    ACTIONS(5865), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [110634] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1327), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(1329), 26,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [110678] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5869), 1,
      sym__newline,
    STATE(1940), 1,
      aux_sym_function_definition_repeat1,
    ACTIONS(1385), 13,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
    ACTIONS(1383), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [110726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1347), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(1349), 26,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [110770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1365), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(1363), 26,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [110814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1357), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(1355), 26,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [110858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1351), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(1353), 26,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [110902] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5872), 1,
      anon_sym_L,
    ACTIONS(5874), 1,
      anon_sym_i,
    ACTIONS(1339), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1341), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [110950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1361), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(1359), 26,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [110994] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1347), 10,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_COLON_COLON,
    ACTIONS(1349), 26,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      anon_sym_COLON_COLON_COLON,
      sym_comma,
  [111038] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1335), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1337), 1,
      anon_sym_COLON_COLON_COLON,
    ACTIONS(1331), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1333), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [111086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1053), 15,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_brace,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
    ACTIONS(1051), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [111130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1470), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [111173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1508), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1510), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [111216] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5878), 14,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
    ACTIONS(5876), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [111259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1527), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1529), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [111302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5882), 14,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
    ACTIONS(5880), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [111345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1551), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1553), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [111388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1500), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1502), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [111431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1519), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1521), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [111474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1539), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1541), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [111517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1533), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1531), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [111560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1476), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1478), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [111603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1515), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1517), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [111646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1543), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1545), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [111689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1547), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1549), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [111732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1535), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1537), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [111775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1480), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1482), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [111818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1492), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1494), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [111861] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1504), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1506), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [111904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1484), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1486), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [111947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1523), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1525), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [111990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1472), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1474), 26,
      sym__external_else,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [112033] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5886), 14,
      sym__newline,
      sym__raw_string_literal,
      sym__external_open_parenthesis,
      sym__external_open_brace,
      anon_sym_BSLASH,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym__hex_literal,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      sym_dot_dot_i,
    ACTIONS(5884), 21,
      anon_sym_function,
      anon_sym_if,
      anon_sym_for,
      anon_sym_while,
      anon_sym_repeat,
      sym__number_literal,
      sym_identifier,
      sym_return,
      sym_next,
      sym_break,
      sym_true,
      sym_false,
      sym_null,
      sym_inf,
      sym_nan,
      anon_sym_NA,
      anon_sym_NA_integer_,
      anon_sym_NA_real_,
      anon_sym_NA_complex_,
      anon_sym_NA_character_,
      sym_dots,
  [112076] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1515), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1517), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [112118] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1543), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1545), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [112160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1500), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1502), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [112202] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1535), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1537), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [112244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1519), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1521), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [112286] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1492), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1494), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [112328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1551), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1553), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [112370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1470), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [112412] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1547), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1549), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [112454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1533), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1531), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [112496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1480), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1482), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [112538] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1484), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1486), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [112580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1504), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1506), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [112622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1523), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1525), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [112664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1539), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1541), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [112706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1472), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1474), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [112748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1476), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1478), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [112790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1508), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1510), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [112832] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1527), 9,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_COLON,
    ACTIONS(1529), 25,
      sym__external_open_parenthesis,
      sym__external_close_parenthesis,
      sym__external_open_bracket,
      sym__external_open_bracket2,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_LT_DASH,
      anon_sym_LT_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_DASH_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      aux_sym_binary_operator_token1,
      anon_sym_PIPE_GT,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_comma,
  [112874] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5888), 1,
      sym_identifier,
    ACTIONS(5890), 1,
      sym_dots,
    ACTIONS(5892), 1,
      sym__external_close_parenthesis,
    STATE(1954), 1,
      sym__close_parenthesis,
    STATE(1995), 1,
      sym_parameter,
    STATE(2138), 1,
      sym__parameter_with_default,
    STATE(2146), 1,
      sym__parameter_without_default,
  [112899] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5888), 1,
      sym_identifier,
    ACTIONS(5890), 1,
      sym_dots,
    STATE(2138), 1,
      sym__parameter_with_default,
    STATE(2146), 1,
      sym__parameter_without_default,
    STATE(2149), 1,
      sym_parameter,
  [112918] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(5896), 1,
      sym__external_open_parenthesis,
    STATE(1714), 1,
      sym__open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
  [112934] = 4,
    ACTIONS(5898), 1,
      anon_sym_DQUOTE,
    ACTIONS(5902), 1,
      sym_comment,
    STATE(2000), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(5900), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [112948] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 1,
      sym_comma,
    ACTIONS(5906), 1,
      sym__external_close_parenthesis,
    STATE(1952), 1,
      sym__close_parenthesis,
    STATE(2032), 1,
      aux_sym_parameters_repeat1,
  [112964] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5908), 1,
      anon_sym_DQUOTE,
    STATE(2026), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(5900), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [112978] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5910), 1,
      anon_sym_SQUOTE,
    STATE(2018), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(5912), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [112992] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5914), 1,
      anon_sym_SQUOTE,
    STATE(2017), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(5912), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [113006] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5916), 1,
      anon_sym_SQUOTE,
    STATE(2001), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(5912), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [113020] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5918), 1,
      anon_sym_DQUOTE,
    STATE(2026), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(5900), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [113034] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5920), 1,
      anon_sym_SQUOTE,
    STATE(2017), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(5912), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [113048] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5922), 1,
      anon_sym_DQUOTE,
    STATE(2026), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(5900), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [113062] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5924), 1,
      sym__newline,
    ACTIONS(5926), 1,
      sym__external_open_parenthesis,
    STATE(1602), 1,
      sym__open_parenthesis,
    STATE(2031), 1,
      aux_sym_function_definition_repeat1,
  [113078] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5928), 1,
      sym__newline,
    ACTIONS(5930), 1,
      sym__external_open_parenthesis,
    STATE(1718), 1,
      sym__open_parenthesis,
    STATE(2021), 1,
      aux_sym_function_definition_repeat1,
  [113094] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5932), 1,
      anon_sym_DQUOTE,
    STATE(2019), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(5900), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [113108] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5934), 1,
      anon_sym_SQUOTE,
    STATE(2011), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(5912), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [113122] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5936), 1,
      anon_sym_DQUOTE,
    STATE(2014), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(5900), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [113136] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5938), 1,
      anon_sym_SQUOTE,
    STATE(2012), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(5912), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [113150] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5940), 1,
      anon_sym_DQUOTE,
    STATE(2013), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(5900), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [113164] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5942), 1,
      anon_sym_SQUOTE,
    STATE(2035), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(5912), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [113178] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5944), 1,
      anon_sym_SQUOTE,
    STATE(2017), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(5912), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [113192] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5946), 1,
      anon_sym_SQUOTE,
    STATE(2017), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(5912), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [113206] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5948), 1,
      anon_sym_DQUOTE,
    STATE(2026), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(5900), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [113220] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5950), 1,
      anon_sym_DQUOTE,
    STATE(2026), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(5900), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [113234] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(5952), 1,
      sym__external_open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
    STATE(2170), 1,
      sym__open_parenthesis,
  [113250] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5954), 1,
      anon_sym_DQUOTE,
    STATE(1996), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(5900), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [113264] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5956), 1,
      anon_sym_SQUOTE,
    STATE(2017), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(5958), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [113278] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5961), 1,
      anon_sym_SQUOTE,
    STATE(2017), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(5912), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [113292] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5963), 1,
      anon_sym_DQUOTE,
    STATE(2026), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(5900), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [113306] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5965), 1,
      anon_sym_SQUOTE,
    STATE(2027), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(5912), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [113320] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(5967), 1,
      sym__external_open_parenthesis,
    STATE(1627), 1,
      sym__open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
  [113336] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5969), 1,
      anon_sym_DQUOTE,
    STATE(2028), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(5900), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [113350] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5971), 1,
      sym__newline,
    ACTIONS(5973), 1,
      sym__external_open_parenthesis,
    STATE(2015), 1,
      aux_sym_function_definition_repeat1,
    STATE(2191), 1,
      sym__open_parenthesis,
  [113366] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5975), 1,
      anon_sym_SQUOTE,
    STATE(2025), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(5912), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [113380] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5977), 1,
      anon_sym_SQUOTE,
    STATE(2017), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(5912), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [113394] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5979), 1,
      anon_sym_DQUOTE,
    STATE(2026), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(5981), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [113408] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5984), 1,
      anon_sym_SQUOTE,
    STATE(2017), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(5912), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [113422] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5986), 1,
      anon_sym_DQUOTE,
    STATE(2026), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(5900), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [113436] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5988), 1,
      anon_sym_SQUOTE,
    STATE(2033), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(5912), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [113450] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5990), 1,
      anon_sym_DQUOTE,
    STATE(2034), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(5900), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [113464] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(5992), 1,
      sym__external_open_parenthesis,
    STATE(1641), 1,
      sym__open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
  [113480] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 1,
      sym_comma,
    ACTIONS(5994), 1,
      sym__external_close_parenthesis,
    STATE(1971), 1,
      sym__close_parenthesis,
    STATE(2119), 1,
      aux_sym_parameters_repeat1,
  [113496] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5996), 1,
      anon_sym_SQUOTE,
    STATE(2017), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(5912), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [113510] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(5998), 1,
      anon_sym_DQUOTE,
    STATE(2026), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(5900), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [113524] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(6000), 1,
      anon_sym_SQUOTE,
    STATE(2017), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(5912), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [113538] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6002), 1,
      sym__newline,
    ACTIONS(6004), 1,
      sym__external_open_parenthesis,
    STATE(1652), 1,
      sym__open_parenthesis,
    STATE(2037), 1,
      aux_sym_function_definition_repeat1,
  [113554] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6006), 1,
      sym__external_open_parenthesis,
    STATE(1653), 1,
      sym__open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
  [113570] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(6008), 1,
      anon_sym_SQUOTE,
    STATE(2068), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(5912), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [113584] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_DQUOTE,
    STATE(2089), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(5900), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [113598] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6012), 1,
      sym__newline,
    ACTIONS(6014), 1,
      sym__external_open_parenthesis,
    STATE(1657), 1,
      sym__open_parenthesis,
    STATE(2041), 1,
      aux_sym_function_definition_repeat1,
  [113614] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6016), 1,
      sym__external_open_parenthesis,
    STATE(1658), 1,
      sym__open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
  [113630] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(6018), 1,
      anon_sym_SQUOTE,
    STATE(2058), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(5912), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [113644] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6020), 1,
      sym__newline,
    ACTIONS(6022), 1,
      sym__external_open_parenthesis,
    STATE(1661), 1,
      sym__open_parenthesis,
    STATE(2044), 1,
      aux_sym_function_definition_repeat1,
  [113660] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6024), 1,
      sym__external_open_parenthesis,
    STATE(1662), 1,
      sym__open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
  [113676] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(6026), 1,
      anon_sym_DQUOTE,
    STATE(2060), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(5900), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [113690] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6028), 1,
      sym__newline,
    ACTIONS(6030), 1,
      sym__external_open_parenthesis,
    STATE(1665), 1,
      sym__open_parenthesis,
    STATE(2047), 1,
      aux_sym_function_definition_repeat1,
  [113706] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6032), 1,
      sym__external_open_parenthesis,
    STATE(1666), 1,
      sym__open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
  [113722] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(6034), 1,
      anon_sym_DQUOTE,
    STATE(2072), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(5900), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [113736] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6036), 1,
      sym__newline,
    ACTIONS(6038), 1,
      sym__external_open_parenthesis,
    STATE(1669), 1,
      sym__open_parenthesis,
    STATE(2050), 1,
      aux_sym_function_definition_repeat1,
  [113752] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6040), 1,
      sym__external_open_parenthesis,
    STATE(1670), 1,
      sym__open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
  [113768] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6042), 1,
      sym__newline,
    ACTIONS(6044), 1,
      sym__external_open_parenthesis,
    STATE(1673), 1,
      sym__open_parenthesis,
    STATE(2052), 1,
      aux_sym_function_definition_repeat1,
  [113784] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6046), 1,
      sym__external_open_parenthesis,
    STATE(1674), 1,
      sym__open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
  [113800] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(6048), 1,
      anon_sym_SQUOTE,
    STATE(2062), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(5912), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [113814] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6050), 1,
      sym__newline,
    ACTIONS(6052), 1,
      sym__external_open_parenthesis,
    STATE(1677), 1,
      sym__open_parenthesis,
    STATE(2056), 1,
      aux_sym_function_definition_repeat1,
  [113830] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(6054), 1,
      anon_sym_DQUOTE,
    STATE(2064), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(5900), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [113844] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6056), 1,
      sym__external_open_parenthesis,
    STATE(1678), 1,
      sym__open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
  [113860] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6058), 1,
      sym__newline,
    ACTIONS(6060), 1,
      sym__external_open_parenthesis,
    STATE(1681), 1,
      sym__open_parenthesis,
    STATE(2059), 1,
      aux_sym_function_definition_repeat1,
  [113876] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(6062), 1,
      anon_sym_SQUOTE,
    STATE(2017), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(5912), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [113890] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6064), 1,
      sym__external_open_parenthesis,
    STATE(1682), 1,
      sym__open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
  [113906] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(6066), 1,
      anon_sym_DQUOTE,
    STATE(2026), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(5900), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [113920] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6068), 1,
      sym__newline,
    ACTIONS(6070), 1,
      sym__external_open_parenthesis,
    STATE(1685), 1,
      sym__open_parenthesis,
    STATE(2063), 1,
      aux_sym_function_definition_repeat1,
  [113936] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(6072), 1,
      anon_sym_SQUOTE,
    STATE(2017), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(5912), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [113950] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6074), 1,
      sym__external_open_parenthesis,
    STATE(1686), 1,
      sym__open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
  [113966] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(6076), 1,
      anon_sym_DQUOTE,
    STATE(2026), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(5900), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [113980] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6078), 1,
      sym__newline,
    ACTIONS(6080), 1,
      sym__external_open_parenthesis,
    STATE(1689), 1,
      sym__open_parenthesis,
    STATE(2067), 1,
      aux_sym_function_definition_repeat1,
  [113996] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(6082), 1,
      anon_sym_SQUOTE,
    STATE(1998), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(5912), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [114010] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6084), 1,
      sym__external_open_parenthesis,
    STATE(1690), 1,
      sym__open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
  [114026] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(6086), 1,
      anon_sym_SQUOTE,
    STATE(2017), 1,
      aux_sym__single_quoted_string_content,
    ACTIONS(5912), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [114040] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6088), 1,
      sym__newline,
    ACTIONS(6090), 1,
      sym__external_open_parenthesis,
    STATE(1693), 1,
      sym__open_parenthesis,
    STATE(2070), 1,
      aux_sym_function_definition_repeat1,
  [114056] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6092), 1,
      sym__external_open_parenthesis,
    STATE(1694), 1,
      sym__open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
  [114072] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6094), 1,
      sym__newline,
    ACTIONS(6096), 1,
      sym__external_open_parenthesis,
    STATE(1697), 1,
      sym__open_parenthesis,
    STATE(2073), 1,
      aux_sym_function_definition_repeat1,
  [114088] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(6098), 1,
      anon_sym_DQUOTE,
    STATE(2026), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(5900), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [114102] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6100), 1,
      sym__external_open_parenthesis,
    STATE(1698), 1,
      sym__open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
  [114118] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6102), 1,
      sym__newline,
    ACTIONS(6104), 1,
      sym__external_open_parenthesis,
    STATE(1699), 1,
      sym__open_parenthesis,
    STATE(2075), 1,
      aux_sym_function_definition_repeat1,
  [114134] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6106), 1,
      sym__external_open_parenthesis,
    STATE(1700), 1,
      sym__open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
  [114150] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6108), 1,
      sym__newline,
    ACTIONS(6110), 1,
      sym__external_open_parenthesis,
    STATE(1701), 1,
      sym__open_parenthesis,
    STATE(2077), 1,
      aux_sym_function_definition_repeat1,
  [114166] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6112), 1,
      sym__external_open_parenthesis,
    STATE(1702), 1,
      sym__open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
  [114182] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6114), 1,
      sym__newline,
    ACTIONS(6116), 1,
      sym__external_open_parenthesis,
    STATE(1703), 1,
      sym__open_parenthesis,
    STATE(2079), 1,
      aux_sym_function_definition_repeat1,
  [114198] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6118), 1,
      sym__external_open_parenthesis,
    STATE(1704), 1,
      sym__open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
  [114214] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6120), 1,
      sym__newline,
    ACTIONS(6122), 1,
      sym__external_open_parenthesis,
    STATE(1705), 1,
      sym__open_parenthesis,
    STATE(2081), 1,
      aux_sym_function_definition_repeat1,
  [114230] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6124), 1,
      sym__external_open_parenthesis,
    STATE(1706), 1,
      sym__open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
  [114246] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6126), 1,
      sym__newline,
    ACTIONS(6128), 1,
      sym__external_open_parenthesis,
    STATE(1707), 1,
      sym__open_parenthesis,
    STATE(2083), 1,
      aux_sym_function_definition_repeat1,
  [114262] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6130), 1,
      sym__external_open_parenthesis,
    STATE(1708), 1,
      sym__open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
  [114278] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6132), 1,
      sym__newline,
    ACTIONS(6134), 1,
      sym__external_open_parenthesis,
    STATE(1709), 1,
      sym__open_parenthesis,
    STATE(2085), 1,
      aux_sym_function_definition_repeat1,
  [114294] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6136), 1,
      sym__external_open_parenthesis,
    STATE(1710), 1,
      sym__open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
  [114310] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6138), 1,
      sym__newline,
    ACTIONS(6140), 1,
      sym__external_open_parenthesis,
    STATE(1711), 1,
      sym__open_parenthesis,
    STATE(2087), 1,
      aux_sym_function_definition_repeat1,
  [114326] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6142), 1,
      sym__external_open_parenthesis,
    STATE(1712), 1,
      sym__open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
  [114342] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6144), 1,
      sym__newline,
    ACTIONS(6146), 1,
      sym__external_open_parenthesis,
    STATE(1713), 1,
      sym__open_parenthesis,
    STATE(1993), 1,
      aux_sym_function_definition_repeat1,
  [114358] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(6148), 1,
      anon_sym_DQUOTE,
    STATE(2026), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(5900), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [114372] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6150), 1,
      sym__newline,
    ACTIONS(6152), 1,
      sym__external_open_parenthesis,
    STATE(1715), 1,
      sym__open_parenthesis,
    STATE(2091), 1,
      aux_sym_function_definition_repeat1,
  [114388] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6154), 1,
      sym__external_open_parenthesis,
    STATE(1716), 1,
      sym__open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
  [114404] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6156), 1,
      sym__newline,
    ACTIONS(6158), 1,
      sym__external_open_parenthesis,
    STATE(1717), 1,
      sym__open_parenthesis,
    STATE(2094), 1,
      aux_sym_function_definition_repeat1,
  [114420] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6160), 1,
      sym__newline,
    ACTIONS(6162), 1,
      sym__external_open_parenthesis,
    STATE(2095), 1,
      aux_sym_function_definition_repeat1,
    STATE(2192), 1,
      sym__open_parenthesis,
  [114436] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6164), 1,
      sym__external_open_parenthesis,
    STATE(1636), 1,
      sym__open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
  [114452] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6166), 1,
      sym__external_open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
    STATE(2174), 1,
      sym__open_parenthesis,
  [114468] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6168), 1,
      sym__newline,
    ACTIONS(6170), 1,
      sym__external_open_parenthesis,
    STATE(2097), 1,
      aux_sym_function_definition_repeat1,
    STATE(2156), 1,
      sym__open_parenthesis,
  [114484] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6172), 1,
      sym__external_open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
    STATE(2157), 1,
      sym__open_parenthesis,
  [114500] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6174), 1,
      sym__newline,
    ACTIONS(6176), 1,
      sym__external_open_parenthesis,
    STATE(2099), 1,
      aux_sym_function_definition_repeat1,
    STATE(2169), 1,
      sym__open_parenthesis,
  [114516] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6178), 1,
      sym__external_open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
    STATE(2180), 1,
      sym__open_parenthesis,
  [114532] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6180), 1,
      sym__newline,
    ACTIONS(6182), 1,
      sym__external_open_parenthesis,
    STATE(2101), 1,
      aux_sym_function_definition_repeat1,
    STATE(2185), 1,
      sym__open_parenthesis,
  [114548] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6184), 1,
      sym__external_open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
    STATE(2187), 1,
      sym__open_parenthesis,
  [114564] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6186), 1,
      sym__newline,
    ACTIONS(6188), 1,
      sym__external_open_parenthesis,
    STATE(2103), 1,
      aux_sym_function_definition_repeat1,
    STATE(2196), 1,
      sym__open_parenthesis,
  [114580] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6190), 1,
      sym__external_open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
    STATE(2151), 1,
      sym__open_parenthesis,
  [114596] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6192), 1,
      sym__newline,
    ACTIONS(6194), 1,
      sym__external_open_parenthesis,
    STATE(2105), 1,
      aux_sym_function_definition_repeat1,
    STATE(2154), 1,
      sym__open_parenthesis,
  [114612] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6196), 1,
      sym__external_open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
    STATE(2155), 1,
      sym__open_parenthesis,
  [114628] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6198), 1,
      sym__newline,
    ACTIONS(6200), 1,
      sym__external_open_parenthesis,
    STATE(2107), 1,
      aux_sym_function_definition_repeat1,
    STATE(2158), 1,
      sym__open_parenthesis,
  [114644] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6202), 1,
      sym__external_open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
    STATE(2159), 1,
      sym__open_parenthesis,
  [114660] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6204), 1,
      sym__newline,
    ACTIONS(6206), 1,
      sym__external_open_parenthesis,
    STATE(2109), 1,
      aux_sym_function_definition_repeat1,
    STATE(2162), 1,
      sym__open_parenthesis,
  [114676] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6208), 1,
      sym__external_open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
    STATE(2163), 1,
      sym__open_parenthesis,
  [114692] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6210), 1,
      sym__newline,
    ACTIONS(6212), 1,
      sym__external_open_parenthesis,
    STATE(2111), 1,
      aux_sym_function_definition_repeat1,
    STATE(2166), 1,
      sym__open_parenthesis,
  [114708] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6214), 1,
      sym__external_open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
    STATE(2167), 1,
      sym__open_parenthesis,
  [114724] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6216), 1,
      sym__newline,
    ACTIONS(6218), 1,
      sym__external_open_parenthesis,
    STATE(2113), 1,
      aux_sym_function_definition_repeat1,
    STATE(2150), 1,
      sym__open_parenthesis,
  [114740] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6220), 1,
      sym__external_open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
    STATE(2171), 1,
      sym__open_parenthesis,
  [114756] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6222), 1,
      sym__newline,
    ACTIONS(6224), 1,
      sym__external_open_parenthesis,
    STATE(2115), 1,
      aux_sym_function_definition_repeat1,
    STATE(2172), 1,
      sym__open_parenthesis,
  [114772] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym__newline,
    ACTIONS(6226), 1,
      sym__external_open_parenthesis,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
    STATE(2173), 1,
      sym__open_parenthesis,
  [114788] = 4,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(6228), 1,
      anon_sym_DQUOTE,
    STATE(2002), 1,
      aux_sym__double_quoted_string_content,
    ACTIONS(5900), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [114802] = 3,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(6230), 1,
      anon_sym_DQUOTE,
    ACTIONS(6232), 2,
      aux_sym__double_quoted_string_content_token1,
      sym_escape_sequence,
  [114813] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6234), 1,
      sym__external_open_parenthesis,
    STATE(1341), 1,
      sym_parameters,
    STATE(1991), 1,
      sym__open_parenthesis,
  [114826] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6236), 1,
      sym_comma,
    ACTIONS(6239), 1,
      sym__external_close_parenthesis,
    STATE(2119), 1,
      aux_sym_parameters_repeat1,
  [114839] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6234), 1,
      sym__external_open_parenthesis,
    STATE(1056), 1,
      sym_parameters,
    STATE(1991), 1,
      sym__open_parenthesis,
  [114852] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6241), 1,
      anon_sym_EQ,
    ACTIONS(6243), 2,
      sym__external_close_parenthesis,
      sym_comma,
  [114863] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6234), 1,
      sym__external_open_parenthesis,
    STATE(1589), 1,
      sym_parameters,
    STATE(1991), 1,
      sym__open_parenthesis,
  [114876] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6234), 1,
      sym__external_open_parenthesis,
    STATE(1427), 1,
      sym_parameters,
    STATE(1991), 1,
      sym__open_parenthesis,
  [114889] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6234), 1,
      sym__external_open_parenthesis,
    STATE(1323), 1,
      sym_parameters,
    STATE(1991), 1,
      sym__open_parenthesis,
  [114902] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6234), 1,
      sym__external_open_parenthesis,
    STATE(1524), 1,
      sym_parameters,
    STATE(1991), 1,
      sym__open_parenthesis,
  [114915] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6234), 1,
      sym__external_open_parenthesis,
    STATE(1025), 1,
      sym_parameters,
    STATE(1991), 1,
      sym__open_parenthesis,
  [114928] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6234), 1,
      sym__external_open_parenthesis,
    STATE(1151), 1,
      sym_parameters,
    STATE(1991), 1,
      sym__open_parenthesis,
  [114941] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6234), 1,
      sym__external_open_parenthesis,
    STATE(1210), 1,
      sym_parameters,
    STATE(1991), 1,
      sym__open_parenthesis,
  [114954] = 3,
    ACTIONS(5902), 1,
      sym_comment,
    ACTIONS(6245), 1,
      anon_sym_SQUOTE,
    ACTIONS(6247), 2,
      aux_sym__single_quoted_string_content_token1,
      sym_escape_sequence,
  [114965] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6234), 1,
      sym__external_open_parenthesis,
    STATE(1365), 1,
      sym_parameters,
    STATE(1991), 1,
      sym__open_parenthesis,
  [114978] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6234), 1,
      sym__external_open_parenthesis,
    STATE(1262), 1,
      sym_parameters,
    STATE(1991), 1,
      sym__open_parenthesis,
  [114991] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6234), 1,
      sym__external_open_parenthesis,
    STATE(1124), 1,
      sym_parameters,
    STATE(1991), 1,
      sym__open_parenthesis,
  [115004] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 1,
      sym__external_open_parenthesis,
    ACTIONS(6249), 1,
      sym__newline,
    STATE(2133), 1,
      aux_sym_function_definition_repeat1,
  [115017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6252), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6254), 1,
      anon_sym_COLON_COLON_COLON,
  [115027] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6243), 2,
      sym__external_close_parenthesis,
      sym_comma,
  [115035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6256), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6258), 1,
      anon_sym_COLON_COLON_COLON,
  [115045] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6262), 1,
      anon_sym_COLON_COLON_COLON,
  [115055] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6264), 2,
      sym__external_close_parenthesis,
      sym_comma,
  [115063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6266), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6268), 1,
      anon_sym_COLON_COLON_COLON,
  [115073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6270), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6272), 1,
      anon_sym_COLON_COLON_COLON,
  [115083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6276), 1,
      anon_sym_COLON_COLON_COLON,
  [115093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6278), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6280), 1,
      anon_sym_COLON_COLON_COLON,
  [115103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6282), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6284), 1,
      anon_sym_COLON_COLON_COLON,
  [115113] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6288), 1,
      anon_sym_COLON_COLON_COLON,
  [115123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6290), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6292), 1,
      anon_sym_COLON_COLON_COLON,
  [115133] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6294), 2,
      sym__external_close_parenthesis,
      sym_comma,
  [115141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6296), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6298), 1,
      anon_sym_COLON_COLON_COLON,
  [115151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6302), 1,
      anon_sym_COLON_COLON_COLON,
  [115161] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6304), 2,
      sym__external_close_parenthesis,
      sym_comma,
  [115169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6306), 1,
      sym_identifier,
  [115176] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6308), 1,
      sym_identifier,
  [115183] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6310), 1,
      anon_sym_in,
  [115190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6312), 1,
      anon_sym_in,
  [115197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6314), 1,
      sym_identifier,
  [115204] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6316), 1,
      sym_identifier,
  [115211] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6318), 1,
      sym_identifier,
  [115218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6320), 1,
      sym_identifier,
  [115225] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 1,
      sym_identifier,
  [115232] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6324), 1,
      sym_identifier,
  [115239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6326), 1,
      anon_sym_in,
  [115246] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6328), 1,
      anon_sym_in,
  [115253] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6330), 1,
      sym_identifier,
  [115260] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6332), 1,
      sym_identifier,
  [115267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6334), 1,
      anon_sym_in,
  [115274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6336), 1,
      anon_sym_in,
  [115281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6338), 1,
      sym_identifier,
  [115288] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6340), 1,
      sym_identifier,
  [115295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6342), 1,
      anon_sym_in,
  [115302] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6344), 1,
      sym_identifier,
  [115309] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6346), 1,
      sym_identifier,
  [115316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6348), 1,
      sym_identifier,
  [115323] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6350), 1,
      sym_identifier,
  [115330] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6352), 1,
      sym_identifier,
  [115337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6354), 1,
      sym_identifier,
  [115344] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6356), 1,
      anon_sym_in,
  [115351] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 1,
      anon_sym_in,
  [115358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6360), 1,
      anon_sym_in,
  [115365] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 1,
      ts_builtin_sym_end,
  [115372] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6364), 1,
      anon_sym_in,
  [115379] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6366), 1,
      sym_identifier,
  [115386] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6368), 1,
      anon_sym_in,
  [115393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6370), 1,
      anon_sym_in,
  [115400] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6372), 1,
      anon_sym_in,
  [115407] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_in,
  [115414] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6376), 1,
      sym_identifier,
  [115421] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6378), 1,
      anon_sym_in,
  [115428] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6380), 1,
      sym_identifier,
  [115435] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6382), 1,
      anon_sym_in,
  [115442] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6384), 1,
      anon_sym_in,
  [115449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6386), 1,
      anon_sym_in,
  [115456] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6388), 1,
      sym_identifier,
  [115463] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6390), 1,
      sym_identifier,
  [115470] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6392), 1,
      anon_sym_in,
  [115477] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6394), 1,
      anon_sym_in,
  [115484] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6396), 1,
      anon_sym_in,
  [115491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6398), 1,
      sym_identifier,
  [115498] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6400), 1,
      anon_sym_in,
  [115505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6402), 1,
      anon_sym_in,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(1003)] = 0,
  [SMALL_STATE(1004)] = 131,
  [SMALL_STATE(1005)] = 259,
  [SMALL_STATE(1006)] = 387,
  [SMALL_STATE(1007)] = 515,
  [SMALL_STATE(1008)] = 643,
  [SMALL_STATE(1009)] = 771,
  [SMALL_STATE(1010)] = 899,
  [SMALL_STATE(1011)] = 1027,
  [SMALL_STATE(1012)] = 1155,
  [SMALL_STATE(1013)] = 1283,
  [SMALL_STATE(1014)] = 1411,
  [SMALL_STATE(1015)] = 1539,
  [SMALL_STATE(1016)] = 1667,
  [SMALL_STATE(1017)] = 1795,
  [SMALL_STATE(1018)] = 1923,
  [SMALL_STATE(1019)] = 2051,
  [SMALL_STATE(1020)] = 2179,
  [SMALL_STATE(1021)] = 2307,
  [SMALL_STATE(1022)] = 2435,
  [SMALL_STATE(1023)] = 2563,
  [SMALL_STATE(1024)] = 2691,
  [SMALL_STATE(1025)] = 2819,
  [SMALL_STATE(1026)] = 2947,
  [SMALL_STATE(1027)] = 3075,
  [SMALL_STATE(1028)] = 3203,
  [SMALL_STATE(1029)] = 3331,
  [SMALL_STATE(1030)] = 3459,
  [SMALL_STATE(1031)] = 3587,
  [SMALL_STATE(1032)] = 3715,
  [SMALL_STATE(1033)] = 3843,
  [SMALL_STATE(1034)] = 3971,
  [SMALL_STATE(1035)] = 4099,
  [SMALL_STATE(1036)] = 4227,
  [SMALL_STATE(1037)] = 4355,
  [SMALL_STATE(1038)] = 4483,
  [SMALL_STATE(1039)] = 4611,
  [SMALL_STATE(1040)] = 4739,
  [SMALL_STATE(1041)] = 4867,
  [SMALL_STATE(1042)] = 4995,
  [SMALL_STATE(1043)] = 5123,
  [SMALL_STATE(1044)] = 5251,
  [SMALL_STATE(1045)] = 5379,
  [SMALL_STATE(1046)] = 5507,
  [SMALL_STATE(1047)] = 5635,
  [SMALL_STATE(1048)] = 5763,
  [SMALL_STATE(1049)] = 5891,
  [SMALL_STATE(1050)] = 6019,
  [SMALL_STATE(1051)] = 6147,
  [SMALL_STATE(1052)] = 6275,
  [SMALL_STATE(1053)] = 6403,
  [SMALL_STATE(1054)] = 6531,
  [SMALL_STATE(1055)] = 6659,
  [SMALL_STATE(1056)] = 6787,
  [SMALL_STATE(1057)] = 6915,
  [SMALL_STATE(1058)] = 7043,
  [SMALL_STATE(1059)] = 7171,
  [SMALL_STATE(1060)] = 7299,
  [SMALL_STATE(1061)] = 7427,
  [SMALL_STATE(1062)] = 7555,
  [SMALL_STATE(1063)] = 7683,
  [SMALL_STATE(1064)] = 7811,
  [SMALL_STATE(1065)] = 7939,
  [SMALL_STATE(1066)] = 8067,
  [SMALL_STATE(1067)] = 8195,
  [SMALL_STATE(1068)] = 8323,
  [SMALL_STATE(1069)] = 8451,
  [SMALL_STATE(1070)] = 8579,
  [SMALL_STATE(1071)] = 8707,
  [SMALL_STATE(1072)] = 8835,
  [SMALL_STATE(1073)] = 8963,
  [SMALL_STATE(1074)] = 9091,
  [SMALL_STATE(1075)] = 9219,
  [SMALL_STATE(1076)] = 9347,
  [SMALL_STATE(1077)] = 9475,
  [SMALL_STATE(1078)] = 9603,
  [SMALL_STATE(1079)] = 9731,
  [SMALL_STATE(1080)] = 9859,
  [SMALL_STATE(1081)] = 9987,
  [SMALL_STATE(1082)] = 10115,
  [SMALL_STATE(1083)] = 10243,
  [SMALL_STATE(1084)] = 10371,
  [SMALL_STATE(1085)] = 10499,
  [SMALL_STATE(1086)] = 10627,
  [SMALL_STATE(1087)] = 10755,
  [SMALL_STATE(1088)] = 10883,
  [SMALL_STATE(1089)] = 11011,
  [SMALL_STATE(1090)] = 11139,
  [SMALL_STATE(1091)] = 11267,
  [SMALL_STATE(1092)] = 11395,
  [SMALL_STATE(1093)] = 11523,
  [SMALL_STATE(1094)] = 11651,
  [SMALL_STATE(1095)] = 11779,
  [SMALL_STATE(1096)] = 11907,
  [SMALL_STATE(1097)] = 12035,
  [SMALL_STATE(1098)] = 12163,
  [SMALL_STATE(1099)] = 12291,
  [SMALL_STATE(1100)] = 12419,
  [SMALL_STATE(1101)] = 12547,
  [SMALL_STATE(1102)] = 12675,
  [SMALL_STATE(1103)] = 12803,
  [SMALL_STATE(1104)] = 12931,
  [SMALL_STATE(1105)] = 13059,
  [SMALL_STATE(1106)] = 13187,
  [SMALL_STATE(1107)] = 13315,
  [SMALL_STATE(1108)] = 13443,
  [SMALL_STATE(1109)] = 13571,
  [SMALL_STATE(1110)] = 13699,
  [SMALL_STATE(1111)] = 13827,
  [SMALL_STATE(1112)] = 13955,
  [SMALL_STATE(1113)] = 14083,
  [SMALL_STATE(1114)] = 14211,
  [SMALL_STATE(1115)] = 14339,
  [SMALL_STATE(1116)] = 14467,
  [SMALL_STATE(1117)] = 14595,
  [SMALL_STATE(1118)] = 14723,
  [SMALL_STATE(1119)] = 14851,
  [SMALL_STATE(1120)] = 14979,
  [SMALL_STATE(1121)] = 15107,
  [SMALL_STATE(1122)] = 15235,
  [SMALL_STATE(1123)] = 15363,
  [SMALL_STATE(1124)] = 15491,
  [SMALL_STATE(1125)] = 15619,
  [SMALL_STATE(1126)] = 15747,
  [SMALL_STATE(1127)] = 15875,
  [SMALL_STATE(1128)] = 16003,
  [SMALL_STATE(1129)] = 16131,
  [SMALL_STATE(1130)] = 16259,
  [SMALL_STATE(1131)] = 16387,
  [SMALL_STATE(1132)] = 16513,
  [SMALL_STATE(1133)] = 16641,
  [SMALL_STATE(1134)] = 16769,
  [SMALL_STATE(1135)] = 16897,
  [SMALL_STATE(1136)] = 17025,
  [SMALL_STATE(1137)] = 17153,
  [SMALL_STATE(1138)] = 17281,
  [SMALL_STATE(1139)] = 17409,
  [SMALL_STATE(1140)] = 17537,
  [SMALL_STATE(1141)] = 17665,
  [SMALL_STATE(1142)] = 17793,
  [SMALL_STATE(1143)] = 17921,
  [SMALL_STATE(1144)] = 18049,
  [SMALL_STATE(1145)] = 18177,
  [SMALL_STATE(1146)] = 18305,
  [SMALL_STATE(1147)] = 18433,
  [SMALL_STATE(1148)] = 18561,
  [SMALL_STATE(1149)] = 18689,
  [SMALL_STATE(1150)] = 18817,
  [SMALL_STATE(1151)] = 18945,
  [SMALL_STATE(1152)] = 19073,
  [SMALL_STATE(1153)] = 19201,
  [SMALL_STATE(1154)] = 19329,
  [SMALL_STATE(1155)] = 19457,
  [SMALL_STATE(1156)] = 19585,
  [SMALL_STATE(1157)] = 19713,
  [SMALL_STATE(1158)] = 19841,
  [SMALL_STATE(1159)] = 19969,
  [SMALL_STATE(1160)] = 20097,
  [SMALL_STATE(1161)] = 20225,
  [SMALL_STATE(1162)] = 20353,
  [SMALL_STATE(1163)] = 20481,
  [SMALL_STATE(1164)] = 20609,
  [SMALL_STATE(1165)] = 20737,
  [SMALL_STATE(1166)] = 20865,
  [SMALL_STATE(1167)] = 20993,
  [SMALL_STATE(1168)] = 21121,
  [SMALL_STATE(1169)] = 21249,
  [SMALL_STATE(1170)] = 21377,
  [SMALL_STATE(1171)] = 21505,
  [SMALL_STATE(1172)] = 21633,
  [SMALL_STATE(1173)] = 21761,
  [SMALL_STATE(1174)] = 21889,
  [SMALL_STATE(1175)] = 22017,
  [SMALL_STATE(1176)] = 22145,
  [SMALL_STATE(1177)] = 22273,
  [SMALL_STATE(1178)] = 22401,
  [SMALL_STATE(1179)] = 22529,
  [SMALL_STATE(1180)] = 22657,
  [SMALL_STATE(1181)] = 22785,
  [SMALL_STATE(1182)] = 22913,
  [SMALL_STATE(1183)] = 23041,
  [SMALL_STATE(1184)] = 23169,
  [SMALL_STATE(1185)] = 23297,
  [SMALL_STATE(1186)] = 23425,
  [SMALL_STATE(1187)] = 23553,
  [SMALL_STATE(1188)] = 23681,
  [SMALL_STATE(1189)] = 23809,
  [SMALL_STATE(1190)] = 23937,
  [SMALL_STATE(1191)] = 24065,
  [SMALL_STATE(1192)] = 24193,
  [SMALL_STATE(1193)] = 24321,
  [SMALL_STATE(1194)] = 24449,
  [SMALL_STATE(1195)] = 24577,
  [SMALL_STATE(1196)] = 24705,
  [SMALL_STATE(1197)] = 24833,
  [SMALL_STATE(1198)] = 24961,
  [SMALL_STATE(1199)] = 25089,
  [SMALL_STATE(1200)] = 25217,
  [SMALL_STATE(1201)] = 25345,
  [SMALL_STATE(1202)] = 25473,
  [SMALL_STATE(1203)] = 25601,
  [SMALL_STATE(1204)] = 25729,
  [SMALL_STATE(1205)] = 25857,
  [SMALL_STATE(1206)] = 25985,
  [SMALL_STATE(1207)] = 26113,
  [SMALL_STATE(1208)] = 26241,
  [SMALL_STATE(1209)] = 26369,
  [SMALL_STATE(1210)] = 26497,
  [SMALL_STATE(1211)] = 26625,
  [SMALL_STATE(1212)] = 26753,
  [SMALL_STATE(1213)] = 26881,
  [SMALL_STATE(1214)] = 27009,
  [SMALL_STATE(1215)] = 27137,
  [SMALL_STATE(1216)] = 27265,
  [SMALL_STATE(1217)] = 27393,
  [SMALL_STATE(1218)] = 27521,
  [SMALL_STATE(1219)] = 27649,
  [SMALL_STATE(1220)] = 27777,
  [SMALL_STATE(1221)] = 27905,
  [SMALL_STATE(1222)] = 28033,
  [SMALL_STATE(1223)] = 28161,
  [SMALL_STATE(1224)] = 28289,
  [SMALL_STATE(1225)] = 28417,
  [SMALL_STATE(1226)] = 28545,
  [SMALL_STATE(1227)] = 28673,
  [SMALL_STATE(1228)] = 28801,
  [SMALL_STATE(1229)] = 28929,
  [SMALL_STATE(1230)] = 29057,
  [SMALL_STATE(1231)] = 29185,
  [SMALL_STATE(1232)] = 29313,
  [SMALL_STATE(1233)] = 29441,
  [SMALL_STATE(1234)] = 29569,
  [SMALL_STATE(1235)] = 29697,
  [SMALL_STATE(1236)] = 29825,
  [SMALL_STATE(1237)] = 29953,
  [SMALL_STATE(1238)] = 30081,
  [SMALL_STATE(1239)] = 30209,
  [SMALL_STATE(1240)] = 30337,
  [SMALL_STATE(1241)] = 30465,
  [SMALL_STATE(1242)] = 30593,
  [SMALL_STATE(1243)] = 30721,
  [SMALL_STATE(1244)] = 30849,
  [SMALL_STATE(1245)] = 30977,
  [SMALL_STATE(1246)] = 31105,
  [SMALL_STATE(1247)] = 31233,
  [SMALL_STATE(1248)] = 31361,
  [SMALL_STATE(1249)] = 31489,
  [SMALL_STATE(1250)] = 31617,
  [SMALL_STATE(1251)] = 31745,
  [SMALL_STATE(1252)] = 31873,
  [SMALL_STATE(1253)] = 32001,
  [SMALL_STATE(1254)] = 32129,
  [SMALL_STATE(1255)] = 32257,
  [SMALL_STATE(1256)] = 32385,
  [SMALL_STATE(1257)] = 32513,
  [SMALL_STATE(1258)] = 32641,
  [SMALL_STATE(1259)] = 32769,
  [SMALL_STATE(1260)] = 32897,
  [SMALL_STATE(1261)] = 33025,
  [SMALL_STATE(1262)] = 33153,
  [SMALL_STATE(1263)] = 33281,
  [SMALL_STATE(1264)] = 33409,
  [SMALL_STATE(1265)] = 33537,
  [SMALL_STATE(1266)] = 33665,
  [SMALL_STATE(1267)] = 33793,
  [SMALL_STATE(1268)] = 33921,
  [SMALL_STATE(1269)] = 34049,
  [SMALL_STATE(1270)] = 34177,
  [SMALL_STATE(1271)] = 34305,
  [SMALL_STATE(1272)] = 34433,
  [SMALL_STATE(1273)] = 34561,
  [SMALL_STATE(1274)] = 34689,
  [SMALL_STATE(1275)] = 34817,
  [SMALL_STATE(1276)] = 34945,
  [SMALL_STATE(1277)] = 35073,
  [SMALL_STATE(1278)] = 35201,
  [SMALL_STATE(1279)] = 35329,
  [SMALL_STATE(1280)] = 35457,
  [SMALL_STATE(1281)] = 35585,
  [SMALL_STATE(1282)] = 35713,
  [SMALL_STATE(1283)] = 35841,
  [SMALL_STATE(1284)] = 35969,
  [SMALL_STATE(1285)] = 36097,
  [SMALL_STATE(1286)] = 36225,
  [SMALL_STATE(1287)] = 36353,
  [SMALL_STATE(1288)] = 36481,
  [SMALL_STATE(1289)] = 36609,
  [SMALL_STATE(1290)] = 36737,
  [SMALL_STATE(1291)] = 36865,
  [SMALL_STATE(1292)] = 36993,
  [SMALL_STATE(1293)] = 37121,
  [SMALL_STATE(1294)] = 37249,
  [SMALL_STATE(1295)] = 37377,
  [SMALL_STATE(1296)] = 37505,
  [SMALL_STATE(1297)] = 37633,
  [SMALL_STATE(1298)] = 37761,
  [SMALL_STATE(1299)] = 37889,
  [SMALL_STATE(1300)] = 38017,
  [SMALL_STATE(1301)] = 38145,
  [SMALL_STATE(1302)] = 38273,
  [SMALL_STATE(1303)] = 38401,
  [SMALL_STATE(1304)] = 38529,
  [SMALL_STATE(1305)] = 38657,
  [SMALL_STATE(1306)] = 38785,
  [SMALL_STATE(1307)] = 38913,
  [SMALL_STATE(1308)] = 39041,
  [SMALL_STATE(1309)] = 39169,
  [SMALL_STATE(1310)] = 39297,
  [SMALL_STATE(1311)] = 39425,
  [SMALL_STATE(1312)] = 39553,
  [SMALL_STATE(1313)] = 39681,
  [SMALL_STATE(1314)] = 39809,
  [SMALL_STATE(1315)] = 39937,
  [SMALL_STATE(1316)] = 40065,
  [SMALL_STATE(1317)] = 40193,
  [SMALL_STATE(1318)] = 40321,
  [SMALL_STATE(1319)] = 40449,
  [SMALL_STATE(1320)] = 40577,
  [SMALL_STATE(1321)] = 40705,
  [SMALL_STATE(1322)] = 40833,
  [SMALL_STATE(1323)] = 40961,
  [SMALL_STATE(1324)] = 41089,
  [SMALL_STATE(1325)] = 41217,
  [SMALL_STATE(1326)] = 41345,
  [SMALL_STATE(1327)] = 41473,
  [SMALL_STATE(1328)] = 41601,
  [SMALL_STATE(1329)] = 41729,
  [SMALL_STATE(1330)] = 41857,
  [SMALL_STATE(1331)] = 41985,
  [SMALL_STATE(1332)] = 42113,
  [SMALL_STATE(1333)] = 42241,
  [SMALL_STATE(1334)] = 42369,
  [SMALL_STATE(1335)] = 42497,
  [SMALL_STATE(1336)] = 42625,
  [SMALL_STATE(1337)] = 42753,
  [SMALL_STATE(1338)] = 42881,
  [SMALL_STATE(1339)] = 43009,
  [SMALL_STATE(1340)] = 43137,
  [SMALL_STATE(1341)] = 43265,
  [SMALL_STATE(1342)] = 43393,
  [SMALL_STATE(1343)] = 43521,
  [SMALL_STATE(1344)] = 43649,
  [SMALL_STATE(1345)] = 43777,
  [SMALL_STATE(1346)] = 43905,
  [SMALL_STATE(1347)] = 44033,
  [SMALL_STATE(1348)] = 44161,
  [SMALL_STATE(1349)] = 44289,
  [SMALL_STATE(1350)] = 44417,
  [SMALL_STATE(1351)] = 44545,
  [SMALL_STATE(1352)] = 44673,
  [SMALL_STATE(1353)] = 44801,
  [SMALL_STATE(1354)] = 44929,
  [SMALL_STATE(1355)] = 45057,
  [SMALL_STATE(1356)] = 45185,
  [SMALL_STATE(1357)] = 45313,
  [SMALL_STATE(1358)] = 45441,
  [SMALL_STATE(1359)] = 45569,
  [SMALL_STATE(1360)] = 45697,
  [SMALL_STATE(1361)] = 45825,
  [SMALL_STATE(1362)] = 45953,
  [SMALL_STATE(1363)] = 46081,
  [SMALL_STATE(1364)] = 46209,
  [SMALL_STATE(1365)] = 46337,
  [SMALL_STATE(1366)] = 46465,
  [SMALL_STATE(1367)] = 46593,
  [SMALL_STATE(1368)] = 46721,
  [SMALL_STATE(1369)] = 46849,
  [SMALL_STATE(1370)] = 46977,
  [SMALL_STATE(1371)] = 47105,
  [SMALL_STATE(1372)] = 47233,
  [SMALL_STATE(1373)] = 47361,
  [SMALL_STATE(1374)] = 47489,
  [SMALL_STATE(1375)] = 47617,
  [SMALL_STATE(1376)] = 47745,
  [SMALL_STATE(1377)] = 47873,
  [SMALL_STATE(1378)] = 48001,
  [SMALL_STATE(1379)] = 48129,
  [SMALL_STATE(1380)] = 48257,
  [SMALL_STATE(1381)] = 48385,
  [SMALL_STATE(1382)] = 48513,
  [SMALL_STATE(1383)] = 48641,
  [SMALL_STATE(1384)] = 48769,
  [SMALL_STATE(1385)] = 48897,
  [SMALL_STATE(1386)] = 49025,
  [SMALL_STATE(1387)] = 49153,
  [SMALL_STATE(1388)] = 49281,
  [SMALL_STATE(1389)] = 49409,
  [SMALL_STATE(1390)] = 49537,
  [SMALL_STATE(1391)] = 49665,
  [SMALL_STATE(1392)] = 49793,
  [SMALL_STATE(1393)] = 49921,
  [SMALL_STATE(1394)] = 50049,
  [SMALL_STATE(1395)] = 50177,
  [SMALL_STATE(1396)] = 50305,
  [SMALL_STATE(1397)] = 50433,
  [SMALL_STATE(1398)] = 50561,
  [SMALL_STATE(1399)] = 50689,
  [SMALL_STATE(1400)] = 50817,
  [SMALL_STATE(1401)] = 50945,
  [SMALL_STATE(1402)] = 51073,
  [SMALL_STATE(1403)] = 51201,
  [SMALL_STATE(1404)] = 51329,
  [SMALL_STATE(1405)] = 51457,
  [SMALL_STATE(1406)] = 51585,
  [SMALL_STATE(1407)] = 51713,
  [SMALL_STATE(1408)] = 51841,
  [SMALL_STATE(1409)] = 51969,
  [SMALL_STATE(1410)] = 52097,
  [SMALL_STATE(1411)] = 52225,
  [SMALL_STATE(1412)] = 52353,
  [SMALL_STATE(1413)] = 52481,
  [SMALL_STATE(1414)] = 52609,
  [SMALL_STATE(1415)] = 52737,
  [SMALL_STATE(1416)] = 52865,
  [SMALL_STATE(1417)] = 52993,
  [SMALL_STATE(1418)] = 53121,
  [SMALL_STATE(1419)] = 53249,
  [SMALL_STATE(1420)] = 53377,
  [SMALL_STATE(1421)] = 53505,
  [SMALL_STATE(1422)] = 53633,
  [SMALL_STATE(1423)] = 53761,
  [SMALL_STATE(1424)] = 53889,
  [SMALL_STATE(1425)] = 54017,
  [SMALL_STATE(1426)] = 54145,
  [SMALL_STATE(1427)] = 54273,
  [SMALL_STATE(1428)] = 54401,
  [SMALL_STATE(1429)] = 54529,
  [SMALL_STATE(1430)] = 54657,
  [SMALL_STATE(1431)] = 54785,
  [SMALL_STATE(1432)] = 54913,
  [SMALL_STATE(1433)] = 55041,
  [SMALL_STATE(1434)] = 55169,
  [SMALL_STATE(1435)] = 55297,
  [SMALL_STATE(1436)] = 55425,
  [SMALL_STATE(1437)] = 55553,
  [SMALL_STATE(1438)] = 55681,
  [SMALL_STATE(1439)] = 55809,
  [SMALL_STATE(1440)] = 55937,
  [SMALL_STATE(1441)] = 56065,
  [SMALL_STATE(1442)] = 56193,
  [SMALL_STATE(1443)] = 56321,
  [SMALL_STATE(1444)] = 56449,
  [SMALL_STATE(1445)] = 56577,
  [SMALL_STATE(1446)] = 56705,
  [SMALL_STATE(1447)] = 56833,
  [SMALL_STATE(1448)] = 56961,
  [SMALL_STATE(1449)] = 57089,
  [SMALL_STATE(1450)] = 57217,
  [SMALL_STATE(1451)] = 57345,
  [SMALL_STATE(1452)] = 57473,
  [SMALL_STATE(1453)] = 57601,
  [SMALL_STATE(1454)] = 57729,
  [SMALL_STATE(1455)] = 57857,
  [SMALL_STATE(1456)] = 57985,
  [SMALL_STATE(1457)] = 58113,
  [SMALL_STATE(1458)] = 58241,
  [SMALL_STATE(1459)] = 58369,
  [SMALL_STATE(1460)] = 58497,
  [SMALL_STATE(1461)] = 58625,
  [SMALL_STATE(1462)] = 58753,
  [SMALL_STATE(1463)] = 58881,
  [SMALL_STATE(1464)] = 59009,
  [SMALL_STATE(1465)] = 59137,
  [SMALL_STATE(1466)] = 59265,
  [SMALL_STATE(1467)] = 59393,
  [SMALL_STATE(1468)] = 59521,
  [SMALL_STATE(1469)] = 59649,
  [SMALL_STATE(1470)] = 59777,
  [SMALL_STATE(1471)] = 59905,
  [SMALL_STATE(1472)] = 60033,
  [SMALL_STATE(1473)] = 60161,
  [SMALL_STATE(1474)] = 60289,
  [SMALL_STATE(1475)] = 60417,
  [SMALL_STATE(1476)] = 60545,
  [SMALL_STATE(1477)] = 60673,
  [SMALL_STATE(1478)] = 60801,
  [SMALL_STATE(1479)] = 60929,
  [SMALL_STATE(1480)] = 61057,
  [SMALL_STATE(1481)] = 61185,
  [SMALL_STATE(1482)] = 61313,
  [SMALL_STATE(1483)] = 61441,
  [SMALL_STATE(1484)] = 61569,
  [SMALL_STATE(1485)] = 61697,
  [SMALL_STATE(1486)] = 61825,
  [SMALL_STATE(1487)] = 61953,
  [SMALL_STATE(1488)] = 62081,
  [SMALL_STATE(1489)] = 62209,
  [SMALL_STATE(1490)] = 62337,
  [SMALL_STATE(1491)] = 62465,
  [SMALL_STATE(1492)] = 62593,
  [SMALL_STATE(1493)] = 62721,
  [SMALL_STATE(1494)] = 62849,
  [SMALL_STATE(1495)] = 62977,
  [SMALL_STATE(1496)] = 63105,
  [SMALL_STATE(1497)] = 63233,
  [SMALL_STATE(1498)] = 63361,
  [SMALL_STATE(1499)] = 63489,
  [SMALL_STATE(1500)] = 63617,
  [SMALL_STATE(1501)] = 63745,
  [SMALL_STATE(1502)] = 63873,
  [SMALL_STATE(1503)] = 64001,
  [SMALL_STATE(1504)] = 64129,
  [SMALL_STATE(1505)] = 64257,
  [SMALL_STATE(1506)] = 64385,
  [SMALL_STATE(1507)] = 64513,
  [SMALL_STATE(1508)] = 64641,
  [SMALL_STATE(1509)] = 64769,
  [SMALL_STATE(1510)] = 64897,
  [SMALL_STATE(1511)] = 65025,
  [SMALL_STATE(1512)] = 65153,
  [SMALL_STATE(1513)] = 65281,
  [SMALL_STATE(1514)] = 65409,
  [SMALL_STATE(1515)] = 65537,
  [SMALL_STATE(1516)] = 65665,
  [SMALL_STATE(1517)] = 65793,
  [SMALL_STATE(1518)] = 65921,
  [SMALL_STATE(1519)] = 66049,
  [SMALL_STATE(1520)] = 66177,
  [SMALL_STATE(1521)] = 66305,
  [SMALL_STATE(1522)] = 66433,
  [SMALL_STATE(1523)] = 66561,
  [SMALL_STATE(1524)] = 66689,
  [SMALL_STATE(1525)] = 66817,
  [SMALL_STATE(1526)] = 66945,
  [SMALL_STATE(1527)] = 67073,
  [SMALL_STATE(1528)] = 67201,
  [SMALL_STATE(1529)] = 67329,
  [SMALL_STATE(1530)] = 67457,
  [SMALL_STATE(1531)] = 67585,
  [SMALL_STATE(1532)] = 67713,
  [SMALL_STATE(1533)] = 67841,
  [SMALL_STATE(1534)] = 67969,
  [SMALL_STATE(1535)] = 68097,
  [SMALL_STATE(1536)] = 68225,
  [SMALL_STATE(1537)] = 68353,
  [SMALL_STATE(1538)] = 68481,
  [SMALL_STATE(1539)] = 68609,
  [SMALL_STATE(1540)] = 68737,
  [SMALL_STATE(1541)] = 68865,
  [SMALL_STATE(1542)] = 68993,
  [SMALL_STATE(1543)] = 69121,
  [SMALL_STATE(1544)] = 69249,
  [SMALL_STATE(1545)] = 69377,
  [SMALL_STATE(1546)] = 69505,
  [SMALL_STATE(1547)] = 69633,
  [SMALL_STATE(1548)] = 69761,
  [SMALL_STATE(1549)] = 69889,
  [SMALL_STATE(1550)] = 70017,
  [SMALL_STATE(1551)] = 70145,
  [SMALL_STATE(1552)] = 70273,
  [SMALL_STATE(1553)] = 70401,
  [SMALL_STATE(1554)] = 70529,
  [SMALL_STATE(1555)] = 70657,
  [SMALL_STATE(1556)] = 70785,
  [SMALL_STATE(1557)] = 70913,
  [SMALL_STATE(1558)] = 71041,
  [SMALL_STATE(1559)] = 71169,
  [SMALL_STATE(1560)] = 71297,
  [SMALL_STATE(1561)] = 71425,
  [SMALL_STATE(1562)] = 71553,
  [SMALL_STATE(1563)] = 71681,
  [SMALL_STATE(1564)] = 71809,
  [SMALL_STATE(1565)] = 71937,
  [SMALL_STATE(1566)] = 72065,
  [SMALL_STATE(1567)] = 72193,
  [SMALL_STATE(1568)] = 72321,
  [SMALL_STATE(1569)] = 72449,
  [SMALL_STATE(1570)] = 72577,
  [SMALL_STATE(1571)] = 72705,
  [SMALL_STATE(1572)] = 72833,
  [SMALL_STATE(1573)] = 72961,
  [SMALL_STATE(1574)] = 73089,
  [SMALL_STATE(1575)] = 73217,
  [SMALL_STATE(1576)] = 73345,
  [SMALL_STATE(1577)] = 73473,
  [SMALL_STATE(1578)] = 73601,
  [SMALL_STATE(1579)] = 73729,
  [SMALL_STATE(1580)] = 73857,
  [SMALL_STATE(1581)] = 73985,
  [SMALL_STATE(1582)] = 74113,
  [SMALL_STATE(1583)] = 74241,
  [SMALL_STATE(1584)] = 74369,
  [SMALL_STATE(1585)] = 74497,
  [SMALL_STATE(1586)] = 74625,
  [SMALL_STATE(1587)] = 74753,
  [SMALL_STATE(1588)] = 74881,
  [SMALL_STATE(1589)] = 75009,
  [SMALL_STATE(1590)] = 75137,
  [SMALL_STATE(1591)] = 75265,
  [SMALL_STATE(1592)] = 75393,
  [SMALL_STATE(1593)] = 75521,
  [SMALL_STATE(1594)] = 75649,
  [SMALL_STATE(1595)] = 75777,
  [SMALL_STATE(1596)] = 75905,
  [SMALL_STATE(1597)] = 76033,
  [SMALL_STATE(1598)] = 76161,
  [SMALL_STATE(1599)] = 76289,
  [SMALL_STATE(1600)] = 76411,
  [SMALL_STATE(1601)] = 76533,
  [SMALL_STATE(1602)] = 76655,
  [SMALL_STATE(1603)] = 76777,
  [SMALL_STATE(1604)] = 76899,
  [SMALL_STATE(1605)] = 77021,
  [SMALL_STATE(1606)] = 77143,
  [SMALL_STATE(1607)] = 77265,
  [SMALL_STATE(1608)] = 77387,
  [SMALL_STATE(1609)] = 77509,
  [SMALL_STATE(1610)] = 77631,
  [SMALL_STATE(1611)] = 77753,
  [SMALL_STATE(1612)] = 77875,
  [SMALL_STATE(1613)] = 77997,
  [SMALL_STATE(1614)] = 78119,
  [SMALL_STATE(1615)] = 78241,
  [SMALL_STATE(1616)] = 78363,
  [SMALL_STATE(1617)] = 78485,
  [SMALL_STATE(1618)] = 78607,
  [SMALL_STATE(1619)] = 78729,
  [SMALL_STATE(1620)] = 78851,
  [SMALL_STATE(1621)] = 78973,
  [SMALL_STATE(1622)] = 79095,
  [SMALL_STATE(1623)] = 79217,
  [SMALL_STATE(1624)] = 79339,
  [SMALL_STATE(1625)] = 79461,
  [SMALL_STATE(1626)] = 79583,
  [SMALL_STATE(1627)] = 79705,
  [SMALL_STATE(1628)] = 79827,
  [SMALL_STATE(1629)] = 79949,
  [SMALL_STATE(1630)] = 80071,
  [SMALL_STATE(1631)] = 80193,
  [SMALL_STATE(1632)] = 80315,
  [SMALL_STATE(1633)] = 80437,
  [SMALL_STATE(1634)] = 80559,
  [SMALL_STATE(1635)] = 80681,
  [SMALL_STATE(1636)] = 80803,
  [SMALL_STATE(1637)] = 80925,
  [SMALL_STATE(1638)] = 81047,
  [SMALL_STATE(1639)] = 81169,
  [SMALL_STATE(1640)] = 81291,
  [SMALL_STATE(1641)] = 81413,
  [SMALL_STATE(1642)] = 81535,
  [SMALL_STATE(1643)] = 81657,
  [SMALL_STATE(1644)] = 81779,
  [SMALL_STATE(1645)] = 81901,
  [SMALL_STATE(1646)] = 82023,
  [SMALL_STATE(1647)] = 82145,
  [SMALL_STATE(1648)] = 82267,
  [SMALL_STATE(1649)] = 82389,
  [SMALL_STATE(1650)] = 82511,
  [SMALL_STATE(1651)] = 82633,
  [SMALL_STATE(1652)] = 82755,
  [SMALL_STATE(1653)] = 82877,
  [SMALL_STATE(1654)] = 82999,
  [SMALL_STATE(1655)] = 83121,
  [SMALL_STATE(1656)] = 83243,
  [SMALL_STATE(1657)] = 83365,
  [SMALL_STATE(1658)] = 83487,
  [SMALL_STATE(1659)] = 83609,
  [SMALL_STATE(1660)] = 83731,
  [SMALL_STATE(1661)] = 83853,
  [SMALL_STATE(1662)] = 83975,
  [SMALL_STATE(1663)] = 84097,
  [SMALL_STATE(1664)] = 84219,
  [SMALL_STATE(1665)] = 84341,
  [SMALL_STATE(1666)] = 84463,
  [SMALL_STATE(1667)] = 84585,
  [SMALL_STATE(1668)] = 84707,
  [SMALL_STATE(1669)] = 84829,
  [SMALL_STATE(1670)] = 84951,
  [SMALL_STATE(1671)] = 85073,
  [SMALL_STATE(1672)] = 85195,
  [SMALL_STATE(1673)] = 85317,
  [SMALL_STATE(1674)] = 85439,
  [SMALL_STATE(1675)] = 85561,
  [SMALL_STATE(1676)] = 85683,
  [SMALL_STATE(1677)] = 85805,
  [SMALL_STATE(1678)] = 85927,
  [SMALL_STATE(1679)] = 86049,
  [SMALL_STATE(1680)] = 86171,
  [SMALL_STATE(1681)] = 86293,
  [SMALL_STATE(1682)] = 86415,
  [SMALL_STATE(1683)] = 86537,
  [SMALL_STATE(1684)] = 86659,
  [SMALL_STATE(1685)] = 86781,
  [SMALL_STATE(1686)] = 86903,
  [SMALL_STATE(1687)] = 87025,
  [SMALL_STATE(1688)] = 87147,
  [SMALL_STATE(1689)] = 87269,
  [SMALL_STATE(1690)] = 87391,
  [SMALL_STATE(1691)] = 87513,
  [SMALL_STATE(1692)] = 87635,
  [SMALL_STATE(1693)] = 87757,
  [SMALL_STATE(1694)] = 87879,
  [SMALL_STATE(1695)] = 88001,
  [SMALL_STATE(1696)] = 88123,
  [SMALL_STATE(1697)] = 88245,
  [SMALL_STATE(1698)] = 88367,
  [SMALL_STATE(1699)] = 88489,
  [SMALL_STATE(1700)] = 88611,
  [SMALL_STATE(1701)] = 88733,
  [SMALL_STATE(1702)] = 88855,
  [SMALL_STATE(1703)] = 88977,
  [SMALL_STATE(1704)] = 89099,
  [SMALL_STATE(1705)] = 89221,
  [SMALL_STATE(1706)] = 89343,
  [SMALL_STATE(1707)] = 89465,
  [SMALL_STATE(1708)] = 89587,
  [SMALL_STATE(1709)] = 89709,
  [SMALL_STATE(1710)] = 89831,
  [SMALL_STATE(1711)] = 89953,
  [SMALL_STATE(1712)] = 90075,
  [SMALL_STATE(1713)] = 90197,
  [SMALL_STATE(1714)] = 90319,
  [SMALL_STATE(1715)] = 90441,
  [SMALL_STATE(1716)] = 90563,
  [SMALL_STATE(1717)] = 90685,
  [SMALL_STATE(1718)] = 90807,
  [SMALL_STATE(1719)] = 90929,
  [SMALL_STATE(1720)] = 91000,
  [SMALL_STATE(1721)] = 91071,
  [SMALL_STATE(1722)] = 91141,
  [SMALL_STATE(1723)] = 91211,
  [SMALL_STATE(1724)] = 91276,
  [SMALL_STATE(1725)] = 91384,
  [SMALL_STATE(1726)] = 91492,
  [SMALL_STATE(1727)] = 91600,
  [SMALL_STATE(1728)] = 91708,
  [SMALL_STATE(1729)] = 91816,
  [SMALL_STATE(1730)] = 91880,
  [SMALL_STATE(1731)] = 91988,
  [SMALL_STATE(1732)] = 92096,
  [SMALL_STATE(1733)] = 92204,
  [SMALL_STATE(1734)] = 92295,
  [SMALL_STATE(1735)] = 92398,
  [SMALL_STATE(1736)] = 92501,
  [SMALL_STATE(1737)] = 92604,
  [SMALL_STATE(1738)] = 92707,
  [SMALL_STATE(1739)] = 92802,
  [SMALL_STATE(1740)] = 92905,
  [SMALL_STATE(1741)] = 92992,
  [SMALL_STATE(1742)] = 93063,
  [SMALL_STATE(1743)] = 93158,
  [SMALL_STATE(1744)] = 93245,
  [SMALL_STATE(1745)] = 93348,
  [SMALL_STATE(1746)] = 93451,
  [SMALL_STATE(1747)] = 93552,
  [SMALL_STATE(1748)] = 93655,
  [SMALL_STATE(1749)] = 93758,
  [SMALL_STATE(1750)] = 93811,
  [SMALL_STATE(1751)] = 93906,
  [SMALL_STATE(1752)] = 93985,
  [SMALL_STATE(1753)] = 94088,
  [SMALL_STATE(1754)] = 94185,
  [SMALL_STATE(1755)] = 94288,
  [SMALL_STATE(1756)] = 94391,
  [SMALL_STATE(1757)] = 94478,
  [SMALL_STATE(1758)] = 94581,
  [SMALL_STATE(1759)] = 94656,
  [SMALL_STATE(1760)] = 94727,
  [SMALL_STATE(1761)] = 94798,
  [SMALL_STATE(1762)] = 94871,
  [SMALL_STATE(1763)] = 94942,
  [SMALL_STATE(1764)] = 95045,
  [SMALL_STATE(1765)] = 95148,
  [SMALL_STATE(1766)] = 95251,
  [SMALL_STATE(1767)] = 95352,
  [SMALL_STATE(1768)] = 95455,
  [SMALL_STATE(1769)] = 95550,
  [SMALL_STATE(1770)] = 95629,
  [SMALL_STATE(1771)] = 95732,
  [SMALL_STATE(1772)] = 95829,
  [SMALL_STATE(1773)] = 95932,
  [SMALL_STATE(1774)] = 96023,
  [SMALL_STATE(1775)] = 96110,
  [SMALL_STATE(1776)] = 96193,
  [SMALL_STATE(1777)] = 96268,
  [SMALL_STATE(1778)] = 96371,
  [SMALL_STATE(1779)] = 96442,
  [SMALL_STATE(1780)] = 96515,
  [SMALL_STATE(1781)] = 96586,
  [SMALL_STATE(1782)] = 96689,
  [SMALL_STATE(1783)] = 96792,
  [SMALL_STATE(1784)] = 96875,
  [SMALL_STATE(1785)] = 96971,
  [SMALL_STATE(1786)] = 97045,
  [SMALL_STATE(1787)] = 97151,
  [SMALL_STATE(1788)] = 97253,
  [SMALL_STATE(1789)] = 97323,
  [SMALL_STATE(1790)] = 97429,
  [SMALL_STATE(1791)] = 97535,
  [SMALL_STATE(1792)] = 97641,
  [SMALL_STATE(1793)] = 97747,
  [SMALL_STATE(1794)] = 97853,
  [SMALL_STATE(1795)] = 97955,
  [SMALL_STATE(1796)] = 98055,
  [SMALL_STATE(1797)] = 98157,
  [SMALL_STATE(1798)] = 98251,
  [SMALL_STATE(1799)] = 98329,
  [SMALL_STATE(1800)] = 98435,
  [SMALL_STATE(1801)] = 98541,
  [SMALL_STATE(1802)] = 98643,
  [SMALL_STATE(1803)] = 98745,
  [SMALL_STATE(1804)] = 98851,
  [SMALL_STATE(1805)] = 98957,
  [SMALL_STATE(1806)] = 99059,
  [SMALL_STATE(1807)] = 99155,
  [SMALL_STATE(1808)] = 99245,
  [SMALL_STATE(1809)] = 99331,
  [SMALL_STATE(1810)] = 99437,
  [SMALL_STATE(1811)] = 99543,
  [SMALL_STATE(1812)] = 99625,
  [SMALL_STATE(1813)] = 99699,
  [SMALL_STATE(1814)] = 99805,
  [SMALL_STATE(1815)] = 99911,
  [SMALL_STATE(1816)] = 100017,
  [SMALL_STATE(1817)] = 100087,
  [SMALL_STATE(1818)] = 100159,
  [SMALL_STATE(1819)] = 100265,
  [SMALL_STATE(1820)] = 100335,
  [SMALL_STATE(1821)] = 100441,
  [SMALL_STATE(1822)] = 100547,
  [SMALL_STATE(1823)] = 100653,
  [SMALL_STATE(1824)] = 100759,
  [SMALL_STATE(1825)] = 100865,
  [SMALL_STATE(1826)] = 100971,
  [SMALL_STATE(1827)] = 101077,
  [SMALL_STATE(1828)] = 101179,
  [SMALL_STATE(1829)] = 101285,
  [SMALL_STATE(1830)] = 101391,
  [SMALL_STATE(1831)] = 101497,
  [SMALL_STATE(1832)] = 101603,
  [SMALL_STATE(1833)] = 101709,
  [SMALL_STATE(1834)] = 101779,
  [SMALL_STATE(1835)] = 101885,
  [SMALL_STATE(1836)] = 101991,
  [SMALL_STATE(1837)] = 102097,
  [SMALL_STATE(1838)] = 102203,
  [SMALL_STATE(1839)] = 102309,
  [SMALL_STATE(1840)] = 102411,
  [SMALL_STATE(1841)] = 102505,
  [SMALL_STATE(1842)] = 102611,
  [SMALL_STATE(1843)] = 102717,
  [SMALL_STATE(1844)] = 102807,
  [SMALL_STATE(1845)] = 102909,
  [SMALL_STATE(1846)] = 103015,
  [SMALL_STATE(1847)] = 103121,
  [SMALL_STATE(1848)] = 103227,
  [SMALL_STATE(1849)] = 103327,
  [SMALL_STATE(1850)] = 103433,
  [SMALL_STATE(1851)] = 103539,
  [SMALL_STATE(1852)] = 103643,
  [SMALL_STATE(1853)] = 103721,
  [SMALL_STATE(1854)] = 103823,
  [SMALL_STATE(1855)] = 103917,
  [SMALL_STATE(1856)] = 104023,
  [SMALL_STATE(1857)] = 104129,
  [SMALL_STATE(1858)] = 104235,
  [SMALL_STATE(1859)] = 104341,
  [SMALL_STATE(1860)] = 104447,
  [SMALL_STATE(1861)] = 104553,
  [SMALL_STATE(1862)] = 104655,
  [SMALL_STATE(1863)] = 104727,
  [SMALL_STATE(1864)] = 104833,
  [SMALL_STATE(1865)] = 104939,
  [SMALL_STATE(1866)] = 105025,
  [SMALL_STATE(1867)] = 105131,
  [SMALL_STATE(1868)] = 105237,
  [SMALL_STATE(1869)] = 105339,
  [SMALL_STATE(1870)] = 105441,
  [SMALL_STATE(1871)] = 105547,
  [SMALL_STATE(1872)] = 105599,
  [SMALL_STATE(1873)] = 105705,
  [SMALL_STATE(1874)] = 105807,
  [SMALL_STATE(1875)] = 105909,
  [SMALL_STATE(1876)] = 106015,
  [SMALL_STATE(1877)] = 106121,
  [SMALL_STATE(1878)] = 106223,
  [SMALL_STATE(1879)] = 106329,
  [SMALL_STATE(1880)] = 106431,
  [SMALL_STATE(1881)] = 106537,
  [SMALL_STATE(1882)] = 106619,
  [SMALL_STATE(1883)] = 106725,
  [SMALL_STATE(1884)] = 106795,
  [SMALL_STATE(1885)] = 106901,
  [SMALL_STATE(1886)] = 107007,
  [SMALL_STATE(1887)] = 107113,
  [SMALL_STATE(1888)] = 107219,
  [SMALL_STATE(1889)] = 107325,
  [SMALL_STATE(1890)] = 107419,
  [SMALL_STATE(1891)] = 107525,
  [SMALL_STATE(1892)] = 107631,
  [SMALL_STATE(1893)] = 107737,
  [SMALL_STATE(1894)] = 107843,
  [SMALL_STATE(1895)] = 107929,
  [SMALL_STATE(1896)] = 107999,
  [SMALL_STATE(1897)] = 108105,
  [SMALL_STATE(1898)] = 108211,
  [SMALL_STATE(1899)] = 108317,
  [SMALL_STATE(1900)] = 108423,
  [SMALL_STATE(1901)] = 108509,
  [SMALL_STATE(1902)] = 108611,
  [SMALL_STATE(1903)] = 108717,
  [SMALL_STATE(1904)] = 108819,
  [SMALL_STATE(1905)] = 108921,
  [SMALL_STATE(1906)] = 109023,
  [SMALL_STATE(1907)] = 109125,
  [SMALL_STATE(1908)] = 109231,
  [SMALL_STATE(1909)] = 109276,
  [SMALL_STATE(1910)] = 109321,
  [SMALL_STATE(1911)] = 109366,
  [SMALL_STATE(1912)] = 109411,
  [SMALL_STATE(1913)] = 109456,
  [SMALL_STATE(1914)] = 109501,
  [SMALL_STATE(1915)] = 109550,
  [SMALL_STATE(1916)] = 109595,
  [SMALL_STATE(1917)] = 109640,
  [SMALL_STATE(1918)] = 109685,
  [SMALL_STATE(1919)] = 109730,
  [SMALL_STATE(1920)] = 109775,
  [SMALL_STATE(1921)] = 109820,
  [SMALL_STATE(1922)] = 109865,
  [SMALL_STATE(1923)] = 109910,
  [SMALL_STATE(1924)] = 109955,
  [SMALL_STATE(1925)] = 110000,
  [SMALL_STATE(1926)] = 110045,
  [SMALL_STATE(1927)] = 110090,
  [SMALL_STATE(1928)] = 110135,
  [SMALL_STATE(1929)] = 110180,
  [SMALL_STATE(1930)] = 110229,
  [SMALL_STATE(1931)] = 110274,
  [SMALL_STATE(1932)] = 110319,
  [SMALL_STATE(1933)] = 110364,
  [SMALL_STATE(1934)] = 110409,
  [SMALL_STATE(1935)] = 110454,
  [SMALL_STATE(1936)] = 110499,
  [SMALL_STATE(1937)] = 110544,
  [SMALL_STATE(1938)] = 110589,
  [SMALL_STATE(1939)] = 110634,
  [SMALL_STATE(1940)] = 110678,
  [SMALL_STATE(1941)] = 110726,
  [SMALL_STATE(1942)] = 110770,
  [SMALL_STATE(1943)] = 110814,
  [SMALL_STATE(1944)] = 110858,
  [SMALL_STATE(1945)] = 110902,
  [SMALL_STATE(1946)] = 110950,
  [SMALL_STATE(1947)] = 110994,
  [SMALL_STATE(1948)] = 111038,
  [SMALL_STATE(1949)] = 111086,
  [SMALL_STATE(1950)] = 111130,
  [SMALL_STATE(1951)] = 111173,
  [SMALL_STATE(1952)] = 111216,
  [SMALL_STATE(1953)] = 111259,
  [SMALL_STATE(1954)] = 111302,
  [SMALL_STATE(1955)] = 111345,
  [SMALL_STATE(1956)] = 111388,
  [SMALL_STATE(1957)] = 111431,
  [SMALL_STATE(1958)] = 111474,
  [SMALL_STATE(1959)] = 111517,
  [SMALL_STATE(1960)] = 111560,
  [SMALL_STATE(1961)] = 111603,
  [SMALL_STATE(1962)] = 111646,
  [SMALL_STATE(1963)] = 111689,
  [SMALL_STATE(1964)] = 111732,
  [SMALL_STATE(1965)] = 111775,
  [SMALL_STATE(1966)] = 111818,
  [SMALL_STATE(1967)] = 111861,
  [SMALL_STATE(1968)] = 111904,
  [SMALL_STATE(1969)] = 111947,
  [SMALL_STATE(1970)] = 111990,
  [SMALL_STATE(1971)] = 112033,
  [SMALL_STATE(1972)] = 112076,
  [SMALL_STATE(1973)] = 112118,
  [SMALL_STATE(1974)] = 112160,
  [SMALL_STATE(1975)] = 112202,
  [SMALL_STATE(1976)] = 112244,
  [SMALL_STATE(1977)] = 112286,
  [SMALL_STATE(1978)] = 112328,
  [SMALL_STATE(1979)] = 112370,
  [SMALL_STATE(1980)] = 112412,
  [SMALL_STATE(1981)] = 112454,
  [SMALL_STATE(1982)] = 112496,
  [SMALL_STATE(1983)] = 112538,
  [SMALL_STATE(1984)] = 112580,
  [SMALL_STATE(1985)] = 112622,
  [SMALL_STATE(1986)] = 112664,
  [SMALL_STATE(1987)] = 112706,
  [SMALL_STATE(1988)] = 112748,
  [SMALL_STATE(1989)] = 112790,
  [SMALL_STATE(1990)] = 112832,
  [SMALL_STATE(1991)] = 112874,
  [SMALL_STATE(1992)] = 112899,
  [SMALL_STATE(1993)] = 112918,
  [SMALL_STATE(1994)] = 112934,
  [SMALL_STATE(1995)] = 112948,
  [SMALL_STATE(1996)] = 112964,
  [SMALL_STATE(1997)] = 112978,
  [SMALL_STATE(1998)] = 112992,
  [SMALL_STATE(1999)] = 113006,
  [SMALL_STATE(2000)] = 113020,
  [SMALL_STATE(2001)] = 113034,
  [SMALL_STATE(2002)] = 113048,
  [SMALL_STATE(2003)] = 113062,
  [SMALL_STATE(2004)] = 113078,
  [SMALL_STATE(2005)] = 113094,
  [SMALL_STATE(2006)] = 113108,
  [SMALL_STATE(2007)] = 113122,
  [SMALL_STATE(2008)] = 113136,
  [SMALL_STATE(2009)] = 113150,
  [SMALL_STATE(2010)] = 113164,
  [SMALL_STATE(2011)] = 113178,
  [SMALL_STATE(2012)] = 113192,
  [SMALL_STATE(2013)] = 113206,
  [SMALL_STATE(2014)] = 113220,
  [SMALL_STATE(2015)] = 113234,
  [SMALL_STATE(2016)] = 113250,
  [SMALL_STATE(2017)] = 113264,
  [SMALL_STATE(2018)] = 113278,
  [SMALL_STATE(2019)] = 113292,
  [SMALL_STATE(2020)] = 113306,
  [SMALL_STATE(2021)] = 113320,
  [SMALL_STATE(2022)] = 113336,
  [SMALL_STATE(2023)] = 113350,
  [SMALL_STATE(2024)] = 113366,
  [SMALL_STATE(2025)] = 113380,
  [SMALL_STATE(2026)] = 113394,
  [SMALL_STATE(2027)] = 113408,
  [SMALL_STATE(2028)] = 113422,
  [SMALL_STATE(2029)] = 113436,
  [SMALL_STATE(2030)] = 113450,
  [SMALL_STATE(2031)] = 113464,
  [SMALL_STATE(2032)] = 113480,
  [SMALL_STATE(2033)] = 113496,
  [SMALL_STATE(2034)] = 113510,
  [SMALL_STATE(2035)] = 113524,
  [SMALL_STATE(2036)] = 113538,
  [SMALL_STATE(2037)] = 113554,
  [SMALL_STATE(2038)] = 113570,
  [SMALL_STATE(2039)] = 113584,
  [SMALL_STATE(2040)] = 113598,
  [SMALL_STATE(2041)] = 113614,
  [SMALL_STATE(2042)] = 113630,
  [SMALL_STATE(2043)] = 113644,
  [SMALL_STATE(2044)] = 113660,
  [SMALL_STATE(2045)] = 113676,
  [SMALL_STATE(2046)] = 113690,
  [SMALL_STATE(2047)] = 113706,
  [SMALL_STATE(2048)] = 113722,
  [SMALL_STATE(2049)] = 113736,
  [SMALL_STATE(2050)] = 113752,
  [SMALL_STATE(2051)] = 113768,
  [SMALL_STATE(2052)] = 113784,
  [SMALL_STATE(2053)] = 113800,
  [SMALL_STATE(2054)] = 113814,
  [SMALL_STATE(2055)] = 113830,
  [SMALL_STATE(2056)] = 113844,
  [SMALL_STATE(2057)] = 113860,
  [SMALL_STATE(2058)] = 113876,
  [SMALL_STATE(2059)] = 113890,
  [SMALL_STATE(2060)] = 113906,
  [SMALL_STATE(2061)] = 113920,
  [SMALL_STATE(2062)] = 113936,
  [SMALL_STATE(2063)] = 113950,
  [SMALL_STATE(2064)] = 113966,
  [SMALL_STATE(2065)] = 113980,
  [SMALL_STATE(2066)] = 113996,
  [SMALL_STATE(2067)] = 114010,
  [SMALL_STATE(2068)] = 114026,
  [SMALL_STATE(2069)] = 114040,
  [SMALL_STATE(2070)] = 114056,
  [SMALL_STATE(2071)] = 114072,
  [SMALL_STATE(2072)] = 114088,
  [SMALL_STATE(2073)] = 114102,
  [SMALL_STATE(2074)] = 114118,
  [SMALL_STATE(2075)] = 114134,
  [SMALL_STATE(2076)] = 114150,
  [SMALL_STATE(2077)] = 114166,
  [SMALL_STATE(2078)] = 114182,
  [SMALL_STATE(2079)] = 114198,
  [SMALL_STATE(2080)] = 114214,
  [SMALL_STATE(2081)] = 114230,
  [SMALL_STATE(2082)] = 114246,
  [SMALL_STATE(2083)] = 114262,
  [SMALL_STATE(2084)] = 114278,
  [SMALL_STATE(2085)] = 114294,
  [SMALL_STATE(2086)] = 114310,
  [SMALL_STATE(2087)] = 114326,
  [SMALL_STATE(2088)] = 114342,
  [SMALL_STATE(2089)] = 114358,
  [SMALL_STATE(2090)] = 114372,
  [SMALL_STATE(2091)] = 114388,
  [SMALL_STATE(2092)] = 114404,
  [SMALL_STATE(2093)] = 114420,
  [SMALL_STATE(2094)] = 114436,
  [SMALL_STATE(2095)] = 114452,
  [SMALL_STATE(2096)] = 114468,
  [SMALL_STATE(2097)] = 114484,
  [SMALL_STATE(2098)] = 114500,
  [SMALL_STATE(2099)] = 114516,
  [SMALL_STATE(2100)] = 114532,
  [SMALL_STATE(2101)] = 114548,
  [SMALL_STATE(2102)] = 114564,
  [SMALL_STATE(2103)] = 114580,
  [SMALL_STATE(2104)] = 114596,
  [SMALL_STATE(2105)] = 114612,
  [SMALL_STATE(2106)] = 114628,
  [SMALL_STATE(2107)] = 114644,
  [SMALL_STATE(2108)] = 114660,
  [SMALL_STATE(2109)] = 114676,
  [SMALL_STATE(2110)] = 114692,
  [SMALL_STATE(2111)] = 114708,
  [SMALL_STATE(2112)] = 114724,
  [SMALL_STATE(2113)] = 114740,
  [SMALL_STATE(2114)] = 114756,
  [SMALL_STATE(2115)] = 114772,
  [SMALL_STATE(2116)] = 114788,
  [SMALL_STATE(2117)] = 114802,
  [SMALL_STATE(2118)] = 114813,
  [SMALL_STATE(2119)] = 114826,
  [SMALL_STATE(2120)] = 114839,
  [SMALL_STATE(2121)] = 114852,
  [SMALL_STATE(2122)] = 114863,
  [SMALL_STATE(2123)] = 114876,
  [SMALL_STATE(2124)] = 114889,
  [SMALL_STATE(2125)] = 114902,
  [SMALL_STATE(2126)] = 114915,
  [SMALL_STATE(2127)] = 114928,
  [SMALL_STATE(2128)] = 114941,
  [SMALL_STATE(2129)] = 114954,
  [SMALL_STATE(2130)] = 114965,
  [SMALL_STATE(2131)] = 114978,
  [SMALL_STATE(2132)] = 114991,
  [SMALL_STATE(2133)] = 115004,
  [SMALL_STATE(2134)] = 115017,
  [SMALL_STATE(2135)] = 115027,
  [SMALL_STATE(2136)] = 115035,
  [SMALL_STATE(2137)] = 115045,
  [SMALL_STATE(2138)] = 115055,
  [SMALL_STATE(2139)] = 115063,
  [SMALL_STATE(2140)] = 115073,
  [SMALL_STATE(2141)] = 115083,
  [SMALL_STATE(2142)] = 115093,
  [SMALL_STATE(2143)] = 115103,
  [SMALL_STATE(2144)] = 115113,
  [SMALL_STATE(2145)] = 115123,
  [SMALL_STATE(2146)] = 115133,
  [SMALL_STATE(2147)] = 115141,
  [SMALL_STATE(2148)] = 115151,
  [SMALL_STATE(2149)] = 115161,
  [SMALL_STATE(2150)] = 115169,
  [SMALL_STATE(2151)] = 115176,
  [SMALL_STATE(2152)] = 115183,
  [SMALL_STATE(2153)] = 115190,
  [SMALL_STATE(2154)] = 115197,
  [SMALL_STATE(2155)] = 115204,
  [SMALL_STATE(2156)] = 115211,
  [SMALL_STATE(2157)] = 115218,
  [SMALL_STATE(2158)] = 115225,
  [SMALL_STATE(2159)] = 115232,
  [SMALL_STATE(2160)] = 115239,
  [SMALL_STATE(2161)] = 115246,
  [SMALL_STATE(2162)] = 115253,
  [SMALL_STATE(2163)] = 115260,
  [SMALL_STATE(2164)] = 115267,
  [SMALL_STATE(2165)] = 115274,
  [SMALL_STATE(2166)] = 115281,
  [SMALL_STATE(2167)] = 115288,
  [SMALL_STATE(2168)] = 115295,
  [SMALL_STATE(2169)] = 115302,
  [SMALL_STATE(2170)] = 115309,
  [SMALL_STATE(2171)] = 115316,
  [SMALL_STATE(2172)] = 115323,
  [SMALL_STATE(2173)] = 115330,
  [SMALL_STATE(2174)] = 115337,
  [SMALL_STATE(2175)] = 115344,
  [SMALL_STATE(2176)] = 115351,
  [SMALL_STATE(2177)] = 115358,
  [SMALL_STATE(2178)] = 115365,
  [SMALL_STATE(2179)] = 115372,
  [SMALL_STATE(2180)] = 115379,
  [SMALL_STATE(2181)] = 115386,
  [SMALL_STATE(2182)] = 115393,
  [SMALL_STATE(2183)] = 115400,
  [SMALL_STATE(2184)] = 115407,
  [SMALL_STATE(2185)] = 115414,
  [SMALL_STATE(2186)] = 115421,
  [SMALL_STATE(2187)] = 115428,
  [SMALL_STATE(2188)] = 115435,
  [SMALL_STATE(2189)] = 115442,
  [SMALL_STATE(2190)] = 115449,
  [SMALL_STATE(2191)] = 115456,
  [SMALL_STATE(2192)] = 115463,
  [SMALL_STATE(2193)] = 115470,
  [SMALL_STATE(2194)] = 115477,
  [SMALL_STATE(2195)] = 115484,
  [SMALL_STATE(2196)] = 115491,
  [SMALL_STATE(2197)] = 115498,
  [SMALL_STATE(2198)] = 115505,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(706),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2122),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2003),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2023),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2004),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1431),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(958),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [51] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 32),
  [53] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 32),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1272),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1274),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1277),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1278),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1283),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, 0, 40),
  [103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, 0, 40),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1542),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1548),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1550),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1551),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1552),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1553),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1554),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1561),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 35),
  [153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 35),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1064),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1066),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1068),
  [169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1069),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1071),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1072),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1075),
  [193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 36),
  [207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 36),
  [209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1132),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1134),
  [221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1136),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1138),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1140),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1143),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1380),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1382),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1384),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1385),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1386),
  [291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1387),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1388),
  [301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1391),
  [309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 8, 0, 44),
  [369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 8, 0, 44),
  [371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_operator, 3, 0, 15),
  [373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_operator, 3, 0, 15),
  [375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, 0, 23),
  [377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, 0, 23),
  [379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_operator, 4, 0, 25),
  [381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_operator, 4, 0, 25),
  [383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, 0, 33),
  [385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, 0, 33),
  [387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 6, 0, 37),
  [389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 6, 0, 37),
  [391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 6, 0, 38),
  [393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 6, 0, 38),
  [395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, 0, 39),
  [397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, 0, 39),
  [399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 41),
  [401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 41),
  [403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 7, 0, 42),
  [405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 7, 0, 42),
  [407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 8, 0, 43),
  [409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 8, 0, 43),
  [411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 45),
  [413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 45),
  [415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 46),
  [417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 46),
  [419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 9, 0, 47),
  [421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 9, 0, 47),
  [423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, 0, 48),
  [425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, 0, 48),
  [427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_statement, 2, 0, 2),
  [429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_statement, 2, 0, 2),
  [431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_operator, 2, 0, 3),
  [433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_operator, 2, 0, 3),
  [435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 3, 0, 8),
  [437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 3, 0, 8),
  [439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_statement, 3, 0, 12),
  [441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_statement, 3, 0, 12),
  [443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_operator, 3, 0, 13),
  [445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_operator, 3, 0, 13),
  [447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 1, 0, 0),
  [449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 1, 0, 0),
  [451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1453),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1499),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1505),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1511),
  [469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1517),
  [471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1522),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1525),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1562),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1348),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1360),
  [505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1362),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1363),
  [513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1395),
  [515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1396),
  [521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1397),
  [525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1400),
  [533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(728),
  [543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2127),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2078),
  [549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2100),
  [551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2046),
  [553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1144),
  [555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(734),
  [567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2066),
  [569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(491),
  [573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(908),
  [575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2118),
  [597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2080),
  [599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2102),
  [601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2049),
  [603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1330),
  [605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(556),
  [623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(880),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1172),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1176),
  [653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1177),
  [657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1179),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1183),
  [677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1364),
  [691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1370),
  [697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1374),
  [701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1376),
  [705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1377),
  [707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1378),
  [713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1379),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1394),
  [725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2123),
  [743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2071),
  [745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2093),
  [747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2036),
  [749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1403),
  [751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(722),
  [763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(429),
  [769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(982),
  [771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extract_operator, 2, 0, 4),
  [793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(770),
  [795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extract_operator, 2, 0, 4),
  [797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 1, 0, 6),
  [807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 1, 0, 6),
  [809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extract_operator, 3, 0, 4),
  [813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extract_operator, 3, 0, 4),
  [817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__argument_value, 1, 0, 16),
  [823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_value, 1, 0, 16),
  [825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1472),
  [827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1479),
  [835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1481),
  [839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1482),
  [843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1004),
  [845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1491),
  [851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1496),
  [863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(860),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(792),
  [889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(774),
  [895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1963),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1966),
  [921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(822),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(829),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1984),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [1007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [1009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [1013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [1015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [1021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1962),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1967),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [1027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [1029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [1031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [1033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [1035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [1037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [1039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [1043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [1045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(977),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(895),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [1051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 1, 0, 6),
  [1053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 1, 0, 6),
  [1055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(788),
  [1057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_operator, 2, 0, 4),
  [1059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_operator, 2, 0, 4),
  [1061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(784),
  [1063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(913),
  [1065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(896),
  [1067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [1069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [1071] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(728),
  [1074] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(2127),
  [1077] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(2127),
  [1080] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(2078),
  [1083] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(2100),
  [1086] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(2046),
  [1089] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(1144),
  [1092] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(1145),
  [1095] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(1146),
  [1098] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(1147),
  [1101] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(1148),
  [1104] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(734),
  [1107] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(734),
  [1110] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(2066),
  [1113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(1994),
  [1116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(491),
  [1119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(908),
  [1122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(917),
  [1125] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(491),
  [1128] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(1934),
  [1131] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(1926),
  [1134] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(713),
  [1137] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(948),
  [1140] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(751),
  [1143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(877),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [1155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(724),
  [1158] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(2118),
  [1161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(2118),
  [1164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(2080),
  [1167] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(2102),
  [1170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(2049),
  [1173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(1330),
  [1176] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(1331),
  [1179] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(1332),
  [1182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(1333),
  [1185] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(1334),
  [1188] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(710),
  [1191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(710),
  [1194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(2038),
  [1197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(2039),
  [1200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(556),
  [1203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(926),
  [1206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(880),
  [1209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(556),
  [1212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(1928),
  [1215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(1925),
  [1218] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(717),
  [1221] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(955),
  [1224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(857),
  [1227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(826),
  [1229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(947),
  [1231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(914),
  [1233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(994),
  [1235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(937),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [1239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(866),
  [1241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(986),
  [1243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [1245] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(721),
  [1248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(2123),
  [1251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(2123),
  [1254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(2071),
  [1257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(2093),
  [1260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(2036),
  [1263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(1403),
  [1266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(1405),
  [1269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(1406),
  [1272] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(1407),
  [1275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(1409),
  [1278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(722),
  [1281] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(722),
  [1284] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(2020),
  [1287] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(2022),
  [1290] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(429),
  [1293] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(982),
  [1296] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(956),
  [1299] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(429),
  [1302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(1912),
  [1305] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(1918),
  [1308] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(742),
  [1311] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(907),
  [1314] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 2, 0, 27), SHIFT_REPEAT(842),
  [1317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(878),
  [1319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(881),
  [1321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(931),
  [1323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(886),
  [1325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(998),
  [1327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__double_quoted_string, 2, 0, 0),
  [1329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__double_quoted_string, 2, 0, 0),
  [1331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0),
  [1333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0),
  [1335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_or_identifier, 1, 0, 0),
  [1337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_or_identifier, 1, 0, 0),
  [1339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_float, 1, 0, 0),
  [1341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_float, 1, 0, 0),
  [1343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(873),
  [1345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(833),
  [1347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 1, 0, 1),
  [1349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 1, 0, 1),
  [1351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__single_quoted_string, 2, 0, 0),
  [1353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__single_quoted_string, 2, 0, 0),
  [1355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__single_quoted_string, 3, 0, 14),
  [1357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__single_quoted_string, 3, 0, 14),
  [1359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__double_quoted_string, 3, 0, 14),
  [1361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__double_quoted_string, 3, 0, 14),
  [1363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 1, 0, 0),
  [1365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 1, 0, 0),
  [1367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(799),
  [1369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [1371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [1373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [1375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [1377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(845),
  [1379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [1381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(787),
  [1383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0),
  [1385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0),
  [1387] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(702),
  [1390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(973),
  [1392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(978),
  [1394] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(720),
  [1397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(950),
  [1399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(890),
  [1401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(892),
  [1403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(723),
  [1406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(915),
  [1408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(922),
  [1410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(731),
  [1413] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(732),
  [1416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [1418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [1420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(932),
  [1422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(935),
  [1424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [1426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(965),
  [1428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [1430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [1432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2124),
  [1434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2074),
  [1436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2096),
  [1438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2040),
  [1440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1301),
  [1442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [1444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [1446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [1448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [1450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [1452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [1454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [1456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(898),
  [1458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [1460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [1462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [1464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [1466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [1468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 2, 0, 5),
  [1470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 2, 0, 5),
  [1472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subset, 2, 0, 5),
  [1474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subset, 2, 0, 5),
  [1476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subset2, 2, 0, 5),
  [1478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subset2, 2, 0, 5),
  [1480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 2, 0, 7),
  [1482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 2, 0, 7),
  [1484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_braced_expression, 2, 0, 7),
  [1486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_braced_expression, 2, 0, 7),
  [1488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [1490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [1492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subset2_arguments, 3, 0, 26),
  [1494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subset2_arguments, 3, 0, 26),
  [1496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [1498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [1500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extract_operator, 3, 0, 15),
  [1502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extract_operator, 3, 0, 15),
  [1504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_arguments, 2, 0, 7),
  [1506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_arguments, 2, 0, 7),
  [1508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subset_arguments, 2, 0, 7),
  [1510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subset_arguments, 2, 0, 7),
  [1512] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(765),
  [1515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subset2_arguments, 2, 0, 7),
  [1517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subset2_arguments, 2, 0, 7),
  [1519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_operator, 3, 0, 15),
  [1521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_operator, 3, 0, 15),
  [1523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 21),
  [1525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 21),
  [1527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_braced_expression, 3, 0, 21),
  [1529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_braced_expression, 3, 0, 21),
  [1531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_na, 1, 0, 0),
  [1533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_na, 1, 0, 0),
  [1535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_integer, 2, 0, 0),
  [1537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_integer, 2, 0, 0),
  [1539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extract_operator, 4, 0, 25),
  [1541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extract_operator, 4, 0, 25),
  [1543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_arguments, 3, 0, 26),
  [1545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_arguments, 3, 0, 26),
  [1547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subset_arguments, 3, 0, 26),
  [1549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subset_arguments, 3, 0, 26),
  [1551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex, 2, 0, 0),
  [1553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex, 2, 0, 0),
  [1555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [1557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(796),
  [1560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(797),
  [1563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [1565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [1567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [1569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [1571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [1573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [1575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(843),
  [1578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [1580] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(852),
  [1583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [1585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1983),
  [1587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [1589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [1591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [1593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [1595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [1597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [1599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [1601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [1603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [1605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1, 0, 0),
  [1607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [1609] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(740),
  [1612] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(2124),
  [1615] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(2124),
  [1618] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(2074),
  [1621] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(2096),
  [1624] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(2040),
  [1627] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(1301),
  [1630] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(1303),
  [1633] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(1305),
  [1636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(1312),
  [1639] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(1314),
  [1642] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(741),
  [1645] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(741),
  [1648] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(1997),
  [1651] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(2005),
  [1654] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(406),
  [1657] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(898),
  [1660] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(406),
  [1663] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(1935),
  [1666] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(698),
  [1669] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(934),
  [1672] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(853),
  [1675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_braced_expression_repeat1, 2, 0, 22),
  [1677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(739),
  [1679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(631),
  [1681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [1683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [1685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [1687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(726),
  [1689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_named, 2, 0, 9),
  [1691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [1693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(714),
  [1695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [1697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [1699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [1701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [1703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [1705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [1707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [1709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [1711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [1713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [1715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [1717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [1719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [1721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0),
  [1723] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(706),
  [1726] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2122),
  [1729] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2122),
  [1732] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2003),
  [1735] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2023),
  [1738] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2004),
  [1741] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1431),
  [1744] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1439),
  [1747] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1571),
  [1750] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1579),
  [1753] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1582),
  [1756] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(744),
  [1759] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(744),
  [1762] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2024),
  [1765] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2048),
  [1768] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(292),
  [1771] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(958),
  [1774] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(292),
  [1777] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(975),
  [1780] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(709),
  [1783] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(987),
  [1786] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(760),
  [1789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [1791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [1793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [1795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [1797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [1799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [1801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [1803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [1805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [1807] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(739),
  [1810] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(2123),
  [1813] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(2123),
  [1816] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(2071),
  [1819] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(2093),
  [1822] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(2036),
  [1825] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(1403),
  [1828] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(1405),
  [1831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(1406),
  [1834] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(1407),
  [1837] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(1409),
  [1840] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(722),
  [1843] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(722),
  [1846] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(2020),
  [1849] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(2022),
  [1852] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(631),
  [1855] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(982),
  [1858] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(631),
  [1861] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(1949),
  [1864] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(742),
  [1867] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(907),
  [1870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 22),
  [1872] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 22), SHIFT_REPEAT(842),
  [1875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [1877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [1879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [1881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(504),
  [1883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [1885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1940),
  [1887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(668),
  [1889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [1891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2125),
  [1893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2092),
  [1895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2104),
  [1897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2051),
  [1899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1512),
  [1901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [1903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1514),
  [1905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [1907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [1909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [1911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(676),
  [1913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(51),
  [1915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(771),
  [1917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [1919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [1921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [1923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [1925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [1927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [1929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [1931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [1933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [1935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(54),
  [1937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [1939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(55),
  [1941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [1943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(506),
  [1945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [1947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [1949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [1951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(628),
  [1953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [1955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [1957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [1959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [1961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [1963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(507),
  [1965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [1967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [1969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [1971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1948),
  [1973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [1975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2126),
  [1977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2076),
  [1979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2098),
  [1981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2043),
  [1983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1019),
  [1985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [1987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [1989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [1991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [1993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1945),
  [1995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1945),
  [1997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [1999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [2001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1903),
  [2003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1981),
  [2005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [2007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [2009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [2011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [2013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [2015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1802),
  [2017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [2019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [2021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1854),
  [2023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1854),
  [2025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [2027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1900),
  [2029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [2031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [2033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1788),
  [2035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [2037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [2039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [2041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [2043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [2045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1787),
  [2047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [2049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [2051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1868),
  [2053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [2055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1879),
  [2057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [2059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1889),
  [2061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [2063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1894),
  [2065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [2067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1895),
  [2069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [2071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1848),
  [2073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [2075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [2077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1906),
  [2079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [2081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [2083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1840),
  [2085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [2087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [2089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [2091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [2093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [2095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [2097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [2099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [2101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [2103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [2105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1852),
  [2107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [2109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [2111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1901),
  [2113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [2115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [2117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [2119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [2121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1784),
  [2123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [2125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [2127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1843),
  [2129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [2131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [2133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(68),
  [2135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [2137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(69),
  [2139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [2141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [2143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1865),
  [2145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [2147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [2149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1881),
  [2151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [2153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [2155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1785),
  [2157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [2159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [2161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1833),
  [2163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [2165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [2167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1862),
  [2169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [2171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [2173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [2175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [2177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1883),
  [2179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [2181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [2183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(50),
  [2185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [2187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [2189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [2191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2120),
  [2193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2082),
  [2195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2106),
  [2197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2054),
  [2199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1598),
  [2201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [2203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [2205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [2207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [2209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [2211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(683),
  [2213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [2215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(835),
  [2217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [2219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [2221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [2223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [2225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [2227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [2229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [2231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(75),
  [2233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [2235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [2237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(76),
  [2239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [2241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [2243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(77),
  [2245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [2247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [2249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [2251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [2253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [2255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [2257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1794),
  [2259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [2261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [2263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [2265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(509),
  [2267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [2269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [2271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [2273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [2275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [2277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [2279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [2281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [2283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [2285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [2287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [2289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [2291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [2293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [2295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [2297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [2299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [2301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [2303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [2305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [2307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [2309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [2311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [2313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [2315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [2317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [2319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [2321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [2323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [2325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [2327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [2329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [2331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [2333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [2335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [2337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [2339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [2341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [2343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(95),
  [2345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [2347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [2349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1795),
  [2351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [2353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1796),
  [2355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [2357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1797),
  [2359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [2361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(96),
  [2363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [2365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1798),
  [2367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [2369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1801),
  [2371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [2373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1806),
  [2375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [2377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1807),
  [2379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [2381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1808),
  [2383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [2385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(97),
  [2387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [2389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(98),
  [2391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [2393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1811),
  [2395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [2397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [2399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [2401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [2403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [2405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1812),
  [2407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [2409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [2411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [2413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [2415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [2417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1816),
  [2419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [2421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [2423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [2425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [2427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [2429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1817),
  [2431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [2433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [2435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [2437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(106),
  [2439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [2441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1819),
  [2443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [2445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [2447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [2449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [2451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [2453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [2455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [2457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [2459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [2461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1827),
  [2463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [2465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [2467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [2469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [2471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [2473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [2475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [2477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [2479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [2481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [2483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [2485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [2487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [2489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1853),
  [2491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [2493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1861),
  [2495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [2497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [2499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [2501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [2503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(118),
  [2505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [2507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [2509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [2511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [2513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1873),
  [2515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [2517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [2519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1877),
  [2521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [2523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [2525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [2527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(688),
  [2529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [2531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2132),
  [2533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2084),
  [2535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2108),
  [2537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2057),
  [2539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1117),
  [2541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [2543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [2545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [2547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [2549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [2551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [2553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [2555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(870),
  [2557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [2559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [2561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [2563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [2565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [2567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [2569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [2571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(124),
  [2573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [2575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [2577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [2579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [2581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [2583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [2585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [2587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [2589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1805),
  [2591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [2593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1844),
  [2595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [2597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [2599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [2601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [2603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [2605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(128),
  [2607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [2609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [2611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [2613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [2615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [2617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [2619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [2621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(132),
  [2623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [2625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1874),
  [2627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [2629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1851),
  [2631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [2633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_with_default, 2, 0, 9),
  [2635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(133),
  [2637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [2639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [2641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(135),
  [2643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [2645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [2647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(136),
  [2649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [2651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [2653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(137),
  [2655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [2657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [2659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(138),
  [2661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [2663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [2665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(139),
  [2667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [2669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [2671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(140),
  [2673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [2675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [2677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(141),
  [2679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [2681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [2683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(142),
  [2685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [2687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [2689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(143),
  [2691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [2693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [2695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [2697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [2699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [2701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [2703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [2705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [2707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [2709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [2711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [2713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(299),
  [2715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [2717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [2719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(300),
  [2721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [2723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [2725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [2727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [2729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [2731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(302),
  [2733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [2735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [2737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(511),
  [2739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [2741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [2743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [2745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(303),
  [2747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [2749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [2751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18),
  [2753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [2755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [2757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [2759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [2761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [2763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [2765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [2767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [2769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(147),
  [2771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [2773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(307),
  [2775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [2777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(148),
  [2779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [2781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [2783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [2785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(308),
  [2787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [2789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [2791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [2793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [2795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [2797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [2799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [2801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [2803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [2805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [2807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [2809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [2811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [2813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [2815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [2817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [2819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(310),
  [2821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [2823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [2825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(156),
  [2827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [2829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [2831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [2833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [2835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [2837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [2839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(312),
  [2841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [2843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [2845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [2847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [2849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(313),
  [2851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [2853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [2855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [2857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [2859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(314),
  [2861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [2863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [2865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [2867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [2869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [2871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [2873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [2875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [2877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [2879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [2881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [2883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(318),
  [2885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [2887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [2889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(319),
  [2891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [2893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [2895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(320),
  [2897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [2899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [2901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [2903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [2905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [2907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(448),
  [2909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [2911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [2913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(160),
  [2915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [2917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [2919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(408),
  [2921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [2923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(512),
  [2925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [2927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [2929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [2931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [2933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [2935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [2937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(433),
  [2939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [2941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(325),
  [2943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [2945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(161),
  [2947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [2949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [2951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [2953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [2955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [2957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [2959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [2961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [2963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [2965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [2967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [2969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(327),
  [2971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [2973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [2975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [2977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [2979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [2981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [2983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(328),
  [2985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [2987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(329),
  [2989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [2991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [2993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [2995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [2997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [2999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(331),
  [3001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [3003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1929),
  [3005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [3007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2128),
  [3009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2086),
  [3011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2110),
  [3013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2061),
  [3015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1205),
  [3017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [3019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [3021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [3023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [3025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [3027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1914),
  [3029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [3031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [3033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1754),
  [3035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1959),
  [3037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [3039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [3041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [3043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [3045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [3047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1757),
  [3049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [3051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [3053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [3055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [3057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [3059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1743),
  [3061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [3063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [3065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1759),
  [3067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [3069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [3071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1755),
  [3073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [3075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [3077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1777),
  [3079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [3081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1735),
  [3083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [3085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1738),
  [3087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [3089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1740),
  [3091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [3093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1741),
  [3095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [3097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1746),
  [3099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [3101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [3103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1750),
  [3105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [3107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [3109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1751),
  [3111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [3113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [3115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1752),
  [3117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [3119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [3121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1753),
  [3123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [3125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [3127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1733),
  [3129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [3131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [3133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1756),
  [3135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [3137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [3139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1783),
  [3141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [3143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [3145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [3147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [3149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [3151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1760),
  [3153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [3155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [3157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1761),
  [3159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [3163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1762),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [3167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [3169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1765),
  [3171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [3173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(332),
  [3175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [3177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1766),
  [3179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [3181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1767),
  [3183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [3185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1768),
  [3187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [3189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1769),
  [3191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [3193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1770),
  [3195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1770),
  [3197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1771),
  [3199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [3201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1773),
  [3203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [3205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1774),
  [3207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [3209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1775),
  [3211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [3213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1776),
  [3215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [3217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1778),
  [3219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [3221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1779),
  [3223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [3225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1780),
  [3227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [3229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [3231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [3233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1781),
  [3235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [3237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [3239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1744),
  [3241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [3243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1747),
  [3245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [3247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [3249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1745),
  [3251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [3253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [3255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1763),
  [3257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [3259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1782),
  [3261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [3263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1734),
  [3265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1734),
  [3267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [3269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1737),
  [3271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [3273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(654),
  [3275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [3277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2131),
  [3279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2088),
  [3281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2112),
  [3283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2065),
  [3285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1252),
  [3287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [3289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [3291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [3293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [3295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [3297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [3299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [3301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(854),
  [3303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [3305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [3307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [3309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [3311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [3313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [3315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [3317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [3319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [3321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [3323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [3325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [3327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [3329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [3331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [3333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [3335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [3337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [3339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4),
  [3341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [3343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(335),
  [3345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [3347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(34),
  [3349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [3351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [3353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [3355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [3357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(177),
  [3359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [3361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [3363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(291),
  [3365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [3367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [3369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [3371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [3373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [3375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(513),
  [3377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [3379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [3381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [3383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(514),
  [3385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [3387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [3389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(181),
  [3391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [3393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [3395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [3397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(517),
  [3399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [3401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [3403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [3405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [3407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [3409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [3411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [3413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [3415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [3417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [3419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [3421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [3423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [3425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [3427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [3429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [3431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [3433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [3435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [3437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [3439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [3441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [3443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [3445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [3447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [3449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [3451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(192),
  [3453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [3455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [3457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [3459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [3461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [3463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [3465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [3467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [3469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(195),
  [3471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [3473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [3475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(449),
  [3477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [3479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [3481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [3483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [3485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(518),
  [3487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [3489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [3491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [3493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [3495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [3497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [3499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [3501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [3503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(525),
  [3505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [3507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [3509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3),
  [3511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [3513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(455),
  [3515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [3517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [3519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [3521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [3523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [3525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [3527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [3529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [3531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [3533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [3535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [3537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [3539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [3541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [3543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [3545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [3547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [3549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [3551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [3553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [3555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [3557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [3559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [3561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [3563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [3565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [3567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [3569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [3571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(530),
  [3573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [3575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [3577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [3579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [3581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [3583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [3585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [3587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [3589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(340),
  [3591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [3593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [3595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [3597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [3599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [3601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [3603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [3605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [3607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [3609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(207),
  [3611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [3613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(532),
  [3615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [3617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [3619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [3621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [3623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [3625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [3627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [3629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [3631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [3633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [3635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [3637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [3639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [3641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [3643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [3645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(346),
  [3647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [3649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [3651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [3653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [3655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(533),
  [3657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [3659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [3661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [3663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [3665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [3667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [3669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [3671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [3673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(535),
  [3675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [3677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(536),
  [3679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [3681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [3683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [3685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(537),
  [3687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [3689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [3691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [3693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [3695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(351),
  [3697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [3699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [3701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(352),
  [3703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [3705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [3707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [3709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [3711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [3713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [3715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [3717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [3719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(538),
  [3721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [3723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(539),
  [3725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [3727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(211),
  [3729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [3731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [3733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [3735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [3737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [3739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [3741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [3743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(434),
  [3745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [3747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [3749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [3751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [3753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [3755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [3757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(462),
  [3759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [3761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [3763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [3765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [3767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [3769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [3771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [3773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [3775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [3777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [3779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(540),
  [3781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [3783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [3785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(358),
  [3787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [3789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [3791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [3793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [3795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [3797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [3799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(359),
  [3801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [3803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(542),
  [3805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [3807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [3809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(360),
  [3811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [3813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(670),
  [3815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [3817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2130),
  [3819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2090),
  [3821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2114),
  [3823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2069),
  [3825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1355),
  [3827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [3829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [3831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [3833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [3835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [3837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(671),
  [3839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [3841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [3843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [3845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [3847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [3849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [3851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [3853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [3855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [3857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [3859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [3861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [3863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [3865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [3867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [3869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [3871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [3873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [3875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(543),
  [3877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [3879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [3881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(544),
  [3883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [3885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [3887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [3889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [3891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [3893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(546),
  [3895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [3897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [3899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [3901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [3903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [3905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [3907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [3909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [3911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(362),
  [3913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [3915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [3917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(228),
  [3919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [3921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [3923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [3925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [3927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [3929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [3931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [3933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [3935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [3937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [3939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [3941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [3943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [3945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [3947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(231),
  [3949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [3951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [3953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [3955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [3957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(232),
  [3959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [3961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(367),
  [3963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [3965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [3967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [3969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [3971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [3973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [3975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [3977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [3979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [3981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [3983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [3985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [3987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [3989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [3991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(235),
  [3993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [3995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [3997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(236),
  [3999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [4001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [4003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(237),
  [4005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [4007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [4009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [4011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [4013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [4015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(239),
  [4017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [4019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [4021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(240),
  [4023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [4025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [4027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(241),
  [4029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [4031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [4033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(242),
  [4035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [4037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [4039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [4041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [4043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [4045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(244),
  [4047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [4049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [4051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(245),
  [4053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [4055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [4057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(371),
  [4059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [4061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [4063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [4065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [4067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [4069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [4071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [4073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [4075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(547),
  [4077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [4079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [4081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [4083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [4085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [4087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(549),
  [4089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [4091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [4093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(550),
  [4095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [4097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [4099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(551),
  [4101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [4103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [4105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(555),
  [4107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [4109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [4111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [4113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [4115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(435),
  [4117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [4119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [4121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [4123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [4125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [4127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [4129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [4131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [4133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [4135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [4137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [4139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [4141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [4143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [4145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [4147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(247),
  [4149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [4151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [4153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [4155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [4157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(248),
  [4159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [4161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(436),
  [4163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [4165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [4167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [4169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(250),
  [4171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [4173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(559),
  [4175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [4177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [4179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [4181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(437),
  [4183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [4185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(252),
  [4187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [4189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(377),
  [4191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [4193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(253),
  [4195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [4197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [4199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [4201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [4203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [4205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [4207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [4209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [4211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [4213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [4215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [4217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(379),
  [4219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [4221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(257),
  [4223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [4225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [4227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [4229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [4231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(258),
  [4233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [4235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(380),
  [4237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [4239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [4241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [4243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(516),
  [4245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [4247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [4249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [4251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [4253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [4255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [4257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(382),
  [4259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [4261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(439),
  [4263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [4265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [4267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [4269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [4271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [4273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [4275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [4277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(577),
  [4279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [4281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [4283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(385),
  [4285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [4287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(560),
  [4289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [4291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [4293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [4295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [4297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [4299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [4301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [4303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [4305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(387),
  [4307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [4309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [4311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [4313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [4315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [4317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [4319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [4321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(389),
  [4323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [4325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(562),
  [4327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [4329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(473),
  [4331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [4333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [4335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [4337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [4339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [4341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [4343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [4345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [4347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(474),
  [4349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [4351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(565),
  [4353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [4355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [4357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [4359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(566),
  [4361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [4363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [4365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [4367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [4369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(567),
  [4371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [4373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [4375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [4377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [4379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [4381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [4383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [4385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [4387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [4389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [4391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [4393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [4395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(443),
  [4397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [4399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(265),
  [4401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [4403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [4405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [4407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [4409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [4411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [4413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(268),
  [4415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [4417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [4419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [4421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [4423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(569),
  [4425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [4427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [4429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [4431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [4433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [4435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [4437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(476),
  [4439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [4441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [4443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(574),
  [4445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [4447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(271),
  [4449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [4451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(477),
  [4453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [4455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [4457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(575),
  [4459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [4461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [4463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [4465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [4467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(479),
  [4469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [4471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [4473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(480),
  [4475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [4477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [4479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [4481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [4483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [4485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5),
  [4487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [4489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [4491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6),
  [4493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [4495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7),
  [4497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [4499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [4501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [4503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [4505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8),
  [4507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [4509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(392),
  [4511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [4513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [4515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(444),
  [4517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [4519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [4521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [4523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [4525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [4527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [4529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [4531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(487),
  [4533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [4535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [4537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(395),
  [4539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [4541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(488),
  [4543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [4545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [4547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [4549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [4551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [4553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [4555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [4557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [4559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(398),
  [4561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [4563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(399),
  [4565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [4567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [4569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [4571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [4573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [4575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(445),
  [4577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [4579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [4581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [4583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [4585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [4587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [4589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [4591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [4593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [4595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [4597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [4599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [4601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [4603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [4605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(447),
  [4607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [4609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9),
  [4611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [4613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [4615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10),
  [4617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [4619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11),
  [4621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [4623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [4625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12),
  [4627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [4629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [4631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [4633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [4635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(267),
  [4637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [4639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [4641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(272),
  [4643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [4645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [4647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [4649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [4651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [4653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(274),
  [4655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [4657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [4659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(275),
  [4661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [4663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [4665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [4667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [4669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [4671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1728),
  [4673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [4675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [4677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1731),
  [4679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [4681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1732),
  [4683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [4685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [4687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1724),
  [4689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [4691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(424),
  [4693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [4695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [4697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [4699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [4701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [4703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [4705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [4707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [4709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [4711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [4713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(277),
  [4715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [4717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13),
  [4719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [4721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [4723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14),
  [4725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [4727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15),
  [4729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [4731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [4733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16),
  [4735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [4737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [4739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [4741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [4743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [4745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(280),
  [4747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [4749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17),
  [4751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [4753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [4755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(41),
  [4757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [4759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19),
  [4761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [4763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [4765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20),
  [4767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [4769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(281),
  [4771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [4773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [4775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [4777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [4779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [4781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [4783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [4785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [4787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [4789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(282),
  [4791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [4793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [4795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(284),
  [4797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [4799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [4801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(26),
  [4803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [4805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [4807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(27),
  [4809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [4811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(28),
  [4813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [4815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [4817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(29),
  [4819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [4821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(285),
  [4823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [4825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [4827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(286),
  [4829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [4831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [4833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(287),
  [4835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [4837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [4839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(288),
  [4841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [4843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [4845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [4847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [4849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [4851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [4853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [4855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [4857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(178),
  [4859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [4861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [4863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(30),
  [4865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [4867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [4869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(31),
  [4871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [4873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(32),
  [4875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [4877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [4879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(33),
  [4881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [4883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(43),
  [4885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [4887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [4889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(44),
  [4891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [4893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [4895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(45),
  [4897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [4899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [4901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(428),
  [4903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [4905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [4907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(497),
  [4909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [4911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(498),
  [4913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [4915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1726),
  [4917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [4919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [4921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1730),
  [4923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [4925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1725),
  [4927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [4929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [4931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1727),
  [4933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [4935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(581),
  [4937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [4939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(582),
  [4941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [4943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [4945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(579),
  [4947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [4949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [4951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(46),
  [4953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [4955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(499),
  [4957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [4959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [4961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [4963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [4965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(35),
  [4967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [4969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(36),
  [4971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [4973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [4975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [4977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [4979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(585),
  [4981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [4983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [4985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(580),
  [4987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [4989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [4991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(500),
  [4993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [4995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(586),
  [4997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [4999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(584),
  [5001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [5003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [5005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(38),
  [5007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [5009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [5011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(39),
  [5013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [5015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(40),
  [5017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [5019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [5021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(21),
  [5023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [5025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [5027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [5029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(47),
  [5031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [5033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [5035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [5037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [5039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(48),
  [5041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [5043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(293),
  [5045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [5047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(49),
  [5049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [5051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [5053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [5055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [5057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [5059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [5061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [5063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(23),
  [5065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [5067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(24),
  [5069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [5071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [5073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(25),
  [5075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [5077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [5079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [5081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [5083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(345),
  [5085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [5087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1905),
  [5089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [5091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [5093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [5095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1836),
  [5097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [5099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [5101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [5103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(217),
  [5105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [5107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1869),
  [5109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [5111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(295),
  [5113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [5115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [5117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [5119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1739),
  [5121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [5123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [5125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [5127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [5129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [5131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1764),
  [5133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [5135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1772),
  [5137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [5139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [5141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [5143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [5145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [5147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1736),
  [5149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [5151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(270),
  [5153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [5155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [5157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [5159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [5161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [5163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [5165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [5167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [5169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [5171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1815),
  [5173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [5175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(400),
  [5177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [5179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1902),
  [5181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [5183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(522),
  [5185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [5187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(523),
  [5189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [5191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [5193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [5195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1823),
  [5197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [5199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [5201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [5203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1904),
  [5205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [5207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [5209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [5211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [5213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [5215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [5217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [5219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [5221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [5223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [5225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [5227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(344),
  [5229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [5231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1898),
  [5233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [5235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [5237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [5239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1839),
  [5241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [5243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [5245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [5247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(116),
  [5249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [5251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1789),
  [5253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [5255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [5257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [5259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [5261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [5263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [5265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [5267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [5269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [5271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(587),
  [5273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [5275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(588),
  [5277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [5279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [5281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [5283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [5285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [5287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [5289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [5291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(120),
  [5293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [5295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1892),
  [5297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [5299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1893),
  [5301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [5303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1897),
  [5305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [5307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1899),
  [5309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [5311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [5313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [5315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1790),
  [5317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [5319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1791),
  [5321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [5323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1792),
  [5325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [5327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1793),
  [5329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [5331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1799),
  [5333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [5335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1800),
  [5337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [5339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1803),
  [5341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [5343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1804),
  [5345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [5347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1809),
  [5349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [5351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1810),
  [5353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [5355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1813),
  [5357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [5359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1814),
  [5361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [5363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1818),
  [5365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [5367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1820),
  [5369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [5371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1821),
  [5373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1821),
  [5375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1822),
  [5377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [5379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1824),
  [5381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [5383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1825),
  [5385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [5387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1826),
  [5389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [5391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1828),
  [5393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [5395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1829),
  [5397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [5399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1830),
  [5401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [5403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1831),
  [5405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [5407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1832),
  [5409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [5411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1834),
  [5413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [5415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1835),
  [5417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [5419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1837),
  [5421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [5423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1838),
  [5425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [5427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1841),
  [5429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [5431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1842),
  [5433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [5435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1845),
  [5437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [5439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1846),
  [5441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [5443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1847),
  [5445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1847),
  [5447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1907),
  [5449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [5451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1849),
  [5453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [5455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1850),
  [5457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [5459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1855),
  [5461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [5463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1856),
  [5465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [5467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1857),
  [5469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [5471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1858),
  [5473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [5475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1859),
  [5477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [5479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1860),
  [5481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [5483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1863),
  [5485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [5487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1864),
  [5489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [5491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1866),
  [5493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [5495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1867),
  [5497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [5499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1870),
  [5501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [5503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1872),
  [5505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [5507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1875),
  [5509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [5511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1876),
  [5513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [5515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1878),
  [5517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [5519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1880),
  [5521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [5523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1882),
  [5525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [5527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1884),
  [5529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [5531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1885),
  [5533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [5535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1886),
  [5537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [5539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1887),
  [5541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [5543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1888),
  [5545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [5547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1890),
  [5549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [5551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1891),
  [5553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [5555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1896),
  [5557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [5559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1786),
  [5561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [5563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [5565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [5567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [5569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [5571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [5573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [5575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1986),
  [5577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [5579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [5581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1216),
  [5583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [5585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [5587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1218),
  [5589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [5591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1220),
  [5593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [5595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1221),
  [5597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1222),
  [5599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [5601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [5603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1223),
  [5605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [5607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1224),
  [5609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [5611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [5613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [5615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1227),
  [5617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [5619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [5621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [5623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [5625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [5627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [5629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [5631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [5633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [5635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1976),
  [5637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [5639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [5641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [5643] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(1749),
  [5646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [5648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [5650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1037),
  [5652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1041),
  [5654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1044),
  [5656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [5658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [5660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1045),
  [5662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [5664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [5666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [5668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [5670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [5672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1050),
  [5674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [5676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [5678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [5680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [5682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1031),
  [5684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [5686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [5688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1040),
  [5690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [5692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [5694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [5696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [5698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [5700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [5702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [5704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [5706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [5708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [5710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [5712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [5714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [5716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [5718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [5720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [5722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [5724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [5726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [5728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [5730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [5732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [5734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [5736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [5738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [5740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [5742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [5744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [5746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [5748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [5750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [5752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [5754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [5756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [5758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [5760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [5762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [5764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [5766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [5768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [5770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [5772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_with_default, 3, 0, 28),
  [5774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [5776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [5778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [5780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [5782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [5784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [5786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [5788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [5790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [5792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [5794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [5796] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(1871),
  [5799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [5801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [5803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [5805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [5807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [5809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [5811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [5813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [5815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [5817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [5819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [5821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [5823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [5825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [5827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [5829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [5831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [5833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [5835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [5837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [5839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [5841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument, 1, 0, 19),
  [5843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 1, 0, 19),
  [5845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_call_arguments_repeat1, 1, 0, 17),
  [5847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_call_arguments_repeat1, 1, 0, 17),
  [5849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1964),
  [5851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [5853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__argument, 1, 0, 18),
  [5855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument, 1, 0, 18),
  [5857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__argument_unnamed, 1, 0, 20),
  [5859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_unnamed, 1, 0, 20),
  [5861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument, 1, 0, 20),
  [5863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 1, 0, 20),
  [5865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__argument_named, 3, 0, 34),
  [5867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_named, 3, 0, 34),
  [5869] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(1940),
  [5872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [5874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [5876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 3, 0, 24),
  [5878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3, 0, 24),
  [5880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 2, 0, 7),
  [5882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2, 0, 7),
  [5884] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 4, 0, 30),
  [5886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 4, 0, 30),
  [5888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2121),
  [5890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2135),
  [5892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1954),
  [5894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [5896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [5898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(750),
  [5900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [5902] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [5904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1992),
  [5906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [5908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1946),
  [5910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(749),
  [5912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [5914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(711),
  [5916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [5918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(712),
  [5920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [5922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(666),
  [5924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [5926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [5928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [5930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [5932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(699),
  [5934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(689),
  [5936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [5938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1915),
  [5940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1917),
  [5942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1944),
  [5944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(660),
  [5946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1910),
  [5948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1911),
  [5950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(662),
  [5952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2170),
  [5954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1939),
  [5956] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__single_quoted_string_content, 2, 0, 0),
  [5958] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__single_quoted_string_content, 2, 0, 0), SHIFT_REPEAT(2129),
  [5961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [5963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [5965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(727),
  [5967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [5969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [5971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [5973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2191),
  [5975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(733),
  [5977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [5979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__double_quoted_string_content, 2, 0, 0),
  [5981] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__double_quoted_string_content, 2, 0, 0), SHIFT_REPEAT(2117),
  [5984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [5986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(703),
  [5988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [5990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(659),
  [5992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [5994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [5996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(663),
  [5998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(664),
  [6000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1943),
  [6002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [6004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [6006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [6008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(704),
  [6010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(716),
  [6012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [6014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [6016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [6018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(687),
  [6020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2044),
  [6022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [6024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [6026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [6028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [6030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [6032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [6034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(738),
  [6036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [6038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [6040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [6042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [6044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [6046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [6048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(674),
  [6050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [6052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [6054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(675),
  [6056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [6058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [6060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [6062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(691),
  [6064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [6066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [6068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [6070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [6072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(677),
  [6074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [6076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(678),
  [6078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [6080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [6082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(719),
  [6084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [6086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [6088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [6090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [6092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [6094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [6096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [6098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(730),
  [6100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [6102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [6104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [6106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [6108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [6110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [6112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [6114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [6116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [6118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [6120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [6122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [6124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [6126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [6128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [6130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [6132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [6134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [6136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [6138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [6140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [6142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [6144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1993),
  [6146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [6148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [6150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [6152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [6154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [6156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [6158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [6160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [6162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [6164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [6166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [6168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [6170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [6172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [6174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [6176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [6178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2180),
  [6180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [6182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [6184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2187),
  [6186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [6188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2196),
  [6190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [6192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [6194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [6196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [6198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [6200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2158),
  [6202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [6204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [6206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [6208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [6210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [6212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [6214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [6216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [6218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2150),
  [6220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2171),
  [6222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [6224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [6226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [6228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [6230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__double_quoted_string_content, 1, 0, 0),
  [6232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__double_quoted_string_content, 1, 0, 0),
  [6234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [6236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 31), SHIFT_REPEAT(1992),
  [6239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 31),
  [6241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [6243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_without_default, 1, 0, 9),
  [6245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__single_quoted_string_content, 1, 0, 0),
  [6247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__single_quoted_string_content, 1, 0, 0),
  [6249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2133),
  [6252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(649),
  [6254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [6256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(651),
  [6258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [6260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(632),
  [6262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [6264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 10),
  [6266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(645),
  [6268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [6270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [6272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [6274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(633),
  [6276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [6278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(650),
  [6280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [6282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(652),
  [6284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [6286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1723),
  [6288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [6290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1729),
  [6292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [6294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 11),
  [6296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(640),
  [6298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [6300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(636),
  [6302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [6304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 29),
  [6306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2181),
  [6308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [6310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [6312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [6314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [6316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [6318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [6320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [6322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [6324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [6326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [6328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [6330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [6332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [6334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [6336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [6338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2186),
  [6340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [6342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [6344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [6346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [6348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [6350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2198),
  [6352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2175),
  [6354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2179),
  [6356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [6358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [6360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [6362] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [6364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [6366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [6368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [6370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [6372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [6374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [6376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [6378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [6380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2165),
  [6382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [6384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [6386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [6388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2184),
  [6390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [6392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [6394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [6396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [6398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [6400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [6402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__newline = 0,
  ts_external_token__semicolon = 1,
  ts_external_token__raw_string_literal = 2,
  ts_external_token__external_else = 3,
  ts_external_token__external_open_parenthesis = 4,
  ts_external_token__external_close_parenthesis = 5,
  ts_external_token__external_open_brace = 6,
  ts_external_token__external_close_brace = 7,
  ts_external_token__external_open_bracket = 8,
  ts_external_token__external_close_bracket = 9,
  ts_external_token__external_open_bracket2 = 10,
  ts_external_token__external_close_bracket2 = 11,
  ts_external_token__error_sentinel = 12,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__newline] = sym__newline,
  [ts_external_token__semicolon] = sym__semicolon,
  [ts_external_token__raw_string_literal] = sym__raw_string_literal,
  [ts_external_token__external_else] = sym__external_else,
  [ts_external_token__external_open_parenthesis] = sym__external_open_parenthesis,
  [ts_external_token__external_close_parenthesis] = sym__external_close_parenthesis,
  [ts_external_token__external_open_brace] = sym__external_open_brace,
  [ts_external_token__external_close_brace] = sym__external_close_brace,
  [ts_external_token__external_open_bracket] = sym__external_open_bracket,
  [ts_external_token__external_close_bracket] = sym__external_close_bracket,
  [ts_external_token__external_open_bracket2] = sym__external_open_bracket2,
  [ts_external_token__external_close_bracket2] = sym__external_close_bracket2,
  [ts_external_token__error_sentinel] = sym__error_sentinel,
};

static const bool ts_external_scanner_states[29][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_close_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_close_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
    [ts_external_token__external_close_bracket2] = true,
    [ts_external_token__error_sentinel] = true,
  },
  [2] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
  },
  [3] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_close_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [4] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [5] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [6] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_close_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [7] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
    [ts_external_token__external_close_bracket2] = true,
  },
  [8] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [9] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_close_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [10] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_close_bracket] = true,
  },
  [11] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_close_bracket2] = true,
  },
  [12] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_close_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [13] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
    [ts_external_token__external_close_bracket2] = true,
  },
  [14] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
  },
  [15] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [16] = {
    [ts_external_token__newline] = true,
    [ts_external_token__semicolon] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
    [ts_external_token__external_close_brace] = true,
  },
  [17] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
  },
  [18] = {
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
  },
  [19] = {
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_open_brace] = true,
  },
  [20] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [21] = {
    [ts_external_token__newline] = true,
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [22] = {
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [23] = {
    [ts_external_token__external_else] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [24] = {
    [ts_external_token__raw_string_literal] = true,
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [25] = {
    [ts_external_token__external_open_parenthesis] = true,
    [ts_external_token__external_close_parenthesis] = true,
    [ts_external_token__external_open_bracket] = true,
    [ts_external_token__external_open_bracket2] = true,
  },
  [26] = {
    [ts_external_token__external_close_parenthesis] = true,
  },
  [27] = {
    [ts_external_token__newline] = true,
    [ts_external_token__external_open_parenthesis] = true,
  },
  [28] = {
    [ts_external_token__external_open_parenthesis] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_r_external_scanner_create(void);
void tree_sitter_r_external_scanner_destroy(void *);
bool tree_sitter_r_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_r_external_scanner_serialize(void *, char *);
void tree_sitter_r_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_r(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_r_external_scanner_create,
      tree_sitter_r_external_scanner_destroy,
      tree_sitter_r_external_scanner_scan,
      tree_sitter_r_external_scanner_serialize,
      tree_sitter_r_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
