#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 101
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 102
#define ALIAS_COUNT 0
#define TOKEN_COUNT 65
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 0
#define MAX_ALIAS_SEQUENCE_LENGTH 5
#define PRODUCTION_ID_COUNT 1

enum {
  aux_sym_source_file_token1 = 1,
  anon_sym_LF = 2,
  sym_comment = 3,
  anon_sym_db = 4,
  anon_sym_dw = 5,
  anon_sym_dd = 6,
  anon_sym_dq = 7,
  anon_sym_section = 8,
  anon_sym_info = 9,
  anon_sym_extern = 10,
  anon_sym_global = 11,
  aux_sym_shell_cmd_token1 = 12,
  sym_shell_prompt = 13,
  anon_sym_Disassemblyofsection = 14,
  anon_sym_COLON = 15,
  sym_objdump_file_format = 16,
  anon_sym_LT = 17,
  anon_sym_GT = 18,
  aux_sym_objdump_addr_token1 = 19,
  aux_sym_objdump_machine_code_bytes_token1 = 20,
  aux_sym_label_token1 = 21,
  anon_sym_byte = 22,
  anon_sym_word = 23,
  anon_sym_dword = 24,
  anon_sym_qword = 25,
  anon_sym_xmmword = 26,
  anon_sym_BYTE = 27,
  anon_sym_WORD = 28,
  anon_sym_DWORD = 29,
  anon_sym_QWORD = 30,
  anon_sym_XMMWORD = 31,
  anon_sym_ptr = 32,
  anon_sym_PTR = 33,
  anon_sym_COMMA = 34,
  sym_register = 35,
  anon_sym_LBRACK = 36,
  anon_sym_LPAREN = 37,
  anon_sym_RPAREN = 38,
  anon_sym_STAR = 39,
  anon_sym_PLUS = 40,
  anon_sym_DASH = 41,
  anon_sym_RBRACK = 42,
  anon_sym_cs = 43,
  anon_sym_ds = 44,
  anon_sym_es = 45,
  anon_sym_fs = 46,
  anon_sym_gs = 47,
  anon_sym_ss = 48,
  sym_escape_sequence = 49,
  anon_sym_DQUOTE = 50,
  aux_sym_string_literal_token1 = 51,
  aux_sym__decimal_literal_token1 = 52,
  aux_sym__decimal_literal_token2 = 53,
  aux_sym__decimal_literal_token3 = 54,
  aux_sym__hex_literal_token1 = 55,
  aux_sym__hex_literal_token2 = 56,
  aux_sym__hex_literal_token3 = 57,
  aux_sym__octal_literal_token1 = 58,
  aux_sym__octal_literal_token2 = 59,
  aux_sym__binary_literal_token1 = 60,
  aux_sym__binary_literal_token2 = 61,
  sym_mnemonic = 62,
  sym_section_name = 63,
  sym__IDENTIFIER = 64,
  sym_source_file = 65,
  sym_directive = 66,
  sym_builtin = 67,
  sym_builtin_kw = 68,
  sym_section = 69,
  sym_extern = 70,
  sym_global = 71,
  sym_shell_cmd = 72,
  sym_objdump_disas_of_section = 73,
  sym_objdump_section_label = 74,
  sym_objdump_addr = 75,
  sym_objdump_offset_label = 76,
  sym_objdump_machine_code_bytes = 77,
  sym_label = 78,
  sym_label_name = 79,
  sym_ins = 80,
  sym_width = 81,
  sym_ptr = 82,
  sym_operand_args = 83,
  sym_operand = 84,
  sym_operand_ident = 85,
  sym_effective_addr = 86,
  sym_segment_prefix = 87,
  sym_segment = 88,
  sym_string_literal = 89,
  sym_integer_literal = 90,
  sym_literal_offset = 91,
  sym__decimal_literal = 92,
  sym__hex_literal = 93,
  sym__octal_literal = 94,
  sym__binary_literal = 95,
  sym_identifier = 96,
  aux_sym_source_file_repeat1 = 97,
  aux_sym_objdump_machine_code_bytes_repeat1 = 98,
  aux_sym_operand_args_repeat1 = 99,
  aux_sym_effective_addr_repeat1 = 100,
  aux_sym_string_literal_repeat1 = 101,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [aux_sym_source_file_token1] = "source_file_token1",
  [anon_sym_LF] = "\n",
  [sym_comment] = "comment",
  [anon_sym_db] = "db",
  [anon_sym_dw] = "dw",
  [anon_sym_dd] = "dd",
  [anon_sym_dq] = "dq",
  [anon_sym_section] = "section",
  [anon_sym_info] = "info",
  [anon_sym_extern] = "extern",
  [anon_sym_global] = "global",
  [aux_sym_shell_cmd_token1] = "shell_cmd_token1",
  [sym_shell_prompt] = "shell_prompt",
  [anon_sym_Disassemblyofsection] = "Disassembly of section ",
  [anon_sym_COLON] = ":",
  [sym_objdump_file_format] = "objdump_file_format",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [aux_sym_objdump_addr_token1] = "objdump_addr_token1",
  [aux_sym_objdump_machine_code_bytes_token1] = "objdump_machine_code_bytes_token1",
  [aux_sym_label_token1] = "label_token1",
  [anon_sym_byte] = "byte",
  [anon_sym_word] = "word",
  [anon_sym_dword] = "dword",
  [anon_sym_qword] = "qword",
  [anon_sym_xmmword] = "xmmword",
  [anon_sym_BYTE] = "BYTE",
  [anon_sym_WORD] = "WORD",
  [anon_sym_DWORD] = "DWORD",
  [anon_sym_QWORD] = "QWORD",
  [anon_sym_XMMWORD] = "XMMWORD",
  [anon_sym_ptr] = "ptr",
  [anon_sym_PTR] = "PTR",
  [anon_sym_COMMA] = ",",
  [sym_register] = "register",
  [anon_sym_LBRACK] = "[",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_STAR] = "*",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_RBRACK] = "]",
  [anon_sym_cs] = "cs",
  [anon_sym_ds] = "ds",
  [anon_sym_es] = "es",
  [anon_sym_fs] = "fs",
  [anon_sym_gs] = "gs",
  [anon_sym_ss] = "ss",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_literal_token1] = "string_literal_token1",
  [aux_sym__decimal_literal_token1] = "_decimal_literal_token1",
  [aux_sym__decimal_literal_token2] = "_decimal_literal_token2",
  [aux_sym__decimal_literal_token3] = "_decimal_literal_token3",
  [aux_sym__hex_literal_token1] = "_hex_literal_token1",
  [aux_sym__hex_literal_token2] = "_hex_literal_token2",
  [aux_sym__hex_literal_token3] = "_hex_literal_token3",
  [aux_sym__octal_literal_token1] = "_octal_literal_token1",
  [aux_sym__octal_literal_token2] = "_octal_literal_token2",
  [aux_sym__binary_literal_token1] = "_binary_literal_token1",
  [aux_sym__binary_literal_token2] = "_binary_literal_token2",
  [sym_mnemonic] = "mnemonic",
  [sym_section_name] = "section_name",
  [sym__IDENTIFIER] = "_IDENTIFIER",
  [sym_source_file] = "source_file",
  [sym_directive] = "directive",
  [sym_builtin] = "builtin",
  [sym_builtin_kw] = "builtin_kw",
  [sym_section] = "section",
  [sym_extern] = "extern",
  [sym_global] = "global",
  [sym_shell_cmd] = "shell_cmd",
  [sym_objdump_disas_of_section] = "objdump_disas_of_section",
  [sym_objdump_section_label] = "objdump_section_label",
  [sym_objdump_addr] = "objdump_addr",
  [sym_objdump_offset_label] = "objdump_offset_label",
  [sym_objdump_machine_code_bytes] = "objdump_machine_code_bytes",
  [sym_label] = "label",
  [sym_label_name] = "label_name",
  [sym_ins] = "ins",
  [sym_width] = "width",
  [sym_ptr] = "ptr",
  [sym_operand_args] = "operand_args",
  [sym_operand] = "operand",
  [sym_operand_ident] = "operand_ident",
  [sym_effective_addr] = "effective_addr",
  [sym_segment_prefix] = "segment_prefix",
  [sym_segment] = "segment",
  [sym_string_literal] = "string_literal",
  [sym_integer_literal] = "integer_literal",
  [sym_literal_offset] = "literal_offset",
  [sym__decimal_literal] = "_decimal_literal",
  [sym__hex_literal] = "_hex_literal",
  [sym__octal_literal] = "_octal_literal",
  [sym__binary_literal] = "_binary_literal",
  [sym_identifier] = "identifier",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_objdump_machine_code_bytes_repeat1] = "objdump_machine_code_bytes_repeat1",
  [aux_sym_operand_args_repeat1] = "operand_args_repeat1",
  [aux_sym_effective_addr_repeat1] = "effective_addr_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [aux_sym_source_file_token1] = aux_sym_source_file_token1,
  [anon_sym_LF] = anon_sym_LF,
  [sym_comment] = sym_comment,
  [anon_sym_db] = anon_sym_db,
  [anon_sym_dw] = anon_sym_dw,
  [anon_sym_dd] = anon_sym_dd,
  [anon_sym_dq] = anon_sym_dq,
  [anon_sym_section] = anon_sym_section,
  [anon_sym_info] = anon_sym_info,
  [anon_sym_extern] = anon_sym_extern,
  [anon_sym_global] = anon_sym_global,
  [aux_sym_shell_cmd_token1] = aux_sym_shell_cmd_token1,
  [sym_shell_prompt] = sym_shell_prompt,
  [anon_sym_Disassemblyofsection] = anon_sym_Disassemblyofsection,
  [anon_sym_COLON] = anon_sym_COLON,
  [sym_objdump_file_format] = sym_objdump_file_format,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [aux_sym_objdump_addr_token1] = aux_sym_objdump_addr_token1,
  [aux_sym_objdump_machine_code_bytes_token1] = aux_sym_objdump_machine_code_bytes_token1,
  [aux_sym_label_token1] = aux_sym_label_token1,
  [anon_sym_byte] = anon_sym_byte,
  [anon_sym_word] = anon_sym_word,
  [anon_sym_dword] = anon_sym_dword,
  [anon_sym_qword] = anon_sym_qword,
  [anon_sym_xmmword] = anon_sym_xmmword,
  [anon_sym_BYTE] = anon_sym_BYTE,
  [anon_sym_WORD] = anon_sym_WORD,
  [anon_sym_DWORD] = anon_sym_DWORD,
  [anon_sym_QWORD] = anon_sym_QWORD,
  [anon_sym_XMMWORD] = anon_sym_XMMWORD,
  [anon_sym_ptr] = anon_sym_ptr,
  [anon_sym_PTR] = anon_sym_PTR,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [sym_register] = sym_register,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_cs] = anon_sym_cs,
  [anon_sym_ds] = anon_sym_ds,
  [anon_sym_es] = anon_sym_es,
  [anon_sym_fs] = anon_sym_fs,
  [anon_sym_gs] = anon_sym_gs,
  [anon_sym_ss] = anon_sym_ss,
  [sym_escape_sequence] = sym_escape_sequence,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_literal_token1] = aux_sym_string_literal_token1,
  [aux_sym__decimal_literal_token1] = aux_sym__decimal_literal_token1,
  [aux_sym__decimal_literal_token2] = aux_sym__decimal_literal_token2,
  [aux_sym__decimal_literal_token3] = aux_sym__decimal_literal_token3,
  [aux_sym__hex_literal_token1] = aux_sym__hex_literal_token1,
  [aux_sym__hex_literal_token2] = aux_sym__hex_literal_token2,
  [aux_sym__hex_literal_token3] = aux_sym__hex_literal_token3,
  [aux_sym__octal_literal_token1] = aux_sym__octal_literal_token1,
  [aux_sym__octal_literal_token2] = aux_sym__octal_literal_token2,
  [aux_sym__binary_literal_token1] = aux_sym__binary_literal_token1,
  [aux_sym__binary_literal_token2] = aux_sym__binary_literal_token2,
  [sym_mnemonic] = sym_mnemonic,
  [sym_section_name] = sym_section_name,
  [sym__IDENTIFIER] = sym__IDENTIFIER,
  [sym_source_file] = sym_source_file,
  [sym_directive] = sym_directive,
  [sym_builtin] = sym_builtin,
  [sym_builtin_kw] = sym_builtin_kw,
  [sym_section] = sym_section,
  [sym_extern] = sym_extern,
  [sym_global] = sym_global,
  [sym_shell_cmd] = sym_shell_cmd,
  [sym_objdump_disas_of_section] = sym_objdump_disas_of_section,
  [sym_objdump_section_label] = sym_objdump_section_label,
  [sym_objdump_addr] = sym_objdump_addr,
  [sym_objdump_offset_label] = sym_objdump_offset_label,
  [sym_objdump_machine_code_bytes] = sym_objdump_machine_code_bytes,
  [sym_label] = sym_label,
  [sym_label_name] = sym_label_name,
  [sym_ins] = sym_ins,
  [sym_width] = sym_width,
  [sym_ptr] = sym_ptr,
  [sym_operand_args] = sym_operand_args,
  [sym_operand] = sym_operand,
  [sym_operand_ident] = sym_operand_ident,
  [sym_effective_addr] = sym_effective_addr,
  [sym_segment_prefix] = sym_segment_prefix,
  [sym_segment] = sym_segment,
  [sym_string_literal] = sym_string_literal,
  [sym_integer_literal] = sym_integer_literal,
  [sym_literal_offset] = sym_literal_offset,
  [sym__decimal_literal] = sym__decimal_literal,
  [sym__hex_literal] = sym__hex_literal,
  [sym__octal_literal] = sym__octal_literal,
  [sym__binary_literal] = sym__binary_literal,
  [sym_identifier] = sym_identifier,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_objdump_machine_code_bytes_repeat1] = aux_sym_objdump_machine_code_bytes_repeat1,
  [aux_sym_operand_args_repeat1] = aux_sym_operand_args_repeat1,
  [aux_sym_effective_addr_repeat1] = aux_sym_effective_addr_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_source_file_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_db] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dd] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_section] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_info] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_shell_cmd_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_shell_prompt] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_Disassemblyofsection] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [sym_objdump_file_format] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_objdump_addr_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_objdump_machine_code_bytes_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_label_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_byte] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_word] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dword] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_qword] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xmmword] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BYTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_WORD] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DWORD] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QWORD] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_XMMWORD] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ptr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PTR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [sym_register] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cs] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ds] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_es] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fs] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gs] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ss] = {
    .visible = true,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__decimal_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__decimal_literal_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__decimal_literal_token3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__hex_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__hex_literal_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__hex_literal_token3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__octal_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__octal_literal_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__binary_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__binary_literal_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_mnemonic] = {
    .visible = true,
    .named = true,
  },
  [sym_section_name] = {
    .visible = true,
    .named = true,
  },
  [sym__IDENTIFIER] = {
    .visible = false,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_builtin] = {
    .visible = true,
    .named = true,
  },
  [sym_builtin_kw] = {
    .visible = true,
    .named = true,
  },
  [sym_section] = {
    .visible = true,
    .named = true,
  },
  [sym_extern] = {
    .visible = true,
    .named = true,
  },
  [sym_global] = {
    .visible = true,
    .named = true,
  },
  [sym_shell_cmd] = {
    .visible = true,
    .named = true,
  },
  [sym_objdump_disas_of_section] = {
    .visible = true,
    .named = true,
  },
  [sym_objdump_section_label] = {
    .visible = true,
    .named = true,
  },
  [sym_objdump_addr] = {
    .visible = true,
    .named = true,
  },
  [sym_objdump_offset_label] = {
    .visible = true,
    .named = true,
  },
  [sym_objdump_machine_code_bytes] = {
    .visible = true,
    .named = true,
  },
  [sym_label] = {
    .visible = true,
    .named = true,
  },
  [sym_label_name] = {
    .visible = true,
    .named = true,
  },
  [sym_ins] = {
    .visible = true,
    .named = true,
  },
  [sym_width] = {
    .visible = true,
    .named = true,
  },
  [sym_ptr] = {
    .visible = true,
    .named = true,
  },
  [sym_operand_args] = {
    .visible = true,
    .named = true,
  },
  [sym_operand] = {
    .visible = true,
    .named = true,
  },
  [sym_operand_ident] = {
    .visible = true,
    .named = true,
  },
  [sym_effective_addr] = {
    .visible = true,
    .named = true,
  },
  [sym_segment_prefix] = {
    .visible = true,
    .named = true,
  },
  [sym_segment] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_offset] = {
    .visible = true,
    .named = true,
  },
  [sym__decimal_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__hex_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__octal_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__binary_literal] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_objdump_machine_code_bytes_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_operand_args_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_effective_addr_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(900);
      if (lookahead == '"') ADVANCE(1048);
      if (lookahead == '$') ADVANCE(923);
      if (lookahead == '(') ADVANCE(1032);
      if (lookahead == ')') ADVANCE(1033);
      if (lookahead == '*') ADVANCE(1034);
      if (lookahead == '+') ADVANCE(1035);
      if (lookahead == ',') ADVANCE(1026);
      if (lookahead == '-') ADVANCE(1036);
      if (lookahead == '.') ADVANCE(2048);
      if (lookahead == '0') ADVANCE(962);
      if (lookahead == '1') ADVANCE(961);
      if (lookahead == ':') ADVANCE(925);
      if (lookahead == '<') ADVANCE(927);
      if (lookahead == '>') ADVANCE(928);
      if (lookahead == 'B') ADVANCE(960);
      if (lookahead == 'D') ADVANCE(959);
      if (lookahead == 'P') ADVANCE(2139);
      if (lookahead == 'Q') ADVANCE(2142);
      if (lookahead == 'W') ADVANCE(2130);
      if (lookahead == 'X') ADVANCE(2128);
      if (lookahead == '[') ADVANCE(1031);
      if (lookahead == '\\') ADVANCE(88);
      if (lookahead == ']') ADVANCE(1037);
      if (lookahead == '_') ADVANCE(2919);
      if (lookahead == 'a') ADVANCE(964);
      if (lookahead == 'b') ADVANCE(976);
      if (lookahead == 'c') ADVANCE(965);
      if (lookahead == 'd') ADVANCE(966);
      if (lookahead == 'e') ADVANCE(968);
      if (lookahead == 'f') ADVANCE(957);
      if (lookahead == 'g') ADVANCE(2532);
      if (lookahead == 'h') ADVANCE(2174);
      if (lookahead == 'i') ADVANCE(2294);
      if (lookahead == 'j') ADVANCE(2146);
      if (lookahead == 'k') ADVANCE(2150);
      if (lookahead == 'l') ADVANCE(2166);
      if (lookahead == 'm') ADVANCE(2151);
      if (lookahead == 'n') ADVANCE(2383);
      if (lookahead == 'o') ADVANCE(2703);
      if (lookahead == 'p') ADVANCE(2152);
      if (lookahead == 'q') ADVANCE(2890);
      if (lookahead == 'r') ADVANCE(2052);
      if (lookahead == 's') ADVANCE(2153);
      if (lookahead == 't') ADVANCE(2066);
      if (lookahead == 'u') ADVANCE(2265);
      if (lookahead == 'v') ADVANCE(2154);
      if (lookahead == 'w') ADVANCE(2168);
      if (lookahead == 'x') ADVANCE(2199);
      if (lookahead == 'y') ADVANCE(2572);
      if (lookahead == '#' ||
          lookahead == ';') ADVANCE(905);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(974);
      if (('A' <= lookahead && lookahead <= 'F')) ADVANCE(995);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      if (('2' <= lookahead && lookahead <= '7')) ADVANCE(973);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == 'z') ADVANCE(2964);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(9)
      if (lookahead == '"') ADVANCE(1048);
      if (lookahead == '\\') ADVANCE(88);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(1049);
      if (lookahead != 0) ADVANCE(1050);
      END_STATE();
    case 2:
      if (lookahead == ' ') ADVANCE(665);
      END_STATE();
    case 3:
      if (lookahead == ' ') ADVANCE(924);
      END_STATE();
    case 4:
      if (lookahead == ' ') ADVANCE(895);
      END_STATE();
    case 5:
      if (lookahead == ' ') ADVANCE(382);
      END_STATE();
    case 6:
      if (lookahead == '"') ADVANCE(1048);
      if (lookahead == '$') ADVANCE(13);
      if (lookahead == '0') ADVANCE(1054);
      if (lookahead == '1') ADVANCE(1055);
      if (lookahead == ':') ADVANCE(877);
      if (lookahead == '>') ADVANCE(928);
      if (lookahead == 'B') ADVANCE(2144);
      if (lookahead == 'D') ADVANCE(2141);
      if (lookahead == 'P') ADVANCE(2139);
      if (lookahead == 'Q') ADVANCE(2142);
      if (lookahead == 'W') ADVANCE(2130);
      if (lookahead == 'X') ADVANCE(2128);
      if (lookahead == '[') ADVANCE(1031);
      if (lookahead == '_') ADVANCE(2919);
      if (lookahead == 'b') ADVANCE(2462);
      if (lookahead == 'd') ADVANCE(2460);
      if (lookahead == 'e') ADVANCE(2231);
      if (lookahead == 'p') ADVANCE(2842);
      if (lookahead == 'q') ADVANCE(2890);
      if (lookahead == 'r') ADVANCE(2053);
      if (lookahead == 's') ADVANCE(2937);
      if (lookahead == 'w') ADVANCE(2635);
      if (lookahead == 'x') ADVANCE(2568);
      if (lookahead == 'y') ADVANCE(2572);
      if (('a' <= lookahead && lookahead <= 'c')) ADVANCE(2458);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(1057);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(6)
      if (('A' <= lookahead && lookahead <= 'F') ||
          lookahead == 'f') ADVANCE(2477);
      if (('2' <= lookahead && lookahead <= '7')) ADVANCE(1056);
      if (lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 7:
      if (lookahead == '"') ADVANCE(1048);
      if (lookahead == '$') ADVANCE(13);
      if (lookahead == '0') ADVANCE(1054);
      if (lookahead == '1') ADVANCE(1055);
      if (lookahead == 'P') ADVANCE(2139);
      if (lookahead == '[') ADVANCE(1031);
      if (lookahead == '_') ADVANCE(2919);
      if (lookahead == 'b') ADVANCE(2463);
      if (lookahead == 'd') ADVANCE(2461);
      if (lookahead == 'e') ADVANCE(2231);
      if (lookahead == 'p') ADVANCE(2842);
      if (lookahead == 'r') ADVANCE(2053);
      if (lookahead == 's') ADVANCE(2937);
      if (('a' <= lookahead && lookahead <= 'c')) ADVANCE(2458);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(1057);
      if (lookahead == 'x' ||
          lookahead == 'y') ADVANCE(2572);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(7)
      if (('2' <= lookahead && lookahead <= '7')) ADVANCE(1056);
      if (('A' <= lookahead && lookahead <= 'F') ||
          lookahead == 'f') ADVANCE(2477);
      if (lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 8:
      if (lookahead == '"') ADVANCE(1048);
      if (lookahead == '$') ADVANCE(13);
      if (lookahead == '0') ADVANCE(1054);
      if (lookahead == '1') ADVANCE(1055);
      if (lookahead == '[') ADVANCE(1031);
      if (lookahead == '_') ADVANCE(2919);
      if (lookahead == 'b') ADVANCE(2463);
      if (lookahead == 'd') ADVANCE(2461);
      if (lookahead == 'e') ADVANCE(2231);
      if (lookahead == 'r') ADVANCE(2053);
      if (lookahead == 's') ADVANCE(2937);
      if (('a' <= lookahead && lookahead <= 'c')) ADVANCE(2458);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(1057);
      if (lookahead == 'x' ||
          lookahead == 'y') ADVANCE(2572);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(8)
      if (('2' <= lookahead && lookahead <= '7')) ADVANCE(1056);
      if (('A' <= lookahead && lookahead <= 'F') ||
          lookahead == 'f') ADVANCE(2477);
      if (lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 9:
      if (lookahead == '"') ADVANCE(1048);
      if (lookahead == '\\') ADVANCE(88);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(9)
      END_STATE();
    case 10:
      if (lookahead == '$') ADVANCE(923);
      if (lookahead == 'D') ADVANCE(942);
      if (lookahead == 'a') ADVANCE(931);
      if (lookahead == 'b') ADVANCE(939);
      if (lookahead == 'c') ADVANCE(932);
      if (lookahead == 'd') ADVANCE(933);
      if (lookahead == 'e') ADVANCE(945);
      if (lookahead == 'f') ADVANCE(929);
      if (lookahead == 'g') ADVANCE(1642);
      if (lookahead == 'h') ADVANCE(1299);
      if (lookahead == 'i') ADVANCE(1427);
      if (lookahead == 'j') ADVANCE(1269);
      if (lookahead == 'k') ADVANCE(1274);
      if (lookahead == 'l') ADVANCE(1289);
      if (lookahead == 'm') ADVANCE(1275);
      if (lookahead == 'n') ADVANCE(1505);
      if (lookahead == 'o') ADVANCE(1814);
      if (lookahead == 'p') ADVANCE(1276);
      if (lookahead == 'r') ADVANCE(1377);
      if (lookahead == 's') ADVANCE(1277);
      if (lookahead == 't') ADVANCE(1211);
      if (lookahead == 'u') ADVANCE(1389);
      if (lookahead == 'v') ADVANCE(1278);
      if (lookahead == 'w') ADVANCE(1291);
      if (lookahead == 'x') ADVANCE(1325);
      if (lookahead == '#' ||
          lookahead == ';') ADVANCE(905);
      if (lookahead == '-' ||
          lookahead == '/') ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(10)
      if (('A' <= lookahead && lookahead <= 'F')) ADVANCE(956);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(958);
      if (lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('q' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 11:
      if (lookahead == '$') ADVANCE(13);
      if (lookahead == '(') ADVANCE(1032);
      if (lookahead == ')') ADVANCE(1033);
      if (lookahead == '*') ADVANCE(1034);
      if (lookahead == '+') ADVANCE(1035);
      if (lookahead == '-') ADVANCE(1036);
      if (lookahead == '0') ADVANCE(1054);
      if (lookahead == '1') ADVANCE(1055);
      if (lookahead == '<') ADVANCE(927);
      if (lookahead == ']') ADVANCE(1037);
      if (lookahead == '_') ADVANCE(2919);
      if (lookahead == 'a') ADVANCE(2458);
      if (lookahead == 'b') ADVANCE(2463);
      if (lookahead == 'c') ADVANCE(2457);
      if (lookahead == 'd') ADVANCE(2459);
      if (lookahead == 'e') ADVANCE(2230);
      if (lookahead == 'f') ADVANCE(2473);
      if (lookahead == 'g') ADVANCE(2737);
      if (lookahead == 'r') ADVANCE(2053);
      if (lookahead == 's') ADVANCE(2936);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(1057);
      if (lookahead == 'x' ||
          lookahead == 'y') ADVANCE(2572);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(11)
      if (('2' <= lookahead && lookahead <= '7')) ADVANCE(1056);
      if (('A' <= lookahead && lookahead <= 'F')) ADVANCE(2477);
      if (lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 12:
      if (lookahead == '$') ADVANCE(13);
      if (lookahead == '.') ADVANCE(894);
      if (lookahead == '0') ADVANCE(407);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(12)
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(408);
      END_STATE();
    case 13:
      if (lookahead == '0') ADVANCE(885);
      END_STATE();
    case 14:
      if (lookahead == '0') ADVANCE(247);
      if (lookahead == '1') ADVANCE(247);
      END_STATE();
    case 15:
      if (lookahead == '1') ADVANCE(1071);
      END_STATE();
    case 16:
      if (lookahead == '1') ADVANCE(592);
      END_STATE();
    case 17:
      if (lookahead == '1') ADVANCE(593);
      END_STATE();
    case 18:
      if (lookahead == '1') ADVANCE(514);
      if (lookahead == '2') ADVANCE(80);
      END_STATE();
    case 19:
      if (lookahead == '1') ADVANCE(77);
      if (lookahead == '2') ADVANCE(86);
      if (lookahead == 'p') ADVANCE(664);
      if (lookahead == 's') ADVANCE(664);
      END_STATE();
    case 20:
      if (lookahead == '1') ADVANCE(74);
      if (lookahead == '2') ADVANCE(23);
      if (lookahead == 'a') ADVANCE(321);
      if (lookahead == 'p') ADVANCE(846);
      if (lookahead == 's') ADVANCE(846);
      END_STATE();
    case 21:
      if (lookahead == '1') ADVANCE(74);
      if (lookahead == '2') ADVANCE(23);
      if (lookahead == 'p') ADVANCE(846);
      if (lookahead == 's') ADVANCE(846);
      END_STATE();
    case 22:
      if (lookahead == '1') ADVANCE(74);
      if (lookahead == '2') ADVANCE(23);
      if (lookahead == 'p') ADVANCE(846);
      if (lookahead == 's') ADVANCE(849);
      END_STATE();
    case 23:
      if (lookahead == '1') ADVANCE(72);
      if (lookahead == '3') ADVANCE(17);
      END_STATE();
    case 24:
      if (lookahead == '1') ADVANCE(69);
      if (lookahead == '3') ADVANCE(16);
      END_STATE();
    case 25:
      if (lookahead == '1') ADVANCE(45);
      END_STATE();
    case 26:
      if (lookahead == '1') ADVANCE(45);
      if (lookahead == '3') ADVANCE(62);
      if (lookahead == '6') ADVANCE(79);
      END_STATE();
    case 27:
      if (lookahead == '1') ADVANCE(45);
      if (lookahead == '3') ADVANCE(65);
      if (lookahead == '6') ADVANCE(79);
      END_STATE();
    case 28:
      if (lookahead == '1') ADVANCE(73);
      if (lookahead == '2') ADVANCE(24);
      if (lookahead == 'p') ADVANCE(846);
      END_STATE();
    case 29:
      if (lookahead == '1') ADVANCE(511);
      if (lookahead == 'e') ADVANCE(694);
      if (lookahead == 'z') ADVANCE(216);
      END_STATE();
    case 30:
      if (lookahead == '2') ADVANCE(1071);
      END_STATE();
    case 31:
      if (lookahead == '2') ADVANCE(592);
      END_STATE();
    case 32:
      if (lookahead == '2') ADVANCE(592);
      if (lookahead == 'a') ADVANCE(539);
      END_STATE();
    case 33:
      if (lookahead == '2') ADVANCE(592);
      if (lookahead == 'p') ADVANCE(846);
      END_STATE();
    case 34:
      if (lookahead == '2') ADVANCE(593);
      END_STATE();
    case 35:
      if (lookahead == '2') ADVANCE(869);
      if (lookahead == 's') ADVANCE(452);
      END_STATE();
    case 36:
      if (lookahead == '2') ADVANCE(853);
      if (lookahead == 'g') ADVANCE(30);
      if (lookahead == 'n') ADVANCE(30);
      END_STATE();
    case 37:
      if (lookahead == '2') ADVANCE(289);
      END_STATE();
    case 38:
      if (lookahead == '2') ADVANCE(844);
      END_STATE();
    case 39:
      if (lookahead == '2') ADVANCE(380);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'i') ADVANCE(41);
      if (lookahead == 'p') ADVANCE(846);
      if (lookahead == 't') ADVANCE(40);
      END_STATE();
    case 40:
      if (lookahead == '2') ADVANCE(873);
      END_STATE();
    case 41:
      if (lookahead == '2') ADVANCE(873);
      if (lookahead == 'l') ADVANCE(33);
      END_STATE();
    case 42:
      if (lookahead == '2') ADVANCE(292);
      END_STATE();
    case 43:
      if (lookahead == '2') ADVANCE(295);
      END_STATE();
    case 44:
      if (lookahead == '2') ADVANCE(1009);
      if (lookahead == 'a') ADVANCE(997);
      if (lookahead == 'b') ADVANCE(1003);
      if (lookahead == 'c') ADVANCE(1001);
      if (lookahead == 'd') ADVANCE(1000);
      if (lookahead == 'e') ADVANCE(1004);
      if (lookahead == 'f') ADVANCE(1006);
      if (lookahead == 'i') ADVANCE(146);
      if (lookahead == 'l') ADVANCE(276);
      if (lookahead == 'm') ADVANCE(781);
      if (lookahead == 'n') ADVANCE(233);
      if (lookahead == 'p') ADVANCE(128);
      if (lookahead == 'r') ADVANCE(538);
      if (lookahead == 's') ADVANCE(124);
      if (lookahead == 't') ADVANCE(694);
      if (lookahead == 'u') ADVANCE(231);
      if (lookahead == 'w') ADVANCE(117);
      if (lookahead == 'x') ADVANCE(121);
      if (lookahead == 'y') ADVANCE(472);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F')) ADVANCE(996);
      END_STATE();
    case 45:
      if (lookahead == '2') ADVANCE(85);
      END_STATE();
    case 46:
      if (lookahead == '2') ADVANCE(290);
      END_STATE();
    case 47:
      if (lookahead == '2') ADVANCE(291);
      END_STATE();
    case 48:
      if (lookahead == '2') ADVANCE(419);
      END_STATE();
    case 49:
      if (lookahead == '2') ADVANCE(373);
      if (lookahead == 'n') ADVANCE(699);
      END_STATE();
    case 50:
      if (lookahead == '2') ADVANCE(685);
      END_STATE();
    case 51:
      if (lookahead == '2') ADVANCE(293);
      END_STATE();
    case 52:
      if (lookahead == '2') ADVANCE(490);
      END_STATE();
    case 53:
      if (lookahead == '2') ADVANCE(490);
      if (lookahead == 'b') ADVANCE(1071);
      END_STATE();
    case 54:
      if (lookahead == '2') ADVANCE(490);
      if (lookahead == 'b' ||
          lookahead == 'w') ADVANCE(1071);
      END_STATE();
    case 55:
      if (lookahead == '2') ADVANCE(490);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'w') ADVANCE(1071);
      END_STATE();
    case 56:
      if (lookahead == '2') ADVANCE(622);
      if (lookahead == 'a' ||
          lookahead == 'u') ADVANCE(1071);
      END_STATE();
    case 57:
      if (lookahead == '2') ADVANCE(687);
      END_STATE();
    case 58:
      if (lookahead == '2') ADVANCE(696);
      END_STATE();
    case 59:
      if (lookahead == '2') ADVANCE(826);
      END_STATE();
    case 60:
      if (lookahead == '2') ADVANCE(426);
      if (lookahead == 'a') ADVANCE(207);
      if (lookahead == 'c') ADVANCE(510);
      if (lookahead == 'm') ADVANCE(115);
      if (lookahead == 'n') ADVANCE(133);
      if (lookahead == 'p') ADVANCE(540);
      if (lookahead == 'r') ADVANCE(219);
      if (lookahead == 's') ADVANCE(784);
      END_STATE();
    case 61:
      if (lookahead == '2') ADVANCE(824);
      END_STATE();
    case 62:
      if (lookahead == '2') ADVANCE(820);
      END_STATE();
    case 63:
      if (lookahead == '2') ADVANCE(607);
      END_STATE();
    case 64:
      if (lookahead == '2') ADVANCE(670);
      END_STATE();
    case 65:
      if (lookahead == '2') ADVANCE(822);
      END_STATE();
    case 66:
      if (lookahead == '2') ADVANCE(684);
      END_STATE();
    case 67:
      if (lookahead == '2') ADVANCE(686);
      END_STATE();
    case 68:
      if (lookahead == '2') ADVANCE(695);
      END_STATE();
    case 69:
      if (lookahead == '3') ADVANCE(592);
      END_STATE();
    case 70:
      if (lookahead == '3') ADVANCE(30);
      END_STATE();
    case 71:
      if (lookahead == '3') ADVANCE(30);
      if (lookahead == '6') ADVANCE(76);
      END_STATE();
    case 72:
      if (lookahead == '3') ADVANCE(593);
      END_STATE();
    case 73:
      if (lookahead == '3') ADVANCE(31);
      END_STATE();
    case 74:
      if (lookahead == '3') ADVANCE(34);
      END_STATE();
    case 75:
      if (lookahead == '3') ADVANCE(61);
      if (lookahead == '6') ADVANCE(78);
      END_STATE();
    case 76:
      if (lookahead == '4') ADVANCE(1071);
      END_STATE();
    case 77:
      if (lookahead == '4') ADVANCE(593);
      END_STATE();
    case 78:
      if (lookahead == '4') ADVANCE(818);
      END_STATE();
    case 79:
      if (lookahead == '4') ADVANCE(821);
      END_STATE();
    case 80:
      if (lookahead == '5') ADVANCE(84);
      END_STATE();
    case 81:
      if (lookahead == '5') ADVANCE(48);
      if (lookahead == 'u') ADVANCE(194);
      if (lookahead == 'w') ADVANCE(239);
      END_STATE();
    case 82:
      if (lookahead == '6') ADVANCE(1071);
      END_STATE();
    case 83:
      if (lookahead == '6') ADVANCE(167);
      END_STATE();
    case 84:
      if (lookahead == '6') ADVANCE(515);
      END_STATE();
    case 85:
      if (lookahead == '8') ADVANCE(1071);
      END_STATE();
    case 86:
      if (lookahead == '8') ADVANCE(593);
      END_STATE();
    case 87:
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(87);
      END_STATE();
    case 88:
      if (lookahead == 'U') ADVANCE(893);
      if (lookahead == 'u') ADVANCE(889);
      if (lookahead == 'x') ADVANCE(887);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1047);
      if (lookahead != 0) ADVANCE(1045);
      END_STATE();
    case 89:
      if (lookahead == 'a') ADVANCE(1122);
      if (lookahead == 'b') ADVANCE(1122);
      if (lookahead == 'c' ||
          lookahead == 'o' ||
          lookahead == 's' ||
          lookahead == 'z') ADVANCE(1071);
      if (lookahead == 'e') ADVANCE(1110);
      if (lookahead == 'g') ADVANCE(1122);
      if (lookahead == 'l') ADVANCE(1122);
      if (lookahead == 'm') ADVANCE(591);
      if (lookahead == 'n') ADVANCE(91);
      if (lookahead == 'p') ADVANCE(1192);
      END_STATE();
    case 90:
      if (lookahead == 'a') ADVANCE(1122);
      if (lookahead == 'b') ADVANCE(1122);
      if (lookahead == 'c' ||
          lookahead == 'e' ||
          lookahead == 'o' ||
          lookahead == 's' ||
          lookahead == 'z') ADVANCE(1071);
      if (lookahead == 'g') ADVANCE(1122);
      if (lookahead == 'l') ADVANCE(1122);
      if (lookahead == 'n') ADVANCE(91);
      if (lookahead == 'p') ADVANCE(1192);
      END_STATE();
    case 91:
      if (lookahead == 'a') ADVANCE(1122);
      if (lookahead == 'b') ADVANCE(1122);
      if (lookahead == 'c' ||
          lookahead == 'e' ||
          lookahead == 'o' ||
          lookahead == 'p' ||
          lookahead == 's' ||
          lookahead == 'z') ADVANCE(1071);
      if (lookahead == 'g') ADVANCE(1122);
      if (lookahead == 'l') ADVANCE(1122);
      END_STATE();
    case 92:
      if (lookahead == 'a') ADVANCE(1071);
      END_STATE();
    case 93:
      if (lookahead == 'a') ADVANCE(1012);
      if (lookahead == 'd') ADVANCE(999);
      if (lookahead == 'e') ADVANCE(1007);
      if (lookahead == 'n') ADVANCE(275);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('b' <= lookahead && lookahead <= 'f')) ADVANCE(996);
      END_STATE();
    case 94:
      if (lookahead == 'a') ADVANCE(1002);
      if (lookahead == 'b') ADVANCE(1008);
      if (lookahead == 'd') ADVANCE(1005);
      if (lookahead == 'l') ADVANCE(119);
      if (lookahead == 'm') ADVANCE(196);
      if (lookahead == 'o') ADVANCE(508);
      if (lookahead == 'p') ADVANCE(782);
      if (lookahead == 'q') ADVANCE(563);
      if (lookahead == 'r') ADVANCE(200);
      if (lookahead == 'v') ADVANCE(729);
      if (lookahead == 'w') ADVANCE(238);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('c' <= lookahead && lookahead <= 'f')) ADVANCE(996);
      END_STATE();
    case 95:
      if (lookahead == 'a') ADVANCE(1011);
      if (lookahead == 'e') ADVANCE(998);
      if (lookahead == 'i') ADVANCE(811);
      if (lookahead == 'p') ADVANCE(592);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('b' <= lookahead && lookahead <= 'f')) ADVANCE(996);
      END_STATE();
    case 96:
      if (lookahead == 'a') ADVANCE(592);
      if (lookahead == 'd') ADVANCE(1121);
      if (lookahead == 'h') ADVANCE(480);
      if (lookahead == 'l') ADVANCE(420);
      if (lookahead == 'm') ADVANCE(697);
      if (lookahead == 'n') ADVANCE(753);
      if (lookahead == 'q') ADVANCE(1071);
      if (lookahead == 's') ADVANCE(847);
      if (lookahead == 'u') ADVANCE(592);
      END_STATE();
    case 97:
      if (lookahead == 'a') ADVANCE(307);
      if (lookahead == 'm') ADVANCE(574);
      if (lookahead == 'n') ADVANCE(579);
      if (lookahead == 'o') ADVANCE(636);
      if (lookahead == 's') ADVANCE(417);
      if (lookahead == 't') ADVANCE(362);
      if (lookahead == 'u') ADVANCE(557);
      if (lookahead == 'x') ADVANCE(558);
      END_STATE();
    case 98:
      if (lookahead == 'a') ADVANCE(671);
      if (lookahead == 'f') ADVANCE(342);
      if (lookahead == 'i') ADVANCE(524);
      if (lookahead == 'o') ADVANCE(809);
      if (lookahead == 'p') ADVANCE(704);
      if (lookahead == 'u') ADVANCE(474);
      END_STATE();
    case 99:
      if (lookahead == 'a') ADVANCE(188);
      if (lookahead == 'b') ADVANCE(486);
      if (lookahead == 'c') ADVANCE(476);
      if (lookahead == 'd') ADVANCE(335);
      if (lookahead == 'e') ADVANCE(830);
      if (lookahead == 'f') ADVANCE(60);
      if (lookahead == 'h') ADVANCE(149);
      if (lookahead == 'i') ADVANCE(49);
      if (lookahead == 'm') ADVANCE(102);
      if (lookahead == 'o') ADVANCE(602);
      if (lookahead == 'r') ADVANCE(340);
      if (lookahead == 's') ADVANCE(138);
      if (lookahead == 't') ADVANCE(334);
      if (lookahead == 'u') ADVANCE(561);
      if (lookahead == 'x') ADVANCE(576);
      END_STATE();
    case 100:
      if (lookahead == 'a') ADVANCE(415);
      if (lookahead == 'b') ADVANCE(167);
      if (lookahead == 'c') ADVANCE(126);
      if (lookahead == 'e') ADVANCE(731);
      if (lookahead == 'f') ADVANCE(342);
      if (lookahead == 'h') ADVANCE(103);
      if (lookahead == 'q') ADVANCE(652);
      if (lookahead == 't') ADVANCE(120);
      if (lookahead == 'u') ADVANCE(185);
      if (lookahead == 'w') ADVANCE(127);
      if (lookahead == 'y') ADVANCE(673);
      END_STATE();
    case 101:
      if (lookahead == 'a') ADVANCE(311);
      if (lookahead == 'b') ADVANCE(488);
      if (lookahead == 'c') ADVANCE(509);
      if (lookahead == 'd') ADVANCE(189);
      if (lookahead == 'e') ADVANCE(819);
      if (lookahead == 'f') ADVANCE(431);
      if (lookahead == 'g') ADVANCE(134);
      if (lookahead == 'h') ADVANCE(123);
      if (lookahead == 'i') ADVANCE(559);
      if (lookahead == 'l') ADVANCE(248);
      if (lookahead == 'm') ADVANCE(164);
      if (lookahead == 'o') ADVANCE(635);
      if (lookahead == 'p') ADVANCE(104);
      if (lookahead == 'r') ADVANCE(130);
      if (lookahead == 's') ADVANCE(220);
      if (lookahead == 't') ADVANCE(365);
      if (lookahead == 'u') ADVANCE(213);
      if (lookahead == 'x') ADVANCE(571);
      if (lookahead == 'z') ADVANCE(346);
      END_STATE();
    case 102:
      if (lookahead == 'a') ADVANCE(315);
      if (lookahead == 'i') ADVANCE(528);
      if (lookahead == 'o') ADVANCE(802);
      if (lookahead == 'u') ADVANCE(465);
      END_STATE();
    case 103:
      if (lookahead == 'a') ADVANCE(18);
      if (lookahead == 'l') ADVANCE(1191);
      if (lookahead == 'r') ADVANCE(1191);
      if (lookahead == 'u') ADVANCE(371);
      END_STATE();
    case 104:
      if (lookahead == 'a') ADVANCE(186);
      if (lookahead == 'b') ADVANCE(489);
      if (lookahead == 'c') ADVANCE(475);
      if (lookahead == 'e') ADVANCE(654);
      if (lookahead == 'g') ADVANCE(162);
      if (lookahead == 'h') ADVANCE(157);
      if (lookahead == 'i') ADVANCE(535);
      if (lookahead == 'l') ADVANCE(835);
      if (lookahead == 'm') ADVANCE(107);
      if (lookahead == 'o') ADVANCE(633);
      if (lookahead == 'p') ADVANCE(359);
      if (lookahead == 'r') ADVANCE(567);
      if (lookahead == 's') ADVANCE(137);
      if (lookahead == 't') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(560);
      if (lookahead == 'x') ADVANCE(577);
      END_STATE();
    case 105:
      if (lookahead == 'a') ADVANCE(869);
      if (lookahead == 'l') ADVANCE(869);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 106:
      if (lookahead == 'a') ADVANCE(850);
      if (lookahead == 'l') ADVANCE(242);
      END_STATE();
    case 107:
      if (lookahead == 'a') ADVANCE(225);
      if (lookahead == 'i') ADVANCE(529);
      if (lookahead == 'o') ADVANCE(805);
      if (lookahead == 'u') ADVANCE(467);
      END_STATE();
    case 108:
      if (lookahead == 'a') ADVANCE(485);
      END_STATE();
    case 109:
      if (lookahead == 'a') ADVANCE(866);
      if (lookahead == 'l') ADVANCE(243);
      END_STATE();
    case 110:
      if (lookahead == 'a') ADVANCE(694);
      END_STATE();
    case 111:
      if (lookahead == 'a') ADVANCE(755);
      END_STATE();
    case 112:
      if (lookahead == 'a') ADVANCE(414);
      if (lookahead == 'd') ADVANCE(269);
      if (lookahead == 'e') ADVANCE(116);
      if (lookahead == 'f') ADVANCE(342);
      if (lookahead == 'o') ADVANCE(296);
      if (lookahead == 'z') ADVANCE(215);
      END_STATE();
    case 113:
      if (lookahead == 'a') ADVANCE(591);
      END_STATE();
    case 114:
      if (lookahead == 'a') ADVANCE(1084);
      if (lookahead == 'u') ADVANCE(1078);
      END_STATE();
    case 115:
      if (lookahead == 'a') ADVANCE(817);
      if (lookahead == 'i') ADVANCE(522);
      if (lookahead == 'u') ADVANCE(461);
      END_STATE();
    case 116:
      if (lookahead == 'a') ADVANCE(1183);
      END_STATE();
    case 117:
      if (lookahead == 'a') ADVANCE(429);
      END_STATE();
    case 118:
      if (lookahead == 'a') ADVANCE(429);
      if (lookahead == 'r') ADVANCE(383);
      END_STATE();
    case 119:
      if (lookahead == 'a') ADVANCE(195);
      if (lookahead == 'c' ||
          lookahead == 'd') ADVANCE(1071);
      if (lookahead == 'f') ADVANCE(477);
      if (lookahead == 'w') ADVANCE(167);
      if (lookahead == 'z') ADVANCE(348);
      END_STATE();
    case 120:
      if (lookahead == 'a') ADVANCE(195);
      if (lookahead == 'c' ||
          lookahead == 'd' ||
          lookahead == 'i') ADVANCE(1071);
      if (lookahead == 'm') ADVANCE(829);
      if (lookahead == 'o') ADVANCE(676);
      END_STATE();
    case 121:
      if (lookahead == 'a') ADVANCE(490);
      if (lookahead == 'c') ADVANCE(405);
      if (lookahead == 'r') ADVANCE(724);
      if (lookahead == 's') ADVANCE(150);
      if (lookahead == 't') ADVANCE(653);
      END_STATE();
    case 122:
      if (lookahead == 'a') ADVANCE(304);
      if (lookahead == 'l') ADVANCE(726);
      if (lookahead == 's') ADVANCE(780);
      END_STATE();
    case 123:
      if (lookahead == 'a') ADVANCE(304);
      if (lookahead == 's') ADVANCE(780);
      END_STATE();
    case 124:
      if (lookahead == 'a') ADVANCE(812);
      if (lookahead == 'c') ADVANCE(152);
      if (lookahead == 'i') ADVANCE(534);
      if (lookahead == 'q') ADVANCE(647);
      if (lookahead == 't') ADVANCE(1107);
      if (lookahead == 'u') ADVANCE(168);
      END_STATE();
    case 125:
      if (lookahead == 'a') ADVANCE(812);
      if (lookahead == 't') ADVANCE(202);
      END_STATE();
    case 126:
      if (lookahead == 'a') ADVANCE(676);
      END_STATE();
    case 127:
      if (lookahead == 'a') ADVANCE(606);
      END_STATE();
    case 128:
      if (lookahead == 'a') ADVANCE(759);
      if (lookahead == 'r') ADVANCE(349);
      if (lookahead == 't') ADVANCE(135);
      END_STATE();
    case 129:
      if (lookahead == 'a') ADVANCE(612);
      END_STATE();
    case 130:
      if (lookahead == 'a') ADVANCE(533);
      if (lookahead == 'c') ADVANCE(599);
      if (lookahead == 'e') ADVANCE(303);
      if (lookahead == 'n') ADVANCE(323);
      if (lookahead == 'o') ADVANCE(794);
      if (lookahead == 's') ADVANCE(631);
      END_STATE();
    case 131:
      if (lookahead == 'a') ADVANCE(473);
      END_STATE();
    case 132:
      if (lookahead == 'a') ADVANCE(473);
      if (lookahead == 'u') ADVANCE(617);
      END_STATE();
    case 133:
      if (lookahead == 'a') ADVANCE(206);
      END_STATE();
    case 134:
      if (lookahead == 'a') ADVANCE(757);
      if (lookahead == 'e') ADVANCE(735);
      END_STATE();
    case 135:
      if (lookahead == 'a') ADVANCE(522);
      END_STATE();
    case 136:
      if (lookahead == 'a') ADVANCE(306);
      END_STATE();
    case 137:
      if (lookahead == 'a') ADVANCE(306);
      if (lookahead == 'c') ADVANCE(141);
      if (lookahead == 'h') ADVANCE(105);
      if (lookahead == 'i') ADVANCE(400);
      if (lookahead == 'l') ADVANCE(469);
      if (lookahead == 'r') ADVANCE(109);
      if (lookahead == 'u') ADVANCE(175);
      END_STATE();
    case 138:
      if (lookahead == 'a') ADVANCE(306);
      if (lookahead == 'h') ADVANCE(783);
      if (lookahead == 'i') ADVANCE(400);
      if (lookahead == 'l') ADVANCE(466);
      if (lookahead == 'r') ADVANCE(106);
      if (lookahead == 'u') ADVANCE(175);
      if (lookahead == 'w') ADVANCE(129);
      END_STATE();
    case 139:
      if (lookahead == 'a') ADVANCE(542);
      END_STATE();
    case 140:
      if (lookahead == 'a') ADVANCE(715);
      END_STATE();
    case 141:
      if (lookahead == 'a') ADVANCE(774);
      END_STATE();
    case 142:
      if (lookahead == 'a') ADVANCE(313);
      END_STATE();
    case 143:
      if (lookahead == 'a') ADVANCE(708);
      END_STATE();
    case 144:
      if (lookahead == 'a') ADVANCE(227);
      if (lookahead == 'q') ADVANCE(1071);
      END_STATE();
    case 145:
      if (lookahead == 'a') ADVANCE(301);
      if (lookahead == 'c') ADVANCE(410);
      if (lookahead == 'g') ADVANCE(353);
      if (lookahead == 'o') ADVANCE(649);
      if (lookahead == 'r') ADVANCE(721);
      if (lookahead == 's') ADVANCE(147);
      END_STATE();
    case 146:
      if (lookahead == 'a') ADVANCE(301);
      if (lookahead == 'c') ADVANCE(581);
      if (lookahead == 'd') ADVANCE(435);
      if (lookahead == 'l') ADVANCE(239);
      if (lookahead == 'm') ADVANCE(778);
      if (lookahead == 'n') ADVANCE(235);
      if (lookahead == 's') ADVANCE(749);
      END_STATE();
    case 147:
      if (lookahead == 'a') ADVANCE(813);
      if (lookahead == 'e') ADVANCE(762);
      END_STATE();
    case 148:
      if (lookahead == 'a') ADVANCE(208);
      END_STATE();
    case 149:
      if (lookahead == 'a') ADVANCE(314);
      if (lookahead == 'm') ADVANCE(443);
      if (lookahead == 's') ADVANCE(786);
      END_STATE();
    case 150:
      if (lookahead == 'a') ADVANCE(814);
      END_STATE();
    case 151:
      if (lookahead == 'a') ADVANCE(228);
      END_STATE();
    case 152:
      if (lookahead == 'a') ADVANCE(481);
      END_STATE();
    case 153:
      if (lookahead == 'a') ADVANCE(536);
      END_STATE();
    case 154:
      if (lookahead == 'a') ADVANCE(317);
      if (lookahead == 's') ADVANCE(787);
      END_STATE();
    case 155:
      if (lookahead == 'a') ADVANCE(718);
      END_STATE();
    case 156:
      if (lookahead == 'a') ADVANCE(484);
      END_STATE();
    case 157:
      if (lookahead == 'a') ADVANCE(318);
      if (lookahead == 'm') ADVANCE(443);
      if (lookahead == 's') ADVANCE(789);
      END_STATE();
    case 158:
      if (lookahead == 'a') ADVANCE(319);
      if (lookahead == 's') ADVANCE(793);
      END_STATE();
    case 159:
      if (lookahead == 'a') ADVANCE(719);
      END_STATE();
    case 160:
      if (lookahead == 'a') ADVANCE(720);
      END_STATE();
    case 161:
      if (lookahead == 'a') ADVANCE(554);
      END_STATE();
    case 162:
      if (lookahead == 'a') ADVANCE(773);
      END_STATE();
    case 163:
      if (lookahead == 'a') ADVANCE(325);
      END_STATE();
    case 164:
      if (lookahead == 'a') ADVANCE(725);
      if (lookahead == 'i') ADVANCE(524);
      if (lookahead == 'o') ADVANCE(803);
      if (lookahead == 'p') ADVANCE(704);
      if (lookahead == 'u') ADVANCE(463);
      END_STATE();
    case 165:
      if (lookahead == 'b') ADVANCE(1122);
      if (lookahead == 'e' ||
          lookahead == 'u') ADVANCE(1071);
      END_STATE();
    case 166:
      if (lookahead == 'b') ADVANCE(1122);
      if (lookahead == 'e' ||
          lookahead == 'u') ADVANCE(1071);
      if (lookahead == 'n') ADVANCE(165);
      END_STATE();
    case 167:
      if (lookahead == 'b') ADVANCE(1071);
      END_STATE();
    case 168:
      if (lookahead == 'b') ADVANCE(1147);
      END_STATE();
    case 169:
      if (lookahead == 'b') ADVANCE(592);
      END_STATE();
    case 170:
      if (lookahead == 'b') ADVANCE(593);
      END_STATE();
    case 171:
      if (lookahead == 'b') ADVANCE(815);
      END_STATE();
    case 172:
      if (lookahead == 'b') ADVANCE(815);
      if (lookahead == 'd') ADVANCE(1169);
      if (lookahead == 's') ADVANCE(815);
      if (lookahead == 'w') ADVANCE(1115);
      END_STATE();
    case 173:
      if (lookahead == 'b') ADVANCE(815);
      if (lookahead == 'd') ADVANCE(622);
      if (lookahead == 'q') ADVANCE(286);
      if (lookahead == 'w') ADVANCE(239);
      END_STATE();
    case 174:
      if (lookahead == 'b') ADVANCE(815);
      if (lookahead == 'd') ADVANCE(622);
      if (lookahead == 'w') ADVANCE(239);
      END_STATE();
    case 175:
      if (lookahead == 'b') ADVANCE(875);
      END_STATE();
    case 176:
      if (lookahead == 'b') ADVANCE(851);
      END_STATE();
    case 177:
      if (lookahead == 'b') ADVANCE(20);
      END_STATE();
    case 178:
      if (lookahead == 'b') ADVANCE(172);
      END_STATE();
    case 179:
      if (lookahead == 'b') ADVANCE(865);
      if (lookahead == 'd') ADVANCE(1169);
      if (lookahead == 's') ADVANCE(815);
      if (lookahead == 'u') ADVANCE(180);
      if (lookahead == 'w') ADVANCE(1189);
      END_STATE();
    case 180:
      if (lookahead == 'b') ADVANCE(865);
      if (lookahead == 'd') ADVANCE(622);
      if (lookahead == 'w') ADVANCE(844);
      END_STATE();
    case 181:
      if (lookahead == 'b') ADVANCE(28);
      END_STATE();
    case 182:
      if (lookahead == 'b') ADVANCE(1170);
      END_STATE();
    case 183:
      if (lookahead == 'b') ADVANCE(21);
      END_STATE();
    case 184:
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'p') ADVANCE(846);
      END_STATE();
    case 185:
      if (lookahead == 'b') ADVANCE(1164);
      END_STATE();
    case 186:
      if (lookahead == 'b') ADVANCE(676);
      if (lookahead == 'c') ADVANCE(453);
      if (lookahead == 'd') ADVANCE(254);
      if (lookahead == 'l') ADVANCE(444);
      if (lookahead == 'n') ADVANCE(244);
      if (lookahead == 'v') ADVANCE(395);
      END_STATE();
    case 187:
      if (lookahead == 'b') ADVANCE(796);
      END_STATE();
    case 188:
      if (lookahead == 'b') ADVANCE(678);
      if (lookahead == 'c') ADVANCE(453);
      if (lookahead == 'd') ADVANCE(254);
      if (lookahead == 'l') ADVANCE(444);
      if (lookahead == 'n') ADVANCE(241);
      if (lookahead == 'u') ADVANCE(708);
      if (lookahead == 'v') ADVANCE(394);
      END_STATE();
    case 189:
      if (lookahead == 'b') ADVANCE(605);
      if (lookahead == 'i') ADVANCE(799);
      if (lookahead == 'p') ADVANCE(592);
      END_STATE();
    case 190:
      if (lookahead == 'b') ADVANCE(639);
      END_STATE();
    case 191:
      if (lookahead == 'b') ADVANCE(52);
      if (lookahead == 'd') ADVANCE(54);
      if (lookahead == 'm') ADVANCE(35);
      if (lookahead == 'q') ADVANCE(55);
      if (lookahead == 's') ADVANCE(258);
      if (lookahead == 'u') ADVANCE(688);
      if (lookahead == 'w') ADVANCE(53);
      if (lookahead == 'z') ADVANCE(825);
      END_STATE();
    case 192:
      if (lookahead == 'b') ADVANCE(143);
      END_STATE();
    case 193:
      if (lookahead == 'b') ADVANCE(38);
      END_STATE();
    case 194:
      if (lookahead == 'b') ADVANCE(674);
      END_STATE();
    case 195:
      if (lookahead == 'c') ADVANCE(1071);
      END_STATE();
    case 196:
      if (lookahead == 'c') ADVANCE(1071);
      if (lookahead == 'o') ADVANCE(800);
      if (lookahead == 'p') ADVANCE(1167);
      END_STATE();
    case 197:
      if (lookahead == 'c') ADVANCE(727);
      END_STATE();
    case 198:
      if (lookahead == 'c') ADVANCE(858);
      if (lookahead == 'd') ADVANCE(384);
      if (lookahead == 'e') ADVANCE(726);
      if (lookahead == 'o') ADVANCE(462);
      if (lookahead == 's') ADVANCE(630);
      END_STATE();
    case 199:
      if (lookahead == 'c') ADVANCE(386);
      if (lookahead == 'e') ADVANCE(546);
      if (lookahead == 's') ADVANCE(385);
      END_STATE();
    case 200:
      if (lookahead == 'c') ADVANCE(70);
      END_STATE();
    case 201:
      if (lookahead == 'c') ADVANCE(867);
      if (lookahead == 'l') ADVANCE(278);
      if (lookahead == 'm') ADVANCE(450);
      if (lookahead == 's') ADVANCE(752);
      END_STATE();
    case 202:
      if (lookahead == 'c') ADVANCE(815);
      if (lookahead == 'e') ADVANCE(532);
      if (lookahead == 's') ADVANCE(815);
      END_STATE();
    case 203:
      if (lookahead == 'c') ADVANCE(1146);
      END_STATE();
    case 204:
      if (lookahead == 'c') ADVANCE(1132);
      END_STATE();
    case 205:
      if (lookahead == 'c') ADVANCE(834);
      END_STATE();
    case 206:
      if (lookahead == 'c') ADVANCE(195);
      END_STATE();
    case 207:
      if (lookahead == 'c') ADVANCE(195);
      if (lookahead == 'd') ADVANCE(239);
      END_STATE();
    case 208:
      if (lookahead == 'c') ADVANCE(726);
      END_STATE();
    case 209:
      if (lookahead == 'c') ADVANCE(454);
      END_STATE();
    case 210:
      if (lookahead == 'c') ADVANCE(455);
      END_STATE();
    case 211:
      if (lookahead == 'c') ADVANCE(418);
      END_STATE();
    case 212:
      if (lookahead == 'c') ADVANCE(570);
      if (lookahead == 'd') ADVANCE(30);
      if (lookahead == 'n') ADVANCE(611);
      END_STATE();
    case 213:
      if (lookahead == 'c') ADVANCE(570);
      if (lookahead == 'n') ADVANCE(611);
      END_STATE();
    case 214:
      if (lookahead == 'c') ADVANCE(456);
      END_STATE();
    case 215:
      if (lookahead == 'c') ADVANCE(531);
      END_STATE();
    case 216:
      if (lookahead == 'c') ADVANCE(531);
      if (lookahead == 'm') ADVANCE(693);
      END_STATE();
    case 217:
      if (lookahead == 'c') ADVANCE(413);
      END_STATE();
    case 218:
      if (lookahead == 'c') ADVANCE(487);
      END_STATE();
    case 219:
      if (lookahead == 'c') ADVANCE(604);
      if (lookahead == 's') ADVANCE(626);
      END_STATE();
    case 220:
      if (lookahead == 'c') ADVANCE(108);
      if (lookahead == 'h') ADVANCE(785);
      if (lookahead == 'q') ADVANCE(652);
      if (lookahead == 't') ADVANCE(507);
      if (lookahead == 'u') ADVANCE(170);
      END_STATE();
    case 221:
      if (lookahead == 'c') ADVANCE(326);
      END_STATE();
    case 222:
      if (lookahead == 'c') ADVANCE(131);
      if (lookahead == 'e') ADVANCE(548);
      if (lookahead == 'r') ADVANCE(358);
      END_STATE();
    case 223:
      if (lookahead == 'c') ADVANCE(553);
      END_STATE();
    case 224:
      if (lookahead == 'c') ADVANCE(330);
      END_STATE();
    case 225:
      if (lookahead == 'c') ADVANCE(683);
      if (lookahead == 'd') ADVANCE(226);
      if (lookahead == 's') ADVANCE(460);
      if (lookahead == 'x') ADVANCE(677);
      END_STATE();
    case 226:
      if (lookahead == 'c') ADVANCE(691);
      if (lookahead == 'd') ADVANCE(81);
      END_STATE();
    case 227:
      if (lookahead == 'c') ADVANCE(763);
      END_STATE();
    case 228:
      if (lookahead == 'c') ADVANCE(747);
      END_STATE();
    case 229:
      if (lookahead == 'c') ADVANCE(739);
      END_STATE();
    case 230:
      if (lookahead == 'c') ADVANCE(701);
      END_STATE();
    case 231:
      if (lookahead == 'c') ADVANCE(584);
      END_STATE();
    case 232:
      if (lookahead == 'c') ADVANCE(159);
      END_STATE();
    case 233:
      if (lookahead == 'c') ADVANCE(479);
      if (lookahead == 'i') ADVANCE(530);
      if (lookahead == 'o') ADVANCE(591);
      if (lookahead == 's') ADVANCE(125);
      END_STATE();
    case 234:
      if (lookahead == 'c') ADVANCE(698);
      END_STATE();
    case 235:
      if (lookahead == 'c') ADVANCE(698);
      if (lookahead == 'i') ADVANCE(726);
      END_STATE();
    case 236:
      if (lookahead == 'c') ADVANCE(156);
      END_STATE();
    case 237:
      if (lookahead == 'c') ADVANCE(160);
      END_STATE();
    case 238:
      if (lookahead == 'd') ADVANCE(1122);
      END_STATE();
    case 239:
      if (lookahead == 'd') ADVANCE(1071);
      END_STATE();
    case 240:
      if (lookahead == 'd') ADVANCE(1071);
      if (lookahead == 'q') ADVANCE(855);
      END_STATE();
    case 241:
      if (lookahead == 'd') ADVANCE(1136);
      END_STATE();
    case 242:
      if (lookahead == 'd') ADVANCE(1169);
      if (lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      END_STATE();
    case 243:
      if (lookahead == 'd') ADVANCE(1169);
      if (lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'v') ADVANCE(865);
      END_STATE();
    case 244:
      if (lookahead == 'd') ADVANCE(1190);
      END_STATE();
    case 245:
      if (lookahead == 'd') ADVANCE(592);
      END_STATE();
    case 246:
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'p') ADVANCE(378);
      if (lookahead == 'q') ADVANCE(592);
      END_STATE();
    case 247:
      if (lookahead == 'd') ADVANCE(592);
      if (lookahead == 'q') ADVANCE(592);
      END_STATE();
    case 248:
      if (lookahead == 'd') ADVANCE(269);
      END_STATE();
    case 249:
      if (lookahead == 'd') ADVANCE(201);
      END_STATE();
    case 250:
      if (lookahead == 'd') ADVANCE(593);
      END_STATE();
    case 251:
      if (lookahead == 'd') ADVANCE(815);
      if (lookahead == 'w') ADVANCE(167);
      END_STATE();
    case 252:
      if (lookahead == 'd') ADVANCE(869);
      END_STATE();
    case 253:
      if (lookahead == 'd') ADVANCE(872);
      END_STATE();
    case 254:
      if (lookahead == 'd') ADVANCE(875);
      END_STATE();
    case 255:
      if (lookahead == 'd') ADVANCE(523);
      END_STATE();
    case 256:
      if (lookahead == 'd') ADVANCE(595);
      END_STATE();
    case 257:
      if (lookahead == 'd') ADVANCE(839);
      if (lookahead == 'q') ADVANCE(862);
      if (lookahead == 'w') ADVANCE(167);
      END_STATE();
    case 258:
      if (lookahead == 'd') ADVANCE(839);
      if (lookahead == 'q') ADVANCE(862);
      if (lookahead == 'w') ADVANCE(167);
      if (lookahead == 'x') ADVANCE(180);
      END_STATE();
    case 259:
      if (lookahead == 'd') ADVANCE(851);
      END_STATE();
    case 260:
      if (lookahead == 'd') ADVANCE(791);
      END_STATE();
    case 261:
      if (lookahead == 'd') ADVANCE(798);
      END_STATE();
    case 262:
      if (lookahead == 'd') ADVANCE(844);
      END_STATE();
    case 263:
      if (lookahead == 'd') ADVANCE(844);
      if (lookahead == 'q') ADVANCE(844);
      END_STATE();
    case 264:
      if (lookahead == 'd') ADVANCE(501);
      END_STATE();
    case 265:
      if (lookahead == 'd') ADVANCE(179);
      END_STATE();
    case 266:
      if (lookahead == 'd') ADVANCE(852);
      END_STATE();
    case 267:
      if (lookahead == 'd') ADVANCE(28);
      END_STATE();
    case 268:
      if (lookahead == 'd') ADVANCE(1146);
      END_STATE();
    case 269:
      if (lookahead == 'd') ADVANCE(628);
      if (lookahead == 'm') ADVANCE(829);
      END_STATE();
    case 270:
      if (lookahead == 'd') ADVANCE(628);
      if (lookahead == 'p') ADVANCE(846);
      END_STATE();
    case 271:
      if (lookahead == 'd') ADVANCE(628);
      if (lookahead == 'q') ADVANCE(1071);
      END_STATE();
    case 272:
      if (lookahead == 'd') ADVANCE(22);
      END_STATE();
    case 273:
      if (lookahead == 'd') ADVANCE(240);
      if (lookahead == 's') ADVANCE(274);
      if (lookahead == 'w') ADVANCE(850);
      END_STATE();
    case 274:
      if (lookahead == 'd') ADVANCE(240);
      if (lookahead == 'w') ADVANCE(850);
      END_STATE();
    case 275:
      if (lookahead == 'd') ADVANCE(1139);
      END_STATE();
    case 276:
      if (lookahead == 'd') ADVANCE(1186);
      END_STATE();
    case 277:
      if (lookahead == 'd') ADVANCE(430);
      if (lookahead == 'm') ADVANCE(778);
      if (lookahead == 'n') ADVANCE(1105);
      END_STATE();
    case 278:
      if (lookahead == 'd') ADVANCE(817);
      END_STATE();
    case 279:
      if (lookahead == 'd') ADVANCE(627);
      if (lookahead == 'p') ADVANCE(284);
      if (lookahead == 's') ADVANCE(299);
      if (lookahead == 't') ADVANCE(600);
      END_STATE();
    case 280:
      if (lookahead == 'd') ADVANCE(627);
      if (lookahead == 'p') ADVANCE(302);
      if (lookahead == 'q') ADVANCE(627);
      if (lookahead == 's') ADVANCE(308);
      if (lookahead == 't') ADVANCE(619);
      if (lookahead == 'u') ADVANCE(281);
      END_STATE();
    case 281:
      if (lookahead == 'd') ADVANCE(627);
      if (lookahead == 'q') ADVANCE(627);
      if (lookahead == 's') ADVANCE(445);
      END_STATE();
    case 282:
      if (lookahead == 'd') ADVANCE(190);
      if (lookahead == 't') ADVANCE(344);
      END_STATE();
    case 283:
      if (lookahead == 'd') ADVANCE(21);
      END_STATE();
    case 284:
      if (lookahead == 'd') ADVANCE(37);
      if (lookahead == 'i') ADVANCE(31);
      if (lookahead == 's') ADVANCE(46);
      END_STATE();
    case 285:
      if (lookahead == 'd') ADVANCE(594);
      END_STATE();
    case 286:
      if (lookahead == 'd') ADVANCE(622);
      END_STATE();
    case 287:
      if (lookahead == 'd') ADVANCE(622);
      if (lookahead == 'h') ADVANCE(640);
      if (lookahead == 'l') ADVANCE(850);
      if (lookahead == 'u') ADVANCE(286);
      END_STATE();
    case 288:
      if (lookahead == 'd') ADVANCE(622);
      if (lookahead == 'h') ADVANCE(659);
      if (lookahead == 'l') ADVANCE(865);
      if (lookahead == 't') ADVANCE(441);
      if (lookahead == 'u') ADVANCE(286);
      END_STATE();
    case 289:
      if (lookahead == 'd') ADVANCE(622);
      if (lookahead == 'p') ADVANCE(857);
      END_STATE();
    case 290:
      if (lookahead == 'd') ADVANCE(622);
      if (lookahead == 'p') ADVANCE(843);
      END_STATE();
    case 291:
      if (lookahead == 'd') ADVANCE(622);
      if (lookahead == 'p') ADVANCE(842);
      if (lookahead == 'q') ADVANCE(622);
      if (lookahead == 'u') ADVANCE(294);
      END_STATE();
    case 292:
      if (lookahead == 'd') ADVANCE(622);
      if (lookahead == 'p') ADVANCE(664);
      if (lookahead == 'q') ADVANCE(622);
      if (lookahead == 'u') ADVANCE(294);
      END_STATE();
    case 293:
      if (lookahead == 'd') ADVANCE(622);
      if (lookahead == 'p') ADVANCE(424);
      END_STATE();
    case 294:
      if (lookahead == 'd') ADVANCE(622);
      if (lookahead == 'q') ADVANCE(622);
      END_STATE();
    case 295:
      if (lookahead == 'd') ADVANCE(622);
      if (lookahead == 'q') ADVANCE(622);
      if (lookahead == 'u') ADVANCE(294);
      END_STATE();
    case 296:
      if (lookahead == 'd') ADVANCE(676);
      if (lookahead == 'o') ADVANCE(603);
      END_STATE();
    case 297:
      if (lookahead == 'd') ADVANCE(623);
      if (lookahead == 'p') ADVANCE(846);
      END_STATE();
    case 298:
      if (lookahead == 'd') ADVANCE(623);
      if (lookahead == 'i' ||
          lookahead == 'q') ADVANCE(1071);
      if (lookahead == 'p') ADVANCE(846);
      if (lookahead == 's') ADVANCE(846);
      END_STATE();
    case 299:
      if (lookahead == 'd') ADVANCE(66);
      if (lookahead == 'i') ADVANCE(64);
      if (lookahead == 's') ADVANCE(67);
      END_STATE();
    case 300:
      if (lookahead == 'd') ADVANCE(51);
      if (lookahead == 's') ADVANCE(51);
      END_STATE();
    case 301:
      if (lookahead == 'd') ADVANCE(239);
      END_STATE();
    case 302:
      if (lookahead == 'd') ADVANCE(42);
      if (lookahead == 'h') ADVANCE(63);
      if (lookahead == 's') ADVANCE(47);
      END_STATE();
    case 303:
      if (lookahead == 'd') ADVANCE(795);
      END_STATE();
    case 304:
      if (lookahead == 'd') ADVANCE(245);
      END_STATE();
    case 305:
      if (lookahead == 'd') ADVANCE(777);
      END_STATE();
    case 306:
      if (lookahead == 'd') ADVANCE(171);
      END_STATE();
    case 307:
      if (lookahead == 'd') ADVANCE(252);
      if (lookahead == 'n') ADVANCE(253);
      END_STATE();
    case 308:
      if (lookahead == 'd') ADVANCE(50);
      if (lookahead == 'i') ADVANCE(64);
      if (lookahead == 's') ADVANCE(57);
      END_STATE();
    case 309:
      if (lookahead == 'd') ADVANCE(434);
      END_STATE();
    case 310:
      if (lookahead == 'd') ADVANCE(43);
      if (lookahead == 's') ADVANCE(43);
      END_STATE();
    case 311:
      if (lookahead == 'd') ADVANCE(285);
      if (lookahead == 'e') ADVANCE(669);
      if (lookahead == 'l') ADVANCE(447);
      if (lookahead == 'n') ADVANCE(255);
      END_STATE();
    case 312:
      if (lookahead == 'd') ADVANCE(58);
      if (lookahead == 's') ADVANCE(58);
      END_STATE();
    case 313:
      if (lookahead == 'd') ADVANCE(232);
      END_STATE();
    case 314:
      if (lookahead == 'd') ADVANCE(259);
      END_STATE();
    case 315:
      if (lookahead == 'd') ADVANCE(260);
      if (lookahead == 'x') ADVANCE(679);
      END_STATE();
    case 316:
      if (lookahead == 'd') ADVANCE(690);
      END_STATE();
    case 317:
      if (lookahead == 'd') ADVANCE(272);
      END_STATE();
    case 318:
      if (lookahead == 'd') ADVANCE(265);
      END_STATE();
    case 319:
      if (lookahead == 'd') ADVANCE(283);
      END_STATE();
    case 320:
      if (lookahead == 'd') ADVANCE(668);
      END_STATE();
    case 321:
      if (lookahead == 'd') ADVANCE(267);
      END_STATE();
    case 322:
      if (lookahead == 'd') ADVANCE(352);
      if (lookahead == 'e') ADVANCE(545);
      if (lookahead == 'i') ADVANCE(506);
      if (lookahead == 'k') ADVANCE(332);
      END_STATE();
    case 323:
      if (lookahead == 'd') ADVANCE(713);
      END_STATE();
    case 324:
      if (lookahead == 'd') ADVANCE(68);
      if (lookahead == 's') ADVANCE(68);
      END_STATE();
    case 325:
      if (lookahead == 'd') ADVANCE(237);
      END_STATE();
    case 326:
      if (lookahead == 'e') ADVANCE(1071);
      END_STATE();
    case 327:
      if (lookahead == 'e') ADVANCE(197);
      END_STATE();
    case 328:
      if (lookahead == 'e') ADVANCE(1010);
      if (lookahead == 'l') ADVANCE(199);
      if (lookahead == 'n') ADVANCE(249);
      if (lookahead == 's') ADVANCE(854);
      if (lookahead == 't') ADVANCE(1193);
      if (lookahead == 'z') ADVANCE(416);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(996);
      END_STATE();
    case 329:
      if (lookahead == 'e') ADVANCE(393);
      if (lookahead == 'o') ADVANCE(859);
      END_STATE();
    case 330:
      if (lookahead == 'e') ADVANCE(593);
      END_STATE();
    case 331:
      if (lookahead == 'e') ADVANCE(656);
      END_STATE();
    case 332:
      if (lookahead == 'e') ADVANCE(832);
      END_STATE();
    case 333:
      if (lookahead == 'e') ADVANCE(625);
      if (lookahead == 'g') ADVANCE(733);
      if (lookahead == 'i') ADVANCE(723);
      END_STATE();
    case 334:
      if (lookahead == 'e') ADVANCE(694);
      END_STATE();
    case 335:
      if (lookahead == 'e') ADVANCE(591);
      END_STATE();
    case 336:
      if (lookahead == 'e') ADVANCE(1092);
      END_STATE();
    case 337:
      if (lookahead == 'e') ADVANCE(1091);
      END_STATE();
    case 338:
      if (lookahead == 'e') ADVANCE(5);
      END_STATE();
    case 339:
      if (lookahead == 'e') ADVANCE(817);
      END_STATE();
    case 340:
      if (lookahead == 'e') ADVANCE(391);
      END_STATE();
    case 341:
      if (lookahead == 'e') ADVANCE(622);
      if (lookahead == 'g') ADVANCE(853);
      END_STATE();
    case 342:
      if (lookahead == 'e') ADVANCE(541);
      END_STATE();
    case 343:
      if (lookahead == 'e') ADVANCE(239);
      END_STATE();
    case 344:
      if (lookahead == 'e') ADVANCE(632);
      END_STATE();
    case 345:
      if (lookahead == 'e') ADVANCE(827);
      if (lookahead == 'm') ADVANCE(139);
      END_STATE();
    case 346:
      if (lookahead == 'e') ADVANCE(651);
      END_STATE();
    case 347:
      if (lookahead == 'e') ADVANCE(372);
      END_STATE();
    case 348:
      if (lookahead == 'e') ADVANCE(645);
      END_STATE();
    case 349:
      if (lookahead == 'e') ADVANCE(493);
      END_STATE();
    case 350:
      if (lookahead == 'e') ADVANCE(326);
      END_STATE();
    case 351:
      if (lookahead == 'e') ADVANCE(343);
      END_STATE();
    case 352:
      if (lookahead == 'e') ADVANCE(204);
      END_STATE();
    case 353:
      if (lookahead == 'e') ADVANCE(762);
      END_STATE();
    case 354:
      if (lookahead == 'e') ADVANCE(641);
      END_STATE();
    case 355:
      if (lookahead == 'e') ADVANCE(646);
      END_STATE();
    case 356:
      if (lookahead == 'e') ADVANCE(562);
      END_STATE();
    case 357:
      if (lookahead == 'e') ADVANCE(767);
      END_STATE();
    case 358:
      if (lookahead == 'e') ADVANCE(750);
      END_STATE();
    case 359:
      if (lookahead == 'e') ADVANCE(648);
      END_STATE();
    case 360:
      if (lookahead == 'e') ADVANCE(831);
      END_STATE();
    case 361:
      if (lookahead == 'e') ADVANCE(716);
      END_STATE();
    case 362:
      if (lookahead == 'e') ADVANCE(705);
      END_STATE();
    case 363:
      if (lookahead == 'e') ADVANCE(549);
      END_STATE();
    case 364:
      if (lookahead == 'e') ADVANCE(717);
      END_STATE();
    case 365:
      if (lookahead == 'e') ADVANCE(714);
      END_STATE();
    case 366:
      if (lookahead == 'e') ADVANCE(550);
      END_STATE();
    case 367:
      if (lookahead == 'e') ADVANCE(661);
      END_STATE();
    case 368:
      if (lookahead == 'e') ADVANCE(552);
      END_STATE();
    case 369:
      if (lookahead == 'f') ADVANCE(1071);
      END_STATE();
    case 370:
      if (lookahead == 'f') ADVANCE(2);
      END_STATE();
    case 371:
      if (lookahead == 'f') ADVANCE(592);
      END_STATE();
    case 372:
      if (lookahead == 'f') ADVANCE(593);
      END_STATE();
    case 373:
      if (lookahead == 'f') ADVANCE(850);
      END_STATE();
    case 374:
      if (lookahead == 'f') ADVANCE(864);
      END_STATE();
    case 375:
      if (lookahead == 'f') ADVANCE(381);
      END_STATE();
    case 376:
      if (lookahead == 'f') ADVANCE(838);
      END_STATE();
    case 377:
      if (lookahead == 'f') ADVANCE(26);
      if (lookahead == 'i') ADVANCE(26);
      if (lookahead == 'p') ADVANCE(664);
      END_STATE();
    case 378:
      if (lookahead == 'f') ADVANCE(14);
      END_STATE();
    case 379:
      if (lookahead == 'f') ADVANCE(425);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(379);
      END_STATE();
    case 380:
      if (lookahead == 'f') ADVANCE(25);
      if (lookahead == 'i') ADVANCE(25);
      END_STATE();
    case 381:
      if (lookahead == 'f') ADVANCE(75);
      if (lookahead == 'i') ADVANCE(75);
      if (lookahead == 'p') ADVANCE(846);
      END_STATE();
    case 382:
      if (lookahead == 'f') ADVANCE(566);
      END_STATE();
    case 383:
      if (lookahead == 'f') ADVANCE(707);
      if (lookahead == 'g') ADVANCE(707);
      END_STATE();
    case 384:
      if (lookahead == 'f') ADVANCE(707);
      if (lookahead == 'g') ADVANCE(707);
      if (lookahead == 'r') ADVANCE(153);
      if (lookahead == 's') ADVANCE(351);
      if (lookahead == 't') ADVANCE(709);
      END_STATE();
    case 385:
      if (lookahead == 'f') ADVANCE(436);
      if (lookahead == 'i') ADVANCE(1102);
      if (lookahead == 'm') ADVANCE(693);
      if (lookahead == 'r') ADVANCE(1071);
      END_STATE();
    case 386:
      if (lookahead == 'f') ADVANCE(436);
      if (lookahead == 'i') ADVANCE(1102);
      if (lookahead == 'm') ADVANCE(693);
      if (lookahead == 's') ADVANCE(1071);
      END_STATE();
    case 387:
      if (lookahead == 'f') ADVANCE(483);
      END_STATE();
    case 388:
      if (lookahead == 'f') ADVANCE(569);
      END_STATE();
    case 389:
      if (lookahead == 'f') ADVANCE(745);
      END_STATE();
    case 390:
      if (lookahead == 'f') ADVANCE(760);
      END_STATE();
    case 391:
      if (lookahead == 'f') ADVANCE(357);
      END_STATE();
    case 392:
      if (lookahead == 'f') ADVANCE(27);
      if (lookahead == 'i') ADVANCE(27);
      if (lookahead == 's') ADVANCE(846);
      END_STATE();
    case 393:
      if (lookahead == 'g') ADVANCE(1071);
      END_STATE();
    case 394:
      if (lookahead == 'g') ADVANCE(840);
      END_STATE();
    case 395:
      if (lookahead == 'g') ADVANCE(839);
      END_STATE();
    case 396:
      if (lookahead == 'g') ADVANCE(844);
      END_STATE();
    case 397:
      if (lookahead == 'g') ADVANCE(860);
      END_STATE();
    case 398:
      if (lookahead == 'g') ADVANCE(1075);
      END_STATE();
    case 399:
      if (lookahead == 'g') ADVANCE(664);
      END_STATE();
    case 400:
      if (lookahead == 'g') ADVANCE(525);
      END_STATE();
    case 401:
      if (lookahead == 'g') ADVANCE(537);
      END_STATE();
    case 402:
      if (lookahead == 'g') ADVANCE(526);
      END_STATE();
    case 403:
      if (lookahead == 'g') ADVANCE(330);
      END_STATE();
    case 404:
      if (lookahead == 'g') ADVANCE(356);
      END_STATE();
    case 405:
      if (lookahead == 'h') ADVANCE(1071);
      END_STATE();
    case 406:
      if (lookahead == 'h') ADVANCE(1099);
      END_STATE();
    case 407:
      if (lookahead == 'h') ADVANCE(1059);
      if (lookahead == 'x') ADVANCE(884);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(408);
      END_STATE();
    case 408:
      if (lookahead == 'h') ADVANCE(1058);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(408);
      END_STATE();
    case 409:
      if (lookahead == 'h') ADVANCE(592);
      if (lookahead == 'l') ADVANCE(592);
      END_STATE();
    case 410:
      if (lookahead == 'h') ADVANCE(393);
      END_STATE();
    case 411:
      if (lookahead == 'h') ADVANCE(173);
      if (lookahead == 'l') ADVANCE(173);
      END_STATE();
    case 412:
      if (lookahead == 'h') ADVANCE(1144);
      END_STATE();
    case 413:
      if (lookahead == 'h') ADVANCE(1142);
      END_STATE();
    case 414:
      if (lookahead == 'h') ADVANCE(369);
      END_STATE();
    case 415:
      if (lookahead == 'h') ADVANCE(369);
      if (lookahead == 'l') ADVANCE(1071);
      if (lookahead == 'r') ADVANCE(1184);
      END_STATE();
    case 416:
      if (lookahead == 'h') ADVANCE(424);
      END_STATE();
    case 417:
      if (lookahead == 'h') ADVANCE(432);
      END_STATE();
    case 418:
      if (lookahead == 'h') ADVANCE(398);
      END_STATE();
    case 419:
      if (lookahead == 'h') ADVANCE(779);
      if (lookahead == 'l') ADVANCE(779);
      END_STATE();
    case 420:
      if (lookahead == 'h') ADVANCE(607);
      if (lookahead == 'p') ADVANCE(846);
      END_STATE();
    case 421:
      if (lookahead == 'h') ADVANCE(446);
      END_STATE();
    case 422:
      if (lookahead == 'h') ADVANCE(354);
      END_STATE();
    case 423:
      if (lookahead == 'h') ADVANCE(355);
      END_STATE();
    case 424:
      if (lookahead == 'i') ADVANCE(1071);
      END_STATE();
    case 425:
      if (lookahead == 'i') ADVANCE(471);
      END_STATE();
    case 426:
      if (lookahead == 'i') ADVANCE(850);
      END_STATE();
    case 427:
      if (lookahead == 'i') ADVANCE(565);
      END_STATE();
    case 428:
      if (lookahead == 'i') ADVANCE(694);
      END_STATE();
    case 429:
      if (lookahead == 'i') ADVANCE(726);
      END_STATE();
    case 430:
      if (lookahead == 'i') ADVANCE(796);
      END_STATE();
    case 431:
      if (lookahead == 'i') ADVANCE(828);
      if (lookahead == 'm') ADVANCE(154);
      if (lookahead == 'n') ADVANCE(521);
      if (lookahead == 'p') ADVANCE(218);
      if (lookahead == 'r') ADVANCE(205);
      END_STATE();
    case 432:
      if (lookahead == 'i') ADVANCE(389);
      END_STATE();
    case 433:
      if (lookahead == 'i') ADVANCE(239);
      END_STATE();
    case 434:
      if (lookahead == 'i') ADVANCE(531);
      END_STATE();
    case 435:
      if (lookahead == 'i') ADVANCE(808);
      END_STATE();
    case 436:
      if (lookahead == 'i') ADVANCE(473);
      END_STATE();
    case 437:
      if (lookahead == 'i') ADVANCE(670);
      END_STATE();
    case 438:
      if (lookahead == 'i') ADVANCE(670);
      if (lookahead == 'p') ADVANCE(658);
      END_STATE();
    case 439:
      if (lookahead == 'i') ADVANCE(513);
      END_STATE();
    case 440:
      if (lookahead == 'i') ADVANCE(750);
      END_STATE();
    case 441:
      if (lookahead == 'i') ADVANCE(722);
      END_STATE();
    case 442:
      if (lookahead == 'i') ADVANCE(732);
      if (lookahead == 'r') ADVANCE(743);
      END_STATE();
    case 443:
      if (lookahead == 'i') ADVANCE(543);
      END_STATE();
    case 444:
      if (lookahead == 'i') ADVANCE(401);
      END_STATE();
    case 445:
      if (lookahead == 'i') ADVANCE(64);
      END_STATE();
    case 446:
      if (lookahead == 'i') ADVANCE(390);
      END_STATE();
    case 447:
      if (lookahead == 'i') ADVANCE(402);
      END_STATE();
    case 448:
      if (lookahead == 'i') ADVANCE(229);
      END_STATE();
    case 449:
      if (lookahead == 'k') ADVANCE(1071);
      END_STATE();
    case 450:
      if (lookahead == 'k') ADVANCE(1071);
      if (lookahead == 'o') ADVANCE(796);
      END_STATE();
    case 451:
      if (lookahead == 'k') ADVANCE(592);
      END_STATE();
    case 452:
      if (lookahead == 'k') ADVANCE(167);
      END_STATE();
    case 453:
      if (lookahead == 'k') ADVANCE(710);
      END_STATE();
    case 454:
      if (lookahead == 'k') ADVANCE(409);
      END_STATE();
    case 455:
      if (lookahead == 'k') ADVANCE(174);
      END_STATE();
    case 456:
      if (lookahead == 'k') ADVANCE(411);
      END_STATE();
    case 457:
      if (lookahead == 'k') ADVANCE(195);
      END_STATE();
    case 458:
      if (lookahead == 'k') ADVANCE(518);
      END_STATE();
    case 459:
      if (lookahead == 'k') ADVANCE(519);
      END_STATE();
    case 460:
      if (lookahead == 'k') ADVANCE(520);
      END_STATE();
    case 461:
      if (lookahead == 'l') ADVANCE(1071);
      END_STATE();
    case 462:
      if (lookahead == 'l') ADVANCE(1071);
      if (lookahead == 'r') ADVANCE(1184);
      if (lookahead == 'u') ADVANCE(547);
      END_STATE();
    case 463:
      if (lookahead == 'l') ADVANCE(593);
      END_STATE();
    case 464:
      if (lookahead == 'l') ADVANCE(869);
      if (lookahead == 'r') ADVANCE(869);
      END_STATE();
    case 465:
      if (lookahead == 'l') ADVANCE(287);
      END_STATE();
    case 466:
      if (lookahead == 'l') ADVANCE(242);
      END_STATE();
    case 467:
      if (lookahead == 'l') ADVANCE(288);
      END_STATE();
    case 468:
      if (lookahead == 'l') ADVANCE(845);
      if (lookahead == 'r') ADVANCE(845);
      if (lookahead == 't') ADVANCE(869);
      END_STATE();
    case 469:
      if (lookahead == 'l') ADVANCE(243);
      END_STATE();
    case 470:
      if (lookahead == 'l') ADVANCE(1146);
      END_STATE();
    case 471:
      if (lookahead == 'l') ADVANCE(338);
      END_STATE();
    case 472:
      if (lookahead == 'l') ADVANCE(59);
      END_STATE();
    case 473:
      if (lookahead == 'l') ADVANCE(461);
      END_STATE();
    case 474:
      if (lookahead == 'l') ADVANCE(1165);
      END_STATE();
    case 475:
      if (lookahead == 'l') ADVANCE(517);
      if (lookahead == 'm') ADVANCE(573);
      if (lookahead == 'o') ADVANCE(499);
      END_STATE();
    case 476:
      if (lookahead == 'l') ADVANCE(517);
      if (lookahead == 'm') ADVANCE(597);
      if (lookahead == 'o') ADVANCE(516);
      END_STATE();
    case 477:
      if (lookahead == 'l') ADVANCE(792);
      END_STATE();
    case 478:
      if (lookahead == 'l') ADVANCE(629);
      END_STATE();
    case 479:
      if (lookahead == 'l') ADVANCE(339);
      END_STATE();
    case 480:
      if (lookahead == 'l') ADVANCE(607);
      if (lookahead == 'p') ADVANCE(846);
      END_STATE();
    case 481:
      if (lookahead == 'l') ADVANCE(326);
      END_STATE();
    case 482:
      if (lookahead == 'l') ADVANCE(578);
      END_STATE();
    case 483:
      if (lookahead == 'l') ADVANCE(448);
      END_STATE();
    case 484:
      if (lookahead == 'l') ADVANCE(330);
      END_STATE();
    case 485:
      if (lookahead == 'l') ADVANCE(347);
      if (lookahead == 't') ADVANCE(770);
      END_STATE();
    case 486:
      if (lookahead == 'l') ADVANCE(363);
      END_STATE();
    case 487:
      if (lookahead == 'l') ADVANCE(140);
      END_STATE();
    case 488:
      if (lookahead == 'l') ADVANCE(366);
      if (lookahead == 'r') ADVANCE(589);
      END_STATE();
    case 489:
      if (lookahead == 'l') ADVANCE(368);
      if (lookahead == 'r') ADVANCE(590);
      END_STATE();
    case 490:
      if (lookahead == 'm') ADVANCE(1071);
      END_STATE();
    case 491:
      if (lookahead == 'm') ADVANCE(1126);
      END_STATE();
    case 492:
      if (lookahead == 'm') ADVANCE(1126);
      if (lookahead == 's') ADVANCE(1071);
      END_STATE();
    case 493:
      if (lookahead == 'm') ADVANCE(1072);
      END_STATE();
    case 494:
      if (lookahead == 'm') ADVANCE(111);
      END_STATE();
    case 495:
      if (lookahead == 'm') ADVANCE(593);
      END_STATE();
    case 496:
      if (lookahead == 'm') ADVANCE(15);
      END_STATE();
    case 497:
      if (lookahead == 'm') ADVANCE(869);
      END_STATE();
    case 498:
      if (lookahead == 'm') ADVANCE(438);
      END_STATE();
    case 499:
      if (lookahead == 'm') ADVANCE(874);
      if (lookahead == 'n') ADVANCE(387);
      END_STATE();
    case 500:
      if (lookahead == 'm') ADVANCE(39);
      END_STATE();
    case 501:
      if (lookahead == 'm') ADVANCE(873);
      if (lookahead == 'p') ADVANCE(846);
      if (lookahead == 'v') ADVANCE(592);
      END_STATE();
    case 502:
      if (lookahead == 'm') ADVANCE(1146);
      END_STATE();
    case 503:
      if (lookahead == 'm') ADVANCE(505);
      if (lookahead == 'n') ADVANCE(282);
      if (lookahead == 'x') ADVANCE(756);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(996);
      END_STATE();
    case 504:
      if (lookahead == 'm') ADVANCE(429);
      END_STATE();
    case 505:
      if (lookahead == 'm') ADVANCE(664);
      END_STATE();
    case 506:
      if (lookahead == 'm') ADVANCE(195);
      END_STATE();
    case 507:
      if (lookahead == 'm') ADVANCE(829);
      END_STATE();
    case 508:
      if (lookahead == 'm') ADVANCE(437);
      END_STATE();
    case 509:
      if (lookahead == 'm') ADVANCE(596);
      if (lookahead == 'o') ADVANCE(498);
      if (lookahead == 'v') ADVANCE(734);
      END_STATE();
    case 510:
      if (lookahead == 'm') ADVANCE(601);
      END_STATE();
    case 511:
      if (lookahead == 'm') ADVANCE(692);
      END_STATE();
    case 512:
      if (lookahead == 'm') ADVANCE(703);
      if (lookahead == 's') ADVANCE(825);
      if (lookahead == 'z') ADVANCE(825);
      END_STATE();
    case 513:
      if (lookahead == 'm') ADVANCE(495);
      END_STATE();
    case 514:
      if (lookahead == 'm') ADVANCE(702);
      if (lookahead == 'n') ADVANCE(360);
      if (lookahead == 'r') ADVANCE(551);
      END_STATE();
    case 515:
      if (lookahead == 'm') ADVANCE(702);
      if (lookahead == 'r') ADVANCE(555);
      END_STATE();
    case 516:
      if (lookahead == 'm') ADVANCE(504);
      END_STATE();
    case 517:
      if (lookahead == 'm') ADVANCE(788);
      END_STATE();
    case 518:
      if (lookahead == 'm') ADVANCE(582);
      END_STATE();
    case 519:
      if (lookahead == 'm') ADVANCE(585);
      END_STATE();
    case 520:
      if (lookahead == 'm') ADVANCE(587);
      END_STATE();
    case 521:
      if (lookahead == 'm') ADVANCE(158);
      END_STATE();
    case 522:
      if (lookahead == 'n') ADVANCE(1071);
      END_STATE();
    case 523:
      if (lookahead == 'n') ADVANCE(592);
      if (lookahead == 'p') ADVANCE(846);
      END_STATE();
    case 524:
      if (lookahead == 'n') ADVANCE(593);
      END_STATE();
    case 525:
      if (lookahead == 'n') ADVANCE(862);
      END_STATE();
    case 526:
      if (lookahead == 'n') ADVANCE(844);
      END_STATE();
    case 527:
      if (lookahead == 'n') ADVANCE(3);
      END_STATE();
    case 528:
      if (lookahead == 'n') ADVANCE(679);
      END_STATE();
    case 529:
      if (lookahead == 'n') ADVANCE(677);
      END_STATE();
    case 530:
      if (lookahead == 'n') ADVANCE(429);
      END_STATE();
    case 531:
      if (lookahead == 'n') ADVANCE(726);
      END_STATE();
    case 532:
      if (lookahead == 'n') ADVANCE(796);
      END_STATE();
    case 533:
      if (lookahead == 'n') ADVANCE(403);
      END_STATE();
    case 534:
      if (lookahead == 'n') ADVANCE(1114);
      END_STATE();
    case 535:
      if (lookahead == 'n') ADVANCE(699);
      END_STATE();
    case 536:
      if (lookahead == 'n') ADVANCE(239);
      END_STATE();
    case 537:
      if (lookahead == 'n') ADVANCE(632);
      END_STATE();
    case 538:
      if (lookahead == 'n') ADVANCE(309);
      if (lookahead == 's') ADVANCE(758);
      END_STATE();
    case 539:
      if (lookahead == 'n') ADVANCE(245);
      END_STATE();
    case 540:
      if (lookahead == 'n') ADVANCE(133);
      END_STATE();
    case 541:
      if (lookahead == 'n') ADVANCE(221);
      END_STATE();
    case 542:
      if (lookahead == 'n') ADVANCE(730);
      END_STATE();
    case 543:
      if (lookahead == 'n') ADVANCE(614);
      END_STATE();
    case 544:
      if (lookahead == 'n') ADVANCE(482);
      END_STATE();
    case 545:
      if (lookahead == 'n') ADVANCE(204);
      END_STATE();
    case 546:
      if (lookahead == 'n') ADVANCE(256);
      END_STATE();
    case 547:
      if (lookahead == 'n') ADVANCE(250);
      END_STATE();
    case 548:
      if (lookahead == 'n') ADVANCE(768);
      if (lookahead == 'x') ADVANCE(440);
      END_STATE();
    case 549:
      if (lookahead == 'n') ADVANCE(261);
      END_STATE();
    case 550:
      if (lookahead == 'n') ADVANCE(264);
      END_STATE();
    case 551:
      if (lookahead == 'n') ADVANCE(316);
      END_STATE();
    case 552:
      if (lookahead == 'n') ADVANCE(266);
      END_STATE();
    case 553:
      if (lookahead == 'n') ADVANCE(739);
      END_STATE();
    case 554:
      if (lookahead == 'n') ADVANCE(262);
      END_STATE();
    case 555:
      if (lookahead == 'n') ADVANCE(320);
      END_STATE();
    case 556:
      if (lookahead == 'n') ADVANCE(388);
      END_STATE();
    case 557:
      if (lookahead == 'n') ADVANCE(613);
      END_STATE();
    case 558:
      if (lookahead == 'n') ADVANCE(575);
      if (lookahead == 'o') ADVANCE(638);
      END_STATE();
    case 559:
      if (lookahead == 'n') ADVANCE(711);
      END_STATE();
    case 560:
      if (lookahead == 'n') ADVANCE(615);
      END_STATE();
    case 561:
      if (lookahead == 'n') ADVANCE(615);
      if (lookahead == 's') ADVANCE(406);
      END_STATE();
    case 562:
      if (lookahead == 'n') ADVANCE(155);
      END_STATE();
    case 563:
      if (lookahead == 'o') ADVANCE(1071);
      END_STATE();
    case 564:
      if (lookahead == 'o') ADVANCE(370);
      END_STATE();
    case 565:
      if (lookahead == 'o') ADVANCE(527);
      END_STATE();
    case 566:
      if (lookahead == 'o') ADVANCE(634);
      END_STATE();
    case 567:
      if (lookahead == 'o') ADVANCE(468);
      END_STATE();
    case 568:
      if (lookahead == 'o') ADVANCE(132);
      END_STATE();
    case 569:
      if (lookahead == 'o') ADVANCE(916);
      END_STATE();
    case 570:
      if (lookahead == 'o') ADVANCE(508);
      END_STATE();
    case 571:
      if (lookahead == 'o') ADVANCE(635);
      END_STATE();
    case 572:
      if (lookahead == 'o') ADVANCE(664);
      END_STATE();
    case 573:
      if (lookahead == 'o') ADVANCE(796);
      if (lookahead == 'p') ADVANCE(870);
      END_STATE();
    case 574:
      if (lookahead == 'o') ADVANCE(801);
      END_STATE();
    case 575:
      if (lookahead == 'o') ADVANCE(638);
      END_STATE();
    case 576:
      if (lookahead == 'o') ADVANCE(632);
      END_STATE();
    case 577:
      if (lookahead == 'o') ADVANCE(633);
      END_STATE();
    case 578:
      if (lookahead == 'o') ADVANCE(396);
      END_STATE();
    case 579:
      if (lookahead == 'o') ADVANCE(733);
      END_STATE();
    case 580:
      if (lookahead == 'o') ADVANCE(804);
      END_STATE();
    case 581:
      if (lookahead == 'o') ADVANCE(502);
      END_STATE();
    case 582:
      if (lookahead == 'o') ADVANCE(807);
      END_STATE();
    case 583:
      if (lookahead == 'o') ADVANCE(644);
      END_STATE();
    case 584:
      if (lookahead == 'o') ADVANCE(491);
      END_STATE();
    case 585:
      if (lookahead == 'o') ADVANCE(810);
      END_STATE();
    case 586:
      if (lookahead == 'o') ADVANCE(643);
      END_STATE();
    case 587:
      if (lookahead == 'o') ADVANCE(806);
      END_STATE();
    case 588:
      if (lookahead == 'o') ADVANCE(706);
      END_STATE();
    case 589:
      if (lookahead == 'o') ADVANCE(142);
      END_STATE();
    case 590:
      if (lookahead == 'o') ADVANCE(163);
      END_STATE();
    case 591:
      if (lookahead == 'p') ADVANCE(1071);
      END_STATE();
    case 592:
      if (lookahead == 'p') ADVANCE(846);
      END_STATE();
    case 593:
      if (lookahead == 'p') ADVANCE(846);
      if (lookahead == 's') ADVANCE(846);
      END_STATE();
    case 594:
      if (lookahead == 'p') ADVANCE(846);
      if (lookahead == 's') ADVANCE(848);
      END_STATE();
    case 595:
      if (lookahead == 'p') ADVANCE(846);
      if (lookahead == 'v') ADVANCE(592);
      END_STATE();
    case 596:
      if (lookahead == 'p') ADVANCE(593);
      END_STATE();
    case 597:
      if (lookahead == 'p') ADVANCE(333);
      END_STATE();
    case 598:
      if (lookahead == 'p') ADVANCE(32);
      if (lookahead == 't') ADVANCE(662);
      END_STATE();
    case 599:
      if (lookahead == 'p') ADVANCE(19);
      END_STATE();
    case 600:
      if (lookahead == 'p') ADVANCE(300);
      if (lookahead == 's') ADVANCE(324);
      END_STATE();
    case 601:
      if (lookahead == 'p') ADVANCE(341);
      END_STATE();
    case 602:
      if (lookahead == 'p') ADVANCE(1098);
      if (lookahead == 'r') ADVANCE(1071);
      END_STATE();
    case 603:
      if (lookahead == 'p') ADVANCE(1125);
      END_STATE();
    case 604:
      if (lookahead == 'p') ADVANCE(1129);
      END_STATE();
    case 605:
      if (lookahead == 'p') ADVANCE(704);
      END_STATE();
    case 606:
      if (lookahead == 'p') ADVANCE(399);
      END_STATE();
    case 607:
      if (lookahead == 'p') ADVANCE(664);
      END_STATE();
    case 608:
      if (lookahead == 'p') ADVANCE(664);
      if (lookahead == 'q') ADVANCE(1071);
      END_STATE();
    case 609:
      if (lookahead == 'p') ADVANCE(664);
      if (lookahead == 's') ADVANCE(664);
      END_STATE();
    case 610:
      if (lookahead == 'p') ADVANCE(726);
      END_STATE();
    case 611:
      if (lookahead == 'p') ADVANCE(209);
      END_STATE();
    case 612:
      if (lookahead == 'p') ADVANCE(239);
      END_STATE();
    case 613:
      if (lookahead == 'p') ADVANCE(210);
      END_STATE();
    case 614:
      if (lookahead == 'p') ADVANCE(588);
      END_STATE();
    case 615:
      if (lookahead == 'p') ADVANCE(214);
      END_STATE();
    case 616:
      if (lookahead == 'p') ADVANCE(439);
      END_STATE();
    case 617:
      if (lookahead == 'p') ADVANCE(620);
      END_STATE();
    case 618:
      if (lookahead == 'p') ADVANCE(750);
      END_STATE();
    case 619:
      if (lookahead == 'p') ADVANCE(310);
      if (lookahead == 's') ADVANCE(312);
      END_STATE();
    case 620:
      if (lookahead == 'p') ADVANCE(344);
      END_STATE();
    case 621:
      if (lookahead == 'p') ADVANCE(161);
      if (lookahead == 't') ADVANCE(638);
      END_STATE();
    case 622:
      if (lookahead == 'q') ADVANCE(1071);
      END_STATE();
    case 623:
      if (lookahead == 'q') ADVANCE(1094);
      END_STATE();
    case 624:
      if (lookahead == 'q') ADVANCE(167);
      END_STATE();
    case 625:
      if (lookahead == 'q') ADVANCE(869);
      if (lookahead == 's') ADVANCE(765);
      END_STATE();
    case 626:
      if (lookahead == 'q') ADVANCE(442);
      END_STATE();
    case 627:
      if (lookahead == 'q') ADVANCE(31);
      END_STATE();
    case 628:
      if (lookahead == 'q') ADVANCE(775);
      END_STATE();
    case 629:
      if (lookahead == 'q') ADVANCE(286);
      END_STATE();
    case 630:
      if (lookahead == 'q') ADVANCE(655);
      END_STATE();
    case 631:
      if (lookahead == 'q') ADVANCE(660);
      END_STATE();
    case 632:
      if (lookahead == 'r') ADVANCE(1071);
      END_STATE();
    case 633:
      if (lookahead == 'r') ADVANCE(1189);
      END_STATE();
    case 634:
      if (lookahead == 'r') ADVANCE(494);
      END_STATE();
    case 635:
      if (lookahead == 'r') ADVANCE(592);
      END_STATE();
    case 636:
      if (lookahead == 'r') ADVANCE(876);
      END_STATE();
    case 637:
      if (lookahead == 'r') ADVANCE(144);
      END_STATE();
    case 638:
      if (lookahead == 'r') ADVANCE(869);
      END_STATE();
    case 639:
      if (lookahead == 'r') ADVANCE(71);
      END_STATE();
    case 640:
      if (lookahead == 'r') ADVANCE(675);
      if (lookahead == 'u') ADVANCE(815);
      if (lookahead == 'w') ADVANCE(1071);
      END_STATE();
    case 641:
      if (lookahead == 'r') ADVANCE(246);
      END_STATE();
    case 642:
      if (lookahead == 'r') ADVANCE(856);
      END_STATE();
    case 643:
      if (lookahead == 'r') ADVANCE(1091);
      END_STATE();
    case 644:
      if (lookahead == 'r') ADVANCE(1093);
      END_STATE();
    case 645:
      if (lookahead == 'r') ADVANCE(563);
      END_STATE();
    case 646:
      if (lookahead == 'r') ADVANCE(263);
      END_STATE();
    case 647:
      if (lookahead == 'r') ADVANCE(726);
      END_STATE();
    case 648:
      if (lookahead == 'r') ADVANCE(490);
      END_STATE();
    case 649:
      if (lookahead == 'r') ADVANCE(1163);
      END_STATE();
    case 650:
      if (lookahead == 'r') ADVANCE(1163);
      if (lookahead == 'u') ADVANCE(748);
      END_STATE();
    case 651:
      if (lookahead == 'r') ADVANCE(568);
      END_STATE();
    case 652:
      if (lookahead == 'r') ADVANCE(730);
      END_STATE();
    case 653:
      if (lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 654:
      if (lookahead == 'r') ADVANCE(500);
      if (lookahead == 'x') ADVANCE(621);
      END_STATE();
    case 655:
      if (lookahead == 'r') ADVANCE(746);
      END_STATE();
    case 656:
      if (lookahead == 'r') ADVANCE(544);
      if (lookahead == 's') ADVANCE(751);
      END_STATE();
    case 657:
      if (lookahead == 'r') ADVANCE(738);
      END_STATE();
    case 658:
      if (lookahead == 'r') ADVANCE(361);
      END_STATE();
    case 659:
      if (lookahead == 'r') ADVANCE(674);
      if (lookahead == 'u') ADVANCE(815);
      if (lookahead == 'w') ADVANCE(1071);
      END_STATE();
    case 660:
      if (lookahead == 'r') ADVANCE(736);
      END_STATE();
    case 661:
      if (lookahead == 'r') ADVANCE(747);
      END_STATE();
    case 662:
      if (lookahead == 'r') ADVANCE(151);
      END_STATE();
    case 663:
      if (lookahead == 'r') ADVANCE(364);
      END_STATE();
    case 664:
      if (lookahead == 's') ADVANCE(1071);
      END_STATE();
    case 665:
      if (lookahead == 's') ADVANCE(327);
      END_STATE();
    case 666:
      if (lookahead == 's') ADVANCE(592);
      END_STATE();
    case 667:
      if (lookahead == 's') ADVANCE(167);
      END_STATE();
    case 668:
      if (lookahead == 's') ADVANCE(30);
      END_STATE();
    case 669:
      if (lookahead == 's') ADVANCE(322);
      END_STATE();
    case 670:
      if (lookahead == 's') ADVANCE(846);
      END_STATE();
    case 671:
      if (lookahead == 's') ADVANCE(458);
      if (lookahead == 'x') ADVANCE(593);
      END_STATE();
    case 672:
      if (lookahead == 's') ADVANCE(593);
      END_STATE();
    case 673:
      if (lookahead == 's') ADVANCE(222);
      END_STATE();
    case 674:
      if (lookahead == 's') ADVANCE(815);
      END_STATE();
    case 675:
      if (lookahead == 's') ADVANCE(815);
      if (lookahead == 'w') ADVANCE(1071);
      END_STATE();
    case 676:
      if (lookahead == 's') ADVANCE(869);
      END_STATE();
    case 677:
      if (lookahead == 's') ADVANCE(869);
      if (lookahead == 'u') ADVANCE(869);
      END_STATE();
    case 678:
      if (lookahead == 's') ADVANCE(862);
      END_STATE();
    case 679:
      if (lookahead == 's') ADVANCE(862);
      if (lookahead == 'u') ADVANCE(862);
      END_STATE();
    case 680:
      if (lookahead == 's') ADVANCE(839);
      END_STATE();
    case 681:
      if (lookahead == 's') ADVANCE(251);
      END_STATE();
    case 682:
      if (lookahead == 's') ADVANCE(844);
      END_STATE();
    case 683:
      if (lookahead == 's') ADVANCE(273);
      END_STATE();
    case 684:
      if (lookahead == 's') ADVANCE(857);
      END_STATE();
    case 685:
      if (lookahead == 's') ADVANCE(857);
      if (lookahead == 'u') ADVANCE(695);
      END_STATE();
    case 686:
      if (lookahead == 's') ADVANCE(843);
      END_STATE();
    case 687:
      if (lookahead == 's') ADVANCE(843);
      if (lookahead == 'u') ADVANCE(695);
      END_STATE();
    case 688:
      if (lookahead == 's') ADVANCE(257);
      END_STATE();
    case 689:
      if (lookahead == 's') ADVANCE(816);
      if (lookahead == 'w') ADVANCE(239);
      END_STATE();
    case 690:
      if (lookahead == 's') ADVANCE(76);
      END_STATE();
    case 691:
      if (lookahead == 's') ADVANCE(689);
      END_STATE();
    case 692:
      if (lookahead == 's') ADVANCE(457);
      END_STATE();
    case 693:
      if (lookahead == 's') ADVANCE(449);
      END_STATE();
    case 694:
      if (lookahead == 's') ADVANCE(726);
      END_STATE();
    case 695:
      if (lookahead == 's') ADVANCE(424);
      END_STATE();
    case 696:
      if (lookahead == 's') ADVANCE(424);
      if (lookahead == 'u') ADVANCE(695);
      END_STATE();
    case 697:
      if (lookahead == 's') ADVANCE(451);
      END_STATE();
    case 698:
      if (lookahead == 's') ADVANCE(744);
      END_STATE();
    case 699:
      if (lookahead == 's') ADVANCE(638);
      END_STATE();
    case 700:
      if (lookahead == 's') ADVANCE(412);
      END_STATE();
    case 701:
      if (lookahead == 's') ADVANCE(632);
      END_STATE();
    case 702:
      if (lookahead == 's') ADVANCE(397);
      END_STATE();
    case 703:
      if (lookahead == 's') ADVANCE(452);
      END_STATE();
    case 704:
      if (lookahead == 's') ADVANCE(136);
      END_STATE();
    case 705:
      if (lookahead == 's') ADVANCE(733);
      END_STATE();
    case 706:
      if (lookahead == 's') ADVANCE(776);
      END_STATE();
    case 707:
      if (lookahead == 's') ADVANCE(192);
      END_STATE();
    case 708:
      if (lookahead == 's') ADVANCE(326);
      END_STATE();
    case 709:
      if (lookahead == 's') ADVANCE(203);
      END_STATE();
    case 710:
      if (lookahead == 's') ADVANCE(681);
      if (lookahead == 'u') ADVANCE(681);
      END_STATE();
    case 711:
      if (lookahead == 's') ADVANCE(367);
      END_STATE();
    case 712:
      if (lookahead == 's') ADVANCE(428);
      END_STATE();
    case 713:
      if (lookahead == 's') ADVANCE(236);
      END_STATE();
    case 714:
      if (lookahead == 's') ADVANCE(728);
      END_STATE();
    case 715:
      if (lookahead == 's') ADVANCE(672);
      END_STATE();
    case 716:
      if (lookahead == 's') ADVANCE(666);
      END_STATE();
    case 717:
      if (lookahead == 's') ADVANCE(682);
      END_STATE();
    case 718:
      if (lookahead == 's') ADVANCE(712);
      END_STATE();
    case 719:
      if (lookahead == 's') ADVANCE(741);
      END_STATE();
    case 720:
      if (lookahead == 's') ADVANCE(742);
      END_STATE();
    case 721:
      if (lookahead == 's') ADVANCE(769);
      END_STATE();
    case 722:
      if (lookahead == 's') ADVANCE(421);
      END_STATE();
    case 723:
      if (lookahead == 's') ADVANCE(765);
      END_STATE();
    case 724:
      if (lookahead == 's') ADVANCE(771);
      END_STATE();
    case 725:
      if (lookahead == 's') ADVANCE(459);
      if (lookahead == 'x') ADVANCE(593);
      END_STATE();
    case 726:
      if (lookahead == 't') ADVANCE(1071);
      END_STATE();
    case 727:
      if (lookahead == 't') ADVANCE(427);
      END_STATE();
    case 728:
      if (lookahead == 't') ADVANCE(592);
      END_STATE();
    case 729:
      if (lookahead == 't') ADVANCE(279);
      END_STATE();
    case 730:
      if (lookahead == 't') ADVANCE(593);
      END_STATE();
    case 731:
      if (lookahead == 't') ADVANCE(90);
      END_STATE();
    case 732:
      if (lookahead == 't') ADVANCE(15);
      END_STATE();
    case 733:
      if (lookahead == 't') ADVANCE(869);
      END_STATE();
    case 734:
      if (lookahead == 't') ADVANCE(280);
      END_STATE();
    case 735:
      if (lookahead == 't') ADVANCE(345);
      END_STATE();
    case 736:
      if (lookahead == 't') ADVANCE(19);
      END_STATE();
    case 737:
      if (lookahead == 't') ADVANCE(298);
      END_STATE();
    case 738:
      if (lookahead == 't') ADVANCE(608);
      END_STATE();
    case 739:
      if (lookahead == 't') ADVANCE(844);
      END_STATE();
    case 740:
      if (lookahead == 't') ADVANCE(860);
      END_STATE();
    case 741:
      if (lookahead == 't') ADVANCE(392);
      END_STATE();
    case 742:
      if (lookahead == 't') ADVANCE(871);
      END_STATE();
    case 743:
      if (lookahead == 't') ADVANCE(1180);
      END_STATE();
    case 744:
      if (lookahead == 't') ADVANCE(591);
      END_STATE();
    case 745:
      if (lookahead == 't') ADVANCE(464);
      END_STATE();
    case 746:
      if (lookahead == 't') ADVANCE(609);
      END_STATE();
    case 747:
      if (lookahead == 't') ADVANCE(377);
      END_STATE();
    case 748:
      if (lookahead == 't') ADVANCE(1176);
      END_STATE();
    case 749:
      if (lookahead == 't') ADVANCE(1150);
      if (lookahead == 'u') ADVANCE(182);
      END_STATE();
    case 750:
      if (lookahead == 't') ADVANCE(1091);
      END_STATE();
    case 751:
      if (lookahead == 't') ADVANCE(1135);
      END_STATE();
    case 752:
      if (lookahead == 't') ADVANCE(817);
      END_STATE();
    case 753:
      if (lookahead == 't') ADVANCE(297);
      END_STATE();
    case 754:
      if (lookahead == 't') ADVANCE(1173);
      END_STATE();
    case 755:
      if (lookahead == 't') ADVANCE(4);
      END_STATE();
    case 756:
      if (lookahead == 't') ADVANCE(637);
      END_STATE();
    case 757:
      if (lookahead == 't') ADVANCE(422);
      END_STATE();
    case 758:
      if (lookahead == 't') ADVANCE(576);
      END_STATE();
    case 759:
      if (lookahead == 't') ADVANCE(135);
      END_STATE();
    case 760:
      if (lookahead == 't') ADVANCE(624);
      END_STATE();
    case 761:
      if (lookahead == 't') ADVANCE(632);
      END_STATE();
    case 762:
      if (lookahead == 't') ADVANCE(187);
      END_STATE();
    case 763:
      if (lookahead == 't') ADVANCE(607);
      END_STATE();
    case 764:
      if (lookahead == 't') ADVANCE(326);
      END_STATE();
    case 765:
      if (lookahead == 't') ADVANCE(642);
      END_STATE();
    case 766:
      if (lookahead == 't') ADVANCE(92);
      END_STATE();
    case 767:
      if (lookahead == 't') ADVANCE(217);
      END_STATE();
    case 768:
      if (lookahead == 't') ADVANCE(344);
      END_STATE();
    case 769:
      if (lookahead == 't') ADVANCE(583);
      END_STATE();
    case 770:
      if (lookahead == 't') ADVANCE(354);
      END_STATE();
    case 771:
      if (lookahead == 't') ADVANCE(586);
      END_STATE();
    case 772:
      if (lookahead == 't') ADVANCE(355);
      END_STATE();
    case 773:
      if (lookahead == 't') ADVANCE(423);
      END_STATE();
    case 774:
      if (lookahead == 't') ADVANCE(772);
      END_STATE();
    case 775:
      if (lookahead == 'u') ADVANCE(1071);
      END_STATE();
    case 776:
      if (lookahead == 'u') ADVANCE(815);
      END_STATE();
    case 777:
      if (lookahead == 'u') ADVANCE(591);
      END_STATE();
    case 778:
      if (lookahead == 'u') ADVANCE(461);
      END_STATE();
    case 779:
      if (lookahead == 'u') ADVANCE(622);
      END_STATE();
    case 780:
      if (lookahead == 'u') ADVANCE(169);
      END_STATE();
    case 781:
      if (lookahead == 'u') ADVANCE(470);
      END_STATE();
    case 782:
      if (lookahead == 'u') ADVANCE(433);
      END_STATE();
    case 783:
      if (lookahead == 'u') ADVANCE(374);
      END_STATE();
    case 784:
      if (lookahead == 'u') ADVANCE(182);
      END_STATE();
    case 785:
      if (lookahead == 'u') ADVANCE(375);
      END_STATE();
    case 786:
      if (lookahead == 'u') ADVANCE(176);
      END_STATE();
    case 787:
      if (lookahead == 'u') ADVANCE(177);
      END_STATE();
    case 788:
      if (lookahead == 'u') ADVANCE(478);
      END_STATE();
    case 789:
      if (lookahead == 'u') ADVANCE(178);
      END_STATE();
    case 790:
      if (lookahead == 'u') ADVANCE(616);
      END_STATE();
    case 791:
      if (lookahead == 'u') ADVANCE(194);
      if (lookahead == 'w') ADVANCE(239);
      END_STATE();
    case 792:
      if (lookahead == 'u') ADVANCE(700);
      END_STATE();
    case 793:
      if (lookahead == 'u') ADVANCE(183);
      END_STATE();
    case 794:
      if (lookahead == 'u') ADVANCE(547);
      END_STATE();
    case 795:
      if (lookahead == 'u') ADVANCE(224);
      END_STATE();
    case 796:
      if (lookahead == 'v') ADVANCE(1071);
      END_STATE();
    case 797:
      if (lookahead == 'v') ADVANCE(1147);
      END_STATE();
    case 798:
      if (lookahead == 'v') ADVANCE(167);
      if (lookahead == 'w') ADVANCE(1071);
      END_STATE();
    case 799:
      if (lookahead == 'v') ADVANCE(593);
      END_STATE();
    case 800:
      if (lookahead == 'v') ADVANCE(90);
      END_STATE();
    case 801:
      if (lookahead == 'v') ADVANCE(869);
      END_STATE();
    case 802:
      if (lookahead == 'v') ADVANCE(512);
      END_STATE();
    case 803:
      if (lookahead == 'v') ADVANCE(96);
      END_STATE();
    case 804:
      if (lookahead == 'v') ADVANCE(166);
      END_STATE();
    case 805:
      if (lookahead == 'v') ADVANCE(191);
      END_STATE();
    case 806:
      if (lookahead == 'v') ADVANCE(844);
      END_STATE();
    case 807:
      if (lookahead == 'v') ADVANCE(271);
      END_STATE();
    case 808:
      if (lookahead == 'v') ADVANCE(1170);
      END_STATE();
    case 809:
      if (lookahead == 'v') ADVANCE(1101);
      END_STATE();
    case 810:
      if (lookahead == 'v') ADVANCE(270);
      END_STATE();
    case 811:
      if (lookahead == 'v') ADVANCE(1164);
      END_STATE();
    case 812:
      if (lookahead == 'v') ADVANCE(326);
      END_STATE();
    case 813:
      if (lookahead == 'v') ADVANCE(336);
      END_STATE();
    case 814:
      if (lookahead == 'v') ADVANCE(337);
      END_STATE();
    case 815:
      if (lookahead == 'w') ADVANCE(1071);
      END_STATE();
    case 816:
      if (lookahead == 'w') ADVANCE(239);
      END_STATE();
    case 817:
      if (lookahead == 'x') ADVANCE(1071);
      END_STATE();
    case 818:
      if (lookahead == 'x') ADVANCE(30);
      END_STATE();
    case 819:
      if (lookahead == 'x') ADVANCE(598);
      END_STATE();
    case 820:
      if (lookahead == 'x') ADVANCE(837);
      END_STATE();
    case 821:
      if (lookahead == 'x') ADVANCE(836);
      END_STATE();
    case 822:
      if (lookahead == 'x') ADVANCE(861);
      END_STATE();
    case 823:
      if (lookahead == 'x') ADVANCE(833);
      END_STATE();
    case 824:
      if (lookahead == 'x') ADVANCE(76);
      END_STATE();
    case 825:
      if (lookahead == 'x') ADVANCE(180);
      END_STATE();
    case 826:
      if (lookahead == 'x') ADVANCE(1168);
      END_STATE();
    case 827:
      if (lookahead == 'x') ADVANCE(596);
      END_STATE();
    case 828:
      if (lookahead == 'x') ADVANCE(790);
      END_STATE();
    case 829:
      if (lookahead == 'x') ADVANCE(230);
      END_STATE();
    case 830:
      if (lookahead == 'x') ADVANCE(754);
      END_STATE();
    case 831:
      if (lookahead == 'x') ADVANCE(764);
      END_STATE();
    case 832:
      if (lookahead == 'y') ADVANCE(404);
      END_STATE();
    case 833:
      if (lookahead == 'z') ADVANCE(1071);
      END_STATE();
    case 834:
      if (lookahead == 'z') ADVANCE(593);
      END_STATE();
    case 835:
      if (lookahead == 'z') ADVANCE(223);
      END_STATE();
    case 836:
      if (lookahead == '2' ||
          lookahead == '4') ADVANCE(1071);
      END_STATE();
    case 837:
      if (lookahead == '4' ||
          lookahead == '8') ADVANCE(1071);
      END_STATE();
    case 838:
      if (lookahead == 'b' ||
          lookahead == 'd') ADVANCE(1071);
      if (lookahead == 'h') ADVANCE(815);
      if (lookahead == 'l') ADVANCE(815);
      END_STATE();
    case 839:
      if (lookahead == 'b' ||
          lookahead == 'w') ADVANCE(1071);
      END_STATE();
    case 840:
      if (lookahead == 'b' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'u') ADVANCE(667);
      END_STATE();
    case 841:
      if (lookahead == 'b' ||
          lookahead == 'y') ADVANCE(1065);
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(841);
      END_STATE();
    case 842:
      if (lookahead == 'd' ||
          lookahead == 'h') ADVANCE(1071);
      END_STATE();
    case 843:
      if (lookahead == 'd' ||
          lookahead == 'i') ADVANCE(1071);
      END_STATE();
    case 844:
      if (lookahead == 'd' ||
          lookahead == 'q') ADVANCE(1071);
      END_STATE();
    case 845:
      if (lookahead == 'd' ||
          lookahead == 'q') ADVANCE(1071);
      if (lookahead == 'v') ADVANCE(844);
      END_STATE();
    case 846:
      if (lookahead == 'd' ||
          lookahead == 's') ADVANCE(1071);
      END_STATE();
    case 847:
      if (lookahead == 'd' ||
          lookahead == 's') ADVANCE(1071);
      if (lookahead == 'h') ADVANCE(305);
      if (lookahead == 'l') ADVANCE(305);
      END_STATE();
    case 848:
      if (lookahead == 'd' ||
          lookahead == 's') ADVANCE(1071);
      if (lookahead == 'u') ADVANCE(169);
      END_STATE();
    case 849:
      if (lookahead == 'd' ||
          lookahead == 's') ADVANCE(1071);
      if (lookahead == 'u') ADVANCE(181);
      END_STATE();
    case 850:
      if (lookahead == 'd' ||
          lookahead == 'w') ADVANCE(1071);
      END_STATE();
    case 851:
      if (lookahead == 'd' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 's') ADVANCE(815);
      END_STATE();
    case 852:
      if (lookahead == 'd' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'v') ADVANCE(167);
      END_STATE();
    case 853:
      if (lookahead == 'e' ||
          lookahead == 't') ADVANCE(1071);
      END_STATE();
    case 854:
      if (lookahead == 'f' ||
          lookahead == 'r') ADVANCE(1071);
      if (lookahead == 'w') ADVANCE(113);
      END_STATE();
    case 855:
      if (lookahead == 'h' ||
          lookahead == 'l') ADVANCE(1071);
      END_STATE();
    case 856:
      if (lookahead == 'i' ||
          lookahead == 'm') ADVANCE(1071);
      END_STATE();
    case 857:
      if (lookahead == 'i' ||
          lookahead == 's') ADVANCE(1071);
      END_STATE();
    case 858:
      if (lookahead == 'l' ||
          lookahead == 'r') ADVANCE(1071);
      if (lookahead == 'p') ADVANCE(609);
      END_STATE();
    case 859:
      if (lookahead == 'p' ||
          lookahead == 't') ADVANCE(1071);
      END_STATE();
    case 860:
      if (lookahead == '1' ||
          lookahead == '2') ADVANCE(1071);
      END_STATE();
    case 861:
      if (lookahead == '2' ||
          lookahead == '4' ||
          lookahead == '8') ADVANCE(1071);
      END_STATE();
    case 862:
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'w') ADVANCE(1071);
      END_STATE();
    case 863:
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'e') ADVANCE(657);
      END_STATE();
    case 864:
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'h') ADVANCE(815);
      if (lookahead == 'l') ADVANCE(815);
      END_STATE();
    case 865:
      if (lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      END_STATE();
    case 866:
      if (lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'v') ADVANCE(865);
      END_STATE();
    case 867:
      if (lookahead == 'l' ||
          lookahead == 'n' ||
          lookahead == 'u') ADVANCE(1071);
      END_STATE();
    case 868:
      if (('0' <= lookahead && lookahead <= '2')) ADVANCE(1071);
      END_STATE();
    case 869:
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      END_STATE();
    case 870:
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'e') ADVANCE(625);
      if (lookahead == 'g') ADVANCE(733);
      if (lookahead == 'i') ADVANCE(723);
      if (lookahead == 'u') ADVANCE(869);
      END_STATE();
    case 871:
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'm') ADVANCE(193);
      END_STATE();
    case 872:
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'n') ADVANCE(869);
      END_STATE();
    case 873:
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'p') ADVANCE(846);
      END_STATE();
    case 874:
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'p') ADVANCE(663);
      if (lookahead == 'u') ADVANCE(869);
      END_STATE();
    case 875:
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 's') ADVANCE(839);
      if (lookahead == 'u') ADVANCE(680);
      END_STATE();
    case 876:
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 't') ADVANCE(362);
      END_STATE();
    case 877:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(1013);
      END_STATE();
    case 878:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(379);
      END_STATE();
    case 879:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(879)
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(886);
      END_STATE();
    case 880:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(880)
      if (lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 881:
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 's' ||
          lookahead == 'w') ADVANCE(1071);
      END_STATE();
    case 882:
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 's' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'h') ADVANCE(305);
      if (lookahead == 'l') ADVANCE(305);
      if (lookahead == 'x') ADVANCE(1115);
      END_STATE();
    case 883:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(1045);
      END_STATE();
    case 884:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(1061);
      END_STATE();
    case 885:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(1060);
      END_STATE();
    case 886:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(996);
      END_STATE();
    case 887:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(883);
      END_STATE();
    case 888:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(887);
      END_STATE();
    case 889:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(888);
      END_STATE();
    case 890:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(889);
      END_STATE();
    case 891:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(890);
      END_STATE();
    case 892:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(891);
      END_STATE();
    case 893:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(892);
      END_STATE();
    case 894:
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1194);
      END_STATE();
    case 895:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(926);
      END_STATE();
    case 896:
      if (eof) ADVANCE(900);
      if (lookahead == '\n') ADVANCE(902);
      if (lookahead == '"') ADVANCE(1048);
      if (lookahead == '$') ADVANCE(13);
      if (lookahead == ',') ADVANCE(1026);
      if (lookahead == '0') ADVANCE(1054);
      if (lookahead == '1') ADVANCE(1055);
      if (lookahead == '<') ADVANCE(927);
      if (lookahead == 'B') ADVANCE(2144);
      if (lookahead == 'D') ADVANCE(2141);
      if (lookahead == 'P') ADVANCE(2139);
      if (lookahead == 'Q') ADVANCE(2142);
      if (lookahead == 'W') ADVANCE(2130);
      if (lookahead == 'X') ADVANCE(2128);
      if (lookahead == '[') ADVANCE(1031);
      if (lookahead == '_') ADVANCE(2919);
      if (lookahead == 'b') ADVANCE(2462);
      if (lookahead == 'd') ADVANCE(2460);
      if (lookahead == 'e') ADVANCE(2231);
      if (lookahead == 'p') ADVANCE(2842);
      if (lookahead == 'q') ADVANCE(2890);
      if (lookahead == 'r') ADVANCE(2053);
      if (lookahead == 's') ADVANCE(2937);
      if (lookahead == 'w') ADVANCE(2635);
      if (lookahead == 'x') ADVANCE(2568);
      if (lookahead == 'y') ADVANCE(2572);
      if (lookahead == '#' ||
          lookahead == ';') ADVANCE(905);
      if (('a' <= lookahead && lookahead <= 'c')) ADVANCE(2458);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(1057);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(896)
      if (('A' <= lookahead && lookahead <= 'F') ||
          lookahead == 'f') ADVANCE(2477);
      if (('2' <= lookahead && lookahead <= '7')) ADVANCE(1056);
      if (lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 897:
      if (eof) ADVANCE(900);
      if (lookahead == '\n') ADVANCE(902);
      if (lookahead == 'i') ADVANCE(556);
      if (lookahead == '#' ||
          lookahead == ';') ADVANCE(905);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(897)
      END_STATE();
    case 898:
      if (eof) ADVANCE(900);
      if (lookahead == '\n') ADVANCE(903);
      if (lookahead == '$') ADVANCE(923);
      if (lookahead == 'D') ADVANCE(942);
      if (lookahead == 'a') ADVANCE(931);
      if (lookahead == 'b') ADVANCE(939);
      if (lookahead == 'c') ADVANCE(932);
      if (lookahead == 'd') ADVANCE(933);
      if (lookahead == 'e') ADVANCE(945);
      if (lookahead == 'f') ADVANCE(929);
      if (lookahead == 'g') ADVANCE(1642);
      if (lookahead == 'h') ADVANCE(1299);
      if (lookahead == 'i') ADVANCE(1427);
      if (lookahead == 'j') ADVANCE(1269);
      if (lookahead == 'k') ADVANCE(1274);
      if (lookahead == 'l') ADVANCE(1289);
      if (lookahead == 'm') ADVANCE(1275);
      if (lookahead == 'n') ADVANCE(1505);
      if (lookahead == 'o') ADVANCE(1814);
      if (lookahead == 'p') ADVANCE(1276);
      if (lookahead == 'r') ADVANCE(1377);
      if (lookahead == 's') ADVANCE(1277);
      if (lookahead == 't') ADVANCE(1211);
      if (lookahead == 'u') ADVANCE(1389);
      if (lookahead == 'v') ADVANCE(1278);
      if (lookahead == 'w') ADVANCE(1291);
      if (lookahead == 'x') ADVANCE(1325);
      if (lookahead == '#' ||
          lookahead == ';') ADVANCE(905);
      if (lookahead == '-' ||
          lookahead == '/') ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(898)
      if (('A' <= lookahead && lookahead <= 'F')) ADVANCE(956);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(958);
      if (lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('q' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 899:
      if (eof) ADVANCE(900);
      if (lookahead == '\n') ADVANCE(904);
      if (lookahead == 'a') ADVANCE(93);
      if (lookahead == 'b') ADVANCE(328);
      if (lookahead == 'c') ADVANCE(94);
      if (lookahead == 'd') ADVANCE(95);
      if (lookahead == 'e') ADVANCE(503);
      if (lookahead == 'f') ADVANCE(44);
      if (lookahead == 'h') ADVANCE(122);
      if (lookahead == 'i') ADVANCE(277);
      if (lookahead == 'j') ADVANCE(89);
      if (lookahead == 'k') ADVANCE(97);
      if (lookahead == 'l') ADVANCE(112);
      if (lookahead == 'm') ADVANCE(98);
      if (lookahead == 'n') ADVANCE(329);
      if (lookahead == 'o') ADVANCE(650);
      if (lookahead == 'p') ADVANCE(99);
      if (lookahead == 'r') ADVANCE(198);
      if (lookahead == 's') ADVANCE(100);
      if (lookahead == 't') ADVANCE(29);
      if (lookahead == 'u') ADVANCE(212);
      if (lookahead == 'v') ADVANCE(101);
      if (lookahead == 'w') ADVANCE(118);
      if (lookahead == 'x') ADVANCE(145);
      if (lookahead == '#' ||
          lookahead == ';') ADVANCE(905);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(899)
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F')) ADVANCE(886);
      END_STATE();
    case 900:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 901:
      ACCEPT_TOKEN(aux_sym_source_file_token1);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(901);
      END_STATE();
    case 902:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(902);
      END_STATE();
    case 903:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(903);
      if (lookahead == 'a') ADVANCE(931);
      if (lookahead == 'b') ADVANCE(939);
      if (lookahead == 'c') ADVANCE(932);
      if (lookahead == 'd') ADVANCE(933);
      if (lookahead == 'e') ADVANCE(945);
      if (lookahead == 'f') ADVANCE(929);
      if (lookahead == 'h') ADVANCE(1299);
      if (lookahead == 'i') ADVANCE(1427);
      if (lookahead == 'j') ADVANCE(1269);
      if (lookahead == 'k') ADVANCE(1274);
      if (lookahead == 'l') ADVANCE(1289);
      if (lookahead == 'm') ADVANCE(1275);
      if (lookahead == 'n') ADVANCE(1505);
      if (lookahead == 'o') ADVANCE(1814);
      if (lookahead == 'p') ADVANCE(1276);
      if (lookahead == 'r') ADVANCE(1377);
      if (lookahead == 's') ADVANCE(1277);
      if (lookahead == 't') ADVANCE(1211);
      if (lookahead == 'u') ADVANCE(1389);
      if (lookahead == 'v') ADVANCE(1278);
      if (lookahead == 'w') ADVANCE(1291);
      if (lookahead == 'x') ADVANCE(1325);
      END_STATE();
    case 904:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(904);
      if (lookahead == 'a') ADVANCE(93);
      if (lookahead == 'b') ADVANCE(328);
      if (lookahead == 'c') ADVANCE(94);
      if (lookahead == 'd') ADVANCE(95);
      if (lookahead == 'e') ADVANCE(503);
      if (lookahead == 'f') ADVANCE(44);
      if (lookahead == 'h') ADVANCE(122);
      if (lookahead == 'i') ADVANCE(277);
      if (lookahead == 'j') ADVANCE(89);
      if (lookahead == 'k') ADVANCE(97);
      if (lookahead == 'l') ADVANCE(112);
      if (lookahead == 'm') ADVANCE(98);
      if (lookahead == 'n') ADVANCE(329);
      if (lookahead == 'o') ADVANCE(650);
      if (lookahead == 'p') ADVANCE(99);
      if (lookahead == 'r') ADVANCE(198);
      if (lookahead == 's') ADVANCE(100);
      if (lookahead == 't') ADVANCE(29);
      if (lookahead == 'u') ADVANCE(212);
      if (lookahead == 'v') ADVANCE(101);
      if (lookahead == 'w') ADVANCE(118);
      if (lookahead == 'x') ADVANCE(145);
      END_STATE();
    case 905:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(905);
      END_STATE();
    case 906:
      ACCEPT_TOKEN(anon_sym_db);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(956);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 907:
      ACCEPT_TOKEN(anon_sym_db);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 908:
      ACCEPT_TOKEN(anon_sym_dw);
      END_STATE();
    case 909:
      ACCEPT_TOKEN(anon_sym_dw);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 910:
      ACCEPT_TOKEN(anon_sym_dd);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(956);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 911:
      ACCEPT_TOKEN(anon_sym_dd);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 912:
      ACCEPT_TOKEN(anon_sym_dq);
      END_STATE();
    case 913:
      ACCEPT_TOKEN(anon_sym_dq);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 914:
      ACCEPT_TOKEN(anon_sym_section);
      END_STATE();
    case 915:
      ACCEPT_TOKEN(anon_sym_section);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 916:
      ACCEPT_TOKEN(anon_sym_info);
      END_STATE();
    case 917:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 918:
      ACCEPT_TOKEN(anon_sym_extern);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 919:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 920:
      ACCEPT_TOKEN(anon_sym_global);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 921:
      ACCEPT_TOKEN(aux_sym_shell_cmd_token1);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(921);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(922);
      END_STATE();
    case 922:
      ACCEPT_TOKEN(aux_sym_shell_cmd_token1);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(922);
      END_STATE();
    case 923:
      ACCEPT_TOKEN(sym_shell_prompt);
      END_STATE();
    case 924:
      ACCEPT_TOKEN(anon_sym_Disassemblyofsection);
      END_STATE();
    case 925:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 926:
      ACCEPT_TOKEN(sym_objdump_file_format);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(926);
      END_STATE();
    case 927:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 928:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 929:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(953);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(934);
      if (lookahead == 'b') ADVANCE(944);
      if (lookahead == 'c') ADVANCE(941);
      if (lookahead == 'd') ADVANCE(940);
      if (lookahead == 'e') ADVANCE(946);
      if (lookahead == 'f') ADVANCE(948);
      if (lookahead == 'i') ADVANCE(1326);
      if (lookahead == 'l') ADVANCE(1449);
      if (lookahead == 'm') ADVANCE(1951);
      if (lookahead == 'n') ADVANCE(1393);
      if (lookahead == 'p') ADVANCE(1305);
      if (lookahead == 'r') ADVANCE(1710);
      if (lookahead == 's') ADVANCE(1301);
      if (lookahead == 't') ADVANCE(1859);
      if (lookahead == 'u') ADVANCE(1411);
      if (lookahead == 'w') ADVANCE(1292);
      if (lookahead == 'x') ADVANCE(1295);
      if (lookahead == 'y') ADVANCE(1643);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F')) ADVANCE(956);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 930:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1071);
      if (lookahead == 's') ADVANCE(1071);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('b' <= lookahead && lookahead <= 'f')) ADVANCE(956);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 931:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(955);
      if (lookahead == 'd') ADVANCE(936);
      if (lookahead == 'e') ADVANCE(950);
      if (lookahead == 'n') ADVANCE(1448);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('b' <= lookahead && lookahead <= 'f')) ADVANCE(956);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 932:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(943);
      if (lookahead == 'b') ADVANCE(952);
      if (lookahead == 'd') ADVANCE(947);
      if (lookahead == 'l') ADVANCE(1296);
      if (lookahead == 'm') ADVANCE(1375);
      if (lookahead == 'o') ADVANCE(1677);
      if (lookahead == 'p') ADVANCE(1947);
      if (lookahead == 'q') ADVANCE(1734);
      if (lookahead == 'r') ADVANCE(1379);
      if (lookahead == 'v') ADVANCE(1898);
      if (lookahead == 'w') ADVANCE(1417);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('c' <= lookahead && lookahead <= 'f')) ADVANCE(956);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 933:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(930);
      if (lookahead == 'b') ADVANCE(906);
      if (lookahead == 'd') ADVANCE(910);
      if (lookahead == 'e') ADVANCE(935);
      if (lookahead == 'i') ADVANCE(1978);
      if (lookahead == 'p') ADVANCE(1764);
      if (lookahead == 'q') ADVANCE(913);
      if (lookahead == 'w') ADVANCE(909);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('c' <= lookahead && lookahead <= 'f')) ADVANCE(956);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 934:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(949);
      if (lookahead == 'd') ADVANCE(938);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(956);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 935:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1071);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(956);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 936:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1184);
      if (lookahead == 'd') ADVANCE(1160);
      if (lookahead == 'o') ADVANCE(1985);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(956);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 937:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(951);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(956);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 938:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1146);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(956);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 939:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(954);
      if (lookahead == 'l') ADVANCE(1378);
      if (lookahead == 'n') ADVANCE(1429);
      if (lookahead == 's') ADVANCE(2020);
      if (lookahead == 't') ADVANCE(1193);
      if (lookahead == 'z') ADVANCE(1587);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(956);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'y')) ADVANCE(2042);
      END_STATE();
    case 940:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(937);
      if (lookahead == 'i') ADVANCE(1965);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(956);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 941:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'h') ADVANCE(1832);
      if (lookahead == 'l') ADVANCE(1514);
      if (lookahead == 'm') ADVANCE(1748);
      if (lookahead == 'o') ADVANCE(1663);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(956);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 942:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'i') ADVANCE(1888);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(956);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 943:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(1632);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(956);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 944:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(1419);
      if (lookahead == 's') ADVANCE(1917);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(956);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 945:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(1675);
      if (lookahead == 'n') ADVANCE(1460);
      if (lookahead == 'x') ADVANCE(1899);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(956);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 946:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(1675);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(956);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 947:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'q') ADVANCE(1122);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(956);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 948:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(1528);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(956);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 949:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1071);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(956);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 950:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1486);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(956);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 951:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1917);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(956);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 952:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'w') ADVANCE(1071);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(956);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 953:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'x') ADVANCE(1667);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(956);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 954:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'x') ADVANCE(1927);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(956);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 955:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a' ||
          lookahead == 'd') ADVANCE(1071);
      if (lookahead == 'm' ||
          lookahead == 's') ADVANCE(1071);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('b' <= lookahead && lookahead <= 'f')) ADVANCE(956);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 956:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(956);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 957:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '2') ADVANCE(989);
      if (lookahead == 'a') ADVANCE(969);
      if (lookahead == 'b') ADVANCE(980);
      if (lookahead == 'c') ADVANCE(978);
      if (lookahead == 'd') ADVANCE(977);
      if (lookahead == 'e') ADVANCE(981);
      if (lookahead == 'f') ADVANCE(983);
      if (lookahead == 'i') ADVANCE(2200);
      if (lookahead == 'l') ADVANCE(2301);
      if (lookahead == 'm') ADVANCE(2856);
      if (lookahead == 'n') ADVANCE(2267);
      if (lookahead == 'p') ADVANCE(2179);
      if (lookahead == 'r') ADVANCE(2604);
      if (lookahead == 's') ADVANCE(1042);
      if (lookahead == 't') ADVANCE(2767);
      if (lookahead == 'u') ADVANCE(2285);
      if (lookahead == 'w') ADVANCE(2169);
      if (lookahead == 'x') ADVANCE(2176);
      if (lookahead == 'y') ADVANCE(2534);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F')) ADVANCE(995);
      END_STATE();
    case 958:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == ':') ADVANCE(878);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(958);
      if (('-' <= lookahead && lookahead <= '/') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(87);
      END_STATE();
    case 959:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 'W') ADVANCE(2131);
      if (lookahead == 'i') ADVANCE(2793);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 960:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 'Y') ADVANCE(2140);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 961:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '_') ADVANCE(841);
      if (lookahead == 'b') ADVANCE(995);
      if (lookahead == 'd') ADVANCE(995);
      if (lookahead == 'y') ADVANCE(1065);
      if (lookahead == 'o' ||
          lookahead == 'q') ADVANCE(1062);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(961);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(974);
      if (('2' <= lookahead && lookahead <= '7')) ADVANCE(973);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 962:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '_') ADVANCE(841);
      if (lookahead == 'b') ADVANCE(963);
      if (lookahead == 'd') ADVANCE(994);
      if (lookahead == 'y') ADVANCE(1068);
      if (lookahead == 'h' ||
          lookahead == 'x') ADVANCE(884);
      if (lookahead == 'o' ||
          lookahead == 'q') ADVANCE(1063);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(961);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(974);
      if (('2' <= lookahead && lookahead <= '7')) ADVANCE(973);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 963:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == '_') ADVANCE(1070);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(963);
      if (('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 964:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 'a') ADVANCE(991);
      if (lookahead == 'd') ADVANCE(971);
      if (lookahead == 'e') ADVANCE(985);
      if (lookahead == 'n') ADVANCE(2299);
      if (lookahead == 'h' ||
          lookahead == 'l' ||
          lookahead == 'x') ADVANCE(1027);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('b' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 965:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 'a') ADVANCE(979);
      if (lookahead == 'b') ADVANCE(987);
      if (lookahead == 'd') ADVANCE(982);
      if (lookahead == 'h' ||
          lookahead == 'x') ADVANCE(1027);
      if (lookahead == 'l') ADVANCE(1028);
      if (lookahead == 'm') ADVANCE(2251);
      if (lookahead == 'o') ADVANCE(2571);
      if (lookahead == 'p') ADVANCE(2854);
      if (lookahead == 'q') ADVANCE(2629);
      if (lookahead == 'r') ADVANCE(2253);
      if (lookahead == 's') ADVANCE(1038);
      if (lookahead == 'v') ADVANCE(2803);
      if (lookahead == 'w') ADVANCE(2295);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('c' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 966:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 'a') ADVANCE(967);
      if (lookahead == 'b') ADVANCE(907);
      if (lookahead == 'd') ADVANCE(911);
      if (lookahead == 'e') ADVANCE(970);
      if (lookahead == 'i') ADVANCE(1030);
      if (lookahead == 'p') ADVANCE(2664);
      if (lookahead == 'q') ADVANCE(912);
      if (lookahead == 's') ADVANCE(1039);
      if (lookahead == 'w') ADVANCE(908);
      if (lookahead == 'h' ||
          lookahead == 'l' ||
          lookahead == 'x') ADVANCE(1027);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('c' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 967:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 'a') ADVANCE(1071);
      if (lookahead == 's') ADVANCE(1071);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('b' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 968:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 'b') ADVANCE(993);
      if (lookahead == 'd') ADVANCE(992);
      if (lookahead == 'm') ADVANCE(2569);
      if (lookahead == 'n') ADVANCE(2334);
      if (lookahead == 's') ADVANCE(1040);
      if (lookahead == 'x') ADVANCE(2822);
      if (('a' <= lookahead && lookahead <= 'c')) ADVANCE(988);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == 'e' ||
          lookahead == 'f') ADVANCE(995);
      END_STATE();
    case 969:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 'b') ADVANCE(984);
      if (lookahead == 'd') ADVANCE(975);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 970:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 'c') ADVANCE(1071);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 971:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 'c') ADVANCE(1184);
      if (lookahead == 'd') ADVANCE(1154);
      if (lookahead == 'o') ADVANCE(2894);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 972:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 'c') ADVANCE(986);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 973:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 'd') ADVANCE(995);
      if (lookahead == 'o' ||
          lookahead == 'q') ADVANCE(1062);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(974);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(973);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 974:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 'd') ADVANCE(995);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(974);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 975:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 'd') ADVANCE(1146);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 976:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 'e') ADVANCE(990);
      if (lookahead == 'h' ||
          lookahead == 'p' ||
          lookahead == 'x') ADVANCE(1027);
      if (lookahead == 'l') ADVANCE(1029);
      if (lookahead == 'n') ADVANCE(2300);
      if (lookahead == 's') ADVANCE(2932);
      if (lookahead == 't') ADVANCE(1193);
      if (lookahead == 'y') ADVANCE(2832);
      if (lookahead == 'z') ADVANCE(2478);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 977:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 'e') ADVANCE(972);
      if (lookahead == 'i') ADVANCE(2876);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 978:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 'h') ADVANCE(2738);
      if (lookahead == 'l') ADVANCE(2394);
      if (lookahead == 'm') ADVANCE(2643);
      if (lookahead == 'o') ADVANCE(2558);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 979:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 'l') ADVANCE(2523);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 980:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 'l') ADVANCE(2297);
      if (lookahead == 's') ADVANCE(2821);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 981:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 'm') ADVANCE(2569);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 982:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 'q') ADVANCE(1122);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 983:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 'r') ADVANCE(2407);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 984:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 's') ADVANCE(1071);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 985:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 's') ADVANCE(2366);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 986:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 's') ADVANCE(2821);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 987:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 'w') ADVANCE(1071);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 988:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 'x') ADVANCE(1027);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 989:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 'x') ADVANCE(2557);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 990:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 'x') ADVANCE(2833);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 991:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 'a' ||
          lookahead == 'd') ADVANCE(1071);
      if (lookahead == 'm' ||
          lookahead == 's') ADVANCE(1071);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('b' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 992:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 'i' ||
          lookahead == 'x') ADVANCE(1027);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 993:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (lookahead == 'p' ||
          lookahead == 'x') ADVANCE(1027);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 994:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(994);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 995:
      ACCEPT_TOKEN(aux_sym_objdump_addr_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(995);
      END_STATE();
    case 996:
      ACCEPT_TOKEN(aux_sym_objdump_machine_code_bytes_token1);
      END_STATE();
    case 997:
      ACCEPT_TOKEN(aux_sym_objdump_machine_code_bytes_token1);
      if (lookahead == 'b') ADVANCE(664);
      if (lookahead == 'd') ADVANCE(268);
      END_STATE();
    case 998:
      ACCEPT_TOKEN(aux_sym_objdump_machine_code_bytes_token1);
      if (lookahead == 'c') ADVANCE(1071);
      END_STATE();
    case 999:
      ACCEPT_TOKEN(aux_sym_objdump_machine_code_bytes_token1);
      if (lookahead == 'c') ADVANCE(1184);
      if (lookahead == 'd') ADVANCE(1166);
      if (lookahead == 'o') ADVANCE(817);
      END_STATE();
    case 1000:
      ACCEPT_TOKEN(aux_sym_objdump_machine_code_bytes_token1);
      if (lookahead == 'e') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(797);
      END_STATE();
    case 1001:
      ACCEPT_TOKEN(aux_sym_objdump_machine_code_bytes_token1);
      if (lookahead == 'h') ADVANCE(664);
      if (lookahead == 'l') ADVANCE(339);
      if (lookahead == 'm') ADVANCE(580);
      if (lookahead == 'o') ADVANCE(492);
      END_STATE();
    case 1002:
      ACCEPT_TOKEN(aux_sym_objdump_machine_code_bytes_token1);
      if (lookahead == 'l') ADVANCE(461);
      END_STATE();
    case 1003:
      ACCEPT_TOKEN(aux_sym_objdump_machine_code_bytes_token1);
      if (lookahead == 'l') ADVANCE(239);
      if (lookahead == 's') ADVANCE(744);
      END_STATE();
    case 1004:
      ACCEPT_TOKEN(aux_sym_objdump_machine_code_bytes_token1);
      if (lookahead == 'm') ADVANCE(505);
      END_STATE();
    case 1005:
      ACCEPT_TOKEN(aux_sym_objdump_machine_code_bytes_token1);
      if (lookahead == 'q') ADVANCE(1122);
      END_STATE();
    case 1006:
      ACCEPT_TOKEN(aux_sym_objdump_machine_code_bytes_token1);
      if (lookahead == 'r') ADVANCE(350);
      END_STATE();
    case 1007:
      ACCEPT_TOKEN(aux_sym_objdump_machine_code_bytes_token1);
      if (lookahead == 's') ADVANCE(322);
      END_STATE();
    case 1008:
      ACCEPT_TOKEN(aux_sym_objdump_machine_code_bytes_token1);
      if (lookahead == 'w') ADVANCE(1071);
      END_STATE();
    case 1009:
      ACCEPT_TOKEN(aux_sym_objdump_machine_code_bytes_token1);
      if (lookahead == 'x') ADVANCE(496);
      END_STATE();
    case 1010:
      ACCEPT_TOKEN(aux_sym_objdump_machine_code_bytes_token1);
      if (lookahead == 'x') ADVANCE(761);
      END_STATE();
    case 1011:
      ACCEPT_TOKEN(aux_sym_objdump_machine_code_bytes_token1);
      if (lookahead == 'a' ||
          lookahead == 's') ADVANCE(1071);
      END_STATE();
    case 1012:
      ACCEPT_TOKEN(aux_sym_objdump_machine_code_bytes_token1);
      if (lookahead == 'a' ||
          lookahead == 'd' ||
          lookahead == 'm' ||
          lookahead == 's') ADVANCE(1071);
      END_STATE();
    case 1013:
      ACCEPT_TOKEN(aux_sym_label_token1);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(1013);
      END_STATE();
    case 1014:
      ACCEPT_TOKEN(anon_sym_byte);
      END_STATE();
    case 1015:
      ACCEPT_TOKEN(anon_sym_word);
      END_STATE();
    case 1016:
      ACCEPT_TOKEN(anon_sym_dword);
      END_STATE();
    case 1017:
      ACCEPT_TOKEN(anon_sym_qword);
      END_STATE();
    case 1018:
      ACCEPT_TOKEN(anon_sym_xmmword);
      END_STATE();
    case 1019:
      ACCEPT_TOKEN(anon_sym_BYTE);
      END_STATE();
    case 1020:
      ACCEPT_TOKEN(anon_sym_WORD);
      END_STATE();
    case 1021:
      ACCEPT_TOKEN(anon_sym_DWORD);
      END_STATE();
    case 1022:
      ACCEPT_TOKEN(anon_sym_QWORD);
      END_STATE();
    case 1023:
      ACCEPT_TOKEN(anon_sym_XMMWORD);
      END_STATE();
    case 1024:
      ACCEPT_TOKEN(anon_sym_ptr);
      END_STATE();
    case 1025:
      ACCEPT_TOKEN(anon_sym_PTR);
      END_STATE();
    case 1026:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 1027:
      ACCEPT_TOKEN(sym_register);
      END_STATE();
    case 1028:
      ACCEPT_TOKEN(sym_register);
      if (lookahead == 'a') ADVANCE(2252);
      if (lookahead == 'c' ||
          lookahead == 'd') ADVANCE(1071);
      if (lookahead == 'f') ADVANCE(2538);
      if (lookahead == 'w') ADVANCE(2220);
      if (lookahead == 'z') ADVANCE(2402);
      END_STATE();
    case 1029:
      ACCEPT_TOKEN(sym_register);
      if (lookahead == 'c') ADVANCE(2439);
      if (lookahead == 'e') ADVANCE(2613);
      if (lookahead == 's') ADVANCE(2438);
      END_STATE();
    case 1030:
      ACCEPT_TOKEN(sym_register);
      if (lookahead == 'v') ADVANCE(1152);
      END_STATE();
    case 1031:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 1032:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 1033:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 1034:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 1035:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 1036:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 1037:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 1038:
      ACCEPT_TOKEN(anon_sym_cs);
      END_STATE();
    case 1039:
      ACCEPT_TOKEN(anon_sym_ds);
      END_STATE();
    case 1040:
      ACCEPT_TOKEN(anon_sym_es);
      if (lookahead == 'i' ||
          lookahead == 'p') ADVANCE(1027);
      END_STATE();
    case 1041:
      ACCEPT_TOKEN(anon_sym_fs);
      END_STATE();
    case 1042:
      ACCEPT_TOKEN(anon_sym_fs);
      if (lookahead == 'a') ADVANCE(2886);
      if (lookahead == 'c') ADVANCE(2201);
      if (lookahead == 'i') ADVANCE(2597);
      if (lookahead == 'q') ADVANCE(2715);
      if (lookahead == 't') ADVANCE(1108);
      if (lookahead == 'u') ADVANCE(2222);
      END_STATE();
    case 1043:
      ACCEPT_TOKEN(anon_sym_gs);
      END_STATE();
    case 1044:
      ACCEPT_TOKEN(anon_sym_ss);
      END_STATE();
    case 1045:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 1046:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1045);
      END_STATE();
    case 1047:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1046);
      END_STATE();
    case 1048:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 1049:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(1049);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(1050);
      END_STATE();
    case 1050:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(1050);
      END_STATE();
    case 1051:
      ACCEPT_TOKEN(aux_sym__decimal_literal_token1);
      if (lookahead == 'h') ADVANCE(1058);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1053);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(408);
      END_STATE();
    case 1052:
      ACCEPT_TOKEN(aux_sym__decimal_literal_token1);
      if (lookahead == 'h') ADVANCE(1058);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(408);
      END_STATE();
    case 1053:
      ACCEPT_TOKEN(aux_sym__decimal_literal_token2);
      if (lookahead == 'h') ADVANCE(1058);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1053);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(408);
      END_STATE();
    case 1054:
      ACCEPT_TOKEN(aux_sym__decimal_literal_token3);
      if (lookahead == '_') ADVANCE(841);
      if (lookahead == 'b') ADVANCE(1066);
      if (lookahead == 'd') ADVANCE(1051);
      if (lookahead == 'h') ADVANCE(1059);
      if (lookahead == 'x') ADVANCE(884);
      if (lookahead == 'y') ADVANCE(1068);
      if (lookahead == 'o' ||
          lookahead == 'q') ADVANCE(1063);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(1055);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(1057);
      if (('2' <= lookahead && lookahead <= '7')) ADVANCE(1056);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(408);
      END_STATE();
    case 1055:
      ACCEPT_TOKEN(aux_sym__decimal_literal_token3);
      if (lookahead == '_') ADVANCE(841);
      if (lookahead == 'b') ADVANCE(1067);
      if (lookahead == 'd') ADVANCE(1052);
      if (lookahead == 'h') ADVANCE(1058);
      if (lookahead == 'y') ADVANCE(1065);
      if (lookahead == 'o' ||
          lookahead == 'q') ADVANCE(1062);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(1055);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(1057);
      if (('2' <= lookahead && lookahead <= '7')) ADVANCE(1056);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(408);
      END_STATE();
    case 1056:
      ACCEPT_TOKEN(aux_sym__decimal_literal_token3);
      if (lookahead == 'd') ADVANCE(1052);
      if (lookahead == 'h') ADVANCE(1058);
      if (lookahead == 'o' ||
          lookahead == 'q') ADVANCE(1062);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(1057);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(1056);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(408);
      END_STATE();
    case 1057:
      ACCEPT_TOKEN(aux_sym__decimal_literal_token3);
      if (lookahead == 'd') ADVANCE(1052);
      if (lookahead == 'h') ADVANCE(1058);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1057);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(408);
      END_STATE();
    case 1058:
      ACCEPT_TOKEN(aux_sym__hex_literal_token1);
      END_STATE();
    case 1059:
      ACCEPT_TOKEN(aux_sym__hex_literal_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(1061);
      END_STATE();
    case 1060:
      ACCEPT_TOKEN(aux_sym__hex_literal_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(1060);
      END_STATE();
    case 1061:
      ACCEPT_TOKEN(aux_sym__hex_literal_token3);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(1061);
      END_STATE();
    case 1062:
      ACCEPT_TOKEN(aux_sym__octal_literal_token1);
      END_STATE();
    case 1063:
      ACCEPT_TOKEN(aux_sym__octal_literal_token1);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(1064);
      END_STATE();
    case 1064:
      ACCEPT_TOKEN(aux_sym__octal_literal_token2);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(1064);
      END_STATE();
    case 1065:
      ACCEPT_TOKEN(aux_sym__binary_literal_token1);
      END_STATE();
    case 1066:
      ACCEPT_TOKEN(aux_sym__binary_literal_token1);
      if (lookahead == '_') ADVANCE(1070);
      if (lookahead == 'h') ADVANCE(1058);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(1069);
      if (('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(408);
      END_STATE();
    case 1067:
      ACCEPT_TOKEN(aux_sym__binary_literal_token1);
      if (lookahead == 'h') ADVANCE(1058);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(408);
      END_STATE();
    case 1068:
      ACCEPT_TOKEN(aux_sym__binary_literal_token1);
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(1070);
      END_STATE();
    case 1069:
      ACCEPT_TOKEN(aux_sym__binary_literal_token2);
      if (lookahead == '_') ADVANCE(1070);
      if (lookahead == 'h') ADVANCE(1058);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(1069);
      if (('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(408);
      END_STATE();
    case 1070:
      ACCEPT_TOKEN(aux_sym__binary_literal_token2);
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(1070);
      END_STATE();
    case 1071:
      ACCEPT_TOKEN(sym_mnemonic);
      END_STATE();
    case 1072:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == '1') ADVANCE(1071);
      END_STATE();
    case 1073:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == '1') ADVANCE(2119);
      if (lookahead == '8') ADVANCE(2220);
      END_STATE();
    case 1074:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == '1') ADVANCE(1265);
      if (lookahead == '8') ADVANCE(1345);
      END_STATE();
    case 1075:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == '1') ADVANCE(83);
      if (lookahead == '8') ADVANCE(167);
      END_STATE();
    case 1076:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == '1') ADVANCE(2118);
      if (lookahead == '3') ADVANCE(2070);
      if (lookahead == '6') ADVANCE(2112);
      if (lookahead == '8') ADVANCE(1071);
      END_STATE();
    case 1077:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == '1') ADVANCE(1264);
      if (lookahead == '3') ADVANCE(1213);
      if (lookahead == '6') ADVANCE(1258);
      if (lookahead == '8') ADVANCE(1071);
      END_STATE();
    case 1078:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == '1') ADVANCE(82);
      if (lookahead == '3') ADVANCE(30);
      if (lookahead == '6') ADVANCE(76);
      if (lookahead == '8') ADVANCE(1071);
      END_STATE();
    case 1079:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == '2') ADVANCE(1474);
      END_STATE();
    case 1080:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == '2') ADVANCE(286);
      END_STATE();
    case 1081:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == '2') ADVANCE(2352);
      END_STATE();
    case 1082:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == '3') ADVANCE(2070);
      if (lookahead == '6') ADVANCE(2112);
      END_STATE();
    case 1083:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == '3') ADVANCE(1213);
      if (lookahead == '6') ADVANCE(1258);
      END_STATE();
    case 1084:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == '3') ADVANCE(30);
      if (lookahead == '6') ADVANCE(76);
      END_STATE();
    case 1085:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == '6') ADVANCE(2112);
      END_STATE();
    case 1086:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == '6') ADVANCE(2112);
      if (lookahead == 'c') ADVANCE(1085);
      if (lookahead == 'o') ADVANCE(2684);
      if (lookahead == 's') ADVANCE(1085);
      END_STATE();
    case 1087:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == '6') ADVANCE(2112);
      if (lookahead == 's') ADVANCE(1085);
      END_STATE();
    case 1088:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == '6') ADVANCE(1258);
      END_STATE();
    case 1089:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == '6') ADVANCE(1258);
      if (lookahead == 'c') ADVANCE(1088);
      if (lookahead == 'o') ADVANCE(1784);
      if (lookahead == 's') ADVANCE(1088);
      END_STATE();
    case 1090:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == '6') ADVANCE(1258);
      if (lookahead == 's') ADVANCE(1088);
      END_STATE();
    case 1091:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == '6') ADVANCE(76);
      END_STATE();
    case 1092:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == '6') ADVANCE(76);
      if (lookahead == 'c') ADVANCE(1091);
      if (lookahead == 'o') ADVANCE(618);
      if (lookahead == 's') ADVANCE(1091);
      END_STATE();
    case 1093:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == '6') ADVANCE(76);
      if (lookahead == 's') ADVANCE(1091);
      END_STATE();
    case 1094:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'a') ADVANCE(1071);
      END_STATE();
    case 1095:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'a') ADVANCE(2239);
      if (lookahead == 'b') ADVANCE(2382);
      if (lookahead == 'd') ADVANCE(1116);
      if (lookahead == 'h') ADVANCE(2543);
      if (lookahead == 'l') ADVANCE(2482);
      if (lookahead == 'm') ADVANCE(2771);
      if (lookahead == 'n') ADVANCE(2813);
      if (lookahead == 'q') ADVANCE(1081);
      if (lookahead == 's') ADVANCE(2960);
      if (lookahead == 'u') ADVANCE(2664);
      if (lookahead == 'z') ADVANCE(2894);
      END_STATE();
    case 1096:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'a') ADVANCE(1115);
      if (lookahead == 'c') ADVANCE(2599);
      if (lookahead == 'f') ADVANCE(1189);
      END_STATE();
    case 1097:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'a') ADVANCE(1115);
      if (lookahead == 'c') ADVANCE(1702);
      if (lookahead == 'f') ADVANCE(1189);
      END_STATE();
    case 1098:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'a') ADVANCE(1115);
      if (lookahead == 'c') ADVANCE(531);
      if (lookahead == 'f') ADVANCE(1189);
      END_STATE();
    case 1099:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'a') ADVANCE(1115);
      if (lookahead == 'f') ADVANCE(1189);
      END_STATE();
    case 1100:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'a') ADVANCE(1363);
      if (lookahead == 'b') ADVANCE(1504);
      if (lookahead == 'd') ADVANCE(1118);
      if (lookahead == 'h') ADVANCE(1652);
      if (lookahead == 'l') ADVANCE(1591);
      if (lookahead == 'm') ADVANCE(1867);
      if (lookahead == 'n') ADVANCE(1906);
      if (lookahead == 'q') ADVANCE(1079);
      if (lookahead == 's') ADVANCE(2040);
      if (lookahead == 'u') ADVANCE(1764);
      if (lookahead == 'z') ADVANCE(1985);
      END_STATE();
    case 1101:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'a') ADVANCE(184);
      if (lookahead == 'b') ADVANCE(326);
      if (lookahead == 'd') ADVANCE(1120);
      if (lookahead == 'h') ADVANCE(480);
      if (lookahead == 'l') ADVANCE(420);
      if (lookahead == 'm') ADVANCE(697);
      if (lookahead == 'n') ADVANCE(737);
      if (lookahead == 'q') ADVANCE(1080);
      if (lookahead == 's') ADVANCE(882);
      if (lookahead == 'u') ADVANCE(592);
      if (lookahead == 'z') ADVANCE(817);
      END_STATE();
    case 1102:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'c') ADVANCE(1071);
      END_STATE();
    case 1103:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'c') ADVANCE(1071);
      if (lookahead == 's') ADVANCE(2945);
      if (lookahead == 't') ADVANCE(1188);
      END_STATE();
    case 1104:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'c') ADVANCE(1071);
      if (lookahead == 's') ADVANCE(2026);
      if (lookahead == 't') ADVANCE(1188);
      END_STATE();
    case 1105:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'c') ADVANCE(1071);
      if (lookahead == 's') ADVANCE(863);
      if (lookahead == 't') ADVANCE(1188);
      END_STATE();
    case 1106:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'c') ADVANCE(1983);
      if (lookahead == 'e') ADVANCE(1705);
      if (lookahead == 'p') ADVANCE(1071);
      if (lookahead == 's') ADVANCE(1983);
      END_STATE();
    case 1107:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'c') ADVANCE(815);
      if (lookahead == 'e') ADVANCE(532);
      if (lookahead == 'p') ADVANCE(1071);
      if (lookahead == 's') ADVANCE(815);
      END_STATE();
    case 1108:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'c') ADVANCE(2889);
      if (lookahead == 'e') ADVANCE(2600);
      if (lookahead == 'p') ADVANCE(1071);
      if (lookahead == 's') ADVANCE(2889);
      END_STATE();
    case 1109:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'c') ADVANCE(1991);
      END_STATE();
    case 1110:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'c') ADVANCE(823);
      END_STATE();
    case 1111:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'c') ADVANCE(2900);
      END_STATE();
    case 1112:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'c') ADVANCE(1739);
      END_STATE();
    case 1113:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'c') ADVANCE(2634);
      END_STATE();
    case 1114:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'c') ADVANCE(572);
      END_STATE();
    case 1115:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'd') ADVANCE(1071);
      END_STATE();
    case 1116:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'd') ADVANCE(2852);
      if (lookahead == 'q') ADVANCE(2088);
      END_STATE();
    case 1117:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'd') ADVANCE(2852);
      if (lookahead == 'q') ADVANCE(2164);
      END_STATE();
    case 1118:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'd') ADVANCE(1945);
      if (lookahead == 'q') ADVANCE(1238);
      END_STATE();
    case 1119:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'd') ADVANCE(1945);
      if (lookahead == 'q') ADVANCE(1287);
      END_STATE();
    case 1120:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'd') ADVANCE(777);
      if (lookahead == 'q') ADVANCE(56);
      END_STATE();
    case 1121:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'd') ADVANCE(777);
      if (lookahead == 'q') ADVANCE(114);
      END_STATE();
    case 1122:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'e') ADVANCE(1071);
      END_STATE();
    case 1123:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'e') ADVANCE(1071);
      if (lookahead == 'n') ADVANCE(1504);
      END_STATE();
    case 1124:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'e') ADVANCE(1071);
      if (lookahead == 'n') ADVANCE(2382);
      END_STATE();
    case 1125:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'e') ADVANCE(1071);
      if (lookahead == 'n') ADVANCE(326);
      END_STATE();
    case 1126:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'i') ADVANCE(1146);
      if (lookahead == 'p') ADVANCE(1146);
      END_STATE();
    case 1127:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'i') ADVANCE(2818);
      if (lookahead == 'v') ADVANCE(1071);
      END_STATE();
    case 1128:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'i') ADVANCE(1909);
      if (lookahead == 'v') ADVANCE(1071);
      END_STATE();
    case 1129:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'i') ADVANCE(740);
      if (lookahead == 'v') ADVANCE(1071);
      END_STATE();
    case 1130:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'l') ADVANCE(2165);
      END_STATE();
    case 1131:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'l') ADVANCE(1288);
      END_STATE();
    case 1132:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'l') ADVANCE(110);
      END_STATE();
    case 1133:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'm') ADVANCE(2959);
      if (lookahead == 'n') ADVANCE(2560);
      END_STATE();
    case 1134:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'm') ADVANCE(2039);
      if (lookahead == 'n') ADVANCE(1668);
      END_STATE();
    case 1135:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'm') ADVANCE(869);
      if (lookahead == 'n') ADVANCE(497);
      END_STATE();
    case 1136:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'n') ADVANCE(1071);
      END_STATE();
    case 1137:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'n') ADVANCE(1151);
      if (lookahead == 'p') ADVANCE(2927);
      END_STATE();
    case 1138:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'n') ADVANCE(1157);
      if (lookahead == 'p') ADVANCE(2015);
      END_STATE();
    case 1139:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'n') ADVANCE(1163);
      if (lookahead == 'p') ADVANCE(846);
      END_STATE();
    case 1140:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'n') ADVANCE(2839);
      if (lookahead == 't') ADVANCE(2951);
      if (lookahead == 'w') ADVANCE(1177);
      END_STATE();
    case 1141:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'n') ADVANCE(1933);
      if (lookahead == 't') ADVANCE(2047);
      if (lookahead == 'w') ADVANCE(1178);
      END_STATE();
    case 1142:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'n') ADVANCE(766);
      if (lookahead == 't') ADVANCE(868);
      if (lookahead == 'w') ADVANCE(1179);
      END_STATE();
    case 1143:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'o') ADVANCE(1774);
      END_STATE();
    case 1144:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'o') ADVANCE(610);
      END_STATE();
    case 1145:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'o') ADVANCE(2677);
      END_STATE();
    case 1146:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'p') ADVANCE(1071);
      END_STATE();
    case 1147:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'p') ADVANCE(1071);
      if (lookahead == 'r') ADVANCE(1146);
      END_STATE();
    case 1148:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'p') ADVANCE(1071);
      if (lookahead == 't') ADVANCE(2660);
      END_STATE();
    case 1149:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'p') ADVANCE(1071);
      if (lookahead == 't') ADVANCE(1760);
      END_STATE();
    case 1150:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'p') ADVANCE(1071);
      if (lookahead == 't') ADVANCE(591);
      END_STATE();
    case 1151:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'p') ADVANCE(2927);
      END_STATE();
    case 1152:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'p') ADVANCE(2927);
      if (lookahead == 's') ADVANCE(2927);
      END_STATE();
    case 1153:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'p') ADVANCE(2927);
      if (lookahead == 's') ADVANCE(2927);
      if (lookahead == 'x') ADVANCE(1071);
      END_STATE();
    case 1154:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'p') ADVANCE(2927);
      if (lookahead == 's') ADVANCE(2925);
      END_STATE();
    case 1155:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'p') ADVANCE(2927);
      if (lookahead == 's') ADVANCE(2961);
      if (lookahead == 'x') ADVANCE(2264);
      END_STATE();
    case 1156:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'p') ADVANCE(2051);
      END_STATE();
    case 1157:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'p') ADVANCE(2015);
      END_STATE();
    case 1158:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'p') ADVANCE(2015);
      if (lookahead == 's') ADVANCE(2015);
      END_STATE();
    case 1159:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'p') ADVANCE(2015);
      if (lookahead == 's') ADVANCE(2015);
      if (lookahead == 'x') ADVANCE(1071);
      END_STATE();
    case 1160:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'p') ADVANCE(2015);
      if (lookahead == 's') ADVANCE(2013);
      END_STATE();
    case 1161:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'p') ADVANCE(2015);
      if (lookahead == 's') ADVANCE(2041);
      if (lookahead == 'x') ADVANCE(1392);
      END_STATE();
    case 1162:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'p') ADVANCE(1198);
      END_STATE();
    case 1163:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'p') ADVANCE(846);
      END_STATE();
    case 1164:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'p') ADVANCE(846);
      if (lookahead == 's') ADVANCE(846);
      END_STATE();
    case 1165:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'p') ADVANCE(846);
      if (lookahead == 's') ADVANCE(846);
      if (lookahead == 'x') ADVANCE(1071);
      END_STATE();
    case 1166:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'p') ADVANCE(846);
      if (lookahead == 's') ADVANCE(848);
      END_STATE();
    case 1167:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'p') ADVANCE(846);
      if (lookahead == 's') ADVANCE(881);
      if (lookahead == 'x') ADVANCE(211);
      END_STATE();
    case 1168:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'p') ADVANCE(15);
      END_STATE();
    case 1169:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'q') ADVANCE(1071);
      END_STATE();
    case 1170:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'r') ADVANCE(1071);
      END_STATE();
    case 1171:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'r') ADVANCE(2959);
      END_STATE();
    case 1172:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'r') ADVANCE(2039);
      END_STATE();
    case 1173:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'r') ADVANCE(869);
      END_STATE();
    case 1174:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 's') ADVANCE(2947);
      END_STATE();
    case 1175:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 's') ADVANCE(2028);
      END_STATE();
    case 1176:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 's') ADVANCE(862);
      END_STATE();
    case 1177:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 't') ADVANCE(2051);
      END_STATE();
    case 1178:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 't') ADVANCE(1198);
      END_STATE();
    case 1179:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 't') ADVANCE(15);
      END_STATE();
    case 1180:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'v') ADVANCE(1071);
      END_STATE();
    case 1181:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'v') ADVANCE(1504);
      END_STATE();
    case 1182:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'v') ADVANCE(2382);
      END_STATE();
    case 1183:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'v') ADVANCE(326);
      END_STATE();
    case 1184:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'x') ADVANCE(1071);
      END_STATE();
    case 1185:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == '1' ||
          lookahead == 'z') ADVANCE(1071);
      if (lookahead == 'c') ADVANCE(1983);
      if (lookahead == 'e') ADVANCE(1705);
      if (lookahead == 'l') ADVANCE(1219);
      if (lookahead == 'p') ADVANCE(1595);
      END_STATE();
    case 1186:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == '1' ||
          lookahead == 'z') ADVANCE(1071);
      if (lookahead == 'c') ADVANCE(815);
      if (lookahead == 'e') ADVANCE(532);
      if (lookahead == 'l') ADVANCE(36);
      if (lookahead == 'p') ADVANCE(424);
      END_STATE();
    case 1187:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == '1' ||
          lookahead == 'z') ADVANCE(1071);
      if (lookahead == 'c') ADVANCE(2889);
      if (lookahead == 'e') ADVANCE(2600);
      if (lookahead == 'l') ADVANCE(2073);
      if (lookahead == 'p') ADVANCE(2486);
      END_STATE();
    case 1188:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == '3' ||
          lookahead == 'o') ADVANCE(1071);
      END_STATE();
    case 1189:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'd' ||
          lookahead == 'q') ADVANCE(1071);
      END_STATE();
    case 1190:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'd' ||
          lookahead == 'q') ADVANCE(1071);
      if (lookahead == 'n') ADVANCE(1189);
      END_STATE();
    case 1191:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'd' ||
          lookahead == 'x') ADVANCE(1071);
      END_STATE();
    case 1192:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'e' ||
          lookahead == 'o') ADVANCE(1071);
      END_STATE();
    case 1193:
      ACCEPT_TOKEN(sym_mnemonic);
      if (lookahead == 'c' ||
          lookahead == 'r' ||
          lookahead == 's') ADVANCE(1071);
      END_STATE();
    case 1194:
      ACCEPT_TOKEN(sym_section_name);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1194);
      END_STATE();
    case 1195:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == ' ') ADVANCE(564);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1196:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == ' ') ADVANCE(564);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 1197:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '0') ADVANCE(1425);
      if (lookahead == '1') ADVANCE(1425);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1198:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '1') ADVANCE(1071);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1199:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '1') ADVANCE(1764);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1200:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '1') ADVANCE(1761);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1201:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '1') ADVANCE(1685);
      if (lookahead == '2') ADVANCE(1262);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1202:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '1') ADVANCE(1259);
      if (lookahead == '2') ADVANCE(1268);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(1832);
      if (lookahead == 's') ADVANCE(1832);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1203:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '1') ADVANCE(1256);
      if (lookahead == '2') ADVANCE(1206);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1499);
      if (lookahead == 'p') ADVANCE(2015);
      if (lookahead == 's') ADVANCE(2015);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1204:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '1') ADVANCE(1256);
      if (lookahead == '2') ADVANCE(1206);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(2015);
      if (lookahead == 's') ADVANCE(2015);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1205:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '1') ADVANCE(1256);
      if (lookahead == '2') ADVANCE(1206);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(2015);
      if (lookahead == 's') ADVANCE(2014);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1206:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '1') ADVANCE(1254);
      if (lookahead == '3') ADVANCE(1200);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1207:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '1') ADVANCE(1251);
      if (lookahead == '3') ADVANCE(1199);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1208:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '1') ADVANCE(1228);
      if (lookahead == '3') ADVANCE(1244);
      if (lookahead == '6') ADVANCE(1261);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1209:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '1') ADVANCE(1228);
      if (lookahead == '3') ADVANCE(1246);
      if (lookahead == '6') ADVANCE(1261);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1210:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '1') ADVANCE(1228);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1211:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '1') ADVANCE(1681);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1859);
      if (lookahead == 'z') ADVANCE(1394);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(2042);
      END_STATE();
    case 1212:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '1') ADVANCE(1255);
      if (lookahead == '2') ADVANCE(1207);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(2015);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1213:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1071);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1214:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1764);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1711);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1215:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1764);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(2015);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1216:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1764);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1217:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1761);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1218:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(2039);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1622);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1219:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(2019);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'g') ADVANCE(1213);
      if (lookahead == 'n') ADVANCE(1213);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1220:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1467);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1221:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(2011);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1222:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1555);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'i') ADVANCE(1223);
      if (lookahead == 'p') ADVANCE(2015);
      if (lookahead == 't') ADVANCE(1224);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1223:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(2035);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(1215);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1224:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(2035);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1225:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1471);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1226:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1472);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1227:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1549);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1865);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1228:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1267);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1229:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1468);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1230:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1469);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1231:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1590);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1232:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1662);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1233:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1662);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b' ||
          lookahead == 'w') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1234:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1662);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'w') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1235:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1662);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1236:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1851);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1237:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1470);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1238:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1791);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a' ||
          lookahead == 'u') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1239:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1853);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1240:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1860);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1241:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1994);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1242:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1596);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1386);
      if (lookahead == 'c') ADVANCE(1680);
      if (lookahead == 'm') ADVANCE(1294);
      if (lookahead == 'n') ADVANCE(1306);
      if (lookahead == 'p') ADVANCE(1713);
      if (lookahead == 'r') ADVANCE(1399);
      if (lookahead == 's') ADVANCE(1953);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1243:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1992);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1244:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1988);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1245:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1777);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1246:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1990);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1247:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1837);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1248:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1852);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1249:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1854);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1250:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2') ADVANCE(1861);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1251:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '3') ADVANCE(1764);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1252:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '3') ADVANCE(1213);
      if (lookahead == '6') ADVANCE(1258);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1253:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '3') ADVANCE(1213);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1254:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '3') ADVANCE(1761);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1255:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '3') ADVANCE(1216);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1256:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '3') ADVANCE(1217);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1257:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '3') ADVANCE(1243);
      if (lookahead == '6') ADVANCE(1260);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1258:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '4') ADVANCE(1071);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1259:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '4') ADVANCE(1761);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1260:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '4') ADVANCE(1986);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1261:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '4') ADVANCE(1989);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1262:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '5') ADVANCE(1266);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1263:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '5') ADVANCE(1231);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'u') ADVANCE(1372);
      if (lookahead == 'w') ADVANCE(1419);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1264:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '6') ADVANCE(1071);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1265:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '6') ADVANCE(1345);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1266:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '6') ADVANCE(1686);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1267:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '8') ADVANCE(1071);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1268:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '8') ADVANCE(1761);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1269:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1122);
      if (lookahead == 'b') ADVANCE(1122);
      if (lookahead == 'c' ||
          lookahead == 'o' ||
          lookahead == 's' ||
          lookahead == 'z') ADVANCE(1071);
      if (lookahead == 'e') ADVANCE(1109);
      if (lookahead == 'g') ADVANCE(1122);
      if (lookahead == 'l') ADVANCE(1122);
      if (lookahead == 'm') ADVANCE(1760);
      if (lookahead == 'n') ADVANCE(1271);
      if (lookahead == 'p') ADVANCE(1192);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'y')) ADVANCE(2042);
      END_STATE();
    case 1270:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1122);
      if (lookahead == 'b') ADVANCE(1122);
      if (lookahead == 'c' ||
          lookahead == 'e' ||
          lookahead == 'o' ||
          lookahead == 's' ||
          lookahead == 'z') ADVANCE(1071);
      if (lookahead == 'g') ADVANCE(1122);
      if (lookahead == 'l') ADVANCE(1122);
      if (lookahead == 'n') ADVANCE(1271);
      if (lookahead == 'p') ADVANCE(1192);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'y')) ADVANCE(2042);
      END_STATE();
    case 1271:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1122);
      if (lookahead == 'b') ADVANCE(1122);
      if (lookahead == 'c' ||
          lookahead == 'e' ||
          lookahead == 'o' ||
          lookahead == 'p' ||
          lookahead == 's' ||
          lookahead == 'z') ADVANCE(1071);
      if (lookahead == 'g') ADVANCE(1122);
      if (lookahead == 'l') ADVANCE(1122);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'y')) ADVANCE(2042);
      END_STATE();
    case 1272:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1273:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1764);
      if (lookahead == 'd') ADVANCE(1119);
      if (lookahead == 'h') ADVANCE(1652);
      if (lookahead == 'l') ADVANCE(1591);
      if (lookahead == 'm') ADVANCE(1867);
      if (lookahead == 'n') ADVANCE(1923);
      if (lookahead == 'q') ADVANCE(1071);
      if (lookahead == 's') ADVANCE(2012);
      if (lookahead == 'u') ADVANCE(1764);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1274:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1483);
      if (lookahead == 'm') ADVANCE(1743);
      if (lookahead == 'n') ADVANCE(1746);
      if (lookahead == 'o') ADVANCE(1805);
      if (lookahead == 's') ADVANCE(1588);
      if (lookahead == 't') ADVANCE(1539);
      if (lookahead == 'u') ADVANCE(1731);
      if (lookahead == 'x') ADVANCE(1727);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1275:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1838);
      if (lookahead == 'f') ADVANCE(1519);
      if (lookahead == 'i') ADVANCE(1695);
      if (lookahead == 'o') ADVANCE(1976);
      if (lookahead == 'p') ADVANCE(1870);
      if (lookahead == 'u') ADVANCE(1645);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1276:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1365);
      if (lookahead == 'b') ADVANCE(1658);
      if (lookahead == 'c') ADVANCE(1648);
      if (lookahead == 'd') ADVANCE(1513);
      if (lookahead == 'e') ADVANCE(1998);
      if (lookahead == 'f') ADVANCE(1242);
      if (lookahead == 'h') ADVANCE(1330);
      if (lookahead == 'i') ADVANCE(1227);
      if (lookahead == 'm') ADVANCE(1279);
      if (lookahead == 'o') ADVANCE(1771);
      if (lookahead == 'r') ADVANCE(1515);
      if (lookahead == 's') ADVANCE(1313);
      if (lookahead == 't') ADVANCE(1512);
      if (lookahead == 'u') ADVANCE(1732);
      if (lookahead == 'x') ADVANCE(1744);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1277:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1582);
      if (lookahead == 'b') ADVANCE(1345);
      if (lookahead == 'c') ADVANCE(1298);
      if (lookahead == 'e') ADVANCE(1398);
      if (lookahead == 'f') ADVANCE(1519);
      if (lookahead == 'h') ADVANCE(1280);
      if (lookahead == 'q') ADVANCE(1819);
      if (lookahead == 't') ADVANCE(1297);
      if (lookahead == 'u') ADVANCE(1362);
      if (lookahead == 'w') ADVANCE(1303);
      if (lookahead == 'y') ADVANCE(1840);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1278:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1489);
      if (lookahead == 'b') ADVANCE(1660);
      if (lookahead == 'c') ADVANCE(1679);
      if (lookahead == 'd') ADVANCE(1367);
      if (lookahead == 'e') ADVANCE(1987);
      if (lookahead == 'f') ADVANCE(1601);
      if (lookahead == 'g') ADVANCE(1316);
      if (lookahead == 'h') ADVANCE(1300);
      if (lookahead == 'i') ADVANCE(1728);
      if (lookahead == 'l') ADVANCE(1428);
      if (lookahead == 'm') ADVANCE(1342);
      if (lookahead == 'o') ADVANCE(1804);
      if (lookahead == 'p') ADVANCE(1281);
      if (lookahead == 'r') ADVANCE(1307);
      if (lookahead == 's') ADVANCE(1401);
      if (lookahead == 't') ADVANCE(1542);
      if (lookahead == 'u') ADVANCE(1390);
      if (lookahead == 'x') ADVANCE(1738);
      if (lookahead == 'z') ADVANCE(1520);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('j' <= lookahead && lookahead <= 'y')) ADVANCE(2042);
      END_STATE();
    case 1279:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1494);
      if (lookahead == 'i') ADVANCE(1701);
      if (lookahead == 'o') ADVANCE(1970);
      if (lookahead == 'u') ADVANCE(1635);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1280:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1201);
      if (lookahead == 'l') ADVANCE(1191);
      if (lookahead == 'r') ADVANCE(1191);
      if (lookahead == 'u') ADVANCE(1547);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1281:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1364);
      if (lookahead == 'b') ADVANCE(1661);
      if (lookahead == 'c') ADVANCE(1647);
      if (lookahead == 'e') ADVANCE(1820);
      if (lookahead == 'g') ADVANCE(1340);
      if (lookahead == 'h') ADVANCE(1335);
      if (lookahead == 'i') ADVANCE(1709);
      if (lookahead == 'l') ADVANCE(2004);
      if (lookahead == 'm') ADVANCE(1284);
      if (lookahead == 'o') ADVANCE(1802);
      if (lookahead == 'p') ADVANCE(1527);
      if (lookahead == 'r') ADVANCE(1736);
      if (lookahead == 's') ADVANCE(1312);
      if (lookahead == 't') ADVANCE(1507);
      if (lookahead == 'u') ADVANCE(1733);
      if (lookahead == 'x') ADVANCE(1745);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1282:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(2039);
      if (lookahead == 'l') ADVANCE(2039);
      if (lookahead == 'u') ADVANCE(1552);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1283:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(2018);
      if (lookahead == 'l') ADVANCE(1422);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1284:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1406);
      if (lookahead == 'i') ADVANCE(1703);
      if (lookahead == 'o') ADVANCE(1973);
      if (lookahead == 'u') ADVANCE(1637);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1285:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1657);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1286:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(2029);
      if (lookahead == 'l') ADVANCE(1421);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1287:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1083);
      if (lookahead == 'u') ADVANCE(1077);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1288:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1859);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1289:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1583);
      if (lookahead == 'd') ADVANCE(1450);
      if (lookahead == 'e') ADVANCE(1293);
      if (lookahead == 'f') ADVANCE(1519);
      if (lookahead == 'o') ADVANCE(1464);
      if (lookahead == 'z') ADVANCE(1395);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'y')) ADVANCE(2042);
      END_STATE();
    case 1290:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1760);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1291:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1598);
      if (lookahead == 'r') ADVANCE(1558);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1292:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1598);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1293:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1181);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1294:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1985);
      if (lookahead == 'i') ADVANCE(1693);
      if (lookahead == 'u') ADVANCE(1632);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1295:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1662);
      if (lookahead == 'c') ADVANCE(1578);
      if (lookahead == 'r') ADVANCE(1894);
      if (lookahead == 's') ADVANCE(1331);
      if (lookahead == 't') ADVANCE(1829);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1296:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1376);
      if (lookahead == 'c' ||
          lookahead == 'd') ADVANCE(1071);
      if (lookahead == 'f') ADVANCE(1649);
      if (lookahead == 'w') ADVANCE(1345);
      if (lookahead == 'z') ADVANCE(1522);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'y')) ADVANCE(2042);
      END_STATE();
    case 1297:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1376);
      if (lookahead == 'c' ||
          lookahead == 'd' ||
          lookahead == 'i') ADVANCE(1071);
      if (lookahead == 'm') ADVANCE(1997);
      if (lookahead == 'o') ADVANCE(1844);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1298:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1844);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1299:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1481);
      if (lookahead == 'l') ADVANCE(1896);
      if (lookahead == 's') ADVANCE(1949);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1300:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1481);
      if (lookahead == 's') ADVANCE(1949);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1301:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1980);
      if (lookahead == 'c') ADVANCE(1308);
      if (lookahead == 'i') ADVANCE(1704);
      if (lookahead == 'q') ADVANCE(1813);
      if (lookahead == 't') ADVANCE(1106);
      if (lookahead == 'u') ADVANCE(1346);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1302:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1980);
      if (lookahead == 't') ADVANCE(1381);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1303:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1778);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1304:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1876);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1305:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1926);
      if (lookahead == 'r') ADVANCE(1525);
      if (lookahead == 't') ADVANCE(1310);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1306:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1387);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1307:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1706);
      if (lookahead == 'c') ADVANCE(1768);
      if (lookahead == 'e') ADVANCE(1482);
      if (lookahead == 'n') ADVANCE(1501);
      if (lookahead == 'o') ADVANCE(1962);
      if (lookahead == 's') ADVANCE(1800);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1308:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1653);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1309:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1780);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1310:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1693);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1311:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1893);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1312:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1487);
      if (lookahead == 'c') ADVANCE(1323);
      if (lookahead == 'h') ADVANCE(1282);
      if (lookahead == 'i') ADVANCE(1573);
      if (lookahead == 'l') ADVANCE(1639);
      if (lookahead == 'r') ADVANCE(1286);
      if (lookahead == 'u') ADVANCE(1353);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1313:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1487);
      if (lookahead == 'h') ADVANCE(1950);
      if (lookahead == 'i') ADVANCE(1573);
      if (lookahead == 'l') ADVANCE(1636);
      if (lookahead == 'r') ADVANCE(1283);
      if (lookahead == 'u') ADVANCE(1353);
      if (lookahead == 'w') ADVANCE(1309);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1314:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1487);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1315:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1408);
      if (lookahead == 'q') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1316:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1925);
      if (lookahead == 'e') ADVANCE(1904);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1317:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1384);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1318:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1646);
      if (lookahead == 'u') ADVANCE(1783);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1319:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1646);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1320:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1640);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1321:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1714);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1322:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1882);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1323:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1942);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1324:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1492);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1325:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1478);
      if (lookahead == 'c') ADVANCE(1581);
      if (lookahead == 'g') ADVANCE(1530);
      if (lookahead == 'o') ADVANCE(1815);
      if (lookahead == 'r') ADVANCE(1890);
      if (lookahead == 's') ADVANCE(1327);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1326:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1478);
      if (lookahead == 'c') ADVANCE(1749);
      if (lookahead == 'd') ADVANCE(1604);
      if (lookahead == 'l') ADVANCE(1419);
      if (lookahead == 'm') ADVANCE(1946);
      if (lookahead == 'n') ADVANCE(1414);
      if (lookahead == 's') ADVANCE(1914);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1327:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1981);
      if (lookahead == 'e') ADVANCE(1932);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1328:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1656);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1329:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1409);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1330:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1493);
      if (lookahead == 'm') ADVANCE(1613);
      if (lookahead == 's') ADVANCE(1954);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1331:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1982);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1332:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1707);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1333:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1495);
      if (lookahead == 's') ADVANCE(1955);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1334:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1886);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1335:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1496);
      if (lookahead == 'm') ADVANCE(1613);
      if (lookahead == 's') ADVANCE(1957);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1336:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1498);
      if (lookahead == 's') ADVANCE(1960);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1337:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1885);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1338:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1887);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1339:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1724);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1340:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1941);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1341:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1503);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1342:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'a') ADVANCE(1895);
      if (lookahead == 'i') ADVANCE(1695);
      if (lookahead == 'o') ADVANCE(1971);
      if (lookahead == 'p') ADVANCE(1870);
      if (lookahead == 'u') ADVANCE(1633);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1343:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(1122);
      if (lookahead == 'e' ||
          lookahead == 'u') ADVANCE(1071);
      if (lookahead == 'n') ADVANCE(1344);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1344:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(1122);
      if (lookahead == 'e' ||
          lookahead == 'u') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1345:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1346:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(1147);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1347:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(1764);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1348:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(1761);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1349:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(1983);
      if (lookahead == 'd') ADVANCE(1169);
      if (lookahead == 's') ADVANCE(1983);
      if (lookahead == 'w') ADVANCE(1115);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1350:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(1983);
      if (lookahead == 'd') ADVANCE(1791);
      if (lookahead == 'q') ADVANCE(1474);
      if (lookahead == 'w') ADVANCE(1419);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1351:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(1983);
      if (lookahead == 'd') ADVANCE(1791);
      if (lookahead == 'w') ADVANCE(1419);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1352:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(1983);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1353:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(2037);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1354:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(2016);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1355:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(1203);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1356:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(1349);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1357:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(2030);
      if (lookahead == 'd') ADVANCE(1169);
      if (lookahead == 's') ADVANCE(1983);
      if (lookahead == 'u') ADVANCE(1358);
      if (lookahead == 'w') ADVANCE(1189);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1358:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(2030);
      if (lookahead == 'd') ADVANCE(1791);
      if (lookahead == 'w') ADVANCE(2011);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1359:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(1212);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1360:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(1170);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1361:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(1204);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1362:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(1158);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1363:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(1832);
      if (lookahead == 'p') ADVANCE(2015);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1364:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(1844);
      if (lookahead == 'c') ADVANCE(1623);
      if (lookahead == 'd') ADVANCE(1434);
      if (lookahead == 'l') ADVANCE(1614);
      if (lookahead == 'n') ADVANCE(1423);
      if (lookahead == 'v') ADVANCE(1568);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1365:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(1846);
      if (lookahead == 'c') ADVANCE(1623);
      if (lookahead == 'd') ADVANCE(1434);
      if (lookahead == 'l') ADVANCE(1614);
      if (lookahead == 'n') ADVANCE(1420);
      if (lookahead == 'u') ADVANCE(1876);
      if (lookahead == 'v') ADVANCE(1567);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1366:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(1964);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1367:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(1785);
      if (lookahead == 'i') ADVANCE(1967);
      if (lookahead == 'p') ADVANCE(1764);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1368:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(1807);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1369:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(1235);
      if (lookahead == 'd') ADVANCE(1233);
      if (lookahead == 'm') ADVANCE(1218);
      if (lookahead == 'q') ADVANCE(1234);
      if (lookahead == 's') ADVANCE(1437);
      if (lookahead == 'u') ADVANCE(1855);
      if (lookahead == 'w') ADVANCE(1232);
      if (lookahead == 'z') ADVANCE(1993);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(2042);
      END_STATE();
    case 1370:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(1644);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1371:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(1221);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1372:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(1842);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1373:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(1320);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1374:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b') ADVANCE(1304);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1375:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1071);
      if (lookahead == 'o') ADVANCE(1968);
      if (lookahead == 'p') ADVANCE(1161);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1376:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1377:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(2024);
      if (lookahead == 'd') ADVANCE(1557);
      if (lookahead == 'e') ADVANCE(1896);
      if (lookahead == 'o') ADVANCE(1631);
      if (lookahead == 's') ADVANCE(1799);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1378:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1560);
      if (lookahead == 'e') ADVANCE(1717);
      if (lookahead == 's') ADVANCE(1559);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1379:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1253);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1380:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(2031);
      if (lookahead == 'l') ADVANCE(1456);
      if (lookahead == 'm') ADVANCE(1619);
      if (lookahead == 's') ADVANCE(1922);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1381:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1983);
      if (lookahead == 'e') ADVANCE(1705);
      if (lookahead == 's') ADVANCE(1983);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1382:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1146);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1383:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1131);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1384:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1896);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1385:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(2003);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1386:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1376);
      if (lookahead == 'd') ADVANCE(1419);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1387:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1376);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1388:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1624);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1389:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1735);
      if (lookahead == 'd') ADVANCE(1213);
      if (lookahead == 'n') ADVANCE(1779);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1390:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1735);
      if (lookahead == 'n') ADVANCE(1779);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1391:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1625);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1392:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1589);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1393:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1650);
      if (lookahead == 'i') ADVANCE(1700);
      if (lookahead == 'o') ADVANCE(1760);
      if (lookahead == 's') ADVANCE(1302);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1394:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1702);
      if (lookahead == 'm') ADVANCE(1863);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1395:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1702);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1396:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1626);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1397:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1586);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1398:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1929);
      if (lookahead == 't') ADVANCE(1270);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1399:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1773);
      if (lookahead == 's') ADVANCE(1795);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1400:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1659);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1401:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1285);
      if (lookahead == 'h') ADVANCE(1952);
      if (lookahead == 'q') ADVANCE(1819);
      if (lookahead == 't') ADVANCE(1678);
      if (lookahead == 'u') ADVANCE(1348);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1402:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1504);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1403:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1866);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1404:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1506);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1405:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1725);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1406:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1850);
      if (lookahead == 'd') ADVANCE(1407);
      if (lookahead == 's') ADVANCE(1630);
      if (lookahead == 'x') ADVANCE(1843);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1407:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1858);
      if (lookahead == 'd') ADVANCE(1263);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1408:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1930);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1409:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1920);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1410:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1908);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1411:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1750);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1412:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1337);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1413:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1319);
      if (lookahead == 'e') ADVANCE(1719);
      if (lookahead == 'r') ADVANCE(1536);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1414:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1864);
      if (lookahead == 'i') ADVANCE(1896);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1415:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1328);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1416:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'c') ADVANCE(1338);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1417:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1122);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1418:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1071);
      if (lookahead == 'q') ADVANCE(2021);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1419:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1420:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1136);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1421:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1169);
      if (lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'v') ADVANCE(2030);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1422:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1169);
      if (lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1423:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1190);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1424:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1764);
      if (lookahead == 'p') ADVANCE(1554);
      if (lookahead == 'q') ADVANCE(1764);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1425:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1764);
      if (lookahead == 'q') ADVANCE(1764);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1426:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1764);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1427:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1600);
      if (lookahead == 'm') ADVANCE(1946);
      if (lookahead == 'n') ADVANCE(1104);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1428:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1450);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1429:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1380);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1430:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1761);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1431:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1983);
      if (lookahead == 'w') ADVANCE(1345);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1432:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(2039);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1433:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(2034);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1434:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(2037);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1435:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1694);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1436:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1763);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1437:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(2007);
      if (lookahead == 'q') ADVANCE(2028);
      if (lookahead == 'w') ADVANCE(1345);
      if (lookahead == 'x') ADVANCE(1358);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1438:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(2007);
      if (lookahead == 'q') ADVANCE(2028);
      if (lookahead == 'w') ADVANCE(1345);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1439:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(2016);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1440:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1958);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1441:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1966);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1442:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(2011);
      if (lookahead == 'q') ADVANCE(2011);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1443:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(2011);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1444:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1672);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1445:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1357);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1446:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(2017);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1447:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1212);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1448:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1138);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1449:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1185);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1450:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1797);
      if (lookahead == 'm') ADVANCE(1997);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1451:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1797);
      if (lookahead == 'p') ADVANCE(2015);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1452:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1797);
      if (lookahead == 'q') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1453:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1205);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1454:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1418);
      if (lookahead == 's') ADVANCE(1455);
      if (lookahead == 'w') ADVANCE(2018);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1455:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1418);
      if (lookahead == 'w') ADVANCE(2018);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1456:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1985);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1457:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1796);
      if (lookahead == 'p') ADVANCE(1462);
      if (lookahead == 's') ADVANCE(1477);
      if (lookahead == 't') ADVANCE(1769);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1458:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1796);
      if (lookahead == 'p') ADVANCE(1480);
      if (lookahead == 'q') ADVANCE(1796);
      if (lookahead == 's') ADVANCE(1488);
      if (lookahead == 't') ADVANCE(1787);
      if (lookahead == 'u') ADVANCE(1459);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1459:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1796);
      if (lookahead == 'q') ADVANCE(1796);
      if (lookahead == 's') ADVANCE(1616);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1460:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1368);
      if (lookahead == 't') ADVANCE(1518);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1461:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1204);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1462:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1220);
      if (lookahead == 'i') ADVANCE(1216);
      if (lookahead == 's') ADVANCE(1229);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1463:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1762);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1464:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1844);
      if (lookahead == 'o') ADVANCE(1772);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1465:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1791);
      if (lookahead == 'h') ADVANCE(1808);
      if (lookahead == 'l') ADVANCE(2018);
      if (lookahead == 'u') ADVANCE(1474);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1466:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1791);
      if (lookahead == 'h') ADVANCE(1826);
      if (lookahead == 'l') ADVANCE(2030);
      if (lookahead == 't') ADVANCE(1612);
      if (lookahead == 'u') ADVANCE(1474);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1467:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1791);
      if (lookahead == 'p') ADVANCE(2023);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1468:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1791);
      if (lookahead == 'p') ADVANCE(2009);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1469:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1791);
      if (lookahead == 'p') ADVANCE(2008);
      if (lookahead == 'q') ADVANCE(1791);
      if (lookahead == 'u') ADVANCE(1473);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1470:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1791);
      if (lookahead == 'p') ADVANCE(1595);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1471:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1791);
      if (lookahead == 'p') ADVANCE(1832);
      if (lookahead == 'q') ADVANCE(1791);
      if (lookahead == 'u') ADVANCE(1473);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1472:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1791);
      if (lookahead == 'q') ADVANCE(1791);
      if (lookahead == 'u') ADVANCE(1473);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1473:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1791);
      if (lookahead == 'q') ADVANCE(1791);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1474:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1791);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1475:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1792);
      if (lookahead == 'p') ADVANCE(2015);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1476:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1792);
      if (lookahead == 'i' ||
          lookahead == 'q') ADVANCE(1071);
      if (lookahead == 'p') ADVANCE(2015);
      if (lookahead == 's') ADVANCE(2015);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1477:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1248);
      if (lookahead == 'i') ADVANCE(1247);
      if (lookahead == 's') ADVANCE(1249);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1478:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1419);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1479:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1237);
      if (lookahead == 's') ADVANCE(1237);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1480:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1225);
      if (lookahead == 'h') ADVANCE(1245);
      if (lookahead == 's') ADVANCE(1230);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1481:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1426);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1482:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1963);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1483:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1432);
      if (lookahead == 'n') ADVANCE(1433);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1484:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1945);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1485:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1603);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1486:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1526);
      if (lookahead == 'e') ADVANCE(1715);
      if (lookahead == 'i') ADVANCE(1676);
      if (lookahead == 'k') ADVANCE(1508);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1487:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1352);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1488:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1236);
      if (lookahead == 'i') ADVANCE(1247);
      if (lookahead == 's') ADVANCE(1239);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1489:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1463);
      if (lookahead == 'e') ADVANCE(1836);
      if (lookahead == 'l') ADVANCE(1617);
      if (lookahead == 'n') ADVANCE(1435);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1490:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1226);
      if (lookahead == 's') ADVANCE(1226);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1491:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1240);
      if (lookahead == 's') ADVANCE(1240);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1492:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1412);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1493:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1439);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1494:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1440);
      if (lookahead == 'x') ADVANCE(1845);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1495:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1453);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1496:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1445);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1497:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1857);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1498:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1461);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1499:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1447);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1500:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1835);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1501:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1502:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1250);
      if (lookahead == 's') ADVANCE(1250);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1503:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd') ADVANCE(1416);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1504:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1505:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1566);
      if (lookahead == 'o') ADVANCE(2025);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1506:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1761);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1507:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1823);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1508:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(2001);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1509:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1794);
      if (lookahead == 'g') ADVANCE(1902);
      if (lookahead == 'i') ADVANCE(1889);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1510:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1089);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1511:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1088);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1512:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1859);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1513:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1760);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1514:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1985);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1515:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1564);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1516:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1791);
      if (lookahead == 'g') ADVANCE(2019);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1517:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1419);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1518:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1801);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1519:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1712);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1520:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1818);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1521:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1995);
      if (lookahead == 'm') ADVANCE(1321);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1522:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1803);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1523:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1548);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1524:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1821);
      if (lookahead == 'r') ADVANCE(1315);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1525:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1665);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1526:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1383);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1527:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1816);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1528:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1504);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1529:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1517);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1530:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1932);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1531:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1682);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1532:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1809);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1533:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1817);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1534:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1934);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1535:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1730);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1536:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1915);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1537:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1999);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1538:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1883);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1539:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1869);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1540:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1720);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1541:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1884);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1542:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1881);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1543:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1721);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1544:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1827);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1545:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e') ADVANCE(1723);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1546:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'f') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1547:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'f') ADVANCE(1764);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1548:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'f') ADVANCE(1761);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1549:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'f') ADVANCE(2018);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1550:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'f') ADVANCE(2027);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1551:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'f') ADVANCE(1556);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1552:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'f') ADVANCE(2005);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1553:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'f') ADVANCE(1208);
      if (lookahead == 'i') ADVANCE(1208);
      if (lookahead == 'p') ADVANCE(1832);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1554:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'f') ADVANCE(1197);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1555:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'f') ADVANCE(1210);
      if (lookahead == 'i') ADVANCE(1210);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1556:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'f') ADVANCE(1257);
      if (lookahead == 'i') ADVANCE(1257);
      if (lookahead == 'p') ADVANCE(2015);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1557:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'f') ADVANCE(1875);
      if (lookahead == 'g') ADVANCE(1875);
      if (lookahead == 'r') ADVANCE(1332);
      if (lookahead == 's') ADVANCE(1529);
      if (lookahead == 't') ADVANCE(1874);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1558:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'f') ADVANCE(1875);
      if (lookahead == 'g') ADVANCE(1875);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1559:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'f') ADVANCE(1608);
      if (lookahead == 'i') ADVANCE(1102);
      if (lookahead == 'm') ADVANCE(1863);
      if (lookahead == 'r') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1560:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'f') ADVANCE(1608);
      if (lookahead == 'i') ADVANCE(1102);
      if (lookahead == 'm') ADVANCE(1863);
      if (lookahead == 's') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1561:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'f') ADVANCE(1655);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1562:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'f') ADVANCE(1918);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1563:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'f') ADVANCE(1928);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1564:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'f') ADVANCE(1534);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1565:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'f') ADVANCE(1209);
      if (lookahead == 'i') ADVANCE(1209);
      if (lookahead == 's') ADVANCE(2015);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1566:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'g') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1567:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'g') ADVANCE(2006);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1568:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'g') ADVANCE(2007);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1569:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'g') ADVANCE(2011);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1570:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'g') ADVANCE(2045);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1571:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'g') ADVANCE(1074);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1572:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'g') ADVANCE(1832);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1573:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'g') ADVANCE(1696);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1574:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'g') ADVANCE(1708);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1575:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'g') ADVANCE(1698);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1576:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'g') ADVANCE(1506);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1577:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'g') ADVANCE(1535);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1578:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'h') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1579:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'h') ADVANCE(1099);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1580:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'h') ADVANCE(1764);
      if (lookahead == 'l') ADVANCE(1764);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1581:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'h') ADVANCE(1566);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1582:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'h') ADVANCE(1546);
      if (lookahead == 'l') ADVANCE(1071);
      if (lookahead == 'r') ADVANCE(1184);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1583:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'h') ADVANCE(1546);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1584:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'h') ADVANCE(1350);
      if (lookahead == 'l') ADVANCE(1350);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1585:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'h') ADVANCE(1143);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1586:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'h') ADVANCE(1141);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1587:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'h') ADVANCE(1595);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1588:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'h') ADVANCE(1599);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1589:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'h') ADVANCE(1571);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1590:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'h') ADVANCE(1948);
      if (lookahead == 'l') ADVANCE(1948);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1591:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'h') ADVANCE(1777);
      if (lookahead == 'p') ADVANCE(2015);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1592:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'h') ADVANCE(1615);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1593:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'h') ADVANCE(1532);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1594:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'h') ADVANCE(1533);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1595:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'i') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1596:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'i') ADVANCE(2018);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1597:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'i') ADVANCE(1859);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1598:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'i') ADVANCE(1896);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1599:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'i') ADVANCE(1562);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1600:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'i') ADVANCE(1964);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1601:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'i') ADVANCE(1996);
      if (lookahead == 'm') ADVANCE(1333);
      if (lookahead == 'n') ADVANCE(1692);
      if (lookahead == 'p') ADVANCE(1400);
      if (lookahead == 'r') ADVANCE(1385);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1602:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'i') ADVANCE(1419);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1603:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'i') ADVANCE(1702);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1604:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'i') ADVANCE(1977);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1605:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'i') ADVANCE(1756);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1606:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'i') ADVANCE(1837);
      if (lookahead == 'p') ADVANCE(1828);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1607:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'i') ADVANCE(1837);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1608:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'i') ADVANCE(1646);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1609:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'i') ADVANCE(1683);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1610:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'i') ADVANCE(1915);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1611:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'i') ADVANCE(1901);
      if (lookahead == 'r') ADVANCE(1912);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1612:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'i') ADVANCE(1892);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1613:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'i') ADVANCE(1716);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1614:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'i') ADVANCE(1574);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1615:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'i') ADVANCE(1563);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1616:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'i') ADVANCE(1247);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1617:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'i') ADVANCE(1575);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1618:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'i') ADVANCE(1410);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1619:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'k') ADVANCE(1071);
      if (lookahead == 'o') ADVANCE(1964);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1620:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'k') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1621:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'k') ADVANCE(1764);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1622:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'k') ADVANCE(1345);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1623:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'k') ADVANCE(1880);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1624:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'k') ADVANCE(1580);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1625:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'k') ADVANCE(1351);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1626:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'k') ADVANCE(1584);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1627:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'k') ADVANCE(1376);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1628:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'k') ADVANCE(1689);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1629:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'k') ADVANCE(1690);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1630:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'k') ADVANCE(1691);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1631:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(1071);
      if (lookahead == 'r') ADVANCE(1184);
      if (lookahead == 'u') ADVANCE(1718);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1632:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1633:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(1761);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1634:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(2039);
      if (lookahead == 'r') ADVANCE(2039);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1635:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(1465);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1636:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(1422);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1637:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(1466);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1638:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(2010);
      if (lookahead == 'r') ADVANCE(2010);
      if (lookahead == 't') ADVANCE(2039);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1639:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(1421);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1640:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(920);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1641:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(1146);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1642:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(1740);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1643:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(1241);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1644:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(2000);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1645:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(1159);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1646:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(1632);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1647:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(1688);
      if (lookahead == 'm') ADVANCE(1741);
      if (lookahead == 'o') ADVANCE(1670);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1648:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(1688);
      if (lookahead == 'm') ADVANCE(1766);
      if (lookahead == 'o') ADVANCE(1687);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1649:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(1959);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1650:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(1514);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1651:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(1798);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1652:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(1777);
      if (lookahead == 'p') ADVANCE(2015);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1653:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(1504);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1654:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(1747);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1655:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(1618);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1656:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(1506);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1657:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(1523);
      if (lookahead == 't') ADVANCE(1939);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1658:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(1540);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1659:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(1322);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1660:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(1543);
      if (lookahead == 'r') ADVANCE(1758);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1661:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l') ADVANCE(1545);
      if (lookahead == 'r') ADVANCE(1759);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1662:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1663:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(1126);
      if (lookahead == 's') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1664:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(1126);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1665:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(1072);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1666:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(1761);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1667:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(1198);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1668:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(2039);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1669:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(1606);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1670:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(2036);
      if (lookahead == 'n') ADVANCE(1561);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1671:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(1222);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1672:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(2035);
      if (lookahead == 'p') ADVANCE(2015);
      if (lookahead == 'v') ADVANCE(1764);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1673:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(1146);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1674:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(1598);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1675:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(1832);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1676:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(1376);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1677:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(1607);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1678:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(1997);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1679:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(1765);
      if (lookahead == 'o') ADVANCE(1669);
      if (lookahead == 'v') ADVANCE(1903);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1680:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(1770);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1681:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(1862);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1682:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(1370);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1683:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(1666);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1684:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(1872);
      if (lookahead == 's') ADVANCE(1993);
      if (lookahead == 'z') ADVANCE(1993);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(2042);
      END_STATE();
    case 1685:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(1871);
      if (lookahead == 'n') ADVANCE(1537);
      if (lookahead == 'r') ADVANCE(1722);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1686:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(1871);
      if (lookahead == 'r') ADVANCE(1729);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1687:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(1674);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1688:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(1961);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1689:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(1751);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1690:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(1752);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1691:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(1754);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1692:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'm') ADVANCE(1336);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1693:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1694:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1764);
      if (lookahead == 'p') ADVANCE(2015);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1695:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1761);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1696:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(2028);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1697:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(918);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1698:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(2011);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1699:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(915);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1700:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1598);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1701:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1845);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1702:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1896);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1703:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1843);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1704:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1112);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1705:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1964);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1706:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1576);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1707:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1419);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1708:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1801);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1709:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1865);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1710:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1485);
      if (lookahead == 's') ADVANCE(1924);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1711:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1426);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1712:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1402);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1713:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1306);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1714:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1900);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1715:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1383);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1716:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1781);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1717:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1436);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1718:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1430);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1719:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1936);
      if (lookahead == 'x') ADVANCE(1610);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1720:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1441);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1721:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1444);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1722:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1497);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1723:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1446);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1724:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1443);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1725:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1908);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1726:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1654);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1727:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1742);
      if (lookahead == 'o') ADVANCE(1806);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1728:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1877);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1729:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1500);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1730:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1334);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1731:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1786);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1732:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1788);
      if (lookahead == 's') ADVANCE(1579);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1733:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(1788);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1734:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'o') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1735:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'o') ADVANCE(1677);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1736:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'o') ADVANCE(1638);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1737:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'o') ADVANCE(1318);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1738:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'o') ADVANCE(1804);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1739:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'o') ADVANCE(1832);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1740:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'o') ADVANCE(1373);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1741:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'o') ADVANCE(1964);
      if (lookahead == 'p') ADVANCE(2032);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1742:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'o') ADVANCE(1806);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1743:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'o') ADVANCE(1969);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1744:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'o') ADVANCE(1801);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1745:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'o') ADVANCE(1802);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1746:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'o') ADVANCE(1902);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1747:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'o') ADVANCE(1569);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1748:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'o') ADVANCE(1972);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1749:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'o') ADVANCE(1673);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1750:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'o') ADVANCE(1664);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1751:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'o') ADVANCE(1975);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1752:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'o') ADVANCE(1979);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1753:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'o') ADVANCE(1812);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1754:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'o') ADVANCE(1974);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1755:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'o') ADVANCE(1811);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1756:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'o') ADVANCE(1699);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1757:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'o') ADVANCE(1873);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1758:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'o') ADVANCE(1324);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1759:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'o') ADVANCE(1341);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1760:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1761:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(2015);
      if (lookahead == 's') ADVANCE(2015);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1762:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(2015);
      if (lookahead == 's') ADVANCE(2013);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1763:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(2015);
      if (lookahead == 'v') ADVANCE(1764);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1764:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(2015);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1765:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(1761);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1766:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(1509);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1767:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(1214);
      if (lookahead == 't') ADVANCE(1830);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1768:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(1202);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1769:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(1479);
      if (lookahead == 's') ADVANCE(1502);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1770:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(1516);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1771:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(1097);
      if (lookahead == 'r') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1772:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(1123);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1773:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(1128);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1774:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(1896);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1775:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(1832);
      if (lookahead == 'q') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1776:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(1832);
      if (lookahead == 's') ADVANCE(1832);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1777:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(1832);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1778:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(1572);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1779:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(1388);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1780:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(1419);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1781:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(1757);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1782:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(1609);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1783:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(1789);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1784:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(1915);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1785:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(1870);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1786:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(1391);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1787:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(1490);
      if (lookahead == 's') ADVANCE(1491);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1788:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(1396);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1789:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(1518);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1790:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p') ADVANCE(1339);
      if (lookahead == 't') ADVANCE(1806);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1791:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'q') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1792:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'q') ADVANCE(1094);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1793:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'q') ADVANCE(1345);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1794:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'q') ADVANCE(2039);
      if (lookahead == 's') ADVANCE(1935);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1795:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'q') ADVANCE(1611);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1796:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'q') ADVANCE(1216);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1797:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'q') ADVANCE(1943);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1798:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'q') ADVANCE(1474);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1799:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'q') ADVANCE(1822);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1800:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'q') ADVANCE(1825);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1801:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1802:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(1189);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1803:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(1734);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1804:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(1764);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1805:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(2038);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1806:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(2039);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1807:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(1252);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1808:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(1841);
      if (lookahead == 'u') ADVANCE(1983);
      if (lookahead == 'w') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1809:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(1424);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1810:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(2022);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1811:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(1088);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1812:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(1090);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1813:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(1896);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1814:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(1157);
      if (lookahead == 'u') ADVANCE(1913);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1815:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(1157);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1816:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(1662);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1817:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(1442);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1818:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(1737);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1819:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(1900);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1820:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(1671);
      if (lookahead == 'x') ADVANCE(1790);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1821:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(1697);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1822:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(1919);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1823:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(1726);
      if (lookahead == 's') ADVANCE(1916);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1824:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(1907);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1825:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(1905);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1826:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(1842);
      if (lookahead == 'u') ADVANCE(1983);
      if (lookahead == 'w') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1827:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(1920);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1828:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(1538);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1829:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(1317);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1830:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(1329);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1831:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'r') ADVANCE(1541);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1832:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1833:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1764);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1834:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1345);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1835:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1213);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1836:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1486);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1837:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(2015);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1838:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1628);
      if (lookahead == 'x') ADVANCE(1761);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1839:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1761);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1840:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1413);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1841:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1983);
      if (lookahead == 'w') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1842:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1983);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1843:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(2039);
      if (lookahead == 'u') ADVANCE(2039);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1844:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(2039);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1845:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(2028);
      if (lookahead == 'u') ADVANCE(2028);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1846:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(2028);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1847:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(2007);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1848:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1431);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1849:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(2011);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1850:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1454);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1851:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(2023);
      if (lookahead == 'u') ADVANCE(1861);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1852:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(2023);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1853:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(2009);
      if (lookahead == 'u') ADVANCE(1861);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1854:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(2009);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1855:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1438);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1856:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1984);
      if (lookahead == 'w') ADVANCE(1419);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1857:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1258);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1858:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1856);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1859:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1896);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1860:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1595);
      if (lookahead == 'u') ADVANCE(1861);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1861:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1595);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1862:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1627);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1863:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1620);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1864:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1917);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1865:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1806);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1866:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1801);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1867:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1621);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1868:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1585);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1869:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1902);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1870:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1314);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1871:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1570);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1872:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1622);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1873:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1944);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1874:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1382);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1875:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1374);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1876:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1504);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1877:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1544);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1878:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1415);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1879:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1597);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1880:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1848);
      if (lookahead == 'u') ADVANCE(1848);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1881:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1897);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1882:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1839);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1883:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1833);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1884:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1849);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1885:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1910);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1886:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1879);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1887:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1911);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1888:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1311);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1889:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1935);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1890:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1937);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1891:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1531);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1892:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1592);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1893:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1891);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1894:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1938);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1895:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1629);
      if (lookahead == 'x') ADVANCE(1761);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1896:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1897:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1764);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1898:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1457);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1899:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1524);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1900:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1761);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1901:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1198);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1902:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(2039);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1903:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1458);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1904:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1521);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1905:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1202);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1906:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1476);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1907:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1775);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1908:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(2011);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1909:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(2045);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1910:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1565);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1911:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(2033);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1912:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1180);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1913:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1175);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1914:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1149);
      if (lookahead == 'u') ADVANCE(1360);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1915:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1088);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1916:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1134);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1917:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1760);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1918:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1634);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1919:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1776);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1920:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1553);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1921:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1172);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1922:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1985);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1923:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1475);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1924:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1744);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1925:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1593);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1926:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1310);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1927:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1801);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1928:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1793);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1929:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1605);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1930:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1777);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1931:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1504);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1932:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1366);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1933:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1272);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1934:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1397);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1935:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1810);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1936:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1518);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1937:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1753);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1938:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1755);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1939:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1532);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1940:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1533);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1941:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1594);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1942:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 't') ADVANCE(1940);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1943:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'u') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1944:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'u') ADVANCE(1983);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1945:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'u') ADVANCE(1760);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1946:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'u') ADVANCE(1632);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1947:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'u') ADVANCE(1602);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1948:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'u') ADVANCE(1791);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1949:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'u') ADVANCE(1347);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1950:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'u') ADVANCE(1550);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1951:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'u') ADVANCE(1641);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1952:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'u') ADVANCE(1551);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1953:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'u') ADVANCE(1360);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1954:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'u') ADVANCE(1354);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1955:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'u') ADVANCE(1355);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1956:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'u') ADVANCE(1782);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1957:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'u') ADVANCE(1356);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1958:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'u') ADVANCE(1372);
      if (lookahead == 'w') ADVANCE(1419);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1959:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'u') ADVANCE(1868);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1960:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'u') ADVANCE(1361);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1961:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'u') ADVANCE(1651);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1962:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'u') ADVANCE(1718);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1963:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'u') ADVANCE(1404);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1964:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'v') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1965:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'v') ADVANCE(1147);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1966:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'v') ADVANCE(1345);
      if (lookahead == 'w') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1967:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'v') ADVANCE(1761);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1968:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'v') ADVANCE(1270);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1969:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'v') ADVANCE(2039);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1970:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'v') ADVANCE(1684);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1971:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'v') ADVANCE(1273);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1972:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'v') ADVANCE(1343);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1973:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'v') ADVANCE(1369);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1974:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'v') ADVANCE(2011);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1975:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'v') ADVANCE(1452);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1976:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'v') ADVANCE(1100);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1977:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'v') ADVANCE(1170);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1978:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'v') ADVANCE(1158);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1979:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'v') ADVANCE(1451);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1980:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'v') ADVANCE(1504);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1981:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'v') ADVANCE(1510);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1982:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'v') ADVANCE(1511);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1983:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'w') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1984:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'w') ADVANCE(1419);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1985:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'x') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1986:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'x') ADVANCE(1213);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1987:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'x') ADVANCE(1767);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1988:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'x') ADVANCE(2044);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1989:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'x') ADVANCE(2043);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1990:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'x') ADVANCE(2046);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1991:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'x') ADVANCE(2002);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1992:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'x') ADVANCE(1258);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1993:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'x') ADVANCE(1358);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1994:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'x') ADVANCE(1162);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1995:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'x') ADVANCE(1765);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1996:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'x') ADVANCE(1956);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1997:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'x') ADVANCE(1403);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1998:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'x') ADVANCE(1921);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 1999:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'x') ADVANCE(1931);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2000:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'y') ADVANCE(1195);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2001:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'y') ADVANCE(1577);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2002:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'z') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(2042);
      END_STATE();
    case 2003:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'z') ADVANCE(1761);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(2042);
      END_STATE();
    case 2004:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'z') ADVANCE(1405);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(2042);
      END_STATE();
    case 2005:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b' ||
          lookahead == 'd') ADVANCE(1071);
      if (lookahead == 'h') ADVANCE(1983);
      if (lookahead == 'l') ADVANCE(1983);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2006:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'u') ADVANCE(1834);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2007:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b' ||
          lookahead == 'w') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2008:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd' ||
          lookahead == 'h') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2009:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd' ||
          lookahead == 'i') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2010:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd' ||
          lookahead == 'q') ADVANCE(1071);
      if (lookahead == 'v') ADVANCE(2011);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2011:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd' ||
          lookahead == 'q') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2012:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd' ||
          lookahead == 's') ADVANCE(1071);
      if (lookahead == 'h') ADVANCE(1484);
      if (lookahead == 'l') ADVANCE(1484);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2013:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd' ||
          lookahead == 's') ADVANCE(1071);
      if (lookahead == 'u') ADVANCE(1347);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2014:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd' ||
          lookahead == 's') ADVANCE(1071);
      if (lookahead == 'u') ADVANCE(1359);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2015:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd' ||
          lookahead == 's') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2016:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 's') ADVANCE(1983);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2017:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'v') ADVANCE(1345);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2018:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd' ||
          lookahead == 'w') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2019:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'e' ||
          lookahead == 't') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2020:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'f' ||
          lookahead == 'r') ADVANCE(1071);
      if (lookahead == 'w') ADVANCE(1290);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2021:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'h' ||
          lookahead == 'l') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2022:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'i' ||
          lookahead == 'm') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2023:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'i' ||
          lookahead == 's') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2024:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l' ||
          lookahead == 'r') ADVANCE(1071);
      if (lookahead == 'p') ADVANCE(1776);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2025:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'p' ||
          lookahead == 't') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2026:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'e') ADVANCE(1824);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2027:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'h') ADVANCE(1983);
      if (lookahead == 'l') ADVANCE(1983);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2028:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'w') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2029:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'v') ADVANCE(2030);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2030:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2031:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'l' ||
          lookahead == 'n' ||
          lookahead == 'u') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2032:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'e') ADVANCE(1794);
      if (lookahead == 'g') ADVANCE(1902);
      if (lookahead == 'i') ADVANCE(1889);
      if (lookahead == 'u') ADVANCE(2039);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2033:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'm') ADVANCE(1371);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2034:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'n') ADVANCE(2039);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2035:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'p') ADVANCE(2015);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2036:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'p') ADVANCE(1831);
      if (lookahead == 'u') ADVANCE(2039);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2037:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 's') ADVANCE(2007);
      if (lookahead == 'u') ADVANCE(1847);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2038:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 't') ADVANCE(1539);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2039:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2040:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 's' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'h') ADVANCE(1484);
      if (lookahead == 'l') ADVANCE(1484);
      if (lookahead == 'x') ADVANCE(1115);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2041:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 's' ||
          lookahead == 'w') ADVANCE(1071);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2042:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2043:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2' ||
          lookahead == '4') ADVANCE(1071);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2044:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '4' ||
          lookahead == '8') ADVANCE(1071);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2045:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '1' ||
          lookahead == '2') ADVANCE(1071);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2046:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '2' ||
          lookahead == '4' ||
          lookahead == '8') ADVANCE(1071);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2047:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '/') ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '2')) ADVANCE(1071);
      if (lookahead == ':') ADVANCE(878);
      if (('-' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2042);
      END_STATE();
    case 2048:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$') ADVANCE(2964);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1194);
      END_STATE();
    case 2049:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '0') ADVANCE(2292);
      if (lookahead == '1') ADVANCE(2292);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('2' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2050:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '1') ADVANCE(2664);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2051:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '1') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2052:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '1') ADVANCE(2962);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(1027);
      if (lookahead == 'a') ADVANCE(2893);
      if (lookahead == 'b') ADVANCE(2942);
      if (lookahead == 'c') ADVANCE(2940);
      if (lookahead == 'd') ADVANCE(2436);
      if (lookahead == 'e') ADVANCE(2802);
      if (lookahead == 'i') ADVANCE(2659);
      if (lookahead == 'o') ADVANCE(2522);
      if (lookahead == 's') ADVANCE(2935);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '7') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('f' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2053:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '1') ADVANCE(2962);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(1027);
      if (lookahead == 'b') ADVANCE(2942);
      if (lookahead == 'd') ADVANCE(2939);
      if (lookahead == 'i') ADVANCE(2659);
      if (lookahead == 's') ADVANCE(2937);
      if (('a' <= lookahead && lookahead <= 'c')) ADVANCE(2893);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '7') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('e' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2054:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '1') ADVANCE(2661);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2055:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '1') ADVANCE(2580);
      if (lookahead == '2') ADVANCE(2116);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2056:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '1') ADVANCE(2113);
      if (lookahead == '2') ADVANCE(2122);
      if (lookahead == 'p') ADVANCE(2738);
      if (lookahead == 's') ADVANCE(2738);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2057:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '1') ADVANCE(2110);
      if (lookahead == '2') ADVANCE(2060);
      if (lookahead == 'a') ADVANCE(2378);
      if (lookahead == 'p') ADVANCE(2927);
      if (lookahead == 's') ADVANCE(2927);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2058:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '1') ADVANCE(2110);
      if (lookahead == '2') ADVANCE(2060);
      if (lookahead == 'p') ADVANCE(2927);
      if (lookahead == 's') ADVANCE(2927);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2059:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '1') ADVANCE(2110);
      if (lookahead == '2') ADVANCE(2060);
      if (lookahead == 'p') ADVANCE(2927);
      if (lookahead == 's') ADVANCE(2926);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2060:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '1') ADVANCE(2108);
      if (lookahead == '3') ADVANCE(2054);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2061:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '1') ADVANCE(2105);
      if (lookahead == '3') ADVANCE(2050);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2062:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '1') ADVANCE(2082);
      if (lookahead == '3') ADVANCE(2099);
      if (lookahead == '6') ADVANCE(2115);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2063:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '1') ADVANCE(2082);
      if (lookahead == '3') ADVANCE(2101);
      if (lookahead == '6') ADVANCE(2115);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2064:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '1') ADVANCE(2082);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2065:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '1') ADVANCE(2109);
      if (lookahead == '2') ADVANCE(2061);
      if (lookahead == 'p') ADVANCE(2927);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2066:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '1') ADVANCE(2575);
      if (lookahead == 'e') ADVANCE(2767);
      if (lookahead == 'z') ADVANCE(2268);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(2964);
      END_STATE();
    case 2067:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2664);
      if (lookahead == 'a') ADVANCE(2606);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2068:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2664);
      if (lookahead == 'p') ADVANCE(2927);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2069:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2664);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2070:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2071:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2661);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2072:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2959);
      if (lookahead == 's') ADVANCE(2513);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2073:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2931);
      if (lookahead == 'g') ADVANCE(2070);
      if (lookahead == 'n') ADVANCE(2070);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2074:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2345);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2075:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2923);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2076:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2434);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'i') ADVANCE(2077);
      if (lookahead == 'p') ADVANCE(2927);
      if (lookahead == 't') ADVANCE(2078);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2077:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2955);
      if (lookahead == 'l') ADVANCE(2068);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2078:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2955);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2079:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2349);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2080:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2350);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2081:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2428);
      if (lookahead == 'n') ADVANCE(2770);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2082:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2121);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2083:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2346);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2084:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2347);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2085:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2481);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2086:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2754);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2087:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2348);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2088:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2691);
      if (lookahead == 'a' ||
          lookahead == 'u') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2089:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2756);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2090:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2764);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2091:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2553);
      if (lookahead == 'b') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2092:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2553);
      if (lookahead == 'b' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2093:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2553);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2094:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2553);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2095:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2487);
      if (lookahead == 'a') ADVANCE(2260);
      if (lookahead == 'c') ADVANCE(2576);
      if (lookahead == 'm') ADVANCE(2172);
      if (lookahead == 'n') ADVANCE(2180);
      if (lookahead == 'p') ADVANCE(2608);
      if (lookahead == 'r') ADVANCE(2274);
      if (lookahead == 's') ADVANCE(2860);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2096:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2903);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2097:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2901);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2098:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2676);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2099:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2897);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2100:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2742);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2101:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2899);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2102:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2755);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2103:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2757);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2104:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2') ADVANCE(2765);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2105:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '3') ADVANCE(2664);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2106:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '3') ADVANCE(2070);
      if (lookahead == '6') ADVANCE(2112);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2107:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '3') ADVANCE(2070);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2108:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '3') ADVANCE(2661);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2109:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '3') ADVANCE(2069);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2110:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '3') ADVANCE(2071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2111:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '3') ADVANCE(2097);
      if (lookahead == '6') ADVANCE(2114);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2112:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '4') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2113:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '4') ADVANCE(2661);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2114:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '4') ADVANCE(2895);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2115:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '4') ADVANCE(2898);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2116:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '5') ADVANCE(2120);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2117:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '5') ADVANCE(2085);
      if (lookahead == 'u') ADVANCE(2248);
      if (lookahead == 'w') ADVANCE(2297);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2118:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '6') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2119:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '6') ADVANCE(2220);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2120:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '6') ADVANCE(2581);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2121:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '8') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2122:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '8') ADVANCE(2661);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2123:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'D') ADVANCE(1020);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2124:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'D') ADVANCE(1021);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2125:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'D') ADVANCE(1022);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2126:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'D') ADVANCE(1023);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2127:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'E') ADVANCE(1019);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2128:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'M') ADVANCE(2129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2129:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'M') ADVANCE(2143);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2130:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'O') ADVANCE(2135);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2131:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'O') ADVANCE(2136);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2132:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'O') ADVANCE(2137);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2133:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'O') ADVANCE(2138);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2134:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'R') ADVANCE(1025);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2135:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'R') ADVANCE(2123);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2136:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'R') ADVANCE(2124);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2137:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'R') ADVANCE(2125);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2138:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'R') ADVANCE(2126);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2139:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'T') ADVANCE(2134);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2140:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'T') ADVANCE(2127);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2141:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'W') ADVANCE(2131);
      if (lookahead == 'h') ADVANCE(1058);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(2477);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2142:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'W') ADVANCE(2132);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2143:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'W') ADVANCE(2133);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2144:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'Y') ADVANCE(2140);
      if (lookahead == 'h') ADVANCE(1058);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(2477);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2145:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2664);
      if (lookahead == 'd') ADVANCE(1117);
      if (lookahead == 'h') ADVANCE(2543);
      if (lookahead == 'l') ADVANCE(2482);
      if (lookahead == 'm') ADVANCE(2771);
      if (lookahead == 'n') ADVANCE(2827);
      if (lookahead == 'q') ADVANCE(1071);
      if (lookahead == 's') ADVANCE(2924);
      if (lookahead == 'u') ADVANCE(2664);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2146:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(1122);
      if (lookahead == 'b') ADVANCE(1122);
      if (lookahead == 'c' ||
          lookahead == 'o' ||
          lookahead == 's' ||
          lookahead == 'z') ADVANCE(1071);
      if (lookahead == 'e') ADVANCE(1111);
      if (lookahead == 'g') ADVANCE(1122);
      if (lookahead == 'l') ADVANCE(1122);
      if (lookahead == 'm') ADVANCE(2660);
      if (lookahead == 'n') ADVANCE(2148);
      if (lookahead == 'p') ADVANCE(1192);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'y')) ADVANCE(2964);
      END_STATE();
    case 2147:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(1122);
      if (lookahead == 'b') ADVANCE(1122);
      if (lookahead == 'c' ||
          lookahead == 'e' ||
          lookahead == 'o' ||
          lookahead == 's' ||
          lookahead == 'z') ADVANCE(1071);
      if (lookahead == 'g') ADVANCE(1122);
      if (lookahead == 'l') ADVANCE(1122);
      if (lookahead == 'n') ADVANCE(2148);
      if (lookahead == 'p') ADVANCE(1192);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'y')) ADVANCE(2964);
      END_STATE();
    case 2148:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(1122);
      if (lookahead == 'b') ADVANCE(1122);
      if (lookahead == 'c' ||
          lookahead == 'e' ||
          lookahead == 'o' ||
          lookahead == 'p' ||
          lookahead == 's' ||
          lookahead == 'z') ADVANCE(1071);
      if (lookahead == 'g') ADVANCE(1122);
      if (lookahead == 'l') ADVANCE(1122);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'y')) ADVANCE(2964);
      END_STATE();
    case 2149:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2150:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2361);
      if (lookahead == 'm') ADVANCE(2638);
      if (lookahead == 'n') ADVANCE(2642);
      if (lookahead == 'o') ADVANCE(2705);
      if (lookahead == 's') ADVANCE(2479);
      if (lookahead == 't') ADVANCE(2418);
      if (lookahead == 'u') ADVANCE(2626);
      if (lookahead == 'x') ADVANCE(2623);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2151:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2743);
      if (lookahead == 'f') ADVANCE(2397);
      if (lookahead == 'i') ADVANCE(2590);
      if (lookahead == 'o') ADVANCE(2874);
      if (lookahead == 'p') ADVANCE(2774);
      if (lookahead == 'u') ADVANCE(2535);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2152:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2242);
      if (lookahead == 'b') ADVANCE(2549);
      if (lookahead == 'c') ADVANCE(2541);
      if (lookahead == 'd') ADVANCE(2392);
      if (lookahead == 'e') ADVANCE(2907);
      if (lookahead == 'f') ADVANCE(2095);
      if (lookahead == 'h') ADVANCE(2204);
      if (lookahead == 'i') ADVANCE(2081);
      if (lookahead == 'm') ADVANCE(2156);
      if (lookahead == 'o') ADVANCE(2666);
      if (lookahead == 'r') ADVANCE(2393);
      if (lookahead == 's') ADVANCE(2186);
      if (lookahead == 't') ADVANCE(2391);
      if (lookahead == 'u') ADVANCE(2627);
      if (lookahead == 'x') ADVANCE(2640);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2153:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2467);
      if (lookahead == 'b') ADVANCE(2220);
      if (lookahead == 'c') ADVANCE(2173);
      if (lookahead == 'e') ADVANCE(2273);
      if (lookahead == 'f') ADVANCE(2397);
      if (lookahead == 'h') ADVANCE(2157);
      if (lookahead == 'i' ||
          lookahead == 'p') ADVANCE(1027);
      if (lookahead == 'q') ADVANCE(2719);
      if (lookahead == 's') ADVANCE(1044);
      if (lookahead == 't') ADVANCE(2170);
      if (lookahead == 'u') ADVANCE(2236);
      if (lookahead == 'w') ADVANCE(2178);
      if (lookahead == 'y') ADVANCE(2745);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2154:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2367);
      if (lookahead == 'b') ADVANCE(2551);
      if (lookahead == 'c') ADVANCE(2574);
      if (lookahead == 'd') ADVANCE(2243);
      if (lookahead == 'e') ADVANCE(2896);
      if (lookahead == 'f') ADVANCE(2493);
      if (lookahead == 'g') ADVANCE(2191);
      if (lookahead == 'h') ADVANCE(2175);
      if (lookahead == 'i') ADVANCE(2624);
      if (lookahead == 'l') ADVANCE(2298);
      if (lookahead == 'm') ADVANCE(2216);
      if (lookahead == 'o') ADVANCE(2701);
      if (lookahead == 'p') ADVANCE(2158);
      if (lookahead == 'r') ADVANCE(2181);
      if (lookahead == 's') ADVANCE(2275);
      if (lookahead == 't') ADVANCE(2421);
      if (lookahead == 'u') ADVANCE(2266);
      if (lookahead == 'x') ADVANCE(2633);
      if (lookahead == 'z') ADVANCE(2399);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('j' <= lookahead && lookahead <= 'y')) ADVANCE(2964);
      END_STATE();
    case 2155:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(1182);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2156:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2372);
      if (lookahead == 'i') ADVANCE(2596);
      if (lookahead == 'o') ADVANCE(2878);
      if (lookahead == 'u') ADVANCE(2526);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2157:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2055);
      if (lookahead == 'l') ADVANCE(1191);
      if (lookahead == 'r') ADVANCE(1191);
      if (lookahead == 'u') ADVANCE(2425);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2158:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2240);
      if (lookahead == 'b') ADVANCE(2552);
      if (lookahead == 'c') ADVANCE(2540);
      if (lookahead == 'e') ADVANCE(2721);
      if (lookahead == 'g') ADVANCE(2214);
      if (lookahead == 'h') ADVANCE(2209);
      if (lookahead == 'i') ADVANCE(2603);
      if (lookahead == 'l') ADVANCE(2913);
      if (lookahead == 'm') ADVANCE(2161);
      if (lookahead == 'o') ADVANCE(2708);
      if (lookahead == 'p') ADVANCE(2406);
      if (lookahead == 'r') ADVANCE(2630);
      if (lookahead == 's') ADVANCE(2185);
      if (lookahead == 't') ADVANCE(2386);
      if (lookahead == 'u') ADVANCE(2628);
      if (lookahead == 'x') ADVANCE(2641);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2159:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2959);
      if (lookahead == 'l') ADVANCE(2959);
      if (lookahead == 'u') ADVANCE(2431);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2160:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2930);
      if (lookahead == 'l') ADVANCE(2318);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2161:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2280);
      if (lookahead == 'i') ADVANCE(2598);
      if (lookahead == 'o') ADVANCE(2881);
      if (lookahead == 'u') ADVANCE(2528);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2162:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2548);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2163:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2948);
      if (lookahead == 'l') ADVANCE(2317);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2164:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(1082);
      if (lookahead == 'u') ADVANCE(1076);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2165:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2767);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2166:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2468);
      if (lookahead == 'd') ADVANCE(2302);
      if (lookahead == 'e') ADVANCE(2155);
      if (lookahead == 'f') ADVANCE(2397);
      if (lookahead == 'o') ADVANCE(2342);
      if (lookahead == 'z') ADVANCE(2269);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'y')) ADVANCE(2964);
      END_STATE();
    case 2167:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2660);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2168:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2489);
      if (lookahead == 'o') ADVANCE(2722);
      if (lookahead == 'r') ADVANCE(2437);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2169:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2489);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2170:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2252);
      if (lookahead == 'c' ||
          lookahead == 'd' ||
          lookahead == 'i') ADVANCE(1071);
      if (lookahead == 'm') ADVANCE(2906);
      if (lookahead == 'o') ADVANCE(2747);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2171:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2886);
      if (lookahead == 't') ADVANCE(2256);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2172:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2894);
      if (lookahead == 'i') ADVANCE(2589);
      if (lookahead == 'u') ADVANCE(2523);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2173:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2747);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2174:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2359);
      if (lookahead == 'l') ADVANCE(2802);
      if (lookahead == 's') ADVANCE(2857);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2175:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2359);
      if (lookahead == 's') ADVANCE(2857);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2176:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2553);
      if (lookahead == 'c') ADVANCE(2465);
      if (lookahead == 'r') ADVANCE(2799);
      if (lookahead == 's') ADVANCE(2203);
      if (lookahead == 't') ADVANCE(2733);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2177:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2781);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2178:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2678);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2179:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2831);
      if (lookahead == 'r') ADVANCE(2408);
      if (lookahead == 't') ADVANCE(2183);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2180:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2261);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2181:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2601);
      if (lookahead == 'c') ADVANCE(2670);
      if (lookahead == 'e') ADVANCE(2360);
      if (lookahead == 'n') ADVANCE(2379);
      if (lookahead == 'o') ADVANCE(2869);
      if (lookahead == 's') ADVANCE(2699);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2182:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2680);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2183:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2589);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2184:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2798);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2185:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2364);
      if (lookahead == 'c') ADVANCE(2196);
      if (lookahead == 'h') ADVANCE(2159);
      if (lookahead == 'i') ADVANCE(2452);
      if (lookahead == 'l') ADVANCE(2530);
      if (lookahead == 'r') ADVANCE(2163);
      if (lookahead == 'u') ADVANCE(2223);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2186:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2364);
      if (lookahead == 'h') ADVANCE(2858);
      if (lookahead == 'i') ADVANCE(2452);
      if (lookahead == 'l') ADVANCE(2527);
      if (lookahead == 'r') ADVANCE(2160);
      if (lookahead == 'u') ADVANCE(2223);
      if (lookahead == 'w') ADVANCE(2182);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2187:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2364);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2188:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2282);
      if (lookahead == 'q') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2189:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2537);
      if (lookahead == 'u') ADVANCE(2683);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2190:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2537);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2191:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2830);
      if (lookahead == 'e') ADVANCE(2811);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2192:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2259);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2193:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2531);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2194:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2609);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2195:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2787);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2196:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2849);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2197:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2370);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2198:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2887);
      if (lookahead == 'e') ADVANCE(2836);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2199:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2356);
      if (lookahead == 'c') ADVANCE(2466);
      if (lookahead == 'g') ADVANCE(2410);
      if (lookahead == 'm') ADVANCE(2555);
      if (lookahead == 'o') ADVANCE(2704);
      if (lookahead == 'r') ADVANCE(2795);
      if (lookahead == 's') ADVANCE(2198);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2200:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2356);
      if (lookahead == 'c') ADVANCE(2646);
      if (lookahead == 'd') ADVANCE(2495);
      if (lookahead == 'l') ADVANCE(2297);
      if (lookahead == 'm') ADVANCE(2853);
      if (lookahead == 'n') ADVANCE(2288);
      if (lookahead == 's') ADVANCE(2807);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2201:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2544);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2202:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2283);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2203:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2888);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2204:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2371);
      if (lookahead == 'm') ADVANCE(2503);
      if (lookahead == 's') ADVANCE(2861);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2205:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2547);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2206:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2602);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2207:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2373);
      if (lookahead == 's') ADVANCE(2862);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2208:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2792);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2209:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2375);
      if (lookahead == 'm') ADVANCE(2503);
      if (lookahead == 's') ADVANCE(2863);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2210:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2376);
      if (lookahead == 's') ADVANCE(2868);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2211:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2789);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2212:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2791);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2213:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2620);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2214:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2848);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2215:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2381);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2216:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'a') ADVANCE(2800);
      if (lookahead == 'i') ADVANCE(2590);
      if (lookahead == 'o') ADVANCE(2879);
      if (lookahead == 'p') ADVANCE(2774);
      if (lookahead == 'u') ADVANCE(2524);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2217:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(2664);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2218:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(1122);
      if (lookahead == 'e' ||
          lookahead == 'u') ADVANCE(1071);
      if (lookahead == 'n') ADVANCE(2219);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2219:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(1122);
      if (lookahead == 'e' ||
          lookahead == 'u') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2220:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2221:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(2661);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2222:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(1147);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2223:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(2957);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2224:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(2928);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2225:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(2057);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2226:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(2232);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2227:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(2949);
      if (lookahead == 'd') ADVANCE(1169);
      if (lookahead == 's') ADVANCE(2889);
      if (lookahead == 'u') ADVANCE(2228);
      if (lookahead == 'w') ADVANCE(1189);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2228:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(2949);
      if (lookahead == 'd') ADVANCE(2691);
      if (lookahead == 'w') ADVANCE(2923);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2229:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(2065);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2230:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(2476);
      if (lookahead == 'd') ADVANCE(2475);
      if (lookahead == 'h') ADVANCE(1058);
      if (lookahead == 's') ADVANCE(1040);
      if (('a' <= lookahead && lookahead <= 'c')) ADVANCE(2474);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == 'e' ||
          lookahead == 'f') ADVANCE(2477);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2231:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(2476);
      if (lookahead == 'd') ADVANCE(2475);
      if (lookahead == 'h') ADVANCE(1058);
      if (lookahead == 's') ADVANCE(2937);
      if (('a' <= lookahead && lookahead <= 'c')) ADVANCE(2474);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == 'e' ||
          lookahead == 'f') ADVANCE(2477);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2232:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(2889);
      if (lookahead == 'd') ADVANCE(1169);
      if (lookahead == 's') ADVANCE(2889);
      if (lookahead == 'w') ADVANCE(1115);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2233:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(2889);
      if (lookahead == 'd') ADVANCE(2691);
      if (lookahead == 'q') ADVANCE(2352);
      if (lookahead == 'w') ADVANCE(2297);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2234:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(2889);
      if (lookahead == 'd') ADVANCE(2691);
      if (lookahead == 'w') ADVANCE(2297);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2235:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(2889);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2236:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(1152);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2237:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(1170);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2238:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(2058);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2239:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(2738);
      if (lookahead == 'p') ADVANCE(2927);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2240:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(2747);
      if (lookahead == 'c') ADVANCE(2514);
      if (lookahead == 'd') ADVANCE(2308);
      if (lookahead == 'l') ADVANCE(2504);
      if (lookahead == 'n') ADVANCE(2320);
      if (lookahead == 'v') ADVANCE(2447);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2241:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(2871);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2242:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(2749);
      if (lookahead == 'c') ADVANCE(2514);
      if (lookahead == 'd') ADVANCE(2308);
      if (lookahead == 'l') ADVANCE(2504);
      if (lookahead == 'n') ADVANCE(2309);
      if (lookahead == 'u') ADVANCE(2781);
      if (lookahead == 'v') ADVANCE(2446);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2243:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(2685);
      if (lookahead == 'i') ADVANCE(2873);
      if (lookahead == 'p') ADVANCE(2664);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2244:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(2709);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2245:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(2094);
      if (lookahead == 'd') ADVANCE(2092);
      if (lookahead == 'm') ADVANCE(2072);
      if (lookahead == 'q') ADVANCE(2093);
      if (lookahead == 's') ADVANCE(2313);
      if (lookahead == 'u') ADVANCE(2758);
      if (lookahead == 'w') ADVANCE(2091);
      if (lookahead == 'z') ADVANCE(2902);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(2964);
      END_STATE();
    case 2246:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(2536);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2247:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(2075);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2248:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(2760);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2249:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(2193);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2250:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b') ADVANCE(2177);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2251:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(1071);
      if (lookahead == 'o') ADVANCE(2875);
      if (lookahead == 'p') ADVANCE(1155);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2252:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2253:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2107);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2254:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2950);
      if (lookahead == 'l') ADVANCE(2339);
      if (lookahead == 'm') ADVANCE(2511);
      if (lookahead == 's') ADVANCE(2828);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2255:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(1130);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2256:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2889);
      if (lookahead == 'e') ADVANCE(2600);
      if (lookahead == 's') ADVANCE(2889);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2257:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(1146);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2258:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2912);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2259:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2802);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2260:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2252);
      if (lookahead == 'd') ADVANCE(2297);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2261:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2252);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2262:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2515);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2263:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2516);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2264:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2480);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2265:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2632);
      if (lookahead == 'd') ADVANCE(2070);
      if (lookahead == 'n') ADVANCE(2679);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2266:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2632);
      if (lookahead == 'n') ADVANCE(2679);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2267:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2542);
      if (lookahead == 'i') ADVANCE(2595);
      if (lookahead == 'o') ADVANCE(2660);
      if (lookahead == 's') ADVANCE(2171);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2268:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2599);
      if (lookahead == 'm') ADVANCE(2768);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2269:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2599);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2270:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2517);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2271:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2472);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2272:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2550);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2273:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2835);
      if (lookahead == 't') ADVANCE(2147);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2274:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2673);
      if (lookahead == 's') ADVANCE(2694);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2275:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2162);
      if (lookahead == 'h') ADVANCE(2859);
      if (lookahead == 'q') ADVANCE(2719);
      if (lookahead == 't') ADVANCE(2573);
      if (lookahead == 'u') ADVANCE(2221);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2276:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2382);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2277:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2773);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2278:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2618);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2279:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2384);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2280:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2753);
      if (lookahead == 'd') ADVANCE(2281);
      if (lookahead == 's') ADVANCE(2521);
      if (lookahead == 'x') ADVANCE(2746);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2281:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2762);
      if (lookahead == 'd') ADVANCE(2117);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2282:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2837);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2283:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2826);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2284:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2816);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2285:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2649);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2286:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2211);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2287:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2190);
      if (lookahead == 'e') ADVANCE(2622);
      if (lookahead == 'r') ADVANCE(2416);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2288:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2769);
      if (lookahead == 'i') ADVANCE(2802);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2289:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2205);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2290:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'c') ADVANCE(2212);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2291:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2664);
      if (lookahead == 'p') ADVANCE(2433);
      if (lookahead == 'q') ADVANCE(2664);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2292:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2664);
      if (lookahead == 'q') ADVANCE(2664);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2293:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2664);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2294:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2490);
      if (lookahead == 'm') ADVANCE(2853);
      if (lookahead == 'n') ADVANCE(1103);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2295:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(1122);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2296:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(1071);
      if (lookahead == 'q') ADVANCE(2933);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2297:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2298:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2302);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2299:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(1137);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2300:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2254);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2301:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(1187);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2302:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2697);
      if (lookahead == 'm') ADVANCE(2906);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2303:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2697);
      if (lookahead == 'p') ADVANCE(2927);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2304:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2697);
      if (lookahead == 'q') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2305:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2661);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2306:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2959);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2307:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2954);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2308:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2957);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2309:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(1136);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2310:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2588);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2311:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(1015);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2312:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2663);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2313:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2918);
      if (lookahead == 'q') ADVANCE(2947);
      if (lookahead == 'w') ADVANCE(2220);
      if (lookahead == 'x') ADVANCE(2228);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2314:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2918);
      if (lookahead == 'q') ADVANCE(2947);
      if (lookahead == 'w') ADVANCE(2220);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2315:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2928);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2316:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2866);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2317:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(1169);
      if (lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'v') ADVANCE(2949);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2318:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(1169);
      if (lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2319:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(1017);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2320:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(1190);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2321:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2872);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2322:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2923);
      if (lookahead == 'q') ADVANCE(2923);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2323:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2923);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2324:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2565);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2325:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2227);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2326:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2929);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2327:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(1018);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2328:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2065);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2329:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(1016);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2330:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2889);
      if (lookahead == 'w') ADVANCE(2220);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2331:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2059);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2332:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2296);
      if (lookahead == 's') ADVANCE(2333);
      if (lookahead == 'w') ADVANCE(2930);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2333:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2296);
      if (lookahead == 'w') ADVANCE(2930);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2334:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2244);
      if (lookahead == 't') ADVANCE(2398);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2335:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2696);
      if (lookahead == 'p') ADVANCE(2340);
      if (lookahead == 's') ADVANCE(2353);
      if (lookahead == 't') ADVANCE(2671);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2336:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2696);
      if (lookahead == 'p') ADVANCE(2358);
      if (lookahead == 'q') ADVANCE(2696);
      if (lookahead == 's') ADVANCE(2365);
      if (lookahead == 't') ADVANCE(2687);
      if (lookahead == 'u') ADVANCE(2337);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2337:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2696);
      if (lookahead == 'q') ADVANCE(2696);
      if (lookahead == 's') ADVANCE(2506);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2338:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2058);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2339:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2894);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2340:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2074);
      if (lookahead == 'i') ADVANCE(2069);
      if (lookahead == 's') ADVANCE(2083);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2341:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2662);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2342:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2747);
      if (lookahead == 'o') ADVANCE(2667);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2343:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2691);
      if (lookahead == 'h') ADVANCE(2711);
      if (lookahead == 'l') ADVANCE(2930);
      if (lookahead == 'u') ADVANCE(2352);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2344:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2691);
      if (lookahead == 'h') ADVANCE(2728);
      if (lookahead == 'l') ADVANCE(2949);
      if (lookahead == 't') ADVANCE(2502);
      if (lookahead == 'u') ADVANCE(2352);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2345:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2691);
      if (lookahead == 'p') ADVANCE(2938);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2346:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2691);
      if (lookahead == 'p') ADVANCE(2921);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2347:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2691);
      if (lookahead == 'p') ADVANCE(2920);
      if (lookahead == 'q') ADVANCE(2691);
      if (lookahead == 'u') ADVANCE(2351);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2348:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2691);
      if (lookahead == 'p') ADVANCE(2486);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2349:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2691);
      if (lookahead == 'p') ADVANCE(2738);
      if (lookahead == 'q') ADVANCE(2691);
      if (lookahead == 'u') ADVANCE(2351);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2350:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2691);
      if (lookahead == 'q') ADVANCE(2691);
      if (lookahead == 'u') ADVANCE(2351);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2351:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2691);
      if (lookahead == 'q') ADVANCE(2691);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2352:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2691);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2353:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2102);
      if (lookahead == 'i') ADVANCE(2100);
      if (lookahead == 's') ADVANCE(2103);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2354:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2695);
      if (lookahead == 'p') ADVANCE(2927);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2355:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2695);
      if (lookahead == 'i' ||
          lookahead == 'q') ADVANCE(1071);
      if (lookahead == 'p') ADVANCE(2927);
      if (lookahead == 's') ADVANCE(2927);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2356:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2297);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2357:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2087);
      if (lookahead == 's') ADVANCE(2087);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2358:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2079);
      if (lookahead == 'h') ADVANCE(2098);
      if (lookahead == 's') ADVANCE(2084);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2359:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2293);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2360:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2870);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2361:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2306);
      if (lookahead == 'n') ADVANCE(2307);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2362:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2852);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2363:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2494);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2364:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2235);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2365:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2086);
      if (lookahead == 'i') ADVANCE(2100);
      if (lookahead == 's') ADVANCE(2089);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2366:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2404);
      if (lookahead == 'e') ADVANCE(2610);
      if (lookahead == 'i') ADVANCE(2570);
      if (lookahead == 'k') ADVANCE(2387);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2367:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2341);
      if (lookahead == 'e') ADVANCE(2741);
      if (lookahead == 'l') ADVANCE(2508);
      if (lookahead == 'n') ADVANCE(2310);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2368:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2080);
      if (lookahead == 's') ADVANCE(2080);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2369:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2090);
      if (lookahead == 's') ADVANCE(2090);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2370:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2286);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2371:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2315);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2372:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2316);
      if (lookahead == 'x') ADVANCE(2748);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2373:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2331);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2374:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2761);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2375:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2325);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2376:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2338);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2377:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2740);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2378:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2328);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2379:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2782);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2380:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2104);
      if (lookahead == 's') ADVANCE(2104);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2381:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd') ADVANCE(2290);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2382:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2383:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2445);
      if (lookahead == 'o') ADVANCE(2941);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2384:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2661);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2385:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(1014);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2386:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2724);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2387:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2910);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2388:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2693);
      if (lookahead == 'g') ADVANCE(2808);
      if (lookahead == 'i') ADVANCE(2794);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2389:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(1086);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2390:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(1085);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2391:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2767);
      if (lookahead == 'r') ADVANCE(1024);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2392:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2660);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2393:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2443);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2394:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2894);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2395:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2691);
      if (lookahead == 'g') ADVANCE(2931);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2396:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2297);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2397:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2607);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2398:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2702);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2399:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2718);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2400:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2905);
      if (lookahead == 'm') ADVANCE(2194);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2401:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2427);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2402:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2700);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2403:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2908);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2404:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2255);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2405:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2720);
      if (lookahead == 'r') ADVANCE(2188);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2406:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2717);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2407:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2382);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2408:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2562);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2409:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2396);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2410:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2836);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2411:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2713);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2412:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2577);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2413:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2716);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2414:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2625);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2415:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2840);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2416:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2814);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2417:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2788);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2418:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2777);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2419:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2615);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2420:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2790);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2421:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2786);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2422:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2616);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2423:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2729);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2424:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e') ADVANCE(2619);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2425:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'f') ADVANCE(2664);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2426:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'f') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2427:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'f') ADVANCE(2661);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2428:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'f') ADVANCE(2930);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2429:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'f') ADVANCE(2946);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2430:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'f') ADVANCE(2435);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2431:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'f') ADVANCE(2916);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2432:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'f') ADVANCE(2062);
      if (lookahead == 'i') ADVANCE(2062);
      if (lookahead == 'p') ADVANCE(2738);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2433:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'f') ADVANCE(2049);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2434:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'f') ADVANCE(2064);
      if (lookahead == 'i') ADVANCE(2064);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2435:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'f') ADVANCE(2111);
      if (lookahead == 'i') ADVANCE(2111);
      if (lookahead == 'p') ADVANCE(2927);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2436:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'f') ADVANCE(2780);
      if (lookahead == 'g') ADVANCE(2780);
      if (lookahead == 'i' ||
          lookahead == 'x') ADVANCE(1027);
      if (lookahead == 'r') ADVANCE(2206);
      if (lookahead == 's') ADVANCE(2409);
      if (lookahead == 't') ADVANCE(2779);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2437:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'f') ADVANCE(2780);
      if (lookahead == 'g') ADVANCE(2780);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2438:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'f') ADVANCE(2497);
      if (lookahead == 'i') ADVANCE(1102);
      if (lookahead == 'm') ADVANCE(2768);
      if (lookahead == 'r') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2439:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'f') ADVANCE(2497);
      if (lookahead == 'i') ADVANCE(1102);
      if (lookahead == 'm') ADVANCE(2768);
      if (lookahead == 's') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2440:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'f') ADVANCE(2545);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2441:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'f') ADVANCE(2823);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2442:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'f') ADVANCE(2834);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2443:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'f') ADVANCE(2415);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2444:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'f') ADVANCE(2063);
      if (lookahead == 'i') ADVANCE(2063);
      if (lookahead == 's') ADVANCE(2927);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2445:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'g') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2446:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'g') ADVANCE(2917);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2447:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'g') ADVANCE(2918);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2448:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'g') ADVANCE(2923);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2449:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'g') ADVANCE(1073);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2450:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'g') ADVANCE(2943);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2451:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'g') ADVANCE(2738);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2452:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'g') ADVANCE(2591);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2453:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'g') ADVANCE(2605);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2454:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'g') ADVANCE(2593);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2455:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'g') ADVANCE(2384);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2456:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'g') ADVANCE(2414);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2457:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(1027);
      if (lookahead == 'l' ||
          lookahead == 'x') ADVANCE(1027);
      if (lookahead == 's') ADVANCE(1038);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(2477);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2458:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(1027);
      if (lookahead == 'l' ||
          lookahead == 'x') ADVANCE(1027);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(2477);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2459:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(1027);
      if (lookahead == 'i' ||
          lookahead == 'l' ||
          lookahead == 'x') ADVANCE(1027);
      if (lookahead == 's') ADVANCE(1039);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(2477);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2460:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(1027);
      if (lookahead == 'i' ||
          lookahead == 'l' ||
          lookahead == 'x') ADVANCE(1027);
      if (lookahead == 'w') ADVANCE(2657);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(2477);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2461:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(1027);
      if (lookahead == 'i' ||
          lookahead == 'l' ||
          lookahead == 'x') ADVANCE(1027);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(2477);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2462:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(1027);
      if (lookahead == 'l' ||
          lookahead == 'p' ||
          lookahead == 'x') ADVANCE(1027);
      if (lookahead == 'y') ADVANCE(2832);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(2477);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2463:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(1027);
      if (lookahead == 'l' ||
          lookahead == 'p' ||
          lookahead == 'x') ADVANCE(1027);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(2477);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2464:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(2664);
      if (lookahead == 'l') ADVANCE(2664);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2465:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2466:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(2445);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2467:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(2426);
      if (lookahead == 'l') ADVANCE(1071);
      if (lookahead == 'r') ADVANCE(1184);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2468:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(2426);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2469:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(1099);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2470:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(1145);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2471:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(2233);
      if (lookahead == 'l') ADVANCE(2233);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2472:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(1140);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2473:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(1058);
      if (lookahead == 's') ADVANCE(1041);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(2477);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2474:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(1058);
      if (lookahead == 'x') ADVANCE(1027);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(2477);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2475:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(1058);
      if (lookahead == 'i' ||
          lookahead == 'x') ADVANCE(1027);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(2477);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2476:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(1058);
      if (lookahead == 'p' ||
          lookahead == 'x') ADVANCE(1027);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(2477);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2477:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(1058);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(2477);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2478:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(2486);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2479:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(2491);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2480:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(2449);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2481:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(2855);
      if (lookahead == 'l') ADVANCE(2855);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2482:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(2676);
      if (lookahead == 'p') ADVANCE(2927);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2483:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(2505);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2484:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(2411);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2485:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h') ADVANCE(2413);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2486:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2487:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i') ADVANCE(2930);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2488:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i') ADVANCE(2767);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2489:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i') ADVANCE(2802);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2490:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i') ADVANCE(2871);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2491:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i') ADVANCE(2441);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2492:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i') ADVANCE(2297);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2493:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i') ADVANCE(2904);
      if (lookahead == 'm') ADVANCE(2207);
      if (lookahead == 'n') ADVANCE(2587);
      if (lookahead == 'p') ADVANCE(2272);
      if (lookahead == 'r') ADVANCE(2258);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2494:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i') ADVANCE(2599);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2495:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i') ADVANCE(2884);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2496:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i') ADVANCE(2652);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2497:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i') ADVANCE(2537);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2498:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i') ADVANCE(2742);
      if (lookahead == 'p') ADVANCE(2732);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2499:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i') ADVANCE(2742);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2500:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i') ADVANCE(2814);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2501:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i') ADVANCE(2806);
      if (lookahead == 'r') ADVANCE(2824);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2502:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i') ADVANCE(2797);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2503:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i') ADVANCE(2611);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2504:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i') ADVANCE(2453);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2505:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i') ADVANCE(2442);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2506:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i') ADVANCE(2100);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2507:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i') ADVANCE(2578);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2508:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i') ADVANCE(2454);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2509:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i') ADVANCE(2284);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2510:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'k') ADVANCE(2664);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2511:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'k') ADVANCE(1071);
      if (lookahead == 'o') ADVANCE(2871);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2512:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'k') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2513:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'k') ADVANCE(2220);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2514:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'k') ADVANCE(2785);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2515:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'k') ADVANCE(2464);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2516:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'k') ADVANCE(2234);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2517:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'k') ADVANCE(2471);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2518:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'k') ADVANCE(2252);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2519:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'k') ADVANCE(2584);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2520:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'k') ADVANCE(2585);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2521:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'k') ADVANCE(2586);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2522:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(1071);
      if (lookahead == 'r') ADVANCE(1184);
      if (lookahead == 'u') ADVANCE(2614);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2523:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2524:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(2661);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2525:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(2959);
      if (lookahead == 'r') ADVANCE(2959);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2526:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(2343);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2527:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(2318);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2528:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(2344);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2529:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(2922);
      if (lookahead == 'r') ADVANCE(2922);
      if (lookahead == 't') ADVANCE(2959);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2530:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(2317);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2531:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(919);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2532:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(2637);
      if (lookahead == 's') ADVANCE(1043);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2533:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(1146);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2534:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(2096);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2535:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(1153);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2536:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(2909);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2537:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(2523);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2538:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(2867);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2539:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(2698);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2540:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(2583);
      if (lookahead == 'm') ADVANCE(2636);
      if (lookahead == 'o') ADVANCE(2563);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2541:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(2583);
      if (lookahead == 'm') ADVANCE(2668);
      if (lookahead == 'o') ADVANCE(2582);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2542:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(2394);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2543:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(2676);
      if (lookahead == 'p') ADVANCE(2927);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2544:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(2382);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2545:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(2509);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2546:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(2644);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2547:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(2384);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2548:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(2401);
      if (lookahead == 't') ADVANCE(2846);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2549:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(2419);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2550:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(2195);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2551:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(2422);
      if (lookahead == 'r') ADVANCE(2655);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2552:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l') ADVANCE(2424);
      if (lookahead == 'r') ADVANCE(2658);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2553:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2554:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(2661);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2555:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(2892);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2556:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(2963);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2557:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(2051);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2558:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(1126);
      if (lookahead == 's') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2559:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(1126);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2560:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(2959);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2561:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(2498);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2562:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(1072);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2563:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(2956);
      if (lookahead == 'n') ADVANCE(2440);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2564:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(2076);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2565:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(2955);
      if (lookahead == 'p') ADVANCE(2927);
      if (lookahead == 'v') ADVANCE(2664);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2566:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(2489);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2567:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(1146);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2568:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(2555);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2569:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(2738);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2570:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(2252);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2571:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(2499);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2572:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(2556);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2573:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(2906);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2574:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(2665);
      if (lookahead == 'o') ADVANCE(2561);
      if (lookahead == 'v') ADVANCE(2810);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2575:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(2766);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2576:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(2672);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2577:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(2246);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2578:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(2554);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2579:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(2776);
      if (lookahead == 's') ADVANCE(2902);
      if (lookahead == 'z') ADVANCE(2902);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(2964);
      END_STATE();
    case 2580:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(2775);
      if (lookahead == 'n') ADVANCE(2403);
      if (lookahead == 'r') ADVANCE(2617);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2581:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(2775);
      if (lookahead == 'r') ADVANCE(2621);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2582:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(2566);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2583:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(2865);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2584:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(2645);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2585:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(2647);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2586:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(2648);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2587:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'm') ADVANCE(2210);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2588:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2664);
      if (lookahead == 'p') ADVANCE(2927);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2589:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2590:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2661);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2591:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2947);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2592:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(917);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2593:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2923);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2594:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(914);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2595:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2489);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2596:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2748);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2597:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(1113);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2598:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2746);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2599:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2802);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2600:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2871);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2601:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2455);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2602:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2297);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2603:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2770);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2604:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2363);
      if (lookahead == 's') ADVANCE(2829);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2605:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2702);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2606:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2293);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2607:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2276);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2608:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2180);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2609:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2804);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2610:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2255);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2611:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2682);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2612:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2546);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2613:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2312);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2614:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2305);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2615:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2321);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2616:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2324);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2617:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2374);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2618:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2816);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2619:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2326);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2620:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2323);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2621:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2377);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2622:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2843);
      if (lookahead == 'x') ADVANCE(2500);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2623:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2639);
      if (lookahead == 'o') ADVANCE(2707);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2624:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2784);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2625:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2208);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2626:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2686);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2627:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2688);
      if (lookahead == 's') ADVANCE(2469);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2628:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'n') ADVANCE(2688);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2629:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2630:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(2529);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2631:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(2189);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2632:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(2571);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2633:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(2701);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2634:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(2738);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2635:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(2722);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2636:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(2871);
      if (lookahead == 'p') ADVANCE(2952);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2637:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(2249);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2638:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(2877);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2639:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(2707);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2640:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(2702);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2641:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(2708);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2642:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(2808);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2643:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(2880);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2644:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(2448);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2645:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(2883);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2646:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(2567);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2647:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(2885);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2648:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(2882);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2649:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(2559);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2650:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(2712);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2651:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(2710);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2652:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(2594);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2653:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(2778);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2654:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(2726);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2655:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(2197);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2656:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(2730);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2657:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(2731);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2658:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'o') ADVANCE(2215);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2659:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(1027);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2660:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2661:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(2927);
      if (lookahead == 's') ADVANCE(2927);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2662:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(2927);
      if (lookahead == 's') ADVANCE(2925);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2663:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(2927);
      if (lookahead == 'v') ADVANCE(2664);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2664:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(2927);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2665:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(2661);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2666:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(1096);
      if (lookahead == 'r') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2667:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(1124);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2668:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(2388);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2669:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(2067);
      if (lookahead == 't') ADVANCE(2734);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2670:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(2056);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2671:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(2357);
      if (lookahead == 's') ADVANCE(2380);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2672:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(2395);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2673:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(1127);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2674:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(2738);
      if (lookahead == 'q') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2675:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(2738);
      if (lookahead == 's') ADVANCE(2738);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2676:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(2738);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2677:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(2802);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2678:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(2451);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2679:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(2262);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2680:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(2297);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2681:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(2507);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2682:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(2653);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2683:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(2689);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2684:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(2814);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2685:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(2774);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2686:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(2263);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2687:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(2368);
      if (lookahead == 's') ADVANCE(2369);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2688:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(2270);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2689:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(2398);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2690:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p') ADVANCE(2213);
      if (lookahead == 't') ADVANCE(2707);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2691:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'q') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2692:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'q') ADVANCE(2220);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2693:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'q') ADVANCE(2959);
      if (lookahead == 's') ADVANCE(2841);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2694:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'q') ADVANCE(2501);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2695:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'q') ADVANCE(1094);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2696:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'q') ADVANCE(2069);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2697:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'q') ADVANCE(2850);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2698:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'q') ADVANCE(2352);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2699:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'q') ADVANCE(2727);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2700:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(2629);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2701:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(2664);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2702:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2703:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(1151);
      if (lookahead == 'u') ADVANCE(2805);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2704:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(1151);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2705:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(2958);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2706:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(1024);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2707:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(2959);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2708:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(1189);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2709:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(2106);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2710:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(1085);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2711:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(2759);
      if (lookahead == 'u') ADVANCE(2889);
      if (lookahead == 'w') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2712:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(1087);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2713:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(2291);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2714:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(2934);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2715:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(2802);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2716:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(2322);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2717:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(2553);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2718:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(2631);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2719:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(2804);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2720:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(2592);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2721:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(2564);
      if (lookahead == 'x') ADVANCE(2690);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2722:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(2311);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2723:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(2825);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2724:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(2612);
      if (lookahead == 's') ADVANCE(2817);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2725:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(2815);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2726:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(2319);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2727:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(2812);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2728:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(2760);
      if (lookahead == 'u') ADVANCE(2889);
      if (lookahead == 'w') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2729:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(2826);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2730:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(2327);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2731:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(2329);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2732:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(2417);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2733:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(2192);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2734:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(2202);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2735:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'r') ADVANCE(2420);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2736:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2664);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2737:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(1043);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2738:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2739:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2220);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2740:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2070);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2741:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2366);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2742:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2927);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2743:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2519);
      if (lookahead == 'x') ADVANCE(2661);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2744:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2661);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2745:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2287);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2746:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2959);
      if (lookahead == 'u') ADVANCE(2959);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2747:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2959);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2748:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2947);
      if (lookahead == 'u') ADVANCE(2947);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2749:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2947);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2750:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2918);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2751:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2330);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2752:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2923);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2753:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2332);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2754:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2938);
      if (lookahead == 'u') ADVANCE(2765);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2755:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2938);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2756:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2921);
      if (lookahead == 'u') ADVANCE(2765);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2757:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2921);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2758:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2314);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2759:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2889);
      if (lookahead == 'w') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2760:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2889);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2761:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2112);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2762:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2763);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2763:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2891);
      if (lookahead == 'w') ADVANCE(2297);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2764:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2486);
      if (lookahead == 'u') ADVANCE(2765);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2765:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2486);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2766:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2518);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2767:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2802);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2768:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2512);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2769:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2821);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2770:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2707);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2771:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2510);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2772:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2470);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2773:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2702);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2774:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2187);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2775:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2450);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2776:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2513);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2777:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2808);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2778:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2851);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2779:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2257);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2780:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2250);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2781:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2382);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2782:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2289);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2783:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2488);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2784:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2423);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2785:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2751);
      if (lookahead == 'u') ADVANCE(2751);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2786:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2801);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2787:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2744);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2788:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2736);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2789:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2819);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2790:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2752);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2791:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2820);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2792:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2783);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2793:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2184);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2794:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2841);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2795:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2844);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2796:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2412);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2797:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2483);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2798:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2796);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2799:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2845);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2800:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 's') ADVANCE(2520);
      if (lookahead == 'x') ADVANCE(2661);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2801:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2664);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2802:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2803:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2335);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2804:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2661);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2805:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(1174);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2806:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2051);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2807:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(1148);
      if (lookahead == 'u') ADVANCE(2237);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2808:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2959);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2809:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(1171);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2810:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2336);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2811:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2400);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2812:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2056);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2813:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2355);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2814:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(1085);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2815:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2674);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2816:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2923);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2817:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(1133);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2818:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2943);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2819:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2444);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2820:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2953);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2821:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2660);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2822:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2405);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2823:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2525);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2824:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(1180);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2825:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2675);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2826:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2432);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2827:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2354);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2828:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2894);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2829:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2640);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2830:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2484);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2831:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2183);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2832:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2385);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2833:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2702);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2834:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2692);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2835:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2496);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2836:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2241);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2837:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2676);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2838:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2382);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2839:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2149);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2840:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2271);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2841:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2714);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2842:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2706);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2843:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2398);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2844:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2650);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2845:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2651);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2846:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2411);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2847:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2413);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2848:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2485);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2849:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 't') ADVANCE(2847);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2850:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'u') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2851:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'u') ADVANCE(2889);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2852:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'u') ADVANCE(2660);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2853:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'u') ADVANCE(2523);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2854:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'u') ADVANCE(2492);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2855:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'u') ADVANCE(2691);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2856:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'u') ADVANCE(2533);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2857:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'u') ADVANCE(2217);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2858:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'u') ADVANCE(2429);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2859:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'u') ADVANCE(2430);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2860:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'u') ADVANCE(2237);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2861:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'u') ADVANCE(2224);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2862:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'u') ADVANCE(2225);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2863:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'u') ADVANCE(2226);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2864:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'u') ADVANCE(2681);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2865:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'u') ADVANCE(2539);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2866:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'u') ADVANCE(2248);
      if (lookahead == 'w') ADVANCE(2297);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2867:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'u') ADVANCE(2772);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2868:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'u') ADVANCE(2238);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2869:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'u') ADVANCE(2614);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2870:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'u') ADVANCE(2279);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2871:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'v') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2872:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'v') ADVANCE(2220);
      if (lookahead == 'w') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2873:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'v') ADVANCE(2661);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2874:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'v') ADVANCE(1095);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2875:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'v') ADVANCE(2147);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2876:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'v') ADVANCE(1147);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2877:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'v') ADVANCE(2959);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2878:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'v') ADVANCE(2579);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2879:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'v') ADVANCE(2145);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2880:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'v') ADVANCE(2218);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2881:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'v') ADVANCE(2245);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2882:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'v') ADVANCE(2923);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2883:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'v') ADVANCE(2304);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2884:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'v') ADVANCE(1170);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2885:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'v') ADVANCE(2303);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2886:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'v') ADVANCE(2382);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2887:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'v') ADVANCE(2389);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2888:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'v') ADVANCE(2390);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2889:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'w') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2890:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'w') ADVANCE(2654);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2891:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'w') ADVANCE(2297);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2892:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'w') ADVANCE(2656);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(1027);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          lookahead == '8' ||
          lookahead == '9' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2893:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'x') ADVANCE(1027);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2894:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'x') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2895:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'x') ADVANCE(2070);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2896:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'x') ADVANCE(2669);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2897:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'x') ADVANCE(2915);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2898:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'x') ADVANCE(2914);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2899:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'x') ADVANCE(2944);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2900:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'x') ADVANCE(2911);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2901:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'x') ADVANCE(2112);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2902:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'x') ADVANCE(2228);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2903:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'x') ADVANCE(1156);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2904:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'x') ADVANCE(2864);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2905:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'x') ADVANCE(2665);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2906:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'x') ADVANCE(2277);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2907:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'x') ADVANCE(2809);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2908:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'x') ADVANCE(2838);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2909:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'y') ADVANCE(1196);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2910:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'y') ADVANCE(2456);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2911:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'z') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(2964);
      END_STATE();
    case 2912:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'z') ADVANCE(2661);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(2964);
      END_STATE();
    case 2913:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'z') ADVANCE(2278);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(2964);
      END_STATE();
    case 2914:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2' ||
          lookahead == '4') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2915:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '4' ||
          lookahead == '8') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2916:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b' ||
          lookahead == 'd') ADVANCE(1071);
      if (lookahead == 'h') ADVANCE(2889);
      if (lookahead == 'l') ADVANCE(2889);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2917:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'u') ADVANCE(2739);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2918:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2919:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b' ||
          lookahead == 'y') ADVANCE(1065);
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(2919);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('2' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2920:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd' ||
          lookahead == 'h') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2921:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd' ||
          lookahead == 'i') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2922:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd' ||
          lookahead == 'q') ADVANCE(1071);
      if (lookahead == 'v') ADVANCE(2923);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2923:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd' ||
          lookahead == 'q') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2924:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd' ||
          lookahead == 's') ADVANCE(1071);
      if (lookahead == 'h') ADVANCE(2362);
      if (lookahead == 'l') ADVANCE(2362);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2925:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd' ||
          lookahead == 's') ADVANCE(1071);
      if (lookahead == 'u') ADVANCE(2217);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2926:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd' ||
          lookahead == 's') ADVANCE(1071);
      if (lookahead == 'u') ADVANCE(2229);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2927:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd' ||
          lookahead == 's') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2928:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 's') ADVANCE(2889);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2929:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'v') ADVANCE(2220);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2930:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2931:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'e' ||
          lookahead == 't') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2932:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'f' ||
          lookahead == 'r') ADVANCE(1071);
      if (lookahead == 'w') ADVANCE(2167);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2933:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'h' ||
          lookahead == 'l') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2934:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i' ||
          lookahead == 'm') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2935:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i' ||
          lookahead == 'p') ADVANCE(1027);
      if (lookahead == 'q') ADVANCE(2723);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2936:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i' ||
          lookahead == 'p') ADVANCE(1027);
      if (lookahead == 's') ADVANCE(1044);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2937:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i' ||
          lookahead == 'p') ADVANCE(1027);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2938:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i' ||
          lookahead == 's') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2939:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'i' ||
          lookahead == 'x') ADVANCE(1027);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2940:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l' ||
          lookahead == 'r') ADVANCE(1071);
      if (lookahead == 'p') ADVANCE(2675);
      if (lookahead == 'x') ADVANCE(1027);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2941:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p' ||
          lookahead == 't') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2942:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'p' ||
          lookahead == 'x') ADVANCE(1027);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2943:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '1' ||
          lookahead == '2') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2944:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '2' ||
          lookahead == '4' ||
          lookahead == '8') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2945:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'e') ADVANCE(2725);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2946:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'h') ADVANCE(2889);
      if (lookahead == 'l') ADVANCE(2889);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2947:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2948:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'v') ADVANCE(2949);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2949:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2950:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'l' ||
          lookahead == 'n' ||
          lookahead == 'u') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2951:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (('0' <= lookahead && lookahead <= '2')) ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('3' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2952:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'e') ADVANCE(2693);
      if (lookahead == 'g') ADVANCE(2808);
      if (lookahead == 'i') ADVANCE(2794);
      if (lookahead == 'u') ADVANCE(2959);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2953:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'm') ADVANCE(2247);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2954:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'n') ADVANCE(2959);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2955:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'p') ADVANCE(2927);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2956:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'p') ADVANCE(2735);
      if (lookahead == 'u') ADVANCE(2959);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2957:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 's') ADVANCE(2918);
      if (lookahead == 'u') ADVANCE(2750);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2958:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 't') ADVANCE(2418);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2959:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2960:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 's' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == 'h') ADVANCE(2362);
      if (lookahead == 'l') ADVANCE(2362);
      if (lookahead == 'x') ADVANCE(1115);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2961:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'q' ||
          lookahead == 's' ||
          lookahead == 'w') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2962:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (('0' <= lookahead && lookahead <= '5')) ADVANCE(1027);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('6' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2963:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(1027);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          lookahead == '8' ||
          lookahead == '9' ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    case 2964:
      ACCEPT_TOKEN(sym__IDENTIFIER);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('@' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2964);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 901},
  [2] = {.lex_state = 896},
  [3] = {.lex_state = 6},
  [4] = {.lex_state = 6},
  [5] = {.lex_state = 11},
  [6] = {.lex_state = 11},
  [7] = {.lex_state = 11},
  [8] = {.lex_state = 898},
  [9] = {.lex_state = 898},
  [10] = {.lex_state = 10},
  [11] = {.lex_state = 6},
  [12] = {.lex_state = 11},
  [13] = {.lex_state = 7},
  [14] = {.lex_state = 11},
  [15] = {.lex_state = 11},
  [16] = {.lex_state = 11},
  [17] = {.lex_state = 11},
  [18] = {.lex_state = 8},
  [19] = {.lex_state = 8},
  [20] = {.lex_state = 7},
  [21] = {.lex_state = 8},
  [22] = {.lex_state = 899},
  [23] = {.lex_state = 896},
  [24] = {.lex_state = 899},
  [25] = {.lex_state = 896},
  [26] = {.lex_state = 896},
  [27] = {.lex_state = 898},
  [28] = {.lex_state = 896},
  [29] = {.lex_state = 896},
  [30] = {.lex_state = 896},
  [31] = {.lex_state = 12},
  [32] = {.lex_state = 897},
  [33] = {.lex_state = 896},
  [34] = {.lex_state = 1},
  [35] = {.lex_state = 896},
  [36] = {.lex_state = 896},
  [37] = {.lex_state = 1},
  [38] = {.lex_state = 896},
  [39] = {.lex_state = 896},
  [40] = {.lex_state = 896},
  [41] = {.lex_state = 1},
  [42] = {.lex_state = 896},
  [43] = {.lex_state = 896},
  [44] = {.lex_state = 896},
  [45] = {.lex_state = 12},
  [46] = {.lex_state = 896},
  [47] = {.lex_state = 896},
  [48] = {.lex_state = 896},
  [49] = {.lex_state = 896},
  [50] = {.lex_state = 879},
  [51] = {.lex_state = 896},
  [52] = {.lex_state = 896},
  [53] = {.lex_state = 896},
  [54] = {.lex_state = 896},
  [55] = {.lex_state = 896},
  [56] = {.lex_state = 896},
  [57] = {.lex_state = 896},
  [58] = {.lex_state = 896},
  [59] = {.lex_state = 896},
  [60] = {.lex_state = 896},
  [61] = {.lex_state = 896},
  [62] = {.lex_state = 896},
  [63] = {.lex_state = 896},
  [64] = {.lex_state = 896},
  [65] = {.lex_state = 896},
  [66] = {.lex_state = 896},
  [67] = {.lex_state = 896},
  [68] = {.lex_state = 896},
  [69] = {.lex_state = 896},
  [70] = {.lex_state = 896},
  [71] = {.lex_state = 896},
  [72] = {.lex_state = 896},
  [73] = {.lex_state = 896},
  [74] = {.lex_state = 896},
  [75] = {.lex_state = 896},
  [76] = {.lex_state = 896},
  [77] = {.lex_state = 880},
  [78] = {.lex_state = 0},
  [79] = {.lex_state = 0},
  [80] = {.lex_state = 880},
  [81] = {.lex_state = 880},
  [82] = {.lex_state = 896},
  [83] = {.lex_state = 0},
  [84] = {.lex_state = 0},
  [85] = {.lex_state = 6},
  [86] = {.lex_state = 0},
  [87] = {.lex_state = 0},
  [88] = {.lex_state = 0},
  [89] = {.lex_state = 0},
  [90] = {.lex_state = 0},
  [91] = {.lex_state = 12},
  [92] = {.lex_state = 6},
  [93] = {.lex_state = 921},
  [94] = {.lex_state = 880},
  [95] = {.lex_state = 6},
  [96] = {.lex_state = 12},
  [97] = {.lex_state = 0},
  [98] = {.lex_state = 0},
  [99] = {.lex_state = 880},
  [100] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_comment] = ACTIONS(1),
    [anon_sym_db] = ACTIONS(1),
    [anon_sym_dw] = ACTIONS(1),
    [anon_sym_dd] = ACTIONS(1),
    [anon_sym_dq] = ACTIONS(1),
    [anon_sym_section] = ACTIONS(1),
    [anon_sym_info] = ACTIONS(1),
    [anon_sym_extern] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [sym_shell_prompt] = ACTIONS(1),
    [anon_sym_Disassemblyofsection] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [aux_sym_objdump_addr_token1] = ACTIONS(1),
    [anon_sym_byte] = ACTIONS(1),
    [anon_sym_word] = ACTIONS(1),
    [anon_sym_qword] = ACTIONS(1),
    [anon_sym_xmmword] = ACTIONS(1),
    [anon_sym_BYTE] = ACTIONS(1),
    [anon_sym_WORD] = ACTIONS(1),
    [anon_sym_DWORD] = ACTIONS(1),
    [anon_sym_QWORD] = ACTIONS(1),
    [anon_sym_XMMWORD] = ACTIONS(1),
    [anon_sym_ptr] = ACTIONS(1),
    [anon_sym_PTR] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [sym_register] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_cs] = ACTIONS(1),
    [anon_sym_ds] = ACTIONS(1),
    [anon_sym_es] = ACTIONS(1),
    [anon_sym_fs] = ACTIONS(1),
    [anon_sym_gs] = ACTIONS(1),
    [anon_sym_ss] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [aux_sym__decimal_literal_token1] = ACTIONS(1),
    [aux_sym__decimal_literal_token2] = ACTIONS(1),
    [aux_sym__decimal_literal_token3] = ACTIONS(1),
    [aux_sym__hex_literal_token3] = ACTIONS(1),
    [aux_sym__octal_literal_token1] = ACTIONS(1),
    [aux_sym__octal_literal_token2] = ACTIONS(1),
    [aux_sym__binary_literal_token1] = ACTIONS(1),
    [aux_sym__binary_literal_token2] = ACTIONS(1),
    [sym_mnemonic] = ACTIONS(1),
    [sym_section_name] = ACTIONS(1),
    [sym__IDENTIFIER] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(100),
    [aux_sym_source_file_token1] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 15,
    ACTIONS(7), 1,
      sym_comment,
    ACTIONS(13), 1,
      sym_register,
    ACTIONS(15), 1,
      anon_sym_LBRACK,
    ACTIONS(17), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      sym__IDENTIFIER,
    STATE(13), 1,
      sym_width,
    STATE(19), 1,
      sym_ptr,
    STATE(26), 1,
      sym_operand,
    STATE(60), 1,
      sym_operand_args,
    ACTIONS(5), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(11), 2,
      anon_sym_ptr,
      anon_sym_PTR,
    STATE(23), 4,
      sym__decimal_literal,
      sym__hex_literal,
      sym__octal_literal,
      sym__binary_literal,
    STATE(39), 4,
      sym_operand_ident,
      sym_effective_addr,
      sym_string_literal,
      sym_integer_literal,
    ACTIONS(9), 10,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_dword,
      anon_sym_qword,
      anon_sym_xmmword,
      anon_sym_BYTE,
      anon_sym_WORD,
      anon_sym_DWORD,
      anon_sym_QWORD,
      anon_sym_XMMWORD,
    ACTIONS(19), 10,
      aux_sym__decimal_literal_token1,
      aux_sym__decimal_literal_token2,
      aux_sym__decimal_literal_token3,
      aux_sym__hex_literal_token1,
      aux_sym__hex_literal_token2,
      aux_sym__hex_literal_token3,
      aux_sym__octal_literal_token1,
      aux_sym__octal_literal_token2,
      aux_sym__binary_literal_token1,
      aux_sym__binary_literal_token2,
  [72] = 14,
    ACTIONS(21), 1,
      sym__IDENTIFIER,
    ACTIONS(27), 1,
      sym_register,
    ACTIONS(29), 1,
      anon_sym_LBRACK,
    ACTIONS(31), 1,
      anon_sym_DQUOTE,
    STATE(13), 1,
      sym_width,
    STATE(19), 1,
      sym_ptr,
    STATE(26), 1,
      sym_operand,
    STATE(49), 1,
      sym_operand_args,
    ACTIONS(25), 2,
      anon_sym_ptr,
      anon_sym_PTR,
    ACTIONS(33), 3,
      aux_sym__hex_literal_token2,
      aux_sym__hex_literal_token3,
      aux_sym__octal_literal_token2,
    STATE(23), 4,
      sym__decimal_literal,
      sym__hex_literal,
      sym__octal_literal,
      sym__binary_literal,
    STATE(39), 4,
      sym_operand_ident,
      sym_effective_addr,
      sym_string_literal,
      sym_integer_literal,
    ACTIONS(19), 7,
      aux_sym__decimal_literal_token1,
      aux_sym__decimal_literal_token2,
      aux_sym__decimal_literal_token3,
      aux_sym__hex_literal_token1,
      aux_sym__octal_literal_token1,
      aux_sym__binary_literal_token1,
      aux_sym__binary_literal_token2,
    ACTIONS(23), 10,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_dword,
      anon_sym_qword,
      anon_sym_xmmword,
      anon_sym_BYTE,
      anon_sym_WORD,
      anon_sym_DWORD,
      anon_sym_QWORD,
      anon_sym_XMMWORD,
  [139] = 13,
    ACTIONS(21), 1,
      sym__IDENTIFIER,
    ACTIONS(27), 1,
      sym_register,
    ACTIONS(29), 1,
      anon_sym_LBRACK,
    ACTIONS(31), 1,
      anon_sym_DQUOTE,
    STATE(13), 1,
      sym_width,
    STATE(19), 1,
      sym_ptr,
    STATE(40), 1,
      sym_operand,
    ACTIONS(25), 2,
      anon_sym_ptr,
      anon_sym_PTR,
    ACTIONS(33), 3,
      aux_sym__hex_literal_token2,
      aux_sym__hex_literal_token3,
      aux_sym__octal_literal_token2,
    STATE(23), 4,
      sym__decimal_literal,
      sym__hex_literal,
      sym__octal_literal,
      sym__binary_literal,
    STATE(39), 4,
      sym_operand_ident,
      sym_effective_addr,
      sym_string_literal,
      sym_integer_literal,
    ACTIONS(19), 7,
      aux_sym__decimal_literal_token1,
      aux_sym__decimal_literal_token2,
      aux_sym__decimal_literal_token3,
      aux_sym__hex_literal_token1,
      aux_sym__octal_literal_token1,
      aux_sym__binary_literal_token1,
      aux_sym__binary_literal_token2,
    ACTIONS(23), 10,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_dword,
      anon_sym_qword,
      anon_sym_xmmword,
      anon_sym_BYTE,
      anon_sym_WORD,
      anon_sym_DWORD,
      anon_sym_QWORD,
      anon_sym_XMMWORD,
  [203] = 10,
    ACTIONS(38), 1,
      anon_sym_RBRACK,
    ACTIONS(43), 1,
      anon_sym_es,
    ACTIONS(52), 1,
      sym__IDENTIFIER,
    STATE(88), 1,
      sym_segment,
    ACTIONS(49), 3,
      aux_sym__hex_literal_token2,
      aux_sym__hex_literal_token3,
      aux_sym__octal_literal_token2,
    STATE(5), 3,
      sym_segment_prefix,
      sym_integer_literal,
      aux_sym_effective_addr_repeat1,
    STATE(12), 4,
      sym__decimal_literal,
      sym__hex_literal,
      sym__octal_literal,
      sym__binary_literal,
    ACTIONS(40), 5,
      anon_sym_cs,
      anon_sym_ds,
      anon_sym_fs,
      anon_sym_gs,
      anon_sym_ss,
    ACTIONS(35), 6,
      sym_register,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(46), 7,
      aux_sym__decimal_literal_token1,
      aux_sym__decimal_literal_token2,
      aux_sym__decimal_literal_token3,
      aux_sym__hex_literal_token1,
      aux_sym__octal_literal_token1,
      aux_sym__binary_literal_token1,
      aux_sym__binary_literal_token2,
  [256] = 10,
    ACTIONS(57), 1,
      anon_sym_RBRACK,
    ACTIONS(61), 1,
      anon_sym_es,
    ACTIONS(67), 1,
      sym__IDENTIFIER,
    STATE(88), 1,
      sym_segment,
    ACTIONS(65), 3,
      aux_sym__hex_literal_token2,
      aux_sym__hex_literal_token3,
      aux_sym__octal_literal_token2,
    STATE(5), 3,
      sym_segment_prefix,
      sym_integer_literal,
      aux_sym_effective_addr_repeat1,
    STATE(12), 4,
      sym__decimal_literal,
      sym__hex_literal,
      sym__octal_literal,
      sym__binary_literal,
    ACTIONS(59), 5,
      anon_sym_cs,
      anon_sym_ds,
      anon_sym_fs,
      anon_sym_gs,
      anon_sym_ss,
    ACTIONS(55), 6,
      sym_register,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(63), 7,
      aux_sym__decimal_literal_token1,
      aux_sym__decimal_literal_token2,
      aux_sym__decimal_literal_token3,
      aux_sym__hex_literal_token1,
      aux_sym__octal_literal_token1,
      aux_sym__binary_literal_token1,
      aux_sym__binary_literal_token2,
  [309] = 9,
    ACTIONS(61), 1,
      anon_sym_es,
    ACTIONS(71), 1,
      sym__IDENTIFIER,
    STATE(88), 1,
      sym_segment,
    ACTIONS(65), 3,
      aux_sym__hex_literal_token2,
      aux_sym__hex_literal_token3,
      aux_sym__octal_literal_token2,
    STATE(6), 3,
      sym_segment_prefix,
      sym_integer_literal,
      aux_sym_effective_addr_repeat1,
    STATE(12), 4,
      sym__decimal_literal,
      sym__hex_literal,
      sym__octal_literal,
      sym__binary_literal,
    ACTIONS(59), 5,
      anon_sym_cs,
      anon_sym_ds,
      anon_sym_fs,
      anon_sym_gs,
      anon_sym_ss,
    ACTIONS(69), 6,
      sym_register,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(63), 7,
      aux_sym__decimal_literal_token1,
      aux_sym__decimal_literal_token2,
      aux_sym__decimal_literal_token3,
      aux_sym__hex_literal_token1,
      aux_sym__octal_literal_token1,
      aux_sym__binary_literal_token1,
      aux_sym__binary_literal_token2,
  [359] = 28,
    ACTIONS(73), 1,
      ts_builtin_sym_end,
    ACTIONS(75), 1,
      anon_sym_LF,
    ACTIONS(77), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_section,
    ACTIONS(83), 1,
      anon_sym_extern,
    ACTIONS(85), 1,
      anon_sym_global,
    ACTIONS(87), 1,
      sym_shell_prompt,
    ACTIONS(89), 1,
      anon_sym_Disassemblyofsection,
    ACTIONS(91), 1,
      sym_objdump_file_format,
    ACTIONS(93), 1,
      aux_sym_objdump_addr_token1,
    ACTIONS(95), 1,
      sym_mnemonic,
    ACTIONS(97), 1,
      sym__IDENTIFIER,
    STATE(3), 1,
      sym_builtin_kw,
    STATE(47), 1,
      sym_label,
    STATE(54), 1,
      sym_directive,
    STATE(61), 1,
      sym_builtin,
    STATE(62), 1,
      sym_objdump_section_label,
    STATE(66), 1,
      sym_section,
    STATE(67), 1,
      sym_extern,
    STATE(68), 1,
      sym_ins,
    STATE(70), 1,
      sym_global,
    STATE(71), 1,
      sym_objdump_offset_label,
    STATE(72), 1,
      sym_shell_cmd,
    STATE(75), 1,
      sym_objdump_disas_of_section,
    STATE(78), 1,
      sym_objdump_addr,
    STATE(92), 1,
      sym_identifier,
    STATE(95), 1,
      sym_label_name,
    ACTIONS(79), 4,
      anon_sym_db,
      anon_sym_dw,
      anon_sym_dd,
      anon_sym_dq,
  [447] = 27,
    ACTIONS(81), 1,
      anon_sym_section,
    ACTIONS(83), 1,
      anon_sym_extern,
    ACTIONS(85), 1,
      anon_sym_global,
    ACTIONS(87), 1,
      sym_shell_prompt,
    ACTIONS(89), 1,
      anon_sym_Disassemblyofsection,
    ACTIONS(91), 1,
      sym_objdump_file_format,
    ACTIONS(93), 1,
      aux_sym_objdump_addr_token1,
    ACTIONS(95), 1,
      sym_mnemonic,
    ACTIONS(97), 1,
      sym__IDENTIFIER,
    ACTIONS(99), 1,
      ts_builtin_sym_end,
    STATE(3), 1,
      sym_builtin_kw,
    STATE(47), 1,
      sym_label,
    STATE(61), 1,
      sym_builtin,
    STATE(62), 1,
      sym_objdump_section_label,
    STATE(66), 1,
      sym_section,
    STATE(67), 1,
      sym_extern,
    STATE(68), 1,
      sym_ins,
    STATE(70), 1,
      sym_global,
    STATE(71), 1,
      sym_objdump_offset_label,
    STATE(72), 1,
      sym_shell_cmd,
    STATE(73), 1,
      sym_directive,
    STATE(75), 1,
      sym_objdump_disas_of_section,
    STATE(78), 1,
      sym_objdump_addr,
    STATE(92), 1,
      sym_identifier,
    STATE(95), 1,
      sym_label_name,
    ACTIONS(101), 2,
      anon_sym_LF,
      sym_comment,
    ACTIONS(79), 4,
      anon_sym_db,
      anon_sym_dw,
      anon_sym_dd,
      anon_sym_dq,
  [533] = 26,
    ACTIONS(81), 1,
      anon_sym_section,
    ACTIONS(83), 1,
      anon_sym_extern,
    ACTIONS(85), 1,
      anon_sym_global,
    ACTIONS(91), 1,
      sym_objdump_file_format,
    ACTIONS(93), 1,
      aux_sym_objdump_addr_token1,
    ACTIONS(97), 1,
      sym__IDENTIFIER,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(105), 1,
      sym_shell_prompt,
    ACTIONS(107), 1,
      anon_sym_Disassemblyofsection,
    ACTIONS(109), 1,
      sym_mnemonic,
    STATE(3), 1,
      sym_builtin_kw,
    STATE(43), 1,
      sym_directive,
    STATE(47), 1,
      sym_label,
    STATE(61), 1,
      sym_builtin,
    STATE(62), 1,
      sym_objdump_section_label,
    STATE(66), 1,
      sym_section,
    STATE(67), 1,
      sym_extern,
    STATE(68), 1,
      sym_ins,
    STATE(70), 1,
      sym_global,
    STATE(71), 1,
      sym_objdump_offset_label,
    STATE(72), 1,
      sym_shell_cmd,
    STATE(75), 1,
      sym_objdump_disas_of_section,
    STATE(78), 1,
      sym_objdump_addr,
    STATE(92), 1,
      sym_identifier,
    STATE(95), 1,
      sym_label_name,
    ACTIONS(79), 4,
      anon_sym_db,
      anon_sym_dw,
      anon_sym_dd,
      anon_sym_dq,
  [615] = 2,
    ACTIONS(113), 8,
      aux_sym__decimal_literal_token1,
      aux_sym__decimal_literal_token2,
      aux_sym__decimal_literal_token3,
      aux_sym__hex_literal_token1,
      aux_sym__octal_literal_token1,
      aux_sym__binary_literal_token1,
      aux_sym__binary_literal_token2,
      sym__IDENTIFIER,
    ACTIONS(111), 18,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_dword,
      anon_sym_qword,
      anon_sym_xmmword,
      anon_sym_BYTE,
      anon_sym_WORD,
      anon_sym_DWORD,
      anon_sym_QWORD,
      anon_sym_XMMWORD,
      anon_sym_ptr,
      anon_sym_PTR,
      sym_register,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      aux_sym__hex_literal_token2,
      aux_sym__hex_literal_token3,
      aux_sym__octal_literal_token2,
  [646] = 4,
    ACTIONS(115), 1,
      anon_sym_LT,
    STATE(14), 1,
      sym_literal_offset,
    ACTIONS(119), 9,
      anon_sym_es,
      aux_sym__decimal_literal_token1,
      aux_sym__decimal_literal_token2,
      aux_sym__decimal_literal_token3,
      aux_sym__hex_literal_token1,
      aux_sym__octal_literal_token1,
      aux_sym__binary_literal_token1,
      aux_sym__binary_literal_token2,
      sym__IDENTIFIER,
    ACTIONS(117), 15,
      sym_register,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_cs,
      anon_sym_ds,
      anon_sym_fs,
      anon_sym_gs,
      anon_sym_ss,
      aux_sym__hex_literal_token2,
      aux_sym__hex_literal_token3,
      aux_sym__octal_literal_token2,
  [681] = 10,
    ACTIONS(21), 1,
      sym__IDENTIFIER,
    ACTIONS(29), 1,
      anon_sym_LBRACK,
    ACTIONS(31), 1,
      anon_sym_DQUOTE,
    ACTIONS(121), 1,
      sym_register,
    STATE(18), 1,
      sym_ptr,
    ACTIONS(25), 2,
      anon_sym_ptr,
      anon_sym_PTR,
    ACTIONS(33), 3,
      aux_sym__hex_literal_token2,
      aux_sym__hex_literal_token3,
      aux_sym__octal_literal_token2,
    STATE(23), 4,
      sym__decimal_literal,
      sym__hex_literal,
      sym__octal_literal,
      sym__binary_literal,
    STATE(33), 4,
      sym_operand_ident,
      sym_effective_addr,
      sym_string_literal,
      sym_integer_literal,
    ACTIONS(19), 7,
      aux_sym__decimal_literal_token1,
      aux_sym__decimal_literal_token2,
      aux_sym__decimal_literal_token3,
      aux_sym__hex_literal_token1,
      aux_sym__octal_literal_token1,
      aux_sym__binary_literal_token1,
      aux_sym__binary_literal_token2,
  [727] = 2,
    ACTIONS(125), 9,
      anon_sym_es,
      aux_sym__decimal_literal_token1,
      aux_sym__decimal_literal_token2,
      aux_sym__decimal_literal_token3,
      aux_sym__hex_literal_token1,
      aux_sym__octal_literal_token1,
      aux_sym__binary_literal_token1,
      aux_sym__binary_literal_token2,
      sym__IDENTIFIER,
    ACTIONS(123), 15,
      sym_register,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_cs,
      anon_sym_ds,
      anon_sym_fs,
      anon_sym_gs,
      anon_sym_ss,
      aux_sym__hex_literal_token2,
      aux_sym__hex_literal_token3,
      aux_sym__octal_literal_token2,
  [756] = 2,
    ACTIONS(129), 9,
      anon_sym_es,
      aux_sym__decimal_literal_token1,
      aux_sym__decimal_literal_token2,
      aux_sym__decimal_literal_token3,
      aux_sym__hex_literal_token1,
      aux_sym__octal_literal_token1,
      aux_sym__binary_literal_token1,
      aux_sym__binary_literal_token2,
      sym__IDENTIFIER,
    ACTIONS(127), 15,
      sym_register,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_cs,
      anon_sym_ds,
      anon_sym_fs,
      anon_sym_gs,
      anon_sym_ss,
      aux_sym__hex_literal_token2,
      aux_sym__hex_literal_token3,
      aux_sym__octal_literal_token2,
  [785] = 2,
    ACTIONS(133), 9,
      anon_sym_es,
      aux_sym__decimal_literal_token1,
      aux_sym__decimal_literal_token2,
      aux_sym__decimal_literal_token3,
      aux_sym__hex_literal_token1,
      aux_sym__octal_literal_token1,
      aux_sym__binary_literal_token1,
      aux_sym__binary_literal_token2,
      sym__IDENTIFIER,
    ACTIONS(131), 15,
      sym_register,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_cs,
      anon_sym_ds,
      anon_sym_fs,
      anon_sym_gs,
      anon_sym_ss,
      aux_sym__hex_literal_token2,
      aux_sym__hex_literal_token3,
      aux_sym__octal_literal_token2,
  [814] = 2,
    ACTIONS(137), 9,
      anon_sym_es,
      aux_sym__decimal_literal_token1,
      aux_sym__decimal_literal_token2,
      aux_sym__decimal_literal_token3,
      aux_sym__hex_literal_token1,
      aux_sym__octal_literal_token1,
      aux_sym__binary_literal_token1,
      aux_sym__binary_literal_token2,
      sym__IDENTIFIER,
    ACTIONS(135), 15,
      sym_register,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_cs,
      anon_sym_ds,
      anon_sym_fs,
      anon_sym_gs,
      anon_sym_ss,
      aux_sym__hex_literal_token2,
      aux_sym__hex_literal_token3,
      aux_sym__octal_literal_token2,
  [843] = 8,
    ACTIONS(21), 1,
      sym__IDENTIFIER,
    ACTIONS(29), 1,
      anon_sym_LBRACK,
    ACTIONS(31), 1,
      anon_sym_DQUOTE,
    ACTIONS(139), 1,
      sym_register,
    ACTIONS(33), 3,
      aux_sym__hex_literal_token2,
      aux_sym__hex_literal_token3,
      aux_sym__octal_literal_token2,
    STATE(23), 4,
      sym__decimal_literal,
      sym__hex_literal,
      sym__octal_literal,
      sym__binary_literal,
    STATE(38), 4,
      sym_operand_ident,
      sym_effective_addr,
      sym_string_literal,
      sym_integer_literal,
    ACTIONS(19), 7,
      aux_sym__decimal_literal_token1,
      aux_sym__decimal_literal_token2,
      aux_sym__decimal_literal_token3,
      aux_sym__hex_literal_token1,
      aux_sym__octal_literal_token1,
      aux_sym__binary_literal_token1,
      aux_sym__binary_literal_token2,
  [882] = 8,
    ACTIONS(21), 1,
      sym__IDENTIFIER,
    ACTIONS(29), 1,
      anon_sym_LBRACK,
    ACTIONS(31), 1,
      anon_sym_DQUOTE,
    ACTIONS(121), 1,
      sym_register,
    ACTIONS(33), 3,
      aux_sym__hex_literal_token2,
      aux_sym__hex_literal_token3,
      aux_sym__octal_literal_token2,
    STATE(23), 4,
      sym__decimal_literal,
      sym__hex_literal,
      sym__octal_literal,
      sym__binary_literal,
    STATE(33), 4,
      sym_operand_ident,
      sym_effective_addr,
      sym_string_literal,
      sym_integer_literal,
    ACTIONS(19), 7,
      aux_sym__decimal_literal_token1,
      aux_sym__decimal_literal_token2,
      aux_sym__decimal_literal_token3,
      aux_sym__hex_literal_token1,
      aux_sym__octal_literal_token1,
      aux_sym__binary_literal_token1,
      aux_sym__binary_literal_token2,
  [921] = 2,
    ACTIONS(141), 8,
      anon_sym_ptr,
      anon_sym_PTR,
      sym_register,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      aux_sym__hex_literal_token2,
      aux_sym__hex_literal_token3,
      aux_sym__octal_literal_token2,
    ACTIONS(143), 8,
      aux_sym__decimal_literal_token1,
      aux_sym__decimal_literal_token2,
      aux_sym__decimal_literal_token3,
      aux_sym__hex_literal_token1,
      aux_sym__octal_literal_token1,
      aux_sym__binary_literal_token1,
      aux_sym__binary_literal_token2,
      sym__IDENTIFIER,
  [942] = 2,
    ACTIONS(145), 6,
      sym_register,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      aux_sym__hex_literal_token2,
      aux_sym__hex_literal_token3,
      aux_sym__octal_literal_token2,
    ACTIONS(147), 8,
      aux_sym__decimal_literal_token1,
      aux_sym__decimal_literal_token2,
      aux_sym__decimal_literal_token3,
      aux_sym__hex_literal_token1,
      aux_sym__octal_literal_token1,
      aux_sym__binary_literal_token1,
      aux_sym__binary_literal_token2,
      sym__IDENTIFIER,
  [961] = 4,
    ACTIONS(149), 1,
      ts_builtin_sym_end,
    ACTIONS(153), 1,
      aux_sym_objdump_machine_code_bytes_token1,
    STATE(22), 1,
      aux_sym_objdump_machine_code_bytes_repeat1,
    ACTIONS(151), 3,
      anon_sym_LF,
      sym_comment,
      sym_mnemonic,
  [976] = 4,
    ACTIONS(156), 1,
      anon_sym_LT,
    STATE(30), 1,
      sym_literal_offset,
    ACTIONS(117), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(119), 2,
      sym_comment,
      anon_sym_COMMA,
  [991] = 4,
    ACTIONS(158), 1,
      ts_builtin_sym_end,
    ACTIONS(162), 1,
      aux_sym_objdump_machine_code_bytes_token1,
    STATE(22), 1,
      aux_sym_objdump_machine_code_bytes_repeat1,
    ACTIONS(160), 3,
      anon_sym_LF,
      sym_comment,
      sym_mnemonic,
  [1006] = 4,
    ACTIONS(166), 1,
      sym_comment,
    ACTIONS(168), 1,
      anon_sym_COMMA,
    STATE(25), 1,
      aux_sym_operand_args_repeat1,
    ACTIONS(164), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [1020] = 4,
    ACTIONS(173), 1,
      sym_comment,
    ACTIONS(175), 1,
      anon_sym_COMMA,
    STATE(28), 1,
      aux_sym_operand_args_repeat1,
    ACTIONS(171), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [1034] = 4,
    ACTIONS(95), 1,
      sym_mnemonic,
    ACTIONS(177), 1,
      ts_builtin_sym_end,
    STATE(59), 1,
      sym_ins,
    ACTIONS(179), 2,
      anon_sym_LF,
      sym_comment,
  [1048] = 4,
    ACTIONS(175), 1,
      anon_sym_COMMA,
    ACTIONS(183), 1,
      sym_comment,
    STATE(25), 1,
      aux_sym_operand_args_repeat1,
    ACTIONS(181), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [1062] = 2,
    ACTIONS(185), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(187), 2,
      sym_comment,
      anon_sym_COMMA,
  [1071] = 2,
    ACTIONS(123), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(125), 2,
      sym_comment,
      anon_sym_COMMA,
  [1080] = 3,
    ACTIONS(189), 1,
      aux_sym__hex_literal_token1,
    STATE(98), 1,
      sym__hex_literal,
    ACTIONS(191), 2,
      aux_sym__hex_literal_token2,
      aux_sym__hex_literal_token3,
  [1091] = 3,
    ACTIONS(195), 1,
      sym_comment,
    ACTIONS(197), 1,
      anon_sym_info,
    ACTIONS(193), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [1102] = 2,
    ACTIONS(199), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(201), 2,
      sym_comment,
      anon_sym_COMMA,
  [1111] = 4,
    ACTIONS(203), 1,
      sym_escape_sequence,
    ACTIONS(205), 1,
      anon_sym_DQUOTE,
    ACTIONS(207), 1,
      aux_sym_string_literal_token1,
    STATE(37), 1,
      aux_sym_string_literal_repeat1,
  [1124] = 2,
    ACTIONS(209), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(211), 2,
      sym_comment,
      anon_sym_COMMA,
  [1133] = 2,
    ACTIONS(213), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(215), 2,
      sym_comment,
      anon_sym_COMMA,
  [1142] = 4,
    ACTIONS(217), 1,
      sym_escape_sequence,
    ACTIONS(220), 1,
      anon_sym_DQUOTE,
    ACTIONS(222), 1,
      aux_sym_string_literal_token1,
    STATE(37), 1,
      aux_sym_string_literal_repeat1,
  [1155] = 2,
    ACTIONS(225), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(227), 2,
      sym_comment,
      anon_sym_COMMA,
  [1164] = 2,
    ACTIONS(229), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(231), 2,
      sym_comment,
      anon_sym_COMMA,
  [1173] = 2,
    ACTIONS(164), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(166), 2,
      sym_comment,
      anon_sym_COMMA,
  [1182] = 4,
    ACTIONS(233), 1,
      sym_escape_sequence,
    ACTIONS(235), 1,
      anon_sym_DQUOTE,
    ACTIONS(237), 1,
      aux_sym_string_literal_token1,
    STATE(34), 1,
      aux_sym_string_literal_repeat1,
  [1195] = 2,
    ACTIONS(239), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(241), 2,
      sym_comment,
      anon_sym_COMMA,
  [1204] = 4,
    ACTIONS(243), 1,
      ts_builtin_sym_end,
    ACTIONS(245), 1,
      anon_sym_LF,
    ACTIONS(247), 1,
      sym_comment,
    STATE(65), 1,
      aux_sym_source_file_repeat1,
  [1217] = 2,
    ACTIONS(131), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(133), 2,
      sym_comment,
      anon_sym_COMMA,
  [1226] = 3,
    ACTIONS(249), 1,
      aux_sym__hex_literal_token1,
    STATE(90), 1,
      sym__hex_literal,
    ACTIONS(251), 2,
      aux_sym__hex_literal_token2,
      aux_sym__hex_literal_token3,
  [1237] = 2,
    ACTIONS(135), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(137), 2,
      sym_comment,
      anon_sym_COMMA,
  [1246] = 2,
    ACTIONS(255), 1,
      sym_comment,
    ACTIONS(253), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [1254] = 2,
    ACTIONS(259), 1,
      sym_comment,
    ACTIONS(257), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [1262] = 2,
    ACTIONS(263), 1,
      sym_comment,
    ACTIONS(261), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [1270] = 3,
    ACTIONS(265), 1,
      aux_sym_objdump_machine_code_bytes_token1,
    STATE(24), 1,
      aux_sym_objdump_machine_code_bytes_repeat1,
    STATE(27), 1,
      sym_objdump_machine_code_bytes,
  [1280] = 3,
    ACTIONS(243), 1,
      ts_builtin_sym_end,
    ACTIONS(245), 1,
      anon_sym_LF,
    STATE(65), 1,
      aux_sym_source_file_repeat1,
  [1290] = 2,
    ACTIONS(269), 1,
      sym_comment,
    ACTIONS(267), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [1298] = 2,
    ACTIONS(273), 1,
      sym_comment,
    ACTIONS(271), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [1306] = 2,
    ACTIONS(277), 1,
      sym_comment,
    ACTIONS(275), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [1314] = 3,
    ACTIONS(275), 1,
      ts_builtin_sym_end,
    ACTIONS(279), 1,
      anon_sym_LF,
    STATE(55), 1,
      aux_sym_source_file_repeat1,
  [1324] = 2,
    ACTIONS(284), 1,
      sym_comment,
    ACTIONS(282), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [1332] = 2,
    ACTIONS(288), 1,
      sym_comment,
    ACTIONS(286), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [1340] = 2,
    ACTIONS(255), 1,
      sym_comment,
    ACTIONS(253), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [1348] = 2,
    ACTIONS(292), 1,
      sym_comment,
    ACTIONS(290), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [1356] = 2,
    ACTIONS(296), 1,
      sym_comment,
    ACTIONS(294), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [1364] = 2,
    ACTIONS(255), 1,
      sym_comment,
    ACTIONS(253), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [1372] = 2,
    ACTIONS(255), 1,
      sym_comment,
    ACTIONS(253), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [1380] = 2,
    ACTIONS(300), 1,
      sym_comment,
    ACTIONS(298), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [1388] = 2,
    ACTIONS(304), 1,
      sym_comment,
    ACTIONS(302), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [1396] = 3,
    ACTIONS(245), 1,
      anon_sym_LF,
    ACTIONS(306), 1,
      ts_builtin_sym_end,
    STATE(55), 1,
      aux_sym_source_file_repeat1,
  [1406] = 2,
    ACTIONS(255), 1,
      sym_comment,
    ACTIONS(253), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [1414] = 2,
    ACTIONS(255), 1,
      sym_comment,
    ACTIONS(253), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [1422] = 2,
    ACTIONS(255), 1,
      sym_comment,
    ACTIONS(253), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [1430] = 3,
    ACTIONS(245), 1,
      anon_sym_LF,
    ACTIONS(308), 1,
      ts_builtin_sym_end,
    STATE(55), 1,
      aux_sym_source_file_repeat1,
  [1440] = 2,
    ACTIONS(255), 1,
      sym_comment,
    ACTIONS(253), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [1448] = 2,
    ACTIONS(255), 1,
      sym_comment,
    ACTIONS(253), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [1456] = 2,
    ACTIONS(255), 1,
      sym_comment,
    ACTIONS(253), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [1464] = 2,
    ACTIONS(312), 1,
      sym_comment,
    ACTIONS(310), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [1472] = 3,
    ACTIONS(245), 1,
      anon_sym_LF,
    ACTIONS(306), 1,
      ts_builtin_sym_end,
    STATE(69), 1,
      aux_sym_source_file_repeat1,
  [1482] = 2,
    ACTIONS(255), 1,
      sym_comment,
    ACTIONS(253), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [1490] = 1,
    ACTIONS(314), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [1495] = 2,
    ACTIONS(316), 1,
      sym__IDENTIFIER,
    STATE(64), 1,
      sym_identifier,
  [1502] = 2,
    ACTIONS(318), 1,
      anon_sym_COLON,
    ACTIONS(320), 1,
      anon_sym_LT,
  [1509] = 2,
    ACTIONS(322), 1,
      anon_sym_GT,
    ACTIONS(324), 1,
      anon_sym_PLUS,
  [1516] = 2,
    ACTIONS(326), 1,
      sym__IDENTIFIER,
    STATE(97), 1,
      sym_identifier,
  [1523] = 2,
    ACTIONS(316), 1,
      sym__IDENTIFIER,
    STATE(63), 1,
      sym_identifier,
  [1530] = 1,
    ACTIONS(275), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [1535] = 2,
    ACTIONS(328), 1,
      anon_sym_GT,
    ACTIONS(330), 1,
      anon_sym_PLUS,
  [1542] = 1,
    ACTIONS(332), 2,
      anon_sym_COLON,
      anon_sym_LT,
  [1547] = 1,
    ACTIONS(267), 2,
      anon_sym_GT,
      aux_sym_label_token1,
  [1552] = 1,
    ACTIONS(334), 1,
      anon_sym_COLON,
  [1556] = 1,
    ACTIONS(336), 1,
      anon_sym_COLON,
  [1560] = 1,
    ACTIONS(338), 1,
      anon_sym_COLON,
  [1564] = 1,
    ACTIONS(340), 1,
      anon_sym_COLON,
  [1568] = 1,
    ACTIONS(342), 1,
      anon_sym_GT,
  [1572] = 1,
    ACTIONS(344), 1,
      sym_section_name,
  [1576] = 1,
    ACTIONS(346), 1,
      aux_sym_label_token1,
  [1580] = 1,
    ACTIONS(348), 1,
      aux_sym_shell_cmd_token1,
  [1584] = 1,
    ACTIONS(350), 1,
      sym__IDENTIFIER,
  [1588] = 1,
    ACTIONS(352), 1,
      aux_sym_label_token1,
  [1592] = 1,
    ACTIONS(354), 1,
      sym_section_name,
  [1596] = 1,
    ACTIONS(356), 1,
      anon_sym_GT,
  [1600] = 1,
    ACTIONS(358), 1,
      anon_sym_GT,
  [1604] = 1,
    ACTIONS(360), 1,
      sym__IDENTIFIER,
  [1608] = 1,
    ACTIONS(362), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 72,
  [SMALL_STATE(4)] = 139,
  [SMALL_STATE(5)] = 203,
  [SMALL_STATE(6)] = 256,
  [SMALL_STATE(7)] = 309,
  [SMALL_STATE(8)] = 359,
  [SMALL_STATE(9)] = 447,
  [SMALL_STATE(10)] = 533,
  [SMALL_STATE(11)] = 615,
  [SMALL_STATE(12)] = 646,
  [SMALL_STATE(13)] = 681,
  [SMALL_STATE(14)] = 727,
  [SMALL_STATE(15)] = 756,
  [SMALL_STATE(16)] = 785,
  [SMALL_STATE(17)] = 814,
  [SMALL_STATE(18)] = 843,
  [SMALL_STATE(19)] = 882,
  [SMALL_STATE(20)] = 921,
  [SMALL_STATE(21)] = 942,
  [SMALL_STATE(22)] = 961,
  [SMALL_STATE(23)] = 976,
  [SMALL_STATE(24)] = 991,
  [SMALL_STATE(25)] = 1006,
  [SMALL_STATE(26)] = 1020,
  [SMALL_STATE(27)] = 1034,
  [SMALL_STATE(28)] = 1048,
  [SMALL_STATE(29)] = 1062,
  [SMALL_STATE(30)] = 1071,
  [SMALL_STATE(31)] = 1080,
  [SMALL_STATE(32)] = 1091,
  [SMALL_STATE(33)] = 1102,
  [SMALL_STATE(34)] = 1111,
  [SMALL_STATE(35)] = 1124,
  [SMALL_STATE(36)] = 1133,
  [SMALL_STATE(37)] = 1142,
  [SMALL_STATE(38)] = 1155,
  [SMALL_STATE(39)] = 1164,
  [SMALL_STATE(40)] = 1173,
  [SMALL_STATE(41)] = 1182,
  [SMALL_STATE(42)] = 1195,
  [SMALL_STATE(43)] = 1204,
  [SMALL_STATE(44)] = 1217,
  [SMALL_STATE(45)] = 1226,
  [SMALL_STATE(46)] = 1237,
  [SMALL_STATE(47)] = 1246,
  [SMALL_STATE(48)] = 1254,
  [SMALL_STATE(49)] = 1262,
  [SMALL_STATE(50)] = 1270,
  [SMALL_STATE(51)] = 1280,
  [SMALL_STATE(52)] = 1290,
  [SMALL_STATE(53)] = 1298,
  [SMALL_STATE(54)] = 1306,
  [SMALL_STATE(55)] = 1314,
  [SMALL_STATE(56)] = 1324,
  [SMALL_STATE(57)] = 1332,
  [SMALL_STATE(58)] = 1340,
  [SMALL_STATE(59)] = 1348,
  [SMALL_STATE(60)] = 1356,
  [SMALL_STATE(61)] = 1364,
  [SMALL_STATE(62)] = 1372,
  [SMALL_STATE(63)] = 1380,
  [SMALL_STATE(64)] = 1388,
  [SMALL_STATE(65)] = 1396,
  [SMALL_STATE(66)] = 1406,
  [SMALL_STATE(67)] = 1414,
  [SMALL_STATE(68)] = 1422,
  [SMALL_STATE(69)] = 1430,
  [SMALL_STATE(70)] = 1440,
  [SMALL_STATE(71)] = 1448,
  [SMALL_STATE(72)] = 1456,
  [SMALL_STATE(73)] = 1464,
  [SMALL_STATE(74)] = 1472,
  [SMALL_STATE(75)] = 1482,
  [SMALL_STATE(76)] = 1490,
  [SMALL_STATE(77)] = 1495,
  [SMALL_STATE(78)] = 1502,
  [SMALL_STATE(79)] = 1509,
  [SMALL_STATE(80)] = 1516,
  [SMALL_STATE(81)] = 1523,
  [SMALL_STATE(82)] = 1530,
  [SMALL_STATE(83)] = 1535,
  [SMALL_STATE(84)] = 1542,
  [SMALL_STATE(85)] = 1547,
  [SMALL_STATE(86)] = 1552,
  [SMALL_STATE(87)] = 1556,
  [SMALL_STATE(88)] = 1560,
  [SMALL_STATE(89)] = 1564,
  [SMALL_STATE(90)] = 1568,
  [SMALL_STATE(91)] = 1572,
  [SMALL_STATE(92)] = 1576,
  [SMALL_STATE(93)] = 1580,
  [SMALL_STATE(94)] = 1584,
  [SMALL_STATE(95)] = 1588,
  [SMALL_STATE(96)] = 1592,
  [SMALL_STATE(97)] = 1596,
  [SMALL_STATE(98)] = 1600,
  [SMALL_STATE(99)] = 1604,
  [SMALL_STATE(100)] = 1608,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ins, 1),
  [7] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ins, 1),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(21),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(39),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(41),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(23),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [35] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_effective_addr_repeat1, 2), SHIFT_REPEAT(5),
  [38] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_effective_addr_repeat1, 2),
  [40] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_effective_addr_repeat1, 2), SHIFT_REPEAT(89),
  [43] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_effective_addr_repeat1, 2), SHIFT_REPEAT(89),
  [46] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_effective_addr_repeat1, 2), SHIFT_REPEAT(12),
  [49] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_effective_addr_repeat1, 2), SHIFT_REPEAT(12),
  [52] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_effective_addr_repeat1, 2), SHIFT_REPEAT(5),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6),
  [73] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1),
  [75] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(96),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(77),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [99] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_label, 2),
  [101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_label, 2),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_builtin_kw, 1),
  [113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_builtin_kw, 1),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_integer_literal, 1),
  [119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_integer_literal, 1),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_integer_literal, 2),
  [125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_integer_literal, 2),
  [127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_segment_prefix, 2),
  [129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_segment_prefix, 2),
  [131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_offset, 3),
  [133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_offset, 3),
  [135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_offset, 5),
  [137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_offset, 5),
  [139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_width, 1),
  [143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_width, 1),
  [145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ptr, 1),
  [147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ptr, 1),
  [149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_objdump_machine_code_bytes_repeat1, 2),
  [151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_objdump_machine_code_bytes_repeat1, 2),
  [153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_objdump_machine_code_bytes_repeat1, 2), SHIFT_REPEAT(22),
  [156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_objdump_machine_code_bytes, 1),
  [160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_objdump_machine_code_bytes, 1),
  [162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_operand_args_repeat1, 2),
  [166] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_operand_args_repeat1, 2),
  [168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operand_args_repeat1, 2), SHIFT_REPEAT(4),
  [171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operand_args, 1),
  [173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operand_args, 1),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4),
  [177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_objdump_offset_label, 3),
  [179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_objdump_offset_label, 3),
  [181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operand_args, 2),
  [183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operand_args, 2),
  [185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_effective_addr, 3),
  [187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_effective_addr, 3),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(98),
  [191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_section, 2),
  [195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_section, 2),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operand, 2),
  [201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operand, 2),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(36),
  [207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 2),
  [211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 2),
  [213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 3),
  [215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 3),
  [217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(37),
  [220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2),
  [222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(37),
  [225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operand, 3),
  [227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operand, 3),
  [229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operand, 1),
  [231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operand, 1),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(34),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(35),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operand_ident, 1),
  [241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operand_ident, 1),
  [243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 2),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_directive, 1),
  [255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_directive, 1),
  [257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shell_cmd, 2),
  [259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_shell_cmd, 2),
  [261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_builtin, 2),
  [263] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_builtin, 2),
  [265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier, 1),
  [269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier, 1),
  [271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_objdump_section_label, 5),
  [273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_objdump_section_label, 5),
  [275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(76),
  [279] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(8),
  [282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_section, 3),
  [284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_section, 3),
  [286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_objdump_disas_of_section, 3),
  [288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_objdump_disas_of_section, 3),
  [290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_objdump_offset_label, 4),
  [292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_objdump_offset_label, 4),
  [294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ins, 2),
  [296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ins, 2),
  [298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global, 2),
  [300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global, 2),
  [302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern, 2),
  [304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extern, 2),
  [306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 3),
  [308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 4),
  [310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_label, 3),
  [312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_label, 3),
  [314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 3),
  [316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_objdump_addr, 1),
  [334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_segment, 1),
  [342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_label_name, 1),
  [348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [362] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_x86asm(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
